/* $Id: hamsi_helper.c 202 2010-05-31 15:46:48Z tp $ */
/*
 * Helper code for Hamsi (input block expansion). This code is
 * automatically generated and includes precomputed tables for
 * expansion code which handles 2 to 8 bits at a time.
 *
 * This file is included from hamsi.c, and is not meant to be compiled
 * independently.
 *
 * ==========================(LICENSE BEGIN)============================
 *
 * Copyright (c) 2007-2010  Projet RNRT SAPHIR
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * ===========================(LICENSE END)=============================
 *
 * @author   Thomas Pornin <thomas.pornin@cryptolog.com>
 */

#if SPH_HAMSI_EXPAND_SMALL == 1

/* Note: this table lists bits within each byte from least
   siginificant to most significant. */
__constant static const sph_u32 T256[32][8] = {
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) }
};

#define INPUT_SMALL   do { \
    __constant const sph_u32 *tp = &T256[0][0]; \
    unsigned u, v; \
    m0 = 0; \
    m1 = 0; \
    m2 = 0; \
    m3 = 0; \
    m4 = 0; \
    m5 = 0; \
    m6 = 0; \
    m7 = 0; \
    for (u = 0; u < 4; u ++) { \
      unsigned db = buf(u); \
      for (v = 0; v < 8; v ++, db >>= 1) { \
        sph_u32 dm = SPH_T32(-(sph_u32)(db & 1)); \
        m0 ^= dm & *tp ++; \
        m1 ^= dm & *tp ++; \
        m2 ^= dm & *tp ++; \
        m3 ^= dm & *tp ++; \
        m4 ^= dm & *tp ++; \
        m5 ^= dm & *tp ++; \
        m6 ^= dm & *tp ++; \
        m7 ^= dm & *tp ++; \
      } \
    } \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_SMALL == 2

__constant static const sph_u32 T256_0[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0xe0278000), SPH_C32(0x19dce008), SPH_C32(0xd7075d82),
    SPH_C32(0x5ad2e31d), SPH_C32(0xe4788000), SPH_C32(0x859673c1),
    SPH_C32(0xb5fb2452), SPH_C32(0x29cc5edf) }
};

__constant static const sph_u32 T256_2[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd), SPH_C32(0x097f5711),
    SPH_C32(0xde77cc4c), SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8),
    SPH_C32(0x8dfacfab), SPH_C32(0xce36cc72) }
};

__constant static const sph_u32 T256_4[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0x7e792000), SPH_C32(0x9418e22f), SPH_C32(0x6643d258),
    SPH_C32(0x9c255be5), SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc),
    SPH_C32(0x11fa3a57), SPH_C32(0x3dc90524) }
};

__constant static const sph_u32 T256_6[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117), SPH_C32(0x3321e92c),
    SPH_C32(0xce122df3), SPH_C32(0x74951000), SPH_C32(0x5a2b467e),
    SPH_C32(0x88fd1d2b), SPH_C32(0x1ee68292) }
};

__constant static const sph_u32 T256_8[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x3fb90800), SPH_C32(0x7cdad883), SPH_C32(0xce97a914),
    SPH_C32(0xbdd9f5e5), SPH_C32(0xde320800), SPH_C32(0x288350fe),
    SPH_C32(0x71852ac7), SPH_C32(0xa6bf9f96) }
};

__constant static const sph_u32 T256_10[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0x9b830400), SPH_C32(0x2227ff88), SPH_C32(0x05b7ad5a),
    SPH_C32(0xadf2c730), SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877),
    SPH_C32(0x6fc548e1), SPH_C32(0x898d2cd6) }
};

__constant static const sph_u32 T256_12[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d), SPH_C32(0xe0272f7d),
    SPH_C32(0xa5e7de5a), SPH_C32(0xa7b80200), SPH_C32(0x1f128433),
    SPH_C32(0x60e5f9f2), SPH_C32(0x9e147576) }
};

__constant static const sph_u32 T256_14[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0xc4e80100), SPH_C32(0x1f70960e), SPH_C32(0x2714ca3c),
    SPH_C32(0x88210c30), SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8),
    SPH_C32(0x8589d8ab), SPH_C32(0xe6c46464) }
};

__constant static const sph_u32 T256_16[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0x62740080), SPH_C32(0x0fb84b07), SPH_C32(0x138a651e),
    SPH_C32(0x44100618), SPH_C32(0x5bd20080), SPH_C32(0x450f18ec),
    SPH_C32(0xc2c46c55), SPH_C32(0xf362b233) }
};

__constant static const sph_u32 T256_18[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x35650040), SPH_C32(0x9b96b64a), SPH_C32(0x6b39cb5f),
    SPH_C32(0x5114bece), SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e),
    SPH_C32(0x36656ba8), SPH_C32(0x23633a05) }
};

__constant static const sph_u32 T256_20[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0xfeca0020), SPH_C32(0x485d28e4), SPH_C32(0x806741fd),
    SPH_C32(0x814681b8), SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6),
    SPH_C32(0xf9ce4c04), SPH_C32(0xe2afa0c0) }
};

__constant static const sph_u32 T256_22[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0x7f650010), SPH_C32(0x242e1472), SPH_C32(0xc03320fe),
    SPH_C32(0xc0a3c0dd), SPH_C32(0x515c0010), SPH_C32(0x40f372fb),
    SPH_C32(0xfce72602), SPH_C32(0x71575061) }
};

__constant static const sph_u32 T256_24[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) },
  { SPH_C32(0xbfb20008), SPH_C32(0x92170a39), SPH_C32(0x6019107f),
    SPH_C32(0xe051606e), SPH_C32(0xa8ae0008), SPH_C32(0x2079397d),
    SPH_C32(0xfe739301), SPH_C32(0xb8a92831) }
};

__constant static const sph_u32 T256_26[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd), SPH_C32(0x05f7ac6d),
    SPH_C32(0xd9e6eee9), SPH_C32(0xd0080004), SPH_C32(0x8c768f77),
    SPH_C32(0x9dc5b050), SPH_C32(0xaf4a29da) }
};

__constant static const sph_u32 T256_28[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7), SPH_C32(0xe007afe6),
    SPH_C32(0x9fed4ab7), SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3),
    SPH_C32(0x99e585aa), SPH_C32(0x8d75f7f1) }
};

__constant static const sph_u32 T256_30[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x08bf0001), SPH_C32(0x38942792), SPH_C32(0xc5f8f3a1),
    SPH_C32(0xe6387b84), SPH_C32(0xc04e0001), SPH_C32(0x33b9c010),
    SPH_C32(0xae0ebb05), SPH_C32(0xb5a4c63b) }
};

#define INPUT_SMALL   do { \
    unsigned acc = buf[0]; \
    const sph_u32 *rp; \
    rp = &T256_0[acc >> 6][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    rp = &T256_2[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_4[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_6[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[1]; \
    rp = &T256_8[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_10[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_12[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_14[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[2]; \
    rp = &T256_16[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_18[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_20[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_22[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[3]; \
    rp = &T256_24[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_26[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_28[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_30[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_SMALL == 3

__constant static const sph_u32 T256_0[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0x022f8000), SPH_C32(0xce2549e4), SPH_C32(0x317ebce8),
    SPH_C32(0x398d5ee1), SPH_C32(0xf0134000), SPH_C32(0x8cee7004),
    SPH_C32(0x6b832ec1), SPH_C32(0xad69718e) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec), SPH_C32(0xe679e16a),
    SPH_C32(0x635fbdfc), SPH_C32(0x146bc000), SPH_C32(0x097803c5),
    SPH_C32(0xde780a93), SPH_C32(0x84a52f51) },
  { SPH_C32(0xe0278000), SPH_C32(0x19dce008), SPH_C32(0xd7075d82),
    SPH_C32(0x5ad2e31d), SPH_C32(0xe4788000), SPH_C32(0x859673c1),
    SPH_C32(0xb5fb2452), SPH_C32(0x29cc5edf) },
  { SPH_C32(0x06708000), SPH_C32(0x526fda2d), SPH_C32(0x5382c538),
    SPH_C32(0x4a93e323), SPH_C32(0x1034c000), SPH_C32(0x9532900c),
    SPH_C32(0xbc847343), SPH_C32(0xf7bb9293) }
};

__constant static const sph_u32 T256_3[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0x7e792000), SPH_C32(0x9418e22f), SPH_C32(0x6643d258),
    SPH_C32(0x9c255be5), SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc),
    SPH_C32(0x11fa3a57), SPH_C32(0x3dc90524) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0xfb316000), SPH_C32(0xef405514), SPH_C32(0x9c00f5fc),
    SPH_C32(0xf3ffc956), SPH_C32(0x71040000), SPH_C32(0x6bfc54f6),
    SPH_C32(0xf33c70b5), SPH_C32(0xb1ad5eff) },
  { SPH_C32(0x85484000), SPH_C32(0x7b58b73b), SPH_C32(0xfa4327a4),
    SPH_C32(0x6fda92b3), SPH_C32(0x982e2000), SPH_C32(0xdfabd80a),
    SPH_C32(0xe2c64ae2), SPH_C32(0x8c645bdb) },
  { SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7), SPH_C32(0xebb91df3),
    SPH_C32(0x52139797), SPH_C32(0x0f7d2000), SPH_C32(0xffe4b6d9),
    SPH_C32(0x957fa2ed), SPH_C32(0x2d88051a) }
};

__constant static const sph_u32 T256_6[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0x951e1000), SPH_C32(0x0e72ce03), SPH_C32(0x37ef9ef8),
    SPH_C32(0x0580e8e1), SPH_C32(0xf4100800), SPH_C32(0xecfdefea),
    SPH_C32(0x754b5d13), SPH_C32(0x6d2d5a84) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0x2a220000), SPH_C32(0xc47ebf14), SPH_C32(0x04ce77d4),
    SPH_C32(0xcb92c512), SPH_C32(0x80851800), SPH_C32(0xb6d6a994),
    SPH_C32(0xfdb64038), SPH_C32(0x73cbd816) },
  { SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117), SPH_C32(0x3321e92c),
    SPH_C32(0xce122df3), SPH_C32(0x74951000), SPH_C32(0x5a2b467e),
    SPH_C32(0x88fd1d2b), SPH_C32(0x1ee68292) },
  { SPH_C32(0x5eb71000), SPH_C32(0x9e55f96a), SPH_C32(0x8c336aff),
    SPH_C32(0xd5744780), SPH_C32(0x4b2c1800), SPH_C32(0x26f19efd),
    SPH_C32(0x466ab43f), SPH_C32(0xa33f7777) }
};

__constant static const sph_u32 T256_9[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0x9b830400), SPH_C32(0x2227ff88), SPH_C32(0x05b7ad5a),
    SPH_C32(0xadf2c730), SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877),
    SPH_C32(0x6fc548e1), SPH_C32(0x898d2cd6) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0x510c0c00), SPH_C32(0x251e9889), SPH_C32(0x1e406226),
    SPH_C32(0x2f32b340), SPH_C32(0xf5360000), SPH_C32(0x7be3bf82),
    SPH_C32(0xd5606668), SPH_C32(0x3f198195) },
  { SPH_C32(0xca8f0800), SPH_C32(0x07396701), SPH_C32(0x1bf7cf7c),
    SPH_C32(0x82c07470), SPH_C32(0x7a080400), SPH_C32(0x767e77f5),
    SPH_C32(0xbaa52e89), SPH_C32(0xb694ad43) },
  { SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76), SPH_C32(0x7432879d),
    SPH_C32(0x0b4d58a6), SPH_C32(0x6eb50400), SPH_C32(0x59c4400a),
    SPH_C32(0xd0d7cb32), SPH_C32(0x92eb46a5) }
};

__constant static const sph_u32 T256_12[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5), SPH_C32(0xc278eb65),
    SPH_C32(0xf0f11d22), SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30),
    SPH_C32(0xa7d61cb3), SPH_C32(0xb3d2a71c) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8), SPH_C32(0x225fc418),
    SPH_C32(0x5516c378), SPH_C32(0x8d760300), SPH_C32(0x12297a03),
    SPH_C32(0xc733e541), SPH_C32(0x2dc6d26a) },
  { SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d), SPH_C32(0xe0272f7d),
    SPH_C32(0xa5e7de5a), SPH_C32(0xa7b80200), SPH_C32(0x1f128433),
    SPH_C32(0x60e5f9f2), SPH_C32(0x9e147576) },
  { SPH_C32(0x3ad20200), SPH_C32(0x98364bdb), SPH_C32(0x42ba3dea),
    SPH_C32(0xcb02b60e), SPH_C32(0x63500300), SPH_C32(0x0062123d),
    SPH_C32(0x47f133ce), SPH_C32(0x16357946) }
};

__constant static const sph_u32 T256_15[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0x62740080), SPH_C32(0x0fb84b07), SPH_C32(0x138a651e),
    SPH_C32(0x44100618), SPH_C32(0x5bd20080), SPH_C32(0x450f18ec),
    SPH_C32(0xc2c46c55), SPH_C32(0xf362b233) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0xec760180), SPH_C32(0xcf102934), SPH_C32(0x474db4fe),
    SPH_C32(0x15a6d657), SPH_C32(0x4aea0000), SPH_C32(0xdfd8f43d),
    SPH_C32(0x73d31bdc), SPH_C32(0xd997dc7f) },
  { SPH_C32(0x8e020100), SPH_C32(0xc0a86233), SPH_C32(0x54c7d1e0),
    SPH_C32(0x51b6d04f), SPH_C32(0x11380080), SPH_C32(0x9ad7ecd1),
    SPH_C32(0xb1177789), SPH_C32(0x2af56e4c) },
  { SPH_C32(0xd5d00180), SPH_C32(0x85a77adf), SPH_C32(0x9603bdb5),
    SPH_C32(0xa2d4627c), SPH_C32(0x289e0080), SPH_C32(0xd060bf3a),
    SPH_C32(0x60597ec2), SPH_C32(0x9d87da67) }
};

__constant static const sph_u32 T256_18[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x11bc0040), SPH_C32(0xf2e1216c), SPH_C32(0x4fcc6651),
    SPH_C32(0x408a1b7d), SPH_C32(0x86610020), SPH_C32(0xe89072d0),
    SPH_C32(0xdd3be10a), SPH_C32(0xf3310573) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x24d90000), SPH_C32(0x69779726), SPH_C32(0x24f5ad0e),
    SPH_C32(0x119ea5b3), SPH_C32(0xcbaf0060), SPH_C32(0xd3cb9eae),
    SPH_C32(0xeb5e8aa2), SPH_C32(0xd0523f76) },
  { SPH_C32(0x35650040), SPH_C32(0x9b96b64a), SPH_C32(0x6b39cb5f),
    SPH_C32(0x5114bece), SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e),
    SPH_C32(0x36656ba8), SPH_C32(0x23633a05) },
  { SPH_C32(0x69170040), SPH_C32(0x522c7b58), SPH_C32(0x1290c6a6),
    SPH_C32(0x32fd9fb6), SPH_C32(0xb3040060), SPH_C32(0x7306c49a),
    SPH_C32(0xb6022a55), SPH_C32(0xa225bbbd) }
};

__constant static const sph_u32 T256_21[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0x7f650010), SPH_C32(0x242e1472), SPH_C32(0xc03320fe),
    SPH_C32(0xc0a3c0dd), SPH_C32(0x515c0010), SPH_C32(0x40f372fb),
    SPH_C32(0xfce72602), SPH_C32(0x71575061) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0xf3e40030), SPH_C32(0xc114970d), SPH_C32(0x05296a06),
    SPH_C32(0x93f8f0a1), SPH_C32(0x724b0000), SPH_C32(0xad67ab9b),
    SPH_C32(0x457d0b05), SPH_C32(0xd21db1c4) },
  { SPH_C32(0x8c810020), SPH_C32(0xe53a837f), SPH_C32(0xc51a4af8),
    SPH_C32(0x535b307c), SPH_C32(0x23170010), SPH_C32(0xed94d960),
    SPH_C32(0xb99a2d07), SPH_C32(0xa34ae1a5) },
  { SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184), SPH_C32(0x39fd6cfa),
    SPH_C32(0x220c601d), SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9),
    SPH_C32(0x854e2bfb), SPH_C32(0x12be7119) }
};

__constant static const sph_u32 T256_24[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0xc3070008), SPH_C32(0x6092c0d7), SPH_C32(0x66418f3c),
    SPH_C32(0xce05ef02), SPH_C32(0xacbd0004), SPH_C32(0x7ef34599),
    SPH_C32(0x9b9d2f13), SPH_C32(0x811ea6b6) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) },
  { SPH_C32(0x7cb50000), SPH_C32(0xf285caee), SPH_C32(0x06589f43),
    SPH_C32(0x2e548f6c), SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4),
    SPH_C32(0x65eebc12), SPH_C32(0x39b78e87) },
  { SPH_C32(0xbfb20008), SPH_C32(0x92170a39), SPH_C32(0x6019107f),
    SPH_C32(0xe051606e), SPH_C32(0xa8ae0008), SPH_C32(0x2079397d),
    SPH_C32(0xfe739301), SPH_C32(0xb8a92831) },
  { SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393), SPH_C32(0xf82b0c42),
    SPH_C32(0x96fda75d), SPH_C32(0x130f000c), SPH_C32(0xece44fa0),
    SPH_C32(0xfb843f6c), SPH_C32(0x614fc6d8) }
};

__constant static const sph_u32 T256_27[8][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7), SPH_C32(0xe007afe6),
    SPH_C32(0x9fed4ab7), SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3),
    SPH_C32(0x99e585aa), SPH_C32(0x8d75f7f1) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x582b0006), SPH_C32(0xd39128c4), SPH_C32(0x042035fa),
    SPH_C32(0x223fde2b), SPH_C32(0x3a050000), SPH_C32(0x6508f6be),
    SPH_C32(0xe1d03671), SPH_C32(0x64347a75) },
  { SPH_C32(0x81a40004), SPH_C32(0xa9958063), SPH_C32(0xe4279a1c),
    SPH_C32(0xbdd2949c), SPH_C32(0xb2260002), SPH_C32(0x3aef510d),
    SPH_C32(0x7835b3db), SPH_C32(0xe9418d84) },
  { SPH_C32(0x09870006), SPH_C32(0xf67227d0), SPH_C32(0x7dc21fb6),
    SPH_C32(0x30a7636d), SPH_C32(0xe38a0002), SPH_C32(0x1f0c5e19),
    SPH_C32(0x01d79997), SPH_C32(0xfbd930c2) }
};

__constant static const sph_u32 T256_30[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x08bf0001), SPH_C32(0x38942792), SPH_C32(0xc5f8f3a1),
    SPH_C32(0xe6387b84), SPH_C32(0xc04e0001), SPH_C32(0x33b9c010),
    SPH_C32(0xae0ebb05), SPH_C32(0xb5a4c63b) }
};

#define INPUT_SMALL   do { \
    unsigned acc = buf[0]; \
    const sph_u32 *rp; \
    rp = &T256_0[acc >> 5][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    rp = &T256_3[(acc >> 2) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = (acc << 8) | buf[1]; \
    rp = &T256_6[(acc >> 7) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_9[(acc >> 4) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_12[(acc >> 1) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = (acc << 8) | buf[2]; \
    rp = &T256_15[(acc >> 6) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_18[(acc >> 3) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_21[acc & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[3]; \
    rp = &T256_24[acc >> 5][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_27[(acc >> 2) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_30[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_SMALL == 4

__constant static const sph_u32 T256_0[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd), SPH_C32(0x097f5711),
    SPH_C32(0xde77cc4c), SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8),
    SPH_C32(0x8dfacfab), SPH_C32(0xce36cc72) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0xf663c000), SPH_C32(0xde81aa29), SPH_C32(0x3801ebf9),
    SPH_C32(0xe7fa92ad), SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec),
    SPH_C32(0xe679e16a), SPH_C32(0x635fbdfc) },
  { SPH_C32(0x022f8000), SPH_C32(0xce2549e4), SPH_C32(0x317ebce8),
    SPH_C32(0x398d5ee1), SPH_C32(0xf0134000), SPH_C32(0x8cee7004),
    SPH_C32(0x6b832ec1), SPH_C32(0xad69718e) },
  { SPH_C32(0x1034c000), SPH_C32(0x9532900c), SPH_C32(0xbc847343),
    SPH_C32(0xf7bb9293), SPH_C32(0x16444000), SPH_C32(0xc75d4a21),
    SPH_C32(0xef06b67b), SPH_C32(0xbd2871b0) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0x16444000), SPH_C32(0xc75d4a21), SPH_C32(0xef06b67b),
    SPH_C32(0xbd2871b0), SPH_C32(0x06708000), SPH_C32(0x526fda2d),
    SPH_C32(0x5382c538), SPH_C32(0x4a93e323) },
  { SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec), SPH_C32(0xe679e16a),
    SPH_C32(0x635fbdfc), SPH_C32(0x146bc000), SPH_C32(0x097803c5),
    SPH_C32(0xde780a93), SPH_C32(0x84a52f51) },
  { SPH_C32(0xf0134000), SPH_C32(0x8cee7004), SPH_C32(0x6b832ec1),
    SPH_C32(0xad69718e), SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0),
    SPH_C32(0x5afd9229), SPH_C32(0x94e42f6f) },
  { SPH_C32(0xe0278000), SPH_C32(0x19dce008), SPH_C32(0xd7075d82),
    SPH_C32(0x5ad2e31d), SPH_C32(0xe4788000), SPH_C32(0x859673c1),
    SPH_C32(0xb5fb2452), SPH_C32(0x29cc5edf) },
  { SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0), SPH_C32(0x5afd9229),
    SPH_C32(0x94e42f6f), SPH_C32(0x022f8000), SPH_C32(0xce2549e4),
    SPH_C32(0x317ebce8), SPH_C32(0x398d5ee1) },
  { SPH_C32(0x06708000), SPH_C32(0x526fda2d), SPH_C32(0x5382c538),
    SPH_C32(0x4a93e323), SPH_C32(0x1034c000), SPH_C32(0x9532900c),
    SPH_C32(0xbc847343), SPH_C32(0xf7bb9293) },
  { SPH_C32(0x146bc000), SPH_C32(0x097803c5), SPH_C32(0xde780a93),
    SPH_C32(0x84a52f51), SPH_C32(0xf663c000), SPH_C32(0xde81aa29),
    SPH_C32(0x3801ebf9), SPH_C32(0xe7fa92ad) }
};

__constant static const sph_u32 T256_4[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117), SPH_C32(0x3321e92c),
    SPH_C32(0xce122df3), SPH_C32(0x74951000), SPH_C32(0x5a2b467e),
    SPH_C32(0x88fd1d2b), SPH_C32(0x1ee68292) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x9dbf3000), SPH_C32(0xee7cca82), SPH_C32(0x9907277c),
    SPH_C32(0x232f87b6), SPH_C32(0x5cfa0000), SPH_C32(0xb06859ba),
    SPH_C32(0xcc651c08), SPH_C32(0x7118f1a0) },
  { SPH_C32(0x22832000), SPH_C32(0x2470bb95), SPH_C32(0xaa26ce50),
    SPH_C32(0xed3daa45), SPH_C32(0x286f1000), SPH_C32(0xea431fc4),
    SPH_C32(0x44980123), SPH_C32(0x6ffe7332) },
  { SPH_C32(0x56163000), SPH_C32(0x7e5bfdeb), SPH_C32(0x22dbd37b),
    SPH_C32(0xf3db28d7), SPH_C32(0xe3c61000), SPH_C32(0x7a6428ad),
    SPH_C32(0xff44f524), SPH_C32(0xbf0adc53) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0xe3c61000), SPH_C32(0x7a6428ad), SPH_C32(0xff44f524),
    SPH_C32(0xbf0adc53), SPH_C32(0xb5d02000), SPH_C32(0x043fd546),
    SPH_C32(0xdd9f265f), SPH_C32(0x4cd1f484) },
  { SPH_C32(0x5cfa0000), SPH_C32(0xb06859ba), SPH_C32(0xcc651c08),
    SPH_C32(0x7118f1a0), SPH_C32(0xc1453000), SPH_C32(0x5e149338),
    SPH_C32(0x55623b74), SPH_C32(0x52377616) },
  { SPH_C32(0x286f1000), SPH_C32(0xea431fc4), SPH_C32(0x44980123),
    SPH_C32(0x6ffe7332), SPH_C32(0x0aec3000), SPH_C32(0xce33a451),
    SPH_C32(0xeebecf73), SPH_C32(0x82c3d977) },
  { SPH_C32(0x7e792000), SPH_C32(0x9418e22f), SPH_C32(0x6643d258),
    SPH_C32(0x9c255be5), SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc),
    SPH_C32(0x11fa3a57), SPH_C32(0x3dc90524) },
  { SPH_C32(0x0aec3000), SPH_C32(0xce33a451), SPH_C32(0xeebecf73),
    SPH_C32(0x82c3d977), SPH_C32(0x22832000), SPH_C32(0x2470bb95),
    SPH_C32(0xaa26ce50), SPH_C32(0xed3daa45) },
  { SPH_C32(0xb5d02000), SPH_C32(0x043fd546), SPH_C32(0xdd9f265f),
    SPH_C32(0x4cd1f484), SPH_C32(0x56163000), SPH_C32(0x7e5bfdeb),
    SPH_C32(0x22dbd37b), SPH_C32(0xf3db28d7) },
  { SPH_C32(0xc1453000), SPH_C32(0x5e149338), SPH_C32(0x55623b74),
    SPH_C32(0x52377616), SPH_C32(0x9dbf3000), SPH_C32(0xee7cca82),
    SPH_C32(0x9907277c), SPH_C32(0x232f87b6) }
};

__constant static const sph_u32 T256_8[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0x9b830400), SPH_C32(0x2227ff88), SPH_C32(0x05b7ad5a),
    SPH_C32(0xadf2c730), SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877),
    SPH_C32(0x6fc548e1), SPH_C32(0x898d2cd6) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0x510c0c00), SPH_C32(0x251e9889), SPH_C32(0x1e406226),
    SPH_C32(0x2f32b340), SPH_C32(0xf5360000), SPH_C32(0x7be3bf82),
    SPH_C32(0xd5606668), SPH_C32(0x3f198195) },
  { SPH_C32(0xca8f0800), SPH_C32(0x07396701), SPH_C32(0x1bf7cf7c),
    SPH_C32(0x82c07470), SPH_C32(0x7a080400), SPH_C32(0x767e77f5),
    SPH_C32(0xbaa52e89), SPH_C32(0xb694ad43) },
  { SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76), SPH_C32(0x7432879d),
    SPH_C32(0x0b4d58a6), SPH_C32(0x6eb50400), SPH_C32(0x59c4400a),
    SPH_C32(0xd0d7cb32), SPH_C32(0x92eb46a5) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x6eb50400), SPH_C32(0x59c4400a), SPH_C32(0xd0d7cb32),
    SPH_C32(0x92eb46a5), SPH_C32(0x2b040800), SPH_C32(0x5360ef7c),
    SPH_C32(0xa4e54caf), SPH_C32(0x99a61e03) },
  { SPH_C32(0xf5360000), SPH_C32(0x7be3bf82), SPH_C32(0xd5606668),
    SPH_C32(0x3f198195), SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b),
    SPH_C32(0xcb20044e), SPH_C32(0x102b32d5) },
  { SPH_C32(0x7a080400), SPH_C32(0x767e77f5), SPH_C32(0xbaa52e89),
    SPH_C32(0xb694ad43), SPH_C32(0xb0870c00), SPH_C32(0x714710f4),
    SPH_C32(0xa152e1f5), SPH_C32(0x3454d933) },
  { SPH_C32(0x3fb90800), SPH_C32(0x7cdad883), SPH_C32(0xce97a914),
    SPH_C32(0xbdd9f5e5), SPH_C32(0xde320800), SPH_C32(0x288350fe),
    SPH_C32(0x71852ac7), SPH_C32(0xa6bf9f96) },
  { SPH_C32(0xb0870c00), SPH_C32(0x714710f4), SPH_C32(0xa152e1f5),
    SPH_C32(0x3454d933), SPH_C32(0xca8f0800), SPH_C32(0x07396701),
    SPH_C32(0x1bf7cf7c), SPH_C32(0x82c07470) },
  { SPH_C32(0x2b040800), SPH_C32(0x5360ef7c), SPH_C32(0xa4e54caf),
    SPH_C32(0x99a61e03), SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76),
    SPH_C32(0x7432879d), SPH_C32(0x0b4d58a6) },
  { SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b), SPH_C32(0xcb20044e),
    SPH_C32(0x102b32d5), SPH_C32(0x510c0c00), SPH_C32(0x251e9889),
    SPH_C32(0x1e406226), SPH_C32(0x2f32b340) }
};

__constant static const sph_u32 T256_12[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0xc4e80100), SPH_C32(0x1f70960e), SPH_C32(0x2714ca3c),
    SPH_C32(0x88210c30), SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8),
    SPH_C32(0x8589d8ab), SPH_C32(0xe6c46464) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0x101c0300), SPH_C32(0x950db5eb), SPH_C32(0xe56c2159),
    SPH_C32(0x78d01112), SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8),
    SPH_C32(0x225fc418), SPH_C32(0x5516c378) },
  { SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5), SPH_C32(0xc278eb65),
    SPH_C32(0xf0f11d22), SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30),
    SPH_C32(0xa7d61cb3), SPH_C32(0xb3d2a71c) },
  { SPH_C32(0x63500300), SPH_C32(0x0062123d), SPH_C32(0x47f133ce),
    SPH_C32(0x16357946), SPH_C32(0x59820100), SPH_C32(0x985459e6),
    SPH_C32(0x054b0e24), SPH_C32(0xdd37cf48) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0x59820100), SPH_C32(0x985459e6), SPH_C32(0x054b0e24),
    SPH_C32(0xdd37cf48), SPH_C32(0x3ad20200), SPH_C32(0x98364bdb),
    SPH_C32(0x42ba3dea), SPH_C32(0xcb02b60e) },
  { SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8), SPH_C32(0x225fc418),
    SPH_C32(0x5516c378), SPH_C32(0x8d760300), SPH_C32(0x12297a03),
    SPH_C32(0xc733e541), SPH_C32(0x2dc6d26a) },
  { SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30), SPH_C32(0xa7d61cb3),
    SPH_C32(0xb3d2a71c), SPH_C32(0xfe3a0300), SPH_C32(0x8746ddd5),
    SPH_C32(0x65aef7d6), SPH_C32(0x4323ba3e) },
  { SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d), SPH_C32(0xe0272f7d),
    SPH_C32(0xa5e7de5a), SPH_C32(0xa7b80200), SPH_C32(0x1f128433),
    SPH_C32(0x60e5f9f2), SPH_C32(0x9e147576) },
  { SPH_C32(0xfe3a0300), SPH_C32(0x8746ddd5), SPH_C32(0x65aef7d6),
    SPH_C32(0x4323ba3e), SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5),
    SPH_C32(0xc278eb65), SPH_C32(0xf0f11d22) },
  { SPH_C32(0x3ad20200), SPH_C32(0x98364bdb), SPH_C32(0x42ba3dea),
    SPH_C32(0xcb02b60e), SPH_C32(0x63500300), SPH_C32(0x0062123d),
    SPH_C32(0x47f133ce), SPH_C32(0x16357946) },
  { SPH_C32(0x8d760300), SPH_C32(0x12297a03), SPH_C32(0xc733e541),
    SPH_C32(0x2dc6d26a), SPH_C32(0x101c0300), SPH_C32(0x950db5eb),
    SPH_C32(0xe56c2159), SPH_C32(0x78d01112) }
};

__constant static const sph_u32 T256_16[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x35650040), SPH_C32(0x9b96b64a), SPH_C32(0x6b39cb5f),
    SPH_C32(0x5114bece), SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e),
    SPH_C32(0x36656ba8), SPH_C32(0x23633a05) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x161c00c0), SPH_C32(0x7e54f492), SPH_C32(0xf4a107fd),
    SPH_C32(0xd0018836), SPH_C32(0x410d0000), SPH_C32(0xea7a09df),
    SPH_C32(0x8c12a9bc), SPH_C32(0xc50530e0) },
  { SPH_C32(0x23790080), SPH_C32(0xe5c242d8), SPH_C32(0x9f98cca2),
    SPH_C32(0x811536f8), SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1),
    SPH_C32(0xba77c214), SPH_C32(0xe6660ae5) },
  { SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6), SPH_C32(0xa9fda70a),
    SPH_C32(0xa2760cfd), SPH_C32(0x74680040), SPH_C32(0x71ecbf95),
    SPH_C32(0xe72b62e3), SPH_C32(0x94118e2e) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0x74680040), SPH_C32(0x71ecbf95), SPH_C32(0xe72b62e3),
    SPH_C32(0x94118e2e), SPH_C32(0x1adf0080), SPH_C32(0xaf751133),
    SPH_C32(0x4ed6c5e9), SPH_C32(0x366782d3) },
  { SPH_C32(0x410d0000), SPH_C32(0xea7a09df), SPH_C32(0x8c12a9bc),
    SPH_C32(0xc50530e0), SPH_C32(0x571100c0), SPH_C32(0x942efd4d),
    SPH_C32(0x78b3ae41), SPH_C32(0x1504b8d6) },
  { SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1), SPH_C32(0xba77c214),
    SPH_C32(0xe6660ae5), SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779),
    SPH_C32(0x25ef0eb6), SPH_C32(0x67733c1d) },
  { SPH_C32(0x62740080), SPH_C32(0x0fb84b07), SPH_C32(0x138a651e),
    SPH_C32(0x44100618), SPH_C32(0x5bd20080), SPH_C32(0x450f18ec),
    SPH_C32(0xc2c46c55), SPH_C32(0xf362b233) },
  { SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779), SPH_C32(0x25ef0eb6),
    SPH_C32(0x67733c1d), SPH_C32(0x23790080), SPH_C32(0xe5c242d8),
    SPH_C32(0x9f98cca2), SPH_C32(0x811536f8) },
  { SPH_C32(0x1adf0080), SPH_C32(0xaf751133), SPH_C32(0x4ed6c5e9),
    SPH_C32(0x366782d3), SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6),
    SPH_C32(0xa9fda70a), SPH_C32(0xa2760cfd) },
  { SPH_C32(0x571100c0), SPH_C32(0x942efd4d), SPH_C32(0x78b3ae41),
    SPH_C32(0x1504b8d6), SPH_C32(0x161c00c0), SPH_C32(0x7e54f492),
    SPH_C32(0xf4a107fd), SPH_C32(0xd0018836) }
};

__constant static const sph_u32 T256_20[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0x7f650010), SPH_C32(0x242e1472), SPH_C32(0xc03320fe),
    SPH_C32(0xc0a3c0dd), SPH_C32(0x515c0010), SPH_C32(0x40f372fb),
    SPH_C32(0xfce72602), SPH_C32(0x71575061) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0xf3e40030), SPH_C32(0xc114970d), SPH_C32(0x05296a06),
    SPH_C32(0x93f8f0a1), SPH_C32(0x724b0000), SPH_C32(0xad67ab9b),
    SPH_C32(0x457d0b05), SPH_C32(0xd21db1c4) },
  { SPH_C32(0x8c810020), SPH_C32(0xe53a837f), SPH_C32(0xc51a4af8),
    SPH_C32(0x535b307c), SPH_C32(0x23170010), SPH_C32(0xed94d960),
    SPH_C32(0xb99a2d07), SPH_C32(0xa34ae1a5) },
  { SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184), SPH_C32(0x39fd6cfa),
    SPH_C32(0x220c601d), SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9),
    SPH_C32(0x854e2bfb), SPH_C32(0x12be7119) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9), SPH_C32(0x854e2bfb),
    SPH_C32(0x12be7119), SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d),
    SPH_C32(0xbcb34701), SPH_C32(0x30b21104) },
  { SPH_C32(0x724b0000), SPH_C32(0xad67ab9b), SPH_C32(0x457d0b05),
    SPH_C32(0xd21db1c4), SPH_C32(0x81af0030), SPH_C32(0x6c733c96),
    SPH_C32(0x40546103), SPH_C32(0x41e54165) },
  { SPH_C32(0x23170010), SPH_C32(0xed94d960), SPH_C32(0xb99a2d07),
    SPH_C32(0xa34ae1a5), SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f),
    SPH_C32(0x7c8067ff), SPH_C32(0xf011d1d9) },
  { SPH_C32(0xfeca0020), SPH_C32(0x485d28e4), SPH_C32(0x806741fd),
    SPH_C32(0x814681b8), SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6),
    SPH_C32(0xf9ce4c04), SPH_C32(0xe2afa0c0) },
  { SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f), SPH_C32(0x7c8067ff),
    SPH_C32(0xf011d1d9), SPH_C32(0x8c810020), SPH_C32(0xe53a837f),
    SPH_C32(0xc51a4af8), SPH_C32(0x535b307c) },
  { SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d), SPH_C32(0xbcb34701),
    SPH_C32(0x30b21104), SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184),
    SPH_C32(0x39fd6cfa), SPH_C32(0x220c601d) },
  { SPH_C32(0x81af0030), SPH_C32(0x6c733c96), SPH_C32(0x40546103),
    SPH_C32(0x41e54165), SPH_C32(0xf3e40030), SPH_C32(0xc114970d),
    SPH_C32(0x05296a06), SPH_C32(0x93f8f0a1) }
};

__constant static const sph_u32 T256_24[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd), SPH_C32(0x05f7ac6d),
    SPH_C32(0xd9e6eee9), SPH_C32(0xd0080004), SPH_C32(0x8c768f77),
    SPH_C32(0x9dc5b050), SPH_C32(0xaf4a29da) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a), SPH_C32(0x63b62351),
    SPH_C32(0x17e301eb), SPH_C32(0x7cb50000), SPH_C32(0xf285caee),
    SPH_C32(0x06589f43), SPH_C32(0x2e548f6c) },
  { SPH_C32(0xc3070008), SPH_C32(0x6092c0d7), SPH_C32(0x66418f3c),
    SPH_C32(0xce05ef02), SPH_C32(0xacbd0004), SPH_C32(0x7ef34599),
    SPH_C32(0x9b9d2f13), SPH_C32(0x811ea6b6) },
  { SPH_C32(0x130f000c), SPH_C32(0xece44fa0), SPH_C32(0xfb843f6c),
    SPH_C32(0x614fc6d8), SPH_C32(0xc7140004), SPH_C32(0x3e18bc33),
    SPH_C32(0x03af332e), SPH_C32(0xf7b26185) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) },
  { SPH_C32(0xc7140004), SPH_C32(0x3e18bc33), SPH_C32(0x03af332e),
    SPH_C32(0xf7b26185), SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393),
    SPH_C32(0xf82b0c42), SPH_C32(0x96fda75d) },
  { SPH_C32(0x7cb50000), SPH_C32(0xf285caee), SPH_C32(0x06589f43),
    SPH_C32(0x2e548f6c), SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4),
    SPH_C32(0x65eebc12), SPH_C32(0x39b78e87) },
  { SPH_C32(0xacbd0004), SPH_C32(0x7ef34599), SPH_C32(0x9b9d2f13),
    SPH_C32(0x811ea6b6), SPH_C32(0x6fba000c), SPH_C32(0x1e61854e),
    SPH_C32(0xfddca02f), SPH_C32(0x4f1b49b4) },
  { SPH_C32(0xbfb20008), SPH_C32(0x92170a39), SPH_C32(0x6019107f),
    SPH_C32(0xe051606e), SPH_C32(0xa8ae0008), SPH_C32(0x2079397d),
    SPH_C32(0xfe739301), SPH_C32(0xb8a92831) },
  { SPH_C32(0x6fba000c), SPH_C32(0x1e61854e), SPH_C32(0xfddca02f),
    SPH_C32(0x4f1b49b4), SPH_C32(0xc3070008), SPH_C32(0x6092c0d7),
    SPH_C32(0x66418f3c), SPH_C32(0xce05ef02) },
  { SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393), SPH_C32(0xf82b0c42),
    SPH_C32(0x96fda75d), SPH_C32(0x130f000c), SPH_C32(0xece44fa0),
    SPH_C32(0xfb843f6c), SPH_C32(0x614fc6d8) },
  { SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4), SPH_C32(0x65eebc12),
    SPH_C32(0x39b78e87), SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a),
    SPH_C32(0x63b62351), SPH_C32(0x17e301eb) }
};

__constant static const sph_u32 T256_28[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x08bf0001), SPH_C32(0x38942792), SPH_C32(0xc5f8f3a1),
    SPH_C32(0xe6387b84), SPH_C32(0xc04e0001), SPH_C32(0x33b9c010),
    SPH_C32(0xae0ebb05), SPH_C32(0xb5a4c63b) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x486d0003), SPH_C32(0x6c5e67a3), SPH_C32(0x37eb3eaf),
    SPH_C32(0x38d131ca), SPH_C32(0x995d0000), SPH_C32(0x2ecee896),
    SPH_C32(0x121462e8), SPH_C32(0x410400f9) },
  { SPH_C32(0x40d20002), SPH_C32(0x54ca4031), SPH_C32(0xf213cd0e),
    SPH_C32(0xdee94a4e), SPH_C32(0x59130001), SPH_C32(0x1d772886),
    SPH_C32(0xbc1ad9ed), SPH_C32(0xf4a0c6c2) },
  { SPH_C32(0x809c0003), SPH_C32(0x67738021), SPH_C32(0x5c1d760b),
    SPH_C32(0x6b4d8c75), SPH_C32(0x91e20001), SPH_C32(0x165acf04),
    SPH_C32(0xd7ec9149), SPH_C32(0xa73c7b7d) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0x91e20001), SPH_C32(0x165acf04), SPH_C32(0xd7ec9149),
    SPH_C32(0xa73c7b7d), SPH_C32(0x117e0002), SPH_C32(0x71294f25),
    SPH_C32(0x8bf1e742), SPH_C32(0xcc71f708) },
  { SPH_C32(0x995d0000), SPH_C32(0x2ecee896), SPH_C32(0x121462e8),
    SPH_C32(0x410400f9), SPH_C32(0xd1300003), SPH_C32(0x42908f35),
    SPH_C32(0x25ff5c47), SPH_C32(0x79d53133) },
  { SPH_C32(0x59130001), SPH_C32(0x1d772886), SPH_C32(0xbc1ad9ed),
    SPH_C32(0xf4a0c6c2), SPH_C32(0x19c10003), SPH_C32(0x49bd68b7),
    SPH_C32(0x4e0914e3), SPH_C32(0x2a498c8c) },
  { SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7), SPH_C32(0xe007afe6),
    SPH_C32(0x9fed4ab7), SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3),
    SPH_C32(0x99e585aa), SPH_C32(0x8d75f7f1) },
  { SPH_C32(0x19c10003), SPH_C32(0x49bd68b7), SPH_C32(0x4e0914e3),
    SPH_C32(0x2a498c8c), SPH_C32(0x40d20002), SPH_C32(0x54ca4031),
    SPH_C32(0xf213cd0e), SPH_C32(0xdee94a4e) },
  { SPH_C32(0x117e0002), SPH_C32(0x71294f25), SPH_C32(0x8bf1e742),
    SPH_C32(0xcc71f708), SPH_C32(0x809c0003), SPH_C32(0x67738021),
    SPH_C32(0x5c1d760b), SPH_C32(0x6b4d8c75) },
  { SPH_C32(0xd1300003), SPH_C32(0x42908f35), SPH_C32(0x25ff5c47),
    SPH_C32(0x79d53133), SPH_C32(0x486d0003), SPH_C32(0x6c5e67a3),
    SPH_C32(0x37eb3eaf), SPH_C32(0x38d131ca) }
};

#define INPUT_SMALL   do { \
    unsigned acc = buf[0]; \
    const sph_u32 *rp; \
    rp = &T256_0[acc >> 4][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    rp = &T256_4[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[1]; \
    rp = &T256_8[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_12[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[2]; \
    rp = &T256_16[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_20[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[3]; \
    rp = &T256_24[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_28[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_SMALL == 5

__constant static const sph_u32 T256_0[32][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0x85484000), SPH_C32(0x7b58b73b), SPH_C32(0xfa4327a4),
    SPH_C32(0x6fda92b3), SPH_C32(0x982e2000), SPH_C32(0xdfabd80a),
    SPH_C32(0xe2c64ae2), SPH_C32(0x8c645bdb) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0x71040000), SPH_C32(0x6bfc54f6), SPH_C32(0xf33c70b5),
    SPH_C32(0xb1ad5eff), SPH_C32(0x8a356000), SPH_C32(0x84bc01e2),
    SPH_C32(0x6f3c8549), SPH_C32(0x425297a9) },
  { SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd), SPH_C32(0x097f5711),
    SPH_C32(0xde77cc4c), SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8),
    SPH_C32(0x8dfacfab), SPH_C32(0xce36cc72) },
  { SPH_C32(0x631f4000), SPH_C32(0x30eb8d1e), SPH_C32(0x7ec6bf1e),
    SPH_C32(0x7f9b928d), SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7),
    SPH_C32(0xebb91df3), SPH_C32(0x52139797) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0x732b8000), SPH_C32(0xa5d91d12), SPH_C32(0xc242cc5d),
    SPH_C32(0x8820001e), SPH_C32(0x7a262000), SPH_C32(0x085271e6),
    SPH_C32(0x04bfab88), SPH_C32(0xef3be627) },
  { SPH_C32(0xf663c000), SPH_C32(0xde81aa29), SPH_C32(0x3801ebf9),
    SPH_C32(0xe7fa92ad), SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec),
    SPH_C32(0xe679e16a), SPH_C32(0x635fbdfc) },
  { SPH_C32(0x6130c000), SPH_C32(0xfecec4fa), SPH_C32(0x4fb803f6),
    SPH_C32(0x4616cc6c), SPH_C32(0x9c712000), SPH_C32(0x43e14bc3),
    SPH_C32(0x803a3332), SPH_C32(0xff7ae619) },
  { SPH_C32(0x022f8000), SPH_C32(0xce2549e4), SPH_C32(0x317ebce8),
    SPH_C32(0x398d5ee1), SPH_C32(0xf0134000), SPH_C32(0x8cee7004),
    SPH_C32(0x6b832ec1), SPH_C32(0xad69718e) },
  { SPH_C32(0x957c8000), SPH_C32(0xee6a2737), SPH_C32(0x46c754e7),
    SPH_C32(0x98610020), SPH_C32(0x8e6a6000), SPH_C32(0x18f6922b),
    SPH_C32(0x0dc0fc99), SPH_C32(0x314c2a6b) },
  { SPH_C32(0x1034c000), SPH_C32(0x9532900c), SPH_C32(0xbc847343),
    SPH_C32(0xf7bb9293), SPH_C32(0x16444000), SPH_C32(0xc75d4a21),
    SPH_C32(0xef06b67b), SPH_C32(0xbd2871b0) },
  { SPH_C32(0x8767c000), SPH_C32(0xb57dfedf), SPH_C32(0xcb3d9b4c),
    SPH_C32(0x5657cc52), SPH_C32(0x683d6000), SPH_C32(0x5345a80e),
    SPH_C32(0x89456423), SPH_C32(0x210d2a55) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0x930c0000), SPH_C32(0xbc05fd1a), SPH_C32(0x154591df),
    SPH_C32(0xd2f2e303), SPH_C32(0x9e5ea000), SPH_C32(0x8dc40227),
    SPH_C32(0xb1448fda), SPH_C32(0xc6f7b8f8) },
  { SPH_C32(0x16444000), SPH_C32(0xc75d4a21), SPH_C32(0xef06b67b),
    SPH_C32(0xbd2871b0), SPH_C32(0x06708000), SPH_C32(0x526fda2d),
    SPH_C32(0x5382c538), SPH_C32(0x4a93e323) },
  { SPH_C32(0x81174000), SPH_C32(0xe71224f2), SPH_C32(0x98bf5e74),
    SPH_C32(0x1cc42f71), SPH_C32(0x7809a000), SPH_C32(0xc6773802),
    SPH_C32(0x35c11760), SPH_C32(0xd6b6b8c6) },
  { SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec), SPH_C32(0xe679e16a),
    SPH_C32(0x635fbdfc), SPH_C32(0x146bc000), SPH_C32(0x097803c5),
    SPH_C32(0xde780a93), SPH_C32(0x84a52f51) },
  { SPH_C32(0x755b0000), SPH_C32(0xf7b6c73f), SPH_C32(0x91c00965),
    SPH_C32(0xc2b3e33d), SPH_C32(0x6a12e000), SPH_C32(0x9d60e1ea),
    SPH_C32(0xb83bd8cb), SPH_C32(0x188074b4) },
  { SPH_C32(0xf0134000), SPH_C32(0x8cee7004), SPH_C32(0x6b832ec1),
    SPH_C32(0xad69718e), SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0),
    SPH_C32(0x5afd9229), SPH_C32(0x94e42f6f) },
  { SPH_C32(0x67404000), SPH_C32(0xaca11ed7), SPH_C32(0x1c3ac6ce),
    SPH_C32(0x0c852f4f), SPH_C32(0x8c45e000), SPH_C32(0xd6d3dbcf),
    SPH_C32(0x3cbe4071), SPH_C32(0x08c1748a) },
  { SPH_C32(0xe0278000), SPH_C32(0x19dce008), SPH_C32(0xd7075d82),
    SPH_C32(0x5ad2e31d), SPH_C32(0xe4788000), SPH_C32(0x859673c1),
    SPH_C32(0xb5fb2452), SPH_C32(0x29cc5edf) },
  { SPH_C32(0x77748000), SPH_C32(0x39938edb), SPH_C32(0xa0beb58d),
    SPH_C32(0xfb3ebddc), SPH_C32(0x9a01a000), SPH_C32(0x118e91ee),
    SPH_C32(0xd3b8f60a), SPH_C32(0xb5e9053a) },
  { SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0), SPH_C32(0x5afd9229),
    SPH_C32(0x94e42f6f), SPH_C32(0x022f8000), SPH_C32(0xce2549e4),
    SPH_C32(0x317ebce8), SPH_C32(0x398d5ee1) },
  { SPH_C32(0x656fc000), SPH_C32(0x62845733), SPH_C32(0x2d447a26),
    SPH_C32(0x350871ae), SPH_C32(0x7c56a000), SPH_C32(0x5a3dabcb),
    SPH_C32(0x573d6eb0), SPH_C32(0xa5a80504) },
  { SPH_C32(0x06708000), SPH_C32(0x526fda2d), SPH_C32(0x5382c538),
    SPH_C32(0x4a93e323), SPH_C32(0x1034c000), SPH_C32(0x9532900c),
    SPH_C32(0xbc847343), SPH_C32(0xf7bb9293) },
  { SPH_C32(0x91238000), SPH_C32(0x7220b4fe), SPH_C32(0x243b2d37),
    SPH_C32(0xeb7fbde2), SPH_C32(0x6e4de000), SPH_C32(0x012a7223),
    SPH_C32(0xdac7a11b), SPH_C32(0x6b9ec976) },
  { SPH_C32(0x146bc000), SPH_C32(0x097803c5), SPH_C32(0xde780a93),
    SPH_C32(0x84a52f51), SPH_C32(0xf663c000), SPH_C32(0xde81aa29),
    SPH_C32(0x3801ebf9), SPH_C32(0xe7fa92ad) },
  { SPH_C32(0x8338c000), SPH_C32(0x29376d16), SPH_C32(0xa9c1e29c),
    SPH_C32(0x25497190), SPH_C32(0x881ae000), SPH_C32(0x4a994806),
    SPH_C32(0x5e4239a1), SPH_C32(0x7bdfc948) }
};

__constant static const sph_u32 T256_5[32][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x3fb90800), SPH_C32(0x7cdad883), SPH_C32(0xce97a914),
    SPH_C32(0xbdd9f5e5), SPH_C32(0xde320800), SPH_C32(0x288350fe),
    SPH_C32(0x71852ac7), SPH_C32(0xa6bf9f96) },
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0xaaa71800), SPH_C32(0x72a81680), SPH_C32(0xf97837ec),
    SPH_C32(0xb8591d04), SPH_C32(0x2a220000), SPH_C32(0xc47ebf14),
    SPH_C32(0x04ce77d4), SPH_C32(0xcb92c512) },
  { SPH_C32(0x951e1000), SPH_C32(0x0e72ce03), SPH_C32(0x37ef9ef8),
    SPH_C32(0x0580e8e1), SPH_C32(0xf4100800), SPH_C32(0xecfdefea),
    SPH_C32(0x754b5d13), SPH_C32(0x6d2d5a84) },
  { SPH_C32(0x4b2c1800), SPH_C32(0x26f19efd), SPH_C32(0x466ab43f),
    SPH_C32(0xa33f7777), SPH_C32(0x159b0800), SPH_C32(0xb8a46797),
    SPH_C32(0xca59dec0), SPH_C32(0x764b30f7) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0x159b0800), SPH_C32(0xb8a46797), SPH_C32(0xca59dec0),
    SPH_C32(0x764b30f7), SPH_C32(0x5eb71000), SPH_C32(0x9e55f96a),
    SPH_C32(0x8c336aff), SPH_C32(0xd5744780) },
  { SPH_C32(0x2a220000), SPH_C32(0xc47ebf14), SPH_C32(0x04ce77d4),
    SPH_C32(0xcb92c512), SPH_C32(0x80851800), SPH_C32(0xb6d6a994),
    SPH_C32(0xfdb64038), SPH_C32(0x73cbd816) },
  { SPH_C32(0xf4100800), SPH_C32(0xecfdefea), SPH_C32(0x754b5d13),
    SPH_C32(0x6d2d5a84), SPH_C32(0x610e1800), SPH_C32(0xe28f21e9),
    SPH_C32(0x42a4c3eb), SPH_C32(0x68adb265) },
  { SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117), SPH_C32(0x3321e92c),
    SPH_C32(0xce122df3), SPH_C32(0x74951000), SPH_C32(0x5a2b467e),
    SPH_C32(0x88fd1d2b), SPH_C32(0x1ee68292) },
  { SPH_C32(0x610e1800), SPH_C32(0xe28f21e9), SPH_C32(0x42a4c3eb),
    SPH_C32(0x68adb265), SPH_C32(0x951e1000), SPH_C32(0x0e72ce03),
    SPH_C32(0x37ef9ef8), SPH_C32(0x0580e8e1) },
  { SPH_C32(0x5eb71000), SPH_C32(0x9e55f96a), SPH_C32(0x8c336aff),
    SPH_C32(0xd5744780), SPH_C32(0x4b2c1800), SPH_C32(0x26f19efd),
    SPH_C32(0x466ab43f), SPH_C32(0xa33f7777) },
  { SPH_C32(0x80851800), SPH_C32(0xb6d6a994), SPH_C32(0xfdb64038),
    SPH_C32(0x73cbd816), SPH_C32(0xaaa71800), SPH_C32(0x72a81680),
    SPH_C32(0xf97837ec), SPH_C32(0xb8591d04) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x37182800), SPH_C32(0x9cd4dc02), SPH_C32(0x607f1090),
    SPH_C32(0x9b769ab2), SPH_C32(0x76d80000), SPH_C32(0x7416e6ae),
    SPH_C32(0xc8ab6bdc), SPH_C32(0xba8a34b2) },
  { SPH_C32(0x08a12000), SPH_C32(0xe00e0481), SPH_C32(0xaee8b984),
    SPH_C32(0x26af6f57), SPH_C32(0xa8ea0800), SPH_C32(0x5c95b650),
    SPH_C32(0xb92e411b), SPH_C32(0x1c35ab24) },
  { SPH_C32(0xd6932800), SPH_C32(0xc88d547f), SPH_C32(0xdf6d9343),
    SPH_C32(0x8010f0c1), SPH_C32(0x49610800), SPH_C32(0x08cc3e2d),
    SPH_C32(0x063cc2c8), SPH_C32(0x0753c157) },
  { SPH_C32(0x9dbf3000), SPH_C32(0xee7cca82), SPH_C32(0x9907277c),
    SPH_C32(0x232f87b6), SPH_C32(0x5cfa0000), SPH_C32(0xb06859ba),
    SPH_C32(0xcc651c08), SPH_C32(0x7118f1a0) },
  { SPH_C32(0x438d3800), SPH_C32(0xc6ff9a7c), SPH_C32(0xe8820dbb),
    SPH_C32(0x85901820), SPH_C32(0xbd710000), SPH_C32(0xe431d1c7),
    SPH_C32(0x73779fdb), SPH_C32(0x6a7e9bd3) },
  { SPH_C32(0x7c343000), SPH_C32(0xba2542ff), SPH_C32(0x2615a4af),
    SPH_C32(0x3849edc5), SPH_C32(0x63430800), SPH_C32(0xccb28139),
    SPH_C32(0x02f2b51c), SPH_C32(0xccc10445) },
  { SPH_C32(0xa2063800), SPH_C32(0x92a61201), SPH_C32(0x57908e68),
    SPH_C32(0x9ef67253), SPH_C32(0x82c80800), SPH_C32(0x98eb0944),
    SPH_C32(0xbde036cf), SPH_C32(0xd7a76e36) },
  { SPH_C32(0x22832000), SPH_C32(0x2470bb95), SPH_C32(0xaa26ce50),
    SPH_C32(0xed3daa45), SPH_C32(0x286f1000), SPH_C32(0xea431fc4),
    SPH_C32(0x44980123), SPH_C32(0x6ffe7332) },
  { SPH_C32(0xfcb12800), SPH_C32(0x0cf3eb6b), SPH_C32(0xdba3e497),
    SPH_C32(0x4b8235d3), SPH_C32(0xc9e41000), SPH_C32(0xbe1a97b9),
    SPH_C32(0xfb8a82f0), SPH_C32(0x74981941) },
  { SPH_C32(0xc3082000), SPH_C32(0x702933e8), SPH_C32(0x15344d83),
    SPH_C32(0xf65bc036), SPH_C32(0x17d61800), SPH_C32(0x9699c747),
    SPH_C32(0x8a0fa837), SPH_C32(0xd22786d7) },
  { SPH_C32(0x1d3a2800), SPH_C32(0x58aa6316), SPH_C32(0x64b16744),
    SPH_C32(0x50e45fa0), SPH_C32(0xf65d1800), SPH_C32(0xc2c04f3a),
    SPH_C32(0x351d2be4), SPH_C32(0xc941eca4) },
  { SPH_C32(0x56163000), SPH_C32(0x7e5bfdeb), SPH_C32(0x22dbd37b),
    SPH_C32(0xf3db28d7), SPH_C32(0xe3c61000), SPH_C32(0x7a6428ad),
    SPH_C32(0xff44f524), SPH_C32(0xbf0adc53) },
  { SPH_C32(0x88243800), SPH_C32(0x56d8ad15), SPH_C32(0x535ef9bc),
    SPH_C32(0x5564b741), SPH_C32(0x024d1000), SPH_C32(0x2e3da0d0),
    SPH_C32(0x405676f7), SPH_C32(0xa46cb620) },
  { SPH_C32(0xb79d3000), SPH_C32(0x2a027596), SPH_C32(0x9dc950a8),
    SPH_C32(0xe8bd42a4), SPH_C32(0xdc7f1800), SPH_C32(0x06bef02e),
    SPH_C32(0x31d35c30), SPH_C32(0x02d329b6) },
  { SPH_C32(0x69af3800), SPH_C32(0x02812568), SPH_C32(0xec4c7a6f),
    SPH_C32(0x4e02dd32), SPH_C32(0x3df41800), SPH_C32(0x52e77853),
    SPH_C32(0x8ec1dfe3), SPH_C32(0x19b543c5) }
};

__constant static const sph_u32 T256_10[32][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5), SPH_C32(0xc278eb65),
    SPH_C32(0xf0f11d22), SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30),
    SPH_C32(0xa7d61cb3), SPH_C32(0xb3d2a71c) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8), SPH_C32(0x225fc418),
    SPH_C32(0x5516c378), SPH_C32(0x8d760300), SPH_C32(0x12297a03),
    SPH_C32(0xc733e541), SPH_C32(0x2dc6d26a) },
  { SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d), SPH_C32(0xe0272f7d),
    SPH_C32(0xa5e7de5a), SPH_C32(0xa7b80200), SPH_C32(0x1f128433),
    SPH_C32(0x60e5f9f2), SPH_C32(0x9e147576) },
  { SPH_C32(0x3ad20200), SPH_C32(0x98364bdb), SPH_C32(0x42ba3dea),
    SPH_C32(0xcb02b60e), SPH_C32(0x63500300), SPH_C32(0x0062123d),
    SPH_C32(0x47f133ce), SPH_C32(0x16357946) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0xfc720400), SPH_C32(0x98f26fa1), SPH_C32(0xcd585a76),
    SPH_C32(0xe7684482), SPH_C32(0xd0550100), SPH_C32(0x30caa1f1),
    SPH_C32(0x4d662f87), SPH_C32(0xac5ee7d6) },
  { SPH_C32(0x28860600), SPH_C32(0x128f4c44), SPH_C32(0x0f20b113),
    SPH_C32(0x179959a0), SPH_C32(0xfa9b0000), SPH_C32(0x3df15fc1),
    SPH_C32(0xeab03334), SPH_C32(0x1f8c40ca) },
  { SPH_C32(0x5bca0600), SPH_C32(0x87e0eb92), SPH_C32(0xadbda384),
    SPH_C32(0x797c31f4), SPH_C32(0x3e730100), SPH_C32(0x2281c9cf),
    SPH_C32(0xcda4f908), SPH_C32(0x97ad4cfa) },
  { SPH_C32(0x61180400), SPH_C32(0x1fd6a049), SPH_C32(0xef079e6e),
    SPH_C32(0xb27e87fa), SPH_C32(0x5d230200), SPH_C32(0x22e3dbf2),
    SPH_C32(0x8a55cac6), SPH_C32(0x819835bc) },
  { SPH_C32(0x12540400), SPH_C32(0x8ab9079f), SPH_C32(0x4d9a8cf9),
    SPH_C32(0xdc9befae), SPH_C32(0x99cb0300), SPH_C32(0x3d934dfc),
    SPH_C32(0xad4100fa), SPH_C32(0x09b9398c) },
  { SPH_C32(0xc6a00600), SPH_C32(0x00c4247a), SPH_C32(0x8fe2679c),
    SPH_C32(0x2c6af28c), SPH_C32(0xb3050200), SPH_C32(0x30a8b3cc),
    SPH_C32(0x0a971c49), SPH_C32(0xba6b9e90) },
  { SPH_C32(0xb5ec0600), SPH_C32(0x95ab83ac), SPH_C32(0x2d7f750b),
    SPH_C32(0x428f9ad8), SPH_C32(0x77ed0300), SPH_C32(0x2fd825c2),
    SPH_C32(0x2d83d675), SPH_C32(0x324a92a0) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0x67f10000), SPH_C32(0xbad59029), SPH_C32(0xc8eff72c),
    SPH_C32(0x4a9a83b2), SPH_C32(0x5f6b0500), SPH_C32(0x3d576986),
    SPH_C32(0x22a36766), SPH_C32(0x25d3cb00) },
  { SPH_C32(0xb3050200), SPH_C32(0x30a8b3cc), SPH_C32(0x0a971c49),
    SPH_C32(0xba6b9e90), SPH_C32(0x75a50400), SPH_C32(0x306c97b6),
    SPH_C32(0x85757bd5), SPH_C32(0x96016c1c) },
  { SPH_C32(0xc0490200), SPH_C32(0xa5c7141a), SPH_C32(0xa80a0ede),
    SPH_C32(0xd48ef6c4), SPH_C32(0xb14d0500), SPH_C32(0x2f1c01b8),
    SPH_C32(0xa261b1e9), SPH_C32(0x1e20602c) },
  { SPH_C32(0xfa9b0000), SPH_C32(0x3df15fc1), SPH_C32(0xeab03334),
    SPH_C32(0x1f8c40ca), SPH_C32(0xd21d0600), SPH_C32(0x2f7e1385),
    SPH_C32(0xe5908227), SPH_C32(0x0815196a) },
  { SPH_C32(0x89d70000), SPH_C32(0xa89ef817), SPH_C32(0x482d21a3),
    SPH_C32(0x7169289e), SPH_C32(0x16f50700), SPH_C32(0x300e858b),
    SPH_C32(0xc284481b), SPH_C32(0x8034155a) },
  { SPH_C32(0x5d230200), SPH_C32(0x22e3dbf2), SPH_C32(0x8a55cac6),
    SPH_C32(0x819835bc), SPH_C32(0x3c3b0600), SPH_C32(0x3d357bbb),
    SPH_C32(0x655254a8), SPH_C32(0x33e6b246) },
  { SPH_C32(0x2e6f0200), SPH_C32(0xb78c7c24), SPH_C32(0x28c8d851),
    SPH_C32(0xef7d5de8), SPH_C32(0xf8d30700), SPH_C32(0x2245edb5),
    SPH_C32(0x42469e94), SPH_C32(0xbbc7be76) },
  { SPH_C32(0x9b830400), SPH_C32(0x2227ff88), SPH_C32(0x05b7ad5a),
    SPH_C32(0xadf2c730), SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877),
    SPH_C32(0x6fc548e1), SPH_C32(0x898d2cd6) },
  { SPH_C32(0xe8cf0400), SPH_C32(0xb748585e), SPH_C32(0xa72abfcd),
    SPH_C32(0xc317af64), SPH_C32(0x4bd60500), SPH_C32(0x12ed5e79),
    SPH_C32(0x48d182dd), SPH_C32(0x01ac20e6) },
  { SPH_C32(0x3c3b0600), SPH_C32(0x3d357bbb), SPH_C32(0x655254a8),
    SPH_C32(0x33e6b246), SPH_C32(0x61180400), SPH_C32(0x1fd6a049),
    SPH_C32(0xef079e6e), SPH_C32(0xb27e87fa) },
  { SPH_C32(0x4f770600), SPH_C32(0xa85adc6d), SPH_C32(0xc7cf463f),
    SPH_C32(0x5d03da12), SPH_C32(0xa5f00500), SPH_C32(0x00a63647),
    SPH_C32(0xc8135452), SPH_C32(0x3a5f8bca) },
  { SPH_C32(0x75a50400), SPH_C32(0x306c97b6), SPH_C32(0x85757bd5),
    SPH_C32(0x96016c1c), SPH_C32(0xc6a00600), SPH_C32(0x00c4247a),
    SPH_C32(0x8fe2679c), SPH_C32(0x2c6af28c) },
  { SPH_C32(0x06e90400), SPH_C32(0xa5033060), SPH_C32(0x27e86942),
    SPH_C32(0xf8e40448), SPH_C32(0x02480700), SPH_C32(0x1fb4b274),
    SPH_C32(0xa8f6ada0), SPH_C32(0xa44bfebc) },
  { SPH_C32(0xd21d0600), SPH_C32(0x2f7e1385), SPH_C32(0xe5908227),
    SPH_C32(0x0815196a), SPH_C32(0x28860600), SPH_C32(0x128f4c44),
    SPH_C32(0x0f20b113), SPH_C32(0x179959a0) },
  { SPH_C32(0xa1510600), SPH_C32(0xba11b453), SPH_C32(0x470d90b0),
    SPH_C32(0x66f0713e), SPH_C32(0xec6e0700), SPH_C32(0x0dffda4a),
    SPH_C32(0x28347b2f), SPH_C32(0x9fb85590) }
};

__constant static const sph_u32 T256_15[32][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x35650040), SPH_C32(0x9b96b64a), SPH_C32(0x6b39cb5f),
    SPH_C32(0x5114bece), SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e),
    SPH_C32(0x36656ba8), SPH_C32(0x23633a05) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x161c00c0), SPH_C32(0x7e54f492), SPH_C32(0xf4a107fd),
    SPH_C32(0xd0018836), SPH_C32(0x410d0000), SPH_C32(0xea7a09df),
    SPH_C32(0x8c12a9bc), SPH_C32(0xc50530e0) },
  { SPH_C32(0x23790080), SPH_C32(0xe5c242d8), SPH_C32(0x9f98cca2),
    SPH_C32(0x811536f8), SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1),
    SPH_C32(0xba77c214), SPH_C32(0xe6660ae5) },
  { SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6), SPH_C32(0xa9fda70a),
    SPH_C32(0xa2760cfd), SPH_C32(0x74680040), SPH_C32(0x71ecbf95),
    SPH_C32(0xe72b62e3), SPH_C32(0x94118e2e) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0x74680040), SPH_C32(0x71ecbf95), SPH_C32(0xe72b62e3),
    SPH_C32(0x94118e2e), SPH_C32(0x1adf0080), SPH_C32(0xaf751133),
    SPH_C32(0x4ed6c5e9), SPH_C32(0x366782d3) },
  { SPH_C32(0x410d0000), SPH_C32(0xea7a09df), SPH_C32(0x8c12a9bc),
    SPH_C32(0xc50530e0), SPH_C32(0x571100c0), SPH_C32(0x942efd4d),
    SPH_C32(0x78b3ae41), SPH_C32(0x1504b8d6) },
  { SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1), SPH_C32(0xba77c214),
    SPH_C32(0xe6660ae5), SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779),
    SPH_C32(0x25ef0eb6), SPH_C32(0x67733c1d) },
  { SPH_C32(0x62740080), SPH_C32(0x0fb84b07), SPH_C32(0x138a651e),
    SPH_C32(0x44100618), SPH_C32(0x5bd20080), SPH_C32(0x450f18ec),
    SPH_C32(0xc2c46c55), SPH_C32(0xf362b233) },
  { SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779), SPH_C32(0x25ef0eb6),
    SPH_C32(0x67733c1d), SPH_C32(0x23790080), SPH_C32(0xe5c242d8),
    SPH_C32(0x9f98cca2), SPH_C32(0x811536f8) },
  { SPH_C32(0x1adf0080), SPH_C32(0xaf751133), SPH_C32(0x4ed6c5e9),
    SPH_C32(0x366782d3), SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6),
    SPH_C32(0xa9fda70a), SPH_C32(0xa2760cfd) },
  { SPH_C32(0x571100c0), SPH_C32(0x942efd4d), SPH_C32(0x78b3ae41),
    SPH_C32(0x1504b8d6), SPH_C32(0x161c00c0), SPH_C32(0x7e54f492),
    SPH_C32(0xf4a107fd), SPH_C32(0xd0018836) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0xfa6a0140), SPH_C32(0xb144dda6), SPH_C32(0xb3ecb303),
    SPH_C32(0xc5a75e61), SPH_C32(0x0be70000), SPH_C32(0x35a2fde2),
    SPH_C32(0xffc1b260), SPH_C32(0x1c92ec9f) },
  { SPH_C32(0xcf0f0100), SPH_C32(0x2ad26bec), SPH_C32(0xd8d5785c),
    SPH_C32(0x94b3e0af), SPH_C32(0x46290040), SPH_C32(0x0ef9119c),
    SPH_C32(0xc9a4d9c8), SPH_C32(0x3ff1d69a) },
  { SPH_C32(0x82c10140), SPH_C32(0x11898792), SPH_C32(0xeeb013f4),
    SPH_C32(0xb7d0daaa), SPH_C32(0x3e820040), SPH_C32(0xae344ba8),
    SPH_C32(0x94f8793f), SPH_C32(0x4d865251) },
  { SPH_C32(0xec760180), SPH_C32(0xcf102934), SPH_C32(0x474db4fe),
    SPH_C32(0x15a6d657), SPH_C32(0x4aea0000), SPH_C32(0xdfd8f43d),
    SPH_C32(0x73d31bdc), SPH_C32(0xd997dc7f) },
  { SPH_C32(0xa1b801c0), SPH_C32(0xf44bc54a), SPH_C32(0x7128df56),
    SPH_C32(0x36c5ec52), SPH_C32(0x32410000), SPH_C32(0x7f15ae09),
    SPH_C32(0x2e8fbb2b), SPH_C32(0xabe058b4) },
  { SPH_C32(0x94dd0180), SPH_C32(0x6fdd7300), SPH_C32(0x1a111409),
    SPH_C32(0x67d1529c), SPH_C32(0x7f8f0040), SPH_C32(0x444e4277),
    SPH_C32(0x18ead083), SPH_C32(0x888362b1) },
  { SPH_C32(0xd91301c0), SPH_C32(0x54869f7e), SPH_C32(0x2c747fa1),
    SPH_C32(0x44b26899), SPH_C32(0x07240040), SPH_C32(0xe4831843),
    SPH_C32(0x45b67074), SPH_C32(0xfaf4e67a) },
  { SPH_C32(0x8e020100), SPH_C32(0xc0a86233), SPH_C32(0x54c7d1e0),
    SPH_C32(0x51b6d04f), SPH_C32(0x11380080), SPH_C32(0x9ad7ecd1),
    SPH_C32(0xb1177789), SPH_C32(0x2af56e4c) },
  { SPH_C32(0xc3cc0140), SPH_C32(0xfbf38e4d), SPH_C32(0x62a2ba48),
    SPH_C32(0x72d5ea4a), SPH_C32(0x69930080), SPH_C32(0x3a1ab6e5),
    SPH_C32(0xec4bd77e), SPH_C32(0x5882ea87) },
  { SPH_C32(0xf6a90100), SPH_C32(0x60653807), SPH_C32(0x099b7117),
    SPH_C32(0x23c15484), SPH_C32(0x245d00c0), SPH_C32(0x01415a9b),
    SPH_C32(0xda2ebcd6), SPH_C32(0x7be1d082) },
  { SPH_C32(0xbb670140), SPH_C32(0x5b3ed479), SPH_C32(0x3ffe1abf),
    SPH_C32(0x00a26e81), SPH_C32(0x5cf600c0), SPH_C32(0xa18c00af),
    SPH_C32(0x87721c21), SPH_C32(0x09965449) },
  { SPH_C32(0xd5d00180), SPH_C32(0x85a77adf), SPH_C32(0x9603bdb5),
    SPH_C32(0xa2d4627c), SPH_C32(0x289e0080), SPH_C32(0xd060bf3a),
    SPH_C32(0x60597ec2), SPH_C32(0x9d87da67) },
  { SPH_C32(0x981e01c0), SPH_C32(0xbefc96a1), SPH_C32(0xa066d61d),
    SPH_C32(0x81b75879), SPH_C32(0x50350080), SPH_C32(0x70ade50e),
    SPH_C32(0x3d05de35), SPH_C32(0xeff05eac) },
  { SPH_C32(0xad7b0180), SPH_C32(0x256a20eb), SPH_C32(0xcb5f1d42),
    SPH_C32(0xd0a3e6b7), SPH_C32(0x1dfb00c0), SPH_C32(0x4bf60970),
    SPH_C32(0x0b60b59d), SPH_C32(0xcc9364a9) },
  { SPH_C32(0xe0b501c0), SPH_C32(0x1e31cc95), SPH_C32(0xfd3a76ea),
    SPH_C32(0xf3c0dcb2), SPH_C32(0x655000c0), SPH_C32(0xeb3b5344),
    SPH_C32(0x563c156a), SPH_C32(0xbee4e062) }
};

__constant static const sph_u32 T256_20[32][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x46400010), SPH_C32(0xf29d41bf), SPH_C32(0x628da57c),
    SPH_C32(0x29af183e), SPH_C32(0x918b0008), SPH_C32(0xf6ca6cb0),
    SPH_C32(0x5ccd1683), SPH_C32(0x51a5f0d2) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0x39250000), SPH_C32(0xd6b355cd), SPH_C32(0xa2be8582),
    SPH_C32(0xe90cd8e3), SPH_C32(0xc0d70018), SPH_C32(0xb6391e4b),
    SPH_C32(0xa02a3081), SPH_C32(0x20f2a0b3) },
  { SPH_C32(0x7f650010), SPH_C32(0x242e1472), SPH_C32(0xc03320fe),
    SPH_C32(0xc0a3c0dd), SPH_C32(0x515c0010), SPH_C32(0x40f372fb),
    SPH_C32(0xfce72602), SPH_C32(0x71575061) },
  { SPH_C32(0x68790010), SPH_C32(0x96402736), SPH_C32(0x5e59a380),
    SPH_C32(0x985b8882), SPH_C32(0xeeee0018), SPH_C32(0xd2e478c2),
    SPH_C32(0x9cfe367d), SPH_C32(0x9106300f) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0xb5a40020), SPH_C32(0x3389d6b2), SPH_C32(0x67a4cf7a),
    SPH_C32(0xba57e89f), SPH_C32(0xe3c00008), SPH_C32(0x5badc72b),
    SPH_C32(0x19b01d86), SPH_C32(0x83b84116) },
  { SPH_C32(0xf3e40030), SPH_C32(0xc114970d), SPH_C32(0x05296a06),
    SPH_C32(0x93f8f0a1), SPH_C32(0x724b0000), SPH_C32(0xad67ab9b),
    SPH_C32(0x457d0b05), SPH_C32(0xd21db1c4) },
  { SPH_C32(0xe4f80030), SPH_C32(0x737aa449), SPH_C32(0x9b43e978),
    SPH_C32(0xcb00b8fe), SPH_C32(0xcdf90008), SPH_C32(0x3f70a1a2),
    SPH_C32(0x25641b7a), SPH_C32(0x324cd1aa) },
  { SPH_C32(0x8c810020), SPH_C32(0xe53a837f), SPH_C32(0xc51a4af8),
    SPH_C32(0x535b307c), SPH_C32(0x23170010), SPH_C32(0xed94d960),
    SPH_C32(0xb99a2d07), SPH_C32(0xa34ae1a5) },
  { SPH_C32(0x9b9d0020), SPH_C32(0x5754b03b), SPH_C32(0x5b70c986),
    SPH_C32(0x0ba37823), SPH_C32(0x9ca50018), SPH_C32(0x7f83d359),
    SPH_C32(0xd9833d78), SPH_C32(0x431b81cb) },
  { SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184), SPH_C32(0x39fd6cfa),
    SPH_C32(0x220c601d), SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9),
    SPH_C32(0x854e2bfb), SPH_C32(0x12be7119) },
  { SPH_C32(0xcac10030), SPH_C32(0x17a7c2c0), SPH_C32(0xa797ef84),
    SPH_C32(0x7af42842), SPH_C32(0xb29c0018), SPH_C32(0x1b5eb5d0),
    SPH_C32(0xe5573b84), SPH_C32(0xf2ef1177) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0x4b6e0000), SPH_C32(0x7bd4fe56), SPH_C32(0xe7c38e87),
    SPH_C32(0x3b116927), SPH_C32(0x41780028), SPH_C32(0xda4a22dd),
    SPH_C32(0xe07e5182), SPH_C32(0x6117e1d6) },
  { SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9), SPH_C32(0x854e2bfb),
    SPH_C32(0x12be7119), SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d),
    SPH_C32(0xbcb34701), SPH_C32(0x30b21104) },
  { SPH_C32(0x1a320010), SPH_C32(0x3b278cad), SPH_C32(0x1b24a885),
    SPH_C32(0x4a463946), SPH_C32(0x6f410028), SPH_C32(0xbe974454),
    SPH_C32(0xdcaa577e), SPH_C32(0xd0e3716a) },
  { SPH_C32(0x724b0000), SPH_C32(0xad67ab9b), SPH_C32(0x457d0b05),
    SPH_C32(0xd21db1c4), SPH_C32(0x81af0030), SPH_C32(0x6c733c96),
    SPH_C32(0x40546103), SPH_C32(0x41e54165) },
  { SPH_C32(0x65570000), SPH_C32(0x1f0998df), SPH_C32(0xdb17887b),
    SPH_C32(0x8ae5f99b), SPH_C32(0x3e1d0038), SPH_C32(0xfe6436af),
    SPH_C32(0x204d717c), SPH_C32(0xa1b4210b) },
  { SPH_C32(0x23170010), SPH_C32(0xed94d960), SPH_C32(0xb99a2d07),
    SPH_C32(0xa34ae1a5), SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f),
    SPH_C32(0x7c8067ff), SPH_C32(0xf011d1d9) },
  { SPH_C32(0x340b0010), SPH_C32(0x5ffaea24), SPH_C32(0x27f0ae79),
    SPH_C32(0xfbb2a9fa), SPH_C32(0x10240038), SPH_C32(0x9ab95026),
    SPH_C32(0x1c997780), SPH_C32(0x1040b1b7) },
  { SPH_C32(0xfeca0020), SPH_C32(0x485d28e4), SPH_C32(0x806741fd),
    SPH_C32(0x814681b8), SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6),
    SPH_C32(0xf9ce4c04), SPH_C32(0xe2afa0c0) },
  { SPH_C32(0xe9d60020), SPH_C32(0xfa331ba0), SPH_C32(0x1e0dc283),
    SPH_C32(0xd9bec9e7), SPH_C32(0x1d0a0028), SPH_C32(0x13f0efcf),
    SPH_C32(0x99d75c7b), SPH_C32(0x02fec0ae) },
  { SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f), SPH_C32(0x7c8067ff),
    SPH_C32(0xf011d1d9), SPH_C32(0x8c810020), SPH_C32(0xe53a837f),
    SPH_C32(0xc51a4af8), SPH_C32(0x535b307c) },
  { SPH_C32(0xb88a0030), SPH_C32(0xbac0695b), SPH_C32(0xe2eae481),
    SPH_C32(0xa8e99986), SPH_C32(0x33330028), SPH_C32(0x772d8946),
    SPH_C32(0xa5035a87), SPH_C32(0xb30a5012) },
  { SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d), SPH_C32(0xbcb34701),
    SPH_C32(0x30b21104), SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184),
    SPH_C32(0x39fd6cfa), SPH_C32(0x220c601d) },
  { SPH_C32(0xc7ef0020), SPH_C32(0x9eee7d29), SPH_C32(0x22d9c47f),
    SPH_C32(0x684a595b), SPH_C32(0x626f0038), SPH_C32(0x37defbbd),
    SPH_C32(0x59e47c85), SPH_C32(0xc25d0073) },
  { SPH_C32(0x81af0030), SPH_C32(0x6c733c96), SPH_C32(0x40546103),
    SPH_C32(0x41e54165), SPH_C32(0xf3e40030), SPH_C32(0xc114970d),
    SPH_C32(0x05296a06), SPH_C32(0x93f8f0a1) },
  { SPH_C32(0x96b30030), SPH_C32(0xde1d0fd2), SPH_C32(0xde3ee27d),
    SPH_C32(0x191d093a), SPH_C32(0x4c560038), SPH_C32(0x53039d34),
    SPH_C32(0x65307a79), SPH_C32(0x73a990cf) }
};

__constant static const sph_u32 T256_25[32][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7), SPH_C32(0xe007afe6),
    SPH_C32(0x9fed4ab7), SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3),
    SPH_C32(0x99e585aa), SPH_C32(0x8d75f7f1) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x582b0006), SPH_C32(0xd39128c4), SPH_C32(0x042035fa),
    SPH_C32(0x223fde2b), SPH_C32(0x3a050000), SPH_C32(0x6508f6be),
    SPH_C32(0xe1d03671), SPH_C32(0x64347a75) },
  { SPH_C32(0x81a40004), SPH_C32(0xa9958063), SPH_C32(0xe4279a1c),
    SPH_C32(0xbdd2949c), SPH_C32(0xb2260002), SPH_C32(0x3aef510d),
    SPH_C32(0x7835b3db), SPH_C32(0xe9418d84) },
  { SPH_C32(0x09870006), SPH_C32(0xf67227d0), SPH_C32(0x7dc21fb6),
    SPH_C32(0x30a7636d), SPH_C32(0xe38a0002), SPH_C32(0x1f0c5e19),
    SPH_C32(0x01d79997), SPH_C32(0xfbd930c2) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xe38a0002), SPH_C32(0x1f0c5e19), SPH_C32(0x01d79997),
    SPH_C32(0xfbd930c2), SPH_C32(0xea0d0004), SPH_C32(0xe97e79c9),
    SPH_C32(0x7c158621), SPH_C32(0xcb7e53af) },
  { SPH_C32(0x3a050000), SPH_C32(0x6508f6be), SPH_C32(0xe1d03671),
    SPH_C32(0x64347a75), SPH_C32(0x622e0006), SPH_C32(0xb699de7a),
    SPH_C32(0xe5f0038b), SPH_C32(0x460ba45e) },
  { SPH_C32(0xb2260002), SPH_C32(0x3aef510d), SPH_C32(0x7835b3db),
    SPH_C32(0xe9418d84), SPH_C32(0x33820006), SPH_C32(0x937ad16e),
    SPH_C32(0x9c1229c7), SPH_C32(0x54931918) },
  { SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd), SPH_C32(0x05f7ac6d),
    SPH_C32(0xd9e6eee9), SPH_C32(0xd0080004), SPH_C32(0x8c768f77),
    SPH_C32(0x9dc5b050), SPH_C32(0xaf4a29da) },
  { SPH_C32(0x33820006), SPH_C32(0x937ad16e), SPH_C32(0x9c1229c7),
    SPH_C32(0x54931918), SPH_C32(0x81a40004), SPH_C32(0xa9958063),
    SPH_C32(0xe4279a1c), SPH_C32(0xbdd2949c) },
  { SPH_C32(0xea0d0004), SPH_C32(0xe97e79c9), SPH_C32(0x7c158621),
    SPH_C32(0xcb7e53af), SPH_C32(0x09870006), SPH_C32(0xf67227d0),
    SPH_C32(0x7dc21fb6), SPH_C32(0x30a7636d) },
  { SPH_C32(0x622e0006), SPH_C32(0xb699de7a), SPH_C32(0xe5f0038b),
    SPH_C32(0x460ba45e), SPH_C32(0x582b0006), SPH_C32(0xd39128c4),
    SPH_C32(0x042035fa), SPH_C32(0x223fde2b) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0x208d000a), SPH_C32(0x7f9e9ece), SPH_C32(0x679616ab),
    SPH_C32(0x35dcdfc0), SPH_C32(0x46b00000), SPH_C32(0x978d3c50),
    SPH_C32(0xe788a932), SPH_C32(0x4a60f519) },
  { SPH_C32(0xf9020008), SPH_C32(0x059a3669), SPH_C32(0x8791b94d),
    SPH_C32(0xaa319577), SPH_C32(0xce930002), SPH_C32(0xc86a9be3),
    SPH_C32(0x7e6d2c98), SPH_C32(0xc71502e8) },
  { SPH_C32(0x7121000a), SPH_C32(0x5a7d91da), SPH_C32(0x1e743ce7),
    SPH_C32(0x27446286), SPH_C32(0x9f3f0002), SPH_C32(0xed8994f7),
    SPH_C32(0x078f06d4), SPH_C32(0xd58dbfae) },
  { SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a), SPH_C32(0x63b62351),
    SPH_C32(0x17e301eb), SPH_C32(0x7cb50000), SPH_C32(0xf285caee),
    SPH_C32(0x06589f43), SPH_C32(0x2e548f6c) },
  { SPH_C32(0xf085000e), SPH_C32(0xf3e811b9), SPH_C32(0xfa53a6fb),
    SPH_C32(0x9a96f61a), SPH_C32(0x2d190000), SPH_C32(0xd766c5fa),
    SPH_C32(0x7fbab50f), SPH_C32(0x3ccc322a) },
  { SPH_C32(0x290a000c), SPH_C32(0x89ecb91e), SPH_C32(0x1a54091d),
    SPH_C32(0x057bbcad), SPH_C32(0xa53a0002), SPH_C32(0x88816249),
    SPH_C32(0xe65f30a5), SPH_C32(0xb1b9c5db) },
  { SPH_C32(0xa129000e), SPH_C32(0xd60b1ead), SPH_C32(0x83b18cb7),
    SPH_C32(0x880e4b5c), SPH_C32(0xf4960002), SPH_C32(0xad626d5d),
    SPH_C32(0x9fbd1ae9), SPH_C32(0xa321789d) },
  { SPH_C32(0xc3070008), SPH_C32(0x6092c0d7), SPH_C32(0x66418f3c),
    SPH_C32(0xce05ef02), SPH_C32(0xacbd0004), SPH_C32(0x7ef34599),
    SPH_C32(0x9b9d2f13), SPH_C32(0x811ea6b6) },
  { SPH_C32(0x4b24000a), SPH_C32(0x3f756764), SPH_C32(0xffa40a96),
    SPH_C32(0x437018f3), SPH_C32(0xfd110004), SPH_C32(0x5b104a8d),
    SPH_C32(0xe27f055f), SPH_C32(0x93861bf0) },
  { SPH_C32(0x92ab0008), SPH_C32(0x4571cfc3), SPH_C32(0x1fa3a570),
    SPH_C32(0xdc9d5244), SPH_C32(0x75320006), SPH_C32(0x04f7ed3e),
    SPH_C32(0x7b9a80f5), SPH_C32(0x1ef3ec01) },
  { SPH_C32(0x1a88000a), SPH_C32(0x1a966870), SPH_C32(0x864620da),
    SPH_C32(0x51e8a5b5), SPH_C32(0x249e0006), SPH_C32(0x2114e22a),
    SPH_C32(0x0278aab9), SPH_C32(0x0c6b5147) },
  { SPH_C32(0x130f000c), SPH_C32(0xece44fa0), SPH_C32(0xfb843f6c),
    SPH_C32(0x614fc6d8), SPH_C32(0xc7140004), SPH_C32(0x3e18bc33),
    SPH_C32(0x03af332e), SPH_C32(0xf7b26185) },
  { SPH_C32(0x9b2c000e), SPH_C32(0xb303e813), SPH_C32(0x6261bac6),
    SPH_C32(0xec3a3129), SPH_C32(0x96b80004), SPH_C32(0x1bfbb327),
    SPH_C32(0x7a4d1962), SPH_C32(0xe52adcc3) },
  { SPH_C32(0x42a3000c), SPH_C32(0xc90740b4), SPH_C32(0x82661520),
    SPH_C32(0x73d77b9e), SPH_C32(0x1e9b0006), SPH_C32(0x441c1494),
    SPH_C32(0xe3a89cc8), SPH_C32(0x685f2b32) },
  { SPH_C32(0xca80000e), SPH_C32(0x96e0e707), SPH_C32(0x1b83908a),
    SPH_C32(0xfea28c6f), SPH_C32(0x4f370006), SPH_C32(0x61ff1b80),
    SPH_C32(0x9a4ab684), SPH_C32(0x7ac79674) }
};

__constant static const sph_u32 T256_30[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x08bf0001), SPH_C32(0x38942792), SPH_C32(0xc5f8f3a1),
    SPH_C32(0xe6387b84), SPH_C32(0xc04e0001), SPH_C32(0x33b9c010),
    SPH_C32(0xae0ebb05), SPH_C32(0xb5a4c63b) }
};

#define INPUT_SMALL   do { \
    unsigned acc = buf[0]; \
    const sph_u32 *rp; \
    rp = &T256_0[acc >> 3][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    acc = (acc << 8) | buf[1]; \
    rp = &T256_5[(acc >> 6) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_10[(acc >> 1) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = (acc << 8) | buf[2]; \
    rp = &T256_15[(acc >> 4) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = (acc << 8) | buf[3]; \
    rp = &T256_20[(acc >> 7) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_25[(acc >> 2) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_30[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_SMALL == 6

__constant static const sph_u32 T256_0[64][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0x7e792000), SPH_C32(0x9418e22f), SPH_C32(0x6643d258),
    SPH_C32(0x9c255be5), SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc),
    SPH_C32(0x11fa3a57), SPH_C32(0x3dc90524) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0xfb316000), SPH_C32(0xef405514), SPH_C32(0x9c00f5fc),
    SPH_C32(0xf3ffc956), SPH_C32(0x71040000), SPH_C32(0x6bfc54f6),
    SPH_C32(0xf33c70b5), SPH_C32(0xb1ad5eff) },
  { SPH_C32(0x85484000), SPH_C32(0x7b58b73b), SPH_C32(0xfa4327a4),
    SPH_C32(0x6fda92b3), SPH_C32(0x982e2000), SPH_C32(0xdfabd80a),
    SPH_C32(0xe2c64ae2), SPH_C32(0x8c645bdb) },
  { SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7), SPH_C32(0xebb91df3),
    SPH_C32(0x52139797), SPH_C32(0x0f7d2000), SPH_C32(0xffe4b6d9),
    SPH_C32(0x957fa2ed), SPH_C32(0x2d88051a) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0x0f7d2000), SPH_C32(0xffe4b6d9), SPH_C32(0x957fa2ed),
    SPH_C32(0x2d88051a), SPH_C32(0x631f4000), SPH_C32(0x30eb8d1e),
    SPH_C32(0x7ec6bf1e), SPH_C32(0x7f9b928d) },
  { SPH_C32(0x71040000), SPH_C32(0x6bfc54f6), SPH_C32(0xf33c70b5),
    SPH_C32(0xb1ad5eff), SPH_C32(0x8a356000), SPH_C32(0x84bc01e2),
    SPH_C32(0x6f3c8549), SPH_C32(0x425297a9) },
  { SPH_C32(0x982e2000), SPH_C32(0xdfabd80a), SPH_C32(0xe2c64ae2),
    SPH_C32(0x8c645bdb), SPH_C32(0x1d666000), SPH_C32(0xa4f36f31),
    SPH_C32(0x18856d46), SPH_C32(0xe3bec968) },
  { SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd), SPH_C32(0x097f5711),
    SPH_C32(0xde77cc4c), SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8),
    SPH_C32(0x8dfacfab), SPH_C32(0xce36cc72) },
  { SPH_C32(0x1d666000), SPH_C32(0xa4f36f31), SPH_C32(0x18856d46),
    SPH_C32(0xe3bec968), SPH_C32(0x85484000), SPH_C32(0x7b58b73b),
    SPH_C32(0xfa4327a4), SPH_C32(0x6fda92b3) },
  { SPH_C32(0x631f4000), SPH_C32(0x30eb8d1e), SPH_C32(0x7ec6bf1e),
    SPH_C32(0x7f9b928d), SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7),
    SPH_C32(0xebb91df3), SPH_C32(0x52139797) },
  { SPH_C32(0x8a356000), SPH_C32(0x84bc01e2), SPH_C32(0x6f3c8549),
    SPH_C32(0x425297a9), SPH_C32(0xfb316000), SPH_C32(0xef405514),
    SPH_C32(0x9c00f5fc), SPH_C32(0xf3ffc956) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0x0d52a000), SPH_C32(0x31c1ff3d), SPH_C32(0xa4011e05),
    SPH_C32(0x14055bfb), SPH_C32(0x930c0000), SPH_C32(0xbc05fd1a),
    SPH_C32(0x154591df), SPH_C32(0xd2f2e303) },
  { SPH_C32(0x732b8000), SPH_C32(0xa5d91d12), SPH_C32(0xc242cc5d),
    SPH_C32(0x8820001e), SPH_C32(0x7a262000), SPH_C32(0x085271e6),
    SPH_C32(0x04bfab88), SPH_C32(0xef3be627) },
  { SPH_C32(0x9a01a000), SPH_C32(0x118e91ee), SPH_C32(0xd3b8f60a),
    SPH_C32(0xb5e9053a), SPH_C32(0xed752000), SPH_C32(0x281d1f35),
    SPH_C32(0x73064387), SPH_C32(0x4ed7b8e6) },
  { SPH_C32(0xf663c000), SPH_C32(0xde81aa29), SPH_C32(0x3801ebf9),
    SPH_C32(0xe7fa92ad), SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec),
    SPH_C32(0xe679e16a), SPH_C32(0x635fbdfc) },
  { SPH_C32(0x1f49e000), SPH_C32(0x6ad626d5), SPH_C32(0x29fbd1ae),
    SPH_C32(0xda339789), SPH_C32(0x755b0000), SPH_C32(0xf7b6c73f),
    SPH_C32(0x91c00965), SPH_C32(0xc2b3e33d) },
  { SPH_C32(0x6130c000), SPH_C32(0xfecec4fa), SPH_C32(0x4fb803f6),
    SPH_C32(0x4616cc6c), SPH_C32(0x9c712000), SPH_C32(0x43e14bc3),
    SPH_C32(0x803a3332), SPH_C32(0xff7ae619) },
  { SPH_C32(0x881ae000), SPH_C32(0x4a994806), SPH_C32(0x5e4239a1),
    SPH_C32(0x7bdfc948), SPH_C32(0x0b222000), SPH_C32(0x63ae2510),
    SPH_C32(0xf783db3d), SPH_C32(0x5e96b8d8) },
  { SPH_C32(0x022f8000), SPH_C32(0xce2549e4), SPH_C32(0x317ebce8),
    SPH_C32(0x398d5ee1), SPH_C32(0xf0134000), SPH_C32(0x8cee7004),
    SPH_C32(0x6b832ec1), SPH_C32(0xad69718e) },
  { SPH_C32(0xeb05a000), SPH_C32(0x7a72c518), SPH_C32(0x208486bf),
    SPH_C32(0x04445bc5), SPH_C32(0x67404000), SPH_C32(0xaca11ed7),
    SPH_C32(0x1c3ac6ce), SPH_C32(0x0c852f4f) },
  { SPH_C32(0x957c8000), SPH_C32(0xee6a2737), SPH_C32(0x46c754e7),
    SPH_C32(0x98610020), SPH_C32(0x8e6a6000), SPH_C32(0x18f6922b),
    SPH_C32(0x0dc0fc99), SPH_C32(0x314c2a6b) },
  { SPH_C32(0x7c56a000), SPH_C32(0x5a3dabcb), SPH_C32(0x573d6eb0),
    SPH_C32(0xa5a80504), SPH_C32(0x19396000), SPH_C32(0x38b9fcf8),
    SPH_C32(0x7a791496), SPH_C32(0x90a074aa) },
  { SPH_C32(0x1034c000), SPH_C32(0x9532900c), SPH_C32(0xbc847343),
    SPH_C32(0xf7bb9293), SPH_C32(0x16444000), SPH_C32(0xc75d4a21),
    SPH_C32(0xef06b67b), SPH_C32(0xbd2871b0) },
  { SPH_C32(0xf91ee000), SPH_C32(0x21651cf0), SPH_C32(0xad7e4914),
    SPH_C32(0xca7297b7), SPH_C32(0x81174000), SPH_C32(0xe71224f2),
    SPH_C32(0x98bf5e74), SPH_C32(0x1cc42f71) },
  { SPH_C32(0x8767c000), SPH_C32(0xb57dfedf), SPH_C32(0xcb3d9b4c),
    SPH_C32(0x5657cc52), SPH_C32(0x683d6000), SPH_C32(0x5345a80e),
    SPH_C32(0x89456423), SPH_C32(0x210d2a55) },
  { SPH_C32(0x6e4de000), SPH_C32(0x012a7223), SPH_C32(0xdac7a11b),
    SPH_C32(0x6b9ec976), SPH_C32(0xff6e6000), SPH_C32(0x730ac6dd),
    SPH_C32(0xfefc8c2c), SPH_C32(0x80e17494) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0xed752000), SPH_C32(0x281d1f35), SPH_C32(0x73064387),
    SPH_C32(0x4ed7b8e6), SPH_C32(0x77748000), SPH_C32(0x39938edb),
    SPH_C32(0xa0beb58d), SPH_C32(0xfb3ebddc) },
  { SPH_C32(0x930c0000), SPH_C32(0xbc05fd1a), SPH_C32(0x154591df),
    SPH_C32(0xd2f2e303), SPH_C32(0x9e5ea000), SPH_C32(0x8dc40227),
    SPH_C32(0xb1448fda), SPH_C32(0xc6f7b8f8) },
  { SPH_C32(0x7a262000), SPH_C32(0x085271e6), SPH_C32(0x04bfab88),
    SPH_C32(0xef3be627), SPH_C32(0x090da000), SPH_C32(0xad8b6cf4),
    SPH_C32(0xc6fd67d5), SPH_C32(0x671be639) },
  { SPH_C32(0x16444000), SPH_C32(0xc75d4a21), SPH_C32(0xef06b67b),
    SPH_C32(0xbd2871b0), SPH_C32(0x06708000), SPH_C32(0x526fda2d),
    SPH_C32(0x5382c538), SPH_C32(0x4a93e323) },
  { SPH_C32(0xff6e6000), SPH_C32(0x730ac6dd), SPH_C32(0xfefc8c2c),
    SPH_C32(0x80e17494), SPH_C32(0x91238000), SPH_C32(0x7220b4fe),
    SPH_C32(0x243b2d37), SPH_C32(0xeb7fbde2) },
  { SPH_C32(0x81174000), SPH_C32(0xe71224f2), SPH_C32(0x98bf5e74),
    SPH_C32(0x1cc42f71), SPH_C32(0x7809a000), SPH_C32(0xc6773802),
    SPH_C32(0x35c11760), SPH_C32(0xd6b6b8c6) },
  { SPH_C32(0x683d6000), SPH_C32(0x5345a80e), SPH_C32(0x89456423),
    SPH_C32(0x210d2a55), SPH_C32(0xef5aa000), SPH_C32(0xe63856d1),
    SPH_C32(0x4278ff6f), SPH_C32(0x775ae607) },
  { SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec), SPH_C32(0xe679e16a),
    SPH_C32(0x635fbdfc), SPH_C32(0x146bc000), SPH_C32(0x097803c5),
    SPH_C32(0xde780a93), SPH_C32(0x84a52f51) },
  { SPH_C32(0x0b222000), SPH_C32(0x63ae2510), SPH_C32(0xf783db3d),
    SPH_C32(0x5e96b8d8), SPH_C32(0x8338c000), SPH_C32(0x29376d16),
    SPH_C32(0xa9c1e29c), SPH_C32(0x25497190) },
  { SPH_C32(0x755b0000), SPH_C32(0xf7b6c73f), SPH_C32(0x91c00965),
    SPH_C32(0xc2b3e33d), SPH_C32(0x6a12e000), SPH_C32(0x9d60e1ea),
    SPH_C32(0xb83bd8cb), SPH_C32(0x188074b4) },
  { SPH_C32(0x9c712000), SPH_C32(0x43e14bc3), SPH_C32(0x803a3332),
    SPH_C32(0xff7ae619), SPH_C32(0xfd41e000), SPH_C32(0xbd2f8f39),
    SPH_C32(0xcf8230c4), SPH_C32(0xb96c2a75) },
  { SPH_C32(0xf0134000), SPH_C32(0x8cee7004), SPH_C32(0x6b832ec1),
    SPH_C32(0xad69718e), SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0),
    SPH_C32(0x5afd9229), SPH_C32(0x94e42f6f) },
  { SPH_C32(0x19396000), SPH_C32(0x38b9fcf8), SPH_C32(0x7a791496),
    SPH_C32(0x90a074aa), SPH_C32(0x656fc000), SPH_C32(0x62845733),
    SPH_C32(0x2d447a26), SPH_C32(0x350871ae) },
  { SPH_C32(0x67404000), SPH_C32(0xaca11ed7), SPH_C32(0x1c3ac6ce),
    SPH_C32(0x0c852f4f), SPH_C32(0x8c45e000), SPH_C32(0xd6d3dbcf),
    SPH_C32(0x3cbe4071), SPH_C32(0x08c1748a) },
  { SPH_C32(0x8e6a6000), SPH_C32(0x18f6922b), SPH_C32(0x0dc0fc99),
    SPH_C32(0x314c2a6b), SPH_C32(0x1b16e000), SPH_C32(0xf69cb51c),
    SPH_C32(0x4b07a87e), SPH_C32(0xa92d2a4b) },
  { SPH_C32(0xe0278000), SPH_C32(0x19dce008), SPH_C32(0xd7075d82),
    SPH_C32(0x5ad2e31d), SPH_C32(0xe4788000), SPH_C32(0x859673c1),
    SPH_C32(0xb5fb2452), SPH_C32(0x29cc5edf) },
  { SPH_C32(0x090da000), SPH_C32(0xad8b6cf4), SPH_C32(0xc6fd67d5),
    SPH_C32(0x671be639), SPH_C32(0x732b8000), SPH_C32(0xa5d91d12),
    SPH_C32(0xc242cc5d), SPH_C32(0x8820001e) },
  { SPH_C32(0x77748000), SPH_C32(0x39938edb), SPH_C32(0xa0beb58d),
    SPH_C32(0xfb3ebddc), SPH_C32(0x9a01a000), SPH_C32(0x118e91ee),
    SPH_C32(0xd3b8f60a), SPH_C32(0xb5e9053a) },
  { SPH_C32(0x9e5ea000), SPH_C32(0x8dc40227), SPH_C32(0xb1448fda),
    SPH_C32(0xc6f7b8f8), SPH_C32(0x0d52a000), SPH_C32(0x31c1ff3d),
    SPH_C32(0xa4011e05), SPH_C32(0x14055bfb) },
  { SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0), SPH_C32(0x5afd9229),
    SPH_C32(0x94e42f6f), SPH_C32(0x022f8000), SPH_C32(0xce2549e4),
    SPH_C32(0x317ebce8), SPH_C32(0x398d5ee1) },
  { SPH_C32(0x1b16e000), SPH_C32(0xf69cb51c), SPH_C32(0x4b07a87e),
    SPH_C32(0xa92d2a4b), SPH_C32(0x957c8000), SPH_C32(0xee6a2737),
    SPH_C32(0x46c754e7), SPH_C32(0x98610020) },
  { SPH_C32(0x656fc000), SPH_C32(0x62845733), SPH_C32(0x2d447a26),
    SPH_C32(0x350871ae), SPH_C32(0x7c56a000), SPH_C32(0x5a3dabcb),
    SPH_C32(0x573d6eb0), SPH_C32(0xa5a80504) },
  { SPH_C32(0x8c45e000), SPH_C32(0xd6d3dbcf), SPH_C32(0x3cbe4071),
    SPH_C32(0x08c1748a), SPH_C32(0xeb05a000), SPH_C32(0x7a72c518),
    SPH_C32(0x208486bf), SPH_C32(0x04445bc5) },
  { SPH_C32(0x06708000), SPH_C32(0x526fda2d), SPH_C32(0x5382c538),
    SPH_C32(0x4a93e323), SPH_C32(0x1034c000), SPH_C32(0x9532900c),
    SPH_C32(0xbc847343), SPH_C32(0xf7bb9293) },
  { SPH_C32(0xef5aa000), SPH_C32(0xe63856d1), SPH_C32(0x4278ff6f),
    SPH_C32(0x775ae607), SPH_C32(0x8767c000), SPH_C32(0xb57dfedf),
    SPH_C32(0xcb3d9b4c), SPH_C32(0x5657cc52) },
  { SPH_C32(0x91238000), SPH_C32(0x7220b4fe), SPH_C32(0x243b2d37),
    SPH_C32(0xeb7fbde2), SPH_C32(0x6e4de000), SPH_C32(0x012a7223),
    SPH_C32(0xdac7a11b), SPH_C32(0x6b9ec976) },
  { SPH_C32(0x7809a000), SPH_C32(0xc6773802), SPH_C32(0x35c11760),
    SPH_C32(0xd6b6b8c6), SPH_C32(0xf91ee000), SPH_C32(0x21651cf0),
    SPH_C32(0xad7e4914), SPH_C32(0xca7297b7) },
  { SPH_C32(0x146bc000), SPH_C32(0x097803c5), SPH_C32(0xde780a93),
    SPH_C32(0x84a52f51), SPH_C32(0xf663c000), SPH_C32(0xde81aa29),
    SPH_C32(0x3801ebf9), SPH_C32(0xe7fa92ad) },
  { SPH_C32(0xfd41e000), SPH_C32(0xbd2f8f39), SPH_C32(0xcf8230c4),
    SPH_C32(0xb96c2a75), SPH_C32(0x6130c000), SPH_C32(0xfecec4fa),
    SPH_C32(0x4fb803f6), SPH_C32(0x4616cc6c) },
  { SPH_C32(0x8338c000), SPH_C32(0x29376d16), SPH_C32(0xa9c1e29c),
    SPH_C32(0x25497190), SPH_C32(0x881ae000), SPH_C32(0x4a994806),
    SPH_C32(0x5e4239a1), SPH_C32(0x7bdfc948) },
  { SPH_C32(0x6a12e000), SPH_C32(0x9d60e1ea), SPH_C32(0xb83bd8cb),
    SPH_C32(0x188074b4), SPH_C32(0x1f49e000), SPH_C32(0x6ad626d5),
    SPH_C32(0x29fbd1ae), SPH_C32(0xda339789) }
};

__constant static const sph_u32 T256_6[64][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0x9b830400), SPH_C32(0x2227ff88), SPH_C32(0x05b7ad5a),
    SPH_C32(0xadf2c730), SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877),
    SPH_C32(0x6fc548e1), SPH_C32(0x898d2cd6) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0x510c0c00), SPH_C32(0x251e9889), SPH_C32(0x1e406226),
    SPH_C32(0x2f32b340), SPH_C32(0xf5360000), SPH_C32(0x7be3bf82),
    SPH_C32(0xd5606668), SPH_C32(0x3f198195) },
  { SPH_C32(0xca8f0800), SPH_C32(0x07396701), SPH_C32(0x1bf7cf7c),
    SPH_C32(0x82c07470), SPH_C32(0x7a080400), SPH_C32(0x767e77f5),
    SPH_C32(0xbaa52e89), SPH_C32(0xb694ad43) },
  { SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76), SPH_C32(0x7432879d),
    SPH_C32(0x0b4d58a6), SPH_C32(0x6eb50400), SPH_C32(0x59c4400a),
    SPH_C32(0xd0d7cb32), SPH_C32(0x92eb46a5) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x6eb50400), SPH_C32(0x59c4400a), SPH_C32(0xd0d7cb32),
    SPH_C32(0x92eb46a5), SPH_C32(0x2b040800), SPH_C32(0x5360ef7c),
    SPH_C32(0xa4e54caf), SPH_C32(0x99a61e03) },
  { SPH_C32(0xf5360000), SPH_C32(0x7be3bf82), SPH_C32(0xd5606668),
    SPH_C32(0x3f198195), SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b),
    SPH_C32(0xcb20044e), SPH_C32(0x102b32d5) },
  { SPH_C32(0x7a080400), SPH_C32(0x767e77f5), SPH_C32(0xbaa52e89),
    SPH_C32(0xb694ad43), SPH_C32(0xb0870c00), SPH_C32(0x714710f4),
    SPH_C32(0xa152e1f5), SPH_C32(0x3454d933) },
  { SPH_C32(0x3fb90800), SPH_C32(0x7cdad883), SPH_C32(0xce97a914),
    SPH_C32(0xbdd9f5e5), SPH_C32(0xde320800), SPH_C32(0x288350fe),
    SPH_C32(0x71852ac7), SPH_C32(0xa6bf9f96) },
  { SPH_C32(0xb0870c00), SPH_C32(0x714710f4), SPH_C32(0xa152e1f5),
    SPH_C32(0x3454d933), SPH_C32(0xca8f0800), SPH_C32(0x07396701),
    SPH_C32(0x1bf7cf7c), SPH_C32(0x82c07470) },
  { SPH_C32(0x2b040800), SPH_C32(0x5360ef7c), SPH_C32(0xa4e54caf),
    SPH_C32(0x99a61e03), SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76),
    SPH_C32(0x7432879d), SPH_C32(0x0b4d58a6) },
  { SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b), SPH_C32(0xcb20044e),
    SPH_C32(0x102b32d5), SPH_C32(0x510c0c00), SPH_C32(0x251e9889),
    SPH_C32(0x1e406226), SPH_C32(0x2f32b340) },
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0xfbab1400), SPH_C32(0x57b68e09), SPH_C32(0xe73855ca),
    SPH_C32(0x976bae44), SPH_C32(0xdf140000), SPH_C32(0xbf9d0096),
    SPH_C32(0xd1ae11bc), SPH_C32(0xf48b4487) },
  { SPH_C32(0x60281000), SPH_C32(0x75917181), SPH_C32(0xe28ff890),
    SPH_C32(0x3a996974), SPH_C32(0x502a0400), SPH_C32(0xb200c8e1),
    SPH_C32(0xbe6b595d), SPH_C32(0x7d066851) },
  { SPH_C32(0xef161400), SPH_C32(0x780cb9f6), SPH_C32(0x8d4ab071),
    SPH_C32(0xb31445a2), SPH_C32(0x44970400), SPH_C32(0x9dbaff1e),
    SPH_C32(0xd419bce6), SPH_C32(0x597983b7) },
  { SPH_C32(0xaaa71800), SPH_C32(0x72a81680), SPH_C32(0xf97837ec),
    SPH_C32(0xb8591d04), SPH_C32(0x2a220000), SPH_C32(0xc47ebf14),
    SPH_C32(0x04ce77d4), SPH_C32(0xcb92c512) },
  { SPH_C32(0x25991c00), SPH_C32(0x7f35def7), SPH_C32(0x96bd7f0d),
    SPH_C32(0x31d431d2), SPH_C32(0x3e9f0000), SPH_C32(0xebc488eb),
    SPH_C32(0x6ebc926f), SPH_C32(0xefed2ef4) },
  { SPH_C32(0xbe1a1800), SPH_C32(0x5d12217f), SPH_C32(0x930ad257),
    SPH_C32(0x9c26f6e2), SPH_C32(0xb1a10400), SPH_C32(0xe659409c),
    SPH_C32(0x0179da8e), SPH_C32(0x66600222) },
  { SPH_C32(0x31241c00), SPH_C32(0x508fe908), SPH_C32(0xfccf9ab6),
    SPH_C32(0x15abda34), SPH_C32(0xa51c0400), SPH_C32(0xc9e37763),
    SPH_C32(0x6b0b3f35), SPH_C32(0x421fe9c4) },
  { SPH_C32(0x951e1000), SPH_C32(0x0e72ce03), SPH_C32(0x37ef9ef8),
    SPH_C32(0x0580e8e1), SPH_C32(0xf4100800), SPH_C32(0xecfdefea),
    SPH_C32(0x754b5d13), SPH_C32(0x6d2d5a84) },
  { SPH_C32(0x1a201400), SPH_C32(0x03ef0674), SPH_C32(0x582ad619),
    SPH_C32(0x8c0dc437), SPH_C32(0xe0ad0800), SPH_C32(0xc347d815),
    SPH_C32(0x1f39b8a8), SPH_C32(0x4952b162) },
  { SPH_C32(0x81a31000), SPH_C32(0x21c8f9fc), SPH_C32(0x5d9d7b43),
    SPH_C32(0x21ff0307), SPH_C32(0x6f930c00), SPH_C32(0xceda1062),
    SPH_C32(0x70fcf049), SPH_C32(0xc0df9db4) },
  { SPH_C32(0x0e9d1400), SPH_C32(0x2c55318b), SPH_C32(0x325833a2),
    SPH_C32(0xa8722fd1), SPH_C32(0x7b2e0c00), SPH_C32(0xe160279d),
    SPH_C32(0x1a8e15f2), SPH_C32(0xe4a07652) },
  { SPH_C32(0x4b2c1800), SPH_C32(0x26f19efd), SPH_C32(0x466ab43f),
    SPH_C32(0xa33f7777), SPH_C32(0x159b0800), SPH_C32(0xb8a46797),
    SPH_C32(0xca59dec0), SPH_C32(0x764b30f7) },
  { SPH_C32(0xc4121c00), SPH_C32(0x2b6c568a), SPH_C32(0x29affcde),
    SPH_C32(0x2ab25ba1), SPH_C32(0x01260800), SPH_C32(0x971e5068),
    SPH_C32(0xa02b3b7b), SPH_C32(0x5234db11) },
  { SPH_C32(0x5f911800), SPH_C32(0x094ba902), SPH_C32(0x2c185184),
    SPH_C32(0x87409c91), SPH_C32(0x8e180c00), SPH_C32(0x9a83981f),
    SPH_C32(0xcfee739a), SPH_C32(0xdbb9f7c7) },
  { SPH_C32(0xd0af1c00), SPH_C32(0x04d66175), SPH_C32(0x43dd1965),
    SPH_C32(0x0ecdb047), SPH_C32(0x9aa50c00), SPH_C32(0xb539afe0),
    SPH_C32(0xa59c9621), SPH_C32(0xffc61c21) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0x44970400), SPH_C32(0x9dbaff1e), SPH_C32(0xd419bce6),
    SPH_C32(0x597983b7), SPH_C32(0xab811000), SPH_C32(0xe5b646e8),
    SPH_C32(0x59530c97), SPH_C32(0xea6dc615) },
  { SPH_C32(0xdf140000), SPH_C32(0xbf9d0096), SPH_C32(0xd1ae11bc),
    SPH_C32(0xf48b4487), SPH_C32(0x24bf1400), SPH_C32(0xe82b8e9f),
    SPH_C32(0x36964476), SPH_C32(0x63e0eac3) },
  { SPH_C32(0x502a0400), SPH_C32(0xb200c8e1), SPH_C32(0xbe6b595d),
    SPH_C32(0x7d066851), SPH_C32(0x30021400), SPH_C32(0xc791b960),
    SPH_C32(0x5ce4a1cd), SPH_C32(0x479f0125) },
  { SPH_C32(0x159b0800), SPH_C32(0xb8a46797), SPH_C32(0xca59dec0),
    SPH_C32(0x764b30f7), SPH_C32(0x5eb71000), SPH_C32(0x9e55f96a),
    SPH_C32(0x8c336aff), SPH_C32(0xd5744780) },
  { SPH_C32(0x9aa50c00), SPH_C32(0xb539afe0), SPH_C32(0xa59c9621),
    SPH_C32(0xffc61c21), SPH_C32(0x4a0a1000), SPH_C32(0xb1efce95),
    SPH_C32(0xe6418f44), SPH_C32(0xf10bac66) },
  { SPH_C32(0x01260800), SPH_C32(0x971e5068), SPH_C32(0xa02b3b7b),
    SPH_C32(0x5234db11), SPH_C32(0xc5341400), SPH_C32(0xbc7206e2),
    SPH_C32(0x8984c7a5), SPH_C32(0x788680b0) },
  { SPH_C32(0x8e180c00), SPH_C32(0x9a83981f), SPH_C32(0xcfee739a),
    SPH_C32(0xdbb9f7c7), SPH_C32(0xd1891400), SPH_C32(0x93c8311d),
    SPH_C32(0xe3f6221e), SPH_C32(0x5cf96b56) },
  { SPH_C32(0x2a220000), SPH_C32(0xc47ebf14), SPH_C32(0x04ce77d4),
    SPH_C32(0xcb92c512), SPH_C32(0x80851800), SPH_C32(0xb6d6a994),
    SPH_C32(0xfdb64038), SPH_C32(0x73cbd816) },
  { SPH_C32(0xa51c0400), SPH_C32(0xc9e37763), SPH_C32(0x6b0b3f35),
    SPH_C32(0x421fe9c4), SPH_C32(0x94381800), SPH_C32(0x996c9e6b),
    SPH_C32(0x97c4a583), SPH_C32(0x57b433f0) },
  { SPH_C32(0x3e9f0000), SPH_C32(0xebc488eb), SPH_C32(0x6ebc926f),
    SPH_C32(0xefed2ef4), SPH_C32(0x1b061c00), SPH_C32(0x94f1561c),
    SPH_C32(0xf801ed62), SPH_C32(0xde391f26) },
  { SPH_C32(0xb1a10400), SPH_C32(0xe659409c), SPH_C32(0x0179da8e),
    SPH_C32(0x66600222), SPH_C32(0x0fbb1c00), SPH_C32(0xbb4b61e3),
    SPH_C32(0x927308d9), SPH_C32(0xfa46f4c0) },
  { SPH_C32(0xf4100800), SPH_C32(0xecfdefea), SPH_C32(0x754b5d13),
    SPH_C32(0x6d2d5a84), SPH_C32(0x610e1800), SPH_C32(0xe28f21e9),
    SPH_C32(0x42a4c3eb), SPH_C32(0x68adb265) },
  { SPH_C32(0x7b2e0c00), SPH_C32(0xe160279d), SPH_C32(0x1a8e15f2),
    SPH_C32(0xe4a07652), SPH_C32(0x75b31800), SPH_C32(0xcd351616),
    SPH_C32(0x28d62650), SPH_C32(0x4cd25983) },
  { SPH_C32(0xe0ad0800), SPH_C32(0xc347d815), SPH_C32(0x1f39b8a8),
    SPH_C32(0x4952b162), SPH_C32(0xfa8d1c00), SPH_C32(0xc0a8de61),
    SPH_C32(0x47136eb1), SPH_C32(0xc55f7555) },
  { SPH_C32(0x6f930c00), SPH_C32(0xceda1062), SPH_C32(0x70fcf049),
    SPH_C32(0xc0df9db4), SPH_C32(0xee301c00), SPH_C32(0xef12e99e),
    SPH_C32(0x2d618b0a), SPH_C32(0xe1209eb3) },
  { SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117), SPH_C32(0x3321e92c),
    SPH_C32(0xce122df3), SPH_C32(0x74951000), SPH_C32(0x5a2b467e),
    SPH_C32(0x88fd1d2b), SPH_C32(0x1ee68292) },
  { SPH_C32(0x30021400), SPH_C32(0xc791b960), SPH_C32(0x5ce4a1cd),
    SPH_C32(0x479f0125), SPH_C32(0x60281000), SPH_C32(0x75917181),
    SPH_C32(0xe28ff890), SPH_C32(0x3a996974) },
  { SPH_C32(0xab811000), SPH_C32(0xe5b646e8), SPH_C32(0x59530c97),
    SPH_C32(0xea6dc615), SPH_C32(0xef161400), SPH_C32(0x780cb9f6),
    SPH_C32(0x8d4ab071), SPH_C32(0xb31445a2) },
  { SPH_C32(0x24bf1400), SPH_C32(0xe82b8e9f), SPH_C32(0x36964476),
    SPH_C32(0x63e0eac3), SPH_C32(0xfbab1400), SPH_C32(0x57b68e09),
    SPH_C32(0xe73855ca), SPH_C32(0x976bae44) },
  { SPH_C32(0x610e1800), SPH_C32(0xe28f21e9), SPH_C32(0x42a4c3eb),
    SPH_C32(0x68adb265), SPH_C32(0x951e1000), SPH_C32(0x0e72ce03),
    SPH_C32(0x37ef9ef8), SPH_C32(0x0580e8e1) },
  { SPH_C32(0xee301c00), SPH_C32(0xef12e99e), SPH_C32(0x2d618b0a),
    SPH_C32(0xe1209eb3), SPH_C32(0x81a31000), SPH_C32(0x21c8f9fc),
    SPH_C32(0x5d9d7b43), SPH_C32(0x21ff0307) },
  { SPH_C32(0x75b31800), SPH_C32(0xcd351616), SPH_C32(0x28d62650),
    SPH_C32(0x4cd25983), SPH_C32(0x0e9d1400), SPH_C32(0x2c55318b),
    SPH_C32(0x325833a2), SPH_C32(0xa8722fd1) },
  { SPH_C32(0xfa8d1c00), SPH_C32(0xc0a8de61), SPH_C32(0x47136eb1),
    SPH_C32(0xc55f7555), SPH_C32(0x1a201400), SPH_C32(0x03ef0674),
    SPH_C32(0x582ad619), SPH_C32(0x8c0dc437) },
  { SPH_C32(0x5eb71000), SPH_C32(0x9e55f96a), SPH_C32(0x8c336aff),
    SPH_C32(0xd5744780), SPH_C32(0x4b2c1800), SPH_C32(0x26f19efd),
    SPH_C32(0x466ab43f), SPH_C32(0xa33f7777) },
  { SPH_C32(0xd1891400), SPH_C32(0x93c8311d), SPH_C32(0xe3f6221e),
    SPH_C32(0x5cf96b56), SPH_C32(0x5f911800), SPH_C32(0x094ba902),
    SPH_C32(0x2c185184), SPH_C32(0x87409c91) },
  { SPH_C32(0x4a0a1000), SPH_C32(0xb1efce95), SPH_C32(0xe6418f44),
    SPH_C32(0xf10bac66), SPH_C32(0xd0af1c00), SPH_C32(0x04d66175),
    SPH_C32(0x43dd1965), SPH_C32(0x0ecdb047) },
  { SPH_C32(0xc5341400), SPH_C32(0xbc7206e2), SPH_C32(0x8984c7a5),
    SPH_C32(0x788680b0), SPH_C32(0xc4121c00), SPH_C32(0x2b6c568a),
    SPH_C32(0x29affcde), SPH_C32(0x2ab25ba1) },
  { SPH_C32(0x80851800), SPH_C32(0xb6d6a994), SPH_C32(0xfdb64038),
    SPH_C32(0x73cbd816), SPH_C32(0xaaa71800), SPH_C32(0x72a81680),
    SPH_C32(0xf97837ec), SPH_C32(0xb8591d04) },
  { SPH_C32(0x0fbb1c00), SPH_C32(0xbb4b61e3), SPH_C32(0x927308d9),
    SPH_C32(0xfa46f4c0), SPH_C32(0xbe1a1800), SPH_C32(0x5d12217f),
    SPH_C32(0x930ad257), SPH_C32(0x9c26f6e2) },
  { SPH_C32(0x94381800), SPH_C32(0x996c9e6b), SPH_C32(0x97c4a583),
    SPH_C32(0x57b433f0), SPH_C32(0x31241c00), SPH_C32(0x508fe908),
    SPH_C32(0xfccf9ab6), SPH_C32(0x15abda34) },
  { SPH_C32(0x1b061c00), SPH_C32(0x94f1561c), SPH_C32(0xf801ed62),
    SPH_C32(0xde391f26), SPH_C32(0x25991c00), SPH_C32(0x7f35def7),
    SPH_C32(0x96bd7f0d), SPH_C32(0x31d431d2) }
};

__constant static const sph_u32 T256_12[64][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0x62740080), SPH_C32(0x0fb84b07), SPH_C32(0x138a651e),
    SPH_C32(0x44100618), SPH_C32(0x5bd20080), SPH_C32(0x450f18ec),
    SPH_C32(0xc2c46c55), SPH_C32(0xf362b233) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0xec760180), SPH_C32(0xcf102934), SPH_C32(0x474db4fe),
    SPH_C32(0x15a6d657), SPH_C32(0x4aea0000), SPH_C32(0xdfd8f43d),
    SPH_C32(0x73d31bdc), SPH_C32(0xd997dc7f) },
  { SPH_C32(0x8e020100), SPH_C32(0xc0a86233), SPH_C32(0x54c7d1e0),
    SPH_C32(0x51b6d04f), SPH_C32(0x11380080), SPH_C32(0x9ad7ecd1),
    SPH_C32(0xb1177789), SPH_C32(0x2af56e4c) },
  { SPH_C32(0xd5d00180), SPH_C32(0x85a77adf), SPH_C32(0x9603bdb5),
    SPH_C32(0xa2d4627c), SPH_C32(0x289e0080), SPH_C32(0xd060bf3a),
    SPH_C32(0x60597ec2), SPH_C32(0x9d87da67) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0x289e0080), SPH_C32(0xd060bf3a), SPH_C32(0x60597ec2),
    SPH_C32(0x9d87da67), SPH_C32(0xfd4e0100), SPH_C32(0x55c7c5e5),
    SPH_C32(0xf65ac377), SPH_C32(0x3f53b81b) },
  { SPH_C32(0x4aea0000), SPH_C32(0xdfd8f43d), SPH_C32(0x73d31bdc),
    SPH_C32(0xd997dc7f), SPH_C32(0xa69c0180), SPH_C32(0x10c8dd09),
    SPH_C32(0x349eaf22), SPH_C32(0xcc310a28) },
  { SPH_C32(0x11380080), SPH_C32(0x9ad7ecd1), SPH_C32(0xb1177789),
    SPH_C32(0x2af56e4c), SPH_C32(0x9f3a0180), SPH_C32(0x5a7f8ee2),
    SPH_C32(0xe5d0a669), SPH_C32(0x7b43be03) },
  { SPH_C32(0xc4e80100), SPH_C32(0x1f70960e), SPH_C32(0x2714ca3c),
    SPH_C32(0x88210c30), SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8),
    SPH_C32(0x8589d8ab), SPH_C32(0xe6c46464) },
  { SPH_C32(0x9f3a0180), SPH_C32(0x5a7f8ee2), SPH_C32(0xe5d0a669),
    SPH_C32(0x7b43be03), SPH_C32(0x8e020100), SPH_C32(0xc0a86233),
    SPH_C32(0x54c7d1e0), SPH_C32(0x51b6d04f) },
  { SPH_C32(0xfd4e0100), SPH_C32(0x55c7c5e5), SPH_C32(0xf65ac377),
    SPH_C32(0x3f53b81b), SPH_C32(0xd5d00180), SPH_C32(0x85a77adf),
    SPH_C32(0x9603bdb5), SPH_C32(0xa2d4627c) },
  { SPH_C32(0xa69c0180), SPH_C32(0x10c8dd09), SPH_C32(0x349eaf22),
    SPH_C32(0xcc310a28), SPH_C32(0xec760180), SPH_C32(0xcf102934),
    SPH_C32(0x474db4fe), SPH_C32(0x15a6d657) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0xfc6a0280), SPH_C32(0x5a1d9cdf), SPH_C32(0xa22195a7),
    SPH_C32(0x6d76c745), SPH_C32(0xd7800000), SPH_C32(0x58fc3bd5),
    SPH_C32(0x518cdfc4), SPH_C32(0x8c811f07) },
  { SPH_C32(0x9e1e0200), SPH_C32(0x55a5d7d8), SPH_C32(0xb1abf0b9),
    SPH_C32(0x2966c15d), SPH_C32(0x8c520080), SPH_C32(0x1df32339),
    SPH_C32(0x9348b391), SPH_C32(0x7fe3ad34) },
  { SPH_C32(0xc5cc0280), SPH_C32(0x10aacf34), SPH_C32(0x736f9cec),
    SPH_C32(0xda04736e), SPH_C32(0xb5f40080), SPH_C32(0x574470d2),
    SPH_C32(0x4206bada), SPH_C32(0xc891191f) },
  { SPH_C32(0x101c0300), SPH_C32(0x950db5eb), SPH_C32(0xe56c2159),
    SPH_C32(0x78d01112), SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8),
    SPH_C32(0x225fc418), SPH_C32(0x5516c378) },
  { SPH_C32(0x4bce0380), SPH_C32(0xd002ad07), SPH_C32(0x27a84d0c),
    SPH_C32(0x8bb2a321), SPH_C32(0xa4cc0000), SPH_C32(0xcd939c03),
    SPH_C32(0xf311cd53), SPH_C32(0xe2647753) },
  { SPH_C32(0x29ba0300), SPH_C32(0xdfbae600), SPH_C32(0x34222812),
    SPH_C32(0xcfa2a539), SPH_C32(0xff1e0080), SPH_C32(0x889c84ef),
    SPH_C32(0x31d5a106), SPH_C32(0x1106c560) },
  { SPH_C32(0x72680380), SPH_C32(0x9ab5feec), SPH_C32(0xf6e64447),
    SPH_C32(0x3cc0170a), SPH_C32(0xc6b80080), SPH_C32(0xc22bd704),
    SPH_C32(0xe09ba84d), SPH_C32(0xa674714b) },
  { SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5), SPH_C32(0xc278eb65),
    SPH_C32(0xf0f11d22), SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30),
    SPH_C32(0xa7d61cb3), SPH_C32(0xb3d2a71c) },
  { SPH_C32(0x8f260280), SPH_C32(0xcf723b09), SPH_C32(0x00bc8730),
    SPH_C32(0x0393af11), SPH_C32(0x13680100), SPH_C32(0x478caddb),
    SPH_C32(0x769815f8), SPH_C32(0x04a01337) },
  { SPH_C32(0xed520200), SPH_C32(0xc0ca700e), SPH_C32(0x1336e22e),
    SPH_C32(0x4783a909), SPH_C32(0x48ba0180), SPH_C32(0x0283b537),
    SPH_C32(0xb45c79ad), SPH_C32(0xf7c2a104) },
  { SPH_C32(0xb6800280), SPH_C32(0x85c568e2), SPH_C32(0xd1f28e7b),
    SPH_C32(0xb4e11b3a), SPH_C32(0x711c0180), SPH_C32(0x4834e6dc),
    SPH_C32(0x651270e6), SPH_C32(0x40b0152f) },
  { SPH_C32(0x63500300), SPH_C32(0x0062123d), SPH_C32(0x47f133ce),
    SPH_C32(0x16357946), SPH_C32(0x59820100), SPH_C32(0x985459e6),
    SPH_C32(0x054b0e24), SPH_C32(0xdd37cf48) },
  { SPH_C32(0x38820380), SPH_C32(0x456d0ad1), SPH_C32(0x85355f9b),
    SPH_C32(0xe557cb75), SPH_C32(0x60240100), SPH_C32(0xd2e30a0d),
    SPH_C32(0xd405076f), SPH_C32(0x6a457b63) },
  { SPH_C32(0x5af60300), SPH_C32(0x4ad541d6), SPH_C32(0x96bf3a85),
    SPH_C32(0xa147cd6d), SPH_C32(0x3bf60180), SPH_C32(0x97ec12e1),
    SPH_C32(0x16c16b3a), SPH_C32(0x9927c950) },
  { SPH_C32(0x01240380), SPH_C32(0x0fda593a), SPH_C32(0x547b56d0),
    SPH_C32(0x52257f5e), SPH_C32(0x02500180), SPH_C32(0xdd5b410a),
    SPH_C32(0xc78f6271), SPH_C32(0x2e557d7b) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0xb5f40080), SPH_C32(0x574470d2), SPH_C32(0x4206bada),
    SPH_C32(0xc891191f), SPH_C32(0x70380200), SPH_C32(0x47eebfe6),
    SPH_C32(0x31692636), SPH_C32(0x12956a71) },
  { SPH_C32(0xd7800000), SPH_C32(0x58fc3bd5), SPH_C32(0x518cdfc4),
    SPH_C32(0x8c811f07), SPH_C32(0x2bea0280), SPH_C32(0x02e1a70a),
    SPH_C32(0xf3ad4a63), SPH_C32(0xe1f7d842) },
  { SPH_C32(0x8c520080), SPH_C32(0x1df32339), SPH_C32(0x9348b391),
    SPH_C32(0x7fe3ad34), SPH_C32(0x124c0280), SPH_C32(0x4856f4e1),
    SPH_C32(0x22e34328), SPH_C32(0x56856c69) },
  { SPH_C32(0x59820100), SPH_C32(0x985459e6), SPH_C32(0x054b0e24),
    SPH_C32(0xdd37cf48), SPH_C32(0x3ad20200), SPH_C32(0x98364bdb),
    SPH_C32(0x42ba3dea), SPH_C32(0xcb02b60e) },
  { SPH_C32(0x02500180), SPH_C32(0xdd5b410a), SPH_C32(0xc78f6271),
    SPH_C32(0x2e557d7b), SPH_C32(0x03740200), SPH_C32(0xd2811830),
    SPH_C32(0x93f434a1), SPH_C32(0x7c700225) },
  { SPH_C32(0x60240100), SPH_C32(0xd2e30a0d), SPH_C32(0xd405076f),
    SPH_C32(0x6a457b63), SPH_C32(0x58a60280), SPH_C32(0x978e00dc),
    SPH_C32(0x513058f4), SPH_C32(0x8f12b016) },
  { SPH_C32(0x3bf60180), SPH_C32(0x97ec12e1), SPH_C32(0x16c16b3a),
    SPH_C32(0x9927c950), SPH_C32(0x61000280), SPH_C32(0xdd395337),
    SPH_C32(0x807e51bf), SPH_C32(0x3860043d) },
  { SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8), SPH_C32(0x225fc418),
    SPH_C32(0x5516c378), SPH_C32(0x8d760300), SPH_C32(0x12297a03),
    SPH_C32(0xc733e541), SPH_C32(0x2dc6d26a) },
  { SPH_C32(0xc6b80080), SPH_C32(0xc22bd704), SPH_C32(0xe09ba84d),
    SPH_C32(0xa674714b), SPH_C32(0xb4d00300), SPH_C32(0x589e29e8),
    SPH_C32(0x167dec0a), SPH_C32(0x9ab46641) },
  { SPH_C32(0xa4cc0000), SPH_C32(0xcd939c03), SPH_C32(0xf311cd53),
    SPH_C32(0xe2647753), SPH_C32(0xef020380), SPH_C32(0x1d913104),
    SPH_C32(0xd4b9805f), SPH_C32(0x69d6d472) },
  { SPH_C32(0xff1e0080), SPH_C32(0x889c84ef), SPH_C32(0x31d5a106),
    SPH_C32(0x1106c560), SPH_C32(0xd6a40380), SPH_C32(0x572662ef),
    SPH_C32(0x05f78914), SPH_C32(0xdea46059) },
  { SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30), SPH_C32(0xa7d61cb3),
    SPH_C32(0xb3d2a71c), SPH_C32(0xfe3a0300), SPH_C32(0x8746ddd5),
    SPH_C32(0x65aef7d6), SPH_C32(0x4323ba3e) },
  { SPH_C32(0x711c0180), SPH_C32(0x4834e6dc), SPH_C32(0x651270e6),
    SPH_C32(0x40b0152f), SPH_C32(0xc79c0300), SPH_C32(0xcdf18e3e),
    SPH_C32(0xb4e0fe9d), SPH_C32(0xf4510e15) },
  { SPH_C32(0x13680100), SPH_C32(0x478caddb), SPH_C32(0x769815f8),
    SPH_C32(0x04a01337), SPH_C32(0x9c4e0380), SPH_C32(0x88fe96d2),
    SPH_C32(0x762492c8), SPH_C32(0x0733bc26) },
  { SPH_C32(0x48ba0180), SPH_C32(0x0283b537), SPH_C32(0xb45c79ad),
    SPH_C32(0xf7c2a104), SPH_C32(0xa5e80380), SPH_C32(0xc249c539),
    SPH_C32(0xa76a9b83), SPH_C32(0xb041080d) },
  { SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d), SPH_C32(0xe0272f7d),
    SPH_C32(0xa5e7de5a), SPH_C32(0xa7b80200), SPH_C32(0x1f128433),
    SPH_C32(0x60e5f9f2), SPH_C32(0x9e147576) },
  { SPH_C32(0x124c0280), SPH_C32(0x4856f4e1), SPH_C32(0x22e34328),
    SPH_C32(0x56856c69), SPH_C32(0x9e1e0200), SPH_C32(0x55a5d7d8),
    SPH_C32(0xb1abf0b9), SPH_C32(0x2966c15d) },
  { SPH_C32(0x70380200), SPH_C32(0x47eebfe6), SPH_C32(0x31692636),
    SPH_C32(0x12956a71), SPH_C32(0xc5cc0280), SPH_C32(0x10aacf34),
    SPH_C32(0x736f9cec), SPH_C32(0xda04736e) },
  { SPH_C32(0x2bea0280), SPH_C32(0x02e1a70a), SPH_C32(0xf3ad4a63),
    SPH_C32(0xe1f7d842), SPH_C32(0xfc6a0280), SPH_C32(0x5a1d9cdf),
    SPH_C32(0xa22195a7), SPH_C32(0x6d76c745) },
  { SPH_C32(0xfe3a0300), SPH_C32(0x8746ddd5), SPH_C32(0x65aef7d6),
    SPH_C32(0x4323ba3e), SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5),
    SPH_C32(0xc278eb65), SPH_C32(0xf0f11d22) },
  { SPH_C32(0xa5e80380), SPH_C32(0xc249c539), SPH_C32(0xa76a9b83),
    SPH_C32(0xb041080d), SPH_C32(0xed520200), SPH_C32(0xc0ca700e),
    SPH_C32(0x1336e22e), SPH_C32(0x4783a909) },
  { SPH_C32(0xc79c0300), SPH_C32(0xcdf18e3e), SPH_C32(0xb4e0fe9d),
    SPH_C32(0xf4510e15), SPH_C32(0xb6800280), SPH_C32(0x85c568e2),
    SPH_C32(0xd1f28e7b), SPH_C32(0xb4e11b3a) },
  { SPH_C32(0x9c4e0380), SPH_C32(0x88fe96d2), SPH_C32(0x762492c8),
    SPH_C32(0x0733bc26), SPH_C32(0x8f260280), SPH_C32(0xcf723b09),
    SPH_C32(0x00bc8730), SPH_C32(0x0393af11) },
  { SPH_C32(0x3ad20200), SPH_C32(0x98364bdb), SPH_C32(0x42ba3dea),
    SPH_C32(0xcb02b60e), SPH_C32(0x63500300), SPH_C32(0x0062123d),
    SPH_C32(0x47f133ce), SPH_C32(0x16357946) },
  { SPH_C32(0x61000280), SPH_C32(0xdd395337), SPH_C32(0x807e51bf),
    SPH_C32(0x3860043d), SPH_C32(0x5af60300), SPH_C32(0x4ad541d6),
    SPH_C32(0x96bf3a85), SPH_C32(0xa147cd6d) },
  { SPH_C32(0x03740200), SPH_C32(0xd2811830), SPH_C32(0x93f434a1),
    SPH_C32(0x7c700225), SPH_C32(0x01240380), SPH_C32(0x0fda593a),
    SPH_C32(0x547b56d0), SPH_C32(0x52257f5e) },
  { SPH_C32(0x58a60280), SPH_C32(0x978e00dc), SPH_C32(0x513058f4),
    SPH_C32(0x8f12b016), SPH_C32(0x38820380), SPH_C32(0x456d0ad1),
    SPH_C32(0x85355f9b), SPH_C32(0xe557cb75) },
  { SPH_C32(0x8d760300), SPH_C32(0x12297a03), SPH_C32(0xc733e541),
    SPH_C32(0x2dc6d26a), SPH_C32(0x101c0300), SPH_C32(0x950db5eb),
    SPH_C32(0xe56c2159), SPH_C32(0x78d01112) },
  { SPH_C32(0xd6a40380), SPH_C32(0x572662ef), SPH_C32(0x05f78914),
    SPH_C32(0xdea46059), SPH_C32(0x29ba0300), SPH_C32(0xdfbae600),
    SPH_C32(0x34222812), SPH_C32(0xcfa2a539) },
  { SPH_C32(0xb4d00300), SPH_C32(0x589e29e8), SPH_C32(0x167dec0a),
    SPH_C32(0x9ab46641), SPH_C32(0x72680380), SPH_C32(0x9ab5feec),
    SPH_C32(0xf6e64447), SPH_C32(0x3cc0170a) },
  { SPH_C32(0xef020380), SPH_C32(0x1d913104), SPH_C32(0xd4b9805f),
    SPH_C32(0x69d6d472), SPH_C32(0x4bce0380), SPH_C32(0xd002ad07),
    SPH_C32(0x27a84d0c), SPH_C32(0x8bb2a321) }
};

__constant static const sph_u32 T256_18[64][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0x7f650010), SPH_C32(0x242e1472), SPH_C32(0xc03320fe),
    SPH_C32(0xc0a3c0dd), SPH_C32(0x515c0010), SPH_C32(0x40f372fb),
    SPH_C32(0xfce72602), SPH_C32(0x71575061) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0xf3e40030), SPH_C32(0xc114970d), SPH_C32(0x05296a06),
    SPH_C32(0x93f8f0a1), SPH_C32(0x724b0000), SPH_C32(0xad67ab9b),
    SPH_C32(0x457d0b05), SPH_C32(0xd21db1c4) },
  { SPH_C32(0x8c810020), SPH_C32(0xe53a837f), SPH_C32(0xc51a4af8),
    SPH_C32(0x535b307c), SPH_C32(0x23170010), SPH_C32(0xed94d960),
    SPH_C32(0xb99a2d07), SPH_C32(0xa34ae1a5) },
  { SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184), SPH_C32(0x39fd6cfa),
    SPH_C32(0x220c601d), SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9),
    SPH_C32(0x854e2bfb), SPH_C32(0x12be7119) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9), SPH_C32(0x854e2bfb),
    SPH_C32(0x12be7119), SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d),
    SPH_C32(0xbcb34701), SPH_C32(0x30b21104) },
  { SPH_C32(0x724b0000), SPH_C32(0xad67ab9b), SPH_C32(0x457d0b05),
    SPH_C32(0xd21db1c4), SPH_C32(0x81af0030), SPH_C32(0x6c733c96),
    SPH_C32(0x40546103), SPH_C32(0x41e54165) },
  { SPH_C32(0x23170010), SPH_C32(0xed94d960), SPH_C32(0xb99a2d07),
    SPH_C32(0xa34ae1a5), SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f),
    SPH_C32(0x7c8067ff), SPH_C32(0xf011d1d9) },
  { SPH_C32(0xfeca0020), SPH_C32(0x485d28e4), SPH_C32(0x806741fd),
    SPH_C32(0x814681b8), SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6),
    SPH_C32(0xf9ce4c04), SPH_C32(0xe2afa0c0) },
  { SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f), SPH_C32(0x7c8067ff),
    SPH_C32(0xf011d1d9), SPH_C32(0x8c810020), SPH_C32(0xe53a837f),
    SPH_C32(0xc51a4af8), SPH_C32(0x535b307c) },
  { SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d), SPH_C32(0xbcb34701),
    SPH_C32(0x30b21104), SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184),
    SPH_C32(0x39fd6cfa), SPH_C32(0x220c601d) },
  { SPH_C32(0x81af0030), SPH_C32(0x6c733c96), SPH_C32(0x40546103),
    SPH_C32(0x41e54165), SPH_C32(0xf3e40030), SPH_C32(0xc114970d),
    SPH_C32(0x05296a06), SPH_C32(0x93f8f0a1) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x1c920050), SPH_C32(0x7ba89e85), SPH_C32(0xca824daa),
    SPH_C32(0x52346a64), SPH_C32(0x56920000), SPH_C32(0xc4103cbd),
    SPH_C32(0x6188a60b), SPH_C32(0xc3831477) },
  { SPH_C32(0x63f70040), SPH_C32(0x5f868af7), SPH_C32(0x0ab16d54),
    SPH_C32(0x9297aab9), SPH_C32(0x07ce0010), SPH_C32(0x84e34e46),
    SPH_C32(0x9d6f8009), SPH_C32(0xb2d44416) },
  { SPH_C32(0x32ab0050), SPH_C32(0x1f75f80c), SPH_C32(0xf6564b56),
    SPH_C32(0xe3c0fad8), SPH_C32(0x29f70010), SPH_C32(0xe03e28cf),
    SPH_C32(0xa1bb86f5), SPH_C32(0x0320d4aa) },
  { SPH_C32(0xef760060), SPH_C32(0xbabc0988), SPH_C32(0xcfab27ac),
    SPH_C32(0xc1cc9ac5), SPH_C32(0x24d90000), SPH_C32(0x69779726),
    SPH_C32(0x24f5ad0e), SPH_C32(0x119ea5b3) },
  { SPH_C32(0xbe2a0070), SPH_C32(0xfa4f7b73), SPH_C32(0x334c01ae),
    SPH_C32(0xb09bcaa4), SPH_C32(0x0ae00000), SPH_C32(0x0daaf1af),
    SPH_C32(0x1821abf2), SPH_C32(0xa06a350f) },
  { SPH_C32(0xc14f0060), SPH_C32(0xde616f01), SPH_C32(0xf37f2150),
    SPH_C32(0x70380a79), SPH_C32(0x5bbc0010), SPH_C32(0x4d598354),
    SPH_C32(0xe4c68df0), SPH_C32(0xd13d656e) },
  { SPH_C32(0x90130070), SPH_C32(0x9e921dfa), SPH_C32(0x0f980752),
    SPH_C32(0x016f5a18), SPH_C32(0x75850010), SPH_C32(0x2984e5dd),
    SPH_C32(0xd8128b0c), SPH_C32(0x60c9f5d2) },
  { SPH_C32(0x11bc0040), SPH_C32(0xf2e1216c), SPH_C32(0x4fcc6651),
    SPH_C32(0x408a1b7d), SPH_C32(0x86610020), SPH_C32(0xe89072d0),
    SPH_C32(0xdd3be10a), SPH_C32(0xf3310573) },
  { SPH_C32(0x40e00050), SPH_C32(0xb2125397), SPH_C32(0xb32b4053),
    SPH_C32(0x31dd4b1c), SPH_C32(0xa8580020), SPH_C32(0x8c4d1459),
    SPH_C32(0xe1efe7f6), SPH_C32(0x42c595cf) },
  { SPH_C32(0x3f850040), SPH_C32(0x963c47e5), SPH_C32(0x731860ad),
    SPH_C32(0xf17e8bc1), SPH_C32(0xf9040030), SPH_C32(0xccbe66a2),
    SPH_C32(0x1d08c1f4), SPH_C32(0x3392c5ae) },
  { SPH_C32(0x6ed90050), SPH_C32(0xd6cf351e), SPH_C32(0x8fff46af),
    SPH_C32(0x8029dba0), SPH_C32(0xd73d0030), SPH_C32(0xa863002b),
    SPH_C32(0x21dcc708), SPH_C32(0x82665512) },
  { SPH_C32(0xb3040060), SPH_C32(0x7306c49a), SPH_C32(0xb6022a55),
    SPH_C32(0xa225bbbd), SPH_C32(0xda130020), SPH_C32(0x212abfc2),
    SPH_C32(0xa492ecf3), SPH_C32(0x90d8240b) },
  { SPH_C32(0xe2580070), SPH_C32(0x33f5b661), SPH_C32(0x4ae50c57),
    SPH_C32(0xd372ebdc), SPH_C32(0xf42a0020), SPH_C32(0x45f7d94b),
    SPH_C32(0x9846ea0f), SPH_C32(0x212cb4b7) },
  { SPH_C32(0x9d3d0060), SPH_C32(0x17dba213), SPH_C32(0x8ad62ca9),
    SPH_C32(0x13d12b01), SPH_C32(0xa5760030), SPH_C32(0x0504abb0),
    SPH_C32(0x64a1cc0d), SPH_C32(0x507be4d6) },
  { SPH_C32(0xcc610070), SPH_C32(0x5728d0e8), SPH_C32(0x76310aab),
    SPH_C32(0x62867b60), SPH_C32(0x8b4f0030), SPH_C32(0x61d9cd39),
    SPH_C32(0x5875caf1), SPH_C32(0xe18f746a) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x29f70010), SPH_C32(0xe03e28cf), SPH_C32(0xa1bb86f5),
    SPH_C32(0x0320d4aa), SPH_C32(0x1b5c0040), SPH_C32(0xff4bd0c3),
    SPH_C32(0x57edcda3), SPH_C32(0xe0e02e72) },
  { SPH_C32(0x56920000), SPH_C32(0xc4103cbd), SPH_C32(0x6188a60b),
    SPH_C32(0xc3831477), SPH_C32(0x4a000050), SPH_C32(0xbfb8a238),
    SPH_C32(0xab0aeba1), SPH_C32(0x91b77e13) },
  { SPH_C32(0x07ce0010), SPH_C32(0x84e34e46), SPH_C32(0x9d6f8009),
    SPH_C32(0xb2d44416), SPH_C32(0x64390050), SPH_C32(0xdb65c4b1),
    SPH_C32(0x97deed5d), SPH_C32(0x2043eeaf) },
  { SPH_C32(0xda130020), SPH_C32(0x212abfc2), SPH_C32(0xa492ecf3),
    SPH_C32(0x90d8240b), SPH_C32(0x69170040), SPH_C32(0x522c7b58),
    SPH_C32(0x1290c6a6), SPH_C32(0x32fd9fb6) },
  { SPH_C32(0x8b4f0030), SPH_C32(0x61d9cd39), SPH_C32(0x5875caf1),
    SPH_C32(0xe18f746a), SPH_C32(0x472e0040), SPH_C32(0x36f11dd1),
    SPH_C32(0x2e44c05a), SPH_C32(0x83090f0a) },
  { SPH_C32(0xf42a0020), SPH_C32(0x45f7d94b), SPH_C32(0x9846ea0f),
    SPH_C32(0x212cb4b7), SPH_C32(0x16720050), SPH_C32(0x76026f2a),
    SPH_C32(0xd2a3e658), SPH_C32(0xf25e5f6b) },
  { SPH_C32(0xa5760030), SPH_C32(0x0504abb0), SPH_C32(0x64a1cc0d),
    SPH_C32(0x507be4d6), SPH_C32(0x384b0050), SPH_C32(0x12df09a3),
    SPH_C32(0xee77e0a4), SPH_C32(0x43aacfd7) },
  { SPH_C32(0x24d90000), SPH_C32(0x69779726), SPH_C32(0x24f5ad0e),
    SPH_C32(0x119ea5b3), SPH_C32(0xcbaf0060), SPH_C32(0xd3cb9eae),
    SPH_C32(0xeb5e8aa2), SPH_C32(0xd0523f76) },
  { SPH_C32(0x75850010), SPH_C32(0x2984e5dd), SPH_C32(0xd8128b0c),
    SPH_C32(0x60c9f5d2), SPH_C32(0xe5960060), SPH_C32(0xb716f827),
    SPH_C32(0xd78a8c5e), SPH_C32(0x61a6afca) },
  { SPH_C32(0x0ae00000), SPH_C32(0x0daaf1af), SPH_C32(0x1821abf2),
    SPH_C32(0xa06a350f), SPH_C32(0xb4ca0070), SPH_C32(0xf7e58adc),
    SPH_C32(0x2b6daa5c), SPH_C32(0x10f1ffab) },
  { SPH_C32(0x5bbc0010), SPH_C32(0x4d598354), SPH_C32(0xe4c68df0),
    SPH_C32(0xd13d656e), SPH_C32(0x9af30070), SPH_C32(0x9338ec55),
    SPH_C32(0x17b9aca0), SPH_C32(0xa1056f17) },
  { SPH_C32(0x86610020), SPH_C32(0xe89072d0), SPH_C32(0xdd3be10a),
    SPH_C32(0xf3310573), SPH_C32(0x97dd0060), SPH_C32(0x1a7153bc),
    SPH_C32(0x92f7875b), SPH_C32(0xb3bb1e0e) },
  { SPH_C32(0xd73d0030), SPH_C32(0xa863002b), SPH_C32(0x21dcc708),
    SPH_C32(0x82665512), SPH_C32(0xb9e40060), SPH_C32(0x7eac3535),
    SPH_C32(0xae2381a7), SPH_C32(0x024f8eb2) },
  { SPH_C32(0xa8580020), SPH_C32(0x8c4d1459), SPH_C32(0xe1efe7f6),
    SPH_C32(0x42c595cf), SPH_C32(0xe8b80070), SPH_C32(0x3e5f47ce),
    SPH_C32(0x52c4a7a5), SPH_C32(0x7318ded3) },
  { SPH_C32(0xf9040030), SPH_C32(0xccbe66a2), SPH_C32(0x1d08c1f4),
    SPH_C32(0x3392c5ae), SPH_C32(0xc6810070), SPH_C32(0x5a822147),
    SPH_C32(0x6e10a159), SPH_C32(0xc2ec4e6f) },
  { SPH_C32(0x35650040), SPH_C32(0x9b96b64a), SPH_C32(0x6b39cb5f),
    SPH_C32(0x5114bece), SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e),
    SPH_C32(0x36656ba8), SPH_C32(0x23633a05) },
  { SPH_C32(0x64390050), SPH_C32(0xdb65c4b1), SPH_C32(0x97deed5d),
    SPH_C32(0x2043eeaf), SPH_C32(0x63f70040), SPH_C32(0x5f868af7),
    SPH_C32(0x0ab16d54), SPH_C32(0x9297aab9) },
  { SPH_C32(0x1b5c0040), SPH_C32(0xff4bd0c3), SPH_C32(0x57edcda3),
    SPH_C32(0xe0e02e72), SPH_C32(0x32ab0050), SPH_C32(0x1f75f80c),
    SPH_C32(0xf6564b56), SPH_C32(0xe3c0fad8) },
  { SPH_C32(0x4a000050), SPH_C32(0xbfb8a238), SPH_C32(0xab0aeba1),
    SPH_C32(0x91b77e13), SPH_C32(0x1c920050), SPH_C32(0x7ba89e85),
    SPH_C32(0xca824daa), SPH_C32(0x52346a64) },
  { SPH_C32(0x97dd0060), SPH_C32(0x1a7153bc), SPH_C32(0x92f7875b),
    SPH_C32(0xb3bb1e0e), SPH_C32(0x11bc0040), SPH_C32(0xf2e1216c),
    SPH_C32(0x4fcc6651), SPH_C32(0x408a1b7d) },
  { SPH_C32(0xc6810070), SPH_C32(0x5a822147), SPH_C32(0x6e10a159),
    SPH_C32(0xc2ec4e6f), SPH_C32(0x3f850040), SPH_C32(0x963c47e5),
    SPH_C32(0x731860ad), SPH_C32(0xf17e8bc1) },
  { SPH_C32(0xb9e40060), SPH_C32(0x7eac3535), SPH_C32(0xae2381a7),
    SPH_C32(0x024f8eb2), SPH_C32(0x6ed90050), SPH_C32(0xd6cf351e),
    SPH_C32(0x8fff46af), SPH_C32(0x8029dba0) },
  { SPH_C32(0xe8b80070), SPH_C32(0x3e5f47ce), SPH_C32(0x52c4a7a5),
    SPH_C32(0x7318ded3), SPH_C32(0x40e00050), SPH_C32(0xb2125397),
    SPH_C32(0xb32b4053), SPH_C32(0x31dd4b1c) },
  { SPH_C32(0x69170040), SPH_C32(0x522c7b58), SPH_C32(0x1290c6a6),
    SPH_C32(0x32fd9fb6), SPH_C32(0xb3040060), SPH_C32(0x7306c49a),
    SPH_C32(0xb6022a55), SPH_C32(0xa225bbbd) },
  { SPH_C32(0x384b0050), SPH_C32(0x12df09a3), SPH_C32(0xee77e0a4),
    SPH_C32(0x43aacfd7), SPH_C32(0x9d3d0060), SPH_C32(0x17dba213),
    SPH_C32(0x8ad62ca9), SPH_C32(0x13d12b01) },
  { SPH_C32(0x472e0040), SPH_C32(0x36f11dd1), SPH_C32(0x2e44c05a),
    SPH_C32(0x83090f0a), SPH_C32(0xcc610070), SPH_C32(0x5728d0e8),
    SPH_C32(0x76310aab), SPH_C32(0x62867b60) },
  { SPH_C32(0x16720050), SPH_C32(0x76026f2a), SPH_C32(0xd2a3e658),
    SPH_C32(0xf25e5f6b), SPH_C32(0xe2580070), SPH_C32(0x33f5b661),
    SPH_C32(0x4ae50c57), SPH_C32(0xd372ebdc) },
  { SPH_C32(0xcbaf0060), SPH_C32(0xd3cb9eae), SPH_C32(0xeb5e8aa2),
    SPH_C32(0xd0523f76), SPH_C32(0xef760060), SPH_C32(0xbabc0988),
    SPH_C32(0xcfab27ac), SPH_C32(0xc1cc9ac5) },
  { SPH_C32(0x9af30070), SPH_C32(0x9338ec55), SPH_C32(0x17b9aca0),
    SPH_C32(0xa1056f17), SPH_C32(0xc14f0060), SPH_C32(0xde616f01),
    SPH_C32(0xf37f2150), SPH_C32(0x70380a79) },
  { SPH_C32(0xe5960060), SPH_C32(0xb716f827), SPH_C32(0xd78a8c5e),
    SPH_C32(0x61a6afca), SPH_C32(0x90130070), SPH_C32(0x9e921dfa),
    SPH_C32(0x0f980752), SPH_C32(0x016f5a18) },
  { SPH_C32(0xb4ca0070), SPH_C32(0xf7e58adc), SPH_C32(0x2b6daa5c),
    SPH_C32(0x10f1ffab), SPH_C32(0xbe2a0070), SPH_C32(0xfa4f7b73),
    SPH_C32(0x334c01ae), SPH_C32(0xb09bcaa4) }
};

__constant static const sph_u32 T256_24[64][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7), SPH_C32(0xe007afe6),
    SPH_C32(0x9fed4ab7), SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3),
    SPH_C32(0x99e585aa), SPH_C32(0x8d75f7f1) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x582b0006), SPH_C32(0xd39128c4), SPH_C32(0x042035fa),
    SPH_C32(0x223fde2b), SPH_C32(0x3a050000), SPH_C32(0x6508f6be),
    SPH_C32(0xe1d03671), SPH_C32(0x64347a75) },
  { SPH_C32(0x81a40004), SPH_C32(0xa9958063), SPH_C32(0xe4279a1c),
    SPH_C32(0xbdd2949c), SPH_C32(0xb2260002), SPH_C32(0x3aef510d),
    SPH_C32(0x7835b3db), SPH_C32(0xe9418d84) },
  { SPH_C32(0x09870006), SPH_C32(0xf67227d0), SPH_C32(0x7dc21fb6),
    SPH_C32(0x30a7636d), SPH_C32(0xe38a0002), SPH_C32(0x1f0c5e19),
    SPH_C32(0x01d79997), SPH_C32(0xfbd930c2) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xe38a0002), SPH_C32(0x1f0c5e19), SPH_C32(0x01d79997),
    SPH_C32(0xfbd930c2), SPH_C32(0xea0d0004), SPH_C32(0xe97e79c9),
    SPH_C32(0x7c158621), SPH_C32(0xcb7e53af) },
  { SPH_C32(0x3a050000), SPH_C32(0x6508f6be), SPH_C32(0xe1d03671),
    SPH_C32(0x64347a75), SPH_C32(0x622e0006), SPH_C32(0xb699de7a),
    SPH_C32(0xe5f0038b), SPH_C32(0x460ba45e) },
  { SPH_C32(0xb2260002), SPH_C32(0x3aef510d), SPH_C32(0x7835b3db),
    SPH_C32(0xe9418d84), SPH_C32(0x33820006), SPH_C32(0x937ad16e),
    SPH_C32(0x9c1229c7), SPH_C32(0x54931918) },
  { SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd), SPH_C32(0x05f7ac6d),
    SPH_C32(0xd9e6eee9), SPH_C32(0xd0080004), SPH_C32(0x8c768f77),
    SPH_C32(0x9dc5b050), SPH_C32(0xaf4a29da) },
  { SPH_C32(0x33820006), SPH_C32(0x937ad16e), SPH_C32(0x9c1229c7),
    SPH_C32(0x54931918), SPH_C32(0x81a40004), SPH_C32(0xa9958063),
    SPH_C32(0xe4279a1c), SPH_C32(0xbdd2949c) },
  { SPH_C32(0xea0d0004), SPH_C32(0xe97e79c9), SPH_C32(0x7c158621),
    SPH_C32(0xcb7e53af), SPH_C32(0x09870006), SPH_C32(0xf67227d0),
    SPH_C32(0x7dc21fb6), SPH_C32(0x30a7636d) },
  { SPH_C32(0x622e0006), SPH_C32(0xb699de7a), SPH_C32(0xe5f0038b),
    SPH_C32(0x460ba45e), SPH_C32(0x582b0006), SPH_C32(0xd39128c4),
    SPH_C32(0x042035fa), SPH_C32(0x223fde2b) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0x208d000a), SPH_C32(0x7f9e9ece), SPH_C32(0x679616ab),
    SPH_C32(0x35dcdfc0), SPH_C32(0x46b00000), SPH_C32(0x978d3c50),
    SPH_C32(0xe788a932), SPH_C32(0x4a60f519) },
  { SPH_C32(0xf9020008), SPH_C32(0x059a3669), SPH_C32(0x8791b94d),
    SPH_C32(0xaa319577), SPH_C32(0xce930002), SPH_C32(0xc86a9be3),
    SPH_C32(0x7e6d2c98), SPH_C32(0xc71502e8) },
  { SPH_C32(0x7121000a), SPH_C32(0x5a7d91da), SPH_C32(0x1e743ce7),
    SPH_C32(0x27446286), SPH_C32(0x9f3f0002), SPH_C32(0xed8994f7),
    SPH_C32(0x078f06d4), SPH_C32(0xd58dbfae) },
  { SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a), SPH_C32(0x63b62351),
    SPH_C32(0x17e301eb), SPH_C32(0x7cb50000), SPH_C32(0xf285caee),
    SPH_C32(0x06589f43), SPH_C32(0x2e548f6c) },
  { SPH_C32(0xf085000e), SPH_C32(0xf3e811b9), SPH_C32(0xfa53a6fb),
    SPH_C32(0x9a96f61a), SPH_C32(0x2d190000), SPH_C32(0xd766c5fa),
    SPH_C32(0x7fbab50f), SPH_C32(0x3ccc322a) },
  { SPH_C32(0x290a000c), SPH_C32(0x89ecb91e), SPH_C32(0x1a54091d),
    SPH_C32(0x057bbcad), SPH_C32(0xa53a0002), SPH_C32(0x88816249),
    SPH_C32(0xe65f30a5), SPH_C32(0xb1b9c5db) },
  { SPH_C32(0xa129000e), SPH_C32(0xd60b1ead), SPH_C32(0x83b18cb7),
    SPH_C32(0x880e4b5c), SPH_C32(0xf4960002), SPH_C32(0xad626d5d),
    SPH_C32(0x9fbd1ae9), SPH_C32(0xa321789d) },
  { SPH_C32(0xc3070008), SPH_C32(0x6092c0d7), SPH_C32(0x66418f3c),
    SPH_C32(0xce05ef02), SPH_C32(0xacbd0004), SPH_C32(0x7ef34599),
    SPH_C32(0x9b9d2f13), SPH_C32(0x811ea6b6) },
  { SPH_C32(0x4b24000a), SPH_C32(0x3f756764), SPH_C32(0xffa40a96),
    SPH_C32(0x437018f3), SPH_C32(0xfd110004), SPH_C32(0x5b104a8d),
    SPH_C32(0xe27f055f), SPH_C32(0x93861bf0) },
  { SPH_C32(0x92ab0008), SPH_C32(0x4571cfc3), SPH_C32(0x1fa3a570),
    SPH_C32(0xdc9d5244), SPH_C32(0x75320006), SPH_C32(0x04f7ed3e),
    SPH_C32(0x7b9a80f5), SPH_C32(0x1ef3ec01) },
  { SPH_C32(0x1a88000a), SPH_C32(0x1a966870), SPH_C32(0x864620da),
    SPH_C32(0x51e8a5b5), SPH_C32(0x249e0006), SPH_C32(0x2114e22a),
    SPH_C32(0x0278aab9), SPH_C32(0x0c6b5147) },
  { SPH_C32(0x130f000c), SPH_C32(0xece44fa0), SPH_C32(0xfb843f6c),
    SPH_C32(0x614fc6d8), SPH_C32(0xc7140004), SPH_C32(0x3e18bc33),
    SPH_C32(0x03af332e), SPH_C32(0xf7b26185) },
  { SPH_C32(0x9b2c000e), SPH_C32(0xb303e813), SPH_C32(0x6261bac6),
    SPH_C32(0xec3a3129), SPH_C32(0x96b80004), SPH_C32(0x1bfbb327),
    SPH_C32(0x7a4d1962), SPH_C32(0xe52adcc3) },
  { SPH_C32(0x42a3000c), SPH_C32(0xc90740b4), SPH_C32(0x82661520),
    SPH_C32(0x73d77b9e), SPH_C32(0x1e9b0006), SPH_C32(0x441c1494),
    SPH_C32(0xe3a89cc8), SPH_C32(0x685f2b32) },
  { SPH_C32(0xca80000e), SPH_C32(0x96e0e707), SPH_C32(0x1b83908a),
    SPH_C32(0xfea28c6f), SPH_C32(0x4f370006), SPH_C32(0x61ff1b80),
    SPH_C32(0x9a4ab684), SPH_C32(0x7ac79674) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) },
  { SPH_C32(0x9f3f0002), SPH_C32(0xed8994f7), SPH_C32(0x078f06d4),
    SPH_C32(0xd58dbfae), SPH_C32(0xee1e0008), SPH_C32(0xb7f4052d),
    SPH_C32(0x19fb3a33), SPH_C32(0xf2c9dd28) },
  { SPH_C32(0x46b00000), SPH_C32(0x978d3c50), SPH_C32(0xe788a932),
    SPH_C32(0x4a60f519), SPH_C32(0x663d000a), SPH_C32(0xe813a29e),
    SPH_C32(0x801ebf99), SPH_C32(0x7fbc2ad9) },
  { SPH_C32(0xce930002), SPH_C32(0xc86a9be3), SPH_C32(0x7e6d2c98),
    SPH_C32(0xc71502e8), SPH_C32(0x3791000a), SPH_C32(0xcdf0ad8a),
    SPH_C32(0xf9fc95d5), SPH_C32(0x6d24979f) },
  { SPH_C32(0xc7140004), SPH_C32(0x3e18bc33), SPH_C32(0x03af332e),
    SPH_C32(0xf7b26185), SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393),
    SPH_C32(0xf82b0c42), SPH_C32(0x96fda75d) },
  { SPH_C32(0x4f370006), SPH_C32(0x61ff1b80), SPH_C32(0x9a4ab684),
    SPH_C32(0x7ac79674), SPH_C32(0x85b70008), SPH_C32(0xf71ffc87),
    SPH_C32(0x81c9260e), SPH_C32(0x84651a1b) },
  { SPH_C32(0x96b80004), SPH_C32(0x1bfbb327), SPH_C32(0x7a4d1962),
    SPH_C32(0xe52adcc3), SPH_C32(0x0d94000a), SPH_C32(0xa8f85b34),
    SPH_C32(0x182ca3a4), SPH_C32(0x0910edea) },
  { SPH_C32(0x1e9b0006), SPH_C32(0x441c1494), SPH_C32(0xe3a89cc8),
    SPH_C32(0x685f2b32), SPH_C32(0x5c38000a), SPH_C32(0x8d1b5420),
    SPH_C32(0x61ce89e8), SPH_C32(0x1b8850ac) },
  { SPH_C32(0x7cb50000), SPH_C32(0xf285caee), SPH_C32(0x06589f43),
    SPH_C32(0x2e548f6c), SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4),
    SPH_C32(0x65eebc12), SPH_C32(0x39b78e87) },
  { SPH_C32(0xf4960002), SPH_C32(0xad626d5d), SPH_C32(0x9fbd1ae9),
    SPH_C32(0xa321789d), SPH_C32(0x55bf000c), SPH_C32(0x7b6973f0),
    SPH_C32(0x1c0c965e), SPH_C32(0x2b2f33c1) },
  { SPH_C32(0x2d190000), SPH_C32(0xd766c5fa), SPH_C32(0x7fbab50f),
    SPH_C32(0x3ccc322a), SPH_C32(0xdd9c000e), SPH_C32(0x248ed443),
    SPH_C32(0x85e913f4), SPH_C32(0xa65ac430) },
  { SPH_C32(0xa53a0002), SPH_C32(0x88816249), SPH_C32(0xe65f30a5),
    SPH_C32(0xb1b9c5db), SPH_C32(0x8c30000e), SPH_C32(0x016ddb57),
    SPH_C32(0xfc0b39b8), SPH_C32(0xb4c27976) },
  { SPH_C32(0xacbd0004), SPH_C32(0x7ef34599), SPH_C32(0x9b9d2f13),
    SPH_C32(0x811ea6b6), SPH_C32(0x6fba000c), SPH_C32(0x1e61854e),
    SPH_C32(0xfddca02f), SPH_C32(0x4f1b49b4) },
  { SPH_C32(0x249e0006), SPH_C32(0x2114e22a), SPH_C32(0x0278aab9),
    SPH_C32(0x0c6b5147), SPH_C32(0x3e16000c), SPH_C32(0x3b828a5a),
    SPH_C32(0x843e8a63), SPH_C32(0x5d83f4f2) },
  { SPH_C32(0xfd110004), SPH_C32(0x5b104a8d), SPH_C32(0xe27f055f),
    SPH_C32(0x93861bf0), SPH_C32(0xb635000e), SPH_C32(0x64652de9),
    SPH_C32(0x1ddb0fc9), SPH_C32(0xd0f60303) },
  { SPH_C32(0x75320006), SPH_C32(0x04f7ed3e), SPH_C32(0x7b9a80f5),
    SPH_C32(0x1ef3ec01), SPH_C32(0xe799000e), SPH_C32(0x418622fd),
    SPH_C32(0x64392585), SPH_C32(0xc26ebe45) },
  { SPH_C32(0xbfb20008), SPH_C32(0x92170a39), SPH_C32(0x6019107f),
    SPH_C32(0xe051606e), SPH_C32(0xa8ae0008), SPH_C32(0x2079397d),
    SPH_C32(0xfe739301), SPH_C32(0xb8a92831) },
  { SPH_C32(0x3791000a), SPH_C32(0xcdf0ad8a), SPH_C32(0xf9fc95d5),
    SPH_C32(0x6d24979f), SPH_C32(0xf9020008), SPH_C32(0x059a3669),
    SPH_C32(0x8791b94d), SPH_C32(0xaa319577) },
  { SPH_C32(0xee1e0008), SPH_C32(0xb7f4052d), SPH_C32(0x19fb3a33),
    SPH_C32(0xf2c9dd28), SPH_C32(0x7121000a), SPH_C32(0x5a7d91da),
    SPH_C32(0x1e743ce7), SPH_C32(0x27446286) },
  { SPH_C32(0x663d000a), SPH_C32(0xe813a29e), SPH_C32(0x801ebf99),
    SPH_C32(0x7fbc2ad9), SPH_C32(0x208d000a), SPH_C32(0x7f9e9ece),
    SPH_C32(0x679616ab), SPH_C32(0x35dcdfc0) },
  { SPH_C32(0x6fba000c), SPH_C32(0x1e61854e), SPH_C32(0xfddca02f),
    SPH_C32(0x4f1b49b4), SPH_C32(0xc3070008), SPH_C32(0x6092c0d7),
    SPH_C32(0x66418f3c), SPH_C32(0xce05ef02) },
  { SPH_C32(0xe799000e), SPH_C32(0x418622fd), SPH_C32(0x64392585),
    SPH_C32(0xc26ebe45), SPH_C32(0x92ab0008), SPH_C32(0x4571cfc3),
    SPH_C32(0x1fa3a570), SPH_C32(0xdc9d5244) },
  { SPH_C32(0x3e16000c), SPH_C32(0x3b828a5a), SPH_C32(0x843e8a63),
    SPH_C32(0x5d83f4f2), SPH_C32(0x1a88000a), SPH_C32(0x1a966870),
    SPH_C32(0x864620da), SPH_C32(0x51e8a5b5) },
  { SPH_C32(0xb635000e), SPH_C32(0x64652de9), SPH_C32(0x1ddb0fc9),
    SPH_C32(0xd0f60303), SPH_C32(0x4b24000a), SPH_C32(0x3f756764),
    SPH_C32(0xffa40a96), SPH_C32(0x437018f3) },
  { SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393), SPH_C32(0xf82b0c42),
    SPH_C32(0x96fda75d), SPH_C32(0x130f000c), SPH_C32(0xece44fa0),
    SPH_C32(0xfb843f6c), SPH_C32(0x614fc6d8) },
  { SPH_C32(0x5c38000a), SPH_C32(0x8d1b5420), SPH_C32(0x61ce89e8),
    SPH_C32(0x1b8850ac), SPH_C32(0x42a3000c), SPH_C32(0xc90740b4),
    SPH_C32(0x82661520), SPH_C32(0x73d77b9e) },
  { SPH_C32(0x85b70008), SPH_C32(0xf71ffc87), SPH_C32(0x81c9260e),
    SPH_C32(0x84651a1b), SPH_C32(0xca80000e), SPH_C32(0x96e0e707),
    SPH_C32(0x1b83908a), SPH_C32(0xfea28c6f) },
  { SPH_C32(0x0d94000a), SPH_C32(0xa8f85b34), SPH_C32(0x182ca3a4),
    SPH_C32(0x0910edea), SPH_C32(0x9b2c000e), SPH_C32(0xb303e813),
    SPH_C32(0x6261bac6), SPH_C32(0xec3a3129) },
  { SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4), SPH_C32(0x65eebc12),
    SPH_C32(0x39b78e87), SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a),
    SPH_C32(0x63b62351), SPH_C32(0x17e301eb) },
  { SPH_C32(0x8c30000e), SPH_C32(0x016ddb57), SPH_C32(0xfc0b39b8),
    SPH_C32(0xb4c27976), SPH_C32(0x290a000c), SPH_C32(0x89ecb91e),
    SPH_C32(0x1a54091d), SPH_C32(0x057bbcad) },
  { SPH_C32(0x55bf000c), SPH_C32(0x7b6973f0), SPH_C32(0x1c0c965e),
    SPH_C32(0x2b2f33c1), SPH_C32(0xa129000e), SPH_C32(0xd60b1ead),
    SPH_C32(0x83b18cb7), SPH_C32(0x880e4b5c) },
  { SPH_C32(0xdd9c000e), SPH_C32(0x248ed443), SPH_C32(0x85e913f4),
    SPH_C32(0xa65ac430), SPH_C32(0xf085000e), SPH_C32(0xf3e811b9),
    SPH_C32(0xfa53a6fb), SPH_C32(0x9a96f61a) }
};

__constant static const sph_u32 T256_30[4][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x08bf0001), SPH_C32(0x38942792), SPH_C32(0xc5f8f3a1),
    SPH_C32(0xe6387b84), SPH_C32(0xc04e0001), SPH_C32(0x33b9c010),
    SPH_C32(0xae0ebb05), SPH_C32(0xb5a4c63b) }
};

#define INPUT_SMALL   do { \
    unsigned acc = buf[0]; \
    const sph_u32 *rp; \
    rp = &T256_0[acc >> 2][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    acc = (acc << 8) | buf[1]; \
    rp = &T256_6[(acc >> 4) & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = (acc << 8) | buf[2]; \
    rp = &T256_12[(acc >> 6) & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_18[acc & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[3]; \
    rp = &T256_24[acc >> 2][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_30[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_SMALL == 7

__constant static const sph_u32 T256_0[128][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x22832000), SPH_C32(0x2470bb95), SPH_C32(0xaa26ce50),
    SPH_C32(0xed3daa45), SPH_C32(0x286f1000), SPH_C32(0xea431fc4),
    SPH_C32(0x44980123), SPH_C32(0x6ffe7332) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0x5cfa0000), SPH_C32(0xb06859ba), SPH_C32(0xcc651c08),
    SPH_C32(0x7118f1a0), SPH_C32(0xc1453000), SPH_C32(0x5e149338),
    SPH_C32(0x55623b74), SPH_C32(0x52377616) },
  { SPH_C32(0x7e792000), SPH_C32(0x9418e22f), SPH_C32(0x6643d258),
    SPH_C32(0x9c255be5), SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc),
    SPH_C32(0x11fa3a57), SPH_C32(0x3dc90524) },
  { SPH_C32(0xb5d02000), SPH_C32(0x043fd546), SPH_C32(0xdd9f265f),
    SPH_C32(0x4cd1f484), SPH_C32(0x56163000), SPH_C32(0x7e5bfdeb),
    SPH_C32(0x22dbd37b), SPH_C32(0xf3db28d7) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0xd9b24000), SPH_C32(0xcb30ee81), SPH_C32(0x36263bac),
    SPH_C32(0x1ec26313), SPH_C32(0x596b1000), SPH_C32(0x81bf4b32),
    SPH_C32(0xb7a47196), SPH_C32(0xde532dcd) },
  { SPH_C32(0xfb316000), SPH_C32(0xef405514), SPH_C32(0x9c00f5fc),
    SPH_C32(0xf3ffc956), SPH_C32(0x71040000), SPH_C32(0x6bfc54f6),
    SPH_C32(0xf33c70b5), SPH_C32(0xb1ad5eff) },
  { SPH_C32(0x30986000), SPH_C32(0x7f67627d), SPH_C32(0x27dc01fb),
    SPH_C32(0x230b6637), SPH_C32(0xce381000), SPH_C32(0xa1f025e1),
    SPH_C32(0xc01d9999), SPH_C32(0x7fbf730c) },
  { SPH_C32(0x85484000), SPH_C32(0x7b58b73b), SPH_C32(0xfa4327a4),
    SPH_C32(0x6fda92b3), SPH_C32(0x982e2000), SPH_C32(0xdfabd80a),
    SPH_C32(0xe2c64ae2), SPH_C32(0x8c645bdb) },
  { SPH_C32(0x4ee14000), SPH_C32(0xeb7f8052), SPH_C32(0x419fd3a3),
    SPH_C32(0xbf2e3dd2), SPH_C32(0x27123000), SPH_C32(0x15a7a91d),
    SPH_C32(0xd1e7a3ce), SPH_C32(0x42767628) },
  { SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7), SPH_C32(0xebb91df3),
    SPH_C32(0x52139797), SPH_C32(0x0f7d2000), SPH_C32(0xffe4b6d9),
    SPH_C32(0x957fa2ed), SPH_C32(0x2d88051a) },
  { SPH_C32(0xa7cb6000), SPH_C32(0x5f280cae), SPH_C32(0x5065e9f4),
    SPH_C32(0x82e738f6), SPH_C32(0xb0413000), SPH_C32(0x35e8c7ce),
    SPH_C32(0xa65e4bc1), SPH_C32(0xe39a28e9) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0x2dfe0000), SPH_C32(0xdb940d4c), SPH_C32(0x3f596cbd),
    SPH_C32(0xc0b5af5f), SPH_C32(0x4b705000), SPH_C32(0xdaa892da),
    SPH_C32(0x3a5ebe3d), SPH_C32(0x1065e1bf) },
  { SPH_C32(0x0f7d2000), SPH_C32(0xffe4b6d9), SPH_C32(0x957fa2ed),
    SPH_C32(0x2d88051a), SPH_C32(0x631f4000), SPH_C32(0x30eb8d1e),
    SPH_C32(0x7ec6bf1e), SPH_C32(0x7f9b928d) },
  { SPH_C32(0xc4d42000), SPH_C32(0x6fc381b0), SPH_C32(0x2ea356ea),
    SPH_C32(0xfd7caa7b), SPH_C32(0xdc235000), SPH_C32(0xfae7fc09),
    SPH_C32(0x4de75632), SPH_C32(0xb189bf7e) },
  { SPH_C32(0x71040000), SPH_C32(0x6bfc54f6), SPH_C32(0xf33c70b5),
    SPH_C32(0xb1ad5eff), SPH_C32(0x8a356000), SPH_C32(0x84bc01e2),
    SPH_C32(0x6f3c8549), SPH_C32(0x425297a9) },
  { SPH_C32(0xbaad0000), SPH_C32(0xfbdb639f), SPH_C32(0x48e084b2),
    SPH_C32(0x6159f19e), SPH_C32(0x35097000), SPH_C32(0x4eb070f5),
    SPH_C32(0x5c1d6c65), SPH_C32(0x8c40ba5a) },
  { SPH_C32(0x982e2000), SPH_C32(0xdfabd80a), SPH_C32(0xe2c64ae2),
    SPH_C32(0x8c645bdb), SPH_C32(0x1d666000), SPH_C32(0xa4f36f31),
    SPH_C32(0x18856d46), SPH_C32(0xe3bec968) },
  { SPH_C32(0x53872000), SPH_C32(0x4f8cef63), SPH_C32(0x591abee5),
    SPH_C32(0x5c90f4ba), SPH_C32(0xa25a7000), SPH_C32(0x6eff1e26),
    SPH_C32(0x2ba4846a), SPH_C32(0x2dace49b) },
  { SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd), SPH_C32(0x097f5711),
    SPH_C32(0xde77cc4c), SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8),
    SPH_C32(0x8dfacfab), SPH_C32(0xce36cc72) },
  { SPH_C32(0x3fe54000), SPH_C32(0x8083d4a4), SPH_C32(0xb2a3a316),
    SPH_C32(0x0e83632d), SPH_C32(0xad275000), SPH_C32(0x911ba8ff),
    SPH_C32(0xbedb2687), SPH_C32(0x0024e181) },
  { SPH_C32(0x1d666000), SPH_C32(0xa4f36f31), SPH_C32(0x18856d46),
    SPH_C32(0xe3bec968), SPH_C32(0x85484000), SPH_C32(0x7b58b73b),
    SPH_C32(0xfa4327a4), SPH_C32(0x6fda92b3) },
  { SPH_C32(0xd6cf6000), SPH_C32(0x34d45858), SPH_C32(0xa3599941),
    SPH_C32(0x334a6609), SPH_C32(0x3a745000), SPH_C32(0xb154c62c),
    SPH_C32(0xc962ce88), SPH_C32(0xa1c8bf40) },
  { SPH_C32(0x631f4000), SPH_C32(0x30eb8d1e), SPH_C32(0x7ec6bf1e),
    SPH_C32(0x7f9b928d), SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7),
    SPH_C32(0xebb91df3), SPH_C32(0x52139797) },
  { SPH_C32(0xa8b64000), SPH_C32(0xa0ccba77), SPH_C32(0xc51a4b19),
    SPH_C32(0xaf6f3dec), SPH_C32(0xd35e7000), SPH_C32(0x05034ad0),
    SPH_C32(0xd898f4df), SPH_C32(0x9c01ba64) },
  { SPH_C32(0x8a356000), SPH_C32(0x84bc01e2), SPH_C32(0x6f3c8549),
    SPH_C32(0x425297a9), SPH_C32(0xfb316000), SPH_C32(0xef405514),
    SPH_C32(0x9c00f5fc), SPH_C32(0xf3ffc956) },
  { SPH_C32(0x419c6000), SPH_C32(0x149b368b), SPH_C32(0xd4e0714e),
    SPH_C32(0x92a638c8), SPH_C32(0x440d7000), SPH_C32(0x254c2403),
    SPH_C32(0xaf211cd0), SPH_C32(0x3dede4a5) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0x2fd18000), SPH_C32(0x15b144a8), SPH_C32(0x0e27d055),
    SPH_C32(0xf938f1be), SPH_C32(0xbb631000), SPH_C32(0x5646e2de),
    SPH_C32(0x51dd90fc), SPH_C32(0xbd0c9031) },
  { SPH_C32(0x0d52a000), SPH_C32(0x31c1ff3d), SPH_C32(0xa4011e05),
    SPH_C32(0x14055bfb), SPH_C32(0x930c0000), SPH_C32(0xbc05fd1a),
    SPH_C32(0x154591df), SPH_C32(0xd2f2e303) },
  { SPH_C32(0xc6fba000), SPH_C32(0xa1e6c854), SPH_C32(0x1fddea02),
    SPH_C32(0xc4f1f49a), SPH_C32(0x2c301000), SPH_C32(0x76098c0d),
    SPH_C32(0x266478f3), SPH_C32(0x1ce0cef0) },
  { SPH_C32(0x732b8000), SPH_C32(0xa5d91d12), SPH_C32(0xc242cc5d),
    SPH_C32(0x8820001e), SPH_C32(0x7a262000), SPH_C32(0x085271e6),
    SPH_C32(0x04bfab88), SPH_C32(0xef3be627) },
  { SPH_C32(0xb8828000), SPH_C32(0x35fe2a7b), SPH_C32(0x799e385a),
    SPH_C32(0x58d4af7f), SPH_C32(0xc51a3000), SPH_C32(0xc25e00f1),
    SPH_C32(0x379e42a4), SPH_C32(0x2129cbd4) },
  { SPH_C32(0x9a01a000), SPH_C32(0x118e91ee), SPH_C32(0xd3b8f60a),
    SPH_C32(0xb5e9053a), SPH_C32(0xed752000), SPH_C32(0x281d1f35),
    SPH_C32(0x73064387), SPH_C32(0x4ed7b8e6) },
  { SPH_C32(0x51a8a000), SPH_C32(0x81a9a687), SPH_C32(0x6864020d),
    SPH_C32(0x651daa5b), SPH_C32(0x52493000), SPH_C32(0xe2116e22),
    SPH_C32(0x4027aaab), SPH_C32(0x80c59515) },
  { SPH_C32(0xf663c000), SPH_C32(0xde81aa29), SPH_C32(0x3801ebf9),
    SPH_C32(0xe7fa92ad), SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec),
    SPH_C32(0xe679e16a), SPH_C32(0x635fbdfc) },
  { SPH_C32(0x3dcac000), SPH_C32(0x4ea69d40), SPH_C32(0x83dd1ffe),
    SPH_C32(0x370e3dcc), SPH_C32(0x5d341000), SPH_C32(0x1df5d8fb),
    SPH_C32(0xd5580846), SPH_C32(0xad4d900f) },
  { SPH_C32(0x1f49e000), SPH_C32(0x6ad626d5), SPH_C32(0x29fbd1ae),
    SPH_C32(0xda339789), SPH_C32(0x755b0000), SPH_C32(0xf7b6c73f),
    SPH_C32(0x91c00965), SPH_C32(0xc2b3e33d) },
  { SPH_C32(0xd4e0e000), SPH_C32(0xfaf111bc), SPH_C32(0x922725a9),
    SPH_C32(0x0ac738e8), SPH_C32(0xca671000), SPH_C32(0x3dbab628),
    SPH_C32(0xa2e1e049), SPH_C32(0x0ca1cece) },
  { SPH_C32(0x6130c000), SPH_C32(0xfecec4fa), SPH_C32(0x4fb803f6),
    SPH_C32(0x4616cc6c), SPH_C32(0x9c712000), SPH_C32(0x43e14bc3),
    SPH_C32(0x803a3332), SPH_C32(0xff7ae619) },
  { SPH_C32(0xaa99c000), SPH_C32(0x6ee9f393), SPH_C32(0xf464f7f1),
    SPH_C32(0x96e2630d), SPH_C32(0x234d3000), SPH_C32(0x89ed3ad4),
    SPH_C32(0xb31bda1e), SPH_C32(0x3168cbea) },
  { SPH_C32(0x881ae000), SPH_C32(0x4a994806), SPH_C32(0x5e4239a1),
    SPH_C32(0x7bdfc948), SPH_C32(0x0b222000), SPH_C32(0x63ae2510),
    SPH_C32(0xf783db3d), SPH_C32(0x5e96b8d8) },
  { SPH_C32(0x43b3e000), SPH_C32(0xdabe7f6f), SPH_C32(0xe59ecda6),
    SPH_C32(0xab2b6629), SPH_C32(0xb41e3000), SPH_C32(0xa9a25407),
    SPH_C32(0xc4a23211), SPH_C32(0x9084952b) },
  { SPH_C32(0x022f8000), SPH_C32(0xce2549e4), SPH_C32(0x317ebce8),
    SPH_C32(0x398d5ee1), SPH_C32(0xf0134000), SPH_C32(0x8cee7004),
    SPH_C32(0x6b832ec1), SPH_C32(0xad69718e) },
  { SPH_C32(0xc9868000), SPH_C32(0x5e027e8d), SPH_C32(0x8aa248ef),
    SPH_C32(0xe979f180), SPH_C32(0x4f2f5000), SPH_C32(0x46e20113),
    SPH_C32(0x58a2c7ed), SPH_C32(0x637b5c7d) },
  { SPH_C32(0xeb05a000), SPH_C32(0x7a72c518), SPH_C32(0x208486bf),
    SPH_C32(0x04445bc5), SPH_C32(0x67404000), SPH_C32(0xaca11ed7),
    SPH_C32(0x1c3ac6ce), SPH_C32(0x0c852f4f) },
  { SPH_C32(0x20aca000), SPH_C32(0xea55f271), SPH_C32(0x9b5872b8),
    SPH_C32(0xd4b0f4a4), SPH_C32(0xd87c5000), SPH_C32(0x66ad6fc0),
    SPH_C32(0x2f1b2fe2), SPH_C32(0xc29702bc) },
  { SPH_C32(0x957c8000), SPH_C32(0xee6a2737), SPH_C32(0x46c754e7),
    SPH_C32(0x98610020), SPH_C32(0x8e6a6000), SPH_C32(0x18f6922b),
    SPH_C32(0x0dc0fc99), SPH_C32(0x314c2a6b) },
  { SPH_C32(0x5ed58000), SPH_C32(0x7e4d105e), SPH_C32(0xfd1ba0e0),
    SPH_C32(0x4895af41), SPH_C32(0x31567000), SPH_C32(0xd2fae33c),
    SPH_C32(0x3ee115b5), SPH_C32(0xff5e0798) },
  { SPH_C32(0x7c56a000), SPH_C32(0x5a3dabcb), SPH_C32(0x573d6eb0),
    SPH_C32(0xa5a80504), SPH_C32(0x19396000), SPH_C32(0x38b9fcf8),
    SPH_C32(0x7a791496), SPH_C32(0x90a074aa) },
  { SPH_C32(0xb7ffa000), SPH_C32(0xca1a9ca2), SPH_C32(0xece19ab7),
    SPH_C32(0x755caa65), SPH_C32(0xa6057000), SPH_C32(0xf2b58def),
    SPH_C32(0x4958fdba), SPH_C32(0x5eb25959) },
  { SPH_C32(0x1034c000), SPH_C32(0x9532900c), SPH_C32(0xbc847343),
    SPH_C32(0xf7bb9293), SPH_C32(0x16444000), SPH_C32(0xc75d4a21),
    SPH_C32(0xef06b67b), SPH_C32(0xbd2871b0) },
  { SPH_C32(0xdb9dc000), SPH_C32(0x0515a765), SPH_C32(0x07588744),
    SPH_C32(0x274f3df2), SPH_C32(0xa9785000), SPH_C32(0x0d513b36),
    SPH_C32(0xdc275f57), SPH_C32(0x733a5c43) },
  { SPH_C32(0xf91ee000), SPH_C32(0x21651cf0), SPH_C32(0xad7e4914),
    SPH_C32(0xca7297b7), SPH_C32(0x81174000), SPH_C32(0xe71224f2),
    SPH_C32(0x98bf5e74), SPH_C32(0x1cc42f71) },
  { SPH_C32(0x32b7e000), SPH_C32(0xb1422b99), SPH_C32(0x16a2bd13),
    SPH_C32(0x1a8638d6), SPH_C32(0x3e2b5000), SPH_C32(0x2d1e55e5),
    SPH_C32(0xab9eb758), SPH_C32(0xd2d60282) },
  { SPH_C32(0x8767c000), SPH_C32(0xb57dfedf), SPH_C32(0xcb3d9b4c),
    SPH_C32(0x5657cc52), SPH_C32(0x683d6000), SPH_C32(0x5345a80e),
    SPH_C32(0x89456423), SPH_C32(0x210d2a55) },
  { SPH_C32(0x4ccec000), SPH_C32(0x255ac9b6), SPH_C32(0x70e16f4b),
    SPH_C32(0x86a36333), SPH_C32(0xd7017000), SPH_C32(0x9949d919),
    SPH_C32(0xba648d0f), SPH_C32(0xef1f07a6) },
  { SPH_C32(0x6e4de000), SPH_C32(0x012a7223), SPH_C32(0xdac7a11b),
    SPH_C32(0x6b9ec976), SPH_C32(0xff6e6000), SPH_C32(0x730ac6dd),
    SPH_C32(0xfefc8c2c), SPH_C32(0x80e17494) },
  { SPH_C32(0xa5e4e000), SPH_C32(0x910d454a), SPH_C32(0x611b551c),
    SPH_C32(0xbb6a6617), SPH_C32(0x40527000), SPH_C32(0xb906b7ca),
    SPH_C32(0xcddd6500), SPH_C32(0x4ef35967) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0xcff60000), SPH_C32(0x0c6da4a0), SPH_C32(0xd9208dd7),
    SPH_C32(0xa3ea12a3), SPH_C32(0x5f1b9000), SPH_C32(0xd3d0911f),
    SPH_C32(0xe426b4ae), SPH_C32(0x94c0ceee) },
  { SPH_C32(0xed752000), SPH_C32(0x281d1f35), SPH_C32(0x73064387),
    SPH_C32(0x4ed7b8e6), SPH_C32(0x77748000), SPH_C32(0x39938edb),
    SPH_C32(0xa0beb58d), SPH_C32(0xfb3ebddc) },
  { SPH_C32(0x26dc2000), SPH_C32(0xb83a285c), SPH_C32(0xc8dab780),
    SPH_C32(0x9e231787), SPH_C32(0xc8489000), SPH_C32(0xf39fffcc),
    SPH_C32(0x939f5ca1), SPH_C32(0x352c902f) },
  { SPH_C32(0x930c0000), SPH_C32(0xbc05fd1a), SPH_C32(0x154591df),
    SPH_C32(0xd2f2e303), SPH_C32(0x9e5ea000), SPH_C32(0x8dc40227),
    SPH_C32(0xb1448fda), SPH_C32(0xc6f7b8f8) },
  { SPH_C32(0x58a50000), SPH_C32(0x2c22ca73), SPH_C32(0xae9965d8),
    SPH_C32(0x02064c62), SPH_C32(0x2162b000), SPH_C32(0x47c87330),
    SPH_C32(0x826566f6), SPH_C32(0x08e5950b) },
  { SPH_C32(0x7a262000), SPH_C32(0x085271e6), SPH_C32(0x04bfab88),
    SPH_C32(0xef3be627), SPH_C32(0x090da000), SPH_C32(0xad8b6cf4),
    SPH_C32(0xc6fd67d5), SPH_C32(0x671be639) },
  { SPH_C32(0xb18f2000), SPH_C32(0x9875468f), SPH_C32(0xbf635f8f),
    SPH_C32(0x3fcf4946), SPH_C32(0xb631b000), SPH_C32(0x67871de3),
    SPH_C32(0xf5dc8ef9), SPH_C32(0xa909cbca) },
  { SPH_C32(0x16444000), SPH_C32(0xc75d4a21), SPH_C32(0xef06b67b),
    SPH_C32(0xbd2871b0), SPH_C32(0x06708000), SPH_C32(0x526fda2d),
    SPH_C32(0x5382c538), SPH_C32(0x4a93e323) },
  { SPH_C32(0xdded4000), SPH_C32(0x577a7d48), SPH_C32(0x54da427c),
    SPH_C32(0x6ddcded1), SPH_C32(0xb94c9000), SPH_C32(0x9863ab3a),
    SPH_C32(0x60a32c14), SPH_C32(0x8481ced0) },
  { SPH_C32(0xff6e6000), SPH_C32(0x730ac6dd), SPH_C32(0xfefc8c2c),
    SPH_C32(0x80e17494), SPH_C32(0x91238000), SPH_C32(0x7220b4fe),
    SPH_C32(0x243b2d37), SPH_C32(0xeb7fbde2) },
  { SPH_C32(0x34c76000), SPH_C32(0xe32df1b4), SPH_C32(0x4520782b),
    SPH_C32(0x5015dbf5), SPH_C32(0x2e1f9000), SPH_C32(0xb82cc5e9),
    SPH_C32(0x171ac41b), SPH_C32(0x256d9011) },
  { SPH_C32(0x81174000), SPH_C32(0xe71224f2), SPH_C32(0x98bf5e74),
    SPH_C32(0x1cc42f71), SPH_C32(0x7809a000), SPH_C32(0xc6773802),
    SPH_C32(0x35c11760), SPH_C32(0xd6b6b8c6) },
  { SPH_C32(0x4abe4000), SPH_C32(0x7735139b), SPH_C32(0x2363aa73),
    SPH_C32(0xcc308010), SPH_C32(0xc735b000), SPH_C32(0x0c7b4915),
    SPH_C32(0x06e0fe4c), SPH_C32(0x18a49535) },
  { SPH_C32(0x683d6000), SPH_C32(0x5345a80e), SPH_C32(0x89456423),
    SPH_C32(0x210d2a55), SPH_C32(0xef5aa000), SPH_C32(0xe63856d1),
    SPH_C32(0x4278ff6f), SPH_C32(0x775ae607) },
  { SPH_C32(0xa3946000), SPH_C32(0xc3629f67), SPH_C32(0x32999024),
    SPH_C32(0xf1f98534), SPH_C32(0x5066b000), SPH_C32(0x2c3427c6),
    SPH_C32(0x71591643), SPH_C32(0xb948cbf4) },
  { SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec), SPH_C32(0xe679e16a),
    SPH_C32(0x635fbdfc), SPH_C32(0x146bc000), SPH_C32(0x097803c5),
    SPH_C32(0xde780a93), SPH_C32(0x84a52f51) },
  { SPH_C32(0x29a10000), SPH_C32(0x47de9e85), SPH_C32(0x5da5156d),
    SPH_C32(0xb3ab129d), SPH_C32(0xab57d000), SPH_C32(0xc37472d2),
    SPH_C32(0xed59e3bf), SPH_C32(0x4ab702a2) },
  { SPH_C32(0x0b222000), SPH_C32(0x63ae2510), SPH_C32(0xf783db3d),
    SPH_C32(0x5e96b8d8), SPH_C32(0x8338c000), SPH_C32(0x29376d16),
    SPH_C32(0xa9c1e29c), SPH_C32(0x25497190) },
  { SPH_C32(0xc08b2000), SPH_C32(0xf3891279), SPH_C32(0x4c5f2f3a),
    SPH_C32(0x8e6217b9), SPH_C32(0x3c04d000), SPH_C32(0xe33b1c01),
    SPH_C32(0x9ae00bb0), SPH_C32(0xeb5b5c63) },
  { SPH_C32(0x755b0000), SPH_C32(0xf7b6c73f), SPH_C32(0x91c00965),
    SPH_C32(0xc2b3e33d), SPH_C32(0x6a12e000), SPH_C32(0x9d60e1ea),
    SPH_C32(0xb83bd8cb), SPH_C32(0x188074b4) },
  { SPH_C32(0xbef20000), SPH_C32(0x6791f056), SPH_C32(0x2a1cfd62),
    SPH_C32(0x12474c5c), SPH_C32(0xd52ef000), SPH_C32(0x576c90fd),
    SPH_C32(0x8b1a31e7), SPH_C32(0xd6925947) },
  { SPH_C32(0x9c712000), SPH_C32(0x43e14bc3), SPH_C32(0x803a3332),
    SPH_C32(0xff7ae619), SPH_C32(0xfd41e000), SPH_C32(0xbd2f8f39),
    SPH_C32(0xcf8230c4), SPH_C32(0xb96c2a75) },
  { SPH_C32(0x57d82000), SPH_C32(0xd3c67caa), SPH_C32(0x3be6c735),
    SPH_C32(0x2f8e4978), SPH_C32(0x427df000), SPH_C32(0x7723fe2e),
    SPH_C32(0xfca3d9e8), SPH_C32(0x777e0786) },
  { SPH_C32(0xf0134000), SPH_C32(0x8cee7004), SPH_C32(0x6b832ec1),
    SPH_C32(0xad69718e), SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0),
    SPH_C32(0x5afd9229), SPH_C32(0x94e42f6f) },
  { SPH_C32(0x3bba4000), SPH_C32(0x1cc9476d), SPH_C32(0xd05fdac6),
    SPH_C32(0x7d9ddeef), SPH_C32(0x4d00d000), SPH_C32(0x88c748f7),
    SPH_C32(0x69dc7b05), SPH_C32(0x5af6029c) },
  { SPH_C32(0x19396000), SPH_C32(0x38b9fcf8), SPH_C32(0x7a791496),
    SPH_C32(0x90a074aa), SPH_C32(0x656fc000), SPH_C32(0x62845733),
    SPH_C32(0x2d447a26), SPH_C32(0x350871ae) },
  { SPH_C32(0xd2906000), SPH_C32(0xa89ecb91), SPH_C32(0xc1a5e091),
    SPH_C32(0x4054dbcb), SPH_C32(0xda53d000), SPH_C32(0xa8882624),
    SPH_C32(0x1e65930a), SPH_C32(0xfb1a5c5d) },
  { SPH_C32(0x67404000), SPH_C32(0xaca11ed7), SPH_C32(0x1c3ac6ce),
    SPH_C32(0x0c852f4f), SPH_C32(0x8c45e000), SPH_C32(0xd6d3dbcf),
    SPH_C32(0x3cbe4071), SPH_C32(0x08c1748a) },
  { SPH_C32(0xace94000), SPH_C32(0x3c8629be), SPH_C32(0xa7e632c9),
    SPH_C32(0xdc71802e), SPH_C32(0x3379f000), SPH_C32(0x1cdfaad8),
    SPH_C32(0x0f9fa95d), SPH_C32(0xc6d35979) },
  { SPH_C32(0x8e6a6000), SPH_C32(0x18f6922b), SPH_C32(0x0dc0fc99),
    SPH_C32(0x314c2a6b), SPH_C32(0x1b16e000), SPH_C32(0xf69cb51c),
    SPH_C32(0x4b07a87e), SPH_C32(0xa92d2a4b) },
  { SPH_C32(0x45c36000), SPH_C32(0x88d1a542), SPH_C32(0xb61c089e),
    SPH_C32(0xe1b8850a), SPH_C32(0xa42af000), SPH_C32(0x3c90c40b),
    SPH_C32(0x78264152), SPH_C32(0x673f07b8) },
  { SPH_C32(0xe0278000), SPH_C32(0x19dce008), SPH_C32(0xd7075d82),
    SPH_C32(0x5ad2e31d), SPH_C32(0xe4788000), SPH_C32(0x859673c1),
    SPH_C32(0xb5fb2452), SPH_C32(0x29cc5edf) },
  { SPH_C32(0x2b8e8000), SPH_C32(0x89fbd761), SPH_C32(0x6cdba985),
    SPH_C32(0x8a264c7c), SPH_C32(0x5b449000), SPH_C32(0x4f9a02d6),
    SPH_C32(0x86dacd7e), SPH_C32(0xe7de732c) },
  { SPH_C32(0x090da000), SPH_C32(0xad8b6cf4), SPH_C32(0xc6fd67d5),
    SPH_C32(0x671be639), SPH_C32(0x732b8000), SPH_C32(0xa5d91d12),
    SPH_C32(0xc242cc5d), SPH_C32(0x8820001e) },
  { SPH_C32(0xc2a4a000), SPH_C32(0x3dac5b9d), SPH_C32(0x7d2193d2),
    SPH_C32(0xb7ef4958), SPH_C32(0xcc179000), SPH_C32(0x6fd56c05),
    SPH_C32(0xf1632571), SPH_C32(0x46322ded) },
  { SPH_C32(0x77748000), SPH_C32(0x39938edb), SPH_C32(0xa0beb58d),
    SPH_C32(0xfb3ebddc), SPH_C32(0x9a01a000), SPH_C32(0x118e91ee),
    SPH_C32(0xd3b8f60a), SPH_C32(0xb5e9053a) },
  { SPH_C32(0xbcdd8000), SPH_C32(0xa9b4b9b2), SPH_C32(0x1b62418a),
    SPH_C32(0x2bca12bd), SPH_C32(0x253db000), SPH_C32(0xdb82e0f9),
    SPH_C32(0xe0991f26), SPH_C32(0x7bfb28c9) },
  { SPH_C32(0x9e5ea000), SPH_C32(0x8dc40227), SPH_C32(0xb1448fda),
    SPH_C32(0xc6f7b8f8), SPH_C32(0x0d52a000), SPH_C32(0x31c1ff3d),
    SPH_C32(0xa4011e05), SPH_C32(0x14055bfb) },
  { SPH_C32(0x55f7a000), SPH_C32(0x1de3354e), SPH_C32(0x0a987bdd),
    SPH_C32(0x16031799), SPH_C32(0xb26eb000), SPH_C32(0xfbcd8e2a),
    SPH_C32(0x9720f729), SPH_C32(0xda177608) },
  { SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0), SPH_C32(0x5afd9229),
    SPH_C32(0x94e42f6f), SPH_C32(0x022f8000), SPH_C32(0xce2549e4),
    SPH_C32(0x317ebce8), SPH_C32(0x398d5ee1) },
  { SPH_C32(0x3995c000), SPH_C32(0xd2ec0e89), SPH_C32(0xe121662e),
    SPH_C32(0x4410800e), SPH_C32(0xbd139000), SPH_C32(0x042938f3),
    SPH_C32(0x025f55c4), SPH_C32(0xf79f7312) },
  { SPH_C32(0x1b16e000), SPH_C32(0xf69cb51c), SPH_C32(0x4b07a87e),
    SPH_C32(0xa92d2a4b), SPH_C32(0x957c8000), SPH_C32(0xee6a2737),
    SPH_C32(0x46c754e7), SPH_C32(0x98610020) },
  { SPH_C32(0xd0bfe000), SPH_C32(0x66bb8275), SPH_C32(0xf0db5c79),
    SPH_C32(0x79d9852a), SPH_C32(0x2a409000), SPH_C32(0x24665620),
    SPH_C32(0x75e6bdcb), SPH_C32(0x56732dd3) },
  { SPH_C32(0x656fc000), SPH_C32(0x62845733), SPH_C32(0x2d447a26),
    SPH_C32(0x350871ae), SPH_C32(0x7c56a000), SPH_C32(0x5a3dabcb),
    SPH_C32(0x573d6eb0), SPH_C32(0xa5a80504) },
  { SPH_C32(0xaec6c000), SPH_C32(0xf2a3605a), SPH_C32(0x96988e21),
    SPH_C32(0xe5fcdecf), SPH_C32(0xc36ab000), SPH_C32(0x9031dadc),
    SPH_C32(0x641c879c), SPH_C32(0x6bba28f7) },
  { SPH_C32(0x8c45e000), SPH_C32(0xd6d3dbcf), SPH_C32(0x3cbe4071),
    SPH_C32(0x08c1748a), SPH_C32(0xeb05a000), SPH_C32(0x7a72c518),
    SPH_C32(0x208486bf), SPH_C32(0x04445bc5) },
  { SPH_C32(0x47ece000), SPH_C32(0x46f4eca6), SPH_C32(0x8762b476),
    SPH_C32(0xd835dbeb), SPH_C32(0x5439b000), SPH_C32(0xb07eb40f),
    SPH_C32(0x13a56f93), SPH_C32(0xca567636) },
  { SPH_C32(0x06708000), SPH_C32(0x526fda2d), SPH_C32(0x5382c538),
    SPH_C32(0x4a93e323), SPH_C32(0x1034c000), SPH_C32(0x9532900c),
    SPH_C32(0xbc847343), SPH_C32(0xf7bb9293) },
  { SPH_C32(0xcdd98000), SPH_C32(0xc248ed44), SPH_C32(0xe85e313f),
    SPH_C32(0x9a674c42), SPH_C32(0xaf08d000), SPH_C32(0x5f3ee11b),
    SPH_C32(0x8fa59a6f), SPH_C32(0x39a9bf60) },
  { SPH_C32(0xef5aa000), SPH_C32(0xe63856d1), SPH_C32(0x4278ff6f),
    SPH_C32(0x775ae607), SPH_C32(0x8767c000), SPH_C32(0xb57dfedf),
    SPH_C32(0xcb3d9b4c), SPH_C32(0x5657cc52) },
  { SPH_C32(0x24f3a000), SPH_C32(0x761f61b8), SPH_C32(0xf9a40b68),
    SPH_C32(0xa7ae4966), SPH_C32(0x385bd000), SPH_C32(0x7f718fc8),
    SPH_C32(0xf81c7260), SPH_C32(0x9845e1a1) },
  { SPH_C32(0x91238000), SPH_C32(0x7220b4fe), SPH_C32(0x243b2d37),
    SPH_C32(0xeb7fbde2), SPH_C32(0x6e4de000), SPH_C32(0x012a7223),
    SPH_C32(0xdac7a11b), SPH_C32(0x6b9ec976) },
  { SPH_C32(0x5a8a8000), SPH_C32(0xe2078397), SPH_C32(0x9fe7d930),
    SPH_C32(0x3b8b1283), SPH_C32(0xd171f000), SPH_C32(0xcb260334),
    SPH_C32(0xe9e64837), SPH_C32(0xa58ce485) },
  { SPH_C32(0x7809a000), SPH_C32(0xc6773802), SPH_C32(0x35c11760),
    SPH_C32(0xd6b6b8c6), SPH_C32(0xf91ee000), SPH_C32(0x21651cf0),
    SPH_C32(0xad7e4914), SPH_C32(0xca7297b7) },
  { SPH_C32(0xb3a0a000), SPH_C32(0x56500f6b), SPH_C32(0x8e1de367),
    SPH_C32(0x064217a7), SPH_C32(0x4622f000), SPH_C32(0xeb696de7),
    SPH_C32(0x9e5fa038), SPH_C32(0x0460ba44) },
  { SPH_C32(0x146bc000), SPH_C32(0x097803c5), SPH_C32(0xde780a93),
    SPH_C32(0x84a52f51), SPH_C32(0xf663c000), SPH_C32(0xde81aa29),
    SPH_C32(0x3801ebf9), SPH_C32(0xe7fa92ad) },
  { SPH_C32(0xdfc2c000), SPH_C32(0x995f34ac), SPH_C32(0x65a4fe94),
    SPH_C32(0x54518030), SPH_C32(0x495fd000), SPH_C32(0x148ddb3e),
    SPH_C32(0x0b2002d5), SPH_C32(0x29e8bf5e) },
  { SPH_C32(0xfd41e000), SPH_C32(0xbd2f8f39), SPH_C32(0xcf8230c4),
    SPH_C32(0xb96c2a75), SPH_C32(0x6130c000), SPH_C32(0xfecec4fa),
    SPH_C32(0x4fb803f6), SPH_C32(0x4616cc6c) },
  { SPH_C32(0x36e8e000), SPH_C32(0x2d08b850), SPH_C32(0x745ec4c3),
    SPH_C32(0x69988514), SPH_C32(0xde0cd000), SPH_C32(0x34c2b5ed),
    SPH_C32(0x7c99eada), SPH_C32(0x8804e19f) },
  { SPH_C32(0x8338c000), SPH_C32(0x29376d16), SPH_C32(0xa9c1e29c),
    SPH_C32(0x25497190), SPH_C32(0x881ae000), SPH_C32(0x4a994806),
    SPH_C32(0x5e4239a1), SPH_C32(0x7bdfc948) },
  { SPH_C32(0x4891c000), SPH_C32(0xb9105a7f), SPH_C32(0x121d169b),
    SPH_C32(0xf5bddef1), SPH_C32(0x3726f000), SPH_C32(0x80953911),
    SPH_C32(0x6d63d08d), SPH_C32(0xb5cde4bb) },
  { SPH_C32(0x6a12e000), SPH_C32(0x9d60e1ea), SPH_C32(0xb83bd8cb),
    SPH_C32(0x188074b4), SPH_C32(0x1f49e000), SPH_C32(0x6ad626d5),
    SPH_C32(0x29fbd1ae), SPH_C32(0xda339789) },
  { SPH_C32(0xa1bbe000), SPH_C32(0x0d47d683), SPH_C32(0x03e72ccc),
    SPH_C32(0xc874dbd5), SPH_C32(0xa075f000), SPH_C32(0xa0da57c2),
    SPH_C32(0x1ada3882), SPH_C32(0x1421ba7a) }
};

__constant static const sph_u32 T256_7[128][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d), SPH_C32(0xe0272f7d),
    SPH_C32(0xa5e7de5a), SPH_C32(0xa7b80200), SPH_C32(0x1f128433),
    SPH_C32(0x60e5f9f2), SPH_C32(0x9e147576) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0x28860600), SPH_C32(0x128f4c44), SPH_C32(0x0f20b113),
    SPH_C32(0x179959a0), SPH_C32(0xfa9b0000), SPH_C32(0x3df15fc1),
    SPH_C32(0xeab03334), SPH_C32(0x1f8c40ca) },
  { SPH_C32(0x61180400), SPH_C32(0x1fd6a049), SPH_C32(0xef079e6e),
    SPH_C32(0xb27e87fa), SPH_C32(0x5d230200), SPH_C32(0x22e3dbf2),
    SPH_C32(0x8a55cac6), SPH_C32(0x819835bc) },
  { SPH_C32(0xc6a00600), SPH_C32(0x00c4247a), SPH_C32(0x8fe2679c),
    SPH_C32(0x2c6af28c), SPH_C32(0xb3050200), SPH_C32(0x30a8b3cc),
    SPH_C32(0x0a971c49), SPH_C32(0xba6b9e90) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0xb3050200), SPH_C32(0x30a8b3cc), SPH_C32(0x0a971c49),
    SPH_C32(0xba6b9e90), SPH_C32(0x75a50400), SPH_C32(0x306c97b6),
    SPH_C32(0x85757bd5), SPH_C32(0x96016c1c) },
  { SPH_C32(0xfa9b0000), SPH_C32(0x3df15fc1), SPH_C32(0xeab03334),
    SPH_C32(0x1f8c40ca), SPH_C32(0xd21d0600), SPH_C32(0x2f7e1385),
    SPH_C32(0xe5908227), SPH_C32(0x0815196a) },
  { SPH_C32(0x5d230200), SPH_C32(0x22e3dbf2), SPH_C32(0x8a55cac6),
    SPH_C32(0x819835bc), SPH_C32(0x3c3b0600), SPH_C32(0x3d357bbb),
    SPH_C32(0x655254a8), SPH_C32(0x33e6b246) },
  { SPH_C32(0x9b830400), SPH_C32(0x2227ff88), SPH_C32(0x05b7ad5a),
    SPH_C32(0xadf2c730), SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877),
    SPH_C32(0x6fc548e1), SPH_C32(0x898d2cd6) },
  { SPH_C32(0x3c3b0600), SPH_C32(0x3d357bbb), SPH_C32(0x655254a8),
    SPH_C32(0x33e6b246), SPH_C32(0x61180400), SPH_C32(0x1fd6a049),
    SPH_C32(0xef079e6e), SPH_C32(0xb27e87fa) },
  { SPH_C32(0x75a50400), SPH_C32(0x306c97b6), SPH_C32(0x85757bd5),
    SPH_C32(0x96016c1c), SPH_C32(0xc6a00600), SPH_C32(0x00c4247a),
    SPH_C32(0x8fe2679c), SPH_C32(0x2c6af28c) },
  { SPH_C32(0xd21d0600), SPH_C32(0x2f7e1385), SPH_C32(0xe5908227),
    SPH_C32(0x0815196a), SPH_C32(0x28860600), SPH_C32(0x128f4c44),
    SPH_C32(0x0f20b113), SPH_C32(0x179959a0) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0x798a0a00), SPH_C32(0x3791d4cd), SPH_C32(0x1160d335),
    SPH_C32(0x38abeae0), SPH_C32(0x0fad0000), SPH_C32(0x4612e043),
    SPH_C32(0x3fd0555c), SPH_C32(0x2095c15f) },
  { SPH_C32(0x30140800), SPH_C32(0x3ac838c0), SPH_C32(0xf147fc48),
    SPH_C32(0x9d4c34ba), SPH_C32(0xa8150200), SPH_C32(0x59006470),
    SPH_C32(0x5f35acae), SPH_C32(0xbe81b429) },
  { SPH_C32(0x97ac0a00), SPH_C32(0x25dabcf3), SPH_C32(0x91a205ba),
    SPH_C32(0x035841cc), SPH_C32(0x46330200), SPH_C32(0x4b4b0c4e),
    SPH_C32(0xdff77a21), SPH_C32(0x85721f05) },
  { SPH_C32(0x510c0c00), SPH_C32(0x251e9889), SPH_C32(0x1e406226),
    SPH_C32(0x2f32b340), SPH_C32(0xf5360000), SPH_C32(0x7be3bf82),
    SPH_C32(0xd5606668), SPH_C32(0x3f198195) },
  { SPH_C32(0xf6b40e00), SPH_C32(0x3a0c1cba), SPH_C32(0x7ea59bd4),
    SPH_C32(0xb126c636), SPH_C32(0x1b100000), SPH_C32(0x69a8d7bc),
    SPH_C32(0x55a2b0e7), SPH_C32(0x04ea2ab9) },
  { SPH_C32(0xbf2a0c00), SPH_C32(0x3755f0b7), SPH_C32(0x9e82b4a9),
    SPH_C32(0x14c1186c), SPH_C32(0xbca80200), SPH_C32(0x76ba538f),
    SPH_C32(0x35474915), SPH_C32(0x9afe5fcf) },
  { SPH_C32(0x18920e00), SPH_C32(0x28477484), SPH_C32(0xfe674d5b),
    SPH_C32(0x8ad56d1a), SPH_C32(0x528e0200), SPH_C32(0x64f13bb1),
    SPH_C32(0xb5859f9a), SPH_C32(0xa10df4e3) },
  { SPH_C32(0xca8f0800), SPH_C32(0x07396701), SPH_C32(0x1bf7cf7c),
    SPH_C32(0x82c07470), SPH_C32(0x7a080400), SPH_C32(0x767e77f5),
    SPH_C32(0xbaa52e89), SPH_C32(0xb694ad43) },
  { SPH_C32(0x6d370a00), SPH_C32(0x182be332), SPH_C32(0x7b12368e),
    SPH_C32(0x1cd40106), SPH_C32(0x942e0400), SPH_C32(0x64351fcb),
    SPH_C32(0x3a67f806), SPH_C32(0x8d67066f) },
  { SPH_C32(0x24a90800), SPH_C32(0x15720f3f), SPH_C32(0x9b3519f3),
    SPH_C32(0xb933df5c), SPH_C32(0x33960600), SPH_C32(0x7b279bf8),
    SPH_C32(0x5a8201f4), SPH_C32(0x13737319) },
  { SPH_C32(0x83110a00), SPH_C32(0x0a608b0c), SPH_C32(0xfbd0e001),
    SPH_C32(0x2727aa2a), SPH_C32(0xddb00600), SPH_C32(0x696cf3c6),
    SPH_C32(0xda40d77b), SPH_C32(0x2880d835) },
  { SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76), SPH_C32(0x7432879d),
    SPH_C32(0x0b4d58a6), SPH_C32(0x6eb50400), SPH_C32(0x59c4400a),
    SPH_C32(0xd0d7cb32), SPH_C32(0x92eb46a5) },
  { SPH_C32(0xe2090e00), SPH_C32(0x15b62b45), SPH_C32(0x14d77e6f),
    SPH_C32(0x95592dd0), SPH_C32(0x80930400), SPH_C32(0x4b8f2834),
    SPH_C32(0x50151dbd), SPH_C32(0xa918ed89) },
  { SPH_C32(0xab970c00), SPH_C32(0x18efc748), SPH_C32(0xf4f05112),
    SPH_C32(0x30bef38a), SPH_C32(0x272b0600), SPH_C32(0x549dac07),
    SPH_C32(0x30f0e44f), SPH_C32(0x370c98ff) },
  { SPH_C32(0x0c2f0e00), SPH_C32(0x07fd437b), SPH_C32(0x9415a8e0),
    SPH_C32(0xaeaa86fc), SPH_C32(0xc90d0600), SPH_C32(0x46d6c439),
    SPH_C32(0xb03232c0), SPH_C32(0x0cff33d3) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x46330200), SPH_C32(0x4b4b0c4e), SPH_C32(0xdff77a21),
    SPH_C32(0x85721f05), SPH_C32(0xd19f0800), SPH_C32(0x6e91b0bd),
    SPH_C32(0x4e557f9b), SPH_C32(0x862a5ec9) },
  { SPH_C32(0x0fad0000), SPH_C32(0x4612e043), SPH_C32(0x3fd0555c),
    SPH_C32(0x2095c15f), SPH_C32(0x76270a00), SPH_C32(0x7183348e),
    SPH_C32(0x2eb08669), SPH_C32(0x183e2bbf) },
  { SPH_C32(0xa8150200), SPH_C32(0x59006470), SPH_C32(0x5f35acae),
    SPH_C32(0xbe81b429), SPH_C32(0x98010a00), SPH_C32(0x63c85cb0),
    SPH_C32(0xae7250e6), SPH_C32(0x23cd8093) },
  { SPH_C32(0x6eb50400), SPH_C32(0x59c4400a), SPH_C32(0xd0d7cb32),
    SPH_C32(0x92eb46a5), SPH_C32(0x2b040800), SPH_C32(0x5360ef7c),
    SPH_C32(0xa4e54caf), SPH_C32(0x99a61e03) },
  { SPH_C32(0xc90d0600), SPH_C32(0x46d6c439), SPH_C32(0xb03232c0),
    SPH_C32(0x0cff33d3), SPH_C32(0xc5220800), SPH_C32(0x412b8742),
    SPH_C32(0x24279a20), SPH_C32(0xa255b52f) },
  { SPH_C32(0x80930400), SPH_C32(0x4b8f2834), SPH_C32(0x50151dbd),
    SPH_C32(0xa918ed89), SPH_C32(0x629a0a00), SPH_C32(0x5e390371),
    SPH_C32(0x44c263d2), SPH_C32(0x3c41c059) },
  { SPH_C32(0x272b0600), SPH_C32(0x549dac07), SPH_C32(0x30f0e44f),
    SPH_C32(0x370c98ff), SPH_C32(0x8cbc0a00), SPH_C32(0x4c726b4f),
    SPH_C32(0xc400b55d), SPH_C32(0x07b26b75) },
  { SPH_C32(0xf5360000), SPH_C32(0x7be3bf82), SPH_C32(0xd5606668),
    SPH_C32(0x3f198195), SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b),
    SPH_C32(0xcb20044e), SPH_C32(0x102b32d5) },
  { SPH_C32(0x528e0200), SPH_C32(0x64f13bb1), SPH_C32(0xb5859f9a),
    SPH_C32(0xa10df4e3), SPH_C32(0x4a1c0c00), SPH_C32(0x4cb64f35),
    SPH_C32(0x4be2d2c1), SPH_C32(0x2bd899f9) },
  { SPH_C32(0x1b100000), SPH_C32(0x69a8d7bc), SPH_C32(0x55a2b0e7),
    SPH_C32(0x04ea2ab9), SPH_C32(0xeda40e00), SPH_C32(0x53a4cb06),
    SPH_C32(0x2b072b33), SPH_C32(0xb5ccec8f) },
  { SPH_C32(0xbca80200), SPH_C32(0x76ba538f), SPH_C32(0x35474915),
    SPH_C32(0x9afe5fcf), SPH_C32(0x03820e00), SPH_C32(0x41efa338),
    SPH_C32(0xabc5fdbc), SPH_C32(0x8e3f47a3) },
  { SPH_C32(0x7a080400), SPH_C32(0x767e77f5), SPH_C32(0xbaa52e89),
    SPH_C32(0xb694ad43), SPH_C32(0xb0870c00), SPH_C32(0x714710f4),
    SPH_C32(0xa152e1f5), SPH_C32(0x3454d933) },
  { SPH_C32(0xddb00600), SPH_C32(0x696cf3c6), SPH_C32(0xda40d77b),
    SPH_C32(0x2880d835), SPH_C32(0x5ea10c00), SPH_C32(0x630c78ca),
    SPH_C32(0x2190377a), SPH_C32(0x0fa7721f) },
  { SPH_C32(0x942e0400), SPH_C32(0x64351fcb), SPH_C32(0x3a67f806),
    SPH_C32(0x8d67066f), SPH_C32(0xf9190e00), SPH_C32(0x7c1efcf9),
    SPH_C32(0x4175ce88), SPH_C32(0x91b30769) },
  { SPH_C32(0x33960600), SPH_C32(0x7b279bf8), SPH_C32(0x5a8201f4),
    SPH_C32(0x13737319), SPH_C32(0x173f0e00), SPH_C32(0x6e5594c7),
    SPH_C32(0xc1b71807), SPH_C32(0xaa40ac45) },
  { SPH_C32(0x3fb90800), SPH_C32(0x7cdad883), SPH_C32(0xce97a914),
    SPH_C32(0xbdd9f5e5), SPH_C32(0xde320800), SPH_C32(0x288350fe),
    SPH_C32(0x71852ac7), SPH_C32(0xa6bf9f96) },
  { SPH_C32(0x98010a00), SPH_C32(0x63c85cb0), SPH_C32(0xae7250e6),
    SPH_C32(0x23cd8093), SPH_C32(0x30140800), SPH_C32(0x3ac838c0),
    SPH_C32(0xf147fc48), SPH_C32(0x9d4c34ba) },
  { SPH_C32(0xd19f0800), SPH_C32(0x6e91b0bd), SPH_C32(0x4e557f9b),
    SPH_C32(0x862a5ec9), SPH_C32(0x97ac0a00), SPH_C32(0x25dabcf3),
    SPH_C32(0x91a205ba), SPH_C32(0x035841cc) },
  { SPH_C32(0x76270a00), SPH_C32(0x7183348e), SPH_C32(0x2eb08669),
    SPH_C32(0x183e2bbf), SPH_C32(0x798a0a00), SPH_C32(0x3791d4cd),
    SPH_C32(0x1160d335), SPH_C32(0x38abeae0) },
  { SPH_C32(0xb0870c00), SPH_C32(0x714710f4), SPH_C32(0xa152e1f5),
    SPH_C32(0x3454d933), SPH_C32(0xca8f0800), SPH_C32(0x07396701),
    SPH_C32(0x1bf7cf7c), SPH_C32(0x82c07470) },
  { SPH_C32(0x173f0e00), SPH_C32(0x6e5594c7), SPH_C32(0xc1b71807),
    SPH_C32(0xaa40ac45), SPH_C32(0x24a90800), SPH_C32(0x15720f3f),
    SPH_C32(0x9b3519f3), SPH_C32(0xb933df5c) },
  { SPH_C32(0x5ea10c00), SPH_C32(0x630c78ca), SPH_C32(0x2190377a),
    SPH_C32(0x0fa7721f), SPH_C32(0x83110a00), SPH_C32(0x0a608b0c),
    SPH_C32(0xfbd0e001), SPH_C32(0x2727aa2a) },
  { SPH_C32(0xf9190e00), SPH_C32(0x7c1efcf9), SPH_C32(0x4175ce88),
    SPH_C32(0x91b30769), SPH_C32(0x6d370a00), SPH_C32(0x182be332),
    SPH_C32(0x7b12368e), SPH_C32(0x1cd40106) },
  { SPH_C32(0x2b040800), SPH_C32(0x5360ef7c), SPH_C32(0xa4e54caf),
    SPH_C32(0x99a61e03), SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76),
    SPH_C32(0x7432879d), SPH_C32(0x0b4d58a6) },
  { SPH_C32(0x8cbc0a00), SPH_C32(0x4c726b4f), SPH_C32(0xc400b55d),
    SPH_C32(0x07b26b75), SPH_C32(0xab970c00), SPH_C32(0x18efc748),
    SPH_C32(0xf4f05112), SPH_C32(0x30bef38a) },
  { SPH_C32(0xc5220800), SPH_C32(0x412b8742), SPH_C32(0x24279a20),
    SPH_C32(0xa255b52f), SPH_C32(0x0c2f0e00), SPH_C32(0x07fd437b),
    SPH_C32(0x9415a8e0), SPH_C32(0xaeaa86fc) },
  { SPH_C32(0x629a0a00), SPH_C32(0x5e390371), SPH_C32(0x44c263d2),
    SPH_C32(0x3c41c059), SPH_C32(0xe2090e00), SPH_C32(0x15b62b45),
    SPH_C32(0x14d77e6f), SPH_C32(0x95592dd0) },
  { SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b), SPH_C32(0xcb20044e),
    SPH_C32(0x102b32d5), SPH_C32(0x510c0c00), SPH_C32(0x251e9889),
    SPH_C32(0x1e406226), SPH_C32(0x2f32b340) },
  { SPH_C32(0x03820e00), SPH_C32(0x41efa338), SPH_C32(0xabc5fdbc),
    SPH_C32(0x8e3f47a3), SPH_C32(0xbf2a0c00), SPH_C32(0x3755f0b7),
    SPH_C32(0x9e82b4a9), SPH_C32(0x14c1186c) },
  { SPH_C32(0x4a1c0c00), SPH_C32(0x4cb64f35), SPH_C32(0x4be2d2c1),
    SPH_C32(0x2bd899f9), SPH_C32(0x18920e00), SPH_C32(0x28477484),
    SPH_C32(0xfe674d5b), SPH_C32(0x8ad56d1a) },
  { SPH_C32(0xeda40e00), SPH_C32(0x53a4cb06), SPH_C32(0x2b072b33),
    SPH_C32(0xb5ccec8f), SPH_C32(0xf6b40e00), SPH_C32(0x3a0c1cba),
    SPH_C32(0x7ea59bd4), SPH_C32(0xb126c636) },
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0xd32d1200), SPH_C32(0x4539c24d), SPH_C32(0xe818e4d9),
    SPH_C32(0x80f2f7e4), SPH_C32(0x258f0000), SPH_C32(0x826c5f57),
    SPH_C32(0x3b1e2288), SPH_C32(0xeb07044d) },
  { SPH_C32(0x9ab31000), SPH_C32(0x48602e40), SPH_C32(0x083fcba4),
    SPH_C32(0x251529be), SPH_C32(0x82370200), SPH_C32(0x9d7edb64),
    SPH_C32(0x5bfbdb7a), SPH_C32(0x7513713b) },
  { SPH_C32(0x3d0b1200), SPH_C32(0x5772aa73), SPH_C32(0x68da3256),
    SPH_C32(0xbb015cc8), SPH_C32(0x6c110200), SPH_C32(0x8f35b35a),
    SPH_C32(0xdb390df5), SPH_C32(0x4ee0da17) },
  { SPH_C32(0xfbab1400), SPH_C32(0x57b68e09), SPH_C32(0xe73855ca),
    SPH_C32(0x976bae44), SPH_C32(0xdf140000), SPH_C32(0xbf9d0096),
    SPH_C32(0xd1ae11bc), SPH_C32(0xf48b4487) },
  { SPH_C32(0x5c131600), SPH_C32(0x48a40a3a), SPH_C32(0x87ddac38),
    SPH_C32(0x097fdb32), SPH_C32(0x31320000), SPH_C32(0xadd668a8),
    SPH_C32(0x516cc733), SPH_C32(0xcf78efab) },
  { SPH_C32(0x158d1400), SPH_C32(0x45fde637), SPH_C32(0x67fa8345),
    SPH_C32(0xac980568), SPH_C32(0x968a0200), SPH_C32(0xb2c4ec9b),
    SPH_C32(0x31893ec1), SPH_C32(0x516c9add) },
  { SPH_C32(0xb2351600), SPH_C32(0x5aef6204), SPH_C32(0x071f7ab7),
    SPH_C32(0x328c701e), SPH_C32(0x78ac0200), SPH_C32(0xa08f84a5),
    SPH_C32(0xb14be84e), SPH_C32(0x6a9f31f1) },
  { SPH_C32(0x60281000), SPH_C32(0x75917181), SPH_C32(0xe28ff890),
    SPH_C32(0x3a996974), SPH_C32(0x502a0400), SPH_C32(0xb200c8e1),
    SPH_C32(0xbe6b595d), SPH_C32(0x7d066851) },
  { SPH_C32(0xc7901200), SPH_C32(0x6a83f5b2), SPH_C32(0x826a0162),
    SPH_C32(0xa48d1c02), SPH_C32(0xbe0c0400), SPH_C32(0xa04ba0df),
    SPH_C32(0x3ea98fd2), SPH_C32(0x46f5c37d) },
  { SPH_C32(0x8e0e1000), SPH_C32(0x67da19bf), SPH_C32(0x624d2e1f),
    SPH_C32(0x016ac258), SPH_C32(0x19b40600), SPH_C32(0xbf5924ec),
    SPH_C32(0x5e4c7620), SPH_C32(0xd8e1b60b) },
  { SPH_C32(0x29b61200), SPH_C32(0x78c89d8c), SPH_C32(0x02a8d7ed),
    SPH_C32(0x9f7eb72e), SPH_C32(0xf7920600), SPH_C32(0xad124cd2),
    SPH_C32(0xde8ea0af), SPH_C32(0xe3121d27) },
  { SPH_C32(0xef161400), SPH_C32(0x780cb9f6), SPH_C32(0x8d4ab071),
    SPH_C32(0xb31445a2), SPH_C32(0x44970400), SPH_C32(0x9dbaff1e),
    SPH_C32(0xd419bce6), SPH_C32(0x597983b7) },
  { SPH_C32(0x48ae1600), SPH_C32(0x671e3dc5), SPH_C32(0xedaf4983),
    SPH_C32(0x2d0030d4), SPH_C32(0xaab10400), SPH_C32(0x8ff19720),
    SPH_C32(0x54db6a69), SPH_C32(0x628a289b) },
  { SPH_C32(0x01301400), SPH_C32(0x6a47d1c8), SPH_C32(0x0d8866fe),
    SPH_C32(0x88e7ee8e), SPH_C32(0x0d090600), SPH_C32(0x90e31313),
    SPH_C32(0x343e939b), SPH_C32(0xfc9e5ded) },
  { SPH_C32(0xa6881600), SPH_C32(0x755555fb), SPH_C32(0x6d6d9f0c),
    SPH_C32(0x16f39bf8), SPH_C32(0xe32f0600), SPH_C32(0x82a87b2d),
    SPH_C32(0xb4fc4514), SPH_C32(0xc76df6c1) },
  { SPH_C32(0xaaa71800), SPH_C32(0x72a81680), SPH_C32(0xf97837ec),
    SPH_C32(0xb8591d04), SPH_C32(0x2a220000), SPH_C32(0xc47ebf14),
    SPH_C32(0x04ce77d4), SPH_C32(0xcb92c512) },
  { SPH_C32(0x0d1f1a00), SPH_C32(0x6dba92b3), SPH_C32(0x999dce1e),
    SPH_C32(0x264d6872), SPH_C32(0xc4040000), SPH_C32(0xd635d72a),
    SPH_C32(0x840ca15b), SPH_C32(0xf0616e3e) },
  { SPH_C32(0x44811800), SPH_C32(0x60e37ebe), SPH_C32(0x79bae163),
    SPH_C32(0x83aab628), SPH_C32(0x63bc0200), SPH_C32(0xc9275319),
    SPH_C32(0xe4e958a9), SPH_C32(0x6e751b48) },
  { SPH_C32(0xe3391a00), SPH_C32(0x7ff1fa8d), SPH_C32(0x195f1891),
    SPH_C32(0x1dbec35e), SPH_C32(0x8d9a0200), SPH_C32(0xdb6c3b27),
    SPH_C32(0x642b8e26), SPH_C32(0x5586b064) },
  { SPH_C32(0x25991c00), SPH_C32(0x7f35def7), SPH_C32(0x96bd7f0d),
    SPH_C32(0x31d431d2), SPH_C32(0x3e9f0000), SPH_C32(0xebc488eb),
    SPH_C32(0x6ebc926f), SPH_C32(0xefed2ef4) },
  { SPH_C32(0x82211e00), SPH_C32(0x60275ac4), SPH_C32(0xf65886ff),
    SPH_C32(0xafc044a4), SPH_C32(0xd0b90000), SPH_C32(0xf98fe0d5),
    SPH_C32(0xee7e44e0), SPH_C32(0xd41e85d8) },
  { SPH_C32(0xcbbf1c00), SPH_C32(0x6d7eb6c9), SPH_C32(0x167fa982),
    SPH_C32(0x0a279afe), SPH_C32(0x77010200), SPH_C32(0xe69d64e6),
    SPH_C32(0x8e9bbd12), SPH_C32(0x4a0af0ae) },
  { SPH_C32(0x6c071e00), SPH_C32(0x726c32fa), SPH_C32(0x769a5070),
    SPH_C32(0x9433ef88), SPH_C32(0x99270200), SPH_C32(0xf4d60cd8),
    SPH_C32(0x0e596b9d), SPH_C32(0x71f95b82) },
  { SPH_C32(0xbe1a1800), SPH_C32(0x5d12217f), SPH_C32(0x930ad257),
    SPH_C32(0x9c26f6e2), SPH_C32(0xb1a10400), SPH_C32(0xe659409c),
    SPH_C32(0x0179da8e), SPH_C32(0x66600222) },
  { SPH_C32(0x19a21a00), SPH_C32(0x4200a54c), SPH_C32(0xf3ef2ba5),
    SPH_C32(0x02328394), SPH_C32(0x5f870400), SPH_C32(0xf41228a2),
    SPH_C32(0x81bb0c01), SPH_C32(0x5d93a90e) },
  { SPH_C32(0x503c1800), SPH_C32(0x4f594941), SPH_C32(0x13c804d8),
    SPH_C32(0xa7d55dce), SPH_C32(0xf83f0600), SPH_C32(0xeb00ac91),
    SPH_C32(0xe15ef5f3), SPH_C32(0xc387dc78) },
  { SPH_C32(0xf7841a00), SPH_C32(0x504bcd72), SPH_C32(0x732dfd2a),
    SPH_C32(0x39c128b8), SPH_C32(0x16190600), SPH_C32(0xf94bc4af),
    SPH_C32(0x619c237c), SPH_C32(0xf8747754) },
  { SPH_C32(0x31241c00), SPH_C32(0x508fe908), SPH_C32(0xfccf9ab6),
    SPH_C32(0x15abda34), SPH_C32(0xa51c0400), SPH_C32(0xc9e37763),
    SPH_C32(0x6b0b3f35), SPH_C32(0x421fe9c4) },
  { SPH_C32(0x969c1e00), SPH_C32(0x4f9d6d3b), SPH_C32(0x9c2a6344),
    SPH_C32(0x8bbfaf42), SPH_C32(0x4b3a0400), SPH_C32(0xdba81f5d),
    SPH_C32(0xebc9e9ba), SPH_C32(0x79ec42e8) },
  { SPH_C32(0xdf021c00), SPH_C32(0x42c48136), SPH_C32(0x7c0d4c39),
    SPH_C32(0x2e587118), SPH_C32(0xec820600), SPH_C32(0xc4ba9b6e),
    SPH_C32(0x8b2c1048), SPH_C32(0xe7f8379e) },
  { SPH_C32(0x78ba1e00), SPH_C32(0x5dd60505), SPH_C32(0x1ce8b5cb),
    SPH_C32(0xb04c046e), SPH_C32(0x02a40600), SPH_C32(0xd6f1f350),
    SPH_C32(0x0beec6c7), SPH_C32(0xdc0b9cb2) },
  { SPH_C32(0x951e1000), SPH_C32(0x0e72ce03), SPH_C32(0x37ef9ef8),
    SPH_C32(0x0580e8e1), SPH_C32(0xf4100800), SPH_C32(0xecfdefea),
    SPH_C32(0x754b5d13), SPH_C32(0x6d2d5a84) },
  { SPH_C32(0x32a61200), SPH_C32(0x11604a30), SPH_C32(0x570a670a),
    SPH_C32(0x9b949d97), SPH_C32(0x1a360800), SPH_C32(0xfeb687d4),
    SPH_C32(0xf5898b9c), SPH_C32(0x56def1a8) },
  { SPH_C32(0x7b381000), SPH_C32(0x1c39a63d), SPH_C32(0xb72d4877),
    SPH_C32(0x3e7343cd), SPH_C32(0xbd8e0a00), SPH_C32(0xe1a403e7),
    SPH_C32(0x956c726e), SPH_C32(0xc8ca84de) },
  { SPH_C32(0xdc801200), SPH_C32(0x032b220e), SPH_C32(0xd7c8b185),
    SPH_C32(0xa06736bb), SPH_C32(0x53a80a00), SPH_C32(0xf3ef6bd9),
    SPH_C32(0x15aea4e1), SPH_C32(0xf3392ff2) },
  { SPH_C32(0x1a201400), SPH_C32(0x03ef0674), SPH_C32(0x582ad619),
    SPH_C32(0x8c0dc437), SPH_C32(0xe0ad0800), SPH_C32(0xc347d815),
    SPH_C32(0x1f39b8a8), SPH_C32(0x4952b162) },
  { SPH_C32(0xbd981600), SPH_C32(0x1cfd8247), SPH_C32(0x38cf2feb),
    SPH_C32(0x1219b141), SPH_C32(0x0e8b0800), SPH_C32(0xd10cb02b),
    SPH_C32(0x9ffb6e27), SPH_C32(0x72a11a4e) },
  { SPH_C32(0xf4061400), SPH_C32(0x11a46e4a), SPH_C32(0xd8e80096),
    SPH_C32(0xb7fe6f1b), SPH_C32(0xa9330a00), SPH_C32(0xce1e3418),
    SPH_C32(0xff1e97d5), SPH_C32(0xecb56f38) },
  { SPH_C32(0x53be1600), SPH_C32(0x0eb6ea79), SPH_C32(0xb80df964),
    SPH_C32(0x29ea1a6d), SPH_C32(0x47150a00), SPH_C32(0xdc555c26),
    SPH_C32(0x7fdc415a), SPH_C32(0xd746c414) },
  { SPH_C32(0x81a31000), SPH_C32(0x21c8f9fc), SPH_C32(0x5d9d7b43),
    SPH_C32(0x21ff0307), SPH_C32(0x6f930c00), SPH_C32(0xceda1062),
    SPH_C32(0x70fcf049), SPH_C32(0xc0df9db4) },
  { SPH_C32(0x261b1200), SPH_C32(0x3eda7dcf), SPH_C32(0x3d7882b1),
    SPH_C32(0xbfeb7671), SPH_C32(0x81b50c00), SPH_C32(0xdc91785c),
    SPH_C32(0xf03e26c6), SPH_C32(0xfb2c3698) },
  { SPH_C32(0x6f851000), SPH_C32(0x338391c2), SPH_C32(0xdd5fadcc),
    SPH_C32(0x1a0ca82b), SPH_C32(0x260d0e00), SPH_C32(0xc383fc6f),
    SPH_C32(0x90dbdf34), SPH_C32(0x653843ee) },
  { SPH_C32(0xc83d1200), SPH_C32(0x2c9115f1), SPH_C32(0xbdba543e),
    SPH_C32(0x8418dd5d), SPH_C32(0xc82b0e00), SPH_C32(0xd1c89451),
    SPH_C32(0x101909bb), SPH_C32(0x5ecbe8c2) },
  { SPH_C32(0x0e9d1400), SPH_C32(0x2c55318b), SPH_C32(0x325833a2),
    SPH_C32(0xa8722fd1), SPH_C32(0x7b2e0c00), SPH_C32(0xe160279d),
    SPH_C32(0x1a8e15f2), SPH_C32(0xe4a07652) },
  { SPH_C32(0xa9251600), SPH_C32(0x3347b5b8), SPH_C32(0x52bdca50),
    SPH_C32(0x36665aa7), SPH_C32(0x95080c00), SPH_C32(0xf32b4fa3),
    SPH_C32(0x9a4cc37d), SPH_C32(0xdf53dd7e) },
  { SPH_C32(0xe0bb1400), SPH_C32(0x3e1e59b5), SPH_C32(0xb29ae52d),
    SPH_C32(0x938184fd), SPH_C32(0x32b00e00), SPH_C32(0xec39cb90),
    SPH_C32(0xfaa93a8f), SPH_C32(0x4147a808) },
  { SPH_C32(0x47031600), SPH_C32(0x210cdd86), SPH_C32(0xd27f1cdf),
    SPH_C32(0x0d95f18b), SPH_C32(0xdc960e00), SPH_C32(0xfe72a3ae),
    SPH_C32(0x7a6bec00), SPH_C32(0x7ab40324) },
  { SPH_C32(0x4b2c1800), SPH_C32(0x26f19efd), SPH_C32(0x466ab43f),
    SPH_C32(0xa33f7777), SPH_C32(0x159b0800), SPH_C32(0xb8a46797),
    SPH_C32(0xca59dec0), SPH_C32(0x764b30f7) },
  { SPH_C32(0xec941a00), SPH_C32(0x39e31ace), SPH_C32(0x268f4dcd),
    SPH_C32(0x3d2b0201), SPH_C32(0xfbbd0800), SPH_C32(0xaaef0fa9),
    SPH_C32(0x4a9b084f), SPH_C32(0x4db89bdb) },
  { SPH_C32(0xa50a1800), SPH_C32(0x34baf6c3), SPH_C32(0xc6a862b0),
    SPH_C32(0x98ccdc5b), SPH_C32(0x5c050a00), SPH_C32(0xb5fd8b9a),
    SPH_C32(0x2a7ef1bd), SPH_C32(0xd3aceead) },
  { SPH_C32(0x02b21a00), SPH_C32(0x2ba872f0), SPH_C32(0xa64d9b42),
    SPH_C32(0x06d8a92d), SPH_C32(0xb2230a00), SPH_C32(0xa7b6e3a4),
    SPH_C32(0xaabc2732), SPH_C32(0xe85f4581) },
  { SPH_C32(0xc4121c00), SPH_C32(0x2b6c568a), SPH_C32(0x29affcde),
    SPH_C32(0x2ab25ba1), SPH_C32(0x01260800), SPH_C32(0x971e5068),
    SPH_C32(0xa02b3b7b), SPH_C32(0x5234db11) },
  { SPH_C32(0x63aa1e00), SPH_C32(0x347ed2b9), SPH_C32(0x494a052c),
    SPH_C32(0xb4a62ed7), SPH_C32(0xef000800), SPH_C32(0x85553856),
    SPH_C32(0x20e9edf4), SPH_C32(0x69c7703d) },
  { SPH_C32(0x2a341c00), SPH_C32(0x39273eb4), SPH_C32(0xa96d2a51),
    SPH_C32(0x1141f08d), SPH_C32(0x48b80a00), SPH_C32(0x9a47bc65),
    SPH_C32(0x400c1406), SPH_C32(0xf7d3054b) },
  { SPH_C32(0x8d8c1e00), SPH_C32(0x2635ba87), SPH_C32(0xc988d3a3),
    SPH_C32(0x8f5585fb), SPH_C32(0xa69e0a00), SPH_C32(0x880cd45b),
    SPH_C32(0xc0cec289), SPH_C32(0xcc20ae67) },
  { SPH_C32(0x5f911800), SPH_C32(0x094ba902), SPH_C32(0x2c185184),
    SPH_C32(0x87409c91), SPH_C32(0x8e180c00), SPH_C32(0x9a83981f),
    SPH_C32(0xcfee739a), SPH_C32(0xdbb9f7c7) },
  { SPH_C32(0xf8291a00), SPH_C32(0x16592d31), SPH_C32(0x4cfda876),
    SPH_C32(0x1954e9e7), SPH_C32(0x603e0c00), SPH_C32(0x88c8f021),
    SPH_C32(0x4f2ca515), SPH_C32(0xe04a5ceb) },
  { SPH_C32(0xb1b71800), SPH_C32(0x1b00c13c), SPH_C32(0xacda870b),
    SPH_C32(0xbcb337bd), SPH_C32(0xc7860e00), SPH_C32(0x97da7412),
    SPH_C32(0x2fc95ce7), SPH_C32(0x7e5e299d) },
  { SPH_C32(0x160f1a00), SPH_C32(0x0412450f), SPH_C32(0xcc3f7ef9),
    SPH_C32(0x22a742cb), SPH_C32(0x29a00e00), SPH_C32(0x85911c2c),
    SPH_C32(0xaf0b8a68), SPH_C32(0x45ad82b1) },
  { SPH_C32(0xd0af1c00), SPH_C32(0x04d66175), SPH_C32(0x43dd1965),
    SPH_C32(0x0ecdb047), SPH_C32(0x9aa50c00), SPH_C32(0xb539afe0),
    SPH_C32(0xa59c9621), SPH_C32(0xffc61c21) },
  { SPH_C32(0x77171e00), SPH_C32(0x1bc4e546), SPH_C32(0x2338e097),
    SPH_C32(0x90d9c531), SPH_C32(0x74830c00), SPH_C32(0xa772c7de),
    SPH_C32(0x255e40ae), SPH_C32(0xc435b70d) },
  { SPH_C32(0x3e891c00), SPH_C32(0x169d094b), SPH_C32(0xc31fcfea),
    SPH_C32(0x353e1b6b), SPH_C32(0xd33b0e00), SPH_C32(0xb86043ed),
    SPH_C32(0x45bbb95c), SPH_C32(0x5a21c27b) },
  { SPH_C32(0x99311e00), SPH_C32(0x098f8d78), SPH_C32(0xa3fa3618),
    SPH_C32(0xab2a6e1d), SPH_C32(0x3d1d0e00), SPH_C32(0xaa2b2bd3),
    SPH_C32(0xc5796fd3), SPH_C32(0x61d26957) }
};

__constant static const sph_u32 T256_14[128][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x11bc0040), SPH_C32(0xf2e1216c), SPH_C32(0x4fcc6651),
    SPH_C32(0x408a1b7d), SPH_C32(0x86610020), SPH_C32(0xe89072d0),
    SPH_C32(0xdd3be10a), SPH_C32(0xf3310573) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x24d90000), SPH_C32(0x69779726), SPH_C32(0x24f5ad0e),
    SPH_C32(0x119ea5b3), SPH_C32(0xcbaf0060), SPH_C32(0xd3cb9eae),
    SPH_C32(0xeb5e8aa2), SPH_C32(0xd0523f76) },
  { SPH_C32(0x35650040), SPH_C32(0x9b96b64a), SPH_C32(0x6b39cb5f),
    SPH_C32(0x5114bece), SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e),
    SPH_C32(0x36656ba8), SPH_C32(0x23633a05) },
  { SPH_C32(0x69170040), SPH_C32(0x522c7b58), SPH_C32(0x1290c6a6),
    SPH_C32(0x32fd9fb6), SPH_C32(0xb3040060), SPH_C32(0x7306c49a),
    SPH_C32(0xb6022a55), SPH_C32(0xa225bbbd) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x07a00080), SPH_C32(0x8cb5d5fe), SPH_C32(0xbb6d61ac),
    SPH_C32(0x908b934b), SPH_C32(0xc76c0020), SPH_C32(0x02ea7b0f),
    SPH_C32(0x512948b6), SPH_C32(0x36343593) },
  { SPH_C32(0x161c00c0), SPH_C32(0x7e54f492), SPH_C32(0xf4a107fd),
    SPH_C32(0xd0018836), SPH_C32(0x410d0000), SPH_C32(0xea7a09df),
    SPH_C32(0x8c12a9bc), SPH_C32(0xc50530e0) },
  { SPH_C32(0x4a6e00c0), SPH_C32(0xb7ee3980), SPH_C32(0x8d080a04),
    SPH_C32(0xb3e8a94e), SPH_C32(0xbfc70020), SPH_C32(0xa227213b),
    SPH_C32(0x0c75e841), SPH_C32(0x4443b158) },
  { SPH_C32(0x23790080), SPH_C32(0xe5c242d8), SPH_C32(0x9f98cca2),
    SPH_C32(0x811536f8), SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1),
    SPH_C32(0xba77c214), SPH_C32(0xe6660ae5) },
  { SPH_C32(0x7f0b0080), SPH_C32(0x2c788fca), SPH_C32(0xe631c15b),
    SPH_C32(0xe2fc1780), SPH_C32(0xf2090060), SPH_C32(0x997ccd45),
    SPH_C32(0x3a1083e9), SPH_C32(0x67208b5d) },
  { SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6), SPH_C32(0xa9fda70a),
    SPH_C32(0xa2760cfd), SPH_C32(0x74680040), SPH_C32(0x71ecbf95),
    SPH_C32(0xe72b62e3), SPH_C32(0x94118e2e) },
  { SPH_C32(0x32c500c0), SPH_C32(0x172363b4), SPH_C32(0xd054aaf3),
    SPH_C32(0xc19f2d85), SPH_C32(0x8aa20060), SPH_C32(0x39b19771),
    SPH_C32(0x674c231e), SPH_C32(0x15570f96) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0x65d40000), SPH_C32(0x830d9ef9), SPH_C32(0xa8e704b2),
    SPH_C32(0xd49b9553), SPH_C32(0x9cbe00a0), SPH_C32(0x47e563e3),
    SPH_C32(0x93ed24e3), SPH_C32(0xc55687a0) },
  { SPH_C32(0x74680040), SPH_C32(0x71ecbf95), SPH_C32(0xe72b62e3),
    SPH_C32(0x94118e2e), SPH_C32(0x1adf0080), SPH_C32(0xaf751133),
    SPH_C32(0x4ed6c5e9), SPH_C32(0x366782d3) },
  { SPH_C32(0x281a0040), SPH_C32(0xb8567287), SPH_C32(0x9e826f1a),
    SPH_C32(0xf7f8af56), SPH_C32(0xe41500a0), SPH_C32(0xe72839d7),
    SPH_C32(0xceb18414), SPH_C32(0xb721036b) },
  { SPH_C32(0x410d0000), SPH_C32(0xea7a09df), SPH_C32(0x8c12a9bc),
    SPH_C32(0xc50530e0), SPH_C32(0x571100c0), SPH_C32(0x942efd4d),
    SPH_C32(0x78b3ae41), SPH_C32(0x1504b8d6) },
  { SPH_C32(0x1d7f0000), SPH_C32(0x23c0c4cd), SPH_C32(0xf5bba445),
    SPH_C32(0xa6ec1198), SPH_C32(0xa9db00e0), SPH_C32(0xdc73d5a9),
    SPH_C32(0xf8d4efbc), SPH_C32(0x9442396e) },
  { SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1), SPH_C32(0xba77c214),
    SPH_C32(0xe6660ae5), SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779),
    SPH_C32(0x25ef0eb6), SPH_C32(0x67733c1d) },
  { SPH_C32(0x50b10040), SPH_C32(0x189b28b3), SPH_C32(0xc3decfed),
    SPH_C32(0x858f2b9d), SPH_C32(0xd17000e0), SPH_C32(0x7cbe8f9d),
    SPH_C32(0xa5884f4b), SPH_C32(0xe635bda5) },
  { SPH_C32(0x62740080), SPH_C32(0x0fb84b07), SPH_C32(0x138a651e),
    SPH_C32(0x44100618), SPH_C32(0x5bd20080), SPH_C32(0x450f18ec),
    SPH_C32(0xc2c46c55), SPH_C32(0xf362b233) },
  { SPH_C32(0x3e060080), SPH_C32(0xc6028615), SPH_C32(0x6a2368e7),
    SPH_C32(0x27f92760), SPH_C32(0xa51800a0), SPH_C32(0x0d523008),
    SPH_C32(0x42a32da8), SPH_C32(0x7224338b) },
  { SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779), SPH_C32(0x25ef0eb6),
    SPH_C32(0x67733c1d), SPH_C32(0x23790080), SPH_C32(0xe5c242d8),
    SPH_C32(0x9f98cca2), SPH_C32(0x811536f8) },
  { SPH_C32(0x73c800c0), SPH_C32(0xfd596a6b), SPH_C32(0x5c46034f),
    SPH_C32(0x049a1d65), SPH_C32(0xddb300a0), SPH_C32(0xad9f6a3c),
    SPH_C32(0x1fff8d5f), SPH_C32(0x0053b740) },
  { SPH_C32(0x1adf0080), SPH_C32(0xaf751133), SPH_C32(0x4ed6c5e9),
    SPH_C32(0x366782d3), SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6),
    SPH_C32(0xa9fda70a), SPH_C32(0xa2760cfd) },
  { SPH_C32(0x46ad0080), SPH_C32(0x66cfdc21), SPH_C32(0x377fc810),
    SPH_C32(0x558ea3ab), SPH_C32(0x907d00e0), SPH_C32(0x96c48642),
    SPH_C32(0x299ae6f7), SPH_C32(0x23308d45) },
  { SPH_C32(0x571100c0), SPH_C32(0x942efd4d), SPH_C32(0x78b3ae41),
    SPH_C32(0x1504b8d6), SPH_C32(0x161c00c0), SPH_C32(0x7e54f492),
    SPH_C32(0xf4a107fd), SPH_C32(0xd0018836) },
  { SPH_C32(0x0b6300c0), SPH_C32(0x5d94305f), SPH_C32(0x011aa3b8),
    SPH_C32(0x76ed99ae), SPH_C32(0xe8d600e0), SPH_C32(0x3609dc76),
    SPH_C32(0x74c64600), SPH_C32(0x5147098e) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0xebd60100), SPH_C32(0x43a5fcca), SPH_C32(0xfc20d552),
    SPH_C32(0x852d451c), SPH_C32(0x8d860020), SPH_C32(0xdd328f32),
    SPH_C32(0x22fa536a), SPH_C32(0xefa3e9ec) },
  { SPH_C32(0xfa6a0140), SPH_C32(0xb144dda6), SPH_C32(0xb3ecb303),
    SPH_C32(0xc5a75e61), SPH_C32(0x0be70000), SPH_C32(0x35a2fde2),
    SPH_C32(0xffc1b260), SPH_C32(0x1c92ec9f) },
  { SPH_C32(0xa6180140), SPH_C32(0x78fe10b4), SPH_C32(0xca45befa),
    SPH_C32(0xa64e7f19), SPH_C32(0xf52d0020), SPH_C32(0x7dffd506),
    SPH_C32(0x7fa6f39d), SPH_C32(0x9dd46d27) },
  { SPH_C32(0xcf0f0100), SPH_C32(0x2ad26bec), SPH_C32(0xd8d5785c),
    SPH_C32(0x94b3e0af), SPH_C32(0x46290040), SPH_C32(0x0ef9119c),
    SPH_C32(0xc9a4d9c8), SPH_C32(0x3ff1d69a) },
  { SPH_C32(0x937d0100), SPH_C32(0xe368a6fe), SPH_C32(0xa17c75a5),
    SPH_C32(0xf75ac1d7), SPH_C32(0xb8e30060), SPH_C32(0x46a43978),
    SPH_C32(0x49c39835), SPH_C32(0xbeb75722) },
  { SPH_C32(0x82c10140), SPH_C32(0x11898792), SPH_C32(0xeeb013f4),
    SPH_C32(0xb7d0daaa), SPH_C32(0x3e820040), SPH_C32(0xae344ba8),
    SPH_C32(0x94f8793f), SPH_C32(0x4d865251) },
  { SPH_C32(0xdeb30140), SPH_C32(0xd8334a80), SPH_C32(0x97191e0d),
    SPH_C32(0xd439fbd2), SPH_C32(0xc0480060), SPH_C32(0xe669634c),
    SPH_C32(0x149f38c2), SPH_C32(0xccc0d3e9) },
  { SPH_C32(0xec760180), SPH_C32(0xcf102934), SPH_C32(0x474db4fe),
    SPH_C32(0x15a6d657), SPH_C32(0x4aea0000), SPH_C32(0xdfd8f43d),
    SPH_C32(0x73d31bdc), SPH_C32(0xd997dc7f) },
  { SPH_C32(0xb0040180), SPH_C32(0x06aae426), SPH_C32(0x3ee4b907),
    SPH_C32(0x764ff72f), SPH_C32(0xb4200020), SPH_C32(0x9785dcd9),
    SPH_C32(0xf3b45a21), SPH_C32(0x58d15dc7) },
  { SPH_C32(0xa1b801c0), SPH_C32(0xf44bc54a), SPH_C32(0x7128df56),
    SPH_C32(0x36c5ec52), SPH_C32(0x32410000), SPH_C32(0x7f15ae09),
    SPH_C32(0x2e8fbb2b), SPH_C32(0xabe058b4) },
  { SPH_C32(0xfdca01c0), SPH_C32(0x3df10858), SPH_C32(0x0881d2af),
    SPH_C32(0x552ccd2a), SPH_C32(0xcc8b0020), SPH_C32(0x374886ed),
    SPH_C32(0xaee8fad6), SPH_C32(0x2aa6d90c) },
  { SPH_C32(0x94dd0180), SPH_C32(0x6fdd7300), SPH_C32(0x1a111409),
    SPH_C32(0x67d1529c), SPH_C32(0x7f8f0040), SPH_C32(0x444e4277),
    SPH_C32(0x18ead083), SPH_C32(0x888362b1) },
  { SPH_C32(0xc8af0180), SPH_C32(0xa667be12), SPH_C32(0x63b819f0),
    SPH_C32(0x043873e4), SPH_C32(0x81450060), SPH_C32(0x0c136a93),
    SPH_C32(0x988d917e), SPH_C32(0x09c5e309) },
  { SPH_C32(0xd91301c0), SPH_C32(0x54869f7e), SPH_C32(0x2c747fa1),
    SPH_C32(0x44b26899), SPH_C32(0x07240040), SPH_C32(0xe4831843),
    SPH_C32(0x45b67074), SPH_C32(0xfaf4e67a) },
  { SPH_C32(0x856101c0), SPH_C32(0x9d3c526c), SPH_C32(0x55dd7258),
    SPH_C32(0x275b49e1), SPH_C32(0xf9ee0060), SPH_C32(0xacde30a7),
    SPH_C32(0xc5d13189), SPH_C32(0x7bb267c2) },
  { SPH_C32(0x8e020100), SPH_C32(0xc0a86233), SPH_C32(0x54c7d1e0),
    SPH_C32(0x51b6d04f), SPH_C32(0x11380080), SPH_C32(0x9ad7ecd1),
    SPH_C32(0xb1177789), SPH_C32(0x2af56e4c) },
  { SPH_C32(0xd2700100), SPH_C32(0x0912af21), SPH_C32(0x2d6edc19),
    SPH_C32(0x325ff137), SPH_C32(0xeff200a0), SPH_C32(0xd28ac435),
    SPH_C32(0x31703674), SPH_C32(0xabb3eff4) },
  { SPH_C32(0xc3cc0140), SPH_C32(0xfbf38e4d), SPH_C32(0x62a2ba48),
    SPH_C32(0x72d5ea4a), SPH_C32(0x69930080), SPH_C32(0x3a1ab6e5),
    SPH_C32(0xec4bd77e), SPH_C32(0x5882ea87) },
  { SPH_C32(0x9fbe0140), SPH_C32(0x3249435f), SPH_C32(0x1b0bb7b1),
    SPH_C32(0x113ccb32), SPH_C32(0x975900a0), SPH_C32(0x72479e01),
    SPH_C32(0x6c2c9683), SPH_C32(0xd9c46b3f) },
  { SPH_C32(0xf6a90100), SPH_C32(0x60653807), SPH_C32(0x099b7117),
    SPH_C32(0x23c15484), SPH_C32(0x245d00c0), SPH_C32(0x01415a9b),
    SPH_C32(0xda2ebcd6), SPH_C32(0x7be1d082) },
  { SPH_C32(0xaadb0100), SPH_C32(0xa9dff515), SPH_C32(0x70327cee),
    SPH_C32(0x402875fc), SPH_C32(0xda9700e0), SPH_C32(0x491c727f),
    SPH_C32(0x5a49fd2b), SPH_C32(0xfaa7513a) },
  { SPH_C32(0xbb670140), SPH_C32(0x5b3ed479), SPH_C32(0x3ffe1abf),
    SPH_C32(0x00a26e81), SPH_C32(0x5cf600c0), SPH_C32(0xa18c00af),
    SPH_C32(0x87721c21), SPH_C32(0x09965449) },
  { SPH_C32(0xe7150140), SPH_C32(0x9284196b), SPH_C32(0x46571746),
    SPH_C32(0x634b4ff9), SPH_C32(0xa23c00e0), SPH_C32(0xe9d1284b),
    SPH_C32(0x07155ddc), SPH_C32(0x88d0d5f1) },
  { SPH_C32(0xd5d00180), SPH_C32(0x85a77adf), SPH_C32(0x9603bdb5),
    SPH_C32(0xa2d4627c), SPH_C32(0x289e0080), SPH_C32(0xd060bf3a),
    SPH_C32(0x60597ec2), SPH_C32(0x9d87da67) },
  { SPH_C32(0x89a20180), SPH_C32(0x4c1db7cd), SPH_C32(0xefaab04c),
    SPH_C32(0xc13d4304), SPH_C32(0xd65400a0), SPH_C32(0x983d97de),
    SPH_C32(0xe03e3f3f), SPH_C32(0x1cc15bdf) },
  { SPH_C32(0x981e01c0), SPH_C32(0xbefc96a1), SPH_C32(0xa066d61d),
    SPH_C32(0x81b75879), SPH_C32(0x50350080), SPH_C32(0x70ade50e),
    SPH_C32(0x3d05de35), SPH_C32(0xeff05eac) },
  { SPH_C32(0xc46c01c0), SPH_C32(0x77465bb3), SPH_C32(0xd9cfdbe4),
    SPH_C32(0xe25e7901), SPH_C32(0xaeff00a0), SPH_C32(0x38f0cdea),
    SPH_C32(0xbd629fc8), SPH_C32(0x6eb6df14) },
  { SPH_C32(0xad7b0180), SPH_C32(0x256a20eb), SPH_C32(0xcb5f1d42),
    SPH_C32(0xd0a3e6b7), SPH_C32(0x1dfb00c0), SPH_C32(0x4bf60970),
    SPH_C32(0x0b60b59d), SPH_C32(0xcc9364a9) },
  { SPH_C32(0xf1090180), SPH_C32(0xecd0edf9), SPH_C32(0xb2f610bb),
    SPH_C32(0xb34ac7cf), SPH_C32(0xe33100e0), SPH_C32(0x03ab2194),
    SPH_C32(0x8b07f460), SPH_C32(0x4dd5e511) },
  { SPH_C32(0xe0b501c0), SPH_C32(0x1e31cc95), SPH_C32(0xfd3a76ea),
    SPH_C32(0xf3c0dcb2), SPH_C32(0x655000c0), SPH_C32(0xeb3b5344),
    SPH_C32(0x563c156a), SPH_C32(0xbee4e062) },
  { SPH_C32(0xbcc701c0), SPH_C32(0xd78b0187), SPH_C32(0x84937b13),
    SPH_C32(0x9029fdca), SPH_C32(0x9b9a00e0), SPH_C32(0xa3667ba0),
    SPH_C32(0xd65b5497), SPH_C32(0x3fa261da) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0x2f3e0000), SPH_C32(0x5cd56ac4), SPH_C32(0xdb341f6e),
    SPH_C32(0x0d0c492c), SPH_C32(0x3a220120), SPH_C32(0x572dbeea),
    SPH_C32(0xa7738bc1), SPH_C32(0x09678d88) },
  { SPH_C32(0x3e820040), SPH_C32(0xae344ba8), SPH_C32(0x94f8793f),
    SPH_C32(0x4d865251), SPH_C32(0xbc430100), SPH_C32(0xbfbdcc3a),
    SPH_C32(0x7a486acb), SPH_C32(0xfa5688fb) },
  { SPH_C32(0x62f00040), SPH_C32(0x678e86ba), SPH_C32(0xed5174c6),
    SPH_C32(0x2e6f7329), SPH_C32(0x42890120), SPH_C32(0xf7e0e4de),
    SPH_C32(0xfa2f2b36), SPH_C32(0x7b100943) },
  { SPH_C32(0x0be70000), SPH_C32(0x35a2fde2), SPH_C32(0xffc1b260),
    SPH_C32(0x1c92ec9f), SPH_C32(0xf18d0140), SPH_C32(0x84e62044),
    SPH_C32(0x4c2d0163), SPH_C32(0xd935b2fe) },
  { SPH_C32(0x57950000), SPH_C32(0xfc1830f0), SPH_C32(0x8668bf99),
    SPH_C32(0x7f7bcde7), SPH_C32(0x0f470160), SPH_C32(0xccbb08a0),
    SPH_C32(0xcc4a409e), SPH_C32(0x58733346) },
  { SPH_C32(0x46290040), SPH_C32(0x0ef9119c), SPH_C32(0xc9a4d9c8),
    SPH_C32(0x3ff1d69a), SPH_C32(0x89260140), SPH_C32(0x242b7a70),
    SPH_C32(0x1171a194), SPH_C32(0xab423635) },
  { SPH_C32(0x1a5b0040), SPH_C32(0xc743dc8e), SPH_C32(0xb00dd431),
    SPH_C32(0x5c18f7e2), SPH_C32(0x77ec0160), SPH_C32(0x6c765294),
    SPH_C32(0x9116e069), SPH_C32(0x2a04b78d) },
  { SPH_C32(0x289e0080), SPH_C32(0xd060bf3a), SPH_C32(0x60597ec2),
    SPH_C32(0x9d87da67), SPH_C32(0xfd4e0100), SPH_C32(0x55c7c5e5),
    SPH_C32(0xf65ac377), SPH_C32(0x3f53b81b) },
  { SPH_C32(0x74ec0080), SPH_C32(0x19da7228), SPH_C32(0x19f0733b),
    SPH_C32(0xfe6efb1f), SPH_C32(0x03840120), SPH_C32(0x1d9aed01),
    SPH_C32(0x763d828a), SPH_C32(0xbe1539a3) },
  { SPH_C32(0x655000c0), SPH_C32(0xeb3b5344), SPH_C32(0x563c156a),
    SPH_C32(0xbee4e062), SPH_C32(0x85e50100), SPH_C32(0xf50a9fd1),
    SPH_C32(0xab066380), SPH_C32(0x4d243cd0) },
  { SPH_C32(0x392200c0), SPH_C32(0x22819e56), SPH_C32(0x2f951893),
    SPH_C32(0xdd0dc11a), SPH_C32(0x7b2f0120), SPH_C32(0xbd57b735),
    SPH_C32(0x2b61227d), SPH_C32(0xcc62bd68) },
  { SPH_C32(0x50350080), SPH_C32(0x70ade50e), SPH_C32(0x3d05de35),
    SPH_C32(0xeff05eac), SPH_C32(0xc82b0140), SPH_C32(0xce5173af),
    SPH_C32(0x9d630828), SPH_C32(0x6e4706d5) },
  { SPH_C32(0x0c470080), SPH_C32(0xb917281c), SPH_C32(0x44acd3cc),
    SPH_C32(0x8c197fd4), SPH_C32(0x36e10160), SPH_C32(0x860c5b4b),
    SPH_C32(0x1d0449d5), SPH_C32(0xef01876d) },
  { SPH_C32(0x1dfb00c0), SPH_C32(0x4bf60970), SPH_C32(0x0b60b59d),
    SPH_C32(0xcc9364a9), SPH_C32(0xb0800140), SPH_C32(0x6e9c299b),
    SPH_C32(0xc03fa8df), SPH_C32(0x1c30821e) },
  { SPH_C32(0x418900c0), SPH_C32(0x824cc462), SPH_C32(0x72c9b864),
    SPH_C32(0xaf7a45d1), SPH_C32(0x4e4a0160), SPH_C32(0x26c1017f),
    SPH_C32(0x4058e922), SPH_C32(0x9d7603a6) },
  { SPH_C32(0x4aea0000), SPH_C32(0xdfd8f43d), SPH_C32(0x73d31bdc),
    SPH_C32(0xd997dc7f), SPH_C32(0xa69c0180), SPH_C32(0x10c8dd09),
    SPH_C32(0x349eaf22), SPH_C32(0xcc310a28) },
  { SPH_C32(0x16980000), SPH_C32(0x1662392f), SPH_C32(0x0a7a1625),
    SPH_C32(0xba7efd07), SPH_C32(0x585601a0), SPH_C32(0x5895f5ed),
    SPH_C32(0xb4f9eedf), SPH_C32(0x4d778b90) },
  { SPH_C32(0x07240040), SPH_C32(0xe4831843), SPH_C32(0x45b67074),
    SPH_C32(0xfaf4e67a), SPH_C32(0xde370180), SPH_C32(0xb005873d),
    SPH_C32(0x69c20fd5), SPH_C32(0xbe468ee3) },
  { SPH_C32(0x5b560040), SPH_C32(0x2d39d551), SPH_C32(0x3c1f7d8d),
    SPH_C32(0x991dc702), SPH_C32(0x20fd01a0), SPH_C32(0xf858afd9),
    SPH_C32(0xe9a54e28), SPH_C32(0x3f000f5b) },
  { SPH_C32(0x32410000), SPH_C32(0x7f15ae09), SPH_C32(0x2e8fbb2b),
    SPH_C32(0xabe058b4), SPH_C32(0x93f901c0), SPH_C32(0x8b5e6b43),
    SPH_C32(0x5fa7647d), SPH_C32(0x9d25b4e6) },
  { SPH_C32(0x6e330000), SPH_C32(0xb6af631b), SPH_C32(0x5726b6d2),
    SPH_C32(0xc80979cc), SPH_C32(0x6d3301e0), SPH_C32(0xc30343a7),
    SPH_C32(0xdfc02580), SPH_C32(0x1c63355e) },
  { SPH_C32(0x7f8f0040), SPH_C32(0x444e4277), SPH_C32(0x18ead083),
    SPH_C32(0x888362b1), SPH_C32(0xeb5201c0), SPH_C32(0x2b933177),
    SPH_C32(0x02fbc48a), SPH_C32(0xef52302d) },
  { SPH_C32(0x23fd0040), SPH_C32(0x8df48f65), SPH_C32(0x6143dd7a),
    SPH_C32(0xeb6a43c9), SPH_C32(0x159801e0), SPH_C32(0x63ce1993),
    SPH_C32(0x829c8577), SPH_C32(0x6e14b195) },
  { SPH_C32(0x11380080), SPH_C32(0x9ad7ecd1), SPH_C32(0xb1177789),
    SPH_C32(0x2af56e4c), SPH_C32(0x9f3a0180), SPH_C32(0x5a7f8ee2),
    SPH_C32(0xe5d0a669), SPH_C32(0x7b43be03) },
  { SPH_C32(0x4d4a0080), SPH_C32(0x536d21c3), SPH_C32(0xc8be7a70),
    SPH_C32(0x491c4f34), SPH_C32(0x61f001a0), SPH_C32(0x1222a606),
    SPH_C32(0x65b7e794), SPH_C32(0xfa053fbb) },
  { SPH_C32(0x5cf600c0), SPH_C32(0xa18c00af), SPH_C32(0x87721c21),
    SPH_C32(0x09965449), SPH_C32(0xe7910180), SPH_C32(0xfab2d4d6),
    SPH_C32(0xb88c069e), SPH_C32(0x09343ac8) },
  { SPH_C32(0x008400c0), SPH_C32(0x6836cdbd), SPH_C32(0xfedb11d8),
    SPH_C32(0x6a7f7531), SPH_C32(0x195b01a0), SPH_C32(0xb2effc32),
    SPH_C32(0x38eb4763), SPH_C32(0x8872bb70) },
  { SPH_C32(0x69930080), SPH_C32(0x3a1ab6e5), SPH_C32(0xec4bd77e),
    SPH_C32(0x5882ea87), SPH_C32(0xaa5f01c0), SPH_C32(0xc1e938a8),
    SPH_C32(0x8ee96d36), SPH_C32(0x2a5700cd) },
  { SPH_C32(0x35e10080), SPH_C32(0xf3a07bf7), SPH_C32(0x95e2da87),
    SPH_C32(0x3b6bcbff), SPH_C32(0x549501e0), SPH_C32(0x89b4104c),
    SPH_C32(0x0e8e2ccb), SPH_C32(0xab118175) },
  { SPH_C32(0x245d00c0), SPH_C32(0x01415a9b), SPH_C32(0xda2ebcd6),
    SPH_C32(0x7be1d082), SPH_C32(0xd2f401c0), SPH_C32(0x6124629c),
    SPH_C32(0xd3b5cdc1), SPH_C32(0x58208406) },
  { SPH_C32(0x782f00c0), SPH_C32(0xc8fb9789), SPH_C32(0xa387b12f),
    SPH_C32(0x1808f1fa), SPH_C32(0x2c3e01e0), SPH_C32(0x29794a78),
    SPH_C32(0x53d28c3c), SPH_C32(0xd96605be) },
  { SPH_C32(0xc4e80100), SPH_C32(0x1f70960e), SPH_C32(0x2714ca3c),
    SPH_C32(0x88210c30), SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8),
    SPH_C32(0x8589d8ab), SPH_C32(0xe6c46464) },
  { SPH_C32(0x989a0100), SPH_C32(0xd6ca5b1c), SPH_C32(0x5ebdc7c5),
    SPH_C32(0xebc82d48), SPH_C32(0x496e0120), SPH_C32(0xc242193c),
    SPH_C32(0x05ee9956), SPH_C32(0x6782e5dc) },
  { SPH_C32(0x89260140), SPH_C32(0x242b7a70), SPH_C32(0x1171a194),
    SPH_C32(0xab423635), SPH_C32(0xcf0f0100), SPH_C32(0x2ad26bec),
    SPH_C32(0xd8d5785c), SPH_C32(0x94b3e0af) },
  { SPH_C32(0xd5540140), SPH_C32(0xed91b762), SPH_C32(0x68d8ac6d),
    SPH_C32(0xc8ab174d), SPH_C32(0x31c50120), SPH_C32(0x628f4308),
    SPH_C32(0x58b239a1), SPH_C32(0x15f56117) },
  { SPH_C32(0xbc430100), SPH_C32(0xbfbdcc3a), SPH_C32(0x7a486acb),
    SPH_C32(0xfa5688fb), SPH_C32(0x82c10140), SPH_C32(0x11898792),
    SPH_C32(0xeeb013f4), SPH_C32(0xb7d0daaa) },
  { SPH_C32(0xe0310100), SPH_C32(0x76070128), SPH_C32(0x03e16732),
    SPH_C32(0x99bfa983), SPH_C32(0x7c0b0160), SPH_C32(0x59d4af76),
    SPH_C32(0x6ed75209), SPH_C32(0x36965b12) },
  { SPH_C32(0xf18d0140), SPH_C32(0x84e62044), SPH_C32(0x4c2d0163),
    SPH_C32(0xd935b2fe), SPH_C32(0xfa6a0140), SPH_C32(0xb144dda6),
    SPH_C32(0xb3ecb303), SPH_C32(0xc5a75e61) },
  { SPH_C32(0xadff0140), SPH_C32(0x4d5ced56), SPH_C32(0x35840c9a),
    SPH_C32(0xbadc9386), SPH_C32(0x04a00160), SPH_C32(0xf919f542),
    SPH_C32(0x338bf2fe), SPH_C32(0x44e1dfd9) },
  { SPH_C32(0x9f3a0180), SPH_C32(0x5a7f8ee2), SPH_C32(0xe5d0a669),
    SPH_C32(0x7b43be03), SPH_C32(0x8e020100), SPH_C32(0xc0a86233),
    SPH_C32(0x54c7d1e0), SPH_C32(0x51b6d04f) },
  { SPH_C32(0xc3480180), SPH_C32(0x93c543f0), SPH_C32(0x9c79ab90),
    SPH_C32(0x18aa9f7b), SPH_C32(0x70c80120), SPH_C32(0x88f54ad7),
    SPH_C32(0xd4a0901d), SPH_C32(0xd0f051f7) },
  { SPH_C32(0xd2f401c0), SPH_C32(0x6124629c), SPH_C32(0xd3b5cdc1),
    SPH_C32(0x58208406), SPH_C32(0xf6a90100), SPH_C32(0x60653807),
    SPH_C32(0x099b7117), SPH_C32(0x23c15484) },
  { SPH_C32(0x8e8601c0), SPH_C32(0xa89eaf8e), SPH_C32(0xaa1cc038),
    SPH_C32(0x3bc9a57e), SPH_C32(0x08630120), SPH_C32(0x283810e3),
    SPH_C32(0x89fc30ea), SPH_C32(0xa287d53c) },
  { SPH_C32(0xe7910180), SPH_C32(0xfab2d4d6), SPH_C32(0xb88c069e),
    SPH_C32(0x09343ac8), SPH_C32(0xbb670140), SPH_C32(0x5b3ed479),
    SPH_C32(0x3ffe1abf), SPH_C32(0x00a26e81) },
  { SPH_C32(0xbbe30180), SPH_C32(0x330819c4), SPH_C32(0xc1250b67),
    SPH_C32(0x6add1bb0), SPH_C32(0x45ad0160), SPH_C32(0x1363fc9d),
    SPH_C32(0xbf995b42), SPH_C32(0x81e4ef39) },
  { SPH_C32(0xaa5f01c0), SPH_C32(0xc1e938a8), SPH_C32(0x8ee96d36),
    SPH_C32(0x2a5700cd), SPH_C32(0xc3cc0140), SPH_C32(0xfbf38e4d),
    SPH_C32(0x62a2ba48), SPH_C32(0x72d5ea4a) },
  { SPH_C32(0xf62d01c0), SPH_C32(0x0853f5ba), SPH_C32(0xf74060cf),
    SPH_C32(0x49be21b5), SPH_C32(0x3d060160), SPH_C32(0xb3aea6a9),
    SPH_C32(0xe2c5fbb5), SPH_C32(0xf3936bf2) },
  { SPH_C32(0xfd4e0100), SPH_C32(0x55c7c5e5), SPH_C32(0xf65ac377),
    SPH_C32(0x3f53b81b), SPH_C32(0xd5d00180), SPH_C32(0x85a77adf),
    SPH_C32(0x9603bdb5), SPH_C32(0xa2d4627c) },
  { SPH_C32(0xa13c0100), SPH_C32(0x9c7d08f7), SPH_C32(0x8ff3ce8e),
    SPH_C32(0x5cba9963), SPH_C32(0x2b1a01a0), SPH_C32(0xcdfa523b),
    SPH_C32(0x1664fc48), SPH_C32(0x2392e3c4) },
  { SPH_C32(0xb0800140), SPH_C32(0x6e9c299b), SPH_C32(0xc03fa8df),
    SPH_C32(0x1c30821e), SPH_C32(0xad7b0180), SPH_C32(0x256a20eb),
    SPH_C32(0xcb5f1d42), SPH_C32(0xd0a3e6b7) },
  { SPH_C32(0xecf20140), SPH_C32(0xa726e489), SPH_C32(0xb996a526),
    SPH_C32(0x7fd9a366), SPH_C32(0x53b101a0), SPH_C32(0x6d37080f),
    SPH_C32(0x4b385cbf), SPH_C32(0x51e5670f) },
  { SPH_C32(0x85e50100), SPH_C32(0xf50a9fd1), SPH_C32(0xab066380),
    SPH_C32(0x4d243cd0), SPH_C32(0xe0b501c0), SPH_C32(0x1e31cc95),
    SPH_C32(0xfd3a76ea), SPH_C32(0xf3c0dcb2) },
  { SPH_C32(0xd9970100), SPH_C32(0x3cb052c3), SPH_C32(0xd2af6e79),
    SPH_C32(0x2ecd1da8), SPH_C32(0x1e7f01e0), SPH_C32(0x566ce471),
    SPH_C32(0x7d5d3717), SPH_C32(0x72865d0a) },
  { SPH_C32(0xc82b0140), SPH_C32(0xce5173af), SPH_C32(0x9d630828),
    SPH_C32(0x6e4706d5), SPH_C32(0x981e01c0), SPH_C32(0xbefc96a1),
    SPH_C32(0xa066d61d), SPH_C32(0x81b75879) },
  { SPH_C32(0x94590140), SPH_C32(0x07ebbebd), SPH_C32(0xe4ca05d1),
    SPH_C32(0x0dae27ad), SPH_C32(0x66d401e0), SPH_C32(0xf6a1be45),
    SPH_C32(0x200197e0), SPH_C32(0x00f1d9c1) },
  { SPH_C32(0xa69c0180), SPH_C32(0x10c8dd09), SPH_C32(0x349eaf22),
    SPH_C32(0xcc310a28), SPH_C32(0xec760180), SPH_C32(0xcf102934),
    SPH_C32(0x474db4fe), SPH_C32(0x15a6d657) },
  { SPH_C32(0xfaee0180), SPH_C32(0xd972101b), SPH_C32(0x4d37a2db),
    SPH_C32(0xafd82b50), SPH_C32(0x12bc01a0), SPH_C32(0x874d01d0),
    SPH_C32(0xc72af503), SPH_C32(0x94e057ef) },
  { SPH_C32(0xeb5201c0), SPH_C32(0x2b933177), SPH_C32(0x02fbc48a),
    SPH_C32(0xef52302d), SPH_C32(0x94dd0180), SPH_C32(0x6fdd7300),
    SPH_C32(0x1a111409), SPH_C32(0x67d1529c) },
  { SPH_C32(0xb72001c0), SPH_C32(0xe229fc65), SPH_C32(0x7b52c973),
    SPH_C32(0x8cbb1155), SPH_C32(0x6a1701a0), SPH_C32(0x27805be4),
    SPH_C32(0x9a7655f4), SPH_C32(0xe697d324) },
  { SPH_C32(0xde370180), SPH_C32(0xb005873d), SPH_C32(0x69c20fd5),
    SPH_C32(0xbe468ee3), SPH_C32(0xd91301c0), SPH_C32(0x54869f7e),
    SPH_C32(0x2c747fa1), SPH_C32(0x44b26899) },
  { SPH_C32(0x82450180), SPH_C32(0x79bf4a2f), SPH_C32(0x106b022c),
    SPH_C32(0xddafaf9b), SPH_C32(0x27d901e0), SPH_C32(0x1cdbb79a),
    SPH_C32(0xac133e5c), SPH_C32(0xc5f4e921) },
  { SPH_C32(0x93f901c0), SPH_C32(0x8b5e6b43), SPH_C32(0x5fa7647d),
    SPH_C32(0x9d25b4e6), SPH_C32(0xa1b801c0), SPH_C32(0xf44bc54a),
    SPH_C32(0x7128df56), SPH_C32(0x36c5ec52) },
  { SPH_C32(0xcf8b01c0), SPH_C32(0x42e4a651), SPH_C32(0x260e6984),
    SPH_C32(0xfecc959e), SPH_C32(0x5f7201e0), SPH_C32(0xbc16edae),
    SPH_C32(0xf14f9eab), SPH_C32(0xb7836dea) }
};

__constant static const sph_u32 T256_21[128][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd), SPH_C32(0x05f7ac6d),
    SPH_C32(0xd9e6eee9), SPH_C32(0xd0080004), SPH_C32(0x8c768f77),
    SPH_C32(0x9dc5b050), SPH_C32(0xaf4a29da) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a), SPH_C32(0x63b62351),
    SPH_C32(0x17e301eb), SPH_C32(0x7cb50000), SPH_C32(0xf285caee),
    SPH_C32(0x06589f43), SPH_C32(0x2e548f6c) },
  { SPH_C32(0xc3070008), SPH_C32(0x6092c0d7), SPH_C32(0x66418f3c),
    SPH_C32(0xce05ef02), SPH_C32(0xacbd0004), SPH_C32(0x7ef34599),
    SPH_C32(0x9b9d2f13), SPH_C32(0x811ea6b6) },
  { SPH_C32(0x130f000c), SPH_C32(0xece44fa0), SPH_C32(0xfb843f6c),
    SPH_C32(0x614fc6d8), SPH_C32(0xc7140004), SPH_C32(0x3e18bc33),
    SPH_C32(0x03af332e), SPH_C32(0xf7b26185) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) },
  { SPH_C32(0xc7140004), SPH_C32(0x3e18bc33), SPH_C32(0x03af332e),
    SPH_C32(0xf7b26185), SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393),
    SPH_C32(0xf82b0c42), SPH_C32(0x96fda75d) },
  { SPH_C32(0x7cb50000), SPH_C32(0xf285caee), SPH_C32(0x06589f43),
    SPH_C32(0x2e548f6c), SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4),
    SPH_C32(0x65eebc12), SPH_C32(0x39b78e87) },
  { SPH_C32(0xacbd0004), SPH_C32(0x7ef34599), SPH_C32(0x9b9d2f13),
    SPH_C32(0x811ea6b6), SPH_C32(0x6fba000c), SPH_C32(0x1e61854e),
    SPH_C32(0xfddca02f), SPH_C32(0x4f1b49b4) },
  { SPH_C32(0xbfb20008), SPH_C32(0x92170a39), SPH_C32(0x6019107f),
    SPH_C32(0xe051606e), SPH_C32(0xa8ae0008), SPH_C32(0x2079397d),
    SPH_C32(0xfe739301), SPH_C32(0xb8a92831) },
  { SPH_C32(0x6fba000c), SPH_C32(0x1e61854e), SPH_C32(0xfddca02f),
    SPH_C32(0x4f1b49b4), SPH_C32(0xc3070008), SPH_C32(0x6092c0d7),
    SPH_C32(0x66418f3c), SPH_C32(0xce05ef02) },
  { SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393), SPH_C32(0xf82b0c42),
    SPH_C32(0x96fda75d), SPH_C32(0x130f000c), SPH_C32(0xece44fa0),
    SPH_C32(0xfb843f6c), SPH_C32(0x614fc6d8) },
  { SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4), SPH_C32(0x65eebc12),
    SPH_C32(0x39b78e87), SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a),
    SPH_C32(0x63b62351), SPH_C32(0x17e301eb) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x81540014), SPH_C32(0xcc85fd8c), SPH_C32(0x61229652),
    SPH_C32(0xde1d79bb), SPH_C32(0x45900000), SPH_C32(0x24369f23),
    SPH_C32(0xa4e61ac1), SPH_C32(0xc758578f) },
  { SPH_C32(0x3af50010), SPH_C32(0x00188b51), SPH_C32(0x64d53a3f),
    SPH_C32(0x07fb9752), SPH_C32(0x95980004), SPH_C32(0xa8401054),
    SPH_C32(0x3923aa91), SPH_C32(0x68127e55) },
  { SPH_C32(0xeafd0014), SPH_C32(0x8c6e0426), SPH_C32(0xf9108a6f),
    SPH_C32(0xa8b1be88), SPH_C32(0xfe310004), SPH_C32(0xe8abe9fe),
    SPH_C32(0xa111b6ac), SPH_C32(0x1ebeb966) },
  { SPH_C32(0xf9f20018), SPH_C32(0x608a4b86), SPH_C32(0x0294b503),
    SPH_C32(0xc9fe7850), SPH_C32(0x39250000), SPH_C32(0xd6b355cd),
    SPH_C32(0xa2be8582), SPH_C32(0xe90cd8e3) },
  { SPH_C32(0x29fa001c), SPH_C32(0xecfcc4f1), SPH_C32(0x9f510553),
    SPH_C32(0x66b4518a), SPH_C32(0x528c0000), SPH_C32(0x9658ac67),
    SPH_C32(0x3a8c99bf), SPH_C32(0x9fa01fd0) },
  { SPH_C32(0x925b0018), SPH_C32(0x2061b22c), SPH_C32(0x9aa6a93e),
    SPH_C32(0xbf52bf63), SPH_C32(0x82840004), SPH_C32(0x1a2e2310),
    SPH_C32(0xa74929ef), SPH_C32(0x30ea360a) },
  { SPH_C32(0x4253001c), SPH_C32(0xac173d5b), SPH_C32(0x0763196e),
    SPH_C32(0x101896b9), SPH_C32(0xe92d0004), SPH_C32(0x5ac5daba),
    SPH_C32(0x3f7b35d2), SPH_C32(0x4646f139) },
  { SPH_C32(0x46400010), SPH_C32(0xf29d41bf), SPH_C32(0x628da57c),
    SPH_C32(0x29af183e), SPH_C32(0x918b0008), SPH_C32(0xf6ca6cb0),
    SPH_C32(0x5ccd1683), SPH_C32(0x51a5f0d2) },
  { SPH_C32(0x96480014), SPH_C32(0x7eebcec8), SPH_C32(0xff48152c),
    SPH_C32(0x86e531e4), SPH_C32(0xfa220008), SPH_C32(0xb621951a),
    SPH_C32(0xc4ff0abe), SPH_C32(0x270937e1) },
  { SPH_C32(0x2de90010), SPH_C32(0xb276b815), SPH_C32(0xfabfb941),
    SPH_C32(0x5f03df0d), SPH_C32(0x2a2a000c), SPH_C32(0x3a571a6d),
    SPH_C32(0x593abaee), SPH_C32(0x88431e3b) },
  { SPH_C32(0xfde10014), SPH_C32(0x3e003762), SPH_C32(0x677a0911),
    SPH_C32(0xf049f6d7), SPH_C32(0x4183000c), SPH_C32(0x7abce3c7),
    SPH_C32(0xc108a6d3), SPH_C32(0xfeefd908) },
  { SPH_C32(0xeeee0018), SPH_C32(0xd2e478c2), SPH_C32(0x9cfe367d),
    SPH_C32(0x9106300f), SPH_C32(0x86970008), SPH_C32(0x44a45ff4),
    SPH_C32(0xc2a795fd), SPH_C32(0x095db88d) },
  { SPH_C32(0x3ee6001c), SPH_C32(0x5e92f7b5), SPH_C32(0x013b862d),
    SPH_C32(0x3e4c19d5), SPH_C32(0xed3e0008), SPH_C32(0x044fa65e),
    SPH_C32(0x5a9589c0), SPH_C32(0x7ff17fbe) },
  { SPH_C32(0x85470018), SPH_C32(0x920f8168), SPH_C32(0x04cc2a40),
    SPH_C32(0xe7aaf73c), SPH_C32(0x3d36000c), SPH_C32(0x88392929),
    SPH_C32(0xc7503990), SPH_C32(0xd0bb5664) },
  { SPH_C32(0x554f001c), SPH_C32(0x1e790e1f), SPH_C32(0x99099a10),
    SPH_C32(0x48e0dee6), SPH_C32(0x569f000c), SPH_C32(0xc8d2d083),
    SPH_C32(0x5f6225ad), SPH_C32(0xa6179157) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0xfe310004), SPH_C32(0xe8abe9fe), SPH_C32(0xa111b6ac),
    SPH_C32(0x1ebeb966), SPH_C32(0x14cc0010), SPH_C32(0x64c5edd8),
    SPH_C32(0x58013cc3), SPH_C32(0xb60f07ee) },
  { SPH_C32(0x45900000), SPH_C32(0x24369f23), SPH_C32(0xa4e61ac1),
    SPH_C32(0xc758578f), SPH_C32(0xc4c40014), SPH_C32(0xe8b362af),
    SPH_C32(0xc5c48c93), SPH_C32(0x19452e34) },
  { SPH_C32(0x95980004), SPH_C32(0xa8401054), SPH_C32(0x3923aa91),
    SPH_C32(0x68127e55), SPH_C32(0xaf6d0014), SPH_C32(0xa8589b05),
    SPH_C32(0x5df690ae), SPH_C32(0x6fe9e907) },
  { SPH_C32(0x86970008), SPH_C32(0x44a45ff4), SPH_C32(0xc2a795fd),
    SPH_C32(0x095db88d), SPH_C32(0x68790010), SPH_C32(0x96402736),
    SPH_C32(0x5e59a380), SPH_C32(0x985b8882) },
  { SPH_C32(0x569f000c), SPH_C32(0xc8d2d083), SPH_C32(0x5f6225ad),
    SPH_C32(0xa6179157), SPH_C32(0x03d00010), SPH_C32(0xd6abde9c),
    SPH_C32(0xc66bbfbd), SPH_C32(0xeef74fb1) },
  { SPH_C32(0xed3e0008), SPH_C32(0x044fa65e), SPH_C32(0x5a9589c0),
    SPH_C32(0x7ff17fbe), SPH_C32(0xd3d80014), SPH_C32(0x5add51eb),
    SPH_C32(0x5bae0fed), SPH_C32(0x41bd666b) },
  { SPH_C32(0x3d36000c), SPH_C32(0x88392929), SPH_C32(0xc7503990),
    SPH_C32(0xd0bb5664), SPH_C32(0xb8710014), SPH_C32(0x1a36a841),
    SPH_C32(0xc39c13d0), SPH_C32(0x3711a158) },
  { SPH_C32(0x39250000), SPH_C32(0xd6b355cd), SPH_C32(0xa2be8582),
    SPH_C32(0xe90cd8e3), SPH_C32(0xc0d70018), SPH_C32(0xb6391e4b),
    SPH_C32(0xa02a3081), SPH_C32(0x20f2a0b3) },
  { SPH_C32(0xe92d0004), SPH_C32(0x5ac5daba), SPH_C32(0x3f7b35d2),
    SPH_C32(0x4646f139), SPH_C32(0xab7e0018), SPH_C32(0xf6d2e7e1),
    SPH_C32(0x38182cbc), SPH_C32(0x565e6780) },
  { SPH_C32(0x528c0000), SPH_C32(0x9658ac67), SPH_C32(0x3a8c99bf),
    SPH_C32(0x9fa01fd0), SPH_C32(0x7b76001c), SPH_C32(0x7aa46896),
    SPH_C32(0xa5dd9cec), SPH_C32(0xf9144e5a) },
  { SPH_C32(0x82840004), SPH_C32(0x1a2e2310), SPH_C32(0xa74929ef),
    SPH_C32(0x30ea360a), SPH_C32(0x10df001c), SPH_C32(0x3a4f913c),
    SPH_C32(0x3def80d1), SPH_C32(0x8fb88969) },
  { SPH_C32(0x918b0008), SPH_C32(0xf6ca6cb0), SPH_C32(0x5ccd1683),
    SPH_C32(0x51a5f0d2), SPH_C32(0xd7cb0018), SPH_C32(0x04572d0f),
    SPH_C32(0x3e40b3ff), SPH_C32(0x780ae8ec) },
  { SPH_C32(0x4183000c), SPH_C32(0x7abce3c7), SPH_C32(0xc108a6d3),
    SPH_C32(0xfeefd908), SPH_C32(0xbc620018), SPH_C32(0x44bcd4a5),
    SPH_C32(0xa672afc2), SPH_C32(0x0ea62fdf) },
  { SPH_C32(0xfa220008), SPH_C32(0xb621951a), SPH_C32(0xc4ff0abe),
    SPH_C32(0x270937e1), SPH_C32(0x6c6a001c), SPH_C32(0xc8ca5bd2),
    SPH_C32(0x3bb71f92), SPH_C32(0xa1ec0605) },
  { SPH_C32(0x2a2a000c), SPH_C32(0x3a571a6d), SPH_C32(0x593abaee),
    SPH_C32(0x88431e3b), SPH_C32(0x07c3001c), SPH_C32(0x8821a278),
    SPH_C32(0xa38503af), SPH_C32(0xd740c136) },
  { SPH_C32(0x7f650010), SPH_C32(0x242e1472), SPH_C32(0xc03320fe),
    SPH_C32(0xc0a3c0dd), SPH_C32(0x515c0010), SPH_C32(0x40f372fb),
    SPH_C32(0xfce72602), SPH_C32(0x71575061) },
  { SPH_C32(0xaf6d0014), SPH_C32(0xa8589b05), SPH_C32(0x5df690ae),
    SPH_C32(0x6fe9e907), SPH_C32(0x3af50010), SPH_C32(0x00188b51),
    SPH_C32(0x64d53a3f), SPH_C32(0x07fb9752) },
  { SPH_C32(0x14cc0010), SPH_C32(0x64c5edd8), SPH_C32(0x58013cc3),
    SPH_C32(0xb60f07ee), SPH_C32(0xeafd0014), SPH_C32(0x8c6e0426),
    SPH_C32(0xf9108a6f), SPH_C32(0xa8b1be88) },
  { SPH_C32(0xc4c40014), SPH_C32(0xe8b362af), SPH_C32(0xc5c48c93),
    SPH_C32(0x19452e34), SPH_C32(0x81540014), SPH_C32(0xcc85fd8c),
    SPH_C32(0x61229652), SPH_C32(0xde1d79bb) },
  { SPH_C32(0xd7cb0018), SPH_C32(0x04572d0f), SPH_C32(0x3e40b3ff),
    SPH_C32(0x780ae8ec), SPH_C32(0x46400010), SPH_C32(0xf29d41bf),
    SPH_C32(0x628da57c), SPH_C32(0x29af183e) },
  { SPH_C32(0x07c3001c), SPH_C32(0x8821a278), SPH_C32(0xa38503af),
    SPH_C32(0xd740c136), SPH_C32(0x2de90010), SPH_C32(0xb276b815),
    SPH_C32(0xfabfb941), SPH_C32(0x5f03df0d) },
  { SPH_C32(0xbc620018), SPH_C32(0x44bcd4a5), SPH_C32(0xa672afc2),
    SPH_C32(0x0ea62fdf), SPH_C32(0xfde10014), SPH_C32(0x3e003762),
    SPH_C32(0x677a0911), SPH_C32(0xf049f6d7) },
  { SPH_C32(0x6c6a001c), SPH_C32(0xc8ca5bd2), SPH_C32(0x3bb71f92),
    SPH_C32(0xa1ec0605), SPH_C32(0x96480014), SPH_C32(0x7eebcec8),
    SPH_C32(0xff48152c), SPH_C32(0x86e531e4) },
  { SPH_C32(0x68790010), SPH_C32(0x96402736), SPH_C32(0x5e59a380),
    SPH_C32(0x985b8882), SPH_C32(0xeeee0018), SPH_C32(0xd2e478c2),
    SPH_C32(0x9cfe367d), SPH_C32(0x9106300f) },
  { SPH_C32(0xb8710014), SPH_C32(0x1a36a841), SPH_C32(0xc39c13d0),
    SPH_C32(0x3711a158), SPH_C32(0x85470018), SPH_C32(0x920f8168),
    SPH_C32(0x04cc2a40), SPH_C32(0xe7aaf73c) },
  { SPH_C32(0x03d00010), SPH_C32(0xd6abde9c), SPH_C32(0xc66bbfbd),
    SPH_C32(0xeef74fb1), SPH_C32(0x554f001c), SPH_C32(0x1e790e1f),
    SPH_C32(0x99099a10), SPH_C32(0x48e0dee6) },
  { SPH_C32(0xd3d80014), SPH_C32(0x5add51eb), SPH_C32(0x5bae0fed),
    SPH_C32(0x41bd666b), SPH_C32(0x3ee6001c), SPH_C32(0x5e92f7b5),
    SPH_C32(0x013b862d), SPH_C32(0x3e4c19d5) },
  { SPH_C32(0xc0d70018), SPH_C32(0xb6391e4b), SPH_C32(0xa02a3081),
    SPH_C32(0x20f2a0b3), SPH_C32(0xf9f20018), SPH_C32(0x608a4b86),
    SPH_C32(0x0294b503), SPH_C32(0xc9fe7850) },
  { SPH_C32(0x10df001c), SPH_C32(0x3a4f913c), SPH_C32(0x3def80d1),
    SPH_C32(0x8fb88969), SPH_C32(0x925b0018), SPH_C32(0x2061b22c),
    SPH_C32(0x9aa6a93e), SPH_C32(0xbf52bf63) },
  { SPH_C32(0xab7e0018), SPH_C32(0xf6d2e7e1), SPH_C32(0x38182cbc),
    SPH_C32(0x565e6780), SPH_C32(0x4253001c), SPH_C32(0xac173d5b),
    SPH_C32(0x0763196e), SPH_C32(0x101896b9) },
  { SPH_C32(0x7b76001c), SPH_C32(0x7aa46896), SPH_C32(0xa5dd9cec),
    SPH_C32(0xf9144e5a), SPH_C32(0x29fa001c), SPH_C32(0xecfcc4f1),
    SPH_C32(0x9f510553), SPH_C32(0x66b4518a) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0x72b00024), SPH_C32(0x0d916a81), SPH_C32(0x640bfc54),
    SPH_C32(0x4de5891a), SPH_C32(0x37db0000), SPH_C32(0x895134b8),
    SPH_C32(0xe19b11c4), SPH_C32(0x1545e64b) },
  { SPH_C32(0xc9110020), SPH_C32(0xc10c1c5c), SPH_C32(0x61fc5039),
    SPH_C32(0x940367f3), SPH_C32(0xe7d30004), SPH_C32(0x0527bbcf),
    SPH_C32(0x7c5ea194), SPH_C32(0xba0fcf91) },
  { SPH_C32(0x19190024), SPH_C32(0x4d7a932b), SPH_C32(0xfc39e069),
    SPH_C32(0x3b494e29), SPH_C32(0x8c7a0004), SPH_C32(0x45cc4265),
    SPH_C32(0xe46cbda9), SPH_C32(0xcca308a2) },
  { SPH_C32(0x0a160028), SPH_C32(0xa19edc8b), SPH_C32(0x07bddf05),
    SPH_C32(0x5a0688f1), SPH_C32(0x4b6e0000), SPH_C32(0x7bd4fe56),
    SPH_C32(0xe7c38e87), SPH_C32(0x3b116927) },
  { SPH_C32(0xda1e002c), SPH_C32(0x2de853fc), SPH_C32(0x9a786f55),
    SPH_C32(0xf54ca12b), SPH_C32(0x20c70000), SPH_C32(0x3b3f07fc),
    SPH_C32(0x7ff192ba), SPH_C32(0x4dbdae14) },
  { SPH_C32(0x61bf0028), SPH_C32(0xe1752521), SPH_C32(0x9f8fc338),
    SPH_C32(0x2caa4fc2), SPH_C32(0xf0cf0004), SPH_C32(0xb749888b),
    SPH_C32(0xe23422ea), SPH_C32(0xe2f787ce) },
  { SPH_C32(0xb1b7002c), SPH_C32(0x6d03aa56), SPH_C32(0x024a7368),
    SPH_C32(0x83e06618), SPH_C32(0x9b660004), SPH_C32(0xf7a27121),
    SPH_C32(0x7a063ed7), SPH_C32(0x945b40fd) },
  { SPH_C32(0xb5a40020), SPH_C32(0x3389d6b2), SPH_C32(0x67a4cf7a),
    SPH_C32(0xba57e89f), SPH_C32(0xe3c00008), SPH_C32(0x5badc72b),
    SPH_C32(0x19b01d86), SPH_C32(0x83b84116) },
  { SPH_C32(0x65ac0024), SPH_C32(0xbfff59c5), SPH_C32(0xfa617f2a),
    SPH_C32(0x151dc145), SPH_C32(0x88690008), SPH_C32(0x1b463e81),
    SPH_C32(0x818201bb), SPH_C32(0xf5148625) },
  { SPH_C32(0xde0d0020), SPH_C32(0x73622f18), SPH_C32(0xff96d347),
    SPH_C32(0xccfb2fac), SPH_C32(0x5861000c), SPH_C32(0x9730b1f6),
    SPH_C32(0x1c47b1eb), SPH_C32(0x5a5eafff) },
  { SPH_C32(0x0e050024), SPH_C32(0xff14a06f), SPH_C32(0x62536317),
    SPH_C32(0x63b10676), SPH_C32(0x33c8000c), SPH_C32(0xd7db485c),
    SPH_C32(0x8475add6), SPH_C32(0x2cf268cc) },
  { SPH_C32(0x1d0a0028), SPH_C32(0x13f0efcf), SPH_C32(0x99d75c7b),
    SPH_C32(0x02fec0ae), SPH_C32(0xf4dc0008), SPH_C32(0xe9c3f46f),
    SPH_C32(0x87da9ef8), SPH_C32(0xdb400949) },
  { SPH_C32(0xcd02002c), SPH_C32(0x9f8660b8), SPH_C32(0x0412ec2b),
    SPH_C32(0xadb4e974), SPH_C32(0x9f750008), SPH_C32(0xa9280dc5),
    SPH_C32(0x1fe882c5), SPH_C32(0xadecce7a) },
  { SPH_C32(0x76a30028), SPH_C32(0x531b1665), SPH_C32(0x01e54046),
    SPH_C32(0x7452079d), SPH_C32(0x4f7d000c), SPH_C32(0x255e82b2),
    SPH_C32(0x822d3295), SPH_C32(0x02a6e7a0) },
  { SPH_C32(0xa6ab002c), SPH_C32(0xdf6d9912), SPH_C32(0x9c20f016),
    SPH_C32(0xdb182e47), SPH_C32(0x24d4000c), SPH_C32(0x65b57b18),
    SPH_C32(0x1a1f2ea8), SPH_C32(0x740a2093) },
  { SPH_C32(0xf3e40030), SPH_C32(0xc114970d), SPH_C32(0x05296a06),
    SPH_C32(0x93f8f0a1), SPH_C32(0x724b0000), SPH_C32(0xad67ab9b),
    SPH_C32(0x457d0b05), SPH_C32(0xd21db1c4) },
  { SPH_C32(0x23ec0034), SPH_C32(0x4d62187a), SPH_C32(0x98ecda56),
    SPH_C32(0x3cb2d97b), SPH_C32(0x19e20000), SPH_C32(0xed8c5231),
    SPH_C32(0xdd4f1738), SPH_C32(0xa4b176f7) },
  { SPH_C32(0x984d0030), SPH_C32(0x81ff6ea7), SPH_C32(0x9d1b763b),
    SPH_C32(0xe5543792), SPH_C32(0xc9ea0004), SPH_C32(0x61fadd46),
    SPH_C32(0x408aa768), SPH_C32(0x0bfb5f2d) },
  { SPH_C32(0x48450034), SPH_C32(0x0d89e1d0), SPH_C32(0x00dec66b),
    SPH_C32(0x4a1e1e48), SPH_C32(0xa2430004), SPH_C32(0x211124ec),
    SPH_C32(0xd8b8bb55), SPH_C32(0x7d57981e) },
  { SPH_C32(0x5b4a0038), SPH_C32(0xe16dae70), SPH_C32(0xfb5af907),
    SPH_C32(0x2b51d890), SPH_C32(0x65570000), SPH_C32(0x1f0998df),
    SPH_C32(0xdb17887b), SPH_C32(0x8ae5f99b) },
  { SPH_C32(0x8b42003c), SPH_C32(0x6d1b2107), SPH_C32(0x669f4957),
    SPH_C32(0x841bf14a), SPH_C32(0x0efe0000), SPH_C32(0x5fe26175),
    SPH_C32(0x43259446), SPH_C32(0xfc493ea8) },
  { SPH_C32(0x30e30038), SPH_C32(0xa18657da), SPH_C32(0x6368e53a),
    SPH_C32(0x5dfd1fa3), SPH_C32(0xdef60004), SPH_C32(0xd394ee02),
    SPH_C32(0xdee02416), SPH_C32(0x53031772) },
  { SPH_C32(0xe0eb003c), SPH_C32(0x2df0d8ad), SPH_C32(0xfead556a),
    SPH_C32(0xf2b73679), SPH_C32(0xb55f0004), SPH_C32(0x937f17a8),
    SPH_C32(0x46d2382b), SPH_C32(0x25afd041) },
  { SPH_C32(0xe4f80030), SPH_C32(0x737aa449), SPH_C32(0x9b43e978),
    SPH_C32(0xcb00b8fe), SPH_C32(0xcdf90008), SPH_C32(0x3f70a1a2),
    SPH_C32(0x25641b7a), SPH_C32(0x324cd1aa) },
  { SPH_C32(0x34f00034), SPH_C32(0xff0c2b3e), SPH_C32(0x06865928),
    SPH_C32(0x644a9124), SPH_C32(0xa6500008), SPH_C32(0x7f9b5808),
    SPH_C32(0xbd560747), SPH_C32(0x44e01699) },
  { SPH_C32(0x8f510030), SPH_C32(0x33915de3), SPH_C32(0x0371f545),
    SPH_C32(0xbdac7fcd), SPH_C32(0x7658000c), SPH_C32(0xf3edd77f),
    SPH_C32(0x2093b717), SPH_C32(0xebaa3f43) },
  { SPH_C32(0x5f590034), SPH_C32(0xbfe7d294), SPH_C32(0x9eb44515),
    SPH_C32(0x12e65617), SPH_C32(0x1df1000c), SPH_C32(0xb3062ed5),
    SPH_C32(0xb8a1ab2a), SPH_C32(0x9d06f870) },
  { SPH_C32(0x4c560038), SPH_C32(0x53039d34), SPH_C32(0x65307a79),
    SPH_C32(0x73a990cf), SPH_C32(0xdae50008), SPH_C32(0x8d1e92e6),
    SPH_C32(0xbb0e9804), SPH_C32(0x6ab499f5) },
  { SPH_C32(0x9c5e003c), SPH_C32(0xdf751243), SPH_C32(0xf8f5ca29),
    SPH_C32(0xdce3b915), SPH_C32(0xb14c0008), SPH_C32(0xcdf56b4c),
    SPH_C32(0x233c8439), SPH_C32(0x1c185ec6) },
  { SPH_C32(0x27ff0038), SPH_C32(0x13e8649e), SPH_C32(0xfd026644),
    SPH_C32(0x050557fc), SPH_C32(0x6144000c), SPH_C32(0x4183e43b),
    SPH_C32(0xbef93469), SPH_C32(0xb352771c) },
  { SPH_C32(0xf7f7003c), SPH_C32(0x9f9eebe9), SPH_C32(0x60c7d614),
    SPH_C32(0xaa4f7e26), SPH_C32(0x0aed000c), SPH_C32(0x01681d91),
    SPH_C32(0x26cb2854), SPH_C32(0xc5feb02f) },
  { SPH_C32(0x8c810020), SPH_C32(0xe53a837f), SPH_C32(0xc51a4af8),
    SPH_C32(0x535b307c), SPH_C32(0x23170010), SPH_C32(0xed94d960),
    SPH_C32(0xb99a2d07), SPH_C32(0xa34ae1a5) },
  { SPH_C32(0x5c890024), SPH_C32(0x694c0c08), SPH_C32(0x58dffaa8),
    SPH_C32(0xfc1119a6), SPH_C32(0x48be0010), SPH_C32(0xad7f20ca),
    SPH_C32(0x21a8313a), SPH_C32(0xd5e62696) },
  { SPH_C32(0xe7280020), SPH_C32(0xa5d17ad5), SPH_C32(0x5d2856c5),
    SPH_C32(0x25f7f74f), SPH_C32(0x98b60014), SPH_C32(0x2109afbd),
    SPH_C32(0xbc6d816a), SPH_C32(0x7aac0f4c) },
  { SPH_C32(0x37200024), SPH_C32(0x29a7f5a2), SPH_C32(0xc0ede695),
    SPH_C32(0x8abdde95), SPH_C32(0xf31f0014), SPH_C32(0x61e25617),
    SPH_C32(0x245f9d57), SPH_C32(0x0c00c87f) },
  { SPH_C32(0x242f0028), SPH_C32(0xc543ba02), SPH_C32(0x3b69d9f9),
    SPH_C32(0xebf2184d), SPH_C32(0x340b0010), SPH_C32(0x5ffaea24),
    SPH_C32(0x27f0ae79), SPH_C32(0xfbb2a9fa) },
  { SPH_C32(0xf427002c), SPH_C32(0x49353575), SPH_C32(0xa6ac69a9),
    SPH_C32(0x44b83197), SPH_C32(0x5fa20010), SPH_C32(0x1f11138e),
    SPH_C32(0xbfc2b244), SPH_C32(0x8d1e6ec9) },
  { SPH_C32(0x4f860028), SPH_C32(0x85a843a8), SPH_C32(0xa35bc5c4),
    SPH_C32(0x9d5edf7e), SPH_C32(0x8faa0014), SPH_C32(0x93679cf9),
    SPH_C32(0x22070214), SPH_C32(0x22544713) },
  { SPH_C32(0x9f8e002c), SPH_C32(0x09deccdf), SPH_C32(0x3e9e7594),
    SPH_C32(0x3214f6a4), SPH_C32(0xe4030014), SPH_C32(0xd38c6553),
    SPH_C32(0xba351e29), SPH_C32(0x54f88020) },
  { SPH_C32(0x9b9d0020), SPH_C32(0x5754b03b), SPH_C32(0x5b70c986),
    SPH_C32(0x0ba37823), SPH_C32(0x9ca50018), SPH_C32(0x7f83d359),
    SPH_C32(0xd9833d78), SPH_C32(0x431b81cb) },
  { SPH_C32(0x4b950024), SPH_C32(0xdb223f4c), SPH_C32(0xc6b579d6),
    SPH_C32(0xa4e951f9), SPH_C32(0xf70c0018), SPH_C32(0x3f682af3),
    SPH_C32(0x41b12145), SPH_C32(0x35b746f8) },
  { SPH_C32(0xf0340020), SPH_C32(0x17bf4991), SPH_C32(0xc342d5bb),
    SPH_C32(0x7d0fbf10), SPH_C32(0x2704001c), SPH_C32(0xb31ea584),
    SPH_C32(0xdc749115), SPH_C32(0x9afd6f22) },
  { SPH_C32(0x203c0024), SPH_C32(0x9bc9c6e6), SPH_C32(0x5e8765eb),
    SPH_C32(0xd24596ca), SPH_C32(0x4cad001c), SPH_C32(0xf3f55c2e),
    SPH_C32(0x44468d28), SPH_C32(0xec51a811) },
  { SPH_C32(0x33330028), SPH_C32(0x772d8946), SPH_C32(0xa5035a87),
    SPH_C32(0xb30a5012), SPH_C32(0x8bb90018), SPH_C32(0xcdede01d),
    SPH_C32(0x47e9be06), SPH_C32(0x1be3c994) },
  { SPH_C32(0xe33b002c), SPH_C32(0xfb5b0631), SPH_C32(0x38c6ead7),
    SPH_C32(0x1c4079c8), SPH_C32(0xe0100018), SPH_C32(0x8d0619b7),
    SPH_C32(0xdfdba23b), SPH_C32(0x6d4f0ea7) },
  { SPH_C32(0x589a0028), SPH_C32(0x37c670ec), SPH_C32(0x3d3146ba),
    SPH_C32(0xc5a69721), SPH_C32(0x3018001c), SPH_C32(0x017096c0),
    SPH_C32(0x421e126b), SPH_C32(0xc205277d) },
  { SPH_C32(0x8892002c), SPH_C32(0xbbb0ff9b), SPH_C32(0xa0f4f6ea),
    SPH_C32(0x6aecbefb), SPH_C32(0x5bb1001c), SPH_C32(0x419b6f6a),
    SPH_C32(0xda2c0e56), SPH_C32(0xb4a9e04e) },
  { SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184), SPH_C32(0x39fd6cfa),
    SPH_C32(0x220c601d), SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9),
    SPH_C32(0x854e2bfb), SPH_C32(0x12be7119) },
  { SPH_C32(0x0dd50034), SPH_C32(0x29bf7ef3), SPH_C32(0xa438dcaa),
    SPH_C32(0x8d4649c7), SPH_C32(0x66870010), SPH_C32(0xc9a24643),
    SPH_C32(0x1d7c37c6), SPH_C32(0x6412b62a) },
  { SPH_C32(0xb6740030), SPH_C32(0xe522082e), SPH_C32(0xa1cf70c7),
    SPH_C32(0x54a0a72e), SPH_C32(0xb68f0014), SPH_C32(0x45d4c934),
    SPH_C32(0x80b98796), SPH_C32(0xcb589ff0) },
  { SPH_C32(0x667c0034), SPH_C32(0x69548759), SPH_C32(0x3c0ac097),
    SPH_C32(0xfbea8ef4), SPH_C32(0xdd260014), SPH_C32(0x053f309e),
    SPH_C32(0x188b9bab), SPH_C32(0xbdf458c3) },
  { SPH_C32(0x75730038), SPH_C32(0x85b0c8f9), SPH_C32(0xc78efffb),
    SPH_C32(0x9aa5482c), SPH_C32(0x1a320010), SPH_C32(0x3b278cad),
    SPH_C32(0x1b24a885), SPH_C32(0x4a463946) },
  { SPH_C32(0xa57b003c), SPH_C32(0x09c6478e), SPH_C32(0x5a4b4fab),
    SPH_C32(0x35ef61f6), SPH_C32(0x719b0010), SPH_C32(0x7bcc7507),
    SPH_C32(0x8316b4b8), SPH_C32(0x3ceafe75) },
  { SPH_C32(0x1eda0038), SPH_C32(0xc55b3153), SPH_C32(0x5fbce3c6),
    SPH_C32(0xec098f1f), SPH_C32(0xa1930014), SPH_C32(0xf7bafa70),
    SPH_C32(0x1ed304e8), SPH_C32(0x93a0d7af) },
  { SPH_C32(0xced2003c), SPH_C32(0x492dbe24), SPH_C32(0xc2795396),
    SPH_C32(0x4343a6c5), SPH_C32(0xca3a0014), SPH_C32(0xb75103da),
    SPH_C32(0x86e118d5), SPH_C32(0xe50c109c) },
  { SPH_C32(0xcac10030), SPH_C32(0x17a7c2c0), SPH_C32(0xa797ef84),
    SPH_C32(0x7af42842), SPH_C32(0xb29c0018), SPH_C32(0x1b5eb5d0),
    SPH_C32(0xe5573b84), SPH_C32(0xf2ef1177) },
  { SPH_C32(0x1ac90034), SPH_C32(0x9bd14db7), SPH_C32(0x3a525fd4),
    SPH_C32(0xd5be0198), SPH_C32(0xd9350018), SPH_C32(0x5bb54c7a),
    SPH_C32(0x7d6527b9), SPH_C32(0x8443d644) },
  { SPH_C32(0xa1680030), SPH_C32(0x574c3b6a), SPH_C32(0x3fa5f3b9),
    SPH_C32(0x0c58ef71), SPH_C32(0x093d001c), SPH_C32(0xd7c3c30d),
    SPH_C32(0xe0a097e9), SPH_C32(0x2b09ff9e) },
  { SPH_C32(0x71600034), SPH_C32(0xdb3ab41d), SPH_C32(0xa26043e9),
    SPH_C32(0xa312c6ab), SPH_C32(0x6294001c), SPH_C32(0x97283aa7),
    SPH_C32(0x78928bd4), SPH_C32(0x5da538ad) },
  { SPH_C32(0x626f0038), SPH_C32(0x37defbbd), SPH_C32(0x59e47c85),
    SPH_C32(0xc25d0073), SPH_C32(0xa5800018), SPH_C32(0xa9308694),
    SPH_C32(0x7b3db8fa), SPH_C32(0xaa175928) },
  { SPH_C32(0xb267003c), SPH_C32(0xbba874ca), SPH_C32(0xc421ccd5),
    SPH_C32(0x6d1729a9), SPH_C32(0xce290018), SPH_C32(0xe9db7f3e),
    SPH_C32(0xe30fa4c7), SPH_C32(0xdcbb9e1b) },
  { SPH_C32(0x09c60038), SPH_C32(0x77350217), SPH_C32(0xc1d660b8),
    SPH_C32(0xb4f1c740), SPH_C32(0x1e21001c), SPH_C32(0x65adf049),
    SPH_C32(0x7eca1497), SPH_C32(0x73f1b7c1) },
  { SPH_C32(0xd9ce003c), SPH_C32(0xfb438d60), SPH_C32(0x5c13d0e8),
    SPH_C32(0x1bbbee9a), SPH_C32(0x7588001c), SPH_C32(0x254609e3),
    SPH_C32(0xe6f808aa), SPH_C32(0x055d70f2) }
};

__constant static const sph_u32 T256_28[16][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x08bf0001), SPH_C32(0x38942792), SPH_C32(0xc5f8f3a1),
    SPH_C32(0xe6387b84), SPH_C32(0xc04e0001), SPH_C32(0x33b9c010),
    SPH_C32(0xae0ebb05), SPH_C32(0xb5a4c63b) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x486d0003), SPH_C32(0x6c5e67a3), SPH_C32(0x37eb3eaf),
    SPH_C32(0x38d131ca), SPH_C32(0x995d0000), SPH_C32(0x2ecee896),
    SPH_C32(0x121462e8), SPH_C32(0x410400f9) },
  { SPH_C32(0x40d20002), SPH_C32(0x54ca4031), SPH_C32(0xf213cd0e),
    SPH_C32(0xdee94a4e), SPH_C32(0x59130001), SPH_C32(0x1d772886),
    SPH_C32(0xbc1ad9ed), SPH_C32(0xf4a0c6c2) },
  { SPH_C32(0x809c0003), SPH_C32(0x67738021), SPH_C32(0x5c1d760b),
    SPH_C32(0x6b4d8c75), SPH_C32(0x91e20001), SPH_C32(0x165acf04),
    SPH_C32(0xd7ec9149), SPH_C32(0xa73c7b7d) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0x91e20001), SPH_C32(0x165acf04), SPH_C32(0xd7ec9149),
    SPH_C32(0xa73c7b7d), SPH_C32(0x117e0002), SPH_C32(0x71294f25),
    SPH_C32(0x8bf1e742), SPH_C32(0xcc71f708) },
  { SPH_C32(0x995d0000), SPH_C32(0x2ecee896), SPH_C32(0x121462e8),
    SPH_C32(0x410400f9), SPH_C32(0xd1300003), SPH_C32(0x42908f35),
    SPH_C32(0x25ff5c47), SPH_C32(0x79d53133) },
  { SPH_C32(0x59130001), SPH_C32(0x1d772886), SPH_C32(0xbc1ad9ed),
    SPH_C32(0xf4a0c6c2), SPH_C32(0x19c10003), SPH_C32(0x49bd68b7),
    SPH_C32(0x4e0914e3), SPH_C32(0x2a498c8c) },
  { SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7), SPH_C32(0xe007afe6),
    SPH_C32(0x9fed4ab7), SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3),
    SPH_C32(0x99e585aa), SPH_C32(0x8d75f7f1) },
  { SPH_C32(0x19c10003), SPH_C32(0x49bd68b7), SPH_C32(0x4e0914e3),
    SPH_C32(0x2a498c8c), SPH_C32(0x40d20002), SPH_C32(0x54ca4031),
    SPH_C32(0xf213cd0e), SPH_C32(0xdee94a4e) },
  { SPH_C32(0x117e0002), SPH_C32(0x71294f25), SPH_C32(0x8bf1e742),
    SPH_C32(0xcc71f708), SPH_C32(0x809c0003), SPH_C32(0x67738021),
    SPH_C32(0x5c1d760b), SPH_C32(0x6b4d8c75) },
  { SPH_C32(0xd1300003), SPH_C32(0x42908f35), SPH_C32(0x25ff5c47),
    SPH_C32(0x79d53133), SPH_C32(0x486d0003), SPH_C32(0x6c5e67a3),
    SPH_C32(0x37eb3eaf), SPH_C32(0x38d131ca) }
};

#define INPUT_SMALL   do { \
    unsigned acc = buf[0]; \
    const sph_u32 *rp; \
    rp = &T256_0[acc >> 1][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    acc = (acc << 8) | buf[1]; \
    rp = &T256_7[(acc >> 2) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = (acc << 8) | buf[2]; \
    rp = &T256_14[(acc >> 3) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = (acc << 8) | buf[3]; \
    rp = &T256_21[(acc >> 4) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    rp = &T256_28[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_SMALL == 8

__constant static const sph_u32 T256_0[256][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x74951000), SPH_C32(0x5a2b467e), SPH_C32(0x88fd1d2b),
    SPH_C32(0x1ee68292), SPH_C32(0xcba90000), SPH_C32(0x90273769),
    SPH_C32(0xbbdcf407), SPH_C32(0xd0f4af61) },
  { SPH_C32(0xcba90000), SPH_C32(0x90273769), SPH_C32(0xbbdcf407),
    SPH_C32(0xd0f4af61), SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117),
    SPH_C32(0x3321e92c), SPH_C32(0xce122df3) },
  { SPH_C32(0xbf3c1000), SPH_C32(0xca0c7117), SPH_C32(0x3321e92c),
    SPH_C32(0xce122df3), SPH_C32(0x74951000), SPH_C32(0x5a2b467e),
    SPH_C32(0x88fd1d2b), SPH_C32(0x1ee68292) },
  { SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc), SPH_C32(0x11fa3a57),
    SPH_C32(0x3dc90524), SPH_C32(0x97530000), SPH_C32(0x204f6ed3),
    SPH_C32(0x77b9e80f), SPH_C32(0xa1ec5ec1) },
  { SPH_C32(0x9dbf3000), SPH_C32(0xee7cca82), SPH_C32(0x9907277c),
    SPH_C32(0x232f87b6), SPH_C32(0x5cfa0000), SPH_C32(0xb06859ba),
    SPH_C32(0xcc651c08), SPH_C32(0x7118f1a0) },
  { SPH_C32(0x22832000), SPH_C32(0x2470bb95), SPH_C32(0xaa26ce50),
    SPH_C32(0xed3daa45), SPH_C32(0x286f1000), SPH_C32(0xea431fc4),
    SPH_C32(0x44980123), SPH_C32(0x6ffe7332) },
  { SPH_C32(0x56163000), SPH_C32(0x7e5bfdeb), SPH_C32(0x22dbd37b),
    SPH_C32(0xf3db28d7), SPH_C32(0xe3c61000), SPH_C32(0x7a6428ad),
    SPH_C32(0xff44f524), SPH_C32(0xbf0adc53) },
  { SPH_C32(0x97530000), SPH_C32(0x204f6ed3), SPH_C32(0x77b9e80f),
    SPH_C32(0xa1ec5ec1), SPH_C32(0x7e792000), SPH_C32(0x9418e22f),
    SPH_C32(0x6643d258), SPH_C32(0x9c255be5) },
  { SPH_C32(0xe3c61000), SPH_C32(0x7a6428ad), SPH_C32(0xff44f524),
    SPH_C32(0xbf0adc53), SPH_C32(0xb5d02000), SPH_C32(0x043fd546),
    SPH_C32(0xdd9f265f), SPH_C32(0x4cd1f484) },
  { SPH_C32(0x5cfa0000), SPH_C32(0xb06859ba), SPH_C32(0xcc651c08),
    SPH_C32(0x7118f1a0), SPH_C32(0xc1453000), SPH_C32(0x5e149338),
    SPH_C32(0x55623b74), SPH_C32(0x52377616) },
  { SPH_C32(0x286f1000), SPH_C32(0xea431fc4), SPH_C32(0x44980123),
    SPH_C32(0x6ffe7332), SPH_C32(0x0aec3000), SPH_C32(0xce33a451),
    SPH_C32(0xeebecf73), SPH_C32(0x82c3d977) },
  { SPH_C32(0x7e792000), SPH_C32(0x9418e22f), SPH_C32(0x6643d258),
    SPH_C32(0x9c255be5), SPH_C32(0xe92a2000), SPH_C32(0xb4578cfc),
    SPH_C32(0x11fa3a57), SPH_C32(0x3dc90524) },
  { SPH_C32(0x0aec3000), SPH_C32(0xce33a451), SPH_C32(0xeebecf73),
    SPH_C32(0x82c3d977), SPH_C32(0x22832000), SPH_C32(0x2470bb95),
    SPH_C32(0xaa26ce50), SPH_C32(0xed3daa45) },
  { SPH_C32(0xb5d02000), SPH_C32(0x043fd546), SPH_C32(0xdd9f265f),
    SPH_C32(0x4cd1f484), SPH_C32(0x56163000), SPH_C32(0x7e5bfdeb),
    SPH_C32(0x22dbd37b), SPH_C32(0xf3db28d7) },
  { SPH_C32(0xc1453000), SPH_C32(0x5e149338), SPH_C32(0x55623b74),
    SPH_C32(0x52377616), SPH_C32(0x9dbf3000), SPH_C32(0xee7cca82),
    SPH_C32(0x9907277c), SPH_C32(0x232f87b6) },
  { SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8), SPH_C32(0x8dfacfab),
    SPH_C32(0xce36cc72), SPH_C32(0xe6570000), SPH_C32(0x4bb33a25),
    SPH_C32(0x848598ba), SPH_C32(0x1041003e) },
  { SPH_C32(0x668e5000), SPH_C32(0x013c9f96), SPH_C32(0x0507d280),
    SPH_C32(0xd0d04ee0), SPH_C32(0x2dfe0000), SPH_C32(0xdb940d4c),
    SPH_C32(0x3f596cbd), SPH_C32(0xc0b5af5f) },
  { SPH_C32(0xd9b24000), SPH_C32(0xcb30ee81), SPH_C32(0x36263bac),
    SPH_C32(0x1ec26313), SPH_C32(0x596b1000), SPH_C32(0x81bf4b32),
    SPH_C32(0xb7a47196), SPH_C32(0xde532dcd) },
  { SPH_C32(0xad275000), SPH_C32(0x911ba8ff), SPH_C32(0xbedb2687),
    SPH_C32(0x0024e181), SPH_C32(0x92c21000), SPH_C32(0x11987c5b),
    SPH_C32(0x0c788591), SPH_C32(0x0ea782ac) },
  { SPH_C32(0xfb316000), SPH_C32(0xef405514), SPH_C32(0x9c00f5fc),
    SPH_C32(0xf3ffc956), SPH_C32(0x71040000), SPH_C32(0x6bfc54f6),
    SPH_C32(0xf33c70b5), SPH_C32(0xb1ad5eff) },
  { SPH_C32(0x8fa47000), SPH_C32(0xb56b136a), SPH_C32(0x14fde8d7),
    SPH_C32(0xed194bc4), SPH_C32(0xbaad0000), SPH_C32(0xfbdb639f),
    SPH_C32(0x48e084b2), SPH_C32(0x6159f19e) },
  { SPH_C32(0x30986000), SPH_C32(0x7f67627d), SPH_C32(0x27dc01fb),
    SPH_C32(0x230b6637), SPH_C32(0xce381000), SPH_C32(0xa1f025e1),
    SPH_C32(0xc01d9999), SPH_C32(0x7fbf730c) },
  { SPH_C32(0x440d7000), SPH_C32(0x254c2403), SPH_C32(0xaf211cd0),
    SPH_C32(0x3dede4a5), SPH_C32(0x05911000), SPH_C32(0x31d71288),
    SPH_C32(0x7bc16d9e), SPH_C32(0xaf4bdc6d) },
  { SPH_C32(0x85484000), SPH_C32(0x7b58b73b), SPH_C32(0xfa4327a4),
    SPH_C32(0x6fda92b3), SPH_C32(0x982e2000), SPH_C32(0xdfabd80a),
    SPH_C32(0xe2c64ae2), SPH_C32(0x8c645bdb) },
  { SPH_C32(0xf1dd5000), SPH_C32(0x2173f145), SPH_C32(0x72be3a8f),
    SPH_C32(0x713c1021), SPH_C32(0x53872000), SPH_C32(0x4f8cef63),
    SPH_C32(0x591abee5), SPH_C32(0x5c90f4ba) },
  { SPH_C32(0x4ee14000), SPH_C32(0xeb7f8052), SPH_C32(0x419fd3a3),
    SPH_C32(0xbf2e3dd2), SPH_C32(0x27123000), SPH_C32(0x15a7a91d),
    SPH_C32(0xd1e7a3ce), SPH_C32(0x42767628) },
  { SPH_C32(0x3a745000), SPH_C32(0xb154c62c), SPH_C32(0xc962ce88),
    SPH_C32(0xa1c8bf40), SPH_C32(0xecbb3000), SPH_C32(0x85809e74),
    SPH_C32(0x6a3b57c9), SPH_C32(0x9282d949) },
  { SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7), SPH_C32(0xebb91df3),
    SPH_C32(0x52139797), SPH_C32(0x0f7d2000), SPH_C32(0xffe4b6d9),
    SPH_C32(0x957fa2ed), SPH_C32(0x2d88051a) },
  { SPH_C32(0x18f77000), SPH_C32(0x95247db9), SPH_C32(0x634400d8),
    SPH_C32(0x4cf51505), SPH_C32(0xc4d42000), SPH_C32(0x6fc381b0),
    SPH_C32(0x2ea356ea), SPH_C32(0xfd7caa7b) },
  { SPH_C32(0xa7cb6000), SPH_C32(0x5f280cae), SPH_C32(0x5065e9f4),
    SPH_C32(0x82e738f6), SPH_C32(0xb0413000), SPH_C32(0x35e8c7ce),
    SPH_C32(0xa65e4bc1), SPH_C32(0xe39a28e9) },
  { SPH_C32(0xd35e7000), SPH_C32(0x05034ad0), SPH_C32(0xd898f4df),
    SPH_C32(0x9c01ba64), SPH_C32(0x7be83000), SPH_C32(0xa5cff0a7),
    SPH_C32(0x1d82bfc6), SPH_C32(0x336e8788) },
  { SPH_C32(0xe6570000), SPH_C32(0x4bb33a25), SPH_C32(0x848598ba),
    SPH_C32(0x1041003e), SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd),
    SPH_C32(0x097f5711), SPH_C32(0xde77cc4c) },
  { SPH_C32(0x92c21000), SPH_C32(0x11987c5b), SPH_C32(0x0c788591),
    SPH_C32(0x0ea782ac), SPH_C32(0x3fe54000), SPH_C32(0x8083d4a4),
    SPH_C32(0xb2a3a316), SPH_C32(0x0e83632d) },
  { SPH_C32(0x2dfe0000), SPH_C32(0xdb940d4c), SPH_C32(0x3f596cbd),
    SPH_C32(0xc0b5af5f), SPH_C32(0x4b705000), SPH_C32(0xdaa892da),
    SPH_C32(0x3a5ebe3d), SPH_C32(0x1065e1bf) },
  { SPH_C32(0x596b1000), SPH_C32(0x81bf4b32), SPH_C32(0xb7a47196),
    SPH_C32(0xde532dcd), SPH_C32(0x80d95000), SPH_C32(0x4a8fa5b3),
    SPH_C32(0x81824a3a), SPH_C32(0xc0914ede) },
  { SPH_C32(0x0f7d2000), SPH_C32(0xffe4b6d9), SPH_C32(0x957fa2ed),
    SPH_C32(0x2d88051a), SPH_C32(0x631f4000), SPH_C32(0x30eb8d1e),
    SPH_C32(0x7ec6bf1e), SPH_C32(0x7f9b928d) },
  { SPH_C32(0x7be83000), SPH_C32(0xa5cff0a7), SPH_C32(0x1d82bfc6),
    SPH_C32(0x336e8788), SPH_C32(0xa8b64000), SPH_C32(0xa0ccba77),
    SPH_C32(0xc51a4b19), SPH_C32(0xaf6f3dec) },
  { SPH_C32(0xc4d42000), SPH_C32(0x6fc381b0), SPH_C32(0x2ea356ea),
    SPH_C32(0xfd7caa7b), SPH_C32(0xdc235000), SPH_C32(0xfae7fc09),
    SPH_C32(0x4de75632), SPH_C32(0xb189bf7e) },
  { SPH_C32(0xb0413000), SPH_C32(0x35e8c7ce), SPH_C32(0xa65e4bc1),
    SPH_C32(0xe39a28e9), SPH_C32(0x178a5000), SPH_C32(0x6ac0cb60),
    SPH_C32(0xf63ba235), SPH_C32(0x617d101f) },
  { SPH_C32(0x71040000), SPH_C32(0x6bfc54f6), SPH_C32(0xf33c70b5),
    SPH_C32(0xb1ad5eff), SPH_C32(0x8a356000), SPH_C32(0x84bc01e2),
    SPH_C32(0x6f3c8549), SPH_C32(0x425297a9) },
  { SPH_C32(0x05911000), SPH_C32(0x31d71288), SPH_C32(0x7bc16d9e),
    SPH_C32(0xaf4bdc6d), SPH_C32(0x419c6000), SPH_C32(0x149b368b),
    SPH_C32(0xd4e0714e), SPH_C32(0x92a638c8) },
  { SPH_C32(0xbaad0000), SPH_C32(0xfbdb639f), SPH_C32(0x48e084b2),
    SPH_C32(0x6159f19e), SPH_C32(0x35097000), SPH_C32(0x4eb070f5),
    SPH_C32(0x5c1d6c65), SPH_C32(0x8c40ba5a) },
  { SPH_C32(0xce381000), SPH_C32(0xa1f025e1), SPH_C32(0xc01d9999),
    SPH_C32(0x7fbf730c), SPH_C32(0xfea07000), SPH_C32(0xde97479c),
    SPH_C32(0xe7c19862), SPH_C32(0x5cb4153b) },
  { SPH_C32(0x982e2000), SPH_C32(0xdfabd80a), SPH_C32(0xe2c64ae2),
    SPH_C32(0x8c645bdb), SPH_C32(0x1d666000), SPH_C32(0xa4f36f31),
    SPH_C32(0x18856d46), SPH_C32(0xe3bec968) },
  { SPH_C32(0xecbb3000), SPH_C32(0x85809e74), SPH_C32(0x6a3b57c9),
    SPH_C32(0x9282d949), SPH_C32(0xd6cf6000), SPH_C32(0x34d45858),
    SPH_C32(0xa3599941), SPH_C32(0x334a6609) },
  { SPH_C32(0x53872000), SPH_C32(0x4f8cef63), SPH_C32(0x591abee5),
    SPH_C32(0x5c90f4ba), SPH_C32(0xa25a7000), SPH_C32(0x6eff1e26),
    SPH_C32(0x2ba4846a), SPH_C32(0x2dace49b) },
  { SPH_C32(0x27123000), SPH_C32(0x15a7a91d), SPH_C32(0xd1e7a3ce),
    SPH_C32(0x42767628), SPH_C32(0x69f37000), SPH_C32(0xfed8294f),
    SPH_C32(0x9078706d), SPH_C32(0xfd584bfa) },
  { SPH_C32(0xf44c4000), SPH_C32(0x10a4e3cd), SPH_C32(0x097f5711),
    SPH_C32(0xde77cc4c), SPH_C32(0x121b4000), SPH_C32(0x5b17d9e8),
    SPH_C32(0x8dfacfab), SPH_C32(0xce36cc72) },
  { SPH_C32(0x80d95000), SPH_C32(0x4a8fa5b3), SPH_C32(0x81824a3a),
    SPH_C32(0xc0914ede), SPH_C32(0xd9b24000), SPH_C32(0xcb30ee81),
    SPH_C32(0x36263bac), SPH_C32(0x1ec26313) },
  { SPH_C32(0x3fe54000), SPH_C32(0x8083d4a4), SPH_C32(0xb2a3a316),
    SPH_C32(0x0e83632d), SPH_C32(0xad275000), SPH_C32(0x911ba8ff),
    SPH_C32(0xbedb2687), SPH_C32(0x0024e181) },
  { SPH_C32(0x4b705000), SPH_C32(0xdaa892da), SPH_C32(0x3a5ebe3d),
    SPH_C32(0x1065e1bf), SPH_C32(0x668e5000), SPH_C32(0x013c9f96),
    SPH_C32(0x0507d280), SPH_C32(0xd0d04ee0) },
  { SPH_C32(0x1d666000), SPH_C32(0xa4f36f31), SPH_C32(0x18856d46),
    SPH_C32(0xe3bec968), SPH_C32(0x85484000), SPH_C32(0x7b58b73b),
    SPH_C32(0xfa4327a4), SPH_C32(0x6fda92b3) },
  { SPH_C32(0x69f37000), SPH_C32(0xfed8294f), SPH_C32(0x9078706d),
    SPH_C32(0xfd584bfa), SPH_C32(0x4ee14000), SPH_C32(0xeb7f8052),
    SPH_C32(0x419fd3a3), SPH_C32(0xbf2e3dd2) },
  { SPH_C32(0xd6cf6000), SPH_C32(0x34d45858), SPH_C32(0xa3599941),
    SPH_C32(0x334a6609), SPH_C32(0x3a745000), SPH_C32(0xb154c62c),
    SPH_C32(0xc962ce88), SPH_C32(0xa1c8bf40) },
  { SPH_C32(0xa25a7000), SPH_C32(0x6eff1e26), SPH_C32(0x2ba4846a),
    SPH_C32(0x2dace49b), SPH_C32(0xf1dd5000), SPH_C32(0x2173f145),
    SPH_C32(0x72be3a8f), SPH_C32(0x713c1021) },
  { SPH_C32(0x631f4000), SPH_C32(0x30eb8d1e), SPH_C32(0x7ec6bf1e),
    SPH_C32(0x7f9b928d), SPH_C32(0x6c626000), SPH_C32(0xcf0f3bc7),
    SPH_C32(0xebb91df3), SPH_C32(0x52139797) },
  { SPH_C32(0x178a5000), SPH_C32(0x6ac0cb60), SPH_C32(0xf63ba235),
    SPH_C32(0x617d101f), SPH_C32(0xa7cb6000), SPH_C32(0x5f280cae),
    SPH_C32(0x5065e9f4), SPH_C32(0x82e738f6) },
  { SPH_C32(0xa8b64000), SPH_C32(0xa0ccba77), SPH_C32(0xc51a4b19),
    SPH_C32(0xaf6f3dec), SPH_C32(0xd35e7000), SPH_C32(0x05034ad0),
    SPH_C32(0xd898f4df), SPH_C32(0x9c01ba64) },
  { SPH_C32(0xdc235000), SPH_C32(0xfae7fc09), SPH_C32(0x4de75632),
    SPH_C32(0xb189bf7e), SPH_C32(0x18f77000), SPH_C32(0x95247db9),
    SPH_C32(0x634400d8), SPH_C32(0x4cf51505) },
  { SPH_C32(0x8a356000), SPH_C32(0x84bc01e2), SPH_C32(0x6f3c8549),
    SPH_C32(0x425297a9), SPH_C32(0xfb316000), SPH_C32(0xef405514),
    SPH_C32(0x9c00f5fc), SPH_C32(0xf3ffc956) },
  { SPH_C32(0xfea07000), SPH_C32(0xde97479c), SPH_C32(0xe7c19862),
    SPH_C32(0x5cb4153b), SPH_C32(0x30986000), SPH_C32(0x7f67627d),
    SPH_C32(0x27dc01fb), SPH_C32(0x230b6637) },
  { SPH_C32(0x419c6000), SPH_C32(0x149b368b), SPH_C32(0xd4e0714e),
    SPH_C32(0x92a638c8), SPH_C32(0x440d7000), SPH_C32(0x254c2403),
    SPH_C32(0xaf211cd0), SPH_C32(0x3dede4a5) },
  { SPH_C32(0x35097000), SPH_C32(0x4eb070f5), SPH_C32(0x5c1d6c65),
    SPH_C32(0x8c40ba5a), SPH_C32(0x8fa47000), SPH_C32(0xb56b136a),
    SPH_C32(0x14fde8d7), SPH_C32(0xed194bc4) },
  { SPH_C32(0xe4788000), SPH_C32(0x859673c1), SPH_C32(0xb5fb2452),
    SPH_C32(0x29cc5edf), SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9),
    SPH_C32(0x62fc79d0), SPH_C32(0x731ebdc2) },
  { SPH_C32(0x90ed9000), SPH_C32(0xdfbd35bf), SPH_C32(0x3d063979),
    SPH_C32(0x372adc4d), SPH_C32(0xcff60000), SPH_C32(0x0c6da4a0),
    SPH_C32(0xd9208dd7), SPH_C32(0xa3ea12a3) },
  { SPH_C32(0x2fd18000), SPH_C32(0x15b144a8), SPH_C32(0x0e27d055),
    SPH_C32(0xf938f1be), SPH_C32(0xbb631000), SPH_C32(0x5646e2de),
    SPH_C32(0x51dd90fc), SPH_C32(0xbd0c9031) },
  { SPH_C32(0x5b449000), SPH_C32(0x4f9a02d6), SPH_C32(0x86dacd7e),
    SPH_C32(0xe7de732c), SPH_C32(0x70ca1000), SPH_C32(0xc661d5b7),
    SPH_C32(0xea0164fb), SPH_C32(0x6df83f50) },
  { SPH_C32(0x0d52a000), SPH_C32(0x31c1ff3d), SPH_C32(0xa4011e05),
    SPH_C32(0x14055bfb), SPH_C32(0x930c0000), SPH_C32(0xbc05fd1a),
    SPH_C32(0x154591df), SPH_C32(0xd2f2e303) },
  { SPH_C32(0x79c7b000), SPH_C32(0x6beab943), SPH_C32(0x2cfc032e),
    SPH_C32(0x0ae3d969), SPH_C32(0x58a50000), SPH_C32(0x2c22ca73),
    SPH_C32(0xae9965d8), SPH_C32(0x02064c62) },
  { SPH_C32(0xc6fba000), SPH_C32(0xa1e6c854), SPH_C32(0x1fddea02),
    SPH_C32(0xc4f1f49a), SPH_C32(0x2c301000), SPH_C32(0x76098c0d),
    SPH_C32(0x266478f3), SPH_C32(0x1ce0cef0) },
  { SPH_C32(0xb26eb000), SPH_C32(0xfbcd8e2a), SPH_C32(0x9720f729),
    SPH_C32(0xda177608), SPH_C32(0xe7991000), SPH_C32(0xe62ebb64),
    SPH_C32(0x9db88cf4), SPH_C32(0xcc146191) },
  { SPH_C32(0x732b8000), SPH_C32(0xa5d91d12), SPH_C32(0xc242cc5d),
    SPH_C32(0x8820001e), SPH_C32(0x7a262000), SPH_C32(0x085271e6),
    SPH_C32(0x04bfab88), SPH_C32(0xef3be627) },
  { SPH_C32(0x07be9000), SPH_C32(0xfff25b6c), SPH_C32(0x4abfd176),
    SPH_C32(0x96c6828c), SPH_C32(0xb18f2000), SPH_C32(0x9875468f),
    SPH_C32(0xbf635f8f), SPH_C32(0x3fcf4946) },
  { SPH_C32(0xb8828000), SPH_C32(0x35fe2a7b), SPH_C32(0x799e385a),
    SPH_C32(0x58d4af7f), SPH_C32(0xc51a3000), SPH_C32(0xc25e00f1),
    SPH_C32(0x379e42a4), SPH_C32(0x2129cbd4) },
  { SPH_C32(0xcc179000), SPH_C32(0x6fd56c05), SPH_C32(0xf1632571),
    SPH_C32(0x46322ded), SPH_C32(0x0eb33000), SPH_C32(0x52793798),
    SPH_C32(0x8c42b6a3), SPH_C32(0xf1dd64b5) },
  { SPH_C32(0x9a01a000), SPH_C32(0x118e91ee), SPH_C32(0xd3b8f60a),
    SPH_C32(0xb5e9053a), SPH_C32(0xed752000), SPH_C32(0x281d1f35),
    SPH_C32(0x73064387), SPH_C32(0x4ed7b8e6) },
  { SPH_C32(0xee94b000), SPH_C32(0x4ba5d790), SPH_C32(0x5b45eb21),
    SPH_C32(0xab0f87a8), SPH_C32(0x26dc2000), SPH_C32(0xb83a285c),
    SPH_C32(0xc8dab780), SPH_C32(0x9e231787) },
  { SPH_C32(0x51a8a000), SPH_C32(0x81a9a687), SPH_C32(0x6864020d),
    SPH_C32(0x651daa5b), SPH_C32(0x52493000), SPH_C32(0xe2116e22),
    SPH_C32(0x4027aaab), SPH_C32(0x80c59515) },
  { SPH_C32(0x253db000), SPH_C32(0xdb82e0f9), SPH_C32(0xe0991f26),
    SPH_C32(0x7bfb28c9), SPH_C32(0x99e03000), SPH_C32(0x7236594b),
    SPH_C32(0xfbfb5eac), SPH_C32(0x50313a74) },
  { SPH_C32(0xf663c000), SPH_C32(0xde81aa29), SPH_C32(0x3801ebf9),
    SPH_C32(0xe7fa92ad), SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec),
    SPH_C32(0xe679e16a), SPH_C32(0x635fbdfc) },
  { SPH_C32(0x82f6d000), SPH_C32(0x84aaec57), SPH_C32(0xb0fcf6d2),
    SPH_C32(0xf91c103f), SPH_C32(0x29a10000), SPH_C32(0x47de9e85),
    SPH_C32(0x5da5156d), SPH_C32(0xb3ab129d) },
  { SPH_C32(0x3dcac000), SPH_C32(0x4ea69d40), SPH_C32(0x83dd1ffe),
    SPH_C32(0x370e3dcc), SPH_C32(0x5d341000), SPH_C32(0x1df5d8fb),
    SPH_C32(0xd5580846), SPH_C32(0xad4d900f) },
  { SPH_C32(0x495fd000), SPH_C32(0x148ddb3e), SPH_C32(0x0b2002d5),
    SPH_C32(0x29e8bf5e), SPH_C32(0x969d1000), SPH_C32(0x8dd2ef92),
    SPH_C32(0x6e84fc41), SPH_C32(0x7db93f6e) },
  { SPH_C32(0x1f49e000), SPH_C32(0x6ad626d5), SPH_C32(0x29fbd1ae),
    SPH_C32(0xda339789), SPH_C32(0x755b0000), SPH_C32(0xf7b6c73f),
    SPH_C32(0x91c00965), SPH_C32(0xc2b3e33d) },
  { SPH_C32(0x6bdcf000), SPH_C32(0x30fd60ab), SPH_C32(0xa106cc85),
    SPH_C32(0xc4d5151b), SPH_C32(0xbef20000), SPH_C32(0x6791f056),
    SPH_C32(0x2a1cfd62), SPH_C32(0x12474c5c) },
  { SPH_C32(0xd4e0e000), SPH_C32(0xfaf111bc), SPH_C32(0x922725a9),
    SPH_C32(0x0ac738e8), SPH_C32(0xca671000), SPH_C32(0x3dbab628),
    SPH_C32(0xa2e1e049), SPH_C32(0x0ca1cece) },
  { SPH_C32(0xa075f000), SPH_C32(0xa0da57c2), SPH_C32(0x1ada3882),
    SPH_C32(0x1421ba7a), SPH_C32(0x01ce1000), SPH_C32(0xad9d8141),
    SPH_C32(0x193d144e), SPH_C32(0xdc5561af) },
  { SPH_C32(0x6130c000), SPH_C32(0xfecec4fa), SPH_C32(0x4fb803f6),
    SPH_C32(0x4616cc6c), SPH_C32(0x9c712000), SPH_C32(0x43e14bc3),
    SPH_C32(0x803a3332), SPH_C32(0xff7ae619) },
  { SPH_C32(0x15a5d000), SPH_C32(0xa4e58284), SPH_C32(0xc7451edd),
    SPH_C32(0x58f04efe), SPH_C32(0x57d82000), SPH_C32(0xd3c67caa),
    SPH_C32(0x3be6c735), SPH_C32(0x2f8e4978) },
  { SPH_C32(0xaa99c000), SPH_C32(0x6ee9f393), SPH_C32(0xf464f7f1),
    SPH_C32(0x96e2630d), SPH_C32(0x234d3000), SPH_C32(0x89ed3ad4),
    SPH_C32(0xb31bda1e), SPH_C32(0x3168cbea) },
  { SPH_C32(0xde0cd000), SPH_C32(0x34c2b5ed), SPH_C32(0x7c99eada),
    SPH_C32(0x8804e19f), SPH_C32(0xe8e43000), SPH_C32(0x19ca0dbd),
    SPH_C32(0x08c72e19), SPH_C32(0xe19c648b) },
  { SPH_C32(0x881ae000), SPH_C32(0x4a994806), SPH_C32(0x5e4239a1),
    SPH_C32(0x7bdfc948), SPH_C32(0x0b222000), SPH_C32(0x63ae2510),
    SPH_C32(0xf783db3d), SPH_C32(0x5e96b8d8) },
  { SPH_C32(0xfc8ff000), SPH_C32(0x10b20e78), SPH_C32(0xd6bf248a),
    SPH_C32(0x65394bda), SPH_C32(0xc08b2000), SPH_C32(0xf3891279),
    SPH_C32(0x4c5f2f3a), SPH_C32(0x8e6217b9) },
  { SPH_C32(0x43b3e000), SPH_C32(0xdabe7f6f), SPH_C32(0xe59ecda6),
    SPH_C32(0xab2b6629), SPH_C32(0xb41e3000), SPH_C32(0xa9a25407),
    SPH_C32(0xc4a23211), SPH_C32(0x9084952b) },
  { SPH_C32(0x3726f000), SPH_C32(0x80953911), SPH_C32(0x6d63d08d),
    SPH_C32(0xb5cde4bb), SPH_C32(0x7fb73000), SPH_C32(0x3985636e),
    SPH_C32(0x7f7ec616), SPH_C32(0x40703a4a) },
  { SPH_C32(0x022f8000), SPH_C32(0xce2549e4), SPH_C32(0x317ebce8),
    SPH_C32(0x398d5ee1), SPH_C32(0xf0134000), SPH_C32(0x8cee7004),
    SPH_C32(0x6b832ec1), SPH_C32(0xad69718e) },
  { SPH_C32(0x76ba9000), SPH_C32(0x940e0f9a), SPH_C32(0xb983a1c3),
    SPH_C32(0x276bdc73), SPH_C32(0x3bba4000), SPH_C32(0x1cc9476d),
    SPH_C32(0xd05fdac6), SPH_C32(0x7d9ddeef) },
  { SPH_C32(0xc9868000), SPH_C32(0x5e027e8d), SPH_C32(0x8aa248ef),
    SPH_C32(0xe979f180), SPH_C32(0x4f2f5000), SPH_C32(0x46e20113),
    SPH_C32(0x58a2c7ed), SPH_C32(0x637b5c7d) },
  { SPH_C32(0xbd139000), SPH_C32(0x042938f3), SPH_C32(0x025f55c4),
    SPH_C32(0xf79f7312), SPH_C32(0x84865000), SPH_C32(0xd6c5367a),
    SPH_C32(0xe37e33ea), SPH_C32(0xb38ff31c) },
  { SPH_C32(0xeb05a000), SPH_C32(0x7a72c518), SPH_C32(0x208486bf),
    SPH_C32(0x04445bc5), SPH_C32(0x67404000), SPH_C32(0xaca11ed7),
    SPH_C32(0x1c3ac6ce), SPH_C32(0x0c852f4f) },
  { SPH_C32(0x9f90b000), SPH_C32(0x20598366), SPH_C32(0xa8799b94),
    SPH_C32(0x1aa2d957), SPH_C32(0xace94000), SPH_C32(0x3c8629be),
    SPH_C32(0xa7e632c9), SPH_C32(0xdc71802e) },
  { SPH_C32(0x20aca000), SPH_C32(0xea55f271), SPH_C32(0x9b5872b8),
    SPH_C32(0xd4b0f4a4), SPH_C32(0xd87c5000), SPH_C32(0x66ad6fc0),
    SPH_C32(0x2f1b2fe2), SPH_C32(0xc29702bc) },
  { SPH_C32(0x5439b000), SPH_C32(0xb07eb40f), SPH_C32(0x13a56f93),
    SPH_C32(0xca567636), SPH_C32(0x13d55000), SPH_C32(0xf68a58a9),
    SPH_C32(0x94c7dbe5), SPH_C32(0x1263addd) },
  { SPH_C32(0x957c8000), SPH_C32(0xee6a2737), SPH_C32(0x46c754e7),
    SPH_C32(0x98610020), SPH_C32(0x8e6a6000), SPH_C32(0x18f6922b),
    SPH_C32(0x0dc0fc99), SPH_C32(0x314c2a6b) },
  { SPH_C32(0xe1e99000), SPH_C32(0xb4416149), SPH_C32(0xce3a49cc),
    SPH_C32(0x868782b2), SPH_C32(0x45c36000), SPH_C32(0x88d1a542),
    SPH_C32(0xb61c089e), SPH_C32(0xe1b8850a) },
  { SPH_C32(0x5ed58000), SPH_C32(0x7e4d105e), SPH_C32(0xfd1ba0e0),
    SPH_C32(0x4895af41), SPH_C32(0x31567000), SPH_C32(0xd2fae33c),
    SPH_C32(0x3ee115b5), SPH_C32(0xff5e0798) },
  { SPH_C32(0x2a409000), SPH_C32(0x24665620), SPH_C32(0x75e6bdcb),
    SPH_C32(0x56732dd3), SPH_C32(0xfaff7000), SPH_C32(0x42ddd455),
    SPH_C32(0x853de1b2), SPH_C32(0x2faaa8f9) },
  { SPH_C32(0x7c56a000), SPH_C32(0x5a3dabcb), SPH_C32(0x573d6eb0),
    SPH_C32(0xa5a80504), SPH_C32(0x19396000), SPH_C32(0x38b9fcf8),
    SPH_C32(0x7a791496), SPH_C32(0x90a074aa) },
  { SPH_C32(0x08c3b000), SPH_C32(0x0016edb5), SPH_C32(0xdfc0739b),
    SPH_C32(0xbb4e8796), SPH_C32(0xd2906000), SPH_C32(0xa89ecb91),
    SPH_C32(0xc1a5e091), SPH_C32(0x4054dbcb) },
  { SPH_C32(0xb7ffa000), SPH_C32(0xca1a9ca2), SPH_C32(0xece19ab7),
    SPH_C32(0x755caa65), SPH_C32(0xa6057000), SPH_C32(0xf2b58def),
    SPH_C32(0x4958fdba), SPH_C32(0x5eb25959) },
  { SPH_C32(0xc36ab000), SPH_C32(0x9031dadc), SPH_C32(0x641c879c),
    SPH_C32(0x6bba28f7), SPH_C32(0x6dac7000), SPH_C32(0x6292ba86),
    SPH_C32(0xf28409bd), SPH_C32(0x8e46f638) },
  { SPH_C32(0x1034c000), SPH_C32(0x9532900c), SPH_C32(0xbc847343),
    SPH_C32(0xf7bb9293), SPH_C32(0x16444000), SPH_C32(0xc75d4a21),
    SPH_C32(0xef06b67b), SPH_C32(0xbd2871b0) },
  { SPH_C32(0x64a1d000), SPH_C32(0xcf19d672), SPH_C32(0x34796e68),
    SPH_C32(0xe95d1001), SPH_C32(0xdded4000), SPH_C32(0x577a7d48),
    SPH_C32(0x54da427c), SPH_C32(0x6ddcded1) },
  { SPH_C32(0xdb9dc000), SPH_C32(0x0515a765), SPH_C32(0x07588744),
    SPH_C32(0x274f3df2), SPH_C32(0xa9785000), SPH_C32(0x0d513b36),
    SPH_C32(0xdc275f57), SPH_C32(0x733a5c43) },
  { SPH_C32(0xaf08d000), SPH_C32(0x5f3ee11b), SPH_C32(0x8fa59a6f),
    SPH_C32(0x39a9bf60), SPH_C32(0x62d15000), SPH_C32(0x9d760c5f),
    SPH_C32(0x67fbab50), SPH_C32(0xa3cef322) },
  { SPH_C32(0xf91ee000), SPH_C32(0x21651cf0), SPH_C32(0xad7e4914),
    SPH_C32(0xca7297b7), SPH_C32(0x81174000), SPH_C32(0xe71224f2),
    SPH_C32(0x98bf5e74), SPH_C32(0x1cc42f71) },
  { SPH_C32(0x8d8bf000), SPH_C32(0x7b4e5a8e), SPH_C32(0x2583543f),
    SPH_C32(0xd4941525), SPH_C32(0x4abe4000), SPH_C32(0x7735139b),
    SPH_C32(0x2363aa73), SPH_C32(0xcc308010) },
  { SPH_C32(0x32b7e000), SPH_C32(0xb1422b99), SPH_C32(0x16a2bd13),
    SPH_C32(0x1a8638d6), SPH_C32(0x3e2b5000), SPH_C32(0x2d1e55e5),
    SPH_C32(0xab9eb758), SPH_C32(0xd2d60282) },
  { SPH_C32(0x4622f000), SPH_C32(0xeb696de7), SPH_C32(0x9e5fa038),
    SPH_C32(0x0460ba44), SPH_C32(0xf5825000), SPH_C32(0xbd39628c),
    SPH_C32(0x1042435f), SPH_C32(0x0222ade3) },
  { SPH_C32(0x8767c000), SPH_C32(0xb57dfedf), SPH_C32(0xcb3d9b4c),
    SPH_C32(0x5657cc52), SPH_C32(0x683d6000), SPH_C32(0x5345a80e),
    SPH_C32(0x89456423), SPH_C32(0x210d2a55) },
  { SPH_C32(0xf3f2d000), SPH_C32(0xef56b8a1), SPH_C32(0x43c08667),
    SPH_C32(0x48b14ec0), SPH_C32(0xa3946000), SPH_C32(0xc3629f67),
    SPH_C32(0x32999024), SPH_C32(0xf1f98534) },
  { SPH_C32(0x4ccec000), SPH_C32(0x255ac9b6), SPH_C32(0x70e16f4b),
    SPH_C32(0x86a36333), SPH_C32(0xd7017000), SPH_C32(0x9949d919),
    SPH_C32(0xba648d0f), SPH_C32(0xef1f07a6) },
  { SPH_C32(0x385bd000), SPH_C32(0x7f718fc8), SPH_C32(0xf81c7260),
    SPH_C32(0x9845e1a1), SPH_C32(0x1ca87000), SPH_C32(0x096eee70),
    SPH_C32(0x01b87908), SPH_C32(0x3feba8c7) },
  { SPH_C32(0x6e4de000), SPH_C32(0x012a7223), SPH_C32(0xdac7a11b),
    SPH_C32(0x6b9ec976), SPH_C32(0xff6e6000), SPH_C32(0x730ac6dd),
    SPH_C32(0xfefc8c2c), SPH_C32(0x80e17494) },
  { SPH_C32(0x1ad8f000), SPH_C32(0x5b01345d), SPH_C32(0x523abc30),
    SPH_C32(0x75784be4), SPH_C32(0x34c76000), SPH_C32(0xe32df1b4),
    SPH_C32(0x4520782b), SPH_C32(0x5015dbf5) },
  { SPH_C32(0xa5e4e000), SPH_C32(0x910d454a), SPH_C32(0x611b551c),
    SPH_C32(0xbb6a6617), SPH_C32(0x40527000), SPH_C32(0xb906b7ca),
    SPH_C32(0xcddd6500), SPH_C32(0x4ef35967) },
  { SPH_C32(0xd171f000), SPH_C32(0xcb260334), SPH_C32(0xe9e64837),
    SPH_C32(0xa58ce485), SPH_C32(0x8bfb7000), SPH_C32(0x292180a3),
    SPH_C32(0x76019107), SPH_C32(0x9e07f606) },
  { SPH_C32(0x045f0000), SPH_C32(0x9c4a93c9), SPH_C32(0x62fc79d0),
    SPH_C32(0x731ebdc2), SPH_C32(0xe0278000), SPH_C32(0x19dce008),
    SPH_C32(0xd7075d82), SPH_C32(0x5ad2e31d) },
  { SPH_C32(0x70ca1000), SPH_C32(0xc661d5b7), SPH_C32(0xea0164fb),
    SPH_C32(0x6df83f50), SPH_C32(0x2b8e8000), SPH_C32(0x89fbd761),
    SPH_C32(0x6cdba985), SPH_C32(0x8a264c7c) },
  { SPH_C32(0xcff60000), SPH_C32(0x0c6da4a0), SPH_C32(0xd9208dd7),
    SPH_C32(0xa3ea12a3), SPH_C32(0x5f1b9000), SPH_C32(0xd3d0911f),
    SPH_C32(0xe426b4ae), SPH_C32(0x94c0ceee) },
  { SPH_C32(0xbb631000), SPH_C32(0x5646e2de), SPH_C32(0x51dd90fc),
    SPH_C32(0xbd0c9031), SPH_C32(0x94b29000), SPH_C32(0x43f7a676),
    SPH_C32(0x5ffa40a9), SPH_C32(0x4434618f) },
  { SPH_C32(0xed752000), SPH_C32(0x281d1f35), SPH_C32(0x73064387),
    SPH_C32(0x4ed7b8e6), SPH_C32(0x77748000), SPH_C32(0x39938edb),
    SPH_C32(0xa0beb58d), SPH_C32(0xfb3ebddc) },
  { SPH_C32(0x99e03000), SPH_C32(0x7236594b), SPH_C32(0xfbfb5eac),
    SPH_C32(0x50313a74), SPH_C32(0xbcdd8000), SPH_C32(0xa9b4b9b2),
    SPH_C32(0x1b62418a), SPH_C32(0x2bca12bd) },
  { SPH_C32(0x26dc2000), SPH_C32(0xb83a285c), SPH_C32(0xc8dab780),
    SPH_C32(0x9e231787), SPH_C32(0xc8489000), SPH_C32(0xf39fffcc),
    SPH_C32(0x939f5ca1), SPH_C32(0x352c902f) },
  { SPH_C32(0x52493000), SPH_C32(0xe2116e22), SPH_C32(0x4027aaab),
    SPH_C32(0x80c59515), SPH_C32(0x03e19000), SPH_C32(0x63b8c8a5),
    SPH_C32(0x2843a8a6), SPH_C32(0xe5d83f4e) },
  { SPH_C32(0x930c0000), SPH_C32(0xbc05fd1a), SPH_C32(0x154591df),
    SPH_C32(0xd2f2e303), SPH_C32(0x9e5ea000), SPH_C32(0x8dc40227),
    SPH_C32(0xb1448fda), SPH_C32(0xc6f7b8f8) },
  { SPH_C32(0xe7991000), SPH_C32(0xe62ebb64), SPH_C32(0x9db88cf4),
    SPH_C32(0xcc146191), SPH_C32(0x55f7a000), SPH_C32(0x1de3354e),
    SPH_C32(0x0a987bdd), SPH_C32(0x16031799) },
  { SPH_C32(0x58a50000), SPH_C32(0x2c22ca73), SPH_C32(0xae9965d8),
    SPH_C32(0x02064c62), SPH_C32(0x2162b000), SPH_C32(0x47c87330),
    SPH_C32(0x826566f6), SPH_C32(0x08e5950b) },
  { SPH_C32(0x2c301000), SPH_C32(0x76098c0d), SPH_C32(0x266478f3),
    SPH_C32(0x1ce0cef0), SPH_C32(0xeacbb000), SPH_C32(0xd7ef4459),
    SPH_C32(0x39b992f1), SPH_C32(0xd8113a6a) },
  { SPH_C32(0x7a262000), SPH_C32(0x085271e6), SPH_C32(0x04bfab88),
    SPH_C32(0xef3be627), SPH_C32(0x090da000), SPH_C32(0xad8b6cf4),
    SPH_C32(0xc6fd67d5), SPH_C32(0x671be639) },
  { SPH_C32(0x0eb33000), SPH_C32(0x52793798), SPH_C32(0x8c42b6a3),
    SPH_C32(0xf1dd64b5), SPH_C32(0xc2a4a000), SPH_C32(0x3dac5b9d),
    SPH_C32(0x7d2193d2), SPH_C32(0xb7ef4958) },
  { SPH_C32(0xb18f2000), SPH_C32(0x9875468f), SPH_C32(0xbf635f8f),
    SPH_C32(0x3fcf4946), SPH_C32(0xb631b000), SPH_C32(0x67871de3),
    SPH_C32(0xf5dc8ef9), SPH_C32(0xa909cbca) },
  { SPH_C32(0xc51a3000), SPH_C32(0xc25e00f1), SPH_C32(0x379e42a4),
    SPH_C32(0x2129cbd4), SPH_C32(0x7d98b000), SPH_C32(0xf7a02a8a),
    SPH_C32(0x4e007afe), SPH_C32(0x79fd64ab) },
  { SPH_C32(0x16444000), SPH_C32(0xc75d4a21), SPH_C32(0xef06b67b),
    SPH_C32(0xbd2871b0), SPH_C32(0x06708000), SPH_C32(0x526fda2d),
    SPH_C32(0x5382c538), SPH_C32(0x4a93e323) },
  { SPH_C32(0x62d15000), SPH_C32(0x9d760c5f), SPH_C32(0x67fbab50),
    SPH_C32(0xa3cef322), SPH_C32(0xcdd98000), SPH_C32(0xc248ed44),
    SPH_C32(0xe85e313f), SPH_C32(0x9a674c42) },
  { SPH_C32(0xdded4000), SPH_C32(0x577a7d48), SPH_C32(0x54da427c),
    SPH_C32(0x6ddcded1), SPH_C32(0xb94c9000), SPH_C32(0x9863ab3a),
    SPH_C32(0x60a32c14), SPH_C32(0x8481ced0) },
  { SPH_C32(0xa9785000), SPH_C32(0x0d513b36), SPH_C32(0xdc275f57),
    SPH_C32(0x733a5c43), SPH_C32(0x72e59000), SPH_C32(0x08449c53),
    SPH_C32(0xdb7fd813), SPH_C32(0x547561b1) },
  { SPH_C32(0xff6e6000), SPH_C32(0x730ac6dd), SPH_C32(0xfefc8c2c),
    SPH_C32(0x80e17494), SPH_C32(0x91238000), SPH_C32(0x7220b4fe),
    SPH_C32(0x243b2d37), SPH_C32(0xeb7fbde2) },
  { SPH_C32(0x8bfb7000), SPH_C32(0x292180a3), SPH_C32(0x76019107),
    SPH_C32(0x9e07f606), SPH_C32(0x5a8a8000), SPH_C32(0xe2078397),
    SPH_C32(0x9fe7d930), SPH_C32(0x3b8b1283) },
  { SPH_C32(0x34c76000), SPH_C32(0xe32df1b4), SPH_C32(0x4520782b),
    SPH_C32(0x5015dbf5), SPH_C32(0x2e1f9000), SPH_C32(0xb82cc5e9),
    SPH_C32(0x171ac41b), SPH_C32(0x256d9011) },
  { SPH_C32(0x40527000), SPH_C32(0xb906b7ca), SPH_C32(0xcddd6500),
    SPH_C32(0x4ef35967), SPH_C32(0xe5b69000), SPH_C32(0x280bf280),
    SPH_C32(0xacc6301c), SPH_C32(0xf5993f70) },
  { SPH_C32(0x81174000), SPH_C32(0xe71224f2), SPH_C32(0x98bf5e74),
    SPH_C32(0x1cc42f71), SPH_C32(0x7809a000), SPH_C32(0xc6773802),
    SPH_C32(0x35c11760), SPH_C32(0xd6b6b8c6) },
  { SPH_C32(0xf5825000), SPH_C32(0xbd39628c), SPH_C32(0x1042435f),
    SPH_C32(0x0222ade3), SPH_C32(0xb3a0a000), SPH_C32(0x56500f6b),
    SPH_C32(0x8e1de367), SPH_C32(0x064217a7) },
  { SPH_C32(0x4abe4000), SPH_C32(0x7735139b), SPH_C32(0x2363aa73),
    SPH_C32(0xcc308010), SPH_C32(0xc735b000), SPH_C32(0x0c7b4915),
    SPH_C32(0x06e0fe4c), SPH_C32(0x18a49535) },
  { SPH_C32(0x3e2b5000), SPH_C32(0x2d1e55e5), SPH_C32(0xab9eb758),
    SPH_C32(0xd2d60282), SPH_C32(0x0c9cb000), SPH_C32(0x9c5c7e7c),
    SPH_C32(0xbd3c0a4b), SPH_C32(0xc8503a54) },
  { SPH_C32(0x683d6000), SPH_C32(0x5345a80e), SPH_C32(0x89456423),
    SPH_C32(0x210d2a55), SPH_C32(0xef5aa000), SPH_C32(0xe63856d1),
    SPH_C32(0x4278ff6f), SPH_C32(0x775ae607) },
  { SPH_C32(0x1ca87000), SPH_C32(0x096eee70), SPH_C32(0x01b87908),
    SPH_C32(0x3feba8c7), SPH_C32(0x24f3a000), SPH_C32(0x761f61b8),
    SPH_C32(0xf9a40b68), SPH_C32(0xa7ae4966) },
  { SPH_C32(0xa3946000), SPH_C32(0xc3629f67), SPH_C32(0x32999024),
    SPH_C32(0xf1f98534), SPH_C32(0x5066b000), SPH_C32(0x2c3427c6),
    SPH_C32(0x71591643), SPH_C32(0xb948cbf4) },
  { SPH_C32(0xd7017000), SPH_C32(0x9949d919), SPH_C32(0xba648d0f),
    SPH_C32(0xef1f07a6), SPH_C32(0x9bcfb000), SPH_C32(0xbc1310af),
    SPH_C32(0xca85e244), SPH_C32(0x69bc6495) },
  { SPH_C32(0xe2080000), SPH_C32(0xd7f9a9ec), SPH_C32(0xe679e16a),
    SPH_C32(0x635fbdfc), SPH_C32(0x146bc000), SPH_C32(0x097803c5),
    SPH_C32(0xde780a93), SPH_C32(0x84a52f51) },
  { SPH_C32(0x969d1000), SPH_C32(0x8dd2ef92), SPH_C32(0x6e84fc41),
    SPH_C32(0x7db93f6e), SPH_C32(0xdfc2c000), SPH_C32(0x995f34ac),
    SPH_C32(0x65a4fe94), SPH_C32(0x54518030) },
  { SPH_C32(0x29a10000), SPH_C32(0x47de9e85), SPH_C32(0x5da5156d),
    SPH_C32(0xb3ab129d), SPH_C32(0xab57d000), SPH_C32(0xc37472d2),
    SPH_C32(0xed59e3bf), SPH_C32(0x4ab702a2) },
  { SPH_C32(0x5d341000), SPH_C32(0x1df5d8fb), SPH_C32(0xd5580846),
    SPH_C32(0xad4d900f), SPH_C32(0x60fed000), SPH_C32(0x535345bb),
    SPH_C32(0x568517b8), SPH_C32(0x9a43adc3) },
  { SPH_C32(0x0b222000), SPH_C32(0x63ae2510), SPH_C32(0xf783db3d),
    SPH_C32(0x5e96b8d8), SPH_C32(0x8338c000), SPH_C32(0x29376d16),
    SPH_C32(0xa9c1e29c), SPH_C32(0x25497190) },
  { SPH_C32(0x7fb73000), SPH_C32(0x3985636e), SPH_C32(0x7f7ec616),
    SPH_C32(0x40703a4a), SPH_C32(0x4891c000), SPH_C32(0xb9105a7f),
    SPH_C32(0x121d169b), SPH_C32(0xf5bddef1) },
  { SPH_C32(0xc08b2000), SPH_C32(0xf3891279), SPH_C32(0x4c5f2f3a),
    SPH_C32(0x8e6217b9), SPH_C32(0x3c04d000), SPH_C32(0xe33b1c01),
    SPH_C32(0x9ae00bb0), SPH_C32(0xeb5b5c63) },
  { SPH_C32(0xb41e3000), SPH_C32(0xa9a25407), SPH_C32(0xc4a23211),
    SPH_C32(0x9084952b), SPH_C32(0xf7add000), SPH_C32(0x731c2b68),
    SPH_C32(0x213cffb7), SPH_C32(0x3baff302) },
  { SPH_C32(0x755b0000), SPH_C32(0xf7b6c73f), SPH_C32(0x91c00965),
    SPH_C32(0xc2b3e33d), SPH_C32(0x6a12e000), SPH_C32(0x9d60e1ea),
    SPH_C32(0xb83bd8cb), SPH_C32(0x188074b4) },
  { SPH_C32(0x01ce1000), SPH_C32(0xad9d8141), SPH_C32(0x193d144e),
    SPH_C32(0xdc5561af), SPH_C32(0xa1bbe000), SPH_C32(0x0d47d683),
    SPH_C32(0x03e72ccc), SPH_C32(0xc874dbd5) },
  { SPH_C32(0xbef20000), SPH_C32(0x6791f056), SPH_C32(0x2a1cfd62),
    SPH_C32(0x12474c5c), SPH_C32(0xd52ef000), SPH_C32(0x576c90fd),
    SPH_C32(0x8b1a31e7), SPH_C32(0xd6925947) },
  { SPH_C32(0xca671000), SPH_C32(0x3dbab628), SPH_C32(0xa2e1e049),
    SPH_C32(0x0ca1cece), SPH_C32(0x1e87f000), SPH_C32(0xc74ba794),
    SPH_C32(0x30c6c5e0), SPH_C32(0x0666f626) },
  { SPH_C32(0x9c712000), SPH_C32(0x43e14bc3), SPH_C32(0x803a3332),
    SPH_C32(0xff7ae619), SPH_C32(0xfd41e000), SPH_C32(0xbd2f8f39),
    SPH_C32(0xcf8230c4), SPH_C32(0xb96c2a75) },
  { SPH_C32(0xe8e43000), SPH_C32(0x19ca0dbd), SPH_C32(0x08c72e19),
    SPH_C32(0xe19c648b), SPH_C32(0x36e8e000), SPH_C32(0x2d08b850),
    SPH_C32(0x745ec4c3), SPH_C32(0x69988514) },
  { SPH_C32(0x57d82000), SPH_C32(0xd3c67caa), SPH_C32(0x3be6c735),
    SPH_C32(0x2f8e4978), SPH_C32(0x427df000), SPH_C32(0x7723fe2e),
    SPH_C32(0xfca3d9e8), SPH_C32(0x777e0786) },
  { SPH_C32(0x234d3000), SPH_C32(0x89ed3ad4), SPH_C32(0xb31bda1e),
    SPH_C32(0x3168cbea), SPH_C32(0x89d4f000), SPH_C32(0xe704c947),
    SPH_C32(0x477f2def), SPH_C32(0xa78aa8e7) },
  { SPH_C32(0xf0134000), SPH_C32(0x8cee7004), SPH_C32(0x6b832ec1),
    SPH_C32(0xad69718e), SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0),
    SPH_C32(0x5afd9229), SPH_C32(0x94e42f6f) },
  { SPH_C32(0x84865000), SPH_C32(0xd6c5367a), SPH_C32(0xe37e33ea),
    SPH_C32(0xb38ff31c), SPH_C32(0x3995c000), SPH_C32(0xd2ec0e89),
    SPH_C32(0xe121662e), SPH_C32(0x4410800e) },
  { SPH_C32(0x3bba4000), SPH_C32(0x1cc9476d), SPH_C32(0xd05fdac6),
    SPH_C32(0x7d9ddeef), SPH_C32(0x4d00d000), SPH_C32(0x88c748f7),
    SPH_C32(0x69dc7b05), SPH_C32(0x5af6029c) },
  { SPH_C32(0x4f2f5000), SPH_C32(0x46e20113), SPH_C32(0x58a2c7ed),
    SPH_C32(0x637b5c7d), SPH_C32(0x86a9d000), SPH_C32(0x18e07f9e),
    SPH_C32(0xd2008f02), SPH_C32(0x8a02adfd) },
  { SPH_C32(0x19396000), SPH_C32(0x38b9fcf8), SPH_C32(0x7a791496),
    SPH_C32(0x90a074aa), SPH_C32(0x656fc000), SPH_C32(0x62845733),
    SPH_C32(0x2d447a26), SPH_C32(0x350871ae) },
  { SPH_C32(0x6dac7000), SPH_C32(0x6292ba86), SPH_C32(0xf28409bd),
    SPH_C32(0x8e46f638), SPH_C32(0xaec6c000), SPH_C32(0xf2a3605a),
    SPH_C32(0x96988e21), SPH_C32(0xe5fcdecf) },
  { SPH_C32(0xd2906000), SPH_C32(0xa89ecb91), SPH_C32(0xc1a5e091),
    SPH_C32(0x4054dbcb), SPH_C32(0xda53d000), SPH_C32(0xa8882624),
    SPH_C32(0x1e65930a), SPH_C32(0xfb1a5c5d) },
  { SPH_C32(0xa6057000), SPH_C32(0xf2b58def), SPH_C32(0x4958fdba),
    SPH_C32(0x5eb25959), SPH_C32(0x11fad000), SPH_C32(0x38af114d),
    SPH_C32(0xa5b9670d), SPH_C32(0x2beef33c) },
  { SPH_C32(0x67404000), SPH_C32(0xaca11ed7), SPH_C32(0x1c3ac6ce),
    SPH_C32(0x0c852f4f), SPH_C32(0x8c45e000), SPH_C32(0xd6d3dbcf),
    SPH_C32(0x3cbe4071), SPH_C32(0x08c1748a) },
  { SPH_C32(0x13d55000), SPH_C32(0xf68a58a9), SPH_C32(0x94c7dbe5),
    SPH_C32(0x1263addd), SPH_C32(0x47ece000), SPH_C32(0x46f4eca6),
    SPH_C32(0x8762b476), SPH_C32(0xd835dbeb) },
  { SPH_C32(0xace94000), SPH_C32(0x3c8629be), SPH_C32(0xa7e632c9),
    SPH_C32(0xdc71802e), SPH_C32(0x3379f000), SPH_C32(0x1cdfaad8),
    SPH_C32(0x0f9fa95d), SPH_C32(0xc6d35979) },
  { SPH_C32(0xd87c5000), SPH_C32(0x66ad6fc0), SPH_C32(0x2f1b2fe2),
    SPH_C32(0xc29702bc), SPH_C32(0xf8d0f000), SPH_C32(0x8cf89db1),
    SPH_C32(0xb4435d5a), SPH_C32(0x1627f618) },
  { SPH_C32(0x8e6a6000), SPH_C32(0x18f6922b), SPH_C32(0x0dc0fc99),
    SPH_C32(0x314c2a6b), SPH_C32(0x1b16e000), SPH_C32(0xf69cb51c),
    SPH_C32(0x4b07a87e), SPH_C32(0xa92d2a4b) },
  { SPH_C32(0xfaff7000), SPH_C32(0x42ddd455), SPH_C32(0x853de1b2),
    SPH_C32(0x2faaa8f9), SPH_C32(0xd0bfe000), SPH_C32(0x66bb8275),
    SPH_C32(0xf0db5c79), SPH_C32(0x79d9852a) },
  { SPH_C32(0x45c36000), SPH_C32(0x88d1a542), SPH_C32(0xb61c089e),
    SPH_C32(0xe1b8850a), SPH_C32(0xa42af000), SPH_C32(0x3c90c40b),
    SPH_C32(0x78264152), SPH_C32(0x673f07b8) },
  { SPH_C32(0x31567000), SPH_C32(0xd2fae33c), SPH_C32(0x3ee115b5),
    SPH_C32(0xff5e0798), SPH_C32(0x6f83f000), SPH_C32(0xacb7f362),
    SPH_C32(0xc3fab555), SPH_C32(0xb7cba8d9) },
  { SPH_C32(0xe0278000), SPH_C32(0x19dce008), SPH_C32(0xd7075d82),
    SPH_C32(0x5ad2e31d), SPH_C32(0xe4788000), SPH_C32(0x859673c1),
    SPH_C32(0xb5fb2452), SPH_C32(0x29cc5edf) },
  { SPH_C32(0x94b29000), SPH_C32(0x43f7a676), SPH_C32(0x5ffa40a9),
    SPH_C32(0x4434618f), SPH_C32(0x2fd18000), SPH_C32(0x15b144a8),
    SPH_C32(0x0e27d055), SPH_C32(0xf938f1be) },
  { SPH_C32(0x2b8e8000), SPH_C32(0x89fbd761), SPH_C32(0x6cdba985),
    SPH_C32(0x8a264c7c), SPH_C32(0x5b449000), SPH_C32(0x4f9a02d6),
    SPH_C32(0x86dacd7e), SPH_C32(0xe7de732c) },
  { SPH_C32(0x5f1b9000), SPH_C32(0xd3d0911f), SPH_C32(0xe426b4ae),
    SPH_C32(0x94c0ceee), SPH_C32(0x90ed9000), SPH_C32(0xdfbd35bf),
    SPH_C32(0x3d063979), SPH_C32(0x372adc4d) },
  { SPH_C32(0x090da000), SPH_C32(0xad8b6cf4), SPH_C32(0xc6fd67d5),
    SPH_C32(0x671be639), SPH_C32(0x732b8000), SPH_C32(0xa5d91d12),
    SPH_C32(0xc242cc5d), SPH_C32(0x8820001e) },
  { SPH_C32(0x7d98b000), SPH_C32(0xf7a02a8a), SPH_C32(0x4e007afe),
    SPH_C32(0x79fd64ab), SPH_C32(0xb8828000), SPH_C32(0x35fe2a7b),
    SPH_C32(0x799e385a), SPH_C32(0x58d4af7f) },
  { SPH_C32(0xc2a4a000), SPH_C32(0x3dac5b9d), SPH_C32(0x7d2193d2),
    SPH_C32(0xb7ef4958), SPH_C32(0xcc179000), SPH_C32(0x6fd56c05),
    SPH_C32(0xf1632571), SPH_C32(0x46322ded) },
  { SPH_C32(0xb631b000), SPH_C32(0x67871de3), SPH_C32(0xf5dc8ef9),
    SPH_C32(0xa909cbca), SPH_C32(0x07be9000), SPH_C32(0xfff25b6c),
    SPH_C32(0x4abfd176), SPH_C32(0x96c6828c) },
  { SPH_C32(0x77748000), SPH_C32(0x39938edb), SPH_C32(0xa0beb58d),
    SPH_C32(0xfb3ebddc), SPH_C32(0x9a01a000), SPH_C32(0x118e91ee),
    SPH_C32(0xd3b8f60a), SPH_C32(0xb5e9053a) },
  { SPH_C32(0x03e19000), SPH_C32(0x63b8c8a5), SPH_C32(0x2843a8a6),
    SPH_C32(0xe5d83f4e), SPH_C32(0x51a8a000), SPH_C32(0x81a9a687),
    SPH_C32(0x6864020d), SPH_C32(0x651daa5b) },
  { SPH_C32(0xbcdd8000), SPH_C32(0xa9b4b9b2), SPH_C32(0x1b62418a),
    SPH_C32(0x2bca12bd), SPH_C32(0x253db000), SPH_C32(0xdb82e0f9),
    SPH_C32(0xe0991f26), SPH_C32(0x7bfb28c9) },
  { SPH_C32(0xc8489000), SPH_C32(0xf39fffcc), SPH_C32(0x939f5ca1),
    SPH_C32(0x352c902f), SPH_C32(0xee94b000), SPH_C32(0x4ba5d790),
    SPH_C32(0x5b45eb21), SPH_C32(0xab0f87a8) },
  { SPH_C32(0x9e5ea000), SPH_C32(0x8dc40227), SPH_C32(0xb1448fda),
    SPH_C32(0xc6f7b8f8), SPH_C32(0x0d52a000), SPH_C32(0x31c1ff3d),
    SPH_C32(0xa4011e05), SPH_C32(0x14055bfb) },
  { SPH_C32(0xeacbb000), SPH_C32(0xd7ef4459), SPH_C32(0x39b992f1),
    SPH_C32(0xd8113a6a), SPH_C32(0xc6fba000), SPH_C32(0xa1e6c854),
    SPH_C32(0x1fddea02), SPH_C32(0xc4f1f49a) },
  { SPH_C32(0x55f7a000), SPH_C32(0x1de3354e), SPH_C32(0x0a987bdd),
    SPH_C32(0x16031799), SPH_C32(0xb26eb000), SPH_C32(0xfbcd8e2a),
    SPH_C32(0x9720f729), SPH_C32(0xda177608) },
  { SPH_C32(0x2162b000), SPH_C32(0x47c87330), SPH_C32(0x826566f6),
    SPH_C32(0x08e5950b), SPH_C32(0x79c7b000), SPH_C32(0x6beab943),
    SPH_C32(0x2cfc032e), SPH_C32(0x0ae3d969) },
  { SPH_C32(0xf23cc000), SPH_C32(0x42cb39e0), SPH_C32(0x5afd9229),
    SPH_C32(0x94e42f6f), SPH_C32(0x022f8000), SPH_C32(0xce2549e4),
    SPH_C32(0x317ebce8), SPH_C32(0x398d5ee1) },
  { SPH_C32(0x86a9d000), SPH_C32(0x18e07f9e), SPH_C32(0xd2008f02),
    SPH_C32(0x8a02adfd), SPH_C32(0xc9868000), SPH_C32(0x5e027e8d),
    SPH_C32(0x8aa248ef), SPH_C32(0xe979f180) },
  { SPH_C32(0x3995c000), SPH_C32(0xd2ec0e89), SPH_C32(0xe121662e),
    SPH_C32(0x4410800e), SPH_C32(0xbd139000), SPH_C32(0x042938f3),
    SPH_C32(0x025f55c4), SPH_C32(0xf79f7312) },
  { SPH_C32(0x4d00d000), SPH_C32(0x88c748f7), SPH_C32(0x69dc7b05),
    SPH_C32(0x5af6029c), SPH_C32(0x76ba9000), SPH_C32(0x940e0f9a),
    SPH_C32(0xb983a1c3), SPH_C32(0x276bdc73) },
  { SPH_C32(0x1b16e000), SPH_C32(0xf69cb51c), SPH_C32(0x4b07a87e),
    SPH_C32(0xa92d2a4b), SPH_C32(0x957c8000), SPH_C32(0xee6a2737),
    SPH_C32(0x46c754e7), SPH_C32(0x98610020) },
  { SPH_C32(0x6f83f000), SPH_C32(0xacb7f362), SPH_C32(0xc3fab555),
    SPH_C32(0xb7cba8d9), SPH_C32(0x5ed58000), SPH_C32(0x7e4d105e),
    SPH_C32(0xfd1ba0e0), SPH_C32(0x4895af41) },
  { SPH_C32(0xd0bfe000), SPH_C32(0x66bb8275), SPH_C32(0xf0db5c79),
    SPH_C32(0x79d9852a), SPH_C32(0x2a409000), SPH_C32(0x24665620),
    SPH_C32(0x75e6bdcb), SPH_C32(0x56732dd3) },
  { SPH_C32(0xa42af000), SPH_C32(0x3c90c40b), SPH_C32(0x78264152),
    SPH_C32(0x673f07b8), SPH_C32(0xe1e99000), SPH_C32(0xb4416149),
    SPH_C32(0xce3a49cc), SPH_C32(0x868782b2) },
  { SPH_C32(0x656fc000), SPH_C32(0x62845733), SPH_C32(0x2d447a26),
    SPH_C32(0x350871ae), SPH_C32(0x7c56a000), SPH_C32(0x5a3dabcb),
    SPH_C32(0x573d6eb0), SPH_C32(0xa5a80504) },
  { SPH_C32(0x11fad000), SPH_C32(0x38af114d), SPH_C32(0xa5b9670d),
    SPH_C32(0x2beef33c), SPH_C32(0xb7ffa000), SPH_C32(0xca1a9ca2),
    SPH_C32(0xece19ab7), SPH_C32(0x755caa65) },
  { SPH_C32(0xaec6c000), SPH_C32(0xf2a3605a), SPH_C32(0x96988e21),
    SPH_C32(0xe5fcdecf), SPH_C32(0xc36ab000), SPH_C32(0x9031dadc),
    SPH_C32(0x641c879c), SPH_C32(0x6bba28f7) },
  { SPH_C32(0xda53d000), SPH_C32(0xa8882624), SPH_C32(0x1e65930a),
    SPH_C32(0xfb1a5c5d), SPH_C32(0x08c3b000), SPH_C32(0x0016edb5),
    SPH_C32(0xdfc0739b), SPH_C32(0xbb4e8796) },
  { SPH_C32(0x8c45e000), SPH_C32(0xd6d3dbcf), SPH_C32(0x3cbe4071),
    SPH_C32(0x08c1748a), SPH_C32(0xeb05a000), SPH_C32(0x7a72c518),
    SPH_C32(0x208486bf), SPH_C32(0x04445bc5) },
  { SPH_C32(0xf8d0f000), SPH_C32(0x8cf89db1), SPH_C32(0xb4435d5a),
    SPH_C32(0x1627f618), SPH_C32(0x20aca000), SPH_C32(0xea55f271),
    SPH_C32(0x9b5872b8), SPH_C32(0xd4b0f4a4) },
  { SPH_C32(0x47ece000), SPH_C32(0x46f4eca6), SPH_C32(0x8762b476),
    SPH_C32(0xd835dbeb), SPH_C32(0x5439b000), SPH_C32(0xb07eb40f),
    SPH_C32(0x13a56f93), SPH_C32(0xca567636) },
  { SPH_C32(0x3379f000), SPH_C32(0x1cdfaad8), SPH_C32(0x0f9fa95d),
    SPH_C32(0xc6d35979), SPH_C32(0x9f90b000), SPH_C32(0x20598366),
    SPH_C32(0xa8799b94), SPH_C32(0x1aa2d957) },
  { SPH_C32(0x06708000), SPH_C32(0x526fda2d), SPH_C32(0x5382c538),
    SPH_C32(0x4a93e323), SPH_C32(0x1034c000), SPH_C32(0x9532900c),
    SPH_C32(0xbc847343), SPH_C32(0xf7bb9293) },
  { SPH_C32(0x72e59000), SPH_C32(0x08449c53), SPH_C32(0xdb7fd813),
    SPH_C32(0x547561b1), SPH_C32(0xdb9dc000), SPH_C32(0x0515a765),
    SPH_C32(0x07588744), SPH_C32(0x274f3df2) },
  { SPH_C32(0xcdd98000), SPH_C32(0xc248ed44), SPH_C32(0xe85e313f),
    SPH_C32(0x9a674c42), SPH_C32(0xaf08d000), SPH_C32(0x5f3ee11b),
    SPH_C32(0x8fa59a6f), SPH_C32(0x39a9bf60) },
  { SPH_C32(0xb94c9000), SPH_C32(0x9863ab3a), SPH_C32(0x60a32c14),
    SPH_C32(0x8481ced0), SPH_C32(0x64a1d000), SPH_C32(0xcf19d672),
    SPH_C32(0x34796e68), SPH_C32(0xe95d1001) },
  { SPH_C32(0xef5aa000), SPH_C32(0xe63856d1), SPH_C32(0x4278ff6f),
    SPH_C32(0x775ae607), SPH_C32(0x8767c000), SPH_C32(0xb57dfedf),
    SPH_C32(0xcb3d9b4c), SPH_C32(0x5657cc52) },
  { SPH_C32(0x9bcfb000), SPH_C32(0xbc1310af), SPH_C32(0xca85e244),
    SPH_C32(0x69bc6495), SPH_C32(0x4ccec000), SPH_C32(0x255ac9b6),
    SPH_C32(0x70e16f4b), SPH_C32(0x86a36333) },
  { SPH_C32(0x24f3a000), SPH_C32(0x761f61b8), SPH_C32(0xf9a40b68),
    SPH_C32(0xa7ae4966), SPH_C32(0x385bd000), SPH_C32(0x7f718fc8),
    SPH_C32(0xf81c7260), SPH_C32(0x9845e1a1) },
  { SPH_C32(0x5066b000), SPH_C32(0x2c3427c6), SPH_C32(0x71591643),
    SPH_C32(0xb948cbf4), SPH_C32(0xf3f2d000), SPH_C32(0xef56b8a1),
    SPH_C32(0x43c08667), SPH_C32(0x48b14ec0) },
  { SPH_C32(0x91238000), SPH_C32(0x7220b4fe), SPH_C32(0x243b2d37),
    SPH_C32(0xeb7fbde2), SPH_C32(0x6e4de000), SPH_C32(0x012a7223),
    SPH_C32(0xdac7a11b), SPH_C32(0x6b9ec976) },
  { SPH_C32(0xe5b69000), SPH_C32(0x280bf280), SPH_C32(0xacc6301c),
    SPH_C32(0xf5993f70), SPH_C32(0xa5e4e000), SPH_C32(0x910d454a),
    SPH_C32(0x611b551c), SPH_C32(0xbb6a6617) },
  { SPH_C32(0x5a8a8000), SPH_C32(0xe2078397), SPH_C32(0x9fe7d930),
    SPH_C32(0x3b8b1283), SPH_C32(0xd171f000), SPH_C32(0xcb260334),
    SPH_C32(0xe9e64837), SPH_C32(0xa58ce485) },
  { SPH_C32(0x2e1f9000), SPH_C32(0xb82cc5e9), SPH_C32(0x171ac41b),
    SPH_C32(0x256d9011), SPH_C32(0x1ad8f000), SPH_C32(0x5b01345d),
    SPH_C32(0x523abc30), SPH_C32(0x75784be4) },
  { SPH_C32(0x7809a000), SPH_C32(0xc6773802), SPH_C32(0x35c11760),
    SPH_C32(0xd6b6b8c6), SPH_C32(0xf91ee000), SPH_C32(0x21651cf0),
    SPH_C32(0xad7e4914), SPH_C32(0xca7297b7) },
  { SPH_C32(0x0c9cb000), SPH_C32(0x9c5c7e7c), SPH_C32(0xbd3c0a4b),
    SPH_C32(0xc8503a54), SPH_C32(0x32b7e000), SPH_C32(0xb1422b99),
    SPH_C32(0x16a2bd13), SPH_C32(0x1a8638d6) },
  { SPH_C32(0xb3a0a000), SPH_C32(0x56500f6b), SPH_C32(0x8e1de367),
    SPH_C32(0x064217a7), SPH_C32(0x4622f000), SPH_C32(0xeb696de7),
    SPH_C32(0x9e5fa038), SPH_C32(0x0460ba44) },
  { SPH_C32(0xc735b000), SPH_C32(0x0c7b4915), SPH_C32(0x06e0fe4c),
    SPH_C32(0x18a49535), SPH_C32(0x8d8bf000), SPH_C32(0x7b4e5a8e),
    SPH_C32(0x2583543f), SPH_C32(0xd4941525) },
  { SPH_C32(0x146bc000), SPH_C32(0x097803c5), SPH_C32(0xde780a93),
    SPH_C32(0x84a52f51), SPH_C32(0xf663c000), SPH_C32(0xde81aa29),
    SPH_C32(0x3801ebf9), SPH_C32(0xe7fa92ad) },
  { SPH_C32(0x60fed000), SPH_C32(0x535345bb), SPH_C32(0x568517b8),
    SPH_C32(0x9a43adc3), SPH_C32(0x3dcac000), SPH_C32(0x4ea69d40),
    SPH_C32(0x83dd1ffe), SPH_C32(0x370e3dcc) },
  { SPH_C32(0xdfc2c000), SPH_C32(0x995f34ac), SPH_C32(0x65a4fe94),
    SPH_C32(0x54518030), SPH_C32(0x495fd000), SPH_C32(0x148ddb3e),
    SPH_C32(0x0b2002d5), SPH_C32(0x29e8bf5e) },
  { SPH_C32(0xab57d000), SPH_C32(0xc37472d2), SPH_C32(0xed59e3bf),
    SPH_C32(0x4ab702a2), SPH_C32(0x82f6d000), SPH_C32(0x84aaec57),
    SPH_C32(0xb0fcf6d2), SPH_C32(0xf91c103f) },
  { SPH_C32(0xfd41e000), SPH_C32(0xbd2f8f39), SPH_C32(0xcf8230c4),
    SPH_C32(0xb96c2a75), SPH_C32(0x6130c000), SPH_C32(0xfecec4fa),
    SPH_C32(0x4fb803f6), SPH_C32(0x4616cc6c) },
  { SPH_C32(0x89d4f000), SPH_C32(0xe704c947), SPH_C32(0x477f2def),
    SPH_C32(0xa78aa8e7), SPH_C32(0xaa99c000), SPH_C32(0x6ee9f393),
    SPH_C32(0xf464f7f1), SPH_C32(0x96e2630d) },
  { SPH_C32(0x36e8e000), SPH_C32(0x2d08b850), SPH_C32(0x745ec4c3),
    SPH_C32(0x69988514), SPH_C32(0xde0cd000), SPH_C32(0x34c2b5ed),
    SPH_C32(0x7c99eada), SPH_C32(0x8804e19f) },
  { SPH_C32(0x427df000), SPH_C32(0x7723fe2e), SPH_C32(0xfca3d9e8),
    SPH_C32(0x777e0786), SPH_C32(0x15a5d000), SPH_C32(0xa4e58284),
    SPH_C32(0xc7451edd), SPH_C32(0x58f04efe) },
  { SPH_C32(0x8338c000), SPH_C32(0x29376d16), SPH_C32(0xa9c1e29c),
    SPH_C32(0x25497190), SPH_C32(0x881ae000), SPH_C32(0x4a994806),
    SPH_C32(0x5e4239a1), SPH_C32(0x7bdfc948) },
  { SPH_C32(0xf7add000), SPH_C32(0x731c2b68), SPH_C32(0x213cffb7),
    SPH_C32(0x3baff302), SPH_C32(0x43b3e000), SPH_C32(0xdabe7f6f),
    SPH_C32(0xe59ecda6), SPH_C32(0xab2b6629) },
  { SPH_C32(0x4891c000), SPH_C32(0xb9105a7f), SPH_C32(0x121d169b),
    SPH_C32(0xf5bddef1), SPH_C32(0x3726f000), SPH_C32(0x80953911),
    SPH_C32(0x6d63d08d), SPH_C32(0xb5cde4bb) },
  { SPH_C32(0x3c04d000), SPH_C32(0xe33b1c01), SPH_C32(0x9ae00bb0),
    SPH_C32(0xeb5b5c63), SPH_C32(0xfc8ff000), SPH_C32(0x10b20e78),
    SPH_C32(0xd6bf248a), SPH_C32(0x65394bda) },
  { SPH_C32(0x6a12e000), SPH_C32(0x9d60e1ea), SPH_C32(0xb83bd8cb),
    SPH_C32(0x188074b4), SPH_C32(0x1f49e000), SPH_C32(0x6ad626d5),
    SPH_C32(0x29fbd1ae), SPH_C32(0xda339789) },
  { SPH_C32(0x1e87f000), SPH_C32(0xc74ba794), SPH_C32(0x30c6c5e0),
    SPH_C32(0x0666f626), SPH_C32(0xd4e0e000), SPH_C32(0xfaf111bc),
    SPH_C32(0x922725a9), SPH_C32(0x0ac738e8) },
  { SPH_C32(0xa1bbe000), SPH_C32(0x0d47d683), SPH_C32(0x03e72ccc),
    SPH_C32(0xc874dbd5), SPH_C32(0xa075f000), SPH_C32(0xa0da57c2),
    SPH_C32(0x1ada3882), SPH_C32(0x1421ba7a) },
  { SPH_C32(0xd52ef000), SPH_C32(0x576c90fd), SPH_C32(0x8b1a31e7),
    SPH_C32(0xd6925947), SPH_C32(0x6bdcf000), SPH_C32(0x30fd60ab),
    SPH_C32(0xa106cc85), SPH_C32(0xc4d5151b) }
};

__constant static const sph_u32 T256_8[256][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8), SPH_C32(0x8589d8ab),
    SPH_C32(0xe6c46464), SPH_C32(0x734c0000), SPH_C32(0x956fa7d6),
    SPH_C32(0xa29d1297), SPH_C32(0x6ee56854) },
  { SPH_C32(0x734c0000), SPH_C32(0x956fa7d6), SPH_C32(0xa29d1297),
    SPH_C32(0x6ee56854), SPH_C32(0xc4e80100), SPH_C32(0x1f70960e),
    SPH_C32(0x2714ca3c), SPH_C32(0x88210c30) },
  { SPH_C32(0xc4e80100), SPH_C32(0x1f70960e), SPH_C32(0x2714ca3c),
    SPH_C32(0x88210c30), SPH_C32(0xb7a40100), SPH_C32(0x8a1f31d8),
    SPH_C32(0x8589d8ab), SPH_C32(0xe6c46464) },
  { SPH_C32(0xa7b80200), SPH_C32(0x1f128433), SPH_C32(0x60e5f9f2),
    SPH_C32(0x9e147576), SPH_C32(0xee260000), SPH_C32(0x124b683e),
    SPH_C32(0x80c2d68f), SPH_C32(0x3bf3ab2c) },
  { SPH_C32(0x101c0300), SPH_C32(0x950db5eb), SPH_C32(0xe56c2159),
    SPH_C32(0x78d01112), SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8),
    SPH_C32(0x225fc418), SPH_C32(0x5516c378) },
  { SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5), SPH_C32(0xc278eb65),
    SPH_C32(0xf0f11d22), SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30),
    SPH_C32(0xa7d61cb3), SPH_C32(0xb3d2a71c) },
  { SPH_C32(0x63500300), SPH_C32(0x0062123d), SPH_C32(0x47f133ce),
    SPH_C32(0x16357946), SPH_C32(0x59820100), SPH_C32(0x985459e6),
    SPH_C32(0x054b0e24), SPH_C32(0xdd37cf48) },
  { SPH_C32(0xee260000), SPH_C32(0x124b683e), SPH_C32(0x80c2d68f),
    SPH_C32(0x3bf3ab2c), SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d),
    SPH_C32(0xe0272f7d), SPH_C32(0xa5e7de5a) },
  { SPH_C32(0x59820100), SPH_C32(0x985459e6), SPH_C32(0x054b0e24),
    SPH_C32(0xdd37cf48), SPH_C32(0x3ad20200), SPH_C32(0x98364bdb),
    SPH_C32(0x42ba3dea), SPH_C32(0xcb02b60e) },
  { SPH_C32(0x9d6a0000), SPH_C32(0x8724cfe8), SPH_C32(0x225fc418),
    SPH_C32(0x5516c378), SPH_C32(0x8d760300), SPH_C32(0x12297a03),
    SPH_C32(0xc733e541), SPH_C32(0x2dc6d26a) },
  { SPH_C32(0x2ace0100), SPH_C32(0x0d3bfe30), SPH_C32(0xa7d61cb3),
    SPH_C32(0xb3d2a71c), SPH_C32(0xfe3a0300), SPH_C32(0x8746ddd5),
    SPH_C32(0x65aef7d6), SPH_C32(0x4323ba3e) },
  { SPH_C32(0x499e0200), SPH_C32(0x0d59ec0d), SPH_C32(0xe0272f7d),
    SPH_C32(0xa5e7de5a), SPH_C32(0xa7b80200), SPH_C32(0x1f128433),
    SPH_C32(0x60e5f9f2), SPH_C32(0x9e147576) },
  { SPH_C32(0xfe3a0300), SPH_C32(0x8746ddd5), SPH_C32(0x65aef7d6),
    SPH_C32(0x4323ba3e), SPH_C32(0xd4f40200), SPH_C32(0x8a7d23e5),
    SPH_C32(0xc278eb65), SPH_C32(0xf0f11d22) },
  { SPH_C32(0x3ad20200), SPH_C32(0x98364bdb), SPH_C32(0x42ba3dea),
    SPH_C32(0xcb02b60e), SPH_C32(0x63500300), SPH_C32(0x0062123d),
    SPH_C32(0x47f133ce), SPH_C32(0x16357946) },
  { SPH_C32(0x8d760300), SPH_C32(0x12297a03), SPH_C32(0xc733e541),
    SPH_C32(0x2dc6d26a), SPH_C32(0x101c0300), SPH_C32(0x950db5eb),
    SPH_C32(0xe56c2159), SPH_C32(0x78d01112) },
  { SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877), SPH_C32(0x6fc548e1),
    SPH_C32(0x898d2cd6), SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff),
    SPH_C32(0x6a72e5bb), SPH_C32(0x247febe6) },
  { SPH_C32(0x389a0500), SPH_C32(0x8782f9af), SPH_C32(0xea4c904a),
    SPH_C32(0x6f4948b2), SPH_C32(0x67f10000), SPH_C32(0xbad59029),
    SPH_C32(0xc8eff72c), SPH_C32(0x4a9a83b2) },
  { SPH_C32(0xfc720400), SPH_C32(0x98f26fa1), SPH_C32(0xcd585a76),
    SPH_C32(0xe7684482), SPH_C32(0xd0550100), SPH_C32(0x30caa1f1),
    SPH_C32(0x4d662f87), SPH_C32(0xac5ee7d6) },
  { SPH_C32(0x4bd60500), SPH_C32(0x12ed5e79), SPH_C32(0x48d182dd),
    SPH_C32(0x01ac20e6), SPH_C32(0xa3190100), SPH_C32(0xa5a50627),
    SPH_C32(0xeffb3d10), SPH_C32(0xc2bb8f82) },
  { SPH_C32(0x28860600), SPH_C32(0x128f4c44), SPH_C32(0x0f20b113),
    SPH_C32(0x179959a0), SPH_C32(0xfa9b0000), SPH_C32(0x3df15fc1),
    SPH_C32(0xeab03334), SPH_C32(0x1f8c40ca) },
  { SPH_C32(0x9f220700), SPH_C32(0x98907d9c), SPH_C32(0x8aa969b8),
    SPH_C32(0xf15d3dc4), SPH_C32(0x89d70000), SPH_C32(0xa89ef817),
    SPH_C32(0x482d21a3), SPH_C32(0x7169289e) },
  { SPH_C32(0x5bca0600), SPH_C32(0x87e0eb92), SPH_C32(0xadbda384),
    SPH_C32(0x797c31f4), SPH_C32(0x3e730100), SPH_C32(0x2281c9cf),
    SPH_C32(0xcda4f908), SPH_C32(0x97ad4cfa) },
  { SPH_C32(0xec6e0700), SPH_C32(0x0dffda4a), SPH_C32(0x28347b2f),
    SPH_C32(0x9fb85590), SPH_C32(0x4d3f0100), SPH_C32(0xb7ee6e19),
    SPH_C32(0x6f39eb9f), SPH_C32(0xf94824ae) },
  { SPH_C32(0x61180400), SPH_C32(0x1fd6a049), SPH_C32(0xef079e6e),
    SPH_C32(0xb27e87fa), SPH_C32(0x5d230200), SPH_C32(0x22e3dbf2),
    SPH_C32(0x8a55cac6), SPH_C32(0x819835bc) },
  { SPH_C32(0xd6bc0500), SPH_C32(0x95c99191), SPH_C32(0x6a8e46c5),
    SPH_C32(0x54bae39e), SPH_C32(0x2e6f0200), SPH_C32(0xb78c7c24),
    SPH_C32(0x28c8d851), SPH_C32(0xef7d5de8) },
  { SPH_C32(0x12540400), SPH_C32(0x8ab9079f), SPH_C32(0x4d9a8cf9),
    SPH_C32(0xdc9befae), SPH_C32(0x99cb0300), SPH_C32(0x3d934dfc),
    SPH_C32(0xad4100fa), SPH_C32(0x09b9398c) },
  { SPH_C32(0xa5f00500), SPH_C32(0x00a63647), SPH_C32(0xc8135452),
    SPH_C32(0x3a5f8bca), SPH_C32(0xea870300), SPH_C32(0xa8fcea2a),
    SPH_C32(0x0fdc126d), SPH_C32(0x675c51d8) },
  { SPH_C32(0xc6a00600), SPH_C32(0x00c4247a), SPH_C32(0x8fe2679c),
    SPH_C32(0x2c6af28c), SPH_C32(0xb3050200), SPH_C32(0x30a8b3cc),
    SPH_C32(0x0a971c49), SPH_C32(0xba6b9e90) },
  { SPH_C32(0x71040700), SPH_C32(0x8adb15a2), SPH_C32(0x0a6bbf37),
    SPH_C32(0xcaae96e8), SPH_C32(0xc0490200), SPH_C32(0xa5c7141a),
    SPH_C32(0xa80a0ede), SPH_C32(0xd48ef6c4) },
  { SPH_C32(0xb5ec0600), SPH_C32(0x95ab83ac), SPH_C32(0x2d7f750b),
    SPH_C32(0x428f9ad8), SPH_C32(0x77ed0300), SPH_C32(0x2fd825c2),
    SPH_C32(0x2d83d675), SPH_C32(0x324a92a0) },
  { SPH_C32(0x02480700), SPH_C32(0x1fb4b274), SPH_C32(0xa8f6ada0),
    SPH_C32(0xa44bfebc), SPH_C32(0x04a10300), SPH_C32(0xbab78214),
    SPH_C32(0x8f1ec4e2), SPH_C32(0x5caffaf4) },
  { SPH_C32(0x14bd0000), SPH_C32(0x2fba37ff), SPH_C32(0x6a72e5bb),
    SPH_C32(0x247febe6), SPH_C32(0x9b830400), SPH_C32(0x2227ff88),
    SPH_C32(0x05b7ad5a), SPH_C32(0xadf2c730) },
  { SPH_C32(0xa3190100), SPH_C32(0xa5a50627), SPH_C32(0xeffb3d10),
    SPH_C32(0xc2bb8f82), SPH_C32(0xe8cf0400), SPH_C32(0xb748585e),
    SPH_C32(0xa72abfcd), SPH_C32(0xc317af64) },
  { SPH_C32(0x67f10000), SPH_C32(0xbad59029), SPH_C32(0xc8eff72c),
    SPH_C32(0x4a9a83b2), SPH_C32(0x5f6b0500), SPH_C32(0x3d576986),
    SPH_C32(0x22a36766), SPH_C32(0x25d3cb00) },
  { SPH_C32(0xd0550100), SPH_C32(0x30caa1f1), SPH_C32(0x4d662f87),
    SPH_C32(0xac5ee7d6), SPH_C32(0x2c270500), SPH_C32(0xa838ce50),
    SPH_C32(0x803e75f1), SPH_C32(0x4b36a354) },
  { SPH_C32(0xb3050200), SPH_C32(0x30a8b3cc), SPH_C32(0x0a971c49),
    SPH_C32(0xba6b9e90), SPH_C32(0x75a50400), SPH_C32(0x306c97b6),
    SPH_C32(0x85757bd5), SPH_C32(0x96016c1c) },
  { SPH_C32(0x04a10300), SPH_C32(0xbab78214), SPH_C32(0x8f1ec4e2),
    SPH_C32(0x5caffaf4), SPH_C32(0x06e90400), SPH_C32(0xa5033060),
    SPH_C32(0x27e86942), SPH_C32(0xf8e40448) },
  { SPH_C32(0xc0490200), SPH_C32(0xa5c7141a), SPH_C32(0xa80a0ede),
    SPH_C32(0xd48ef6c4), SPH_C32(0xb14d0500), SPH_C32(0x2f1c01b8),
    SPH_C32(0xa261b1e9), SPH_C32(0x1e20602c) },
  { SPH_C32(0x77ed0300), SPH_C32(0x2fd825c2), SPH_C32(0x2d83d675),
    SPH_C32(0x324a92a0), SPH_C32(0xc2010500), SPH_C32(0xba73a66e),
    SPH_C32(0x00fca37e), SPH_C32(0x70c50878) },
  { SPH_C32(0xfa9b0000), SPH_C32(0x3df15fc1), SPH_C32(0xeab03334),
    SPH_C32(0x1f8c40ca), SPH_C32(0xd21d0600), SPH_C32(0x2f7e1385),
    SPH_C32(0xe5908227), SPH_C32(0x0815196a) },
  { SPH_C32(0x4d3f0100), SPH_C32(0xb7ee6e19), SPH_C32(0x6f39eb9f),
    SPH_C32(0xf94824ae), SPH_C32(0xa1510600), SPH_C32(0xba11b453),
    SPH_C32(0x470d90b0), SPH_C32(0x66f0713e) },
  { SPH_C32(0x89d70000), SPH_C32(0xa89ef817), SPH_C32(0x482d21a3),
    SPH_C32(0x7169289e), SPH_C32(0x16f50700), SPH_C32(0x300e858b),
    SPH_C32(0xc284481b), SPH_C32(0x8034155a) },
  { SPH_C32(0x3e730100), SPH_C32(0x2281c9cf), SPH_C32(0xcda4f908),
    SPH_C32(0x97ad4cfa), SPH_C32(0x65b90700), SPH_C32(0xa561225d),
    SPH_C32(0x60195a8c), SPH_C32(0xeed17d0e) },
  { SPH_C32(0x5d230200), SPH_C32(0x22e3dbf2), SPH_C32(0x8a55cac6),
    SPH_C32(0x819835bc), SPH_C32(0x3c3b0600), SPH_C32(0x3d357bbb),
    SPH_C32(0x655254a8), SPH_C32(0x33e6b246) },
  { SPH_C32(0xea870300), SPH_C32(0xa8fcea2a), SPH_C32(0x0fdc126d),
    SPH_C32(0x675c51d8), SPH_C32(0x4f770600), SPH_C32(0xa85adc6d),
    SPH_C32(0xc7cf463f), SPH_C32(0x5d03da12) },
  { SPH_C32(0x2e6f0200), SPH_C32(0xb78c7c24), SPH_C32(0x28c8d851),
    SPH_C32(0xef7d5de8), SPH_C32(0xf8d30700), SPH_C32(0x2245edb5),
    SPH_C32(0x42469e94), SPH_C32(0xbbc7be76) },
  { SPH_C32(0x99cb0300), SPH_C32(0x3d934dfc), SPH_C32(0xad4100fa),
    SPH_C32(0x09b9398c), SPH_C32(0x8b9f0700), SPH_C32(0xb72a4a63),
    SPH_C32(0xe0db8c03), SPH_C32(0xd522d622) },
  { SPH_C32(0x9b830400), SPH_C32(0x2227ff88), SPH_C32(0x05b7ad5a),
    SPH_C32(0xadf2c730), SPH_C32(0x8f3e0400), SPH_C32(0x0d9dc877),
    SPH_C32(0x6fc548e1), SPH_C32(0x898d2cd6) },
  { SPH_C32(0x2c270500), SPH_C32(0xa838ce50), SPH_C32(0x803e75f1),
    SPH_C32(0x4b36a354), SPH_C32(0xfc720400), SPH_C32(0x98f26fa1),
    SPH_C32(0xcd585a76), SPH_C32(0xe7684482) },
  { SPH_C32(0xe8cf0400), SPH_C32(0xb748585e), SPH_C32(0xa72abfcd),
    SPH_C32(0xc317af64), SPH_C32(0x4bd60500), SPH_C32(0x12ed5e79),
    SPH_C32(0x48d182dd), SPH_C32(0x01ac20e6) },
  { SPH_C32(0x5f6b0500), SPH_C32(0x3d576986), SPH_C32(0x22a36766),
    SPH_C32(0x25d3cb00), SPH_C32(0x389a0500), SPH_C32(0x8782f9af),
    SPH_C32(0xea4c904a), SPH_C32(0x6f4948b2) },
  { SPH_C32(0x3c3b0600), SPH_C32(0x3d357bbb), SPH_C32(0x655254a8),
    SPH_C32(0x33e6b246), SPH_C32(0x61180400), SPH_C32(0x1fd6a049),
    SPH_C32(0xef079e6e), SPH_C32(0xb27e87fa) },
  { SPH_C32(0x8b9f0700), SPH_C32(0xb72a4a63), SPH_C32(0xe0db8c03),
    SPH_C32(0xd522d622), SPH_C32(0x12540400), SPH_C32(0x8ab9079f),
    SPH_C32(0x4d9a8cf9), SPH_C32(0xdc9befae) },
  { SPH_C32(0x4f770600), SPH_C32(0xa85adc6d), SPH_C32(0xc7cf463f),
    SPH_C32(0x5d03da12), SPH_C32(0xa5f00500), SPH_C32(0x00a63647),
    SPH_C32(0xc8135452), SPH_C32(0x3a5f8bca) },
  { SPH_C32(0xf8d30700), SPH_C32(0x2245edb5), SPH_C32(0x42469e94),
    SPH_C32(0xbbc7be76), SPH_C32(0xd6bc0500), SPH_C32(0x95c99191),
    SPH_C32(0x6a8e46c5), SPH_C32(0x54bae39e) },
  { SPH_C32(0x75a50400), SPH_C32(0x306c97b6), SPH_C32(0x85757bd5),
    SPH_C32(0x96016c1c), SPH_C32(0xc6a00600), SPH_C32(0x00c4247a),
    SPH_C32(0x8fe2679c), SPH_C32(0x2c6af28c) },
  { SPH_C32(0xc2010500), SPH_C32(0xba73a66e), SPH_C32(0x00fca37e),
    SPH_C32(0x70c50878), SPH_C32(0xb5ec0600), SPH_C32(0x95ab83ac),
    SPH_C32(0x2d7f750b), SPH_C32(0x428f9ad8) },
  { SPH_C32(0x06e90400), SPH_C32(0xa5033060), SPH_C32(0x27e86942),
    SPH_C32(0xf8e40448), SPH_C32(0x02480700), SPH_C32(0x1fb4b274),
    SPH_C32(0xa8f6ada0), SPH_C32(0xa44bfebc) },
  { SPH_C32(0xb14d0500), SPH_C32(0x2f1c01b8), SPH_C32(0xa261b1e9),
    SPH_C32(0x1e20602c), SPH_C32(0x71040700), SPH_C32(0x8adb15a2),
    SPH_C32(0x0a6bbf37), SPH_C32(0xcaae96e8) },
  { SPH_C32(0xd21d0600), SPH_C32(0x2f7e1385), SPH_C32(0xe5908227),
    SPH_C32(0x0815196a), SPH_C32(0x28860600), SPH_C32(0x128f4c44),
    SPH_C32(0x0f20b113), SPH_C32(0x179959a0) },
  { SPH_C32(0x65b90700), SPH_C32(0xa561225d), SPH_C32(0x60195a8c),
    SPH_C32(0xeed17d0e), SPH_C32(0x5bca0600), SPH_C32(0x87e0eb92),
    SPH_C32(0xadbda384), SPH_C32(0x797c31f4) },
  { SPH_C32(0xa1510600), SPH_C32(0xba11b453), SPH_C32(0x470d90b0),
    SPH_C32(0x66f0713e), SPH_C32(0xec6e0700), SPH_C32(0x0dffda4a),
    SPH_C32(0x28347b2f), SPH_C32(0x9fb85590) },
  { SPH_C32(0x16f50700), SPH_C32(0x300e858b), SPH_C32(0xc284481b),
    SPH_C32(0x8034155a), SPH_C32(0x9f220700), SPH_C32(0x98907d9c),
    SPH_C32(0x8aa969b8), SPH_C32(0xf15d3dc4) },
  { SPH_C32(0xde320800), SPH_C32(0x288350fe), SPH_C32(0x71852ac7),
    SPH_C32(0xa6bf9f96), SPH_C32(0xe18b0000), SPH_C32(0x5459887d),
    SPH_C32(0xbf1283d3), SPH_C32(0x1b666a73) },
  { SPH_C32(0x69960900), SPH_C32(0xa29c6126), SPH_C32(0xf40cf26c),
    SPH_C32(0x407bfbf2), SPH_C32(0x92c70000), SPH_C32(0xc1362fab),
    SPH_C32(0x1d8f9144), SPH_C32(0x75830227) },
  { SPH_C32(0xad7e0800), SPH_C32(0xbdecf728), SPH_C32(0xd3183850),
    SPH_C32(0xc85af7c2), SPH_C32(0x25630100), SPH_C32(0x4b291e73),
    SPH_C32(0x980649ef), SPH_C32(0x93476643) },
  { SPH_C32(0x1ada0900), SPH_C32(0x37f3c6f0), SPH_C32(0x5691e0fb),
    SPH_C32(0x2e9e93a6), SPH_C32(0x562f0100), SPH_C32(0xde46b9a5),
    SPH_C32(0x3a9b5b78), SPH_C32(0xfda20e17) },
  { SPH_C32(0x798a0a00), SPH_C32(0x3791d4cd), SPH_C32(0x1160d335),
    SPH_C32(0x38abeae0), SPH_C32(0x0fad0000), SPH_C32(0x4612e043),
    SPH_C32(0x3fd0555c), SPH_C32(0x2095c15f) },
  { SPH_C32(0xce2e0b00), SPH_C32(0xbd8ee515), SPH_C32(0x94e90b9e),
    SPH_C32(0xde6f8e84), SPH_C32(0x7ce10000), SPH_C32(0xd37d4795),
    SPH_C32(0x9d4d47cb), SPH_C32(0x4e70a90b) },
  { SPH_C32(0x0ac60a00), SPH_C32(0xa2fe731b), SPH_C32(0xb3fdc1a2),
    SPH_C32(0x564e82b4), SPH_C32(0xcb450100), SPH_C32(0x5962764d),
    SPH_C32(0x18c49f60), SPH_C32(0xa8b4cd6f) },
  { SPH_C32(0xbd620b00), SPH_C32(0x28e142c3), SPH_C32(0x36741909),
    SPH_C32(0xb08ae6d0), SPH_C32(0xb8090100), SPH_C32(0xcc0dd19b),
    SPH_C32(0xba598df7), SPH_C32(0xc651a53b) },
  { SPH_C32(0x30140800), SPH_C32(0x3ac838c0), SPH_C32(0xf147fc48),
    SPH_C32(0x9d4c34ba), SPH_C32(0xa8150200), SPH_C32(0x59006470),
    SPH_C32(0x5f35acae), SPH_C32(0xbe81b429) },
  { SPH_C32(0x87b00900), SPH_C32(0xb0d70918), SPH_C32(0x74ce24e3),
    SPH_C32(0x7b8850de), SPH_C32(0xdb590200), SPH_C32(0xcc6fc3a6),
    SPH_C32(0xfda8be39), SPH_C32(0xd064dc7d) },
  { SPH_C32(0x43580800), SPH_C32(0xafa79f16), SPH_C32(0x53daeedf),
    SPH_C32(0xf3a95cee), SPH_C32(0x6cfd0300), SPH_C32(0x4670f27e),
    SPH_C32(0x78216692), SPH_C32(0x36a0b819) },
  { SPH_C32(0xf4fc0900), SPH_C32(0x25b8aece), SPH_C32(0xd6533674),
    SPH_C32(0x156d388a), SPH_C32(0x1fb10300), SPH_C32(0xd31f55a8),
    SPH_C32(0xdabc7405), SPH_C32(0x5845d04d) },
  { SPH_C32(0x97ac0a00), SPH_C32(0x25dabcf3), SPH_C32(0x91a205ba),
    SPH_C32(0x035841cc), SPH_C32(0x46330200), SPH_C32(0x4b4b0c4e),
    SPH_C32(0xdff77a21), SPH_C32(0x85721f05) },
  { SPH_C32(0x20080b00), SPH_C32(0xafc58d2b), SPH_C32(0x142bdd11),
    SPH_C32(0xe59c25a8), SPH_C32(0x357f0200), SPH_C32(0xde24ab98),
    SPH_C32(0x7d6a68b6), SPH_C32(0xeb977751) },
  { SPH_C32(0xe4e00a00), SPH_C32(0xb0b51b25), SPH_C32(0x333f172d),
    SPH_C32(0x6dbd2998), SPH_C32(0x82db0300), SPH_C32(0x543b9a40),
    SPH_C32(0xf8e3b01d), SPH_C32(0x0d531335) },
  { SPH_C32(0x53440b00), SPH_C32(0x3aaa2afd), SPH_C32(0xb6b6cf86),
    SPH_C32(0x8b794dfc), SPH_C32(0xf1970300), SPH_C32(0xc1543d96),
    SPH_C32(0x5a7ea28a), SPH_C32(0x63b67b61) },
  { SPH_C32(0x510c0c00), SPH_C32(0x251e9889), SPH_C32(0x1e406226),
    SPH_C32(0x2f32b340), SPH_C32(0xf5360000), SPH_C32(0x7be3bf82),
    SPH_C32(0xd5606668), SPH_C32(0x3f198195) },
  { SPH_C32(0xe6a80d00), SPH_C32(0xaf01a951), SPH_C32(0x9bc9ba8d),
    SPH_C32(0xc9f6d724), SPH_C32(0x867a0000), SPH_C32(0xee8c1854),
    SPH_C32(0x77fd74ff), SPH_C32(0x51fce9c1) },
  { SPH_C32(0x22400c00), SPH_C32(0xb0713f5f), SPH_C32(0xbcdd70b1),
    SPH_C32(0x41d7db14), SPH_C32(0x31de0100), SPH_C32(0x6493298c),
    SPH_C32(0xf274ac54), SPH_C32(0xb7388da5) },
  { SPH_C32(0x95e40d00), SPH_C32(0x3a6e0e87), SPH_C32(0x3954a81a),
    SPH_C32(0xa713bf70), SPH_C32(0x42920100), SPH_C32(0xf1fc8e5a),
    SPH_C32(0x50e9bec3), SPH_C32(0xd9dde5f1) },
  { SPH_C32(0xf6b40e00), SPH_C32(0x3a0c1cba), SPH_C32(0x7ea59bd4),
    SPH_C32(0xb126c636), SPH_C32(0x1b100000), SPH_C32(0x69a8d7bc),
    SPH_C32(0x55a2b0e7), SPH_C32(0x04ea2ab9) },
  { SPH_C32(0x41100f00), SPH_C32(0xb0132d62), SPH_C32(0xfb2c437f),
    SPH_C32(0x57e2a252), SPH_C32(0x685c0000), SPH_C32(0xfcc7706a),
    SPH_C32(0xf73fa270), SPH_C32(0x6a0f42ed) },
  { SPH_C32(0x85f80e00), SPH_C32(0xaf63bb6c), SPH_C32(0xdc388943),
    SPH_C32(0xdfc3ae62), SPH_C32(0xdff80100), SPH_C32(0x76d841b2),
    SPH_C32(0x72b67adb), SPH_C32(0x8ccb2689) },
  { SPH_C32(0x325c0f00), SPH_C32(0x257c8ab4), SPH_C32(0x59b151e8),
    SPH_C32(0x3907ca06), SPH_C32(0xacb40100), SPH_C32(0xe3b7e664),
    SPH_C32(0xd02b684c), SPH_C32(0xe22e4edd) },
  { SPH_C32(0xbf2a0c00), SPH_C32(0x3755f0b7), SPH_C32(0x9e82b4a9),
    SPH_C32(0x14c1186c), SPH_C32(0xbca80200), SPH_C32(0x76ba538f),
    SPH_C32(0x35474915), SPH_C32(0x9afe5fcf) },
  { SPH_C32(0x088e0d00), SPH_C32(0xbd4ac16f), SPH_C32(0x1b0b6c02),
    SPH_C32(0xf2057c08), SPH_C32(0xcfe40200), SPH_C32(0xe3d5f459),
    SPH_C32(0x97da5b82), SPH_C32(0xf41b379b) },
  { SPH_C32(0xcc660c00), SPH_C32(0xa23a5761), SPH_C32(0x3c1fa63e),
    SPH_C32(0x7a247038), SPH_C32(0x78400300), SPH_C32(0x69cac581),
    SPH_C32(0x12538329), SPH_C32(0x12df53ff) },
  { SPH_C32(0x7bc20d00), SPH_C32(0x282566b9), SPH_C32(0xb9967e95),
    SPH_C32(0x9ce0145c), SPH_C32(0x0b0c0300), SPH_C32(0xfca56257),
    SPH_C32(0xb0ce91be), SPH_C32(0x7c3a3bab) },
  { SPH_C32(0x18920e00), SPH_C32(0x28477484), SPH_C32(0xfe674d5b),
    SPH_C32(0x8ad56d1a), SPH_C32(0x528e0200), SPH_C32(0x64f13bb1),
    SPH_C32(0xb5859f9a), SPH_C32(0xa10df4e3) },
  { SPH_C32(0xaf360f00), SPH_C32(0xa258455c), SPH_C32(0x7bee95f0),
    SPH_C32(0x6c11097e), SPH_C32(0x21c20200), SPH_C32(0xf19e9c67),
    SPH_C32(0x17188d0d), SPH_C32(0xcfe89cb7) },
  { SPH_C32(0x6bde0e00), SPH_C32(0xbd28d352), SPH_C32(0x5cfa5fcc),
    SPH_C32(0xe430054e), SPH_C32(0x96660300), SPH_C32(0x7b81adbf),
    SPH_C32(0x929155a6), SPH_C32(0x292cf8d3) },
  { SPH_C32(0xdc7a0f00), SPH_C32(0x3737e28a), SPH_C32(0xd9738767),
    SPH_C32(0x02f4612a), SPH_C32(0xe52a0300), SPH_C32(0xeeee0a69),
    SPH_C32(0x300c4731), SPH_C32(0x47c99087) },
  { SPH_C32(0xca8f0800), SPH_C32(0x07396701), SPH_C32(0x1bf7cf7c),
    SPH_C32(0x82c07470), SPH_C32(0x7a080400), SPH_C32(0x767e77f5),
    SPH_C32(0xbaa52e89), SPH_C32(0xb694ad43) },
  { SPH_C32(0x7d2b0900), SPH_C32(0x8d2656d9), SPH_C32(0x9e7e17d7),
    SPH_C32(0x64041014), SPH_C32(0x09440400), SPH_C32(0xe311d023),
    SPH_C32(0x18383c1e), SPH_C32(0xd871c517) },
  { SPH_C32(0xb9c30800), SPH_C32(0x9256c0d7), SPH_C32(0xb96addeb),
    SPH_C32(0xec251c24), SPH_C32(0xbee00500), SPH_C32(0x690ee1fb),
    SPH_C32(0x9db1e4b5), SPH_C32(0x3eb5a173) },
  { SPH_C32(0x0e670900), SPH_C32(0x1849f10f), SPH_C32(0x3ce30540),
    SPH_C32(0x0ae17840), SPH_C32(0xcdac0500), SPH_C32(0xfc61462d),
    SPH_C32(0x3f2cf622), SPH_C32(0x5050c927) },
  { SPH_C32(0x6d370a00), SPH_C32(0x182be332), SPH_C32(0x7b12368e),
    SPH_C32(0x1cd40106), SPH_C32(0x942e0400), SPH_C32(0x64351fcb),
    SPH_C32(0x3a67f806), SPH_C32(0x8d67066f) },
  { SPH_C32(0xda930b00), SPH_C32(0x9234d2ea), SPH_C32(0xfe9bee25),
    SPH_C32(0xfa106562), SPH_C32(0xe7620400), SPH_C32(0xf15ab81d),
    SPH_C32(0x98faea91), SPH_C32(0xe3826e3b) },
  { SPH_C32(0x1e7b0a00), SPH_C32(0x8d4444e4), SPH_C32(0xd98f2419),
    SPH_C32(0x72316952), SPH_C32(0x50c60500), SPH_C32(0x7b4589c5),
    SPH_C32(0x1d73323a), SPH_C32(0x05460a5f) },
  { SPH_C32(0xa9df0b00), SPH_C32(0x075b753c), SPH_C32(0x5c06fcb2),
    SPH_C32(0x94f50d36), SPH_C32(0x238a0500), SPH_C32(0xee2a2e13),
    SPH_C32(0xbfee20ad), SPH_C32(0x6ba3620b) },
  { SPH_C32(0x24a90800), SPH_C32(0x15720f3f), SPH_C32(0x9b3519f3),
    SPH_C32(0xb933df5c), SPH_C32(0x33960600), SPH_C32(0x7b279bf8),
    SPH_C32(0x5a8201f4), SPH_C32(0x13737319) },
  { SPH_C32(0x930d0900), SPH_C32(0x9f6d3ee7), SPH_C32(0x1ebcc158),
    SPH_C32(0x5ff7bb38), SPH_C32(0x40da0600), SPH_C32(0xee483c2e),
    SPH_C32(0xf81f1363), SPH_C32(0x7d961b4d) },
  { SPH_C32(0x57e50800), SPH_C32(0x801da8e9), SPH_C32(0x39a80b64),
    SPH_C32(0xd7d6b708), SPH_C32(0xf77e0700), SPH_C32(0x64570df6),
    SPH_C32(0x7d96cbc8), SPH_C32(0x9b527f29) },
  { SPH_C32(0xe0410900), SPH_C32(0x0a029931), SPH_C32(0xbc21d3cf),
    SPH_C32(0x3112d36c), SPH_C32(0x84320700), SPH_C32(0xf138aa20),
    SPH_C32(0xdf0bd95f), SPH_C32(0xf5b7177d) },
  { SPH_C32(0x83110a00), SPH_C32(0x0a608b0c), SPH_C32(0xfbd0e001),
    SPH_C32(0x2727aa2a), SPH_C32(0xddb00600), SPH_C32(0x696cf3c6),
    SPH_C32(0xda40d77b), SPH_C32(0x2880d835) },
  { SPH_C32(0x34b50b00), SPH_C32(0x807fbad4), SPH_C32(0x7e5938aa),
    SPH_C32(0xc1e3ce4e), SPH_C32(0xaefc0600), SPH_C32(0xfc035410),
    SPH_C32(0x78ddc5ec), SPH_C32(0x4665b061) },
  { SPH_C32(0xf05d0a00), SPH_C32(0x9f0f2cda), SPH_C32(0x594df296),
    SPH_C32(0x49c2c27e), SPH_C32(0x19580700), SPH_C32(0x761c65c8),
    SPH_C32(0xfd541d47), SPH_C32(0xa0a1d405) },
  { SPH_C32(0x47f90b00), SPH_C32(0x15101d02), SPH_C32(0xdcc42a3d),
    SPH_C32(0xaf06a61a), SPH_C32(0x6a140700), SPH_C32(0xe373c21e),
    SPH_C32(0x5fc90fd0), SPH_C32(0xce44bc51) },
  { SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76), SPH_C32(0x7432879d),
    SPH_C32(0x0b4d58a6), SPH_C32(0x6eb50400), SPH_C32(0x59c4400a),
    SPH_C32(0xd0d7cb32), SPH_C32(0x92eb46a5) },
  { SPH_C32(0xf2150d00), SPH_C32(0x80bb9eae), SPH_C32(0xf1bb5f36),
    SPH_C32(0xed893cc2), SPH_C32(0x1df90400), SPH_C32(0xccabe7dc),
    SPH_C32(0x724ad9a5), SPH_C32(0xfc0e2ef1) },
  { SPH_C32(0x36fd0c00), SPH_C32(0x9fcb08a0), SPH_C32(0xd6af950a),
    SPH_C32(0x65a830f2), SPH_C32(0xaa5d0500), SPH_C32(0x46b4d604),
    SPH_C32(0xf7c3010e), SPH_C32(0x1aca4a95) },
  { SPH_C32(0x81590d00), SPH_C32(0x15d43978), SPH_C32(0x53264da1),
    SPH_C32(0x836c5496), SPH_C32(0xd9110500), SPH_C32(0xd3db71d2),
    SPH_C32(0x555e1399), SPH_C32(0x742f22c1) },
  { SPH_C32(0xe2090e00), SPH_C32(0x15b62b45), SPH_C32(0x14d77e6f),
    SPH_C32(0x95592dd0), SPH_C32(0x80930400), SPH_C32(0x4b8f2834),
    SPH_C32(0x50151dbd), SPH_C32(0xa918ed89) },
  { SPH_C32(0x55ad0f00), SPH_C32(0x9fa91a9d), SPH_C32(0x915ea6c4),
    SPH_C32(0x739d49b4), SPH_C32(0xf3df0400), SPH_C32(0xdee08fe2),
    SPH_C32(0xf2880f2a), SPH_C32(0xc7fd85dd) },
  { SPH_C32(0x91450e00), SPH_C32(0x80d98c93), SPH_C32(0xb64a6cf8),
    SPH_C32(0xfbbc4584), SPH_C32(0x447b0500), SPH_C32(0x54ffbe3a),
    SPH_C32(0x7701d781), SPH_C32(0x2139e1b9) },
  { SPH_C32(0x26e10f00), SPH_C32(0x0ac6bd4b), SPH_C32(0x33c3b453),
    SPH_C32(0x1d7821e0), SPH_C32(0x37370500), SPH_C32(0xc19019ec),
    SPH_C32(0xd59cc516), SPH_C32(0x4fdc89ed) },
  { SPH_C32(0xab970c00), SPH_C32(0x18efc748), SPH_C32(0xf4f05112),
    SPH_C32(0x30bef38a), SPH_C32(0x272b0600), SPH_C32(0x549dac07),
    SPH_C32(0x30f0e44f), SPH_C32(0x370c98ff) },
  { SPH_C32(0x1c330d00), SPH_C32(0x92f0f690), SPH_C32(0x717989b9),
    SPH_C32(0xd67a97ee), SPH_C32(0x54670600), SPH_C32(0xc1f20bd1),
    SPH_C32(0x926df6d8), SPH_C32(0x59e9f0ab) },
  { SPH_C32(0xd8db0c00), SPH_C32(0x8d80609e), SPH_C32(0x566d4385),
    SPH_C32(0x5e5b9bde), SPH_C32(0xe3c30700), SPH_C32(0x4bed3a09),
    SPH_C32(0x17e42e73), SPH_C32(0xbf2d94cf) },
  { SPH_C32(0x6f7f0d00), SPH_C32(0x079f5146), SPH_C32(0xd3e49b2e),
    SPH_C32(0xb89fffba), SPH_C32(0x908f0700), SPH_C32(0xde829ddf),
    SPH_C32(0xb5793ce4), SPH_C32(0xd1c8fc9b) },
  { SPH_C32(0x0c2f0e00), SPH_C32(0x07fd437b), SPH_C32(0x9415a8e0),
    SPH_C32(0xaeaa86fc), SPH_C32(0xc90d0600), SPH_C32(0x46d6c439),
    SPH_C32(0xb03232c0), SPH_C32(0x0cff33d3) },
  { SPH_C32(0xbb8b0f00), SPH_C32(0x8de272a3), SPH_C32(0x119c704b),
    SPH_C32(0x486ee298), SPH_C32(0xba410600), SPH_C32(0xd3b963ef),
    SPH_C32(0x12af2057), SPH_C32(0x621a5b87) },
  { SPH_C32(0x7f630e00), SPH_C32(0x9292e4ad), SPH_C32(0x3688ba77),
    SPH_C32(0xc04feea8), SPH_C32(0x0de50700), SPH_C32(0x59a65237),
    SPH_C32(0x9726f8fc), SPH_C32(0x84de3fe3) },
  { SPH_C32(0xc8c70f00), SPH_C32(0x188dd575), SPH_C32(0xb30162dc),
    SPH_C32(0x268b8acc), SPH_C32(0x7ea90700), SPH_C32(0xccc9f5e1),
    SPH_C32(0x35bbea6b), SPH_C32(0xea3b57b7) },
  { SPH_C32(0xe18b0000), SPH_C32(0x5459887d), SPH_C32(0xbf1283d3),
    SPH_C32(0x1b666a73), SPH_C32(0x3fb90800), SPH_C32(0x7cdad883),
    SPH_C32(0xce97a914), SPH_C32(0xbdd9f5e5) },
  { SPH_C32(0x562f0100), SPH_C32(0xde46b9a5), SPH_C32(0x3a9b5b78),
    SPH_C32(0xfda20e17), SPH_C32(0x4cf50800), SPH_C32(0xe9b57f55),
    SPH_C32(0x6c0abb83), SPH_C32(0xd33c9db1) },
  { SPH_C32(0x92c70000), SPH_C32(0xc1362fab), SPH_C32(0x1d8f9144),
    SPH_C32(0x75830227), SPH_C32(0xfb510900), SPH_C32(0x63aa4e8d),
    SPH_C32(0xe9836328), SPH_C32(0x35f8f9d5) },
  { SPH_C32(0x25630100), SPH_C32(0x4b291e73), SPH_C32(0x980649ef),
    SPH_C32(0x93476643), SPH_C32(0x881d0900), SPH_C32(0xf6c5e95b),
    SPH_C32(0x4b1e71bf), SPH_C32(0x5b1d9181) },
  { SPH_C32(0x46330200), SPH_C32(0x4b4b0c4e), SPH_C32(0xdff77a21),
    SPH_C32(0x85721f05), SPH_C32(0xd19f0800), SPH_C32(0x6e91b0bd),
    SPH_C32(0x4e557f9b), SPH_C32(0x862a5ec9) },
  { SPH_C32(0xf1970300), SPH_C32(0xc1543d96), SPH_C32(0x5a7ea28a),
    SPH_C32(0x63b67b61), SPH_C32(0xa2d30800), SPH_C32(0xfbfe176b),
    SPH_C32(0xecc86d0c), SPH_C32(0xe8cf369d) },
  { SPH_C32(0x357f0200), SPH_C32(0xde24ab98), SPH_C32(0x7d6a68b6),
    SPH_C32(0xeb977751), SPH_C32(0x15770900), SPH_C32(0x71e126b3),
    SPH_C32(0x6941b5a7), SPH_C32(0x0e0b52f9) },
  { SPH_C32(0x82db0300), SPH_C32(0x543b9a40), SPH_C32(0xf8e3b01d),
    SPH_C32(0x0d531335), SPH_C32(0x663b0900), SPH_C32(0xe48e8165),
    SPH_C32(0xcbdca730), SPH_C32(0x60ee3aad) },
  { SPH_C32(0x0fad0000), SPH_C32(0x4612e043), SPH_C32(0x3fd0555c),
    SPH_C32(0x2095c15f), SPH_C32(0x76270a00), SPH_C32(0x7183348e),
    SPH_C32(0x2eb08669), SPH_C32(0x183e2bbf) },
  { SPH_C32(0xb8090100), SPH_C32(0xcc0dd19b), SPH_C32(0xba598df7),
    SPH_C32(0xc651a53b), SPH_C32(0x056b0a00), SPH_C32(0xe4ec9358),
    SPH_C32(0x8c2d94fe), SPH_C32(0x76db43eb) },
  { SPH_C32(0x7ce10000), SPH_C32(0xd37d4795), SPH_C32(0x9d4d47cb),
    SPH_C32(0x4e70a90b), SPH_C32(0xb2cf0b00), SPH_C32(0x6ef3a280),
    SPH_C32(0x09a44c55), SPH_C32(0x901f278f) },
  { SPH_C32(0xcb450100), SPH_C32(0x5962764d), SPH_C32(0x18c49f60),
    SPH_C32(0xa8b4cd6f), SPH_C32(0xc1830b00), SPH_C32(0xfb9c0556),
    SPH_C32(0xab395ec2), SPH_C32(0xfefa4fdb) },
  { SPH_C32(0xa8150200), SPH_C32(0x59006470), SPH_C32(0x5f35acae),
    SPH_C32(0xbe81b429), SPH_C32(0x98010a00), SPH_C32(0x63c85cb0),
    SPH_C32(0xae7250e6), SPH_C32(0x23cd8093) },
  { SPH_C32(0x1fb10300), SPH_C32(0xd31f55a8), SPH_C32(0xdabc7405),
    SPH_C32(0x5845d04d), SPH_C32(0xeb4d0a00), SPH_C32(0xf6a7fb66),
    SPH_C32(0x0cef4271), SPH_C32(0x4d28e8c7) },
  { SPH_C32(0xdb590200), SPH_C32(0xcc6fc3a6), SPH_C32(0xfda8be39),
    SPH_C32(0xd064dc7d), SPH_C32(0x5ce90b00), SPH_C32(0x7cb8cabe),
    SPH_C32(0x89669ada), SPH_C32(0xabec8ca3) },
  { SPH_C32(0x6cfd0300), SPH_C32(0x4670f27e), SPH_C32(0x78216692),
    SPH_C32(0x36a0b819), SPH_C32(0x2fa50b00), SPH_C32(0xe9d76d68),
    SPH_C32(0x2bfb884d), SPH_C32(0xc509e4f7) },
  { SPH_C32(0x6eb50400), SPH_C32(0x59c4400a), SPH_C32(0xd0d7cb32),
    SPH_C32(0x92eb46a5), SPH_C32(0x2b040800), SPH_C32(0x5360ef7c),
    SPH_C32(0xa4e54caf), SPH_C32(0x99a61e03) },
  { SPH_C32(0xd9110500), SPH_C32(0xd3db71d2), SPH_C32(0x555e1399),
    SPH_C32(0x742f22c1), SPH_C32(0x58480800), SPH_C32(0xc60f48aa),
    SPH_C32(0x06785e38), SPH_C32(0xf7437657) },
  { SPH_C32(0x1df90400), SPH_C32(0xccabe7dc), SPH_C32(0x724ad9a5),
    SPH_C32(0xfc0e2ef1), SPH_C32(0xefec0900), SPH_C32(0x4c107972),
    SPH_C32(0x83f18693), SPH_C32(0x11871233) },
  { SPH_C32(0xaa5d0500), SPH_C32(0x46b4d604), SPH_C32(0xf7c3010e),
    SPH_C32(0x1aca4a95), SPH_C32(0x9ca00900), SPH_C32(0xd97fdea4),
    SPH_C32(0x216c9404), SPH_C32(0x7f627a67) },
  { SPH_C32(0xc90d0600), SPH_C32(0x46d6c439), SPH_C32(0xb03232c0),
    SPH_C32(0x0cff33d3), SPH_C32(0xc5220800), SPH_C32(0x412b8742),
    SPH_C32(0x24279a20), SPH_C32(0xa255b52f) },
  { SPH_C32(0x7ea90700), SPH_C32(0xccc9f5e1), SPH_C32(0x35bbea6b),
    SPH_C32(0xea3b57b7), SPH_C32(0xb66e0800), SPH_C32(0xd4442094),
    SPH_C32(0x86ba88b7), SPH_C32(0xccb0dd7b) },
  { SPH_C32(0xba410600), SPH_C32(0xd3b963ef), SPH_C32(0x12af2057),
    SPH_C32(0x621a5b87), SPH_C32(0x01ca0900), SPH_C32(0x5e5b114c),
    SPH_C32(0x0333501c), SPH_C32(0x2a74b91f) },
  { SPH_C32(0x0de50700), SPH_C32(0x59a65237), SPH_C32(0x9726f8fc),
    SPH_C32(0x84de3fe3), SPH_C32(0x72860900), SPH_C32(0xcb34b69a),
    SPH_C32(0xa1ae428b), SPH_C32(0x4491d14b) },
  { SPH_C32(0x80930400), SPH_C32(0x4b8f2834), SPH_C32(0x50151dbd),
    SPH_C32(0xa918ed89), SPH_C32(0x629a0a00), SPH_C32(0x5e390371),
    SPH_C32(0x44c263d2), SPH_C32(0x3c41c059) },
  { SPH_C32(0x37370500), SPH_C32(0xc19019ec), SPH_C32(0xd59cc516),
    SPH_C32(0x4fdc89ed), SPH_C32(0x11d60a00), SPH_C32(0xcb56a4a7),
    SPH_C32(0xe65f7145), SPH_C32(0x52a4a80d) },
  { SPH_C32(0xf3df0400), SPH_C32(0xdee08fe2), SPH_C32(0xf2880f2a),
    SPH_C32(0xc7fd85dd), SPH_C32(0xa6720b00), SPH_C32(0x4149957f),
    SPH_C32(0x63d6a9ee), SPH_C32(0xb460cc69) },
  { SPH_C32(0x447b0500), SPH_C32(0x54ffbe3a), SPH_C32(0x7701d781),
    SPH_C32(0x2139e1b9), SPH_C32(0xd53e0b00), SPH_C32(0xd42632a9),
    SPH_C32(0xc14bbb79), SPH_C32(0xda85a43d) },
  { SPH_C32(0x272b0600), SPH_C32(0x549dac07), SPH_C32(0x30f0e44f),
    SPH_C32(0x370c98ff), SPH_C32(0x8cbc0a00), SPH_C32(0x4c726b4f),
    SPH_C32(0xc400b55d), SPH_C32(0x07b26b75) },
  { SPH_C32(0x908f0700), SPH_C32(0xde829ddf), SPH_C32(0xb5793ce4),
    SPH_C32(0xd1c8fc9b), SPH_C32(0xfff00a00), SPH_C32(0xd91dcc99),
    SPH_C32(0x669da7ca), SPH_C32(0x69570321) },
  { SPH_C32(0x54670600), SPH_C32(0xc1f20bd1), SPH_C32(0x926df6d8),
    SPH_C32(0x59e9f0ab), SPH_C32(0x48540b00), SPH_C32(0x5302fd41),
    SPH_C32(0xe3147f61), SPH_C32(0x8f936745) },
  { SPH_C32(0xe3c30700), SPH_C32(0x4bed3a09), SPH_C32(0x17e42e73),
    SPH_C32(0xbf2d94cf), SPH_C32(0x3b180b00), SPH_C32(0xc66d5a97),
    SPH_C32(0x41896df6), SPH_C32(0xe1760f11) },
  { SPH_C32(0xf5360000), SPH_C32(0x7be3bf82), SPH_C32(0xd5606668),
    SPH_C32(0x3f198195), SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b),
    SPH_C32(0xcb20044e), SPH_C32(0x102b32d5) },
  { SPH_C32(0x42920100), SPH_C32(0xf1fc8e5a), SPH_C32(0x50e9bec3),
    SPH_C32(0xd9dde5f1), SPH_C32(0xd7760c00), SPH_C32(0xcb9280dd),
    SPH_C32(0x69bd16d9), SPH_C32(0x7ece5a81) },
  { SPH_C32(0x867a0000), SPH_C32(0xee8c1854), SPH_C32(0x77fd74ff),
    SPH_C32(0x51fce9c1), SPH_C32(0x60d20d00), SPH_C32(0x418db105),
    SPH_C32(0xec34ce72), SPH_C32(0x980a3ee5) },
  { SPH_C32(0x31de0100), SPH_C32(0x6493298c), SPH_C32(0xf274ac54),
    SPH_C32(0xb7388da5), SPH_C32(0x139e0d00), SPH_C32(0xd4e216d3),
    SPH_C32(0x4ea9dce5), SPH_C32(0xf6ef56b1) },
  { SPH_C32(0x528e0200), SPH_C32(0x64f13bb1), SPH_C32(0xb5859f9a),
    SPH_C32(0xa10df4e3), SPH_C32(0x4a1c0c00), SPH_C32(0x4cb64f35),
    SPH_C32(0x4be2d2c1), SPH_C32(0x2bd899f9) },
  { SPH_C32(0xe52a0300), SPH_C32(0xeeee0a69), SPH_C32(0x300c4731),
    SPH_C32(0x47c99087), SPH_C32(0x39500c00), SPH_C32(0xd9d9e8e3),
    SPH_C32(0xe97fc056), SPH_C32(0x453df1ad) },
  { SPH_C32(0x21c20200), SPH_C32(0xf19e9c67), SPH_C32(0x17188d0d),
    SPH_C32(0xcfe89cb7), SPH_C32(0x8ef40d00), SPH_C32(0x53c6d93b),
    SPH_C32(0x6cf618fd), SPH_C32(0xa3f995c9) },
  { SPH_C32(0x96660300), SPH_C32(0x7b81adbf), SPH_C32(0x929155a6),
    SPH_C32(0x292cf8d3), SPH_C32(0xfdb80d00), SPH_C32(0xc6a97eed),
    SPH_C32(0xce6b0a6a), SPH_C32(0xcd1cfd9d) },
  { SPH_C32(0x1b100000), SPH_C32(0x69a8d7bc), SPH_C32(0x55a2b0e7),
    SPH_C32(0x04ea2ab9), SPH_C32(0xeda40e00), SPH_C32(0x53a4cb06),
    SPH_C32(0x2b072b33), SPH_C32(0xb5ccec8f) },
  { SPH_C32(0xacb40100), SPH_C32(0xe3b7e664), SPH_C32(0xd02b684c),
    SPH_C32(0xe22e4edd), SPH_C32(0x9ee80e00), SPH_C32(0xc6cb6cd0),
    SPH_C32(0x899a39a4), SPH_C32(0xdb2984db) },
  { SPH_C32(0x685c0000), SPH_C32(0xfcc7706a), SPH_C32(0xf73fa270),
    SPH_C32(0x6a0f42ed), SPH_C32(0x294c0f00), SPH_C32(0x4cd45d08),
    SPH_C32(0x0c13e10f), SPH_C32(0x3dede0bf) },
  { SPH_C32(0xdff80100), SPH_C32(0x76d841b2), SPH_C32(0x72b67adb),
    SPH_C32(0x8ccb2689), SPH_C32(0x5a000f00), SPH_C32(0xd9bbfade),
    SPH_C32(0xae8ef398), SPH_C32(0x530888eb) },
  { SPH_C32(0xbca80200), SPH_C32(0x76ba538f), SPH_C32(0x35474915),
    SPH_C32(0x9afe5fcf), SPH_C32(0x03820e00), SPH_C32(0x41efa338),
    SPH_C32(0xabc5fdbc), SPH_C32(0x8e3f47a3) },
  { SPH_C32(0x0b0c0300), SPH_C32(0xfca56257), SPH_C32(0xb0ce91be),
    SPH_C32(0x7c3a3bab), SPH_C32(0x70ce0e00), SPH_C32(0xd48004ee),
    SPH_C32(0x0958ef2b), SPH_C32(0xe0da2ff7) },
  { SPH_C32(0xcfe40200), SPH_C32(0xe3d5f459), SPH_C32(0x97da5b82),
    SPH_C32(0xf41b379b), SPH_C32(0xc76a0f00), SPH_C32(0x5e9f3536),
    SPH_C32(0x8cd13780), SPH_C32(0x061e4b93) },
  { SPH_C32(0x78400300), SPH_C32(0x69cac581), SPH_C32(0x12538329),
    SPH_C32(0x12df53ff), SPH_C32(0xb4260f00), SPH_C32(0xcbf092e0),
    SPH_C32(0x2e4c2517), SPH_C32(0x68fb23c7) },
  { SPH_C32(0x7a080400), SPH_C32(0x767e77f5), SPH_C32(0xbaa52e89),
    SPH_C32(0xb694ad43), SPH_C32(0xb0870c00), SPH_C32(0x714710f4),
    SPH_C32(0xa152e1f5), SPH_C32(0x3454d933) },
  { SPH_C32(0xcdac0500), SPH_C32(0xfc61462d), SPH_C32(0x3f2cf622),
    SPH_C32(0x5050c927), SPH_C32(0xc3cb0c00), SPH_C32(0xe428b722),
    SPH_C32(0x03cff362), SPH_C32(0x5ab1b167) },
  { SPH_C32(0x09440400), SPH_C32(0xe311d023), SPH_C32(0x18383c1e),
    SPH_C32(0xd871c517), SPH_C32(0x746f0d00), SPH_C32(0x6e3786fa),
    SPH_C32(0x86462bc9), SPH_C32(0xbc75d503) },
  { SPH_C32(0xbee00500), SPH_C32(0x690ee1fb), SPH_C32(0x9db1e4b5),
    SPH_C32(0x3eb5a173), SPH_C32(0x07230d00), SPH_C32(0xfb58212c),
    SPH_C32(0x24db395e), SPH_C32(0xd290bd57) },
  { SPH_C32(0xddb00600), SPH_C32(0x696cf3c6), SPH_C32(0xda40d77b),
    SPH_C32(0x2880d835), SPH_C32(0x5ea10c00), SPH_C32(0x630c78ca),
    SPH_C32(0x2190377a), SPH_C32(0x0fa7721f) },
  { SPH_C32(0x6a140700), SPH_C32(0xe373c21e), SPH_C32(0x5fc90fd0),
    SPH_C32(0xce44bc51), SPH_C32(0x2ded0c00), SPH_C32(0xf663df1c),
    SPH_C32(0x830d25ed), SPH_C32(0x61421a4b) },
  { SPH_C32(0xaefc0600), SPH_C32(0xfc035410), SPH_C32(0x78ddc5ec),
    SPH_C32(0x4665b061), SPH_C32(0x9a490d00), SPH_C32(0x7c7ceec4),
    SPH_C32(0x0684fd46), SPH_C32(0x87867e2f) },
  { SPH_C32(0x19580700), SPH_C32(0x761c65c8), SPH_C32(0xfd541d47),
    SPH_C32(0xa0a1d405), SPH_C32(0xe9050d00), SPH_C32(0xe9134912),
    SPH_C32(0xa419efd1), SPH_C32(0xe963167b) },
  { SPH_C32(0x942e0400), SPH_C32(0x64351fcb), SPH_C32(0x3a67f806),
    SPH_C32(0x8d67066f), SPH_C32(0xf9190e00), SPH_C32(0x7c1efcf9),
    SPH_C32(0x4175ce88), SPH_C32(0x91b30769) },
  { SPH_C32(0x238a0500), SPH_C32(0xee2a2e13), SPH_C32(0xbfee20ad),
    SPH_C32(0x6ba3620b), SPH_C32(0x8a550e00), SPH_C32(0xe9715b2f),
    SPH_C32(0xe3e8dc1f), SPH_C32(0xff566f3d) },
  { SPH_C32(0xe7620400), SPH_C32(0xf15ab81d), SPH_C32(0x98faea91),
    SPH_C32(0xe3826e3b), SPH_C32(0x3df10f00), SPH_C32(0x636e6af7),
    SPH_C32(0x666104b4), SPH_C32(0x19920b59) },
  { SPH_C32(0x50c60500), SPH_C32(0x7b4589c5), SPH_C32(0x1d73323a),
    SPH_C32(0x05460a5f), SPH_C32(0x4ebd0f00), SPH_C32(0xf601cd21),
    SPH_C32(0xc4fc1623), SPH_C32(0x7777630d) },
  { SPH_C32(0x33960600), SPH_C32(0x7b279bf8), SPH_C32(0x5a8201f4),
    SPH_C32(0x13737319), SPH_C32(0x173f0e00), SPH_C32(0x6e5594c7),
    SPH_C32(0xc1b71807), SPH_C32(0xaa40ac45) },
  { SPH_C32(0x84320700), SPH_C32(0xf138aa20), SPH_C32(0xdf0bd95f),
    SPH_C32(0xf5b7177d), SPH_C32(0x64730e00), SPH_C32(0xfb3a3311),
    SPH_C32(0x632a0a90), SPH_C32(0xc4a5c411) },
  { SPH_C32(0x40da0600), SPH_C32(0xee483c2e), SPH_C32(0xf81f1363),
    SPH_C32(0x7d961b4d), SPH_C32(0xd3d70f00), SPH_C32(0x712502c9),
    SPH_C32(0xe6a3d23b), SPH_C32(0x2261a075) },
  { SPH_C32(0xf77e0700), SPH_C32(0x64570df6), SPH_C32(0x7d96cbc8),
    SPH_C32(0x9b527f29), SPH_C32(0xa09b0f00), SPH_C32(0xe44aa51f),
    SPH_C32(0x443ec0ac), SPH_C32(0x4c84c821) },
  { SPH_C32(0x3fb90800), SPH_C32(0x7cdad883), SPH_C32(0xce97a914),
    SPH_C32(0xbdd9f5e5), SPH_C32(0xde320800), SPH_C32(0x288350fe),
    SPH_C32(0x71852ac7), SPH_C32(0xa6bf9f96) },
  { SPH_C32(0x881d0900), SPH_C32(0xf6c5e95b), SPH_C32(0x4b1e71bf),
    SPH_C32(0x5b1d9181), SPH_C32(0xad7e0800), SPH_C32(0xbdecf728),
    SPH_C32(0xd3183850), SPH_C32(0xc85af7c2) },
  { SPH_C32(0x4cf50800), SPH_C32(0xe9b57f55), SPH_C32(0x6c0abb83),
    SPH_C32(0xd33c9db1), SPH_C32(0x1ada0900), SPH_C32(0x37f3c6f0),
    SPH_C32(0x5691e0fb), SPH_C32(0x2e9e93a6) },
  { SPH_C32(0xfb510900), SPH_C32(0x63aa4e8d), SPH_C32(0xe9836328),
    SPH_C32(0x35f8f9d5), SPH_C32(0x69960900), SPH_C32(0xa29c6126),
    SPH_C32(0xf40cf26c), SPH_C32(0x407bfbf2) },
  { SPH_C32(0x98010a00), SPH_C32(0x63c85cb0), SPH_C32(0xae7250e6),
    SPH_C32(0x23cd8093), SPH_C32(0x30140800), SPH_C32(0x3ac838c0),
    SPH_C32(0xf147fc48), SPH_C32(0x9d4c34ba) },
  { SPH_C32(0x2fa50b00), SPH_C32(0xe9d76d68), SPH_C32(0x2bfb884d),
    SPH_C32(0xc509e4f7), SPH_C32(0x43580800), SPH_C32(0xafa79f16),
    SPH_C32(0x53daeedf), SPH_C32(0xf3a95cee) },
  { SPH_C32(0xeb4d0a00), SPH_C32(0xf6a7fb66), SPH_C32(0x0cef4271),
    SPH_C32(0x4d28e8c7), SPH_C32(0xf4fc0900), SPH_C32(0x25b8aece),
    SPH_C32(0xd6533674), SPH_C32(0x156d388a) },
  { SPH_C32(0x5ce90b00), SPH_C32(0x7cb8cabe), SPH_C32(0x89669ada),
    SPH_C32(0xabec8ca3), SPH_C32(0x87b00900), SPH_C32(0xb0d70918),
    SPH_C32(0x74ce24e3), SPH_C32(0x7b8850de) },
  { SPH_C32(0xd19f0800), SPH_C32(0x6e91b0bd), SPH_C32(0x4e557f9b),
    SPH_C32(0x862a5ec9), SPH_C32(0x97ac0a00), SPH_C32(0x25dabcf3),
    SPH_C32(0x91a205ba), SPH_C32(0x035841cc) },
  { SPH_C32(0x663b0900), SPH_C32(0xe48e8165), SPH_C32(0xcbdca730),
    SPH_C32(0x60ee3aad), SPH_C32(0xe4e00a00), SPH_C32(0xb0b51b25),
    SPH_C32(0x333f172d), SPH_C32(0x6dbd2998) },
  { SPH_C32(0xa2d30800), SPH_C32(0xfbfe176b), SPH_C32(0xecc86d0c),
    SPH_C32(0xe8cf369d), SPH_C32(0x53440b00), SPH_C32(0x3aaa2afd),
    SPH_C32(0xb6b6cf86), SPH_C32(0x8b794dfc) },
  { SPH_C32(0x15770900), SPH_C32(0x71e126b3), SPH_C32(0x6941b5a7),
    SPH_C32(0x0e0b52f9), SPH_C32(0x20080b00), SPH_C32(0xafc58d2b),
    SPH_C32(0x142bdd11), SPH_C32(0xe59c25a8) },
  { SPH_C32(0x76270a00), SPH_C32(0x7183348e), SPH_C32(0x2eb08669),
    SPH_C32(0x183e2bbf), SPH_C32(0x798a0a00), SPH_C32(0x3791d4cd),
    SPH_C32(0x1160d335), SPH_C32(0x38abeae0) },
  { SPH_C32(0xc1830b00), SPH_C32(0xfb9c0556), SPH_C32(0xab395ec2),
    SPH_C32(0xfefa4fdb), SPH_C32(0x0ac60a00), SPH_C32(0xa2fe731b),
    SPH_C32(0xb3fdc1a2), SPH_C32(0x564e82b4) },
  { SPH_C32(0x056b0a00), SPH_C32(0xe4ec9358), SPH_C32(0x8c2d94fe),
    SPH_C32(0x76db43eb), SPH_C32(0xbd620b00), SPH_C32(0x28e142c3),
    SPH_C32(0x36741909), SPH_C32(0xb08ae6d0) },
  { SPH_C32(0xb2cf0b00), SPH_C32(0x6ef3a280), SPH_C32(0x09a44c55),
    SPH_C32(0x901f278f), SPH_C32(0xce2e0b00), SPH_C32(0xbd8ee515),
    SPH_C32(0x94e90b9e), SPH_C32(0xde6f8e84) },
  { SPH_C32(0xb0870c00), SPH_C32(0x714710f4), SPH_C32(0xa152e1f5),
    SPH_C32(0x3454d933), SPH_C32(0xca8f0800), SPH_C32(0x07396701),
    SPH_C32(0x1bf7cf7c), SPH_C32(0x82c07470) },
  { SPH_C32(0x07230d00), SPH_C32(0xfb58212c), SPH_C32(0x24db395e),
    SPH_C32(0xd290bd57), SPH_C32(0xb9c30800), SPH_C32(0x9256c0d7),
    SPH_C32(0xb96addeb), SPH_C32(0xec251c24) },
  { SPH_C32(0xc3cb0c00), SPH_C32(0xe428b722), SPH_C32(0x03cff362),
    SPH_C32(0x5ab1b167), SPH_C32(0x0e670900), SPH_C32(0x1849f10f),
    SPH_C32(0x3ce30540), SPH_C32(0x0ae17840) },
  { SPH_C32(0x746f0d00), SPH_C32(0x6e3786fa), SPH_C32(0x86462bc9),
    SPH_C32(0xbc75d503), SPH_C32(0x7d2b0900), SPH_C32(0x8d2656d9),
    SPH_C32(0x9e7e17d7), SPH_C32(0x64041014) },
  { SPH_C32(0x173f0e00), SPH_C32(0x6e5594c7), SPH_C32(0xc1b71807),
    SPH_C32(0xaa40ac45), SPH_C32(0x24a90800), SPH_C32(0x15720f3f),
    SPH_C32(0x9b3519f3), SPH_C32(0xb933df5c) },
  { SPH_C32(0xa09b0f00), SPH_C32(0xe44aa51f), SPH_C32(0x443ec0ac),
    SPH_C32(0x4c84c821), SPH_C32(0x57e50800), SPH_C32(0x801da8e9),
    SPH_C32(0x39a80b64), SPH_C32(0xd7d6b708) },
  { SPH_C32(0x64730e00), SPH_C32(0xfb3a3311), SPH_C32(0x632a0a90),
    SPH_C32(0xc4a5c411), SPH_C32(0xe0410900), SPH_C32(0x0a029931),
    SPH_C32(0xbc21d3cf), SPH_C32(0x3112d36c) },
  { SPH_C32(0xd3d70f00), SPH_C32(0x712502c9), SPH_C32(0xe6a3d23b),
    SPH_C32(0x2261a075), SPH_C32(0x930d0900), SPH_C32(0x9f6d3ee7),
    SPH_C32(0x1ebcc158), SPH_C32(0x5ff7bb38) },
  { SPH_C32(0x5ea10c00), SPH_C32(0x630c78ca), SPH_C32(0x2190377a),
    SPH_C32(0x0fa7721f), SPH_C32(0x83110a00), SPH_C32(0x0a608b0c),
    SPH_C32(0xfbd0e001), SPH_C32(0x2727aa2a) },
  { SPH_C32(0xe9050d00), SPH_C32(0xe9134912), SPH_C32(0xa419efd1),
    SPH_C32(0xe963167b), SPH_C32(0xf05d0a00), SPH_C32(0x9f0f2cda),
    SPH_C32(0x594df296), SPH_C32(0x49c2c27e) },
  { SPH_C32(0x2ded0c00), SPH_C32(0xf663df1c), SPH_C32(0x830d25ed),
    SPH_C32(0x61421a4b), SPH_C32(0x47f90b00), SPH_C32(0x15101d02),
    SPH_C32(0xdcc42a3d), SPH_C32(0xaf06a61a) },
  { SPH_C32(0x9a490d00), SPH_C32(0x7c7ceec4), SPH_C32(0x0684fd46),
    SPH_C32(0x87867e2f), SPH_C32(0x34b50b00), SPH_C32(0x807fbad4),
    SPH_C32(0x7e5938aa), SPH_C32(0xc1e3ce4e) },
  { SPH_C32(0xf9190e00), SPH_C32(0x7c1efcf9), SPH_C32(0x4175ce88),
    SPH_C32(0x91b30769), SPH_C32(0x6d370a00), SPH_C32(0x182be332),
    SPH_C32(0x7b12368e), SPH_C32(0x1cd40106) },
  { SPH_C32(0x4ebd0f00), SPH_C32(0xf601cd21), SPH_C32(0xc4fc1623),
    SPH_C32(0x7777630d), SPH_C32(0x1e7b0a00), SPH_C32(0x8d4444e4),
    SPH_C32(0xd98f2419), SPH_C32(0x72316952) },
  { SPH_C32(0x8a550e00), SPH_C32(0xe9715b2f), SPH_C32(0xe3e8dc1f),
    SPH_C32(0xff566f3d), SPH_C32(0xa9df0b00), SPH_C32(0x075b753c),
    SPH_C32(0x5c06fcb2), SPH_C32(0x94f50d36) },
  { SPH_C32(0x3df10f00), SPH_C32(0x636e6af7), SPH_C32(0x666104b4),
    SPH_C32(0x19920b59), SPH_C32(0xda930b00), SPH_C32(0x9234d2ea),
    SPH_C32(0xfe9bee25), SPH_C32(0xfa106562) },
  { SPH_C32(0x2b040800), SPH_C32(0x5360ef7c), SPH_C32(0xa4e54caf),
    SPH_C32(0x99a61e03), SPH_C32(0x45b10c00), SPH_C32(0x0aa4af76),
    SPH_C32(0x7432879d), SPH_C32(0x0b4d58a6) },
  { SPH_C32(0x9ca00900), SPH_C32(0xd97fdea4), SPH_C32(0x216c9404),
    SPH_C32(0x7f627a67), SPH_C32(0x36fd0c00), SPH_C32(0x9fcb08a0),
    SPH_C32(0xd6af950a), SPH_C32(0x65a830f2) },
  { SPH_C32(0x58480800), SPH_C32(0xc60f48aa), SPH_C32(0x06785e38),
    SPH_C32(0xf7437657), SPH_C32(0x81590d00), SPH_C32(0x15d43978),
    SPH_C32(0x53264da1), SPH_C32(0x836c5496) },
  { SPH_C32(0xefec0900), SPH_C32(0x4c107972), SPH_C32(0x83f18693),
    SPH_C32(0x11871233), SPH_C32(0xf2150d00), SPH_C32(0x80bb9eae),
    SPH_C32(0xf1bb5f36), SPH_C32(0xed893cc2) },
  { SPH_C32(0x8cbc0a00), SPH_C32(0x4c726b4f), SPH_C32(0xc400b55d),
    SPH_C32(0x07b26b75), SPH_C32(0xab970c00), SPH_C32(0x18efc748),
    SPH_C32(0xf4f05112), SPH_C32(0x30bef38a) },
  { SPH_C32(0x3b180b00), SPH_C32(0xc66d5a97), SPH_C32(0x41896df6),
    SPH_C32(0xe1760f11), SPH_C32(0xd8db0c00), SPH_C32(0x8d80609e),
    SPH_C32(0x566d4385), SPH_C32(0x5e5b9bde) },
  { SPH_C32(0xfff00a00), SPH_C32(0xd91dcc99), SPH_C32(0x669da7ca),
    SPH_C32(0x69570321), SPH_C32(0x6f7f0d00), SPH_C32(0x079f5146),
    SPH_C32(0xd3e49b2e), SPH_C32(0xb89fffba) },
  { SPH_C32(0x48540b00), SPH_C32(0x5302fd41), SPH_C32(0xe3147f61),
    SPH_C32(0x8f936745), SPH_C32(0x1c330d00), SPH_C32(0x92f0f690),
    SPH_C32(0x717989b9), SPH_C32(0xd67a97ee) },
  { SPH_C32(0xc5220800), SPH_C32(0x412b8742), SPH_C32(0x24279a20),
    SPH_C32(0xa255b52f), SPH_C32(0x0c2f0e00), SPH_C32(0x07fd437b),
    SPH_C32(0x9415a8e0), SPH_C32(0xaeaa86fc) },
  { SPH_C32(0x72860900), SPH_C32(0xcb34b69a), SPH_C32(0xa1ae428b),
    SPH_C32(0x4491d14b), SPH_C32(0x7f630e00), SPH_C32(0x9292e4ad),
    SPH_C32(0x3688ba77), SPH_C32(0xc04feea8) },
  { SPH_C32(0xb66e0800), SPH_C32(0xd4442094), SPH_C32(0x86ba88b7),
    SPH_C32(0xccb0dd7b), SPH_C32(0xc8c70f00), SPH_C32(0x188dd575),
    SPH_C32(0xb30162dc), SPH_C32(0x268b8acc) },
  { SPH_C32(0x01ca0900), SPH_C32(0x5e5b114c), SPH_C32(0x0333501c),
    SPH_C32(0x2a74b91f), SPH_C32(0xbb8b0f00), SPH_C32(0x8de272a3),
    SPH_C32(0x119c704b), SPH_C32(0x486ee298) },
  { SPH_C32(0x629a0a00), SPH_C32(0x5e390371), SPH_C32(0x44c263d2),
    SPH_C32(0x3c41c059), SPH_C32(0xe2090e00), SPH_C32(0x15b62b45),
    SPH_C32(0x14d77e6f), SPH_C32(0x95592dd0) },
  { SPH_C32(0xd53e0b00), SPH_C32(0xd42632a9), SPH_C32(0xc14bbb79),
    SPH_C32(0xda85a43d), SPH_C32(0x91450e00), SPH_C32(0x80d98c93),
    SPH_C32(0xb64a6cf8), SPH_C32(0xfbbc4584) },
  { SPH_C32(0x11d60a00), SPH_C32(0xcb56a4a7), SPH_C32(0xe65f7145),
    SPH_C32(0x52a4a80d), SPH_C32(0x26e10f00), SPH_C32(0x0ac6bd4b),
    SPH_C32(0x33c3b453), SPH_C32(0x1d7821e0) },
  { SPH_C32(0xa6720b00), SPH_C32(0x4149957f), SPH_C32(0x63d6a9ee),
    SPH_C32(0xb460cc69), SPH_C32(0x55ad0f00), SPH_C32(0x9fa91a9d),
    SPH_C32(0x915ea6c4), SPH_C32(0x739d49b4) },
  { SPH_C32(0xa43a0c00), SPH_C32(0x5efd270b), SPH_C32(0xcb20044e),
    SPH_C32(0x102b32d5), SPH_C32(0x510c0c00), SPH_C32(0x251e9889),
    SPH_C32(0x1e406226), SPH_C32(0x2f32b340) },
  { SPH_C32(0x139e0d00), SPH_C32(0xd4e216d3), SPH_C32(0x4ea9dce5),
    SPH_C32(0xf6ef56b1), SPH_C32(0x22400c00), SPH_C32(0xb0713f5f),
    SPH_C32(0xbcdd70b1), SPH_C32(0x41d7db14) },
  { SPH_C32(0xd7760c00), SPH_C32(0xcb9280dd), SPH_C32(0x69bd16d9),
    SPH_C32(0x7ece5a81), SPH_C32(0x95e40d00), SPH_C32(0x3a6e0e87),
    SPH_C32(0x3954a81a), SPH_C32(0xa713bf70) },
  { SPH_C32(0x60d20d00), SPH_C32(0x418db105), SPH_C32(0xec34ce72),
    SPH_C32(0x980a3ee5), SPH_C32(0xe6a80d00), SPH_C32(0xaf01a951),
    SPH_C32(0x9bc9ba8d), SPH_C32(0xc9f6d724) },
  { SPH_C32(0x03820e00), SPH_C32(0x41efa338), SPH_C32(0xabc5fdbc),
    SPH_C32(0x8e3f47a3), SPH_C32(0xbf2a0c00), SPH_C32(0x3755f0b7),
    SPH_C32(0x9e82b4a9), SPH_C32(0x14c1186c) },
  { SPH_C32(0xb4260f00), SPH_C32(0xcbf092e0), SPH_C32(0x2e4c2517),
    SPH_C32(0x68fb23c7), SPH_C32(0xcc660c00), SPH_C32(0xa23a5761),
    SPH_C32(0x3c1fa63e), SPH_C32(0x7a247038) },
  { SPH_C32(0x70ce0e00), SPH_C32(0xd48004ee), SPH_C32(0x0958ef2b),
    SPH_C32(0xe0da2ff7), SPH_C32(0x7bc20d00), SPH_C32(0x282566b9),
    SPH_C32(0xb9967e95), SPH_C32(0x9ce0145c) },
  { SPH_C32(0xc76a0f00), SPH_C32(0x5e9f3536), SPH_C32(0x8cd13780),
    SPH_C32(0x061e4b93), SPH_C32(0x088e0d00), SPH_C32(0xbd4ac16f),
    SPH_C32(0x1b0b6c02), SPH_C32(0xf2057c08) },
  { SPH_C32(0x4a1c0c00), SPH_C32(0x4cb64f35), SPH_C32(0x4be2d2c1),
    SPH_C32(0x2bd899f9), SPH_C32(0x18920e00), SPH_C32(0x28477484),
    SPH_C32(0xfe674d5b), SPH_C32(0x8ad56d1a) },
  { SPH_C32(0xfdb80d00), SPH_C32(0xc6a97eed), SPH_C32(0xce6b0a6a),
    SPH_C32(0xcd1cfd9d), SPH_C32(0x6bde0e00), SPH_C32(0xbd28d352),
    SPH_C32(0x5cfa5fcc), SPH_C32(0xe430054e) },
  { SPH_C32(0x39500c00), SPH_C32(0xd9d9e8e3), SPH_C32(0xe97fc056),
    SPH_C32(0x453df1ad), SPH_C32(0xdc7a0f00), SPH_C32(0x3737e28a),
    SPH_C32(0xd9738767), SPH_C32(0x02f4612a) },
  { SPH_C32(0x8ef40d00), SPH_C32(0x53c6d93b), SPH_C32(0x6cf618fd),
    SPH_C32(0xa3f995c9), SPH_C32(0xaf360f00), SPH_C32(0xa258455c),
    SPH_C32(0x7bee95f0), SPH_C32(0x6c11097e) },
  { SPH_C32(0xeda40e00), SPH_C32(0x53a4cb06), SPH_C32(0x2b072b33),
    SPH_C32(0xb5ccec8f), SPH_C32(0xf6b40e00), SPH_C32(0x3a0c1cba),
    SPH_C32(0x7ea59bd4), SPH_C32(0xb126c636) },
  { SPH_C32(0x5a000f00), SPH_C32(0xd9bbfade), SPH_C32(0xae8ef398),
    SPH_C32(0x530888eb), SPH_C32(0x85f80e00), SPH_C32(0xaf63bb6c),
    SPH_C32(0xdc388943), SPH_C32(0xdfc3ae62) },
  { SPH_C32(0x9ee80e00), SPH_C32(0xc6cb6cd0), SPH_C32(0x899a39a4),
    SPH_C32(0xdb2984db), SPH_C32(0x325c0f00), SPH_C32(0x257c8ab4),
    SPH_C32(0x59b151e8), SPH_C32(0x3907ca06) },
  { SPH_C32(0x294c0f00), SPH_C32(0x4cd45d08), SPH_C32(0x0c13e10f),
    SPH_C32(0x3dede0bf), SPH_C32(0x41100f00), SPH_C32(0xb0132d62),
    SPH_C32(0xfb2c437f), SPH_C32(0x57e2a252) }
};

__constant static const sph_u32 T256_16[256][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0x515c0010), SPH_C32(0x40f372fb), SPH_C32(0xfce72602),
    SPH_C32(0x71575061), SPH_C32(0x2e390000), SPH_C32(0x64dd6689),
    SPH_C32(0x3cd406fc), SPH_C32(0xb1f490bc) },
  { SPH_C32(0x2e390000), SPH_C32(0x64dd6689), SPH_C32(0x3cd406fc),
    SPH_C32(0xb1f490bc), SPH_C32(0x7f650010), SPH_C32(0x242e1472),
    SPH_C32(0xc03320fe), SPH_C32(0xc0a3c0dd) },
  { SPH_C32(0x7f650010), SPH_C32(0x242e1472), SPH_C32(0xc03320fe),
    SPH_C32(0xc0a3c0dd), SPH_C32(0x515c0010), SPH_C32(0x40f372fb),
    SPH_C32(0xfce72602), SPH_C32(0x71575061) },
  { SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6), SPH_C32(0xf9ce4c04),
    SPH_C32(0xe2afa0c0), SPH_C32(0x5c720000), SPH_C32(0xc9bacd12),
    SPH_C32(0x79a90df9), SPH_C32(0x63e92178) },
  { SPH_C32(0xf3e40030), SPH_C32(0xc114970d), SPH_C32(0x05296a06),
    SPH_C32(0x93f8f0a1), SPH_C32(0x724b0000), SPH_C32(0xad67ab9b),
    SPH_C32(0x457d0b05), SPH_C32(0xd21db1c4) },
  { SPH_C32(0x8c810020), SPH_C32(0xe53a837f), SPH_C32(0xc51a4af8),
    SPH_C32(0x535b307c), SPH_C32(0x23170010), SPH_C32(0xed94d960),
    SPH_C32(0xb99a2d07), SPH_C32(0xa34ae1a5) },
  { SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184), SPH_C32(0x39fd6cfa),
    SPH_C32(0x220c601d), SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9),
    SPH_C32(0x854e2bfb), SPH_C32(0x12be7119) },
  { SPH_C32(0x5c720000), SPH_C32(0xc9bacd12), SPH_C32(0x79a90df9),
    SPH_C32(0x63e92178), SPH_C32(0xfeca0020), SPH_C32(0x485d28e4),
    SPH_C32(0x806741fd), SPH_C32(0x814681b8) },
  { SPH_C32(0x0d2e0010), SPH_C32(0x8949bfe9), SPH_C32(0x854e2bfb),
    SPH_C32(0x12be7119), SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d),
    SPH_C32(0xbcb34701), SPH_C32(0x30b21104) },
  { SPH_C32(0x724b0000), SPH_C32(0xad67ab9b), SPH_C32(0x457d0b05),
    SPH_C32(0xd21db1c4), SPH_C32(0x81af0030), SPH_C32(0x6c733c96),
    SPH_C32(0x40546103), SPH_C32(0x41e54165) },
  { SPH_C32(0x23170010), SPH_C32(0xed94d960), SPH_C32(0xb99a2d07),
    SPH_C32(0xa34ae1a5), SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f),
    SPH_C32(0x7c8067ff), SPH_C32(0xf011d1d9) },
  { SPH_C32(0xfeca0020), SPH_C32(0x485d28e4), SPH_C32(0x806741fd),
    SPH_C32(0x814681b8), SPH_C32(0xa2b80020), SPH_C32(0x81e7e5f6),
    SPH_C32(0xf9ce4c04), SPH_C32(0xe2afa0c0) },
  { SPH_C32(0xaf960030), SPH_C32(0x08ae5a1f), SPH_C32(0x7c8067ff),
    SPH_C32(0xf011d1d9), SPH_C32(0x8c810020), SPH_C32(0xe53a837f),
    SPH_C32(0xc51a4af8), SPH_C32(0x535b307c) },
  { SPH_C32(0xd0f30020), SPH_C32(0x2c804e6d), SPH_C32(0xbcb34701),
    SPH_C32(0x30b21104), SPH_C32(0xdddd0030), SPH_C32(0xa5c9f184),
    SPH_C32(0x39fd6cfa), SPH_C32(0x220c601d) },
  { SPH_C32(0x81af0030), SPH_C32(0x6c733c96), SPH_C32(0x40546103),
    SPH_C32(0x41e54165), SPH_C32(0xf3e40030), SPH_C32(0xc114970d),
    SPH_C32(0x05296a06), SPH_C32(0x93f8f0a1) },
  { SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e), SPH_C32(0x36656ba8),
    SPH_C32(0x23633a05), SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34),
    SPH_C32(0x5d5ca0f7), SPH_C32(0x727784cb) },
  { SPH_C32(0x1c920050), SPH_C32(0x7ba89e85), SPH_C32(0xca824daa),
    SPH_C32(0x52346a64), SPH_C32(0x56920000), SPH_C32(0xc4103cbd),
    SPH_C32(0x6188a60b), SPH_C32(0xc3831477) },
  { SPH_C32(0x63f70040), SPH_C32(0x5f868af7), SPH_C32(0x0ab16d54),
    SPH_C32(0x9297aab9), SPH_C32(0x07ce0010), SPH_C32(0x84e34e46),
    SPH_C32(0x9d6f8009), SPH_C32(0xb2d44416) },
  { SPH_C32(0x32ab0050), SPH_C32(0x1f75f80c), SPH_C32(0xf6564b56),
    SPH_C32(0xe3c0fad8), SPH_C32(0x29f70010), SPH_C32(0xe03e28cf),
    SPH_C32(0xa1bb86f5), SPH_C32(0x0320d4aa) },
  { SPH_C32(0xef760060), SPH_C32(0xbabc0988), SPH_C32(0xcfab27ac),
    SPH_C32(0xc1cc9ac5), SPH_C32(0x24d90000), SPH_C32(0x69779726),
    SPH_C32(0x24f5ad0e), SPH_C32(0x119ea5b3) },
  { SPH_C32(0xbe2a0070), SPH_C32(0xfa4f7b73), SPH_C32(0x334c01ae),
    SPH_C32(0xb09bcaa4), SPH_C32(0x0ae00000), SPH_C32(0x0daaf1af),
    SPH_C32(0x1821abf2), SPH_C32(0xa06a350f) },
  { SPH_C32(0xc14f0060), SPH_C32(0xde616f01), SPH_C32(0xf37f2150),
    SPH_C32(0x70380a79), SPH_C32(0x5bbc0010), SPH_C32(0x4d598354),
    SPH_C32(0xe4c68df0), SPH_C32(0xd13d656e) },
  { SPH_C32(0x90130070), SPH_C32(0x9e921dfa), SPH_C32(0x0f980752),
    SPH_C32(0x016f5a18), SPH_C32(0x75850010), SPH_C32(0x2984e5dd),
    SPH_C32(0xd8128b0c), SPH_C32(0x60c9f5d2) },
  { SPH_C32(0x11bc0040), SPH_C32(0xf2e1216c), SPH_C32(0x4fcc6651),
    SPH_C32(0x408a1b7d), SPH_C32(0x86610020), SPH_C32(0xe89072d0),
    SPH_C32(0xdd3be10a), SPH_C32(0xf3310573) },
  { SPH_C32(0x40e00050), SPH_C32(0xb2125397), SPH_C32(0xb32b4053),
    SPH_C32(0x31dd4b1c), SPH_C32(0xa8580020), SPH_C32(0x8c4d1459),
    SPH_C32(0xe1efe7f6), SPH_C32(0x42c595cf) },
  { SPH_C32(0x3f850040), SPH_C32(0x963c47e5), SPH_C32(0x731860ad),
    SPH_C32(0xf17e8bc1), SPH_C32(0xf9040030), SPH_C32(0xccbe66a2),
    SPH_C32(0x1d08c1f4), SPH_C32(0x3392c5ae) },
  { SPH_C32(0x6ed90050), SPH_C32(0xd6cf351e), SPH_C32(0x8fff46af),
    SPH_C32(0x8029dba0), SPH_C32(0xd73d0030), SPH_C32(0xa863002b),
    SPH_C32(0x21dcc708), SPH_C32(0x82665512) },
  { SPH_C32(0xb3040060), SPH_C32(0x7306c49a), SPH_C32(0xb6022a55),
    SPH_C32(0xa225bbbd), SPH_C32(0xda130020), SPH_C32(0x212abfc2),
    SPH_C32(0xa492ecf3), SPH_C32(0x90d8240b) },
  { SPH_C32(0xe2580070), SPH_C32(0x33f5b661), SPH_C32(0x4ae50c57),
    SPH_C32(0xd372ebdc), SPH_C32(0xf42a0020), SPH_C32(0x45f7d94b),
    SPH_C32(0x9846ea0f), SPH_C32(0x212cb4b7) },
  { SPH_C32(0x9d3d0060), SPH_C32(0x17dba213), SPH_C32(0x8ad62ca9),
    SPH_C32(0x13d12b01), SPH_C32(0xa5760030), SPH_C32(0x0504abb0),
    SPH_C32(0x64a1cc0d), SPH_C32(0x507be4d6) },
  { SPH_C32(0xcc610070), SPH_C32(0x5728d0e8), SPH_C32(0x76310aab),
    SPH_C32(0x62867b60), SPH_C32(0x8b4f0030), SPH_C32(0x61d9cd39),
    SPH_C32(0x5875caf1), SPH_C32(0xe18f746a) },
  { SPH_C32(0x78ab0000), SPH_C32(0xa0cd5a34), SPH_C32(0x5d5ca0f7),
    SPH_C32(0x727784cb), SPH_C32(0x35650040), SPH_C32(0x9b96b64a),
    SPH_C32(0x6b39cb5f), SPH_C32(0x5114bece) },
  { SPH_C32(0x29f70010), SPH_C32(0xe03e28cf), SPH_C32(0xa1bb86f5),
    SPH_C32(0x0320d4aa), SPH_C32(0x1b5c0040), SPH_C32(0xff4bd0c3),
    SPH_C32(0x57edcda3), SPH_C32(0xe0e02e72) },
  { SPH_C32(0x56920000), SPH_C32(0xc4103cbd), SPH_C32(0x6188a60b),
    SPH_C32(0xc3831477), SPH_C32(0x4a000050), SPH_C32(0xbfb8a238),
    SPH_C32(0xab0aeba1), SPH_C32(0x91b77e13) },
  { SPH_C32(0x07ce0010), SPH_C32(0x84e34e46), SPH_C32(0x9d6f8009),
    SPH_C32(0xb2d44416), SPH_C32(0x64390050), SPH_C32(0xdb65c4b1),
    SPH_C32(0x97deed5d), SPH_C32(0x2043eeaf) },
  { SPH_C32(0xda130020), SPH_C32(0x212abfc2), SPH_C32(0xa492ecf3),
    SPH_C32(0x90d8240b), SPH_C32(0x69170040), SPH_C32(0x522c7b58),
    SPH_C32(0x1290c6a6), SPH_C32(0x32fd9fb6) },
  { SPH_C32(0x8b4f0030), SPH_C32(0x61d9cd39), SPH_C32(0x5875caf1),
    SPH_C32(0xe18f746a), SPH_C32(0x472e0040), SPH_C32(0x36f11dd1),
    SPH_C32(0x2e44c05a), SPH_C32(0x83090f0a) },
  { SPH_C32(0xf42a0020), SPH_C32(0x45f7d94b), SPH_C32(0x9846ea0f),
    SPH_C32(0x212cb4b7), SPH_C32(0x16720050), SPH_C32(0x76026f2a),
    SPH_C32(0xd2a3e658), SPH_C32(0xf25e5f6b) },
  { SPH_C32(0xa5760030), SPH_C32(0x0504abb0), SPH_C32(0x64a1cc0d),
    SPH_C32(0x507be4d6), SPH_C32(0x384b0050), SPH_C32(0x12df09a3),
    SPH_C32(0xee77e0a4), SPH_C32(0x43aacfd7) },
  { SPH_C32(0x24d90000), SPH_C32(0x69779726), SPH_C32(0x24f5ad0e),
    SPH_C32(0x119ea5b3), SPH_C32(0xcbaf0060), SPH_C32(0xd3cb9eae),
    SPH_C32(0xeb5e8aa2), SPH_C32(0xd0523f76) },
  { SPH_C32(0x75850010), SPH_C32(0x2984e5dd), SPH_C32(0xd8128b0c),
    SPH_C32(0x60c9f5d2), SPH_C32(0xe5960060), SPH_C32(0xb716f827),
    SPH_C32(0xd78a8c5e), SPH_C32(0x61a6afca) },
  { SPH_C32(0x0ae00000), SPH_C32(0x0daaf1af), SPH_C32(0x1821abf2),
    SPH_C32(0xa06a350f), SPH_C32(0xb4ca0070), SPH_C32(0xf7e58adc),
    SPH_C32(0x2b6daa5c), SPH_C32(0x10f1ffab) },
  { SPH_C32(0x5bbc0010), SPH_C32(0x4d598354), SPH_C32(0xe4c68df0),
    SPH_C32(0xd13d656e), SPH_C32(0x9af30070), SPH_C32(0x9338ec55),
    SPH_C32(0x17b9aca0), SPH_C32(0xa1056f17) },
  { SPH_C32(0x86610020), SPH_C32(0xe89072d0), SPH_C32(0xdd3be10a),
    SPH_C32(0xf3310573), SPH_C32(0x97dd0060), SPH_C32(0x1a7153bc),
    SPH_C32(0x92f7875b), SPH_C32(0xb3bb1e0e) },
  { SPH_C32(0xd73d0030), SPH_C32(0xa863002b), SPH_C32(0x21dcc708),
    SPH_C32(0x82665512), SPH_C32(0xb9e40060), SPH_C32(0x7eac3535),
    SPH_C32(0xae2381a7), SPH_C32(0x024f8eb2) },
  { SPH_C32(0xa8580020), SPH_C32(0x8c4d1459), SPH_C32(0xe1efe7f6),
    SPH_C32(0x42c595cf), SPH_C32(0xe8b80070), SPH_C32(0x3e5f47ce),
    SPH_C32(0x52c4a7a5), SPH_C32(0x7318ded3) },
  { SPH_C32(0xf9040030), SPH_C32(0xccbe66a2), SPH_C32(0x1d08c1f4),
    SPH_C32(0x3392c5ae), SPH_C32(0xc6810070), SPH_C32(0x5a822147),
    SPH_C32(0x6e10a159), SPH_C32(0xc2ec4e6f) },
  { SPH_C32(0x35650040), SPH_C32(0x9b96b64a), SPH_C32(0x6b39cb5f),
    SPH_C32(0x5114bece), SPH_C32(0x4dce0040), SPH_C32(0x3b5bec7e),
    SPH_C32(0x36656ba8), SPH_C32(0x23633a05) },
  { SPH_C32(0x64390050), SPH_C32(0xdb65c4b1), SPH_C32(0x97deed5d),
    SPH_C32(0x2043eeaf), SPH_C32(0x63f70040), SPH_C32(0x5f868af7),
    SPH_C32(0x0ab16d54), SPH_C32(0x9297aab9) },
  { SPH_C32(0x1b5c0040), SPH_C32(0xff4bd0c3), SPH_C32(0x57edcda3),
    SPH_C32(0xe0e02e72), SPH_C32(0x32ab0050), SPH_C32(0x1f75f80c),
    SPH_C32(0xf6564b56), SPH_C32(0xe3c0fad8) },
  { SPH_C32(0x4a000050), SPH_C32(0xbfb8a238), SPH_C32(0xab0aeba1),
    SPH_C32(0x91b77e13), SPH_C32(0x1c920050), SPH_C32(0x7ba89e85),
    SPH_C32(0xca824daa), SPH_C32(0x52346a64) },
  { SPH_C32(0x97dd0060), SPH_C32(0x1a7153bc), SPH_C32(0x92f7875b),
    SPH_C32(0xb3bb1e0e), SPH_C32(0x11bc0040), SPH_C32(0xf2e1216c),
    SPH_C32(0x4fcc6651), SPH_C32(0x408a1b7d) },
  { SPH_C32(0xc6810070), SPH_C32(0x5a822147), SPH_C32(0x6e10a159),
    SPH_C32(0xc2ec4e6f), SPH_C32(0x3f850040), SPH_C32(0x963c47e5),
    SPH_C32(0x731860ad), SPH_C32(0xf17e8bc1) },
  { SPH_C32(0xb9e40060), SPH_C32(0x7eac3535), SPH_C32(0xae2381a7),
    SPH_C32(0x024f8eb2), SPH_C32(0x6ed90050), SPH_C32(0xd6cf351e),
    SPH_C32(0x8fff46af), SPH_C32(0x8029dba0) },
  { SPH_C32(0xe8b80070), SPH_C32(0x3e5f47ce), SPH_C32(0x52c4a7a5),
    SPH_C32(0x7318ded3), SPH_C32(0x40e00050), SPH_C32(0xb2125397),
    SPH_C32(0xb32b4053), SPH_C32(0x31dd4b1c) },
  { SPH_C32(0x69170040), SPH_C32(0x522c7b58), SPH_C32(0x1290c6a6),
    SPH_C32(0x32fd9fb6), SPH_C32(0xb3040060), SPH_C32(0x7306c49a),
    SPH_C32(0xb6022a55), SPH_C32(0xa225bbbd) },
  { SPH_C32(0x384b0050), SPH_C32(0x12df09a3), SPH_C32(0xee77e0a4),
    SPH_C32(0x43aacfd7), SPH_C32(0x9d3d0060), SPH_C32(0x17dba213),
    SPH_C32(0x8ad62ca9), SPH_C32(0x13d12b01) },
  { SPH_C32(0x472e0040), SPH_C32(0x36f11dd1), SPH_C32(0x2e44c05a),
    SPH_C32(0x83090f0a), SPH_C32(0xcc610070), SPH_C32(0x5728d0e8),
    SPH_C32(0x76310aab), SPH_C32(0x62867b60) },
  { SPH_C32(0x16720050), SPH_C32(0x76026f2a), SPH_C32(0xd2a3e658),
    SPH_C32(0xf25e5f6b), SPH_C32(0xe2580070), SPH_C32(0x33f5b661),
    SPH_C32(0x4ae50c57), SPH_C32(0xd372ebdc) },
  { SPH_C32(0xcbaf0060), SPH_C32(0xd3cb9eae), SPH_C32(0xeb5e8aa2),
    SPH_C32(0xd0523f76), SPH_C32(0xef760060), SPH_C32(0xbabc0988),
    SPH_C32(0xcfab27ac), SPH_C32(0xc1cc9ac5) },
  { SPH_C32(0x9af30070), SPH_C32(0x9338ec55), SPH_C32(0x17b9aca0),
    SPH_C32(0xa1056f17), SPH_C32(0xc14f0060), SPH_C32(0xde616f01),
    SPH_C32(0xf37f2150), SPH_C32(0x70380a79) },
  { SPH_C32(0xe5960060), SPH_C32(0xb716f827), SPH_C32(0xd78a8c5e),
    SPH_C32(0x61a6afca), SPH_C32(0x90130070), SPH_C32(0x9e921dfa),
    SPH_C32(0x0f980752), SPH_C32(0x016f5a18) },
  { SPH_C32(0xb4ca0070), SPH_C32(0xf7e58adc), SPH_C32(0x2b6daa5c),
    SPH_C32(0x10f1ffab), SPH_C32(0xbe2a0070), SPH_C32(0xfa4f7b73),
    SPH_C32(0x334c01ae), SPH_C32(0xb09bcaa4) },
  { SPH_C32(0x5bd20080), SPH_C32(0x450f18ec), SPH_C32(0xc2c46c55),
    SPH_C32(0xf362b233), SPH_C32(0x39a60000), SPH_C32(0x4ab753eb),
    SPH_C32(0xd14e094b), SPH_C32(0xb772b42b) },
  { SPH_C32(0x0a8e0090), SPH_C32(0x05fc6a17), SPH_C32(0x3e234a57),
    SPH_C32(0x8235e252), SPH_C32(0x179f0000), SPH_C32(0x2e6a3562),
    SPH_C32(0xed9a0fb7), SPH_C32(0x06862497) },
  { SPH_C32(0x75eb0080), SPH_C32(0x21d27e65), SPH_C32(0xfe106aa9),
    SPH_C32(0x4296228f), SPH_C32(0x46c30010), SPH_C32(0x6e994799),
    SPH_C32(0x117d29b5), SPH_C32(0x77d174f6) },
  { SPH_C32(0x24b70090), SPH_C32(0x61210c9e), SPH_C32(0x02f74cab),
    SPH_C32(0x33c172ee), SPH_C32(0x68fa0010), SPH_C32(0x0a442110),
    SPH_C32(0x2da92f49), SPH_C32(0xc625e44a) },
  { SPH_C32(0xf96a00a0), SPH_C32(0xc4e8fd1a), SPH_C32(0x3b0a2051),
    SPH_C32(0x11cd12f3), SPH_C32(0x65d40000), SPH_C32(0x830d9ef9),
    SPH_C32(0xa8e704b2), SPH_C32(0xd49b9553) },
  { SPH_C32(0xa83600b0), SPH_C32(0x841b8fe1), SPH_C32(0xc7ed0653),
    SPH_C32(0x609a4292), SPH_C32(0x4bed0000), SPH_C32(0xe7d0f870),
    SPH_C32(0x9433024e), SPH_C32(0x656f05ef) },
  { SPH_C32(0xd75300a0), SPH_C32(0xa0359b93), SPH_C32(0x07de26ad),
    SPH_C32(0xa039824f), SPH_C32(0x1ab10010), SPH_C32(0xa7238a8b),
    SPH_C32(0x68d4244c), SPH_C32(0x1438558e) },
  { SPH_C32(0x860f00b0), SPH_C32(0xe0c6e968), SPH_C32(0xfb3900af),
    SPH_C32(0xd16ed22e), SPH_C32(0x34880010), SPH_C32(0xc3feec02),
    SPH_C32(0x540022b0), SPH_C32(0xa5ccc532) },
  { SPH_C32(0x07a00080), SPH_C32(0x8cb5d5fe), SPH_C32(0xbb6d61ac),
    SPH_C32(0x908b934b), SPH_C32(0xc76c0020), SPH_C32(0x02ea7b0f),
    SPH_C32(0x512948b6), SPH_C32(0x36343593) },
  { SPH_C32(0x56fc0090), SPH_C32(0xcc46a705), SPH_C32(0x478a47ae),
    SPH_C32(0xe1dcc32a), SPH_C32(0xe9550020), SPH_C32(0x66371d86),
    SPH_C32(0x6dfd4e4a), SPH_C32(0x87c0a52f) },
  { SPH_C32(0x29990080), SPH_C32(0xe868b377), SPH_C32(0x87b96750),
    SPH_C32(0x217f03f7), SPH_C32(0xb8090030), SPH_C32(0x26c46f7d),
    SPH_C32(0x911a6848), SPH_C32(0xf697f54e) },
  { SPH_C32(0x78c50090), SPH_C32(0xa89bc18c), SPH_C32(0x7b5e4152),
    SPH_C32(0x50285396), SPH_C32(0x96300030), SPH_C32(0x421909f4),
    SPH_C32(0xadce6eb4), SPH_C32(0x476365f2) },
  { SPH_C32(0xa51800a0), SPH_C32(0x0d523008), SPH_C32(0x42a32da8),
    SPH_C32(0x7224338b), SPH_C32(0x9b1e0020), SPH_C32(0xcb50b61d),
    SPH_C32(0x2880454f), SPH_C32(0x55dd14eb) },
  { SPH_C32(0xf44400b0), SPH_C32(0x4da142f3), SPH_C32(0xbe440baa),
    SPH_C32(0x037363ea), SPH_C32(0xb5270020), SPH_C32(0xaf8dd094),
    SPH_C32(0x145443b3), SPH_C32(0xe4298457) },
  { SPH_C32(0x8b2100a0), SPH_C32(0x698f5681), SPH_C32(0x7e772b54),
    SPH_C32(0xc3d0a337), SPH_C32(0xe47b0030), SPH_C32(0xef7ea26f),
    SPH_C32(0xe8b365b1), SPH_C32(0x957ed436) },
  { SPH_C32(0xda7d00b0), SPH_C32(0x297c247a), SPH_C32(0x82900d56),
    SPH_C32(0xb287f356), SPH_C32(0xca420030), SPH_C32(0x8ba3c4e6),
    SPH_C32(0xd467634d), SPH_C32(0x248a448a) },
  { SPH_C32(0x161c00c0), SPH_C32(0x7e54f492), SPH_C32(0xf4a107fd),
    SPH_C32(0xd0018836), SPH_C32(0x410d0000), SPH_C32(0xea7a09df),
    SPH_C32(0x8c12a9bc), SPH_C32(0xc50530e0) },
  { SPH_C32(0x474000d0), SPH_C32(0x3ea78669), SPH_C32(0x084621ff),
    SPH_C32(0xa156d857), SPH_C32(0x6f340000), SPH_C32(0x8ea76f56),
    SPH_C32(0xb0c6af40), SPH_C32(0x74f1a05c) },
  { SPH_C32(0x382500c0), SPH_C32(0x1a89921b), SPH_C32(0xc8750101),
    SPH_C32(0x61f5188a), SPH_C32(0x3e680010), SPH_C32(0xce541dad),
    SPH_C32(0x4c218942), SPH_C32(0x05a6f03d) },
  { SPH_C32(0x697900d0), SPH_C32(0x5a7ae0e0), SPH_C32(0x34922703),
    SPH_C32(0x10a248eb), SPH_C32(0x10510010), SPH_C32(0xaa897b24),
    SPH_C32(0x70f58fbe), SPH_C32(0xb4526081) },
  { SPH_C32(0xb4a400e0), SPH_C32(0xffb31164), SPH_C32(0x0d6f4bf9),
    SPH_C32(0x32ae28f6), SPH_C32(0x1d7f0000), SPH_C32(0x23c0c4cd),
    SPH_C32(0xf5bba445), SPH_C32(0xa6ec1198) },
  { SPH_C32(0xe5f800f0), SPH_C32(0xbf40639f), SPH_C32(0xf1886dfb),
    SPH_C32(0x43f97897), SPH_C32(0x33460000), SPH_C32(0x471da244),
    SPH_C32(0xc96fa2b9), SPH_C32(0x17188124) },
  { SPH_C32(0x9a9d00e0), SPH_C32(0x9b6e77ed), SPH_C32(0x31bb4d05),
    SPH_C32(0x835ab84a), SPH_C32(0x621a0010), SPH_C32(0x07eed0bf),
    SPH_C32(0x358884bb), SPH_C32(0x664fd145) },
  { SPH_C32(0xcbc100f0), SPH_C32(0xdb9d0516), SPH_C32(0xcd5c6b07),
    SPH_C32(0xf20de82b), SPH_C32(0x4c230010), SPH_C32(0x6333b636),
    SPH_C32(0x095c8247), SPH_C32(0xd7bb41f9) },
  { SPH_C32(0x4a6e00c0), SPH_C32(0xb7ee3980), SPH_C32(0x8d080a04),
    SPH_C32(0xb3e8a94e), SPH_C32(0xbfc70020), SPH_C32(0xa227213b),
    SPH_C32(0x0c75e841), SPH_C32(0x4443b158) },
  { SPH_C32(0x1b3200d0), SPH_C32(0xf71d4b7b), SPH_C32(0x71ef2c06),
    SPH_C32(0xc2bff92f), SPH_C32(0x91fe0020), SPH_C32(0xc6fa47b2),
    SPH_C32(0x30a1eebd), SPH_C32(0xf5b721e4) },
  { SPH_C32(0x645700c0), SPH_C32(0xd3335f09), SPH_C32(0xb1dc0cf8),
    SPH_C32(0x021c39f2), SPH_C32(0xc0a20030), SPH_C32(0x86093549),
    SPH_C32(0xcc46c8bf), SPH_C32(0x84e07185) },
  { SPH_C32(0x350b00d0), SPH_C32(0x93c02df2), SPH_C32(0x4d3b2afa),
    SPH_C32(0x734b6993), SPH_C32(0xee9b0030), SPH_C32(0xe2d453c0),
    SPH_C32(0xf092ce43), SPH_C32(0x3514e139) },
  { SPH_C32(0xe8d600e0), SPH_C32(0x3609dc76), SPH_C32(0x74c64600),
    SPH_C32(0x5147098e), SPH_C32(0xe3b50020), SPH_C32(0x6b9dec29),
    SPH_C32(0x75dce5b8), SPH_C32(0x27aa9020) },
  { SPH_C32(0xb98a00f0), SPH_C32(0x76faae8d), SPH_C32(0x88216002),
    SPH_C32(0x201059ef), SPH_C32(0xcd8c0020), SPH_C32(0x0f408aa0),
    SPH_C32(0x4908e344), SPH_C32(0x965e009c) },
  { SPH_C32(0xc6ef00e0), SPH_C32(0x52d4baff), SPH_C32(0x481240fc),
    SPH_C32(0xe0b39932), SPH_C32(0x9cd00030), SPH_C32(0x4fb3f85b),
    SPH_C32(0xb5efc546), SPH_C32(0xe70950fd) },
  { SPH_C32(0x97b300f0), SPH_C32(0x1227c804), SPH_C32(0xb4f566fe),
    SPH_C32(0x91e4c953), SPH_C32(0xb2e90030), SPH_C32(0x2b6e9ed2),
    SPH_C32(0x893bc3ba), SPH_C32(0x56fdc041) },
  { SPH_C32(0x23790080), SPH_C32(0xe5c242d8), SPH_C32(0x9f98cca2),
    SPH_C32(0x811536f8), SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1),
    SPH_C32(0xba77c214), SPH_C32(0xe6660ae5) },
  { SPH_C32(0x72250090), SPH_C32(0xa5313023), SPH_C32(0x637feaa0),
    SPH_C32(0xf0426699), SPH_C32(0x22fa0040), SPH_C32(0xb5fc8328),
    SPH_C32(0x86a3c4e8), SPH_C32(0x57929a59) },
  { SPH_C32(0x0d400080), SPH_C32(0x811f2451), SPH_C32(0xa34cca5e),
    SPH_C32(0x30e1a644), SPH_C32(0x73a60050), SPH_C32(0xf50ff1d3),
    SPH_C32(0x7a44e2ea), SPH_C32(0x26c5ca38) },
  { SPH_C32(0x5c1c0090), SPH_C32(0xc1ec56aa), SPH_C32(0x5fabec5c),
    SPH_C32(0x41b6f625), SPH_C32(0x5d9f0050), SPH_C32(0x91d2975a),
    SPH_C32(0x4690e416), SPH_C32(0x97315a84) },
  { SPH_C32(0x81c100a0), SPH_C32(0x6425a72e), SPH_C32(0x665680a6),
    SPH_C32(0x63ba9638), SPH_C32(0x50b10040), SPH_C32(0x189b28b3),
    SPH_C32(0xc3decfed), SPH_C32(0x858f2b9d) },
  { SPH_C32(0xd09d00b0), SPH_C32(0x24d6d5d5), SPH_C32(0x9ab1a6a4),
    SPH_C32(0x12edc659), SPH_C32(0x7e880040), SPH_C32(0x7c464e3a),
    SPH_C32(0xff0ac911), SPH_C32(0x347bbb21) },
  { SPH_C32(0xaff800a0), SPH_C32(0x00f8c1a7), SPH_C32(0x5a82865a),
    SPH_C32(0xd24e0684), SPH_C32(0x2fd40050), SPH_C32(0x3cb53cc1),
    SPH_C32(0x03edef13), SPH_C32(0x452ceb40) },
  { SPH_C32(0xfea400b0), SPH_C32(0x400bb35c), SPH_C32(0xa665a058),
    SPH_C32(0xa31956e5), SPH_C32(0x01ed0050), SPH_C32(0x58685a48),
    SPH_C32(0x3f39e9ef), SPH_C32(0xf4d87bfc) },
  { SPH_C32(0x7f0b0080), SPH_C32(0x2c788fca), SPH_C32(0xe631c15b),
    SPH_C32(0xe2fc1780), SPH_C32(0xf2090060), SPH_C32(0x997ccd45),
    SPH_C32(0x3a1083e9), SPH_C32(0x67208b5d) },
  { SPH_C32(0x2e570090), SPH_C32(0x6c8bfd31), SPH_C32(0x1ad6e759),
    SPH_C32(0x93ab47e1), SPH_C32(0xdc300060), SPH_C32(0xfda1abcc),
    SPH_C32(0x06c48515), SPH_C32(0xd6d41be1) },
  { SPH_C32(0x51320080), SPH_C32(0x48a5e943), SPH_C32(0xdae5c7a7),
    SPH_C32(0x5308873c), SPH_C32(0x8d6c0070), SPH_C32(0xbd52d937),
    SPH_C32(0xfa23a317), SPH_C32(0xa7834b80) },
  { SPH_C32(0x006e0090), SPH_C32(0x08569bb8), SPH_C32(0x2602e1a5),
    SPH_C32(0x225fd75d), SPH_C32(0xa3550070), SPH_C32(0xd98fbfbe),
    SPH_C32(0xc6f7a5eb), SPH_C32(0x1677db3c) },
  { SPH_C32(0xddb300a0), SPH_C32(0xad9f6a3c), SPH_C32(0x1fff8d5f),
    SPH_C32(0x0053b740), SPH_C32(0xae7b0060), SPH_C32(0x50c60057),
    SPH_C32(0x43b98e10), SPH_C32(0x04c9aa25) },
  { SPH_C32(0x8cef00b0), SPH_C32(0xed6c18c7), SPH_C32(0xe318ab5d),
    SPH_C32(0x7104e721), SPH_C32(0x80420060), SPH_C32(0x341b66de),
    SPH_C32(0x7f6d88ec), SPH_C32(0xb53d3a99) },
  { SPH_C32(0xf38a00a0), SPH_C32(0xc9420cb5), SPH_C32(0x232b8ba3),
    SPH_C32(0xb1a727fc), SPH_C32(0xd11e0070), SPH_C32(0x74e81425),
    SPH_C32(0x838aaeee), SPH_C32(0xc46a6af8) },
  { SPH_C32(0xa2d600b0), SPH_C32(0x89b17e4e), SPH_C32(0xdfccada1),
    SPH_C32(0xc0f0779d), SPH_C32(0xff270070), SPH_C32(0x103572ac),
    SPH_C32(0xbf5ea812), SPH_C32(0x759efa44) },
  { SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6), SPH_C32(0xa9fda70a),
    SPH_C32(0xa2760cfd), SPH_C32(0x74680040), SPH_C32(0x71ecbf95),
    SPH_C32(0xe72b62e3), SPH_C32(0x94118e2e) },
  { SPH_C32(0x3feb00d0), SPH_C32(0x9e6adc5d), SPH_C32(0x551a8108),
    SPH_C32(0xd3215c9c), SPH_C32(0x5a510040), SPH_C32(0x1531d91c),
    SPH_C32(0xdbff641f), SPH_C32(0x25e51e92) },
  { SPH_C32(0x408e00c0), SPH_C32(0xba44c82f), SPH_C32(0x9529a1f6),
    SPH_C32(0x13829c41), SPH_C32(0x0b0d0050), SPH_C32(0x55c2abe7),
    SPH_C32(0x2718421d), SPH_C32(0x54b24ef3) },
  { SPH_C32(0x11d200d0), SPH_C32(0xfab7bad4), SPH_C32(0x69ce87f4),
    SPH_C32(0x62d5cc20), SPH_C32(0x25340050), SPH_C32(0x311fcd6e),
    SPH_C32(0x1bcc44e1), SPH_C32(0xe546de4f) },
  { SPH_C32(0xcc0f00e0), SPH_C32(0x5f7e4b50), SPH_C32(0x5033eb0e),
    SPH_C32(0x40d9ac3d), SPH_C32(0x281a0040), SPH_C32(0xb8567287),
    SPH_C32(0x9e826f1a), SPH_C32(0xf7f8af56) },
  { SPH_C32(0x9d5300f0), SPH_C32(0x1f8d39ab), SPH_C32(0xacd4cd0c),
    SPH_C32(0x318efc5c), SPH_C32(0x06230040), SPH_C32(0xdc8b140e),
    SPH_C32(0xa25669e6), SPH_C32(0x460c3fea) },
  { SPH_C32(0xe23600e0), SPH_C32(0x3ba32dd9), SPH_C32(0x6ce7edf2),
    SPH_C32(0xf12d3c81), SPH_C32(0x577f0050), SPH_C32(0x9c7866f5),
    SPH_C32(0x5eb14fe4), SPH_C32(0x375b6f8b) },
  { SPH_C32(0xb36a00f0), SPH_C32(0x7b505f22), SPH_C32(0x9000cbf0),
    SPH_C32(0x807a6ce0), SPH_C32(0x79460050), SPH_C32(0xf8a5007c),
    SPH_C32(0x62654918), SPH_C32(0x86afff37) },
  { SPH_C32(0x32c500c0), SPH_C32(0x172363b4), SPH_C32(0xd054aaf3),
    SPH_C32(0xc19f2d85), SPH_C32(0x8aa20060), SPH_C32(0x39b19771),
    SPH_C32(0x674c231e), SPH_C32(0x15570f96) },
  { SPH_C32(0x639900d0), SPH_C32(0x57d0114f), SPH_C32(0x2cb38cf1),
    SPH_C32(0xb0c87de4), SPH_C32(0xa49b0060), SPH_C32(0x5d6cf1f8),
    SPH_C32(0x5b9825e2), SPH_C32(0xa4a39f2a) },
  { SPH_C32(0x1cfc00c0), SPH_C32(0x73fe053d), SPH_C32(0xec80ac0f),
    SPH_C32(0x706bbd39), SPH_C32(0xf5c70070), SPH_C32(0x1d9f8303),
    SPH_C32(0xa77f03e0), SPH_C32(0xd5f4cf4b) },
  { SPH_C32(0x4da000d0), SPH_C32(0x330d77c6), SPH_C32(0x10678a0d),
    SPH_C32(0x013ced58), SPH_C32(0xdbfe0070), SPH_C32(0x7942e58a),
    SPH_C32(0x9bab051c), SPH_C32(0x64005ff7) },
  { SPH_C32(0x907d00e0), SPH_C32(0x96c48642), SPH_C32(0x299ae6f7),
    SPH_C32(0x23308d45), SPH_C32(0xd6d00060), SPH_C32(0xf00b5a63),
    SPH_C32(0x1ee52ee7), SPH_C32(0x76be2eee) },
  { SPH_C32(0xc12100f0), SPH_C32(0xd637f4b9), SPH_C32(0xd57dc0f5),
    SPH_C32(0x5267dd24), SPH_C32(0xf8e90060), SPH_C32(0x94d63cea),
    SPH_C32(0x2231281b), SPH_C32(0xc74abe52) },
  { SPH_C32(0xbe4400e0), SPH_C32(0xf219e0cb), SPH_C32(0x154ee00b),
    SPH_C32(0x92c41df9), SPH_C32(0xa9b50070), SPH_C32(0xd4254e11),
    SPH_C32(0xded60e19), SPH_C32(0xb61dee33) },
  { SPH_C32(0xef1800f0), SPH_C32(0xb2ea9230), SPH_C32(0xe9a9c609),
    SPH_C32(0xe3934d98), SPH_C32(0x878c0070), SPH_C32(0xb0f82898),
    SPH_C32(0xe20208e5), SPH_C32(0x07e97e8f) },
  { SPH_C32(0x39a60000), SPH_C32(0x4ab753eb), SPH_C32(0xd14e094b),
    SPH_C32(0xb772b42b), SPH_C32(0x62740080), SPH_C32(0x0fb84b07),
    SPH_C32(0x138a651e), SPH_C32(0x44100618) },
  { SPH_C32(0x68fa0010), SPH_C32(0x0a442110), SPH_C32(0x2da92f49),
    SPH_C32(0xc625e44a), SPH_C32(0x4c4d0080), SPH_C32(0x6b652d8e),
    SPH_C32(0x2f5e63e2), SPH_C32(0xf5e496a4) },
  { SPH_C32(0x179f0000), SPH_C32(0x2e6a3562), SPH_C32(0xed9a0fb7),
    SPH_C32(0x06862497), SPH_C32(0x1d110090), SPH_C32(0x2b965f75),
    SPH_C32(0xd3b945e0), SPH_C32(0x84b3c6c5) },
  { SPH_C32(0x46c30010), SPH_C32(0x6e994799), SPH_C32(0x117d29b5),
    SPH_C32(0x77d174f6), SPH_C32(0x33280090), SPH_C32(0x4f4b39fc),
    SPH_C32(0xef6d431c), SPH_C32(0x35475679) },
  { SPH_C32(0x9b1e0020), SPH_C32(0xcb50b61d), SPH_C32(0x2880454f),
    SPH_C32(0x55dd14eb), SPH_C32(0x3e060080), SPH_C32(0xc6028615),
    SPH_C32(0x6a2368e7), SPH_C32(0x27f92760) },
  { SPH_C32(0xca420030), SPH_C32(0x8ba3c4e6), SPH_C32(0xd467634d),
    SPH_C32(0x248a448a), SPH_C32(0x103f0080), SPH_C32(0xa2dfe09c),
    SPH_C32(0x56f76e1b), SPH_C32(0x960db7dc) },
  { SPH_C32(0xb5270020), SPH_C32(0xaf8dd094), SPH_C32(0x145443b3),
    SPH_C32(0xe4298457), SPH_C32(0x41630090), SPH_C32(0xe22c9267),
    SPH_C32(0xaa104819), SPH_C32(0xe75ae7bd) },
  { SPH_C32(0xe47b0030), SPH_C32(0xef7ea26f), SPH_C32(0xe8b365b1),
    SPH_C32(0x957ed436), SPH_C32(0x6f5a0090), SPH_C32(0x86f1f4ee),
    SPH_C32(0x96c44ee5), SPH_C32(0x56ae7701) },
  { SPH_C32(0x65d40000), SPH_C32(0x830d9ef9), SPH_C32(0xa8e704b2),
    SPH_C32(0xd49b9553), SPH_C32(0x9cbe00a0), SPH_C32(0x47e563e3),
    SPH_C32(0x93ed24e3), SPH_C32(0xc55687a0) },
  { SPH_C32(0x34880010), SPH_C32(0xc3feec02), SPH_C32(0x540022b0),
    SPH_C32(0xa5ccc532), SPH_C32(0xb28700a0), SPH_C32(0x2338056a),
    SPH_C32(0xaf39221f), SPH_C32(0x74a2171c) },
  { SPH_C32(0x4bed0000), SPH_C32(0xe7d0f870), SPH_C32(0x9433024e),
    SPH_C32(0x656f05ef), SPH_C32(0xe3db00b0), SPH_C32(0x63cb7791),
    SPH_C32(0x53de041d), SPH_C32(0x05f5477d) },
  { SPH_C32(0x1ab10010), SPH_C32(0xa7238a8b), SPH_C32(0x68d4244c),
    SPH_C32(0x1438558e), SPH_C32(0xcde200b0), SPH_C32(0x07161118),
    SPH_C32(0x6f0a02e1), SPH_C32(0xb401d7c1) },
  { SPH_C32(0xc76c0020), SPH_C32(0x02ea7b0f), SPH_C32(0x512948b6),
    SPH_C32(0x36343593), SPH_C32(0xc0cc00a0), SPH_C32(0x8e5faef1),
    SPH_C32(0xea44291a), SPH_C32(0xa6bfa6d8) },
  { SPH_C32(0x96300030), SPH_C32(0x421909f4), SPH_C32(0xadce6eb4),
    SPH_C32(0x476365f2), SPH_C32(0xeef500a0), SPH_C32(0xea82c878),
    SPH_C32(0xd6902fe6), SPH_C32(0x174b3664) },
  { SPH_C32(0xe9550020), SPH_C32(0x66371d86), SPH_C32(0x6dfd4e4a),
    SPH_C32(0x87c0a52f), SPH_C32(0xbfa900b0), SPH_C32(0xaa71ba83),
    SPH_C32(0x2a7709e4), SPH_C32(0x661c6605) },
  { SPH_C32(0xb8090030), SPH_C32(0x26c46f7d), SPH_C32(0x911a6848),
    SPH_C32(0xf697f54e), SPH_C32(0x919000b0), SPH_C32(0xceacdc0a),
    SPH_C32(0x16a30f18), SPH_C32(0xd7e8f6b9) },
  { SPH_C32(0x74680040), SPH_C32(0x71ecbf95), SPH_C32(0xe72b62e3),
    SPH_C32(0x94118e2e), SPH_C32(0x1adf0080), SPH_C32(0xaf751133),
    SPH_C32(0x4ed6c5e9), SPH_C32(0x366782d3) },
  { SPH_C32(0x25340050), SPH_C32(0x311fcd6e), SPH_C32(0x1bcc44e1),
    SPH_C32(0xe546de4f), SPH_C32(0x34e60080), SPH_C32(0xcba877ba),
    SPH_C32(0x7202c315), SPH_C32(0x8793126f) },
  { SPH_C32(0x5a510040), SPH_C32(0x1531d91c), SPH_C32(0xdbff641f),
    SPH_C32(0x25e51e92), SPH_C32(0x65ba0090), SPH_C32(0x8b5b0541),
    SPH_C32(0x8ee5e517), SPH_C32(0xf6c4420e) },
  { SPH_C32(0x0b0d0050), SPH_C32(0x55c2abe7), SPH_C32(0x2718421d),
    SPH_C32(0x54b24ef3), SPH_C32(0x4b830090), SPH_C32(0xef8663c8),
    SPH_C32(0xb231e3eb), SPH_C32(0x4730d2b2) },
  { SPH_C32(0xd6d00060), SPH_C32(0xf00b5a63), SPH_C32(0x1ee52ee7),
    SPH_C32(0x76be2eee), SPH_C32(0x46ad0080), SPH_C32(0x66cfdc21),
    SPH_C32(0x377fc810), SPH_C32(0x558ea3ab) },
  { SPH_C32(0x878c0070), SPH_C32(0xb0f82898), SPH_C32(0xe20208e5),
    SPH_C32(0x07e97e8f), SPH_C32(0x68940080), SPH_C32(0x0212baa8),
    SPH_C32(0x0babceec), SPH_C32(0xe47a3317) },
  { SPH_C32(0xf8e90060), SPH_C32(0x94d63cea), SPH_C32(0x2231281b),
    SPH_C32(0xc74abe52), SPH_C32(0x39c80090), SPH_C32(0x42e1c853),
    SPH_C32(0xf74ce8ee), SPH_C32(0x952d6376) },
  { SPH_C32(0xa9b50070), SPH_C32(0xd4254e11), SPH_C32(0xded60e19),
    SPH_C32(0xb61dee33), SPH_C32(0x17f10090), SPH_C32(0x263caeda),
    SPH_C32(0xcb98ee12), SPH_C32(0x24d9f3ca) },
  { SPH_C32(0x281a0040), SPH_C32(0xb8567287), SPH_C32(0x9e826f1a),
    SPH_C32(0xf7f8af56), SPH_C32(0xe41500a0), SPH_C32(0xe72839d7),
    SPH_C32(0xceb18414), SPH_C32(0xb721036b) },
  { SPH_C32(0x79460050), SPH_C32(0xf8a5007c), SPH_C32(0x62654918),
    SPH_C32(0x86afff37), SPH_C32(0xca2c00a0), SPH_C32(0x83f55f5e),
    SPH_C32(0xf26582e8), SPH_C32(0x06d593d7) },
  { SPH_C32(0x06230040), SPH_C32(0xdc8b140e), SPH_C32(0xa25669e6),
    SPH_C32(0x460c3fea), SPH_C32(0x9b7000b0), SPH_C32(0xc3062da5),
    SPH_C32(0x0e82a4ea), SPH_C32(0x7782c3b6) },
  { SPH_C32(0x577f0050), SPH_C32(0x9c7866f5), SPH_C32(0x5eb14fe4),
    SPH_C32(0x375b6f8b), SPH_C32(0xb54900b0), SPH_C32(0xa7db4b2c),
    SPH_C32(0x3256a216), SPH_C32(0xc676530a) },
  { SPH_C32(0x8aa20060), SPH_C32(0x39b19771), SPH_C32(0x674c231e),
    SPH_C32(0x15570f96), SPH_C32(0xb86700a0), SPH_C32(0x2e92f4c5),
    SPH_C32(0xb71889ed), SPH_C32(0xd4c82213) },
  { SPH_C32(0xdbfe0070), SPH_C32(0x7942e58a), SPH_C32(0x9bab051c),
    SPH_C32(0x64005ff7), SPH_C32(0x965e00a0), SPH_C32(0x4a4f924c),
    SPH_C32(0x8bcc8f11), SPH_C32(0x653cb2af) },
  { SPH_C32(0xa49b0060), SPH_C32(0x5d6cf1f8), SPH_C32(0x5b9825e2),
    SPH_C32(0xa4a39f2a), SPH_C32(0xc70200b0), SPH_C32(0x0abce0b7),
    SPH_C32(0x772ba913), SPH_C32(0x146be2ce) },
  { SPH_C32(0xf5c70070), SPH_C32(0x1d9f8303), SPH_C32(0xa77f03e0),
    SPH_C32(0xd5f4cf4b), SPH_C32(0xe93b00b0), SPH_C32(0x6e61863e),
    SPH_C32(0x4bffafef), SPH_C32(0xa59f7272) },
  { SPH_C32(0x410d0000), SPH_C32(0xea7a09df), SPH_C32(0x8c12a9bc),
    SPH_C32(0xc50530e0), SPH_C32(0x571100c0), SPH_C32(0x942efd4d),
    SPH_C32(0x78b3ae41), SPH_C32(0x1504b8d6) },
  { SPH_C32(0x10510010), SPH_C32(0xaa897b24), SPH_C32(0x70f58fbe),
    SPH_C32(0xb4526081), SPH_C32(0x792800c0), SPH_C32(0xf0f39bc4),
    SPH_C32(0x4467a8bd), SPH_C32(0xa4f0286a) },
  { SPH_C32(0x6f340000), SPH_C32(0x8ea76f56), SPH_C32(0xb0c6af40),
    SPH_C32(0x74f1a05c), SPH_C32(0x287400d0), SPH_C32(0xb000e93f),
    SPH_C32(0xb8808ebf), SPH_C32(0xd5a7780b) },
  { SPH_C32(0x3e680010), SPH_C32(0xce541dad), SPH_C32(0x4c218942),
    SPH_C32(0x05a6f03d), SPH_C32(0x064d00d0), SPH_C32(0xd4dd8fb6),
    SPH_C32(0x84548843), SPH_C32(0x6453e8b7) },
  { SPH_C32(0xe3b50020), SPH_C32(0x6b9dec29), SPH_C32(0x75dce5b8),
    SPH_C32(0x27aa9020), SPH_C32(0x0b6300c0), SPH_C32(0x5d94305f),
    SPH_C32(0x011aa3b8), SPH_C32(0x76ed99ae) },
  { SPH_C32(0xb2e90030), SPH_C32(0x2b6e9ed2), SPH_C32(0x893bc3ba),
    SPH_C32(0x56fdc041), SPH_C32(0x255a00c0), SPH_C32(0x394956d6),
    SPH_C32(0x3dcea544), SPH_C32(0xc7190912) },
  { SPH_C32(0xcd8c0020), SPH_C32(0x0f408aa0), SPH_C32(0x4908e344),
    SPH_C32(0x965e009c), SPH_C32(0x740600d0), SPH_C32(0x79ba242d),
    SPH_C32(0xc1298346), SPH_C32(0xb64e5973) },
  { SPH_C32(0x9cd00030), SPH_C32(0x4fb3f85b), SPH_C32(0xb5efc546),
    SPH_C32(0xe70950fd), SPH_C32(0x5a3f00d0), SPH_C32(0x1d6742a4),
    SPH_C32(0xfdfd85ba), SPH_C32(0x07bac9cf) },
  { SPH_C32(0x1d7f0000), SPH_C32(0x23c0c4cd), SPH_C32(0xf5bba445),
    SPH_C32(0xa6ec1198), SPH_C32(0xa9db00e0), SPH_C32(0xdc73d5a9),
    SPH_C32(0xf8d4efbc), SPH_C32(0x9442396e) },
  { SPH_C32(0x4c230010), SPH_C32(0x6333b636), SPH_C32(0x095c8247),
    SPH_C32(0xd7bb41f9), SPH_C32(0x87e200e0), SPH_C32(0xb8aeb320),
    SPH_C32(0xc400e940), SPH_C32(0x25b6a9d2) },
  { SPH_C32(0x33460000), SPH_C32(0x471da244), SPH_C32(0xc96fa2b9),
    SPH_C32(0x17188124), SPH_C32(0xd6be00f0), SPH_C32(0xf85dc1db),
    SPH_C32(0x38e7cf42), SPH_C32(0x54e1f9b3) },
  { SPH_C32(0x621a0010), SPH_C32(0x07eed0bf), SPH_C32(0x358884bb),
    SPH_C32(0x664fd145), SPH_C32(0xf88700f0), SPH_C32(0x9c80a752),
    SPH_C32(0x0433c9be), SPH_C32(0xe515690f) },
  { SPH_C32(0xbfc70020), SPH_C32(0xa227213b), SPH_C32(0x0c75e841),
    SPH_C32(0x4443b158), SPH_C32(0xf5a900e0), SPH_C32(0x15c918bb),
    SPH_C32(0x817de245), SPH_C32(0xf7ab1816) },
  { SPH_C32(0xee9b0030), SPH_C32(0xe2d453c0), SPH_C32(0xf092ce43),
    SPH_C32(0x3514e139), SPH_C32(0xdb9000e0), SPH_C32(0x71147e32),
    SPH_C32(0xbda9e4b9), SPH_C32(0x465f88aa) },
  { SPH_C32(0x91fe0020), SPH_C32(0xc6fa47b2), SPH_C32(0x30a1eebd),
    SPH_C32(0xf5b721e4), SPH_C32(0x8acc00f0), SPH_C32(0x31e70cc9),
    SPH_C32(0x414ec2bb), SPH_C32(0x3708d8cb) },
  { SPH_C32(0xc0a20030), SPH_C32(0x86093549), SPH_C32(0xcc46c8bf),
    SPH_C32(0x84e07185), SPH_C32(0xa4f500f0), SPH_C32(0x553a6a40),
    SPH_C32(0x7d9ac447), SPH_C32(0x86fc4877) },
  { SPH_C32(0x0cc30040), SPH_C32(0xd121e5a1), SPH_C32(0xba77c214),
    SPH_C32(0xe6660ae5), SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779),
    SPH_C32(0x25ef0eb6), SPH_C32(0x67733c1d) },
  { SPH_C32(0x5d9f0050), SPH_C32(0x91d2975a), SPH_C32(0x4690e416),
    SPH_C32(0x97315a84), SPH_C32(0x018300c0), SPH_C32(0x503ec1f0),
    SPH_C32(0x193b084a), SPH_C32(0xd687aca1) },
  { SPH_C32(0x22fa0040), SPH_C32(0xb5fc8328), SPH_C32(0x86a3c4e8),
    SPH_C32(0x57929a59), SPH_C32(0x50df00d0), SPH_C32(0x10cdb30b),
    SPH_C32(0xe5dc2e48), SPH_C32(0xa7d0fcc0) },
  { SPH_C32(0x73a60050), SPH_C32(0xf50ff1d3), SPH_C32(0x7a44e2ea),
    SPH_C32(0x26c5ca38), SPH_C32(0x7ee600d0), SPH_C32(0x7410d582),
    SPH_C32(0xd90828b4), SPH_C32(0x16246c7c) },
  { SPH_C32(0xae7b0060), SPH_C32(0x50c60057), SPH_C32(0x43b98e10),
    SPH_C32(0x04c9aa25), SPH_C32(0x73c800c0), SPH_C32(0xfd596a6b),
    SPH_C32(0x5c46034f), SPH_C32(0x049a1d65) },
  { SPH_C32(0xff270070), SPH_C32(0x103572ac), SPH_C32(0xbf5ea812),
    SPH_C32(0x759efa44), SPH_C32(0x5df100c0), SPH_C32(0x99840ce2),
    SPH_C32(0x609205b3), SPH_C32(0xb56e8dd9) },
  { SPH_C32(0x80420060), SPH_C32(0x341b66de), SPH_C32(0x7f6d88ec),
    SPH_C32(0xb53d3a99), SPH_C32(0x0cad00d0), SPH_C32(0xd9777e19),
    SPH_C32(0x9c7523b1), SPH_C32(0xc439ddb8) },
  { SPH_C32(0xd11e0070), SPH_C32(0x74e81425), SPH_C32(0x838aaeee),
    SPH_C32(0xc46a6af8), SPH_C32(0x229400d0), SPH_C32(0xbdaa1890),
    SPH_C32(0xa0a1254d), SPH_C32(0x75cd4d04) },
  { SPH_C32(0x50b10040), SPH_C32(0x189b28b3), SPH_C32(0xc3decfed),
    SPH_C32(0x858f2b9d), SPH_C32(0xd17000e0), SPH_C32(0x7cbe8f9d),
    SPH_C32(0xa5884f4b), SPH_C32(0xe635bda5) },
  { SPH_C32(0x01ed0050), SPH_C32(0x58685a48), SPH_C32(0x3f39e9ef),
    SPH_C32(0xf4d87bfc), SPH_C32(0xff4900e0), SPH_C32(0x1863e914),
    SPH_C32(0x995c49b7), SPH_C32(0x57c12d19) },
  { SPH_C32(0x7e880040), SPH_C32(0x7c464e3a), SPH_C32(0xff0ac911),
    SPH_C32(0x347bbb21), SPH_C32(0xae1500f0), SPH_C32(0x58909bef),
    SPH_C32(0x65bb6fb5), SPH_C32(0x26967d78) },
  { SPH_C32(0x2fd40050), SPH_C32(0x3cb53cc1), SPH_C32(0x03edef13),
    SPH_C32(0x452ceb40), SPH_C32(0x802c00f0), SPH_C32(0x3c4dfd66),
    SPH_C32(0x596f6949), SPH_C32(0x9762edc4) },
  { SPH_C32(0xf2090060), SPH_C32(0x997ccd45), SPH_C32(0x3a1083e9),
    SPH_C32(0x67208b5d), SPH_C32(0x8d0200e0), SPH_C32(0xb504428f),
    SPH_C32(0xdc2142b2), SPH_C32(0x85dc9cdd) },
  { SPH_C32(0xa3550070), SPH_C32(0xd98fbfbe), SPH_C32(0xc6f7a5eb),
    SPH_C32(0x1677db3c), SPH_C32(0xa33b00e0), SPH_C32(0xd1d92406),
    SPH_C32(0xe0f5444e), SPH_C32(0x34280c61) },
  { SPH_C32(0xdc300060), SPH_C32(0xfda1abcc), SPH_C32(0x06c48515),
    SPH_C32(0xd6d41be1), SPH_C32(0xf26700f0), SPH_C32(0x912a56fd),
    SPH_C32(0x1c12624c), SPH_C32(0x457f5c00) },
  { SPH_C32(0x8d6c0070), SPH_C32(0xbd52d937), SPH_C32(0xfa23a317),
    SPH_C32(0xa7834b80), SPH_C32(0xdc5e00f0), SPH_C32(0xf5f73074),
    SPH_C32(0x20c664b0), SPH_C32(0xf48bccbc) },
  { SPH_C32(0x62740080), SPH_C32(0x0fb84b07), SPH_C32(0x138a651e),
    SPH_C32(0x44100618), SPH_C32(0x5bd20080), SPH_C32(0x450f18ec),
    SPH_C32(0xc2c46c55), SPH_C32(0xf362b233) },
  { SPH_C32(0x33280090), SPH_C32(0x4f4b39fc), SPH_C32(0xef6d431c),
    SPH_C32(0x35475679), SPH_C32(0x75eb0080), SPH_C32(0x21d27e65),
    SPH_C32(0xfe106aa9), SPH_C32(0x4296228f) },
  { SPH_C32(0x4c4d0080), SPH_C32(0x6b652d8e), SPH_C32(0x2f5e63e2),
    SPH_C32(0xf5e496a4), SPH_C32(0x24b70090), SPH_C32(0x61210c9e),
    SPH_C32(0x02f74cab), SPH_C32(0x33c172ee) },
  { SPH_C32(0x1d110090), SPH_C32(0x2b965f75), SPH_C32(0xd3b945e0),
    SPH_C32(0x84b3c6c5), SPH_C32(0x0a8e0090), SPH_C32(0x05fc6a17),
    SPH_C32(0x3e234a57), SPH_C32(0x8235e252) },
  { SPH_C32(0xc0cc00a0), SPH_C32(0x8e5faef1), SPH_C32(0xea44291a),
    SPH_C32(0xa6bfa6d8), SPH_C32(0x07a00080), SPH_C32(0x8cb5d5fe),
    SPH_C32(0xbb6d61ac), SPH_C32(0x908b934b) },
  { SPH_C32(0x919000b0), SPH_C32(0xceacdc0a), SPH_C32(0x16a30f18),
    SPH_C32(0xd7e8f6b9), SPH_C32(0x29990080), SPH_C32(0xe868b377),
    SPH_C32(0x87b96750), SPH_C32(0x217f03f7) },
  { SPH_C32(0xeef500a0), SPH_C32(0xea82c878), SPH_C32(0xd6902fe6),
    SPH_C32(0x174b3664), SPH_C32(0x78c50090), SPH_C32(0xa89bc18c),
    SPH_C32(0x7b5e4152), SPH_C32(0x50285396) },
  { SPH_C32(0xbfa900b0), SPH_C32(0xaa71ba83), SPH_C32(0x2a7709e4),
    SPH_C32(0x661c6605), SPH_C32(0x56fc0090), SPH_C32(0xcc46a705),
    SPH_C32(0x478a47ae), SPH_C32(0xe1dcc32a) },
  { SPH_C32(0x3e060080), SPH_C32(0xc6028615), SPH_C32(0x6a2368e7),
    SPH_C32(0x27f92760), SPH_C32(0xa51800a0), SPH_C32(0x0d523008),
    SPH_C32(0x42a32da8), SPH_C32(0x7224338b) },
  { SPH_C32(0x6f5a0090), SPH_C32(0x86f1f4ee), SPH_C32(0x96c44ee5),
    SPH_C32(0x56ae7701), SPH_C32(0x8b2100a0), SPH_C32(0x698f5681),
    SPH_C32(0x7e772b54), SPH_C32(0xc3d0a337) },
  { SPH_C32(0x103f0080), SPH_C32(0xa2dfe09c), SPH_C32(0x56f76e1b),
    SPH_C32(0x960db7dc), SPH_C32(0xda7d00b0), SPH_C32(0x297c247a),
    SPH_C32(0x82900d56), SPH_C32(0xb287f356) },
  { SPH_C32(0x41630090), SPH_C32(0xe22c9267), SPH_C32(0xaa104819),
    SPH_C32(0xe75ae7bd), SPH_C32(0xf44400b0), SPH_C32(0x4da142f3),
    SPH_C32(0xbe440baa), SPH_C32(0x037363ea) },
  { SPH_C32(0x9cbe00a0), SPH_C32(0x47e563e3), SPH_C32(0x93ed24e3),
    SPH_C32(0xc55687a0), SPH_C32(0xf96a00a0), SPH_C32(0xc4e8fd1a),
    SPH_C32(0x3b0a2051), SPH_C32(0x11cd12f3) },
  { SPH_C32(0xcde200b0), SPH_C32(0x07161118), SPH_C32(0x6f0a02e1),
    SPH_C32(0xb401d7c1), SPH_C32(0xd75300a0), SPH_C32(0xa0359b93),
    SPH_C32(0x07de26ad), SPH_C32(0xa039824f) },
  { SPH_C32(0xb28700a0), SPH_C32(0x2338056a), SPH_C32(0xaf39221f),
    SPH_C32(0x74a2171c), SPH_C32(0x860f00b0), SPH_C32(0xe0c6e968),
    SPH_C32(0xfb3900af), SPH_C32(0xd16ed22e) },
  { SPH_C32(0xe3db00b0), SPH_C32(0x63cb7791), SPH_C32(0x53de041d),
    SPH_C32(0x05f5477d), SPH_C32(0xa83600b0), SPH_C32(0x841b8fe1),
    SPH_C32(0xc7ed0653), SPH_C32(0x609a4292) },
  { SPH_C32(0x2fba00c0), SPH_C32(0x34e3a779), SPH_C32(0x25ef0eb6),
    SPH_C32(0x67733c1d), SPH_C32(0x23790080), SPH_C32(0xe5c242d8),
    SPH_C32(0x9f98cca2), SPH_C32(0x811536f8) },
  { SPH_C32(0x7ee600d0), SPH_C32(0x7410d582), SPH_C32(0xd90828b4),
    SPH_C32(0x16246c7c), SPH_C32(0x0d400080), SPH_C32(0x811f2451),
    SPH_C32(0xa34cca5e), SPH_C32(0x30e1a644) },
  { SPH_C32(0x018300c0), SPH_C32(0x503ec1f0), SPH_C32(0x193b084a),
    SPH_C32(0xd687aca1), SPH_C32(0x5c1c0090), SPH_C32(0xc1ec56aa),
    SPH_C32(0x5fabec5c), SPH_C32(0x41b6f625) },
  { SPH_C32(0x50df00d0), SPH_C32(0x10cdb30b), SPH_C32(0xe5dc2e48),
    SPH_C32(0xa7d0fcc0), SPH_C32(0x72250090), SPH_C32(0xa5313023),
    SPH_C32(0x637feaa0), SPH_C32(0xf0426699) },
  { SPH_C32(0x8d0200e0), SPH_C32(0xb504428f), SPH_C32(0xdc2142b2),
    SPH_C32(0x85dc9cdd), SPH_C32(0x7f0b0080), SPH_C32(0x2c788fca),
    SPH_C32(0xe631c15b), SPH_C32(0xe2fc1780) },
  { SPH_C32(0xdc5e00f0), SPH_C32(0xf5f73074), SPH_C32(0x20c664b0),
    SPH_C32(0xf48bccbc), SPH_C32(0x51320080), SPH_C32(0x48a5e943),
    SPH_C32(0xdae5c7a7), SPH_C32(0x5308873c) },
  { SPH_C32(0xa33b00e0), SPH_C32(0xd1d92406), SPH_C32(0xe0f5444e),
    SPH_C32(0x34280c61), SPH_C32(0x006e0090), SPH_C32(0x08569bb8),
    SPH_C32(0x2602e1a5), SPH_C32(0x225fd75d) },
  { SPH_C32(0xf26700f0), SPH_C32(0x912a56fd), SPH_C32(0x1c12624c),
    SPH_C32(0x457f5c00), SPH_C32(0x2e570090), SPH_C32(0x6c8bfd31),
    SPH_C32(0x1ad6e759), SPH_C32(0x93ab47e1) },
  { SPH_C32(0x73c800c0), SPH_C32(0xfd596a6b), SPH_C32(0x5c46034f),
    SPH_C32(0x049a1d65), SPH_C32(0xddb300a0), SPH_C32(0xad9f6a3c),
    SPH_C32(0x1fff8d5f), SPH_C32(0x0053b740) },
  { SPH_C32(0x229400d0), SPH_C32(0xbdaa1890), SPH_C32(0xa0a1254d),
    SPH_C32(0x75cd4d04), SPH_C32(0xf38a00a0), SPH_C32(0xc9420cb5),
    SPH_C32(0x232b8ba3), SPH_C32(0xb1a727fc) },
  { SPH_C32(0x5df100c0), SPH_C32(0x99840ce2), SPH_C32(0x609205b3),
    SPH_C32(0xb56e8dd9), SPH_C32(0xa2d600b0), SPH_C32(0x89b17e4e),
    SPH_C32(0xdfccada1), SPH_C32(0xc0f0779d) },
  { SPH_C32(0x0cad00d0), SPH_C32(0xd9777e19), SPH_C32(0x9c7523b1),
    SPH_C32(0xc439ddb8), SPH_C32(0x8cef00b0), SPH_C32(0xed6c18c7),
    SPH_C32(0xe318ab5d), SPH_C32(0x7104e721) },
  { SPH_C32(0xd17000e0), SPH_C32(0x7cbe8f9d), SPH_C32(0xa5884f4b),
    SPH_C32(0xe635bda5), SPH_C32(0x81c100a0), SPH_C32(0x6425a72e),
    SPH_C32(0x665680a6), SPH_C32(0x63ba9638) },
  { SPH_C32(0x802c00f0), SPH_C32(0x3c4dfd66), SPH_C32(0x596f6949),
    SPH_C32(0x9762edc4), SPH_C32(0xaff800a0), SPH_C32(0x00f8c1a7),
    SPH_C32(0x5a82865a), SPH_C32(0xd24e0684) },
  { SPH_C32(0xff4900e0), SPH_C32(0x1863e914), SPH_C32(0x995c49b7),
    SPH_C32(0x57c12d19), SPH_C32(0xfea400b0), SPH_C32(0x400bb35c),
    SPH_C32(0xa665a058), SPH_C32(0xa31956e5) },
  { SPH_C32(0xae1500f0), SPH_C32(0x58909bef), SPH_C32(0x65bb6fb5),
    SPH_C32(0x26967d78), SPH_C32(0xd09d00b0), SPH_C32(0x24d6d5d5),
    SPH_C32(0x9ab1a6a4), SPH_C32(0x12edc659) },
  { SPH_C32(0x1adf0080), SPH_C32(0xaf751133), SPH_C32(0x4ed6c5e9),
    SPH_C32(0x366782d3), SPH_C32(0x6eb700c0), SPH_C32(0xde99aea6),
    SPH_C32(0xa9fda70a), SPH_C32(0xa2760cfd) },
  { SPH_C32(0x4b830090), SPH_C32(0xef8663c8), SPH_C32(0xb231e3eb),
    SPH_C32(0x4730d2b2), SPH_C32(0x408e00c0), SPH_C32(0xba44c82f),
    SPH_C32(0x9529a1f6), SPH_C32(0x13829c41) },
  { SPH_C32(0x34e60080), SPH_C32(0xcba877ba), SPH_C32(0x7202c315),
    SPH_C32(0x8793126f), SPH_C32(0x11d200d0), SPH_C32(0xfab7bad4),
    SPH_C32(0x69ce87f4), SPH_C32(0x62d5cc20) },
  { SPH_C32(0x65ba0090), SPH_C32(0x8b5b0541), SPH_C32(0x8ee5e517),
    SPH_C32(0xf6c4420e), SPH_C32(0x3feb00d0), SPH_C32(0x9e6adc5d),
    SPH_C32(0x551a8108), SPH_C32(0xd3215c9c) },
  { SPH_C32(0xb86700a0), SPH_C32(0x2e92f4c5), SPH_C32(0xb71889ed),
    SPH_C32(0xd4c82213), SPH_C32(0x32c500c0), SPH_C32(0x172363b4),
    SPH_C32(0xd054aaf3), SPH_C32(0xc19f2d85) },
  { SPH_C32(0xe93b00b0), SPH_C32(0x6e61863e), SPH_C32(0x4bffafef),
    SPH_C32(0xa59f7272), SPH_C32(0x1cfc00c0), SPH_C32(0x73fe053d),
    SPH_C32(0xec80ac0f), SPH_C32(0x706bbd39) },
  { SPH_C32(0x965e00a0), SPH_C32(0x4a4f924c), SPH_C32(0x8bcc8f11),
    SPH_C32(0x653cb2af), SPH_C32(0x4da000d0), SPH_C32(0x330d77c6),
    SPH_C32(0x10678a0d), SPH_C32(0x013ced58) },
  { SPH_C32(0xc70200b0), SPH_C32(0x0abce0b7), SPH_C32(0x772ba913),
    SPH_C32(0x146be2ce), SPH_C32(0x639900d0), SPH_C32(0x57d0114f),
    SPH_C32(0x2cb38cf1), SPH_C32(0xb0c87de4) },
  { SPH_C32(0x46ad0080), SPH_C32(0x66cfdc21), SPH_C32(0x377fc810),
    SPH_C32(0x558ea3ab), SPH_C32(0x907d00e0), SPH_C32(0x96c48642),
    SPH_C32(0x299ae6f7), SPH_C32(0x23308d45) },
  { SPH_C32(0x17f10090), SPH_C32(0x263caeda), SPH_C32(0xcb98ee12),
    SPH_C32(0x24d9f3ca), SPH_C32(0xbe4400e0), SPH_C32(0xf219e0cb),
    SPH_C32(0x154ee00b), SPH_C32(0x92c41df9) },
  { SPH_C32(0x68940080), SPH_C32(0x0212baa8), SPH_C32(0x0babceec),
    SPH_C32(0xe47a3317), SPH_C32(0xef1800f0), SPH_C32(0xb2ea9230),
    SPH_C32(0xe9a9c609), SPH_C32(0xe3934d98) },
  { SPH_C32(0x39c80090), SPH_C32(0x42e1c853), SPH_C32(0xf74ce8ee),
    SPH_C32(0x952d6376), SPH_C32(0xc12100f0), SPH_C32(0xd637f4b9),
    SPH_C32(0xd57dc0f5), SPH_C32(0x5267dd24) },
  { SPH_C32(0xe41500a0), SPH_C32(0xe72839d7), SPH_C32(0xceb18414),
    SPH_C32(0xb721036b), SPH_C32(0xcc0f00e0), SPH_C32(0x5f7e4b50),
    SPH_C32(0x5033eb0e), SPH_C32(0x40d9ac3d) },
  { SPH_C32(0xb54900b0), SPH_C32(0xa7db4b2c), SPH_C32(0x3256a216),
    SPH_C32(0xc676530a), SPH_C32(0xe23600e0), SPH_C32(0x3ba32dd9),
    SPH_C32(0x6ce7edf2), SPH_C32(0xf12d3c81) },
  { SPH_C32(0xca2c00a0), SPH_C32(0x83f55f5e), SPH_C32(0xf26582e8),
    SPH_C32(0x06d593d7), SPH_C32(0xb36a00f0), SPH_C32(0x7b505f22),
    SPH_C32(0x9000cbf0), SPH_C32(0x807a6ce0) },
  { SPH_C32(0x9b7000b0), SPH_C32(0xc3062da5), SPH_C32(0x0e82a4ea),
    SPH_C32(0x7782c3b6), SPH_C32(0x9d5300f0), SPH_C32(0x1f8d39ab),
    SPH_C32(0xacd4cd0c), SPH_C32(0x318efc5c) },
  { SPH_C32(0x571100c0), SPH_C32(0x942efd4d), SPH_C32(0x78b3ae41),
    SPH_C32(0x1504b8d6), SPH_C32(0x161c00c0), SPH_C32(0x7e54f492),
    SPH_C32(0xf4a107fd), SPH_C32(0xd0018836) },
  { SPH_C32(0x064d00d0), SPH_C32(0xd4dd8fb6), SPH_C32(0x84548843),
    SPH_C32(0x6453e8b7), SPH_C32(0x382500c0), SPH_C32(0x1a89921b),
    SPH_C32(0xc8750101), SPH_C32(0x61f5188a) },
  { SPH_C32(0x792800c0), SPH_C32(0xf0f39bc4), SPH_C32(0x4467a8bd),
    SPH_C32(0xa4f0286a), SPH_C32(0x697900d0), SPH_C32(0x5a7ae0e0),
    SPH_C32(0x34922703), SPH_C32(0x10a248eb) },
  { SPH_C32(0x287400d0), SPH_C32(0xb000e93f), SPH_C32(0xb8808ebf),
    SPH_C32(0xd5a7780b), SPH_C32(0x474000d0), SPH_C32(0x3ea78669),
    SPH_C32(0x084621ff), SPH_C32(0xa156d857) },
  { SPH_C32(0xf5a900e0), SPH_C32(0x15c918bb), SPH_C32(0x817de245),
    SPH_C32(0xf7ab1816), SPH_C32(0x4a6e00c0), SPH_C32(0xb7ee3980),
    SPH_C32(0x8d080a04), SPH_C32(0xb3e8a94e) },
  { SPH_C32(0xa4f500f0), SPH_C32(0x553a6a40), SPH_C32(0x7d9ac447),
    SPH_C32(0x86fc4877), SPH_C32(0x645700c0), SPH_C32(0xd3335f09),
    SPH_C32(0xb1dc0cf8), SPH_C32(0x021c39f2) },
  { SPH_C32(0xdb9000e0), SPH_C32(0x71147e32), SPH_C32(0xbda9e4b9),
    SPH_C32(0x465f88aa), SPH_C32(0x350b00d0), SPH_C32(0x93c02df2),
    SPH_C32(0x4d3b2afa), SPH_C32(0x734b6993) },
  { SPH_C32(0x8acc00f0), SPH_C32(0x31e70cc9), SPH_C32(0x414ec2bb),
    SPH_C32(0x3708d8cb), SPH_C32(0x1b3200d0), SPH_C32(0xf71d4b7b),
    SPH_C32(0x71ef2c06), SPH_C32(0xc2bff92f) },
  { SPH_C32(0x0b6300c0), SPH_C32(0x5d94305f), SPH_C32(0x011aa3b8),
    SPH_C32(0x76ed99ae), SPH_C32(0xe8d600e0), SPH_C32(0x3609dc76),
    SPH_C32(0x74c64600), SPH_C32(0x5147098e) },
  { SPH_C32(0x5a3f00d0), SPH_C32(0x1d6742a4), SPH_C32(0xfdfd85ba),
    SPH_C32(0x07bac9cf), SPH_C32(0xc6ef00e0), SPH_C32(0x52d4baff),
    SPH_C32(0x481240fc), SPH_C32(0xe0b39932) },
  { SPH_C32(0x255a00c0), SPH_C32(0x394956d6), SPH_C32(0x3dcea544),
    SPH_C32(0xc7190912), SPH_C32(0x97b300f0), SPH_C32(0x1227c804),
    SPH_C32(0xb4f566fe), SPH_C32(0x91e4c953) },
  { SPH_C32(0x740600d0), SPH_C32(0x79ba242d), SPH_C32(0xc1298346),
    SPH_C32(0xb64e5973), SPH_C32(0xb98a00f0), SPH_C32(0x76faae8d),
    SPH_C32(0x88216002), SPH_C32(0x201059ef) },
  { SPH_C32(0xa9db00e0), SPH_C32(0xdc73d5a9), SPH_C32(0xf8d4efbc),
    SPH_C32(0x9442396e), SPH_C32(0xb4a400e0), SPH_C32(0xffb31164),
    SPH_C32(0x0d6f4bf9), SPH_C32(0x32ae28f6) },
  { SPH_C32(0xf88700f0), SPH_C32(0x9c80a752), SPH_C32(0x0433c9be),
    SPH_C32(0xe515690f), SPH_C32(0x9a9d00e0), SPH_C32(0x9b6e77ed),
    SPH_C32(0x31bb4d05), SPH_C32(0x835ab84a) },
  { SPH_C32(0x87e200e0), SPH_C32(0xb8aeb320), SPH_C32(0xc400e940),
    SPH_C32(0x25b6a9d2), SPH_C32(0xcbc100f0), SPH_C32(0xdb9d0516),
    SPH_C32(0xcd5c6b07), SPH_C32(0xf20de82b) },
  { SPH_C32(0xd6be00f0), SPH_C32(0xf85dc1db), SPH_C32(0x38e7cf42),
    SPH_C32(0x54e1f9b3), SPH_C32(0xe5f800f0), SPH_C32(0xbf40639f),
    SPH_C32(0xf1886dfb), SPH_C32(0x43f97897) }
};

__constant static const sph_u32 T256_24[256][8] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000) },
  { SPH_C32(0xc04e0001), SPH_C32(0x33b9c010), SPH_C32(0xae0ebb05),
    SPH_C32(0xb5a4c63b), SPH_C32(0xc8f10000), SPH_C32(0x0b2de782),
    SPH_C32(0x6bf648a4), SPH_C32(0x539cbdbf) },
  { SPH_C32(0xc8f10000), SPH_C32(0x0b2de782), SPH_C32(0x6bf648a4),
    SPH_C32(0x539cbdbf), SPH_C32(0x08bf0001), SPH_C32(0x38942792),
    SPH_C32(0xc5f8f3a1), SPH_C32(0xe6387b84) },
  { SPH_C32(0x08bf0001), SPH_C32(0x38942792), SPH_C32(0xc5f8f3a1),
    SPH_C32(0xe6387b84), SPH_C32(0xc04e0001), SPH_C32(0x33b9c010),
    SPH_C32(0xae0ebb05), SPH_C32(0xb5a4c63b) },
  { SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3), SPH_C32(0x99e585aa),
    SPH_C32(0x8d75f7f1), SPH_C32(0x51ac0000), SPH_C32(0x25e30f14),
    SPH_C32(0x79e22a4c), SPH_C32(0x1298bd46) },
  { SPH_C32(0x486d0003), SPH_C32(0x6c5e67a3), SPH_C32(0x37eb3eaf),
    SPH_C32(0x38d131ca), SPH_C32(0x995d0000), SPH_C32(0x2ecee896),
    SPH_C32(0x121462e8), SPH_C32(0x410400f9) },
  { SPH_C32(0x40d20002), SPH_C32(0x54ca4031), SPH_C32(0xf213cd0e),
    SPH_C32(0xdee94a4e), SPH_C32(0x59130001), SPH_C32(0x1d772886),
    SPH_C32(0xbc1ad9ed), SPH_C32(0xf4a0c6c2) },
  { SPH_C32(0x809c0003), SPH_C32(0x67738021), SPH_C32(0x5c1d760b),
    SPH_C32(0x6b4d8c75), SPH_C32(0x91e20001), SPH_C32(0x165acf04),
    SPH_C32(0xd7ec9149), SPH_C32(0xa73c7b7d) },
  { SPH_C32(0x51ac0000), SPH_C32(0x25e30f14), SPH_C32(0x79e22a4c),
    SPH_C32(0x1298bd46), SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7),
    SPH_C32(0xe007afe6), SPH_C32(0x9fed4ab7) },
  { SPH_C32(0x91e20001), SPH_C32(0x165acf04), SPH_C32(0xd7ec9149),
    SPH_C32(0xa73c7b7d), SPH_C32(0x117e0002), SPH_C32(0x71294f25),
    SPH_C32(0x8bf1e742), SPH_C32(0xcc71f708) },
  { SPH_C32(0x995d0000), SPH_C32(0x2ecee896), SPH_C32(0x121462e8),
    SPH_C32(0x410400f9), SPH_C32(0xd1300003), SPH_C32(0x42908f35),
    SPH_C32(0x25ff5c47), SPH_C32(0x79d53133) },
  { SPH_C32(0x59130001), SPH_C32(0x1d772886), SPH_C32(0xbc1ad9ed),
    SPH_C32(0xf4a0c6c2), SPH_C32(0x19c10003), SPH_C32(0x49bd68b7),
    SPH_C32(0x4e0914e3), SPH_C32(0x2a498c8c) },
  { SPH_C32(0xd98f0002), SPH_C32(0x7a04a8a7), SPH_C32(0xe007afe6),
    SPH_C32(0x9fed4ab7), SPH_C32(0x88230002), SPH_C32(0x5fe7a7b3),
    SPH_C32(0x99e585aa), SPH_C32(0x8d75f7f1) },
  { SPH_C32(0x19c10003), SPH_C32(0x49bd68b7), SPH_C32(0x4e0914e3),
    SPH_C32(0x2a498c8c), SPH_C32(0x40d20002), SPH_C32(0x54ca4031),
    SPH_C32(0xf213cd0e), SPH_C32(0xdee94a4e) },
  { SPH_C32(0x117e0002), SPH_C32(0x71294f25), SPH_C32(0x8bf1e742),
    SPH_C32(0xcc71f708), SPH_C32(0x809c0003), SPH_C32(0x67738021),
    SPH_C32(0x5c1d760b), SPH_C32(0x6b4d8c75) },
  { SPH_C32(0xd1300003), SPH_C32(0x42908f35), SPH_C32(0x25ff5c47),
    SPH_C32(0x79d53133), SPH_C32(0x486d0003), SPH_C32(0x6c5e67a3),
    SPH_C32(0x37eb3eaf), SPH_C32(0x38d131ca) },
  { SPH_C32(0xd0080004), SPH_C32(0x8c768f77), SPH_C32(0x9dc5b050),
    SPH_C32(0xaf4a29da), SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa),
    SPH_C32(0x98321c3d), SPH_C32(0x76acc733) },
  { SPH_C32(0x10460005), SPH_C32(0xbfcf4f67), SPH_C32(0x33cb0b55),
    SPH_C32(0x1aeeefe1), SPH_C32(0xa3580000), SPH_C32(0x4bc61e28),
    SPH_C32(0xf3c45499), SPH_C32(0x25307a8c) },
  { SPH_C32(0x18f90004), SPH_C32(0x875b68f5), SPH_C32(0xf633f8f4),
    SPH_C32(0xfcd69465), SPH_C32(0x63160001), SPH_C32(0x787fde38),
    SPH_C32(0x5dcaef9c), SPH_C32(0x9094bcb7) },
  { SPH_C32(0xd8b70005), SPH_C32(0xb4e2a8e5), SPH_C32(0x583d43f1),
    SPH_C32(0x4972525e), SPH_C32(0xabe70001), SPH_C32(0x735239ba),
    SPH_C32(0x363ca738), SPH_C32(0xc3080108) },
  { SPH_C32(0x582b0006), SPH_C32(0xd39128c4), SPH_C32(0x042035fa),
    SPH_C32(0x223fde2b), SPH_C32(0x3a050000), SPH_C32(0x6508f6be),
    SPH_C32(0xe1d03671), SPH_C32(0x64347a75) },
  { SPH_C32(0x98650007), SPH_C32(0xe028e8d4), SPH_C32(0xaa2e8eff),
    SPH_C32(0x979b1810), SPH_C32(0xf2f40000), SPH_C32(0x6e25113c),
    SPH_C32(0x8a267ed5), SPH_C32(0x37a8c7ca) },
  { SPH_C32(0x90da0006), SPH_C32(0xd8bccf46), SPH_C32(0x6fd67d5e),
    SPH_C32(0x71a36394), SPH_C32(0x32ba0001), SPH_C32(0x5d9cd12c),
    SPH_C32(0x2428c5d0), SPH_C32(0x820c01f1) },
  { SPH_C32(0x50940007), SPH_C32(0xeb050f56), SPH_C32(0xc1d8c65b),
    SPH_C32(0xc407a5af), SPH_C32(0xfa4b0001), SPH_C32(0x56b136ae),
    SPH_C32(0x4fde8d74), SPH_C32(0xd190bc4e) },
  { SPH_C32(0x81a40004), SPH_C32(0xa9958063), SPH_C32(0xe4279a1c),
    SPH_C32(0xbdd2949c), SPH_C32(0xb2260002), SPH_C32(0x3aef510d),
    SPH_C32(0x7835b3db), SPH_C32(0xe9418d84) },
  { SPH_C32(0x41ea0005), SPH_C32(0x9a2c4073), SPH_C32(0x4a292119),
    SPH_C32(0x087652a7), SPH_C32(0x7ad70002), SPH_C32(0x31c2b68f),
    SPH_C32(0x13c3fb7f), SPH_C32(0xbadd303b) },
  { SPH_C32(0x49550004), SPH_C32(0xa2b867e1), SPH_C32(0x8fd1d2b8),
    SPH_C32(0xee4e2923), SPH_C32(0xba990003), SPH_C32(0x027b769f),
    SPH_C32(0xbdcd407a), SPH_C32(0x0f79f600) },
  { SPH_C32(0x891b0005), SPH_C32(0x9101a7f1), SPH_C32(0x21df69bd),
    SPH_C32(0x5beaef18), SPH_C32(0x72680003), SPH_C32(0x0956911d),
    SPH_C32(0xd63b08de), SPH_C32(0x5ce54bbf) },
  { SPH_C32(0x09870006), SPH_C32(0xf67227d0), SPH_C32(0x7dc21fb6),
    SPH_C32(0x30a7636d), SPH_C32(0xe38a0002), SPH_C32(0x1f0c5e19),
    SPH_C32(0x01d79997), SPH_C32(0xfbd930c2) },
  { SPH_C32(0xc9c90007), SPH_C32(0xc5cbe7c0), SPH_C32(0xd3cca4b3),
    SPH_C32(0x8503a556), SPH_C32(0x2b7b0002), SPH_C32(0x1421b99b),
    SPH_C32(0x6a21d133), SPH_C32(0xa8458d7d) },
  { SPH_C32(0xc1760006), SPH_C32(0xfd5fc052), SPH_C32(0x16345712),
    SPH_C32(0x633bded2), SPH_C32(0xeb350003), SPH_C32(0x2798798b),
    SPH_C32(0xc42f6a36), SPH_C32(0x1de14b46) },
  { SPH_C32(0x01380007), SPH_C32(0xcee60042), SPH_C32(0xb83aec17),
    SPH_C32(0xd69f18e9), SPH_C32(0x23c40003), SPH_C32(0x2cb59e09),
    SPH_C32(0xafd92292), SPH_C32(0x4e7df6f9) },
  { SPH_C32(0x6ba90000), SPH_C32(0x40ebf9aa), SPH_C32(0x98321c3d),
    SPH_C32(0x76acc733), SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd),
    SPH_C32(0x05f7ac6d), SPH_C32(0xd9e6eee9) },
  { SPH_C32(0xabe70001), SPH_C32(0x735239ba), SPH_C32(0x363ca738),
    SPH_C32(0xc3080108), SPH_C32(0x73500004), SPH_C32(0xc7b0915f),
    SPH_C32(0x6e01e4c9), SPH_C32(0x8a7a5356) },
  { SPH_C32(0xa3580000), SPH_C32(0x4bc61e28), SPH_C32(0xf3c45499),
    SPH_C32(0x25307a8c), SPH_C32(0xb31e0005), SPH_C32(0xf409514f),
    SPH_C32(0xc00f5fcc), SPH_C32(0x3fde956d) },
  { SPH_C32(0x63160001), SPH_C32(0x787fde38), SPH_C32(0x5dcaef9c),
    SPH_C32(0x9094bcb7), SPH_C32(0x7bef0005), SPH_C32(0xff24b6cd),
    SPH_C32(0xabf91768), SPH_C32(0x6c4228d2) },
  { SPH_C32(0xe38a0002), SPH_C32(0x1f0c5e19), SPH_C32(0x01d79997),
    SPH_C32(0xfbd930c2), SPH_C32(0xea0d0004), SPH_C32(0xe97e79c9),
    SPH_C32(0x7c158621), SPH_C32(0xcb7e53af) },
  { SPH_C32(0x23c40003), SPH_C32(0x2cb59e09), SPH_C32(0xafd92292),
    SPH_C32(0x4e7df6f9), SPH_C32(0x22fc0004), SPH_C32(0xe2539e4b),
    SPH_C32(0x17e3ce85), SPH_C32(0x98e2ee10) },
  { SPH_C32(0x2b7b0002), SPH_C32(0x1421b99b), SPH_C32(0x6a21d133),
    SPH_C32(0xa8458d7d), SPH_C32(0xe2b20005), SPH_C32(0xd1ea5e5b),
    SPH_C32(0xb9ed7580), SPH_C32(0x2d46282b) },
  { SPH_C32(0xeb350003), SPH_C32(0x2798798b), SPH_C32(0xc42f6a36),
    SPH_C32(0x1de14b46), SPH_C32(0x2a430005), SPH_C32(0xdac7b9d9),
    SPH_C32(0xd21b3d24), SPH_C32(0x7eda9594) },
  { SPH_C32(0x3a050000), SPH_C32(0x6508f6be), SPH_C32(0xe1d03671),
    SPH_C32(0x64347a75), SPH_C32(0x622e0006), SPH_C32(0xb699de7a),
    SPH_C32(0xe5f0038b), SPH_C32(0x460ba45e) },
  { SPH_C32(0xfa4b0001), SPH_C32(0x56b136ae), SPH_C32(0x4fde8d74),
    SPH_C32(0xd190bc4e), SPH_C32(0xaadf0006), SPH_C32(0xbdb439f8),
    SPH_C32(0x8e064b2f), SPH_C32(0x159719e1) },
  { SPH_C32(0xf2f40000), SPH_C32(0x6e25113c), SPH_C32(0x8a267ed5),
    SPH_C32(0x37a8c7ca), SPH_C32(0x6a910007), SPH_C32(0x8e0df9e8),
    SPH_C32(0x2008f02a), SPH_C32(0xa033dfda) },
  { SPH_C32(0x32ba0001), SPH_C32(0x5d9cd12c), SPH_C32(0x2428c5d0),
    SPH_C32(0x820c01f1), SPH_C32(0xa2600007), SPH_C32(0x85201e6a),
    SPH_C32(0x4bfeb88e), SPH_C32(0xf3af6265) },
  { SPH_C32(0xb2260002), SPH_C32(0x3aef510d), SPH_C32(0x7835b3db),
    SPH_C32(0xe9418d84), SPH_C32(0x33820006), SPH_C32(0x937ad16e),
    SPH_C32(0x9c1229c7), SPH_C32(0x54931918) },
  { SPH_C32(0x72680003), SPH_C32(0x0956911d), SPH_C32(0xd63b08de),
    SPH_C32(0x5ce54bbf), SPH_C32(0xfb730006), SPH_C32(0x985736ec),
    SPH_C32(0xf7e46163), SPH_C32(0x070fa4a7) },
  { SPH_C32(0x7ad70002), SPH_C32(0x31c2b68f), SPH_C32(0x13c3fb7f),
    SPH_C32(0xbadd303b), SPH_C32(0x3b3d0007), SPH_C32(0xabeef6fc),
    SPH_C32(0x59eada66), SPH_C32(0xb2ab629c) },
  { SPH_C32(0xba990003), SPH_C32(0x027b769f), SPH_C32(0xbdcd407a),
    SPH_C32(0x0f79f600), SPH_C32(0xf3cc0007), SPH_C32(0xa0c3117e),
    SPH_C32(0x321c92c2), SPH_C32(0xe137df23) },
  { SPH_C32(0xbba10004), SPH_C32(0xcc9d76dd), SPH_C32(0x05f7ac6d),
    SPH_C32(0xd9e6eee9), SPH_C32(0xd0080004), SPH_C32(0x8c768f77),
    SPH_C32(0x9dc5b050), SPH_C32(0xaf4a29da) },
  { SPH_C32(0x7bef0005), SPH_C32(0xff24b6cd), SPH_C32(0xabf91768),
    SPH_C32(0x6c4228d2), SPH_C32(0x18f90004), SPH_C32(0x875b68f5),
    SPH_C32(0xf633f8f4), SPH_C32(0xfcd69465) },
  { SPH_C32(0x73500004), SPH_C32(0xc7b0915f), SPH_C32(0x6e01e4c9),
    SPH_C32(0x8a7a5356), SPH_C32(0xd8b70005), SPH_C32(0xb4e2a8e5),
    SPH_C32(0x583d43f1), SPH_C32(0x4972525e) },
  { SPH_C32(0xb31e0005), SPH_C32(0xf409514f), SPH_C32(0xc00f5fcc),
    SPH_C32(0x3fde956d), SPH_C32(0x10460005), SPH_C32(0xbfcf4f67),
    SPH_C32(0x33cb0b55), SPH_C32(0x1aeeefe1) },
  { SPH_C32(0x33820006), SPH_C32(0x937ad16e), SPH_C32(0x9c1229c7),
    SPH_C32(0x54931918), SPH_C32(0x81a40004), SPH_C32(0xa9958063),
    SPH_C32(0xe4279a1c), SPH_C32(0xbdd2949c) },
  { SPH_C32(0xf3cc0007), SPH_C32(0xa0c3117e), SPH_C32(0x321c92c2),
    SPH_C32(0xe137df23), SPH_C32(0x49550004), SPH_C32(0xa2b867e1),
    SPH_C32(0x8fd1d2b8), SPH_C32(0xee4e2923) },
  { SPH_C32(0xfb730006), SPH_C32(0x985736ec), SPH_C32(0xf7e46163),
    SPH_C32(0x070fa4a7), SPH_C32(0x891b0005), SPH_C32(0x9101a7f1),
    SPH_C32(0x21df69bd), SPH_C32(0x5beaef18) },
  { SPH_C32(0x3b3d0007), SPH_C32(0xabeef6fc), SPH_C32(0x59eada66),
    SPH_C32(0xb2ab629c), SPH_C32(0x41ea0005), SPH_C32(0x9a2c4073),
    SPH_C32(0x4a292119), SPH_C32(0x087652a7) },
  { SPH_C32(0xea0d0004), SPH_C32(0xe97e79c9), SPH_C32(0x7c158621),
    SPH_C32(0xcb7e53af), SPH_C32(0x09870006), SPH_C32(0xf67227d0),
    SPH_C32(0x7dc21fb6), SPH_C32(0x30a7636d) },
  { SPH_C32(0x2a430005), SPH_C32(0xdac7b9d9), SPH_C32(0xd21b3d24),
    SPH_C32(0x7eda9594), SPH_C32(0xc1760006), SPH_C32(0xfd5fc052),
    SPH_C32(0x16345712), SPH_C32(0x633bded2) },
  { SPH_C32(0x22fc0004), SPH_C32(0xe2539e4b), SPH_C32(0x17e3ce85),
    SPH_C32(0x98e2ee10), SPH_C32(0x01380007), SPH_C32(0xcee60042),
    SPH_C32(0xb83aec17), SPH_C32(0xd69f18e9) },
  { SPH_C32(0xe2b20005), SPH_C32(0xd1ea5e5b), SPH_C32(0xb9ed7580),
    SPH_C32(0x2d46282b), SPH_C32(0xc9c90007), SPH_C32(0xc5cbe7c0),
    SPH_C32(0xd3cca4b3), SPH_C32(0x8503a556) },
  { SPH_C32(0x622e0006), SPH_C32(0xb699de7a), SPH_C32(0xe5f0038b),
    SPH_C32(0x460ba45e), SPH_C32(0x582b0006), SPH_C32(0xd39128c4),
    SPH_C32(0x042035fa), SPH_C32(0x223fde2b) },
  { SPH_C32(0xa2600007), SPH_C32(0x85201e6a), SPH_C32(0x4bfeb88e),
    SPH_C32(0xf3af6265), SPH_C32(0x90da0006), SPH_C32(0xd8bccf46),
    SPH_C32(0x6fd67d5e), SPH_C32(0x71a36394) },
  { SPH_C32(0xaadf0006), SPH_C32(0xbdb439f8), SPH_C32(0x8e064b2f),
    SPH_C32(0x159719e1), SPH_C32(0x50940007), SPH_C32(0xeb050f56),
    SPH_C32(0xc1d8c65b), SPH_C32(0xc407a5af) },
  { SPH_C32(0x6a910007), SPH_C32(0x8e0df9e8), SPH_C32(0x2008f02a),
    SPH_C32(0xa033dfda), SPH_C32(0x98650007), SPH_C32(0xe028e8d4),
    SPH_C32(0xaa2e8eff), SPH_C32(0x979b1810) },
  { SPH_C32(0xa8ae0008), SPH_C32(0x2079397d), SPH_C32(0xfe739301),
    SPH_C32(0xb8a92831), SPH_C32(0x171c0000), SPH_C32(0xb26e3344),
    SPH_C32(0x9e6a837e), SPH_C32(0x58f8485f) },
  { SPH_C32(0x68e00009), SPH_C32(0x13c0f96d), SPH_C32(0x507d2804),
    SPH_C32(0x0d0dee0a), SPH_C32(0xdfed0000), SPH_C32(0xb943d4c6),
    SPH_C32(0xf59ccbda), SPH_C32(0x0b64f5e0) },
  { SPH_C32(0x605f0008), SPH_C32(0x2b54deff), SPH_C32(0x9585dba5),
    SPH_C32(0xeb35958e), SPH_C32(0x1fa30001), SPH_C32(0x8afa14d6),
    SPH_C32(0x5b9270df), SPH_C32(0xbec033db) },
  { SPH_C32(0xa0110009), SPH_C32(0x18ed1eef), SPH_C32(0x3b8b60a0),
    SPH_C32(0x5e9153b5), SPH_C32(0xd7520001), SPH_C32(0x81d7f354),
    SPH_C32(0x3064387b), SPH_C32(0xed5c8e64) },
  { SPH_C32(0x208d000a), SPH_C32(0x7f9e9ece), SPH_C32(0x679616ab),
    SPH_C32(0x35dcdfc0), SPH_C32(0x46b00000), SPH_C32(0x978d3c50),
    SPH_C32(0xe788a932), SPH_C32(0x4a60f519) },
  { SPH_C32(0xe0c3000b), SPH_C32(0x4c275ede), SPH_C32(0xc998adae),
    SPH_C32(0x807819fb), SPH_C32(0x8e410000), SPH_C32(0x9ca0dbd2),
    SPH_C32(0x8c7ee196), SPH_C32(0x19fc48a6) },
  { SPH_C32(0xe87c000a), SPH_C32(0x74b3794c), SPH_C32(0x0c605e0f),
    SPH_C32(0x6640627f), SPH_C32(0x4e0f0001), SPH_C32(0xaf191bc2),
    SPH_C32(0x22705a93), SPH_C32(0xac588e9d) },
  { SPH_C32(0x2832000b), SPH_C32(0x470ab95c), SPH_C32(0xa26ee50a),
    SPH_C32(0xd3e4a444), SPH_C32(0x86fe0001), SPH_C32(0xa434fc40),
    SPH_C32(0x49861237), SPH_C32(0xffc43322) },
  { SPH_C32(0xf9020008), SPH_C32(0x059a3669), SPH_C32(0x8791b94d),
    SPH_C32(0xaa319577), SPH_C32(0xce930002), SPH_C32(0xc86a9be3),
    SPH_C32(0x7e6d2c98), SPH_C32(0xc71502e8) },
  { SPH_C32(0x394c0009), SPH_C32(0x3623f679), SPH_C32(0x299f0248),
    SPH_C32(0x1f95534c), SPH_C32(0x06620002), SPH_C32(0xc3477c61),
    SPH_C32(0x159b643c), SPH_C32(0x9489bf57) },
  { SPH_C32(0x31f30008), SPH_C32(0x0eb7d1eb), SPH_C32(0xec67f1e9),
    SPH_C32(0xf9ad28c8), SPH_C32(0xc62c0003), SPH_C32(0xf0febc71),
    SPH_C32(0xbb95df39), SPH_C32(0x212d796c) },
  { SPH_C32(0xf1bd0009), SPH_C32(0x3d0e11fb), SPH_C32(0x42694aec),
    SPH_C32(0x4c09eef3), SPH_C32(0x0edd0003), SPH_C32(0xfbd35bf3),
    SPH_C32(0xd063979d), SPH_C32(0x72b1c4d3) },
  { SPH_C32(0x7121000a), SPH_C32(0x5a7d91da), SPH_C32(0x1e743ce7),
    SPH_C32(0x27446286), SPH_C32(0x9f3f0002), SPH_C32(0xed8994f7),
    SPH_C32(0x078f06d4), SPH_C32(0xd58dbfae) },
  { SPH_C32(0xb16f000b), SPH_C32(0x69c451ca), SPH_C32(0xb07a87e2),
    SPH_C32(0x92e0a4bd), SPH_C32(0x57ce0002), SPH_C32(0xe6a47375),
    SPH_C32(0x6c794e70), SPH_C32(0x86110211) },
  { SPH_C32(0xb9d0000a), SPH_C32(0x51507658), SPH_C32(0x75827443),
    SPH_C32(0x74d8df39), SPH_C32(0x97800003), SPH_C32(0xd51db365),
    SPH_C32(0xc277f575), SPH_C32(0x33b5c42a) },
  { SPH_C32(0x799e000b), SPH_C32(0x62e9b648), SPH_C32(0xdb8ccf46),
    SPH_C32(0xc17c1902), SPH_C32(0x5f710003), SPH_C32(0xde3054e7),
    SPH_C32(0xa981bdd1), SPH_C32(0x60297995) },
  { SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a), SPH_C32(0x63b62351),
    SPH_C32(0x17e301eb), SPH_C32(0x7cb50000), SPH_C32(0xf285caee),
    SPH_C32(0x06589f43), SPH_C32(0x2e548f6c) },
  { SPH_C32(0xb8e8000d), SPH_C32(0x9fb6761a), SPH_C32(0xcdb89854),
    SPH_C32(0xa247c7d0), SPH_C32(0xb4440000), SPH_C32(0xf9a82d6c),
    SPH_C32(0x6daed7e7), SPH_C32(0x7dc832d3) },
  { SPH_C32(0xb057000c), SPH_C32(0xa7225188), SPH_C32(0x08406bf5),
    SPH_C32(0x447fbc54), SPH_C32(0x740a0001), SPH_C32(0xca11ed7c),
    SPH_C32(0xc3a06ce2), SPH_C32(0xc86cf4e8) },
  { SPH_C32(0x7019000d), SPH_C32(0x949b9198), SPH_C32(0xa64ed0f0),
    SPH_C32(0xf1db7a6f), SPH_C32(0xbcfb0001), SPH_C32(0xc13c0afe),
    SPH_C32(0xa8562446), SPH_C32(0x9bf04957) },
  { SPH_C32(0xf085000e), SPH_C32(0xf3e811b9), SPH_C32(0xfa53a6fb),
    SPH_C32(0x9a96f61a), SPH_C32(0x2d190000), SPH_C32(0xd766c5fa),
    SPH_C32(0x7fbab50f), SPH_C32(0x3ccc322a) },
  { SPH_C32(0x30cb000f), SPH_C32(0xc051d1a9), SPH_C32(0x545d1dfe),
    SPH_C32(0x2f323021), SPH_C32(0xe5e80000), SPH_C32(0xdc4b2278),
    SPH_C32(0x144cfdab), SPH_C32(0x6f508f95) },
  { SPH_C32(0x3874000e), SPH_C32(0xf8c5f63b), SPH_C32(0x91a5ee5f),
    SPH_C32(0xc90a4ba5), SPH_C32(0x25a60001), SPH_C32(0xeff2e268),
    SPH_C32(0xba4246ae), SPH_C32(0xdaf449ae) },
  { SPH_C32(0xf83a000f), SPH_C32(0xcb7c362b), SPH_C32(0x3fab555a),
    SPH_C32(0x7cae8d9e), SPH_C32(0xed570001), SPH_C32(0xe4df05ea),
    SPH_C32(0xd1b40e0a), SPH_C32(0x8968f411) },
  { SPH_C32(0x290a000c), SPH_C32(0x89ecb91e), SPH_C32(0x1a54091d),
    SPH_C32(0x057bbcad), SPH_C32(0xa53a0002), SPH_C32(0x88816249),
    SPH_C32(0xe65f30a5), SPH_C32(0xb1b9c5db) },
  { SPH_C32(0xe944000d), SPH_C32(0xba55790e), SPH_C32(0xb45ab218),
    SPH_C32(0xb0df7a96), SPH_C32(0x6dcb0002), SPH_C32(0x83ac85cb),
    SPH_C32(0x8da97801), SPH_C32(0xe2257864) },
  { SPH_C32(0xe1fb000c), SPH_C32(0x82c15e9c), SPH_C32(0x71a241b9),
    SPH_C32(0x56e70112), SPH_C32(0xad850003), SPH_C32(0xb01545db),
    SPH_C32(0x23a7c304), SPH_C32(0x5781be5f) },
  { SPH_C32(0x21b5000d), SPH_C32(0xb1789e8c), SPH_C32(0xdfacfabc),
    SPH_C32(0xe343c729), SPH_C32(0x65740003), SPH_C32(0xbb38a259),
    SPH_C32(0x48518ba0), SPH_C32(0x041d03e0) },
  { SPH_C32(0xa129000e), SPH_C32(0xd60b1ead), SPH_C32(0x83b18cb7),
    SPH_C32(0x880e4b5c), SPH_C32(0xf4960002), SPH_C32(0xad626d5d),
    SPH_C32(0x9fbd1ae9), SPH_C32(0xa321789d) },
  { SPH_C32(0x6167000f), SPH_C32(0xe5b2debd), SPH_C32(0x2dbf37b2),
    SPH_C32(0x3daa8d67), SPH_C32(0x3c670002), SPH_C32(0xa64f8adf),
    SPH_C32(0xf44b524d), SPH_C32(0xf0bdc522) },
  { SPH_C32(0x69d8000e), SPH_C32(0xdd26f92f), SPH_C32(0xe847c413),
    SPH_C32(0xdb92f6e3), SPH_C32(0xfc290003), SPH_C32(0x95f64acf),
    SPH_C32(0x5a45e948), SPH_C32(0x45190319) },
  { SPH_C32(0xa996000f), SPH_C32(0xee9f393f), SPH_C32(0x46497f16),
    SPH_C32(0x6e3630d8), SPH_C32(0x34d80003), SPH_C32(0x9edbad4d),
    SPH_C32(0x31b3a1ec), SPH_C32(0x1685bea6) },
  { SPH_C32(0xc3070008), SPH_C32(0x6092c0d7), SPH_C32(0x66418f3c),
    SPH_C32(0xce05ef02), SPH_C32(0xacbd0004), SPH_C32(0x7ef34599),
    SPH_C32(0x9b9d2f13), SPH_C32(0x811ea6b6) },
  { SPH_C32(0x03490009), SPH_C32(0x532b00c7), SPH_C32(0xc84f3439),
    SPH_C32(0x7ba12939), SPH_C32(0x644c0004), SPH_C32(0x75dea21b),
    SPH_C32(0xf06b67b7), SPH_C32(0xd2821b09) },
  { SPH_C32(0x0bf60008), SPH_C32(0x6bbf2755), SPH_C32(0x0db7c798),
    SPH_C32(0x9d9952bd), SPH_C32(0xa4020005), SPH_C32(0x4667620b),
    SPH_C32(0x5e65dcb2), SPH_C32(0x6726dd32) },
  { SPH_C32(0xcbb80009), SPH_C32(0x5806e745), SPH_C32(0xa3b97c9d),
    SPH_C32(0x283d9486), SPH_C32(0x6cf30005), SPH_C32(0x4d4a8589),
    SPH_C32(0x35939416), SPH_C32(0x34ba608d) },
  { SPH_C32(0x4b24000a), SPH_C32(0x3f756764), SPH_C32(0xffa40a96),
    SPH_C32(0x437018f3), SPH_C32(0xfd110004), SPH_C32(0x5b104a8d),
    SPH_C32(0xe27f055f), SPH_C32(0x93861bf0) },
  { SPH_C32(0x8b6a000b), SPH_C32(0x0ccca774), SPH_C32(0x51aab193),
    SPH_C32(0xf6d4dec8), SPH_C32(0x35e00004), SPH_C32(0x503dad0f),
    SPH_C32(0x89894dfb), SPH_C32(0xc01aa64f) },
  { SPH_C32(0x83d5000a), SPH_C32(0x345880e6), SPH_C32(0x94524232),
    SPH_C32(0x10eca54c), SPH_C32(0xf5ae0005), SPH_C32(0x63846d1f),
    SPH_C32(0x2787f6fe), SPH_C32(0x75be6074) },
  { SPH_C32(0x439b000b), SPH_C32(0x07e140f6), SPH_C32(0x3a5cf937),
    SPH_C32(0xa5486377), SPH_C32(0x3d5f0005), SPH_C32(0x68a98a9d),
    SPH_C32(0x4c71be5a), SPH_C32(0x2622ddcb) },
  { SPH_C32(0x92ab0008), SPH_C32(0x4571cfc3), SPH_C32(0x1fa3a570),
    SPH_C32(0xdc9d5244), SPH_C32(0x75320006), SPH_C32(0x04f7ed3e),
    SPH_C32(0x7b9a80f5), SPH_C32(0x1ef3ec01) },
  { SPH_C32(0x52e50009), SPH_C32(0x76c80fd3), SPH_C32(0xb1ad1e75),
    SPH_C32(0x6939947f), SPH_C32(0xbdc30006), SPH_C32(0x0fda0abc),
    SPH_C32(0x106cc851), SPH_C32(0x4d6f51be) },
  { SPH_C32(0x5a5a0008), SPH_C32(0x4e5c2841), SPH_C32(0x7455edd4),
    SPH_C32(0x8f01effb), SPH_C32(0x7d8d0007), SPH_C32(0x3c63caac),
    SPH_C32(0xbe627354), SPH_C32(0xf8cb9785) },
  { SPH_C32(0x9a140009), SPH_C32(0x7de5e851), SPH_C32(0xda5b56d1),
    SPH_C32(0x3aa529c0), SPH_C32(0xb57c0007), SPH_C32(0x374e2d2e),
    SPH_C32(0xd5943bf0), SPH_C32(0xab572a3a) },
  { SPH_C32(0x1a88000a), SPH_C32(0x1a966870), SPH_C32(0x864620da),
    SPH_C32(0x51e8a5b5), SPH_C32(0x249e0006), SPH_C32(0x2114e22a),
    SPH_C32(0x0278aab9), SPH_C32(0x0c6b5147) },
  { SPH_C32(0xdac6000b), SPH_C32(0x292fa860), SPH_C32(0x28489bdf),
    SPH_C32(0xe44c638e), SPH_C32(0xec6f0006), SPH_C32(0x2a3905a8),
    SPH_C32(0x698ee21d), SPH_C32(0x5ff7ecf8) },
  { SPH_C32(0xd279000a), SPH_C32(0x11bb8ff2), SPH_C32(0xedb0687e),
    SPH_C32(0x0274180a), SPH_C32(0x2c210007), SPH_C32(0x1980c5b8),
    SPH_C32(0xc7805918), SPH_C32(0xea532ac3) },
  { SPH_C32(0x1237000b), SPH_C32(0x22024fe2), SPH_C32(0x43bed37b),
    SPH_C32(0xb7d0de31), SPH_C32(0xe4d00007), SPH_C32(0x12ad223a),
    SPH_C32(0xac7611bc), SPH_C32(0xb9cf977c) },
  { SPH_C32(0x130f000c), SPH_C32(0xece44fa0), SPH_C32(0xfb843f6c),
    SPH_C32(0x614fc6d8), SPH_C32(0xc7140004), SPH_C32(0x3e18bc33),
    SPH_C32(0x03af332e), SPH_C32(0xf7b26185) },
  { SPH_C32(0xd341000d), SPH_C32(0xdf5d8fb0), SPH_C32(0x558a8469),
    SPH_C32(0xd4eb00e3), SPH_C32(0x0fe50004), SPH_C32(0x35355bb1),
    SPH_C32(0x68597b8a), SPH_C32(0xa42edc3a) },
  { SPH_C32(0xdbfe000c), SPH_C32(0xe7c9a822), SPH_C32(0x907277c8),
    SPH_C32(0x32d37b67), SPH_C32(0xcfab0005), SPH_C32(0x068c9ba1),
    SPH_C32(0xc657c08f), SPH_C32(0x118a1a01) },
  { SPH_C32(0x1bb0000d), SPH_C32(0xd4706832), SPH_C32(0x3e7ccccd),
    SPH_C32(0x8777bd5c), SPH_C32(0x075a0005), SPH_C32(0x0da17c23),
    SPH_C32(0xada1882b), SPH_C32(0x4216a7be) },
  { SPH_C32(0x9b2c000e), SPH_C32(0xb303e813), SPH_C32(0x6261bac6),
    SPH_C32(0xec3a3129), SPH_C32(0x96b80004), SPH_C32(0x1bfbb327),
    SPH_C32(0x7a4d1962), SPH_C32(0xe52adcc3) },
  { SPH_C32(0x5b62000f), SPH_C32(0x80ba2803), SPH_C32(0xcc6f01c3),
    SPH_C32(0x599ef712), SPH_C32(0x5e490004), SPH_C32(0x10d654a5),
    SPH_C32(0x11bb51c6), SPH_C32(0xb6b6617c) },
  { SPH_C32(0x53dd000e), SPH_C32(0xb82e0f91), SPH_C32(0x0997f262),
    SPH_C32(0xbfa68c96), SPH_C32(0x9e070005), SPH_C32(0x236f94b5),
    SPH_C32(0xbfb5eac3), SPH_C32(0x0312a747) },
  { SPH_C32(0x9393000f), SPH_C32(0x8b97cf81), SPH_C32(0xa7994967),
    SPH_C32(0x0a024aad), SPH_C32(0x56f60005), SPH_C32(0x28427337),
    SPH_C32(0xd443a267), SPH_C32(0x508e1af8) },
  { SPH_C32(0x42a3000c), SPH_C32(0xc90740b4), SPH_C32(0x82661520),
    SPH_C32(0x73d77b9e), SPH_C32(0x1e9b0006), SPH_C32(0x441c1494),
    SPH_C32(0xe3a89cc8), SPH_C32(0x685f2b32) },
  { SPH_C32(0x82ed000d), SPH_C32(0xfabe80a4), SPH_C32(0x2c68ae25),
    SPH_C32(0xc673bda5), SPH_C32(0xd66a0006), SPH_C32(0x4f31f316),
    SPH_C32(0x885ed46c), SPH_C32(0x3bc3968d) },
  { SPH_C32(0x8a52000c), SPH_C32(0xc22aa736), SPH_C32(0xe9905d84),
    SPH_C32(0x204bc621), SPH_C32(0x16240007), SPH_C32(0x7c883306),
    SPH_C32(0x26506f69), SPH_C32(0x8e6750b6) },
  { SPH_C32(0x4a1c000d), SPH_C32(0xf1936726), SPH_C32(0x479ee681),
    SPH_C32(0x95ef001a), SPH_C32(0xded50007), SPH_C32(0x77a5d484),
    SPH_C32(0x4da627cd), SPH_C32(0xddfbed09) },
  { SPH_C32(0xca80000e), SPH_C32(0x96e0e707), SPH_C32(0x1b83908a),
    SPH_C32(0xfea28c6f), SPH_C32(0x4f370006), SPH_C32(0x61ff1b80),
    SPH_C32(0x9a4ab684), SPH_C32(0x7ac79674) },
  { SPH_C32(0x0ace000f), SPH_C32(0xa5592717), SPH_C32(0xb58d2b8f),
    SPH_C32(0x4b064a54), SPH_C32(0x87c60006), SPH_C32(0x6ad2fc02),
    SPH_C32(0xf1bcfe20), SPH_C32(0x295b2bcb) },
  { SPH_C32(0x0271000e), SPH_C32(0x9dcd0085), SPH_C32(0x7075d82e),
    SPH_C32(0xad3e31d0), SPH_C32(0x47880007), SPH_C32(0x596b3c12),
    SPH_C32(0x5fb24525), SPH_C32(0x9cffedf0) },
  { SPH_C32(0xc23f000f), SPH_C32(0xae74c095), SPH_C32(0xde7b632b),
    SPH_C32(0x189af7eb), SPH_C32(0x8f790007), SPH_C32(0x5246db90),
    SPH_C32(0x34440d81), SPH_C32(0xcf63504f) },
  { SPH_C32(0x171c0000), SPH_C32(0xb26e3344), SPH_C32(0x9e6a837e),
    SPH_C32(0x58f8485f), SPH_C32(0xbfb20008), SPH_C32(0x92170a39),
    SPH_C32(0x6019107f), SPH_C32(0xe051606e) },
  { SPH_C32(0xd7520001), SPH_C32(0x81d7f354), SPH_C32(0x3064387b),
    SPH_C32(0xed5c8e64), SPH_C32(0x77430008), SPH_C32(0x993aedbb),
    SPH_C32(0x0bef58db), SPH_C32(0xb3cdddd1) },
  { SPH_C32(0xdfed0000), SPH_C32(0xb943d4c6), SPH_C32(0xf59ccbda),
    SPH_C32(0x0b64f5e0), SPH_C32(0xb70d0009), SPH_C32(0xaa832dab),
    SPH_C32(0xa5e1e3de), SPH_C32(0x06691bea) },
  { SPH_C32(0x1fa30001), SPH_C32(0x8afa14d6), SPH_C32(0x5b9270df),
    SPH_C32(0xbec033db), SPH_C32(0x7ffc0009), SPH_C32(0xa1aeca29),
    SPH_C32(0xce17ab7a), SPH_C32(0x55f5a655) },
  { SPH_C32(0x9f3f0002), SPH_C32(0xed8994f7), SPH_C32(0x078f06d4),
    SPH_C32(0xd58dbfae), SPH_C32(0xee1e0008), SPH_C32(0xb7f4052d),
    SPH_C32(0x19fb3a33), SPH_C32(0xf2c9dd28) },
  { SPH_C32(0x5f710003), SPH_C32(0xde3054e7), SPH_C32(0xa981bdd1),
    SPH_C32(0x60297995), SPH_C32(0x26ef0008), SPH_C32(0xbcd9e2af),
    SPH_C32(0x720d7297), SPH_C32(0xa1556097) },
  { SPH_C32(0x57ce0002), SPH_C32(0xe6a47375), SPH_C32(0x6c794e70),
    SPH_C32(0x86110211), SPH_C32(0xe6a10009), SPH_C32(0x8f6022bf),
    SPH_C32(0xdc03c992), SPH_C32(0x14f1a6ac) },
  { SPH_C32(0x97800003), SPH_C32(0xd51db365), SPH_C32(0xc277f575),
    SPH_C32(0x33b5c42a), SPH_C32(0x2e500009), SPH_C32(0x844dc53d),
    SPH_C32(0xb7f58136), SPH_C32(0x476d1b13) },
  { SPH_C32(0x46b00000), SPH_C32(0x978d3c50), SPH_C32(0xe788a932),
    SPH_C32(0x4a60f519), SPH_C32(0x663d000a), SPH_C32(0xe813a29e),
    SPH_C32(0x801ebf99), SPH_C32(0x7fbc2ad9) },
  { SPH_C32(0x86fe0001), SPH_C32(0xa434fc40), SPH_C32(0x49861237),
    SPH_C32(0xffc43322), SPH_C32(0xaecc000a), SPH_C32(0xe33e451c),
    SPH_C32(0xebe8f73d), SPH_C32(0x2c209766) },
  { SPH_C32(0x8e410000), SPH_C32(0x9ca0dbd2), SPH_C32(0x8c7ee196),
    SPH_C32(0x19fc48a6), SPH_C32(0x6e82000b), SPH_C32(0xd087850c),
    SPH_C32(0x45e64c38), SPH_C32(0x9984515d) },
  { SPH_C32(0x4e0f0001), SPH_C32(0xaf191bc2), SPH_C32(0x22705a93),
    SPH_C32(0xac588e9d), SPH_C32(0xa673000b), SPH_C32(0xdbaa628e),
    SPH_C32(0x2e10049c), SPH_C32(0xca18ece2) },
  { SPH_C32(0xce930002), SPH_C32(0xc86a9be3), SPH_C32(0x7e6d2c98),
    SPH_C32(0xc71502e8), SPH_C32(0x3791000a), SPH_C32(0xcdf0ad8a),
    SPH_C32(0xf9fc95d5), SPH_C32(0x6d24979f) },
  { SPH_C32(0x0edd0003), SPH_C32(0xfbd35bf3), SPH_C32(0xd063979d),
    SPH_C32(0x72b1c4d3), SPH_C32(0xff60000a), SPH_C32(0xc6dd4a08),
    SPH_C32(0x920add71), SPH_C32(0x3eb82a20) },
  { SPH_C32(0x06620002), SPH_C32(0xc3477c61), SPH_C32(0x159b643c),
    SPH_C32(0x9489bf57), SPH_C32(0x3f2e000b), SPH_C32(0xf5648a18),
    SPH_C32(0x3c046674), SPH_C32(0x8b1cec1b) },
  { SPH_C32(0xc62c0003), SPH_C32(0xf0febc71), SPH_C32(0xbb95df39),
    SPH_C32(0x212d796c), SPH_C32(0xf7df000b), SPH_C32(0xfe496d9a),
    SPH_C32(0x57f22ed0), SPH_C32(0xd88051a4) },
  { SPH_C32(0xc7140004), SPH_C32(0x3e18bc33), SPH_C32(0x03af332e),
    SPH_C32(0xf7b26185), SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393),
    SPH_C32(0xf82b0c42), SPH_C32(0x96fda75d) },
  { SPH_C32(0x075a0005), SPH_C32(0x0da17c23), SPH_C32(0xada1882b),
    SPH_C32(0x4216a7be), SPH_C32(0x1cea0008), SPH_C32(0xd9d11411),
    SPH_C32(0x93dd44e6), SPH_C32(0xc5611ae2) },
  { SPH_C32(0x0fe50004), SPH_C32(0x35355bb1), SPH_C32(0x68597b8a),
    SPH_C32(0xa42edc3a), SPH_C32(0xdca40009), SPH_C32(0xea68d401),
    SPH_C32(0x3dd3ffe3), SPH_C32(0x70c5dcd9) },
  { SPH_C32(0xcfab0005), SPH_C32(0x068c9ba1), SPH_C32(0xc657c08f),
    SPH_C32(0x118a1a01), SPH_C32(0x14550009), SPH_C32(0xe1453383),
    SPH_C32(0x5625b747), SPH_C32(0x23596166) },
  { SPH_C32(0x4f370006), SPH_C32(0x61ff1b80), SPH_C32(0x9a4ab684),
    SPH_C32(0x7ac79674), SPH_C32(0x85b70008), SPH_C32(0xf71ffc87),
    SPH_C32(0x81c9260e), SPH_C32(0x84651a1b) },
  { SPH_C32(0x8f790007), SPH_C32(0x5246db90), SPH_C32(0x34440d81),
    SPH_C32(0xcf63504f), SPH_C32(0x4d460008), SPH_C32(0xfc321b05),
    SPH_C32(0xea3f6eaa), SPH_C32(0xd7f9a7a4) },
  { SPH_C32(0x87c60006), SPH_C32(0x6ad2fc02), SPH_C32(0xf1bcfe20),
    SPH_C32(0x295b2bcb), SPH_C32(0x8d080009), SPH_C32(0xcf8bdb15),
    SPH_C32(0x4431d5af), SPH_C32(0x625d619f) },
  { SPH_C32(0x47880007), SPH_C32(0x596b3c12), SPH_C32(0x5fb24525),
    SPH_C32(0x9cffedf0), SPH_C32(0x45f90009), SPH_C32(0xc4a63c97),
    SPH_C32(0x2fc79d0b), SPH_C32(0x31c1dc20) },
  { SPH_C32(0x96b80004), SPH_C32(0x1bfbb327), SPH_C32(0x7a4d1962),
    SPH_C32(0xe52adcc3), SPH_C32(0x0d94000a), SPH_C32(0xa8f85b34),
    SPH_C32(0x182ca3a4), SPH_C32(0x0910edea) },
  { SPH_C32(0x56f60005), SPH_C32(0x28427337), SPH_C32(0xd443a267),
    SPH_C32(0x508e1af8), SPH_C32(0xc565000a), SPH_C32(0xa3d5bcb6),
    SPH_C32(0x73daeb00), SPH_C32(0x5a8c5055) },
  { SPH_C32(0x5e490004), SPH_C32(0x10d654a5), SPH_C32(0x11bb51c6),
    SPH_C32(0xb6b6617c), SPH_C32(0x052b000b), SPH_C32(0x906c7ca6),
    SPH_C32(0xddd45005), SPH_C32(0xef28966e) },
  { SPH_C32(0x9e070005), SPH_C32(0x236f94b5), SPH_C32(0xbfb5eac3),
    SPH_C32(0x0312a747), SPH_C32(0xcdda000b), SPH_C32(0x9b419b24),
    SPH_C32(0xb62218a1), SPH_C32(0xbcb42bd1) },
  { SPH_C32(0x1e9b0006), SPH_C32(0x441c1494), SPH_C32(0xe3a89cc8),
    SPH_C32(0x685f2b32), SPH_C32(0x5c38000a), SPH_C32(0x8d1b5420),
    SPH_C32(0x61ce89e8), SPH_C32(0x1b8850ac) },
  { SPH_C32(0xded50007), SPH_C32(0x77a5d484), SPH_C32(0x4da627cd),
    SPH_C32(0xddfbed09), SPH_C32(0x94c9000a), SPH_C32(0x8636b3a2),
    SPH_C32(0x0a38c14c), SPH_C32(0x4814ed13) },
  { SPH_C32(0xd66a0006), SPH_C32(0x4f31f316), SPH_C32(0x885ed46c),
    SPH_C32(0x3bc3968d), SPH_C32(0x5487000b), SPH_C32(0xb58f73b2),
    SPH_C32(0xa4367a49), SPH_C32(0xfdb02b28) },
  { SPH_C32(0x16240007), SPH_C32(0x7c883306), SPH_C32(0x26506f69),
    SPH_C32(0x8e6750b6), SPH_C32(0x9c76000b), SPH_C32(0xbea29430),
    SPH_C32(0xcfc032ed), SPH_C32(0xae2c9697) },
  { SPH_C32(0x7cb50000), SPH_C32(0xf285caee), SPH_C32(0x06589f43),
    SPH_C32(0x2e548f6c), SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4),
    SPH_C32(0x65eebc12), SPH_C32(0x39b78e87) },
  { SPH_C32(0xbcfb0001), SPH_C32(0xc13c0afe), SPH_C32(0xa8562446),
    SPH_C32(0x9bf04957), SPH_C32(0xcce2000c), SPH_C32(0x55a79b66),
    SPH_C32(0x0e18f4b6), SPH_C32(0x6a2b3338) },
  { SPH_C32(0xb4440000), SPH_C32(0xf9a82d6c), SPH_C32(0x6daed7e7),
    SPH_C32(0x7dc832d3), SPH_C32(0x0cac000d), SPH_C32(0x661e5b76),
    SPH_C32(0xa0164fb3), SPH_C32(0xdf8ff503) },
  { SPH_C32(0x740a0001), SPH_C32(0xca11ed7c), SPH_C32(0xc3a06ce2),
    SPH_C32(0xc86cf4e8), SPH_C32(0xc45d000d), SPH_C32(0x6d33bcf4),
    SPH_C32(0xcbe00717), SPH_C32(0x8c1348bc) },
  { SPH_C32(0xf4960002), SPH_C32(0xad626d5d), SPH_C32(0x9fbd1ae9),
    SPH_C32(0xa321789d), SPH_C32(0x55bf000c), SPH_C32(0x7b6973f0),
    SPH_C32(0x1c0c965e), SPH_C32(0x2b2f33c1) },
  { SPH_C32(0x34d80003), SPH_C32(0x9edbad4d), SPH_C32(0x31b3a1ec),
    SPH_C32(0x1685bea6), SPH_C32(0x9d4e000c), SPH_C32(0x70449472),
    SPH_C32(0x77fadefa), SPH_C32(0x78b38e7e) },
  { SPH_C32(0x3c670002), SPH_C32(0xa64f8adf), SPH_C32(0xf44b524d),
    SPH_C32(0xf0bdc522), SPH_C32(0x5d00000d), SPH_C32(0x43fd5462),
    SPH_C32(0xd9f465ff), SPH_C32(0xcd174845) },
  { SPH_C32(0xfc290003), SPH_C32(0x95f64acf), SPH_C32(0x5a45e948),
    SPH_C32(0x45190319), SPH_C32(0x95f1000d), SPH_C32(0x48d0b3e0),
    SPH_C32(0xb2022d5b), SPH_C32(0x9e8bf5fa) },
  { SPH_C32(0x2d190000), SPH_C32(0xd766c5fa), SPH_C32(0x7fbab50f),
    SPH_C32(0x3ccc322a), SPH_C32(0xdd9c000e), SPH_C32(0x248ed443),
    SPH_C32(0x85e913f4), SPH_C32(0xa65ac430) },
  { SPH_C32(0xed570001), SPH_C32(0xe4df05ea), SPH_C32(0xd1b40e0a),
    SPH_C32(0x8968f411), SPH_C32(0x156d000e), SPH_C32(0x2fa333c1),
    SPH_C32(0xee1f5b50), SPH_C32(0xf5c6798f) },
  { SPH_C32(0xe5e80000), SPH_C32(0xdc4b2278), SPH_C32(0x144cfdab),
    SPH_C32(0x6f508f95), SPH_C32(0xd523000f), SPH_C32(0x1c1af3d1),
    SPH_C32(0x4011e055), SPH_C32(0x4062bfb4) },
  { SPH_C32(0x25a60001), SPH_C32(0xeff2e268), SPH_C32(0xba4246ae),
    SPH_C32(0xdaf449ae), SPH_C32(0x1dd2000f), SPH_C32(0x17371453),
    SPH_C32(0x2be7a8f1), SPH_C32(0x13fe020b) },
  { SPH_C32(0xa53a0002), SPH_C32(0x88816249), SPH_C32(0xe65f30a5),
    SPH_C32(0xb1b9c5db), SPH_C32(0x8c30000e), SPH_C32(0x016ddb57),
    SPH_C32(0xfc0b39b8), SPH_C32(0xb4c27976) },
  { SPH_C32(0x65740003), SPH_C32(0xbb38a259), SPH_C32(0x48518ba0),
    SPH_C32(0x041d03e0), SPH_C32(0x44c1000e), SPH_C32(0x0a403cd5),
    SPH_C32(0x97fd711c), SPH_C32(0xe75ec4c9) },
  { SPH_C32(0x6dcb0002), SPH_C32(0x83ac85cb), SPH_C32(0x8da97801),
    SPH_C32(0xe2257864), SPH_C32(0x848f000f), SPH_C32(0x39f9fcc5),
    SPH_C32(0x39f3ca19), SPH_C32(0x52fa02f2) },
  { SPH_C32(0xad850003), SPH_C32(0xb01545db), SPH_C32(0x23a7c304),
    SPH_C32(0x5781be5f), SPH_C32(0x4c7e000f), SPH_C32(0x32d41b47),
    SPH_C32(0x520582bd), SPH_C32(0x0166bf4d) },
  { SPH_C32(0xacbd0004), SPH_C32(0x7ef34599), SPH_C32(0x9b9d2f13),
    SPH_C32(0x811ea6b6), SPH_C32(0x6fba000c), SPH_C32(0x1e61854e),
    SPH_C32(0xfddca02f), SPH_C32(0x4f1b49b4) },
  { SPH_C32(0x6cf30005), SPH_C32(0x4d4a8589), SPH_C32(0x35939416),
    SPH_C32(0x34ba608d), SPH_C32(0xa74b000c), SPH_C32(0x154c62cc),
    SPH_C32(0x962ae88b), SPH_C32(0x1c87f40b) },
  { SPH_C32(0x644c0004), SPH_C32(0x75dea21b), SPH_C32(0xf06b67b7),
    SPH_C32(0xd2821b09), SPH_C32(0x6705000d), SPH_C32(0x26f5a2dc),
    SPH_C32(0x3824538e), SPH_C32(0xa9233230) },
  { SPH_C32(0xa4020005), SPH_C32(0x4667620b), SPH_C32(0x5e65dcb2),
    SPH_C32(0x6726dd32), SPH_C32(0xaff4000d), SPH_C32(0x2dd8455e),
    SPH_C32(0x53d21b2a), SPH_C32(0xfabf8f8f) },
  { SPH_C32(0x249e0006), SPH_C32(0x2114e22a), SPH_C32(0x0278aab9),
    SPH_C32(0x0c6b5147), SPH_C32(0x3e16000c), SPH_C32(0x3b828a5a),
    SPH_C32(0x843e8a63), SPH_C32(0x5d83f4f2) },
  { SPH_C32(0xe4d00007), SPH_C32(0x12ad223a), SPH_C32(0xac7611bc),
    SPH_C32(0xb9cf977c), SPH_C32(0xf6e7000c), SPH_C32(0x30af6dd8),
    SPH_C32(0xefc8c2c7), SPH_C32(0x0e1f494d) },
  { SPH_C32(0xec6f0006), SPH_C32(0x2a3905a8), SPH_C32(0x698ee21d),
    SPH_C32(0x5ff7ecf8), SPH_C32(0x36a9000d), SPH_C32(0x0316adc8),
    SPH_C32(0x41c679c2), SPH_C32(0xbbbb8f76) },
  { SPH_C32(0x2c210007), SPH_C32(0x1980c5b8), SPH_C32(0xc7805918),
    SPH_C32(0xea532ac3), SPH_C32(0xfe58000d), SPH_C32(0x083b4a4a),
    SPH_C32(0x2a303166), SPH_C32(0xe82732c9) },
  { SPH_C32(0xfd110004), SPH_C32(0x5b104a8d), SPH_C32(0xe27f055f),
    SPH_C32(0x93861bf0), SPH_C32(0xb635000e), SPH_C32(0x64652de9),
    SPH_C32(0x1ddb0fc9), SPH_C32(0xd0f60303) },
  { SPH_C32(0x3d5f0005), SPH_C32(0x68a98a9d), SPH_C32(0x4c71be5a),
    SPH_C32(0x2622ddcb), SPH_C32(0x7ec4000e), SPH_C32(0x6f48ca6b),
    SPH_C32(0x762d476d), SPH_C32(0x836abebc) },
  { SPH_C32(0x35e00004), SPH_C32(0x503dad0f), SPH_C32(0x89894dfb),
    SPH_C32(0xc01aa64f), SPH_C32(0xbe8a000f), SPH_C32(0x5cf10a7b),
    SPH_C32(0xd823fc68), SPH_C32(0x36ce7887) },
  { SPH_C32(0xf5ae0005), SPH_C32(0x63846d1f), SPH_C32(0x2787f6fe),
    SPH_C32(0x75be6074), SPH_C32(0x767b000f), SPH_C32(0x57dcedf9),
    SPH_C32(0xb3d5b4cc), SPH_C32(0x6552c538) },
  { SPH_C32(0x75320006), SPH_C32(0x04f7ed3e), SPH_C32(0x7b9a80f5),
    SPH_C32(0x1ef3ec01), SPH_C32(0xe799000e), SPH_C32(0x418622fd),
    SPH_C32(0x64392585), SPH_C32(0xc26ebe45) },
  { SPH_C32(0xb57c0007), SPH_C32(0x374e2d2e), SPH_C32(0xd5943bf0),
    SPH_C32(0xab572a3a), SPH_C32(0x2f68000e), SPH_C32(0x4aabc57f),
    SPH_C32(0x0fcf6d21), SPH_C32(0x91f203fa) },
  { SPH_C32(0xbdc30006), SPH_C32(0x0fda0abc), SPH_C32(0x106cc851),
    SPH_C32(0x4d6f51be), SPH_C32(0xef26000f), SPH_C32(0x7912056f),
    SPH_C32(0xa1c1d624), SPH_C32(0x2456c5c1) },
  { SPH_C32(0x7d8d0007), SPH_C32(0x3c63caac), SPH_C32(0xbe627354),
    SPH_C32(0xf8cb9785), SPH_C32(0x27d7000f), SPH_C32(0x723fe2ed),
    SPH_C32(0xca379e80), SPH_C32(0x77ca787e) },
  { SPH_C32(0xbfb20008), SPH_C32(0x92170a39), SPH_C32(0x6019107f),
    SPH_C32(0xe051606e), SPH_C32(0xa8ae0008), SPH_C32(0x2079397d),
    SPH_C32(0xfe739301), SPH_C32(0xb8a92831) },
  { SPH_C32(0x7ffc0009), SPH_C32(0xa1aeca29), SPH_C32(0xce17ab7a),
    SPH_C32(0x55f5a655), SPH_C32(0x605f0008), SPH_C32(0x2b54deff),
    SPH_C32(0x9585dba5), SPH_C32(0xeb35958e) },
  { SPH_C32(0x77430008), SPH_C32(0x993aedbb), SPH_C32(0x0bef58db),
    SPH_C32(0xb3cdddd1), SPH_C32(0xa0110009), SPH_C32(0x18ed1eef),
    SPH_C32(0x3b8b60a0), SPH_C32(0x5e9153b5) },
  { SPH_C32(0xb70d0009), SPH_C32(0xaa832dab), SPH_C32(0xa5e1e3de),
    SPH_C32(0x06691bea), SPH_C32(0x68e00009), SPH_C32(0x13c0f96d),
    SPH_C32(0x507d2804), SPH_C32(0x0d0dee0a) },
  { SPH_C32(0x3791000a), SPH_C32(0xcdf0ad8a), SPH_C32(0xf9fc95d5),
    SPH_C32(0x6d24979f), SPH_C32(0xf9020008), SPH_C32(0x059a3669),
    SPH_C32(0x8791b94d), SPH_C32(0xaa319577) },
  { SPH_C32(0xf7df000b), SPH_C32(0xfe496d9a), SPH_C32(0x57f22ed0),
    SPH_C32(0xd88051a4), SPH_C32(0x31f30008), SPH_C32(0x0eb7d1eb),
    SPH_C32(0xec67f1e9), SPH_C32(0xf9ad28c8) },
  { SPH_C32(0xff60000a), SPH_C32(0xc6dd4a08), SPH_C32(0x920add71),
    SPH_C32(0x3eb82a20), SPH_C32(0xf1bd0009), SPH_C32(0x3d0e11fb),
    SPH_C32(0x42694aec), SPH_C32(0x4c09eef3) },
  { SPH_C32(0x3f2e000b), SPH_C32(0xf5648a18), SPH_C32(0x3c046674),
    SPH_C32(0x8b1cec1b), SPH_C32(0x394c0009), SPH_C32(0x3623f679),
    SPH_C32(0x299f0248), SPH_C32(0x1f95534c) },
  { SPH_C32(0xee1e0008), SPH_C32(0xb7f4052d), SPH_C32(0x19fb3a33),
    SPH_C32(0xf2c9dd28), SPH_C32(0x7121000a), SPH_C32(0x5a7d91da),
    SPH_C32(0x1e743ce7), SPH_C32(0x27446286) },
  { SPH_C32(0x2e500009), SPH_C32(0x844dc53d), SPH_C32(0xb7f58136),
    SPH_C32(0x476d1b13), SPH_C32(0xb9d0000a), SPH_C32(0x51507658),
    SPH_C32(0x75827443), SPH_C32(0x74d8df39) },
  { SPH_C32(0x26ef0008), SPH_C32(0xbcd9e2af), SPH_C32(0x720d7297),
    SPH_C32(0xa1556097), SPH_C32(0x799e000b), SPH_C32(0x62e9b648),
    SPH_C32(0xdb8ccf46), SPH_C32(0xc17c1902) },
  { SPH_C32(0xe6a10009), SPH_C32(0x8f6022bf), SPH_C32(0xdc03c992),
    SPH_C32(0x14f1a6ac), SPH_C32(0xb16f000b), SPH_C32(0x69c451ca),
    SPH_C32(0xb07a87e2), SPH_C32(0x92e0a4bd) },
  { SPH_C32(0x663d000a), SPH_C32(0xe813a29e), SPH_C32(0x801ebf99),
    SPH_C32(0x7fbc2ad9), SPH_C32(0x208d000a), SPH_C32(0x7f9e9ece),
    SPH_C32(0x679616ab), SPH_C32(0x35dcdfc0) },
  { SPH_C32(0xa673000b), SPH_C32(0xdbaa628e), SPH_C32(0x2e10049c),
    SPH_C32(0xca18ece2), SPH_C32(0xe87c000a), SPH_C32(0x74b3794c),
    SPH_C32(0x0c605e0f), SPH_C32(0x6640627f) },
  { SPH_C32(0xaecc000a), SPH_C32(0xe33e451c), SPH_C32(0xebe8f73d),
    SPH_C32(0x2c209766), SPH_C32(0x2832000b), SPH_C32(0x470ab95c),
    SPH_C32(0xa26ee50a), SPH_C32(0xd3e4a444) },
  { SPH_C32(0x6e82000b), SPH_C32(0xd087850c), SPH_C32(0x45e64c38),
    SPH_C32(0x9984515d), SPH_C32(0xe0c3000b), SPH_C32(0x4c275ede),
    SPH_C32(0xc998adae), SPH_C32(0x807819fb) },
  { SPH_C32(0x6fba000c), SPH_C32(0x1e61854e), SPH_C32(0xfddca02f),
    SPH_C32(0x4f1b49b4), SPH_C32(0xc3070008), SPH_C32(0x6092c0d7),
    SPH_C32(0x66418f3c), SPH_C32(0xce05ef02) },
  { SPH_C32(0xaff4000d), SPH_C32(0x2dd8455e), SPH_C32(0x53d21b2a),
    SPH_C32(0xfabf8f8f), SPH_C32(0x0bf60008), SPH_C32(0x6bbf2755),
    SPH_C32(0x0db7c798), SPH_C32(0x9d9952bd) },
  { SPH_C32(0xa74b000c), SPH_C32(0x154c62cc), SPH_C32(0x962ae88b),
    SPH_C32(0x1c87f40b), SPH_C32(0xcbb80009), SPH_C32(0x5806e745),
    SPH_C32(0xa3b97c9d), SPH_C32(0x283d9486) },
  { SPH_C32(0x6705000d), SPH_C32(0x26f5a2dc), SPH_C32(0x3824538e),
    SPH_C32(0xa9233230), SPH_C32(0x03490009), SPH_C32(0x532b00c7),
    SPH_C32(0xc84f3439), SPH_C32(0x7ba12939) },
  { SPH_C32(0xe799000e), SPH_C32(0x418622fd), SPH_C32(0x64392585),
    SPH_C32(0xc26ebe45), SPH_C32(0x92ab0008), SPH_C32(0x4571cfc3),
    SPH_C32(0x1fa3a570), SPH_C32(0xdc9d5244) },
  { SPH_C32(0x27d7000f), SPH_C32(0x723fe2ed), SPH_C32(0xca379e80),
    SPH_C32(0x77ca787e), SPH_C32(0x5a5a0008), SPH_C32(0x4e5c2841),
    SPH_C32(0x7455edd4), SPH_C32(0x8f01effb) },
  { SPH_C32(0x2f68000e), SPH_C32(0x4aabc57f), SPH_C32(0x0fcf6d21),
    SPH_C32(0x91f203fa), SPH_C32(0x9a140009), SPH_C32(0x7de5e851),
    SPH_C32(0xda5b56d1), SPH_C32(0x3aa529c0) },
  { SPH_C32(0xef26000f), SPH_C32(0x7912056f), SPH_C32(0xa1c1d624),
    SPH_C32(0x2456c5c1), SPH_C32(0x52e50009), SPH_C32(0x76c80fd3),
    SPH_C32(0xb1ad1e75), SPH_C32(0x6939947f) },
  { SPH_C32(0x3e16000c), SPH_C32(0x3b828a5a), SPH_C32(0x843e8a63),
    SPH_C32(0x5d83f4f2), SPH_C32(0x1a88000a), SPH_C32(0x1a966870),
    SPH_C32(0x864620da), SPH_C32(0x51e8a5b5) },
  { SPH_C32(0xfe58000d), SPH_C32(0x083b4a4a), SPH_C32(0x2a303166),
    SPH_C32(0xe82732c9), SPH_C32(0xd279000a), SPH_C32(0x11bb8ff2),
    SPH_C32(0xedb0687e), SPH_C32(0x0274180a) },
  { SPH_C32(0xf6e7000c), SPH_C32(0x30af6dd8), SPH_C32(0xefc8c2c7),
    SPH_C32(0x0e1f494d), SPH_C32(0x1237000b), SPH_C32(0x22024fe2),
    SPH_C32(0x43bed37b), SPH_C32(0xb7d0de31) },
  { SPH_C32(0x36a9000d), SPH_C32(0x0316adc8), SPH_C32(0x41c679c2),
    SPH_C32(0xbbbb8f76), SPH_C32(0xdac6000b), SPH_C32(0x292fa860),
    SPH_C32(0x28489bdf), SPH_C32(0xe44c638e) },
  { SPH_C32(0xb635000e), SPH_C32(0x64652de9), SPH_C32(0x1ddb0fc9),
    SPH_C32(0xd0f60303), SPH_C32(0x4b24000a), SPH_C32(0x3f756764),
    SPH_C32(0xffa40a96), SPH_C32(0x437018f3) },
  { SPH_C32(0x767b000f), SPH_C32(0x57dcedf9), SPH_C32(0xb3d5b4cc),
    SPH_C32(0x6552c538), SPH_C32(0x83d5000a), SPH_C32(0x345880e6),
    SPH_C32(0x94524232), SPH_C32(0x10eca54c) },
  { SPH_C32(0x7ec4000e), SPH_C32(0x6f48ca6b), SPH_C32(0x762d476d),
    SPH_C32(0x836abebc), SPH_C32(0x439b000b), SPH_C32(0x07e140f6),
    SPH_C32(0x3a5cf937), SPH_C32(0xa5486377) },
  { SPH_C32(0xbe8a000f), SPH_C32(0x5cf10a7b), SPH_C32(0xd823fc68),
    SPH_C32(0x36ce7887), SPH_C32(0x8b6a000b), SPH_C32(0x0ccca774),
    SPH_C32(0x51aab193), SPH_C32(0xf6d4dec8) },
  { SPH_C32(0xd41b0008), SPH_C32(0xd2fcf393), SPH_C32(0xf82b0c42),
    SPH_C32(0x96fda75d), SPH_C32(0x130f000c), SPH_C32(0xece44fa0),
    SPH_C32(0xfb843f6c), SPH_C32(0x614fc6d8) },
  { SPH_C32(0x14550009), SPH_C32(0xe1453383), SPH_C32(0x5625b747),
    SPH_C32(0x23596166), SPH_C32(0xdbfe000c), SPH_C32(0xe7c9a822),
    SPH_C32(0x907277c8), SPH_C32(0x32d37b67) },
  { SPH_C32(0x1cea0008), SPH_C32(0xd9d11411), SPH_C32(0x93dd44e6),
    SPH_C32(0xc5611ae2), SPH_C32(0x1bb0000d), SPH_C32(0xd4706832),
    SPH_C32(0x3e7ccccd), SPH_C32(0x8777bd5c) },
  { SPH_C32(0xdca40009), SPH_C32(0xea68d401), SPH_C32(0x3dd3ffe3),
    SPH_C32(0x70c5dcd9), SPH_C32(0xd341000d), SPH_C32(0xdf5d8fb0),
    SPH_C32(0x558a8469), SPH_C32(0xd4eb00e3) },
  { SPH_C32(0x5c38000a), SPH_C32(0x8d1b5420), SPH_C32(0x61ce89e8),
    SPH_C32(0x1b8850ac), SPH_C32(0x42a3000c), SPH_C32(0xc90740b4),
    SPH_C32(0x82661520), SPH_C32(0x73d77b9e) },
  { SPH_C32(0x9c76000b), SPH_C32(0xbea29430), SPH_C32(0xcfc032ed),
    SPH_C32(0xae2c9697), SPH_C32(0x8a52000c), SPH_C32(0xc22aa736),
    SPH_C32(0xe9905d84), SPH_C32(0x204bc621) },
  { SPH_C32(0x94c9000a), SPH_C32(0x8636b3a2), SPH_C32(0x0a38c14c),
    SPH_C32(0x4814ed13), SPH_C32(0x4a1c000d), SPH_C32(0xf1936726),
    SPH_C32(0x479ee681), SPH_C32(0x95ef001a) },
  { SPH_C32(0x5487000b), SPH_C32(0xb58f73b2), SPH_C32(0xa4367a49),
    SPH_C32(0xfdb02b28), SPH_C32(0x82ed000d), SPH_C32(0xfabe80a4),
    SPH_C32(0x2c68ae25), SPH_C32(0xc673bda5) },
  { SPH_C32(0x85b70008), SPH_C32(0xf71ffc87), SPH_C32(0x81c9260e),
    SPH_C32(0x84651a1b), SPH_C32(0xca80000e), SPH_C32(0x96e0e707),
    SPH_C32(0x1b83908a), SPH_C32(0xfea28c6f) },
  { SPH_C32(0x45f90009), SPH_C32(0xc4a63c97), SPH_C32(0x2fc79d0b),
    SPH_C32(0x31c1dc20), SPH_C32(0x0271000e), SPH_C32(0x9dcd0085),
    SPH_C32(0x7075d82e), SPH_C32(0xad3e31d0) },
  { SPH_C32(0x4d460008), SPH_C32(0xfc321b05), SPH_C32(0xea3f6eaa),
    SPH_C32(0xd7f9a7a4), SPH_C32(0xc23f000f), SPH_C32(0xae74c095),
    SPH_C32(0xde7b632b), SPH_C32(0x189af7eb) },
  { SPH_C32(0x8d080009), SPH_C32(0xcf8bdb15), SPH_C32(0x4431d5af),
    SPH_C32(0x625d619f), SPH_C32(0x0ace000f), SPH_C32(0xa5592717),
    SPH_C32(0xb58d2b8f), SPH_C32(0x4b064a54) },
  { SPH_C32(0x0d94000a), SPH_C32(0xa8f85b34), SPH_C32(0x182ca3a4),
    SPH_C32(0x0910edea), SPH_C32(0x9b2c000e), SPH_C32(0xb303e813),
    SPH_C32(0x6261bac6), SPH_C32(0xec3a3129) },
  { SPH_C32(0xcdda000b), SPH_C32(0x9b419b24), SPH_C32(0xb62218a1),
    SPH_C32(0xbcb42bd1), SPH_C32(0x53dd000e), SPH_C32(0xb82e0f91),
    SPH_C32(0x0997f262), SPH_C32(0xbfa68c96) },
  { SPH_C32(0xc565000a), SPH_C32(0xa3d5bcb6), SPH_C32(0x73daeb00),
    SPH_C32(0x5a8c5055), SPH_C32(0x9393000f), SPH_C32(0x8b97cf81),
    SPH_C32(0xa7994967), SPH_C32(0x0a024aad) },
  { SPH_C32(0x052b000b), SPH_C32(0x906c7ca6), SPH_C32(0xddd45005),
    SPH_C32(0xef28966e), SPH_C32(0x5b62000f), SPH_C32(0x80ba2803),
    SPH_C32(0xcc6f01c3), SPH_C32(0x599ef712) },
  { SPH_C32(0x0413000c), SPH_C32(0x5e8a7ce4), SPH_C32(0x65eebc12),
    SPH_C32(0x39b78e87), SPH_C32(0x78a6000c), SPH_C32(0xac0fb60a),
    SPH_C32(0x63b62351), SPH_C32(0x17e301eb) },
  { SPH_C32(0xc45d000d), SPH_C32(0x6d33bcf4), SPH_C32(0xcbe00717),
    SPH_C32(0x8c1348bc), SPH_C32(0xb057000c), SPH_C32(0xa7225188),
    SPH_C32(0x08406bf5), SPH_C32(0x447fbc54) },
  { SPH_C32(0xcce2000c), SPH_C32(0x55a79b66), SPH_C32(0x0e18f4b6),
    SPH_C32(0x6a2b3338), SPH_C32(0x7019000d), SPH_C32(0x949b9198),
    SPH_C32(0xa64ed0f0), SPH_C32(0xf1db7a6f) },
  { SPH_C32(0x0cac000d), SPH_C32(0x661e5b76), SPH_C32(0xa0164fb3),
    SPH_C32(0xdf8ff503), SPH_C32(0xb8e8000d), SPH_C32(0x9fb6761a),
    SPH_C32(0xcdb89854), SPH_C32(0xa247c7d0) },
  { SPH_C32(0x8c30000e), SPH_C32(0x016ddb57), SPH_C32(0xfc0b39b8),
    SPH_C32(0xb4c27976), SPH_C32(0x290a000c), SPH_C32(0x89ecb91e),
    SPH_C32(0x1a54091d), SPH_C32(0x057bbcad) },
  { SPH_C32(0x4c7e000f), SPH_C32(0x32d41b47), SPH_C32(0x520582bd),
    SPH_C32(0x0166bf4d), SPH_C32(0xe1fb000c), SPH_C32(0x82c15e9c),
    SPH_C32(0x71a241b9), SPH_C32(0x56e70112) },
  { SPH_C32(0x44c1000e), SPH_C32(0x0a403cd5), SPH_C32(0x97fd711c),
    SPH_C32(0xe75ec4c9), SPH_C32(0x21b5000d), SPH_C32(0xb1789e8c),
    SPH_C32(0xdfacfabc), SPH_C32(0xe343c729) },
  { SPH_C32(0x848f000f), SPH_C32(0x39f9fcc5), SPH_C32(0x39f3ca19),
    SPH_C32(0x52fa02f2), SPH_C32(0xe944000d), SPH_C32(0xba55790e),
    SPH_C32(0xb45ab218), SPH_C32(0xb0df7a96) },
  { SPH_C32(0x55bf000c), SPH_C32(0x7b6973f0), SPH_C32(0x1c0c965e),
    SPH_C32(0x2b2f33c1), SPH_C32(0xa129000e), SPH_C32(0xd60b1ead),
    SPH_C32(0x83b18cb7), SPH_C32(0x880e4b5c) },
  { SPH_C32(0x95f1000d), SPH_C32(0x48d0b3e0), SPH_C32(0xb2022d5b),
    SPH_C32(0x9e8bf5fa), SPH_C32(0x69d8000e), SPH_C32(0xdd26f92f),
    SPH_C32(0xe847c413), SPH_C32(0xdb92f6e3) },
  { SPH_C32(0x9d4e000c), SPH_C32(0x70449472), SPH_C32(0x77fadefa),
    SPH_C32(0x78b38e7e), SPH_C32(0xa996000f), SPH_C32(0xee9f393f),
    SPH_C32(0x46497f16), SPH_C32(0x6e3630d8) },
  { SPH_C32(0x5d00000d), SPH_C32(0x43fd5462), SPH_C32(0xd9f465ff),
    SPH_C32(0xcd174845), SPH_C32(0x6167000f), SPH_C32(0xe5b2debd),
    SPH_C32(0x2dbf37b2), SPH_C32(0x3daa8d67) },
  { SPH_C32(0xdd9c000e), SPH_C32(0x248ed443), SPH_C32(0x85e913f4),
    SPH_C32(0xa65ac430), SPH_C32(0xf085000e), SPH_C32(0xf3e811b9),
    SPH_C32(0xfa53a6fb), SPH_C32(0x9a96f61a) },
  { SPH_C32(0x1dd2000f), SPH_C32(0x17371453), SPH_C32(0x2be7a8f1),
    SPH_C32(0x13fe020b), SPH_C32(0x3874000e), SPH_C32(0xf8c5f63b),
    SPH_C32(0x91a5ee5f), SPH_C32(0xc90a4ba5) },
  { SPH_C32(0x156d000e), SPH_C32(0x2fa333c1), SPH_C32(0xee1f5b50),
    SPH_C32(0xf5c6798f), SPH_C32(0xf83a000f), SPH_C32(0xcb7c362b),
    SPH_C32(0x3fab555a), SPH_C32(0x7cae8d9e) },
  { SPH_C32(0xd523000f), SPH_C32(0x1c1af3d1), SPH_C32(0x4011e055),
    SPH_C32(0x4062bfb4), SPH_C32(0x30cb000f), SPH_C32(0xc051d1a9),
    SPH_C32(0x545d1dfe), SPH_C32(0x2f323021) }
};

#define INPUT_SMALL   do { \
    unsigned acc = buf[0]; \
    const sph_u32 *rp; \
    rp = &T256_0[acc][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    acc = buf[1]; \
    rp = &T256_8[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[2]; \
    rp = &T256_16[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    acc = buf[3]; \
    rp = &T256_24[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 1

/* Note: this table lists bits within each byte from least
   siginificant to most significant. */
__constant static const sph_u32 T512[64][16] = {
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) }
};

#define INPUT_BIG   do { \
    __constant const sph_u32 *tp = &T512[0][0]; \
    unsigned u, v; \
    m0 = 0; \
    m1 = 0; \
    m2 = 0; \
    m3 = 0; \
    m4 = 0; \
    m5 = 0; \
    m6 = 0; \
    m7 = 0; \
    m8 = 0; \
    m9 = 0; \
    mA = 0; \
    mB = 0; \
    mC = 0; \
    mD = 0; \
    mE = 0; \
    mF = 0; \
    _Pragma("unroll") \
    for (u = 0; u < 8; u ++) { \
      unsigned db = buf(u); \
      for (v = 0; v < 8; v ++, db >>= 1) { \
        sph_u32 dm = SPH_T32(-(sph_u32)(db & 1)); \
        m0 ^= dm & *tp ++; \
        m1 ^= dm & *tp ++; \
        m2 ^= dm & *tp ++; \
        m3 ^= dm & *tp ++; \
        m4 ^= dm & *tp ++; \
        m5 ^= dm & *tp ++; \
        m6 ^= dm & *tp ++; \
        m7 ^= dm & *tp ++; \
        m8 ^= dm & *tp ++; \
        m9 ^= dm & *tp ++; \
        mA ^= dm & *tp ++; \
        mB ^= dm & *tp ++; \
        mC ^= dm & *tp ++; \
        mD ^= dm & *tp ++; \
        mE ^= dm & *tp ++; \
        mF ^= dm & *tp ++; \
      } \
    } \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 2

__constant static const sph_u32 T512_0[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0x6f299000), SPH_C32(0x6c850000), SPH_C32(0x2f160000),
    SPH_C32(0x782e0000), SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6),
    SPH_C32(0xd26a8c36), SPH_C32(0x32219526), SPH_C32(0x29449c00),
    SPH_C32(0x64e70000), SPH_C32(0xf24b0000), SPH_C32(0xc2f30000),
    SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745), SPH_C32(0xf3e04259),
    SPH_C32(0x8d0d9ec4) }
};

__constant static const sph_u32 T512_2[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0xc8934400), SPH_C32(0x5a3e0000), SPH_C32(0x57870000),
    SPH_C32(0x4c560000), SPH_C32(0xea982435), SPH_C32(0x75b11115),
    SPH_C32(0x28b67247), SPH_C32(0x2dd1f9ab), SPH_C32(0x54285c00),
    SPH_C32(0xeaed0000), SPH_C32(0xc5d60000), SPH_C32(0xa1c50000),
    SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1), SPH_C32(0x6bb0419d),
    SPH_C32(0x551b3782) }
};

__constant static const sph_u32 T512_4[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0x373d2800), SPH_C32(0x71500000), SPH_C32(0x95e00000),
    SPH_C32(0x0a140000), SPH_C32(0xbdac1909), SPH_C32(0x48ef9831),
    SPH_C32(0x456d6d1f), SPH_C32(0x3daac2da), SPH_C32(0x145a3c00),
    SPH_C32(0xb9e90000), SPH_C32(0x61270000), SPH_C32(0xf1610000),
    SPH_C32(0xce613d6c), SPH_C32(0xb0493d78), SPH_C32(0x47a96720),
    SPH_C32(0xe18e24c5) }
};

__constant static const sph_u32 T512_6[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0x26600240), SPH_C32(0xddd80000), SPH_C32(0x722a0000),
    SPH_C32(0x4f060000), SPH_C32(0x936667ff), SPH_C32(0x29f944ce),
    SPH_C32(0x368b63d5), SPH_C32(0x0c26f262), SPH_C32(0xef0b0270),
    SPH_C32(0x3afd0000), SPH_C32(0x5dae0000), SPH_C32(0x69490000),
    SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9), SPH_C32(0x66140a51),
    SPH_C32(0x924f5d0a) }
};

__constant static const sph_u32 T512_8[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0x5cb00110), SPH_C32(0x913e0000), SPH_C32(0x44190000),
    SPH_C32(0x888c0000), SPH_C32(0x66dc7418), SPH_C32(0x921f1d66),
    SPH_C32(0x55ceea25), SPH_C32(0x925c44e9), SPH_C32(0xe8870170),
    SPH_C32(0x9d720000), SPH_C32(0x12db0000), SPH_C32(0xd4220000),
    SPH_C32(0xf2886b27), SPH_C32(0xa921e543), SPH_C32(0x4ef8b518),
    SPH_C32(0x618813b1) }
};

__constant static const sph_u32 T512_10[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0x832800a0), SPH_C32(0x67420000), SPH_C32(0xe1170000),
    SPH_C32(0x370b0000), SPH_C32(0xcba30034), SPH_C32(0x3c34923c),
    SPH_C32(0x9767bdcc), SPH_C32(0x450360bf), SPH_C32(0x774400f0),
    SPH_C32(0xf15a0000), SPH_C32(0xf5b20000), SPH_C32(0x34140000),
    SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25), SPH_C32(0x0bc3cd1e),
    SPH_C32(0xcf3775cb) }
};

__constant static const sph_u32 T512_12[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0x231f0009), SPH_C32(0x42f40000), SPH_C32(0x66790000),
    SPH_C32(0x4ebb0000), SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6),
    SPH_C32(0xe2b1674a), SPH_C32(0x69505b3a), SPH_C32(0xf7750009),
    SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000), SPH_C32(0x04920000),
    SPH_C32(0x029519a9), SPH_C32(0xf8e836ba), SPH_C32(0x7a87f14e),
    SPH_C32(0x9e16981a) }
};

__constant static const sph_u32 T512_14[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0x50ff0004), SPH_C32(0x45744000), SPH_C32(0x3dfb0000),
    SPH_C32(0x19e60000), SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d),
    SPH_C32(0xe1a8cc96), SPH_C32(0x7b1bd6b9), SPH_C32(0xf6800005),
    SPH_C32(0x3443c000), SPH_C32(0x24070000), SPH_C32(0x8f3d0000),
    SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae), SPH_C32(0xcdc58b19),
    SPH_C32(0xd795ba31) }
};

__constant static const sph_u32 T512_16[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0x9b060002), SPH_C32(0x61468000), SPH_C32(0x221e0000),
    SPH_C32(0x1d740000), SPH_C32(0x36715d27), SPH_C32(0x30495c92),
    SPH_C32(0xf11336a7), SPH_C32(0xfe1cdc7f), SPH_C32(0x75c90003),
    SPH_C32(0x0e10c000), SPH_C32(0xd1200000), SPH_C32(0xbaea0000),
    SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757), SPH_C32(0xbb28761d),
    SPH_C32(0x00b72e2b) }
};

__constant static const sph_u32 T512_18[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0xa4c20000), SPH_C32(0xd9372400), SPH_C32(0x0a480000),
    SPH_C32(0x66610000), SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c),
    SPH_C32(0xa324df94), SPH_C32(0x2ba05a55), SPH_C32(0x75a40000),
    SPH_C32(0xc28b2700), SPH_C32(0x94a40000), SPH_C32(0x90f50000),
    SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae), SPH_C32(0x1767c483),
    SPH_C32(0xaedf667e) }
};

__constant static const sph_u32 T512_20[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0xfd250000), SPH_C32(0xb3c41100), SPH_C32(0xcef00000),
    SPH_C32(0xcef90000), SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493),
    SPH_C32(0x7098b0a6), SPH_C32(0x1af21fe1), SPH_C32(0x45180000),
    SPH_C32(0xa5b51700), SPH_C32(0xf96a0000), SPH_C32(0x3b480000),
    SPH_C32(0x1ecc142c), SPH_C32(0x231395d6), SPH_C32(0x16bca6b0),
    SPH_C32(0xdf33f4df) }
};

__constant static const sph_u32 T512_22[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0xf2500000), SPH_C32(0xeebd0a00), SPH_C32(0x67a80000),
    SPH_C32(0xab8a0000), SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74),
    SPH_C32(0xdb73e86e), SPH_C32(0x1568ff0f), SPH_C32(0x0c720000),
    SPH_C32(0x49e50f00), SPH_C32(0x42790000), SPH_C32(0x5cea0000),
    SPH_C32(0x33aa301a), SPH_C32(0x15822514), SPH_C32(0x95a34b7b),
    SPH_C32(0xb44b0090) }
};

__constant static const sph_u32 T512_24[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0xaf220000), SPH_C32(0x7b6c0090), SPH_C32(0x67e20000),
    SPH_C32(0x8da20000), SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3),
    SPH_C32(0x9ac484f4), SPH_C32(0x8b6c72bd), SPH_C32(0x69510000),
    SPH_C32(0xd4e1009c), SPH_C32(0xc3230000), SPH_C32(0xac2f0000),
    SPH_C32(0xe4950bae), SPH_C32(0xcea415dc), SPH_C32(0x87ec287c),
    SPH_C32(0xbce1a3ce) }
};

__constant static const sph_u32 T512_26[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0xe8dd0000), SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000),
    SPH_C32(0xbb150000), SPH_C32(0x80bd361b), SPH_C32(0x24e81d44),
    SPH_C32(0xbfa8c2f4), SPH_C32(0x524a0d59), SPH_C32(0x54500000),
    SPH_C32(0x0671005c), SPH_C32(0x25ae0000), SPH_C32(0x6a1e0000),
    SPH_C32(0x2ea54edf), SPH_C32(0x664e8512), SPH_C32(0xbfba18c3),
    SPH_C32(0x7e715d17) }
};

__constant static const sph_u32 T512_28[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0xf75a0000), SPH_C32(0x19840028), SPH_C32(0xa2190000),
    SPH_C32(0xeef80000), SPH_C32(0xc0722516), SPH_C32(0x19981260),
    SPH_C32(0x73dba1e6), SPH_C32(0xe1844257), SPH_C32(0x14190000),
    SPH_C32(0x23ca003c), SPH_C32(0x50df0000), SPH_C32(0x44b60000),
    SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75), SPH_C32(0x61e610b0),
    SPH_C32(0xdbcadb80) }
};

__constant static const sph_u32 T512_30[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0xb6ce0000), SPH_C32(0xdae90002), SPH_C32(0x156e8000),
    SPH_C32(0xda920000), SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a),
    SPH_C32(0xf272e8ae), SPH_C32(0xa6b8c28d), SPH_C32(0x86790000),
    SPH_C32(0x3f390002), SPH_C32(0xe19ae000), SPH_C32(0x98560000),
    SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea), SPH_C32(0xd3dd4944),
    SPH_C32(0x161ddab9) }
};

__constant static const sph_u32 T512_32[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0x75e60000), SPH_C32(0x95660001), SPH_C32(0x307b2000),
    SPH_C32(0xadf40000), SPH_C32(0x8f321eea), SPH_C32(0x24298307),
    SPH_C32(0xe8c49cf9), SPH_C32(0x4b7eec55), SPH_C32(0xaec30000),
    SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000), SPH_C32(0x2c150000),
    SPH_C32(0x45cc75b3), SPH_C32(0x6650b736), SPH_C32(0xab92f78f),
    SPH_C32(0xa312567b) }
};

__constant static const sph_u32 T512_34[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xb2060000), SPH_C32(0xc5690000), SPH_C32(0x28031200),
    SPH_C32(0x74670000), SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8),
    SPH_C32(0x33d1dfec), SPH_C32(0x094e3198), SPH_C32(0xac480000),
    SPH_C32(0x1ba60000), SPH_C32(0x45fb1380), SPH_C32(0x03430000),
    SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6), SPH_C32(0xfe72c7fe),
    SPH_C32(0x91e478f6) }
};

__constant static const sph_u32 T512_36[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0x7a8c0000), SPH_C32(0xa5d40000), SPH_C32(0x13260880),
    SPH_C32(0xc63d0000), SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43),
    SPH_C32(0x59d0b4f8), SPH_C32(0x979961d0), SPH_C32(0x78230000),
    SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80), SPH_C32(0x90a50000),
    SPH_C32(0x713e2879), SPH_C32(0x7ee98924), SPH_C32(0xf08ca062),
    SPH_C32(0x636f8bab) }
};

__constant static const sph_u32 T512_38[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0x4d8a0000), SPH_C32(0x49340000), SPH_C32(0x3c8b0500),
    SPH_C32(0xaea30000), SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4),
    SPH_C32(0x8f19eaec), SPH_C32(0x443d3004), SPH_C32(0xcc140000),
    SPH_C32(0xa5630000), SPH_C32(0x5ab90780), SPH_C32(0x3b500000),
    SPH_C32(0x4bd013ff), SPH_C32(0x879b3418), SPH_C32(0x694348c1),
    SPH_C32(0xca5a87fe) }
};

__constant static const sph_u32 T512_40[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0x01dd0000), SPH_C32(0x80a80000), SPH_C32(0xf4960048),
    SPH_C32(0xa6000000), SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37),
    SPH_C32(0x6612cffd), SPH_C32(0x2c94459e), SPH_C32(0x52500000),
    SPH_C32(0x29540000), SPH_C32(0x6a61004e), SPH_C32(0xf0ff0000),
    SPH_C32(0x9a317eec), SPH_C32(0x452341ce), SPH_C32(0xcf568fe5),
    SPH_C32(0x5303130f) }
};

__constant static const sph_u32 T512_42[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x835a0000), SPH_C32(0xc4f70000), SPH_C32(0x01470022),
    SPH_C32(0xeec80000), SPH_C32(0x60a54f69), SPH_C32(0x142f2a24),
    SPH_C32(0x5cf534f2), SPH_C32(0x3ea660f7), SPH_C32(0x88980000),
    SPH_C32(0x1f940000), SPH_C32(0x7fcf002e), SPH_C32(0xfb4e0000),
    SPH_C32(0xf158079a), SPH_C32(0x61ae9167), SPH_C32(0xa895706c),
    SPH_C32(0xe6107494) }
};

__constant static const sph_u32 T512_44[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0xa2d60000), SPH_C32(0xa6760000), SPH_C32(0xc9440014),
    SPH_C32(0xeba30000), SPH_C32(0xccec2e7b), SPH_C32(0x3018c499),
    SPH_C32(0x03490afa), SPH_C32(0x9b6ef888), SPH_C32(0xa53b0000),
    SPH_C32(0x14260000), SPH_C32(0x4e30001e), SPH_C32(0x7cae0000),
    SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d), SPH_C32(0xf73168d8),
    SPH_C32(0x0b1b4946) }
};

__constant static const sph_u32 T512_46[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0x45190000), SPH_C32(0xab0c0000), SPH_C32(0x30be0001),
    SPH_C32(0x690a2000), SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d),
    SPH_C32(0x2dd1fa46), SPH_C32(0x24314f17), SPH_C32(0x58430000),
    SPH_C32(0x807e0000), SPH_C32(0x78330001), SPH_C32(0xc66b3800),
    SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd), SPH_C32(0xac73fe6f),
    SPH_C32(0x3a4479b1) }
};

__constant static const sph_u32 T512_48[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x8c3a0000), SPH_C32(0xda980000), SPH_C32(0x607f0000),
    SPH_C32(0x54078800), SPH_C32(0x85714513), SPH_C32(0x6006b243),
    SPH_C32(0xdb50399c), SPH_C32(0x8a58e6a4), SPH_C32(0x1e6c0000),
    SPH_C32(0xc4420000), SPH_C32(0x8a2e0000), SPH_C32(0xbcb6b800),
    SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da), SPH_C32(0x6a0c1bc8),
    SPH_C32(0xb99dc2eb) }
};

__constant static const sph_u32 T512_50[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0xb82f0000), SPH_C32(0xb12c0000), SPH_C32(0x30d80000),
    SPH_C32(0x14445000), SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec),
    SPH_C32(0x2e98bf23), SPH_C32(0x551e3d6e), SPH_C32(0x02f20000),
    SPH_C32(0xa2810000), SPH_C32(0x873f0000), SPH_C32(0xe36c7800),
    SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6), SPH_C32(0xc4c23237),
    SPH_C32(0x7f32259e) }
};

__constant static const sph_u32 T512_52[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x57370000), SPH_C32(0xcaf20000), SPH_C32(0x364e0000),
    SPH_C32(0xc0220480), SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c),
    SPH_C32(0xa1937f8f), SPH_C32(0x15b961e7), SPH_C32(0xb4310000),
    SPH_C32(0x77330000), SPH_C32(0xb15d0000), SPH_C32(0x7fd004e0),
    SPH_C32(0x78a26138), SPH_C32(0xd116c35d), SPH_C32(0xd256d489),
    SPH_C32(0x4e6f74de) }
};

__constant static const sph_u32 T512_54[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0x16ed0000), SPH_C32(0x15680000), SPH_C32(0xedd70000),
    SPH_C32(0x325d0220), SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643),
    SPH_C32(0xe375f8a8), SPH_C32(0x81fdf908), SPH_C32(0xe6280000),
    SPH_C32(0x4c4b0000), SPH_C32(0xa8550000), SPH_C32(0xd3d002e0),
    SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da), SPH_C32(0x289506b4),
    SPH_C32(0xd75a4897) }
};

__constant static const sph_u32 T512_56[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) },
  { SPH_C32(0x95bb0000), SPH_C32(0x81450000), SPH_C32(0x3b240000),
    SPH_C32(0x48db0140), SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec),
    SPH_C32(0x62c91877), SPH_C32(0xe7e00a94), SPH_C32(0xee930000),
    SPH_C32(0xd6070000), SPH_C32(0x92c10000), SPH_C32(0x2b9801e0),
    SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57), SPH_C32(0x45312374),
    SPH_C32(0x201f6a64) }
};

__constant static const sph_u32 T512_58[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0x5fec0000), SPH_C32(0x294b0000), SPH_C32(0x99d20000),
    SPH_C32(0x4ed00012), SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9),
    SPH_C32(0x57140bdf), SPH_C32(0x30aebcf7), SPH_C32(0x5fa80000),
    SPH_C32(0x56030000), SPH_C32(0x43ae0000), SPH_C32(0x64f30013),
    SPH_C32(0x257e86bf), SPH_C32(0x1311944e), SPH_C32(0x541e95bf),
    SPH_C32(0x8ea4db69) }
};

__constant static const sph_u32 T512_60[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x93bb0000), SPH_C32(0x3b070000), SPH_C32(0xba010000),
    SPH_C32(0x99d00008), SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722),
    SPH_C32(0x96f896b3), SPH_C32(0x2879ebac), SPH_C32(0x01930000),
    SPH_C32(0xe7820000), SPH_C32(0xedfb0000), SPH_C32(0xcf0c000b),
    SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e), SPH_C32(0x063661e1),
    SPH_C32(0x536f9e7b) }
};

__constant static const sph_u32 T512_62[4][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0xabe70000), SPH_C32(0x9e0d0000), SPH_C32(0xaf270000),
    SPH_C32(0x3d180005), SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695),
    SPH_C32(0xb5c347eb), SPH_C32(0x3c5dfffe), SPH_C32(0x033d0000),
    SPH_C32(0x08b30000), SPH_C32(0xf33a0000), SPH_C32(0x3ac20007),
    SPH_C32(0x51298a50), SPH_C32(0x6b6e661f), SPH_C32(0x0ea5cfe3),
    SPH_C32(0xe6da7ffe) }
};

#define INPUT_BIG   do { \
    unsigned acc = buf(0); \
    __constant const sph_u32 *rp; \
    rp = &T512_0[acc >> 6][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    m8 = rp[8]; \
    m9 = rp[9]; \
    mA = rp[10]; \
    mB = rp[11]; \
    mC = rp[12]; \
    mD = rp[13]; \
    mE = rp[14]; \
    mF = rp[15]; \
    rp = &T512_2[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_4[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_6[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(1); \
    rp = &T512_8[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_10[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_12[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_14[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(2); \
    rp = &T512_16[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_18[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_20[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_22[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(3); \
    rp = &T512_24[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_26[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_28[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_30[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(4); \
    rp = &T512_32[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_34[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_36[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_38[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(5); \
    rp = &T512_40[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_42[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_44[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_46[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(6); \
    rp = &T512_48[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_50[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_52[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_54[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(7); \
    rp = &T512_56[acc >> 6][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_58[(acc >> 4) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_60[(acc >> 2) & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_62[acc & 0x03][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 3

__constant static const sph_u32 T512_0[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0xb5ff8400), SPH_C32(0xd4340000), SPH_C32(0x601a0000),
    SPH_C32(0x2f600000), SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1),
    SPH_C32(0xb0e67183), SPH_C32(0xf5c750ed), SPH_C32(0x8efe4800),
    SPH_C32(0x525c0000), SPH_C32(0x8ada0000), SPH_C32(0xf68b0000),
    SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86), SPH_C32(0x093cbc28),
    SPH_C32(0x92fdf249) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0xdad61400), SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000),
    SPH_C32(0x574e0000), SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67),
    SPH_C32(0x628cfdb5), SPH_C32(0xc7e6c5cb), SPH_C32(0xa7bad400),
    SPH_C32(0x36bb0000), SPH_C32(0x78910000), SPH_C32(0x34780000),
    SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3), SPH_C32(0xfadcfe71),
    SPH_C32(0x1ff06c8d) },
  { SPH_C32(0x6f299000), SPH_C32(0x6c850000), SPH_C32(0x2f160000),
    SPH_C32(0x782e0000), SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6),
    SPH_C32(0xd26a8c36), SPH_C32(0x32219526), SPH_C32(0x29449c00),
    SPH_C32(0x64e70000), SPH_C32(0xf24b0000), SPH_C32(0xc2f30000),
    SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745), SPH_C32(0xf3e04259),
    SPH_C32(0x8d0d9ec4) },
  { SPH_C32(0xf3928800), SPH_C32(0xdc560000), SPH_C32(0xbd470000),
    SPH_C32(0x95bd0000), SPH_C32(0x3d767488), SPH_C32(0xf3c9c922),
    SPH_C32(0x916cbfec), SPH_C32(0x4aeb5b0f), SPH_C32(0xe1d7d800),
    SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000), SPH_C32(0x8ea50000),
    SPH_C32(0xe4466aba), SPH_C32(0x23732650), SPH_C32(0xdb56301e),
    SPH_C32(0xa0dc676f) }
};

__constant static const sph_u32 T512_3[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0x373d2800), SPH_C32(0x71500000), SPH_C32(0x95e00000),
    SPH_C32(0x0a140000), SPH_C32(0xbdac1909), SPH_C32(0x48ef9831),
    SPH_C32(0x456d6d1f), SPH_C32(0x3daac2da), SPH_C32(0x145a3c00),
    SPH_C32(0xb9e90000), SPH_C32(0x61270000), SPH_C32(0xf1610000),
    SPH_C32(0xce613d6c), SPH_C32(0xb0493d78), SPH_C32(0x47a96720),
    SPH_C32(0xe18e24c5) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0x40726000), SPH_C32(0x53040000), SPH_C32(0xa4f10000),
    SPH_C32(0x50a40000), SPH_C32(0x7dc35a1c), SPH_C32(0x24ecf999),
    SPH_C32(0x2c1926bd), SPH_C32(0xb4951347), SPH_C32(0xbfdc0c00),
    SPH_C32(0x786a0000), SPH_C32(0x66960000), SPH_C32(0x16e60000),
    SPH_C32(0x2af76720), SPH_C32(0x19b270bd), SPH_C32(0x41c239e5),
    SPH_C32(0xa4ee2836) },
  { SPH_C32(0x774f4800), SPH_C32(0x22540000), SPH_C32(0x31110000),
    SPH_C32(0x5ab00000), SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8),
    SPH_C32(0x69744ba2), SPH_C32(0x893fd19d), SPH_C32(0xab863000),
    SPH_C32(0xc1830000), SPH_C32(0x07b10000), SPH_C32(0xe7870000),
    SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5), SPH_C32(0x066b5ec5),
    SPH_C32(0x45600cf3) },
  { SPH_C32(0x63157400), SPH_C32(0x9bbd0000), SPH_C32(0x50360000),
    SPH_C32(0xabd10000), SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0),
    SPH_C32(0x2edd2c82), SPH_C32(0x68b1f558), SPH_C32(0x88e12400),
    SPH_C32(0x093a0000), SPH_C32(0xf3760000), SPH_C32(0x1cf20000),
    SPH_C32(0x975b7e29), SPH_C32(0x515de88c), SPH_C32(0x04af54fa),
    SPH_C32(0x9944eaec) }
};

__constant static const sph_u32 T512_6[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0x5b3c0210), SPH_C32(0x36b10000), SPH_C32(0x0b6c0000),
    SPH_C32(0x35e70000), SPH_C32(0x0f5b2339), SPH_C32(0x7f3b4ddc),
    SPH_C32(0x7d22556c), SPH_C32(0x619b0a52), SPH_C32(0x95db0120),
    SPH_C32(0x761b0000), SPH_C32(0x6b9d0000), SPH_C32(0xaec30000),
    SPH_C32(0x6eb52fe1), SPH_C32(0xffe3ec51), SPH_C32(0x055183a1),
    SPH_C32(0x0c35eb81) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0x7d5c0050), SPH_C32(0xeb690000), SPH_C32(0x79460000),
    SPH_C32(0x7ae10000), SPH_C32(0x9c3d44c6), SPH_C32(0x56c20912),
    SPH_C32(0x4ba936b9), SPH_C32(0x6dbdf830), SPH_C32(0x7ad00350),
    SPH_C32(0x4ce60000), SPH_C32(0x36330000), SPH_C32(0xc78a0000),
    SPH_C32(0xf5ba13e7), SPH_C32(0xbbe659a8), SPH_C32(0x634589f0),
    SPH_C32(0x9e7ab68b) },
  { SPH_C32(0x26600240), SPH_C32(0xddd80000), SPH_C32(0x722a0000),
    SPH_C32(0x4f060000), SPH_C32(0x936667ff), SPH_C32(0x29f944ce),
    SPH_C32(0x368b63d5), SPH_C32(0x0c26f262), SPH_C32(0xef0b0270),
    SPH_C32(0x3afd0000), SPH_C32(0x5dae0000), SPH_C32(0x69490000),
    SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9), SPH_C32(0x66140a51),
    SPH_C32(0x924f5d0a) },
  { SPH_C32(0x92570220), SPH_C32(0xd1940000), SPH_C32(0x24e80000),
    SPH_C32(0x13a80000), SPH_C32(0x073278c0), SPH_C32(0x12c7bceb),
    SPH_C32(0x2dbd3ce8), SPH_C32(0xfff2a53a), SPH_C32(0xb3bb0360),
    SPH_C32(0xabc30000), SPH_C32(0x19b70000), SPH_C32(0xe1c50000),
    SPH_C32(0xfdd3481e), SPH_C32(0xd61aa89f), SPH_C32(0x33dae074),
    SPH_C32(0x001319e3) }
};

__constant static const sph_u32 T512_9[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0x832800a0), SPH_C32(0x67420000), SPH_C32(0xe1170000),
    SPH_C32(0x370b0000), SPH_C32(0xcba30034), SPH_C32(0x3c34923c),
    SPH_C32(0x9767bdcc), SPH_C32(0x450360bf), SPH_C32(0x774400f0),
    SPH_C32(0xf15a0000), SPH_C32(0xf5b20000), SPH_C32(0x34140000),
    SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25), SPH_C32(0x0bc3cd1e),
    SPH_C32(0xcf3775cb) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0x9fc30180), SPH_C32(0x6c280000), SPH_C32(0xe7690000),
    SPH_C32(0xe0360000), SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966),
    SPH_C32(0x453b7806), SPH_C32(0xaebf667a), SPH_C32(0x405b0030),
    SPH_C32(0x9a540000), SPH_C32(0x42670000), SPH_C32(0x5fb10000),
    SPH_C32(0xd6c06187), SPH_C32(0x5d81863c), SPH_C32(0x87922fef),
    SPH_C32(0x79e0422c) },
  { SPH_C32(0x1ceb0120), SPH_C32(0x0b6a0000), SPH_C32(0x067e0000),
    SPH_C32(0xd73d0000), SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a),
    SPH_C32(0xd25cc5ca), SPH_C32(0xebbc06c5), SPH_C32(0x371f00c0),
    SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000), SPH_C32(0x6ba50000),
    SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19), SPH_C32(0x8c51e2f1),
    SPH_C32(0xb6d737e7) },
  { SPH_C32(0x6baf01d0), SPH_C32(0xfa300000), SPH_C32(0xf3cc0000),
    SPH_C32(0xe3290000), SPH_C32(0x392b6b13), SPH_C32(0x9515777f),
    SPH_C32(0xd99f08d4), SPH_C32(0x248b730e), SPH_C32(0xc3730090),
    SPH_C32(0xfd160000), SPH_C32(0xa3700000), SPH_C32(0x68ba0000),
    SPH_C32(0x1d6361b3), SPH_C32(0x61b51400), SPH_C32(0x10f59223),
    SPH_C32(0x3ce32293) }
};

__constant static const sph_u32 T512_12[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0x510a0008), SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000),
    SPH_C32(0x92490000), SPH_C32(0x381e7454), SPH_C32(0x13229849),
    SPH_C32(0x56eab6c1), SPH_C32(0x3298f492), SPH_C32(0x84950004),
    SPH_C32(0xc8bc8000), SPH_C32(0x98540000), SPH_C32(0x53cf0000),
    SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31), SPH_C32(0x799e5a92),
    SPH_C32(0x8c5d1599) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0x72150001), SPH_C32(0xfcff4000), SPH_C32(0xbc530000),
    SPH_C32(0xdcf20000), SPH_C32(0xc6c52f87), SPH_C32(0x227e289f),
    SPH_C32(0xb45bd18b), SPH_C32(0x5bc8afa8), SPH_C32(0x73e0000d),
    SPH_C32(0x07804000), SPH_C32(0x5b820000), SPH_C32(0x575d0000),
    SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b), SPH_C32(0x0319abdc),
    SPH_C32(0x124b8d83) },
  { SPH_C32(0x231f0009), SPH_C32(0x42f40000), SPH_C32(0x66790000),
    SPH_C32(0x4ebb0000), SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6),
    SPH_C32(0xe2b1674a), SPH_C32(0x69505b3a), SPH_C32(0xf7750009),
    SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000), SPH_C32(0x04920000),
    SPH_C32(0x029519a9), SPH_C32(0xf8e836ba), SPH_C32(0x7a87f14e),
    SPH_C32(0x9e16981a) },
  { SPH_C32(0x85600008), SPH_C32(0x33c38000), SPH_C32(0x7f850000),
    SPH_C32(0xd8600000), SPH_C32(0xc450362e), SPH_C32(0xda961e25),
    SPH_C32(0xcedc20c5), SPH_C32(0xc5de37b2), SPH_C32(0xa78a000d),
    SPH_C32(0x8a488000), SPH_C32(0xfe2d0000), SPH_C32(0x1d740000),
    SPH_C32(0x19294faf), SPH_C32(0x199a4de7), SPH_C32(0x9b2f3dd8),
    SPH_C32(0xe50d4ea3) }
};

__constant static const sph_u32 T512_15[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0x9b060002), SPH_C32(0x61468000), SPH_C32(0x221e0000),
    SPH_C32(0x1d740000), SPH_C32(0x36715d27), SPH_C32(0x30495c92),
    SPH_C32(0xf11336a7), SPH_C32(0xfe1cdc7f), SPH_C32(0x75c90003),
    SPH_C32(0x0e10c000), SPH_C32(0xd1200000), SPH_C32(0xbaea0000),
    SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757), SPH_C32(0xbb28761d),
    SPH_C32(0x00b72e2b) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0x83490006), SPH_C32(0x3a530000), SPH_C32(0xf5270000),
    SPH_C32(0x35d70000), SPH_C32(0xaaf314c5), SPH_C32(0x8de062f9),
    SPH_C32(0x76edfd04), SPH_C32(0xd722941a), SPH_C32(0x48b00000),
    SPH_C32(0x1e61c000), SPH_C32(0xeac20000), SPH_C32(0x31450000),
    SPH_C32(0x873e1fe4), SPH_C32(0x5cdb4536), SPH_C32(0x66560735),
    SPH_C32(0x52259edc) },
  { SPH_C32(0x184f0004), SPH_C32(0x5b158000), SPH_C32(0xd7390000),
    SPH_C32(0x28a30000), SPH_C32(0x9c8249e2), SPH_C32(0xbda93e6b),
    SPH_C32(0x87fecba3), SPH_C32(0x293e4865), SPH_C32(0x3d790003),
    SPH_C32(0x10710000), SPH_C32(0x3be20000), SPH_C32(0x8baf0000),
    SPH_C32(0x0cfa30da), SPH_C32(0xdb83f261), SPH_C32(0xdd7e7128),
    SPH_C32(0x5292b0f7) },
  { SPH_C32(0x6d860007), SPH_C32(0x55054000), SPH_C32(0x06190000),
    SPH_C32(0x92490000), SPH_C32(0x174666dc), SPH_C32(0x3af1893c),
    SPH_C32(0x3cd6bdbe), SPH_C32(0x2989664e), SPH_C32(0xd3b60002),
    SPH_C32(0x7f274000), SPH_C32(0xc8dc0000), SPH_C32(0x2c310000),
    SPH_C32(0xb14f42c3), SPH_C32(0x6c9219a4), SPH_C32(0x97453192),
    SPH_C32(0xac3942a3) }
};

__constant static const sph_u32 T512_18[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0xcd990000), SPH_C32(0xd4fa2100), SPH_C32(0xa33e0000),
    SPH_C32(0x65440000), SPH_C32(0xd9f9364c), SPH_C32(0xe786faeb),
    SPH_C32(0x7143d295), SPH_C32(0x6b1e8d40), SPH_C32(0x2c430000),
    SPH_C32(0xa8781200), SPH_C32(0x501c0000), SPH_C32(0x386d0000),
    SPH_C32(0x3f4f30a7), SPH_C32(0x422b9861), SPH_C32(0xc4dbabb1),
    SPH_C32(0x9f8d23ca) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0x695b0000), SPH_C32(0x0dcd0500), SPH_C32(0xa9760000),
    SPH_C32(0x03250000), SPH_C32(0x2183248b), SPH_C32(0x61380db7),
    SPH_C32(0xd2670d01), SPH_C32(0x40bed715), SPH_C32(0x59e70000),
    SPH_C32(0x6af33500), SPH_C32(0xc4b80000), SPH_C32(0xa8980000),
    SPH_C32(0xc4376747), SPH_C32(0x0be593cf), SPH_C32(0xd3bc6f32),
    SPH_C32(0x315245b4) },
  { SPH_C32(0xa4c20000), SPH_C32(0xd9372400), SPH_C32(0x0a480000),
    SPH_C32(0x66610000), SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c),
    SPH_C32(0xa324df94), SPH_C32(0x2ba05a55), SPH_C32(0x75a40000),
    SPH_C32(0xc28b2700), SPH_C32(0x94a40000), SPH_C32(0x90f50000),
    SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae), SPH_C32(0x1767c483),
    SPH_C32(0xaedf667e) },
  { SPH_C32(0x1cff0000), SPH_C32(0xcf462200), SPH_C32(0x3dd20000),
    SPH_C32(0x93d00000), SPH_C32(0xdafb736b), SPH_C32(0x28f60619),
    SPH_C32(0xc500c982), SPH_C32(0xee61b16b), SPH_C32(0x88810000),
    SPH_C32(0x714f3600), SPH_C32(0x5a540000), SPH_C32(0x5e0c0000),
    SPH_C32(0xc7352260), SPH_C32(0xc4956f3d), SPH_C32(0x67ff7425),
    SPH_C32(0xb42d799f) }
};

__constant static const sph_u32 T512_21[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0xf2500000), SPH_C32(0xeebd0a00), SPH_C32(0x67a80000),
    SPH_C32(0xab8a0000), SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74),
    SPH_C32(0xdb73e86e), SPH_C32(0x1568ff0f), SPH_C32(0x0c720000),
    SPH_C32(0x49e50f00), SPH_C32(0x42790000), SPH_C32(0x5cea0000),
    SPH_C32(0x33aa301a), SPH_C32(0x15822514), SPH_C32(0x95a34b7b),
    SPH_C32(0xb44b0090) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0x496a0000), SPH_C32(0xec501800), SPH_C32(0xbb130000),
    SPH_C32(0x67a20000), SPH_C32(0x2d662436), SPH_C32(0x3691b0c2),
    SPH_C32(0x831fedcb), SPH_C32(0x6b78f44f), SPH_C32(0x461f0000),
    SPH_C32(0xb1290300), SPH_C32(0x124b0000), SPH_C32(0x02d10000),
    SPH_C32(0xabb01976), SPH_C32(0xb19c0925), SPH_C32(0x28f4b503),
    SPH_C32(0x64e214a1) },
  { SPH_C32(0xbb3a0000), SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000),
    SPH_C32(0xcc280000), SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6),
    SPH_C32(0x586c05a5), SPH_C32(0x7e100b40), SPH_C32(0x4a6d0000),
    SPH_C32(0xf8cc0c00), SPH_C32(0x50320000), SPH_C32(0x5e3b0000),
    SPH_C32(0x981a296c), SPH_C32(0xa41e2c31), SPH_C32(0xbd57fe78),
    SPH_C32(0xd0a91431) },
  { SPH_C32(0xb7480000), SPH_C32(0x4b081d00), SPH_C32(0x9ec20000),
    SPH_C32(0x90c20000), SPH_C32(0xa4575cec), SPH_C32(0x294548a2),
    SPH_C32(0xcdcf4ede), SPH_C32(0xca5b0bd0), SPH_C32(0xb44f0000),
    SPH_C32(0x5f940900), SPH_C32(0x75e30000), SPH_C32(0xa95b0000),
    SPH_C32(0x112b51b6), SPH_C32(0xbbcad451), SPH_C32(0xf3875d6d),
    SPH_C32(0x718aebae) }
};

__constant static const sph_u32 T512_24[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0xd5dc0000), SPH_C32(0x28da0084), SPH_C32(0xdaa00000),
    SPH_C32(0x7d240000), SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a),
    SPH_C32(0x87fef24b), SPH_C32(0x90daf380), SPH_C32(0x2eae0000),
    SPH_C32(0x55c70048), SPH_C32(0x98ec0000), SPH_C32(0x9a980000),
    SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b), SPH_C32(0xa2806e7c),
    SPH_C32(0x65c7dc2a) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0x7afe0000), SPH_C32(0x53b60014), SPH_C32(0xbd420000),
    SPH_C32(0xf0860000), SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979),
    SPH_C32(0x1d3a76bf), SPH_C32(0x1bb6813d), SPH_C32(0x47ff0000),
    SPH_C32(0x812600d4), SPH_C32(0x5bcf0000), SPH_C32(0x36b70000),
    SPH_C32(0x47392832), SPH_C32(0x935f59b7), SPH_C32(0x256c4600),
    SPH_C32(0xd9267fe4) },
  { SPH_C32(0xaf220000), SPH_C32(0x7b6c0090), SPH_C32(0x67e20000),
    SPH_C32(0x8da20000), SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3),
    SPH_C32(0x9ac484f4), SPH_C32(0x8b6c72bd), SPH_C32(0x69510000),
    SPH_C32(0xd4e1009c), SPH_C32(0xc3230000), SPH_C32(0xac2f0000),
    SPH_C32(0xe4950bae), SPH_C32(0xcea415dc), SPH_C32(0x87ec287c),
    SPH_C32(0xbce1a3ce) },
  { SPH_C32(0x13af0000), SPH_C32(0x87570088), SPH_C32(0x7e610000),
    SPH_C32(0x5ca90000), SPH_C32(0x699c66ed), SPH_C32(0xf511dca5),
    SPH_C32(0x9ad65ec3), SPH_C32(0xa75722f3), SPH_C32(0x818c0000),
    SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000), SPH_C32(0x173a0000),
    SPH_C32(0x64283db5), SPH_C32(0xea4c0898), SPH_C32(0x3844ea88),
    SPH_C32(0xeeabae97) }
};

__constant static const sph_u32 T512_27[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0xf75a0000), SPH_C32(0x19840028), SPH_C32(0xa2190000),
    SPH_C32(0xeef80000), SPH_C32(0xc0722516), SPH_C32(0x19981260),
    SPH_C32(0x73dba1e6), SPH_C32(0xe1844257), SPH_C32(0x14190000),
    SPH_C32(0x23ca003c), SPH_C32(0x50df0000), SPH_C32(0x44b60000),
    SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75), SPH_C32(0x61e610b0),
    SPH_C32(0xdbcadb80) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0x40490000), SPH_C32(0x25bb0060), SPH_C32(0x75710000),
    SPH_C32(0x2ea80000), SPH_C32(0x35c9296f), SPH_C32(0x5abd2967),
    SPH_C32(0xde5c0873), SPH_C32(0xa5bb8697), SPH_C32(0x5fce0000),
    SPH_C32(0xc675000c), SPH_C32(0xeb450000), SPH_C32(0x7b450000),
    SPH_C32(0x75063a62), SPH_C32(0x67cd2643), SPH_C32(0x122f6b61),
    SPH_C32(0x1675c999) },
  { SPH_C32(0xb7130000), SPH_C32(0x3c3f0048), SPH_C32(0xd7680000),
    SPH_C32(0xc0500000), SPH_C32(0xf5bb0c79), SPH_C32(0x43253b07),
    SPH_C32(0xad87a995), SPH_C32(0x443fc4c0), SPH_C32(0x4bd70000),
    SPH_C32(0xe5bf0030), SPH_C32(0xbb9a0000), SPH_C32(0x3ff30000),
    SPH_C32(0x6e6a5dd2), SPH_C32(0x5b3e8a36), SPH_C32(0x73c97bd1),
    SPH_C32(0xcdbf1219) },
  { SPH_C32(0xa30a0000), SPH_C32(0x1ff50074), SPH_C32(0x87b70000),
    SPH_C32(0x84e60000), SPH_C32(0xeed76bc9), SPH_C32(0x7fd69772),
    SPH_C32(0xcc61b925), SPH_C32(0x9ff51f40), SPH_C32(0xa8940000),
    SPH_C32(0xdff10024), SPH_C32(0x495c0000), SPH_C32(0x95bd0000),
    SPH_C32(0xb5741f74), SPH_C32(0x7e553423), SPH_C32(0x61f4ca87),
    SPH_C32(0xf7f18bce) }
};

__constant static const sph_u32 T512_30[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x5d5c0000), SPH_C32(0x36100002), SPH_C32(0xa8302000),
    SPH_C32(0x19b70000), SPH_C32(0x5f9b0c57), SPH_C32(0x0cf1fcdb),
    SPH_C32(0x908b2232), SPH_C32(0xfe716097), SPH_C32(0x45510000),
    SPH_C32(0x70b60001), SPH_C32(0xc48f4000), SPH_C32(0xef300000),
    SPH_C32(0xec8a2380), SPH_C32(0x5c931767), SPH_C32(0xc96b3d13),
    SPH_C32(0xfbdbf461) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0xeb920000), SPH_C32(0xecf90000), SPH_C32(0xbd5ea000),
    SPH_C32(0xc3250000), SPH_C32(0xa9465633), SPH_C32(0x3ac3a051),
    SPH_C32(0x62f9ca9c), SPH_C32(0x58c9a21a), SPH_C32(0xc3280000),
    SPH_C32(0x4f8f0003), SPH_C32(0x2515a000), SPH_C32(0x77660000),
    SPH_C32(0x79ef448e), SPH_C32(0x121bdf8d), SPH_C32(0x1ab67457),
    SPH_C32(0xedc62ed8) },
  { SPH_C32(0xb6ce0000), SPH_C32(0xdae90002), SPH_C32(0x156e8000),
    SPH_C32(0xda920000), SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a),
    SPH_C32(0xf272e8ae), SPH_C32(0xa6b8c28d), SPH_C32(0x86790000),
    SPH_C32(0x3f390002), SPH_C32(0xe19ae000), SPH_C32(0x98560000),
    SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea), SPH_C32(0xd3dd4944),
    SPH_C32(0x161ddab9) },
  { SPH_C32(0x6deb0000), SPH_C32(0xd3c00002), SPH_C32(0x5cc44000),
    SPH_C32(0x5b730000), SPH_C32(0x3c23313d), SPH_C32(0x744b68bb),
    SPH_C32(0xb12483d8), SPH_C32(0x4ed478a3), SPH_C32(0xf39f0000),
    SPH_C32(0xaa5f0003), SPH_C32(0xd1e1c000), SPH_C32(0x35a20000),
    SPH_C32(0x1a5779e4), SPH_C32(0x6aa14bed), SPH_C32(0x3b19d5bd),
    SPH_C32(0x5d6336ec) }
};

__constant static const sph_u32 T512_33[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xb2060000), SPH_C32(0xc5690000), SPH_C32(0x28031200),
    SPH_C32(0x74670000), SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8),
    SPH_C32(0x33d1dfec), SPH_C32(0x094e3198), SPH_C32(0xac480000),
    SPH_C32(0x1ba60000), SPH_C32(0x45fb1380), SPH_C32(0x03430000),
    SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6), SPH_C32(0xfe72c7fe),
    SPH_C32(0x91e478f6) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0x028b0000), SPH_C32(0x87e90001), SPH_C32(0x3c2af380),
    SPH_C32(0x2f560000), SPH_C32(0x1f4944d9), SPH_C32(0x79e2e780),
    SPH_C32(0x55e03071), SPH_C32(0x32f62e8d), SPH_C32(0xc56b0000),
    SPH_C32(0xd7e60000), SPH_C32(0x2452c180), SPH_C32(0xf6c50000),
    SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f), SPH_C32(0x8ef57364),
    SPH_C32(0x70c6f340) },
  { SPH_C32(0xb08d0000), SPH_C32(0x42800001), SPH_C32(0x1429e180),
    SPH_C32(0x5b310000), SPH_C32(0xa98b722d), SPH_C32(0x92f0de78),
    SPH_C32(0x6631ef9d), SPH_C32(0x3bb81f15), SPH_C32(0x69230000),
    SPH_C32(0xcc400000), SPH_C32(0x61a9d200), SPH_C32(0xf5860000),
    SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9), SPH_C32(0x7087b49a),
    SPH_C32(0xe1228bb6) },
  { SPH_C32(0x1cc50000), SPH_C32(0x59260001), SPH_C32(0x51d2f200),
    SPH_C32(0x58720000), SPH_C32(0xf30e4347), SPH_C32(0x8d428ece),
    SPH_C32(0x98432863), SPH_C32(0xaa5c67e3), SPH_C32(0x776d0000),
    SPH_C32(0x128f0000), SPH_C32(0x0c51d380), SPH_C32(0x82a20000),
    SPH_C32(0x907b5a33), SPH_C32(0x5dcb6487), SPH_C32(0xbd24ac88),
    SPH_C32(0x7988c2d8) }
};

__constant static const sph_u32 T512_36[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0xf9bd0000), SPH_C32(0xfeab0000), SPH_C32(0xcf080900),
    SPH_C32(0x05560000), SPH_C32(0x2c97007b), SPH_C32(0x361db598),
    SPH_C32(0x16d6024f), SPH_C32(0xed083c51), SPH_C32(0x4f250000),
    SPH_C32(0xfe1c0000), SPH_C32(0x86970600), SPH_C32(0xf83b0000),
    SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3), SPH_C32(0x2645fe76),
    SPH_C32(0xb0cbda7f) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0x83310000), SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180),
    SPH_C32(0xc36b0000), SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb),
    SPH_C32(0x4f06b6b7), SPH_C32(0x7a915d81), SPH_C32(0x37060000),
    SPH_C32(0xece00000), SPH_C32(0x2fad0d80), SPH_C32(0x689e0000),
    SPH_C32(0xddca5657), SPH_C32(0x31ce47e7), SPH_C32(0xd6c95e14),
    SPH_C32(0xd3a451d4) },
  { SPH_C32(0x7a8c0000), SPH_C32(0xa5d40000), SPH_C32(0x13260880),
    SPH_C32(0xc63d0000), SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43),
    SPH_C32(0x59d0b4f8), SPH_C32(0x979961d0), SPH_C32(0x78230000),
    SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80), SPH_C32(0x90a50000),
    SPH_C32(0x713e2879), SPH_C32(0x7ee98924), SPH_C32(0xf08ca062),
    SPH_C32(0x636f8bab) },
  { SPH_C32(0xfb120000), SPH_C32(0x49830000), SPH_C32(0x75140a00),
    SPH_C32(0x53ce0000), SPH_C32(0x961a45a8), SPH_C32(0xb65573ff),
    SPH_C32(0xbf8a16d5), SPH_C32(0x19fed62a), SPH_C32(0x35a90000),
    SPH_C32(0x5bc80000), SPH_C32(0x95b10e80), SPH_C32(0x3e060000),
    SPH_C32(0x67471384), SPH_C32(0xb1868180), SPH_C32(0x7f954a8e),
    SPH_C32(0x2752bbaf) }
};

__constant static const sph_u32 T512_39[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0x01dd0000), SPH_C32(0x80a80000), SPH_C32(0xf4960048),
    SPH_C32(0xa6000000), SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37),
    SPH_C32(0x6612cffd), SPH_C32(0x2c94459e), SPH_C32(0x52500000),
    SPH_C32(0x29540000), SPH_C32(0x6a61004e), SPH_C32(0xf0ff0000),
    SPH_C32(0x9a317eec), SPH_C32(0x452341ce), SPH_C32(0xcf568fe5),
    SPH_C32(0x5303130f) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x9e440000), SPH_C32(0x8c370000), SPH_C32(0x30d807ce),
    SPH_C32(0xcbaf0000), SPH_C32(0xd1e16d13), SPH_C32(0xc2b875d6),
    SPH_C32(0xa615c724), SPH_C32(0x995994f1), SPH_C32(0xd2130000),
    SPH_C32(0x45ab0000), SPH_C32(0xf8c50286), SPH_C32(0xc30c0000),
    SPH_C32(0x574d284c), SPH_C32(0xda31f145), SPH_C32(0x4f1ee235),
    SPH_C32(0xf1f0e16b) },
  { SPH_C32(0x9f990000), SPH_C32(0x0c9f0000), SPH_C32(0xc44e0786),
    SPH_C32(0x6daf0000), SPH_C32(0x413413b1), SPH_C32(0x155ef9e1),
    SPH_C32(0xc00708d9), SPH_C32(0xb5cdd16f), SPH_C32(0x80430000),
    SPH_C32(0x6cff0000), SPH_C32(0x92a402c8), SPH_C32(0x33f30000),
    SPH_C32(0xcd7c56a0), SPH_C32(0x9f12b08b), SPH_C32(0x80486dd0),
    SPH_C32(0xa2f3f264) },
  { SPH_C32(0xcdc90000), SPH_C32(0x25cb0000), SPH_C32(0xae2f07c8),
    SPH_C32(0x9d500000), SPH_C32(0xdb056d5d), SPH_C32(0x507db82f),
    SPH_C32(0x0f51873c), SPH_C32(0xe6cec260), SPH_C32(0xd3ce0000),
    SPH_C32(0xc5030000), SPH_C32(0x0c5302ce), SPH_C32(0x650c0000),
    SPH_C32(0xc79856ee), SPH_C32(0x0dd77d72), SPH_C32(0x290c2dc8),
    SPH_C32(0xdd64a4f5) }
};

__constant static const sph_u32 T512_42[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0x8f750000), SPH_C32(0xadc40000), SPH_C32(0xf8bb0024),
    SPH_C32(0x6c430000), SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3),
    SPH_C32(0x5ced124e), SPH_C32(0x7665c55a), SPH_C32(0xa9140000),
    SPH_C32(0x7d150000), SPH_C32(0xb7cc0018), SPH_C32(0xfe250000),
    SPH_C32(0x5d116688), SPH_C32(0x45997fda), SPH_C32(0xf7294e64),
    SPH_C32(0x43d8eceb) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x0c2f0000), SPH_C32(0x69330000), SPH_C32(0xf9fc0006),
    SPH_C32(0x828b0000), SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7),
    SPH_C32(0x001826bc), SPH_C32(0x48c3a5ad), SPH_C32(0x218c0000),
    SPH_C32(0x62810000), SPH_C32(0xc8030036), SPH_C32(0x056b0000),
    SPH_C32(0xac496112), SPH_C32(0x2437eebd), SPH_C32(0x5fbc3e08),
    SPH_C32(0xa5c8987f) },
  { SPH_C32(0x835a0000), SPH_C32(0xc4f70000), SPH_C32(0x01470022),
    SPH_C32(0xeec80000), SPH_C32(0x60a54f69), SPH_C32(0x142f2a24),
    SPH_C32(0x5cf534f2), SPH_C32(0x3ea660f7), SPH_C32(0x88980000),
    SPH_C32(0x1f940000), SPH_C32(0x7fcf002e), SPH_C32(0xfb4e0000),
    SPH_C32(0xf158079a), SPH_C32(0x61ae9167), SPH_C32(0xa895706c),
    SPH_C32(0xe6107494) },
  { SPH_C32(0x84b70000), SPH_C32(0x76a70000), SPH_C32(0x86330028),
    SPH_C32(0x79c50000), SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480),
    SPH_C32(0xa88d56d0), SPH_C32(0xaed3d139), SPH_C32(0x2a4e0000),
    SPH_C32(0xb9e20000), SPH_C32(0xb68b003a), SPH_C32(0x10ed0000),
    SPH_C32(0x3db429e1), SPH_C32(0x51b655fe), SPH_C32(0xabdc7a96),
    SPH_C32(0x7d7e8c1c) }
};

__constant static const sph_u32 T512_45[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0x45190000), SPH_C32(0xab0c0000), SPH_C32(0x30be0001),
    SPH_C32(0x690a2000), SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d),
    SPH_C32(0x2dd1fa46), SPH_C32(0x24314f17), SPH_C32(0x58430000),
    SPH_C32(0x807e0000), SPH_C32(0x78330001), SPH_C32(0xc66b3800),
    SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd), SPH_C32(0xac73fe6f),
    SPH_C32(0x3a4479b1) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0xfd780000), SPH_C32(0x94580000), SPH_C32(0x3603001f),
    SPH_C32(0xbac53800), SPH_C32(0x68a95109), SPH_C32(0x017295e0),
    SPH_C32(0x5b4296b7), SPH_C32(0x315f30f7), SPH_C32(0x1ab70000),
    SPH_C32(0x99220000), SPH_C32(0xcff9000a), SPH_C32(0x386c1800),
    SPH_C32(0x66b90d6b), SPH_C32(0x80bed174), SPH_C32(0x75da660b),
    SPH_C32(0x8e008768) },
  { SPH_C32(0xb8610000), SPH_C32(0x3f540000), SPH_C32(0x06bd001e),
    SPH_C32(0xd3cf1800), SPH_C32(0xaa552310), SPH_C32(0xb0a615ed),
    SPH_C32(0x76936cf1), SPH_C32(0x156e7fe0), SPH_C32(0x42f40000),
    SPH_C32(0x195c0000), SPH_C32(0xb7ca000b), SPH_C32(0xfe072000),
    SPH_C32(0x818e51b7), SPH_C32(0xf913eea9), SPH_C32(0xd9a99864),
    SPH_C32(0xb444fed9) },
  { SPH_C32(0xe0220000), SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f),
    SPH_C32(0x15a42000), SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30),
    SPH_C32(0xdae0929e), SPH_C32(0x2f2a0651), SPH_C32(0x5fae0000),
    SPH_C32(0x322e0000), SPH_C32(0xff47000b), SPH_C32(0x51663800),
    SPH_C32(0xa4457f72), SPH_C32(0x316a5179), SPH_C32(0x580b9c4d),
    SPH_C32(0xaa31c87f) }
};

__constant static const sph_u32 T512_48[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0xa4b10000), SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000),
    SPH_C32(0x4b9e9000), SPH_C32(0xf30107fb), SPH_C32(0xbde710e0),
    SPH_C32(0x805696dc), SPH_C32(0x93b1da1b), SPH_C32(0x2a790000),
    SPH_C32(0xaff60000), SPH_C32(0xda890000), SPH_C32(0xfcf56000),
    SPH_C32(0x686d3607), SPH_C32(0xdadc8975), SPH_C32(0x9fc49d77),
    SPH_C32(0x66db1921) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x288b0000), SPH_C32(0x0d770000), SPH_C32(0x5db60000),
    SPH_C32(0x1f991800), SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3),
    SPH_C32(0x5b06af40), SPH_C32(0x19e93cbf), SPH_C32(0x34150000),
    SPH_C32(0x6bb40000), SPH_C32(0x50a70000), SPH_C32(0x4043d800),
    SPH_C32(0x442925b1), SPH_C32(0x51215aaf), SPH_C32(0xf5c886bf),
    SPH_C32(0xdf46dbca) },
  { SPH_C32(0x8c3a0000), SPH_C32(0xda980000), SPH_C32(0x607f0000),
    SPH_C32(0x54078800), SPH_C32(0x85714513), SPH_C32(0x6006b243),
    SPH_C32(0xdb50399c), SPH_C32(0x8a58e6a4), SPH_C32(0x1e6c0000),
    SPH_C32(0xc4420000), SPH_C32(0x8a2e0000), SPH_C32(0xbcb6b800),
    SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da), SPH_C32(0x6a0c1bc8),
    SPH_C32(0xb99dc2eb) },
  { SPH_C32(0x36e70000), SPH_C32(0xc9350000), SPH_C32(0xd7980000),
    SPH_C32(0xa32fa000), SPH_C32(0x5a34515e), SPH_C32(0x561c7179),
    SPH_C32(0x310ab488), SPH_C32(0xa074fe54), SPH_C32(0xa6430000),
    SPH_C32(0x756e0000), SPH_C32(0xbaf60000), SPH_C32(0xa8f2e800),
    SPH_C32(0xed1c7314), SPH_C32(0xbada3b36), SPH_C32(0x4494a4eb),
    SPH_C32(0xec83ff85) }
};

__constant static const sph_u32 T512_51[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x57370000), SPH_C32(0xcaf20000), SPH_C32(0x364e0000),
    SPH_C32(0xc0220480), SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c),
    SPH_C32(0xa1937f8f), SPH_C32(0x15b961e7), SPH_C32(0xb4310000),
    SPH_C32(0x77330000), SPH_C32(0xb15d0000), SPH_C32(0x7fd004e0),
    SPH_C32(0x78a26138), SPH_C32(0xd116c35d), SPH_C32(0xd256d489),
    SPH_C32(0x4e6f74de) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xb6c30000), SPH_C32(0xd5b20000), SPH_C32(0x36620000),
    SPH_C32(0x9cbc7ce0), SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b),
    SPH_C32(0x1694e6be), SPH_C32(0x315d5140), SPH_C32(0x59db0000),
    SPH_C32(0xae6c0000), SPH_C32(0x30f40000), SPH_C32(0x48da2860),
    SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b), SPH_C32(0x999f2612),
    SPH_C32(0x71fa0dc9) },
  { SPH_C32(0xe1f40000), SPH_C32(0x1f400000), SPH_C32(0x002c0000),
    SPH_C32(0x5c9e7860), SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87),
    SPH_C32(0xb7079931), SPH_C32(0x24e430a7), SPH_C32(0xedea0000),
    SPH_C32(0xd95f0000), SPH_C32(0x81a90000), SPH_C32(0x370a2c80),
    SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736), SPH_C32(0x4bc9f29b),
    SPH_C32(0x3f957917) },
  { SPH_C32(0x55c50000), SPH_C32(0x68730000), SPH_C32(0xb1710000),
    SPH_C32(0x234e7c80), SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda),
    SPH_C32(0x65514db8), SPH_C32(0x6a8b4479), SPH_C32(0x0eec0000),
    SPH_C32(0x649e0000), SPH_C32(0x06ba0000), SPH_C32(0x88f82ce0),
    SPH_C32(0xa7e77575), SPH_C32(0xe70c0067), SPH_C32(0x380c599d),
    SPH_C32(0x64436c2e) }
};

__constant static const sph_u32 T512_54[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0x9d000000), SPH_C32(0x1b090000), SPH_C32(0x01b00000),
    SPH_C32(0xb0930240), SPH_C32(0x46ba7497), SPH_C32(0xf53e2561),
    SPH_C32(0x0f6d3db7), SPH_C32(0x10a52867), SPH_C32(0x657e0000),
    SPH_C32(0xd8660000), SPH_C32(0x7ea60000), SPH_C32(0xa9560180),
    SPH_C32(0x31e76a62), SPH_C32(0x94183875), SPH_C32(0xa929e66b),
    SPH_C32(0xb147bb0b) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0x8bed0000), SPH_C32(0x0e610000), SPH_C32(0xec670000),
    SPH_C32(0x82ce0060), SPH_C32(0xa5b6421e), SPH_C32(0xaf74c322),
    SPH_C32(0xec18c51f), SPH_C32(0x9158d16f), SPH_C32(0x83560000),
    SPH_C32(0x942d0000), SPH_C32(0xd6f30000), SPH_C32(0x7a860360),
    SPH_C32(0xe9865ada), SPH_C32(0x0cbf88af), SPH_C32(0x81bce0df),
    SPH_C32(0x661df39c) },
  { SPH_C32(0x16ed0000), SPH_C32(0x15680000), SPH_C32(0xedd70000),
    SPH_C32(0x325d0220), SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643),
    SPH_C32(0xe375f8a8), SPH_C32(0x81fdf908), SPH_C32(0xe6280000),
    SPH_C32(0x4c4b0000), SPH_C32(0xa8550000), SPH_C32(0xd3d002e0),
    SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da), SPH_C32(0x289506b4),
    SPH_C32(0xd75a4897) },
  { SPH_C32(0x6dc50000), SPH_C32(0x422a0000), SPH_C32(0x44320000),
    SPH_C32(0x511e0280), SPH_C32(0x7dd772a6), SPH_C32(0x37d373f8),
    SPH_C32(0xc48dc3ab), SPH_C32(0x460299f8), SPH_C32(0x73930000),
    SPH_C32(0xcd0e0000), SPH_C32(0x93710000), SPH_C32(0x9b0b03a0),
    SPH_C32(0xd2eb5ceb), SPH_C32(0xce52de36), SPH_C32(0x4a5c1ec3),
    SPH_C32(0x30ba4203) }
};

__constant static const sph_u32 T512_57[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0x5fec0000), SPH_C32(0x294b0000), SPH_C32(0x99d20000),
    SPH_C32(0x4ed00012), SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9),
    SPH_C32(0x57140bdf), SPH_C32(0x30aebcf7), SPH_C32(0x5fa80000),
    SPH_C32(0x56030000), SPH_C32(0x43ae0000), SPH_C32(0x64f30013),
    SPH_C32(0x257e86bf), SPH_C32(0x1311944e), SPH_C32(0x541e95bf),
    SPH_C32(0x8ea4db69) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0xb13b0000), SPH_C32(0x80040000), SPH_C32(0xd16f0000),
    SPH_C32(0x4f6b01f3), SPH_C32(0xb12faec3), SPH_C32(0x287d6f19),
    SPH_C32(0x112fb6cb), SPH_C32(0xaebbb10d), SPH_C32(0x7b6c0000),
    SPH_C32(0x280a0000), SPH_C32(0x73990000), SPH_C32(0x496000a1),
    SPH_C32(0xa5768de3), SPH_C32(0xc42f093c), SPH_C32(0x24f2a563),
    SPH_C32(0x79f5076e) },
  { SPH_C32(0xeed70000), SPH_C32(0xa94f0000), SPH_C32(0x48bd0000),
    SPH_C32(0x01bb01e1), SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0),
    SPH_C32(0x463bbd14), SPH_C32(0x9e150dfa), SPH_C32(0x24c40000),
    SPH_C32(0x7e090000), SPH_C32(0x30370000), SPH_C32(0x2d9300b2),
    SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72), SPH_C32(0x70ec30dc),
    SPH_C32(0xf751dc07) },
  { SPH_C32(0xb17f0000), SPH_C32(0xff4c0000), SPH_C32(0x0b130000),
    SPH_C32(0x654801f2), SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e),
    SPH_C32(0x122528ab), SPH_C32(0x10b1d693), SPH_C32(0x24800000),
    SPH_C32(0x01410000), SPH_C32(0xea4b0000), SPH_C32(0x07b000b3),
    SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5), SPH_C32(0x73e6aebc),
    SPH_C32(0x495bbb99) }
};

__constant static const sph_u32 T512_60[8][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0xa9490000), SPH_C32(0x713c0000), SPH_C32(0xb1e60000),
    SPH_C32(0xc8d60009), SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4),
    SPH_C32(0xbd50e9e9), SPH_C32(0x89e81e7b), SPH_C32(0x39cf0000),
    SPH_C32(0x42880000), SPH_C32(0xf8dd0000), SPH_C32(0x6bc40006),
    SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599), SPH_C32(0x250db0b9),
    SPH_C32(0x474b8a29) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x3af20000), SPH_C32(0x4a3b0000), SPH_C32(0x0be70000),
    SPH_C32(0x51060001), SPH_C32(0xc78fb695), SPH_C32(0x4577d386),
    SPH_C32(0x2ba87f5a), SPH_C32(0xa191f5d7), SPH_C32(0x385c0000),
    SPH_C32(0xa50a0000), SPH_C32(0x15260000), SPH_C32(0xa4c8000d),
    SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7), SPH_C32(0x233bd158),
    SPH_C32(0x14241452) },
  { SPH_C32(0x93bb0000), SPH_C32(0x3b070000), SPH_C32(0xba010000),
    SPH_C32(0x99d00008), SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722),
    SPH_C32(0x96f896b3), SPH_C32(0x2879ebac), SPH_C32(0x01930000),
    SPH_C32(0xe7820000), SPH_C32(0xedfb0000), SPH_C32(0xcf0c000b),
    SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e), SPH_C32(0x063661e1),
    SPH_C32(0x536f9e7b) },
  { SPH_C32(0x3b610000), SPH_C32(0xadb90000), SPH_C32(0xe61c0000),
    SPH_C32(0x9e0a000a), SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8),
    SPH_C32(0x2d9e1ebb), SPH_C32(0xf2fe6bac), SPH_C32(0xaa740000),
    SPH_C32(0x798f0000), SPH_C32(0x42dc0000), SPH_C32(0xf214000e),
    SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb), SPH_C32(0xb3f5260a),
    SPH_C32(0x6f326185) }
};

__constant static const sph_u32 T512_63[2][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) }
};

#define INPUT_BIG   do { \
    unsigned acc = buf(0); \
    __constant const sph_u32 *rp; \
    rp = &T512_0[acc >> 5][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    m8 = rp[8]; \
    m9 = rp[9]; \
    mA = rp[10]; \
    mB = rp[11]; \
    mC = rp[12]; \
    mD = rp[13]; \
    mE = rp[14]; \
    mF = rp[15]; \
    rp = &T512_3[(acc >> 2) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(1); \
    rp = &T512_6[(acc >> 7) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_9[(acc >> 4) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_12[(acc >> 1) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(2); \
    rp = &T512_15[(acc >> 6) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_18[(acc >> 3) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_21[acc & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(3); \
    rp = &T512_24[acc >> 5][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_27[(acc >> 2) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(4); \
    rp = &T512_30[(acc >> 7) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_33[(acc >> 4) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_36[(acc >> 1) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(5); \
    rp = &T512_39[(acc >> 6) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_42[(acc >> 3) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_45[acc & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(6); \
    rp = &T512_48[acc >> 5][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_51[(acc >> 2) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(7); \
    rp = &T512_54[(acc >> 7) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_57[(acc >> 4) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_60[(acc >> 1) & 0x07][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_63[acc & 0x01][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 4

__constant static const sph_u32 T512_0[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0xc8934400), SPH_C32(0x5a3e0000), SPH_C32(0x57870000),
    SPH_C32(0x4c560000), SPH_C32(0xea982435), SPH_C32(0x75b11115),
    SPH_C32(0x28b67247), SPH_C32(0x2dd1f9ab), SPH_C32(0x54285c00),
    SPH_C32(0xeaed0000), SPH_C32(0xc5d60000), SPH_C32(0xa1c50000),
    SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1), SPH_C32(0x6bb0419d),
    SPH_C32(0x551b3782) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0x7d6cc000), SPH_C32(0x8e0a0000), SPH_C32(0x379d0000),
    SPH_C32(0x63360000), SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4),
    SPH_C32(0x985003c4), SPH_C32(0xd816a946), SPH_C32(0xdad61400),
    SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000), SPH_C32(0x574e0000),
    SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67), SPH_C32(0x628cfdb5),
    SPH_C32(0xc7e6c5cb) },
  { SPH_C32(0xb5ff8400), SPH_C32(0xd4340000), SPH_C32(0x601a0000),
    SPH_C32(0x2f600000), SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1),
    SPH_C32(0xb0e67183), SPH_C32(0xf5c750ed), SPH_C32(0x8efe4800),
    SPH_C32(0x525c0000), SPH_C32(0x8ada0000), SPH_C32(0xf68b0000),
    SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86), SPH_C32(0x093cbc28),
    SPH_C32(0x92fdf249) },
  { SPH_C32(0xe1d7d800), SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000),
    SPH_C32(0x8ea50000), SPH_C32(0xe4466aba), SPH_C32(0x23732650),
    SPH_C32(0xdb56301e), SPH_C32(0xa0dc676f), SPH_C32(0x12455000),
    SPH_C32(0xe28f0000), SPH_C32(0x188b0000), SPH_C32(0x1b180000),
    SPH_C32(0xd9301e32), SPH_C32(0xd0baef72), SPH_C32(0x4a3a8ff2),
    SPH_C32(0xea373c60) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0x12455000), SPH_C32(0xe28f0000), SPH_C32(0x188b0000),
    SPH_C32(0x1b180000), SPH_C32(0xd9301e32), SPH_C32(0xd0baef72),
    SPH_C32(0x4a3a8ff2), SPH_C32(0xea373c60), SPH_C32(0xf3928800),
    SPH_C32(0xdc560000), SPH_C32(0xbd470000), SPH_C32(0x95bd0000),
    SPH_C32(0x3d767488), SPH_C32(0xf3c9c922), SPH_C32(0x916cbfec),
    SPH_C32(0x4aeb5b0f) },
  { SPH_C32(0xdad61400), SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000),
    SPH_C32(0x574e0000), SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67),
    SPH_C32(0x628cfdb5), SPH_C32(0xc7e6c5cb), SPH_C32(0xa7bad400),
    SPH_C32(0x36bb0000), SPH_C32(0x78910000), SPH_C32(0x34780000),
    SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3), SPH_C32(0xfadcfe71),
    SPH_C32(0x1ff06c8d) },
  { SPH_C32(0x8efe4800), SPH_C32(0x525c0000), SPH_C32(0x8ada0000),
    SPH_C32(0xf68b0000), SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86),
    SPH_C32(0x093cbc28), SPH_C32(0x92fdf249), SPH_C32(0x3b01cc00),
    SPH_C32(0x86680000), SPH_C32(0xeac00000), SPH_C32(0xd9eb0000),
    SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837), SPH_C32(0xb9dacdab),
    SPH_C32(0x673aa2a4) },
  { SPH_C32(0x6f299000), SPH_C32(0x6c850000), SPH_C32(0x2f160000),
    SPH_C32(0x782e0000), SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6),
    SPH_C32(0xd26a8c36), SPH_C32(0x32219526), SPH_C32(0x29449c00),
    SPH_C32(0x64e70000), SPH_C32(0xf24b0000), SPH_C32(0xc2f30000),
    SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745), SPH_C32(0xf3e04259),
    SPH_C32(0x8d0d9ec4) },
  { SPH_C32(0x3b01cc00), SPH_C32(0x86680000), SPH_C32(0xeac00000),
    SPH_C32(0xd9eb0000), SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837),
    SPH_C32(0xb9dacdab), SPH_C32(0x673aa2a4), SPH_C32(0xb5ff8400),
    SPH_C32(0xd4340000), SPH_C32(0x601a0000), SPH_C32(0x2f600000),
    SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1), SPH_C32(0xb0e67183),
    SPH_C32(0xf5c750ed) },
  { SPH_C32(0xf3928800), SPH_C32(0xdc560000), SPH_C32(0xbd470000),
    SPH_C32(0x95bd0000), SPH_C32(0x3d767488), SPH_C32(0xf3c9c922),
    SPH_C32(0x916cbfec), SPH_C32(0x4aeb5b0f), SPH_C32(0xe1d7d800),
    SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000), SPH_C32(0x8ea50000),
    SPH_C32(0xe4466aba), SPH_C32(0x23732650), SPH_C32(0xdb56301e),
    SPH_C32(0xa0dc676f) },
  { SPH_C32(0xa7bad400), SPH_C32(0x36bb0000), SPH_C32(0x78910000),
    SPH_C32(0x34780000), SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3),
    SPH_C32(0xfadcfe71), SPH_C32(0x1ff06c8d), SPH_C32(0x7d6cc000),
    SPH_C32(0x8e0a0000), SPH_C32(0x379d0000), SPH_C32(0x63360000),
    SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4), SPH_C32(0x985003c4),
    SPH_C32(0xd816a946) }
};

__constant static const sph_u32 T512_4[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0x26600240), SPH_C32(0xddd80000), SPH_C32(0x722a0000),
    SPH_C32(0x4f060000), SPH_C32(0x936667ff), SPH_C32(0x29f944ce),
    SPH_C32(0x368b63d5), SPH_C32(0x0c26f262), SPH_C32(0xef0b0270),
    SPH_C32(0x3afd0000), SPH_C32(0x5dae0000), SPH_C32(0x69490000),
    SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9), SPH_C32(0x66140a51),
    SPH_C32(0x924f5d0a) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0xfb513e70), SPH_C32(0x83140000), SPH_C32(0x3c890000),
    SPH_C32(0x98280000), SPH_C32(0x556e016a), SPH_C32(0xf44c8881),
    SPH_C32(0x21bd6d71), SPH_C32(0x73c179cf), SPH_C32(0xea0c1430),
    SPH_C32(0x2f9c0000), SPH_C32(0xdb430000), SPH_C32(0xdd3a0000),
    SPH_C32(0x7ba47f9c), SPH_C32(0x955a547e), SPH_C32(0x525b63bb),
    SPH_C32(0x424d4977) },
  { SPH_C32(0xdd313c30), SPH_C32(0x5ecc0000), SPH_C32(0x4ea30000),
    SPH_C32(0xd72e0000), SPH_C32(0xc6086695), SPH_C32(0xddb5cc4f),
    SPH_C32(0x17360ea4), SPH_C32(0x7fe78bad), SPH_C32(0x05071640),
    SPH_C32(0x15610000), SPH_C32(0x86ed0000), SPH_C32(0xb4730000),
    SPH_C32(0xe0ab439a), SPH_C32(0xd15fe187), SPH_C32(0x344f69ea),
    SPH_C32(0xd002147d) },
  { SPH_C32(0x323a3e40), SPH_C32(0x64310000), SPH_C32(0x130d0000),
    SPH_C32(0xbe670000), SPH_C32(0x5d075a93), SPH_C32(0x99b079b6),
    SPH_C32(0x712204f5), SPH_C32(0xeda8d6a7), SPH_C32(0xcc6c1670),
    SPH_C32(0xf2440000), SPH_C32(0xa9690000), SPH_C32(0x923c0000),
    SPH_C32(0xe8c21863), SPH_C32(0xbca310b0), SPH_C32(0x64d0006e),
    SPH_C32(0x4e6bbb15) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0xcc6c1670), SPH_C32(0xf2440000), SPH_C32(0xa9690000),
    SPH_C32(0x923c0000), SPH_C32(0xe8c21863), SPH_C32(0xbca310b0),
    SPH_C32(0x64d0006e), SPH_C32(0x4e6bbb15), SPH_C32(0xfe562830),
    SPH_C32(0x96750000), SPH_C32(0xba640000), SPH_C32(0x2c5b0000),
    SPH_C32(0xb5c542f0), SPH_C32(0x25136906), SPH_C32(0x15f2049b),
    SPH_C32(0xa3c36db2) },
  { SPH_C32(0xea0c1430), SPH_C32(0x2f9c0000), SPH_C32(0xdb430000),
    SPH_C32(0xdd3a0000), SPH_C32(0x7ba47f9c), SPH_C32(0x955a547e),
    SPH_C32(0x525b63bb), SPH_C32(0x424d4977), SPH_C32(0x115d2a40),
    SPH_C32(0xac880000), SPH_C32(0xe7ca0000), SPH_C32(0x45120000),
    SPH_C32(0x2eca7ef6), SPH_C32(0x6116dcff), SPH_C32(0x73e60eca),
    SPH_C32(0x318c30b8) },
  { SPH_C32(0x05071640), SPH_C32(0x15610000), SPH_C32(0x86ed0000),
    SPH_C32(0xb4730000), SPH_C32(0xe0ab439a), SPH_C32(0xd15fe187),
    SPH_C32(0x344f69ea), SPH_C32(0xd002147d), SPH_C32(0xd8362a70),
    SPH_C32(0x4bad0000), SPH_C32(0xc84e0000), SPH_C32(0x635d0000),
    SPH_C32(0x26a3250f), SPH_C32(0x0cea2dc8), SPH_C32(0x2379674e),
    SPH_C32(0xafe59fd0) },
  { SPH_C32(0x373d2800), SPH_C32(0x71500000), SPH_C32(0x95e00000),
    SPH_C32(0x0a140000), SPH_C32(0xbdac1909), SPH_C32(0x48ef9831),
    SPH_C32(0x456d6d1f), SPH_C32(0x3daac2da), SPH_C32(0x145a3c00),
    SPH_C32(0xb9e90000), SPH_C32(0x61270000), SPH_C32(0xf1610000),
    SPH_C32(0xce613d6c), SPH_C32(0xb0493d78), SPH_C32(0x47a96720),
    SPH_C32(0xe18e24c5) },
  { SPH_C32(0xd8362a70), SPH_C32(0x4bad0000), SPH_C32(0xc84e0000),
    SPH_C32(0x635d0000), SPH_C32(0x26a3250f), SPH_C32(0x0cea2dc8),
    SPH_C32(0x2379674e), SPH_C32(0xafe59fd0), SPH_C32(0xdd313c30),
    SPH_C32(0x5ecc0000), SPH_C32(0x4ea30000), SPH_C32(0xd72e0000),
    SPH_C32(0xc6086695), SPH_C32(0xddb5cc4f), SPH_C32(0x17360ea4),
    SPH_C32(0x7fe78bad) },
  { SPH_C32(0xfe562830), SPH_C32(0x96750000), SPH_C32(0xba640000),
    SPH_C32(0x2c5b0000), SPH_C32(0xb5c542f0), SPH_C32(0x25136906),
    SPH_C32(0x15f2049b), SPH_C32(0xa3c36db2), SPH_C32(0x323a3e40),
    SPH_C32(0x64310000), SPH_C32(0x130d0000), SPH_C32(0xbe670000),
    SPH_C32(0x5d075a93), SPH_C32(0x99b079b6), SPH_C32(0x712204f5),
    SPH_C32(0xeda8d6a7) },
  { SPH_C32(0x115d2a40), SPH_C32(0xac880000), SPH_C32(0xe7ca0000),
    SPH_C32(0x45120000), SPH_C32(0x2eca7ef6), SPH_C32(0x6116dcff),
    SPH_C32(0x73e60eca), SPH_C32(0x318c30b8), SPH_C32(0xfb513e70),
    SPH_C32(0x83140000), SPH_C32(0x3c890000), SPH_C32(0x98280000),
    SPH_C32(0x556e016a), SPH_C32(0xf44c8881), SPH_C32(0x21bd6d71),
    SPH_C32(0x73c179cf) }
};

__constant static const sph_u32 T512_8[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0x832800a0), SPH_C32(0x67420000), SPH_C32(0xe1170000),
    SPH_C32(0x370b0000), SPH_C32(0xcba30034), SPH_C32(0x3c34923c),
    SPH_C32(0x9767bdcc), SPH_C32(0x450360bf), SPH_C32(0x774400f0),
    SPH_C32(0xf15a0000), SPH_C32(0xf5b20000), SPH_C32(0x34140000),
    SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25), SPH_C32(0x0bc3cd1e),
    SPH_C32(0xcf3775cb) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0x9fc30180), SPH_C32(0x6c280000), SPH_C32(0xe7690000),
    SPH_C32(0xe0360000), SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966),
    SPH_C32(0x453b7806), SPH_C32(0xaebf667a), SPH_C32(0x405b0030),
    SPH_C32(0x9a540000), SPH_C32(0x42670000), SPH_C32(0x5fb10000),
    SPH_C32(0xd6c06187), SPH_C32(0x5d81863c), SPH_C32(0x87922fef),
    SPH_C32(0x79e0422c) },
  { SPH_C32(0x1ceb0120), SPH_C32(0x0b6a0000), SPH_C32(0x067e0000),
    SPH_C32(0xd73d0000), SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a),
    SPH_C32(0xd25cc5ca), SPH_C32(0xebbc06c5), SPH_C32(0x371f00c0),
    SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000), SPH_C32(0x6ba50000),
    SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19), SPH_C32(0x8c51e2f1),
    SPH_C32(0xb6d737e7) },
  { SPH_C32(0x6baf01d0), SPH_C32(0xfa300000), SPH_C32(0xf3cc0000),
    SPH_C32(0xe3290000), SPH_C32(0x392b6b13), SPH_C32(0x9515777f),
    SPH_C32(0xd99f08d4), SPH_C32(0x248b730e), SPH_C32(0xc3730090),
    SPH_C32(0xfd160000), SPH_C32(0xa3700000), SPH_C32(0x68ba0000),
    SPH_C32(0x1d6361b3), SPH_C32(0x61b51400), SPH_C32(0x10f59223),
    SPH_C32(0x3ce32293) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0xc3730090), SPH_C32(0xfd160000), SPH_C32(0xa3700000),
    SPH_C32(0x68ba0000), SPH_C32(0x1d6361b3), SPH_C32(0x61b51400),
    SPH_C32(0x10f59223), SPH_C32(0x3ce32293), SPH_C32(0xa8dc0140),
    SPH_C32(0x07260000), SPH_C32(0x50bc0000), SPH_C32(0x8b930000),
    SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f), SPH_C32(0xc96a9af7),
    SPH_C32(0x1868519d) },
  { SPH_C32(0x405b0030), SPH_C32(0x9a540000), SPH_C32(0x42670000),
    SPH_C32(0x5fb10000), SPH_C32(0xd6c06187), SPH_C32(0x5d81863c),
    SPH_C32(0x87922fef), SPH_C32(0x79e0422c), SPH_C32(0xdf9801b0),
    SPH_C32(0xf67c0000), SPH_C32(0xa50e0000), SPH_C32(0xbf870000),
    SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a), SPH_C32(0xc2a957e9),
    SPH_C32(0xd75f2456) },
  { SPH_C32(0x371f00c0), SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000),
    SPH_C32(0x6ba50000), SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19),
    SPH_C32(0x8c51e2f1), SPH_C32(0xb6d737e7), SPH_C32(0x2bf401e0),
    SPH_C32(0x60640000), SPH_C32(0xb1ab0000), SPH_C32(0xbc980000),
    SPH_C32(0xefeb0a94), SPH_C32(0xc894f143), SPH_C32(0x5e0d273b),
    SPH_C32(0x5d6b3122) },
  { SPH_C32(0x5cb00110), SPH_C32(0x913e0000), SPH_C32(0x44190000),
    SPH_C32(0x888c0000), SPH_C32(0x66dc7418), SPH_C32(0x921f1d66),
    SPH_C32(0x55ceea25), SPH_C32(0x925c44e9), SPH_C32(0xe8870170),
    SPH_C32(0x9d720000), SPH_C32(0x12db0000), SPH_C32(0xd4220000),
    SPH_C32(0xf2886b27), SPH_C32(0xa921e543), SPH_C32(0x4ef8b518),
    SPH_C32(0x618813b1) },
  { SPH_C32(0x2bf401e0), SPH_C32(0x60640000), SPH_C32(0xb1ab0000),
    SPH_C32(0xbc980000), SPH_C32(0xefeb0a94), SPH_C32(0xc894f143),
    SPH_C32(0x5e0d273b), SPH_C32(0x5d6b3122), SPH_C32(0x1ceb0120),
    SPH_C32(0x0b6a0000), SPH_C32(0x067e0000), SPH_C32(0xd73d0000),
    SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a), SPH_C32(0xd25cc5ca),
    SPH_C32(0xebbc06c5) },
  { SPH_C32(0xa8dc0140), SPH_C32(0x07260000), SPH_C32(0x50bc0000),
    SPH_C32(0x8b930000), SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f),
    SPH_C32(0xc96a9af7), SPH_C32(0x1868519d), SPH_C32(0x6baf01d0),
    SPH_C32(0xfa300000), SPH_C32(0xf3cc0000), SPH_C32(0xe3290000),
    SPH_C32(0x392b6b13), SPH_C32(0x9515777f), SPH_C32(0xd99f08d4),
    SPH_C32(0x248b730e) },
  { SPH_C32(0xdf9801b0), SPH_C32(0xf67c0000), SPH_C32(0xa50e0000),
    SPH_C32(0xbf870000), SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a),
    SPH_C32(0xc2a957e9), SPH_C32(0xd75f2456), SPH_C32(0x9fc30180),
    SPH_C32(0x6c280000), SPH_C32(0xe7690000), SPH_C32(0xe0360000),
    SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966), SPH_C32(0x453b7806),
    SPH_C32(0xaebf667a) }
};

__constant static const sph_u32 T512_12[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0x50ff0004), SPH_C32(0x45744000), SPH_C32(0x3dfb0000),
    SPH_C32(0x19e60000), SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d),
    SPH_C32(0xe1a8cc96), SPH_C32(0x7b1bd6b9), SPH_C32(0xf6800005),
    SPH_C32(0x3443c000), SPH_C32(0x24070000), SPH_C32(0x8f3d0000),
    SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae), SPH_C32(0xcdc58b19),
    SPH_C32(0xd795ba31) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0x01f5000c), SPH_C32(0xfb7f0000), SPH_C32(0xe7d10000),
    SPH_C32(0x8baf0000), SPH_C32(0x23a22252), SPH_C32(0xf250e314),
    SPH_C32(0xb7427a57), SPH_C32(0x4983222b), SPH_C32(0x72150001),
    SPH_C32(0xfcff4000), SPH_C32(0xbc530000), SPH_C32(0xdcf20000),
    SPH_C32(0xc6c52f87), SPH_C32(0x227e289f), SPH_C32(0xb45bd18b),
    SPH_C32(0x5bc8afa8) },
  { SPH_C32(0x510a0008), SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000),
    SPH_C32(0x92490000), SPH_C32(0x381e7454), SPH_C32(0x13229849),
    SPH_C32(0x56eab6c1), SPH_C32(0x3298f492), SPH_C32(0x84950004),
    SPH_C32(0xc8bc8000), SPH_C32(0x98540000), SPH_C32(0x53cf0000),
    SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31), SPH_C32(0x799e5a92),
    SPH_C32(0x8c5d1599) },
  { SPH_C32(0xa78a000d), SPH_C32(0x8a488000), SPH_C32(0xfe2d0000),
    SPH_C32(0x1d740000), SPH_C32(0x19294faf), SPH_C32(0x199a4de7),
    SPH_C32(0x9b2f3dd8), SPH_C32(0xe50d4ea3), SPH_C32(0x22ea0005),
    SPH_C32(0xb98b0000), SPH_C32(0x81a80000), SPH_C32(0xc5140000),
    SPH_C32(0xdd797981), SPH_C32(0xc30c53c2), SPH_C32(0x55f31d1d),
    SPH_C32(0x20d37911) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0x22ea0005), SPH_C32(0xb98b0000), SPH_C32(0x81a80000),
    SPH_C32(0xc5140000), SPH_C32(0xdd797981), SPH_C32(0xc30c53c2),
    SPH_C32(0x55f31d1d), SPH_C32(0x20d37911), SPH_C32(0x85600008),
    SPH_C32(0x33c38000), SPH_C32(0x7f850000), SPH_C32(0xd8600000),
    SPH_C32(0xc450362e), SPH_C32(0xda961e25), SPH_C32(0xcedc20c5),
    SPH_C32(0xc5de37b2) },
  { SPH_C32(0x72150001), SPH_C32(0xfcff4000), SPH_C32(0xbc530000),
    SPH_C32(0xdcf20000), SPH_C32(0xc6c52f87), SPH_C32(0x227e289f),
    SPH_C32(0xb45bd18b), SPH_C32(0x5bc8afa8), SPH_C32(0x73e0000d),
    SPH_C32(0x07804000), SPH_C32(0x5b820000), SPH_C32(0x575d0000),
    SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b), SPH_C32(0x0319abdc),
    SPH_C32(0x124b8d83) },
  { SPH_C32(0x84950004), SPH_C32(0xc8bc8000), SPH_C32(0x98540000),
    SPH_C32(0x53cf0000), SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31),
    SPH_C32(0x799e5a92), SPH_C32(0x8c5d1599), SPH_C32(0xd59f000c),
    SPH_C32(0x76b7c000), SPH_C32(0x427e0000), SPH_C32(0xc1860000),
    SPH_C32(0xdfec6028), SPH_C32(0x3be46578), SPH_C32(0x2f74ec53),
    SPH_C32(0xbec5e10b) },
  { SPH_C32(0x231f0009), SPH_C32(0x42f40000), SPH_C32(0x66790000),
    SPH_C32(0x4ebb0000), SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6),
    SPH_C32(0xe2b1674a), SPH_C32(0x69505b3a), SPH_C32(0xf7750009),
    SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000), SPH_C32(0x04920000),
    SPH_C32(0x029519a9), SPH_C32(0xf8e836ba), SPH_C32(0x7a87f14e),
    SPH_C32(0x9e16981a) },
  { SPH_C32(0xd59f000c), SPH_C32(0x76b7c000), SPH_C32(0x427e0000),
    SPH_C32(0xc1860000), SPH_C32(0xdfec6028), SPH_C32(0x3be46578),
    SPH_C32(0x2f74ec53), SPH_C32(0xbec5e10b), SPH_C32(0x510a0008),
    SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000), SPH_C32(0x92490000),
    SPH_C32(0x381e7454), SPH_C32(0x13229849), SPH_C32(0x56eab6c1),
    SPH_C32(0x3298f492) },
  { SPH_C32(0x85600008), SPH_C32(0x33c38000), SPH_C32(0x7f850000),
    SPH_C32(0xd8600000), SPH_C32(0xc450362e), SPH_C32(0xda961e25),
    SPH_C32(0xcedc20c5), SPH_C32(0xc5de37b2), SPH_C32(0xa78a000d),
    SPH_C32(0x8a488000), SPH_C32(0xfe2d0000), SPH_C32(0x1d740000),
    SPH_C32(0x19294faf), SPH_C32(0x199a4de7), SPH_C32(0x9b2f3dd8),
    SPH_C32(0xe50d4ea3) },
  { SPH_C32(0x73e0000d), SPH_C32(0x07804000), SPH_C32(0x5b820000),
    SPH_C32(0x575d0000), SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b),
    SPH_C32(0x0319abdc), SPH_C32(0x124b8d83), SPH_C32(0x01f5000c),
    SPH_C32(0xfb7f0000), SPH_C32(0xe7d10000), SPH_C32(0x8baf0000),
    SPH_C32(0x23a22252), SPH_C32(0xf250e314), SPH_C32(0xb7427a57),
    SPH_C32(0x4983222b) }
};

__constant static const sph_u32 T512_16[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0xa4c20000), SPH_C32(0xd9372400), SPH_C32(0x0a480000),
    SPH_C32(0x66610000), SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c),
    SPH_C32(0xa324df94), SPH_C32(0x2ba05a55), SPH_C32(0x75a40000),
    SPH_C32(0xc28b2700), SPH_C32(0x94a40000), SPH_C32(0x90f50000),
    SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae), SPH_C32(0x1767c483),
    SPH_C32(0xaedf667e) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0x006d0003), SPH_C32(0xcc9be700), SPH_C32(0x45840000),
    SPH_C32(0x2a1f0000), SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9),
    SPH_C32(0xac4fb29e), SPH_C32(0xae684855), SPH_C32(0x3fa90001),
    SPH_C32(0x74ea4300), SPH_C32(0x6dd20000), SPH_C32(0x510a0000),
    SPH_C32(0xbeb7373e), SPH_C32(0x78611737), SPH_C32(0xfe785bad),
    SPH_C32(0x7bd4ce7f) },
  { SPH_C32(0xa4af0003), SPH_C32(0x15acc300), SPH_C32(0x4fcc0000),
    SPH_C32(0x4c7e0000), SPH_C32(0x88c66a19), SPH_C32(0x48284ba5),
    SPH_C32(0x0f6b6d0a), SPH_C32(0x85c81200), SPH_C32(0x4a0d0001),
    SPH_C32(0xb6616400), SPH_C32(0xf9760000), SPH_C32(0xc1ff0000),
    SPH_C32(0x45cf60de), SPH_C32(0x31af1c99), SPH_C32(0xe91f9f2e),
    SPH_C32(0xd50ba801) },
  { SPH_C32(0xd10b0003), SPH_C32(0xd727e400), SPH_C32(0xdb680000),
    SPH_C32(0xdc8b0000), SPH_C32(0x73be3df9), SPH_C32(0x01e6400b),
    SPH_C32(0x180ca989), SPH_C32(0x2b17747e), SPH_C32(0x9b6b0001),
    SPH_C32(0xaddd6700), SPH_C32(0x679a0000), SPH_C32(0x376b0000),
    SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b), SPH_C32(0x5d5c8439),
    SPH_C32(0x5074942a) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0x9b6b0001), SPH_C32(0xaddd6700), SPH_C32(0x679a0000),
    SPH_C32(0x376b0000), SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b),
    SPH_C32(0x5d5c8439), SPH_C32(0x5074942a), SPH_C32(0x4a600002),
    SPH_C32(0x7afa8300), SPH_C32(0xbcf20000), SPH_C32(0xebe00000),
    SPH_C32(0x35731800), SPH_C32(0xff39a060), SPH_C32(0x45502db0),
    SPH_C32(0x7b63e054) },
  { SPH_C32(0x3fa90001), SPH_C32(0x74ea4300), SPH_C32(0x6dd20000),
    SPH_C32(0x510a0000), SPH_C32(0xbeb7373e), SPH_C32(0x78611737),
    SPH_C32(0xfe785bad), SPH_C32(0x7bd4ce7f), SPH_C32(0x3fc40002),
    SPH_C32(0xb871a400), SPH_C32(0x28560000), SPH_C32(0x7b150000),
    SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce), SPH_C32(0x5237e933),
    SPH_C32(0xd5bc862a) },
  { SPH_C32(0x4a0d0001), SPH_C32(0xb6616400), SPH_C32(0xf9760000),
    SPH_C32(0xc1ff0000), SPH_C32(0x45cf60de), SPH_C32(0x31af1c99),
    SPH_C32(0xe91f9f2e), SPH_C32(0xd50ba801), SPH_C32(0xeea20002),
    SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000), SPH_C32(0x8d810000),
    SPH_C32(0xcd090ac7), SPH_C32(0x7987573c), SPH_C32(0xe674f224),
    SPH_C32(0x50c3ba01) },
  { SPH_C32(0x9b060002), SPH_C32(0x61468000), SPH_C32(0x221e0000),
    SPH_C32(0x1d740000), SPH_C32(0x36715d27), SPH_C32(0x30495c92),
    SPH_C32(0xf11336a7), SPH_C32(0xfe1cdc7f), SPH_C32(0x75c90003),
    SPH_C32(0x0e10c000), SPH_C32(0xd1200000), SPH_C32(0xbaea0000),
    SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757), SPH_C32(0xbb28761d),
    SPH_C32(0x00b72e2b) },
  { SPH_C32(0xeea20002), SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000),
    SPH_C32(0x8d810000), SPH_C32(0xcd090ac7), SPH_C32(0x7987573c),
    SPH_C32(0xe674f224), SPH_C32(0x50c3ba01), SPH_C32(0xa4af0003),
    SPH_C32(0x15acc300), SPH_C32(0x4fcc0000), SPH_C32(0x4c7e0000),
    SPH_C32(0x88c66a19), SPH_C32(0x48284ba5), SPH_C32(0x0f6b6d0a),
    SPH_C32(0x85c81200) },
  { SPH_C32(0x4a600002), SPH_C32(0x7afa8300), SPH_C32(0xbcf20000),
    SPH_C32(0xebe00000), SPH_C32(0x35731800), SPH_C32(0xff39a060),
    SPH_C32(0x45502db0), SPH_C32(0x7b63e054), SPH_C32(0xd10b0003),
    SPH_C32(0xd727e400), SPH_C32(0xdb680000), SPH_C32(0xdc8b0000),
    SPH_C32(0x73be3df9), SPH_C32(0x01e6400b), SPH_C32(0x180ca989),
    SPH_C32(0x2b17747e) },
  { SPH_C32(0x3fc40002), SPH_C32(0xb871a400), SPH_C32(0x28560000),
    SPH_C32(0x7b150000), SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce),
    SPH_C32(0x5237e933), SPH_C32(0xd5bc862a), SPH_C32(0x006d0003),
    SPH_C32(0xcc9be700), SPH_C32(0x45840000), SPH_C32(0x2a1f0000),
    SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9), SPH_C32(0xac4fb29e),
    SPH_C32(0xae684855) }
};

__constant static const sph_u32 T512_20[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0xf2500000), SPH_C32(0xeebd0a00), SPH_C32(0x67a80000),
    SPH_C32(0xab8a0000), SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74),
    SPH_C32(0xdb73e86e), SPH_C32(0x1568ff0f), SPH_C32(0x0c720000),
    SPH_C32(0x49e50f00), SPH_C32(0x42790000), SPH_C32(0x5cea0000),
    SPH_C32(0x33aa301a), SPH_C32(0x15822514), SPH_C32(0x95a34b7b),
    SPH_C32(0xb44b0090) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0x496a0000), SPH_C32(0xec501800), SPH_C32(0xbb130000),
    SPH_C32(0x67a20000), SPH_C32(0x2d662436), SPH_C32(0x3691b0c2),
    SPH_C32(0x831fedcb), SPH_C32(0x6b78f44f), SPH_C32(0x461f0000),
    SPH_C32(0xb1290300), SPH_C32(0x124b0000), SPH_C32(0x02d10000),
    SPH_C32(0xabb01976), SPH_C32(0xb19c0925), SPH_C32(0x28f4b503),
    SPH_C32(0x64e214a1) },
  { SPH_C32(0xbb3a0000), SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000),
    SPH_C32(0xcc280000), SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6),
    SPH_C32(0x586c05a5), SPH_C32(0x7e100b40), SPH_C32(0x4a6d0000),
    SPH_C32(0xf8cc0c00), SPH_C32(0x50320000), SPH_C32(0x5e3b0000),
    SPH_C32(0x981a296c), SPH_C32(0xa41e2c31), SPH_C32(0xbd57fe78),
    SPH_C32(0xd0a91431) },
  { SPH_C32(0xb7480000), SPH_C32(0x4b081d00), SPH_C32(0x9ec20000),
    SPH_C32(0x90c20000), SPH_C32(0xa4575cec), SPH_C32(0x294548a2),
    SPH_C32(0xcdcf4ede), SPH_C32(0xca5b0bd0), SPH_C32(0xb44f0000),
    SPH_C32(0x5f940900), SPH_C32(0x75e30000), SPH_C32(0xa95b0000),
    SPH_C32(0x112b51b6), SPH_C32(0xbbcad451), SPH_C32(0xf3875d6d),
    SPH_C32(0x718aebae) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0xb44f0000), SPH_C32(0x5f940900), SPH_C32(0x75e30000),
    SPH_C32(0xa95b0000), SPH_C32(0x112b51b6), SPH_C32(0xbbcad451),
    SPH_C32(0xf3875d6d), SPH_C32(0x718aebae), SPH_C32(0x03070000),
    SPH_C32(0x149c1400), SPH_C32(0xeb210000), SPH_C32(0x39990000),
    SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3), SPH_C32(0x3e4813b3),
    SPH_C32(0xbbd1e07e) },
  { SPH_C32(0x461f0000), SPH_C32(0xb1290300), SPH_C32(0x124b0000),
    SPH_C32(0x02d10000), SPH_C32(0xabb01976), SPH_C32(0xb19c0925),
    SPH_C32(0x28f4b503), SPH_C32(0x64e214a1), SPH_C32(0x0f750000),
    SPH_C32(0x5d791b00), SPH_C32(0xa9580000), SPH_C32(0x65730000),
    SPH_C32(0x86d63d40), SPH_C32(0x870db9e7), SPH_C32(0xabeb58c8),
    SPH_C32(0x0f9ae0ee) },
  { SPH_C32(0x4a6d0000), SPH_C32(0xf8cc0c00), SPH_C32(0x50320000),
    SPH_C32(0x5e3b0000), SPH_C32(0x981a296c), SPH_C32(0xa41e2c31),
    SPH_C32(0xbd57fe78), SPH_C32(0xd0a91431), SPH_C32(0xf1570000),
    SPH_C32(0xfa211e00), SPH_C32(0x8c890000), SPH_C32(0x92130000),
    SPH_C32(0x0fe7459a), SPH_C32(0x98d94187), SPH_C32(0xe53bfbdd),
    SPH_C32(0xaeb91f71) },
  { SPH_C32(0xfd250000), SPH_C32(0xb3c41100), SPH_C32(0xcef00000),
    SPH_C32(0xcef90000), SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493),
    SPH_C32(0x7098b0a6), SPH_C32(0x1af21fe1), SPH_C32(0x45180000),
    SPH_C32(0xa5b51700), SPH_C32(0xf96a0000), SPH_C32(0x3b480000),
    SPH_C32(0x1ecc142c), SPH_C32(0x231395d6), SPH_C32(0x16bca6b0),
    SPH_C32(0xdf33f4df) },
  { SPH_C32(0xf1570000), SPH_C32(0xfa211e00), SPH_C32(0x8c890000),
    SPH_C32(0x92130000), SPH_C32(0x0fe7459a), SPH_C32(0x98d94187),
    SPH_C32(0xe53bfbdd), SPH_C32(0xaeb91f71), SPH_C32(0xbb3a0000),
    SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000), SPH_C32(0xcc280000),
    SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6), SPH_C32(0x586c05a5),
    SPH_C32(0x7e100b40) },
  { SPH_C32(0x03070000), SPH_C32(0x149c1400), SPH_C32(0xeb210000),
    SPH_C32(0x39990000), SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3),
    SPH_C32(0x3e4813b3), SPH_C32(0xbbd1e07e), SPH_C32(0xb7480000),
    SPH_C32(0x4b081d00), SPH_C32(0x9ec20000), SPH_C32(0x90c20000),
    SPH_C32(0xa4575cec), SPH_C32(0x294548a2), SPH_C32(0xcdcf4ede),
    SPH_C32(0xca5b0bd0) },
  { SPH_C32(0x0f750000), SPH_C32(0x5d791b00), SPH_C32(0xa9580000),
    SPH_C32(0x65730000), SPH_C32(0x86d63d40), SPH_C32(0x870db9e7),
    SPH_C32(0xabeb58c8), SPH_C32(0x0f9ae0ee), SPH_C32(0x496a0000),
    SPH_C32(0xec501800), SPH_C32(0xbb130000), SPH_C32(0x67a20000),
    SPH_C32(0x2d662436), SPH_C32(0x3691b0c2), SPH_C32(0x831fedcb),
    SPH_C32(0x6b78f44f) }
};

__constant static const sph_u32 T512_24[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0xe8dd0000), SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000),
    SPH_C32(0xbb150000), SPH_C32(0x80bd361b), SPH_C32(0x24e81d44),
    SPH_C32(0xbfa8c2f4), SPH_C32(0x524a0d59), SPH_C32(0x54500000),
    SPH_C32(0x0671005c), SPH_C32(0x25ae0000), SPH_C32(0x6a1e0000),
    SPH_C32(0x2ea54edf), SPH_C32(0x664e8512), SPH_C32(0xbfba18c3),
    SPH_C32(0x7e715d17) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0x3d010000), SPH_C32(0xd29000c0), SPH_C32(0xe68d0000),
    SPH_C32(0xc6310000), SPH_C32(0xca304571), SPH_C32(0xa8ea90ce),
    SPH_C32(0x385630bf), SPH_C32(0xc290fed9), SPH_C32(0x7afe0000),
    SPH_C32(0x53b60014), SPH_C32(0xbd420000), SPH_C32(0xf0860000),
    SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979), SPH_C32(0x1d3a76bf),
    SPH_C32(0x1bb6813d) },
  { SPH_C32(0xd5dc0000), SPH_C32(0x28da0084), SPH_C32(0xdaa00000),
    SPH_C32(0x7d240000), SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a),
    SPH_C32(0x87fef24b), SPH_C32(0x90daf380), SPH_C32(0x2eae0000),
    SPH_C32(0x55c70048), SPH_C32(0x98ec0000), SPH_C32(0x9a980000),
    SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b), SPH_C32(0xa2806e7c),
    SPH_C32(0x65c7dc2a) },
  { SPH_C32(0x818c0000), SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000),
    SPH_C32(0x173a0000), SPH_C32(0x64283db5), SPH_C32(0xea4c0898),
    SPH_C32(0x3844ea88), SPH_C32(0xeeabae97), SPH_C32(0x92230000),
    SPH_C32(0xa9fc0050), SPH_C32(0x816f0000), SPH_C32(0x4b930000),
    SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d), SPH_C32(0xa292b44b),
    SPH_C32(0x49fc8c64) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0x92230000), SPH_C32(0xa9fc0050), SPH_C32(0x816f0000),
    SPH_C32(0x4b930000), SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d),
    SPH_C32(0xa292b44b), SPH_C32(0x49fc8c64), SPH_C32(0x13af0000),
    SPH_C32(0x87570088), SPH_C32(0x7e610000), SPH_C32(0x5ca90000),
    SPH_C32(0x699c66ed), SPH_C32(0xf511dca5), SPH_C32(0x9ad65ec3),
    SPH_C32(0xa75722f3) },
  { SPH_C32(0x7afe0000), SPH_C32(0x53b60014), SPH_C32(0xbd420000),
    SPH_C32(0xf0860000), SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979),
    SPH_C32(0x1d3a76bf), SPH_C32(0x1bb6813d), SPH_C32(0x47ff0000),
    SPH_C32(0x812600d4), SPH_C32(0x5bcf0000), SPH_C32(0x36b70000),
    SPH_C32(0x47392832), SPH_C32(0x935f59b7), SPH_C32(0x256c4600),
    SPH_C32(0xd9267fe4) },
  { SPH_C32(0x2eae0000), SPH_C32(0x55c70048), SPH_C32(0x98ec0000),
    SPH_C32(0x9a980000), SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b),
    SPH_C32(0xa2806e7c), SPH_C32(0x65c7dc2a), SPH_C32(0xfb720000),
    SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000), SPH_C32(0xe7bc0000),
    SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1), SPH_C32(0x257e9c37),
    SPH_C32(0xf51d2faa) },
  { SPH_C32(0xaf220000), SPH_C32(0x7b6c0090), SPH_C32(0x67e20000),
    SPH_C32(0x8da20000), SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3),
    SPH_C32(0x9ac484f4), SPH_C32(0x8b6c72bd), SPH_C32(0x69510000),
    SPH_C32(0xd4e1009c), SPH_C32(0xc3230000), SPH_C32(0xac2f0000),
    SPH_C32(0xe4950bae), SPH_C32(0xcea415dc), SPH_C32(0x87ec287c),
    SPH_C32(0xbce1a3ce) },
  { SPH_C32(0xfb720000), SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000),
    SPH_C32(0xe7bc0000), SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1),
    SPH_C32(0x257e9c37), SPH_C32(0xf51d2faa), SPH_C32(0xd5dc0000),
    SPH_C32(0x28da0084), SPH_C32(0xdaa00000), SPH_C32(0x7d240000),
    SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a), SPH_C32(0x87fef24b),
    SPH_C32(0x90daf380) },
  { SPH_C32(0x13af0000), SPH_C32(0x87570088), SPH_C32(0x7e610000),
    SPH_C32(0x5ca90000), SPH_C32(0x699c66ed), SPH_C32(0xf511dca5),
    SPH_C32(0x9ad65ec3), SPH_C32(0xa75722f3), SPH_C32(0x818c0000),
    SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000), SPH_C32(0x173a0000),
    SPH_C32(0x64283db5), SPH_C32(0xea4c0898), SPH_C32(0x3844ea88),
    SPH_C32(0xeeabae97) },
  { SPH_C32(0x47ff0000), SPH_C32(0x812600d4), SPH_C32(0x5bcf0000),
    SPH_C32(0x36b70000), SPH_C32(0x47392832), SPH_C32(0x935f59b7),
    SPH_C32(0x256c4600), SPH_C32(0xd9267fe4), SPH_C32(0x3d010000),
    SPH_C32(0xd29000c0), SPH_C32(0xe68d0000), SPH_C32(0xc6310000),
    SPH_C32(0xca304571), SPH_C32(0xa8ea90ce), SPH_C32(0x385630bf),
    SPH_C32(0xc290fed9) }
};

__constant static const sph_u32 T512_28[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0xb6ce0000), SPH_C32(0xdae90002), SPH_C32(0x156e8000),
    SPH_C32(0xda920000), SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a),
    SPH_C32(0xf272e8ae), SPH_C32(0xa6b8c28d), SPH_C32(0x86790000),
    SPH_C32(0x3f390002), SPH_C32(0xe19ae000), SPH_C32(0x98560000),
    SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea), SPH_C32(0xd3dd4944),
    SPH_C32(0x161ddab9) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0x92600000), SPH_C32(0x1cf3003e), SPH_C32(0xb145e000),
    SPH_C32(0xdce00000), SPH_C32(0x8e0900be), SPH_C32(0x727b649f),
    SPH_C32(0xb23b59f4), SPH_C32(0xcdd70139), SPH_C32(0xd3f40000),
    SPH_C32(0xdf9e0014), SPH_C32(0x06326000), SPH_C32(0xe88a0000),
    SPH_C32(0xb8a67fcc), SPH_C32(0x5dd12a75), SPH_C32(0x339210bc),
    SPH_C32(0x8aeb81e3) },
  { SPH_C32(0x24ae0000), SPH_C32(0xc61a003c), SPH_C32(0xa42b6000),
    SPH_C32(0x06720000), SPH_C32(0x78d45ada), SPH_C32(0x44493815),
    SPH_C32(0x4049b15a), SPH_C32(0x6b6fc3b4), SPH_C32(0x558d0000),
    SPH_C32(0xe0a70016), SPH_C32(0xe7a88000), SPH_C32(0x70dc0000),
    SPH_C32(0x2dc318c2), SPH_C32(0x1359e29f), SPH_C32(0xe04f59f8),
    SPH_C32(0x9cf65b5a) },
  { SPH_C32(0xa2d70000), SPH_C32(0xf923003e), SPH_C32(0x45b18000),
    SPH_C32(0x9e240000), SPH_C32(0xedb13dd4), SPH_C32(0x0ac1f0ff),
    SPH_C32(0x9394f81e), SPH_C32(0x7d72190d), SPH_C32(0x653a0000),
    SPH_C32(0x05770016), SPH_C32(0x135ce000), SPH_C32(0x32180000),
    SPH_C32(0x4e7b25a8), SPH_C32(0x6be376ff), SPH_C32(0xc1e0f812),
    SPH_C32(0x2c53436e) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0x653a0000), SPH_C32(0x05770016), SPH_C32(0x135ce000),
    SPH_C32(0x32180000), SPH_C32(0x4e7b25a8), SPH_C32(0x6be376ff),
    SPH_C32(0xc1e0f812), SPH_C32(0x2c53436e), SPH_C32(0xc7ed0000),
    SPH_C32(0xfc540028), SPH_C32(0x56ed6000), SPH_C32(0xac3c0000),
    SPH_C32(0xa3ca187c), SPH_C32(0x61228600), SPH_C32(0x5274000c),
    SPH_C32(0x51215a63) },
  { SPH_C32(0xd3f40000), SPH_C32(0xdf9e0014), SPH_C32(0x06326000),
    SPH_C32(0xe88a0000), SPH_C32(0xb8a67fcc), SPH_C32(0x5dd12a75),
    SPH_C32(0x339210bc), SPH_C32(0x8aeb81e3), SPH_C32(0x41940000),
    SPH_C32(0xc36d002a), SPH_C32(0xb7778000), SPH_C32(0x346a0000),
    SPH_C32(0x36af7f72), SPH_C32(0x2faa4eea), SPH_C32(0x81a94948),
    SPH_C32(0x473c80da) },
  { SPH_C32(0x558d0000), SPH_C32(0xe0a70016), SPH_C32(0xe7a88000),
    SPH_C32(0x70dc0000), SPH_C32(0x2dc318c2), SPH_C32(0x1359e29f),
    SPH_C32(0xe04f59f8), SPH_C32(0x9cf65b5a), SPH_C32(0x71230000),
    SPH_C32(0x26bd002a), SPH_C32(0x4383e000), SPH_C32(0x76ae0000),
    SPH_C32(0x55174218), SPH_C32(0x5710da8a), SPH_C32(0xa006e8a2),
    SPH_C32(0xf79998ee) },
  { SPH_C32(0xf75a0000), SPH_C32(0x19840028), SPH_C32(0xa2190000),
    SPH_C32(0xeef80000), SPH_C32(0xc0722516), SPH_C32(0x19981260),
    SPH_C32(0x73dba1e6), SPH_C32(0xe1844257), SPH_C32(0x14190000),
    SPH_C32(0x23ca003c), SPH_C32(0x50df0000), SPH_C32(0x44b60000),
    SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75), SPH_C32(0x61e610b0),
    SPH_C32(0xdbcadb80) },
  { SPH_C32(0x71230000), SPH_C32(0x26bd002a), SPH_C32(0x4383e000),
    SPH_C32(0x76ae0000), SPH_C32(0x55174218), SPH_C32(0x5710da8a),
    SPH_C32(0xa006e8a2), SPH_C32(0xf79998ee), SPH_C32(0x24ae0000),
    SPH_C32(0xc61a003c), SPH_C32(0xa42b6000), SPH_C32(0x06720000),
    SPH_C32(0x78d45ada), SPH_C32(0x44493815), SPH_C32(0x4049b15a),
    SPH_C32(0x6b6fc3b4) },
  { SPH_C32(0xc7ed0000), SPH_C32(0xfc540028), SPH_C32(0x56ed6000),
    SPH_C32(0xac3c0000), SPH_C32(0xa3ca187c), SPH_C32(0x61228600),
    SPH_C32(0x5274000c), SPH_C32(0x51215a63), SPH_C32(0xa2d70000),
    SPH_C32(0xf923003e), SPH_C32(0x45b18000), SPH_C32(0x9e240000),
    SPH_C32(0xedb13dd4), SPH_C32(0x0ac1f0ff), SPH_C32(0x9394f81e),
    SPH_C32(0x7d72190d) },
  { SPH_C32(0x41940000), SPH_C32(0xc36d002a), SPH_C32(0xb7778000),
    SPH_C32(0x346a0000), SPH_C32(0x36af7f72), SPH_C32(0x2faa4eea),
    SPH_C32(0x81a94948), SPH_C32(0x473c80da), SPH_C32(0x92600000),
    SPH_C32(0x1cf3003e), SPH_C32(0xb145e000), SPH_C32(0xdce00000),
    SPH_C32(0x8e0900be), SPH_C32(0x727b649f), SPH_C32(0xb23b59f4),
    SPH_C32(0xcdd70139) }
};

__constant static const sph_u32 T512_32[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xb2060000), SPH_C32(0xc5690000), SPH_C32(0x28031200),
    SPH_C32(0x74670000), SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8),
    SPH_C32(0x33d1dfec), SPH_C32(0x094e3198), SPH_C32(0xac480000),
    SPH_C32(0x1ba60000), SPH_C32(0x45fb1380), SPH_C32(0x03430000),
    SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6), SPH_C32(0xfe72c7fe),
    SPH_C32(0x91e478f6) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0x028b0000), SPH_C32(0x87e90001), SPH_C32(0x3c2af380),
    SPH_C32(0x2f560000), SPH_C32(0x1f4944d9), SPH_C32(0x79e2e780),
    SPH_C32(0x55e03071), SPH_C32(0x32f62e8d), SPH_C32(0xc56b0000),
    SPH_C32(0xd7e60000), SPH_C32(0x2452c180), SPH_C32(0xf6c50000),
    SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f), SPH_C32(0x8ef57364),
    SPH_C32(0x70c6f340) },
  { SPH_C32(0xb08d0000), SPH_C32(0x42800001), SPH_C32(0x1429e180),
    SPH_C32(0x5b310000), SPH_C32(0xa98b722d), SPH_C32(0x92f0de78),
    SPH_C32(0x6631ef9d), SPH_C32(0x3bb81f15), SPH_C32(0x69230000),
    SPH_C32(0xcc400000), SPH_C32(0x61a9d200), SPH_C32(0xf5860000),
    SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9), SPH_C32(0x7087b49a),
    SPH_C32(0xe1228bb6) },
  { SPH_C32(0x1cc50000), SPH_C32(0x59260001), SPH_C32(0x51d2f200),
    SPH_C32(0x58720000), SPH_C32(0xf30e4347), SPH_C32(0x8d428ece),
    SPH_C32(0x98432863), SPH_C32(0xaa5c67e3), SPH_C32(0x776d0000),
    SPH_C32(0x128f0000), SPH_C32(0x0c51d380), SPH_C32(0x82a20000),
    SPH_C32(0x907b5a33), SPH_C32(0x5dcb6487), SPH_C32(0xbd24ac88),
    SPH_C32(0x7988c2d8) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0x776d0000), SPH_C32(0x128f0000), SPH_C32(0x0c51d380),
    SPH_C32(0x82a20000), SPH_C32(0x907b5a33), SPH_C32(0x5dcb6487),
    SPH_C32(0xbd24ac88), SPH_C32(0x7988c2d8), SPH_C32(0x6ba80000),
    SPH_C32(0x4ba90001), SPH_C32(0x5d832180), SPH_C32(0xdad00000),
    SPH_C32(0x63751974), SPH_C32(0xd089ea49), SPH_C32(0x256784eb),
    SPH_C32(0xd3d4a53b) },
  { SPH_C32(0xc56b0000), SPH_C32(0xd7e60000), SPH_C32(0x2452c180),
    SPH_C32(0xf6c50000), SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f),
    SPH_C32(0x8ef57364), SPH_C32(0x70c6f340), SPH_C32(0xc7e00000),
    SPH_C32(0x500f0001), SPH_C32(0x18783200), SPH_C32(0xd9930000),
    SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff), SPH_C32(0xdb154315),
    SPH_C32(0x4230ddcd) },
  { SPH_C32(0x69230000), SPH_C32(0xcc400000), SPH_C32(0x61a9d200),
    SPH_C32(0xf5860000), SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9),
    SPH_C32(0x7087b49a), SPH_C32(0xe1228bb6), SPH_C32(0xd9ae0000),
    SPH_C32(0x8ec00001), SPH_C32(0x75803380), SPH_C32(0xaeb70000),
    SPH_C32(0xd5b72f80), SPH_C32(0x3b9bd3b1), SPH_C32(0x16b65b07),
    SPH_C32(0xda9a94a3) },
  { SPH_C32(0x75e60000), SPH_C32(0x95660001), SPH_C32(0x307b2000),
    SPH_C32(0xadf40000), SPH_C32(0x8f321eea), SPH_C32(0x24298307),
    SPH_C32(0xe8c49cf9), SPH_C32(0x4b7eec55), SPH_C32(0xaec30000),
    SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000), SPH_C32(0x2c150000),
    SPH_C32(0x45cc75b3), SPH_C32(0x6650b736), SPH_C32(0xab92f78f),
    SPH_C32(0xa312567b) },
  { SPH_C32(0xd9ae0000), SPH_C32(0x8ec00001), SPH_C32(0x75803380),
    SPH_C32(0xaeb70000), SPH_C32(0xd5b72f80), SPH_C32(0x3b9bd3b1),
    SPH_C32(0x16b65b07), SPH_C32(0xda9a94a3), SPH_C32(0xb08d0000),
    SPH_C32(0x42800001), SPH_C32(0x1429e180), SPH_C32(0x5b310000),
    SPH_C32(0xa98b722d), SPH_C32(0x92f0de78), SPH_C32(0x6631ef9d),
    SPH_C32(0x3bb81f15) },
  { SPH_C32(0x6ba80000), SPH_C32(0x4ba90001), SPH_C32(0x5d832180),
    SPH_C32(0xdad00000), SPH_C32(0x63751974), SPH_C32(0xd089ea49),
    SPH_C32(0x256784eb), SPH_C32(0xd3d4a53b), SPH_C32(0x1cc50000),
    SPH_C32(0x59260001), SPH_C32(0x51d2f200), SPH_C32(0x58720000),
    SPH_C32(0xf30e4347), SPH_C32(0x8d428ece), SPH_C32(0x98432863),
    SPH_C32(0xaa5c67e3) },
  { SPH_C32(0xc7e00000), SPH_C32(0x500f0001), SPH_C32(0x18783200),
    SPH_C32(0xd9930000), SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff),
    SPH_C32(0xdb154315), SPH_C32(0x4230ddcd), SPH_C32(0x028b0000),
    SPH_C32(0x87e90001), SPH_C32(0x3c2af380), SPH_C32(0x2f560000),
    SPH_C32(0x1f4944d9), SPH_C32(0x79e2e780), SPH_C32(0x55e03071),
    SPH_C32(0x32f62e8d) }
};

__constant static const sph_u32 T512_36[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0x4d8a0000), SPH_C32(0x49340000), SPH_C32(0x3c8b0500),
    SPH_C32(0xaea30000), SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4),
    SPH_C32(0x8f19eaec), SPH_C32(0x443d3004), SPH_C32(0xcc140000),
    SPH_C32(0xa5630000), SPH_C32(0x5ab90780), SPH_C32(0x3b500000),
    SPH_C32(0x4bd013ff), SPH_C32(0x879b3418), SPH_C32(0x694348c1),
    SPH_C32(0xca5a87fe) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0xb4370000), SPH_C32(0xb79f0000), SPH_C32(0xf3830c00),
    SPH_C32(0xabf50000), SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c),
    SPH_C32(0x99cfe8a3), SPH_C32(0xa9350c55), SPH_C32(0x83310000),
    SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180), SPH_C32(0xc36b0000),
    SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb), SPH_C32(0x4f06b6b7),
    SPH_C32(0x7a915d81) },
  { SPH_C32(0xf9bd0000), SPH_C32(0xfeab0000), SPH_C32(0xcf080900),
    SPH_C32(0x05560000), SPH_C32(0x2c97007b), SPH_C32(0x361db598),
    SPH_C32(0x16d6024f), SPH_C32(0xed083c51), SPH_C32(0x4f250000),
    SPH_C32(0xfe1c0000), SPH_C32(0x86970600), SPH_C32(0xf83b0000),
    SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3), SPH_C32(0x2645fe76),
    SPH_C32(0xb0cbda7f) },
  { SPH_C32(0x35a90000), SPH_C32(0x5bc80000), SPH_C32(0x95b10e80),
    SPH_C32(0x3e060000), SPH_C32(0x67471384), SPH_C32(0xb1868180),
    SPH_C32(0x7f954a8e), SPH_C32(0x2752bbaf), SPH_C32(0xcebb0000),
    SPH_C32(0x124b0000), SPH_C32(0xe0a50480), SPH_C32(0x6dc80000),
    SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f), SPH_C32(0xc01f5c5b),
    SPH_C32(0x3eac6d85) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0xcebb0000), SPH_C32(0x124b0000), SPH_C32(0xe0a50480),
    SPH_C32(0x6dc80000), SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f),
    SPH_C32(0xc01f5c5b), SPH_C32(0x3eac6d85), SPH_C32(0xfb120000),
    SPH_C32(0x49830000), SPH_C32(0x75140a00), SPH_C32(0x53ce0000),
    SPH_C32(0x961a45a8), SPH_C32(0xb65573ff), SPH_C32(0xbf8a16d5),
    SPH_C32(0x19fed62a) },
  { SPH_C32(0x83310000), SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180),
    SPH_C32(0xc36b0000), SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb),
    SPH_C32(0x4f06b6b7), SPH_C32(0x7a915d81), SPH_C32(0x37060000),
    SPH_C32(0xece00000), SPH_C32(0x2fad0d80), SPH_C32(0x689e0000),
    SPH_C32(0xddca5657), SPH_C32(0x31ce47e7), SPH_C32(0xd6c95e14),
    SPH_C32(0xd3a451d4) },
  { SPH_C32(0x4f250000), SPH_C32(0xfe1c0000), SPH_C32(0x86970600),
    SPH_C32(0xf83b0000), SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3),
    SPH_C32(0x2645fe76), SPH_C32(0xb0cbda7f), SPH_C32(0xb6980000),
    SPH_C32(0x00b70000), SPH_C32(0x499f0f00), SPH_C32(0xfd6d0000),
    SPH_C32(0x80637e55), SPH_C32(0x793a7b5b), SPH_C32(0x3093fc39),
    SPH_C32(0x5dc3e62e) },
  { SPH_C32(0x7a8c0000), SPH_C32(0xa5d40000), SPH_C32(0x13260880),
    SPH_C32(0xc63d0000), SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43),
    SPH_C32(0x59d0b4f8), SPH_C32(0x979961d0), SPH_C32(0x78230000),
    SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80), SPH_C32(0x90a50000),
    SPH_C32(0x713e2879), SPH_C32(0x7ee98924), SPH_C32(0xf08ca062),
    SPH_C32(0x636f8bab) },
  { SPH_C32(0xb6980000), SPH_C32(0x00b70000), SPH_C32(0x499f0f00),
    SPH_C32(0xfd6d0000), SPH_C32(0x80637e55), SPH_C32(0x793a7b5b),
    SPH_C32(0x3093fc39), SPH_C32(0x5dc3e62e), SPH_C32(0xf9bd0000),
    SPH_C32(0xfeab0000), SPH_C32(0xcf080900), SPH_C32(0x05560000),
    SPH_C32(0x2c97007b), SPH_C32(0x361db598), SPH_C32(0x16d6024f),
    SPH_C32(0xed083c51) },
  { SPH_C32(0xfb120000), SPH_C32(0x49830000), SPH_C32(0x75140a00),
    SPH_C32(0x53ce0000), SPH_C32(0x961a45a8), SPH_C32(0xb65573ff),
    SPH_C32(0xbf8a16d5), SPH_C32(0x19fed62a), SPH_C32(0x35a90000),
    SPH_C32(0x5bc80000), SPH_C32(0x95b10e80), SPH_C32(0x3e060000),
    SPH_C32(0x67471384), SPH_C32(0xb1868180), SPH_C32(0x7f954a8e),
    SPH_C32(0x2752bbaf) },
  { SPH_C32(0x37060000), SPH_C32(0xece00000), SPH_C32(0x2fad0d80),
    SPH_C32(0x689e0000), SPH_C32(0xddca5657), SPH_C32(0x31ce47e7),
    SPH_C32(0xd6c95e14), SPH_C32(0xd3a451d4), SPH_C32(0xb4370000),
    SPH_C32(0xb79f0000), SPH_C32(0xf3830c00), SPH_C32(0xabf50000),
    SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c), SPH_C32(0x99cfe8a3),
    SPH_C32(0xa9350c55) }
};

__constant static const sph_u32 T512_40[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x835a0000), SPH_C32(0xc4f70000), SPH_C32(0x01470022),
    SPH_C32(0xeec80000), SPH_C32(0x60a54f69), SPH_C32(0x142f2a24),
    SPH_C32(0x5cf534f2), SPH_C32(0x3ea660f7), SPH_C32(0x88980000),
    SPH_C32(0x1f940000), SPH_C32(0x7fcf002e), SPH_C32(0xfb4e0000),
    SPH_C32(0xf158079a), SPH_C32(0x61ae9167), SPH_C32(0xa895706c),
    SPH_C32(0xe6107494) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0xdac80000), SPH_C32(0x36c00000), SPH_C32(0x15ae0060),
    SPH_C32(0x0bb10000), SPH_C32(0x6b697976), SPH_C32(0x248dd0a9),
    SPH_C32(0x67c3ff89), SPH_C32(0xb513679b), SPH_C32(0x584f0000),
    SPH_C32(0x729f0000), SPH_C32(0xe07f000a), SPH_C32(0x43790000),
    SPH_C32(0x9b1948bd), SPH_C32(0xe74476ba), SPH_C32(0x5d240486),
    SPH_C32(0xa72142f2) },
  { SPH_C32(0x59920000), SPH_C32(0xf2370000), SPH_C32(0x14e90042),
    SPH_C32(0xe5790000), SPH_C32(0x0bcc361f), SPH_C32(0x30a2fa8d),
    SPH_C32(0x3b36cb7b), SPH_C32(0x8bb5076c), SPH_C32(0xd0d70000),
    SPH_C32(0x6d0b0000), SPH_C32(0x9fb00024), SPH_C32(0xb8370000),
    SPH_C32(0x6a414f27), SPH_C32(0x86eae7dd), SPH_C32(0xf5b174ea),
    SPH_C32(0x41313666) },
  { SPH_C32(0xd10a0000), SPH_C32(0xeda30000), SPH_C32(0x6b26006c),
    SPH_C32(0x1e370000), SPH_C32(0xfa943185), SPH_C32(0x510c6bea),
    SPH_C32(0x93a3bb17), SPH_C32(0x6da573f8), SPH_C32(0xdb150000),
    SPH_C32(0xb6680000), SPH_C32(0xe1380028), SPH_C32(0xadb10000),
    SPH_C32(0xfbbc07d4), SPH_C32(0xf36b5c9e), SPH_C32(0x01d13074),
    SPH_C32(0x99872205) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0xdb150000), SPH_C32(0xb6680000), SPH_C32(0xe1380028),
    SPH_C32(0xadb10000), SPH_C32(0xfbbc07d4), SPH_C32(0xf36b5c9e),
    SPH_C32(0x01d13074), SPH_C32(0x99872205), SPH_C32(0x0a1f0000),
    SPH_C32(0x5bcb0000), SPH_C32(0x8a1e0044), SPH_C32(0xb3860000),
    SPH_C32(0x01283651), SPH_C32(0xa2673774), SPH_C32(0x92728b63),
    SPH_C32(0xf42251fd) },
  { SPH_C32(0x584f0000), SPH_C32(0x729f0000), SPH_C32(0xe07f000a),
    SPH_C32(0x43790000), SPH_C32(0x9b1948bd), SPH_C32(0xe74476ba),
    SPH_C32(0x5d240486), SPH_C32(0xa72142f2), SPH_C32(0x82870000),
    SPH_C32(0x445f0000), SPH_C32(0xf5d1006a), SPH_C32(0x48c80000),
    SPH_C32(0xf07031cb), SPH_C32(0xc3c9a613), SPH_C32(0x3ae7fb0f),
    SPH_C32(0x12322569) },
  { SPH_C32(0xd0d70000), SPH_C32(0x6d0b0000), SPH_C32(0x9fb00024),
    SPH_C32(0xb8370000), SPH_C32(0x6a414f27), SPH_C32(0x86eae7dd),
    SPH_C32(0xf5b174ea), SPH_C32(0x41313666), SPH_C32(0x89450000),
    SPH_C32(0x9f3c0000), SPH_C32(0x8b590066), SPH_C32(0x5d4e0000),
    SPH_C32(0x618d7938), SPH_C32(0xb6481d50), SPH_C32(0xce87bf91),
    SPH_C32(0xca84310a) },
  { SPH_C32(0x01dd0000), SPH_C32(0x80a80000), SPH_C32(0xf4960048),
    SPH_C32(0xa6000000), SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37),
    SPH_C32(0x6612cffd), SPH_C32(0x2c94459e), SPH_C32(0x52500000),
    SPH_C32(0x29540000), SPH_C32(0x6a61004e), SPH_C32(0xf0ff0000),
    SPH_C32(0x9a317eec), SPH_C32(0x452341ce), SPH_C32(0xcf568fe5),
    SPH_C32(0x5303130f) },
  { SPH_C32(0x89450000), SPH_C32(0x9f3c0000), SPH_C32(0x8b590066),
    SPH_C32(0x5d4e0000), SPH_C32(0x618d7938), SPH_C32(0xb6481d50),
    SPH_C32(0xce87bf91), SPH_C32(0xca84310a), SPH_C32(0x59920000),
    SPH_C32(0xf2370000), SPH_C32(0x14e90042), SPH_C32(0xe5790000),
    SPH_C32(0x0bcc361f), SPH_C32(0x30a2fa8d), SPH_C32(0x3b36cb7b),
    SPH_C32(0x8bb5076c) },
  { SPH_C32(0x0a1f0000), SPH_C32(0x5bcb0000), SPH_C32(0x8a1e0044),
    SPH_C32(0xb3860000), SPH_C32(0x01283651), SPH_C32(0xa2673774),
    SPH_C32(0x92728b63), SPH_C32(0xf42251fd), SPH_C32(0xd10a0000),
    SPH_C32(0xeda30000), SPH_C32(0x6b26006c), SPH_C32(0x1e370000),
    SPH_C32(0xfa943185), SPH_C32(0x510c6bea), SPH_C32(0x93a3bb17),
    SPH_C32(0x6da573f8) },
  { SPH_C32(0x82870000), SPH_C32(0x445f0000), SPH_C32(0xf5d1006a),
    SPH_C32(0x48c80000), SPH_C32(0xf07031cb), SPH_C32(0xc3c9a613),
    SPH_C32(0x3ae7fb0f), SPH_C32(0x12322569), SPH_C32(0xdac80000),
    SPH_C32(0x36c00000), SPH_C32(0x15ae0060), SPH_C32(0x0bb10000),
    SPH_C32(0x6b697976), SPH_C32(0x248dd0a9), SPH_C32(0x67c3ff89),
    SPH_C32(0xb513679b) }
};

__constant static const sph_u32 T512_44[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0x45190000), SPH_C32(0xab0c0000), SPH_C32(0x30be0001),
    SPH_C32(0x690a2000), SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d),
    SPH_C32(0x2dd1fa46), SPH_C32(0x24314f17), SPH_C32(0x58430000),
    SPH_C32(0x807e0000), SPH_C32(0x78330001), SPH_C32(0xc66b3800),
    SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd), SPH_C32(0xac73fe6f),
    SPH_C32(0x3a4479b1) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0xfd780000), SPH_C32(0x94580000), SPH_C32(0x3603001f),
    SPH_C32(0xbac53800), SPH_C32(0x68a95109), SPH_C32(0x017295e0),
    SPH_C32(0x5b4296b7), SPH_C32(0x315f30f7), SPH_C32(0x1ab70000),
    SPH_C32(0x99220000), SPH_C32(0xcff9000a), SPH_C32(0x386c1800),
    SPH_C32(0x66b90d6b), SPH_C32(0x80bed174), SPH_C32(0x75da660b),
    SPH_C32(0x8e008768) },
  { SPH_C32(0xb8610000), SPH_C32(0x3f540000), SPH_C32(0x06bd001e),
    SPH_C32(0xd3cf1800), SPH_C32(0xaa552310), SPH_C32(0xb0a615ed),
    SPH_C32(0x76936cf1), SPH_C32(0x156e7fe0), SPH_C32(0x42f40000),
    SPH_C32(0x195c0000), SPH_C32(0xb7ca000b), SPH_C32(0xfe072000),
    SPH_C32(0x818e51b7), SPH_C32(0xf913eea9), SPH_C32(0xd9a99864),
    SPH_C32(0xb444fed9) },
  { SPH_C32(0xe0220000), SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f),
    SPH_C32(0x15a42000), SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30),
    SPH_C32(0xdae0929e), SPH_C32(0x2f2a0651), SPH_C32(0x5fae0000),
    SPH_C32(0x322e0000), SPH_C32(0xff47000b), SPH_C32(0x51663800),
    SPH_C32(0xa4457f72), SPH_C32(0x316a5179), SPH_C32(0x580b9c4d),
    SPH_C32(0xaa31c87f) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0x5fae0000), SPH_C32(0x322e0000), SPH_C32(0xff47000b),
    SPH_C32(0x51663800), SPH_C32(0xa4457f72), SPH_C32(0x316a5179),
    SPH_C32(0x580b9c4d), SPH_C32(0xaa31c87f), SPH_C32(0xbf8c0000),
    SPH_C32(0x8d040000), SPH_C32(0x81c90014), SPH_C32(0x44c21800),
    SPH_C32(0xe92700be), SPH_C32(0xf8617b49), SPH_C32(0x82eb0ed3),
    SPH_C32(0x851bce2e) },
  { SPH_C32(0x1ab70000), SPH_C32(0x99220000), SPH_C32(0xcff9000a),
    SPH_C32(0x386c1800), SPH_C32(0x66b90d6b), SPH_C32(0x80bed174),
    SPH_C32(0x75da660b), SPH_C32(0x8e008768), SPH_C32(0xe7cf0000),
    SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015), SPH_C32(0x82a92000),
    SPH_C32(0x0e105c62), SPH_C32(0x81cc4494), SPH_C32(0x2e98f0bc),
    SPH_C32(0xbf5fb79f) },
  { SPH_C32(0x42f40000), SPH_C32(0x195c0000), SPH_C32(0xb7ca000b),
    SPH_C32(0xfe072000), SPH_C32(0x818e51b7), SPH_C32(0xf913eea9),
    SPH_C32(0xd9a99864), SPH_C32(0xb444fed9), SPH_C32(0xfa950000),
    SPH_C32(0x26080000), SPH_C32(0xb1770015), SPH_C32(0x2dc83800),
    SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44), SPH_C32(0xaf3af495),
    SPH_C32(0xa12a8139) },
  { SPH_C32(0xa2d60000), SPH_C32(0xa6760000), SPH_C32(0xc9440014),
    SPH_C32(0xeba30000), SPH_C32(0xccec2e7b), SPH_C32(0x3018c499),
    SPH_C32(0x03490afa), SPH_C32(0x9b6ef888), SPH_C32(0xa53b0000),
    SPH_C32(0x14260000), SPH_C32(0x4e30001e), SPH_C32(0x7cae0000),
    SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d), SPH_C32(0xf73168d8),
    SPH_C32(0x0b1b4946) },
  { SPH_C32(0xfa950000), SPH_C32(0x26080000), SPH_C32(0xb1770015),
    SPH_C32(0x2dc83800), SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44),
    SPH_C32(0xaf3af495), SPH_C32(0xa12a8139), SPH_C32(0xb8610000),
    SPH_C32(0x3f540000), SPH_C32(0x06bd001e), SPH_C32(0xd3cf1800),
    SPH_C32(0xaa552310), SPH_C32(0xb0a615ed), SPH_C32(0x76936cf1),
    SPH_C32(0x156e7fe0) },
  { SPH_C32(0xbf8c0000), SPH_C32(0x8d040000), SPH_C32(0x81c90014),
    SPH_C32(0x44c21800), SPH_C32(0xe92700be), SPH_C32(0xf8617b49),
    SPH_C32(0x82eb0ed3), SPH_C32(0x851bce2e), SPH_C32(0xe0220000),
    SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f), SPH_C32(0x15a42000),
    SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30), SPH_C32(0xdae0929e),
    SPH_C32(0x2f2a0651) },
  { SPH_C32(0xe7cf0000), SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015),
    SPH_C32(0x82a92000), SPH_C32(0x0e105c62), SPH_C32(0x81cc4494),
    SPH_C32(0x2e98f0bc), SPH_C32(0xbf5fb79f), SPH_C32(0xfd780000),
    SPH_C32(0x94580000), SPH_C32(0x3603001f), SPH_C32(0xbac53800),
    SPH_C32(0x68a95109), SPH_C32(0x017295e0), SPH_C32(0x5b4296b7),
    SPH_C32(0x315f30f7) }
};

__constant static const sph_u32 T512_48[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0xb82f0000), SPH_C32(0xb12c0000), SPH_C32(0x30d80000),
    SPH_C32(0x14445000), SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec),
    SPH_C32(0x2e98bf23), SPH_C32(0x551e3d6e), SPH_C32(0x02f20000),
    SPH_C32(0xa2810000), SPH_C32(0x873f0000), SPH_C32(0xe36c7800),
    SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6), SPH_C32(0xc4c23237),
    SPH_C32(0x7f32259e) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0x1c9e0000), SPH_C32(0x66c30000), SPH_C32(0x0d110000),
    SPH_C32(0x5fdac000), SPH_C32(0x32596759), SPH_C32(0x8cc0f80c),
    SPH_C32(0xaece29ff), SPH_C32(0xc6afe775), SPH_C32(0x288b0000),
    SPH_C32(0x0d770000), SPH_C32(0x5db60000), SPH_C32(0x1f991800),
    SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3), SPH_C32(0x5b06af40),
    SPH_C32(0x19e93cbf) },
  { SPH_C32(0xa4b10000), SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000),
    SPH_C32(0x4b9e9000), SPH_C32(0xf30107fb), SPH_C32(0xbde710e0),
    SPH_C32(0x805696dc), SPH_C32(0x93b1da1b), SPH_C32(0x2a790000),
    SPH_C32(0xaff60000), SPH_C32(0xda890000), SPH_C32(0xfcf56000),
    SPH_C32(0x686d3607), SPH_C32(0xdadc8975), SPH_C32(0x9fc49d77),
    SPH_C32(0x66db1921) },
  { SPH_C32(0xa6430000), SPH_C32(0x756e0000), SPH_C32(0xbaf60000),
    SPH_C32(0xa8f2e800), SPH_C32(0xed1c7314), SPH_C32(0xbada3b36),
    SPH_C32(0x4494a4eb), SPH_C32(0xec83ff85), SPH_C32(0x90a40000),
    SPH_C32(0xbc5b0000), SPH_C32(0x6d6e0000), SPH_C32(0x0bdd4800),
    SPH_C32(0xb728224a), SPH_C32(0xecc64a4f), SPH_C32(0x759e1063),
    SPH_C32(0x4cf701d1) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x90a40000), SPH_C32(0xbc5b0000), SPH_C32(0x6d6e0000),
    SPH_C32(0x0bdd4800), SPH_C32(0xb728224a), SPH_C32(0xecc64a4f),
    SPH_C32(0x759e1063), SPH_C32(0x4cf701d1), SPH_C32(0x36e70000),
    SPH_C32(0xc9350000), SPH_C32(0xd7980000), SPH_C32(0xa32fa000),
    SPH_C32(0x5a34515e), SPH_C32(0x561c7179), SPH_C32(0x310ab488),
    SPH_C32(0xa074fe54) },
  { SPH_C32(0x288b0000), SPH_C32(0x0d770000), SPH_C32(0x5db60000),
    SPH_C32(0x1f991800), SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3),
    SPH_C32(0x5b06af40), SPH_C32(0x19e93cbf), SPH_C32(0x34150000),
    SPH_C32(0x6bb40000), SPH_C32(0x50a70000), SPH_C32(0x4043d800),
    SPH_C32(0x442925b1), SPH_C32(0x51215aaf), SPH_C32(0xf5c886bf),
    SPH_C32(0xdf46dbca) },
  { SPH_C32(0x2a790000), SPH_C32(0xaff60000), SPH_C32(0xda890000),
    SPH_C32(0xfcf56000), SPH_C32(0x686d3607), SPH_C32(0xdadc8975),
    SPH_C32(0x9fc49d77), SPH_C32(0x66db1921), SPH_C32(0x8ec80000),
    SPH_C32(0x78190000), SPH_C32(0xe7400000), SPH_C32(0xb76bf000),
    SPH_C32(0x9b6c31fc), SPH_C32(0x673b9995), SPH_C32(0x1f920bab),
    SPH_C32(0xf56ac33a) },
  { SPH_C32(0x8c3a0000), SPH_C32(0xda980000), SPH_C32(0x607f0000),
    SPH_C32(0x54078800), SPH_C32(0x85714513), SPH_C32(0x6006b243),
    SPH_C32(0xdb50399c), SPH_C32(0x8a58e6a4), SPH_C32(0x1e6c0000),
    SPH_C32(0xc4420000), SPH_C32(0x8a2e0000), SPH_C32(0xbcb6b800),
    SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da), SPH_C32(0x6a0c1bc8),
    SPH_C32(0xb99dc2eb) },
  { SPH_C32(0x8ec80000), SPH_C32(0x78190000), SPH_C32(0xe7400000),
    SPH_C32(0xb76bf000), SPH_C32(0x9b6c31fc), SPH_C32(0x673b9995),
    SPH_C32(0x1f920bab), SPH_C32(0xf56ac33a), SPH_C32(0xa4b10000),
    SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000), SPH_C32(0x4b9e9000),
    SPH_C32(0xf30107fb), SPH_C32(0xbde710e0), SPH_C32(0x805696dc),
    SPH_C32(0x93b1da1b) },
  { SPH_C32(0x36e70000), SPH_C32(0xc9350000), SPH_C32(0xd7980000),
    SPH_C32(0xa32fa000), SPH_C32(0x5a34515e), SPH_C32(0x561c7179),
    SPH_C32(0x310ab488), SPH_C32(0xa074fe54), SPH_C32(0xa6430000),
    SPH_C32(0x756e0000), SPH_C32(0xbaf60000), SPH_C32(0xa8f2e800),
    SPH_C32(0xed1c7314), SPH_C32(0xbada3b36), SPH_C32(0x4494a4eb),
    SPH_C32(0xec83ff85) },
  { SPH_C32(0x34150000), SPH_C32(0x6bb40000), SPH_C32(0x50a70000),
    SPH_C32(0x4043d800), SPH_C32(0x442925b1), SPH_C32(0x51215aaf),
    SPH_C32(0xf5c886bf), SPH_C32(0xdf46dbca), SPH_C32(0x1c9e0000),
    SPH_C32(0x66c30000), SPH_C32(0x0d110000), SPH_C32(0x5fdac000),
    SPH_C32(0x32596759), SPH_C32(0x8cc0f80c), SPH_C32(0xaece29ff),
    SPH_C32(0xc6afe775) }
};

__constant static const sph_u32 T512_52[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0x16ed0000), SPH_C32(0x15680000), SPH_C32(0xedd70000),
    SPH_C32(0x325d0220), SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643),
    SPH_C32(0xe375f8a8), SPH_C32(0x81fdf908), SPH_C32(0xe6280000),
    SPH_C32(0x4c4b0000), SPH_C32(0xa8550000), SPH_C32(0xd3d002e0),
    SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da), SPH_C32(0x289506b4),
    SPH_C32(0xd75a4897) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0x52190000), SPH_C32(0x3b780000), SPH_C32(0x19080000),
    SPH_C32(0xac000600), SPH_C32(0xa0c35180), SPH_C32(0x49b17387),
    SPH_C32(0xfac3d23d), SPH_C32(0x99353c49), SPH_C32(0x13c30000),
    SPH_C32(0xe4e20000), SPH_C32(0xc2910000), SPH_C32(0x5e7f00a0),
    SPH_C32(0x15d70c2b), SPH_C32(0x4f5861c8), SPH_C32(0xb825551a),
    SPH_C32(0x0d71a4a6) },
  { SPH_C32(0x44f40000), SPH_C32(0x2e100000), SPH_C32(0xf4df0000),
    SPH_C32(0x9e5d0420), SPH_C32(0x43cf6709), SPH_C32(0x13fb95c4),
    SPH_C32(0x19b62a95), SPH_C32(0x18c8c541), SPH_C32(0xf5eb0000),
    SPH_C32(0xa8a90000), SPH_C32(0x6ac40000), SPH_C32(0x8daf0240),
    SPH_C32(0xcdb63c93), SPH_C32(0xd7ffd112), SPH_C32(0x90b053ae),
    SPH_C32(0xda2bec31) },
  { SPH_C32(0xa2dc0000), SPH_C32(0x625b0000), SPH_C32(0x5c8a0000),
    SPH_C32(0x4d8d06c0), SPH_C32(0x9bae57b1), SPH_C32(0x8b5c251e),
    SPH_C32(0x31232c21), SPH_C32(0xcf928dd6), SPH_C32(0x052e0000),
    SPH_C32(0xf18a0000), SPH_C32(0x2f460000), SPH_C32(0x6c220280),
    SPH_C32(0xf6db3aa2), SPH_C32(0x1512878b), SPH_C32(0x5b50adb2),
    SPH_C32(0x8c8c5dae) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x052e0000), SPH_C32(0xf18a0000), SPH_C32(0x2f460000),
    SPH_C32(0x6c220280), SPH_C32(0xf6db3aa2), SPH_C32(0x1512878b),
    SPH_C32(0x5b50adb2), SPH_C32(0x8c8c5dae), SPH_C32(0xa7f20000),
    SPH_C32(0x93d10000), SPH_C32(0x73cc0000), SPH_C32(0x21af0440),
    SPH_C32(0x6d756d13), SPH_C32(0x9e4ea295), SPH_C32(0x6a738193),
    SPH_C32(0x431ed078) },
  { SPH_C32(0x13c30000), SPH_C32(0xe4e20000), SPH_C32(0xc2910000),
    SPH_C32(0x5e7f00a0), SPH_C32(0x15d70c2b), SPH_C32(0x4f5861c8),
    SPH_C32(0xb825551a), SPH_C32(0x0d71a4a6), SPH_C32(0x41da0000),
    SPH_C32(0xdf9a0000), SPH_C32(0xdb990000), SPH_C32(0xf27f06a0),
    SPH_C32(0xb5145dab), SPH_C32(0x06e9124f), SPH_C32(0x42e68727),
    SPH_C32(0x944498ef) },
  { SPH_C32(0xf5eb0000), SPH_C32(0xa8a90000), SPH_C32(0x6ac40000),
    SPH_C32(0x8daf0240), SPH_C32(0xcdb63c93), SPH_C32(0xd7ffd112),
    SPH_C32(0x90b053ae), SPH_C32(0xda2bec31), SPH_C32(0xb11f0000),
    SPH_C32(0x86b90000), SPH_C32(0x9e1b0000), SPH_C32(0x13f20660),
    SPH_C32(0x8e795b9a), SPH_C32(0xc40444d6), SPH_C32(0x8906793b),
    SPH_C32(0xc2e32970) },
  { SPH_C32(0x57370000), SPH_C32(0xcaf20000), SPH_C32(0x364e0000),
    SPH_C32(0xc0220480), SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c),
    SPH_C32(0xa1937f8f), SPH_C32(0x15b961e7), SPH_C32(0xb4310000),
    SPH_C32(0x77330000), SPH_C32(0xb15d0000), SPH_C32(0x7fd004e0),
    SPH_C32(0x78a26138), SPH_C32(0xd116c35d), SPH_C32(0xd256d489),
    SPH_C32(0x4e6f74de) },
  { SPH_C32(0xb11f0000), SPH_C32(0x86b90000), SPH_C32(0x9e1b0000),
    SPH_C32(0x13f20660), SPH_C32(0x8e795b9a), SPH_C32(0xc40444d6),
    SPH_C32(0x8906793b), SPH_C32(0xc2e32970), SPH_C32(0x44f40000),
    SPH_C32(0x2e100000), SPH_C32(0xf4df0000), SPH_C32(0x9e5d0420),
    SPH_C32(0x43cf6709), SPH_C32(0x13fb95c4), SPH_C32(0x19b62a95),
    SPH_C32(0x18c8c541) },
  { SPH_C32(0xa7f20000), SPH_C32(0x93d10000), SPH_C32(0x73cc0000),
    SPH_C32(0x21af0440), SPH_C32(0x6d756d13), SPH_C32(0x9e4ea295),
    SPH_C32(0x6a738193), SPH_C32(0x431ed078), SPH_C32(0xa2dc0000),
    SPH_C32(0x625b0000), SPH_C32(0x5c8a0000), SPH_C32(0x4d8d06c0),
    SPH_C32(0x9bae57b1), SPH_C32(0x8b5c251e), SPH_C32(0x31232c21),
    SPH_C32(0xcf928dd6) },
  { SPH_C32(0x41da0000), SPH_C32(0xdf9a0000), SPH_C32(0xdb990000),
    SPH_C32(0xf27f06a0), SPH_C32(0xb5145dab), SPH_C32(0x06e9124f),
    SPH_C32(0x42e68727), SPH_C32(0x944498ef), SPH_C32(0x52190000),
    SPH_C32(0x3b780000), SPH_C32(0x19080000), SPH_C32(0xac000600),
    SPH_C32(0xa0c35180), SPH_C32(0x49b17387), SPH_C32(0xfac3d23d),
    SPH_C32(0x99353c49) }
};

__constant static const sph_u32 T512_56[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0x5fec0000), SPH_C32(0x294b0000), SPH_C32(0x99d20000),
    SPH_C32(0x4ed00012), SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9),
    SPH_C32(0x57140bdf), SPH_C32(0x30aebcf7), SPH_C32(0x5fa80000),
    SPH_C32(0x56030000), SPH_C32(0x43ae0000), SPH_C32(0x64f30013),
    SPH_C32(0x257e86bf), SPH_C32(0x1311944e), SPH_C32(0x541e95bf),
    SPH_C32(0x8ea4db69) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0xb13b0000), SPH_C32(0x80040000), SPH_C32(0xd16f0000),
    SPH_C32(0x4f6b01f3), SPH_C32(0xb12faec3), SPH_C32(0x287d6f19),
    SPH_C32(0x112fb6cb), SPH_C32(0xaebbb10d), SPH_C32(0x7b6c0000),
    SPH_C32(0x280a0000), SPH_C32(0x73990000), SPH_C32(0x496000a1),
    SPH_C32(0xa5768de3), SPH_C32(0xc42f093c), SPH_C32(0x24f2a563),
    SPH_C32(0x79f5076e) },
  { SPH_C32(0xeed70000), SPH_C32(0xa94f0000), SPH_C32(0x48bd0000),
    SPH_C32(0x01bb01e1), SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0),
    SPH_C32(0x463bbd14), SPH_C32(0x9e150dfa), SPH_C32(0x24c40000),
    SPH_C32(0x7e090000), SPH_C32(0x30370000), SPH_C32(0x2d9300b2),
    SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72), SPH_C32(0x70ec30dc),
    SPH_C32(0xf751dc07) },
  { SPH_C32(0xb17f0000), SPH_C32(0xff4c0000), SPH_C32(0x0b130000),
    SPH_C32(0x654801f2), SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e),
    SPH_C32(0x122528ab), SPH_C32(0x10b1d693), SPH_C32(0x24800000),
    SPH_C32(0x01410000), SPH_C32(0xea4b0000), SPH_C32(0x07b000b3),
    SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5), SPH_C32(0x73e6aebc),
    SPH_C32(0x495bbb99) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) },
  { SPH_C32(0x24800000), SPH_C32(0x01410000), SPH_C32(0xea4b0000),
    SPH_C32(0x07b000b3), SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5),
    SPH_C32(0x73e6aebc), SPH_C32(0x495bbb99), SPH_C32(0x95ff0000),
    SPH_C32(0xfe0d0000), SPH_C32(0xe1580000), SPH_C32(0x62f80141),
    SPH_C32(0x3127a59f), SPH_C32(0xff43f26b), SPH_C32(0x61c38617),
    SPH_C32(0x59ea6d0a) },
  { SPH_C32(0x7b6c0000), SPH_C32(0x280a0000), SPH_C32(0x73990000),
    SPH_C32(0x496000a1), SPH_C32(0xa5768de3), SPH_C32(0xc42f093c),
    SPH_C32(0x24f2a563), SPH_C32(0x79f5076e), SPH_C32(0xca570000),
    SPH_C32(0xa80e0000), SPH_C32(0xa2f60000), SPH_C32(0x060b0152),
    SPH_C32(0x14592320), SPH_C32(0xec526625), SPH_C32(0x35dd13a8),
    SPH_C32(0xd74eb663) },
  { SPH_C32(0x24c40000), SPH_C32(0x7e090000), SPH_C32(0x30370000),
    SPH_C32(0x2d9300b2), SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72),
    SPH_C32(0x70ec30dc), SPH_C32(0xf751dc07), SPH_C32(0xca130000),
    SPH_C32(0xd7460000), SPH_C32(0x788a0000), SPH_C32(0x2c280153),
    SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2), SPH_C32(0x36d78dc8),
    SPH_C32(0x6944d1fd) },
  { SPH_C32(0x95bb0000), SPH_C32(0x81450000), SPH_C32(0x3b240000),
    SPH_C32(0x48db0140), SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec),
    SPH_C32(0x62c91877), SPH_C32(0xe7e00a94), SPH_C32(0xee930000),
    SPH_C32(0xd6070000), SPH_C32(0x92c10000), SPH_C32(0x2b9801e0),
    SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57), SPH_C32(0x45312374),
    SPH_C32(0x201f6a64) },
  { SPH_C32(0xca130000), SPH_C32(0xd7460000), SPH_C32(0x788a0000),
    SPH_C32(0x2c280153), SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2),
    SPH_C32(0x36d78dc8), SPH_C32(0x6944d1fd), SPH_C32(0xeed70000),
    SPH_C32(0xa94f0000), SPH_C32(0x48bd0000), SPH_C32(0x01bb01e1),
    SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0), SPH_C32(0x463bbd14),
    SPH_C32(0x9e150dfa) },
  { SPH_C32(0x95ff0000), SPH_C32(0xfe0d0000), SPH_C32(0xe1580000),
    SPH_C32(0x62f80141), SPH_C32(0x3127a59f), SPH_C32(0xff43f26b),
    SPH_C32(0x61c38617), SPH_C32(0x59ea6d0a), SPH_C32(0xb17f0000),
    SPH_C32(0xff4c0000), SPH_C32(0x0b130000), SPH_C32(0x654801f2),
    SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e), SPH_C32(0x122528ab),
    SPH_C32(0x10b1d693) },
  { SPH_C32(0xca570000), SPH_C32(0xa80e0000), SPH_C32(0xa2f60000),
    SPH_C32(0x060b0152), SPH_C32(0x14592320), SPH_C32(0xec526625),
    SPH_C32(0x35dd13a8), SPH_C32(0xd74eb663), SPH_C32(0xb13b0000),
    SPH_C32(0x80040000), SPH_C32(0xd16f0000), SPH_C32(0x4f6b01f3),
    SPH_C32(0xb12faec3), SPH_C32(0x287d6f19), SPH_C32(0x112fb6cb),
    SPH_C32(0xaebbb10d) }
};

__constant static const sph_u32 T512_60[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0xabe70000), SPH_C32(0x9e0d0000), SPH_C32(0xaf270000),
    SPH_C32(0x3d180005), SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695),
    SPH_C32(0xb5c347eb), SPH_C32(0x3c5dfffe), SPH_C32(0x033d0000),
    SPH_C32(0x08b30000), SPH_C32(0xf33a0000), SPH_C32(0x3ac20007),
    SPH_C32(0x51298a50), SPH_C32(0x6b6e661f), SPH_C32(0x0ea5cfe3),
    SPH_C32(0xe6da7ffe) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0x02ae0000), SPH_C32(0xef310000), SPH_C32(0x1ec10000),
    SPH_C32(0xf5ce000c), SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231),
    SPH_C32(0x0893ae02), SPH_C32(0xb5b5e185), SPH_C32(0x3af20000),
    SPH_C32(0x4a3b0000), SPH_C32(0x0be70000), SPH_C32(0x51060001),
    SPH_C32(0xc78fb695), SPH_C32(0x4577d386), SPH_C32(0x2ba87f5a),
    SPH_C32(0xa191f5d7) },
  { SPH_C32(0xa9490000), SPH_C32(0x713c0000), SPH_C32(0xb1e60000),
    SPH_C32(0xc8d60009), SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4),
    SPH_C32(0xbd50e9e9), SPH_C32(0x89e81e7b), SPH_C32(0x39cf0000),
    SPH_C32(0x42880000), SPH_C32(0xf8dd0000), SPH_C32(0x6bc40006),
    SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599), SPH_C32(0x250db0b9),
    SPH_C32(0x474b8a29) },
  { SPH_C32(0xaa740000), SPH_C32(0x798f0000), SPH_C32(0x42dc0000),
    SPH_C32(0xf214000e), SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb),
    SPH_C32(0xb3f5260a), SPH_C32(0x6f326185), SPH_C32(0x91150000),
    SPH_C32(0xd4360000), SPH_C32(0xa4c00000), SPH_C32(0x6c1e0004),
    SPH_C32(0xebc0a946), SPH_C32(0x3181c513), SPH_C32(0x9e6b38b1),
    SPH_C32(0x9dcc0a29) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x91150000), SPH_C32(0xd4360000), SPH_C32(0xa4c00000),
    SPH_C32(0x6c1e0004), SPH_C32(0xebc0a946), SPH_C32(0x3181c513),
    SPH_C32(0x9e6b38b1), SPH_C32(0x9dcc0a29), SPH_C32(0x3b610000),
    SPH_C32(0xadb90000), SPH_C32(0xe61c0000), SPH_C32(0x9e0a000a),
    SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8), SPH_C32(0x2d9e1ebb),
    SPH_C32(0xf2fe6bac) },
  { SPH_C32(0x3af20000), SPH_C32(0x4a3b0000), SPH_C32(0x0be70000),
    SPH_C32(0x51060001), SPH_C32(0xc78fb695), SPH_C32(0x4577d386),
    SPH_C32(0x2ba87f5a), SPH_C32(0xa191f5d7), SPH_C32(0x385c0000),
    SPH_C32(0xa50a0000), SPH_C32(0x15260000), SPH_C32(0xa4c8000d),
    SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7), SPH_C32(0x233bd158),
    SPH_C32(0x14241452) },
  { SPH_C32(0x39cf0000), SPH_C32(0x42880000), SPH_C32(0xf8dd0000),
    SPH_C32(0x6bc40006), SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599),
    SPH_C32(0x250db0b9), SPH_C32(0x474b8a29), SPH_C32(0x90860000),
    SPH_C32(0x33b40000), SPH_C32(0x493b0000), SPH_C32(0xa312000f),
    SPH_C32(0x6610241e), SPH_C32(0x8d22713d), SPH_C32(0x985d5950),
    SPH_C32(0xcea39452) },
  { SPH_C32(0x93bb0000), SPH_C32(0x3b070000), SPH_C32(0xba010000),
    SPH_C32(0x99d00008), SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722),
    SPH_C32(0x96f896b3), SPH_C32(0x2879ebac), SPH_C32(0x01930000),
    SPH_C32(0xe7820000), SPH_C32(0xedfb0000), SPH_C32(0xcf0c000b),
    SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e), SPH_C32(0x063661e1),
    SPH_C32(0x536f9e7b) },
  { SPH_C32(0x90860000), SPH_C32(0x33b40000), SPH_C32(0x493b0000),
    SPH_C32(0xa312000f), SPH_C32(0x6610241e), SPH_C32(0x8d22713d),
    SPH_C32(0x985d5950), SPH_C32(0xcea39452), SPH_C32(0xa9490000),
    SPH_C32(0x713c0000), SPH_C32(0xb1e60000), SPH_C32(0xc8d60009),
    SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4), SPH_C32(0xbd50e9e9),
    SPH_C32(0x89e81e7b) },
  { SPH_C32(0x3b610000), SPH_C32(0xadb90000), SPH_C32(0xe61c0000),
    SPH_C32(0x9e0a000a), SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8),
    SPH_C32(0x2d9e1ebb), SPH_C32(0xf2fe6bac), SPH_C32(0xaa740000),
    SPH_C32(0x798f0000), SPH_C32(0x42dc0000), SPH_C32(0xf214000e),
    SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb), SPH_C32(0xb3f5260a),
    SPH_C32(0x6f326185) },
  { SPH_C32(0x385c0000), SPH_C32(0xa50a0000), SPH_C32(0x15260000),
    SPH_C32(0xa4c8000d), SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7),
    SPH_C32(0x233bd158), SPH_C32(0x14241452), SPH_C32(0x02ae0000),
    SPH_C32(0xef310000), SPH_C32(0x1ec10000), SPH_C32(0xf5ce000c),
    SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231), SPH_C32(0x0893ae02),
    SPH_C32(0xb5b5e185) }
};

#define INPUT_BIG   do { \
    unsigned acc = buf(0); \
    __constant const sph_u32 *rp; \
    rp = &T512_0[acc >> 4][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    m8 = rp[8]; \
    m9 = rp[9]; \
    mA = rp[10]; \
    mB = rp[11]; \
    mC = rp[12]; \
    mD = rp[13]; \
    mE = rp[14]; \
    mF = rp[15]; \
    rp = &T512_4[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(1); \
    rp = &T512_8[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_12[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(2); \
    rp = &T512_16[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_20[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(3); \
    rp = &T512_24[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_28[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(4); \
    rp = &T512_32[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_36[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(5); \
    rp = &T512_40[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_44[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(6); \
    rp = &T512_48[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_52[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(7); \
    rp = &T512_56[acc >> 4][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_60[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 5

__constant static const sph_u32 T512_0[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0x774f4800), SPH_C32(0x22540000), SPH_C32(0x31110000),
    SPH_C32(0x5ab00000), SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8),
    SPH_C32(0x69744ba2), SPH_C32(0x893fd19d), SPH_C32(0xab863000),
    SPH_C32(0xc1830000), SPH_C32(0x07b10000), SPH_C32(0xe7870000),
    SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5), SPH_C32(0x066b5ec5),
    SPH_C32(0x45600cf3) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0xbfdc0c00), SPH_C32(0x786a0000), SPH_C32(0x66960000),
    SPH_C32(0x16e60000), SPH_C32(0x2af76720), SPH_C32(0x19b270bd),
    SPH_C32(0x41c239e5), SPH_C32(0xa4ee2836), SPH_C32(0xffae6c00),
    SPH_C32(0x2b6e0000), SPH_C32(0xc2670000), SPH_C32(0x46420000),
    SPH_C32(0x57343d3c), SPH_C32(0x3d5e8924), SPH_C32(0x6ddb1f58),
    SPH_C32(0x107b3b71) },
  { SPH_C32(0xc8934400), SPH_C32(0x5a3e0000), SPH_C32(0x57870000),
    SPH_C32(0x4c560000), SPH_C32(0xea982435), SPH_C32(0x75b11115),
    SPH_C32(0x28b67247), SPH_C32(0x2dd1f9ab), SPH_C32(0x54285c00),
    SPH_C32(0xeaed0000), SPH_C32(0xc5d60000), SPH_C32(0xa1c50000),
    SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1), SPH_C32(0x6bb0419d),
    SPH_C32(0x551b3782) },
  { SPH_C32(0xebf45000), SPH_C32(0x92870000), SPH_C32(0xa3400000),
    SPH_C32(0xb7230000), SPH_C32(0x99550050), SPH_C32(0x8d17b45c),
    SPH_C32(0x2a727878), SPH_C32(0xf1f51fb4), SPH_C32(0x63157400),
    SPH_C32(0x9bbd0000), SPH_C32(0x50360000), SPH_C32(0xabd10000),
    SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0), SPH_C32(0x2edd2c82),
    SPH_C32(0x68b1f558) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0x0a238800), SPH_C32(0xac5e0000), SPH_C32(0x068c0000),
    SPH_C32(0x39860000), SPH_C32(0x7d136aea), SPH_C32(0xae64920c),
    SPH_C32(0xf1244866), SPH_C32(0x512978db), SPH_C32(0x71502400),
    SPH_C32(0x79320000), SPH_C32(0x48bd0000), SPH_C32(0xb0c90000),
    SPH_C32(0xd73e604b), SPH_C32(0x0cf0b3a2), SPH_C32(0x64e7a370),
    SPH_C32(0x8286c938) },
  { SPH_C32(0x7d6cc000), SPH_C32(0x8e0a0000), SPH_C32(0x379d0000),
    SPH_C32(0x63360000), SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4),
    SPH_C32(0x985003c4), SPH_C32(0xd816a946), SPH_C32(0xdad61400),
    SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000), SPH_C32(0x574e0000),
    SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67), SPH_C32(0x628cfdb5),
    SPH_C32(0xc7e6c5cb) },
  { SPH_C32(0x5e0bd400), SPH_C32(0x46b30000), SPH_C32(0xc35a0000),
    SPH_C32(0x98430000), SPH_C32(0xceb10d9a), SPH_C32(0x3ac156ed),
    SPH_C32(0x9a9409fb), SPH_C32(0x04324f59), SPH_C32(0xedeb3c00),
    SPH_C32(0xc9e10000), SPH_C32(0xdaec0000), SPH_C32(0x5d5a0000),
    SPH_C32(0x8e04230e), SPH_C32(0xede46656), SPH_C32(0x27e190aa),
    SPH_C32(0xfa4c0711) },
  { SPH_C32(0xb5ff8400), SPH_C32(0xd4340000), SPH_C32(0x601a0000),
    SPH_C32(0x2f600000), SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1),
    SPH_C32(0xb0e67183), SPH_C32(0xf5c750ed), SPH_C32(0x8efe4800),
    SPH_C32(0x525c0000), SPH_C32(0x8ada0000), SPH_C32(0xf68b0000),
    SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86), SPH_C32(0x093cbc28),
    SPH_C32(0x92fdf249) },
  { SPH_C32(0x96989000), SPH_C32(0x1c8d0000), SPH_C32(0x94dd0000),
    SPH_C32(0xd4150000), SPH_C32(0x242929af), SPH_C32(0x4f7047f8),
    SPH_C32(0xb2227bbc), SPH_C32(0x29e3b6f2), SPH_C32(0xb9c36000),
    SPH_C32(0x230c0000), SPH_C32(0x1f3a0000), SPH_C32(0xfc9f0000),
    SPH_C32(0x3da6447e), SPH_C32(0x7941a2b7), SPH_C32(0x4c51d137),
    SPH_C32(0xaf573093) },
  { SPH_C32(0xe1d7d800), SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000),
    SPH_C32(0x8ea50000), SPH_C32(0xe4466aba), SPH_C32(0x23732650),
    SPH_C32(0xdb56301e), SPH_C32(0xa0dc676f), SPH_C32(0x12455000),
    SPH_C32(0xe28f0000), SPH_C32(0x188b0000), SPH_C32(0x1b180000),
    SPH_C32(0xd9301e32), SPH_C32(0xd0baef72), SPH_C32(0x4a3a8ff2),
    SPH_C32(0xea373c60) },
  { SPH_C32(0xc2b0cc00), SPH_C32(0xf6600000), SPH_C32(0x510b0000),
    SPH_C32(0x75d00000), SPH_C32(0x978b4edf), SPH_C32(0xdbd58319),
    SPH_C32(0xd9923a21), SPH_C32(0x7cf88170), SPH_C32(0x25787800),
    SPH_C32(0x93df0000), SPH_C32(0x8d6b0000), SPH_C32(0x110c0000),
    SPH_C32(0x649c073b), SPH_C32(0x98557743), SPH_C32(0x0f57e2ed),
    SPH_C32(0xd79dfeba) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0x650a1800), SPH_C32(0xc0db0000), SPH_C32(0x299a0000),
    SPH_C32(0x41a80000), SPH_C32(0x195f5d27), SPH_C32(0xbcb98eda),
    SPH_C32(0x234ec450), SPH_C32(0x6308edfd), SPH_C32(0x5814b800),
    SPH_C32(0x1dd50000), SPH_C32(0xbaf60000), SPH_C32(0x723a0000),
    SPH_C32(0xd9e02ec4), SPH_C32(0x5a3284e7), SPH_C32(0x9707e129),
    SPH_C32(0x0f8b57fc) },
  { SPH_C32(0x12455000), SPH_C32(0xe28f0000), SPH_C32(0x188b0000),
    SPH_C32(0x1b180000), SPH_C32(0xd9301e32), SPH_C32(0xd0baef72),
    SPH_C32(0x4a3a8ff2), SPH_C32(0xea373c60), SPH_C32(0xf3928800),
    SPH_C32(0xdc560000), SPH_C32(0xbd470000), SPH_C32(0x95bd0000),
    SPH_C32(0x3d767488), SPH_C32(0xf3c9c922), SPH_C32(0x916cbfec),
    SPH_C32(0x4aeb5b0f) },
  { SPH_C32(0x31224400), SPH_C32(0x2a360000), SPH_C32(0xec4c0000),
    SPH_C32(0xe06d0000), SPH_C32(0xaafd3a57), SPH_C32(0x281c4a3b),
    SPH_C32(0x48fe85cd), SPH_C32(0x3613da7f), SPH_C32(0xc4afa000),
    SPH_C32(0xad060000), SPH_C32(0x28a70000), SPH_C32(0x9fa90000),
    SPH_C32(0x80da6d81), SPH_C32(0xbb265113), SPH_C32(0xd401d2f3),
    SPH_C32(0x774199d5) },
  { SPH_C32(0xdad61400), SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000),
    SPH_C32(0x574e0000), SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67),
    SPH_C32(0x628cfdb5), SPH_C32(0xc7e6c5cb), SPH_C32(0xa7bad400),
    SPH_C32(0x36bb0000), SPH_C32(0x78910000), SPH_C32(0x34780000),
    SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3), SPH_C32(0xfadcfe71),
    SPH_C32(0x1ff06c8d) },
  { SPH_C32(0xf9b10000), SPH_C32(0x70080000), SPH_C32(0xbbcb0000),
    SPH_C32(0xac3b0000), SPH_C32(0x40651e62), SPH_C32(0x5dad5b2e),
    SPH_C32(0x6048f78a), SPH_C32(0x1bc223d4), SPH_C32(0x9087fc00),
    SPH_C32(0x47eb0000), SPH_C32(0xed710000), SPH_C32(0x3e6c0000),
    SPH_C32(0x33780af1), SPH_C32(0x2f8395f2), SPH_C32(0xbfb1936e),
    SPH_C32(0x225aae57) },
  { SPH_C32(0x8efe4800), SPH_C32(0x525c0000), SPH_C32(0x8ada0000),
    SPH_C32(0xf68b0000), SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86),
    SPH_C32(0x093cbc28), SPH_C32(0x92fdf249), SPH_C32(0x3b01cc00),
    SPH_C32(0x86680000), SPH_C32(0xeac00000), SPH_C32(0xd9eb0000),
    SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837), SPH_C32(0xb9dacdab),
    SPH_C32(0x673aa2a4) },
  { SPH_C32(0xad995c00), SPH_C32(0x9ae50000), SPH_C32(0x7e1d0000),
    SPH_C32(0x0dfe0000), SPH_C32(0xf3c77912), SPH_C32(0xc9089fcf),
    SPH_C32(0x0bf8b617), SPH_C32(0x4ed91456), SPH_C32(0x0c3ce400),
    SPH_C32(0xf7380000), SPH_C32(0x7f200000), SPH_C32(0xd3ff0000),
    SPH_C32(0x6a4249b4), SPH_C32(0xce974006), SPH_C32(0xfcb7a0b4),
    SPH_C32(0x5a90607e) },
  { SPH_C32(0x6f299000), SPH_C32(0x6c850000), SPH_C32(0x2f160000),
    SPH_C32(0x782e0000), SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6),
    SPH_C32(0xd26a8c36), SPH_C32(0x32219526), SPH_C32(0x29449c00),
    SPH_C32(0x64e70000), SPH_C32(0xf24b0000), SPH_C32(0xc2f30000),
    SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745), SPH_C32(0xf3e04259),
    SPH_C32(0x8d0d9ec4) },
  { SPH_C32(0x4c4e8400), SPH_C32(0xa43c0000), SPH_C32(0xdbd10000),
    SPH_C32(0x835b0000), SPH_C32(0x178113a8), SPH_C32(0xea7bb99f),
    SPH_C32(0xd0ae8609), SPH_C32(0xee057339), SPH_C32(0x1e79b400),
    SPH_C32(0x15b70000), SPH_C32(0x67ab0000), SPH_C32(0xc8e70000),
    SPH_C32(0xb3725786), SPH_C32(0x1e2daf74), SPH_C32(0xb68d2f46),
    SPH_C32(0xb0a75c1e) },
  { SPH_C32(0x3b01cc00), SPH_C32(0x86680000), SPH_C32(0xeac00000),
    SPH_C32(0xd9eb0000), SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837),
    SPH_C32(0xb9dacdab), SPH_C32(0x673aa2a4), SPH_C32(0xb5ff8400),
    SPH_C32(0xd4340000), SPH_C32(0x601a0000), SPH_C32(0x2f600000),
    SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1), SPH_C32(0xb0e67183),
    SPH_C32(0xf5c750ed) },
  { SPH_C32(0x1866d800), SPH_C32(0x4ed10000), SPH_C32(0x1e070000),
    SPH_C32(0x229e0000), SPH_C32(0xa42374d8), SPH_C32(0x7ede7d7e),
    SPH_C32(0xbb1ec794), SPH_C32(0xbb1e44bb), SPH_C32(0x82c2ac00),
    SPH_C32(0xa5640000), SPH_C32(0xf5fa0000), SPH_C32(0x25740000),
    SPH_C32(0xea4814c3), SPH_C32(0xff397a80), SPH_C32(0xf58b1c9c),
    SPH_C32(0xc86d9237) },
  { SPH_C32(0xf3928800), SPH_C32(0xdc560000), SPH_C32(0xbd470000),
    SPH_C32(0x95bd0000), SPH_C32(0x3d767488), SPH_C32(0xf3c9c922),
    SPH_C32(0x916cbfec), SPH_C32(0x4aeb5b0f), SPH_C32(0xe1d7d800),
    SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000), SPH_C32(0x8ea50000),
    SPH_C32(0xe4466aba), SPH_C32(0x23732650), SPH_C32(0xdb56301e),
    SPH_C32(0xa0dc676f) },
  { SPH_C32(0xd0f59c00), SPH_C32(0x14ef0000), SPH_C32(0x49800000),
    SPH_C32(0x6ec80000), SPH_C32(0x4ebb50ed), SPH_C32(0x0b6f6c6b),
    SPH_C32(0x93a8b5d3), SPH_C32(0x96cfbd10), SPH_C32(0xd6eaf000),
    SPH_C32(0x4f890000), SPH_C32(0x302c0000), SPH_C32(0x84b10000),
    SPH_C32(0x59ea73b3), SPH_C32(0x6b9cbe61), SPH_C32(0x9e3b5d01),
    SPH_C32(0x9d76a5b5) },
  { SPH_C32(0xa7bad400), SPH_C32(0x36bb0000), SPH_C32(0x78910000),
    SPH_C32(0x34780000), SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3),
    SPH_C32(0xfadcfe71), SPH_C32(0x1ff06c8d), SPH_C32(0x7d6cc000),
    SPH_C32(0x8e0a0000), SPH_C32(0x379d0000), SPH_C32(0x63360000),
    SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4), SPH_C32(0x985003c4),
    SPH_C32(0xd816a946) },
  { SPH_C32(0x84ddc000), SPH_C32(0xfe020000), SPH_C32(0x8c560000),
    SPH_C32(0xcf0d0000), SPH_C32(0xfd19379d), SPH_C32(0x9fcaa88a),
    SPH_C32(0xf818f44e), SPH_C32(0xc3d48a92), SPH_C32(0x4a51e800),
    SPH_C32(0xff5a0000), SPH_C32(0xa27d0000), SPH_C32(0x69220000),
    SPH_C32(0x00d030f6), SPH_C32(0x8a886b95), SPH_C32(0xdd3d6edb),
    SPH_C32(0xe5bc6b9c) }
};

__constant static const sph_u32 T512_5[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0x5cb00110), SPH_C32(0x913e0000), SPH_C32(0x44190000),
    SPH_C32(0x888c0000), SPH_C32(0x66dc7418), SPH_C32(0x921f1d66),
    SPH_C32(0x55ceea25), SPH_C32(0x925c44e9), SPH_C32(0xe8870170),
    SPH_C32(0x9d720000), SPH_C32(0x12db0000), SPH_C32(0xd4220000),
    SPH_C32(0xf2886b27), SPH_C32(0xa921e543), SPH_C32(0x4ef8b518),
    SPH_C32(0x618813b1) },
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0x078c0300), SPH_C32(0xa78f0000), SPH_C32(0x4f750000),
    SPH_C32(0xbd6b0000), SPH_C32(0x69875721), SPH_C32(0xed2450ba),
    SPH_C32(0x28ecbf49), SPH_C32(0xf3c74ebb), SPH_C32(0x7d5c0050),
    SPH_C32(0xeb690000), SPH_C32(0x79460000), SPH_C32(0x7ae10000),
    SPH_C32(0x9c3d44c6), SPH_C32(0x56c20912), SPH_C32(0x4ba936b9),
    SPH_C32(0x6dbdf830) },
  { SPH_C32(0x5b3c0210), SPH_C32(0x36b10000), SPH_C32(0x0b6c0000),
    SPH_C32(0x35e70000), SPH_C32(0x0f5b2339), SPH_C32(0x7f3b4ddc),
    SPH_C32(0x7d22556c), SPH_C32(0x619b0a52), SPH_C32(0x95db0120),
    SPH_C32(0x761b0000), SPH_C32(0x6b9d0000), SPH_C32(0xaec30000),
    SPH_C32(0x6eb52fe1), SPH_C32(0xffe3ec51), SPH_C32(0x055183a1),
    SPH_C32(0x0c35eb81) },
  { SPH_C32(0xb3bb0360), SPH_C32(0xabc30000), SPH_C32(0x19b70000),
    SPH_C32(0xe1c50000), SPH_C32(0xfdd3481e), SPH_C32(0xd61aa89f),
    SPH_C32(0x33dae074), SPH_C32(0x001319e3), SPH_C32(0x21ec0140),
    SPH_C32(0x7a570000), SPH_C32(0x3d5f0000), SPH_C32(0xf26d0000),
    SPH_C32(0xfae130de), SPH_C32(0xc4dd1474), SPH_C32(0x1e67dc9c),
    SPH_C32(0xffe1bcd9) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0x21ec0140), SPH_C32(0x7a570000), SPH_C32(0x3d5f0000),
    SPH_C32(0xf26d0000), SPH_C32(0xfae130de), SPH_C32(0xc4dd1474),
    SPH_C32(0x1e67dc9c), SPH_C32(0xffe1bcd9), SPH_C32(0x92570220),
    SPH_C32(0xd1940000), SPH_C32(0x24e80000), SPH_C32(0x13a80000),
    SPH_C32(0x073278c0), SPH_C32(0x12c7bceb), SPH_C32(0x2dbd3ce8),
    SPH_C32(0xfff2a53a) },
  { SPH_C32(0x7d5c0050), SPH_C32(0xeb690000), SPH_C32(0x79460000),
    SPH_C32(0x7ae10000), SPH_C32(0x9c3d44c6), SPH_C32(0x56c20912),
    SPH_C32(0x4ba936b9), SPH_C32(0x6dbdf830), SPH_C32(0x7ad00350),
    SPH_C32(0x4ce60000), SPH_C32(0x36330000), SPH_C32(0xc78a0000),
    SPH_C32(0xf5ba13e7), SPH_C32(0xbbe659a8), SPH_C32(0x634589f0),
    SPH_C32(0x9e7ab68b) },
  { SPH_C32(0x95db0120), SPH_C32(0x761b0000), SPH_C32(0x6b9d0000),
    SPH_C32(0xaec30000), SPH_C32(0x6eb52fe1), SPH_C32(0xffe3ec51),
    SPH_C32(0x055183a1), SPH_C32(0x0c35eb81), SPH_C32(0xcee70330),
    SPH_C32(0x40aa0000), SPH_C32(0x60f10000), SPH_C32(0x9b240000),
    SPH_C32(0x61ee0cd8), SPH_C32(0x80d8a18d), SPH_C32(0x7873d6cd),
    SPH_C32(0x6daee1d3) },
  { SPH_C32(0x26600240), SPH_C32(0xddd80000), SPH_C32(0x722a0000),
    SPH_C32(0x4f060000), SPH_C32(0x936667ff), SPH_C32(0x29f944ce),
    SPH_C32(0x368b63d5), SPH_C32(0x0c26f262), SPH_C32(0xef0b0270),
    SPH_C32(0x3afd0000), SPH_C32(0x5dae0000), SPH_C32(0x69490000),
    SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9), SPH_C32(0x66140a51),
    SPH_C32(0x924f5d0a) },
  { SPH_C32(0xcee70330), SPH_C32(0x40aa0000), SPH_C32(0x60f10000),
    SPH_C32(0x9b240000), SPH_C32(0x61ee0cd8), SPH_C32(0x80d8a18d),
    SPH_C32(0x7873d6cd), SPH_C32(0x6daee1d3), SPH_C32(0x5b3c0210),
    SPH_C32(0x36b10000), SPH_C32(0x0b6c0000), SPH_C32(0x35e70000),
    SPH_C32(0x0f5b2339), SPH_C32(0x7f3b4ddc), SPH_C32(0x7d22556c),
    SPH_C32(0x619b0a52) },
  { SPH_C32(0x92570220), SPH_C32(0xd1940000), SPH_C32(0x24e80000),
    SPH_C32(0x13a80000), SPH_C32(0x073278c0), SPH_C32(0x12c7bceb),
    SPH_C32(0x2dbd3ce8), SPH_C32(0xfff2a53a), SPH_C32(0xb3bb0360),
    SPH_C32(0xabc30000), SPH_C32(0x19b70000), SPH_C32(0xe1c50000),
    SPH_C32(0xfdd3481e), SPH_C32(0xd61aa89f), SPH_C32(0x33dae074),
    SPH_C32(0x001319e3) },
  { SPH_C32(0x7ad00350), SPH_C32(0x4ce60000), SPH_C32(0x36330000),
    SPH_C32(0xc78a0000), SPH_C32(0xf5ba13e7), SPH_C32(0xbbe659a8),
    SPH_C32(0x634589f0), SPH_C32(0x9e7ab68b), SPH_C32(0x078c0300),
    SPH_C32(0xa78f0000), SPH_C32(0x4f750000), SPH_C32(0xbd6b0000),
    SPH_C32(0x69875721), SPH_C32(0xed2450ba), SPH_C32(0x28ecbf49),
    SPH_C32(0xf3c74ebb) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0xfcdd3d70), SPH_C32(0x249b0000), SPH_C32(0x73fc0000),
    SPH_C32(0x25430000), SPH_C32(0x3ce9564b), SPH_C32(0x1968d83b),
    SPH_C32(0x0951d238), SPH_C32(0x80063774), SPH_C32(0x97501460),
    SPH_C32(0xc4f50000), SPH_C32(0xa2050000), SPH_C32(0xa7db0000),
    SPH_C32(0xe7993b5a), SPH_C32(0xc3985d6c), SPH_C32(0x19f25502),
    SPH_C32(0x2ff0b147) },
  { SPH_C32(0xa06d3c60), SPH_C32(0xb5a50000), SPH_C32(0x37e50000),
    SPH_C32(0xadcf0000), SPH_C32(0x5a352253), SPH_C32(0x8b77c55d),
    SPH_C32(0x5c9f381d), SPH_C32(0x125a739d), SPH_C32(0x7fd71510),
    SPH_C32(0x59870000), SPH_C32(0xb0de0000), SPH_C32(0x73f90000),
    SPH_C32(0x1511507d), SPH_C32(0x6ab9b82f), SPH_C32(0x570ae01a),
    SPH_C32(0x4e78a2f6) },
  { SPH_C32(0x48ea3d10), SPH_C32(0x28d70000), SPH_C32(0x253e0000),
    SPH_C32(0x79ed0000), SPH_C32(0xa8bd4974), SPH_C32(0x2256201e),
    SPH_C32(0x12678d05), SPH_C32(0x73d2602c), SPH_C32(0xcbe01570),
    SPH_C32(0x55cb0000), SPH_C32(0xe61c0000), SPH_C32(0x2f570000),
    SPH_C32(0x81454f42), SPH_C32(0x5187400a), SPH_C32(0x4c3cbf27),
    SPH_C32(0xbdacf5ae) },
  { SPH_C32(0xfb513e70), SPH_C32(0x83140000), SPH_C32(0x3c890000),
    SPH_C32(0x98280000), SPH_C32(0x556e016a), SPH_C32(0xf44c8881),
    SPH_C32(0x21bd6d71), SPH_C32(0x73c179cf), SPH_C32(0xea0c1430),
    SPH_C32(0x2f9c0000), SPH_C32(0xdb430000), SPH_C32(0xdd3a0000),
    SPH_C32(0x7ba47f9c), SPH_C32(0x955a547e), SPH_C32(0x525b63bb),
    SPH_C32(0x424d4977) },
  { SPH_C32(0x13d63f00), SPH_C32(0x1e660000), SPH_C32(0x2e520000),
    SPH_C32(0x4c0a0000), SPH_C32(0xa7e66a4d), SPH_C32(0x5d6d6dc2),
    SPH_C32(0x6f45d869), SPH_C32(0x12496a7e), SPH_C32(0x5e3b1450),
    SPH_C32(0x23d00000), SPH_C32(0x8d810000), SPH_C32(0x81940000),
    SPH_C32(0xeff060a3), SPH_C32(0xae64ac5b), SPH_C32(0x496d3c86),
    SPH_C32(0xb1991e2f) },
  { SPH_C32(0x4f663e10), SPH_C32(0x8f580000), SPH_C32(0x6a4b0000),
    SPH_C32(0xc4860000), SPH_C32(0xc13a1e55), SPH_C32(0xcf7270a4),
    SPH_C32(0x3a8b324c), SPH_C32(0x80152e97), SPH_C32(0xb6bc1520),
    SPH_C32(0xbea20000), SPH_C32(0x9f5a0000), SPH_C32(0x55b60000),
    SPH_C32(0x1d780b84), SPH_C32(0x07454918), SPH_C32(0x0795899e),
    SPH_C32(0xd0110d9e) },
  { SPH_C32(0xa7e13f60), SPH_C32(0x122a0000), SPH_C32(0x78900000),
    SPH_C32(0x10a40000), SPH_C32(0x33b27572), SPH_C32(0x665395e7),
    SPH_C32(0x74738754), SPH_C32(0xe19d3d26), SPH_C32(0x028b1540),
    SPH_C32(0xb2ee0000), SPH_C32(0xc9980000), SPH_C32(0x09180000),
    SPH_C32(0x892c14bb), SPH_C32(0x3c7bb13d), SPH_C32(0x1ca3d6a3),
    SPH_C32(0x23c55ac6) },
  { SPH_C32(0xdd313c30), SPH_C32(0x5ecc0000), SPH_C32(0x4ea30000),
    SPH_C32(0xd72e0000), SPH_C32(0xc6086695), SPH_C32(0xddb5cc4f),
    SPH_C32(0x17360ea4), SPH_C32(0x7fe78bad), SPH_C32(0x05071640),
    SPH_C32(0x15610000), SPH_C32(0x86ed0000), SPH_C32(0xb4730000),
    SPH_C32(0xe0ab439a), SPH_C32(0xd15fe187), SPH_C32(0x344f69ea),
    SPH_C32(0xd002147d) },
  { SPH_C32(0x35b63d40), SPH_C32(0xc3be0000), SPH_C32(0x5c780000),
    SPH_C32(0x030c0000), SPH_C32(0x34800db2), SPH_C32(0x7494290c),
    SPH_C32(0x59cebbbc), SPH_C32(0x1e6f981c), SPH_C32(0xb1301620),
    SPH_C32(0x192d0000), SPH_C32(0xd02f0000), SPH_C32(0xe8dd0000),
    SPH_C32(0x74ff5ca5), SPH_C32(0xea6119a2), SPH_C32(0x2f7936d7),
    SPH_C32(0x23d64325) },
  { SPH_C32(0x69063c50), SPH_C32(0x52800000), SPH_C32(0x18610000),
    SPH_C32(0x8b800000), SPH_C32(0x525c79aa), SPH_C32(0xe68b346a),
    SPH_C32(0x0c005199), SPH_C32(0x8c33dcf5), SPH_C32(0x59b71750),
    SPH_C32(0x845f0000), SPH_C32(0xc2f40000), SPH_C32(0x3cff0000),
    SPH_C32(0x86773782), SPH_C32(0x4340fce1), SPH_C32(0x618183cf),
    SPH_C32(0x425e5094) },
  { SPH_C32(0x81813d20), SPH_C32(0xcff20000), SPH_C32(0x0aba0000),
    SPH_C32(0x5fa20000), SPH_C32(0xa0d4128d), SPH_C32(0x4faad129),
    SPH_C32(0x42f8e481), SPH_C32(0xedbbcf44), SPH_C32(0xed801730),
    SPH_C32(0x88130000), SPH_C32(0x94360000), SPH_C32(0x60510000),
    SPH_C32(0x122328bd), SPH_C32(0x787e04c4), SPH_C32(0x7ab7dcf2),
    SPH_C32(0xb18a07cc) },
  { SPH_C32(0x323a3e40), SPH_C32(0x64310000), SPH_C32(0x130d0000),
    SPH_C32(0xbe670000), SPH_C32(0x5d075a93), SPH_C32(0x99b079b6),
    SPH_C32(0x712204f5), SPH_C32(0xeda8d6a7), SPH_C32(0xcc6c1670),
    SPH_C32(0xf2440000), SPH_C32(0xa9690000), SPH_C32(0x923c0000),
    SPH_C32(0xe8c21863), SPH_C32(0xbca310b0), SPH_C32(0x64d0006e),
    SPH_C32(0x4e6bbb15) },
  { SPH_C32(0xdabd3f30), SPH_C32(0xf9430000), SPH_C32(0x01d60000),
    SPH_C32(0x6a450000), SPH_C32(0xaf8f31b4), SPH_C32(0x30919cf5),
    SPH_C32(0x3fdab1ed), SPH_C32(0x8c20c516), SPH_C32(0x785b1610),
    SPH_C32(0xfe080000), SPH_C32(0xffab0000), SPH_C32(0xce920000),
    SPH_C32(0x7c96075c), SPH_C32(0x879de895), SPH_C32(0x7fe65f53),
    SPH_C32(0xbdbfec4d) },
  { SPH_C32(0x860d3e20), SPH_C32(0x687d0000), SPH_C32(0x45cf0000),
    SPH_C32(0xe2c90000), SPH_C32(0xc95345ac), SPH_C32(0xa28e8193),
    SPH_C32(0x6a145bc8), SPH_C32(0x1e7c81ff), SPH_C32(0x90dc1760),
    SPH_C32(0x637a0000), SPH_C32(0xed700000), SPH_C32(0x1ab00000),
    SPH_C32(0x8e1e6c7b), SPH_C32(0x2ebc0dd6), SPH_C32(0x311eea4b),
    SPH_C32(0xdc37fffc) },
  { SPH_C32(0x6e8a3f50), SPH_C32(0xf50f0000), SPH_C32(0x57140000),
    SPH_C32(0x36eb0000), SPH_C32(0x3bdb2e8b), SPH_C32(0x0baf64d0),
    SPH_C32(0x24eceed0), SPH_C32(0x7ff4924e), SPH_C32(0x24eb1700),
    SPH_C32(0x6f360000), SPH_C32(0xbbb20000), SPH_C32(0x461e0000),
    SPH_C32(0x1a4a7344), SPH_C32(0x1582f5f3), SPH_C32(0x2a28b576),
    SPH_C32(0x2fe3a8a4) }
};

__constant static const sph_u32 T512_10[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0x510a0008), SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000),
    SPH_C32(0x92490000), SPH_C32(0x381e7454), SPH_C32(0x13229849),
    SPH_C32(0x56eab6c1), SPH_C32(0x3298f492), SPH_C32(0x84950004),
    SPH_C32(0xc8bc8000), SPH_C32(0x98540000), SPH_C32(0x53cf0000),
    SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31), SPH_C32(0x799e5a92),
    SPH_C32(0x8c5d1599) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0x72150001), SPH_C32(0xfcff4000), SPH_C32(0xbc530000),
    SPH_C32(0xdcf20000), SPH_C32(0xc6c52f87), SPH_C32(0x227e289f),
    SPH_C32(0xb45bd18b), SPH_C32(0x5bc8afa8), SPH_C32(0x73e0000d),
    SPH_C32(0x07804000), SPH_C32(0x5b820000), SPH_C32(0x575d0000),
    SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b), SPH_C32(0x0319abdc),
    SPH_C32(0x124b8d83) },
  { SPH_C32(0x231f0009), SPH_C32(0x42f40000), SPH_C32(0x66790000),
    SPH_C32(0x4ebb0000), SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6),
    SPH_C32(0xe2b1674a), SPH_C32(0x69505b3a), SPH_C32(0xf7750009),
    SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000), SPH_C32(0x04920000),
    SPH_C32(0x029519a9), SPH_C32(0xf8e836ba), SPH_C32(0x7a87f14e),
    SPH_C32(0x9e16981a) },
  { SPH_C32(0x85600008), SPH_C32(0x33c38000), SPH_C32(0x7f850000),
    SPH_C32(0xd8600000), SPH_C32(0xc450362e), SPH_C32(0xda961e25),
    SPH_C32(0xcedc20c5), SPH_C32(0xc5de37b2), SPH_C32(0xa78a000d),
    SPH_C32(0x8a488000), SPH_C32(0xfe2d0000), SPH_C32(0x1d740000),
    SPH_C32(0x19294faf), SPH_C32(0x199a4de7), SPH_C32(0x9b2f3dd8),
    SPH_C32(0xe50d4ea3) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0xd13b00f1), SPH_C32(0x806d8000), SPH_C32(0xec4e0000),
    SPH_C32(0xa2cf0000), SPH_C32(0xb3bc1371), SPH_C32(0xb14142d6),
    SPH_C32(0x27ae8a91), SPH_C32(0x63b91943), SPH_C32(0xa4930054),
    SPH_C32(0xd36c4000), SPH_C32(0x295e0000), SPH_C32(0x1af90000),
    SPH_C32(0x592828be), SPH_C32(0x87cd0544), SPH_C32(0x7d0cbc44),
    SPH_C32(0xf12fc3cd) },
  { SPH_C32(0x803100f9), SPH_C32(0x3e66c000), SPH_C32(0x36640000),
    SPH_C32(0x30860000), SPH_C32(0x8ba26725), SPH_C32(0xa263da9f),
    SPH_C32(0x71443c50), SPH_C32(0x5121edd1), SPH_C32(0x20060050),
    SPH_C32(0x1bd0c000), SPH_C32(0xb10a0000), SPH_C32(0x49360000),
    SPH_C32(0xbeda3cc2), SPH_C32(0xaf0bf875), SPH_C32(0x0492e6d6),
    SPH_C32(0x7d72d654) },
  { SPH_C32(0x264e00f8), SPH_C32(0x4f514000), SPH_C32(0x2f980000),
    SPH_C32(0xa65d0000), SPH_C32(0xb1290ad8), SPH_C32(0x49a9746c),
    SPH_C32(0x5d297bdf), SPH_C32(0xfdaf8159), SPH_C32(0x70f90054),
    SPH_C32(0x5ea48000), SPH_C32(0x8cf10000), SPH_C32(0x50d00000),
    SPH_C32(0xa5666ac4), SPH_C32(0x4e798328), SPH_C32(0xe53a2a40),
    SPH_C32(0x066900ed) },
  { SPH_C32(0xa32e00f0), SPH_C32(0x7c92c000), SPH_C32(0x501d0000),
    SPH_C32(0x7e3d0000), SPH_C32(0x75793cf6), SPH_C32(0x933f6a49),
    SPH_C32(0x93f55b1a), SPH_C32(0x3871b6eb), SPH_C32(0xd7730059),
    SPH_C32(0xd4ec0000), SPH_C32(0x72dc0000), SPH_C32(0x4da40000),
    SPH_C32(0xbc4f256b), SPH_C32(0x57e3cecf), SPH_C32(0x7e151798),
    SPH_C32(0xe3644e4e) },
  { SPH_C32(0x055100f1), SPH_C32(0x0da54000), SPH_C32(0x49e10000),
    SPH_C32(0xe8e60000), SPH_C32(0x4ff2510b), SPH_C32(0x78f5c4ba),
    SPH_C32(0xbf981c95), SPH_C32(0x94ffda63), SPH_C32(0x878c005d),
    SPH_C32(0x91984000), SPH_C32(0x4f270000), SPH_C32(0x54420000),
    SPH_C32(0xa7f3736d), SPH_C32(0xb691b592), SPH_C32(0x9fbddb0e),
    SPH_C32(0x987f98f7) },
  { SPH_C32(0x545b00f9), SPH_C32(0xb3ae0000), SPH_C32(0x93cb0000),
    SPH_C32(0x7aaf0000), SPH_C32(0x77ec255f), SPH_C32(0x6bd75cf3),
    SPH_C32(0xe972aa54), SPH_C32(0xa6672ef1), SPH_C32(0x03190059),
    SPH_C32(0x5924c000), SPH_C32(0xd7730000), SPH_C32(0x078d0000),
    SPH_C32(0x40016711), SPH_C32(0x9e5748a3), SPH_C32(0xe623819c),
    SPH_C32(0x14228d6e) },
  { SPH_C32(0xf22400f8), SPH_C32(0xc2998000), SPH_C32(0x8a370000),
    SPH_C32(0xec740000), SPH_C32(0x4d6748a2), SPH_C32(0x801df200),
    SPH_C32(0xc51feddb), SPH_C32(0x0ae94279), SPH_C32(0x53e6005d),
    SPH_C32(0x1c508000), SPH_C32(0xea880000), SPH_C32(0x1e6b0000),
    SPH_C32(0x5bbd3117), SPH_C32(0x7f2533fe), SPH_C32(0x078b4d0a),
    SPH_C32(0x6f395bd7) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0x52130051), SPH_C32(0xe72f8000), SPH_C32(0x0d590000),
    SPH_C32(0x95c40000), SPH_C32(0x781f1345), SPH_C32(0x8d75d0ea),
    SPH_C32(0xb0c9375d), SPH_C32(0x26ba79fc), SPH_C32(0xd3d700a4),
    SPH_C32(0x22364000), SPH_C32(0xdcec0000), SPH_C32(0x2eed0000),
    SPH_C32(0xd01f5632), SPH_C32(0xdd46e961), SPH_C32(0x76cf715a),
    SPH_C32(0x3e18b606) },
  { SPH_C32(0x03190059), SPH_C32(0x5924c000), SPH_C32(0xd7730000),
    SPH_C32(0x078d0000), SPH_C32(0x40016711), SPH_C32(0x9e5748a3),
    SPH_C32(0xe623819c), SPH_C32(0x14228d6e), SPH_C32(0x574200a0),
    SPH_C32(0xea8ac000), SPH_C32(0x44b80000), SPH_C32(0x7d220000),
    SPH_C32(0x37ed424e), SPH_C32(0xf5801450), SPH_C32(0x0f512bc8),
    SPH_C32(0xb245a39f) },
  { SPH_C32(0xa5660058), SPH_C32(0x28134000), SPH_C32(0xce8f0000),
    SPH_C32(0x91560000), SPH_C32(0x7a8a0aec), SPH_C32(0x759de650),
    SPH_C32(0xca4ec613), SPH_C32(0xb8ace1e6), SPH_C32(0x07bd00a4),
    SPH_C32(0xaffe8000), SPH_C32(0x79430000), SPH_C32(0x64c40000),
    SPH_C32(0x2c511448), SPH_C32(0x14f26f0d), SPH_C32(0xeef9e75e),
    SPH_C32(0xc95e7526) },
  { SPH_C32(0x20060050), SPH_C32(0x1bd0c000), SPH_C32(0xb10a0000),
    SPH_C32(0x49360000), SPH_C32(0xbeda3cc2), SPH_C32(0xaf0bf875),
    SPH_C32(0x0492e6d6), SPH_C32(0x7d72d654), SPH_C32(0xa03700a9),
    SPH_C32(0x25b60000), SPH_C32(0x876e0000), SPH_C32(0x79b00000),
    SPH_C32(0x35785be7), SPH_C32(0x0d6822ea), SPH_C32(0x75d6da86),
    SPH_C32(0x2c533b85) },
  { SPH_C32(0x86790051), SPH_C32(0x6ae74000), SPH_C32(0xa8f60000),
    SPH_C32(0xdfed0000), SPH_C32(0x8451513f), SPH_C32(0x44c15686),
    SPH_C32(0x28ffa159), SPH_C32(0xd1fcbadc), SPH_C32(0xf0c800ad),
    SPH_C32(0x60c24000), SPH_C32(0xba950000), SPH_C32(0x60560000),
    SPH_C32(0x2ec40de1), SPH_C32(0xec1a59b7), SPH_C32(0x947e1610),
    SPH_C32(0x5748ed3c) },
  { SPH_C32(0xd7730059), SPH_C32(0xd4ec0000), SPH_C32(0x72dc0000),
    SPH_C32(0x4da40000), SPH_C32(0xbc4f256b), SPH_C32(0x57e3cecf),
    SPH_C32(0x7e151798), SPH_C32(0xe3644e4e), SPH_C32(0x745d00a9),
    SPH_C32(0xa87ec000), SPH_C32(0x22c10000), SPH_C32(0x33990000),
    SPH_C32(0xc936199d), SPH_C32(0xc4dca486), SPH_C32(0xede04c82),
    SPH_C32(0xdb15f8a5) },
  { SPH_C32(0x710c0058), SPH_C32(0xa5db8000), SPH_C32(0x6b200000),
    SPH_C32(0xdb7f0000), SPH_C32(0x86c44896), SPH_C32(0xbc29603c),
    SPH_C32(0x52785017), SPH_C32(0x4fea22c6), SPH_C32(0x24a200ad),
    SPH_C32(0xed0a8000), SPH_C32(0x1f3a0000), SPH_C32(0x2a7f0000),
    SPH_C32(0xd28a4f9b), SPH_C32(0x25aedfdb), SPH_C32(0x0c488014),
    SPH_C32(0xa00e2e1c) },
  { SPH_C32(0x832800a0), SPH_C32(0x67420000), SPH_C32(0xe1170000),
    SPH_C32(0x370b0000), SPH_C32(0xcba30034), SPH_C32(0x3c34923c),
    SPH_C32(0x9767bdcc), SPH_C32(0x450360bf), SPH_C32(0x774400f0),
    SPH_C32(0xf15a0000), SPH_C32(0xf5b20000), SPH_C32(0x34140000),
    SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25), SPH_C32(0x0bc3cd1e),
    SPH_C32(0xcf3775cb) },
  { SPH_C32(0x255700a1), SPH_C32(0x16758000), SPH_C32(0xf8eb0000),
    SPH_C32(0xa1d00000), SPH_C32(0xf1286dc9), SPH_C32(0xd7fe3ccf),
    SPH_C32(0xbb0afa43), SPH_C32(0xe98d0c37), SPH_C32(0x27bb00f4),
    SPH_C32(0xb42e4000), SPH_C32(0xc8490000), SPH_C32(0x2df20000),
    SPH_C32(0x928b288a), SPH_C32(0xbbf99778), SPH_C32(0xea6b0188),
    SPH_C32(0xb42ca372) },
  { SPH_C32(0x745d00a9), SPH_C32(0xa87ec000), SPH_C32(0x22c10000),
    SPH_C32(0x33990000), SPH_C32(0xc936199d), SPH_C32(0xc4dca486),
    SPH_C32(0xede04c82), SPH_C32(0xdb15f8a5), SPH_C32(0xa32e00f0),
    SPH_C32(0x7c92c000), SPH_C32(0x501d0000), SPH_C32(0x7e3d0000),
    SPH_C32(0x75793cf6), SPH_C32(0x933f6a49), SPH_C32(0x93f55b1a),
    SPH_C32(0x3871b6eb) },
  { SPH_C32(0xd22200a8), SPH_C32(0xd9494000), SPH_C32(0x3b3d0000),
    SPH_C32(0xa5420000), SPH_C32(0xf3bd7460), SPH_C32(0x2f160a75),
    SPH_C32(0xc18d0b0d), SPH_C32(0x779b942d), SPH_C32(0xf3d100f4),
    SPH_C32(0x39e68000), SPH_C32(0x6de60000), SPH_C32(0x67db0000),
    SPH_C32(0x6ec56af0), SPH_C32(0x724d1114), SPH_C32(0x725d978c),
    SPH_C32(0x436a6052) },
  { SPH_C32(0x574200a0), SPH_C32(0xea8ac000), SPH_C32(0x44b80000),
    SPH_C32(0x7d220000), SPH_C32(0x37ed424e), SPH_C32(0xf5801450),
    SPH_C32(0x0f512bc8), SPH_C32(0xb245a39f), SPH_C32(0x545b00f9),
    SPH_C32(0xb3ae0000), SPH_C32(0x93cb0000), SPH_C32(0x7aaf0000),
    SPH_C32(0x77ec255f), SPH_C32(0x6bd75cf3), SPH_C32(0xe972aa54),
    SPH_C32(0xa6672ef1) },
  { SPH_C32(0xf13d00a1), SPH_C32(0x9bbd4000), SPH_C32(0x5d440000),
    SPH_C32(0xebf90000), SPH_C32(0x0d662fb3), SPH_C32(0x1e4abaa3),
    SPH_C32(0x233c6c47), SPH_C32(0x1ecbcf17), SPH_C32(0x04a400fd),
    SPH_C32(0xf6da4000), SPH_C32(0xae300000), SPH_C32(0x63490000),
    SPH_C32(0x6c507359), SPH_C32(0x8aa527ae), SPH_C32(0x08da66c2),
    SPH_C32(0xdd7cf848) },
  { SPH_C32(0xa03700a9), SPH_C32(0x25b60000), SPH_C32(0x876e0000),
    SPH_C32(0x79b00000), SPH_C32(0x35785be7), SPH_C32(0x0d6822ea),
    SPH_C32(0x75d6da86), SPH_C32(0x2c533b85), SPH_C32(0x803100f9),
    SPH_C32(0x3e66c000), SPH_C32(0x36640000), SPH_C32(0x30860000),
    SPH_C32(0x8ba26725), SPH_C32(0xa263da9f), SPH_C32(0x71443c50),
    SPH_C32(0x5121edd1) },
  { SPH_C32(0x064800a8), SPH_C32(0x54818000), SPH_C32(0x9e920000),
    SPH_C32(0xef6b0000), SPH_C32(0x0ff3361a), SPH_C32(0xe6a28c19),
    SPH_C32(0x59bb9d09), SPH_C32(0x80dd570d), SPH_C32(0xd0ce00fd),
    SPH_C32(0x7b128000), SPH_C32(0x0b9f0000), SPH_C32(0x29600000),
    SPH_C32(0x901e3123), SPH_C32(0x4311a1c2), SPH_C32(0x90ecf0c6),
    SPH_C32(0x2a3a3b68) }
};

__constant static const sph_u32 T512_15[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0xa4c20000), SPH_C32(0xd9372400), SPH_C32(0x0a480000),
    SPH_C32(0x66610000), SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c),
    SPH_C32(0xa324df94), SPH_C32(0x2ba05a55), SPH_C32(0x75a40000),
    SPH_C32(0xc28b2700), SPH_C32(0x94a40000), SPH_C32(0x90f50000),
    SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae), SPH_C32(0x1767c483),
    SPH_C32(0xaedf667e) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0x006d0003), SPH_C32(0xcc9be700), SPH_C32(0x45840000),
    SPH_C32(0x2a1f0000), SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9),
    SPH_C32(0xac4fb29e), SPH_C32(0xae684855), SPH_C32(0x3fa90001),
    SPH_C32(0x74ea4300), SPH_C32(0x6dd20000), SPH_C32(0x510a0000),
    SPH_C32(0xbeb7373e), SPH_C32(0x78611737), SPH_C32(0xfe785bad),
    SPH_C32(0x7bd4ce7f) },
  { SPH_C32(0xa4af0003), SPH_C32(0x15acc300), SPH_C32(0x4fcc0000),
    SPH_C32(0x4c7e0000), SPH_C32(0x88c66a19), SPH_C32(0x48284ba5),
    SPH_C32(0x0f6b6d0a), SPH_C32(0x85c81200), SPH_C32(0x4a0d0001),
    SPH_C32(0xb6616400), SPH_C32(0xf9760000), SPH_C32(0xc1ff0000),
    SPH_C32(0x45cf60de), SPH_C32(0x31af1c99), SPH_C32(0xe91f9f2e),
    SPH_C32(0xd50ba801) },
  { SPH_C32(0xd10b0003), SPH_C32(0xd727e400), SPH_C32(0xdb680000),
    SPH_C32(0xdc8b0000), SPH_C32(0x73be3df9), SPH_C32(0x01e6400b),
    SPH_C32(0x180ca989), SPH_C32(0x2b17747e), SPH_C32(0x9b6b0001),
    SPH_C32(0xaddd6700), SPH_C32(0x679a0000), SPH_C32(0x376b0000),
    SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b), SPH_C32(0x5d5c8439),
    SPH_C32(0x5074942a) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0x9b6b0001), SPH_C32(0xaddd6700), SPH_C32(0x679a0000),
    SPH_C32(0x376b0000), SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b),
    SPH_C32(0x5d5c8439), SPH_C32(0x5074942a), SPH_C32(0x4a600002),
    SPH_C32(0x7afa8300), SPH_C32(0xbcf20000), SPH_C32(0xebe00000),
    SPH_C32(0x35731800), SPH_C32(0xff39a060), SPH_C32(0x45502db0),
    SPH_C32(0x7b63e054) },
  { SPH_C32(0x3fa90001), SPH_C32(0x74ea4300), SPH_C32(0x6dd20000),
    SPH_C32(0x510a0000), SPH_C32(0xbeb7373e), SPH_C32(0x78611737),
    SPH_C32(0xfe785bad), SPH_C32(0x7bd4ce7f), SPH_C32(0x3fc40002),
    SPH_C32(0xb871a400), SPH_C32(0x28560000), SPH_C32(0x7b150000),
    SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce), SPH_C32(0x5237e933),
    SPH_C32(0xd5bc862a) },
  { SPH_C32(0x4a0d0001), SPH_C32(0xb6616400), SPH_C32(0xf9760000),
    SPH_C32(0xc1ff0000), SPH_C32(0x45cf60de), SPH_C32(0x31af1c99),
    SPH_C32(0xe91f9f2e), SPH_C32(0xd50ba801), SPH_C32(0xeea20002),
    SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000), SPH_C32(0x8d810000),
    SPH_C32(0xcd090ac7), SPH_C32(0x7987573c), SPH_C32(0xe674f224),
    SPH_C32(0x50c3ba01) },
  { SPH_C32(0x9b060002), SPH_C32(0x61468000), SPH_C32(0x221e0000),
    SPH_C32(0x1d740000), SPH_C32(0x36715d27), SPH_C32(0x30495c92),
    SPH_C32(0xf11336a7), SPH_C32(0xfe1cdc7f), SPH_C32(0x75c90003),
    SPH_C32(0x0e10c000), SPH_C32(0xd1200000), SPH_C32(0xbaea0000),
    SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757), SPH_C32(0xbb28761d),
    SPH_C32(0x00b72e2b) },
  { SPH_C32(0xeea20002), SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000),
    SPH_C32(0x8d810000), SPH_C32(0xcd090ac7), SPH_C32(0x7987573c),
    SPH_C32(0xe674f224), SPH_C32(0x50c3ba01), SPH_C32(0xa4af0003),
    SPH_C32(0x15acc300), SPH_C32(0x4fcc0000), SPH_C32(0x4c7e0000),
    SPH_C32(0x88c66a19), SPH_C32(0x48284ba5), SPH_C32(0x0f6b6d0a),
    SPH_C32(0x85c81200) },
  { SPH_C32(0x4a600002), SPH_C32(0x7afa8300), SPH_C32(0xbcf20000),
    SPH_C32(0xebe00000), SPH_C32(0x35731800), SPH_C32(0xff39a060),
    SPH_C32(0x45502db0), SPH_C32(0x7b63e054), SPH_C32(0xd10b0003),
    SPH_C32(0xd727e400), SPH_C32(0xdb680000), SPH_C32(0xdc8b0000),
    SPH_C32(0x73be3df9), SPH_C32(0x01e6400b), SPH_C32(0x180ca989),
    SPH_C32(0x2b17747e) },
  { SPH_C32(0x3fc40002), SPH_C32(0xb871a400), SPH_C32(0x28560000),
    SPH_C32(0x7b150000), SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce),
    SPH_C32(0x5237e933), SPH_C32(0xd5bc862a), SPH_C32(0x006d0003),
    SPH_C32(0xcc9be700), SPH_C32(0x45840000), SPH_C32(0x2a1f0000),
    SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9), SPH_C32(0xac4fb29e),
    SPH_C32(0xae684855) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0x83240005), SPH_C32(0xf6c8e700), SPH_C32(0xb0a30000),
    SPH_C32(0x1fc80000), SPH_C32(0xda4f6c1b), SPH_C32(0x4376de00),
    SPH_C32(0xdaa24f9a), SPH_C32(0x794adc4f), SPH_C32(0x77190001),
    SPH_C32(0x6a8b8300), SPH_C32(0x87100000), SPH_C32(0x604f0000),
    SPH_C32(0x398928da), SPH_C32(0x24ba5201), SPH_C32(0x982e5c98),
    SPH_C32(0x29f150a3) },
  { SPH_C32(0x27e60005), SPH_C32(0x2fffc300), SPH_C32(0xbaeb0000),
    SPH_C32(0x79a90000), SPH_C32(0x22357edc), SPH_C32(0xc5c8295c),
    SPH_C32(0x7986900e), SPH_C32(0x52ea861a), SPH_C32(0x02bd0001),
    SPH_C32(0xa800a400), SPH_C32(0x13b40000), SPH_C32(0xf0ba0000),
    SPH_C32(0xc2f17f3a), SPH_C32(0x6d7459af), SPH_C32(0x8f49981b),
    SPH_C32(0x872e36dd) },
  { SPH_C32(0x52420005), SPH_C32(0xed74e400), SPH_C32(0x2e4f0000),
    SPH_C32(0xe95c0000), SPH_C32(0xd94d293c), SPH_C32(0x8c0622f2),
    SPH_C32(0x6ee1548d), SPH_C32(0xfc35e064), SPH_C32(0xd3db0001),
    SPH_C32(0xb3bca700), SPH_C32(0x8d580000), SPH_C32(0x062e0000),
    SPH_C32(0xc1f33a1d), SPH_C32(0xa204a55d), SPH_C32(0x3b0a830c),
    SPH_C32(0x02510af6) },
  { SPH_C32(0x83490006), SPH_C32(0x3a530000), SPH_C32(0xf5270000),
    SPH_C32(0x35d70000), SPH_C32(0xaaf314c5), SPH_C32(0x8de062f9),
    SPH_C32(0x76edfd04), SPH_C32(0xd722941a), SPH_C32(0x48b00000),
    SPH_C32(0x1e61c000), SPH_C32(0xeac20000), SPH_C32(0x31450000),
    SPH_C32(0x873e1fe4), SPH_C32(0x5cdb4536), SPH_C32(0x66560735),
    SPH_C32(0x52259edc) },
  { SPH_C32(0xf6ed0006), SPH_C32(0xf8d82700), SPH_C32(0x61830000),
    SPH_C32(0xa5220000), SPH_C32(0x518b4325), SPH_C32(0xc42e6957),
    SPH_C32(0x618a3987), SPH_C32(0x79fdf264), SPH_C32(0x99d60000),
    SPH_C32(0x05ddc300), SPH_C32(0x742e0000), SPH_C32(0xc7d10000),
    SPH_C32(0x843c5ac3), SPH_C32(0x93abb9c4), SPH_C32(0xd2151c22),
    SPH_C32(0xd75aa2f7) },
  { SPH_C32(0x522f0006), SPH_C32(0x21ef0300), SPH_C32(0x6bcb0000),
    SPH_C32(0xc3430000), SPH_C32(0xa9f151e2), SPH_C32(0x42909e0b),
    SPH_C32(0xc2aee613), SPH_C32(0x525da831), SPH_C32(0xec720000),
    SPH_C32(0xc756e400), SPH_C32(0xe08a0000), SPH_C32(0x57240000),
    SPH_C32(0x7f440d23), SPH_C32(0xda65b26a), SPH_C32(0xc572d8a1),
    SPH_C32(0x7985c489) },
  { SPH_C32(0x278b0006), SPH_C32(0xe3642400), SPH_C32(0xff6f0000),
    SPH_C32(0x53b60000), SPH_C32(0x52890602), SPH_C32(0x0b5e95a5),
    SPH_C32(0xd5c92290), SPH_C32(0xfc82ce4f), SPH_C32(0x3d140000),
    SPH_C32(0xdceae700), SPH_C32(0x7e660000), SPH_C32(0xa1b00000),
    SPH_C32(0x7c464804), SPH_C32(0x15154e98), SPH_C32(0x7131c3b6),
    SPH_C32(0xfcfaf8a2) },
  { SPH_C32(0x184f0004), SPH_C32(0x5b158000), SPH_C32(0xd7390000),
    SPH_C32(0x28a30000), SPH_C32(0x9c8249e2), SPH_C32(0xbda93e6b),
    SPH_C32(0x87fecba3), SPH_C32(0x293e4865), SPH_C32(0x3d790003),
    SPH_C32(0x10710000), SPH_C32(0x3be20000), SPH_C32(0x8baf0000),
    SPH_C32(0x0cfa30da), SPH_C32(0xdb83f261), SPH_C32(0xdd7e7128),
    SPH_C32(0x5292b0f7) },
  { SPH_C32(0x6deb0004), SPH_C32(0x999ea700), SPH_C32(0x439d0000),
    SPH_C32(0xb8560000), SPH_C32(0x67fa1e02), SPH_C32(0xf46735c5),
    SPH_C32(0x90990f20), SPH_C32(0x87e12e1b), SPH_C32(0xec1f0003),
    SPH_C32(0x0bcd0300), SPH_C32(0xa50e0000), SPH_C32(0x7d3b0000),
    SPH_C32(0x0ff875fd), SPH_C32(0x14f30e93), SPH_C32(0x693d6a3f),
    SPH_C32(0xd7ed8cdc) },
  { SPH_C32(0xc9290004), SPH_C32(0x40a98300), SPH_C32(0x49d50000),
    SPH_C32(0xde370000), SPH_C32(0x9f800cc5), SPH_C32(0x72d9c299),
    SPH_C32(0x33bdd0b4), SPH_C32(0xac41744e), SPH_C32(0x99bb0003),
    SPH_C32(0xc9462400), SPH_C32(0x31aa0000), SPH_C32(0xedce0000),
    SPH_C32(0xf480221d), SPH_C32(0x5d3d053d), SPH_C32(0x7e5aaebc),
    SPH_C32(0x7932eaa2) },
  { SPH_C32(0xbc8d0004), SPH_C32(0x8222a400), SPH_C32(0xdd710000),
    SPH_C32(0x4ec20000), SPH_C32(0x64f85b25), SPH_C32(0x3b17c937),
    SPH_C32(0x24da1437), SPH_C32(0x029e1230), SPH_C32(0x48dd0003),
    SPH_C32(0xd2fa2700), SPH_C32(0xaf460000), SPH_C32(0x1b5a0000),
    SPH_C32(0xf782673a), SPH_C32(0x924df9cf), SPH_C32(0xca19b5ab),
    SPH_C32(0xfc4dd689) },
  { SPH_C32(0x6d860007), SPH_C32(0x55054000), SPH_C32(0x06190000),
    SPH_C32(0x92490000), SPH_C32(0x174666dc), SPH_C32(0x3af1893c),
    SPH_C32(0x3cd6bdbe), SPH_C32(0x2989664e), SPH_C32(0xd3b60002),
    SPH_C32(0x7f274000), SPH_C32(0xc8dc0000), SPH_C32(0x2c310000),
    SPH_C32(0xb14f42c3), SPH_C32(0x6c9219a4), SPH_C32(0x97453192),
    SPH_C32(0xac3942a3) },
  { SPH_C32(0x18220007), SPH_C32(0x978e6700), SPH_C32(0x92bd0000),
    SPH_C32(0x02bc0000), SPH_C32(0xec3e313c), SPH_C32(0x733f8292),
    SPH_C32(0x2bb1793d), SPH_C32(0x87560030), SPH_C32(0x02d00002),
    SPH_C32(0x649b4300), SPH_C32(0x56300000), SPH_C32(0xdaa50000),
    SPH_C32(0xb24d07e4), SPH_C32(0xa3e2e556), SPH_C32(0x23062a85),
    SPH_C32(0x29467e88) },
  { SPH_C32(0xbce00007), SPH_C32(0x4eb94300), SPH_C32(0x98f50000),
    SPH_C32(0x64dd0000), SPH_C32(0x144423fb), SPH_C32(0xf58175ce),
    SPH_C32(0x8895a6a9), SPH_C32(0xacf65a65), SPH_C32(0x77740002),
    SPH_C32(0xa6106400), SPH_C32(0xc2940000), SPH_C32(0x4a500000),
    SPH_C32(0x49355004), SPH_C32(0xea2ceef8), SPH_C32(0x3461ee06),
    SPH_C32(0x879918f6) },
  { SPH_C32(0xc9440007), SPH_C32(0x8c326400), SPH_C32(0x0c510000),
    SPH_C32(0xf4280000), SPH_C32(0xef3c741b), SPH_C32(0xbc4f7e60),
    SPH_C32(0x9ff2622a), SPH_C32(0x02293c1b), SPH_C32(0xa6120002),
    SPH_C32(0xbdac6700), SPH_C32(0x5c780000), SPH_C32(0xbcc40000),
    SPH_C32(0x4a371523), SPH_C32(0x255c120a), SPH_C32(0x8022f511),
    SPH_C32(0x02e624dd) }
};

__constant static const sph_u32 T512_20[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0xca010000), SPH_C32(0xe6680f0c), SPH_C32(0xe6b80000),
    SPH_C32(0x7d670000), SPH_C32(0x10bb259d), SPH_C32(0x6c91743b),
    SPH_C32(0x888be7f3), SPH_C32(0x83c6d1e3), SPH_C32(0x51000000),
    SPH_C32(0xdc340590), SPH_C32(0x42330000), SPH_C32(0x7ac20000),
    SPH_C32(0x4eb566f3), SPH_C32(0xa863bc93), SPH_C32(0xd41427e1),
    SPH_C32(0x2a4f8d22) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0x38510000), SPH_C32(0x08d5050c), SPH_C32(0x81100000),
    SPH_C32(0xd6ed0000), SPH_C32(0xaa206d5d), SPH_C32(0x66c7a94f),
    SPH_C32(0x53f80f9d), SPH_C32(0x96ae2eec), SPH_C32(0x5d720000),
    SPH_C32(0x95d10a90), SPH_C32(0x004a0000), SPH_C32(0x26280000),
    SPH_C32(0x7d1f56e9), SPH_C32(0xbde19987), SPH_C32(0x41b76c9a),
    SPH_C32(0x9e048db2) },
  { SPH_C32(0xf2500000), SPH_C32(0xeebd0a00), SPH_C32(0x67a80000),
    SPH_C32(0xab8a0000), SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74),
    SPH_C32(0xdb73e86e), SPH_C32(0x1568ff0f), SPH_C32(0x0c720000),
    SPH_C32(0x49e50f00), SPH_C32(0x42790000), SPH_C32(0x5cea0000),
    SPH_C32(0x33aa301a), SPH_C32(0x15822514), SPH_C32(0x95a34b7b),
    SPH_C32(0xb44b0090) },
  { SPH_C32(0x34230000), SPH_C32(0x41300a0c), SPH_C32(0xc3690000),
    SPH_C32(0x8a070000), SPH_C32(0x998a5d47), SPH_C32(0x73458c5b),
    SPH_C32(0xc65b44e6), SPH_C32(0x22e52e7c), SPH_C32(0xa3500000),
    SPH_C32(0x32890f90), SPH_C32(0x259b0000), SPH_C32(0xd1480000),
    SPH_C32(0xf42e2e33), SPH_C32(0xa23561e7), SPH_C32(0x0f67cf8f),
    SPH_C32(0x3f27722d) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0x836b0000), SPH_C32(0x0a38170c), SPH_C32(0x5dab0000),
    SPH_C32(0x1ac50000), SPH_C32(0x3ddd01ab), SPH_C32(0x5a00c4f9),
    SPH_C32(0x0b940a38), SPH_C32(0xe8be25ac), SPH_C32(0x171f0000),
    SPH_C32(0x6d1d0690), SPH_C32(0x50780000), SPH_C32(0x78130000),
    SPH_C32(0xe5057f85), SPH_C32(0x19ffb5b6), SPH_C32(0xfce092e2),
    SPH_C32(0x4ead9983) },
  { SPH_C32(0x496a0000), SPH_C32(0xec501800), SPH_C32(0xbb130000),
    SPH_C32(0x67a20000), SPH_C32(0x2d662436), SPH_C32(0x3691b0c2),
    SPH_C32(0x831fedcb), SPH_C32(0x6b78f44f), SPH_C32(0x461f0000),
    SPH_C32(0xb1290300), SPH_C32(0x124b0000), SPH_C32(0x02d10000),
    SPH_C32(0xabb01976), SPH_C32(0xb19c0925), SPH_C32(0x28f4b503),
    SPH_C32(0x64e214a1) },
  { SPH_C32(0x8f190000), SPH_C32(0x43dd180c), SPH_C32(0x1fd20000),
    SPH_C32(0x462f0000), SPH_C32(0x0e7731b1), SPH_C32(0x4f82e1ed),
    SPH_C32(0x9e374143), SPH_C32(0x5cf5253c), SPH_C32(0xe93d0000),
    SPH_C32(0xca450390), SPH_C32(0x75a90000), SPH_C32(0x8f730000),
    SPH_C32(0x6c34075f), SPH_C32(0x062b4dd6), SPH_C32(0xb23031f7),
    SPH_C32(0xef8e661c) },
  { SPH_C32(0xbb3a0000), SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000),
    SPH_C32(0xcc280000), SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6),
    SPH_C32(0x586c05a5), SPH_C32(0x7e100b40), SPH_C32(0x4a6d0000),
    SPH_C32(0xf8cc0c00), SPH_C32(0x50320000), SPH_C32(0x5e3b0000),
    SPH_C32(0x981a296c), SPH_C32(0xa41e2c31), SPH_C32(0xbd57fe78),
    SPH_C32(0xd0a91431) },
  { SPH_C32(0x7d490000), SPH_C32(0xad60120c), SPH_C32(0x787a0000),
    SPH_C32(0xeda50000), SPH_C32(0xb4ec7971), SPH_C32(0x45d43c99),
    SPH_C32(0x4544a92d), SPH_C32(0x499dda33), SPH_C32(0xe54f0000),
    SPH_C32(0x83a00c90), SPH_C32(0x37d00000), SPH_C32(0xd3990000),
    SPH_C32(0x5f9e3745), SPH_C32(0x13a968c2), SPH_C32(0x27937a8c),
    SPH_C32(0x5bc5668c) },
  { SPH_C32(0xb7480000), SPH_C32(0x4b081d00), SPH_C32(0x9ec20000),
    SPH_C32(0x90c20000), SPH_C32(0xa4575cec), SPH_C32(0x294548a2),
    SPH_C32(0xcdcf4ede), SPH_C32(0xca5b0bd0), SPH_C32(0xb44f0000),
    SPH_C32(0x5f940900), SPH_C32(0x75e30000), SPH_C32(0xa95b0000),
    SPH_C32(0x112b51b6), SPH_C32(0xbbcad451), SPH_C32(0xf3875d6d),
    SPH_C32(0x718aebae) },
  { SPH_C32(0x713b0000), SPH_C32(0xe4851d0c), SPH_C32(0x3a030000),
    SPH_C32(0xb14f0000), SPH_C32(0x8746496b), SPH_C32(0x5056198d),
    SPH_C32(0xd0e7e256), SPH_C32(0xfdd6daa3), SPH_C32(0x1b6d0000),
    SPH_C32(0x24f80990), SPH_C32(0x12010000), SPH_C32(0x24f90000),
    SPH_C32(0xd6af4f9f), SPH_C32(0x0c7d90a2), SPH_C32(0x6943d999),
    SPH_C32(0xfae69913) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0x7e4e0000), SPH_C32(0xb9fc060c), SPH_C32(0x935b0000),
    SPH_C32(0xd43c0000), SPH_C32(0x0190742b), SPH_C32(0xd75ba06a),
    SPH_C32(0x7b0cba9e), SPH_C32(0xf24c3a4d), SPH_C32(0x52070000),
    SPH_C32(0xc8a81190), SPH_C32(0xa9120000), SPH_C32(0x435b0000),
    SPH_C32(0xfbc96ba9), SPH_C32(0x3aec2060), SPH_C32(0xea5c3452),
    SPH_C32(0x919e6d5c) },
  { SPH_C32(0xb44f0000), SPH_C32(0x5f940900), SPH_C32(0x75e30000),
    SPH_C32(0xa95b0000), SPH_C32(0x112b51b6), SPH_C32(0xbbcad451),
    SPH_C32(0xf3875d6d), SPH_C32(0x718aebae), SPH_C32(0x03070000),
    SPH_C32(0x149c1400), SPH_C32(0xeb210000), SPH_C32(0x39990000),
    SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3), SPH_C32(0x3e4813b3),
    SPH_C32(0xbbd1e07e) },
  { SPH_C32(0x723c0000), SPH_C32(0xf019090c), SPH_C32(0xd1220000),
    SPH_C32(0x88d60000), SPH_C32(0x323a4431), SPH_C32(0xc2d9857e),
    SPH_C32(0xeeaff1e5), SPH_C32(0x46073add), SPH_C32(0xac250000),
    SPH_C32(0x6ff01490), SPH_C32(0x8cc30000), SPH_C32(0xb43b0000),
    SPH_C32(0x72f81373), SPH_C32(0x2538d800), SPH_C32(0xa48c9747),
    SPH_C32(0x30bd92c3) },
  { SPH_C32(0x461f0000), SPH_C32(0xb1290300), SPH_C32(0x124b0000),
    SPH_C32(0x02d10000), SPH_C32(0xabb01976), SPH_C32(0xb19c0925),
    SPH_C32(0x28f4b503), SPH_C32(0x64e214a1), SPH_C32(0x0f750000),
    SPH_C32(0x5d791b00), SPH_C32(0xa9580000), SPH_C32(0x65730000),
    SPH_C32(0x86d63d40), SPH_C32(0x870db9e7), SPH_C32(0xabeb58c8),
    SPH_C32(0x0f9ae0ee) },
  { SPH_C32(0x806c0000), SPH_C32(0x1ea4030c), SPH_C32(0xb68a0000),
    SPH_C32(0x235c0000), SPH_C32(0x88a10cf1), SPH_C32(0xc88f580a),
    SPH_C32(0x35dc198b), SPH_C32(0x536fc5d2), SPH_C32(0xa0570000),
    SPH_C32(0x26151b90), SPH_C32(0xceba0000), SPH_C32(0xe8d10000),
    SPH_C32(0x41522369), SPH_C32(0x30bafd14), SPH_C32(0x312fdc3c),
    SPH_C32(0x84f69253) },
  { SPH_C32(0x4a6d0000), SPH_C32(0xf8cc0c00), SPH_C32(0x50320000),
    SPH_C32(0x5e3b0000), SPH_C32(0x981a296c), SPH_C32(0xa41e2c31),
    SPH_C32(0xbd57fe78), SPH_C32(0xd0a91431), SPH_C32(0xf1570000),
    SPH_C32(0xfa211e00), SPH_C32(0x8c890000), SPH_C32(0x92130000),
    SPH_C32(0x0fe7459a), SPH_C32(0x98d94187), SPH_C32(0xe53bfbdd),
    SPH_C32(0xaeb91f71) },
  { SPH_C32(0x8c1e0000), SPH_C32(0x57410c0c), SPH_C32(0xf4f30000),
    SPH_C32(0x7fb60000), SPH_C32(0xbb0b3ceb), SPH_C32(0xdd0d7d1e),
    SPH_C32(0xa07f52f0), SPH_C32(0xe724c542), SPH_C32(0x5e750000),
    SPH_C32(0x814d1e90), SPH_C32(0xeb6b0000), SPH_C32(0x1fb10000),
    SPH_C32(0xc8635bb3), SPH_C32(0x2f6e0574), SPH_C32(0x7fff7f29),
    SPH_C32(0x25d56dcc) },
  { SPH_C32(0xfd250000), SPH_C32(0xb3c41100), SPH_C32(0xcef00000),
    SPH_C32(0xcef90000), SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493),
    SPH_C32(0x7098b0a6), SPH_C32(0x1af21fe1), SPH_C32(0x45180000),
    SPH_C32(0xa5b51700), SPH_C32(0xf96a0000), SPH_C32(0x3b480000),
    SPH_C32(0x1ecc142c), SPH_C32(0x231395d6), SPH_C32(0x16bca6b0),
    SPH_C32(0xdf33f4df) },
  { SPH_C32(0x3b560000), SPH_C32(0x1c49110c), SPH_C32(0x6a310000),
    SPH_C32(0xef740000), SPH_C32(0x1f5c6007), SPH_C32(0xf44835bc),
    SPH_C32(0x6db01c2e), SPH_C32(0x2d7fce92), SPH_C32(0xea3a0000),
    SPH_C32(0xded91790), SPH_C32(0x9e880000), SPH_C32(0xb6ea0000),
    SPH_C32(0xd9480a05), SPH_C32(0x94a4d125), SPH_C32(0x8c782244),
    SPH_C32(0x545f8662) },
  { SPH_C32(0xf1570000), SPH_C32(0xfa211e00), SPH_C32(0x8c890000),
    SPH_C32(0x92130000), SPH_C32(0x0fe7459a), SPH_C32(0x98d94187),
    SPH_C32(0xe53bfbdd), SPH_C32(0xaeb91f71), SPH_C32(0xbb3a0000),
    SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000), SPH_C32(0xcc280000),
    SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6), SPH_C32(0x586c05a5),
    SPH_C32(0x7e100b40) },
  { SPH_C32(0x37240000), SPH_C32(0x55ac1e0c), SPH_C32(0x28480000),
    SPH_C32(0xb39e0000), SPH_C32(0x2cf6501d), SPH_C32(0xe1ca10a8),
    SPH_C32(0xf8135755), SPH_C32(0x9934ce02), SPH_C32(0x14180000),
    SPH_C32(0x79811290), SPH_C32(0xbb590000), SPH_C32(0x418a0000),
    SPH_C32(0x507972df), SPH_C32(0x8b702945), SPH_C32(0xc2a88151),
    SPH_C32(0xf57c79fd) },
  { SPH_C32(0x03070000), SPH_C32(0x149c1400), SPH_C32(0xeb210000),
    SPH_C32(0x39990000), SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3),
    SPH_C32(0x3e4813b3), SPH_C32(0xbbd1e07e), SPH_C32(0xb7480000),
    SPH_C32(0x4b081d00), SPH_C32(0x9ec20000), SPH_C32(0x90c20000),
    SPH_C32(0xa4575cec), SPH_C32(0x294548a2), SPH_C32(0xcdcf4ede),
    SPH_C32(0xca5b0bd0) },
  { SPH_C32(0xc5740000), SPH_C32(0xbb11140c), SPH_C32(0x4fe00000),
    SPH_C32(0x18140000), SPH_C32(0x966d18dd), SPH_C32(0xeb9ccddc),
    SPH_C32(0x2360bf3b), SPH_C32(0x8c5c310d), SPH_C32(0x186a0000),
    SPH_C32(0x30641d90), SPH_C32(0xf9200000), SPH_C32(0x1d600000),
    SPH_C32(0x63d342c5), SPH_C32(0x9ef20c51), SPH_C32(0x570bca2a),
    SPH_C32(0x4137796d) },
  { SPH_C32(0x0f750000), SPH_C32(0x5d791b00), SPH_C32(0xa9580000),
    SPH_C32(0x65730000), SPH_C32(0x86d63d40), SPH_C32(0x870db9e7),
    SPH_C32(0xabeb58c8), SPH_C32(0x0f9ae0ee), SPH_C32(0x496a0000),
    SPH_C32(0xec501800), SPH_C32(0xbb130000), SPH_C32(0x67a20000),
    SPH_C32(0x2d662436), SPH_C32(0x3691b0c2), SPH_C32(0x831fedcb),
    SPH_C32(0x6b78f44f) },
  { SPH_C32(0xc9060000), SPH_C32(0xf2f41b0c), SPH_C32(0x0d990000),
    SPH_C32(0x44fe0000), SPH_C32(0xa5c728c7), SPH_C32(0xfe1ee8c8),
    SPH_C32(0xb6c3f440), SPH_C32(0x3817319d), SPH_C32(0xe6480000),
    SPH_C32(0x973c1890), SPH_C32(0xdcf10000), SPH_C32(0xea000000),
    SPH_C32(0xeae23a1f), SPH_C32(0x8126f431), SPH_C32(0x19db693f),
    SPH_C32(0xe01486f2) }
};

__constant static const sph_u32 T512_25[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0xf75a0000), SPH_C32(0x19840028), SPH_C32(0xa2190000),
    SPH_C32(0xeef80000), SPH_C32(0xc0722516), SPH_C32(0x19981260),
    SPH_C32(0x73dba1e6), SPH_C32(0xe1844257), SPH_C32(0x14190000),
    SPH_C32(0x23ca003c), SPH_C32(0x50df0000), SPH_C32(0x44b60000),
    SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75), SPH_C32(0x61e610b0),
    SPH_C32(0xdbcadb80) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0x40490000), SPH_C32(0x25bb0060), SPH_C32(0x75710000),
    SPH_C32(0x2ea80000), SPH_C32(0x35c9296f), SPH_C32(0x5abd2967),
    SPH_C32(0xde5c0873), SPH_C32(0xa5bb8697), SPH_C32(0x5fce0000),
    SPH_C32(0xc675000c), SPH_C32(0xeb450000), SPH_C32(0x7b450000),
    SPH_C32(0x75063a62), SPH_C32(0x67cd2643), SPH_C32(0x122f6b61),
    SPH_C32(0x1675c999) },
  { SPH_C32(0xb7130000), SPH_C32(0x3c3f0048), SPH_C32(0xd7680000),
    SPH_C32(0xc0500000), SPH_C32(0xf5bb0c79), SPH_C32(0x43253b07),
    SPH_C32(0xad87a995), SPH_C32(0x443fc4c0), SPH_C32(0x4bd70000),
    SPH_C32(0xe5bf0030), SPH_C32(0xbb9a0000), SPH_C32(0x3ff30000),
    SPH_C32(0x6e6a5dd2), SPH_C32(0x5b3e8a36), SPH_C32(0x73c97bd1),
    SPH_C32(0xcdbf1219) },
  { SPH_C32(0xa30a0000), SPH_C32(0x1ff50074), SPH_C32(0x87b70000),
    SPH_C32(0x84e60000), SPH_C32(0xeed76bc9), SPH_C32(0x7fd69772),
    SPH_C32(0xcc61b925), SPH_C32(0x9ff51f40), SPH_C32(0xa8940000),
    SPH_C32(0xdff10024), SPH_C32(0x495c0000), SPH_C32(0x95bd0000),
    SPH_C32(0xb5741f74), SPH_C32(0x7e553423), SPH_C32(0x61f4ca87),
    SPH_C32(0xf7f18bce) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0xa8940000), SPH_C32(0xdff10024), SPH_C32(0x495c0000),
    SPH_C32(0x95bd0000), SPH_C32(0xb5741f74), SPH_C32(0x7e553423),
    SPH_C32(0x61f4ca87), SPH_C32(0xf7f18bce), SPH_C32(0x0b9e0000),
    SPH_C32(0xc0040050), SPH_C32(0xceeb0000), SPH_C32(0x115b0000),
    SPH_C32(0x5ba374bd), SPH_C32(0x0183a351), SPH_C32(0xad9573a2),
    SPH_C32(0x6804948e) },
  { SPH_C32(0x5fce0000), SPH_C32(0xc675000c), SPH_C32(0xeb450000),
    SPH_C32(0x7b450000), SPH_C32(0x75063a62), SPH_C32(0x67cd2643),
    SPH_C32(0x122f6b61), SPH_C32(0x1675c999), SPH_C32(0x1f870000),
    SPH_C32(0xe3ce006c), SPH_C32(0x9e340000), SPH_C32(0x55ed0000),
    SPH_C32(0x40cf130d), SPH_C32(0x3d700f24), SPH_C32(0xcc736312),
    SPH_C32(0xb3ce4f0e) },
  { SPH_C32(0x4bd70000), SPH_C32(0xe5bf0030), SPH_C32(0xbb9a0000),
    SPH_C32(0x3ff30000), SPH_C32(0x6e6a5dd2), SPH_C32(0x5b3e8a36),
    SPH_C32(0x73c97bd1), SPH_C32(0xcdbf1219), SPH_C32(0xfcc40000),
    SPH_C32(0xd9800078), SPH_C32(0x6cf20000), SPH_C32(0xffa30000),
    SPH_C32(0x9bd151ab), SPH_C32(0x181bb131), SPH_C32(0xde4ed244),
    SPH_C32(0x8980d6d9) },
  { SPH_C32(0xe8dd0000), SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000),
    SPH_C32(0xbb150000), SPH_C32(0x80bd361b), SPH_C32(0x24e81d44),
    SPH_C32(0xbfa8c2f4), SPH_C32(0x524a0d59), SPH_C32(0x54500000),
    SPH_C32(0x0671005c), SPH_C32(0x25ae0000), SPH_C32(0x6a1e0000),
    SPH_C32(0x2ea54edf), SPH_C32(0x664e8512), SPH_C32(0xbfba18c3),
    SPH_C32(0x7e715d17) },
  { SPH_C32(0xfcc40000), SPH_C32(0xd9800078), SPH_C32(0x6cf20000),
    SPH_C32(0xffa30000), SPH_C32(0x9bd151ab), SPH_C32(0x181bb131),
    SPH_C32(0xde4ed244), SPH_C32(0x8980d6d9), SPH_C32(0xb7130000),
    SPH_C32(0x3c3f0048), SPH_C32(0xd7680000), SPH_C32(0xc0500000),
    SPH_C32(0xf5bb0c79), SPH_C32(0x43253b07), SPH_C32(0xad87a995),
    SPH_C32(0x443fc4c0) },
  { SPH_C32(0x0b9e0000), SPH_C32(0xc0040050), SPH_C32(0xceeb0000),
    SPH_C32(0x115b0000), SPH_C32(0x5ba374bd), SPH_C32(0x0183a351),
    SPH_C32(0xad9573a2), SPH_C32(0x6804948e), SPH_C32(0xa30a0000),
    SPH_C32(0x1ff50074), SPH_C32(0x87b70000), SPH_C32(0x84e60000),
    SPH_C32(0xeed76bc9), SPH_C32(0x7fd69772), SPH_C32(0xcc61b925),
    SPH_C32(0x9ff51f40) },
  { SPH_C32(0x1f870000), SPH_C32(0xe3ce006c), SPH_C32(0x9e340000),
    SPH_C32(0x55ed0000), SPH_C32(0x40cf130d), SPH_C32(0x3d700f24),
    SPH_C32(0xcc736312), SPH_C32(0xb3ce4f0e), SPH_C32(0x40490000),
    SPH_C32(0x25bb0060), SPH_C32(0x75710000), SPH_C32(0x2ea80000),
    SPH_C32(0x35c9296f), SPH_C32(0x5abd2967), SPH_C32(0xde5c0873),
    SPH_C32(0xa5bb8697) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0x7d480000), SPH_C32(0xf72b00a0), SPH_C32(0x93fc0000),
    SPH_C32(0xe8990000), SPH_C32(0xfff96c1e), SPH_C32(0xf257b9a9),
    SPH_C32(0xe60a38cc), SPH_C32(0x672b784e), SPH_C32(0x25300000),
    SPH_C32(0x95c30018), SPH_C32(0x56070000), SPH_C32(0x8bc30000),
    SPH_C32(0xf80f5721), SPH_C32(0x5c78ef3a), SPH_C32(0x0f151dde),
    SPH_C32(0x0dc348a4) },
  { SPH_C32(0x8a120000), SPH_C32(0xeeaf0088), SPH_C32(0x31e50000),
    SPH_C32(0x06610000), SPH_C32(0x3f8b4908), SPH_C32(0xebcfabc9),
    SPH_C32(0x95d1992a), SPH_C32(0x86af3a19), SPH_C32(0x31290000),
    SPH_C32(0xb6090024), SPH_C32(0x06d80000), SPH_C32(0xcf750000),
    SPH_C32(0xe3633091), SPH_C32(0x608b434f), SPH_C32(0x6ef30d6e),
    SPH_C32(0xd6099324) },
  { SPH_C32(0x9e0b0000), SPH_C32(0xcd6500b4), SPH_C32(0x613a0000),
    SPH_C32(0x42d70000), SPH_C32(0x24e72eb8), SPH_C32(0xd73c07bc),
    SPH_C32(0xf437899a), SPH_C32(0x5d65e199), SPH_C32(0xd26a0000),
    SPH_C32(0x8c470030), SPH_C32(0xf41e0000), SPH_C32(0x653b0000),
    SPH_C32(0x387d7237), SPH_C32(0x45e0fd5a), SPH_C32(0x7ccebc38),
    SPH_C32(0xec470af3) },
  { SPH_C32(0x3d010000), SPH_C32(0xd29000c0), SPH_C32(0xe68d0000),
    SPH_C32(0xc6310000), SPH_C32(0xca304571), SPH_C32(0xa8ea90ce),
    SPH_C32(0x385630bf), SPH_C32(0xc290fed9), SPH_C32(0x7afe0000),
    SPH_C32(0x53b60014), SPH_C32(0xbd420000), SPH_C32(0xf0860000),
    SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979), SPH_C32(0x1d3a76bf),
    SPH_C32(0x1bb6813d) },
  { SPH_C32(0x29180000), SPH_C32(0xf15a00fc), SPH_C32(0xb6520000),
    SPH_C32(0x82870000), SPH_C32(0xd15c22c1), SPH_C32(0x94193cbb),
    SPH_C32(0x59b0200f), SPH_C32(0x195a2559), SPH_C32(0x99bd0000),
    SPH_C32(0x69f80000), SPH_C32(0x4f840000), SPH_C32(0x5ac80000),
    SPH_C32(0x56172fe5), SPH_C32(0x1ede776c), SPH_C32(0x0f07c7e9),
    SPH_C32(0x21f818ea) },
  { SPH_C32(0xde420000), SPH_C32(0xe8de00d4), SPH_C32(0x144b0000),
    SPH_C32(0x6c7f0000), SPH_C32(0x112e07d7), SPH_C32(0x8d812edb),
    SPH_C32(0x2a6b81e9), SPH_C32(0xf8de670e), SPH_C32(0x8da40000),
    SPH_C32(0x4a32003c), SPH_C32(0x1f5b0000), SPH_C32(0x1e7e0000),
    SPH_C32(0x4d7b4855), SPH_C32(0x222ddb19), SPH_C32(0x6ee1d759),
    SPH_C32(0xfa32c36a) },
  { SPH_C32(0xca5b0000), SPH_C32(0xcb1400e8), SPH_C32(0x44940000),
    SPH_C32(0x28c90000), SPH_C32(0x0a426067), SPH_C32(0xb17282ae),
    SPH_C32(0x4b8d9159), SPH_C32(0x2314bc8e), SPH_C32(0x6ee70000),
    SPH_C32(0x707c0028), SPH_C32(0xed9d0000), SPH_C32(0xb4300000),
    SPH_C32(0x96650af3), SPH_C32(0x0746650c), SPH_C32(0x7cdc660f),
    SPH_C32(0xc07c5abd) },
  { SPH_C32(0xd5dc0000), SPH_C32(0x28da0084), SPH_C32(0xdaa00000),
    SPH_C32(0x7d240000), SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a),
    SPH_C32(0x87fef24b), SPH_C32(0x90daf380), SPH_C32(0x2eae0000),
    SPH_C32(0x55c70048), SPH_C32(0x98ec0000), SPH_C32(0x9a980000),
    SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b), SPH_C32(0xa2806e7c),
    SPH_C32(0x65c7dc2a) },
  { SPH_C32(0xc1c50000), SPH_C32(0x0b1000b8), SPH_C32(0x8a7f0000),
    SPH_C32(0x39920000), SPH_C32(0x51e114da), SPH_C32(0xb0f121ff),
    SPH_C32(0xe618e2fb), SPH_C32(0x4b102800), SPH_C32(0xcded0000),
    SPH_C32(0x6f89005c), SPH_C32(0x6a2a0000), SPH_C32(0x30d60000),
    SPH_C32(0x78b2613a), SPH_C32(0x7890f27e), SPH_C32(0xb0bddf2a),
    SPH_C32(0x5f8945fd) },
  { SPH_C32(0x369f0000), SPH_C32(0x12940090), SPH_C32(0x28660000),
    SPH_C32(0xd76a0000), SPH_C32(0x919331cc), SPH_C32(0xa969339f),
    SPH_C32(0x95c3431d), SPH_C32(0xaa946a57), SPH_C32(0xd9f40000),
    SPH_C32(0x4c430060), SPH_C32(0x3af50000), SPH_C32(0x74600000),
    SPH_C32(0x63de068a), SPH_C32(0x44635e0b), SPH_C32(0xd15bcf9a),
    SPH_C32(0x84439e7d) },
  { SPH_C32(0x22860000), SPH_C32(0x315e00ac), SPH_C32(0x78b90000),
    SPH_C32(0x93dc0000), SPH_C32(0x8aff567c), SPH_C32(0x959a9fea),
    SPH_C32(0xf42553ad), SPH_C32(0x715eb1d7), SPH_C32(0x3ab70000),
    SPH_C32(0x760d0074), SPH_C32(0xc8330000), SPH_C32(0xde2e0000),
    SPH_C32(0xb8c0442c), SPH_C32(0x6108e01e), SPH_C32(0xc3667ecc),
    SPH_C32(0xbe0d07aa) },
  { SPH_C32(0x818c0000), SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000),
    SPH_C32(0x173a0000), SPH_C32(0x64283db5), SPH_C32(0xea4c0898),
    SPH_C32(0x3844ea88), SPH_C32(0xeeabae97), SPH_C32(0x92230000),
    SPH_C32(0xa9fc0050), SPH_C32(0x816f0000), SPH_C32(0x4b930000),
    SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d), SPH_C32(0xa292b44b),
    SPH_C32(0x49fc8c64) },
  { SPH_C32(0x95950000), SPH_C32(0x0d6100e4), SPH_C32(0xafd10000),
    SPH_C32(0x538c0000), SPH_C32(0x7f445a05), SPH_C32(0xd6bfa4ed),
    SPH_C32(0x59a2fa38), SPH_C32(0x35617517), SPH_C32(0x71600000),
    SPH_C32(0x93b20044), SPH_C32(0x73a90000), SPH_C32(0xe1dd0000),
    SPH_C32(0xd6aa19fe), SPH_C32(0x3a366a28), SPH_C32(0xb0af051d),
    SPH_C32(0x73b215b3) },
  { SPH_C32(0x62cf0000), SPH_C32(0x14e500cc), SPH_C32(0x0dc80000),
    SPH_C32(0xbd740000), SPH_C32(0xbf367f13), SPH_C32(0xcf27b68d),
    SPH_C32(0x2a795bde), SPH_C32(0xd4e53740), SPH_C32(0x65790000),
    SPH_C32(0xb0780078), SPH_C32(0x23760000), SPH_C32(0xa56b0000),
    SPH_C32(0xcdc67e4e), SPH_C32(0x06c5c65d), SPH_C32(0xd14915ad),
    SPH_C32(0xa878ce33) },
  { SPH_C32(0x76d60000), SPH_C32(0x372f00f0), SPH_C32(0x5d170000),
    SPH_C32(0xf9c20000), SPH_C32(0xa45a18a3), SPH_C32(0xf3d41af8),
    SPH_C32(0x4b9f4b6e), SPH_C32(0x0f2fecc0), SPH_C32(0x863a0000),
    SPH_C32(0x8a36006c), SPH_C32(0xd1b00000), SPH_C32(0x0f250000),
    SPH_C32(0x16d83ce8), SPH_C32(0x23ae7848), SPH_C32(0xc374a4fb),
    SPH_C32(0x923657e4) }
};

__constant static const sph_u32 T512_30[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0xb08d0000), SPH_C32(0x42800001), SPH_C32(0x1429e180),
    SPH_C32(0x5b310000), SPH_C32(0xa98b722d), SPH_C32(0x92f0de78),
    SPH_C32(0x6631ef9d), SPH_C32(0x3bb81f15), SPH_C32(0x69230000),
    SPH_C32(0xcc400000), SPH_C32(0x61a9d200), SPH_C32(0xf5860000),
    SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9), SPH_C32(0x7087b49a),
    SPH_C32(0xe1228bb6) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0xc56b0000), SPH_C32(0xd7e60000), SPH_C32(0x2452c180),
    SPH_C32(0xf6c50000), SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f),
    SPH_C32(0x8ef57364), SPH_C32(0x70c6f340), SPH_C32(0xc7e00000),
    SPH_C32(0x500f0001), SPH_C32(0x18783200), SPH_C32(0xd9930000),
    SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff), SPH_C32(0xdb154315),
    SPH_C32(0x4230ddcd) },
  { SPH_C32(0x75e60000), SPH_C32(0x95660001), SPH_C32(0x307b2000),
    SPH_C32(0xadf40000), SPH_C32(0x8f321eea), SPH_C32(0x24298307),
    SPH_C32(0xe8c49cf9), SPH_C32(0x4b7eec55), SPH_C32(0xaec30000),
    SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000), SPH_C32(0x2c150000),
    SPH_C32(0x45cc75b3), SPH_C32(0x6650b736), SPH_C32(0xab92f78f),
    SPH_C32(0xa312567b) },
  { SPH_C32(0x6ba80000), SPH_C32(0x4ba90001), SPH_C32(0x5d832180),
    SPH_C32(0xdad00000), SPH_C32(0x63751974), SPH_C32(0xd089ea49),
    SPH_C32(0x256784eb), SPH_C32(0xd3d4a53b), SPH_C32(0x1cc50000),
    SPH_C32(0x59260001), SPH_C32(0x51d2f200), SPH_C32(0x58720000),
    SPH_C32(0xf30e4347), SPH_C32(0x8d428ece), SPH_C32(0x98432863),
    SPH_C32(0xaa5c67e3) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x98370000), SPH_C32(0xe1f60002), SPH_C32(0x8c62e180),
    SPH_C32(0xef720000), SPH_C32(0x79226090), SPH_C32(0xba28a1a4),
    SPH_C32(0x1e7e5156), SPH_C32(0x8eb793d7), SPH_C32(0x82b10000),
    SPH_C32(0x20b90000), SPH_C32(0xdcf77200), SPH_C32(0x36a30000),
    SPH_C32(0xd57a0b9e), SPH_C32(0x93a8ad98), SPH_C32(0x127e7e06),
    SPH_C32(0xb9eb29ac) },
  { SPH_C32(0x28ba0000), SPH_C32(0xa3760003), SPH_C32(0x984b0000),
    SPH_C32(0xb4430000), SPH_C32(0xd0a912bd), SPH_C32(0x28d87fdc),
    SPH_C32(0x784fbecb), SPH_C32(0xb50f8cc2), SPH_C32(0xeb920000),
    SPH_C32(0xecf90000), SPH_C32(0xbd5ea000), SPH_C32(0xc3250000),
    SPH_C32(0xa9465633), SPH_C32(0x3ac3a051), SPH_C32(0x62f9ca9c),
    SPH_C32(0x58c9a21a) },
  { SPH_C32(0x36f40000), SPH_C32(0x7db90003), SPH_C32(0xf5b30180),
    SPH_C32(0xc3670000), SPH_C32(0x3cee1523), SPH_C32(0xdc781692),
    SPH_C32(0xb5eca6d9), SPH_C32(0x2da5c5ac), SPH_C32(0x59940000),
    SPH_C32(0x29900000), SPH_C32(0x955db200), SPH_C32(0xb7420000),
    SPH_C32(0x1f8460c7), SPH_C32(0xd1d199a9), SPH_C32(0x51281570),
    SPH_C32(0x51879382) },
  { SPH_C32(0x5d5c0000), SPH_C32(0x36100002), SPH_C32(0xa8302000),
    SPH_C32(0x19b70000), SPH_C32(0x5f9b0c57), SPH_C32(0x0cf1fcdb),
    SPH_C32(0x908b2232), SPH_C32(0xfe716097), SPH_C32(0x45510000),
    SPH_C32(0x70b60001), SPH_C32(0xc48f4000), SPH_C32(0xef300000),
    SPH_C32(0xec8a2380), SPH_C32(0x5c931767), SPH_C32(0xc96b3d13),
    SPH_C32(0xfbdbf461) },
  { SPH_C32(0x43120000), SPH_C32(0xe8df0002), SPH_C32(0xc5c82180),
    SPH_C32(0x6e930000), SPH_C32(0xb3dc0bc9), SPH_C32(0xf8519595),
    SPH_C32(0x5d283a20), SPH_C32(0x66db29f9), SPH_C32(0xf7570000),
    SPH_C32(0xb5df0001), SPH_C32(0xec8c5200), SPH_C32(0x9b570000),
    SPH_C32(0x5a481574), SPH_C32(0xb7812e9f), SPH_C32(0xfabae2ff),
    SPH_C32(0xf295c5f9) },
  { SPH_C32(0xf39f0000), SPH_C32(0xaa5f0003), SPH_C32(0xd1e1c000),
    SPH_C32(0x35a20000), SPH_C32(0x1a5779e4), SPH_C32(0x6aa14bed),
    SPH_C32(0x3b19d5bd), SPH_C32(0x5d6336ec), SPH_C32(0x9e740000),
    SPH_C32(0x799f0001), SPH_C32(0x8d258000), SPH_C32(0x6ed10000),
    SPH_C32(0x267448d9), SPH_C32(0x1eea2356), SPH_C32(0x8a3d5665),
    SPH_C32(0x13b74e4f) },
  { SPH_C32(0xedd10000), SPH_C32(0x74900003), SPH_C32(0xbc19c180),
    SPH_C32(0x42860000), SPH_C32(0xf6107e7a), SPH_C32(0x9e0122a3),
    SPH_C32(0xf6bacdaf), SPH_C32(0xc5c97f82), SPH_C32(0x2c720000),
    SPH_C32(0xbcf60001), SPH_C32(0xa5269200), SPH_C32(0x1ab60000),
    SPH_C32(0x90b67e2d), SPH_C32(0xf5f81aae), SPH_C32(0xb9ec8989),
    SPH_C32(0x1af97fd7) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0x2ef90000), SPH_C32(0x3b1f0000), SPH_C32(0x990c6180),
    SPH_C32(0x35e00000), SPH_C32(0x8fff3af4), SPH_C32(0x8c1afd2e),
    SPH_C32(0xec0cb9f8), SPH_C32(0x280f515a), SPH_C32(0x04c80000),
    SPH_C32(0x1f800002), SPH_C32(0x3d6d9200), SPH_C32(0xaef50000),
    SPH_C32(0x401f6c90), SPH_C32(0xdd206572), SPH_C32(0xc1a33742),
    SPH_C32(0xaff6f315) },
  { SPH_C32(0x9e740000), SPH_C32(0x799f0001), SPH_C32(0x8d258000),
    SPH_C32(0x6ed10000), SPH_C32(0x267448d9), SPH_C32(0x1eea2356),
    SPH_C32(0x8a3d5665), SPH_C32(0x13b74e4f), SPH_C32(0x6deb0000),
    SPH_C32(0xd3c00002), SPH_C32(0x5cc44000), SPH_C32(0x5b730000),
    SPH_C32(0x3c23313d), SPH_C32(0x744b68bb), SPH_C32(0xb12483d8),
    SPH_C32(0x4ed478a3) },
  { SPH_C32(0x803a0000), SPH_C32(0xa7500001), SPH_C32(0xe0dd8180),
    SPH_C32(0x19f50000), SPH_C32(0xca334f47), SPH_C32(0xea4a4a18),
    SPH_C32(0x479e4e77), SPH_C32(0x8b1d0721), SPH_C32(0xdfed0000),
    SPH_C32(0x16a90002), SPH_C32(0x74c75200), SPH_C32(0x2f140000),
    SPH_C32(0x8ae107c9), SPH_C32(0x9f595143), SPH_C32(0x82f55c34),
    SPH_C32(0x479a493b) },
  { SPH_C32(0xeb920000), SPH_C32(0xecf90000), SPH_C32(0xbd5ea000),
    SPH_C32(0xc3250000), SPH_C32(0xa9465633), SPH_C32(0x3ac3a051),
    SPH_C32(0x62f9ca9c), SPH_C32(0x58c9a21a), SPH_C32(0xc3280000),
    SPH_C32(0x4f8f0003), SPH_C32(0x2515a000), SPH_C32(0x77660000),
    SPH_C32(0x79ef448e), SPH_C32(0x121bdf8d), SPH_C32(0x1ab67457),
    SPH_C32(0xedc62ed8) },
  { SPH_C32(0xf5dc0000), SPH_C32(0x32360000), SPH_C32(0xd0a6a180),
    SPH_C32(0xb4010000), SPH_C32(0x450151ad), SPH_C32(0xce63c91f),
    SPH_C32(0xaf5ad28e), SPH_C32(0xc063eb74), SPH_C32(0x712e0000),
    SPH_C32(0x8ae60003), SPH_C32(0x0d16b200), SPH_C32(0x03010000),
    SPH_C32(0xcf2d727a), SPH_C32(0xf909e675), SPH_C32(0x2967abbb),
    SPH_C32(0xe4881f40) },
  { SPH_C32(0x45510000), SPH_C32(0x70b60001), SPH_C32(0xc48f4000),
    SPH_C32(0xef300000), SPH_C32(0xec8a2380), SPH_C32(0x5c931767),
    SPH_C32(0xc96b3d13), SPH_C32(0xfbdbf461), SPH_C32(0x180d0000),
    SPH_C32(0x46a60003), SPH_C32(0x6cbf6000), SPH_C32(0xf6870000),
    SPH_C32(0xb3112fd7), SPH_C32(0x5062ebbc), SPH_C32(0x59e01f21),
    SPH_C32(0x05aa94f6) },
  { SPH_C32(0x5b1f0000), SPH_C32(0xae790001), SPH_C32(0xa9774180),
    SPH_C32(0x98140000), SPH_C32(0x00cd241e), SPH_C32(0xa8337e29),
    SPH_C32(0x04c82501), SPH_C32(0x6371bd0f), SPH_C32(0xaa0b0000),
    SPH_C32(0x83cf0003), SPH_C32(0x44bc7200), SPH_C32(0x82e00000),
    SPH_C32(0x05d31923), SPH_C32(0xbb70d244), SPH_C32(0x6a31c0cd),
    SPH_C32(0x0ce4a56e) },
  { SPH_C32(0xb6ce0000), SPH_C32(0xdae90002), SPH_C32(0x156e8000),
    SPH_C32(0xda920000), SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a),
    SPH_C32(0xf272e8ae), SPH_C32(0xa6b8c28d), SPH_C32(0x86790000),
    SPH_C32(0x3f390002), SPH_C32(0xe19ae000), SPH_C32(0x98560000),
    SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea), SPH_C32(0xd3dd4944),
    SPH_C32(0x161ddab9) },
  { SPH_C32(0xa8800000), SPH_C32(0x04260002), SPH_C32(0x78968180),
    SPH_C32(0xadb60000), SPH_C32(0x1a9a5dfa), SPH_C32(0xc29235c4),
    SPH_C32(0x3fd1f0bc), SPH_C32(0x3e128be3), SPH_C32(0x347f0000),
    SPH_C32(0xfa500002), SPH_C32(0xc999f200), SPH_C32(0xec310000),
    SPH_C32(0x23a751fa), SPH_C32(0xa59af112), SPH_C32(0xe00c96a8),
    SPH_C32(0x1f53eb21) },
  { SPH_C32(0x180d0000), SPH_C32(0x46a60003), SPH_C32(0x6cbf6000),
    SPH_C32(0xf6870000), SPH_C32(0xb3112fd7), SPH_C32(0x5062ebbc),
    SPH_C32(0x59e01f21), SPH_C32(0x05aa94f6), SPH_C32(0x5d5c0000),
    SPH_C32(0x36100002), SPH_C32(0xa8302000), SPH_C32(0x19b70000),
    SPH_C32(0x5f9b0c57), SPH_C32(0x0cf1fcdb), SPH_C32(0x908b2232),
    SPH_C32(0xfe716097) },
  { SPH_C32(0x06430000), SPH_C32(0x98690003), SPH_C32(0x01476180),
    SPH_C32(0x81a30000), SPH_C32(0x5f562849), SPH_C32(0xa4c282f2),
    SPH_C32(0x94430733), SPH_C32(0x9d00dd98), SPH_C32(0xef5a0000),
    SPH_C32(0xf3790002), SPH_C32(0x80333200), SPH_C32(0x6dd00000),
    SPH_C32(0xe9593aa3), SPH_C32(0xe7e3c523), SPH_C32(0xa35afdde),
    SPH_C32(0xf73f510f) },
  { SPH_C32(0x6deb0000), SPH_C32(0xd3c00002), SPH_C32(0x5cc44000),
    SPH_C32(0x5b730000), SPH_C32(0x3c23313d), SPH_C32(0x744b68bb),
    SPH_C32(0xb12483d8), SPH_C32(0x4ed478a3), SPH_C32(0xf39f0000),
    SPH_C32(0xaa5f0003), SPH_C32(0xd1e1c000), SPH_C32(0x35a20000),
    SPH_C32(0x1a5779e4), SPH_C32(0x6aa14bed), SPH_C32(0x3b19d5bd),
    SPH_C32(0x5d6336ec) },
  { SPH_C32(0x73a50000), SPH_C32(0x0d0f0002), SPH_C32(0x313c4180),
    SPH_C32(0x2c570000), SPH_C32(0xd06436a3), SPH_C32(0x80eb01f5),
    SPH_C32(0x7c879bca), SPH_C32(0xd67e31cd), SPH_C32(0x41990000),
    SPH_C32(0x6f360003), SPH_C32(0xf9e2d200), SPH_C32(0x41c50000),
    SPH_C32(0xac954f10), SPH_C32(0x81b37215), SPH_C32(0x08c80a51),
    SPH_C32(0x542d0774) },
  { SPH_C32(0xc3280000), SPH_C32(0x4f8f0003), SPH_C32(0x2515a000),
    SPH_C32(0x77660000), SPH_C32(0x79ef448e), SPH_C32(0x121bdf8d),
    SPH_C32(0x1ab67457), SPH_C32(0xedc62ed8), SPH_C32(0x28ba0000),
    SPH_C32(0xa3760003), SPH_C32(0x984b0000), SPH_C32(0xb4430000),
    SPH_C32(0xd0a912bd), SPH_C32(0x28d87fdc), SPH_C32(0x784fbecb),
    SPH_C32(0xb50f8cc2) },
  { SPH_C32(0xdd660000), SPH_C32(0x91400003), SPH_C32(0x48eda180),
    SPH_C32(0x00420000), SPH_C32(0x95a84310), SPH_C32(0xe6bbb6c3),
    SPH_C32(0xd7156c45), SPH_C32(0x756c67b6), SPH_C32(0x9abc0000),
    SPH_C32(0x661f0003), SPH_C32(0xb0481200), SPH_C32(0xc0240000),
    SPH_C32(0x666b2449), SPH_C32(0xc3ca4624), SPH_C32(0x4b9e6127),
    SPH_C32(0xbc41bd5a) }
};

__constant static const sph_u32 T512_35[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0x4d8a0000), SPH_C32(0x49340000), SPH_C32(0x3c8b0500),
    SPH_C32(0xaea30000), SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4),
    SPH_C32(0x8f19eaec), SPH_C32(0x443d3004), SPH_C32(0xcc140000),
    SPH_C32(0xa5630000), SPH_C32(0x5ab90780), SPH_C32(0x3b500000),
    SPH_C32(0x4bd013ff), SPH_C32(0x879b3418), SPH_C32(0x694348c1),
    SPH_C32(0xca5a87fe) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0xb4370000), SPH_C32(0xb79f0000), SPH_C32(0xf3830c00),
    SPH_C32(0xabf50000), SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c),
    SPH_C32(0x99cfe8a3), SPH_C32(0xa9350c55), SPH_C32(0x83310000),
    SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180), SPH_C32(0xc36b0000),
    SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb), SPH_C32(0x4f06b6b7),
    SPH_C32(0x7a915d81) },
  { SPH_C32(0xf9bd0000), SPH_C32(0xfeab0000), SPH_C32(0xcf080900),
    SPH_C32(0x05560000), SPH_C32(0x2c97007b), SPH_C32(0x361db598),
    SPH_C32(0x16d6024f), SPH_C32(0xed083c51), SPH_C32(0x4f250000),
    SPH_C32(0xfe1c0000), SPH_C32(0x86970600), SPH_C32(0xf83b0000),
    SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3), SPH_C32(0x2645fe76),
    SPH_C32(0xb0cbda7f) },
  { SPH_C32(0x35a90000), SPH_C32(0x5bc80000), SPH_C32(0x95b10e80),
    SPH_C32(0x3e060000), SPH_C32(0x67471384), SPH_C32(0xb1868180),
    SPH_C32(0x7f954a8e), SPH_C32(0x2752bbaf), SPH_C32(0xcebb0000),
    SPH_C32(0x124b0000), SPH_C32(0xe0a50480), SPH_C32(0x6dc80000),
    SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f), SPH_C32(0xc01f5c5b),
    SPH_C32(0x3eac6d85) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0xcebb0000), SPH_C32(0x124b0000), SPH_C32(0xe0a50480),
    SPH_C32(0x6dc80000), SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f),
    SPH_C32(0xc01f5c5b), SPH_C32(0x3eac6d85), SPH_C32(0xfb120000),
    SPH_C32(0x49830000), SPH_C32(0x75140a00), SPH_C32(0x53ce0000),
    SPH_C32(0x961a45a8), SPH_C32(0xb65573ff), SPH_C32(0xbf8a16d5),
    SPH_C32(0x19fed62a) },
  { SPH_C32(0x83310000), SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180),
    SPH_C32(0xc36b0000), SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb),
    SPH_C32(0x4f06b6b7), SPH_C32(0x7a915d81), SPH_C32(0x37060000),
    SPH_C32(0xece00000), SPH_C32(0x2fad0d80), SPH_C32(0x689e0000),
    SPH_C32(0xddca5657), SPH_C32(0x31ce47e7), SPH_C32(0xd6c95e14),
    SPH_C32(0xd3a451d4) },
  { SPH_C32(0x4f250000), SPH_C32(0xfe1c0000), SPH_C32(0x86970600),
    SPH_C32(0xf83b0000), SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3),
    SPH_C32(0x2645fe76), SPH_C32(0xb0cbda7f), SPH_C32(0xb6980000),
    SPH_C32(0x00b70000), SPH_C32(0x499f0f00), SPH_C32(0xfd6d0000),
    SPH_C32(0x80637e55), SPH_C32(0x793a7b5b), SPH_C32(0x3093fc39),
    SPH_C32(0x5dc3e62e) },
  { SPH_C32(0x7a8c0000), SPH_C32(0xa5d40000), SPH_C32(0x13260880),
    SPH_C32(0xc63d0000), SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43),
    SPH_C32(0x59d0b4f8), SPH_C32(0x979961d0), SPH_C32(0x78230000),
    SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80), SPH_C32(0x90a50000),
    SPH_C32(0x713e2879), SPH_C32(0x7ee98924), SPH_C32(0xf08ca062),
    SPH_C32(0x636f8bab) },
  { SPH_C32(0xb6980000), SPH_C32(0x00b70000), SPH_C32(0x499f0f00),
    SPH_C32(0xfd6d0000), SPH_C32(0x80637e55), SPH_C32(0x793a7b5b),
    SPH_C32(0x3093fc39), SPH_C32(0x5dc3e62e), SPH_C32(0xf9bd0000),
    SPH_C32(0xfeab0000), SPH_C32(0xcf080900), SPH_C32(0x05560000),
    SPH_C32(0x2c97007b), SPH_C32(0x361db598), SPH_C32(0x16d6024f),
    SPH_C32(0xed083c51) },
  { SPH_C32(0xfb120000), SPH_C32(0x49830000), SPH_C32(0x75140a00),
    SPH_C32(0x53ce0000), SPH_C32(0x961a45a8), SPH_C32(0xb65573ff),
    SPH_C32(0xbf8a16d5), SPH_C32(0x19fed62a), SPH_C32(0x35a90000),
    SPH_C32(0x5bc80000), SPH_C32(0x95b10e80), SPH_C32(0x3e060000),
    SPH_C32(0x67471384), SPH_C32(0xb1868180), SPH_C32(0x7f954a8e),
    SPH_C32(0x2752bbaf) },
  { SPH_C32(0x37060000), SPH_C32(0xece00000), SPH_C32(0x2fad0d80),
    SPH_C32(0x689e0000), SPH_C32(0xddca5657), SPH_C32(0x31ce47e7),
    SPH_C32(0xd6c95e14), SPH_C32(0xd3a451d4), SPH_C32(0xb4370000),
    SPH_C32(0xb79f0000), SPH_C32(0xf3830c00), SPH_C32(0xabf50000),
    SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c), SPH_C32(0x99cfe8a3),
    SPH_C32(0xa9350c55) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0x605c0000), SPH_C32(0xbec50000), SPH_C32(0x1f421400),
    SPH_C32(0x38130000), SPH_C32(0x11552295), SPH_C32(0x982964ae),
    SPH_C32(0x97318f3f), SPH_C32(0x5bbeff08), SPH_C32(0x9fd00000),
    SPH_C32(0x32980000), SPH_C32(0x0bca0300), SPH_C32(0xe2d70000),
    SPH_C32(0xb1ee2f9c), SPH_C32(0xbc5455f2), SPH_C32(0x2bf9ba3f),
    SPH_C32(0x16cdfe94) },
  { SPH_C32(0x2dd60000), SPH_C32(0xf7f10000), SPH_C32(0x23c91100),
    SPH_C32(0x96b00000), SPH_C32(0x072c1968), SPH_C32(0x57466c0a),
    SPH_C32(0x182865d3), SPH_C32(0x1f83cf0c), SPH_C32(0x53c40000),
    SPH_C32(0x97fb0000), SPH_C32(0x51730480), SPH_C32(0xd9870000),
    SPH_C32(0xfa3e3c63), SPH_C32(0x3bcf61ea), SPH_C32(0x42baf2fe),
    SPH_C32(0xdc97796a) },
  { SPH_C32(0xe1c20000), SPH_C32(0x52920000), SPH_C32(0x79701680),
    SPH_C32(0xade00000), SPH_C32(0x4cfc0a97), SPH_C32(0xd0dd5812),
    SPH_C32(0x716b2d12), SPH_C32(0xd5d948f2), SPH_C32(0xd25a0000),
    SPH_C32(0x7bac0000), SPH_C32(0x37410600), SPH_C32(0x4c740000),
    SPH_C32(0xa7971461), SPH_C32(0x733b5d56), SPH_C32(0xa4e050d3),
    SPH_C32(0x52f0ce90) },
  { SPH_C32(0xd46b0000), SPH_C32(0x095a0000), SPH_C32(0xecc11800),
    SPH_C32(0x93e60000), SPH_C32(0x2bbb1913), SPH_C32(0x615bd992),
    SPH_C32(0x0efe679c), SPH_C32(0xf28bf35d), SPH_C32(0x1ce10000),
    SPH_C32(0x69e70000), SPH_C32(0xd7e40280), SPH_C32(0x21bc0000),
    SPH_C32(0x56ca424d), SPH_C32(0x74e8af29), SPH_C32(0x64ff0c88),
    SPH_C32(0x6c5ca315) },
  { SPH_C32(0x187f0000), SPH_C32(0xac390000), SPH_C32(0xb6781f80),
    SPH_C32(0xa8b60000), SPH_C32(0x606b0aec), SPH_C32(0xe6c0ed8a),
    SPH_C32(0x67bd2f5d), SPH_C32(0x38d174a3), SPH_C32(0x9d7f0000),
    SPH_C32(0x85b00000), SPH_C32(0xb1d60000), SPH_C32(0xb44f0000),
    SPH_C32(0x0b636a4f), SPH_C32(0x3c1c9395), SPH_C32(0x82a5aea5),
    SPH_C32(0xe23b14ef) },
  { SPH_C32(0x55f50000), SPH_C32(0xe50d0000), SPH_C32(0x8af31a80),
    SPH_C32(0x06150000), SPH_C32(0x76123111), SPH_C32(0x29afe52e),
    SPH_C32(0xe8a4c5b1), SPH_C32(0x7cec44a7), SPH_C32(0x516b0000),
    SPH_C32(0x20d30000), SPH_C32(0xeb6f0780), SPH_C32(0x8f1f0000),
    SPH_C32(0x40b379b0), SPH_C32(0xbb87a78d), SPH_C32(0xebe6e664),
    SPH_C32(0x28619311) },
  { SPH_C32(0x99e10000), SPH_C32(0x406e0000), SPH_C32(0xd04a1d00),
    SPH_C32(0x3d450000), SPH_C32(0x3dc222ee), SPH_C32(0xae34d136),
    SPH_C32(0x81e78d70), SPH_C32(0xb6b6c359), SPH_C32(0xd0f50000),
    SPH_C32(0xcc840000), SPH_C32(0x8d5d0500), SPH_C32(0x1aec0000),
    SPH_C32(0x1d1a51b2), SPH_C32(0xf3739b31), SPH_C32(0x0dbc4449),
    SPH_C32(0xa60624eb) },
  { SPH_C32(0xaee70000), SPH_C32(0xac8e0000), SPH_C32(0xffe71080),
    SPH_C32(0x55db0000), SPH_C32(0xe00874b9), SPH_C32(0x9ffa96d1),
    SPH_C32(0x572ed364), SPH_C32(0x6512928d), SPH_C32(0x64c20000),
    SPH_C32(0x7b1b0000), SPH_C32(0x7ede0900), SPH_C32(0xb1190000),
    SPH_C32(0x27f46a34), SPH_C32(0x0a01260d), SPH_C32(0x9473acea),
    SPH_C32(0x0f3328be) },
  { SPH_C32(0x62f30000), SPH_C32(0x09ed0000), SPH_C32(0xa55e1700),
    SPH_C32(0x6e8b0000), SPH_C32(0xabd86746), SPH_C32(0x1861a2c9),
    SPH_C32(0x3e6d9ba5), SPH_C32(0xaf481573), SPH_C32(0xe55c0000),
    SPH_C32(0x974c0000), SPH_C32(0x18ec0b80), SPH_C32(0x24ea0000),
    SPH_C32(0x7a5d4236), SPH_C32(0x42f51ab1), SPH_C32(0x72290ec7),
    SPH_C32(0x81549f44) },
  { SPH_C32(0x2f790000), SPH_C32(0x40d90000), SPH_C32(0x99d51200),
    SPH_C32(0xc0280000), SPH_C32(0xbda15cbb), SPH_C32(0xd70eaa6d),
    SPH_C32(0xb1747149), SPH_C32(0xeb752577), SPH_C32(0x29480000),
    SPH_C32(0x322f0000), SPH_C32(0x42550c00), SPH_C32(0x1fba0000),
    SPH_C32(0x318d51c9), SPH_C32(0xc56e2ea9), SPH_C32(0x1b6a4606),
    SPH_C32(0x4b0e18ba) },
  { SPH_C32(0xe36d0000), SPH_C32(0xe5ba0000), SPH_C32(0xc36c1580),
    SPH_C32(0xfb780000), SPH_C32(0xf6714f44), SPH_C32(0x50959e75),
    SPH_C32(0xd8373988), SPH_C32(0x212fa289), SPH_C32(0xa8d60000),
    SPH_C32(0xde780000), SPH_C32(0x24670e80), SPH_C32(0x8a490000),
    SPH_C32(0x6c2479cb), SPH_C32(0x8d9a1215), SPH_C32(0xfd30e42b),
    SPH_C32(0xc569af40) },
  { SPH_C32(0xd6c40000), SPH_C32(0xbe720000), SPH_C32(0x56dd1b00),
    SPH_C32(0xc57e0000), SPH_C32(0x91365cc0), SPH_C32(0xe1131ff5),
    SPH_C32(0xa7a27306), SPH_C32(0x067d1926), SPH_C32(0x666d0000),
    SPH_C32(0xcc330000), SPH_C32(0xc4c20a00), SPH_C32(0xe7810000),
    SPH_C32(0x9d792fe7), SPH_C32(0x8a49e06a), SPH_C32(0x3d2fb870),
    SPH_C32(0xfbc5c2c5) },
  { SPH_C32(0x1ad00000), SPH_C32(0x1b110000), SPH_C32(0x0c641c80),
    SPH_C32(0xfe2e0000), SPH_C32(0xdae64f3f), SPH_C32(0x66882bed),
    SPH_C32(0xcee13bc7), SPH_C32(0xcc279ed8), SPH_C32(0xe7f30000),
    SPH_C32(0x20640000), SPH_C32(0xa2f00880), SPH_C32(0x72720000),
    SPH_C32(0xc0d007e5), SPH_C32(0xc2bddcd6), SPH_C32(0xdb751a5d),
    SPH_C32(0x75a2753f) },
  { SPH_C32(0x575a0000), SPH_C32(0x52250000), SPH_C32(0x30ef1980),
    SPH_C32(0x508d0000), SPH_C32(0xcc9f74c2), SPH_C32(0xa9e72349),
    SPH_C32(0x41f8d12b), SPH_C32(0x881aaedc), SPH_C32(0x2be70000),
    SPH_C32(0x85070000), SPH_C32(0xf8490f00), SPH_C32(0x49220000),
    SPH_C32(0x8b00141a), SPH_C32(0x4526e8ce), SPH_C32(0xb236529c),
    SPH_C32(0xbff8f2c1) },
  { SPH_C32(0x9b4e0000), SPH_C32(0xf7460000), SPH_C32(0x6a561e00),
    SPH_C32(0x6bdd0000), SPH_C32(0x874f673d), SPH_C32(0x2e7c1751),
    SPH_C32(0x28bb99ea), SPH_C32(0x42402922), SPH_C32(0xaa790000),
    SPH_C32(0x69500000), SPH_C32(0x9e7b0d80), SPH_C32(0xdcd10000),
    SPH_C32(0xd6a93c18), SPH_C32(0x0dd2d472), SPH_C32(0x546cf0b1),
    SPH_C32(0x319f453b) }
};

__constant static const sph_u32 T512_40[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0x8f750000), SPH_C32(0xadc40000), SPH_C32(0xf8bb0024),
    SPH_C32(0x6c430000), SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3),
    SPH_C32(0x5ced124e), SPH_C32(0x7665c55a), SPH_C32(0xa9140000),
    SPH_C32(0x7d150000), SPH_C32(0xb7cc0018), SPH_C32(0xfe250000),
    SPH_C32(0x5d116688), SPH_C32(0x45997fda), SPH_C32(0xf7294e64),
    SPH_C32(0x43d8eceb) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x0c2f0000), SPH_C32(0x69330000), SPH_C32(0xf9fc0006),
    SPH_C32(0x828b0000), SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7),
    SPH_C32(0x001826bc), SPH_C32(0x48c3a5ad), SPH_C32(0x218c0000),
    SPH_C32(0x62810000), SPH_C32(0xc8030036), SPH_C32(0x056b0000),
    SPH_C32(0xac496112), SPH_C32(0x2437eebd), SPH_C32(0x5fbc3e08),
    SPH_C32(0xa5c8987f) },
  { SPH_C32(0x835a0000), SPH_C32(0xc4f70000), SPH_C32(0x01470022),
    SPH_C32(0xeec80000), SPH_C32(0x60a54f69), SPH_C32(0x142f2a24),
    SPH_C32(0x5cf534f2), SPH_C32(0x3ea660f7), SPH_C32(0x88980000),
    SPH_C32(0x1f940000), SPH_C32(0x7fcf002e), SPH_C32(0xfb4e0000),
    SPH_C32(0xf158079a), SPH_C32(0x61ae9167), SPH_C32(0xa895706c),
    SPH_C32(0xe6107494) },
  { SPH_C32(0x84b70000), SPH_C32(0x76a70000), SPH_C32(0x86330028),
    SPH_C32(0x79c50000), SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480),
    SPH_C32(0xa88d56d0), SPH_C32(0xaed3d139), SPH_C32(0x2a4e0000),
    SPH_C32(0xb9e20000), SPH_C32(0xb68b003a), SPH_C32(0x10ed0000),
    SPH_C32(0x3db429e1), SPH_C32(0x51b655fe), SPH_C32(0xabdc7a96),
    SPH_C32(0x7d7e8c1c) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0x55bd0000), SPH_C32(0x9b040000), SPH_C32(0xed150044),
    SPH_C32(0x67f20000), SPH_C32(0xd9435d42), SPH_C32(0x0de42f6a),
    SPH_C32(0x3b2eedc7), SPH_C32(0xc376a2c1), SPH_C32(0xf15b0000),
    SPH_C32(0x0f8a0000), SPH_C32(0x57b30012), SPH_C32(0xbd5c0000),
    SPH_C32(0xc6082e35), SPH_C32(0xa2dd0960), SPH_C32(0xaa0d4ae2),
    SPH_C32(0xe4f9ae19) },
  { SPH_C32(0xdac80000), SPH_C32(0x36c00000), SPH_C32(0x15ae0060),
    SPH_C32(0x0bb10000), SPH_C32(0x6b697976), SPH_C32(0x248dd0a9),
    SPH_C32(0x67c3ff89), SPH_C32(0xb513679b), SPH_C32(0x584f0000),
    SPH_C32(0x729f0000), SPH_C32(0xe07f000a), SPH_C32(0x43790000),
    SPH_C32(0x9b1948bd), SPH_C32(0xe74476ba), SPH_C32(0x5d240486),
    SPH_C32(0xa72142f2) },
  { SPH_C32(0xdd250000), SPH_C32(0x84900000), SPH_C32(0x92da006a),
    SPH_C32(0x9cbc0000), SPH_C32(0x281b5ad8), SPH_C32(0x6c4abe0d),
    SPH_C32(0x93bb9dab), SPH_C32(0x2566d655), SPH_C32(0xfa990000),
    SPH_C32(0xd4e90000), SPH_C32(0x293b001e), SPH_C32(0xa8da0000),
    SPH_C32(0x57f566c6), SPH_C32(0xd75cb223), SPH_C32(0x5e6d0e7c),
    SPH_C32(0x3c4fba7a) },
  { SPH_C32(0x59920000), SPH_C32(0xf2370000), SPH_C32(0x14e90042),
    SPH_C32(0xe5790000), SPH_C32(0x0bcc361f), SPH_C32(0x30a2fa8d),
    SPH_C32(0x3b36cb7b), SPH_C32(0x8bb5076c), SPH_C32(0xd0d70000),
    SPH_C32(0x6d0b0000), SPH_C32(0x9fb00024), SPH_C32(0xb8370000),
    SPH_C32(0x6a414f27), SPH_C32(0x86eae7dd), SPH_C32(0xf5b174ea),
    SPH_C32(0x41313666) },
  { SPH_C32(0x5e7f0000), SPH_C32(0x40670000), SPH_C32(0x939d0048),
    SPH_C32(0x72740000), SPH_C32(0x48be15b1), SPH_C32(0x78659429),
    SPH_C32(0xcf4ea959), SPH_C32(0x1bc0b6a2), SPH_C32(0x72010000),
    SPH_C32(0xcb7d0000), SPH_C32(0x56f40030), SPH_C32(0x53940000),
    SPH_C32(0xa6ad615c), SPH_C32(0xb6f22344), SPH_C32(0xf6f87e10),
    SPH_C32(0xda5fceee) },
  { SPH_C32(0xd10a0000), SPH_C32(0xeda30000), SPH_C32(0x6b26006c),
    SPH_C32(0x1e370000), SPH_C32(0xfa943185), SPH_C32(0x510c6bea),
    SPH_C32(0x93a3bb17), SPH_C32(0x6da573f8), SPH_C32(0xdb150000),
    SPH_C32(0xb6680000), SPH_C32(0xe1380028), SPH_C32(0xadb10000),
    SPH_C32(0xfbbc07d4), SPH_C32(0xf36b5c9e), SPH_C32(0x01d13074),
    SPH_C32(0x99872205) },
  { SPH_C32(0xd6e70000), SPH_C32(0x5ff30000), SPH_C32(0xec520066),
    SPH_C32(0x893a0000), SPH_C32(0xb9e6122b), SPH_C32(0x19cb054e),
    SPH_C32(0x67dbd935), SPH_C32(0xfdd0c236), SPH_C32(0x79c30000),
    SPH_C32(0x101e0000), SPH_C32(0x287c003c), SPH_C32(0x46120000),
    SPH_C32(0x375029af), SPH_C32(0xc3739807), SPH_C32(0x02983a8e),
    SPH_C32(0x02e9da8d) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0x54600000), SPH_C32(0x1bac0000), SPH_C32(0x1983000c),
    SPH_C32(0xc1f20000), SPH_C32(0x499623e0), SPH_C32(0xda02a35d),
    SPH_C32(0x5d3c223a), SPH_C32(0xefe2e75f), SPH_C32(0xa30b0000),
    SPH_C32(0x26de0000), SPH_C32(0x3dd2005c), SPH_C32(0x4da30000),
    SPH_C32(0x5c3950d9), SPH_C32(0xe7fe48ae), SPH_C32(0x655bc507),
    SPH_C32(0xb7fabd16) },
  { SPH_C32(0xdb150000), SPH_C32(0xb6680000), SPH_C32(0xe1380028),
    SPH_C32(0xadb10000), SPH_C32(0xfbbc07d4), SPH_C32(0xf36b5c9e),
    SPH_C32(0x01d13074), SPH_C32(0x99872205), SPH_C32(0x0a1f0000),
    SPH_C32(0x5bcb0000), SPH_C32(0x8a1e0044), SPH_C32(0xb3860000),
    SPH_C32(0x01283651), SPH_C32(0xa2673774), SPH_C32(0x92728b63),
    SPH_C32(0xf42251fd) },
  { SPH_C32(0xdcf80000), SPH_C32(0x04380000), SPH_C32(0x664c0022),
    SPH_C32(0x3abc0000), SPH_C32(0xb8ce247a), SPH_C32(0xbbac323a),
    SPH_C32(0xf5a95256), SPH_C32(0x09f293cb), SPH_C32(0xa8c90000),
    SPH_C32(0xfdbd0000), SPH_C32(0x435a0050), SPH_C32(0x58250000),
    SPH_C32(0xcdc4182a), SPH_C32(0x927ff3ed), SPH_C32(0x913b8199),
    SPH_C32(0x6f4ca975) },
  { SPH_C32(0x584f0000), SPH_C32(0x729f0000), SPH_C32(0xe07f000a),
    SPH_C32(0x43790000), SPH_C32(0x9b1948bd), SPH_C32(0xe74476ba),
    SPH_C32(0x5d240486), SPH_C32(0xa72142f2), SPH_C32(0x82870000),
    SPH_C32(0x445f0000), SPH_C32(0xf5d1006a), SPH_C32(0x48c80000),
    SPH_C32(0xf07031cb), SPH_C32(0xc3c9a613), SPH_C32(0x3ae7fb0f),
    SPH_C32(0x12322569) },
  { SPH_C32(0x5fa20000), SPH_C32(0xc0cf0000), SPH_C32(0x670b0000),
    SPH_C32(0xd4740000), SPH_C32(0xd86b6b13), SPH_C32(0xaf83181e),
    SPH_C32(0xa95c66a4), SPH_C32(0x3754f33c), SPH_C32(0x20510000),
    SPH_C32(0xe2290000), SPH_C32(0x3c95007e), SPH_C32(0xa36b0000),
    SPH_C32(0x3c9c1fb0), SPH_C32(0xf3d1628a), SPH_C32(0x39aef1f5),
    SPH_C32(0x895cdde1) },
  { SPH_C32(0xd0d70000), SPH_C32(0x6d0b0000), SPH_C32(0x9fb00024),
    SPH_C32(0xb8370000), SPH_C32(0x6a414f27), SPH_C32(0x86eae7dd),
    SPH_C32(0xf5b174ea), SPH_C32(0x41313666), SPH_C32(0x89450000),
    SPH_C32(0x9f3c0000), SPH_C32(0x8b590066), SPH_C32(0x5d4e0000),
    SPH_C32(0x618d7938), SPH_C32(0xb6481d50), SPH_C32(0xce87bf91),
    SPH_C32(0xca84310a) },
  { SPH_C32(0xd73a0000), SPH_C32(0xdf5b0000), SPH_C32(0x18c4002e),
    SPH_C32(0x2f3a0000), SPH_C32(0x29336c89), SPH_C32(0xce2d8979),
    SPH_C32(0x01c916c8), SPH_C32(0xd14487a8), SPH_C32(0x2b930000),
    SPH_C32(0x394a0000), SPH_C32(0x421d0072), SPH_C32(0xb6ed0000),
    SPH_C32(0xad615743), SPH_C32(0x8650d9c9), SPH_C32(0xcdceb56b),
    SPH_C32(0x51eac982) },
  { SPH_C32(0x01dd0000), SPH_C32(0x80a80000), SPH_C32(0xf4960048),
    SPH_C32(0xa6000000), SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37),
    SPH_C32(0x6612cffd), SPH_C32(0x2c94459e), SPH_C32(0x52500000),
    SPH_C32(0x29540000), SPH_C32(0x6a61004e), SPH_C32(0xf0ff0000),
    SPH_C32(0x9a317eec), SPH_C32(0x452341ce), SPH_C32(0xcf568fe5),
    SPH_C32(0x5303130f) },
  { SPH_C32(0x06300000), SPH_C32(0x32f80000), SPH_C32(0x73e20042),
    SPH_C32(0x310d0000), SPH_C32(0xd3a75d0c), SPH_C32(0x9f21e293),
    SPH_C32(0x926aaddf), SPH_C32(0xbce1f450), SPH_C32(0xf0860000),
    SPH_C32(0x8f220000), SPH_C32(0xa325005a), SPH_C32(0x1b5c0000),
    SPH_C32(0x56dd5097), SPH_C32(0x753b8557), SPH_C32(0xcc1f851f),
    SPH_C32(0xc86deb87) },
  { SPH_C32(0x89450000), SPH_C32(0x9f3c0000), SPH_C32(0x8b590066),
    SPH_C32(0x5d4e0000), SPH_C32(0x618d7938), SPH_C32(0xb6481d50),
    SPH_C32(0xce87bf91), SPH_C32(0xca84310a), SPH_C32(0x59920000),
    SPH_C32(0xf2370000), SPH_C32(0x14e90042), SPH_C32(0xe5790000),
    SPH_C32(0x0bcc361f), SPH_C32(0x30a2fa8d), SPH_C32(0x3b36cb7b),
    SPH_C32(0x8bb5076c) },
  { SPH_C32(0x8ea80000), SPH_C32(0x2d6c0000), SPH_C32(0x0c2d006c),
    SPH_C32(0xca430000), SPH_C32(0x22ff5a96), SPH_C32(0xfe8f73f4),
    SPH_C32(0x3affddb3), SPH_C32(0x5af180c4), SPH_C32(0xfb440000),
    SPH_C32(0x54410000), SPH_C32(0xddad0056), SPH_C32(0x0eda0000),
    SPH_C32(0xc7201864), SPH_C32(0x00ba3e14), SPH_C32(0x387fc181),
    SPH_C32(0x10dbffe4) },
  { SPH_C32(0x0a1f0000), SPH_C32(0x5bcb0000), SPH_C32(0x8a1e0044),
    SPH_C32(0xb3860000), SPH_C32(0x01283651), SPH_C32(0xa2673774),
    SPH_C32(0x92728b63), SPH_C32(0xf42251fd), SPH_C32(0xd10a0000),
    SPH_C32(0xeda30000), SPH_C32(0x6b26006c), SPH_C32(0x1e370000),
    SPH_C32(0xfa943185), SPH_C32(0x510c6bea), SPH_C32(0x93a3bb17),
    SPH_C32(0x6da573f8) },
  { SPH_C32(0x0df20000), SPH_C32(0xe99b0000), SPH_C32(0x0d6a004e),
    SPH_C32(0x248b0000), SPH_C32(0x425a15ff), SPH_C32(0xeaa059d0),
    SPH_C32(0x660ae941), SPH_C32(0x6457e033), SPH_C32(0x73dc0000),
    SPH_C32(0x4bd50000), SPH_C32(0xa2620078), SPH_C32(0xf5940000),
    SPH_C32(0x36781ffe), SPH_C32(0x6114af73), SPH_C32(0x90eab1ed),
    SPH_C32(0xf6cb8b70) },
  { SPH_C32(0x82870000), SPH_C32(0x445f0000), SPH_C32(0xf5d1006a),
    SPH_C32(0x48c80000), SPH_C32(0xf07031cb), SPH_C32(0xc3c9a613),
    SPH_C32(0x3ae7fb0f), SPH_C32(0x12322569), SPH_C32(0xdac80000),
    SPH_C32(0x36c00000), SPH_C32(0x15ae0060), SPH_C32(0x0bb10000),
    SPH_C32(0x6b697976), SPH_C32(0x248dd0a9), SPH_C32(0x67c3ff89),
    SPH_C32(0xb513679b) },
  { SPH_C32(0x856a0000), SPH_C32(0xf60f0000), SPH_C32(0x72a50060),
    SPH_C32(0xdfc50000), SPH_C32(0xb3021265), SPH_C32(0x8b0ec8b7),
    SPH_C32(0xce9f992d), SPH_C32(0x824794a7), SPH_C32(0x781e0000),
    SPH_C32(0x90b60000), SPH_C32(0xdcea0074), SPH_C32(0xe0120000),
    SPH_C32(0xa785570d), SPH_C32(0x14951430), SPH_C32(0x648af573),
    SPH_C32(0x2e7d9f13) }
};

__constant static const sph_u32 T512_45[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x8c3a0000), SPH_C32(0xda980000), SPH_C32(0x607f0000),
    SPH_C32(0x54078800), SPH_C32(0x85714513), SPH_C32(0x6006b243),
    SPH_C32(0xdb50399c), SPH_C32(0x8a58e6a4), SPH_C32(0x1e6c0000),
    SPH_C32(0xc4420000), SPH_C32(0x8a2e0000), SPH_C32(0xbcb6b800),
    SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da), SPH_C32(0x6a0c1bc8),
    SPH_C32(0xb99dc2eb) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0x462f0000), SPH_C32(0x443c0000), SPH_C32(0xf21d0001),
    SPH_C32(0x7add8000), SPH_C32(0xcb734f6a), SPH_C32(0xf250ec07),
    SPH_C32(0xc67fe5a7), SPH_C32(0x83d9bb5a), SPH_C32(0x8f0c0000),
    SPH_C32(0x35a80000), SPH_C32(0xa2dc0000), SPH_C32(0x47d02800),
    SPH_C32(0x8cfe7860), SPH_C32(0x2382de49), SPH_C32(0x30fe267d),
    SPH_C32(0x2db012e9) },
  { SPH_C32(0xca150000), SPH_C32(0x9ea40000), SPH_C32(0x92620001),
    SPH_C32(0x2eda0800), SPH_C32(0x4e020a79), SPH_C32(0x92565e44),
    SPH_C32(0x1d2fdc3b), SPH_C32(0x09815dfe), SPH_C32(0x91600000),
    SPH_C32(0xf1ea0000), SPH_C32(0x28f20000), SPH_C32(0xfb669000),
    SPH_C32(0xa0ba6bd6), SPH_C32(0xa87f0d93), SPH_C32(0x5af23db5),
    SPH_C32(0x942dd002) },
  { SPH_C32(0xd4790000), SPH_C32(0x5ae60000), SPH_C32(0x184c0001),
    SPH_C32(0x926cb000), SPH_C32(0x624619cf), SPH_C32(0x19ab8d9e),
    SPH_C32(0x7723c7f3), SPH_C32(0xb01c9f15), SPH_C32(0x03360000),
    SPH_C32(0xef300000), SPH_C32(0xc2a30000), SPH_C32(0x13d7a000),
    SPH_C32(0x098f3d73), SPH_C32(0x43846c0a), SPH_C32(0xebae1fe1),
    SPH_C32(0xa7e8f44d) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0x03360000), SPH_C32(0xef300000), SPH_C32(0xc2a30000),
    SPH_C32(0x13d7a000), SPH_C32(0x098f3d73), SPH_C32(0x43846c0a),
    SPH_C32(0xebae1fe1), SPH_C32(0xa7e8f44d), SPH_C32(0xd74f0000),
    SPH_C32(0xb5d60000), SPH_C32(0xdaef0001), SPH_C32(0x81bb1000),
    SPH_C32(0x6bc924bc), SPH_C32(0x5a2fe194), SPH_C32(0x9c8dd812),
    SPH_C32(0x17f46b58) },
  { SPH_C32(0x8f0c0000), SPH_C32(0x35a80000), SPH_C32(0xa2dc0000),
    SPH_C32(0x47d02800), SPH_C32(0x8cfe7860), SPH_C32(0x2382de49),
    SPH_C32(0x30fe267d), SPH_C32(0x2db012e9), SPH_C32(0xc9230000),
    SPH_C32(0x71940000), SPH_C32(0x50c10001), SPH_C32(0x3d0da800),
    SPH_C32(0x478d370a), SPH_C32(0xd1d2324e), SPH_C32(0xf681c3da),
    SPH_C32(0xae69a9b3) },
  { SPH_C32(0x91600000), SPH_C32(0xf1ea0000), SPH_C32(0x28f20000),
    SPH_C32(0xfb669000), SPH_C32(0xa0ba6bd6), SPH_C32(0xa87f0d93),
    SPH_C32(0x5af23db5), SPH_C32(0x942dd002), SPH_C32(0x5b750000),
    SPH_C32(0x6f4e0000), SPH_C32(0xba900001), SPH_C32(0xd5bc9800),
    SPH_C32(0xeeb861af), SPH_C32(0x3a2953d7), SPH_C32(0x47dde18e),
    SPH_C32(0x9dac8dfc) },
  { SPH_C32(0x45190000), SPH_C32(0xab0c0000), SPH_C32(0x30be0001),
    SPH_C32(0x690a2000), SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d),
    SPH_C32(0x2dd1fa46), SPH_C32(0x24314f17), SPH_C32(0x58430000),
    SPH_C32(0x807e0000), SPH_C32(0x78330001), SPH_C32(0xc66b3800),
    SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd), SPH_C32(0xac73fe6f),
    SPH_C32(0x3a4479b1) },
  { SPH_C32(0x5b750000), SPH_C32(0x6f4e0000), SPH_C32(0xba900001),
    SPH_C32(0xd5bc9800), SPH_C32(0xeeb861af), SPH_C32(0x3a2953d7),
    SPH_C32(0x47dde18e), SPH_C32(0x9dac8dfc), SPH_C32(0xca150000),
    SPH_C32(0x9ea40000), SPH_C32(0x92620001), SPH_C32(0x2eda0800),
    SPH_C32(0x4e020a79), SPH_C32(0x92565e44), SPH_C32(0x1d2fdc3b),
    SPH_C32(0x09815dfe) },
  { SPH_C32(0xd74f0000), SPH_C32(0xb5d60000), SPH_C32(0xdaef0001),
    SPH_C32(0x81bb1000), SPH_C32(0x6bc924bc), SPH_C32(0x5a2fe194),
    SPH_C32(0x9c8dd812), SPH_C32(0x17f46b58), SPH_C32(0xd4790000),
    SPH_C32(0x5ae60000), SPH_C32(0x184c0001), SPH_C32(0x926cb000),
    SPH_C32(0x624619cf), SPH_C32(0x19ab8d9e), SPH_C32(0x7723c7f3),
    SPH_C32(0xb01c9f15) },
  { SPH_C32(0xc9230000), SPH_C32(0x71940000), SPH_C32(0x50c10001),
    SPH_C32(0x3d0da800), SPH_C32(0x478d370a), SPH_C32(0xd1d2324e),
    SPH_C32(0xf681c3da), SPH_C32(0xae69a9b3), SPH_C32(0x462f0000),
    SPH_C32(0x443c0000), SPH_C32(0xf21d0001), SPH_C32(0x7add8000),
    SPH_C32(0xcb734f6a), SPH_C32(0xf250ec07), SPH_C32(0xc67fe5a7),
    SPH_C32(0x83d9bb5a) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0xbb570000), SPH_C32(0xd0640000), SPH_C32(0xc41e001e),
    SPH_C32(0xc018b800), SPH_C32(0xa3da1e63), SPH_C32(0xf32279e7),
    SPH_C32(0x9d3d7310), SPH_C32(0xb2868bad), SPH_C32(0x95bb0000),
    SPH_C32(0xac8a0000), SPH_C32(0x6d25000a), SPH_C32(0x7fbc3000),
    SPH_C32(0xea47750b), SPH_C32(0xa33c0f3d), SPH_C32(0x45244076),
    SPH_C32(0xa3b09581) },
  { SPH_C32(0x376d0000), SPH_C32(0x0afc0000), SPH_C32(0xa461001e),
    SPH_C32(0x941f3000), SPH_C32(0x26ab5b70), SPH_C32(0x9324cba4),
    SPH_C32(0x466d4a8c), SPH_C32(0x38de6d09), SPH_C32(0x8bd70000),
    SPH_C32(0x68c80000), SPH_C32(0xe70b000a), SPH_C32(0xc30a8800),
    SPH_C32(0xc60366bd), SPH_C32(0x28c1dce7), SPH_C32(0x2f285bbe),
    SPH_C32(0x1a2d576a) },
  { SPH_C32(0x29010000), SPH_C32(0xcebe0000), SPH_C32(0x2e4f001e),
    SPH_C32(0x28a98800), SPH_C32(0x0aef48c6), SPH_C32(0x18d9187e),
    SPH_C32(0x2c615144), SPH_C32(0x8143afe2), SPH_C32(0x19810000),
    SPH_C32(0x76120000), SPH_C32(0x0d5a000a), SPH_C32(0x2bbbb800),
    SPH_C32(0x6f363018), SPH_C32(0xc33abd7e), SPH_C32(0x9e7479ea),
    SPH_C32(0x29e87325) },
  { SPH_C32(0xfd780000), SPH_C32(0x94580000), SPH_C32(0x3603001f),
    SPH_C32(0xbac53800), SPH_C32(0x68a95109), SPH_C32(0x017295e0),
    SPH_C32(0x5b4296b7), SPH_C32(0x315f30f7), SPH_C32(0x1ab70000),
    SPH_C32(0x99220000), SPH_C32(0xcff9000a), SPH_C32(0x386c1800),
    SPH_C32(0x66b90d6b), SPH_C32(0x80bed174), SPH_C32(0x75da660b),
    SPH_C32(0x8e008768) },
  { SPH_C32(0xe3140000), SPH_C32(0x501a0000), SPH_C32(0xbc2d001f),
    SPH_C32(0x06738000), SPH_C32(0x44ed42bf), SPH_C32(0x8a8f463a),
    SPH_C32(0x314e8d7f), SPH_C32(0x88c2f21c), SPH_C32(0x88e10000),
    SPH_C32(0x87f80000), SPH_C32(0x25a8000a), SPH_C32(0xd0dd2800),
    SPH_C32(0xcf8c5bce), SPH_C32(0x6b45b0ed), SPH_C32(0xc486445f),
    SPH_C32(0xbdc5a327) },
  { SPH_C32(0x6f2e0000), SPH_C32(0x8a820000), SPH_C32(0xdc52001f),
    SPH_C32(0x52740800), SPH_C32(0xc19c07ac), SPH_C32(0xea89f479),
    SPH_C32(0xea1eb4e3), SPH_C32(0x029a14b8), SPH_C32(0x968d0000),
    SPH_C32(0x43ba0000), SPH_C32(0xaf86000a), SPH_C32(0x6c6b9000),
    SPH_C32(0xe3c84878), SPH_C32(0xe0b86337), SPH_C32(0xae8a5f97),
    SPH_C32(0x045861cc) },
  { SPH_C32(0x71420000), SPH_C32(0x4ec00000), SPH_C32(0x567c001f),
    SPH_C32(0xeec2b000), SPH_C32(0xedd8141a), SPH_C32(0x617427a3),
    SPH_C32(0x8012af2b), SPH_C32(0xbb07d653), SPH_C32(0x04db0000),
    SPH_C32(0x5d600000), SPH_C32(0x45d7000a), SPH_C32(0x84daa000),
    SPH_C32(0x4afd1edd), SPH_C32(0x0b4302ae), SPH_C32(0x1fd67dc3),
    SPH_C32(0x379d4583) },
  { SPH_C32(0xb8610000), SPH_C32(0x3f540000), SPH_C32(0x06bd001e),
    SPH_C32(0xd3cf1800), SPH_C32(0xaa552310), SPH_C32(0xb0a615ed),
    SPH_C32(0x76936cf1), SPH_C32(0x156e7fe0), SPH_C32(0x42f40000),
    SPH_C32(0x195c0000), SPH_C32(0xb7ca000b), SPH_C32(0xfe072000),
    SPH_C32(0x818e51b7), SPH_C32(0xf913eea9), SPH_C32(0xd9a99864),
    SPH_C32(0xb444fed9) },
  { SPH_C32(0xa60d0000), SPH_C32(0xfb160000), SPH_C32(0x8c93001e),
    SPH_C32(0x6f79a000), SPH_C32(0x861130a6), SPH_C32(0x3b5bc637),
    SPH_C32(0x1c9f7739), SPH_C32(0xacf3bd0b), SPH_C32(0xd0a20000),
    SPH_C32(0x07860000), SPH_C32(0x5d9b000b), SPH_C32(0x16b61000),
    SPH_C32(0x28bb0712), SPH_C32(0x12e88f30), SPH_C32(0x68f5ba30),
    SPH_C32(0x8781da96) },
  { SPH_C32(0x2a370000), SPH_C32(0x218e0000), SPH_C32(0xecec001e),
    SPH_C32(0x3b7e2800), SPH_C32(0x036075b5), SPH_C32(0x5b5d7474),
    SPH_C32(0xc7cf4ea5), SPH_C32(0x26ab5baf), SPH_C32(0xcece0000),
    SPH_C32(0xc3c40000), SPH_C32(0xd7b5000b), SPH_C32(0xaa00a800),
    SPH_C32(0x04ff14a4), SPH_C32(0x99155cea), SPH_C32(0x02f9a1f8),
    SPH_C32(0x3e1c187d) },
  { SPH_C32(0x345b0000), SPH_C32(0xe5cc0000), SPH_C32(0x66c2001e),
    SPH_C32(0x87c89000), SPH_C32(0x2f246603), SPH_C32(0xd0a0a7ae),
    SPH_C32(0xadc3556d), SPH_C32(0x9f369944), SPH_C32(0x5c980000),
    SPH_C32(0xdd1e0000), SPH_C32(0x3de4000b), SPH_C32(0x42b19800),
    SPH_C32(0xadca4201), SPH_C32(0x72ee3d73), SPH_C32(0xb3a583ac),
    SPH_C32(0x0dd93c32) },
  { SPH_C32(0xe0220000), SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f),
    SPH_C32(0x15a42000), SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30),
    SPH_C32(0xdae0929e), SPH_C32(0x2f2a0651), SPH_C32(0x5fae0000),
    SPH_C32(0x322e0000), SPH_C32(0xff47000b), SPH_C32(0x51663800),
    SPH_C32(0xa4457f72), SPH_C32(0x316a5179), SPH_C32(0x580b9c4d),
    SPH_C32(0xaa31c87f) },
  { SPH_C32(0xfe4e0000), SPH_C32(0x7b680000), SPH_C32(0xf4a0001f),
    SPH_C32(0xa9129800), SPH_C32(0x61266c7a), SPH_C32(0x42f6f9ea),
    SPH_C32(0xb0ec8956), SPH_C32(0x96b7c4ba), SPH_C32(0xcdf80000),
    SPH_C32(0x2cf40000), SPH_C32(0x1516000b), SPH_C32(0xb9d70800),
    SPH_C32(0x0d7029d7), SPH_C32(0xda9130e0), SPH_C32(0xe957be19),
    SPH_C32(0x99f4ec30) },
  { SPH_C32(0x72740000), SPH_C32(0xa1f00000), SPH_C32(0x94df001f),
    SPH_C32(0xfd151000), SPH_C32(0xe4572969), SPH_C32(0x22f04ba9),
    SPH_C32(0x6bbcb0ca), SPH_C32(0x1cef221e), SPH_C32(0xd3940000),
    SPH_C32(0xe8b60000), SPH_C32(0x9f38000b), SPH_C32(0x0561b000),
    SPH_C32(0x21343a61), SPH_C32(0x516ce33a), SPH_C32(0x835ba5d1),
    SPH_C32(0x20692edb) },
  { SPH_C32(0x6c180000), SPH_C32(0x65b20000), SPH_C32(0x1ef1001f),
    SPH_C32(0x41a3a800), SPH_C32(0xc8133adf), SPH_C32(0xa90d9873),
    SPH_C32(0x01b0ab02), SPH_C32(0xa572e0f5), SPH_C32(0x41c20000),
    SPH_C32(0xf66c0000), SPH_C32(0x7569000b), SPH_C32(0xedd08000),
    SPH_C32(0x88016cc4), SPH_C32(0xba9782a3), SPH_C32(0x32078785),
    SPH_C32(0x13ac0a94) }
};

__constant static const sph_u32 T512_50[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0x44f40000), SPH_C32(0x2e100000), SPH_C32(0xf4df0000),
    SPH_C32(0x9e5d0420), SPH_C32(0x43cf6709), SPH_C32(0x13fb95c4),
    SPH_C32(0x19b62a95), SPH_C32(0x18c8c541), SPH_C32(0xf5eb0000),
    SPH_C32(0xa8a90000), SPH_C32(0x6ac40000), SPH_C32(0x8daf0240),
    SPH_C32(0xcdb63c93), SPH_C32(0xd7ffd112), SPH_C32(0x90b053ae),
    SPH_C32(0xda2bec31) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x13c30000), SPH_C32(0xe4e20000), SPH_C32(0xc2910000),
    SPH_C32(0x5e7f00a0), SPH_C32(0x15d70c2b), SPH_C32(0x4f5861c8),
    SPH_C32(0xb825551a), SPH_C32(0x0d71a4a6), SPH_C32(0x41da0000),
    SPH_C32(0xdf9a0000), SPH_C32(0xdb990000), SPH_C32(0xf27f06a0),
    SPH_C32(0xb5145dab), SPH_C32(0x06e9124f), SPH_C32(0x42e68727),
    SPH_C32(0x944498ef) },
  { SPH_C32(0x57370000), SPH_C32(0xcaf20000), SPH_C32(0x364e0000),
    SPH_C32(0xc0220480), SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c),
    SPH_C32(0xa1937f8f), SPH_C32(0x15b961e7), SPH_C32(0xb4310000),
    SPH_C32(0x77330000), SPH_C32(0xb15d0000), SPH_C32(0x7fd004e0),
    SPH_C32(0x78a26138), SPH_C32(0xd116c35d), SPH_C32(0xd256d489),
    SPH_C32(0x4e6f74de) },
  { SPH_C32(0xa7f20000), SPH_C32(0x93d10000), SPH_C32(0x73cc0000),
    SPH_C32(0x21af0440), SPH_C32(0x6d756d13), SPH_C32(0x9e4ea295),
    SPH_C32(0x6a738193), SPH_C32(0x431ed078), SPH_C32(0xa2dc0000),
    SPH_C32(0x625b0000), SPH_C32(0x5c8a0000), SPH_C32(0x4d8d06c0),
    SPH_C32(0x9bae57b1), SPH_C32(0x8b5c251e), SPH_C32(0x31232c21),
    SPH_C32(0xcf928dd6) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xf2370000), SPH_C32(0xfba20000), SPH_C32(0xc2bd0000),
    SPH_C32(0x02e178c0), SPH_C32(0x257072de), SPH_C32(0xc5d07d4f),
    SPH_C32(0x0f22cc2b), SPH_C32(0x29959401), SPH_C32(0xac300000),
    SPH_C32(0x06c50000), SPH_C32(0x5a300000), SPH_C32(0xc5752a20),
    SPH_C32(0x3c4922c4), SPH_C32(0x6c502579), SPH_C32(0x092f75bc),
    SPH_C32(0xabd1e1f8) },
  { SPH_C32(0xb6c30000), SPH_C32(0xd5b20000), SPH_C32(0x36620000),
    SPH_C32(0x9cbc7ce0), SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b),
    SPH_C32(0x1694e6be), SPH_C32(0x315d5140), SPH_C32(0x59db0000),
    SPH_C32(0xae6c0000), SPH_C32(0x30f40000), SPH_C32(0x48da2860),
    SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b), SPH_C32(0x999f2612),
    SPH_C32(0x71fa0dc9) },
  { SPH_C32(0x46060000), SPH_C32(0x8c910000), SPH_C32(0x73e00000),
    SPH_C32(0x7d317c20), SPH_C32(0x5dd213e6), SPH_C32(0x14c6be12),
    SPH_C32(0xdd7418a2), SPH_C32(0x67fae0df), SPH_C32(0x4f360000),
    SPH_C32(0xbb040000), SPH_C32(0xdd230000), SPH_C32(0x7a872a40),
    SPH_C32(0x12f328de), SPH_C32(0xe1e51228), SPH_C32(0x7aeadeba),
    SPH_C32(0xf007f4c1) },
  { SPH_C32(0xe1f40000), SPH_C32(0x1f400000), SPH_C32(0x002c0000),
    SPH_C32(0x5c9e7860), SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87),
    SPH_C32(0xb7079931), SPH_C32(0x24e430a7), SPH_C32(0xedea0000),
    SPH_C32(0xd95f0000), SPH_C32(0x81a90000), SPH_C32(0x370a2c80),
    SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736), SPH_C32(0x4bc9f29b),
    SPH_C32(0x3f957917) },
  { SPH_C32(0x11310000), SPH_C32(0x46630000), SPH_C32(0x45ae0000),
    SPH_C32(0xbd1378a0), SPH_C32(0x0bca78c4), SPH_C32(0x48654a1e),
    SPH_C32(0x7ce7672d), SPH_C32(0x72438138), SPH_C32(0xfb070000),
    SPH_C32(0xcc370000), SPH_C32(0x6c7e0000), SPH_C32(0x05572ea0),
    SPH_C32(0x6a5149e6), SPH_C32(0x30f3d175), SPH_C32(0xa8bc0a33),
    SPH_C32(0xbe68801f) },
  { SPH_C32(0x55c50000), SPH_C32(0x68730000), SPH_C32(0xb1710000),
    SPH_C32(0x234e7c80), SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda),
    SPH_C32(0x65514db8), SPH_C32(0x6a8b4479), SPH_C32(0x0eec0000),
    SPH_C32(0x649e0000), SPH_C32(0x06ba0000), SPH_C32(0x88f82ce0),
    SPH_C32(0xa7e77575), SPH_C32(0xe70c0067), SPH_C32(0x380c599d),
    SPH_C32(0x64436c2e) },
  { SPH_C32(0xa5000000), SPH_C32(0x31500000), SPH_C32(0xf4f30000),
    SPH_C32(0xc2c37c40), SPH_C32(0x736819fc), SPH_C32(0x99738943),
    SPH_C32(0xaeb1b3a4), SPH_C32(0x3c2cf5e6), SPH_C32(0x18010000),
    SPH_C32(0x71f60000), SPH_C32(0xeb6d0000), SPH_C32(0xbaa52ec0),
    SPH_C32(0x44eb43fc), SPH_C32(0xbd46e624), SPH_C32(0xdb79a135),
    SPH_C32(0xe5be9526) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0x4a180000), SPH_C32(0x4a8e0000), SPH_C32(0xf2650000),
    SPH_C32(0x16a528c0), SPH_C32(0xe428127c), SPH_C32(0xf4f795a3),
    SPH_C32(0x21ba7308), SPH_C32(0x7c8ba96f), SPH_C32(0xaec20000),
    SPH_C32(0xa4440000), SPH_C32(0xdd0f0000), SPH_C32(0x26195220),
    SPH_C32(0x2254562b), SPH_C32(0x6b6d0eaf), SPH_C32(0xcded478b),
    SPH_C32(0xd4e3c466) },
  { SPH_C32(0x0eec0000), SPH_C32(0x649e0000), SPH_C32(0x06ba0000),
    SPH_C32(0x88f82ce0), SPH_C32(0xa7e77575), SPH_C32(0xe70c0067),
    SPH_C32(0x380c599d), SPH_C32(0x64436c2e), SPH_C32(0x5b290000),
    SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000), SPH_C32(0xabb65060),
    SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd), SPH_C32(0x5d5d1425),
    SPH_C32(0x0ec82857) },
  { SPH_C32(0xfe290000), SPH_C32(0x3dbd0000), SPH_C32(0x43380000),
    SPH_C32(0x69752c20), SPH_C32(0x9c8a7344), SPH_C32(0x25e156fe),
    SPH_C32(0xf3eca781), SPH_C32(0x32e4ddb1), SPH_C32(0x4dc40000),
    SPH_C32(0x19850000), SPH_C32(0x5a1c0000), SPH_C32(0x99eb5240),
    SPH_C32(0x0cee5c31), SPH_C32(0xe6d839fe), SPH_C32(0xbe28ec8d),
    SPH_C32(0x8f35d15f) },
  { SPH_C32(0x59db0000), SPH_C32(0xae6c0000), SPH_C32(0x30f40000),
    SPH_C32(0x48da2860), SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b),
    SPH_C32(0x999f2612), SPH_C32(0x71fa0dc9), SPH_C32(0xef180000),
    SPH_C32(0x7bde0000), SPH_C32(0x06960000), SPH_C32(0xd4665480),
    SPH_C32(0x97400b80), SPH_C32(0x6d841ce0), SPH_C32(0x8f0bc0ac),
    SPH_C32(0x40a75c89) },
  { SPH_C32(0xa91e0000), SPH_C32(0xf74f0000), SPH_C32(0x75760000),
    SPH_C32(0xa95728a0), SPH_C32(0xca921866), SPH_C32(0x7942a2f2),
    SPH_C32(0x527fd80e), SPH_C32(0x275dbc56), SPH_C32(0xf9f50000),
    SPH_C32(0x6eb60000), SPH_C32(0xeb410000), SPH_C32(0xe63b56a0),
    SPH_C32(0x744c3d09), SPH_C32(0x37cefaa3), SPH_C32(0x6c7e3804),
    SPH_C32(0xc15aa581) },
  { SPH_C32(0xedea0000), SPH_C32(0xd95f0000), SPH_C32(0x81a90000),
    SPH_C32(0x370a2c80), SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736),
    SPH_C32(0x4bc9f29b), SPH_C32(0x3f957917), SPH_C32(0x0c1e0000),
    SPH_C32(0xc61f0000), SPH_C32(0x81850000), SPH_C32(0x6b9454e0),
    SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1), SPH_C32(0xfcce6baa),
    SPH_C32(0x1b7149b0) },
  { SPH_C32(0x1d2f0000), SPH_C32(0x807c0000), SPH_C32(0xc42b0000),
    SPH_C32(0xd6872c40), SPH_C32(0xb230795e), SPH_C32(0xa85461af),
    SPH_C32(0x80290c87), SPH_C32(0x6932c888), SPH_C32(0x1af30000),
    SPH_C32(0xd3770000), SPH_C32(0x6c520000), SPH_C32(0x59c956c0),
    SPH_C32(0x5af63713), SPH_C32(0xba7bcdf2), SPH_C32(0x1fbb9302),
    SPH_C32(0x9a8cb0b8) },
  { SPH_C32(0xb82f0000), SPH_C32(0xb12c0000), SPH_C32(0x30d80000),
    SPH_C32(0x14445000), SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec),
    SPH_C32(0x2e98bf23), SPH_C32(0x551e3d6e), SPH_C32(0x02f20000),
    SPH_C32(0xa2810000), SPH_C32(0x873f0000), SPH_C32(0xe36c7800),
    SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6), SPH_C32(0xc4c23237),
    SPH_C32(0x7f32259e) },
  { SPH_C32(0x48ea0000), SPH_C32(0xe80f0000), SPH_C32(0x755a0000),
    SPH_C32(0xf5c950c0), SPH_C32(0xfa356693), SPH_C32(0xf3cabe75),
    SPH_C32(0xe578413f), SPH_C32(0x03b98cf1), SPH_C32(0x141f0000),
    SPH_C32(0xb7e90000), SPH_C32(0x6ae80000), SPH_C32(0xd1317a20),
    SPH_C32(0xfd114266), SPH_C32(0x5d77cd95), SPH_C32(0x27b7ca9f),
    SPH_C32(0xfecfdc96) },
  { SPH_C32(0x0c1e0000), SPH_C32(0xc61f0000), SPH_C32(0x81850000),
    SPH_C32(0x6b9454e0), SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1),
    SPH_C32(0xfcce6baa), SPH_C32(0x1b7149b0), SPH_C32(0xe1f40000),
    SPH_C32(0x1f400000), SPH_C32(0x002c0000), SPH_C32(0x5c9e7860),
    SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87), SPH_C32(0xb7079931),
    SPH_C32(0x24e430a7) },
  { SPH_C32(0xfcdb0000), SPH_C32(0x9f3c0000), SPH_C32(0xc4070000),
    SPH_C32(0x8a195420), SPH_C32(0x829707ab), SPH_C32(0x22dc7d28),
    SPH_C32(0x372e95b6), SPH_C32(0x4dd6f82f), SPH_C32(0xf7190000),
    SPH_C32(0x0a280000), SPH_C32(0xedfb0000), SPH_C32(0x6ec37a40),
    SPH_C32(0xd3ab487c), SPH_C32(0xd0c2fac4), SPH_C32(0x54726199),
    SPH_C32(0xa519c9af) },
  { SPH_C32(0x5b290000), SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000),
    SPH_C32(0xabb65060), SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd),
    SPH_C32(0x5d5d1425), SPH_C32(0x0ec82857), SPH_C32(0x55c50000),
    SPH_C32(0x68730000), SPH_C32(0xb1710000), SPH_C32(0x234e7c80),
    SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda), SPH_C32(0x65514db8),
    SPH_C32(0x6a8b4479) },
  { SPH_C32(0xabec0000), SPH_C32(0x55ce0000), SPH_C32(0xf2490000),
    SPH_C32(0x4a3b50a0), SPH_C32(0xd48f6c89), SPH_C32(0x7e7f8924),
    SPH_C32(0x96bdea39), SPH_C32(0x586f99c8), SPH_C32(0x43280000),
    SPH_C32(0x7d1b0000), SPH_C32(0x5ca60000), SPH_C32(0x11137ea0),
    SPH_C32(0xab092944), SPH_C32(0x01d43999), SPH_C32(0x8624b510),
    SPH_C32(0xeb76bd71) },
  { SPH_C32(0xef180000), SPH_C32(0x7bde0000), SPH_C32(0x06960000),
    SPH_C32(0xd4665480), SPH_C32(0x97400b80), SPH_C32(0x6d841ce0),
    SPH_C32(0x8f0bc0ac), SPH_C32(0x40a75c89), SPH_C32(0xb6c30000),
    SPH_C32(0xd5b20000), SPH_C32(0x36620000), SPH_C32(0x9cbc7ce0),
    SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b), SPH_C32(0x1694e6be),
    SPH_C32(0x315d5140) },
  { SPH_C32(0x1fdd0000), SPH_C32(0x22fd0000), SPH_C32(0x43140000),
    SPH_C32(0x35eb5440), SPH_C32(0xac2d0db1), SPH_C32(0xaf694a79),
    SPH_C32(0x44eb3eb0), SPH_C32(0x1600ed16), SPH_C32(0xa02e0000),
    SPH_C32(0xc0da0000), SPH_C32(0xdbb50000), SPH_C32(0xaee17ec0),
    SPH_C32(0x85b3235e), SPH_C32(0x8c610ec8), SPH_C32(0xf5e11e16),
    SPH_C32(0xb0a0a848) }
};

__constant static const sph_u32 T512_55[32][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0x5fec0000), SPH_C32(0x294b0000), SPH_C32(0x99d20000),
    SPH_C32(0x4ed00012), SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9),
    SPH_C32(0x57140bdf), SPH_C32(0x30aebcf7), SPH_C32(0x5fa80000),
    SPH_C32(0x56030000), SPH_C32(0x43ae0000), SPH_C32(0x64f30013),
    SPH_C32(0x257e86bf), SPH_C32(0x1311944e), SPH_C32(0x541e95bf),
    SPH_C32(0x8ea4db69) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0xb13b0000), SPH_C32(0x80040000), SPH_C32(0xd16f0000),
    SPH_C32(0x4f6b01f3), SPH_C32(0xb12faec3), SPH_C32(0x287d6f19),
    SPH_C32(0x112fb6cb), SPH_C32(0xaebbb10d), SPH_C32(0x7b6c0000),
    SPH_C32(0x280a0000), SPH_C32(0x73990000), SPH_C32(0x496000a1),
    SPH_C32(0xa5768de3), SPH_C32(0xc42f093c), SPH_C32(0x24f2a563),
    SPH_C32(0x79f5076e) },
  { SPH_C32(0xeed70000), SPH_C32(0xa94f0000), SPH_C32(0x48bd0000),
    SPH_C32(0x01bb01e1), SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0),
    SPH_C32(0x463bbd14), SPH_C32(0x9e150dfa), SPH_C32(0x24c40000),
    SPH_C32(0x7e090000), SPH_C32(0x30370000), SPH_C32(0x2d9300b2),
    SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72), SPH_C32(0x70ec30dc),
    SPH_C32(0xf751dc07) },
  { SPH_C32(0xb17f0000), SPH_C32(0xff4c0000), SPH_C32(0x0b130000),
    SPH_C32(0x654801f2), SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e),
    SPH_C32(0x122528ab), SPH_C32(0x10b1d693), SPH_C32(0x24800000),
    SPH_C32(0x01410000), SPH_C32(0xea4b0000), SPH_C32(0x07b000b3),
    SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5), SPH_C32(0x73e6aebc),
    SPH_C32(0x495bbb99) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) },
  { SPH_C32(0x24800000), SPH_C32(0x01410000), SPH_C32(0xea4b0000),
    SPH_C32(0x07b000b3), SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5),
    SPH_C32(0x73e6aebc), SPH_C32(0x495bbb99), SPH_C32(0x95ff0000),
    SPH_C32(0xfe0d0000), SPH_C32(0xe1580000), SPH_C32(0x62f80141),
    SPH_C32(0x3127a59f), SPH_C32(0xff43f26b), SPH_C32(0x61c38617),
    SPH_C32(0x59ea6d0a) },
  { SPH_C32(0x7b6c0000), SPH_C32(0x280a0000), SPH_C32(0x73990000),
    SPH_C32(0x496000a1), SPH_C32(0xa5768de3), SPH_C32(0xc42f093c),
    SPH_C32(0x24f2a563), SPH_C32(0x79f5076e), SPH_C32(0xca570000),
    SPH_C32(0xa80e0000), SPH_C32(0xa2f60000), SPH_C32(0x060b0152),
    SPH_C32(0x14592320), SPH_C32(0xec526625), SPH_C32(0x35dd13a8),
    SPH_C32(0xd74eb663) },
  { SPH_C32(0x24c40000), SPH_C32(0x7e090000), SPH_C32(0x30370000),
    SPH_C32(0x2d9300b2), SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72),
    SPH_C32(0x70ec30dc), SPH_C32(0xf751dc07), SPH_C32(0xca130000),
    SPH_C32(0xd7460000), SPH_C32(0x788a0000), SPH_C32(0x2c280153),
    SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2), SPH_C32(0x36d78dc8),
    SPH_C32(0x6944d1fd) },
  { SPH_C32(0x95bb0000), SPH_C32(0x81450000), SPH_C32(0x3b240000),
    SPH_C32(0x48db0140), SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec),
    SPH_C32(0x62c91877), SPH_C32(0xe7e00a94), SPH_C32(0xee930000),
    SPH_C32(0xd6070000), SPH_C32(0x92c10000), SPH_C32(0x2b9801e0),
    SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57), SPH_C32(0x45312374),
    SPH_C32(0x201f6a64) },
  { SPH_C32(0xca130000), SPH_C32(0xd7460000), SPH_C32(0x788a0000),
    SPH_C32(0x2c280153), SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2),
    SPH_C32(0x36d78dc8), SPH_C32(0x6944d1fd), SPH_C32(0xeed70000),
    SPH_C32(0xa94f0000), SPH_C32(0x48bd0000), SPH_C32(0x01bb01e1),
    SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0), SPH_C32(0x463bbd14),
    SPH_C32(0x9e150dfa) },
  { SPH_C32(0x95ff0000), SPH_C32(0xfe0d0000), SPH_C32(0xe1580000),
    SPH_C32(0x62f80141), SPH_C32(0x3127a59f), SPH_C32(0xff43f26b),
    SPH_C32(0x61c38617), SPH_C32(0x59ea6d0a), SPH_C32(0xb17f0000),
    SPH_C32(0xff4c0000), SPH_C32(0x0b130000), SPH_C32(0x654801f2),
    SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e), SPH_C32(0x122528ab),
    SPH_C32(0x10b1d693) },
  { SPH_C32(0xca570000), SPH_C32(0xa80e0000), SPH_C32(0xa2f60000),
    SPH_C32(0x060b0152), SPH_C32(0x14592320), SPH_C32(0xec526625),
    SPH_C32(0x35dd13a8), SPH_C32(0xd74eb663), SPH_C32(0xb13b0000),
    SPH_C32(0x80040000), SPH_C32(0xd16f0000), SPH_C32(0x4f6b01f3),
    SPH_C32(0xb12faec3), SPH_C32(0x287d6f19), SPH_C32(0x112fb6cb),
    SPH_C32(0xaebbb10d) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0xb9800000), SPH_C32(0x1a480000), SPH_C32(0xebfb0000),
    SPH_C32(0xb72302f3), SPH_C32(0xfd1fb607), SPH_C32(0x8bb62494),
    SPH_C32(0x7c8b930b), SPH_C32(0x59fe93fe), SPH_C32(0xf0810000),
    SPH_C32(0x266b0000), SPH_C32(0x9ffe0000), SPH_C32(0xcbae00c1),
    SPH_C32(0x00c0cffd), SPH_C32(0x6b5bca1e), SPH_C32(0xc8ea607c),
    SPH_C32(0xe8add601) },
  { SPH_C32(0xe66c0000), SPH_C32(0x33030000), SPH_C32(0x72290000),
    SPH_C32(0xf9f302e1), SPH_C32(0xe3ccf974), SPH_C32(0x31112c5d),
    SPH_C32(0x2b9f98d4), SPH_C32(0x69502f09), SPH_C32(0xaf290000),
    SPH_C32(0x70680000), SPH_C32(0xdc500000), SPH_C32(0xaf5d00d2),
    SPH_C32(0x25be4942), SPH_C32(0x784a5e50), SPH_C32(0x9cf4f5c3),
    SPH_C32(0x66090d68) },
  { SPH_C32(0xb9c40000), SPH_C32(0x65000000), SPH_C32(0x31870000),
    SPH_C32(0x9d0002f2), SPH_C32(0xc6b27fcb), SPH_C32(0x2200b813),
    SPH_C32(0x7f810d6b), SPH_C32(0xe7f4f460), SPH_C32(0xaf6d0000),
    SPH_C32(0x0f200000), SPH_C32(0x062c0000), SPH_C32(0x857e00d3),
    SPH_C32(0x1e13808e), SPH_C32(0xd1fcc2d7), SPH_C32(0x9ffe6ba3),
    SPH_C32(0xd8036af6) },
  { SPH_C32(0x08bb0000), SPH_C32(0x9a4c0000), SPH_C32(0x3a940000),
    SPH_C32(0xf8480300), SPH_C32(0x4c3018c4), SPH_C32(0xa3cb4b8d),
    SPH_C32(0x6da425c0), SPH_C32(0xf74522f3), SPH_C32(0x8bed0000),
    SPH_C32(0x0e610000), SPH_C32(0xec670000), SPH_C32(0x82ce0060),
    SPH_C32(0xa5b6421e), SPH_C32(0xaf74c322), SPH_C32(0xec18c51f),
    SPH_C32(0x9158d16f) },
  { SPH_C32(0x57130000), SPH_C32(0xcc4f0000), SPH_C32(0x793a0000),
    SPH_C32(0x9cbb0313), SPH_C32(0x694e9e7b), SPH_C32(0xb0dadfc3),
    SPH_C32(0x39bab07f), SPH_C32(0x79e1f99a), SPH_C32(0x8ba90000),
    SPH_C32(0x71290000), SPH_C32(0x361b0000), SPH_C32(0xa8ed0061),
    SPH_C32(0x9e1b8bd2), SPH_C32(0x06c25fa5), SPH_C32(0xef125b7f),
    SPH_C32(0x2f52b6f1) },
  { SPH_C32(0x08ff0000), SPH_C32(0xe5040000), SPH_C32(0xe0e80000),
    SPH_C32(0xd26b0301), SPH_C32(0x779dd108), SPH_C32(0x0a7dd70a),
    SPH_C32(0x6eaebba0), SPH_C32(0x494f456d), SPH_C32(0xd4010000),
    SPH_C32(0x272a0000), SPH_C32(0x75b50000), SPH_C32(0xcc1e0072),
    SPH_C32(0xbb650d6d), SPH_C32(0x15d3cbeb), SPH_C32(0xbb0ccec0),
    SPH_C32(0xa1f66d98) },
  { SPH_C32(0x57570000), SPH_C32(0xb3070000), SPH_C32(0xa3460000),
    SPH_C32(0xb6980312), SPH_C32(0x52e357b7), SPH_C32(0x196c4344),
    SPH_C32(0x3ab02e1f), SPH_C32(0xc7eb9e04), SPH_C32(0xd4450000),
    SPH_C32(0x58620000), SPH_C32(0xafc90000), SPH_C32(0xe63d0073),
    SPH_C32(0x80c8c4a1), SPH_C32(0xbc65576c), SPH_C32(0xb80650a0),
    SPH_C32(0x1ffc0a06) },
  { SPH_C32(0x9d000000), SPH_C32(0x1b090000), SPH_C32(0x01b00000),
    SPH_C32(0xb0930240), SPH_C32(0x46ba7497), SPH_C32(0xf53e2561),
    SPH_C32(0x0f6d3db7), SPH_C32(0x10a52867), SPH_C32(0x657e0000),
    SPH_C32(0xd8660000), SPH_C32(0x7ea60000), SPH_C32(0xa9560180),
    SPH_C32(0x31e76a62), SPH_C32(0x94183875), SPH_C32(0xa929e66b),
    SPH_C32(0xb147bb0b) },
  { SPH_C32(0xc2a80000), SPH_C32(0x4d0a0000), SPH_C32(0x421e0000),
    SPH_C32(0xd4600253), SPH_C32(0x63c4f228), SPH_C32(0xe62fb12f),
    SPH_C32(0x5b73a808), SPH_C32(0x9e01f30e), SPH_C32(0x653a0000),
    SPH_C32(0xa72e0000), SPH_C32(0xa4da0000), SPH_C32(0x83750181),
    SPH_C32(0x0a4aa3ae), SPH_C32(0x3daea4f2), SPH_C32(0xaa23780b),
    SPH_C32(0x0f4ddc95) },
  { SPH_C32(0x9d440000), SPH_C32(0x64410000), SPH_C32(0xdbcc0000),
    SPH_C32(0x9ab00241), SPH_C32(0x7d17bd5b), SPH_C32(0x5c88b9e6),
    SPH_C32(0x0c67a3d7), SPH_C32(0xaeaf4ff9), SPH_C32(0x3a920000),
    SPH_C32(0xf12d0000), SPH_C32(0xe7740000), SPH_C32(0xe7860192),
    SPH_C32(0x2f342511), SPH_C32(0x2ebf30bc), SPH_C32(0xfe3dedb4),
    SPH_C32(0x81e907fc) },
  { SPH_C32(0xc2ec0000), SPH_C32(0x32420000), SPH_C32(0x98620000),
    SPH_C32(0xfe430252), SPH_C32(0x58693be4), SPH_C32(0x4f992da8),
    SPH_C32(0x58793668), SPH_C32(0x200b9490), SPH_C32(0x3ad60000),
    SPH_C32(0x8e650000), SPH_C32(0x3d080000), SPH_C32(0xcda50193),
    SPH_C32(0x1499ecdd), SPH_C32(0x8709ac3b), SPH_C32(0xfd3773d4),
    SPH_C32(0x3fe36062) },
  { SPH_C32(0x73930000), SPH_C32(0xcd0e0000), SPH_C32(0x93710000),
    SPH_C32(0x9b0b03a0), SPH_C32(0xd2eb5ceb), SPH_C32(0xce52de36),
    SPH_C32(0x4a5c1ec3), SPH_C32(0x30ba4203), SPH_C32(0x1e560000),
    SPH_C32(0x8f240000), SPH_C32(0xd7430000), SPH_C32(0xca150120),
    SPH_C32(0xaf3c2e4d), SPH_C32(0xf981adce), SPH_C32(0x8ed1dd68),
    SPH_C32(0x76b8dbfb) },
  { SPH_C32(0x2c3b0000), SPH_C32(0x9b0d0000), SPH_C32(0xd0df0000),
    SPH_C32(0xfff803b3), SPH_C32(0xf795da54), SPH_C32(0xdd434a78),
    SPH_C32(0x1e428b7c), SPH_C32(0xbe1e996a), SPH_C32(0x1e120000),
    SPH_C32(0xf06c0000), SPH_C32(0x0d3f0000), SPH_C32(0xe0360121),
    SPH_C32(0x9491e781), SPH_C32(0x50373149), SPH_C32(0x8ddb4308),
    SPH_C32(0xc8b2bc65) },
  { SPH_C32(0x73d70000), SPH_C32(0xb2460000), SPH_C32(0x490d0000),
    SPH_C32(0xb12803a1), SPH_C32(0xe9469527), SPH_C32(0x67e442b1),
    SPH_C32(0x495680a3), SPH_C32(0x8eb0259d), SPH_C32(0x41ba0000),
    SPH_C32(0xa66f0000), SPH_C32(0x4e910000), SPH_C32(0x84c50132),
    SPH_C32(0xb1ef613e), SPH_C32(0x4326a507), SPH_C32(0xd9c5d6b7),
    SPH_C32(0x4616670c) },
  { SPH_C32(0x2c7f0000), SPH_C32(0xe4450000), SPH_C32(0x0aa30000),
    SPH_C32(0xd5db03b2), SPH_C32(0xcc381398), SPH_C32(0x74f5d6ff),
    SPH_C32(0x1d48151c), SPH_C32(0x0014fef4), SPH_C32(0x41fe0000),
    SPH_C32(0xd9270000), SPH_C32(0x94ed0000), SPH_C32(0xaee60133),
    SPH_C32(0x8a42a8f2), SPH_C32(0xea903980), SPH_C32(0xdacf48d7),
    SPH_C32(0xf81c0092) }
};

__constant static const sph_u32 T512_60[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0xabe70000), SPH_C32(0x9e0d0000), SPH_C32(0xaf270000),
    SPH_C32(0x3d180005), SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695),
    SPH_C32(0xb5c347eb), SPH_C32(0x3c5dfffe), SPH_C32(0x033d0000),
    SPH_C32(0x08b30000), SPH_C32(0xf33a0000), SPH_C32(0x3ac20007),
    SPH_C32(0x51298a50), SPH_C32(0x6b6e661f), SPH_C32(0x0ea5cfe3),
    SPH_C32(0xe6da7ffe) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0x02ae0000), SPH_C32(0xef310000), SPH_C32(0x1ec10000),
    SPH_C32(0xf5ce000c), SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231),
    SPH_C32(0x0893ae02), SPH_C32(0xb5b5e185), SPH_C32(0x3af20000),
    SPH_C32(0x4a3b0000), SPH_C32(0x0be70000), SPH_C32(0x51060001),
    SPH_C32(0xc78fb695), SPH_C32(0x4577d386), SPH_C32(0x2ba87f5a),
    SPH_C32(0xa191f5d7) },
  { SPH_C32(0xa9490000), SPH_C32(0x713c0000), SPH_C32(0xb1e60000),
    SPH_C32(0xc8d60009), SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4),
    SPH_C32(0xbd50e9e9), SPH_C32(0x89e81e7b), SPH_C32(0x39cf0000),
    SPH_C32(0x42880000), SPH_C32(0xf8dd0000), SPH_C32(0x6bc40006),
    SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599), SPH_C32(0x250db0b9),
    SPH_C32(0x474b8a29) },
  { SPH_C32(0xaa740000), SPH_C32(0x798f0000), SPH_C32(0x42dc0000),
    SPH_C32(0xf214000e), SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb),
    SPH_C32(0xb3f5260a), SPH_C32(0x6f326185), SPH_C32(0x91150000),
    SPH_C32(0xd4360000), SPH_C32(0xa4c00000), SPH_C32(0x6c1e0004),
    SPH_C32(0xebc0a946), SPH_C32(0x3181c513), SPH_C32(0x9e6b38b1),
    SPH_C32(0x9dcc0a29) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x91150000), SPH_C32(0xd4360000), SPH_C32(0xa4c00000),
    SPH_C32(0x6c1e0004), SPH_C32(0xebc0a946), SPH_C32(0x3181c513),
    SPH_C32(0x9e6b38b1), SPH_C32(0x9dcc0a29), SPH_C32(0x3b610000),
    SPH_C32(0xadb90000), SPH_C32(0xe61c0000), SPH_C32(0x9e0a000a),
    SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8), SPH_C32(0x2d9e1ebb),
    SPH_C32(0xf2fe6bac) },
  { SPH_C32(0x3af20000), SPH_C32(0x4a3b0000), SPH_C32(0x0be70000),
    SPH_C32(0x51060001), SPH_C32(0xc78fb695), SPH_C32(0x4577d386),
    SPH_C32(0x2ba87f5a), SPH_C32(0xa191f5d7), SPH_C32(0x385c0000),
    SPH_C32(0xa50a0000), SPH_C32(0x15260000), SPH_C32(0xa4c8000d),
    SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7), SPH_C32(0x233bd158),
    SPH_C32(0x14241452) },
  { SPH_C32(0x39cf0000), SPH_C32(0x42880000), SPH_C32(0xf8dd0000),
    SPH_C32(0x6bc40006), SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599),
    SPH_C32(0x250db0b9), SPH_C32(0x474b8a29), SPH_C32(0x90860000),
    SPH_C32(0x33b40000), SPH_C32(0x493b0000), SPH_C32(0xa312000f),
    SPH_C32(0x6610241e), SPH_C32(0x8d22713d), SPH_C32(0x985d5950),
    SPH_C32(0xcea39452) },
  { SPH_C32(0x93bb0000), SPH_C32(0x3b070000), SPH_C32(0xba010000),
    SPH_C32(0x99d00008), SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722),
    SPH_C32(0x96f896b3), SPH_C32(0x2879ebac), SPH_C32(0x01930000),
    SPH_C32(0xe7820000), SPH_C32(0xedfb0000), SPH_C32(0xcf0c000b),
    SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e), SPH_C32(0x063661e1),
    SPH_C32(0x536f9e7b) },
  { SPH_C32(0x90860000), SPH_C32(0x33b40000), SPH_C32(0x493b0000),
    SPH_C32(0xa312000f), SPH_C32(0x6610241e), SPH_C32(0x8d22713d),
    SPH_C32(0x985d5950), SPH_C32(0xcea39452), SPH_C32(0xa9490000),
    SPH_C32(0x713c0000), SPH_C32(0xb1e60000), SPH_C32(0xc8d60009),
    SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4), SPH_C32(0xbd50e9e9),
    SPH_C32(0x89e81e7b) },
  { SPH_C32(0x3b610000), SPH_C32(0xadb90000), SPH_C32(0xe61c0000),
    SPH_C32(0x9e0a000a), SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8),
    SPH_C32(0x2d9e1ebb), SPH_C32(0xf2fe6bac), SPH_C32(0xaa740000),
    SPH_C32(0x798f0000), SPH_C32(0x42dc0000), SPH_C32(0xf214000e),
    SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb), SPH_C32(0xb3f5260a),
    SPH_C32(0x6f326185) },
  { SPH_C32(0x385c0000), SPH_C32(0xa50a0000), SPH_C32(0x15260000),
    SPH_C32(0xa4c8000d), SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7),
    SPH_C32(0x233bd158), SPH_C32(0x14241452), SPH_C32(0x02ae0000),
    SPH_C32(0xef310000), SPH_C32(0x1ec10000), SPH_C32(0xf5ce000c),
    SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231), SPH_C32(0x0893ae02),
    SPH_C32(0xb5b5e185) }
};

#define INPUT_BIG   do { \
    unsigned acc = buf(0); \
    __constant const sph_u32 *rp; \
    rp = &T512_0[acc >> 3][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    m8 = rp[8]; \
    m9 = rp[9]; \
    mA = rp[10]; \
    mB = rp[11]; \
    mC = rp[12]; \
    mD = rp[13]; \
    mE = rp[14]; \
    mF = rp[15]; \
    acc = (acc << 8) | buf(1); \
    rp = &T512_5[(acc >> 6) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_10[(acc >> 1) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(2); \
    rp = &T512_15[(acc >> 4) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(3); \
    rp = &T512_20[(acc >> 7) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_25[(acc >> 2) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(4); \
    rp = &T512_30[(acc >> 5) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_35[acc & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(5); \
    rp = &T512_40[acc >> 3][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(6); \
    rp = &T512_45[(acc >> 6) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_50[(acc >> 1) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(7); \
    rp = &T512_55[(acc >> 4) & 0x1f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_60[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 6

__constant static const sph_u32 T512_0[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0x373d2800), SPH_C32(0x71500000), SPH_C32(0x95e00000),
    SPH_C32(0x0a140000), SPH_C32(0xbdac1909), SPH_C32(0x48ef9831),
    SPH_C32(0x456d6d1f), SPH_C32(0x3daac2da), SPH_C32(0x145a3c00),
    SPH_C32(0xb9e90000), SPH_C32(0x61270000), SPH_C32(0xf1610000),
    SPH_C32(0xce613d6c), SPH_C32(0xb0493d78), SPH_C32(0x47a96720),
    SPH_C32(0xe18e24c5) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0x40726000), SPH_C32(0x53040000), SPH_C32(0xa4f10000),
    SPH_C32(0x50a40000), SPH_C32(0x7dc35a1c), SPH_C32(0x24ecf999),
    SPH_C32(0x2c1926bd), SPH_C32(0xb4951347), SPH_C32(0xbfdc0c00),
    SPH_C32(0x786a0000), SPH_C32(0x66960000), SPH_C32(0x16e60000),
    SPH_C32(0x2af76720), SPH_C32(0x19b270bd), SPH_C32(0x41c239e5),
    SPH_C32(0xa4ee2836) },
  { SPH_C32(0x774f4800), SPH_C32(0x22540000), SPH_C32(0x31110000),
    SPH_C32(0x5ab00000), SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8),
    SPH_C32(0x69744ba2), SPH_C32(0x893fd19d), SPH_C32(0xab863000),
    SPH_C32(0xc1830000), SPH_C32(0x07b10000), SPH_C32(0xe7870000),
    SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5), SPH_C32(0x066b5ec5),
    SPH_C32(0x45600cf3) },
  { SPH_C32(0x63157400), SPH_C32(0x9bbd0000), SPH_C32(0x50360000),
    SPH_C32(0xabd10000), SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0),
    SPH_C32(0x2edd2c82), SPH_C32(0x68b1f558), SPH_C32(0x88e12400),
    SPH_C32(0x093a0000), SPH_C32(0xf3760000), SPH_C32(0x1cf20000),
    SPH_C32(0x975b7e29), SPH_C32(0x515de88c), SPH_C32(0x04af54fa),
    SPH_C32(0x9944eaec) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0x88e12400), SPH_C32(0x093a0000), SPH_C32(0xf3760000),
    SPH_C32(0x1cf20000), SPH_C32(0x975b7e29), SPH_C32(0x515de88c),
    SPH_C32(0x04af54fa), SPH_C32(0x9944eaec), SPH_C32(0xebf45000),
    SPH_C32(0x92870000), SPH_C32(0xa3400000), SPH_C32(0xb7230000),
    SPH_C32(0x99550050), SPH_C32(0x8d17b45c), SPH_C32(0x2a727878),
    SPH_C32(0xf1f51fb4) },
  { SPH_C32(0xbfdc0c00), SPH_C32(0x786a0000), SPH_C32(0x66960000),
    SPH_C32(0x16e60000), SPH_C32(0x2af76720), SPH_C32(0x19b270bd),
    SPH_C32(0x41c239e5), SPH_C32(0xa4ee2836), SPH_C32(0xffae6c00),
    SPH_C32(0x2b6e0000), SPH_C32(0xc2670000), SPH_C32(0x46420000),
    SPH_C32(0x57343d3c), SPH_C32(0x3d5e8924), SPH_C32(0x6ddb1f58),
    SPH_C32(0x107b3b71) },
  { SPH_C32(0xab863000), SPH_C32(0xc1830000), SPH_C32(0x07b10000),
    SPH_C32(0xe7870000), SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5),
    SPH_C32(0x066b5ec5), SPH_C32(0x45600cf3), SPH_C32(0xdcc97800),
    SPH_C32(0xe3d70000), SPH_C32(0x36a00000), SPH_C32(0xbd370000),
    SPH_C32(0x24f91959), SPH_C32(0xc5f82c6d), SPH_C32(0x6f1f1567),
    SPH_C32(0xcc5fdd6e) },
  { SPH_C32(0xc8934400), SPH_C32(0x5a3e0000), SPH_C32(0x57870000),
    SPH_C32(0x4c560000), SPH_C32(0xea982435), SPH_C32(0x75b11115),
    SPH_C32(0x28b67247), SPH_C32(0x2dd1f9ab), SPH_C32(0x54285c00),
    SPH_C32(0xeaed0000), SPH_C32(0xc5d60000), SPH_C32(0xa1c50000),
    SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1), SPH_C32(0x6bb0419d),
    SPH_C32(0x551b3782) },
  { SPH_C32(0xdcc97800), SPH_C32(0xe3d70000), SPH_C32(0x36a00000),
    SPH_C32(0xbd370000), SPH_C32(0x24f91959), SPH_C32(0xc5f82c6d),
    SPH_C32(0x6f1f1567), SPH_C32(0xcc5fdd6e), SPH_C32(0x774f4800),
    SPH_C32(0x22540000), SPH_C32(0x31110000), SPH_C32(0x5ab00000),
    SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8), SPH_C32(0x69744ba2),
    SPH_C32(0x893fd19d) },
  { SPH_C32(0xebf45000), SPH_C32(0x92870000), SPH_C32(0xa3400000),
    SPH_C32(0xb7230000), SPH_C32(0x99550050), SPH_C32(0x8d17b45c),
    SPH_C32(0x2a727878), SPH_C32(0xf1f51fb4), SPH_C32(0x63157400),
    SPH_C32(0x9bbd0000), SPH_C32(0x50360000), SPH_C32(0xabd10000),
    SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0), SPH_C32(0x2edd2c82),
    SPH_C32(0x68b1f558) },
  { SPH_C32(0xffae6c00), SPH_C32(0x2b6e0000), SPH_C32(0xc2670000),
    SPH_C32(0x46420000), SPH_C32(0x57343d3c), SPH_C32(0x3d5e8924),
    SPH_C32(0x6ddb1f58), SPH_C32(0x107b3b71), SPH_C32(0x40726000),
    SPH_C32(0x53040000), SPH_C32(0xa4f10000), SPH_C32(0x50a40000),
    SPH_C32(0x7dc35a1c), SPH_C32(0x24ecf999), SPH_C32(0x2c1926bd),
    SPH_C32(0xb4951347) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0x3d1ea000), SPH_C32(0xdd0e0000), SPH_C32(0x936c0000),
    SPH_C32(0x33920000), SPH_C32(0xc0bf73e3), SPH_C32(0xe68b0a3d),
    SPH_C32(0xb4492579), SPH_C32(0x6c83ba01), SPH_C32(0x650a1800),
    SPH_C32(0xc0db0000), SPH_C32(0x299a0000), SPH_C32(0x41a80000),
    SPH_C32(0x195f5d27), SPH_C32(0xbcb98eda), SPH_C32(0x234ec450),
    SPH_C32(0x6308edfd) },
  { SPH_C32(0x0a238800), SPH_C32(0xac5e0000), SPH_C32(0x068c0000),
    SPH_C32(0x39860000), SPH_C32(0x7d136aea), SPH_C32(0xae64920c),
    SPH_C32(0xf1244866), SPH_C32(0x512978db), SPH_C32(0x71502400),
    SPH_C32(0x79320000), SPH_C32(0x48bd0000), SPH_C32(0xb0c90000),
    SPH_C32(0xd73e604b), SPH_C32(0x0cf0b3a2), SPH_C32(0x64e7a370),
    SPH_C32(0x8286c938) },
  { SPH_C32(0x1e79b400), SPH_C32(0x15b70000), SPH_C32(0x67ab0000),
    SPH_C32(0xc8e70000), SPH_C32(0xb3725786), SPH_C32(0x1e2daf74),
    SPH_C32(0xb68d2f46), SPH_C32(0xb0a75c1e), SPH_C32(0x52373000),
    SPH_C32(0xb18b0000), SPH_C32(0xbc7a0000), SPH_C32(0x4bbc0000),
    SPH_C32(0xa4f3442e), SPH_C32(0xf45616eb), SPH_C32(0x6623a94f),
    SPH_C32(0x5ea22f27) },
  { SPH_C32(0x7d6cc000), SPH_C32(0x8e0a0000), SPH_C32(0x379d0000),
    SPH_C32(0x63360000), SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4),
    SPH_C32(0x985003c4), SPH_C32(0xd816a946), SPH_C32(0xdad61400),
    SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000), SPH_C32(0x574e0000),
    SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67), SPH_C32(0x628cfdb5),
    SPH_C32(0xc7e6c5cb) },
  { SPH_C32(0x6936fc00), SPH_C32(0x37e30000), SPH_C32(0x56ba0000),
    SPH_C32(0x92570000), SPH_C32(0x731d1493), SPH_C32(0x722ecedc),
    SPH_C32(0xdff964e4), SPH_C32(0x39988d83), SPH_C32(0xf9b10000),
    SPH_C32(0x70080000), SPH_C32(0xbbcb0000), SPH_C32(0xac3b0000),
    SPH_C32(0x40651e62), SPH_C32(0x5dad5b2e), SPH_C32(0x6048f78a),
    SPH_C32(0x1bc223d4) },
  { SPH_C32(0x5e0bd400), SPH_C32(0x46b30000), SPH_C32(0xc35a0000),
    SPH_C32(0x98430000), SPH_C32(0xceb10d9a), SPH_C32(0x3ac156ed),
    SPH_C32(0x9a9409fb), SPH_C32(0x04324f59), SPH_C32(0xedeb3c00),
    SPH_C32(0xc9e10000), SPH_C32(0xdaec0000), SPH_C32(0x5d5a0000),
    SPH_C32(0x8e04230e), SPH_C32(0xede46656), SPH_C32(0x27e190aa),
    SPH_C32(0xfa4c0711) },
  { SPH_C32(0x4a51e800), SPH_C32(0xff5a0000), SPH_C32(0xa27d0000),
    SPH_C32(0x69220000), SPH_C32(0x00d030f6), SPH_C32(0x8a886b95),
    SPH_C32(0xdd3d6edb), SPH_C32(0xe5bc6b9c), SPH_C32(0xce8c2800),
    SPH_C32(0x01580000), SPH_C32(0x2e2b0000), SPH_C32(0xa62f0000),
    SPH_C32(0xfdc9076b), SPH_C32(0x1542c31f), SPH_C32(0x25259a95),
    SPH_C32(0x2668e10e) },
  { SPH_C32(0xb5ff8400), SPH_C32(0xd4340000), SPH_C32(0x601a0000),
    SPH_C32(0x2f600000), SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1),
    SPH_C32(0xb0e67183), SPH_C32(0xf5c750ed), SPH_C32(0x8efe4800),
    SPH_C32(0x525c0000), SPH_C32(0x8ada0000), SPH_C32(0xf68b0000),
    SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86), SPH_C32(0x093cbc28),
    SPH_C32(0x92fdf249) },
  { SPH_C32(0xa1a5b800), SPH_C32(0x6ddd0000), SPH_C32(0x013d0000),
    SPH_C32(0xde010000), SPH_C32(0x998530a6), SPH_C32(0x079fdfc9),
    SPH_C32(0xf74f16a3), SPH_C32(0x14497428), SPH_C32(0xad995c00),
    SPH_C32(0x9ae50000), SPH_C32(0x7e1d0000), SPH_C32(0x0dfe0000),
    SPH_C32(0xf3c77912), SPH_C32(0xc9089fcf), SPH_C32(0x0bf8b617),
    SPH_C32(0x4ed91456) },
  { SPH_C32(0x96989000), SPH_C32(0x1c8d0000), SPH_C32(0x94dd0000),
    SPH_C32(0xd4150000), SPH_C32(0x242929af), SPH_C32(0x4f7047f8),
    SPH_C32(0xb2227bbc), SPH_C32(0x29e3b6f2), SPH_C32(0xb9c36000),
    SPH_C32(0x230c0000), SPH_C32(0x1f3a0000), SPH_C32(0xfc9f0000),
    SPH_C32(0x3da6447e), SPH_C32(0x7941a2b7), SPH_C32(0x4c51d137),
    SPH_C32(0xaf573093) },
  { SPH_C32(0x82c2ac00), SPH_C32(0xa5640000), SPH_C32(0xf5fa0000),
    SPH_C32(0x25740000), SPH_C32(0xea4814c3), SPH_C32(0xff397a80),
    SPH_C32(0xf58b1c9c), SPH_C32(0xc86d9237), SPH_C32(0x9aa47400),
    SPH_C32(0xebb50000), SPH_C32(0xebfd0000), SPH_C32(0x07ea0000),
    SPH_C32(0x4e6b601b), SPH_C32(0x81e707fe), SPH_C32(0x4e95db08),
    SPH_C32(0x7373d68c) },
  { SPH_C32(0xe1d7d800), SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000),
    SPH_C32(0x8ea50000), SPH_C32(0xe4466aba), SPH_C32(0x23732650),
    SPH_C32(0xdb56301e), SPH_C32(0xa0dc676f), SPH_C32(0x12455000),
    SPH_C32(0xe28f0000), SPH_C32(0x188b0000), SPH_C32(0x1b180000),
    SPH_C32(0xd9301e32), SPH_C32(0xd0baef72), SPH_C32(0x4a3a8ff2),
    SPH_C32(0xea373c60) },
  { SPH_C32(0xf58de400), SPH_C32(0x87300000), SPH_C32(0xc4eb0000),
    SPH_C32(0x7fc40000), SPH_C32(0x2a2757d6), SPH_C32(0x933a1b28),
    SPH_C32(0x9cff573e), SPH_C32(0x415243aa), SPH_C32(0x31224400),
    SPH_C32(0x2a360000), SPH_C32(0xec4c0000), SPH_C32(0xe06d0000),
    SPH_C32(0xaafd3a57), SPH_C32(0x281c4a3b), SPH_C32(0x48fe85cd),
    SPH_C32(0x3613da7f) },
  { SPH_C32(0xc2b0cc00), SPH_C32(0xf6600000), SPH_C32(0x510b0000),
    SPH_C32(0x75d00000), SPH_C32(0x978b4edf), SPH_C32(0xdbd58319),
    SPH_C32(0xd9923a21), SPH_C32(0x7cf88170), SPH_C32(0x25787800),
    SPH_C32(0x93df0000), SPH_C32(0x8d6b0000), SPH_C32(0x110c0000),
    SPH_C32(0x649c073b), SPH_C32(0x98557743), SPH_C32(0x0f57e2ed),
    SPH_C32(0xd79dfeba) },
  { SPH_C32(0xd6eaf000), SPH_C32(0x4f890000), SPH_C32(0x302c0000),
    SPH_C32(0x84b10000), SPH_C32(0x59ea73b3), SPH_C32(0x6b9cbe61),
    SPH_C32(0x9e3b5d01), SPH_C32(0x9d76a5b5), SPH_C32(0x061f6c00),
    SPH_C32(0x5b660000), SPH_C32(0x79ac0000), SPH_C32(0xea790000),
    SPH_C32(0x1751235e), SPH_C32(0x60f3d20a), SPH_C32(0x0d93e8d2),
    SPH_C32(0x0bb918a5) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0x52373000), SPH_C32(0xb18b0000), SPH_C32(0xbc7a0000),
    SPH_C32(0x4bbc0000), SPH_C32(0xa4f3442e), SPH_C32(0xf45616eb),
    SPH_C32(0x6623a94f), SPH_C32(0x5ea22f27), SPH_C32(0x4c4e8400),
    SPH_C32(0xa43c0000), SPH_C32(0xdbd10000), SPH_C32(0x835b0000),
    SPH_C32(0x178113a8), SPH_C32(0xea7bb99f), SPH_C32(0xd0ae8609),
    SPH_C32(0xee057339) },
  { SPH_C32(0x650a1800), SPH_C32(0xc0db0000), SPH_C32(0x299a0000),
    SPH_C32(0x41a80000), SPH_C32(0x195f5d27), SPH_C32(0xbcb98eda),
    SPH_C32(0x234ec450), SPH_C32(0x6308edfd), SPH_C32(0x5814b800),
    SPH_C32(0x1dd50000), SPH_C32(0xbaf60000), SPH_C32(0x723a0000),
    SPH_C32(0xd9e02ec4), SPH_C32(0x5a3284e7), SPH_C32(0x9707e129),
    SPH_C32(0x0f8b57fc) },
  { SPH_C32(0x71502400), SPH_C32(0x79320000), SPH_C32(0x48bd0000),
    SPH_C32(0xb0c90000), SPH_C32(0xd73e604b), SPH_C32(0x0cf0b3a2),
    SPH_C32(0x64e7a370), SPH_C32(0x8286c938), SPH_C32(0x7b73ac00),
    SPH_C32(0xd56c0000), SPH_C32(0x4e310000), SPH_C32(0x894f0000),
    SPH_C32(0xaa2d0aa1), SPH_C32(0xa29421ae), SPH_C32(0x95c3eb16),
    SPH_C32(0xd3afb1e3) },
  { SPH_C32(0x12455000), SPH_C32(0xe28f0000), SPH_C32(0x188b0000),
    SPH_C32(0x1b180000), SPH_C32(0xd9301e32), SPH_C32(0xd0baef72),
    SPH_C32(0x4a3a8ff2), SPH_C32(0xea373c60), SPH_C32(0xf3928800),
    SPH_C32(0xdc560000), SPH_C32(0xbd470000), SPH_C32(0x95bd0000),
    SPH_C32(0x3d767488), SPH_C32(0xf3c9c922), SPH_C32(0x916cbfec),
    SPH_C32(0x4aeb5b0f) },
  { SPH_C32(0x061f6c00), SPH_C32(0x5b660000), SPH_C32(0x79ac0000),
    SPH_C32(0xea790000), SPH_C32(0x1751235e), SPH_C32(0x60f3d20a),
    SPH_C32(0x0d93e8d2), SPH_C32(0x0bb918a5), SPH_C32(0xd0f59c00),
    SPH_C32(0x14ef0000), SPH_C32(0x49800000), SPH_C32(0x6ec80000),
    SPH_C32(0x4ebb50ed), SPH_C32(0x0b6f6c6b), SPH_C32(0x93a8b5d3),
    SPH_C32(0x96cfbd10) },
  { SPH_C32(0x31224400), SPH_C32(0x2a360000), SPH_C32(0xec4c0000),
    SPH_C32(0xe06d0000), SPH_C32(0xaafd3a57), SPH_C32(0x281c4a3b),
    SPH_C32(0x48fe85cd), SPH_C32(0x3613da7f), SPH_C32(0xc4afa000),
    SPH_C32(0xad060000), SPH_C32(0x28a70000), SPH_C32(0x9fa90000),
    SPH_C32(0x80da6d81), SPH_C32(0xbb265113), SPH_C32(0xd401d2f3),
    SPH_C32(0x774199d5) },
  { SPH_C32(0x25787800), SPH_C32(0x93df0000), SPH_C32(0x8d6b0000),
    SPH_C32(0x110c0000), SPH_C32(0x649c073b), SPH_C32(0x98557743),
    SPH_C32(0x0f57e2ed), SPH_C32(0xd79dfeba), SPH_C32(0xe7c8b400),
    SPH_C32(0x65bf0000), SPH_C32(0xdc600000), SPH_C32(0x64dc0000),
    SPH_C32(0xf31749e4), SPH_C32(0x4380f45a), SPH_C32(0xd6c5d8cc),
    SPH_C32(0xab657fca) },
  { SPH_C32(0xdad61400), SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000),
    SPH_C32(0x574e0000), SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67),
    SPH_C32(0x628cfdb5), SPH_C32(0xc7e6c5cb), SPH_C32(0xa7bad400),
    SPH_C32(0x36bb0000), SPH_C32(0x78910000), SPH_C32(0x34780000),
    SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3), SPH_C32(0xfadcfe71),
    SPH_C32(0x1ff06c8d) },
  { SPH_C32(0xce8c2800), SPH_C32(0x01580000), SPH_C32(0x2e2b0000),
    SPH_C32(0xa62f0000), SPH_C32(0xfdc9076b), SPH_C32(0x1542c31f),
    SPH_C32(0x25259a95), SPH_C32(0x2668e10e), SPH_C32(0x84ddc000),
    SPH_C32(0xfe020000), SPH_C32(0x8c560000), SPH_C32(0xcf0d0000),
    SPH_C32(0xfd19379d), SPH_C32(0x9fcaa88a), SPH_C32(0xf818f44e),
    SPH_C32(0xc3d48a92) },
  { SPH_C32(0xf9b10000), SPH_C32(0x70080000), SPH_C32(0xbbcb0000),
    SPH_C32(0xac3b0000), SPH_C32(0x40651e62), SPH_C32(0x5dad5b2e),
    SPH_C32(0x6048f78a), SPH_C32(0x1bc223d4), SPH_C32(0x9087fc00),
    SPH_C32(0x47eb0000), SPH_C32(0xed710000), SPH_C32(0x3e6c0000),
    SPH_C32(0x33780af1), SPH_C32(0x2f8395f2), SPH_C32(0xbfb1936e),
    SPH_C32(0x225aae57) },
  { SPH_C32(0xedeb3c00), SPH_C32(0xc9e10000), SPH_C32(0xdaec0000),
    SPH_C32(0x5d5a0000), SPH_C32(0x8e04230e), SPH_C32(0xede46656),
    SPH_C32(0x27e190aa), SPH_C32(0xfa4c0711), SPH_C32(0xb3e0e800),
    SPH_C32(0x8f520000), SPH_C32(0x19b60000), SPH_C32(0xc5190000),
    SPH_C32(0x40b52e94), SPH_C32(0xd72530bb), SPH_C32(0xbd759951),
    SPH_C32(0xfe7e4848) },
  { SPH_C32(0x8efe4800), SPH_C32(0x525c0000), SPH_C32(0x8ada0000),
    SPH_C32(0xf68b0000), SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86),
    SPH_C32(0x093cbc28), SPH_C32(0x92fdf249), SPH_C32(0x3b01cc00),
    SPH_C32(0x86680000), SPH_C32(0xeac00000), SPH_C32(0xd9eb0000),
    SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837), SPH_C32(0xb9dacdab),
    SPH_C32(0x673aa2a4) },
  { SPH_C32(0x9aa47400), SPH_C32(0xebb50000), SPH_C32(0xebfd0000),
    SPH_C32(0x07ea0000), SPH_C32(0x4e6b601b), SPH_C32(0x81e707fe),
    SPH_C32(0x4e95db08), SPH_C32(0x7373d68c), SPH_C32(0x1866d800),
    SPH_C32(0x4ed10000), SPH_C32(0x1e070000), SPH_C32(0x229e0000),
    SPH_C32(0xa42374d8), SPH_C32(0x7ede7d7e), SPH_C32(0xbb1ec794),
    SPH_C32(0xbb1e44bb) },
  { SPH_C32(0xad995c00), SPH_C32(0x9ae50000), SPH_C32(0x7e1d0000),
    SPH_C32(0x0dfe0000), SPH_C32(0xf3c77912), SPH_C32(0xc9089fcf),
    SPH_C32(0x0bf8b617), SPH_C32(0x4ed91456), SPH_C32(0x0c3ce400),
    SPH_C32(0xf7380000), SPH_C32(0x7f200000), SPH_C32(0xd3ff0000),
    SPH_C32(0x6a4249b4), SPH_C32(0xce974006), SPH_C32(0xfcb7a0b4),
    SPH_C32(0x5a90607e) },
  { SPH_C32(0xb9c36000), SPH_C32(0x230c0000), SPH_C32(0x1f3a0000),
    SPH_C32(0xfc9f0000), SPH_C32(0x3da6447e), SPH_C32(0x7941a2b7),
    SPH_C32(0x4c51d137), SPH_C32(0xaf573093), SPH_C32(0x2f5bf000),
    SPH_C32(0x3f810000), SPH_C32(0x8be70000), SPH_C32(0x288a0000),
    SPH_C32(0x198f6dd1), SPH_C32(0x3631e54f), SPH_C32(0xfe73aa8b),
    SPH_C32(0x86b48661) },
  { SPH_C32(0x6f299000), SPH_C32(0x6c850000), SPH_C32(0x2f160000),
    SPH_C32(0x782e0000), SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6),
    SPH_C32(0xd26a8c36), SPH_C32(0x32219526), SPH_C32(0x29449c00),
    SPH_C32(0x64e70000), SPH_C32(0xf24b0000), SPH_C32(0xc2f30000),
    SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745), SPH_C32(0xf3e04259),
    SPH_C32(0x8d0d9ec4) },
  { SPH_C32(0x7b73ac00), SPH_C32(0xd56c0000), SPH_C32(0x4e310000),
    SPH_C32(0x894f0000), SPH_C32(0xaa2d0aa1), SPH_C32(0xa29421ae),
    SPH_C32(0x95c3eb16), SPH_C32(0xd3afb1e3), SPH_C32(0x0a238800),
    SPH_C32(0xac5e0000), SPH_C32(0x068c0000), SPH_C32(0x39860000),
    SPH_C32(0x7d136aea), SPH_C32(0xae64920c), SPH_C32(0xf1244866),
    SPH_C32(0x512978db) },
  { SPH_C32(0x4c4e8400), SPH_C32(0xa43c0000), SPH_C32(0xdbd10000),
    SPH_C32(0x835b0000), SPH_C32(0x178113a8), SPH_C32(0xea7bb99f),
    SPH_C32(0xd0ae8609), SPH_C32(0xee057339), SPH_C32(0x1e79b400),
    SPH_C32(0x15b70000), SPH_C32(0x67ab0000), SPH_C32(0xc8e70000),
    SPH_C32(0xb3725786), SPH_C32(0x1e2daf74), SPH_C32(0xb68d2f46),
    SPH_C32(0xb0a75c1e) },
  { SPH_C32(0x5814b800), SPH_C32(0x1dd50000), SPH_C32(0xbaf60000),
    SPH_C32(0x723a0000), SPH_C32(0xd9e02ec4), SPH_C32(0x5a3284e7),
    SPH_C32(0x9707e129), SPH_C32(0x0f8b57fc), SPH_C32(0x3d1ea000),
    SPH_C32(0xdd0e0000), SPH_C32(0x936c0000), SPH_C32(0x33920000),
    SPH_C32(0xc0bf73e3), SPH_C32(0xe68b0a3d), SPH_C32(0xb4492579),
    SPH_C32(0x6c83ba01) },
  { SPH_C32(0x3b01cc00), SPH_C32(0x86680000), SPH_C32(0xeac00000),
    SPH_C32(0xd9eb0000), SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837),
    SPH_C32(0xb9dacdab), SPH_C32(0x673aa2a4), SPH_C32(0xb5ff8400),
    SPH_C32(0xd4340000), SPH_C32(0x601a0000), SPH_C32(0x2f600000),
    SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1), SPH_C32(0xb0e67183),
    SPH_C32(0xf5c750ed) },
  { SPH_C32(0x2f5bf000), SPH_C32(0x3f810000), SPH_C32(0x8be70000),
    SPH_C32(0x288a0000), SPH_C32(0x198f6dd1), SPH_C32(0x3631e54f),
    SPH_C32(0xfe73aa8b), SPH_C32(0x86b48661), SPH_C32(0x96989000),
    SPH_C32(0x1c8d0000), SPH_C32(0x94dd0000), SPH_C32(0xd4150000),
    SPH_C32(0x242929af), SPH_C32(0x4f7047f8), SPH_C32(0xb2227bbc),
    SPH_C32(0x29e3b6f2) },
  { SPH_C32(0x1866d800), SPH_C32(0x4ed10000), SPH_C32(0x1e070000),
    SPH_C32(0x229e0000), SPH_C32(0xa42374d8), SPH_C32(0x7ede7d7e),
    SPH_C32(0xbb1ec794), SPH_C32(0xbb1e44bb), SPH_C32(0x82c2ac00),
    SPH_C32(0xa5640000), SPH_C32(0xf5fa0000), SPH_C32(0x25740000),
    SPH_C32(0xea4814c3), SPH_C32(0xff397a80), SPH_C32(0xf58b1c9c),
    SPH_C32(0xc86d9237) },
  { SPH_C32(0x0c3ce400), SPH_C32(0xf7380000), SPH_C32(0x7f200000),
    SPH_C32(0xd3ff0000), SPH_C32(0x6a4249b4), SPH_C32(0xce974006),
    SPH_C32(0xfcb7a0b4), SPH_C32(0x5a90607e), SPH_C32(0xa1a5b800),
    SPH_C32(0x6ddd0000), SPH_C32(0x013d0000), SPH_C32(0xde010000),
    SPH_C32(0x998530a6), SPH_C32(0x079fdfc9), SPH_C32(0xf74f16a3),
    SPH_C32(0x14497428) },
  { SPH_C32(0xf3928800), SPH_C32(0xdc560000), SPH_C32(0xbd470000),
    SPH_C32(0x95bd0000), SPH_C32(0x3d767488), SPH_C32(0xf3c9c922),
    SPH_C32(0x916cbfec), SPH_C32(0x4aeb5b0f), SPH_C32(0xe1d7d800),
    SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000), SPH_C32(0x8ea50000),
    SPH_C32(0xe4466aba), SPH_C32(0x23732650), SPH_C32(0xdb56301e),
    SPH_C32(0xa0dc676f) },
  { SPH_C32(0xe7c8b400), SPH_C32(0x65bf0000), SPH_C32(0xdc600000),
    SPH_C32(0x64dc0000), SPH_C32(0xf31749e4), SPH_C32(0x4380f45a),
    SPH_C32(0xd6c5d8cc), SPH_C32(0xab657fca), SPH_C32(0xc2b0cc00),
    SPH_C32(0xf6600000), SPH_C32(0x510b0000), SPH_C32(0x75d00000),
    SPH_C32(0x978b4edf), SPH_C32(0xdbd58319), SPH_C32(0xd9923a21),
    SPH_C32(0x7cf88170) },
  { SPH_C32(0xd0f59c00), SPH_C32(0x14ef0000), SPH_C32(0x49800000),
    SPH_C32(0x6ec80000), SPH_C32(0x4ebb50ed), SPH_C32(0x0b6f6c6b),
    SPH_C32(0x93a8b5d3), SPH_C32(0x96cfbd10), SPH_C32(0xd6eaf000),
    SPH_C32(0x4f890000), SPH_C32(0x302c0000), SPH_C32(0x84b10000),
    SPH_C32(0x59ea73b3), SPH_C32(0x6b9cbe61), SPH_C32(0x9e3b5d01),
    SPH_C32(0x9d76a5b5) },
  { SPH_C32(0xc4afa000), SPH_C32(0xad060000), SPH_C32(0x28a70000),
    SPH_C32(0x9fa90000), SPH_C32(0x80da6d81), SPH_C32(0xbb265113),
    SPH_C32(0xd401d2f3), SPH_C32(0x774199d5), SPH_C32(0xf58de400),
    SPH_C32(0x87300000), SPH_C32(0xc4eb0000), SPH_C32(0x7fc40000),
    SPH_C32(0x2a2757d6), SPH_C32(0x933a1b28), SPH_C32(0x9cff573e),
    SPH_C32(0x415243aa) },
  { SPH_C32(0xa7bad400), SPH_C32(0x36bb0000), SPH_C32(0x78910000),
    SPH_C32(0x34780000), SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3),
    SPH_C32(0xfadcfe71), SPH_C32(0x1ff06c8d), SPH_C32(0x7d6cc000),
    SPH_C32(0x8e0a0000), SPH_C32(0x379d0000), SPH_C32(0x63360000),
    SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4), SPH_C32(0x985003c4),
    SPH_C32(0xd816a946) },
  { SPH_C32(0xb3e0e800), SPH_C32(0x8f520000), SPH_C32(0x19b60000),
    SPH_C32(0xc5190000), SPH_C32(0x40b52e94), SPH_C32(0xd72530bb),
    SPH_C32(0xbd759951), SPH_C32(0xfe7e4848), SPH_C32(0x5e0bd400),
    SPH_C32(0x46b30000), SPH_C32(0xc35a0000), SPH_C32(0x98430000),
    SPH_C32(0xceb10d9a), SPH_C32(0x3ac156ed), SPH_C32(0x9a9409fb),
    SPH_C32(0x04324f59) },
  { SPH_C32(0x84ddc000), SPH_C32(0xfe020000), SPH_C32(0x8c560000),
    SPH_C32(0xcf0d0000), SPH_C32(0xfd19379d), SPH_C32(0x9fcaa88a),
    SPH_C32(0xf818f44e), SPH_C32(0xc3d48a92), SPH_C32(0x4a51e800),
    SPH_C32(0xff5a0000), SPH_C32(0xa27d0000), SPH_C32(0x69220000),
    SPH_C32(0x00d030f6), SPH_C32(0x8a886b95), SPH_C32(0xdd3d6edb),
    SPH_C32(0xe5bc6b9c) },
  { SPH_C32(0x9087fc00), SPH_C32(0x47eb0000), SPH_C32(0xed710000),
    SPH_C32(0x3e6c0000), SPH_C32(0x33780af1), SPH_C32(0x2f8395f2),
    SPH_C32(0xbfb1936e), SPH_C32(0x225aae57), SPH_C32(0x6936fc00),
    SPH_C32(0x37e30000), SPH_C32(0x56ba0000), SPH_C32(0x92570000),
    SPH_C32(0x731d1493), SPH_C32(0x722ecedc), SPH_C32(0xdff964e4),
    SPH_C32(0x39988d83) }
};

__constant static const sph_u32 T512_6[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0x832800a0), SPH_C32(0x67420000), SPH_C32(0xe1170000),
    SPH_C32(0x370b0000), SPH_C32(0xcba30034), SPH_C32(0x3c34923c),
    SPH_C32(0x9767bdcc), SPH_C32(0x450360bf), SPH_C32(0x774400f0),
    SPH_C32(0xf15a0000), SPH_C32(0xf5b20000), SPH_C32(0x34140000),
    SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25), SPH_C32(0x0bc3cd1e),
    SPH_C32(0xcf3775cb) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0x9fc30180), SPH_C32(0x6c280000), SPH_C32(0xe7690000),
    SPH_C32(0xe0360000), SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966),
    SPH_C32(0x453b7806), SPH_C32(0xaebf667a), SPH_C32(0x405b0030),
    SPH_C32(0x9a540000), SPH_C32(0x42670000), SPH_C32(0x5fb10000),
    SPH_C32(0xd6c06187), SPH_C32(0x5d81863c), SPH_C32(0x87922fef),
    SPH_C32(0x79e0422c) },
  { SPH_C32(0x1ceb0120), SPH_C32(0x0b6a0000), SPH_C32(0x067e0000),
    SPH_C32(0xd73d0000), SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a),
    SPH_C32(0xd25cc5ca), SPH_C32(0xebbc06c5), SPH_C32(0x371f00c0),
    SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000), SPH_C32(0x6ba50000),
    SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19), SPH_C32(0x8c51e2f1),
    SPH_C32(0xb6d737e7) },
  { SPH_C32(0x6baf01d0), SPH_C32(0xfa300000), SPH_C32(0xf3cc0000),
    SPH_C32(0xe3290000), SPH_C32(0x392b6b13), SPH_C32(0x9515777f),
    SPH_C32(0xd99f08d4), SPH_C32(0x248b730e), SPH_C32(0xc3730090),
    SPH_C32(0xfd160000), SPH_C32(0xa3700000), SPH_C32(0x68ba0000),
    SPH_C32(0x1d6361b3), SPH_C32(0x61b51400), SPH_C32(0x10f59223),
    SPH_C32(0x3ce32293) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0xc3730090), SPH_C32(0xfd160000), SPH_C32(0xa3700000),
    SPH_C32(0x68ba0000), SPH_C32(0x1d6361b3), SPH_C32(0x61b51400),
    SPH_C32(0x10f59223), SPH_C32(0x3ce32293), SPH_C32(0xa8dc0140),
    SPH_C32(0x07260000), SPH_C32(0x50bc0000), SPH_C32(0x8b930000),
    SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f), SPH_C32(0xc96a9af7),
    SPH_C32(0x1868519d) },
  { SPH_C32(0x405b0030), SPH_C32(0x9a540000), SPH_C32(0x42670000),
    SPH_C32(0x5fb10000), SPH_C32(0xd6c06187), SPH_C32(0x5d81863c),
    SPH_C32(0x87922fef), SPH_C32(0x79e0422c), SPH_C32(0xdf9801b0),
    SPH_C32(0xf67c0000), SPH_C32(0xa50e0000), SPH_C32(0xbf870000),
    SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a), SPH_C32(0xc2a957e9),
    SPH_C32(0xd75f2456) },
  { SPH_C32(0x371f00c0), SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000),
    SPH_C32(0x6ba50000), SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19),
    SPH_C32(0x8c51e2f1), SPH_C32(0xb6d737e7), SPH_C32(0x2bf401e0),
    SPH_C32(0x60640000), SPH_C32(0xb1ab0000), SPH_C32(0xbc980000),
    SPH_C32(0xefeb0a94), SPH_C32(0xc894f143), SPH_C32(0x5e0d273b),
    SPH_C32(0x5d6b3122) },
  { SPH_C32(0x5cb00110), SPH_C32(0x913e0000), SPH_C32(0x44190000),
    SPH_C32(0x888c0000), SPH_C32(0x66dc7418), SPH_C32(0x921f1d66),
    SPH_C32(0x55ceea25), SPH_C32(0x925c44e9), SPH_C32(0xe8870170),
    SPH_C32(0x9d720000), SPH_C32(0x12db0000), SPH_C32(0xd4220000),
    SPH_C32(0xf2886b27), SPH_C32(0xa921e543), SPH_C32(0x4ef8b518),
    SPH_C32(0x618813b1) },
  { SPH_C32(0x2bf401e0), SPH_C32(0x60640000), SPH_C32(0xb1ab0000),
    SPH_C32(0xbc980000), SPH_C32(0xefeb0a94), SPH_C32(0xc894f143),
    SPH_C32(0x5e0d273b), SPH_C32(0x5d6b3122), SPH_C32(0x1ceb0120),
    SPH_C32(0x0b6a0000), SPH_C32(0x067e0000), SPH_C32(0xd73d0000),
    SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a), SPH_C32(0xd25cc5ca),
    SPH_C32(0xebbc06c5) },
  { SPH_C32(0xa8dc0140), SPH_C32(0x07260000), SPH_C32(0x50bc0000),
    SPH_C32(0x8b930000), SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f),
    SPH_C32(0xc96a9af7), SPH_C32(0x1868519d), SPH_C32(0x6baf01d0),
    SPH_C32(0xfa300000), SPH_C32(0xf3cc0000), SPH_C32(0xe3290000),
    SPH_C32(0x392b6b13), SPH_C32(0x9515777f), SPH_C32(0xd99f08d4),
    SPH_C32(0x248b730e) },
  { SPH_C32(0xdf9801b0), SPH_C32(0xf67c0000), SPH_C32(0xa50e0000),
    SPH_C32(0xbf870000), SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a),
    SPH_C32(0xc2a957e9), SPH_C32(0xd75f2456), SPH_C32(0x9fc30180),
    SPH_C32(0x6c280000), SPH_C32(0xe7690000), SPH_C32(0xe0360000),
    SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966), SPH_C32(0x453b7806),
    SPH_C32(0xaebf667a) },
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0x984f0280), SPH_C32(0xcba70000), SPH_C32(0xa81c0000),
    SPH_C32(0x5d5d0000), SPH_C32(0x1238428a), SPH_C32(0x1e8e59dc),
    SPH_C32(0x6dd7c74f), SPH_C32(0x5d7828c1), SPH_C32(0x3d070060),
    SPH_C32(0x713d0000), SPH_C32(0x3b210000), SPH_C32(0x25500000),
    SPH_C32(0x4afd2541), SPH_C32(0x0b438f2e), SPH_C32(0xcc3b1956),
    SPH_C32(0x145dba1c) },
  { SPH_C32(0x1b670220), SPH_C32(0xace50000), SPH_C32(0x490b0000),
    SPH_C32(0x6a560000), SPH_C32(0xd99b42be), SPH_C32(0x22bacbe0),
    SPH_C32(0xfab07a83), SPH_C32(0x187b487e), SPH_C32(0x4a430090),
    SPH_C32(0x80670000), SPH_C32(0xce930000), SPH_C32(0x11440000),
    SPH_C32(0xc3ca5bcd), SPH_C32(0x51c8630b), SPH_C32(0xc7f8d448),
    SPH_C32(0xdb6acfd7) },
  { SPH_C32(0x6c2302d0), SPH_C32(0x5dbf0000), SPH_C32(0xbcb90000),
    SPH_C32(0x5e420000), SPH_C32(0x50ac3c32), SPH_C32(0x783127c5),
    SPH_C32(0xf173b79d), SPH_C32(0xd74c3db5), SPH_C32(0xbe2f00c0),
    SPH_C32(0x167f0000), SPH_C32(0xda360000), SPH_C32(0x125b0000),
    SPH_C32(0x815e2575), SPH_C32(0x37771d12), SPH_C32(0x5b5ca49a),
    SPH_C32(0x515edaa3) },
  { SPH_C32(0x078c0300), SPH_C32(0xa78f0000), SPH_C32(0x4f750000),
    SPH_C32(0xbd6b0000), SPH_C32(0x69875721), SPH_C32(0xed2450ba),
    SPH_C32(0x28ecbf49), SPH_C32(0xf3c74ebb), SPH_C32(0x7d5c0050),
    SPH_C32(0xeb690000), SPH_C32(0x79460000), SPH_C32(0x7ae10000),
    SPH_C32(0x9c3d44c6), SPH_C32(0x56c20912), SPH_C32(0x4ba936b9),
    SPH_C32(0x6dbdf830) },
  { SPH_C32(0x70c803f0), SPH_C32(0x56d50000), SPH_C32(0xbac70000),
    SPH_C32(0x897f0000), SPH_C32(0xe0b029ad), SPH_C32(0xb7afbc9f),
    SPH_C32(0x232f7257), SPH_C32(0x3cf03b70), SPH_C32(0x89300000),
    SPH_C32(0x7d710000), SPH_C32(0x6de30000), SPH_C32(0x79fe0000),
    SPH_C32(0xdea93a7e), SPH_C32(0x307d770b), SPH_C32(0xd70d466b),
    SPH_C32(0xe789ed44) },
  { SPH_C32(0xf3e00350), SPH_C32(0x31970000), SPH_C32(0x5bd00000),
    SPH_C32(0xbe740000), SPH_C32(0x2b132999), SPH_C32(0x8b9b2ea3),
    SPH_C32(0xb448cf9b), SPH_C32(0x79f35bcf), SPH_C32(0xfe7400f0),
    SPH_C32(0x8c2b0000), SPH_C32(0x98510000), SPH_C32(0x4dea0000),
    SPH_C32(0x579e44f2), SPH_C32(0x6af69b2e), SPH_C32(0xdcce8b75),
    SPH_C32(0x28be988f) },
  { SPH_C32(0x84a403a0), SPH_C32(0xc0cd0000), SPH_C32(0xae620000),
    SPH_C32(0x8a600000), SPH_C32(0xa2245715), SPH_C32(0xd110c286),
    SPH_C32(0xbf8b0285), SPH_C32(0xb6c42e04), SPH_C32(0x0a1800a0),
    SPH_C32(0x1a330000), SPH_C32(0x8cf40000), SPH_C32(0x4ef50000),
    SPH_C32(0x150a3a4a), SPH_C32(0x0c49e537), SPH_C32(0x406afba7),
    SPH_C32(0xa28a8dfb) },
  { SPH_C32(0x5b3c0210), SPH_C32(0x36b10000), SPH_C32(0x0b6c0000),
    SPH_C32(0x35e70000), SPH_C32(0x0f5b2339), SPH_C32(0x7f3b4ddc),
    SPH_C32(0x7d22556c), SPH_C32(0x619b0a52), SPH_C32(0x95db0120),
    SPH_C32(0x761b0000), SPH_C32(0x6b9d0000), SPH_C32(0xaec30000),
    SPH_C32(0x6eb52fe1), SPH_C32(0xffe3ec51), SPH_C32(0x055183a1),
    SPH_C32(0x0c35eb81) },
  { SPH_C32(0x2c7802e0), SPH_C32(0xc7eb0000), SPH_C32(0xfede0000),
    SPH_C32(0x01f30000), SPH_C32(0x866c5db5), SPH_C32(0x25b0a1f9),
    SPH_C32(0x76e19872), SPH_C32(0xaeac7f99), SPH_C32(0x61b70170),
    SPH_C32(0xe0030000), SPH_C32(0x7f380000), SPH_C32(0xaddc0000),
    SPH_C32(0x2c215159), SPH_C32(0x995c9248), SPH_C32(0x99f5f373),
    SPH_C32(0x8601fef5) },
  { SPH_C32(0xaf500240), SPH_C32(0xa0a90000), SPH_C32(0x1fc90000),
    SPH_C32(0x36f80000), SPH_C32(0x4dcf5d81), SPH_C32(0x198433c5),
    SPH_C32(0xe18625be), SPH_C32(0xebaf1f26), SPH_C32(0x16f30180),
    SPH_C32(0x11590000), SPH_C32(0x8a8a0000), SPH_C32(0x99c80000),
    SPH_C32(0xa5162fd5), SPH_C32(0xc3d77e6d), SPH_C32(0x92363e6d),
    SPH_C32(0x49368b3e) },
  { SPH_C32(0xd81402b0), SPH_C32(0x51f30000), SPH_C32(0xea7b0000),
    SPH_C32(0x02ec0000), SPH_C32(0xc4f8230d), SPH_C32(0x430fdfe0),
    SPH_C32(0xea45e8a0), SPH_C32(0x24986aed), SPH_C32(0xe29f01d0),
    SPH_C32(0x87410000), SPH_C32(0x9e2f0000), SPH_C32(0x9ad70000),
    SPH_C32(0xe782516d), SPH_C32(0xa5680074), SPH_C32(0x0e924ebf),
    SPH_C32(0xc3029e4a) },
  { SPH_C32(0xb3bb0360), SPH_C32(0xabc30000), SPH_C32(0x19b70000),
    SPH_C32(0xe1c50000), SPH_C32(0xfdd3481e), SPH_C32(0xd61aa89f),
    SPH_C32(0x33dae074), SPH_C32(0x001319e3), SPH_C32(0x21ec0140),
    SPH_C32(0x7a570000), SPH_C32(0x3d5f0000), SPH_C32(0xf26d0000),
    SPH_C32(0xfae130de), SPH_C32(0xc4dd1474), SPH_C32(0x1e67dc9c),
    SPH_C32(0xffe1bcd9) },
  { SPH_C32(0xc4ff0390), SPH_C32(0x5a990000), SPH_C32(0xec050000),
    SPH_C32(0xd5d10000), SPH_C32(0x74e43692), SPH_C32(0x8c9144ba),
    SPH_C32(0x38192d6a), SPH_C32(0xcf246c28), SPH_C32(0xd5800110),
    SPH_C32(0xec4f0000), SPH_C32(0x29fa0000), SPH_C32(0xf1720000),
    SPH_C32(0xb8754e66), SPH_C32(0xa2626a6d), SPH_C32(0x82c3ac4e),
    SPH_C32(0x75d5a9ad) },
  { SPH_C32(0x47d70330), SPH_C32(0x3ddb0000), SPH_C32(0x0d120000),
    SPH_C32(0xe2da0000), SPH_C32(0xbf4736a6), SPH_C32(0xb0a5d686),
    SPH_C32(0xaf7e90a6), SPH_C32(0x8a270c97), SPH_C32(0xa2c401e0),
    SPH_C32(0x1d150000), SPH_C32(0xdc480000), SPH_C32(0xc5660000),
    SPH_C32(0x314230ea), SPH_C32(0xf8e98648), SPH_C32(0x89006150),
    SPH_C32(0xbae2dc66) },
  { SPH_C32(0x309303c0), SPH_C32(0xcc810000), SPH_C32(0xf8a00000),
    SPH_C32(0xd6ce0000), SPH_C32(0x3670482a), SPH_C32(0xea2e3aa3),
    SPH_C32(0xa4bd5db8), SPH_C32(0x4510795c), SPH_C32(0x56a801b0),
    SPH_C32(0x8b0d0000), SPH_C32(0xc8ed0000), SPH_C32(0xc6790000),
    SPH_C32(0x73d64e52), SPH_C32(0x9e56f851), SPH_C32(0x15a41182),
    SPH_C32(0x30d6c912) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0xbe2f00c0), SPH_C32(0x167f0000), SPH_C32(0xda360000),
    SPH_C32(0x125b0000), SPH_C32(0x815e2575), SPH_C32(0x37771d12),
    SPH_C32(0x5b5ca49a), SPH_C32(0x515edaa3), SPH_C32(0xd20c0210),
    SPH_C32(0x4bc00000), SPH_C32(0x668f0000), SPH_C32(0x4c190000),
    SPH_C32(0xd1f21947), SPH_C32(0x4f463ad7), SPH_C32(0xaa2f1307),
    SPH_C32(0x8612e716) },
  { SPH_C32(0x3d070060), SPH_C32(0x713d0000), SPH_C32(0x3b210000),
    SPH_C32(0x25500000), SPH_C32(0x4afd2541), SPH_C32(0x0b438f2e),
    SPH_C32(0xcc3b1956), SPH_C32(0x145dba1c), SPH_C32(0xa54802e0),
    SPH_C32(0xba9a0000), SPH_C32(0x933d0000), SPH_C32(0x780d0000),
    SPH_C32(0x58c567cb), SPH_C32(0x15cdd6f2), SPH_C32(0xa1ecde19),
    SPH_C32(0x492592dd) },
  { SPH_C32(0x4a430090), SPH_C32(0x80670000), SPH_C32(0xce930000),
    SPH_C32(0x11440000), SPH_C32(0xc3ca5bcd), SPH_C32(0x51c8630b),
    SPH_C32(0xc7f8d448), SPH_C32(0xdb6acfd7), SPH_C32(0x512402b0),
    SPH_C32(0x2c820000), SPH_C32(0x87980000), SPH_C32(0x7b120000),
    SPH_C32(0x1a511973), SPH_C32(0x7372a8eb), SPH_C32(0x3d48aecb),
    SPH_C32(0xc31187a9) },
  { SPH_C32(0x21ec0140), SPH_C32(0x7a570000), SPH_C32(0x3d5f0000),
    SPH_C32(0xf26d0000), SPH_C32(0xfae130de), SPH_C32(0xc4dd1474),
    SPH_C32(0x1e67dc9c), SPH_C32(0xffe1bcd9), SPH_C32(0x92570220),
    SPH_C32(0xd1940000), SPH_C32(0x24e80000), SPH_C32(0x13a80000),
    SPH_C32(0x073278c0), SPH_C32(0x12c7bceb), SPH_C32(0x2dbd3ce8),
    SPH_C32(0xfff2a53a) },
  { SPH_C32(0x56a801b0), SPH_C32(0x8b0d0000), SPH_C32(0xc8ed0000),
    SPH_C32(0xc6790000), SPH_C32(0x73d64e52), SPH_C32(0x9e56f851),
    SPH_C32(0x15a41182), SPH_C32(0x30d6c912), SPH_C32(0x663b0270),
    SPH_C32(0x478c0000), SPH_C32(0x304d0000), SPH_C32(0x10b70000),
    SPH_C32(0x45a60678), SPH_C32(0x7478c2f2), SPH_C32(0xb1194c3a),
    SPH_C32(0x75c6b04e) },
  { SPH_C32(0xd5800110), SPH_C32(0xec4f0000), SPH_C32(0x29fa0000),
    SPH_C32(0xf1720000), SPH_C32(0xb8754e66), SPH_C32(0xa2626a6d),
    SPH_C32(0x82c3ac4e), SPH_C32(0x75d5a9ad), SPH_C32(0x117f0280),
    SPH_C32(0xb6d60000), SPH_C32(0xc5ff0000), SPH_C32(0x24a30000),
    SPH_C32(0xcc9178f4), SPH_C32(0x2ef32ed7), SPH_C32(0xbada8124),
    SPH_C32(0xbaf1c585) },
  { SPH_C32(0xa2c401e0), SPH_C32(0x1d150000), SPH_C32(0xdc480000),
    SPH_C32(0xc5660000), SPH_C32(0x314230ea), SPH_C32(0xf8e98648),
    SPH_C32(0x89006150), SPH_C32(0xbae2dc66), SPH_C32(0xe51302d0),
    SPH_C32(0x20ce0000), SPH_C32(0xd15a0000), SPH_C32(0x27bc0000),
    SPH_C32(0x8e05064c), SPH_C32(0x484c50ce), SPH_C32(0x267ef1f6),
    SPH_C32(0x30c5d0f1) },
  { SPH_C32(0x7d5c0050), SPH_C32(0xeb690000), SPH_C32(0x79460000),
    SPH_C32(0x7ae10000), SPH_C32(0x9c3d44c6), SPH_C32(0x56c20912),
    SPH_C32(0x4ba936b9), SPH_C32(0x6dbdf830), SPH_C32(0x7ad00350),
    SPH_C32(0x4ce60000), SPH_C32(0x36330000), SPH_C32(0xc78a0000),
    SPH_C32(0xf5ba13e7), SPH_C32(0xbbe659a8), SPH_C32(0x634589f0),
    SPH_C32(0x9e7ab68b) },
  { SPH_C32(0x0a1800a0), SPH_C32(0x1a330000), SPH_C32(0x8cf40000),
    SPH_C32(0x4ef50000), SPH_C32(0x150a3a4a), SPH_C32(0x0c49e537),
    SPH_C32(0x406afba7), SPH_C32(0xa28a8dfb), SPH_C32(0x8ebc0300),
    SPH_C32(0xdafe0000), SPH_C32(0x22960000), SPH_C32(0xc4950000),
    SPH_C32(0xb72e6d5f), SPH_C32(0xdd5927b1), SPH_C32(0xffe1f922),
    SPH_C32(0x144ea3ff) },
  { SPH_C32(0x89300000), SPH_C32(0x7d710000), SPH_C32(0x6de30000),
    SPH_C32(0x79fe0000), SPH_C32(0xdea93a7e), SPH_C32(0x307d770b),
    SPH_C32(0xd70d466b), SPH_C32(0xe789ed44), SPH_C32(0xf9f803f0),
    SPH_C32(0x2ba40000), SPH_C32(0xd7240000), SPH_C32(0xf0810000),
    SPH_C32(0x3e1913d3), SPH_C32(0x87d2cb94), SPH_C32(0xf422343c),
    SPH_C32(0xdb79d634) },
  { SPH_C32(0xfe7400f0), SPH_C32(0x8c2b0000), SPH_C32(0x98510000),
    SPH_C32(0x4dea0000), SPH_C32(0x579e44f2), SPH_C32(0x6af69b2e),
    SPH_C32(0xdcce8b75), SPH_C32(0x28be988f), SPH_C32(0x0d9403a0),
    SPH_C32(0xbdbc0000), SPH_C32(0xc3810000), SPH_C32(0xf39e0000),
    SPH_C32(0x7c8d6d6b), SPH_C32(0xe16db58d), SPH_C32(0x688644ee),
    SPH_C32(0x514dc340) },
  { SPH_C32(0x95db0120), SPH_C32(0x761b0000), SPH_C32(0x6b9d0000),
    SPH_C32(0xaec30000), SPH_C32(0x6eb52fe1), SPH_C32(0xffe3ec51),
    SPH_C32(0x055183a1), SPH_C32(0x0c35eb81), SPH_C32(0xcee70330),
    SPH_C32(0x40aa0000), SPH_C32(0x60f10000), SPH_C32(0x9b240000),
    SPH_C32(0x61ee0cd8), SPH_C32(0x80d8a18d), SPH_C32(0x7873d6cd),
    SPH_C32(0x6daee1d3) },
  { SPH_C32(0xe29f01d0), SPH_C32(0x87410000), SPH_C32(0x9e2f0000),
    SPH_C32(0x9ad70000), SPH_C32(0xe782516d), SPH_C32(0xa5680074),
    SPH_C32(0x0e924ebf), SPH_C32(0xc3029e4a), SPH_C32(0x3a8b0360),
    SPH_C32(0xd6b20000), SPH_C32(0x74540000), SPH_C32(0x983b0000),
    SPH_C32(0x237a7260), SPH_C32(0xe667df94), SPH_C32(0xe4d7a61f),
    SPH_C32(0xe79af4a7) },
  { SPH_C32(0x61b70170), SPH_C32(0xe0030000), SPH_C32(0x7f380000),
    SPH_C32(0xaddc0000), SPH_C32(0x2c215159), SPH_C32(0x995c9248),
    SPH_C32(0x99f5f373), SPH_C32(0x8601fef5), SPH_C32(0x4dcf0390),
    SPH_C32(0x27e80000), SPH_C32(0x81e60000), SPH_C32(0xac2f0000),
    SPH_C32(0xaa4d0cec), SPH_C32(0xbcec33b1), SPH_C32(0xef146b01),
    SPH_C32(0x28ad816c) },
  { SPH_C32(0x16f30180), SPH_C32(0x11590000), SPH_C32(0x8a8a0000),
    SPH_C32(0x99c80000), SPH_C32(0xa5162fd5), SPH_C32(0xc3d77e6d),
    SPH_C32(0x92363e6d), SPH_C32(0x49368b3e), SPH_C32(0xb9a303c0),
    SPH_C32(0xb1f00000), SPH_C32(0x95430000), SPH_C32(0xaf300000),
    SPH_C32(0xe8d97254), SPH_C32(0xda534da8), SPH_C32(0x73b01bd3),
    SPH_C32(0xa2999418) },
  { SPH_C32(0x26600240), SPH_C32(0xddd80000), SPH_C32(0x722a0000),
    SPH_C32(0x4f060000), SPH_C32(0x936667ff), SPH_C32(0x29f944ce),
    SPH_C32(0x368b63d5), SPH_C32(0x0c26f262), SPH_C32(0xef0b0270),
    SPH_C32(0x3afd0000), SPH_C32(0x5dae0000), SPH_C32(0x69490000),
    SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9), SPH_C32(0x66140a51),
    SPH_C32(0x924f5d0a) },
  { SPH_C32(0x512402b0), SPH_C32(0x2c820000), SPH_C32(0x87980000),
    SPH_C32(0x7b120000), SPH_C32(0x1a511973), SPH_C32(0x7372a8eb),
    SPH_C32(0x3d48aecb), SPH_C32(0xc31187a9), SPH_C32(0x1b670220),
    SPH_C32(0xace50000), SPH_C32(0x490b0000), SPH_C32(0x6a560000),
    SPH_C32(0xd99b42be), SPH_C32(0x22bacbe0), SPH_C32(0xfab07a83),
    SPH_C32(0x187b487e) },
  { SPH_C32(0xd20c0210), SPH_C32(0x4bc00000), SPH_C32(0x668f0000),
    SPH_C32(0x4c190000), SPH_C32(0xd1f21947), SPH_C32(0x4f463ad7),
    SPH_C32(0xaa2f1307), SPH_C32(0x8612e716), SPH_C32(0x6c2302d0),
    SPH_C32(0x5dbf0000), SPH_C32(0xbcb90000), SPH_C32(0x5e420000),
    SPH_C32(0x50ac3c32), SPH_C32(0x783127c5), SPH_C32(0xf173b79d),
    SPH_C32(0xd74c3db5) },
  { SPH_C32(0xa54802e0), SPH_C32(0xba9a0000), SPH_C32(0x933d0000),
    SPH_C32(0x780d0000), SPH_C32(0x58c567cb), SPH_C32(0x15cdd6f2),
    SPH_C32(0xa1ecde19), SPH_C32(0x492592dd), SPH_C32(0x984f0280),
    SPH_C32(0xcba70000), SPH_C32(0xa81c0000), SPH_C32(0x5d5d0000),
    SPH_C32(0x1238428a), SPH_C32(0x1e8e59dc), SPH_C32(0x6dd7c74f),
    SPH_C32(0x5d7828c1) },
  { SPH_C32(0xcee70330), SPH_C32(0x40aa0000), SPH_C32(0x60f10000),
    SPH_C32(0x9b240000), SPH_C32(0x61ee0cd8), SPH_C32(0x80d8a18d),
    SPH_C32(0x7873d6cd), SPH_C32(0x6daee1d3), SPH_C32(0x5b3c0210),
    SPH_C32(0x36b10000), SPH_C32(0x0b6c0000), SPH_C32(0x35e70000),
    SPH_C32(0x0f5b2339), SPH_C32(0x7f3b4ddc), SPH_C32(0x7d22556c),
    SPH_C32(0x619b0a52) },
  { SPH_C32(0xb9a303c0), SPH_C32(0xb1f00000), SPH_C32(0x95430000),
    SPH_C32(0xaf300000), SPH_C32(0xe8d97254), SPH_C32(0xda534da8),
    SPH_C32(0x73b01bd3), SPH_C32(0xa2999418), SPH_C32(0xaf500240),
    SPH_C32(0xa0a90000), SPH_C32(0x1fc90000), SPH_C32(0x36f80000),
    SPH_C32(0x4dcf5d81), SPH_C32(0x198433c5), SPH_C32(0xe18625be),
    SPH_C32(0xebaf1f26) },
  { SPH_C32(0x3a8b0360), SPH_C32(0xd6b20000), SPH_C32(0x74540000),
    SPH_C32(0x983b0000), SPH_C32(0x237a7260), SPH_C32(0xe667df94),
    SPH_C32(0xe4d7a61f), SPH_C32(0xe79af4a7), SPH_C32(0xd81402b0),
    SPH_C32(0x51f30000), SPH_C32(0xea7b0000), SPH_C32(0x02ec0000),
    SPH_C32(0xc4f8230d), SPH_C32(0x430fdfe0), SPH_C32(0xea45e8a0),
    SPH_C32(0x24986aed) },
  { SPH_C32(0x4dcf0390), SPH_C32(0x27e80000), SPH_C32(0x81e60000),
    SPH_C32(0xac2f0000), SPH_C32(0xaa4d0cec), SPH_C32(0xbcec33b1),
    SPH_C32(0xef146b01), SPH_C32(0x28ad816c), SPH_C32(0x2c7802e0),
    SPH_C32(0xc7eb0000), SPH_C32(0xfede0000), SPH_C32(0x01f30000),
    SPH_C32(0x866c5db5), SPH_C32(0x25b0a1f9), SPH_C32(0x76e19872),
    SPH_C32(0xaeac7f99) },
  { SPH_C32(0x92570220), SPH_C32(0xd1940000), SPH_C32(0x24e80000),
    SPH_C32(0x13a80000), SPH_C32(0x073278c0), SPH_C32(0x12c7bceb),
    SPH_C32(0x2dbd3ce8), SPH_C32(0xfff2a53a), SPH_C32(0xb3bb0360),
    SPH_C32(0xabc30000), SPH_C32(0x19b70000), SPH_C32(0xe1c50000),
    SPH_C32(0xfdd3481e), SPH_C32(0xd61aa89f), SPH_C32(0x33dae074),
    SPH_C32(0x001319e3) },
  { SPH_C32(0xe51302d0), SPH_C32(0x20ce0000), SPH_C32(0xd15a0000),
    SPH_C32(0x27bc0000), SPH_C32(0x8e05064c), SPH_C32(0x484c50ce),
    SPH_C32(0x267ef1f6), SPH_C32(0x30c5d0f1), SPH_C32(0x47d70330),
    SPH_C32(0x3ddb0000), SPH_C32(0x0d120000), SPH_C32(0xe2da0000),
    SPH_C32(0xbf4736a6), SPH_C32(0xb0a5d686), SPH_C32(0xaf7e90a6),
    SPH_C32(0x8a270c97) },
  { SPH_C32(0x663b0270), SPH_C32(0x478c0000), SPH_C32(0x304d0000),
    SPH_C32(0x10b70000), SPH_C32(0x45a60678), SPH_C32(0x7478c2f2),
    SPH_C32(0xb1194c3a), SPH_C32(0x75c6b04e), SPH_C32(0x309303c0),
    SPH_C32(0xcc810000), SPH_C32(0xf8a00000), SPH_C32(0xd6ce0000),
    SPH_C32(0x3670482a), SPH_C32(0xea2e3aa3), SPH_C32(0xa4bd5db8),
    SPH_C32(0x4510795c) },
  { SPH_C32(0x117f0280), SPH_C32(0xb6d60000), SPH_C32(0xc5ff0000),
    SPH_C32(0x24a30000), SPH_C32(0xcc9178f4), SPH_C32(0x2ef32ed7),
    SPH_C32(0xbada8124), SPH_C32(0xbaf1c585), SPH_C32(0xc4ff0390),
    SPH_C32(0x5a990000), SPH_C32(0xec050000), SPH_C32(0xd5d10000),
    SPH_C32(0x74e43692), SPH_C32(0x8c9144ba), SPH_C32(0x38192d6a),
    SPH_C32(0xcf246c28) },
  { SPH_C32(0x7ad00350), SPH_C32(0x4ce60000), SPH_C32(0x36330000),
    SPH_C32(0xc78a0000), SPH_C32(0xf5ba13e7), SPH_C32(0xbbe659a8),
    SPH_C32(0x634589f0), SPH_C32(0x9e7ab68b), SPH_C32(0x078c0300),
    SPH_C32(0xa78f0000), SPH_C32(0x4f750000), SPH_C32(0xbd6b0000),
    SPH_C32(0x69875721), SPH_C32(0xed2450ba), SPH_C32(0x28ecbf49),
    SPH_C32(0xf3c74ebb) },
  { SPH_C32(0x0d9403a0), SPH_C32(0xbdbc0000), SPH_C32(0xc3810000),
    SPH_C32(0xf39e0000), SPH_C32(0x7c8d6d6b), SPH_C32(0xe16db58d),
    SPH_C32(0x688644ee), SPH_C32(0x514dc340), SPH_C32(0xf3e00350),
    SPH_C32(0x31970000), SPH_C32(0x5bd00000), SPH_C32(0xbe740000),
    SPH_C32(0x2b132999), SPH_C32(0x8b9b2ea3), SPH_C32(0xb448cf9b),
    SPH_C32(0x79f35bcf) },
  { SPH_C32(0x8ebc0300), SPH_C32(0xdafe0000), SPH_C32(0x22960000),
    SPH_C32(0xc4950000), SPH_C32(0xb72e6d5f), SPH_C32(0xdd5927b1),
    SPH_C32(0xffe1f922), SPH_C32(0x144ea3ff), SPH_C32(0x84a403a0),
    SPH_C32(0xc0cd0000), SPH_C32(0xae620000), SPH_C32(0x8a600000),
    SPH_C32(0xa2245715), SPH_C32(0xd110c286), SPH_C32(0xbf8b0285),
    SPH_C32(0xb6c42e04) },
  { SPH_C32(0xf9f803f0), SPH_C32(0x2ba40000), SPH_C32(0xd7240000),
    SPH_C32(0xf0810000), SPH_C32(0x3e1913d3), SPH_C32(0x87d2cb94),
    SPH_C32(0xf422343c), SPH_C32(0xdb79d634), SPH_C32(0x70c803f0),
    SPH_C32(0x56d50000), SPH_C32(0xbac70000), SPH_C32(0x897f0000),
    SPH_C32(0xe0b029ad), SPH_C32(0xb7afbc9f), SPH_C32(0x232f7257),
    SPH_C32(0x3cf03b70) }
};

__constant static const sph_u32 T512_12[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0x9b060002), SPH_C32(0x61468000), SPH_C32(0x221e0000),
    SPH_C32(0x1d740000), SPH_C32(0x36715d27), SPH_C32(0x30495c92),
    SPH_C32(0xf11336a7), SPH_C32(0xfe1cdc7f), SPH_C32(0x75c90003),
    SPH_C32(0x0e10c000), SPH_C32(0xd1200000), SPH_C32(0xbaea0000),
    SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757), SPH_C32(0xbb28761d),
    SPH_C32(0x00b72e2b) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0x83490006), SPH_C32(0x3a530000), SPH_C32(0xf5270000),
    SPH_C32(0x35d70000), SPH_C32(0xaaf314c5), SPH_C32(0x8de062f9),
    SPH_C32(0x76edfd04), SPH_C32(0xd722941a), SPH_C32(0x48b00000),
    SPH_C32(0x1e61c000), SPH_C32(0xeac20000), SPH_C32(0x31450000),
    SPH_C32(0x873e1fe4), SPH_C32(0x5cdb4536), SPH_C32(0x66560735),
    SPH_C32(0x52259edc) },
  { SPH_C32(0x184f0004), SPH_C32(0x5b158000), SPH_C32(0xd7390000),
    SPH_C32(0x28a30000), SPH_C32(0x9c8249e2), SPH_C32(0xbda93e6b),
    SPH_C32(0x87fecba3), SPH_C32(0x293e4865), SPH_C32(0x3d790003),
    SPH_C32(0x10710000), SPH_C32(0x3be20000), SPH_C32(0x8baf0000),
    SPH_C32(0x0cfa30da), SPH_C32(0xdb83f261), SPH_C32(0xdd7e7128),
    SPH_C32(0x5292b0f7) },
  { SPH_C32(0x6d860007), SPH_C32(0x55054000), SPH_C32(0x06190000),
    SPH_C32(0x92490000), SPH_C32(0x174666dc), SPH_C32(0x3af1893c),
    SPH_C32(0x3cd6bdbe), SPH_C32(0x2989664e), SPH_C32(0xd3b60002),
    SPH_C32(0x7f274000), SPH_C32(0xc8dc0000), SPH_C32(0x2c310000),
    SPH_C32(0xb14f42c3), SPH_C32(0x6c9219a4), SPH_C32(0x97453192),
    SPH_C32(0xac3942a3) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0xd3b60002), SPH_C32(0x7f274000), SPH_C32(0xc8dc0000),
    SPH_C32(0x2c310000), SPH_C32(0xb14f42c3), SPH_C32(0x6c9219a4),
    SPH_C32(0x97453192), SPH_C32(0xac3942a3), SPH_C32(0xbe300005),
    SPH_C32(0x2a220000), SPH_C32(0xcec50000), SPH_C32(0xbe780000),
    SPH_C32(0xa609241f), SPH_C32(0x56639098), SPH_C32(0xab938c2c),
    SPH_C32(0x85b024ed) },
  { SPH_C32(0x48b00000), SPH_C32(0x1e61c000), SPH_C32(0xeac20000),
    SPH_C32(0x31450000), SPH_C32(0x873e1fe4), SPH_C32(0x5cdb4536),
    SPH_C32(0x66560735), SPH_C32(0x52259edc), SPH_C32(0xcbf90006),
    SPH_C32(0x2432c000), SPH_C32(0x1fe50000), SPH_C32(0x04920000),
    SPH_C32(0x2dcd0b21), SPH_C32(0xd13b27cf), SPH_C32(0x10bbfa31),
    SPH_C32(0x85070ac6) },
  { SPH_C32(0x3d790003), SPH_C32(0x10710000), SPH_C32(0x3be20000),
    SPH_C32(0x8baf0000), SPH_C32(0x0cfa30da), SPH_C32(0xdb83f261),
    SPH_C32(0xdd7e7128), SPH_C32(0x5292b0f7), SPH_C32(0x25360007),
    SPH_C32(0x4b648000), SPH_C32(0xecdb0000), SPH_C32(0xa30c0000),
    SPH_C32(0x90787938), SPH_C32(0x662acc0a), SPH_C32(0x5a80ba8b),
    SPH_C32(0x7bacf892) },
  { SPH_C32(0x50ff0004), SPH_C32(0x45744000), SPH_C32(0x3dfb0000),
    SPH_C32(0x19e60000), SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d),
    SPH_C32(0xe1a8cc96), SPH_C32(0x7b1bd6b9), SPH_C32(0xf6800005),
    SPH_C32(0x3443c000), SPH_C32(0x24070000), SPH_C32(0x8f3d0000),
    SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae), SPH_C32(0xcdc58b19),
    SPH_C32(0xd795ba31) },
  { SPH_C32(0x25360007), SPH_C32(0x4b648000), SPH_C32(0xecdb0000),
    SPH_C32(0xa30c0000), SPH_C32(0x90787938), SPH_C32(0x662acc0a),
    SPH_C32(0x5a80ba8b), SPH_C32(0x7bacf892), SPH_C32(0x184f0004),
    SPH_C32(0x5b158000), SPH_C32(0xd7390000), SPH_C32(0x28a30000),
    SPH_C32(0x9c8249e2), SPH_C32(0xbda93e6b), SPH_C32(0x87fecba3),
    SPH_C32(0x293e4865) },
  { SPH_C32(0xbe300005), SPH_C32(0x2a220000), SPH_C32(0xcec50000),
    SPH_C32(0xbe780000), SPH_C32(0xa609241f), SPH_C32(0x56639098),
    SPH_C32(0xab938c2c), SPH_C32(0x85b024ed), SPH_C32(0x6d860007),
    SPH_C32(0x55054000), SPH_C32(0x06190000), SPH_C32(0x92490000),
    SPH_C32(0x174666dc), SPH_C32(0x3af1893c), SPH_C32(0x3cd6bdbe),
    SPH_C32(0x2989664e) },
  { SPH_C32(0xcbf90006), SPH_C32(0x2432c000), SPH_C32(0x1fe50000),
    SPH_C32(0x04920000), SPH_C32(0x2dcd0b21), SPH_C32(0xd13b27cf),
    SPH_C32(0x10bbfa31), SPH_C32(0x85070ac6), SPH_C32(0x83490006),
    SPH_C32(0x3a530000), SPH_C32(0xf5270000), SPH_C32(0x35d70000),
    SPH_C32(0xaaf314c5), SPH_C32(0x8de062f9), SPH_C32(0x76edfd04),
    SPH_C32(0xd722941a) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0x82bc000a), SPH_C32(0xc12c0000), SPH_C32(0x12f60000),
    SPH_C32(0xbe780000), SPH_C32(0x89513697), SPH_C32(0x7fb081ed),
    SPH_C32(0xc1af8753), SPH_C32(0x9ea1b631), SPH_C32(0x3aa50001),
    SPH_C32(0xe29e8000), SPH_C32(0x56910000), SPH_C32(0xedb70000),
    SPH_C32(0x41fb3063), SPH_C32(0x7ea56da9), SPH_C32(0xd20dd6be),
    SPH_C32(0x09ed3174) },
  { SPH_C32(0x19ba0008), SPH_C32(0xa06a8000), SPH_C32(0x30e80000),
    SPH_C32(0xa30c0000), SPH_C32(0xbf206bb0), SPH_C32(0x4ff9dd7f),
    SPH_C32(0x30bcb1f4), SPH_C32(0x60bd6a4e), SPH_C32(0x4f6c0002),
    SPH_C32(0xec8e4000), SPH_C32(0x87b10000), SPH_C32(0x575d0000),
    SPH_C32(0xca3f1f5d), SPH_C32(0xf9fddafe), SPH_C32(0x6925a0a3),
    SPH_C32(0x095a1f5f) },
  { SPH_C32(0x6c73000b), SPH_C32(0xae7a4000), SPH_C32(0xe1c80000),
    SPH_C32(0x19e60000), SPH_C32(0x34e4448e), SPH_C32(0xc8a16a28),
    SPH_C32(0x8b94c7e9), SPH_C32(0x600a4465), SPH_C32(0xa1a30003),
    SPH_C32(0x83d80000), SPH_C32(0x748f0000), SPH_C32(0xf0c30000),
    SPH_C32(0x778a6d44), SPH_C32(0x4eec313b), SPH_C32(0x231ee019),
    SPH_C32(0xf7f1ed0b) },
  { SPH_C32(0x01f5000c), SPH_C32(0xfb7f0000), SPH_C32(0xe7d10000),
    SPH_C32(0x8baf0000), SPH_C32(0x23a22252), SPH_C32(0xf250e314),
    SPH_C32(0xb7427a57), SPH_C32(0x4983222b), SPH_C32(0x72150001),
    SPH_C32(0xfcff4000), SPH_C32(0xbc530000), SPH_C32(0xdcf20000),
    SPH_C32(0xc6c52f87), SPH_C32(0x227e289f), SPH_C32(0xb45bd18b),
    SPH_C32(0x5bc8afa8) },
  { SPH_C32(0x743c000f), SPH_C32(0xf56fc000), SPH_C32(0x36f10000),
    SPH_C32(0x31450000), SPH_C32(0xa8660d6c), SPH_C32(0x75085443),
    SPH_C32(0x0c6a0c4a), SPH_C32(0x49340c00), SPH_C32(0x9cda0000),
    SPH_C32(0x93a90000), SPH_C32(0x4f6d0000), SPH_C32(0x7b6c0000),
    SPH_C32(0x7b705d9e), SPH_C32(0x956fc35a), SPH_C32(0xfe609131),
    SPH_C32(0xa5635dfc) },
  { SPH_C32(0xef3a000d), SPH_C32(0x94294000), SPH_C32(0x14ef0000),
    SPH_C32(0x2c310000), SPH_C32(0x9e17504b), SPH_C32(0x454108d1),
    SPH_C32(0xfd793aed), SPH_C32(0xb728d07f), SPH_C32(0xe9130003),
    SPH_C32(0x9db9c000), SPH_C32(0x9e4d0000), SPH_C32(0xc1860000),
    SPH_C32(0xf0b472a0), SPH_C32(0x1237740d), SPH_C32(0x4548e72c),
    SPH_C32(0xa5d473d7) },
  { SPH_C32(0x9af3000e), SPH_C32(0x9a398000), SPH_C32(0xc5cf0000),
    SPH_C32(0x96db0000), SPH_C32(0x15d37f75), SPH_C32(0xc219bf86),
    SPH_C32(0x46514cf0), SPH_C32(0xb79ffe54), SPH_C32(0x07dc0002),
    SPH_C32(0xf2ef8000), SPH_C32(0x6d730000), SPH_C32(0x66180000),
    SPH_C32(0x4d0100b9), SPH_C32(0xa5269fc8), SPH_C32(0x0f73a796),
    SPH_C32(0x5b7f8183) },
  { SPH_C32(0x510a0008), SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000),
    SPH_C32(0x92490000), SPH_C32(0x381e7454), SPH_C32(0x13229849),
    SPH_C32(0x56eab6c1), SPH_C32(0x3298f492), SPH_C32(0x84950004),
    SPH_C32(0xc8bc8000), SPH_C32(0x98540000), SPH_C32(0x53cf0000),
    SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31), SPH_C32(0x799e5a92),
    SPH_C32(0x8c5d1599) },
  { SPH_C32(0x24c3000b), SPH_C32(0xb01b8000), SPH_C32(0x0b0a0000),
    SPH_C32(0x28a30000), SPH_C32(0xb3da5b6a), SPH_C32(0x947a2f1e),
    SPH_C32(0xedc2c0dc), SPH_C32(0x322fdab9), SPH_C32(0x6a5a0005),
    SPH_C32(0xa7eac000), SPH_C32(0x6b6a0000), SPH_C32(0xf4510000),
    SPH_C32(0x5a476665), SPH_C32(0x9fd716f4), SPH_C32(0x33a51a28),
    SPH_C32(0x72f6e7cd) },
  { SPH_C32(0xbfc50009), SPH_C32(0xd15d0000), SPH_C32(0x29140000),
    SPH_C32(0x35d70000), SPH_C32(0x85ab064d), SPH_C32(0xa433738c),
    SPH_C32(0x1cd1f67b), SPH_C32(0xcc3306c6), SPH_C32(0x1f930006),
    SPH_C32(0xa9fa0000), SPH_C32(0xba4a0000), SPH_C32(0x4ebb0000),
    SPH_C32(0xd183495b), SPH_C32(0x188fa1a3), SPH_C32(0x888d6c35),
    SPH_C32(0x7241c9e6) },
  { SPH_C32(0xca0c000a), SPH_C32(0xdf4dc000), SPH_C32(0xf8340000),
    SPH_C32(0x8f3d0000), SPH_C32(0x0e6f2973), SPH_C32(0x236bc4db),
    SPH_C32(0xa7f98066), SPH_C32(0xcc8428ed), SPH_C32(0xf15c0007),
    SPH_C32(0xc6ac4000), SPH_C32(0x49740000), SPH_C32(0xe9250000),
    SPH_C32(0x6c363b42), SPH_C32(0xaf9e4a66), SPH_C32(0xc2b62c8f),
    SPH_C32(0x8cea3bb2) },
  { SPH_C32(0xa78a000d), SPH_C32(0x8a488000), SPH_C32(0xfe2d0000),
    SPH_C32(0x1d740000), SPH_C32(0x19294faf), SPH_C32(0x199a4de7),
    SPH_C32(0x9b2f3dd8), SPH_C32(0xe50d4ea3), SPH_C32(0x22ea0005),
    SPH_C32(0xb98b0000), SPH_C32(0x81a80000), SPH_C32(0xc5140000),
    SPH_C32(0xdd797981), SPH_C32(0xc30c53c2), SPH_C32(0x55f31d1d),
    SPH_C32(0x20d37911) },
  { SPH_C32(0xd243000e), SPH_C32(0x84584000), SPH_C32(0x2f0d0000),
    SPH_C32(0xa79e0000), SPH_C32(0x92ed6091), SPH_C32(0x9ec2fab0),
    SPH_C32(0x20074bc5), SPH_C32(0xe5ba6088), SPH_C32(0xcc250004),
    SPH_C32(0xd6dd4000), SPH_C32(0x72960000), SPH_C32(0x628a0000),
    SPH_C32(0x60cc0b98), SPH_C32(0x741db807), SPH_C32(0x1fc85da7),
    SPH_C32(0xde788b45) },
  { SPH_C32(0x4945000c), SPH_C32(0xe51ec000), SPH_C32(0x0d130000),
    SPH_C32(0xbaea0000), SPH_C32(0xa49c3db6), SPH_C32(0xae8ba622),
    SPH_C32(0xd1147d62), SPH_C32(0x1ba6bcf7), SPH_C32(0xb9ec0007),
    SPH_C32(0xd8cd8000), SPH_C32(0xa3b60000), SPH_C32(0xd8600000),
    SPH_C32(0xeb0824a6), SPH_C32(0xf3450f50), SPH_C32(0xa4e02bba),
    SPH_C32(0xdecfa56e) },
  { SPH_C32(0x3c8c000f), SPH_C32(0xeb0e0000), SPH_C32(0xdc330000),
    SPH_C32(0x00000000), SPH_C32(0x2f581288), SPH_C32(0x29d31175),
    SPH_C32(0x6a3c0b7f), SPH_C32(0x1b1192dc), SPH_C32(0x57230006),
    SPH_C32(0xb79bc000), SPH_C32(0x50880000), SPH_C32(0x7ffe0000),
    SPH_C32(0x56bd56bf), SPH_C32(0x4454e495), SPH_C32(0xeedb6b00),
    SPH_C32(0x2064573a) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0xa1a30003), SPH_C32(0x83d80000), SPH_C32(0x748f0000),
    SPH_C32(0xf0c30000), SPH_C32(0x778a6d44), SPH_C32(0x4eec313b),
    SPH_C32(0x231ee019), SPH_C32(0xf7f1ed0b), SPH_C32(0xcdd00008),
    SPH_C32(0x2da24000), SPH_C32(0x95470000), SPH_C32(0xe9250000),
    SPH_C32(0x436e29ca), SPH_C32(0x864d5b13), SPH_C32(0xa88a27f0),
    SPH_C32(0x97fba96e) },
  { SPH_C32(0x3aa50001), SPH_C32(0xe29e8000), SPH_C32(0x56910000),
    SPH_C32(0xedb70000), SPH_C32(0x41fb3063), SPH_C32(0x7ea56da9),
    SPH_C32(0xd20dd6be), SPH_C32(0x09ed3174), SPH_C32(0xb819000b),
    SPH_C32(0x23b28000), SPH_C32(0x44670000), SPH_C32(0x53cf0000),
    SPH_C32(0xc8aa06f4), SPH_C32(0x0115ec44), SPH_C32(0x13a251ed),
    SPH_C32(0x974c8745) },
  { SPH_C32(0x4f6c0002), SPH_C32(0xec8e4000), SPH_C32(0x87b10000),
    SPH_C32(0x575d0000), SPH_C32(0xca3f1f5d), SPH_C32(0xf9fddafe),
    SPH_C32(0x6925a0a3), SPH_C32(0x095a1f5f), SPH_C32(0x56d6000a),
    SPH_C32(0x4ce4c000), SPH_C32(0xb7590000), SPH_C32(0xf4510000),
    SPH_C32(0x751f74ed), SPH_C32(0xb6040781), SPH_C32(0x59991157),
    SPH_C32(0x69e77511) },
  { SPH_C32(0x22ea0005), SPH_C32(0xb98b0000), SPH_C32(0x81a80000),
    SPH_C32(0xc5140000), SPH_C32(0xdd797981), SPH_C32(0xc30c53c2),
    SPH_C32(0x55f31d1d), SPH_C32(0x20d37911), SPH_C32(0x85600008),
    SPH_C32(0x33c38000), SPH_C32(0x7f850000), SPH_C32(0xd8600000),
    SPH_C32(0xc450362e), SPH_C32(0xda961e25), SPH_C32(0xcedc20c5),
    SPH_C32(0xc5de37b2) },
  { SPH_C32(0x57230006), SPH_C32(0xb79bc000), SPH_C32(0x50880000),
    SPH_C32(0x7ffe0000), SPH_C32(0x56bd56bf), SPH_C32(0x4454e495),
    SPH_C32(0xeedb6b00), SPH_C32(0x2064573a), SPH_C32(0x6baf0009),
    SPH_C32(0x5c95c000), SPH_C32(0x8cbb0000), SPH_C32(0x7ffe0000),
    SPH_C32(0x79e54437), SPH_C32(0x6d87f5e0), SPH_C32(0x84e7607f),
    SPH_C32(0x3b75c5e6) },
  { SPH_C32(0xcc250004), SPH_C32(0xd6dd4000), SPH_C32(0x72960000),
    SPH_C32(0x628a0000), SPH_C32(0x60cc0b98), SPH_C32(0x741db807),
    SPH_C32(0x1fc85da7), SPH_C32(0xde788b45), SPH_C32(0x1e66000a),
    SPH_C32(0x52850000), SPH_C32(0x5d9b0000), SPH_C32(0xc5140000),
    SPH_C32(0xf2216b09), SPH_C32(0xeadf42b7), SPH_C32(0x3fcf1662),
    SPH_C32(0x3bc2ebcd) },
  { SPH_C32(0xb9ec0007), SPH_C32(0xd8cd8000), SPH_C32(0xa3b60000),
    SPH_C32(0xd8600000), SPH_C32(0xeb0824a6), SPH_C32(0xf3450f50),
    SPH_C32(0xa4e02bba), SPH_C32(0xdecfa56e), SPH_C32(0xf0a9000b),
    SPH_C32(0x3dd34000), SPH_C32(0xaea50000), SPH_C32(0x628a0000),
    SPH_C32(0x4f941910), SPH_C32(0x5dcea972), SPH_C32(0x75f456d8),
    SPH_C32(0xc5691999) },
  { SPH_C32(0x72150001), SPH_C32(0xfcff4000), SPH_C32(0xbc530000),
    SPH_C32(0xdcf20000), SPH_C32(0xc6c52f87), SPH_C32(0x227e289f),
    SPH_C32(0xb45bd18b), SPH_C32(0x5bc8afa8), SPH_C32(0x73e0000d),
    SPH_C32(0x07804000), SPH_C32(0x5b820000), SPH_C32(0x575d0000),
    SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b), SPH_C32(0x0319abdc),
    SPH_C32(0x124b8d83) },
  { SPH_C32(0x07dc0002), SPH_C32(0xf2ef8000), SPH_C32(0x6d730000),
    SPH_C32(0x66180000), SPH_C32(0x4d0100b9), SPH_C32(0xa5269fc8),
    SPH_C32(0x0f73a796), SPH_C32(0x5b7f8183), SPH_C32(0x9d2f000c),
    SPH_C32(0x68d60000), SPH_C32(0xa8bc0000), SPH_C32(0xf0c30000),
    SPH_C32(0x58d27fcc), SPH_C32(0x673f204e), SPH_C32(0x4922eb66),
    SPH_C32(0xece07fd7) },
  { SPH_C32(0x9cda0000), SPH_C32(0x93a90000), SPH_C32(0x4f6d0000),
    SPH_C32(0x7b6c0000), SPH_C32(0x7b705d9e), SPH_C32(0x956fc35a),
    SPH_C32(0xfe609131), SPH_C32(0xa5635dfc), SPH_C32(0xe8e6000f),
    SPH_C32(0x66c6c000), SPH_C32(0x799c0000), SPH_C32(0x4a290000),
    SPH_C32(0xd31650f2), SPH_C32(0xe0679719), SPH_C32(0xf20a9d7b),
    SPH_C32(0xec5751fc) },
  { SPH_C32(0xe9130003), SPH_C32(0x9db9c000), SPH_C32(0x9e4d0000),
    SPH_C32(0xc1860000), SPH_C32(0xf0b472a0), SPH_C32(0x1237740d),
    SPH_C32(0x4548e72c), SPH_C32(0xa5d473d7), SPH_C32(0x0629000e),
    SPH_C32(0x09908000), SPH_C32(0x8aa20000), SPH_C32(0xedb70000),
    SPH_C32(0x6ea322eb), SPH_C32(0x57767cdc), SPH_C32(0xb831ddc1),
    SPH_C32(0x12fca3a8) },
  { SPH_C32(0x84950004), SPH_C32(0xc8bc8000), SPH_C32(0x98540000),
    SPH_C32(0x53cf0000), SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31),
    SPH_C32(0x799e5a92), SPH_C32(0x8c5d1599), SPH_C32(0xd59f000c),
    SPH_C32(0x76b7c000), SPH_C32(0x427e0000), SPH_C32(0xc1860000),
    SPH_C32(0xdfec6028), SPH_C32(0x3be46578), SPH_C32(0x2f74ec53),
    SPH_C32(0xbec5e10b) },
  { SPH_C32(0xf15c0007), SPH_C32(0xc6ac4000), SPH_C32(0x49740000),
    SPH_C32(0xe9250000), SPH_C32(0x6c363b42), SPH_C32(0xaf9e4a66),
    SPH_C32(0xc2b62c8f), SPH_C32(0x8cea3bb2), SPH_C32(0x3b50000d),
    SPH_C32(0x19e18000), SPH_C32(0xb1400000), SPH_C32(0x66180000),
    SPH_C32(0x62591231), SPH_C32(0x8cf58ebd), SPH_C32(0x654face9),
    SPH_C32(0x406e135f) },
  { SPH_C32(0x6a5a0005), SPH_C32(0xa7eac000), SPH_C32(0x6b6a0000),
    SPH_C32(0xf4510000), SPH_C32(0x5a476665), SPH_C32(0x9fd716f4),
    SPH_C32(0x33a51a28), SPH_C32(0x72f6e7cd), SPH_C32(0x4e99000e),
    SPH_C32(0x17f14000), SPH_C32(0x60600000), SPH_C32(0xdcf20000),
    SPH_C32(0xe99d3d0f), SPH_C32(0x0bad39ea), SPH_C32(0xde67daf4),
    SPH_C32(0x40d93d74) },
  { SPH_C32(0x1f930006), SPH_C32(0xa9fa0000), SPH_C32(0xba4a0000),
    SPH_C32(0x4ebb0000), SPH_C32(0xd183495b), SPH_C32(0x188fa1a3),
    SPH_C32(0x888d6c35), SPH_C32(0x7241c9e6), SPH_C32(0xa056000f),
    SPH_C32(0x78a70000), SPH_C32(0x935e0000), SPH_C32(0x7b6c0000),
    SPH_C32(0x54284f16), SPH_C32(0xbcbcd22f), SPH_C32(0x945c9a4e),
    SPH_C32(0xbe72cf20) },
  { SPH_C32(0x231f0009), SPH_C32(0x42f40000), SPH_C32(0x66790000),
    SPH_C32(0x4ebb0000), SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6),
    SPH_C32(0xe2b1674a), SPH_C32(0x69505b3a), SPH_C32(0xf7750009),
    SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000), SPH_C32(0x04920000),
    SPH_C32(0x029519a9), SPH_C32(0xf8e836ba), SPH_C32(0x7a87f14e),
    SPH_C32(0x9e16981a) },
  { SPH_C32(0x56d6000a), SPH_C32(0x4ce4c000), SPH_C32(0xb7590000),
    SPH_C32(0xf4510000), SPH_C32(0x751f74ed), SPH_C32(0xb6040781),
    SPH_C32(0x59991157), SPH_C32(0x69e77511), SPH_C32(0x19ba0008),
    SPH_C32(0xa06a8000), SPH_C32(0x30e80000), SPH_C32(0xa30c0000),
    SPH_C32(0xbf206bb0), SPH_C32(0x4ff9dd7f), SPH_C32(0x30bcb1f4),
    SPH_C32(0x60bd6a4e) },
  { SPH_C32(0xcdd00008), SPH_C32(0x2da24000), SPH_C32(0x95470000),
    SPH_C32(0xe9250000), SPH_C32(0x436e29ca), SPH_C32(0x864d5b13),
    SPH_C32(0xa88a27f0), SPH_C32(0x97fba96e), SPH_C32(0x6c73000b),
    SPH_C32(0xae7a4000), SPH_C32(0xe1c80000), SPH_C32(0x19e60000),
    SPH_C32(0x34e4448e), SPH_C32(0xc8a16a28), SPH_C32(0x8b94c7e9),
    SPH_C32(0x600a4465) },
  { SPH_C32(0xb819000b), SPH_C32(0x23b28000), SPH_C32(0x44670000),
    SPH_C32(0x53cf0000), SPH_C32(0xc8aa06f4), SPH_C32(0x0115ec44),
    SPH_C32(0x13a251ed), SPH_C32(0x974c8745), SPH_C32(0x82bc000a),
    SPH_C32(0xc12c0000), SPH_C32(0x12f60000), SPH_C32(0xbe780000),
    SPH_C32(0x89513697), SPH_C32(0x7fb081ed), SPH_C32(0xc1af8753),
    SPH_C32(0x9ea1b631) },
  { SPH_C32(0xd59f000c), SPH_C32(0x76b7c000), SPH_C32(0x427e0000),
    SPH_C32(0xc1860000), SPH_C32(0xdfec6028), SPH_C32(0x3be46578),
    SPH_C32(0x2f74ec53), SPH_C32(0xbec5e10b), SPH_C32(0x510a0008),
    SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000), SPH_C32(0x92490000),
    SPH_C32(0x381e7454), SPH_C32(0x13229849), SPH_C32(0x56eab6c1),
    SPH_C32(0x3298f492) },
  { SPH_C32(0xa056000f), SPH_C32(0x78a70000), SPH_C32(0x935e0000),
    SPH_C32(0x7b6c0000), SPH_C32(0x54284f16), SPH_C32(0xbcbcd22f),
    SPH_C32(0x945c9a4e), SPH_C32(0xbe72cf20), SPH_C32(0xbfc50009),
    SPH_C32(0xd15d0000), SPH_C32(0x29140000), SPH_C32(0x35d70000),
    SPH_C32(0x85ab064d), SPH_C32(0xa433738c), SPH_C32(0x1cd1f67b),
    SPH_C32(0xcc3306c6) },
  { SPH_C32(0x3b50000d), SPH_C32(0x19e18000), SPH_C32(0xb1400000),
    SPH_C32(0x66180000), SPH_C32(0x62591231), SPH_C32(0x8cf58ebd),
    SPH_C32(0x654face9), SPH_C32(0x406e135f), SPH_C32(0xca0c000a),
    SPH_C32(0xdf4dc000), SPH_C32(0xf8340000), SPH_C32(0x8f3d0000),
    SPH_C32(0x0e6f2973), SPH_C32(0x236bc4db), SPH_C32(0xa7f98066),
    SPH_C32(0xcc8428ed) },
  { SPH_C32(0x4e99000e), SPH_C32(0x17f14000), SPH_C32(0x60600000),
    SPH_C32(0xdcf20000), SPH_C32(0xe99d3d0f), SPH_C32(0x0bad39ea),
    SPH_C32(0xde67daf4), SPH_C32(0x40d93d74), SPH_C32(0x24c3000b),
    SPH_C32(0xb01b8000), SPH_C32(0x0b0a0000), SPH_C32(0x28a30000),
    SPH_C32(0xb3da5b6a), SPH_C32(0x947a2f1e), SPH_C32(0xedc2c0dc),
    SPH_C32(0x322fdab9) },
  { SPH_C32(0x85600008), SPH_C32(0x33c38000), SPH_C32(0x7f850000),
    SPH_C32(0xd8600000), SPH_C32(0xc450362e), SPH_C32(0xda961e25),
    SPH_C32(0xcedc20c5), SPH_C32(0xc5de37b2), SPH_C32(0xa78a000d),
    SPH_C32(0x8a488000), SPH_C32(0xfe2d0000), SPH_C32(0x1d740000),
    SPH_C32(0x19294faf), SPH_C32(0x199a4de7), SPH_C32(0x9b2f3dd8),
    SPH_C32(0xe50d4ea3) },
  { SPH_C32(0xf0a9000b), SPH_C32(0x3dd34000), SPH_C32(0xaea50000),
    SPH_C32(0x628a0000), SPH_C32(0x4f941910), SPH_C32(0x5dcea972),
    SPH_C32(0x75f456d8), SPH_C32(0xc5691999), SPH_C32(0x4945000c),
    SPH_C32(0xe51ec000), SPH_C32(0x0d130000), SPH_C32(0xbaea0000),
    SPH_C32(0xa49c3db6), SPH_C32(0xae8ba622), SPH_C32(0xd1147d62),
    SPH_C32(0x1ba6bcf7) },
  { SPH_C32(0x6baf0009), SPH_C32(0x5c95c000), SPH_C32(0x8cbb0000),
    SPH_C32(0x7ffe0000), SPH_C32(0x79e54437), SPH_C32(0x6d87f5e0),
    SPH_C32(0x84e7607f), SPH_C32(0x3b75c5e6), SPH_C32(0x3c8c000f),
    SPH_C32(0xeb0e0000), SPH_C32(0xdc330000), SPH_C32(0x00000000),
    SPH_C32(0x2f581288), SPH_C32(0x29d31175), SPH_C32(0x6a3c0b7f),
    SPH_C32(0x1b1192dc) },
  { SPH_C32(0x1e66000a), SPH_C32(0x52850000), SPH_C32(0x5d9b0000),
    SPH_C32(0xc5140000), SPH_C32(0xf2216b09), SPH_C32(0xeadf42b7),
    SPH_C32(0x3fcf1662), SPH_C32(0x3bc2ebcd), SPH_C32(0xd243000e),
    SPH_C32(0x84584000), SPH_C32(0x2f0d0000), SPH_C32(0xa79e0000),
    SPH_C32(0x92ed6091), SPH_C32(0x9ec2fab0), SPH_C32(0x20074bc5),
    SPH_C32(0xe5ba6088) },
  { SPH_C32(0x73e0000d), SPH_C32(0x07804000), SPH_C32(0x5b820000),
    SPH_C32(0x575d0000), SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b),
    SPH_C32(0x0319abdc), SPH_C32(0x124b8d83), SPH_C32(0x01f5000c),
    SPH_C32(0xfb7f0000), SPH_C32(0xe7d10000), SPH_C32(0x8baf0000),
    SPH_C32(0x23a22252), SPH_C32(0xf250e314), SPH_C32(0xb7427a57),
    SPH_C32(0x4983222b) },
  { SPH_C32(0x0629000e), SPH_C32(0x09908000), SPH_C32(0x8aa20000),
    SPH_C32(0xedb70000), SPH_C32(0x6ea322eb), SPH_C32(0x57767cdc),
    SPH_C32(0xb831ddc1), SPH_C32(0x12fca3a8), SPH_C32(0xef3a000d),
    SPH_C32(0x94294000), SPH_C32(0x14ef0000), SPH_C32(0x2c310000),
    SPH_C32(0x9e17504b), SPH_C32(0x454108d1), SPH_C32(0xfd793aed),
    SPH_C32(0xb728d07f) },
  { SPH_C32(0x9d2f000c), SPH_C32(0x68d60000), SPH_C32(0xa8bc0000),
    SPH_C32(0xf0c30000), SPH_C32(0x58d27fcc), SPH_C32(0x673f204e),
    SPH_C32(0x4922eb66), SPH_C32(0xece07fd7), SPH_C32(0x9af3000e),
    SPH_C32(0x9a398000), SPH_C32(0xc5cf0000), SPH_C32(0x96db0000),
    SPH_C32(0x15d37f75), SPH_C32(0xc219bf86), SPH_C32(0x46514cf0),
    SPH_C32(0xb79ffe54) },
  { SPH_C32(0xe8e6000f), SPH_C32(0x66c6c000), SPH_C32(0x799c0000),
    SPH_C32(0x4a290000), SPH_C32(0xd31650f2), SPH_C32(0xe0679719),
    SPH_C32(0xf20a9d7b), SPH_C32(0xec5751fc), SPH_C32(0x743c000f),
    SPH_C32(0xf56fc000), SPH_C32(0x36f10000), SPH_C32(0x31450000),
    SPH_C32(0xa8660d6c), SPH_C32(0x75085443), SPH_C32(0x0c6a0c4a),
    SPH_C32(0x49340c00) }
};

__constant static const sph_u32 T512_18[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0xf2500000), SPH_C32(0xeebd0a00), SPH_C32(0x67a80000),
    SPH_C32(0xab8a0000), SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74),
    SPH_C32(0xdb73e86e), SPH_C32(0x1568ff0f), SPH_C32(0x0c720000),
    SPH_C32(0x49e50f00), SPH_C32(0x42790000), SPH_C32(0x5cea0000),
    SPH_C32(0x33aa301a), SPH_C32(0x15822514), SPH_C32(0x95a34b7b),
    SPH_C32(0xb44b0090) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0x496a0000), SPH_C32(0xec501800), SPH_C32(0xbb130000),
    SPH_C32(0x67a20000), SPH_C32(0x2d662436), SPH_C32(0x3691b0c2),
    SPH_C32(0x831fedcb), SPH_C32(0x6b78f44f), SPH_C32(0x461f0000),
    SPH_C32(0xb1290300), SPH_C32(0x124b0000), SPH_C32(0x02d10000),
    SPH_C32(0xabb01976), SPH_C32(0xb19c0925), SPH_C32(0x28f4b503),
    SPH_C32(0x64e214a1) },
  { SPH_C32(0xbb3a0000), SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000),
    SPH_C32(0xcc280000), SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6),
    SPH_C32(0x586c05a5), SPH_C32(0x7e100b40), SPH_C32(0x4a6d0000),
    SPH_C32(0xf8cc0c00), SPH_C32(0x50320000), SPH_C32(0x5e3b0000),
    SPH_C32(0x981a296c), SPH_C32(0xa41e2c31), SPH_C32(0xbd57fe78),
    SPH_C32(0xd0a91431) },
  { SPH_C32(0xb7480000), SPH_C32(0x4b081d00), SPH_C32(0x9ec20000),
    SPH_C32(0x90c20000), SPH_C32(0xa4575cec), SPH_C32(0x294548a2),
    SPH_C32(0xcdcf4ede), SPH_C32(0xca5b0bd0), SPH_C32(0xb44f0000),
    SPH_C32(0x5f940900), SPH_C32(0x75e30000), SPH_C32(0xa95b0000),
    SPH_C32(0x112b51b6), SPH_C32(0xbbcad451), SPH_C32(0xf3875d6d),
    SPH_C32(0x718aebae) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0xb44f0000), SPH_C32(0x5f940900), SPH_C32(0x75e30000),
    SPH_C32(0xa95b0000), SPH_C32(0x112b51b6), SPH_C32(0xbbcad451),
    SPH_C32(0xf3875d6d), SPH_C32(0x718aebae), SPH_C32(0x03070000),
    SPH_C32(0x149c1400), SPH_C32(0xeb210000), SPH_C32(0x39990000),
    SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3), SPH_C32(0x3e4813b3),
    SPH_C32(0xbbd1e07e) },
  { SPH_C32(0x461f0000), SPH_C32(0xb1290300), SPH_C32(0x124b0000),
    SPH_C32(0x02d10000), SPH_C32(0xabb01976), SPH_C32(0xb19c0925),
    SPH_C32(0x28f4b503), SPH_C32(0x64e214a1), SPH_C32(0x0f750000),
    SPH_C32(0x5d791b00), SPH_C32(0xa9580000), SPH_C32(0x65730000),
    SPH_C32(0x86d63d40), SPH_C32(0x870db9e7), SPH_C32(0xabeb58c8),
    SPH_C32(0x0f9ae0ee) },
  { SPH_C32(0x4a6d0000), SPH_C32(0xf8cc0c00), SPH_C32(0x50320000),
    SPH_C32(0x5e3b0000), SPH_C32(0x981a296c), SPH_C32(0xa41e2c31),
    SPH_C32(0xbd57fe78), SPH_C32(0xd0a91431), SPH_C32(0xf1570000),
    SPH_C32(0xfa211e00), SPH_C32(0x8c890000), SPH_C32(0x92130000),
    SPH_C32(0x0fe7459a), SPH_C32(0x98d94187), SPH_C32(0xe53bfbdd),
    SPH_C32(0xaeb91f71) },
  { SPH_C32(0xfd250000), SPH_C32(0xb3c41100), SPH_C32(0xcef00000),
    SPH_C32(0xcef90000), SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493),
    SPH_C32(0x7098b0a6), SPH_C32(0x1af21fe1), SPH_C32(0x45180000),
    SPH_C32(0xa5b51700), SPH_C32(0xf96a0000), SPH_C32(0x3b480000),
    SPH_C32(0x1ecc142c), SPH_C32(0x231395d6), SPH_C32(0x16bca6b0),
    SPH_C32(0xdf33f4df) },
  { SPH_C32(0xf1570000), SPH_C32(0xfa211e00), SPH_C32(0x8c890000),
    SPH_C32(0x92130000), SPH_C32(0x0fe7459a), SPH_C32(0x98d94187),
    SPH_C32(0xe53bfbdd), SPH_C32(0xaeb91f71), SPH_C32(0xbb3a0000),
    SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000), SPH_C32(0xcc280000),
    SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6), SPH_C32(0x586c05a5),
    SPH_C32(0x7e100b40) },
  { SPH_C32(0x03070000), SPH_C32(0x149c1400), SPH_C32(0xeb210000),
    SPH_C32(0x39990000), SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3),
    SPH_C32(0x3e4813b3), SPH_C32(0xbbd1e07e), SPH_C32(0xb7480000),
    SPH_C32(0x4b081d00), SPH_C32(0x9ec20000), SPH_C32(0x90c20000),
    SPH_C32(0xa4575cec), SPH_C32(0x294548a2), SPH_C32(0xcdcf4ede),
    SPH_C32(0xca5b0bd0) },
  { SPH_C32(0x0f750000), SPH_C32(0x5d791b00), SPH_C32(0xa9580000),
    SPH_C32(0x65730000), SPH_C32(0x86d63d40), SPH_C32(0x870db9e7),
    SPH_C32(0xabeb58c8), SPH_C32(0x0f9ae0ee), SPH_C32(0x496a0000),
    SPH_C32(0xec501800), SPH_C32(0xbb130000), SPH_C32(0x67a20000),
    SPH_C32(0x2d662436), SPH_C32(0x3691b0c2), SPH_C32(0x831fedcb),
    SPH_C32(0x6b78f44f) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0x79d60000), SPH_C32(0x8b6e2800), SPH_C32(0xd6dd0000),
    SPH_C32(0xcc1f0000), SPH_C32(0xc8d267fa), SPH_C32(0x5c4c2eba),
    SPH_C32(0x82c48ff8), SPH_C32(0x1a9466ee), SPH_C32(0x2f440000),
    SPH_C32(0xbce40600), SPH_C32(0xbb3d0000), SPH_C32(0x01f40000),
    SPH_C32(0x8a333dfd), SPH_C32(0xd0a40492), SPH_C32(0xfa93b802),
    SPH_C32(0x245cc3b4) },
  { SPH_C32(0x8b860000), SPH_C32(0x65d32200), SPH_C32(0xb1750000),
    SPH_C32(0x67950000), SPH_C32(0x72492f3a), SPH_C32(0x561af3ce),
    SPH_C32(0x59b76796), SPH_C32(0x0ffc99e1), SPH_C32(0x23360000),
    SPH_C32(0xf5010900), SPH_C32(0xf9440000), SPH_C32(0x5d1e0000),
    SPH_C32(0xb9990de7), SPH_C32(0xc5262186), SPH_C32(0x6f30f379),
    SPH_C32(0x9017c324) },
  { SPH_C32(0x87f40000), SPH_C32(0x2c362d00), SPH_C32(0xf30c0000),
    SPH_C32(0x3b7f0000), SPH_C32(0x41e31f20), SPH_C32(0x4398d6da),
    SPH_C32(0xcc142ced), SPH_C32(0xbbb79971), SPH_C32(0xdd140000),
    SPH_C32(0x52590c00), SPH_C32(0xdc950000), SPH_C32(0xaa7e0000),
    SPH_C32(0x30a8753d), SPH_C32(0xdaf2d9e6), SPH_C32(0x21e0506c),
    SPH_C32(0x31343cbb) },
  { SPH_C32(0x30bc0000), SPH_C32(0x673e3000), SPH_C32(0x6dce0000),
    SPH_C32(0xabbd0000), SPH_C32(0xe5b443cc), SPH_C32(0x6add9e78),
    SPH_C32(0x01db6233), SPH_C32(0x71ec92a1), SPH_C32(0x695b0000),
    SPH_C32(0x0dcd0500), SPH_C32(0xa9760000), SPH_C32(0x03250000),
    SPH_C32(0x2183248b), SPH_C32(0x61380db7), SPH_C32(0xd2670d01),
    SPH_C32(0x40bed715) },
  { SPH_C32(0x3cce0000), SPH_C32(0x2edb3f00), SPH_C32(0x2fb70000),
    SPH_C32(0xf7570000), SPH_C32(0xd61e73d6), SPH_C32(0x7f5fbb6c),
    SPH_C32(0x94782948), SPH_C32(0xc5a79231), SPH_C32(0x97790000),
    SPH_C32(0xaa950000), SPH_C32(0x8ca70000), SPH_C32(0xf4450000),
    SPH_C32(0xa8b25c51), SPH_C32(0x7eecf5d7), SPH_C32(0x9cb7ae14),
    SPH_C32(0xe19d288a) },
  { SPH_C32(0xce9e0000), SPH_C32(0xc0663500), SPH_C32(0x481f0000),
    SPH_C32(0x5cdd0000), SPH_C32(0x6c853b16), SPH_C32(0x75096618),
    SPH_C32(0x4f0bc126), SPH_C32(0xd0cf6d3e), SPH_C32(0x9b0b0000),
    SPH_C32(0xe3700f00), SPH_C32(0xcede0000), SPH_C32(0xa8af0000),
    SPH_C32(0x9b186c4b), SPH_C32(0x6b6ed0c3), SPH_C32(0x0914e56f),
    SPH_C32(0x55d6281a) },
  { SPH_C32(0xc2ec0000), SPH_C32(0x89833a00), SPH_C32(0x0a660000),
    SPH_C32(0x00370000), SPH_C32(0x5f2f0b0c), SPH_C32(0x608b430c),
    SPH_C32(0xdaa88a5d), SPH_C32(0x64846dae), SPH_C32(0x65290000),
    SPH_C32(0x44280a00), SPH_C32(0xeb0f0000), SPH_C32(0x5fcf0000),
    SPH_C32(0x12291491), SPH_C32(0x74ba28a3), SPH_C32(0x47c4467a),
    SPH_C32(0xf4f5d785) },
  { SPH_C32(0xcd990000), SPH_C32(0xd4fa2100), SPH_C32(0xa33e0000),
    SPH_C32(0x65440000), SPH_C32(0xd9f9364c), SPH_C32(0xe786faeb),
    SPH_C32(0x7143d295), SPH_C32(0x6b1e8d40), SPH_C32(0x2c430000),
    SPH_C32(0xa8781200), SPH_C32(0x501c0000), SPH_C32(0x386d0000),
    SPH_C32(0x3f4f30a7), SPH_C32(0x422b9861), SPH_C32(0xc4dbabb1),
    SPH_C32(0x9f8d23ca) },
  { SPH_C32(0xc1eb0000), SPH_C32(0x9d1f2e00), SPH_C32(0xe1470000),
    SPH_C32(0x39ae0000), SPH_C32(0xea530656), SPH_C32(0xf204dfff),
    SPH_C32(0xe4e099ee), SPH_C32(0xdf558dd0), SPH_C32(0xd2610000),
    SPH_C32(0x0f201700), SPH_C32(0x75cd0000), SPH_C32(0xcf0d0000),
    SPH_C32(0xb67e487d), SPH_C32(0x5dff6001), SPH_C32(0x8a0b08a4),
    SPH_C32(0x3eaedc55) },
  { SPH_C32(0x33bb0000), SPH_C32(0x73a22400), SPH_C32(0x86ef0000),
    SPH_C32(0x92240000), SPH_C32(0x50c84e96), SPH_C32(0xf852028b),
    SPH_C32(0x3f937180), SPH_C32(0xca3d72df), SPH_C32(0xde130000),
    SPH_C32(0x46c51800), SPH_C32(0x37b40000), SPH_C32(0x93e70000),
    SPH_C32(0x85d47867), SPH_C32(0x487d4515), SPH_C32(0x1fa843df),
    SPH_C32(0x8ae5dcc5) },
  { SPH_C32(0x3fc90000), SPH_C32(0x3a472b00), SPH_C32(0xc4960000),
    SPH_C32(0xcece0000), SPH_C32(0x63627e8c), SPH_C32(0xedd0279f),
    SPH_C32(0xaa303afb), SPH_C32(0x7e76724f), SPH_C32(0x20310000),
    SPH_C32(0xe19d1d00), SPH_C32(0x12650000), SPH_C32(0x64870000),
    SPH_C32(0x0ce500bd), SPH_C32(0x57a9bd75), SPH_C32(0x5178e0ca),
    SPH_C32(0x2bc6235a) },
  { SPH_C32(0x88810000), SPH_C32(0x714f3600), SPH_C32(0x5a540000),
    SPH_C32(0x5e0c0000), SPH_C32(0xc7352260), SPH_C32(0xc4956f3d),
    SPH_C32(0x67ff7425), SPH_C32(0xb42d799f), SPH_C32(0x947e0000),
    SPH_C32(0xbe091400), SPH_C32(0x67860000), SPH_C32(0xcddc0000),
    SPH_C32(0x1dce510b), SPH_C32(0xec636924), SPH_C32(0xa2ffbda7),
    SPH_C32(0x5a4cc8f4) },
  { SPH_C32(0x84f30000), SPH_C32(0x38aa3900), SPH_C32(0x182d0000),
    SPH_C32(0x02e60000), SPH_C32(0xf49f127a), SPH_C32(0xd1174a29),
    SPH_C32(0xf25c3f5e), SPH_C32(0x0066790f), SPH_C32(0x6a5c0000),
    SPH_C32(0x19511100), SPH_C32(0x42570000), SPH_C32(0x3abc0000),
    SPH_C32(0x94ff29d1), SPH_C32(0xf3b79144), SPH_C32(0xec2f1eb2),
    SPH_C32(0xfb6f376b) },
  { SPH_C32(0x76a30000), SPH_C32(0xd6173300), SPH_C32(0x7f850000),
    SPH_C32(0xa96c0000), SPH_C32(0x4e045aba), SPH_C32(0xdb41975d),
    SPH_C32(0x292fd730), SPH_C32(0x150e8600), SPH_C32(0x662e0000),
    SPH_C32(0x50b41e00), SPH_C32(0x002e0000), SPH_C32(0x66560000),
    SPH_C32(0xa75519cb), SPH_C32(0xe635b450), SPH_C32(0x798c55c9),
    SPH_C32(0x4f2437fb) },
  { SPH_C32(0x7ad10000), SPH_C32(0x9ff23c00), SPH_C32(0x3dfc0000),
    SPH_C32(0xf5860000), SPH_C32(0x7dae6aa0), SPH_C32(0xcec3b249),
    SPH_C32(0xbc8c9c4b), SPH_C32(0xa1458690), SPH_C32(0x980c0000),
    SPH_C32(0xf7ec1b00), SPH_C32(0x25ff0000), SPH_C32(0x91360000),
    SPH_C32(0x2e646111), SPH_C32(0xf9e14c30), SPH_C32(0x375cf6dc),
    SPH_C32(0xee07c864) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0xdd140000), SPH_C32(0x52590c00), SPH_C32(0xdc950000),
    SPH_C32(0xaa7e0000), SPH_C32(0x30a8753d), SPH_C32(0xdaf2d9e6),
    SPH_C32(0x21e0506c), SPH_C32(0x31343cbb), SPH_C32(0x5ae00000),
    SPH_C32(0x7e6f2100), SPH_C32(0x2f990000), SPH_C32(0x91010000),
    SPH_C32(0x714b6a1d), SPH_C32(0x996a0f3c), SPH_C32(0xedf47c81),
    SPH_C32(0x8a83a5ca) },
  { SPH_C32(0x2f440000), SPH_C32(0xbce40600), SPH_C32(0xbb3d0000),
    SPH_C32(0x01f40000), SPH_C32(0x8a333dfd), SPH_C32(0xd0a40492),
    SPH_C32(0xfa93b802), SPH_C32(0x245cc3b4), SPH_C32(0x56920000),
    SPH_C32(0x378a2e00), SPH_C32(0x6de00000), SPH_C32(0xcdeb0000),
    SPH_C32(0x42e15a07), SPH_C32(0x8ce82a28), SPH_C32(0x785737fa),
    SPH_C32(0x3ec8a55a) },
  { SPH_C32(0x23360000), SPH_C32(0xf5010900), SPH_C32(0xf9440000),
    SPH_C32(0x5d1e0000), SPH_C32(0xb9990de7), SPH_C32(0xc5262186),
    SPH_C32(0x6f30f379), SPH_C32(0x9017c324), SPH_C32(0xa8b00000),
    SPH_C32(0x90d22b00), SPH_C32(0x48310000), SPH_C32(0x3a8b0000),
    SPH_C32(0xcbd022dd), SPH_C32(0x933cd248), SPH_C32(0x368794ef),
    SPH_C32(0x9feb5ac5) },
  { SPH_C32(0x947e0000), SPH_C32(0xbe091400), SPH_C32(0x67860000),
    SPH_C32(0xcddc0000), SPH_C32(0x1dce510b), SPH_C32(0xec636924),
    SPH_C32(0xa2ffbda7), SPH_C32(0x5a4cc8f4), SPH_C32(0x1cff0000),
    SPH_C32(0xcf462200), SPH_C32(0x3dd20000), SPH_C32(0x93d00000),
    SPH_C32(0xdafb736b), SPH_C32(0x28f60619), SPH_C32(0xc500c982),
    SPH_C32(0xee61b16b) },
  { SPH_C32(0x980c0000), SPH_C32(0xf7ec1b00), SPH_C32(0x25ff0000),
    SPH_C32(0x91360000), SPH_C32(0x2e646111), SPH_C32(0xf9e14c30),
    SPH_C32(0x375cf6dc), SPH_C32(0xee07c864), SPH_C32(0xe2dd0000),
    SPH_C32(0x681e2700), SPH_C32(0x18030000), SPH_C32(0x64b00000),
    SPH_C32(0x53ca0bb1), SPH_C32(0x3722fe79), SPH_C32(0x8bd06a97),
    SPH_C32(0x4f424ef4) },
  { SPH_C32(0x6a5c0000), SPH_C32(0x19511100), SPH_C32(0x42570000),
    SPH_C32(0x3abc0000), SPH_C32(0x94ff29d1), SPH_C32(0xf3b79144),
    SPH_C32(0xec2f1eb2), SPH_C32(0xfb6f376b), SPH_C32(0xeeaf0000),
    SPH_C32(0x21fb2800), SPH_C32(0x5a7a0000), SPH_C32(0x385a0000),
    SPH_C32(0x60603bab), SPH_C32(0x22a0db6d), SPH_C32(0x1e7321ec),
    SPH_C32(0xfb094e64) },
  { SPH_C32(0x662e0000), SPH_C32(0x50b41e00), SPH_C32(0x002e0000),
    SPH_C32(0x66560000), SPH_C32(0xa75519cb), SPH_C32(0xe635b450),
    SPH_C32(0x798c55c9), SPH_C32(0x4f2437fb), SPH_C32(0x108d0000),
    SPH_C32(0x86a32d00), SPH_C32(0x7fab0000), SPH_C32(0xcf3a0000),
    SPH_C32(0xe9514371), SPH_C32(0x3d74230d), SPH_C32(0x50a382f9),
    SPH_C32(0x5a2ab1fb) },
  { SPH_C32(0x695b0000), SPH_C32(0x0dcd0500), SPH_C32(0xa9760000),
    SPH_C32(0x03250000), SPH_C32(0x2183248b), SPH_C32(0x61380db7),
    SPH_C32(0xd2670d01), SPH_C32(0x40bed715), SPH_C32(0x59e70000),
    SPH_C32(0x6af33500), SPH_C32(0xc4b80000), SPH_C32(0xa8980000),
    SPH_C32(0xc4376747), SPH_C32(0x0be593cf), SPH_C32(0xd3bc6f32),
    SPH_C32(0x315245b4) },
  { SPH_C32(0x65290000), SPH_C32(0x44280a00), SPH_C32(0xeb0f0000),
    SPH_C32(0x5fcf0000), SPH_C32(0x12291491), SPH_C32(0x74ba28a3),
    SPH_C32(0x47c4467a), SPH_C32(0xf4f5d785), SPH_C32(0xa7c50000),
    SPH_C32(0xcdab3000), SPH_C32(0xe1690000), SPH_C32(0x5ff80000),
    SPH_C32(0x4d061f9d), SPH_C32(0x14316baf), SPH_C32(0x9d6ccc27),
    SPH_C32(0x9071ba2b) },
  { SPH_C32(0x97790000), SPH_C32(0xaa950000), SPH_C32(0x8ca70000),
    SPH_C32(0xf4450000), SPH_C32(0xa8b25c51), SPH_C32(0x7eecf5d7),
    SPH_C32(0x9cb7ae14), SPH_C32(0xe19d288a), SPH_C32(0xabb70000),
    SPH_C32(0x844e3f00), SPH_C32(0xa3100000), SPH_C32(0x03120000),
    SPH_C32(0x7eac2f87), SPH_C32(0x01b34ebb), SPH_C32(0x08cf875c),
    SPH_C32(0x243ababb) },
  { SPH_C32(0x9b0b0000), SPH_C32(0xe3700f00), SPH_C32(0xcede0000),
    SPH_C32(0xa8af0000), SPH_C32(0x9b186c4b), SPH_C32(0x6b6ed0c3),
    SPH_C32(0x0914e56f), SPH_C32(0x55d6281a), SPH_C32(0x55950000),
    SPH_C32(0x23163a00), SPH_C32(0x86c10000), SPH_C32(0xf4720000),
    SPH_C32(0xf79d575d), SPH_C32(0x1e67b6db), SPH_C32(0x461f2449),
    SPH_C32(0x85194524) },
  { SPH_C32(0x2c430000), SPH_C32(0xa8781200), SPH_C32(0x501c0000),
    SPH_C32(0x386d0000), SPH_C32(0x3f4f30a7), SPH_C32(0x422b9861),
    SPH_C32(0xc4dbabb1), SPH_C32(0x9f8d23ca), SPH_C32(0xe1da0000),
    SPH_C32(0x7c823300), SPH_C32(0xf3220000), SPH_C32(0x5d290000),
    SPH_C32(0xe6b606eb), SPH_C32(0xa5ad628a), SPH_C32(0xb5987924),
    SPH_C32(0xf493ae8a) },
  { SPH_C32(0x20310000), SPH_C32(0xe19d1d00), SPH_C32(0x12650000),
    SPH_C32(0x64870000), SPH_C32(0x0ce500bd), SPH_C32(0x57a9bd75),
    SPH_C32(0x5178e0ca), SPH_C32(0x2bc6235a), SPH_C32(0x1ff80000),
    SPH_C32(0xdbda3600), SPH_C32(0xd6f30000), SPH_C32(0xaa490000),
    SPH_C32(0x6f877e31), SPH_C32(0xba799aea), SPH_C32(0xfb48da31),
    SPH_C32(0x55b05115) },
  { SPH_C32(0xd2610000), SPH_C32(0x0f201700), SPH_C32(0x75cd0000),
    SPH_C32(0xcf0d0000), SPH_C32(0xb67e487d), SPH_C32(0x5dff6001),
    SPH_C32(0x8a0b08a4), SPH_C32(0x3eaedc55), SPH_C32(0x138a0000),
    SPH_C32(0x923f3900), SPH_C32(0x948a0000), SPH_C32(0xf6a30000),
    SPH_C32(0x5c2d4e2b), SPH_C32(0xaffbbffe), SPH_C32(0x6eeb914a),
    SPH_C32(0xe1fb5185) },
  { SPH_C32(0xde130000), SPH_C32(0x46c51800), SPH_C32(0x37b40000),
    SPH_C32(0x93e70000), SPH_C32(0x85d47867), SPH_C32(0x487d4515),
    SPH_C32(0x1fa843df), SPH_C32(0x8ae5dcc5), SPH_C32(0xeda80000),
    SPH_C32(0x35673c00), SPH_C32(0xb15b0000), SPH_C32(0x01c30000),
    SPH_C32(0xd51c36f1), SPH_C32(0xb02f479e), SPH_C32(0x203b325f),
    SPH_C32(0x40d8ae1a) },
  { SPH_C32(0xa4c20000), SPH_C32(0xd9372400), SPH_C32(0x0a480000),
    SPH_C32(0x66610000), SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c),
    SPH_C32(0xa324df94), SPH_C32(0x2ba05a55), SPH_C32(0x75a40000),
    SPH_C32(0xc28b2700), SPH_C32(0x94a40000), SPH_C32(0x90f50000),
    SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae), SPH_C32(0x1767c483),
    SPH_C32(0xaedf667e) },
  { SPH_C32(0xa8b00000), SPH_C32(0x90d22b00), SPH_C32(0x48310000),
    SPH_C32(0x3a8b0000), SPH_C32(0xcbd022dd), SPH_C32(0x933cd248),
    SPH_C32(0x368794ef), SPH_C32(0x9feb5ac5), SPH_C32(0x8b860000),
    SPH_C32(0x65d32200), SPH_C32(0xb1750000), SPH_C32(0x67950000),
    SPH_C32(0x72492f3a), SPH_C32(0x561af3ce), SPH_C32(0x59b76796),
    SPH_C32(0x0ffc99e1) },
  { SPH_C32(0x5ae00000), SPH_C32(0x7e6f2100), SPH_C32(0x2f990000),
    SPH_C32(0x91010000), SPH_C32(0x714b6a1d), SPH_C32(0x996a0f3c),
    SPH_C32(0xedf47c81), SPH_C32(0x8a83a5ca), SPH_C32(0x87f40000),
    SPH_C32(0x2c362d00), SPH_C32(0xf30c0000), SPH_C32(0x3b7f0000),
    SPH_C32(0x41e31f20), SPH_C32(0x4398d6da), SPH_C32(0xcc142ced),
    SPH_C32(0xbbb79971) },
  { SPH_C32(0x56920000), SPH_C32(0x378a2e00), SPH_C32(0x6de00000),
    SPH_C32(0xcdeb0000), SPH_C32(0x42e15a07), SPH_C32(0x8ce82a28),
    SPH_C32(0x785737fa), SPH_C32(0x3ec8a55a), SPH_C32(0x79d60000),
    SPH_C32(0x8b6e2800), SPH_C32(0xd6dd0000), SPH_C32(0xcc1f0000),
    SPH_C32(0xc8d267fa), SPH_C32(0x5c4c2eba), SPH_C32(0x82c48ff8),
    SPH_C32(0x1a9466ee) },
  { SPH_C32(0xe1da0000), SPH_C32(0x7c823300), SPH_C32(0xf3220000),
    SPH_C32(0x5d290000), SPH_C32(0xe6b606eb), SPH_C32(0xa5ad628a),
    SPH_C32(0xb5987924), SPH_C32(0xf493ae8a), SPH_C32(0xcd990000),
    SPH_C32(0xd4fa2100), SPH_C32(0xa33e0000), SPH_C32(0x65440000),
    SPH_C32(0xd9f9364c), SPH_C32(0xe786faeb), SPH_C32(0x7143d295),
    SPH_C32(0x6b1e8d40) },
  { SPH_C32(0xeda80000), SPH_C32(0x35673c00), SPH_C32(0xb15b0000),
    SPH_C32(0x01c30000), SPH_C32(0xd51c36f1), SPH_C32(0xb02f479e),
    SPH_C32(0x203b325f), SPH_C32(0x40d8ae1a), SPH_C32(0x33bb0000),
    SPH_C32(0x73a22400), SPH_C32(0x86ef0000), SPH_C32(0x92240000),
    SPH_C32(0x50c84e96), SPH_C32(0xf852028b), SPH_C32(0x3f937180),
    SPH_C32(0xca3d72df) },
  { SPH_C32(0x1ff80000), SPH_C32(0xdbda3600), SPH_C32(0xd6f30000),
    SPH_C32(0xaa490000), SPH_C32(0x6f877e31), SPH_C32(0xba799aea),
    SPH_C32(0xfb48da31), SPH_C32(0x55b05115), SPH_C32(0x3fc90000),
    SPH_C32(0x3a472b00), SPH_C32(0xc4960000), SPH_C32(0xcece0000),
    SPH_C32(0x63627e8c), SPH_C32(0xedd0279f), SPH_C32(0xaa303afb),
    SPH_C32(0x7e76724f) },
  { SPH_C32(0x138a0000), SPH_C32(0x923f3900), SPH_C32(0x948a0000),
    SPH_C32(0xf6a30000), SPH_C32(0x5c2d4e2b), SPH_C32(0xaffbbffe),
    SPH_C32(0x6eeb914a), SPH_C32(0xe1fb5185), SPH_C32(0xc1eb0000),
    SPH_C32(0x9d1f2e00), SPH_C32(0xe1470000), SPH_C32(0x39ae0000),
    SPH_C32(0xea530656), SPH_C32(0xf204dfff), SPH_C32(0xe4e099ee),
    SPH_C32(0xdf558dd0) },
  { SPH_C32(0x1cff0000), SPH_C32(0xcf462200), SPH_C32(0x3dd20000),
    SPH_C32(0x93d00000), SPH_C32(0xdafb736b), SPH_C32(0x28f60619),
    SPH_C32(0xc500c982), SPH_C32(0xee61b16b), SPH_C32(0x88810000),
    SPH_C32(0x714f3600), SPH_C32(0x5a540000), SPH_C32(0x5e0c0000),
    SPH_C32(0xc7352260), SPH_C32(0xc4956f3d), SPH_C32(0x67ff7425),
    SPH_C32(0xb42d799f) },
  { SPH_C32(0x108d0000), SPH_C32(0x86a32d00), SPH_C32(0x7fab0000),
    SPH_C32(0xcf3a0000), SPH_C32(0xe9514371), SPH_C32(0x3d74230d),
    SPH_C32(0x50a382f9), SPH_C32(0x5a2ab1fb), SPH_C32(0x76a30000),
    SPH_C32(0xd6173300), SPH_C32(0x7f850000), SPH_C32(0xa96c0000),
    SPH_C32(0x4e045aba), SPH_C32(0xdb41975d), SPH_C32(0x292fd730),
    SPH_C32(0x150e8600) },
  { SPH_C32(0xe2dd0000), SPH_C32(0x681e2700), SPH_C32(0x18030000),
    SPH_C32(0x64b00000), SPH_C32(0x53ca0bb1), SPH_C32(0x3722fe79),
    SPH_C32(0x8bd06a97), SPH_C32(0x4f424ef4), SPH_C32(0x7ad10000),
    SPH_C32(0x9ff23c00), SPH_C32(0x3dfc0000), SPH_C32(0xf5860000),
    SPH_C32(0x7dae6aa0), SPH_C32(0xcec3b249), SPH_C32(0xbc8c9c4b),
    SPH_C32(0xa1458690) },
  { SPH_C32(0xeeaf0000), SPH_C32(0x21fb2800), SPH_C32(0x5a7a0000),
    SPH_C32(0x385a0000), SPH_C32(0x60603bab), SPH_C32(0x22a0db6d),
    SPH_C32(0x1e7321ec), SPH_C32(0xfb094e64), SPH_C32(0x84f30000),
    SPH_C32(0x38aa3900), SPH_C32(0x182d0000), SPH_C32(0x02e60000),
    SPH_C32(0xf49f127a), SPH_C32(0xd1174a29), SPH_C32(0xf25c3f5e),
    SPH_C32(0x0066790f) },
  { SPH_C32(0x59e70000), SPH_C32(0x6af33500), SPH_C32(0xc4b80000),
    SPH_C32(0xa8980000), SPH_C32(0xc4376747), SPH_C32(0x0be593cf),
    SPH_C32(0xd3bc6f32), SPH_C32(0x315245b4), SPH_C32(0x30bc0000),
    SPH_C32(0x673e3000), SPH_C32(0x6dce0000), SPH_C32(0xabbd0000),
    SPH_C32(0xe5b443cc), SPH_C32(0x6add9e78), SPH_C32(0x01db6233),
    SPH_C32(0x71ec92a1) },
  { SPH_C32(0x55950000), SPH_C32(0x23163a00), SPH_C32(0x86c10000),
    SPH_C32(0xf4720000), SPH_C32(0xf79d575d), SPH_C32(0x1e67b6db),
    SPH_C32(0x461f2449), SPH_C32(0x85194524), SPH_C32(0xce9e0000),
    SPH_C32(0xc0663500), SPH_C32(0x481f0000), SPH_C32(0x5cdd0000),
    SPH_C32(0x6c853b16), SPH_C32(0x75096618), SPH_C32(0x4f0bc126),
    SPH_C32(0xd0cf6d3e) },
  { SPH_C32(0xa7c50000), SPH_C32(0xcdab3000), SPH_C32(0xe1690000),
    SPH_C32(0x5ff80000), SPH_C32(0x4d061f9d), SPH_C32(0x14316baf),
    SPH_C32(0x9d6ccc27), SPH_C32(0x9071ba2b), SPH_C32(0xc2ec0000),
    SPH_C32(0x89833a00), SPH_C32(0x0a660000), SPH_C32(0x00370000),
    SPH_C32(0x5f2f0b0c), SPH_C32(0x608b430c), SPH_C32(0xdaa88a5d),
    SPH_C32(0x64846dae) },
  { SPH_C32(0xabb70000), SPH_C32(0x844e3f00), SPH_C32(0xa3100000),
    SPH_C32(0x03120000), SPH_C32(0x7eac2f87), SPH_C32(0x01b34ebb),
    SPH_C32(0x08cf875c), SPH_C32(0x243ababb), SPH_C32(0x3cce0000),
    SPH_C32(0x2edb3f00), SPH_C32(0x2fb70000), SPH_C32(0xf7570000),
    SPH_C32(0xd61e73d6), SPH_C32(0x7f5fbb6c), SPH_C32(0x94782948),
    SPH_C32(0xc5a79231) }
};

__constant static const sph_u32 T512_24[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0xf75a0000), SPH_C32(0x19840028), SPH_C32(0xa2190000),
    SPH_C32(0xeef80000), SPH_C32(0xc0722516), SPH_C32(0x19981260),
    SPH_C32(0x73dba1e6), SPH_C32(0xe1844257), SPH_C32(0x14190000),
    SPH_C32(0x23ca003c), SPH_C32(0x50df0000), SPH_C32(0x44b60000),
    SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75), SPH_C32(0x61e610b0),
    SPH_C32(0xdbcadb80) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0x40490000), SPH_C32(0x25bb0060), SPH_C32(0x75710000),
    SPH_C32(0x2ea80000), SPH_C32(0x35c9296f), SPH_C32(0x5abd2967),
    SPH_C32(0xde5c0873), SPH_C32(0xa5bb8697), SPH_C32(0x5fce0000),
    SPH_C32(0xc675000c), SPH_C32(0xeb450000), SPH_C32(0x7b450000),
    SPH_C32(0x75063a62), SPH_C32(0x67cd2643), SPH_C32(0x122f6b61),
    SPH_C32(0x1675c999) },
  { SPH_C32(0xb7130000), SPH_C32(0x3c3f0048), SPH_C32(0xd7680000),
    SPH_C32(0xc0500000), SPH_C32(0xf5bb0c79), SPH_C32(0x43253b07),
    SPH_C32(0xad87a995), SPH_C32(0x443fc4c0), SPH_C32(0x4bd70000),
    SPH_C32(0xe5bf0030), SPH_C32(0xbb9a0000), SPH_C32(0x3ff30000),
    SPH_C32(0x6e6a5dd2), SPH_C32(0x5b3e8a36), SPH_C32(0x73c97bd1),
    SPH_C32(0xcdbf1219) },
  { SPH_C32(0xa30a0000), SPH_C32(0x1ff50074), SPH_C32(0x87b70000),
    SPH_C32(0x84e60000), SPH_C32(0xeed76bc9), SPH_C32(0x7fd69772),
    SPH_C32(0xcc61b925), SPH_C32(0x9ff51f40), SPH_C32(0xa8940000),
    SPH_C32(0xdff10024), SPH_C32(0x495c0000), SPH_C32(0x95bd0000),
    SPH_C32(0xb5741f74), SPH_C32(0x7e553423), SPH_C32(0x61f4ca87),
    SPH_C32(0xf7f18bce) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0xa8940000), SPH_C32(0xdff10024), SPH_C32(0x495c0000),
    SPH_C32(0x95bd0000), SPH_C32(0xb5741f74), SPH_C32(0x7e553423),
    SPH_C32(0x61f4ca87), SPH_C32(0xf7f18bce), SPH_C32(0x0b9e0000),
    SPH_C32(0xc0040050), SPH_C32(0xceeb0000), SPH_C32(0x115b0000),
    SPH_C32(0x5ba374bd), SPH_C32(0x0183a351), SPH_C32(0xad9573a2),
    SPH_C32(0x6804948e) },
  { SPH_C32(0x5fce0000), SPH_C32(0xc675000c), SPH_C32(0xeb450000),
    SPH_C32(0x7b450000), SPH_C32(0x75063a62), SPH_C32(0x67cd2643),
    SPH_C32(0x122f6b61), SPH_C32(0x1675c999), SPH_C32(0x1f870000),
    SPH_C32(0xe3ce006c), SPH_C32(0x9e340000), SPH_C32(0x55ed0000),
    SPH_C32(0x40cf130d), SPH_C32(0x3d700f24), SPH_C32(0xcc736312),
    SPH_C32(0xb3ce4f0e) },
  { SPH_C32(0x4bd70000), SPH_C32(0xe5bf0030), SPH_C32(0xbb9a0000),
    SPH_C32(0x3ff30000), SPH_C32(0x6e6a5dd2), SPH_C32(0x5b3e8a36),
    SPH_C32(0x73c97bd1), SPH_C32(0xcdbf1219), SPH_C32(0xfcc40000),
    SPH_C32(0xd9800078), SPH_C32(0x6cf20000), SPH_C32(0xffa30000),
    SPH_C32(0x9bd151ab), SPH_C32(0x181bb131), SPH_C32(0xde4ed244),
    SPH_C32(0x8980d6d9) },
  { SPH_C32(0xe8dd0000), SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000),
    SPH_C32(0xbb150000), SPH_C32(0x80bd361b), SPH_C32(0x24e81d44),
    SPH_C32(0xbfa8c2f4), SPH_C32(0x524a0d59), SPH_C32(0x54500000),
    SPH_C32(0x0671005c), SPH_C32(0x25ae0000), SPH_C32(0x6a1e0000),
    SPH_C32(0x2ea54edf), SPH_C32(0x664e8512), SPH_C32(0xbfba18c3),
    SPH_C32(0x7e715d17) },
  { SPH_C32(0xfcc40000), SPH_C32(0xd9800078), SPH_C32(0x6cf20000),
    SPH_C32(0xffa30000), SPH_C32(0x9bd151ab), SPH_C32(0x181bb131),
    SPH_C32(0xde4ed244), SPH_C32(0x8980d6d9), SPH_C32(0xb7130000),
    SPH_C32(0x3c3f0048), SPH_C32(0xd7680000), SPH_C32(0xc0500000),
    SPH_C32(0xf5bb0c79), SPH_C32(0x43253b07), SPH_C32(0xad87a995),
    SPH_C32(0x443fc4c0) },
  { SPH_C32(0x0b9e0000), SPH_C32(0xc0040050), SPH_C32(0xceeb0000),
    SPH_C32(0x115b0000), SPH_C32(0x5ba374bd), SPH_C32(0x0183a351),
    SPH_C32(0xad9573a2), SPH_C32(0x6804948e), SPH_C32(0xa30a0000),
    SPH_C32(0x1ff50074), SPH_C32(0x87b70000), SPH_C32(0x84e60000),
    SPH_C32(0xeed76bc9), SPH_C32(0x7fd69772), SPH_C32(0xcc61b925),
    SPH_C32(0x9ff51f40) },
  { SPH_C32(0x1f870000), SPH_C32(0xe3ce006c), SPH_C32(0x9e340000),
    SPH_C32(0x55ed0000), SPH_C32(0x40cf130d), SPH_C32(0x3d700f24),
    SPH_C32(0xcc736312), SPH_C32(0xb3ce4f0e), SPH_C32(0x40490000),
    SPH_C32(0x25bb0060), SPH_C32(0x75710000), SPH_C32(0x2ea80000),
    SPH_C32(0x35c9296f), SPH_C32(0x5abd2967), SPH_C32(0xde5c0873),
    SPH_C32(0xa5bb8697) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0x7d480000), SPH_C32(0xf72b00a0), SPH_C32(0x93fc0000),
    SPH_C32(0xe8990000), SPH_C32(0xfff96c1e), SPH_C32(0xf257b9a9),
    SPH_C32(0xe60a38cc), SPH_C32(0x672b784e), SPH_C32(0x25300000),
    SPH_C32(0x95c30018), SPH_C32(0x56070000), SPH_C32(0x8bc30000),
    SPH_C32(0xf80f5721), SPH_C32(0x5c78ef3a), SPH_C32(0x0f151dde),
    SPH_C32(0x0dc348a4) },
  { SPH_C32(0x8a120000), SPH_C32(0xeeaf0088), SPH_C32(0x31e50000),
    SPH_C32(0x06610000), SPH_C32(0x3f8b4908), SPH_C32(0xebcfabc9),
    SPH_C32(0x95d1992a), SPH_C32(0x86af3a19), SPH_C32(0x31290000),
    SPH_C32(0xb6090024), SPH_C32(0x06d80000), SPH_C32(0xcf750000),
    SPH_C32(0xe3633091), SPH_C32(0x608b434f), SPH_C32(0x6ef30d6e),
    SPH_C32(0xd6099324) },
  { SPH_C32(0x9e0b0000), SPH_C32(0xcd6500b4), SPH_C32(0x613a0000),
    SPH_C32(0x42d70000), SPH_C32(0x24e72eb8), SPH_C32(0xd73c07bc),
    SPH_C32(0xf437899a), SPH_C32(0x5d65e199), SPH_C32(0xd26a0000),
    SPH_C32(0x8c470030), SPH_C32(0xf41e0000), SPH_C32(0x653b0000),
    SPH_C32(0x387d7237), SPH_C32(0x45e0fd5a), SPH_C32(0x7ccebc38),
    SPH_C32(0xec470af3) },
  { SPH_C32(0x3d010000), SPH_C32(0xd29000c0), SPH_C32(0xe68d0000),
    SPH_C32(0xc6310000), SPH_C32(0xca304571), SPH_C32(0xa8ea90ce),
    SPH_C32(0x385630bf), SPH_C32(0xc290fed9), SPH_C32(0x7afe0000),
    SPH_C32(0x53b60014), SPH_C32(0xbd420000), SPH_C32(0xf0860000),
    SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979), SPH_C32(0x1d3a76bf),
    SPH_C32(0x1bb6813d) },
  { SPH_C32(0x29180000), SPH_C32(0xf15a00fc), SPH_C32(0xb6520000),
    SPH_C32(0x82870000), SPH_C32(0xd15c22c1), SPH_C32(0x94193cbb),
    SPH_C32(0x59b0200f), SPH_C32(0x195a2559), SPH_C32(0x99bd0000),
    SPH_C32(0x69f80000), SPH_C32(0x4f840000), SPH_C32(0x5ac80000),
    SPH_C32(0x56172fe5), SPH_C32(0x1ede776c), SPH_C32(0x0f07c7e9),
    SPH_C32(0x21f818ea) },
  { SPH_C32(0xde420000), SPH_C32(0xe8de00d4), SPH_C32(0x144b0000),
    SPH_C32(0x6c7f0000), SPH_C32(0x112e07d7), SPH_C32(0x8d812edb),
    SPH_C32(0x2a6b81e9), SPH_C32(0xf8de670e), SPH_C32(0x8da40000),
    SPH_C32(0x4a32003c), SPH_C32(0x1f5b0000), SPH_C32(0x1e7e0000),
    SPH_C32(0x4d7b4855), SPH_C32(0x222ddb19), SPH_C32(0x6ee1d759),
    SPH_C32(0xfa32c36a) },
  { SPH_C32(0xca5b0000), SPH_C32(0xcb1400e8), SPH_C32(0x44940000),
    SPH_C32(0x28c90000), SPH_C32(0x0a426067), SPH_C32(0xb17282ae),
    SPH_C32(0x4b8d9159), SPH_C32(0x2314bc8e), SPH_C32(0x6ee70000),
    SPH_C32(0x707c0028), SPH_C32(0xed9d0000), SPH_C32(0xb4300000),
    SPH_C32(0x96650af3), SPH_C32(0x0746650c), SPH_C32(0x7cdc660f),
    SPH_C32(0xc07c5abd) },
  { SPH_C32(0xd5dc0000), SPH_C32(0x28da0084), SPH_C32(0xdaa00000),
    SPH_C32(0x7d240000), SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a),
    SPH_C32(0x87fef24b), SPH_C32(0x90daf380), SPH_C32(0x2eae0000),
    SPH_C32(0x55c70048), SPH_C32(0x98ec0000), SPH_C32(0x9a980000),
    SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b), SPH_C32(0xa2806e7c),
    SPH_C32(0x65c7dc2a) },
  { SPH_C32(0xc1c50000), SPH_C32(0x0b1000b8), SPH_C32(0x8a7f0000),
    SPH_C32(0x39920000), SPH_C32(0x51e114da), SPH_C32(0xb0f121ff),
    SPH_C32(0xe618e2fb), SPH_C32(0x4b102800), SPH_C32(0xcded0000),
    SPH_C32(0x6f89005c), SPH_C32(0x6a2a0000), SPH_C32(0x30d60000),
    SPH_C32(0x78b2613a), SPH_C32(0x7890f27e), SPH_C32(0xb0bddf2a),
    SPH_C32(0x5f8945fd) },
  { SPH_C32(0x369f0000), SPH_C32(0x12940090), SPH_C32(0x28660000),
    SPH_C32(0xd76a0000), SPH_C32(0x919331cc), SPH_C32(0xa969339f),
    SPH_C32(0x95c3431d), SPH_C32(0xaa946a57), SPH_C32(0xd9f40000),
    SPH_C32(0x4c430060), SPH_C32(0x3af50000), SPH_C32(0x74600000),
    SPH_C32(0x63de068a), SPH_C32(0x44635e0b), SPH_C32(0xd15bcf9a),
    SPH_C32(0x84439e7d) },
  { SPH_C32(0x22860000), SPH_C32(0x315e00ac), SPH_C32(0x78b90000),
    SPH_C32(0x93dc0000), SPH_C32(0x8aff567c), SPH_C32(0x959a9fea),
    SPH_C32(0xf42553ad), SPH_C32(0x715eb1d7), SPH_C32(0x3ab70000),
    SPH_C32(0x760d0074), SPH_C32(0xc8330000), SPH_C32(0xde2e0000),
    SPH_C32(0xb8c0442c), SPH_C32(0x6108e01e), SPH_C32(0xc3667ecc),
    SPH_C32(0xbe0d07aa) },
  { SPH_C32(0x818c0000), SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000),
    SPH_C32(0x173a0000), SPH_C32(0x64283db5), SPH_C32(0xea4c0898),
    SPH_C32(0x3844ea88), SPH_C32(0xeeabae97), SPH_C32(0x92230000),
    SPH_C32(0xa9fc0050), SPH_C32(0x816f0000), SPH_C32(0x4b930000),
    SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d), SPH_C32(0xa292b44b),
    SPH_C32(0x49fc8c64) },
  { SPH_C32(0x95950000), SPH_C32(0x0d6100e4), SPH_C32(0xafd10000),
    SPH_C32(0x538c0000), SPH_C32(0x7f445a05), SPH_C32(0xd6bfa4ed),
    SPH_C32(0x59a2fa38), SPH_C32(0x35617517), SPH_C32(0x71600000),
    SPH_C32(0x93b20044), SPH_C32(0x73a90000), SPH_C32(0xe1dd0000),
    SPH_C32(0xd6aa19fe), SPH_C32(0x3a366a28), SPH_C32(0xb0af051d),
    SPH_C32(0x73b215b3) },
  { SPH_C32(0x62cf0000), SPH_C32(0x14e500cc), SPH_C32(0x0dc80000),
    SPH_C32(0xbd740000), SPH_C32(0xbf367f13), SPH_C32(0xcf27b68d),
    SPH_C32(0x2a795bde), SPH_C32(0xd4e53740), SPH_C32(0x65790000),
    SPH_C32(0xb0780078), SPH_C32(0x23760000), SPH_C32(0xa56b0000),
    SPH_C32(0xcdc67e4e), SPH_C32(0x06c5c65d), SPH_C32(0xd14915ad),
    SPH_C32(0xa878ce33) },
  { SPH_C32(0x76d60000), SPH_C32(0x372f00f0), SPH_C32(0x5d170000),
    SPH_C32(0xf9c20000), SPH_C32(0xa45a18a3), SPH_C32(0xf3d41af8),
    SPH_C32(0x4b9f4b6e), SPH_C32(0x0f2fecc0), SPH_C32(0x863a0000),
    SPH_C32(0x8a36006c), SPH_C32(0xd1b00000), SPH_C32(0x0f250000),
    SPH_C32(0x16d83ce8), SPH_C32(0x23ae7848), SPH_C32(0xc374a4fb),
    SPH_C32(0x923657e4) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0xd26a0000), SPH_C32(0x8c470030), SPH_C32(0xf41e0000),
    SPH_C32(0x653b0000), SPH_C32(0x387d7237), SPH_C32(0x45e0fd5a),
    SPH_C32(0x7ccebc38), SPH_C32(0xec470af3), SPH_C32(0x4c610000),
    SPH_C32(0x41220084), SPH_C32(0x95240000), SPH_C32(0x27ec0000),
    SPH_C32(0x1c9a5c8f), SPH_C32(0x92dcfae6), SPH_C32(0x88f935a2),
    SPH_C32(0xb122eb6a) },
  { SPH_C32(0x25300000), SPH_C32(0x95c30018), SPH_C32(0x56070000),
    SPH_C32(0x8bc30000), SPH_C32(0xf80f5721), SPH_C32(0x5c78ef3a),
    SPH_C32(0x0f151dde), SPH_C32(0x0dc348a4), SPH_C32(0x58780000),
    SPH_C32(0x62e800b8), SPH_C32(0xc5fb0000), SPH_C32(0x635a0000),
    SPH_C32(0x07f63b3f), SPH_C32(0xae2f5693), SPH_C32(0xe91f2512),
    SPH_C32(0x6ae830ea) },
  { SPH_C32(0x31290000), SPH_C32(0xb6090024), SPH_C32(0x06d80000),
    SPH_C32(0xcf750000), SPH_C32(0xe3633091), SPH_C32(0x608b434f),
    SPH_C32(0x6ef30d6e), SPH_C32(0xd6099324), SPH_C32(0xbb3b0000),
    SPH_C32(0x58a600ac), SPH_C32(0x373d0000), SPH_C32(0xc9140000),
    SPH_C32(0xdce87999), SPH_C32(0x8b44e886), SPH_C32(0xfb229444),
    SPH_C32(0x50a6a93d) },
  { SPH_C32(0x92230000), SPH_C32(0xa9fc0050), SPH_C32(0x816f0000),
    SPH_C32(0x4b930000), SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d),
    SPH_C32(0xa292b44b), SPH_C32(0x49fc8c64), SPH_C32(0x13af0000),
    SPH_C32(0x87570088), SPH_C32(0x7e610000), SPH_C32(0x5ca90000),
    SPH_C32(0x699c66ed), SPH_C32(0xf511dca5), SPH_C32(0x9ad65ec3),
    SPH_C32(0xa75722f3) },
  { SPH_C32(0x863a0000), SPH_C32(0x8a36006c), SPH_C32(0xd1b00000),
    SPH_C32(0x0f250000), SPH_C32(0x16d83ce8), SPH_C32(0x23ae7848),
    SPH_C32(0xc374a4fb), SPH_C32(0x923657e4), SPH_C32(0xf0ec0000),
    SPH_C32(0xbd19009c), SPH_C32(0x8ca70000), SPH_C32(0xf6e70000),
    SPH_C32(0xb282244b), SPH_C32(0xd07a62b0), SPH_C32(0x88ebef95),
    SPH_C32(0x9d19bb24) },
  { SPH_C32(0x71600000), SPH_C32(0x93b20044), SPH_C32(0x73a90000),
    SPH_C32(0xe1dd0000), SPH_C32(0xd6aa19fe), SPH_C32(0x3a366a28),
    SPH_C32(0xb0af051d), SPH_C32(0x73b215b3), SPH_C32(0xe4f50000),
    SPH_C32(0x9ed300a0), SPH_C32(0xdc780000), SPH_C32(0xb2510000),
    SPH_C32(0xa9ee43fb), SPH_C32(0xec89cec5), SPH_C32(0xe90dff25),
    SPH_C32(0x46d360a4) },
  { SPH_C32(0x65790000), SPH_C32(0xb0780078), SPH_C32(0x23760000),
    SPH_C32(0xa56b0000), SPH_C32(0xcdc67e4e), SPH_C32(0x06c5c65d),
    SPH_C32(0xd14915ad), SPH_C32(0xa878ce33), SPH_C32(0x07b60000),
    SPH_C32(0xa49d00b4), SPH_C32(0x2ebe0000), SPH_C32(0x181f0000),
    SPH_C32(0x72f0015d), SPH_C32(0xc9e270d0), SPH_C32(0xfb304e73),
    SPH_C32(0x7c9df973) },
  { SPH_C32(0x7afe0000), SPH_C32(0x53b60014), SPH_C32(0xbd420000),
    SPH_C32(0xf0860000), SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979),
    SPH_C32(0x1d3a76bf), SPH_C32(0x1bb6813d), SPH_C32(0x47ff0000),
    SPH_C32(0x812600d4), SPH_C32(0x5bcf0000), SPH_C32(0x36b70000),
    SPH_C32(0x47392832), SPH_C32(0x935f59b7), SPH_C32(0x256c4600),
    SPH_C32(0xd9267fe4) },
  { SPH_C32(0x6ee70000), SPH_C32(0x707c0028), SPH_C32(0xed9d0000),
    SPH_C32(0xb4300000), SPH_C32(0x96650af3), SPH_C32(0x0746650c),
    SPH_C32(0x7cdc660f), SPH_C32(0xc07c5abd), SPH_C32(0xa4bc0000),
    SPH_C32(0xbb6800c0), SPH_C32(0xa9090000), SPH_C32(0x9cf90000),
    SPH_C32(0x9c276a94), SPH_C32(0xb634e7a2), SPH_C32(0x3751f756),
    SPH_C32(0xe368e633) },
  { SPH_C32(0x99bd0000), SPH_C32(0x69f80000), SPH_C32(0x4f840000),
    SPH_C32(0x5ac80000), SPH_C32(0x56172fe5), SPH_C32(0x1ede776c),
    SPH_C32(0x0f07c7e9), SPH_C32(0x21f818ea), SPH_C32(0xb0a50000),
    SPH_C32(0x98a200fc), SPH_C32(0xf9d60000), SPH_C32(0xd84f0000),
    SPH_C32(0x874b0d24), SPH_C32(0x8ac74bd7), SPH_C32(0x56b7e7e6),
    SPH_C32(0x38a23db3) },
  { SPH_C32(0x8da40000), SPH_C32(0x4a32003c), SPH_C32(0x1f5b0000),
    SPH_C32(0x1e7e0000), SPH_C32(0x4d7b4855), SPH_C32(0x222ddb19),
    SPH_C32(0x6ee1d759), SPH_C32(0xfa32c36a), SPH_C32(0x53e60000),
    SPH_C32(0xa2ec00e8), SPH_C32(0x0b100000), SPH_C32(0x72010000),
    SPH_C32(0x5c554f82), SPH_C32(0xafacf5c2), SPH_C32(0x448a56b0),
    SPH_C32(0x02eca464) },
  { SPH_C32(0x2eae0000), SPH_C32(0x55c70048), SPH_C32(0x98ec0000),
    SPH_C32(0x9a980000), SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b),
    SPH_C32(0xa2806e7c), SPH_C32(0x65c7dc2a), SPH_C32(0xfb720000),
    SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000), SPH_C32(0xe7bc0000),
    SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1), SPH_C32(0x257e9c37),
    SPH_C32(0xf51d2faa) },
  { SPH_C32(0x3ab70000), SPH_C32(0x760d0074), SPH_C32(0xc8330000),
    SPH_C32(0xde2e0000), SPH_C32(0xb8c0442c), SPH_C32(0x6108e01e),
    SPH_C32(0xc3667ecc), SPH_C32(0xbe0d07aa), SPH_C32(0x18310000),
    SPH_C32(0x475300d8), SPH_C32(0xb08a0000), SPH_C32(0x4df20000),
    SPH_C32(0x323f1250), SPH_C32(0xf4927ff4), SPH_C32(0x37432d61),
    SPH_C32(0xcf53b67d) },
  { SPH_C32(0xcded0000), SPH_C32(0x6f89005c), SPH_C32(0x6a2a0000),
    SPH_C32(0x30d60000), SPH_C32(0x78b2613a), SPH_C32(0x7890f27e),
    SPH_C32(0xb0bddf2a), SPH_C32(0x5f8945fd), SPH_C32(0x0c280000),
    SPH_C32(0x649900e4), SPH_C32(0xe0550000), SPH_C32(0x09440000),
    SPH_C32(0x295375e0), SPH_C32(0xc861d381), SPH_C32(0x56a53dd1),
    SPH_C32(0x14996dfd) },
  { SPH_C32(0xd9f40000), SPH_C32(0x4c430060), SPH_C32(0x3af50000),
    SPH_C32(0x74600000), SPH_C32(0x63de068a), SPH_C32(0x44635e0b),
    SPH_C32(0xd15bcf9a), SPH_C32(0x84439e7d), SPH_C32(0xef6b0000),
    SPH_C32(0x5ed700f0), SPH_C32(0x12930000), SPH_C32(0xa30a0000),
    SPH_C32(0xf24d3746), SPH_C32(0xed0a6d94), SPH_C32(0x44988c87),
    SPH_C32(0x2ed7f42a) },
  { SPH_C32(0xaf220000), SPH_C32(0x7b6c0090), SPH_C32(0x67e20000),
    SPH_C32(0x8da20000), SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3),
    SPH_C32(0x9ac484f4), SPH_C32(0x8b6c72bd), SPH_C32(0x69510000),
    SPH_C32(0xd4e1009c), SPH_C32(0xc3230000), SPH_C32(0xac2f0000),
    SPH_C32(0xe4950bae), SPH_C32(0xcea415dc), SPH_C32(0x87ec287c),
    SPH_C32(0xbce1a3ce) },
  { SPH_C32(0xbb3b0000), SPH_C32(0x58a600ac), SPH_C32(0x373d0000),
    SPH_C32(0xc9140000), SPH_C32(0xdce87999), SPH_C32(0x8b44e886),
    SPH_C32(0xfb229444), SPH_C32(0x50a6a93d), SPH_C32(0x8a120000),
    SPH_C32(0xeeaf0088), SPH_C32(0x31e50000), SPH_C32(0x06610000),
    SPH_C32(0x3f8b4908), SPH_C32(0xebcfabc9), SPH_C32(0x95d1992a),
    SPH_C32(0x86af3a19) },
  { SPH_C32(0x4c610000), SPH_C32(0x41220084), SPH_C32(0x95240000),
    SPH_C32(0x27ec0000), SPH_C32(0x1c9a5c8f), SPH_C32(0x92dcfae6),
    SPH_C32(0x88f935a2), SPH_C32(0xb122eb6a), SPH_C32(0x9e0b0000),
    SPH_C32(0xcd6500b4), SPH_C32(0x613a0000), SPH_C32(0x42d70000),
    SPH_C32(0x24e72eb8), SPH_C32(0xd73c07bc), SPH_C32(0xf437899a),
    SPH_C32(0x5d65e199) },
  { SPH_C32(0x58780000), SPH_C32(0x62e800b8), SPH_C32(0xc5fb0000),
    SPH_C32(0x635a0000), SPH_C32(0x07f63b3f), SPH_C32(0xae2f5693),
    SPH_C32(0xe91f2512), SPH_C32(0x6ae830ea), SPH_C32(0x7d480000),
    SPH_C32(0xf72b00a0), SPH_C32(0x93fc0000), SPH_C32(0xe8990000),
    SPH_C32(0xfff96c1e), SPH_C32(0xf257b9a9), SPH_C32(0xe60a38cc),
    SPH_C32(0x672b784e) },
  { SPH_C32(0xfb720000), SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000),
    SPH_C32(0xe7bc0000), SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1),
    SPH_C32(0x257e9c37), SPH_C32(0xf51d2faa), SPH_C32(0xd5dc0000),
    SPH_C32(0x28da0084), SPH_C32(0xdaa00000), SPH_C32(0x7d240000),
    SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a), SPH_C32(0x87fef24b),
    SPH_C32(0x90daf380) },
  { SPH_C32(0xef6b0000), SPH_C32(0x5ed700f0), SPH_C32(0x12930000),
    SPH_C32(0xa30a0000), SPH_C32(0xf24d3746), SPH_C32(0xed0a6d94),
    SPH_C32(0x44988c87), SPH_C32(0x2ed7f42a), SPH_C32(0x369f0000),
    SPH_C32(0x12940090), SPH_C32(0x28660000), SPH_C32(0xd76a0000),
    SPH_C32(0x919331cc), SPH_C32(0xa969339f), SPH_C32(0x95c3431d),
    SPH_C32(0xaa946a57) },
  { SPH_C32(0x18310000), SPH_C32(0x475300d8), SPH_C32(0xb08a0000),
    SPH_C32(0x4df20000), SPH_C32(0x323f1250), SPH_C32(0xf4927ff4),
    SPH_C32(0x37432d61), SPH_C32(0xcf53b67d), SPH_C32(0x22860000),
    SPH_C32(0x315e00ac), SPH_C32(0x78b90000), SPH_C32(0x93dc0000),
    SPH_C32(0x8aff567c), SPH_C32(0x959a9fea), SPH_C32(0xf42553ad),
    SPH_C32(0x715eb1d7) },
  { SPH_C32(0x0c280000), SPH_C32(0x649900e4), SPH_C32(0xe0550000),
    SPH_C32(0x09440000), SPH_C32(0x295375e0), SPH_C32(0xc861d381),
    SPH_C32(0x56a53dd1), SPH_C32(0x14996dfd), SPH_C32(0xc1c50000),
    SPH_C32(0x0b1000b8), SPH_C32(0x8a7f0000), SPH_C32(0x39920000),
    SPH_C32(0x51e114da), SPH_C32(0xb0f121ff), SPH_C32(0xe618e2fb),
    SPH_C32(0x4b102800) },
  { SPH_C32(0x13af0000), SPH_C32(0x87570088), SPH_C32(0x7e610000),
    SPH_C32(0x5ca90000), SPH_C32(0x699c66ed), SPH_C32(0xf511dca5),
    SPH_C32(0x9ad65ec3), SPH_C32(0xa75722f3), SPH_C32(0x818c0000),
    SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000), SPH_C32(0x173a0000),
    SPH_C32(0x64283db5), SPH_C32(0xea4c0898), SPH_C32(0x3844ea88),
    SPH_C32(0xeeabae97) },
  { SPH_C32(0x07b60000), SPH_C32(0xa49d00b4), SPH_C32(0x2ebe0000),
    SPH_C32(0x181f0000), SPH_C32(0x72f0015d), SPH_C32(0xc9e270d0),
    SPH_C32(0xfb304e73), SPH_C32(0x7c9df973), SPH_C32(0x62cf0000),
    SPH_C32(0x14e500cc), SPH_C32(0x0dc80000), SPH_C32(0xbd740000),
    SPH_C32(0xbf367f13), SPH_C32(0xcf27b68d), SPH_C32(0x2a795bde),
    SPH_C32(0xd4e53740) },
  { SPH_C32(0xf0ec0000), SPH_C32(0xbd19009c), SPH_C32(0x8ca70000),
    SPH_C32(0xf6e70000), SPH_C32(0xb282244b), SPH_C32(0xd07a62b0),
    SPH_C32(0x88ebef95), SPH_C32(0x9d19bb24), SPH_C32(0x76d60000),
    SPH_C32(0x372f00f0), SPH_C32(0x5d170000), SPH_C32(0xf9c20000),
    SPH_C32(0xa45a18a3), SPH_C32(0xf3d41af8), SPH_C32(0x4b9f4b6e),
    SPH_C32(0x0f2fecc0) },
  { SPH_C32(0xe4f50000), SPH_C32(0x9ed300a0), SPH_C32(0xdc780000),
    SPH_C32(0xb2510000), SPH_C32(0xa9ee43fb), SPH_C32(0xec89cec5),
    SPH_C32(0xe90dff25), SPH_C32(0x46d360a4), SPH_C32(0x95950000),
    SPH_C32(0x0d6100e4), SPH_C32(0xafd10000), SPH_C32(0x538c0000),
    SPH_C32(0x7f445a05), SPH_C32(0xd6bfa4ed), SPH_C32(0x59a2fa38),
    SPH_C32(0x35617517) },
  { SPH_C32(0x47ff0000), SPH_C32(0x812600d4), SPH_C32(0x5bcf0000),
    SPH_C32(0x36b70000), SPH_C32(0x47392832), SPH_C32(0x935f59b7),
    SPH_C32(0x256c4600), SPH_C32(0xd9267fe4), SPH_C32(0x3d010000),
    SPH_C32(0xd29000c0), SPH_C32(0xe68d0000), SPH_C32(0xc6310000),
    SPH_C32(0xca304571), SPH_C32(0xa8ea90ce), SPH_C32(0x385630bf),
    SPH_C32(0xc290fed9) },
  { SPH_C32(0x53e60000), SPH_C32(0xa2ec00e8), SPH_C32(0x0b100000),
    SPH_C32(0x72010000), SPH_C32(0x5c554f82), SPH_C32(0xafacf5c2),
    SPH_C32(0x448a56b0), SPH_C32(0x02eca464), SPH_C32(0xde420000),
    SPH_C32(0xe8de00d4), SPH_C32(0x144b0000), SPH_C32(0x6c7f0000),
    SPH_C32(0x112e07d7), SPH_C32(0x8d812edb), SPH_C32(0x2a6b81e9),
    SPH_C32(0xf8de670e) },
  { SPH_C32(0xa4bc0000), SPH_C32(0xbb6800c0), SPH_C32(0xa9090000),
    SPH_C32(0x9cf90000), SPH_C32(0x9c276a94), SPH_C32(0xb634e7a2),
    SPH_C32(0x3751f756), SPH_C32(0xe368e633), SPH_C32(0xca5b0000),
    SPH_C32(0xcb1400e8), SPH_C32(0x44940000), SPH_C32(0x28c90000),
    SPH_C32(0x0a426067), SPH_C32(0xb17282ae), SPH_C32(0x4b8d9159),
    SPH_C32(0x2314bc8e) },
  { SPH_C32(0xb0a50000), SPH_C32(0x98a200fc), SPH_C32(0xf9d60000),
    SPH_C32(0xd84f0000), SPH_C32(0x874b0d24), SPH_C32(0x8ac74bd7),
    SPH_C32(0x56b7e7e6), SPH_C32(0x38a23db3), SPH_C32(0x29180000),
    SPH_C32(0xf15a00fc), SPH_C32(0xb6520000), SPH_C32(0x82870000),
    SPH_C32(0xd15c22c1), SPH_C32(0x94193cbb), SPH_C32(0x59b0200f),
    SPH_C32(0x195a2559) }
};

__constant static const sph_u32 T512_30[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xb2060000), SPH_C32(0xc5690000), SPH_C32(0x28031200),
    SPH_C32(0x74670000), SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8),
    SPH_C32(0x33d1dfec), SPH_C32(0x094e3198), SPH_C32(0xac480000),
    SPH_C32(0x1ba60000), SPH_C32(0x45fb1380), SPH_C32(0x03430000),
    SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6), SPH_C32(0xfe72c7fe),
    SPH_C32(0x91e478f6) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0x028b0000), SPH_C32(0x87e90001), SPH_C32(0x3c2af380),
    SPH_C32(0x2f560000), SPH_C32(0x1f4944d9), SPH_C32(0x79e2e780),
    SPH_C32(0x55e03071), SPH_C32(0x32f62e8d), SPH_C32(0xc56b0000),
    SPH_C32(0xd7e60000), SPH_C32(0x2452c180), SPH_C32(0xf6c50000),
    SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f), SPH_C32(0x8ef57364),
    SPH_C32(0x70c6f340) },
  { SPH_C32(0xb08d0000), SPH_C32(0x42800001), SPH_C32(0x1429e180),
    SPH_C32(0x5b310000), SPH_C32(0xa98b722d), SPH_C32(0x92f0de78),
    SPH_C32(0x6631ef9d), SPH_C32(0x3bb81f15), SPH_C32(0x69230000),
    SPH_C32(0xcc400000), SPH_C32(0x61a9d200), SPH_C32(0xf5860000),
    SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9), SPH_C32(0x7087b49a),
    SPH_C32(0xe1228bb6) },
  { SPH_C32(0x1cc50000), SPH_C32(0x59260001), SPH_C32(0x51d2f200),
    SPH_C32(0x58720000), SPH_C32(0xf30e4347), SPH_C32(0x8d428ece),
    SPH_C32(0x98432863), SPH_C32(0xaa5c67e3), SPH_C32(0x776d0000),
    SPH_C32(0x128f0000), SPH_C32(0x0c51d380), SPH_C32(0x82a20000),
    SPH_C32(0x907b5a33), SPH_C32(0x5dcb6487), SPH_C32(0xbd24ac88),
    SPH_C32(0x7988c2d8) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0x776d0000), SPH_C32(0x128f0000), SPH_C32(0x0c51d380),
    SPH_C32(0x82a20000), SPH_C32(0x907b5a33), SPH_C32(0x5dcb6487),
    SPH_C32(0xbd24ac88), SPH_C32(0x7988c2d8), SPH_C32(0x6ba80000),
    SPH_C32(0x4ba90001), SPH_C32(0x5d832180), SPH_C32(0xdad00000),
    SPH_C32(0x63751974), SPH_C32(0xd089ea49), SPH_C32(0x256784eb),
    SPH_C32(0xd3d4a53b) },
  { SPH_C32(0xc56b0000), SPH_C32(0xd7e60000), SPH_C32(0x2452c180),
    SPH_C32(0xf6c50000), SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f),
    SPH_C32(0x8ef57364), SPH_C32(0x70c6f340), SPH_C32(0xc7e00000),
    SPH_C32(0x500f0001), SPH_C32(0x18783200), SPH_C32(0xd9930000),
    SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff), SPH_C32(0xdb154315),
    SPH_C32(0x4230ddcd) },
  { SPH_C32(0x69230000), SPH_C32(0xcc400000), SPH_C32(0x61a9d200),
    SPH_C32(0xf5860000), SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9),
    SPH_C32(0x7087b49a), SPH_C32(0xe1228bb6), SPH_C32(0xd9ae0000),
    SPH_C32(0x8ec00001), SPH_C32(0x75803380), SPH_C32(0xaeb70000),
    SPH_C32(0xd5b72f80), SPH_C32(0x3b9bd3b1), SPH_C32(0x16b65b07),
    SPH_C32(0xda9a94a3) },
  { SPH_C32(0x75e60000), SPH_C32(0x95660001), SPH_C32(0x307b2000),
    SPH_C32(0xadf40000), SPH_C32(0x8f321eea), SPH_C32(0x24298307),
    SPH_C32(0xe8c49cf9), SPH_C32(0x4b7eec55), SPH_C32(0xaec30000),
    SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000), SPH_C32(0x2c150000),
    SPH_C32(0x45cc75b3), SPH_C32(0x6650b736), SPH_C32(0xab92f78f),
    SPH_C32(0xa312567b) },
  { SPH_C32(0xd9ae0000), SPH_C32(0x8ec00001), SPH_C32(0x75803380),
    SPH_C32(0xaeb70000), SPH_C32(0xd5b72f80), SPH_C32(0x3b9bd3b1),
    SPH_C32(0x16b65b07), SPH_C32(0xda9a94a3), SPH_C32(0xb08d0000),
    SPH_C32(0x42800001), SPH_C32(0x1429e180), SPH_C32(0x5b310000),
    SPH_C32(0xa98b722d), SPH_C32(0x92f0de78), SPH_C32(0x6631ef9d),
    SPH_C32(0x3bb81f15) },
  { SPH_C32(0x6ba80000), SPH_C32(0x4ba90001), SPH_C32(0x5d832180),
    SPH_C32(0xdad00000), SPH_C32(0x63751974), SPH_C32(0xd089ea49),
    SPH_C32(0x256784eb), SPH_C32(0xd3d4a53b), SPH_C32(0x1cc50000),
    SPH_C32(0x59260001), SPH_C32(0x51d2f200), SPH_C32(0x58720000),
    SPH_C32(0xf30e4347), SPH_C32(0x8d428ece), SPH_C32(0x98432863),
    SPH_C32(0xaa5c67e3) },
  { SPH_C32(0xc7e00000), SPH_C32(0x500f0001), SPH_C32(0x18783200),
    SPH_C32(0xd9930000), SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff),
    SPH_C32(0xdb154315), SPH_C32(0x4230ddcd), SPH_C32(0x028b0000),
    SPH_C32(0x87e90001), SPH_C32(0x3c2af380), SPH_C32(0x2f560000),
    SPH_C32(0x1f4944d9), SPH_C32(0x79e2e780), SPH_C32(0x55e03071),
    SPH_C32(0x32f62e8d) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x2a310000), SPH_C32(0x249f0002), SPH_C32(0xa461f380),
    SPH_C32(0x9b150000), SPH_C32(0xcfe05664), SPH_C32(0x513a985c),
    SPH_C32(0x2daf8eba), SPH_C32(0x87f9a24f), SPH_C32(0x2ef90000),
    SPH_C32(0x3b1f0000), SPH_C32(0x990c6180), SPH_C32(0x35e00000),
    SPH_C32(0x8fff3af4), SPH_C32(0x8c1afd2e), SPH_C32(0xec0cb9f8),
    SPH_C32(0x280f515a) },
  { SPH_C32(0x98370000), SPH_C32(0xe1f60002), SPH_C32(0x8c62e180),
    SPH_C32(0xef720000), SPH_C32(0x79226090), SPH_C32(0xba28a1a4),
    SPH_C32(0x1e7e5156), SPH_C32(0x8eb793d7), SPH_C32(0x82b10000),
    SPH_C32(0x20b90000), SPH_C32(0xdcf77200), SPH_C32(0x36a30000),
    SPH_C32(0xd57a0b9e), SPH_C32(0x93a8ad98), SPH_C32(0x127e7e06),
    SPH_C32(0xb9eb29ac) },
  { SPH_C32(0x347f0000), SPH_C32(0xfa500002), SPH_C32(0xc999f200),
    SPH_C32(0xec310000), SPH_C32(0x23a751fa), SPH_C32(0xa59af112),
    SPH_C32(0xe00c96a8), SPH_C32(0x1f53eb21), SPH_C32(0x9cff0000),
    SPH_C32(0xfe760000), SPH_C32(0xb10f7380), SPH_C32(0x41870000),
    SPH_C32(0x393d0c00), SPH_C32(0x6708c4d6), SPH_C32(0xdfdd6614),
    SPH_C32(0x214160c2) },
  { SPH_C32(0x28ba0000), SPH_C32(0xa3760003), SPH_C32(0x984b0000),
    SPH_C32(0xb4430000), SPH_C32(0xd0a912bd), SPH_C32(0x28d87fdc),
    SPH_C32(0x784fbecb), SPH_C32(0xb50f8cc2), SPH_C32(0xeb920000),
    SPH_C32(0xecf90000), SPH_C32(0xbd5ea000), SPH_C32(0xc3250000),
    SPH_C32(0xa9465633), SPH_C32(0x3ac3a051), SPH_C32(0x62f9ca9c),
    SPH_C32(0x58c9a21a) },
  { SPH_C32(0x84f20000), SPH_C32(0xb8d00003), SPH_C32(0xddb01380),
    SPH_C32(0xb7000000), SPH_C32(0x8a2c23d7), SPH_C32(0x376a2f6a),
    SPH_C32(0x863d7935), SPH_C32(0x24ebf434), SPH_C32(0xf5dc0000),
    SPH_C32(0x32360000), SPH_C32(0xd0a6a180), SPH_C32(0xb4010000),
    SPH_C32(0x450151ad), SPH_C32(0xce63c91f), SPH_C32(0xaf5ad28e),
    SPH_C32(0xc063eb74) },
  { SPH_C32(0x36f40000), SPH_C32(0x7db90003), SPH_C32(0xf5b30180),
    SPH_C32(0xc3670000), SPH_C32(0x3cee1523), SPH_C32(0xdc781692),
    SPH_C32(0xb5eca6d9), SPH_C32(0x2da5c5ac), SPH_C32(0x59940000),
    SPH_C32(0x29900000), SPH_C32(0x955db200), SPH_C32(0xb7420000),
    SPH_C32(0x1f8460c7), SPH_C32(0xd1d199a9), SPH_C32(0x51281570),
    SPH_C32(0x51879382) },
  { SPH_C32(0x9abc0000), SPH_C32(0x661f0003), SPH_C32(0xb0481200),
    SPH_C32(0xc0240000), SPH_C32(0x666b2449), SPH_C32(0xc3ca4624),
    SPH_C32(0x4b9e6127), SPH_C32(0xbc41bd5a), SPH_C32(0x47da0000),
    SPH_C32(0xf75f0000), SPH_C32(0xf8a5b380), SPH_C32(0xc0660000),
    SPH_C32(0xf3c36759), SPH_C32(0x2571f0e7), SPH_C32(0x9c8b0d62),
    SPH_C32(0xc92ddaec) },
  { SPH_C32(0x5d5c0000), SPH_C32(0x36100002), SPH_C32(0xa8302000),
    SPH_C32(0x19b70000), SPH_C32(0x5f9b0c57), SPH_C32(0x0cf1fcdb),
    SPH_C32(0x908b2232), SPH_C32(0xfe716097), SPH_C32(0x45510000),
    SPH_C32(0x70b60001), SPH_C32(0xc48f4000), SPH_C32(0xef300000),
    SPH_C32(0xec8a2380), SPH_C32(0x5c931767), SPH_C32(0xc96b3d13),
    SPH_C32(0xfbdbf461) },
  { SPH_C32(0xf1140000), SPH_C32(0x2db60002), SPH_C32(0xedcb3380),
    SPH_C32(0x1af40000), SPH_C32(0x051e3d3d), SPH_C32(0x1343ac6d),
    SPH_C32(0x6ef9e5cc), SPH_C32(0x6f951861), SPH_C32(0x5b1f0000),
    SPH_C32(0xae790001), SPH_C32(0xa9774180), SPH_C32(0x98140000),
    SPH_C32(0x00cd241e), SPH_C32(0xa8337e29), SPH_C32(0x04c82501),
    SPH_C32(0x6371bd0f) },
  { SPH_C32(0x43120000), SPH_C32(0xe8df0002), SPH_C32(0xc5c82180),
    SPH_C32(0x6e930000), SPH_C32(0xb3dc0bc9), SPH_C32(0xf8519595),
    SPH_C32(0x5d283a20), SPH_C32(0x66db29f9), SPH_C32(0xf7570000),
    SPH_C32(0xb5df0001), SPH_C32(0xec8c5200), SPH_C32(0x9b570000),
    SPH_C32(0x5a481574), SPH_C32(0xb7812e9f), SPH_C32(0xfabae2ff),
    SPH_C32(0xf295c5f9) },
  { SPH_C32(0xef5a0000), SPH_C32(0xf3790002), SPH_C32(0x80333200),
    SPH_C32(0x6dd00000), SPH_C32(0xe9593aa3), SPH_C32(0xe7e3c523),
    SPH_C32(0xa35afdde), SPH_C32(0xf73f510f), SPH_C32(0xe9190000),
    SPH_C32(0x6b100001), SPH_C32(0x81745380), SPH_C32(0xec730000),
    SPH_C32(0xb60f12ea), SPH_C32(0x432147d1), SPH_C32(0x3719faed),
    SPH_C32(0x6a3f8c97) },
  { SPH_C32(0xf39f0000), SPH_C32(0xaa5f0003), SPH_C32(0xd1e1c000),
    SPH_C32(0x35a20000), SPH_C32(0x1a5779e4), SPH_C32(0x6aa14bed),
    SPH_C32(0x3b19d5bd), SPH_C32(0x5d6336ec), SPH_C32(0x9e740000),
    SPH_C32(0x799f0001), SPH_C32(0x8d258000), SPH_C32(0x6ed10000),
    SPH_C32(0x267448d9), SPH_C32(0x1eea2356), SPH_C32(0x8a3d5665),
    SPH_C32(0x13b74e4f) },
  { SPH_C32(0x5fd70000), SPH_C32(0xb1f90003), SPH_C32(0x941ad380),
    SPH_C32(0x36e10000), SPH_C32(0x40d2488e), SPH_C32(0x75131b5b),
    SPH_C32(0xc56b1243), SPH_C32(0xcc874e1a), SPH_C32(0x803a0000),
    SPH_C32(0xa7500001), SPH_C32(0xe0dd8180), SPH_C32(0x19f50000),
    SPH_C32(0xca334f47), SPH_C32(0xea4a4a18), SPH_C32(0x479e4e77),
    SPH_C32(0x8b1d0721) },
  { SPH_C32(0xedd10000), SPH_C32(0x74900003), SPH_C32(0xbc19c180),
    SPH_C32(0x42860000), SPH_C32(0xf6107e7a), SPH_C32(0x9e0122a3),
    SPH_C32(0xf6bacdaf), SPH_C32(0xc5c97f82), SPH_C32(0x2c720000),
    SPH_C32(0xbcf60001), SPH_C32(0xa5269200), SPH_C32(0x1ab60000),
    SPH_C32(0x90b67e2d), SPH_C32(0xf5f81aae), SPH_C32(0xb9ec8989),
    SPH_C32(0x1af97fd7) },
  { SPH_C32(0x41990000), SPH_C32(0x6f360003), SPH_C32(0xf9e2d200),
    SPH_C32(0x41c50000), SPH_C32(0xac954f10), SPH_C32(0x81b37215),
    SPH_C32(0x08c80a51), SPH_C32(0x542d0774), SPH_C32(0x323c0000),
    SPH_C32(0x62390001), SPH_C32(0xc8de9380), SPH_C32(0x6d920000),
    SPH_C32(0x7cf179b3), SPH_C32(0x015873e0), SPH_C32(0x744f919b),
    SPH_C32(0x825336b9) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0x9cff0000), SPH_C32(0xfe760000), SPH_C32(0xb10f7380),
    SPH_C32(0x41870000), SPH_C32(0x393d0c00), SPH_C32(0x6708c4d6),
    SPH_C32(0xdfdd6614), SPH_C32(0x214160c2), SPH_C32(0xa8800000),
    SPH_C32(0x04260002), SPH_C32(0x78968180), SPH_C32(0xadb60000),
    SPH_C32(0x1a9a5dfa), SPH_C32(0xc29235c4), SPH_C32(0x3fd1f0bc),
    SPH_C32(0x3e128be3) },
  { SPH_C32(0x2ef90000), SPH_C32(0x3b1f0000), SPH_C32(0x990c6180),
    SPH_C32(0x35e00000), SPH_C32(0x8fff3af4), SPH_C32(0x8c1afd2e),
    SPH_C32(0xec0cb9f8), SPH_C32(0x280f515a), SPH_C32(0x04c80000),
    SPH_C32(0x1f800002), SPH_C32(0x3d6d9200), SPH_C32(0xaef50000),
    SPH_C32(0x401f6c90), SPH_C32(0xdd206572), SPH_C32(0xc1a33742),
    SPH_C32(0xaff6f315) },
  { SPH_C32(0x82b10000), SPH_C32(0x20b90000), SPH_C32(0xdcf77200),
    SPH_C32(0x36a30000), SPH_C32(0xd57a0b9e), SPH_C32(0x93a8ad98),
    SPH_C32(0x127e7e06), SPH_C32(0xb9eb29ac), SPH_C32(0x1a860000),
    SPH_C32(0xc14f0002), SPH_C32(0x50959380), SPH_C32(0xd9d10000),
    SPH_C32(0xac586b0e), SPH_C32(0x29800c3c), SPH_C32(0x0c002f50),
    SPH_C32(0x375cba7b) },
  { SPH_C32(0x9e740000), SPH_C32(0x799f0001), SPH_C32(0x8d258000),
    SPH_C32(0x6ed10000), SPH_C32(0x267448d9), SPH_C32(0x1eea2356),
    SPH_C32(0x8a3d5665), SPH_C32(0x13b74e4f), SPH_C32(0x6deb0000),
    SPH_C32(0xd3c00002), SPH_C32(0x5cc44000), SPH_C32(0x5b730000),
    SPH_C32(0x3c23313d), SPH_C32(0x744b68bb), SPH_C32(0xb12483d8),
    SPH_C32(0x4ed478a3) },
  { SPH_C32(0x323c0000), SPH_C32(0x62390001), SPH_C32(0xc8de9380),
    SPH_C32(0x6d920000), SPH_C32(0x7cf179b3), SPH_C32(0x015873e0),
    SPH_C32(0x744f919b), SPH_C32(0x825336b9), SPH_C32(0x73a50000),
    SPH_C32(0x0d0f0002), SPH_C32(0x313c4180), SPH_C32(0x2c570000),
    SPH_C32(0xd06436a3), SPH_C32(0x80eb01f5), SPH_C32(0x7c879bca),
    SPH_C32(0xd67e31cd) },
  { SPH_C32(0x803a0000), SPH_C32(0xa7500001), SPH_C32(0xe0dd8180),
    SPH_C32(0x19f50000), SPH_C32(0xca334f47), SPH_C32(0xea4a4a18),
    SPH_C32(0x479e4e77), SPH_C32(0x8b1d0721), SPH_C32(0xdfed0000),
    SPH_C32(0x16a90002), SPH_C32(0x74c75200), SPH_C32(0x2f140000),
    SPH_C32(0x8ae107c9), SPH_C32(0x9f595143), SPH_C32(0x82f55c34),
    SPH_C32(0x479a493b) },
  { SPH_C32(0x2c720000), SPH_C32(0xbcf60001), SPH_C32(0xa5269200),
    SPH_C32(0x1ab60000), SPH_C32(0x90b67e2d), SPH_C32(0xf5f81aae),
    SPH_C32(0xb9ec8989), SPH_C32(0x1af97fd7), SPH_C32(0xc1a30000),
    SPH_C32(0xc8660002), SPH_C32(0x193f5380), SPH_C32(0x58300000),
    SPH_C32(0x66a60057), SPH_C32(0x6bf9380d), SPH_C32(0x4f564426),
    SPH_C32(0xdf300055) },
  { SPH_C32(0xeb920000), SPH_C32(0xecf90000), SPH_C32(0xbd5ea000),
    SPH_C32(0xc3250000), SPH_C32(0xa9465633), SPH_C32(0x3ac3a051),
    SPH_C32(0x62f9ca9c), SPH_C32(0x58c9a21a), SPH_C32(0xc3280000),
    SPH_C32(0x4f8f0003), SPH_C32(0x2515a000), SPH_C32(0x77660000),
    SPH_C32(0x79ef448e), SPH_C32(0x121bdf8d), SPH_C32(0x1ab67457),
    SPH_C32(0xedc62ed8) },
  { SPH_C32(0x47da0000), SPH_C32(0xf75f0000), SPH_C32(0xf8a5b380),
    SPH_C32(0xc0660000), SPH_C32(0xf3c36759), SPH_C32(0x2571f0e7),
    SPH_C32(0x9c8b0d62), SPH_C32(0xc92ddaec), SPH_C32(0xdd660000),
    SPH_C32(0x91400003), SPH_C32(0x48eda180), SPH_C32(0x00420000),
    SPH_C32(0x95a84310), SPH_C32(0xe6bbb6c3), SPH_C32(0xd7156c45),
    SPH_C32(0x756c67b6) },
  { SPH_C32(0xf5dc0000), SPH_C32(0x32360000), SPH_C32(0xd0a6a180),
    SPH_C32(0xb4010000), SPH_C32(0x450151ad), SPH_C32(0xce63c91f),
    SPH_C32(0xaf5ad28e), SPH_C32(0xc063eb74), SPH_C32(0x712e0000),
    SPH_C32(0x8ae60003), SPH_C32(0x0d16b200), SPH_C32(0x03010000),
    SPH_C32(0xcf2d727a), SPH_C32(0xf909e675), SPH_C32(0x2967abbb),
    SPH_C32(0xe4881f40) },
  { SPH_C32(0x59940000), SPH_C32(0x29900000), SPH_C32(0x955db200),
    SPH_C32(0xb7420000), SPH_C32(0x1f8460c7), SPH_C32(0xd1d199a9),
    SPH_C32(0x51281570), SPH_C32(0x51879382), SPH_C32(0x6f600000),
    SPH_C32(0x54290003), SPH_C32(0x60eeb380), SPH_C32(0x74250000),
    SPH_C32(0x236a75e4), SPH_C32(0x0da98f3b), SPH_C32(0xe4c4b3a9),
    SPH_C32(0x7c22562e) },
  { SPH_C32(0x45510000), SPH_C32(0x70b60001), SPH_C32(0xc48f4000),
    SPH_C32(0xef300000), SPH_C32(0xec8a2380), SPH_C32(0x5c931767),
    SPH_C32(0xc96b3d13), SPH_C32(0xfbdbf461), SPH_C32(0x180d0000),
    SPH_C32(0x46a60003), SPH_C32(0x6cbf6000), SPH_C32(0xf6870000),
    SPH_C32(0xb3112fd7), SPH_C32(0x5062ebbc), SPH_C32(0x59e01f21),
    SPH_C32(0x05aa94f6) },
  { SPH_C32(0xe9190000), SPH_C32(0x6b100001), SPH_C32(0x81745380),
    SPH_C32(0xec730000), SPH_C32(0xb60f12ea), SPH_C32(0x432147d1),
    SPH_C32(0x3719faed), SPH_C32(0x6a3f8c97), SPH_C32(0x06430000),
    SPH_C32(0x98690003), SPH_C32(0x01476180), SPH_C32(0x81a30000),
    SPH_C32(0x5f562849), SPH_C32(0xa4c282f2), SPH_C32(0x94430733),
    SPH_C32(0x9d00dd98) },
  { SPH_C32(0x5b1f0000), SPH_C32(0xae790001), SPH_C32(0xa9774180),
    SPH_C32(0x98140000), SPH_C32(0x00cd241e), SPH_C32(0xa8337e29),
    SPH_C32(0x04c82501), SPH_C32(0x6371bd0f), SPH_C32(0xaa0b0000),
    SPH_C32(0x83cf0003), SPH_C32(0x44bc7200), SPH_C32(0x82e00000),
    SPH_C32(0x05d31923), SPH_C32(0xbb70d244), SPH_C32(0x6a31c0cd),
    SPH_C32(0x0ce4a56e) },
  { SPH_C32(0xf7570000), SPH_C32(0xb5df0001), SPH_C32(0xec8c5200),
    SPH_C32(0x9b570000), SPH_C32(0x5a481574), SPH_C32(0xb7812e9f),
    SPH_C32(0xfabae2ff), SPH_C32(0xf295c5f9), SPH_C32(0xb4450000),
    SPH_C32(0x5d000003), SPH_C32(0x29447380), SPH_C32(0xf5c40000),
    SPH_C32(0xe9941ebd), SPH_C32(0x4fd0bb0a), SPH_C32(0xa792d8df),
    SPH_C32(0x944eec00) },
  { SPH_C32(0xb6ce0000), SPH_C32(0xdae90002), SPH_C32(0x156e8000),
    SPH_C32(0xda920000), SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a),
    SPH_C32(0xf272e8ae), SPH_C32(0xa6b8c28d), SPH_C32(0x86790000),
    SPH_C32(0x3f390002), SPH_C32(0xe19ae000), SPH_C32(0x98560000),
    SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea), SPH_C32(0xd3dd4944),
    SPH_C32(0x161ddab9) },
  { SPH_C32(0x1a860000), SPH_C32(0xc14f0002), SPH_C32(0x50959380),
    SPH_C32(0xd9d10000), SPH_C32(0xac586b0e), SPH_C32(0x29800c3c),
    SPH_C32(0x0c002f50), SPH_C32(0x375cba7b), SPH_C32(0x98370000),
    SPH_C32(0xe1f60002), SPH_C32(0x8c62e180), SPH_C32(0xef720000),
    SPH_C32(0x79226090), SPH_C32(0xba28a1a4), SPH_C32(0x1e7e5156),
    SPH_C32(0x8eb793d7) },
  { SPH_C32(0xa8800000), SPH_C32(0x04260002), SPH_C32(0x78968180),
    SPH_C32(0xadb60000), SPH_C32(0x1a9a5dfa), SPH_C32(0xc29235c4),
    SPH_C32(0x3fd1f0bc), SPH_C32(0x3e128be3), SPH_C32(0x347f0000),
    SPH_C32(0xfa500002), SPH_C32(0xc999f200), SPH_C32(0xec310000),
    SPH_C32(0x23a751fa), SPH_C32(0xa59af112), SPH_C32(0xe00c96a8),
    SPH_C32(0x1f53eb21) },
  { SPH_C32(0x04c80000), SPH_C32(0x1f800002), SPH_C32(0x3d6d9200),
    SPH_C32(0xaef50000), SPH_C32(0x401f6c90), SPH_C32(0xdd206572),
    SPH_C32(0xc1a33742), SPH_C32(0xaff6f315), SPH_C32(0x2a310000),
    SPH_C32(0x249f0002), SPH_C32(0xa461f380), SPH_C32(0x9b150000),
    SPH_C32(0xcfe05664), SPH_C32(0x513a985c), SPH_C32(0x2daf8eba),
    SPH_C32(0x87f9a24f) },
  { SPH_C32(0x180d0000), SPH_C32(0x46a60003), SPH_C32(0x6cbf6000),
    SPH_C32(0xf6870000), SPH_C32(0xb3112fd7), SPH_C32(0x5062ebbc),
    SPH_C32(0x59e01f21), SPH_C32(0x05aa94f6), SPH_C32(0x5d5c0000),
    SPH_C32(0x36100002), SPH_C32(0xa8302000), SPH_C32(0x19b70000),
    SPH_C32(0x5f9b0c57), SPH_C32(0x0cf1fcdb), SPH_C32(0x908b2232),
    SPH_C32(0xfe716097) },
  { SPH_C32(0xb4450000), SPH_C32(0x5d000003), SPH_C32(0x29447380),
    SPH_C32(0xf5c40000), SPH_C32(0xe9941ebd), SPH_C32(0x4fd0bb0a),
    SPH_C32(0xa792d8df), SPH_C32(0x944eec00), SPH_C32(0x43120000),
    SPH_C32(0xe8df0002), SPH_C32(0xc5c82180), SPH_C32(0x6e930000),
    SPH_C32(0xb3dc0bc9), SPH_C32(0xf8519595), SPH_C32(0x5d283a20),
    SPH_C32(0x66db29f9) },
  { SPH_C32(0x06430000), SPH_C32(0x98690003), SPH_C32(0x01476180),
    SPH_C32(0x81a30000), SPH_C32(0x5f562849), SPH_C32(0xa4c282f2),
    SPH_C32(0x94430733), SPH_C32(0x9d00dd98), SPH_C32(0xef5a0000),
    SPH_C32(0xf3790002), SPH_C32(0x80333200), SPH_C32(0x6dd00000),
    SPH_C32(0xe9593aa3), SPH_C32(0xe7e3c523), SPH_C32(0xa35afdde),
    SPH_C32(0xf73f510f) },
  { SPH_C32(0xaa0b0000), SPH_C32(0x83cf0003), SPH_C32(0x44bc7200),
    SPH_C32(0x82e00000), SPH_C32(0x05d31923), SPH_C32(0xbb70d244),
    SPH_C32(0x6a31c0cd), SPH_C32(0x0ce4a56e), SPH_C32(0xf1140000),
    SPH_C32(0x2db60002), SPH_C32(0xedcb3380), SPH_C32(0x1af40000),
    SPH_C32(0x051e3d3d), SPH_C32(0x1343ac6d), SPH_C32(0x6ef9e5cc),
    SPH_C32(0x6f951861) },
  { SPH_C32(0x6deb0000), SPH_C32(0xd3c00002), SPH_C32(0x5cc44000),
    SPH_C32(0x5b730000), SPH_C32(0x3c23313d), SPH_C32(0x744b68bb),
    SPH_C32(0xb12483d8), SPH_C32(0x4ed478a3), SPH_C32(0xf39f0000),
    SPH_C32(0xaa5f0003), SPH_C32(0xd1e1c000), SPH_C32(0x35a20000),
    SPH_C32(0x1a5779e4), SPH_C32(0x6aa14bed), SPH_C32(0x3b19d5bd),
    SPH_C32(0x5d6336ec) },
  { SPH_C32(0xc1a30000), SPH_C32(0xc8660002), SPH_C32(0x193f5380),
    SPH_C32(0x58300000), SPH_C32(0x66a60057), SPH_C32(0x6bf9380d),
    SPH_C32(0x4f564426), SPH_C32(0xdf300055), SPH_C32(0xedd10000),
    SPH_C32(0x74900003), SPH_C32(0xbc19c180), SPH_C32(0x42860000),
    SPH_C32(0xf6107e7a), SPH_C32(0x9e0122a3), SPH_C32(0xf6bacdaf),
    SPH_C32(0xc5c97f82) },
  { SPH_C32(0x73a50000), SPH_C32(0x0d0f0002), SPH_C32(0x313c4180),
    SPH_C32(0x2c570000), SPH_C32(0xd06436a3), SPH_C32(0x80eb01f5),
    SPH_C32(0x7c879bca), SPH_C32(0xd67e31cd), SPH_C32(0x41990000),
    SPH_C32(0x6f360003), SPH_C32(0xf9e2d200), SPH_C32(0x41c50000),
    SPH_C32(0xac954f10), SPH_C32(0x81b37215), SPH_C32(0x08c80a51),
    SPH_C32(0x542d0774) },
  { SPH_C32(0xdfed0000), SPH_C32(0x16a90002), SPH_C32(0x74c75200),
    SPH_C32(0x2f140000), SPH_C32(0x8ae107c9), SPH_C32(0x9f595143),
    SPH_C32(0x82f55c34), SPH_C32(0x479a493b), SPH_C32(0x5fd70000),
    SPH_C32(0xb1f90003), SPH_C32(0x941ad380), SPH_C32(0x36e10000),
    SPH_C32(0x40d2488e), SPH_C32(0x75131b5b), SPH_C32(0xc56b1243),
    SPH_C32(0xcc874e1a) },
  { SPH_C32(0xc3280000), SPH_C32(0x4f8f0003), SPH_C32(0x2515a000),
    SPH_C32(0x77660000), SPH_C32(0x79ef448e), SPH_C32(0x121bdf8d),
    SPH_C32(0x1ab67457), SPH_C32(0xedc62ed8), SPH_C32(0x28ba0000),
    SPH_C32(0xa3760003), SPH_C32(0x984b0000), SPH_C32(0xb4430000),
    SPH_C32(0xd0a912bd), SPH_C32(0x28d87fdc), SPH_C32(0x784fbecb),
    SPH_C32(0xb50f8cc2) },
  { SPH_C32(0x6f600000), SPH_C32(0x54290003), SPH_C32(0x60eeb380),
    SPH_C32(0x74250000), SPH_C32(0x236a75e4), SPH_C32(0x0da98f3b),
    SPH_C32(0xe4c4b3a9), SPH_C32(0x7c22562e), SPH_C32(0x36f40000),
    SPH_C32(0x7db90003), SPH_C32(0xf5b30180), SPH_C32(0xc3670000),
    SPH_C32(0x3cee1523), SPH_C32(0xdc781692), SPH_C32(0xb5eca6d9),
    SPH_C32(0x2da5c5ac) },
  { SPH_C32(0xdd660000), SPH_C32(0x91400003), SPH_C32(0x48eda180),
    SPH_C32(0x00420000), SPH_C32(0x95a84310), SPH_C32(0xe6bbb6c3),
    SPH_C32(0xd7156c45), SPH_C32(0x756c67b6), SPH_C32(0x9abc0000),
    SPH_C32(0x661f0003), SPH_C32(0xb0481200), SPH_C32(0xc0240000),
    SPH_C32(0x666b2449), SPH_C32(0xc3ca4624), SPH_C32(0x4b9e6127),
    SPH_C32(0xbc41bd5a) },
  { SPH_C32(0x712e0000), SPH_C32(0x8ae60003), SPH_C32(0x0d16b200),
    SPH_C32(0x03010000), SPH_C32(0xcf2d727a), SPH_C32(0xf909e675),
    SPH_C32(0x2967abbb), SPH_C32(0xe4881f40), SPH_C32(0x84f20000),
    SPH_C32(0xb8d00003), SPH_C32(0xddb01380), SPH_C32(0xb7000000),
    SPH_C32(0x8a2c23d7), SPH_C32(0x376a2f6a), SPH_C32(0x863d7935),
    SPH_C32(0x24ebf434) }
};

__constant static const sph_u32 T512_36[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0x01dd0000), SPH_C32(0x80a80000), SPH_C32(0xf4960048),
    SPH_C32(0xa6000000), SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37),
    SPH_C32(0x6612cffd), SPH_C32(0x2c94459e), SPH_C32(0x52500000),
    SPH_C32(0x29540000), SPH_C32(0x6a61004e), SPH_C32(0xf0ff0000),
    SPH_C32(0x9a317eec), SPH_C32(0x452341ce), SPH_C32(0xcf568fe5),
    SPH_C32(0x5303130f) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x9e440000), SPH_C32(0x8c370000), SPH_C32(0x30d807ce),
    SPH_C32(0xcbaf0000), SPH_C32(0xd1e16d13), SPH_C32(0xc2b875d6),
    SPH_C32(0xa615c724), SPH_C32(0x995994f1), SPH_C32(0xd2130000),
    SPH_C32(0x45ab0000), SPH_C32(0xf8c50286), SPH_C32(0xc30c0000),
    SPH_C32(0x574d284c), SPH_C32(0xda31f145), SPH_C32(0x4f1ee235),
    SPH_C32(0xf1f0e16b) },
  { SPH_C32(0x9f990000), SPH_C32(0x0c9f0000), SPH_C32(0xc44e0786),
    SPH_C32(0x6daf0000), SPH_C32(0x413413b1), SPH_C32(0x155ef9e1),
    SPH_C32(0xc00708d9), SPH_C32(0xb5cdd16f), SPH_C32(0x80430000),
    SPH_C32(0x6cff0000), SPH_C32(0x92a402c8), SPH_C32(0x33f30000),
    SPH_C32(0xcd7c56a0), SPH_C32(0x9f12b08b), SPH_C32(0x80486dd0),
    SPH_C32(0xa2f3f264) },
  { SPH_C32(0xcdc90000), SPH_C32(0x25cb0000), SPH_C32(0xae2f07c8),
    SPH_C32(0x9d500000), SPH_C32(0xdb056d5d), SPH_C32(0x507db82f),
    SPH_C32(0x0f51873c), SPH_C32(0xe6cec260), SPH_C32(0xd3ce0000),
    SPH_C32(0xc5030000), SPH_C32(0x0c5302ce), SPH_C32(0x650c0000),
    SPH_C32(0xc79856ee), SPH_C32(0x0dd77d72), SPH_C32(0x290c2dc8),
    SPH_C32(0xdd64a4f5) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0xd3ce0000), SPH_C32(0xc5030000), SPH_C32(0x0c5302ce),
    SPH_C32(0x650c0000), SPH_C32(0xc79856ee), SPH_C32(0x0dd77d72),
    SPH_C32(0x290c2dc8), SPH_C32(0xdd64a4f5), SPH_C32(0x1e070000),
    SPH_C32(0xe0c80000), SPH_C32(0xa27c0506), SPH_C32(0xf85c0000),
    SPH_C32(0x1c9d3bb3), SPH_C32(0x5daac55d), SPH_C32(0x265daaf4),
    SPH_C32(0x3baa6695) },
  { SPH_C32(0xd2130000), SPH_C32(0x45ab0000), SPH_C32(0xf8c50286),
    SPH_C32(0xc30c0000), SPH_C32(0x574d284c), SPH_C32(0xda31f145),
    SPH_C32(0x4f1ee235), SPH_C32(0xf1f0e16b), SPH_C32(0x4c570000),
    SPH_C32(0xc99c0000), SPH_C32(0xc81d0548), SPH_C32(0x08a30000),
    SPH_C32(0x86ac455f), SPH_C32(0x18898493), SPH_C32(0xe90b2511),
    SPH_C32(0x68a9759a) },
  { SPH_C32(0x80430000), SPH_C32(0x6cff0000), SPH_C32(0x92a402c8),
    SPH_C32(0x33f30000), SPH_C32(0xcd7c56a0), SPH_C32(0x9f12b08b),
    SPH_C32(0x80486dd0), SPH_C32(0xa2f3f264), SPH_C32(0x1fda0000),
    SPH_C32(0x60600000), SPH_C32(0x56ea054e), SPH_C32(0x5e5c0000),
    SPH_C32(0x8c484511), SPH_C32(0x8a4c496a), SPH_C32(0x404f6509),
    SPH_C32(0x173e230b) },
  { SPH_C32(0x4d8a0000), SPH_C32(0x49340000), SPH_C32(0x3c8b0500),
    SPH_C32(0xaea30000), SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4),
    SPH_C32(0x8f19eaec), SPH_C32(0x443d3004), SPH_C32(0xcc140000),
    SPH_C32(0xa5630000), SPH_C32(0x5ab90780), SPH_C32(0x3b500000),
    SPH_C32(0x4bd013ff), SPH_C32(0x879b3418), SPH_C32(0x694348c1),
    SPH_C32(0xca5a87fe) },
  { SPH_C32(0x1fda0000), SPH_C32(0x60600000), SPH_C32(0x56ea054e),
    SPH_C32(0x5e5c0000), SPH_C32(0x8c484511), SPH_C32(0x8a4c496a),
    SPH_C32(0x404f6509), SPH_C32(0x173e230b), SPH_C32(0x9f990000),
    SPH_C32(0x0c9f0000), SPH_C32(0xc44e0786), SPH_C32(0x6daf0000),
    SPH_C32(0x413413b1), SPH_C32(0x155ef9e1), SPH_C32(0xc00708d9),
    SPH_C32(0xb5cdd16f) },
  { SPH_C32(0x1e070000), SPH_C32(0xe0c80000), SPH_C32(0xa27c0506),
    SPH_C32(0xf85c0000), SPH_C32(0x1c9d3bb3), SPH_C32(0x5daac55d),
    SPH_C32(0x265daaf4), SPH_C32(0x3baa6695), SPH_C32(0xcdc90000),
    SPH_C32(0x25cb0000), SPH_C32(0xae2f07c8), SPH_C32(0x9d500000),
    SPH_C32(0xdb056d5d), SPH_C32(0x507db82f), SPH_C32(0x0f51873c),
    SPH_C32(0xe6cec260) },
  { SPH_C32(0x4c570000), SPH_C32(0xc99c0000), SPH_C32(0xc81d0548),
    SPH_C32(0x08a30000), SPH_C32(0x86ac455f), SPH_C32(0x18898493),
    SPH_C32(0xe90b2511), SPH_C32(0x68a9759a), SPH_C32(0x9e440000),
    SPH_C32(0x8c370000), SPH_C32(0x30d807ce), SPH_C32(0xcbaf0000),
    SPH_C32(0xd1e16d13), SPH_C32(0xc2b875d6), SPH_C32(0xa615c724),
    SPH_C32(0x995994f1) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0x2a730000), SPH_C32(0x3ba80000), SPH_C32(0xc35b0bce),
    SPH_C32(0x605a0000), SPH_C32(0xeb0f5695), SPH_C32(0x3bcac8ea),
    SPH_C32(0x3fda2f87), SPH_C32(0x306c98a4), SPH_C32(0x51220000),
    SPH_C32(0x1ed40000), SPH_C32(0x24eb0306), SPH_C32(0x00670000),
    SPH_C32(0xb069459d), SPH_C32(0x128d0b9e), SPH_C32(0x00185482),
    SPH_C32(0x8b61bcea) },
  { SPH_C32(0x2bae0000), SPH_C32(0xbb000000), SPH_C32(0x37cd0b86),
    SPH_C32(0xc65a0000), SPH_C32(0x7bda2837), SPH_C32(0xec2c44dd),
    SPH_C32(0x59c8e07a), SPH_C32(0x1cf8dd3a), SPH_C32(0x03720000),
    SPH_C32(0x37800000), SPH_C32(0x4e8a0348), SPH_C32(0xf0980000),
    SPH_C32(0x2a583b71), SPH_C32(0x57ae4a50), SPH_C32(0xcf4edb67),
    SPH_C32(0xd862afe5) },
  { SPH_C32(0x79fe0000), SPH_C32(0x92540000), SPH_C32(0x5dac0bc8),
    SPH_C32(0x36a50000), SPH_C32(0xe1eb56db), SPH_C32(0xa90f0513),
    SPH_C32(0x969e6f9f), SPH_C32(0x4ffbce35), SPH_C32(0x50ff0000),
    SPH_C32(0x9e7c0000), SPH_C32(0xd07d034e), SPH_C32(0xa6670000),
    SPH_C32(0x20bc3b3f), SPH_C32(0xc56b87a9), SPH_C32(0x660a9b7f),
    SPH_C32(0xa7f5f974) },
  { SPH_C32(0xb4370000), SPH_C32(0xb79f0000), SPH_C32(0xf3830c00),
    SPH_C32(0xabf50000), SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c),
    SPH_C32(0x99cfe8a3), SPH_C32(0xa9350c55), SPH_C32(0x83310000),
    SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180), SPH_C32(0xc36b0000),
    SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb), SPH_C32(0x4f06b6b7),
    SPH_C32(0x7a915d81) },
  { SPH_C32(0xe6670000), SPH_C32(0x9ecb0000), SPH_C32(0x99e20c4e),
    SPH_C32(0x5b0a0000), SPH_C32(0xa0df456a), SPH_C32(0xbc51fcf2),
    SPH_C32(0x56996746), SPH_C32(0xfa361f5a), SPH_C32(0xd0bc0000),
    SPH_C32(0xf2830000), SPH_C32(0x42d90186), SPH_C32(0x95940000),
    SPH_C32(0xedc06d9f), SPH_C32(0x5a793722), SPH_C32(0xe642f6af),
    SPH_C32(0x05060b10) },
  { SPH_C32(0xe7ba0000), SPH_C32(0x1e630000), SPH_C32(0x6d740c06),
    SPH_C32(0xfd0a0000), SPH_C32(0x300a3bc8), SPH_C32(0x6bb770c5),
    SPH_C32(0x308ba8bb), SPH_C32(0xd6a25ac4), SPH_C32(0x82ec0000),
    SPH_C32(0xdbd70000), SPH_C32(0x28b801c8), SPH_C32(0x656b0000),
    SPH_C32(0x77f11373), SPH_C32(0x1f5a76ec), SPH_C32(0x2914794a),
    SPH_C32(0x5605181f) },
  { SPH_C32(0xb5ea0000), SPH_C32(0x37370000), SPH_C32(0x07150c48),
    SPH_C32(0x0df50000), SPH_C32(0xaa3b4524), SPH_C32(0x2e94310b),
    SPH_C32(0xffdd275e), SPH_C32(0x85a149cb), SPH_C32(0xd1610000),
    SPH_C32(0x722b0000), SPH_C32(0xb64f01ce), SPH_C32(0x33940000),
    SPH_C32(0x7d15133d), SPH_C32(0x8d9fbb15), SPH_C32(0x80503952),
    SPH_C32(0x29924e8e) },
  { SPH_C32(0xf9bd0000), SPH_C32(0xfeab0000), SPH_C32(0xcf080900),
    SPH_C32(0x05560000), SPH_C32(0x2c97007b), SPH_C32(0x361db598),
    SPH_C32(0x16d6024f), SPH_C32(0xed083c51), SPH_C32(0x4f250000),
    SPH_C32(0xfe1c0000), SPH_C32(0x86970600), SPH_C32(0xf83b0000),
    SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3), SPH_C32(0x2645fe76),
    SPH_C32(0xb0cbda7f) },
  { SPH_C32(0xabed0000), SPH_C32(0xd7ff0000), SPH_C32(0xa569094e),
    SPH_C32(0xf5a90000), SPH_C32(0xb6a67e97), SPH_C32(0x733ef456),
    SPH_C32(0xd9808daa), SPH_C32(0xbe0b2f5e), SPH_C32(0x1ca80000),
    SPH_C32(0x57e00000), SPH_C32(0x18600606), SPH_C32(0xaec40000),
    SPH_C32(0xa6107e60), SPH_C32(0xdde2033a), SPH_C32(0x8f01be6e),
    SPH_C32(0xcf5c8cee) },
  { SPH_C32(0xaa300000), SPH_C32(0x57570000), SPH_C32(0x51ff0906),
    SPH_C32(0x53a90000), SPH_C32(0x26730035), SPH_C32(0xa4d87861),
    SPH_C32(0xbf924257), SPH_C32(0x929f6ac0), SPH_C32(0x4ef80000),
    SPH_C32(0x7eb40000), SPH_C32(0x72010648), SPH_C32(0x5e3b0000),
    SPH_C32(0x3c21008c), SPH_C32(0x98c142f4), SPH_C32(0x4057318b),
    SPH_C32(0x9c5f9fe1) },
  { SPH_C32(0xf8600000), SPH_C32(0x7e030000), SPH_C32(0x3b9e0948),
    SPH_C32(0xa3560000), SPH_C32(0xbc427ed9), SPH_C32(0xe1fb39af),
    SPH_C32(0x70c4cdb2), SPH_C32(0xc19c79cf), SPH_C32(0x1d750000),
    SPH_C32(0xd7480000), SPH_C32(0xecf6064e), SPH_C32(0x08c40000),
    SPH_C32(0x36c500c2), SPH_C32(0x0a048f0d), SPH_C32(0xe9137193),
    SPH_C32(0xe3c8c970) },
  { SPH_C32(0x35a90000), SPH_C32(0x5bc80000), SPH_C32(0x95b10e80),
    SPH_C32(0x3e060000), SPH_C32(0x67471384), SPH_C32(0xb1868180),
    SPH_C32(0x7f954a8e), SPH_C32(0x2752bbaf), SPH_C32(0xcebb0000),
    SPH_C32(0x124b0000), SPH_C32(0xe0a50480), SPH_C32(0x6dc80000),
    SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f), SPH_C32(0xc01f5c5b),
    SPH_C32(0x3eac6d85) },
  { SPH_C32(0x67f90000), SPH_C32(0x729c0000), SPH_C32(0xffd00ece),
    SPH_C32(0xcef90000), SPH_C32(0xfd766d68), SPH_C32(0xf4a5c04e),
    SPH_C32(0xb0c3c56b), SPH_C32(0x7451a8a0), SPH_C32(0x9d360000),
    SPH_C32(0xbbb70000), SPH_C32(0x7e520486), SPH_C32(0x3b370000),
    SPH_C32(0xfbb95662), SPH_C32(0x95163f86), SPH_C32(0x695b1c43),
    SPH_C32(0x413b3b14) },
  { SPH_C32(0x66240000), SPH_C32(0xf2340000), SPH_C32(0x0b460e86),
    SPH_C32(0x68f90000), SPH_C32(0x6da313ca), SPH_C32(0x23434c79),
    SPH_C32(0xd6d10a96), SPH_C32(0x58c5ed3e), SPH_C32(0xcf660000),
    SPH_C32(0x92e30000), SPH_C32(0x143304c8), SPH_C32(0xcbc80000),
    SPH_C32(0x6188288e), SPH_C32(0xd0357e48), SPH_C32(0xa60d93a6),
    SPH_C32(0x1238281b) },
  { SPH_C32(0x34740000), SPH_C32(0xdb600000), SPH_C32(0x61270ec8),
    SPH_C32(0x98060000), SPH_C32(0xf7926d26), SPH_C32(0x66600db7),
    SPH_C32(0x19878573), SPH_C32(0x0bc6fe31), SPH_C32(0x9ceb0000),
    SPH_C32(0x3b1f0000), SPH_C32(0x8ac404ce), SPH_C32(0x9d370000),
    SPH_C32(0x6b6c28c0), SPH_C32(0x42f0b3b1), SPH_C32(0x0f49d3be),
    SPH_C32(0x6daf7e8a) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0x50ff0000), SPH_C32(0x9e7c0000), SPH_C32(0xd07d034e),
    SPH_C32(0xa6670000), SPH_C32(0x20bc3b3f), SPH_C32(0xc56b87a9),
    SPH_C32(0x660a9b7f), SPH_C32(0xa7f5f974), SPH_C32(0x29010000),
    SPH_C32(0x0c280000), SPH_C32(0x8dd10886), SPH_C32(0x90c20000),
    SPH_C32(0xc1576de4), SPH_C32(0x6c6482ba), SPH_C32(0xf094f4e0),
    SPH_C32(0xe80e3741) },
  { SPH_C32(0x51220000), SPH_C32(0x1ed40000), SPH_C32(0x24eb0306),
    SPH_C32(0x00670000), SPH_C32(0xb069459d), SPH_C32(0x128d0b9e),
    SPH_C32(0x00185482), SPH_C32(0x8b61bcea), SPH_C32(0x7b510000),
    SPH_C32(0x257c0000), SPH_C32(0xe7b008c8), SPH_C32(0x603d0000),
    SPH_C32(0x5b661308), SPH_C32(0x2947c374), SPH_C32(0x3fc27b05),
    SPH_C32(0xbb0d244e) },
  { SPH_C32(0x03720000), SPH_C32(0x37800000), SPH_C32(0x4e8a0348),
    SPH_C32(0xf0980000), SPH_C32(0x2a583b71), SPH_C32(0x57ae4a50),
    SPH_C32(0xcf4edb67), SPH_C32(0xd862afe5), SPH_C32(0x28dc0000),
    SPH_C32(0x8c800000), SPH_C32(0x794708ce), SPH_C32(0x36c20000),
    SPH_C32(0x51821346), SPH_C32(0xbb820e8d), SPH_C32(0x96863b1d),
    SPH_C32(0xc49a72df) },
  { SPH_C32(0xcebb0000), SPH_C32(0x124b0000), SPH_C32(0xe0a50480),
    SPH_C32(0x6dc80000), SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f),
    SPH_C32(0xc01f5c5b), SPH_C32(0x3eac6d85), SPH_C32(0xfb120000),
    SPH_C32(0x49830000), SPH_C32(0x75140a00), SPH_C32(0x53ce0000),
    SPH_C32(0x961a45a8), SPH_C32(0xb65573ff), SPH_C32(0xbf8a16d5),
    SPH_C32(0x19fed62a) },
  { SPH_C32(0x9ceb0000), SPH_C32(0x3b1f0000), SPH_C32(0x8ac404ce),
    SPH_C32(0x9d370000), SPH_C32(0x6b6c28c0), SPH_C32(0x42f0b3b1),
    SPH_C32(0x0f49d3be), SPH_C32(0x6daf7e8a), SPH_C32(0xa89f0000),
    SPH_C32(0xe07f0000), SPH_C32(0xebe30a06), SPH_C32(0x05310000),
    SPH_C32(0x9cfe45e6), SPH_C32(0x2490be06), SPH_C32(0x16ce56cd),
    SPH_C32(0x666980bb) },
  { SPH_C32(0x9d360000), SPH_C32(0xbbb70000), SPH_C32(0x7e520486),
    SPH_C32(0x3b370000), SPH_C32(0xfbb95662), SPH_C32(0x95163f86),
    SPH_C32(0x695b1c43), SPH_C32(0x413b3b14), SPH_C32(0xfacf0000),
    SPH_C32(0xc92b0000), SPH_C32(0x81820a48), SPH_C32(0xf5ce0000),
    SPH_C32(0x06cf3b0a), SPH_C32(0x61b3ffc8), SPH_C32(0xd998d928),
    SPH_C32(0x356a93b4) },
  { SPH_C32(0xcf660000), SPH_C32(0x92e30000), SPH_C32(0x143304c8),
    SPH_C32(0xcbc80000), SPH_C32(0x6188288e), SPH_C32(0xd0357e48),
    SPH_C32(0xa60d93a6), SPH_C32(0x1238281b), SPH_C32(0xa9420000),
    SPH_C32(0x60d70000), SPH_C32(0x1f750a4e), SPH_C32(0xa3310000),
    SPH_C32(0x0c2b3b44), SPH_C32(0xf3763231), SPH_C32(0x70dc9930),
    SPH_C32(0x4afdc525) },
  { SPH_C32(0x83310000), SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180),
    SPH_C32(0xc36b0000), SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb),
    SPH_C32(0x4f06b6b7), SPH_C32(0x7a915d81), SPH_C32(0x37060000),
    SPH_C32(0xece00000), SPH_C32(0x2fad0d80), SPH_C32(0x689e0000),
    SPH_C32(0xddca5657), SPH_C32(0x31ce47e7), SPH_C32(0xd6c95e14),
    SPH_C32(0xd3a451d4) },
  { SPH_C32(0xd1610000), SPH_C32(0x722b0000), SPH_C32(0xb64f01ce),
    SPH_C32(0x33940000), SPH_C32(0x7d15133d), SPH_C32(0x8d9fbb15),
    SPH_C32(0x80503952), SPH_C32(0x29924e8e), SPH_C32(0x648b0000),
    SPH_C32(0x451c0000), SPH_C32(0xb15a0d86), SPH_C32(0x3e610000),
    SPH_C32(0xd72e5619), SPH_C32(0xa30b8a1e), SPH_C32(0x7f8d1e0c),
    SPH_C32(0xac330745) },
  { SPH_C32(0xd0bc0000), SPH_C32(0xf2830000), SPH_C32(0x42d90186),
    SPH_C32(0x95940000), SPH_C32(0xedc06d9f), SPH_C32(0x5a793722),
    SPH_C32(0xe642f6af), SPH_C32(0x05060b10), SPH_C32(0x36db0000),
    SPH_C32(0x6c480000), SPH_C32(0xdb3b0dc8), SPH_C32(0xce9e0000),
    SPH_C32(0x4d1f28f5), SPH_C32(0xe628cbd0), SPH_C32(0xb0db91e9),
    SPH_C32(0xff30144a) },
  { SPH_C32(0x82ec0000), SPH_C32(0xdbd70000), SPH_C32(0x28b801c8),
    SPH_C32(0x656b0000), SPH_C32(0x77f11373), SPH_C32(0x1f5a76ec),
    SPH_C32(0x2914794a), SPH_C32(0x5605181f), SPH_C32(0x65560000),
    SPH_C32(0xc5b40000), SPH_C32(0x45cc0dce), SPH_C32(0x98610000),
    SPH_C32(0x47fb28bb), SPH_C32(0x74ed0629), SPH_C32(0x199fd1f1),
    SPH_C32(0x80a742db) },
  { SPH_C32(0x4f250000), SPH_C32(0xfe1c0000), SPH_C32(0x86970600),
    SPH_C32(0xf83b0000), SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3),
    SPH_C32(0x2645fe76), SPH_C32(0xb0cbda7f), SPH_C32(0xb6980000),
    SPH_C32(0x00b70000), SPH_C32(0x499f0f00), SPH_C32(0xfd6d0000),
    SPH_C32(0x80637e55), SPH_C32(0x793a7b5b), SPH_C32(0x3093fc39),
    SPH_C32(0x5dc3e62e) },
  { SPH_C32(0x1d750000), SPH_C32(0xd7480000), SPH_C32(0xecf6064e),
    SPH_C32(0x08c40000), SPH_C32(0x36c500c2), SPH_C32(0x0a048f0d),
    SPH_C32(0xe9137193), SPH_C32(0xe3c8c970), SPH_C32(0xe5150000),
    SPH_C32(0xa94b0000), SPH_C32(0xd7680f06), SPH_C32(0xab920000),
    SPH_C32(0x8a877e1b), SPH_C32(0xebffb6a2), SPH_C32(0x99d7bc21),
    SPH_C32(0x2254b0bf) },
  { SPH_C32(0x1ca80000), SPH_C32(0x57e00000), SPH_C32(0x18600606),
    SPH_C32(0xaec40000), SPH_C32(0xa6107e60), SPH_C32(0xdde2033a),
    SPH_C32(0x8f01be6e), SPH_C32(0xcf5c8cee), SPH_C32(0xb7450000),
    SPH_C32(0x801f0000), SPH_C32(0xbd090f48), SPH_C32(0x5b6d0000),
    SPH_C32(0x10b600f7), SPH_C32(0xaedcf76c), SPH_C32(0x568133c4),
    SPH_C32(0x7157a3b0) },
  { SPH_C32(0x4ef80000), SPH_C32(0x7eb40000), SPH_C32(0x72010648),
    SPH_C32(0x5e3b0000), SPH_C32(0x3c21008c), SPH_C32(0x98c142f4),
    SPH_C32(0x4057318b), SPH_C32(0x9c5f9fe1), SPH_C32(0xe4c80000),
    SPH_C32(0x29e30000), SPH_C32(0x23fe0f4e), SPH_C32(0x0d920000),
    SPH_C32(0x1a5200b9), SPH_C32(0x3c193a95), SPH_C32(0xffc573dc),
    SPH_C32(0x0ec0f521) },
  { SPH_C32(0x7a8c0000), SPH_C32(0xa5d40000), SPH_C32(0x13260880),
    SPH_C32(0xc63d0000), SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43),
    SPH_C32(0x59d0b4f8), SPH_C32(0x979961d0), SPH_C32(0x78230000),
    SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80), SPH_C32(0x90a50000),
    SPH_C32(0x713e2879), SPH_C32(0x7ee98924), SPH_C32(0xf08ca062),
    SPH_C32(0x636f8bab) },
  { SPH_C32(0x28dc0000), SPH_C32(0x8c800000), SPH_C32(0x794708ce),
    SPH_C32(0x36c20000), SPH_C32(0x51821346), SPH_C32(0xbb820e8d),
    SPH_C32(0x96863b1d), SPH_C32(0xc49a72df), SPH_C32(0x2bae0000),
    SPH_C32(0xbb000000), SPH_C32(0x37cd0b86), SPH_C32(0xc65a0000),
    SPH_C32(0x7bda2837), SPH_C32(0xec2c44dd), SPH_C32(0x59c8e07a),
    SPH_C32(0x1cf8dd3a) },
  { SPH_C32(0x29010000), SPH_C32(0x0c280000), SPH_C32(0x8dd10886),
    SPH_C32(0x90c20000), SPH_C32(0xc1576de4), SPH_C32(0x6c6482ba),
    SPH_C32(0xf094f4e0), SPH_C32(0xe80e3741), SPH_C32(0x79fe0000),
    SPH_C32(0x92540000), SPH_C32(0x5dac0bc8), SPH_C32(0x36a50000),
    SPH_C32(0xe1eb56db), SPH_C32(0xa90f0513), SPH_C32(0x969e6f9f),
    SPH_C32(0x4ffbce35) },
  { SPH_C32(0x7b510000), SPH_C32(0x257c0000), SPH_C32(0xe7b008c8),
    SPH_C32(0x603d0000), SPH_C32(0x5b661308), SPH_C32(0x2947c374),
    SPH_C32(0x3fc27b05), SPH_C32(0xbb0d244e), SPH_C32(0x2a730000),
    SPH_C32(0x3ba80000), SPH_C32(0xc35b0bce), SPH_C32(0x605a0000),
    SPH_C32(0xeb0f5695), SPH_C32(0x3bcac8ea), SPH_C32(0x3fda2f87),
    SPH_C32(0x306c98a4) },
  { SPH_C32(0xb6980000), SPH_C32(0x00b70000), SPH_C32(0x499f0f00),
    SPH_C32(0xfd6d0000), SPH_C32(0x80637e55), SPH_C32(0x793a7b5b),
    SPH_C32(0x3093fc39), SPH_C32(0x5dc3e62e), SPH_C32(0xf9bd0000),
    SPH_C32(0xfeab0000), SPH_C32(0xcf080900), SPH_C32(0x05560000),
    SPH_C32(0x2c97007b), SPH_C32(0x361db598), SPH_C32(0x16d6024f),
    SPH_C32(0xed083c51) },
  { SPH_C32(0xe4c80000), SPH_C32(0x29e30000), SPH_C32(0x23fe0f4e),
    SPH_C32(0x0d920000), SPH_C32(0x1a5200b9), SPH_C32(0x3c193a95),
    SPH_C32(0xffc573dc), SPH_C32(0x0ec0f521), SPH_C32(0xaa300000),
    SPH_C32(0x57570000), SPH_C32(0x51ff0906), SPH_C32(0x53a90000),
    SPH_C32(0x26730035), SPH_C32(0xa4d87861), SPH_C32(0xbf924257),
    SPH_C32(0x929f6ac0) },
  { SPH_C32(0xe5150000), SPH_C32(0xa94b0000), SPH_C32(0xd7680f06),
    SPH_C32(0xab920000), SPH_C32(0x8a877e1b), SPH_C32(0xebffb6a2),
    SPH_C32(0x99d7bc21), SPH_C32(0x2254b0bf), SPH_C32(0xf8600000),
    SPH_C32(0x7e030000), SPH_C32(0x3b9e0948), SPH_C32(0xa3560000),
    SPH_C32(0xbc427ed9), SPH_C32(0xe1fb39af), SPH_C32(0x70c4cdb2),
    SPH_C32(0xc19c79cf) },
  { SPH_C32(0xb7450000), SPH_C32(0x801f0000), SPH_C32(0xbd090f48),
    SPH_C32(0x5b6d0000), SPH_C32(0x10b600f7), SPH_C32(0xaedcf76c),
    SPH_C32(0x568133c4), SPH_C32(0x7157a3b0), SPH_C32(0xabed0000),
    SPH_C32(0xd7ff0000), SPH_C32(0xa569094e), SPH_C32(0xf5a90000),
    SPH_C32(0xb6a67e97), SPH_C32(0x733ef456), SPH_C32(0xd9808daa),
    SPH_C32(0xbe0b2f5e) },
  { SPH_C32(0xfb120000), SPH_C32(0x49830000), SPH_C32(0x75140a00),
    SPH_C32(0x53ce0000), SPH_C32(0x961a45a8), SPH_C32(0xb65573ff),
    SPH_C32(0xbf8a16d5), SPH_C32(0x19fed62a), SPH_C32(0x35a90000),
    SPH_C32(0x5bc80000), SPH_C32(0x95b10e80), SPH_C32(0x3e060000),
    SPH_C32(0x67471384), SPH_C32(0xb1868180), SPH_C32(0x7f954a8e),
    SPH_C32(0x2752bbaf) },
  { SPH_C32(0xa9420000), SPH_C32(0x60d70000), SPH_C32(0x1f750a4e),
    SPH_C32(0xa3310000), SPH_C32(0x0c2b3b44), SPH_C32(0xf3763231),
    SPH_C32(0x70dc9930), SPH_C32(0x4afdc525), SPH_C32(0x66240000),
    SPH_C32(0xf2340000), SPH_C32(0x0b460e86), SPH_C32(0x68f90000),
    SPH_C32(0x6da313ca), SPH_C32(0x23434c79), SPH_C32(0xd6d10a96),
    SPH_C32(0x58c5ed3e) },
  { SPH_C32(0xa89f0000), SPH_C32(0xe07f0000), SPH_C32(0xebe30a06),
    SPH_C32(0x05310000), SPH_C32(0x9cfe45e6), SPH_C32(0x2490be06),
    SPH_C32(0x16ce56cd), SPH_C32(0x666980bb), SPH_C32(0x34740000),
    SPH_C32(0xdb600000), SPH_C32(0x61270ec8), SPH_C32(0x98060000),
    SPH_C32(0xf7926d26), SPH_C32(0x66600db7), SPH_C32(0x19878573),
    SPH_C32(0x0bc6fe31) },
  { SPH_C32(0xfacf0000), SPH_C32(0xc92b0000), SPH_C32(0x81820a48),
    SPH_C32(0xf5ce0000), SPH_C32(0x06cf3b0a), SPH_C32(0x61b3ffc8),
    SPH_C32(0xd998d928), SPH_C32(0x356a93b4), SPH_C32(0x67f90000),
    SPH_C32(0x729c0000), SPH_C32(0xffd00ece), SPH_C32(0xcef90000),
    SPH_C32(0xfd766d68), SPH_C32(0xf4a5c04e), SPH_C32(0xb0c3c56b),
    SPH_C32(0x7451a8a0) },
  { SPH_C32(0x37060000), SPH_C32(0xece00000), SPH_C32(0x2fad0d80),
    SPH_C32(0x689e0000), SPH_C32(0xddca5657), SPH_C32(0x31ce47e7),
    SPH_C32(0xd6c95e14), SPH_C32(0xd3a451d4), SPH_C32(0xb4370000),
    SPH_C32(0xb79f0000), SPH_C32(0xf3830c00), SPH_C32(0xabf50000),
    SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c), SPH_C32(0x99cfe8a3),
    SPH_C32(0xa9350c55) },
  { SPH_C32(0x65560000), SPH_C32(0xc5b40000), SPH_C32(0x45cc0dce),
    SPH_C32(0x98610000), SPH_C32(0x47fb28bb), SPH_C32(0x74ed0629),
    SPH_C32(0x199fd1f1), SPH_C32(0x80a742db), SPH_C32(0xe7ba0000),
    SPH_C32(0x1e630000), SPH_C32(0x6d740c06), SPH_C32(0xfd0a0000),
    SPH_C32(0x300a3bc8), SPH_C32(0x6bb770c5), SPH_C32(0x308ba8bb),
    SPH_C32(0xd6a25ac4) },
  { SPH_C32(0x648b0000), SPH_C32(0x451c0000), SPH_C32(0xb15a0d86),
    SPH_C32(0x3e610000), SPH_C32(0xd72e5619), SPH_C32(0xa30b8a1e),
    SPH_C32(0x7f8d1e0c), SPH_C32(0xac330745), SPH_C32(0xb5ea0000),
    SPH_C32(0x37370000), SPH_C32(0x07150c48), SPH_C32(0x0df50000),
    SPH_C32(0xaa3b4524), SPH_C32(0x2e94310b), SPH_C32(0xffdd275e),
    SPH_C32(0x85a149cb) },
  { SPH_C32(0x36db0000), SPH_C32(0x6c480000), SPH_C32(0xdb3b0dc8),
    SPH_C32(0xce9e0000), SPH_C32(0x4d1f28f5), SPH_C32(0xe628cbd0),
    SPH_C32(0xb0db91e9), SPH_C32(0xff30144a), SPH_C32(0xe6670000),
    SPH_C32(0x9ecb0000), SPH_C32(0x99e20c4e), SPH_C32(0x5b0a0000),
    SPH_C32(0xa0df456a), SPH_C32(0xbc51fcf2), SPH_C32(0x56996746),
    SPH_C32(0xfa361f5a) }
};

__constant static const sph_u32 T512_42[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0x45190000), SPH_C32(0xab0c0000), SPH_C32(0x30be0001),
    SPH_C32(0x690a2000), SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d),
    SPH_C32(0x2dd1fa46), SPH_C32(0x24314f17), SPH_C32(0x58430000),
    SPH_C32(0x807e0000), SPH_C32(0x78330001), SPH_C32(0xc66b3800),
    SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd), SPH_C32(0xac73fe6f),
    SPH_C32(0x3a4479b1) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0xfd780000), SPH_C32(0x94580000), SPH_C32(0x3603001f),
    SPH_C32(0xbac53800), SPH_C32(0x68a95109), SPH_C32(0x017295e0),
    SPH_C32(0x5b4296b7), SPH_C32(0x315f30f7), SPH_C32(0x1ab70000),
    SPH_C32(0x99220000), SPH_C32(0xcff9000a), SPH_C32(0x386c1800),
    SPH_C32(0x66b90d6b), SPH_C32(0x80bed174), SPH_C32(0x75da660b),
    SPH_C32(0x8e008768) },
  { SPH_C32(0xb8610000), SPH_C32(0x3f540000), SPH_C32(0x06bd001e),
    SPH_C32(0xd3cf1800), SPH_C32(0xaa552310), SPH_C32(0xb0a615ed),
    SPH_C32(0x76936cf1), SPH_C32(0x156e7fe0), SPH_C32(0x42f40000),
    SPH_C32(0x195c0000), SPH_C32(0xb7ca000b), SPH_C32(0xfe072000),
    SPH_C32(0x818e51b7), SPH_C32(0xf913eea9), SPH_C32(0xd9a99864),
    SPH_C32(0xb444fed9) },
  { SPH_C32(0xe0220000), SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f),
    SPH_C32(0x15a42000), SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30),
    SPH_C32(0xdae0929e), SPH_C32(0x2f2a0651), SPH_C32(0x5fae0000),
    SPH_C32(0x322e0000), SPH_C32(0xff47000b), SPH_C32(0x51663800),
    SPH_C32(0xa4457f72), SPH_C32(0x316a5179), SPH_C32(0x580b9c4d),
    SPH_C32(0xaa31c87f) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0x5fae0000), SPH_C32(0x322e0000), SPH_C32(0xff47000b),
    SPH_C32(0x51663800), SPH_C32(0xa4457f72), SPH_C32(0x316a5179),
    SPH_C32(0x580b9c4d), SPH_C32(0xaa31c87f), SPH_C32(0xbf8c0000),
    SPH_C32(0x8d040000), SPH_C32(0x81c90014), SPH_C32(0x44c21800),
    SPH_C32(0xe92700be), SPH_C32(0xf8617b49), SPH_C32(0x82eb0ed3),
    SPH_C32(0x851bce2e) },
  { SPH_C32(0x1ab70000), SPH_C32(0x99220000), SPH_C32(0xcff9000a),
    SPH_C32(0x386c1800), SPH_C32(0x66b90d6b), SPH_C32(0x80bed174),
    SPH_C32(0x75da660b), SPH_C32(0x8e008768), SPH_C32(0xe7cf0000),
    SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015), SPH_C32(0x82a92000),
    SPH_C32(0x0e105c62), SPH_C32(0x81cc4494), SPH_C32(0x2e98f0bc),
    SPH_C32(0xbf5fb79f) },
  { SPH_C32(0x42f40000), SPH_C32(0x195c0000), SPH_C32(0xb7ca000b),
    SPH_C32(0xfe072000), SPH_C32(0x818e51b7), SPH_C32(0xf913eea9),
    SPH_C32(0xd9a99864), SPH_C32(0xb444fed9), SPH_C32(0xfa950000),
    SPH_C32(0x26080000), SPH_C32(0xb1770015), SPH_C32(0x2dc83800),
    SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44), SPH_C32(0xaf3af495),
    SPH_C32(0xa12a8139) },
  { SPH_C32(0xa2d60000), SPH_C32(0xa6760000), SPH_C32(0xc9440014),
    SPH_C32(0xeba30000), SPH_C32(0xccec2e7b), SPH_C32(0x3018c499),
    SPH_C32(0x03490afa), SPH_C32(0x9b6ef888), SPH_C32(0xa53b0000),
    SPH_C32(0x14260000), SPH_C32(0x4e30001e), SPH_C32(0x7cae0000),
    SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d), SPH_C32(0xf73168d8),
    SPH_C32(0x0b1b4946) },
  { SPH_C32(0xfa950000), SPH_C32(0x26080000), SPH_C32(0xb1770015),
    SPH_C32(0x2dc83800), SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44),
    SPH_C32(0xaf3af495), SPH_C32(0xa12a8139), SPH_C32(0xb8610000),
    SPH_C32(0x3f540000), SPH_C32(0x06bd001e), SPH_C32(0xd3cf1800),
    SPH_C32(0xaa552310), SPH_C32(0xb0a615ed), SPH_C32(0x76936cf1),
    SPH_C32(0x156e7fe0) },
  { SPH_C32(0xbf8c0000), SPH_C32(0x8d040000), SPH_C32(0x81c90014),
    SPH_C32(0x44c21800), SPH_C32(0xe92700be), SPH_C32(0xf8617b49),
    SPH_C32(0x82eb0ed3), SPH_C32(0x851bce2e), SPH_C32(0xe0220000),
    SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f), SPH_C32(0x15a42000),
    SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30), SPH_C32(0xdae0929e),
    SPH_C32(0x2f2a0651) },
  { SPH_C32(0xe7cf0000), SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015),
    SPH_C32(0x82a92000), SPH_C32(0x0e105c62), SPH_C32(0x81cc4494),
    SPH_C32(0x2e98f0bc), SPH_C32(0xbf5fb79f), SPH_C32(0xfd780000),
    SPH_C32(0x94580000), SPH_C32(0x3603001f), SPH_C32(0xbac53800),
    SPH_C32(0x68a95109), SPH_C32(0x017295e0), SPH_C32(0x5b4296b7),
    SPH_C32(0x315f30f7) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0xd0db0000), SPH_C32(0x9fea0000), SPH_C32(0x07fc002f),
    SPH_C32(0x3d253800), SPH_C32(0x166f5b46), SPH_C32(0x1803aeba),
    SPH_C32(0x04e68e03), SPH_C32(0xdc540d25), SPH_C32(0x16980000),
    SPH_C32(0xf0110000), SPH_C32(0x3605000c), SPH_C32(0xbae71800),
    SPH_C32(0xb4366636), SPH_C32(0xbdf80493), SPH_C32(0x75c240b7),
    SPH_C32(0xc6c322c5) },
  { SPH_C32(0x95c20000), SPH_C32(0x34e60000), SPH_C32(0x3742002e),
    SPH_C32(0x542f1800), SPH_C32(0xd493295f), SPH_C32(0xa9d72eb7),
    SPH_C32(0x29377445), SPH_C32(0xf8654232), SPH_C32(0x4edb0000),
    SPH_C32(0x706f0000), SPH_C32(0x4e36000d), SPH_C32(0x7c8c2000),
    SPH_C32(0x53013aea), SPH_C32(0xc4553b4e), SPH_C32(0xd9b1bed8),
    SPH_C32(0xfc875b74) },
  { SPH_C32(0xcd810000), SPH_C32(0xb4980000), SPH_C32(0x4f71002f),
    SPH_C32(0x92442000), SPH_C32(0x33a47583), SPH_C32(0xd07a116a),
    SPH_C32(0x85448a2a), SPH_C32(0xc2213b83), SPH_C32(0x53810000),
    SPH_C32(0x5b1d0000), SPH_C32(0x06bb000d), SPH_C32(0xd3ed3800),
    SPH_C32(0x76ca142f), SPH_C32(0x0c2c849e), SPH_C32(0x5813baf1),
    SPH_C32(0xe2f26dd2) },
  { SPH_C32(0x2da30000), SPH_C32(0x0bb20000), SPH_C32(0x31ff0030),
    SPH_C32(0x87e00000), SPH_C32(0x7ec60a4f), SPH_C32(0x19713b5a),
    SPH_C32(0x5fa418b4), SPH_C32(0xed0b3dd2), SPH_C32(0x0c2f0000),
    SPH_C32(0x69330000), SPH_C32(0xf9fc0006), SPH_C32(0x828b0000),
    SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7), SPH_C32(0x001826bc),
    SPH_C32(0x48c3a5ad) },
  { SPH_C32(0x75e00000), SPH_C32(0x8bcc0000), SPH_C32(0x49cc0031),
    SPH_C32(0x418b3800), SPH_C32(0x99f15693), SPH_C32(0x60dc0487),
    SPH_C32(0xf3d7e6db), SPH_C32(0xd74f4463), SPH_C32(0x11750000),
    SPH_C32(0x42410000), SPH_C32(0xb1710006), SPH_C32(0x2dea1800),
    SPH_C32(0xf7444598), SPH_C32(0xf53f6a37), SPH_C32(0x81ba2295),
    SPH_C32(0x56b6930b) },
  { SPH_C32(0x30f90000), SPH_C32(0x20c00000), SPH_C32(0x79720030),
    SPH_C32(0x28811800), SPH_C32(0x5b0d248a), SPH_C32(0xd108848a),
    SPH_C32(0xde061c9d), SPH_C32(0xf37e0b74), SPH_C32(0x49360000),
    SPH_C32(0xc23f0000), SPH_C32(0xc9420007), SPH_C32(0xeb812000),
    SPH_C32(0x10731944), SPH_C32(0x8c9255ea), SPH_C32(0x2dc9dcfa),
    SPH_C32(0x6cf2eaba) },
  { SPH_C32(0x68ba0000), SPH_C32(0xa0be0000), SPH_C32(0x01410031),
    SPH_C32(0xeeea2000), SPH_C32(0xbc3a7856), SPH_C32(0xa8a5bb57),
    SPH_C32(0x7275e2f2), SPH_C32(0xc93a72c5), SPH_C32(0x546c0000),
    SPH_C32(0xe94d0000), SPH_C32(0x81cf0007), SPH_C32(0x44e03800),
    SPH_C32(0x35b83781), SPH_C32(0x44ebea3a), SPH_C32(0xac6bd8d3),
    SPH_C32(0x7287dc1c) },
  { SPH_C32(0x8f750000), SPH_C32(0xadc40000), SPH_C32(0xf8bb0024),
    SPH_C32(0x6c430000), SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3),
    SPH_C32(0x5ced124e), SPH_C32(0x7665c55a), SPH_C32(0xa9140000),
    SPH_C32(0x7d150000), SPH_C32(0xb7cc0018), SPH_C32(0xfe250000),
    SPH_C32(0x5d116688), SPH_C32(0x45997fda), SPH_C32(0xf7294e64),
    SPH_C32(0x43d8eceb) },
  { SPH_C32(0xd7360000), SPH_C32(0x2dba0000), SPH_C32(0x80880025),
    SPH_C32(0xaa283800), SPH_C32(0x551d78e8), SPH_C32(0x50c4c01e),
    SPH_C32(0xf09eec21), SPH_C32(0x4c21bceb), SPH_C32(0xb44e0000),
    SPH_C32(0x56670000), SPH_C32(0xff410018), SPH_C32(0x51441800),
    SPH_C32(0x78da484d), SPH_C32(0x8de0c00a), SPH_C32(0x768b4a4d),
    SPH_C32(0x5dadda4d) },
  { SPH_C32(0x922f0000), SPH_C32(0x86b60000), SPH_C32(0xb0360024),
    SPH_C32(0xc3221800), SPH_C32(0x97e10af1), SPH_C32(0xe1104013),
    SPH_C32(0xdd4f1667), SPH_C32(0x6810f3fc), SPH_C32(0xec0d0000),
    SPH_C32(0xd6190000), SPH_C32(0x87720019), SPH_C32(0x972f2000),
    SPH_C32(0x9fed1491), SPH_C32(0xf44dffd7), SPH_C32(0xdaf8b422),
    SPH_C32(0x67e9a3fc) },
  { SPH_C32(0xca6c0000), SPH_C32(0x06c80000), SPH_C32(0xc8050025),
    SPH_C32(0x05492000), SPH_C32(0x70d6562d), SPH_C32(0x98bd7fce),
    SPH_C32(0x713ce808), SPH_C32(0x52548a4d), SPH_C32(0xf1570000),
    SPH_C32(0xfd6b0000), SPH_C32(0xcfff0019), SPH_C32(0x384e3800),
    SPH_C32(0xba263a54), SPH_C32(0x3c344007), SPH_C32(0x5b5ab00b),
    SPH_C32(0x799c955a) },
  { SPH_C32(0x2a4e0000), SPH_C32(0xb9e20000), SPH_C32(0xb68b003a),
    SPH_C32(0x10ed0000), SPH_C32(0x3db429e1), SPH_C32(0x51b655fe),
    SPH_C32(0xabdc7a96), SPH_C32(0x7d7e8c1c), SPH_C32(0xaef90000),
    SPH_C32(0xcf450000), SPH_C32(0x30b80012), SPH_C32(0x69280000),
    SPH_C32(0x1e634526), SPH_C32(0x0d5e117e), SPH_C32(0x03512c46),
    SPH_C32(0xd3ad5d25) },
  { SPH_C32(0x720d0000), SPH_C32(0x399c0000), SPH_C32(0xceb8003b),
    SPH_C32(0xd6863800), SPH_C32(0xda83753d), SPH_C32(0x281b6a23),
    SPH_C32(0x07af84f9), SPH_C32(0x473af5ad), SPH_C32(0xb3a30000),
    SPH_C32(0xe4370000), SPH_C32(0x78350012), SPH_C32(0xc6491800),
    SPH_C32(0x3ba86be3), SPH_C32(0xc527aeae), SPH_C32(0x82f3286f),
    SPH_C32(0xcdd86b83) },
  { SPH_C32(0x37140000), SPH_C32(0x92900000), SPH_C32(0xfe06003a),
    SPH_C32(0xbf8c1800), SPH_C32(0x187f0724), SPH_C32(0x99cfea2e),
    SPH_C32(0x2a7e7ebf), SPH_C32(0x630bbaba), SPH_C32(0xebe00000),
    SPH_C32(0x64490000), SPH_C32(0x00060013), SPH_C32(0x00222000),
    SPH_C32(0xdc9f373f), SPH_C32(0xbc8a9173), SPH_C32(0x2e80d600),
    SPH_C32(0xf79c1232) },
  { SPH_C32(0x6f570000), SPH_C32(0x12ee0000), SPH_C32(0x8635003b),
    SPH_C32(0x79e72000), SPH_C32(0xff485bf8), SPH_C32(0xe062d5f3),
    SPH_C32(0x860d80d0), SPH_C32(0x594fc30b), SPH_C32(0xf6ba0000),
    SPH_C32(0x4f3b0000), SPH_C32(0x488b0013), SPH_C32(0xaf433800),
    SPH_C32(0xf95419fa), SPH_C32(0x74f32ea3), SPH_C32(0xaf22d229),
    SPH_C32(0xe9e92494) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x53810000), SPH_C32(0x5b1d0000), SPH_C32(0x06bb000d),
    SPH_C32(0xd3ed3800), SPH_C32(0x76ca142f), SPH_C32(0x0c2c849e),
    SPH_C32(0x5813baf1), SPH_C32(0xe2f26dd2), SPH_C32(0x9e000000),
    SPH_C32(0xef850000), SPH_C32(0x49ca0022), SPH_C32(0x41a91800),
    SPH_C32(0x456e61ac), SPH_C32(0xdc5695f4), SPH_C32(0xdd5730db),
    SPH_C32(0x20d35651) },
  { SPH_C32(0x16980000), SPH_C32(0xf0110000), SPH_C32(0x3605000c),
    SPH_C32(0xbae71800), SPH_C32(0xb4366636), SPH_C32(0xbdf80493),
    SPH_C32(0x75c240b7), SPH_C32(0xc6c322c5), SPH_C32(0xc6430000),
    SPH_C32(0x6ffb0000), SPH_C32(0x31f90023), SPH_C32(0x87c22000),
    SPH_C32(0xa2593d70), SPH_C32(0xa5fbaa29), SPH_C32(0x7124ceb4),
    SPH_C32(0x1a972fe0) },
  { SPH_C32(0x4edb0000), SPH_C32(0x706f0000), SPH_C32(0x4e36000d),
    SPH_C32(0x7c8c2000), SPH_C32(0x53013aea), SPH_C32(0xc4553b4e),
    SPH_C32(0xd9b1bed8), SPH_C32(0xfc875b74), SPH_C32(0xdb190000),
    SPH_C32(0x44890000), SPH_C32(0x79740023), SPH_C32(0x28a33800),
    SPH_C32(0x879213b5), SPH_C32(0x6d8215f9), SPH_C32(0xf086ca9d),
    SPH_C32(0x04e21946) },
  { SPH_C32(0xaef90000), SPH_C32(0xcf450000), SPH_C32(0x30b80012),
    SPH_C32(0x69280000), SPH_C32(0x1e634526), SPH_C32(0x0d5e117e),
    SPH_C32(0x03512c46), SPH_C32(0xd3ad5d25), SPH_C32(0x84b70000),
    SPH_C32(0x76a70000), SPH_C32(0x86330028), SPH_C32(0x79c50000),
    SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480), SPH_C32(0xa88d56d0),
    SPH_C32(0xaed3d139) },
  { SPH_C32(0xf6ba0000), SPH_C32(0x4f3b0000), SPH_C32(0x488b0013),
    SPH_C32(0xaf433800), SPH_C32(0xf95419fa), SPH_C32(0x74f32ea3),
    SPH_C32(0xaf22d229), SPH_C32(0xe9e92494), SPH_C32(0x99ed0000),
    SPH_C32(0x5dd50000), SPH_C32(0xcebe0028), SPH_C32(0xd6a41800),
    SPH_C32(0x061c4202), SPH_C32(0x9491fb50), SPH_C32(0x292f52f9),
    SPH_C32(0xb0a6e79f) },
  { SPH_C32(0xb3a30000), SPH_C32(0xe4370000), SPH_C32(0x78350012),
    SPH_C32(0xc6491800), SPH_C32(0x3ba86be3), SPH_C32(0xc527aeae),
    SPH_C32(0x82f3286f), SPH_C32(0xcdd86b83), SPH_C32(0xc1ae0000),
    SPH_C32(0xddab0000), SPH_C32(0xb68d0029), SPH_C32(0x10cf2000),
    SPH_C32(0xe12b1ede), SPH_C32(0xed3cc48d), SPH_C32(0x855cac96),
    SPH_C32(0x8ae29e2e) },
  { SPH_C32(0xebe00000), SPH_C32(0x64490000), SPH_C32(0x00060013),
    SPH_C32(0x00222000), SPH_C32(0xdc9f373f), SPH_C32(0xbc8a9173),
    SPH_C32(0x2e80d600), SPH_C32(0xf79c1232), SPH_C32(0xdcf40000),
    SPH_C32(0xf6d90000), SPH_C32(0xfe000029), SPH_C32(0xbfae3800),
    SPH_C32(0xc4e0301b), SPH_C32(0x25457b5d), SPH_C32(0x04fea8bf),
    SPH_C32(0x9497a888) },
  { SPH_C32(0x0c2f0000), SPH_C32(0x69330000), SPH_C32(0xf9fc0006),
    SPH_C32(0x828b0000), SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7),
    SPH_C32(0x001826bc), SPH_C32(0x48c3a5ad), SPH_C32(0x218c0000),
    SPH_C32(0x62810000), SPH_C32(0xc8030036), SPH_C32(0x056b0000),
    SPH_C32(0xac496112), SPH_C32(0x2437eebd), SPH_C32(0x5fbc3e08),
    SPH_C32(0xa5c8987f) },
  { SPH_C32(0x546c0000), SPH_C32(0xe94d0000), SPH_C32(0x81cf0007),
    SPH_C32(0x44e03800), SPH_C32(0x35b83781), SPH_C32(0x44ebea3a),
    SPH_C32(0xac6bd8d3), SPH_C32(0x7287dc1c), SPH_C32(0x3cd60000),
    SPH_C32(0x49f30000), SPH_C32(0x808e0036), SPH_C32(0xaa0a1800),
    SPH_C32(0x89824fd7), SPH_C32(0xec4e516d), SPH_C32(0xde1e3a21),
    SPH_C32(0xbbbdaed9) },
  { SPH_C32(0x11750000), SPH_C32(0x42410000), SPH_C32(0xb1710006),
    SPH_C32(0x2dea1800), SPH_C32(0xf7444598), SPH_C32(0xf53f6a37),
    SPH_C32(0x81ba2295), SPH_C32(0x56b6930b), SPH_C32(0x64950000),
    SPH_C32(0xc98d0000), SPH_C32(0xf8bd0037), SPH_C32(0x6c612000),
    SPH_C32(0x6eb5130b), SPH_C32(0x95e36eb0), SPH_C32(0x726dc44e),
    SPH_C32(0x81f9d768) },
  { SPH_C32(0x49360000), SPH_C32(0xc23f0000), SPH_C32(0xc9420007),
    SPH_C32(0xeb812000), SPH_C32(0x10731944), SPH_C32(0x8c9255ea),
    SPH_C32(0x2dc9dcfa), SPH_C32(0x6cf2eaba), SPH_C32(0x79cf0000),
    SPH_C32(0xe2ff0000), SPH_C32(0xb0300037), SPH_C32(0xc3003800),
    SPH_C32(0x4b7e3dce), SPH_C32(0x5d9ad160), SPH_C32(0xf3cfc067),
    SPH_C32(0x9f8ce1ce) },
  { SPH_C32(0xa9140000), SPH_C32(0x7d150000), SPH_C32(0xb7cc0018),
    SPH_C32(0xfe250000), SPH_C32(0x5d116688), SPH_C32(0x45997fda),
    SPH_C32(0xf7294e64), SPH_C32(0x43d8eceb), SPH_C32(0x26610000),
    SPH_C32(0xd0d10000), SPH_C32(0x4f77003c), SPH_C32(0x92660000),
    SPH_C32(0xef3b42bc), SPH_C32(0x6cf08019), SPH_C32(0xabc45c2a),
    SPH_C32(0x35bd29b1) },
  { SPH_C32(0xf1570000), SPH_C32(0xfd6b0000), SPH_C32(0xcfff0019),
    SPH_C32(0x384e3800), SPH_C32(0xba263a54), SPH_C32(0x3c344007),
    SPH_C32(0x5b5ab00b), SPH_C32(0x799c955a), SPH_C32(0x3b3b0000),
    SPH_C32(0xfba30000), SPH_C32(0x07fa003c), SPH_C32(0x3d071800),
    SPH_C32(0xcaf06c79), SPH_C32(0xa4893fc9), SPH_C32(0x2a665803),
    SPH_C32(0x2bc81f17) },
  { SPH_C32(0xb44e0000), SPH_C32(0x56670000), SPH_C32(0xff410018),
    SPH_C32(0x51441800), SPH_C32(0x78da484d), SPH_C32(0x8de0c00a),
    SPH_C32(0x768b4a4d), SPH_C32(0x5dadda4d), SPH_C32(0x63780000),
    SPH_C32(0x7bdd0000), SPH_C32(0x7fc9003d), SPH_C32(0xfb6c2000),
    SPH_C32(0x2dc730a5), SPH_C32(0xdd240014), SPH_C32(0x8615a66c),
    SPH_C32(0x118c66a6) },
  { SPH_C32(0xec0d0000), SPH_C32(0xd6190000), SPH_C32(0x87720019),
    SPH_C32(0x972f2000), SPH_C32(0x9fed1491), SPH_C32(0xf44dffd7),
    SPH_C32(0xdaf8b422), SPH_C32(0x67e9a3fc), SPH_C32(0x7e220000),
    SPH_C32(0x50af0000), SPH_C32(0x3744003d), SPH_C32(0x540d3800),
    SPH_C32(0x080c1e60), SPH_C32(0x155dbfc4), SPH_C32(0x07b7a245),
    SPH_C32(0x0ff95000) },
  { SPH_C32(0x835a0000), SPH_C32(0xc4f70000), SPH_C32(0x01470022),
    SPH_C32(0xeec80000), SPH_C32(0x60a54f69), SPH_C32(0x142f2a24),
    SPH_C32(0x5cf534f2), SPH_C32(0x3ea660f7), SPH_C32(0x88980000),
    SPH_C32(0x1f940000), SPH_C32(0x7fcf002e), SPH_C32(0xfb4e0000),
    SPH_C32(0xf158079a), SPH_C32(0x61ae9167), SPH_C32(0xa895706c),
    SPH_C32(0xe6107494) },
  { SPH_C32(0xdb190000), SPH_C32(0x44890000), SPH_C32(0x79740023),
    SPH_C32(0x28a33800), SPH_C32(0x879213b5), SPH_C32(0x6d8215f9),
    SPH_C32(0xf086ca9d), SPH_C32(0x04e21946), SPH_C32(0x95c20000),
    SPH_C32(0x34e60000), SPH_C32(0x3742002e), SPH_C32(0x542f1800),
    SPH_C32(0xd493295f), SPH_C32(0xa9d72eb7), SPH_C32(0x29377445),
    SPH_C32(0xf8654232) },
  { SPH_C32(0x9e000000), SPH_C32(0xef850000), SPH_C32(0x49ca0022),
    SPH_C32(0x41a91800), SPH_C32(0x456e61ac), SPH_C32(0xdc5695f4),
    SPH_C32(0xdd5730db), SPH_C32(0x20d35651), SPH_C32(0xcd810000),
    SPH_C32(0xb4980000), SPH_C32(0x4f71002f), SPH_C32(0x92442000),
    SPH_C32(0x33a47583), SPH_C32(0xd07a116a), SPH_C32(0x85448a2a),
    SPH_C32(0xc2213b83) },
  { SPH_C32(0xc6430000), SPH_C32(0x6ffb0000), SPH_C32(0x31f90023),
    SPH_C32(0x87c22000), SPH_C32(0xa2593d70), SPH_C32(0xa5fbaa29),
    SPH_C32(0x7124ceb4), SPH_C32(0x1a972fe0), SPH_C32(0xd0db0000),
    SPH_C32(0x9fea0000), SPH_C32(0x07fc002f), SPH_C32(0x3d253800),
    SPH_C32(0x166f5b46), SPH_C32(0x1803aeba), SPH_C32(0x04e68e03),
    SPH_C32(0xdc540d25) },
  { SPH_C32(0x26610000), SPH_C32(0xd0d10000), SPH_C32(0x4f77003c),
    SPH_C32(0x92660000), SPH_C32(0xef3b42bc), SPH_C32(0x6cf08019),
    SPH_C32(0xabc45c2a), SPH_C32(0x35bd29b1), SPH_C32(0x8f750000),
    SPH_C32(0xadc40000), SPH_C32(0xf8bb0024), SPH_C32(0x6c430000),
    SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3), SPH_C32(0x5ced124e),
    SPH_C32(0x7665c55a) },
  { SPH_C32(0x7e220000), SPH_C32(0x50af0000), SPH_C32(0x3744003d),
    SPH_C32(0x540d3800), SPH_C32(0x080c1e60), SPH_C32(0x155dbfc4),
    SPH_C32(0x07b7a245), SPH_C32(0x0ff95000), SPH_C32(0x922f0000),
    SPH_C32(0x86b60000), SPH_C32(0xb0360024), SPH_C32(0xc3221800),
    SPH_C32(0x97e10af1), SPH_C32(0xe1104013), SPH_C32(0xdd4f1667),
    SPH_C32(0x6810f3fc) },
  { SPH_C32(0x3b3b0000), SPH_C32(0xfba30000), SPH_C32(0x07fa003c),
    SPH_C32(0x3d071800), SPH_C32(0xcaf06c79), SPH_C32(0xa4893fc9),
    SPH_C32(0x2a665803), SPH_C32(0x2bc81f17), SPH_C32(0xca6c0000),
    SPH_C32(0x06c80000), SPH_C32(0xc8050025), SPH_C32(0x05492000),
    SPH_C32(0x70d6562d), SPH_C32(0x98bd7fce), SPH_C32(0x713ce808),
    SPH_C32(0x52548a4d) },
  { SPH_C32(0x63780000), SPH_C32(0x7bdd0000), SPH_C32(0x7fc9003d),
    SPH_C32(0xfb6c2000), SPH_C32(0x2dc730a5), SPH_C32(0xdd240014),
    SPH_C32(0x8615a66c), SPH_C32(0x118c66a6), SPH_C32(0xd7360000),
    SPH_C32(0x2dba0000), SPH_C32(0x80880025), SPH_C32(0xaa283800),
    SPH_C32(0x551d78e8), SPH_C32(0x50c4c01e), SPH_C32(0xf09eec21),
    SPH_C32(0x4c21bceb) },
  { SPH_C32(0x84b70000), SPH_C32(0x76a70000), SPH_C32(0x86330028),
    SPH_C32(0x79c50000), SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480),
    SPH_C32(0xa88d56d0), SPH_C32(0xaed3d139), SPH_C32(0x2a4e0000),
    SPH_C32(0xb9e20000), SPH_C32(0xb68b003a), SPH_C32(0x10ed0000),
    SPH_C32(0x3db429e1), SPH_C32(0x51b655fe), SPH_C32(0xabdc7a96),
    SPH_C32(0x7d7e8c1c) },
  { SPH_C32(0xdcf40000), SPH_C32(0xf6d90000), SPH_C32(0xfe000029),
    SPH_C32(0xbfae3800), SPH_C32(0xc4e0301b), SPH_C32(0x25457b5d),
    SPH_C32(0x04fea8bf), SPH_C32(0x9497a888), SPH_C32(0x37140000),
    SPH_C32(0x92900000), SPH_C32(0xfe06003a), SPH_C32(0xbf8c1800),
    SPH_C32(0x187f0724), SPH_C32(0x99cfea2e), SPH_C32(0x2a7e7ebf),
    SPH_C32(0x630bbaba) },
  { SPH_C32(0x99ed0000), SPH_C32(0x5dd50000), SPH_C32(0xcebe0028),
    SPH_C32(0xd6a41800), SPH_C32(0x061c4202), SPH_C32(0x9491fb50),
    SPH_C32(0x292f52f9), SPH_C32(0xb0a6e79f), SPH_C32(0x6f570000),
    SPH_C32(0x12ee0000), SPH_C32(0x8635003b), SPH_C32(0x79e72000),
    SPH_C32(0xff485bf8), SPH_C32(0xe062d5f3), SPH_C32(0x860d80d0),
    SPH_C32(0x594fc30b) },
  { SPH_C32(0xc1ae0000), SPH_C32(0xddab0000), SPH_C32(0xb68d0029),
    SPH_C32(0x10cf2000), SPH_C32(0xe12b1ede), SPH_C32(0xed3cc48d),
    SPH_C32(0x855cac96), SPH_C32(0x8ae29e2e), SPH_C32(0x720d0000),
    SPH_C32(0x399c0000), SPH_C32(0xceb8003b), SPH_C32(0xd6863800),
    SPH_C32(0xda83753d), SPH_C32(0x281b6a23), SPH_C32(0x07af84f9),
    SPH_C32(0x473af5ad) },
  { SPH_C32(0x218c0000), SPH_C32(0x62810000), SPH_C32(0xc8030036),
    SPH_C32(0x056b0000), SPH_C32(0xac496112), SPH_C32(0x2437eebd),
    SPH_C32(0x5fbc3e08), SPH_C32(0xa5c8987f), SPH_C32(0x2da30000),
    SPH_C32(0x0bb20000), SPH_C32(0x31ff0030), SPH_C32(0x87e00000),
    SPH_C32(0x7ec60a4f), SPH_C32(0x19713b5a), SPH_C32(0x5fa418b4),
    SPH_C32(0xed0b3dd2) },
  { SPH_C32(0x79cf0000), SPH_C32(0xe2ff0000), SPH_C32(0xb0300037),
    SPH_C32(0xc3003800), SPH_C32(0x4b7e3dce), SPH_C32(0x5d9ad160),
    SPH_C32(0xf3cfc067), SPH_C32(0x9f8ce1ce), SPH_C32(0x30f90000),
    SPH_C32(0x20c00000), SPH_C32(0x79720030), SPH_C32(0x28811800),
    SPH_C32(0x5b0d248a), SPH_C32(0xd108848a), SPH_C32(0xde061c9d),
    SPH_C32(0xf37e0b74) },
  { SPH_C32(0x3cd60000), SPH_C32(0x49f30000), SPH_C32(0x808e0036),
    SPH_C32(0xaa0a1800), SPH_C32(0x89824fd7), SPH_C32(0xec4e516d),
    SPH_C32(0xde1e3a21), SPH_C32(0xbbbdaed9), SPH_C32(0x68ba0000),
    SPH_C32(0xa0be0000), SPH_C32(0x01410031), SPH_C32(0xeeea2000),
    SPH_C32(0xbc3a7856), SPH_C32(0xa8a5bb57), SPH_C32(0x7275e2f2),
    SPH_C32(0xc93a72c5) },
  { SPH_C32(0x64950000), SPH_C32(0xc98d0000), SPH_C32(0xf8bd0037),
    SPH_C32(0x6c612000), SPH_C32(0x6eb5130b), SPH_C32(0x95e36eb0),
    SPH_C32(0x726dc44e), SPH_C32(0x81f9d768), SPH_C32(0x75e00000),
    SPH_C32(0x8bcc0000), SPH_C32(0x49cc0031), SPH_C32(0x418b3800),
    SPH_C32(0x99f15693), SPH_C32(0x60dc0487), SPH_C32(0xf3d7e6db),
    SPH_C32(0xd74f4463) }
};

__constant static const sph_u32 T512_48[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x57370000), SPH_C32(0xcaf20000), SPH_C32(0x364e0000),
    SPH_C32(0xc0220480), SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c),
    SPH_C32(0xa1937f8f), SPH_C32(0x15b961e7), SPH_C32(0xb4310000),
    SPH_C32(0x77330000), SPH_C32(0xb15d0000), SPH_C32(0x7fd004e0),
    SPH_C32(0x78a26138), SPH_C32(0xd116c35d), SPH_C32(0xd256d489),
    SPH_C32(0x4e6f74de) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xb6c30000), SPH_C32(0xd5b20000), SPH_C32(0x36620000),
    SPH_C32(0x9cbc7ce0), SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b),
    SPH_C32(0x1694e6be), SPH_C32(0x315d5140), SPH_C32(0x59db0000),
    SPH_C32(0xae6c0000), SPH_C32(0x30f40000), SPH_C32(0x48da2860),
    SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b), SPH_C32(0x999f2612),
    SPH_C32(0x71fa0dc9) },
  { SPH_C32(0xe1f40000), SPH_C32(0x1f400000), SPH_C32(0x002c0000),
    SPH_C32(0x5c9e7860), SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87),
    SPH_C32(0xb7079931), SPH_C32(0x24e430a7), SPH_C32(0xedea0000),
    SPH_C32(0xd95f0000), SPH_C32(0x81a90000), SPH_C32(0x370a2c80),
    SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736), SPH_C32(0x4bc9f29b),
    SPH_C32(0x3f957917) },
  { SPH_C32(0x55c50000), SPH_C32(0x68730000), SPH_C32(0xb1710000),
    SPH_C32(0x234e7c80), SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda),
    SPH_C32(0x65514db8), SPH_C32(0x6a8b4479), SPH_C32(0x0eec0000),
    SPH_C32(0x649e0000), SPH_C32(0x06ba0000), SPH_C32(0x88f82ce0),
    SPH_C32(0xa7e77575), SPH_C32(0xe70c0067), SPH_C32(0x380c599d),
    SPH_C32(0x64436c2e) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0x0eec0000), SPH_C32(0x649e0000), SPH_C32(0x06ba0000),
    SPH_C32(0x88f82ce0), SPH_C32(0xa7e77575), SPH_C32(0xe70c0067),
    SPH_C32(0x380c599d), SPH_C32(0x64436c2e), SPH_C32(0x5b290000),
    SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000), SPH_C32(0xabb65060),
    SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd), SPH_C32(0x5d5d1425),
    SPH_C32(0x0ec82857) },
  { SPH_C32(0x59db0000), SPH_C32(0xae6c0000), SPH_C32(0x30f40000),
    SPH_C32(0x48da2860), SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b),
    SPH_C32(0x999f2612), SPH_C32(0x71fa0dc9), SPH_C32(0xef180000),
    SPH_C32(0x7bde0000), SPH_C32(0x06960000), SPH_C32(0xd4665480),
    SPH_C32(0x97400b80), SPH_C32(0x6d841ce0), SPH_C32(0x8f0bc0ac),
    SPH_C32(0x40a75c89) },
  { SPH_C32(0xedea0000), SPH_C32(0xd95f0000), SPH_C32(0x81a90000),
    SPH_C32(0x370a2c80), SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736),
    SPH_C32(0x4bc9f29b), SPH_C32(0x3f957917), SPH_C32(0x0c1e0000),
    SPH_C32(0xc61f0000), SPH_C32(0x81850000), SPH_C32(0x6b9454e0),
    SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1), SPH_C32(0xfcce6baa),
    SPH_C32(0x1b7149b0) },
  { SPH_C32(0xb82f0000), SPH_C32(0xb12c0000), SPH_C32(0x30d80000),
    SPH_C32(0x14445000), SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec),
    SPH_C32(0x2e98bf23), SPH_C32(0x551e3d6e), SPH_C32(0x02f20000),
    SPH_C32(0xa2810000), SPH_C32(0x873f0000), SPH_C32(0xe36c7800),
    SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6), SPH_C32(0xc4c23237),
    SPH_C32(0x7f32259e) },
  { SPH_C32(0x0c1e0000), SPH_C32(0xc61f0000), SPH_C32(0x81850000),
    SPH_C32(0x6b9454e0), SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1),
    SPH_C32(0xfcce6baa), SPH_C32(0x1b7149b0), SPH_C32(0xe1f40000),
    SPH_C32(0x1f400000), SPH_C32(0x002c0000), SPH_C32(0x5c9e7860),
    SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87), SPH_C32(0xb7079931),
    SPH_C32(0x24e430a7) },
  { SPH_C32(0x5b290000), SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000),
    SPH_C32(0xabb65060), SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd),
    SPH_C32(0x5d5d1425), SPH_C32(0x0ec82857), SPH_C32(0x55c50000),
    SPH_C32(0x68730000), SPH_C32(0xb1710000), SPH_C32(0x234e7c80),
    SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda), SPH_C32(0x65514db8),
    SPH_C32(0x6a8b4479) },
  { SPH_C32(0xef180000), SPH_C32(0x7bde0000), SPH_C32(0x06960000),
    SPH_C32(0xd4665480), SPH_C32(0x97400b80), SPH_C32(0x6d841ce0),
    SPH_C32(0x8f0bc0ac), SPH_C32(0x40a75c89), SPH_C32(0xb6c30000),
    SPH_C32(0xd5b20000), SPH_C32(0x36620000), SPH_C32(0x9cbc7ce0),
    SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b), SPH_C32(0x1694e6be),
    SPH_C32(0x315d5140) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0xaa5d0000), SPH_C32(0xb3710000), SPH_C32(0x3b730000),
    SPH_C32(0xc366bce0), SPH_C32(0x54e6728e), SPH_C32(0x5aeb1087),
    SPH_C32(0xb85acf41), SPH_C32(0xf7f2b635), SPH_C32(0x71500000),
    SPH_C32(0xa31b0000), SPH_C32(0x6d420000), SPH_C32(0x57433060),
    SPH_C32(0x878f5cbf), SPH_C32(0x664e56c8), SPH_C32(0xc2998952),
    SPH_C32(0x68133176) },
  { SPH_C32(0xfd6a0000), SPH_C32(0x79830000), SPH_C32(0x0d3d0000),
    SPH_C32(0x0344b860), SPH_C32(0x02fe19ac), SPH_C32(0x0648e48b),
    SPH_C32(0x19c9b0ce), SPH_C32(0xe24bd7d2), SPH_C32(0xc5610000),
    SPH_C32(0xd4280000), SPH_C32(0xdc1f0000), SPH_C32(0x28933480),
    SPH_C32(0xff2d3d87), SPH_C32(0xb7589595), SPH_C32(0x10cf5ddb),
    SPH_C32(0x267c45a8) },
  { SPH_C32(0x495b0000), SPH_C32(0x0eb00000), SPH_C32(0xbc600000),
    SPH_C32(0x7c94bc80), SPH_C32(0x7a5c7894), SPH_C32(0xd75e27d6),
    SPH_C32(0xcb9f6447), SPH_C32(0xac24a30c), SPH_C32(0x26670000),
    SPH_C32(0x69e90000), SPH_C32(0x5b0c0000), SPH_C32(0x976134e0),
    SPH_C32(0xd197379d), SPH_C32(0x3aeda2c4), SPH_C32(0x630af6dd),
    SPH_C32(0x7daa5091) },
  { SPH_C32(0x1c9e0000), SPH_C32(0x66c30000), SPH_C32(0x0d110000),
    SPH_C32(0x5fdac000), SPH_C32(0x32596759), SPH_C32(0x8cc0f80c),
    SPH_C32(0xaece29ff), SPH_C32(0xc6afe775), SPH_C32(0x288b0000),
    SPH_C32(0x0d770000), SPH_C32(0x5db60000), SPH_C32(0x1f991800),
    SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3), SPH_C32(0x5b06af40),
    SPH_C32(0x19e93cbf) },
  { SPH_C32(0xa8af0000), SPH_C32(0x11f00000), SPH_C32(0xbc4c0000),
    SPH_C32(0x200ac4e0), SPH_C32(0x4afb0661), SPH_C32(0x5dd63b51),
    SPH_C32(0x7c98fd76), SPH_C32(0x88c093ab), SPH_C32(0xcb8d0000),
    SPH_C32(0xb0b60000), SPH_C32(0xdaa50000), SPH_C32(0xa06b1860),
    SPH_C32(0x58ca48f2), SPH_C32(0x505495f2), SPH_C32(0x28c30446),
    SPH_C32(0x423f2986) },
  { SPH_C32(0xff980000), SPH_C32(0xdb020000), SPH_C32(0x8a020000),
    SPH_C32(0xe028c060), SPH_C32(0x1ce36d43), SPH_C32(0x0175cf5d),
    SPH_C32(0xdd0b82f9), SPH_C32(0x9d79f24c), SPH_C32(0x7fbc0000),
    SPH_C32(0xc7850000), SPH_C32(0x6bf80000), SPH_C32(0xdfbb1c80),
    SPH_C32(0x206829ca), SPH_C32(0x814256af), SPH_C32(0xfa95d0cf),
    SPH_C32(0x0c505d58) },
  { SPH_C32(0x4ba90000), SPH_C32(0xac310000), SPH_C32(0x3b5f0000),
    SPH_C32(0x9ff8c480), SPH_C32(0x64410c7b), SPH_C32(0xd0630c00),
    SPH_C32(0x0f5d5670), SPH_C32(0xd3168692), SPH_C32(0x9cba0000),
    SPH_C32(0x7a440000), SPH_C32(0xeceb0000), SPH_C32(0x60491ce0),
    SPH_C32(0x0ed223d0), SPH_C32(0x0cf761fe), SPH_C32(0x89507bc9),
    SPH_C32(0x57864861) },
  { SPH_C32(0xa4b10000), SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000),
    SPH_C32(0x4b9e9000), SPH_C32(0xf30107fb), SPH_C32(0xbde710e0),
    SPH_C32(0x805696dc), SPH_C32(0x93b1da1b), SPH_C32(0x2a790000),
    SPH_C32(0xaff60000), SPH_C32(0xda890000), SPH_C32(0xfcf56000),
    SPH_C32(0x686d3607), SPH_C32(0xdadc8975), SPH_C32(0x9fc49d77),
    SPH_C32(0x66db1921) },
  { SPH_C32(0x10800000), SPH_C32(0xa0dc0000), SPH_C32(0x8c940000),
    SPH_C32(0x344e94e0), SPH_C32(0x8ba366c3), SPH_C32(0x6cf1d3bd),
    SPH_C32(0x52004255), SPH_C32(0xdddeaec5), SPH_C32(0xc97f0000),
    SPH_C32(0x12370000), SPH_C32(0x5d9a0000), SPH_C32(0x43076060),
    SPH_C32(0x46d73c1d), SPH_C32(0x5769be24), SPH_C32(0xec013671),
    SPH_C32(0x3d0d0c18) },
  { SPH_C32(0x47b70000), SPH_C32(0x6a2e0000), SPH_C32(0xbada0000),
    SPH_C32(0xf46c9060), SPH_C32(0xddbb0de1), SPH_C32(0x305227b1),
    SPH_C32(0xf3933dda), SPH_C32(0xc867cf22), SPH_C32(0x7d4e0000),
    SPH_C32(0x65040000), SPH_C32(0xecc70000), SPH_C32(0x3cd76480),
    SPH_C32(0x3e755d25), SPH_C32(0x867f7d79), SPH_C32(0x3e57e2f8),
    SPH_C32(0x736278c6) },
  { SPH_C32(0xf3860000), SPH_C32(0x1d1d0000), SPH_C32(0x0b870000),
    SPH_C32(0x8bbc9480), SPH_C32(0xa5196cd9), SPH_C32(0xe144e4ec),
    SPH_C32(0x21c5e953), SPH_C32(0x8608bbfc), SPH_C32(0x9e480000),
    SPH_C32(0xd8c50000), SPH_C32(0x6bd40000), SPH_C32(0x832564e0),
    SPH_C32(0x10cf573f), SPH_C32(0x0bca4a28), SPH_C32(0x4d9249fe),
    SPH_C32(0x28b46dff) },
  { SPH_C32(0xa6430000), SPH_C32(0x756e0000), SPH_C32(0xbaf60000),
    SPH_C32(0xa8f2e800), SPH_C32(0xed1c7314), SPH_C32(0xbada3b36),
    SPH_C32(0x4494a4eb), SPH_C32(0xec83ff85), SPH_C32(0x90a40000),
    SPH_C32(0xbc5b0000), SPH_C32(0x6d6e0000), SPH_C32(0x0bdd4800),
    SPH_C32(0xb728224a), SPH_C32(0xecc64a4f), SPH_C32(0x759e1063),
    SPH_C32(0x4cf701d1) },
  { SPH_C32(0x12720000), SPH_C32(0x025d0000), SPH_C32(0x0bab0000),
    SPH_C32(0xd722ece0), SPH_C32(0x95be122c), SPH_C32(0x6bccf86b),
    SPH_C32(0x96c27062), SPH_C32(0xa2ec8b5b), SPH_C32(0x73a20000),
    SPH_C32(0x019a0000), SPH_C32(0xea7d0000), SPH_C32(0xb42f4860),
    SPH_C32(0x99922850), SPH_C32(0x61737d1e), SPH_C32(0x065bbb65),
    SPH_C32(0x172114e8) },
  { SPH_C32(0x45450000), SPH_C32(0xc8af0000), SPH_C32(0x3de50000),
    SPH_C32(0x1700e860), SPH_C32(0xc3a6790e), SPH_C32(0x376f0c67),
    SPH_C32(0x37510fed), SPH_C32(0xb755eabc), SPH_C32(0xc7930000),
    SPH_C32(0x76a90000), SPH_C32(0x5b200000), SPH_C32(0xcbff4c80),
    SPH_C32(0xe1304968), SPH_C32(0xb065be43), SPH_C32(0xd40d6fec),
    SPH_C32(0x594e6036) },
  { SPH_C32(0xf1740000), SPH_C32(0xbf9c0000), SPH_C32(0x8cb80000),
    SPH_C32(0x68d0ec80), SPH_C32(0xbb041836), SPH_C32(0xe679cf3a),
    SPH_C32(0xe507db64), SPH_C32(0xf93a9e62), SPH_C32(0x24950000),
    SPH_C32(0xcb680000), SPH_C32(0xdc330000), SPH_C32(0x740d4ce0),
    SPH_C32(0xcf8a4372), SPH_C32(0x3dd08912), SPH_C32(0xa7c8c4ea),
    SPH_C32(0x0298750f) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x26670000), SPH_C32(0x69e90000), SPH_C32(0x5b0c0000),
    SPH_C32(0x976134e0), SPH_C32(0xd197379d), SPH_C32(0x3aeda2c4),
    SPH_C32(0x630af6dd), SPH_C32(0x7daa5091), SPH_C32(0x6f3c0000),
    SPH_C32(0x67590000), SPH_C32(0xe76c0000), SPH_C32(0xebf58860),
    SPH_C32(0xabcb4f09), SPH_C32(0xedb38512), SPH_C32(0xa895929a),
    SPH_C32(0xd18ef39d) },
  { SPH_C32(0x71500000), SPH_C32(0xa31b0000), SPH_C32(0x6d420000),
    SPH_C32(0x57433060), SPH_C32(0x878f5cbf), SPH_C32(0x664e56c8),
    SPH_C32(0xc2998952), SPH_C32(0x68133176), SPH_C32(0xdb0d0000),
    SPH_C32(0x106a0000), SPH_C32(0x56310000), SPH_C32(0x94258c80),
    SPH_C32(0xd3692e31), SPH_C32(0x3ca5464f), SPH_C32(0x7ac34613),
    SPH_C32(0x9fe18743) },
  { SPH_C32(0xc5610000), SPH_C32(0xd4280000), SPH_C32(0xdc1f0000),
    SPH_C32(0x28933480), SPH_C32(0xff2d3d87), SPH_C32(0xb7589595),
    SPH_C32(0x10cf5ddb), SPH_C32(0x267c45a8), SPH_C32(0x380b0000),
    SPH_C32(0xadab0000), SPH_C32(0xd1220000), SPH_C32(0x2bd78ce0),
    SPH_C32(0xfdd3242b), SPH_C32(0xb110711e), SPH_C32(0x0906ed15),
    SPH_C32(0xc437927a) },
  { SPH_C32(0x90a40000), SPH_C32(0xbc5b0000), SPH_C32(0x6d6e0000),
    SPH_C32(0x0bdd4800), SPH_C32(0xb728224a), SPH_C32(0xecc64a4f),
    SPH_C32(0x759e1063), SPH_C32(0x4cf701d1), SPH_C32(0x36e70000),
    SPH_C32(0xc9350000), SPH_C32(0xd7980000), SPH_C32(0xa32fa000),
    SPH_C32(0x5a34515e), SPH_C32(0x561c7179), SPH_C32(0x310ab488),
    SPH_C32(0xa074fe54) },
  { SPH_C32(0x24950000), SPH_C32(0xcb680000), SPH_C32(0xdc330000),
    SPH_C32(0x740d4ce0), SPH_C32(0xcf8a4372), SPH_C32(0x3dd08912),
    SPH_C32(0xa7c8c4ea), SPH_C32(0x0298750f), SPH_C32(0xd5e10000),
    SPH_C32(0x74f40000), SPH_C32(0x508b0000), SPH_C32(0x1cdda060),
    SPH_C32(0x748e5b44), SPH_C32(0xdba94628), SPH_C32(0x42cf1f8e),
    SPH_C32(0xfba2eb6d) },
  { SPH_C32(0x73a20000), SPH_C32(0x019a0000), SPH_C32(0xea7d0000),
    SPH_C32(0xb42f4860), SPH_C32(0x99922850), SPH_C32(0x61737d1e),
    SPH_C32(0x065bbb65), SPH_C32(0x172114e8), SPH_C32(0x61d00000),
    SPH_C32(0x03c70000), SPH_C32(0xe1d60000), SPH_C32(0x630da480),
    SPH_C32(0x0c2c3a7c), SPH_C32(0x0abf8575), SPH_C32(0x9099cb07),
    SPH_C32(0xb5cd9fb3) },
  { SPH_C32(0xc7930000), SPH_C32(0x76a90000), SPH_C32(0x5b200000),
    SPH_C32(0xcbff4c80), SPH_C32(0xe1304968), SPH_C32(0xb065be43),
    SPH_C32(0xd40d6fec), SPH_C32(0x594e6036), SPH_C32(0x82d60000),
    SPH_C32(0xbe060000), SPH_C32(0x66c50000), SPH_C32(0xdcffa4e0),
    SPH_C32(0x22963066), SPH_C32(0x870ab224), SPH_C32(0xe35c6001),
    SPH_C32(0xee1b8a8a) },
  { SPH_C32(0x288b0000), SPH_C32(0x0d770000), SPH_C32(0x5db60000),
    SPH_C32(0x1f991800), SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3),
    SPH_C32(0x5b06af40), SPH_C32(0x19e93cbf), SPH_C32(0x34150000),
    SPH_C32(0x6bb40000), SPH_C32(0x50a70000), SPH_C32(0x4043d800),
    SPH_C32(0x442925b1), SPH_C32(0x51215aaf), SPH_C32(0xf5c886bf),
    SPH_C32(0xdf46dbca) },
  { SPH_C32(0x9cba0000), SPH_C32(0x7a440000), SPH_C32(0xeceb0000),
    SPH_C32(0x60491ce0), SPH_C32(0x0ed223d0), SPH_C32(0x0cf761fe),
    SPH_C32(0x89507bc9), SPH_C32(0x57864861), SPH_C32(0xd7130000),
    SPH_C32(0xd6750000), SPH_C32(0xd7b40000), SPH_C32(0xffb1d860),
    SPH_C32(0x6a932fab), SPH_C32(0xdc946dfe), SPH_C32(0x860d2db9),
    SPH_C32(0x8490cef3) },
  { SPH_C32(0xcb8d0000), SPH_C32(0xb0b60000), SPH_C32(0xdaa50000),
    SPH_C32(0xa06b1860), SPH_C32(0x58ca48f2), SPH_C32(0x505495f2),
    SPH_C32(0x28c30446), SPH_C32(0x423f2986), SPH_C32(0x63220000),
    SPH_C32(0xa1460000), SPH_C32(0x66e90000), SPH_C32(0x8061dc80),
    SPH_C32(0x12314e93), SPH_C32(0x0d82aea3), SPH_C32(0x545bf930),
    SPH_C32(0xcaffba2d) },
  { SPH_C32(0x7fbc0000), SPH_C32(0xc7850000), SPH_C32(0x6bf80000),
    SPH_C32(0xdfbb1c80), SPH_C32(0x206829ca), SPH_C32(0x814256af),
    SPH_C32(0xfa95d0cf), SPH_C32(0x0c505d58), SPH_C32(0x80240000),
    SPH_C32(0x1c870000), SPH_C32(0xe1fa0000), SPH_C32(0x3f93dce0),
    SPH_C32(0x3c8b4489), SPH_C32(0x803799f2), SPH_C32(0x279e5236),
    SPH_C32(0x9129af14) },
  { SPH_C32(0x2a790000), SPH_C32(0xaff60000), SPH_C32(0xda890000),
    SPH_C32(0xfcf56000), SPH_C32(0x686d3607), SPH_C32(0xdadc8975),
    SPH_C32(0x9fc49d77), SPH_C32(0x66db1921), SPH_C32(0x8ec80000),
    SPH_C32(0x78190000), SPH_C32(0xe7400000), SPH_C32(0xb76bf000),
    SPH_C32(0x9b6c31fc), SPH_C32(0x673b9995), SPH_C32(0x1f920bab),
    SPH_C32(0xf56ac33a) },
  { SPH_C32(0x9e480000), SPH_C32(0xd8c50000), SPH_C32(0x6bd40000),
    SPH_C32(0x832564e0), SPH_C32(0x10cf573f), SPH_C32(0x0bca4a28),
    SPH_C32(0x4d9249fe), SPH_C32(0x28b46dff), SPH_C32(0x6dce0000),
    SPH_C32(0xc5d80000), SPH_C32(0x60530000), SPH_C32(0x0899f060),
    SPH_C32(0xb5d63be6), SPH_C32(0xea8eaec4), SPH_C32(0x6c57a0ad),
    SPH_C32(0xaebcd603) },
  { SPH_C32(0xc97f0000), SPH_C32(0x12370000), SPH_C32(0x5d9a0000),
    SPH_C32(0x43076060), SPH_C32(0x46d73c1d), SPH_C32(0x5769be24),
    SPH_C32(0xec013671), SPH_C32(0x3d0d0c18), SPH_C32(0xd9ff0000),
    SPH_C32(0xb2eb0000), SPH_C32(0xd10e0000), SPH_C32(0x7749f480),
    SPH_C32(0xcd745ade), SPH_C32(0x3b986d99), SPH_C32(0xbe017424),
    SPH_C32(0xe0d3a2dd) },
  { SPH_C32(0x7d4e0000), SPH_C32(0x65040000), SPH_C32(0xecc70000),
    SPH_C32(0x3cd76480), SPH_C32(0x3e755d25), SPH_C32(0x867f7d79),
    SPH_C32(0x3e57e2f8), SPH_C32(0x736278c6), SPH_C32(0x3af90000),
    SPH_C32(0x0f2a0000), SPH_C32(0x561d0000), SPH_C32(0xc8bbf4e0),
    SPH_C32(0xe3ce50c4), SPH_C32(0xb62d5ac8), SPH_C32(0xcdc4df22),
    SPH_C32(0xbb05b7e4) },
  { SPH_C32(0x8c3a0000), SPH_C32(0xda980000), SPH_C32(0x607f0000),
    SPH_C32(0x54078800), SPH_C32(0x85714513), SPH_C32(0x6006b243),
    SPH_C32(0xdb50399c), SPH_C32(0x8a58e6a4), SPH_C32(0x1e6c0000),
    SPH_C32(0xc4420000), SPH_C32(0x8a2e0000), SPH_C32(0xbcb6b800),
    SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da), SPH_C32(0x6a0c1bc8),
    SPH_C32(0xb99dc2eb) },
  { SPH_C32(0x380b0000), SPH_C32(0xadab0000), SPH_C32(0xd1220000),
    SPH_C32(0x2bd78ce0), SPH_C32(0xfdd3242b), SPH_C32(0xb110711e),
    SPH_C32(0x0906ed15), SPH_C32(0xc437927a), SPH_C32(0xfd6a0000),
    SPH_C32(0x79830000), SPH_C32(0x0d3d0000), SPH_C32(0x0344b860),
    SPH_C32(0x02fe19ac), SPH_C32(0x0648e48b), SPH_C32(0x19c9b0ce),
    SPH_C32(0xe24bd7d2) },
  { SPH_C32(0x6f3c0000), SPH_C32(0x67590000), SPH_C32(0xe76c0000),
    SPH_C32(0xebf58860), SPH_C32(0xabcb4f09), SPH_C32(0xedb38512),
    SPH_C32(0xa895929a), SPH_C32(0xd18ef39d), SPH_C32(0x495b0000),
    SPH_C32(0x0eb00000), SPH_C32(0xbc600000), SPH_C32(0x7c94bc80),
    SPH_C32(0x7a5c7894), SPH_C32(0xd75e27d6), SPH_C32(0xcb9f6447),
    SPH_C32(0xac24a30c) },
  { SPH_C32(0xdb0d0000), SPH_C32(0x106a0000), SPH_C32(0x56310000),
    SPH_C32(0x94258c80), SPH_C32(0xd3692e31), SPH_C32(0x3ca5464f),
    SPH_C32(0x7ac34613), SPH_C32(0x9fe18743), SPH_C32(0xaa5d0000),
    SPH_C32(0xb3710000), SPH_C32(0x3b730000), SPH_C32(0xc366bce0),
    SPH_C32(0x54e6728e), SPH_C32(0x5aeb1087), SPH_C32(0xb85acf41),
    SPH_C32(0xf7f2b635) },
  { SPH_C32(0x8ec80000), SPH_C32(0x78190000), SPH_C32(0xe7400000),
    SPH_C32(0xb76bf000), SPH_C32(0x9b6c31fc), SPH_C32(0x673b9995),
    SPH_C32(0x1f920bab), SPH_C32(0xf56ac33a), SPH_C32(0xa4b10000),
    SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000), SPH_C32(0x4b9e9000),
    SPH_C32(0xf30107fb), SPH_C32(0xbde710e0), SPH_C32(0x805696dc),
    SPH_C32(0x93b1da1b) },
  { SPH_C32(0x3af90000), SPH_C32(0x0f2a0000), SPH_C32(0x561d0000),
    SPH_C32(0xc8bbf4e0), SPH_C32(0xe3ce50c4), SPH_C32(0xb62d5ac8),
    SPH_C32(0xcdc4df22), SPH_C32(0xbb05b7e4), SPH_C32(0x47b70000),
    SPH_C32(0x6a2e0000), SPH_C32(0xbada0000), SPH_C32(0xf46c9060),
    SPH_C32(0xddbb0de1), SPH_C32(0x305227b1), SPH_C32(0xf3933dda),
    SPH_C32(0xc867cf22) },
  { SPH_C32(0x6dce0000), SPH_C32(0xc5d80000), SPH_C32(0x60530000),
    SPH_C32(0x0899f060), SPH_C32(0xb5d63be6), SPH_C32(0xea8eaec4),
    SPH_C32(0x6c57a0ad), SPH_C32(0xaebcd603), SPH_C32(0xf3860000),
    SPH_C32(0x1d1d0000), SPH_C32(0x0b870000), SPH_C32(0x8bbc9480),
    SPH_C32(0xa5196cd9), SPH_C32(0xe144e4ec), SPH_C32(0x21c5e953),
    SPH_C32(0x8608bbfc) },
  { SPH_C32(0xd9ff0000), SPH_C32(0xb2eb0000), SPH_C32(0xd10e0000),
    SPH_C32(0x7749f480), SPH_C32(0xcd745ade), SPH_C32(0x3b986d99),
    SPH_C32(0xbe017424), SPH_C32(0xe0d3a2dd), SPH_C32(0x10800000),
    SPH_C32(0xa0dc0000), SPH_C32(0x8c940000), SPH_C32(0x344e94e0),
    SPH_C32(0x8ba366c3), SPH_C32(0x6cf1d3bd), SPH_C32(0x52004255),
    SPH_C32(0xdddeaec5) },
  { SPH_C32(0x36e70000), SPH_C32(0xc9350000), SPH_C32(0xd7980000),
    SPH_C32(0xa32fa000), SPH_C32(0x5a34515e), SPH_C32(0x561c7179),
    SPH_C32(0x310ab488), SPH_C32(0xa074fe54), SPH_C32(0xa6430000),
    SPH_C32(0x756e0000), SPH_C32(0xbaf60000), SPH_C32(0xa8f2e800),
    SPH_C32(0xed1c7314), SPH_C32(0xbada3b36), SPH_C32(0x4494a4eb),
    SPH_C32(0xec83ff85) },
  { SPH_C32(0x82d60000), SPH_C32(0xbe060000), SPH_C32(0x66c50000),
    SPH_C32(0xdcffa4e0), SPH_C32(0x22963066), SPH_C32(0x870ab224),
    SPH_C32(0xe35c6001), SPH_C32(0xee1b8a8a), SPH_C32(0x45450000),
    SPH_C32(0xc8af0000), SPH_C32(0x3de50000), SPH_C32(0x1700e860),
    SPH_C32(0xc3a6790e), SPH_C32(0x376f0c67), SPH_C32(0x37510fed),
    SPH_C32(0xb755eabc) },
  { SPH_C32(0xd5e10000), SPH_C32(0x74f40000), SPH_C32(0x508b0000),
    SPH_C32(0x1cdda060), SPH_C32(0x748e5b44), SPH_C32(0xdba94628),
    SPH_C32(0x42cf1f8e), SPH_C32(0xfba2eb6d), SPH_C32(0xf1740000),
    SPH_C32(0xbf9c0000), SPH_C32(0x8cb80000), SPH_C32(0x68d0ec80),
    SPH_C32(0xbb041836), SPH_C32(0xe679cf3a), SPH_C32(0xe507db64),
    SPH_C32(0xf93a9e62) },
  { SPH_C32(0x61d00000), SPH_C32(0x03c70000), SPH_C32(0xe1d60000),
    SPH_C32(0x630da480), SPH_C32(0x0c2c3a7c), SPH_C32(0x0abf8575),
    SPH_C32(0x9099cb07), SPH_C32(0xb5cd9fb3), SPH_C32(0x12720000),
    SPH_C32(0x025d0000), SPH_C32(0x0bab0000), SPH_C32(0xd722ece0),
    SPH_C32(0x95be122c), SPH_C32(0x6bccf86b), SPH_C32(0x96c27062),
    SPH_C32(0xa2ec8b5b) },
  { SPH_C32(0x34150000), SPH_C32(0x6bb40000), SPH_C32(0x50a70000),
    SPH_C32(0x4043d800), SPH_C32(0x442925b1), SPH_C32(0x51215aaf),
    SPH_C32(0xf5c886bf), SPH_C32(0xdf46dbca), SPH_C32(0x1c9e0000),
    SPH_C32(0x66c30000), SPH_C32(0x0d110000), SPH_C32(0x5fdac000),
    SPH_C32(0x32596759), SPH_C32(0x8cc0f80c), SPH_C32(0xaece29ff),
    SPH_C32(0xc6afe775) },
  { SPH_C32(0x80240000), SPH_C32(0x1c870000), SPH_C32(0xe1fa0000),
    SPH_C32(0x3f93dce0), SPH_C32(0x3c8b4489), SPH_C32(0x803799f2),
    SPH_C32(0x279e5236), SPH_C32(0x9129af14), SPH_C32(0xff980000),
    SPH_C32(0xdb020000), SPH_C32(0x8a020000), SPH_C32(0xe028c060),
    SPH_C32(0x1ce36d43), SPH_C32(0x0175cf5d), SPH_C32(0xdd0b82f9),
    SPH_C32(0x9d79f24c) },
  { SPH_C32(0xd7130000), SPH_C32(0xd6750000), SPH_C32(0xd7b40000),
    SPH_C32(0xffb1d860), SPH_C32(0x6a932fab), SPH_C32(0xdc946dfe),
    SPH_C32(0x860d2db9), SPH_C32(0x8490cef3), SPH_C32(0x4ba90000),
    SPH_C32(0xac310000), SPH_C32(0x3b5f0000), SPH_C32(0x9ff8c480),
    SPH_C32(0x64410c7b), SPH_C32(0xd0630c00), SPH_C32(0x0f5d5670),
    SPH_C32(0xd3168692) },
  { SPH_C32(0x63220000), SPH_C32(0xa1460000), SPH_C32(0x66e90000),
    SPH_C32(0x8061dc80), SPH_C32(0x12314e93), SPH_C32(0x0d82aea3),
    SPH_C32(0x545bf930), SPH_C32(0xcaffba2d), SPH_C32(0xa8af0000),
    SPH_C32(0x11f00000), SPH_C32(0xbc4c0000), SPH_C32(0x200ac4e0),
    SPH_C32(0x4afb0661), SPH_C32(0x5dd63b51), SPH_C32(0x7c98fd76),
    SPH_C32(0x88c093ab) }
};

__constant static const sph_u32 T512_54[64][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0x5fec0000), SPH_C32(0x294b0000), SPH_C32(0x99d20000),
    SPH_C32(0x4ed00012), SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9),
    SPH_C32(0x57140bdf), SPH_C32(0x30aebcf7), SPH_C32(0x5fa80000),
    SPH_C32(0x56030000), SPH_C32(0x43ae0000), SPH_C32(0x64f30013),
    SPH_C32(0x257e86bf), SPH_C32(0x1311944e), SPH_C32(0x541e95bf),
    SPH_C32(0x8ea4db69) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0xb13b0000), SPH_C32(0x80040000), SPH_C32(0xd16f0000),
    SPH_C32(0x4f6b01f3), SPH_C32(0xb12faec3), SPH_C32(0x287d6f19),
    SPH_C32(0x112fb6cb), SPH_C32(0xaebbb10d), SPH_C32(0x7b6c0000),
    SPH_C32(0x280a0000), SPH_C32(0x73990000), SPH_C32(0x496000a1),
    SPH_C32(0xa5768de3), SPH_C32(0xc42f093c), SPH_C32(0x24f2a563),
    SPH_C32(0x79f5076e) },
  { SPH_C32(0xeed70000), SPH_C32(0xa94f0000), SPH_C32(0x48bd0000),
    SPH_C32(0x01bb01e1), SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0),
    SPH_C32(0x463bbd14), SPH_C32(0x9e150dfa), SPH_C32(0x24c40000),
    SPH_C32(0x7e090000), SPH_C32(0x30370000), SPH_C32(0x2d9300b2),
    SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72), SPH_C32(0x70ec30dc),
    SPH_C32(0xf751dc07) },
  { SPH_C32(0xb17f0000), SPH_C32(0xff4c0000), SPH_C32(0x0b130000),
    SPH_C32(0x654801f2), SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e),
    SPH_C32(0x122528ab), SPH_C32(0x10b1d693), SPH_C32(0x24800000),
    SPH_C32(0x01410000), SPH_C32(0xea4b0000), SPH_C32(0x07b000b3),
    SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5), SPH_C32(0x73e6aebc),
    SPH_C32(0x495bbb99) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) },
  { SPH_C32(0x24800000), SPH_C32(0x01410000), SPH_C32(0xea4b0000),
    SPH_C32(0x07b000b3), SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5),
    SPH_C32(0x73e6aebc), SPH_C32(0x495bbb99), SPH_C32(0x95ff0000),
    SPH_C32(0xfe0d0000), SPH_C32(0xe1580000), SPH_C32(0x62f80141),
    SPH_C32(0x3127a59f), SPH_C32(0xff43f26b), SPH_C32(0x61c38617),
    SPH_C32(0x59ea6d0a) },
  { SPH_C32(0x7b6c0000), SPH_C32(0x280a0000), SPH_C32(0x73990000),
    SPH_C32(0x496000a1), SPH_C32(0xa5768de3), SPH_C32(0xc42f093c),
    SPH_C32(0x24f2a563), SPH_C32(0x79f5076e), SPH_C32(0xca570000),
    SPH_C32(0xa80e0000), SPH_C32(0xa2f60000), SPH_C32(0x060b0152),
    SPH_C32(0x14592320), SPH_C32(0xec526625), SPH_C32(0x35dd13a8),
    SPH_C32(0xd74eb663) },
  { SPH_C32(0x24c40000), SPH_C32(0x7e090000), SPH_C32(0x30370000),
    SPH_C32(0x2d9300b2), SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72),
    SPH_C32(0x70ec30dc), SPH_C32(0xf751dc07), SPH_C32(0xca130000),
    SPH_C32(0xd7460000), SPH_C32(0x788a0000), SPH_C32(0x2c280153),
    SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2), SPH_C32(0x36d78dc8),
    SPH_C32(0x6944d1fd) },
  { SPH_C32(0x95bb0000), SPH_C32(0x81450000), SPH_C32(0x3b240000),
    SPH_C32(0x48db0140), SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec),
    SPH_C32(0x62c91877), SPH_C32(0xe7e00a94), SPH_C32(0xee930000),
    SPH_C32(0xd6070000), SPH_C32(0x92c10000), SPH_C32(0x2b9801e0),
    SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57), SPH_C32(0x45312374),
    SPH_C32(0x201f6a64) },
  { SPH_C32(0xca130000), SPH_C32(0xd7460000), SPH_C32(0x788a0000),
    SPH_C32(0x2c280153), SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2),
    SPH_C32(0x36d78dc8), SPH_C32(0x6944d1fd), SPH_C32(0xeed70000),
    SPH_C32(0xa94f0000), SPH_C32(0x48bd0000), SPH_C32(0x01bb01e1),
    SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0), SPH_C32(0x463bbd14),
    SPH_C32(0x9e150dfa) },
  { SPH_C32(0x95ff0000), SPH_C32(0xfe0d0000), SPH_C32(0xe1580000),
    SPH_C32(0x62f80141), SPH_C32(0x3127a59f), SPH_C32(0xff43f26b),
    SPH_C32(0x61c38617), SPH_C32(0x59ea6d0a), SPH_C32(0xb17f0000),
    SPH_C32(0xff4c0000), SPH_C32(0x0b130000), SPH_C32(0x654801f2),
    SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e), SPH_C32(0x122528ab),
    SPH_C32(0x10b1d693) },
  { SPH_C32(0xca570000), SPH_C32(0xa80e0000), SPH_C32(0xa2f60000),
    SPH_C32(0x060b0152), SPH_C32(0x14592320), SPH_C32(0xec526625),
    SPH_C32(0x35dd13a8), SPH_C32(0xd74eb663), SPH_C32(0xb13b0000),
    SPH_C32(0x80040000), SPH_C32(0xd16f0000), SPH_C32(0x4f6b01f3),
    SPH_C32(0xb12faec3), SPH_C32(0x287d6f19), SPH_C32(0x112fb6cb),
    SPH_C32(0xaebbb10d) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0xb9800000), SPH_C32(0x1a480000), SPH_C32(0xebfb0000),
    SPH_C32(0xb72302f3), SPH_C32(0xfd1fb607), SPH_C32(0x8bb62494),
    SPH_C32(0x7c8b930b), SPH_C32(0x59fe93fe), SPH_C32(0xf0810000),
    SPH_C32(0x266b0000), SPH_C32(0x9ffe0000), SPH_C32(0xcbae00c1),
    SPH_C32(0x00c0cffd), SPH_C32(0x6b5bca1e), SPH_C32(0xc8ea607c),
    SPH_C32(0xe8add601) },
  { SPH_C32(0xe66c0000), SPH_C32(0x33030000), SPH_C32(0x72290000),
    SPH_C32(0xf9f302e1), SPH_C32(0xe3ccf974), SPH_C32(0x31112c5d),
    SPH_C32(0x2b9f98d4), SPH_C32(0x69502f09), SPH_C32(0xaf290000),
    SPH_C32(0x70680000), SPH_C32(0xdc500000), SPH_C32(0xaf5d00d2),
    SPH_C32(0x25be4942), SPH_C32(0x784a5e50), SPH_C32(0x9cf4f5c3),
    SPH_C32(0x66090d68) },
  { SPH_C32(0xb9c40000), SPH_C32(0x65000000), SPH_C32(0x31870000),
    SPH_C32(0x9d0002f2), SPH_C32(0xc6b27fcb), SPH_C32(0x2200b813),
    SPH_C32(0x7f810d6b), SPH_C32(0xe7f4f460), SPH_C32(0xaf6d0000),
    SPH_C32(0x0f200000), SPH_C32(0x062c0000), SPH_C32(0x857e00d3),
    SPH_C32(0x1e13808e), SPH_C32(0xd1fcc2d7), SPH_C32(0x9ffe6ba3),
    SPH_C32(0xd8036af6) },
  { SPH_C32(0x08bb0000), SPH_C32(0x9a4c0000), SPH_C32(0x3a940000),
    SPH_C32(0xf8480300), SPH_C32(0x4c3018c4), SPH_C32(0xa3cb4b8d),
    SPH_C32(0x6da425c0), SPH_C32(0xf74522f3), SPH_C32(0x8bed0000),
    SPH_C32(0x0e610000), SPH_C32(0xec670000), SPH_C32(0x82ce0060),
    SPH_C32(0xa5b6421e), SPH_C32(0xaf74c322), SPH_C32(0xec18c51f),
    SPH_C32(0x9158d16f) },
  { SPH_C32(0x57130000), SPH_C32(0xcc4f0000), SPH_C32(0x793a0000),
    SPH_C32(0x9cbb0313), SPH_C32(0x694e9e7b), SPH_C32(0xb0dadfc3),
    SPH_C32(0x39bab07f), SPH_C32(0x79e1f99a), SPH_C32(0x8ba90000),
    SPH_C32(0x71290000), SPH_C32(0x361b0000), SPH_C32(0xa8ed0061),
    SPH_C32(0x9e1b8bd2), SPH_C32(0x06c25fa5), SPH_C32(0xef125b7f),
    SPH_C32(0x2f52b6f1) },
  { SPH_C32(0x08ff0000), SPH_C32(0xe5040000), SPH_C32(0xe0e80000),
    SPH_C32(0xd26b0301), SPH_C32(0x779dd108), SPH_C32(0x0a7dd70a),
    SPH_C32(0x6eaebba0), SPH_C32(0x494f456d), SPH_C32(0xd4010000),
    SPH_C32(0x272a0000), SPH_C32(0x75b50000), SPH_C32(0xcc1e0072),
    SPH_C32(0xbb650d6d), SPH_C32(0x15d3cbeb), SPH_C32(0xbb0ccec0),
    SPH_C32(0xa1f66d98) },
  { SPH_C32(0x57570000), SPH_C32(0xb3070000), SPH_C32(0xa3460000),
    SPH_C32(0xb6980312), SPH_C32(0x52e357b7), SPH_C32(0x196c4344),
    SPH_C32(0x3ab02e1f), SPH_C32(0xc7eb9e04), SPH_C32(0xd4450000),
    SPH_C32(0x58620000), SPH_C32(0xafc90000), SPH_C32(0xe63d0073),
    SPH_C32(0x80c8c4a1), SPH_C32(0xbc65576c), SPH_C32(0xb80650a0),
    SPH_C32(0x1ffc0a06) },
  { SPH_C32(0x9d000000), SPH_C32(0x1b090000), SPH_C32(0x01b00000),
    SPH_C32(0xb0930240), SPH_C32(0x46ba7497), SPH_C32(0xf53e2561),
    SPH_C32(0x0f6d3db7), SPH_C32(0x10a52867), SPH_C32(0x657e0000),
    SPH_C32(0xd8660000), SPH_C32(0x7ea60000), SPH_C32(0xa9560180),
    SPH_C32(0x31e76a62), SPH_C32(0x94183875), SPH_C32(0xa929e66b),
    SPH_C32(0xb147bb0b) },
  { SPH_C32(0xc2a80000), SPH_C32(0x4d0a0000), SPH_C32(0x421e0000),
    SPH_C32(0xd4600253), SPH_C32(0x63c4f228), SPH_C32(0xe62fb12f),
    SPH_C32(0x5b73a808), SPH_C32(0x9e01f30e), SPH_C32(0x653a0000),
    SPH_C32(0xa72e0000), SPH_C32(0xa4da0000), SPH_C32(0x83750181),
    SPH_C32(0x0a4aa3ae), SPH_C32(0x3daea4f2), SPH_C32(0xaa23780b),
    SPH_C32(0x0f4ddc95) },
  { SPH_C32(0x9d440000), SPH_C32(0x64410000), SPH_C32(0xdbcc0000),
    SPH_C32(0x9ab00241), SPH_C32(0x7d17bd5b), SPH_C32(0x5c88b9e6),
    SPH_C32(0x0c67a3d7), SPH_C32(0xaeaf4ff9), SPH_C32(0x3a920000),
    SPH_C32(0xf12d0000), SPH_C32(0xe7740000), SPH_C32(0xe7860192),
    SPH_C32(0x2f342511), SPH_C32(0x2ebf30bc), SPH_C32(0xfe3dedb4),
    SPH_C32(0x81e907fc) },
  { SPH_C32(0xc2ec0000), SPH_C32(0x32420000), SPH_C32(0x98620000),
    SPH_C32(0xfe430252), SPH_C32(0x58693be4), SPH_C32(0x4f992da8),
    SPH_C32(0x58793668), SPH_C32(0x200b9490), SPH_C32(0x3ad60000),
    SPH_C32(0x8e650000), SPH_C32(0x3d080000), SPH_C32(0xcda50193),
    SPH_C32(0x1499ecdd), SPH_C32(0x8709ac3b), SPH_C32(0xfd3773d4),
    SPH_C32(0x3fe36062) },
  { SPH_C32(0x73930000), SPH_C32(0xcd0e0000), SPH_C32(0x93710000),
    SPH_C32(0x9b0b03a0), SPH_C32(0xd2eb5ceb), SPH_C32(0xce52de36),
    SPH_C32(0x4a5c1ec3), SPH_C32(0x30ba4203), SPH_C32(0x1e560000),
    SPH_C32(0x8f240000), SPH_C32(0xd7430000), SPH_C32(0xca150120),
    SPH_C32(0xaf3c2e4d), SPH_C32(0xf981adce), SPH_C32(0x8ed1dd68),
    SPH_C32(0x76b8dbfb) },
  { SPH_C32(0x2c3b0000), SPH_C32(0x9b0d0000), SPH_C32(0xd0df0000),
    SPH_C32(0xfff803b3), SPH_C32(0xf795da54), SPH_C32(0xdd434a78),
    SPH_C32(0x1e428b7c), SPH_C32(0xbe1e996a), SPH_C32(0x1e120000),
    SPH_C32(0xf06c0000), SPH_C32(0x0d3f0000), SPH_C32(0xe0360121),
    SPH_C32(0x9491e781), SPH_C32(0x50373149), SPH_C32(0x8ddb4308),
    SPH_C32(0xc8b2bc65) },
  { SPH_C32(0x73d70000), SPH_C32(0xb2460000), SPH_C32(0x490d0000),
    SPH_C32(0xb12803a1), SPH_C32(0xe9469527), SPH_C32(0x67e442b1),
    SPH_C32(0x495680a3), SPH_C32(0x8eb0259d), SPH_C32(0x41ba0000),
    SPH_C32(0xa66f0000), SPH_C32(0x4e910000), SPH_C32(0x84c50132),
    SPH_C32(0xb1ef613e), SPH_C32(0x4326a507), SPH_C32(0xd9c5d6b7),
    SPH_C32(0x4616670c) },
  { SPH_C32(0x2c7f0000), SPH_C32(0xe4450000), SPH_C32(0x0aa30000),
    SPH_C32(0xd5db03b2), SPH_C32(0xcc381398), SPH_C32(0x74f5d6ff),
    SPH_C32(0x1d48151c), SPH_C32(0x0014fef4), SPH_C32(0x41fe0000),
    SPH_C32(0xd9270000), SPH_C32(0x94ed0000), SPH_C32(0xaee60133),
    SPH_C32(0x8a42a8f2), SPH_C32(0xea903980), SPH_C32(0xdacf48d7),
    SPH_C32(0xf81c0092) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0xaf6d0000), SPH_C32(0x0f200000), SPH_C32(0x062c0000),
    SPH_C32(0x857e00d3), SPH_C32(0x1e13808e), SPH_C32(0xd1fcc2d7),
    SPH_C32(0x9ffe6ba3), SPH_C32(0xd8036af6), SPH_C32(0x16a90000),
    SPH_C32(0x6a200000), SPH_C32(0x37ab0000), SPH_C32(0x187e0221),
    SPH_C32(0xd8a1ff45), SPH_C32(0xf3fc7ac4), SPH_C32(0xe07f66c8),
    SPH_C32(0x3ff79e96) },
  { SPH_C32(0xf0810000), SPH_C32(0x266b0000), SPH_C32(0x9ffe0000),
    SPH_C32(0xcbae00c1), SPH_C32(0x00c0cffd), SPH_C32(0x6b5bca1e),
    SPH_C32(0xc8ea607c), SPH_C32(0xe8add601), SPH_C32(0x49010000),
    SPH_C32(0x3c230000), SPH_C32(0x74050000), SPH_C32(0x7c8d0232),
    SPH_C32(0xfddf79fa), SPH_C32(0xe0edee8a), SPH_C32(0xb461f377),
    SPH_C32(0xb15345ff) },
  { SPH_C32(0xaf290000), SPH_C32(0x70680000), SPH_C32(0xdc500000),
    SPH_C32(0xaf5d00d2), SPH_C32(0x25be4942), SPH_C32(0x784a5e50),
    SPH_C32(0x9cf4f5c3), SPH_C32(0x66090d68), SPH_C32(0x49450000),
    SPH_C32(0x436b0000), SPH_C32(0xae790000), SPH_C32(0x56ae0233),
    SPH_C32(0xc672b036), SPH_C32(0x495b720d), SPH_C32(0xb76b6d17),
    SPH_C32(0x0f592261) },
  { SPH_C32(0x1e560000), SPH_C32(0x8f240000), SPH_C32(0xd7430000),
    SPH_C32(0xca150120), SPH_C32(0xaf3c2e4d), SPH_C32(0xf981adce),
    SPH_C32(0x8ed1dd68), SPH_C32(0x76b8dbfb), SPH_C32(0x6dc50000),
    SPH_C32(0x422a0000), SPH_C32(0x44320000), SPH_C32(0x511e0280),
    SPH_C32(0x7dd772a6), SPH_C32(0x37d373f8), SPH_C32(0xc48dc3ab),
    SPH_C32(0x460299f8) },
  { SPH_C32(0x41fe0000), SPH_C32(0xd9270000), SPH_C32(0x94ed0000),
    SPH_C32(0xaee60133), SPH_C32(0x8a42a8f2), SPH_C32(0xea903980),
    SPH_C32(0xdacf48d7), SPH_C32(0xf81c0092), SPH_C32(0x6d810000),
    SPH_C32(0x3d620000), SPH_C32(0x9e4e0000), SPH_C32(0x7b3d0281),
    SPH_C32(0x467abb6a), SPH_C32(0x9e65ef7f), SPH_C32(0xc7875dcb),
    SPH_C32(0xf808fe66) },
  { SPH_C32(0x1e120000), SPH_C32(0xf06c0000), SPH_C32(0x0d3f0000),
    SPH_C32(0xe0360121), SPH_C32(0x9491e781), SPH_C32(0x50373149),
    SPH_C32(0x8ddb4308), SPH_C32(0xc8b2bc65), SPH_C32(0x32290000),
    SPH_C32(0x6b610000), SPH_C32(0xdde00000), SPH_C32(0x1fce0292),
    SPH_C32(0x63043dd5), SPH_C32(0x8d747b31), SPH_C32(0x9399c874),
    SPH_C32(0x76ac250f) },
  { SPH_C32(0x41ba0000), SPH_C32(0xa66f0000), SPH_C32(0x4e910000),
    SPH_C32(0x84c50132), SPH_C32(0xb1ef613e), SPH_C32(0x4326a507),
    SPH_C32(0xd9c5d6b7), SPH_C32(0x4616670c), SPH_C32(0x326d0000),
    SPH_C32(0x14290000), SPH_C32(0x079c0000), SPH_C32(0x35ed0293),
    SPH_C32(0x58a9f419), SPH_C32(0x24c2e7b6), SPH_C32(0x90935614),
    SPH_C32(0xc8a64291) },
  { SPH_C32(0x8bed0000), SPH_C32(0x0e610000), SPH_C32(0xec670000),
    SPH_C32(0x82ce0060), SPH_C32(0xa5b6421e), SPH_C32(0xaf74c322),
    SPH_C32(0xec18c51f), SPH_C32(0x9158d16f), SPH_C32(0x83560000),
    SPH_C32(0x942d0000), SPH_C32(0xd6f30000), SPH_C32(0x7a860360),
    SPH_C32(0xe9865ada), SPH_C32(0x0cbf88af), SPH_C32(0x81bce0df),
    SPH_C32(0x661df39c) },
  { SPH_C32(0xd4450000), SPH_C32(0x58620000), SPH_C32(0xafc90000),
    SPH_C32(0xe63d0073), SPH_C32(0x80c8c4a1), SPH_C32(0xbc65576c),
    SPH_C32(0xb80650a0), SPH_C32(0x1ffc0a06), SPH_C32(0x83120000),
    SPH_C32(0xeb650000), SPH_C32(0x0c8f0000), SPH_C32(0x50a50361),
    SPH_C32(0xd22b9316), SPH_C32(0xa5091428), SPH_C32(0x82b67ebf),
    SPH_C32(0xd8179402) },
  { SPH_C32(0x8ba90000), SPH_C32(0x71290000), SPH_C32(0x361b0000),
    SPH_C32(0xa8ed0061), SPH_C32(0x9e1b8bd2), SPH_C32(0x06c25fa5),
    SPH_C32(0xef125b7f), SPH_C32(0x2f52b6f1), SPH_C32(0xdcba0000),
    SPH_C32(0xbd660000), SPH_C32(0x4f210000), SPH_C32(0x34560372),
    SPH_C32(0xf75515a9), SPH_C32(0xb6188066), SPH_C32(0xd6a8eb00),
    SPH_C32(0x56b34f6b) },
  { SPH_C32(0xd4010000), SPH_C32(0x272a0000), SPH_C32(0x75b50000),
    SPH_C32(0xcc1e0072), SPH_C32(0xbb650d6d), SPH_C32(0x15d3cbeb),
    SPH_C32(0xbb0ccec0), SPH_C32(0xa1f66d98), SPH_C32(0xdcfe0000),
    SPH_C32(0xc22e0000), SPH_C32(0x955d0000), SPH_C32(0x1e750373),
    SPH_C32(0xccf8dc65), SPH_C32(0x1fae1ce1), SPH_C32(0xd5a27560),
    SPH_C32(0xe8b928f5) },
  { SPH_C32(0x657e0000), SPH_C32(0xd8660000), SPH_C32(0x7ea60000),
    SPH_C32(0xa9560180), SPH_C32(0x31e76a62), SPH_C32(0x94183875),
    SPH_C32(0xa929e66b), SPH_C32(0xb147bb0b), SPH_C32(0xf87e0000),
    SPH_C32(0xc36f0000), SPH_C32(0x7f160000), SPH_C32(0x19c503c0),
    SPH_C32(0x775d1ef5), SPH_C32(0x61261d14), SPH_C32(0xa644dbdc),
    SPH_C32(0xa1e2936c) },
  { SPH_C32(0x3ad60000), SPH_C32(0x8e650000), SPH_C32(0x3d080000),
    SPH_C32(0xcda50193), SPH_C32(0x1499ecdd), SPH_C32(0x8709ac3b),
    SPH_C32(0xfd3773d4), SPH_C32(0x3fe36062), SPH_C32(0xf83a0000),
    SPH_C32(0xbc270000), SPH_C32(0xa56a0000), SPH_C32(0x33e603c1),
    SPH_C32(0x4cf0d739), SPH_C32(0xc8908193), SPH_C32(0xa54e45bc),
    SPH_C32(0x1fe8f4f2) },
  { SPH_C32(0x653a0000), SPH_C32(0xa72e0000), SPH_C32(0xa4da0000),
    SPH_C32(0x83750181), SPH_C32(0x0a4aa3ae), SPH_C32(0x3daea4f2),
    SPH_C32(0xaa23780b), SPH_C32(0x0f4ddc95), SPH_C32(0xa7920000),
    SPH_C32(0xea240000), SPH_C32(0xe6c40000), SPH_C32(0x571503d2),
    SPH_C32(0x698e5186), SPH_C32(0xdb8115dd), SPH_C32(0xf150d003),
    SPH_C32(0x914c2f9b) },
  { SPH_C32(0x3a920000), SPH_C32(0xf12d0000), SPH_C32(0xe7740000),
    SPH_C32(0xe7860192), SPH_C32(0x2f342511), SPH_C32(0x2ebf30bc),
    SPH_C32(0xfe3dedb4), SPH_C32(0x81e907fc), SPH_C32(0xa7d60000),
    SPH_C32(0x956c0000), SPH_C32(0x3cb80000), SPH_C32(0x7d3603d3),
    SPH_C32(0x5223984a), SPH_C32(0x7237895a), SPH_C32(0xf25a4e63),
    SPH_C32(0x2f464805) },
  { SPH_C32(0x16ed0000), SPH_C32(0x15680000), SPH_C32(0xedd70000),
    SPH_C32(0x325d0220), SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643),
    SPH_C32(0xe375f8a8), SPH_C32(0x81fdf908), SPH_C32(0xe6280000),
    SPH_C32(0x4c4b0000), SPH_C32(0xa8550000), SPH_C32(0xd3d002e0),
    SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da), SPH_C32(0x289506b4),
    SPH_C32(0xd75a4897) },
  { SPH_C32(0x49450000), SPH_C32(0x436b0000), SPH_C32(0xae790000),
    SPH_C32(0x56ae0233), SPH_C32(0xc672b036), SPH_C32(0x495b720d),
    SPH_C32(0xb76b6d17), SPH_C32(0x0f592261), SPH_C32(0xe66c0000),
    SPH_C32(0x33030000), SPH_C32(0x72290000), SPH_C32(0xf9f302e1),
    SPH_C32(0xe3ccf974), SPH_C32(0x31112c5d), SPH_C32(0x2b9f98d4),
    SPH_C32(0x69502f09) },
  { SPH_C32(0x16a90000), SPH_C32(0x6a200000), SPH_C32(0x37ab0000),
    SPH_C32(0x187e0221), SPH_C32(0xd8a1ff45), SPH_C32(0xf3fc7ac4),
    SPH_C32(0xe07f66c8), SPH_C32(0x3ff79e96), SPH_C32(0xb9c40000),
    SPH_C32(0x65000000), SPH_C32(0x31870000), SPH_C32(0x9d0002f2),
    SPH_C32(0xc6b27fcb), SPH_C32(0x2200b813), SPH_C32(0x7f810d6b),
    SPH_C32(0xe7f4f460) },
  { SPH_C32(0x49010000), SPH_C32(0x3c230000), SPH_C32(0x74050000),
    SPH_C32(0x7c8d0232), SPH_C32(0xfddf79fa), SPH_C32(0xe0edee8a),
    SPH_C32(0xb461f377), SPH_C32(0xb15345ff), SPH_C32(0xb9800000),
    SPH_C32(0x1a480000), SPH_C32(0xebfb0000), SPH_C32(0xb72302f3),
    SPH_C32(0xfd1fb607), SPH_C32(0x8bb62494), SPH_C32(0x7c8b930b),
    SPH_C32(0x59fe93fe) },
  { SPH_C32(0xf87e0000), SPH_C32(0xc36f0000), SPH_C32(0x7f160000),
    SPH_C32(0x19c503c0), SPH_C32(0x775d1ef5), SPH_C32(0x61261d14),
    SPH_C32(0xa644dbdc), SPH_C32(0xa1e2936c), SPH_C32(0x9d000000),
    SPH_C32(0x1b090000), SPH_C32(0x01b00000), SPH_C32(0xb0930240),
    SPH_C32(0x46ba7497), SPH_C32(0xf53e2561), SPH_C32(0x0f6d3db7),
    SPH_C32(0x10a52867) },
  { SPH_C32(0xa7d60000), SPH_C32(0x956c0000), SPH_C32(0x3cb80000),
    SPH_C32(0x7d3603d3), SPH_C32(0x5223984a), SPH_C32(0x7237895a),
    SPH_C32(0xf25a4e63), SPH_C32(0x2f464805), SPH_C32(0x9d440000),
    SPH_C32(0x64410000), SPH_C32(0xdbcc0000), SPH_C32(0x9ab00241),
    SPH_C32(0x7d17bd5b), SPH_C32(0x5c88b9e6), SPH_C32(0x0c67a3d7),
    SPH_C32(0xaeaf4ff9) },
  { SPH_C32(0xf83a0000), SPH_C32(0xbc270000), SPH_C32(0xa56a0000),
    SPH_C32(0x33e603c1), SPH_C32(0x4cf0d739), SPH_C32(0xc8908193),
    SPH_C32(0xa54e45bc), SPH_C32(0x1fe8f4f2), SPH_C32(0xc2ec0000),
    SPH_C32(0x32420000), SPH_C32(0x98620000), SPH_C32(0xfe430252),
    SPH_C32(0x58693be4), SPH_C32(0x4f992da8), SPH_C32(0x58793668),
    SPH_C32(0x200b9490) },
  { SPH_C32(0xa7920000), SPH_C32(0xea240000), SPH_C32(0xe6c40000),
    SPH_C32(0x571503d2), SPH_C32(0x698e5186), SPH_C32(0xdb8115dd),
    SPH_C32(0xf150d003), SPH_C32(0x914c2f9b), SPH_C32(0xc2a80000),
    SPH_C32(0x4d0a0000), SPH_C32(0x421e0000), SPH_C32(0xd4600253),
    SPH_C32(0x63c4f228), SPH_C32(0xe62fb12f), SPH_C32(0x5b73a808),
    SPH_C32(0x9e01f30e) },
  { SPH_C32(0x6dc50000), SPH_C32(0x422a0000), SPH_C32(0x44320000),
    SPH_C32(0x511e0280), SPH_C32(0x7dd772a6), SPH_C32(0x37d373f8),
    SPH_C32(0xc48dc3ab), SPH_C32(0x460299f8), SPH_C32(0x73930000),
    SPH_C32(0xcd0e0000), SPH_C32(0x93710000), SPH_C32(0x9b0b03a0),
    SPH_C32(0xd2eb5ceb), SPH_C32(0xce52de36), SPH_C32(0x4a5c1ec3),
    SPH_C32(0x30ba4203) },
  { SPH_C32(0x326d0000), SPH_C32(0x14290000), SPH_C32(0x079c0000),
    SPH_C32(0x35ed0293), SPH_C32(0x58a9f419), SPH_C32(0x24c2e7b6),
    SPH_C32(0x90935614), SPH_C32(0xc8a64291), SPH_C32(0x73d70000),
    SPH_C32(0xb2460000), SPH_C32(0x490d0000), SPH_C32(0xb12803a1),
    SPH_C32(0xe9469527), SPH_C32(0x67e442b1), SPH_C32(0x495680a3),
    SPH_C32(0x8eb0259d) },
  { SPH_C32(0x6d810000), SPH_C32(0x3d620000), SPH_C32(0x9e4e0000),
    SPH_C32(0x7b3d0281), SPH_C32(0x467abb6a), SPH_C32(0x9e65ef7f),
    SPH_C32(0xc7875dcb), SPH_C32(0xf808fe66), SPH_C32(0x2c7f0000),
    SPH_C32(0xe4450000), SPH_C32(0x0aa30000), SPH_C32(0xd5db03b2),
    SPH_C32(0xcc381398), SPH_C32(0x74f5d6ff), SPH_C32(0x1d48151c),
    SPH_C32(0x0014fef4) },
  { SPH_C32(0x32290000), SPH_C32(0x6b610000), SPH_C32(0xdde00000),
    SPH_C32(0x1fce0292), SPH_C32(0x63043dd5), SPH_C32(0x8d747b31),
    SPH_C32(0x9399c874), SPH_C32(0x76ac250f), SPH_C32(0x2c3b0000),
    SPH_C32(0x9b0d0000), SPH_C32(0xd0df0000), SPH_C32(0xfff803b3),
    SPH_C32(0xf795da54), SPH_C32(0xdd434a78), SPH_C32(0x1e428b7c),
    SPH_C32(0xbe1e996a) },
  { SPH_C32(0x83560000), SPH_C32(0x942d0000), SPH_C32(0xd6f30000),
    SPH_C32(0x7a860360), SPH_C32(0xe9865ada), SPH_C32(0x0cbf88af),
    SPH_C32(0x81bce0df), SPH_C32(0x661df39c), SPH_C32(0x08bb0000),
    SPH_C32(0x9a4c0000), SPH_C32(0x3a940000), SPH_C32(0xf8480300),
    SPH_C32(0x4c3018c4), SPH_C32(0xa3cb4b8d), SPH_C32(0x6da425c0),
    SPH_C32(0xf74522f3) },
  { SPH_C32(0xdcfe0000), SPH_C32(0xc22e0000), SPH_C32(0x955d0000),
    SPH_C32(0x1e750373), SPH_C32(0xccf8dc65), SPH_C32(0x1fae1ce1),
    SPH_C32(0xd5a27560), SPH_C32(0xe8b928f5), SPH_C32(0x08ff0000),
    SPH_C32(0xe5040000), SPH_C32(0xe0e80000), SPH_C32(0xd26b0301),
    SPH_C32(0x779dd108), SPH_C32(0x0a7dd70a), SPH_C32(0x6eaebba0),
    SPH_C32(0x494f456d) },
  { SPH_C32(0x83120000), SPH_C32(0xeb650000), SPH_C32(0x0c8f0000),
    SPH_C32(0x50a50361), SPH_C32(0xd22b9316), SPH_C32(0xa5091428),
    SPH_C32(0x82b67ebf), SPH_C32(0xd8179402), SPH_C32(0x57570000),
    SPH_C32(0xb3070000), SPH_C32(0xa3460000), SPH_C32(0xb6980312),
    SPH_C32(0x52e357b7), SPH_C32(0x196c4344), SPH_C32(0x3ab02e1f),
    SPH_C32(0xc7eb9e04) },
  { SPH_C32(0xdcba0000), SPH_C32(0xbd660000), SPH_C32(0x4f210000),
    SPH_C32(0x34560372), SPH_C32(0xf75515a9), SPH_C32(0xb6188066),
    SPH_C32(0xd6a8eb00), SPH_C32(0x56b34f6b), SPH_C32(0x57130000),
    SPH_C32(0xcc4f0000), SPH_C32(0x793a0000), SPH_C32(0x9cbb0313),
    SPH_C32(0x694e9e7b), SPH_C32(0xb0dadfc3), SPH_C32(0x39bab07f),
    SPH_C32(0x79e1f99a) }
};

__constant static const sph_u32 T512_60[16][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0xabe70000), SPH_C32(0x9e0d0000), SPH_C32(0xaf270000),
    SPH_C32(0x3d180005), SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695),
    SPH_C32(0xb5c347eb), SPH_C32(0x3c5dfffe), SPH_C32(0x033d0000),
    SPH_C32(0x08b30000), SPH_C32(0xf33a0000), SPH_C32(0x3ac20007),
    SPH_C32(0x51298a50), SPH_C32(0x6b6e661f), SPH_C32(0x0ea5cfe3),
    SPH_C32(0xe6da7ffe) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0x02ae0000), SPH_C32(0xef310000), SPH_C32(0x1ec10000),
    SPH_C32(0xf5ce000c), SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231),
    SPH_C32(0x0893ae02), SPH_C32(0xb5b5e185), SPH_C32(0x3af20000),
    SPH_C32(0x4a3b0000), SPH_C32(0x0be70000), SPH_C32(0x51060001),
    SPH_C32(0xc78fb695), SPH_C32(0x4577d386), SPH_C32(0x2ba87f5a),
    SPH_C32(0xa191f5d7) },
  { SPH_C32(0xa9490000), SPH_C32(0x713c0000), SPH_C32(0xb1e60000),
    SPH_C32(0xc8d60009), SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4),
    SPH_C32(0xbd50e9e9), SPH_C32(0x89e81e7b), SPH_C32(0x39cf0000),
    SPH_C32(0x42880000), SPH_C32(0xf8dd0000), SPH_C32(0x6bc40006),
    SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599), SPH_C32(0x250db0b9),
    SPH_C32(0x474b8a29) },
  { SPH_C32(0xaa740000), SPH_C32(0x798f0000), SPH_C32(0x42dc0000),
    SPH_C32(0xf214000e), SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb),
    SPH_C32(0xb3f5260a), SPH_C32(0x6f326185), SPH_C32(0x91150000),
    SPH_C32(0xd4360000), SPH_C32(0xa4c00000), SPH_C32(0x6c1e0004),
    SPH_C32(0xebc0a946), SPH_C32(0x3181c513), SPH_C32(0x9e6b38b1),
    SPH_C32(0x9dcc0a29) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x91150000), SPH_C32(0xd4360000), SPH_C32(0xa4c00000),
    SPH_C32(0x6c1e0004), SPH_C32(0xebc0a946), SPH_C32(0x3181c513),
    SPH_C32(0x9e6b38b1), SPH_C32(0x9dcc0a29), SPH_C32(0x3b610000),
    SPH_C32(0xadb90000), SPH_C32(0xe61c0000), SPH_C32(0x9e0a000a),
    SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8), SPH_C32(0x2d9e1ebb),
    SPH_C32(0xf2fe6bac) },
  { SPH_C32(0x3af20000), SPH_C32(0x4a3b0000), SPH_C32(0x0be70000),
    SPH_C32(0x51060001), SPH_C32(0xc78fb695), SPH_C32(0x4577d386),
    SPH_C32(0x2ba87f5a), SPH_C32(0xa191f5d7), SPH_C32(0x385c0000),
    SPH_C32(0xa50a0000), SPH_C32(0x15260000), SPH_C32(0xa4c8000d),
    SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7), SPH_C32(0x233bd158),
    SPH_C32(0x14241452) },
  { SPH_C32(0x39cf0000), SPH_C32(0x42880000), SPH_C32(0xf8dd0000),
    SPH_C32(0x6bc40006), SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599),
    SPH_C32(0x250db0b9), SPH_C32(0x474b8a29), SPH_C32(0x90860000),
    SPH_C32(0x33b40000), SPH_C32(0x493b0000), SPH_C32(0xa312000f),
    SPH_C32(0x6610241e), SPH_C32(0x8d22713d), SPH_C32(0x985d5950),
    SPH_C32(0xcea39452) },
  { SPH_C32(0x93bb0000), SPH_C32(0x3b070000), SPH_C32(0xba010000),
    SPH_C32(0x99d00008), SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722),
    SPH_C32(0x96f896b3), SPH_C32(0x2879ebac), SPH_C32(0x01930000),
    SPH_C32(0xe7820000), SPH_C32(0xedfb0000), SPH_C32(0xcf0c000b),
    SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e), SPH_C32(0x063661e1),
    SPH_C32(0x536f9e7b) },
  { SPH_C32(0x90860000), SPH_C32(0x33b40000), SPH_C32(0x493b0000),
    SPH_C32(0xa312000f), SPH_C32(0x6610241e), SPH_C32(0x8d22713d),
    SPH_C32(0x985d5950), SPH_C32(0xcea39452), SPH_C32(0xa9490000),
    SPH_C32(0x713c0000), SPH_C32(0xb1e60000), SPH_C32(0xc8d60009),
    SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4), SPH_C32(0xbd50e9e9),
    SPH_C32(0x89e81e7b) },
  { SPH_C32(0x3b610000), SPH_C32(0xadb90000), SPH_C32(0xe61c0000),
    SPH_C32(0x9e0a000a), SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8),
    SPH_C32(0x2d9e1ebb), SPH_C32(0xf2fe6bac), SPH_C32(0xaa740000),
    SPH_C32(0x798f0000), SPH_C32(0x42dc0000), SPH_C32(0xf214000e),
    SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb), SPH_C32(0xb3f5260a),
    SPH_C32(0x6f326185) },
  { SPH_C32(0x385c0000), SPH_C32(0xa50a0000), SPH_C32(0x15260000),
    SPH_C32(0xa4c8000d), SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7),
    SPH_C32(0x233bd158), SPH_C32(0x14241452), SPH_C32(0x02ae0000),
    SPH_C32(0xef310000), SPH_C32(0x1ec10000), SPH_C32(0xf5ce000c),
    SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231), SPH_C32(0x0893ae02),
    SPH_C32(0xb5b5e185) }
};

#define INPUT_BIG   do { \
    unsigned acc = buf(0); \
    __constant const sph_u32 *rp; \
    rp = &T512_0[acc >> 2][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    m8 = rp[8]; \
    m9 = rp[9]; \
    mA = rp[10]; \
    mB = rp[11]; \
    mC = rp[12]; \
    mD = rp[13]; \
    mE = rp[14]; \
    mF = rp[15]; \
    acc = (acc << 8) | buf(1); \
    rp = &T512_6[(acc >> 4) & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(2); \
    rp = &T512_12[(acc >> 6) & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_18[acc & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(3); \
    rp = &T512_24[acc >> 2][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(4); \
    rp = &T512_30[(acc >> 4) & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(5); \
    rp = &T512_36[(acc >> 6) & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_42[acc & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(6); \
    rp = &T512_48[acc >> 2][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(7); \
    rp = &T512_54[(acc >> 4) & 0x3f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_60[acc & 0x0f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 7

__constant static const sph_u32 T512_0[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0xdd313c30), SPH_C32(0x5ecc0000), SPH_C32(0x4ea30000),
    SPH_C32(0xd72e0000), SPH_C32(0xc6086695), SPH_C32(0xddb5cc4f),
    SPH_C32(0x17360ea4), SPH_C32(0x7fe78bad), SPH_C32(0x05071640),
    SPH_C32(0x15610000), SPH_C32(0x86ed0000), SPH_C32(0xb4730000),
    SPH_C32(0xe0ab439a), SPH_C32(0xd15fe187), SPH_C32(0x344f69ea),
    SPH_C32(0xd002147d) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0xea0c1430), SPH_C32(0x2f9c0000), SPH_C32(0xdb430000),
    SPH_C32(0xdd3a0000), SPH_C32(0x7ba47f9c), SPH_C32(0x955a547e),
    SPH_C32(0x525b63bb), SPH_C32(0x424d4977), SPH_C32(0x115d2a40),
    SPH_C32(0xac880000), SPH_C32(0xe7ca0000), SPH_C32(0x45120000),
    SPH_C32(0x2eca7ef6), SPH_C32(0x6116dcff), SPH_C32(0x73e60eca),
    SPH_C32(0x318c30b8) },
  { SPH_C32(0x373d2800), SPH_C32(0x71500000), SPH_C32(0x95e00000),
    SPH_C32(0x0a140000), SPH_C32(0xbdac1909), SPH_C32(0x48ef9831),
    SPH_C32(0x456d6d1f), SPH_C32(0x3daac2da), SPH_C32(0x145a3c00),
    SPH_C32(0xb9e90000), SPH_C32(0x61270000), SPH_C32(0xf1610000),
    SPH_C32(0xce613d6c), SPH_C32(0xb0493d78), SPH_C32(0x47a96720),
    SPH_C32(0xe18e24c5) },
  { SPH_C32(0xfe562830), SPH_C32(0x96750000), SPH_C32(0xba640000),
    SPH_C32(0x2c5b0000), SPH_C32(0xb5c542f0), SPH_C32(0x25136906),
    SPH_C32(0x15f2049b), SPH_C32(0xa3c36db2), SPH_C32(0x323a3e40),
    SPH_C32(0x64310000), SPH_C32(0x130d0000), SPH_C32(0xbe670000),
    SPH_C32(0x5d075a93), SPH_C32(0x99b079b6), SPH_C32(0x712204f5),
    SPH_C32(0xeda8d6a7) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0x9d435c30), SPH_C32(0x0dc80000), SPH_C32(0xea520000),
    SPH_C32(0x878a0000), SPH_C32(0xbbcb3c89), SPH_C32(0xf95935d6),
    SPH_C32(0x3b2f2819), SPH_C32(0xcb7298ea), SPH_C32(0xbadb1a40),
    SPH_C32(0x6d0b0000), SPH_C32(0xe07b0000), SPH_C32(0xa2950000),
    SPH_C32(0xca5c24ba), SPH_C32(0xc8ed913a), SPH_C32(0x758d500f),
    SPH_C32(0x74ec3c4b) },
  { SPH_C32(0x40726000), SPH_C32(0x53040000), SPH_C32(0xa4f10000),
    SPH_C32(0x50a40000), SPH_C32(0x7dc35a1c), SPH_C32(0x24ecf999),
    SPH_C32(0x2c1926bd), SPH_C32(0xb4951347), SPH_C32(0xbfdc0c00),
    SPH_C32(0x786a0000), SPH_C32(0x66960000), SPH_C32(0x16e60000),
    SPH_C32(0x2af76720), SPH_C32(0x19b270bd), SPH_C32(0x41c239e5),
    SPH_C32(0xa4ee2836) },
  { SPH_C32(0x89196030), SPH_C32(0xb4210000), SPH_C32(0x8b750000),
    SPH_C32(0x76eb0000), SPH_C32(0x75aa01e5), SPH_C32(0x491008ae),
    SPH_C32(0x7c864f39), SPH_C32(0x2afcbc2f), SPH_C32(0x99bc0e40),
    SPH_C32(0xa5b20000), SPH_C32(0x14bc0000), SPH_C32(0x59e00000),
    SPH_C32(0xb99100df), SPH_C32(0x304b3473), SPH_C32(0x77495a30),
    SPH_C32(0xa8c8da54) },
  { SPH_C32(0x774f4800), SPH_C32(0x22540000), SPH_C32(0x31110000),
    SPH_C32(0x5ab00000), SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8),
    SPH_C32(0x69744ba2), SPH_C32(0x893fd19d), SPH_C32(0xab863000),
    SPH_C32(0xc1830000), SPH_C32(0x07b10000), SPH_C32(0xe7870000),
    SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5), SPH_C32(0x066b5ec5),
    SPH_C32(0x45600cf3) },
  { SPH_C32(0xbe244830), SPH_C32(0xc5710000), SPH_C32(0x1e950000),
    SPH_C32(0x7cff0000), SPH_C32(0xc80618ec), SPH_C32(0x01ff909f),
    SPH_C32(0x39eb2226), SPH_C32(0x17567ef5), SPH_C32(0x8de63240),
    SPH_C32(0x1c5b0000), SPH_C32(0x759b0000), SPH_C32(0xa8810000),
    SPH_C32(0x77f03db3), SPH_C32(0x8002090b), SPH_C32(0x30e03d10),
    SPH_C32(0x4946fe91) },
  { SPH_C32(0x63157400), SPH_C32(0x9bbd0000), SPH_C32(0x50360000),
    SPH_C32(0xabd10000), SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0),
    SPH_C32(0x2edd2c82), SPH_C32(0x68b1f558), SPH_C32(0x88e12400),
    SPH_C32(0x093a0000), SPH_C32(0xf3760000), SPH_C32(0x1cf20000),
    SPH_C32(0x975b7e29), SPH_C32(0x515de88c), SPH_C32(0x04af54fa),
    SPH_C32(0x9944eaec) },
  { SPH_C32(0xaa7e7430), SPH_C32(0x7c980000), SPH_C32(0x7fb20000),
    SPH_C32(0x8d9e0000), SPH_C32(0x06672580), SPH_C32(0xb1b6ade7),
    SPH_C32(0x7e424506), SPH_C32(0xf6d85a30), SPH_C32(0xae812640),
    SPH_C32(0xd4e20000), SPH_C32(0x815c0000), SPH_C32(0x53f40000),
    SPH_C32(0x043d19d6), SPH_C32(0x78a4ac42), SPH_C32(0x3224372f),
    SPH_C32(0x9562188e) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0x55d01830), SPH_C32(0x57f60000), SPH_C32(0xbdd50000),
    SPH_C32(0xcbdc0000), SPH_C32(0x515318bc), SPH_C32(0x8ce824c3),
    SPH_C32(0x13995a5e), SPH_C32(0xe6a36141), SPH_C32(0xeef34640),
    SPH_C32(0x87e60000), SPH_C32(0x25ad0000), SPH_C32(0x03500000),
    SPH_C32(0x79fe43ca), SPH_C32(0x5c4855db), SPH_C32(0x1e3d1192),
    SPH_C32(0x21f70bc9) },
  { SPH_C32(0x88e12400), SPH_C32(0x093a0000), SPH_C32(0xf3760000),
    SPH_C32(0x1cf20000), SPH_C32(0x975b7e29), SPH_C32(0x515de88c),
    SPH_C32(0x04af54fa), SPH_C32(0x9944eaec), SPH_C32(0xebf45000),
    SPH_C32(0x92870000), SPH_C32(0xa3400000), SPH_C32(0xb7230000),
    SPH_C32(0x99550050), SPH_C32(0x8d17b45c), SPH_C32(0x2a727878),
    SPH_C32(0xf1f51fb4) },
  { SPH_C32(0x418a2430), SPH_C32(0xee1f0000), SPH_C32(0xdcf20000),
    SPH_C32(0x3abd0000), SPH_C32(0x9f3225d0), SPH_C32(0x3ca119bb),
    SPH_C32(0x54303d7e), SPH_C32(0x072d4584), SPH_C32(0xcd945240),
    SPH_C32(0x4f5f0000), SPH_C32(0xd16a0000), SPH_C32(0xf8250000),
    SPH_C32(0x0a3367af), SPH_C32(0xa4eef092), SPH_C32(0x1cf91bad),
    SPH_C32(0xfdd3edd6) },
  { SPH_C32(0xbfdc0c00), SPH_C32(0x786a0000), SPH_C32(0x66960000),
    SPH_C32(0x16e60000), SPH_C32(0x2af76720), SPH_C32(0x19b270bd),
    SPH_C32(0x41c239e5), SPH_C32(0xa4ee2836), SPH_C32(0xffae6c00),
    SPH_C32(0x2b6e0000), SPH_C32(0xc2670000), SPH_C32(0x46420000),
    SPH_C32(0x57343d3c), SPH_C32(0x3d5e8924), SPH_C32(0x6ddb1f58),
    SPH_C32(0x107b3b71) },
  { SPH_C32(0x76b70c30), SPH_C32(0x9f4f0000), SPH_C32(0x49120000),
    SPH_C32(0x30a90000), SPH_C32(0x229e3cd9), SPH_C32(0x744e818a),
    SPH_C32(0x115d5061), SPH_C32(0x3a87875e), SPH_C32(0xd9ce6e40),
    SPH_C32(0xf6b60000), SPH_C32(0xb04d0000), SPH_C32(0x09440000),
    SPH_C32(0xc4525ac3), SPH_C32(0x14a7cdea), SPH_C32(0x5b507c8d),
    SPH_C32(0x1c5dc913) },
  { SPH_C32(0xab863000), SPH_C32(0xc1830000), SPH_C32(0x07b10000),
    SPH_C32(0xe7870000), SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5),
    SPH_C32(0x066b5ec5), SPH_C32(0x45600cf3), SPH_C32(0xdcc97800),
    SPH_C32(0xe3d70000), SPH_C32(0x36a00000), SPH_C32(0xbd370000),
    SPH_C32(0x24f91959), SPH_C32(0xc5f82c6d), SPH_C32(0x6f1f1567),
    SPH_C32(0xcc5fdd6e) },
  { SPH_C32(0x62ed3030), SPH_C32(0x26a60000), SPH_C32(0x28350000),
    SPH_C32(0xc1c80000), SPH_C32(0xecff01b5), SPH_C32(0xc407bcf2),
    SPH_C32(0x56f43741), SPH_C32(0xdb09a39b), SPH_C32(0xfaa97a40),
    SPH_C32(0x3e0f0000), SPH_C32(0x448a0000), SPH_C32(0xf2310000),
    SPH_C32(0xb79f7ea6), SPH_C32(0xec0168a3), SPH_C32(0x599476b2),
    SPH_C32(0xc0792f0c) },
  { SPH_C32(0xc8934400), SPH_C32(0x5a3e0000), SPH_C32(0x57870000),
    SPH_C32(0x4c560000), SPH_C32(0xea982435), SPH_C32(0x75b11115),
    SPH_C32(0x28b67247), SPH_C32(0x2dd1f9ab), SPH_C32(0x54285c00),
    SPH_C32(0xeaed0000), SPH_C32(0xc5d60000), SPH_C32(0xa1c50000),
    SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1), SPH_C32(0x6bb0419d),
    SPH_C32(0x551b3782) },
  { SPH_C32(0x01f84430), SPH_C32(0xbd1b0000), SPH_C32(0x78030000),
    SPH_C32(0x6a190000), SPH_C32(0xe2f17fcc), SPH_C32(0x184de022),
    SPH_C32(0x78291bc3), SPH_C32(0xb3b856c3), SPH_C32(0x72485e40),
    SPH_C32(0x37350000), SPH_C32(0xb7fc0000), SPH_C32(0xeec30000),
    SPH_C32(0x20c4008f), SPH_C32(0xbd5c802f), SPH_C32(0x5d3b2248),
    SPH_C32(0x593dc5e0) },
  { SPH_C32(0xdcc97800), SPH_C32(0xe3d70000), SPH_C32(0x36a00000),
    SPH_C32(0xbd370000), SPH_C32(0x24f91959), SPH_C32(0xc5f82c6d),
    SPH_C32(0x6f1f1567), SPH_C32(0xcc5fdd6e), SPH_C32(0x774f4800),
    SPH_C32(0x22540000), SPH_C32(0x31110000), SPH_C32(0x5ab00000),
    SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8), SPH_C32(0x69744ba2),
    SPH_C32(0x893fd19d) },
  { SPH_C32(0x15a27830), SPH_C32(0x04f20000), SPH_C32(0x19240000),
    SPH_C32(0x9b780000), SPH_C32(0x2c9042a0), SPH_C32(0xa804dd5a),
    SPH_C32(0x3f807ce3), SPH_C32(0x52367206), SPH_C32(0x512f4a40),
    SPH_C32(0xff8c0000), SPH_C32(0x433b0000), SPH_C32(0x15b60000),
    SPH_C32(0x530924ea), SPH_C32(0x45fa2566), SPH_C32(0x5fff2877),
    SPH_C32(0x851923ff) },
  { SPH_C32(0xebf45000), SPH_C32(0x92870000), SPH_C32(0xa3400000),
    SPH_C32(0xb7230000), SPH_C32(0x99550050), SPH_C32(0x8d17b45c),
    SPH_C32(0x2a727878), SPH_C32(0xf1f51fb4), SPH_C32(0x63157400),
    SPH_C32(0x9bbd0000), SPH_C32(0x50360000), SPH_C32(0xabd10000),
    SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0), SPH_C32(0x2edd2c82),
    SPH_C32(0x68b1f558) },
  { SPH_C32(0x229f5030), SPH_C32(0x75a20000), SPH_C32(0x8cc40000),
    SPH_C32(0x916c0000), SPH_C32(0x913c5ba9), SPH_C32(0xe0eb456b),
    SPH_C32(0x7aed11fc), SPH_C32(0x6f9cb0dc), SPH_C32(0x45757640),
    SPH_C32(0x46650000), SPH_C32(0x221c0000), SPH_C32(0xe4d70000),
    SPH_C32(0x9d681986), SPH_C32(0xf5b3181e), SPH_C32(0x18564f57),
    SPH_C32(0x6497073a) },
  { SPH_C32(0xffae6c00), SPH_C32(0x2b6e0000), SPH_C32(0xc2670000),
    SPH_C32(0x46420000), SPH_C32(0x57343d3c), SPH_C32(0x3d5e8924),
    SPH_C32(0x6ddb1f58), SPH_C32(0x107b3b71), SPH_C32(0x40726000),
    SPH_C32(0x53040000), SPH_C32(0xa4f10000), SPH_C32(0x50a40000),
    SPH_C32(0x7dc35a1c), SPH_C32(0x24ecf999), SPH_C32(0x2c1926bd),
    SPH_C32(0xb4951347) },
  { SPH_C32(0x36c56c30), SPH_C32(0xcc4b0000), SPH_C32(0xede30000),
    SPH_C32(0x600d0000), SPH_C32(0x5f5d66c5), SPH_C32(0x50a27813),
    SPH_C32(0x3d4476dc), SPH_C32(0x8e129419), SPH_C32(0x66126240),
    SPH_C32(0x8edc0000), SPH_C32(0xd6db0000), SPH_C32(0x1fa20000),
    SPH_C32(0xeea53de3), SPH_C32(0x0d15bd57), SPH_C32(0x1a924568),
    SPH_C32(0xb8b3e125) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0xe02f9c30), SPH_C32(0x83c20000), SPH_C32(0xddcf0000),
    SPH_C32(0xe4bc0000), SPH_C32(0x06b71576), SPH_C32(0x3b3ec672),
    SPH_C32(0xa37f2bdd), SPH_C32(0x136431ac), SPH_C32(0x600d0e40),
    SPH_C32(0xd5ba0000), SPH_C32(0xaf770000), SPH_C32(0xf5db0000),
    SPH_C32(0xf9f41ebd), SPH_C32(0x6de66f5d), SPH_C32(0x1701adba),
    SPH_C32(0xb30af980) },
  { SPH_C32(0x3d1ea000), SPH_C32(0xdd0e0000), SPH_C32(0x936c0000),
    SPH_C32(0x33920000), SPH_C32(0xc0bf73e3), SPH_C32(0xe68b0a3d),
    SPH_C32(0xb4492579), SPH_C32(0x6c83ba01), SPH_C32(0x650a1800),
    SPH_C32(0xc0db0000), SPH_C32(0x299a0000), SPH_C32(0x41a80000),
    SPH_C32(0x195f5d27), SPH_C32(0xbcb98eda), SPH_C32(0x234ec450),
    SPH_C32(0x6308edfd) },
  { SPH_C32(0xf475a030), SPH_C32(0x3a2b0000), SPH_C32(0xbce80000),
    SPH_C32(0x15dd0000), SPH_C32(0xc8d6281a), SPH_C32(0x8b77fb0a),
    SPH_C32(0xe4d64cfd), SPH_C32(0xf2ea1569), SPH_C32(0x436a1a40),
    SPH_C32(0x1d030000), SPH_C32(0x5bb00000), SPH_C32(0x0eae0000),
    SPH_C32(0x8a393ad8), SPH_C32(0x9540ca14), SPH_C32(0x15c5a785),
    SPH_C32(0x6f2e1f9f) },
  { SPH_C32(0x0a238800), SPH_C32(0xac5e0000), SPH_C32(0x068c0000),
    SPH_C32(0x39860000), SPH_C32(0x7d136aea), SPH_C32(0xae64920c),
    SPH_C32(0xf1244866), SPH_C32(0x512978db), SPH_C32(0x71502400),
    SPH_C32(0x79320000), SPH_C32(0x48bd0000), SPH_C32(0xb0c90000),
    SPH_C32(0xd73e604b), SPH_C32(0x0cf0b3a2), SPH_C32(0x64e7a370),
    SPH_C32(0x8286c938) },
  { SPH_C32(0xc3488830), SPH_C32(0x4b7b0000), SPH_C32(0x29080000),
    SPH_C32(0x1fc90000), SPH_C32(0x757a3113), SPH_C32(0xc398633b),
    SPH_C32(0xa1bb21e2), SPH_C32(0xcf40d7b3), SPH_C32(0x57302640),
    SPH_C32(0xa4ea0000), SPH_C32(0x3a970000), SPH_C32(0xffcf0000),
    SPH_C32(0x445807b4), SPH_C32(0x2509f76c), SPH_C32(0x526cc0a5),
    SPH_C32(0x8ea03b5a) },
  { SPH_C32(0x1e79b400), SPH_C32(0x15b70000), SPH_C32(0x67ab0000),
    SPH_C32(0xc8e70000), SPH_C32(0xb3725786), SPH_C32(0x1e2daf74),
    SPH_C32(0xb68d2f46), SPH_C32(0xb0a75c1e), SPH_C32(0x52373000),
    SPH_C32(0xb18b0000), SPH_C32(0xbc7a0000), SPH_C32(0x4bbc0000),
    SPH_C32(0xa4f3442e), SPH_C32(0xf45616eb), SPH_C32(0x6623a94f),
    SPH_C32(0x5ea22f27) },
  { SPH_C32(0xd712b430), SPH_C32(0xf2920000), SPH_C32(0x482f0000),
    SPH_C32(0xeea80000), SPH_C32(0xbb1b0c7f), SPH_C32(0x73d15e43),
    SPH_C32(0xe61246c2), SPH_C32(0x2ecef376), SPH_C32(0x74573240),
    SPH_C32(0x6c530000), SPH_C32(0xce500000), SPH_C32(0x04ba0000),
    SPH_C32(0x379523d1), SPH_C32(0xddaf5225), SPH_C32(0x50a8ca9a),
    SPH_C32(0x5284dd45) },
  { SPH_C32(0x7d6cc000), SPH_C32(0x8e0a0000), SPH_C32(0x379d0000),
    SPH_C32(0x63360000), SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4),
    SPH_C32(0x985003c4), SPH_C32(0xd816a946), SPH_C32(0xdad61400),
    SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000), SPH_C32(0x574e0000),
    SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67), SPH_C32(0x628cfdb5),
    SPH_C32(0xc7e6c5cb) },
  { SPH_C32(0xb407c030), SPH_C32(0x692f0000), SPH_C32(0x18190000),
    SPH_C32(0x45790000), SPH_C32(0xb5157206), SPH_C32(0xaf9b0293),
    SPH_C32(0xc8cf6a40), SPH_C32(0x467f062e), SPH_C32(0xfcb61640),
    SPH_C32(0x65690000), SPH_C32(0x3d260000), SPH_C32(0x18480000),
    SPH_C32(0xa0ce5df8), SPH_C32(0x8cf2baa9), SPH_C32(0x54079e60),
    SPH_C32(0xcbc037a9) },
  { SPH_C32(0x6936fc00), SPH_C32(0x37e30000), SPH_C32(0x56ba0000),
    SPH_C32(0x92570000), SPH_C32(0x731d1493), SPH_C32(0x722ecedc),
    SPH_C32(0xdff964e4), SPH_C32(0x39988d83), SPH_C32(0xf9b10000),
    SPH_C32(0x70080000), SPH_C32(0xbbcb0000), SPH_C32(0xac3b0000),
    SPH_C32(0x40651e62), SPH_C32(0x5dad5b2e), SPH_C32(0x6048f78a),
    SPH_C32(0x1bc223d4) },
  { SPH_C32(0xa05dfc30), SPH_C32(0xd0c60000), SPH_C32(0x793e0000),
    SPH_C32(0xb4180000), SPH_C32(0x7b744f6a), SPH_C32(0x1fd23feb),
    SPH_C32(0x8f660d60), SPH_C32(0xa7f122eb), SPH_C32(0xdfd10240),
    SPH_C32(0xadd00000), SPH_C32(0xc9e10000), SPH_C32(0xe33d0000),
    SPH_C32(0xd303799d), SPH_C32(0x74541fe0), SPH_C32(0x56c3945f),
    SPH_C32(0x17e4d1b6) },
  { SPH_C32(0x5e0bd400), SPH_C32(0x46b30000), SPH_C32(0xc35a0000),
    SPH_C32(0x98430000), SPH_C32(0xceb10d9a), SPH_C32(0x3ac156ed),
    SPH_C32(0x9a9409fb), SPH_C32(0x04324f59), SPH_C32(0xedeb3c00),
    SPH_C32(0xc9e10000), SPH_C32(0xdaec0000), SPH_C32(0x5d5a0000),
    SPH_C32(0x8e04230e), SPH_C32(0xede46656), SPH_C32(0x27e190aa),
    SPH_C32(0xfa4c0711) },
  { SPH_C32(0x9760d430), SPH_C32(0xa1960000), SPH_C32(0xecde0000),
    SPH_C32(0xbe0c0000), SPH_C32(0xc6d85663), SPH_C32(0x573da7da),
    SPH_C32(0xca0b607f), SPH_C32(0x9a5be031), SPH_C32(0xcb8b3e40),
    SPH_C32(0x14390000), SPH_C32(0xa8c60000), SPH_C32(0x125c0000),
    SPH_C32(0x1d6244f1), SPH_C32(0xc41d2298), SPH_C32(0x116af37f),
    SPH_C32(0xf66af573) },
  { SPH_C32(0x4a51e800), SPH_C32(0xff5a0000), SPH_C32(0xa27d0000),
    SPH_C32(0x69220000), SPH_C32(0x00d030f6), SPH_C32(0x8a886b95),
    SPH_C32(0xdd3d6edb), SPH_C32(0xe5bc6b9c), SPH_C32(0xce8c2800),
    SPH_C32(0x01580000), SPH_C32(0x2e2b0000), SPH_C32(0xa62f0000),
    SPH_C32(0xfdc9076b), SPH_C32(0x1542c31f), SPH_C32(0x25259a95),
    SPH_C32(0x2668e10e) },
  { SPH_C32(0x833ae830), SPH_C32(0x187f0000), SPH_C32(0x8df90000),
    SPH_C32(0x4f6d0000), SPH_C32(0x08b96b0f), SPH_C32(0xe7749aa2),
    SPH_C32(0x8da2075f), SPH_C32(0x7bd5c4f4), SPH_C32(0xe8ec2a40),
    SPH_C32(0xdc800000), SPH_C32(0x5c010000), SPH_C32(0xe9290000),
    SPH_C32(0x6eaf6094), SPH_C32(0x3cbb87d1), SPH_C32(0x13aef940),
    SPH_C32(0x2a4e136c) },
  { SPH_C32(0xb5ff8400), SPH_C32(0xd4340000), SPH_C32(0x601a0000),
    SPH_C32(0x2f600000), SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1),
    SPH_C32(0xb0e67183), SPH_C32(0xf5c750ed), SPH_C32(0x8efe4800),
    SPH_C32(0x525c0000), SPH_C32(0x8ada0000), SPH_C32(0xf68b0000),
    SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86), SPH_C32(0x093cbc28),
    SPH_C32(0x92fdf249) },
  { SPH_C32(0x7c948430), SPH_C32(0x33110000), SPH_C32(0x4f9e0000),
    SPH_C32(0x092f0000), SPH_C32(0x5f8d5633), SPH_C32(0xda2a1386),
    SPH_C32(0xe0791807), SPH_C32(0x6baeff85), SPH_C32(0xa89e4a40),
    SPH_C32(0x8f840000), SPH_C32(0xf8f00000), SPH_C32(0xb98d0000),
    SPH_C32(0x136c3a88), SPH_C32(0x18577e48), SPH_C32(0x3fb7dffd),
    SPH_C32(0x9edb002b) },
  { SPH_C32(0xa1a5b800), SPH_C32(0x6ddd0000), SPH_C32(0x013d0000),
    SPH_C32(0xde010000), SPH_C32(0x998530a6), SPH_C32(0x079fdfc9),
    SPH_C32(0xf74f16a3), SPH_C32(0x14497428), SPH_C32(0xad995c00),
    SPH_C32(0x9ae50000), SPH_C32(0x7e1d0000), SPH_C32(0x0dfe0000),
    SPH_C32(0xf3c77912), SPH_C32(0xc9089fcf), SPH_C32(0x0bf8b617),
    SPH_C32(0x4ed91456) },
  { SPH_C32(0x68ceb830), SPH_C32(0x8af80000), SPH_C32(0x2eb90000),
    SPH_C32(0xf84e0000), SPH_C32(0x91ec6b5f), SPH_C32(0x6a632efe),
    SPH_C32(0xa7d07f27), SPH_C32(0x8a20db40), SPH_C32(0x8bf95e40),
    SPH_C32(0x473d0000), SPH_C32(0x0c370000), SPH_C32(0x42f80000),
    SPH_C32(0x60a11eed), SPH_C32(0xe0f1db01), SPH_C32(0x3d73d5c2),
    SPH_C32(0x42ffe634) },
  { SPH_C32(0x96989000), SPH_C32(0x1c8d0000), SPH_C32(0x94dd0000),
    SPH_C32(0xd4150000), SPH_C32(0x242929af), SPH_C32(0x4f7047f8),
    SPH_C32(0xb2227bbc), SPH_C32(0x29e3b6f2), SPH_C32(0xb9c36000),
    SPH_C32(0x230c0000), SPH_C32(0x1f3a0000), SPH_C32(0xfc9f0000),
    SPH_C32(0x3da6447e), SPH_C32(0x7941a2b7), SPH_C32(0x4c51d137),
    SPH_C32(0xaf573093) },
  { SPH_C32(0x5ff39030), SPH_C32(0xfba80000), SPH_C32(0xbb590000),
    SPH_C32(0xf25a0000), SPH_C32(0x2c407256), SPH_C32(0x228cb6cf),
    SPH_C32(0xe2bd1238), SPH_C32(0xb78a199a), SPH_C32(0x9fa36240),
    SPH_C32(0xfed40000), SPH_C32(0x6d100000), SPH_C32(0xb3990000),
    SPH_C32(0xaec02381), SPH_C32(0x50b8e679), SPH_C32(0x7adab2e2),
    SPH_C32(0xa371c2f1) },
  { SPH_C32(0x82c2ac00), SPH_C32(0xa5640000), SPH_C32(0xf5fa0000),
    SPH_C32(0x25740000), SPH_C32(0xea4814c3), SPH_C32(0xff397a80),
    SPH_C32(0xf58b1c9c), SPH_C32(0xc86d9237), SPH_C32(0x9aa47400),
    SPH_C32(0xebb50000), SPH_C32(0xebfd0000), SPH_C32(0x07ea0000),
    SPH_C32(0x4e6b601b), SPH_C32(0x81e707fe), SPH_C32(0x4e95db08),
    SPH_C32(0x7373d68c) },
  { SPH_C32(0x4ba9ac30), SPH_C32(0x42410000), SPH_C32(0xda7e0000),
    SPH_C32(0x033b0000), SPH_C32(0xe2214f3a), SPH_C32(0x92c58bb7),
    SPH_C32(0xa5147518), SPH_C32(0x56043d5f), SPH_C32(0xbcc47640),
    SPH_C32(0x366d0000), SPH_C32(0x99d70000), SPH_C32(0x48ec0000),
    SPH_C32(0xdd0d07e4), SPH_C32(0xa81e4330), SPH_C32(0x781eb8dd),
    SPH_C32(0x7f5524ee) },
  { SPH_C32(0xe1d7d800), SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000),
    SPH_C32(0x8ea50000), SPH_C32(0xe4466aba), SPH_C32(0x23732650),
    SPH_C32(0xdb56301e), SPH_C32(0xa0dc676f), SPH_C32(0x12455000),
    SPH_C32(0xe28f0000), SPH_C32(0x188b0000), SPH_C32(0x1b180000),
    SPH_C32(0xd9301e32), SPH_C32(0xd0baef72), SPH_C32(0x4a3a8ff2),
    SPH_C32(0xea373c60) },
  { SPH_C32(0x28bcd830), SPH_C32(0xd9fc0000), SPH_C32(0x8a480000),
    SPH_C32(0xa8ea0000), SPH_C32(0xec2f3143), SPH_C32(0x4e8fd767),
    SPH_C32(0x8bc9599a), SPH_C32(0x3eb5c807), SPH_C32(0x34255240),
    SPH_C32(0x3f570000), SPH_C32(0x6aa10000), SPH_C32(0x541e0000),
    SPH_C32(0x4a5679cd), SPH_C32(0xf943abbc), SPH_C32(0x7cb1ec27),
    SPH_C32(0xe611ce02) },
  { SPH_C32(0xf58de400), SPH_C32(0x87300000), SPH_C32(0xc4eb0000),
    SPH_C32(0x7fc40000), SPH_C32(0x2a2757d6), SPH_C32(0x933a1b28),
    SPH_C32(0x9cff573e), SPH_C32(0x415243aa), SPH_C32(0x31224400),
    SPH_C32(0x2a360000), SPH_C32(0xec4c0000), SPH_C32(0xe06d0000),
    SPH_C32(0xaafd3a57), SPH_C32(0x281c4a3b), SPH_C32(0x48fe85cd),
    SPH_C32(0x3613da7f) },
  { SPH_C32(0x3ce6e430), SPH_C32(0x60150000), SPH_C32(0xeb6f0000),
    SPH_C32(0x598b0000), SPH_C32(0x224e0c2f), SPH_C32(0xfec6ea1f),
    SPH_C32(0xcc603eba), SPH_C32(0xdf3becc2), SPH_C32(0x17424640),
    SPH_C32(0xf7ee0000), SPH_C32(0x9e660000), SPH_C32(0xaf6b0000),
    SPH_C32(0x399b5da8), SPH_C32(0x01e50ef5), SPH_C32(0x7e75e618),
    SPH_C32(0x3a35281d) },
  { SPH_C32(0xc2b0cc00), SPH_C32(0xf6600000), SPH_C32(0x510b0000),
    SPH_C32(0x75d00000), SPH_C32(0x978b4edf), SPH_C32(0xdbd58319),
    SPH_C32(0xd9923a21), SPH_C32(0x7cf88170), SPH_C32(0x25787800),
    SPH_C32(0x93df0000), SPH_C32(0x8d6b0000), SPH_C32(0x110c0000),
    SPH_C32(0x649c073b), SPH_C32(0x98557743), SPH_C32(0x0f57e2ed),
    SPH_C32(0xd79dfeba) },
  { SPH_C32(0x0bdbcc30), SPH_C32(0x11450000), SPH_C32(0x7e8f0000),
    SPH_C32(0x539f0000), SPH_C32(0x9fe21526), SPH_C32(0xb629722e),
    SPH_C32(0x890d53a5), SPH_C32(0xe2912e18), SPH_C32(0x03187a40),
    SPH_C32(0x4e070000), SPH_C32(0xff410000), SPH_C32(0x5e0a0000),
    SPH_C32(0xf7fa60c4), SPH_C32(0xb1ac338d), SPH_C32(0x39dc8138),
    SPH_C32(0xdbbb0cd8) },
  { SPH_C32(0xd6eaf000), SPH_C32(0x4f890000), SPH_C32(0x302c0000),
    SPH_C32(0x84b10000), SPH_C32(0x59ea73b3), SPH_C32(0x6b9cbe61),
    SPH_C32(0x9e3b5d01), SPH_C32(0x9d76a5b5), SPH_C32(0x061f6c00),
    SPH_C32(0x5b660000), SPH_C32(0x79ac0000), SPH_C32(0xea790000),
    SPH_C32(0x1751235e), SPH_C32(0x60f3d20a), SPH_C32(0x0d93e8d2),
    SPH_C32(0x0bb918a5) },
  { SPH_C32(0x1f81f030), SPH_C32(0xa8ac0000), SPH_C32(0x1fa80000),
    SPH_C32(0xa2fe0000), SPH_C32(0x5183284a), SPH_C32(0x06604f56),
    SPH_C32(0xcea43485), SPH_C32(0x031f0add), SPH_C32(0x207f6e40),
    SPH_C32(0x86be0000), SPH_C32(0x0b860000), SPH_C32(0xa57f0000),
    SPH_C32(0x843744a1), SPH_C32(0x490a96c4), SPH_C32(0x3b188b07),
    SPH_C32(0x079feac7) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0x8f060c30), SPH_C32(0xef470000), SPH_C32(0xf2d90000),
    SPH_C32(0x9c920000), SPH_C32(0x62fb22bb), SPH_C32(0x29e3daa4),
    SPH_C32(0x7115a7eb), SPH_C32(0x2145a48a), SPH_C32(0x49499240),
    SPH_C32(0xb15d0000), SPH_C32(0x5d3c0000), SPH_C32(0x37280000),
    SPH_C32(0xf72a5032), SPH_C32(0x3b245818), SPH_C32(0xe4e1efe3),
    SPH_C32(0x3e076744) },
  { SPH_C32(0x52373000), SPH_C32(0xb18b0000), SPH_C32(0xbc7a0000),
    SPH_C32(0x4bbc0000), SPH_C32(0xa4f3442e), SPH_C32(0xf45616eb),
    SPH_C32(0x6623a94f), SPH_C32(0x5ea22f27), SPH_C32(0x4c4e8400),
    SPH_C32(0xa43c0000), SPH_C32(0xdbd10000), SPH_C32(0x835b0000),
    SPH_C32(0x178113a8), SPH_C32(0xea7bb99f), SPH_C32(0xd0ae8609),
    SPH_C32(0xee057339) },
  { SPH_C32(0x9b5c3030), SPH_C32(0x56ae0000), SPH_C32(0x93fe0000),
    SPH_C32(0x6df30000), SPH_C32(0xac9a1fd7), SPH_C32(0x99aae7dc),
    SPH_C32(0x36bcc0cb), SPH_C32(0xc0cb804f), SPH_C32(0x6a2e8640),
    SPH_C32(0x79e40000), SPH_C32(0xa9fb0000), SPH_C32(0xcc5d0000),
    SPH_C32(0x84e77457), SPH_C32(0xc382fd51), SPH_C32(0xe625e5dc),
    SPH_C32(0xe223815b) },
  { SPH_C32(0x650a1800), SPH_C32(0xc0db0000), SPH_C32(0x299a0000),
    SPH_C32(0x41a80000), SPH_C32(0x195f5d27), SPH_C32(0xbcb98eda),
    SPH_C32(0x234ec450), SPH_C32(0x6308edfd), SPH_C32(0x5814b800),
    SPH_C32(0x1dd50000), SPH_C32(0xbaf60000), SPH_C32(0x723a0000),
    SPH_C32(0xd9e02ec4), SPH_C32(0x5a3284e7), SPH_C32(0x9707e129),
    SPH_C32(0x0f8b57fc) },
  { SPH_C32(0xac611830), SPH_C32(0x27fe0000), SPH_C32(0x061e0000),
    SPH_C32(0x67e70000), SPH_C32(0x113606de), SPH_C32(0xd1457fed),
    SPH_C32(0x73d1add4), SPH_C32(0xfd614295), SPH_C32(0x7e74ba40),
    SPH_C32(0xc00d0000), SPH_C32(0xc8dc0000), SPH_C32(0x3d3c0000),
    SPH_C32(0x4a86493b), SPH_C32(0x73cbc029), SPH_C32(0xa18c82fc),
    SPH_C32(0x03ada59e) },
  { SPH_C32(0x71502400), SPH_C32(0x79320000), SPH_C32(0x48bd0000),
    SPH_C32(0xb0c90000), SPH_C32(0xd73e604b), SPH_C32(0x0cf0b3a2),
    SPH_C32(0x64e7a370), SPH_C32(0x8286c938), SPH_C32(0x7b73ac00),
    SPH_C32(0xd56c0000), SPH_C32(0x4e310000), SPH_C32(0x894f0000),
    SPH_C32(0xaa2d0aa1), SPH_C32(0xa29421ae), SPH_C32(0x95c3eb16),
    SPH_C32(0xd3afb1e3) },
  { SPH_C32(0xb83b2430), SPH_C32(0x9e170000), SPH_C32(0x67390000),
    SPH_C32(0x96860000), SPH_C32(0xdf573bb2), SPH_C32(0x610c4295),
    SPH_C32(0x3478caf4), SPH_C32(0x1cef6650), SPH_C32(0x5d13ae40),
    SPH_C32(0x08b40000), SPH_C32(0x3c1b0000), SPH_C32(0xc6490000),
    SPH_C32(0x394b6d5e), SPH_C32(0x8b6d6560), SPH_C32(0xa34888c3),
    SPH_C32(0xdf894381) },
  { SPH_C32(0x12455000), SPH_C32(0xe28f0000), SPH_C32(0x188b0000),
    SPH_C32(0x1b180000), SPH_C32(0xd9301e32), SPH_C32(0xd0baef72),
    SPH_C32(0x4a3a8ff2), SPH_C32(0xea373c60), SPH_C32(0xf3928800),
    SPH_C32(0xdc560000), SPH_C32(0xbd470000), SPH_C32(0x95bd0000),
    SPH_C32(0x3d767488), SPH_C32(0xf3c9c922), SPH_C32(0x916cbfec),
    SPH_C32(0x4aeb5b0f) },
  { SPH_C32(0xdb2e5030), SPH_C32(0x05aa0000), SPH_C32(0x370f0000),
    SPH_C32(0x3d570000), SPH_C32(0xd15945cb), SPH_C32(0xbd461e45),
    SPH_C32(0x1aa5e676), SPH_C32(0x745e9308), SPH_C32(0xd5f28a40),
    SPH_C32(0x018e0000), SPH_C32(0xcf6d0000), SPH_C32(0xdabb0000),
    SPH_C32(0xae101377), SPH_C32(0xda308dec), SPH_C32(0xa7e7dc39),
    SPH_C32(0x46cda96d) },
  { SPH_C32(0x061f6c00), SPH_C32(0x5b660000), SPH_C32(0x79ac0000),
    SPH_C32(0xea790000), SPH_C32(0x1751235e), SPH_C32(0x60f3d20a),
    SPH_C32(0x0d93e8d2), SPH_C32(0x0bb918a5), SPH_C32(0xd0f59c00),
    SPH_C32(0x14ef0000), SPH_C32(0x49800000), SPH_C32(0x6ec80000),
    SPH_C32(0x4ebb50ed), SPH_C32(0x0b6f6c6b), SPH_C32(0x93a8b5d3),
    SPH_C32(0x96cfbd10) },
  { SPH_C32(0xcf746c30), SPH_C32(0xbc430000), SPH_C32(0x56280000),
    SPH_C32(0xcc360000), SPH_C32(0x1f3878a7), SPH_C32(0x0d0f233d),
    SPH_C32(0x5d0c8156), SPH_C32(0x95d0b7cd), SPH_C32(0xf6959e40),
    SPH_C32(0xc9370000), SPH_C32(0x3baa0000), SPH_C32(0x21ce0000),
    SPH_C32(0xdddd3712), SPH_C32(0x229628a5), SPH_C32(0xa523d606),
    SPH_C32(0x9ae94f72) },
  { SPH_C32(0x31224400), SPH_C32(0x2a360000), SPH_C32(0xec4c0000),
    SPH_C32(0xe06d0000), SPH_C32(0xaafd3a57), SPH_C32(0x281c4a3b),
    SPH_C32(0x48fe85cd), SPH_C32(0x3613da7f), SPH_C32(0xc4afa000),
    SPH_C32(0xad060000), SPH_C32(0x28a70000), SPH_C32(0x9fa90000),
    SPH_C32(0x80da6d81), SPH_C32(0xbb265113), SPH_C32(0xd401d2f3),
    SPH_C32(0x774199d5) },
  { SPH_C32(0xf8494430), SPH_C32(0xcd130000), SPH_C32(0xc3c80000),
    SPH_C32(0xc6220000), SPH_C32(0xa29461ae), SPH_C32(0x45e0bb0c),
    SPH_C32(0x1861ec49), SPH_C32(0xa87a7517), SPH_C32(0xe2cfa240),
    SPH_C32(0x70de0000), SPH_C32(0x5a8d0000), SPH_C32(0xd0af0000),
    SPH_C32(0x13bc0a7e), SPH_C32(0x92df15dd), SPH_C32(0xe28ab126),
    SPH_C32(0x7b676bb7) },
  { SPH_C32(0x25787800), SPH_C32(0x93df0000), SPH_C32(0x8d6b0000),
    SPH_C32(0x110c0000), SPH_C32(0x649c073b), SPH_C32(0x98557743),
    SPH_C32(0x0f57e2ed), SPH_C32(0xd79dfeba), SPH_C32(0xe7c8b400),
    SPH_C32(0x65bf0000), SPH_C32(0xdc600000), SPH_C32(0x64dc0000),
    SPH_C32(0xf31749e4), SPH_C32(0x4380f45a), SPH_C32(0xd6c5d8cc),
    SPH_C32(0xab657fca) },
  { SPH_C32(0xec137830), SPH_C32(0x74fa0000), SPH_C32(0xa2ef0000),
    SPH_C32(0x37430000), SPH_C32(0x6cf55cc2), SPH_C32(0xf5a98674),
    SPH_C32(0x5fc88b69), SPH_C32(0x49f451d2), SPH_C32(0xc1a8b640),
    SPH_C32(0xb8670000), SPH_C32(0xae4a0000), SPH_C32(0x2bda0000),
    SPH_C32(0x60712e1b), SPH_C32(0x6a79b094), SPH_C32(0xe04ebb19),
    SPH_C32(0xa7438da8) },
  { SPH_C32(0xdad61400), SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000),
    SPH_C32(0x574e0000), SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67),
    SPH_C32(0x628cfdb5), SPH_C32(0xc7e6c5cb), SPH_C32(0xa7bad400),
    SPH_C32(0x36bb0000), SPH_C32(0x78910000), SPH_C32(0x34780000),
    SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3), SPH_C32(0xfadcfe71),
    SPH_C32(0x1ff06c8d) },
  { SPH_C32(0x13bd1430), SPH_C32(0x5f940000), SPH_C32(0x60880000),
    SPH_C32(0x71010000), SPH_C32(0x3bc161fe), SPH_C32(0xc8f70f50),
    SPH_C32(0x32139431), SPH_C32(0x598f6aa3), SPH_C32(0x81dad640),
    SPH_C32(0xeb630000), SPH_C32(0x0abb0000), SPH_C32(0x7b7e0000),
    SPH_C32(0x1db27407), SPH_C32(0x4e95490d), SPH_C32(0xcc579da4),
    SPH_C32(0x13d69eef) },
  { SPH_C32(0xce8c2800), SPH_C32(0x01580000), SPH_C32(0x2e2b0000),
    SPH_C32(0xa62f0000), SPH_C32(0xfdc9076b), SPH_C32(0x1542c31f),
    SPH_C32(0x25259a95), SPH_C32(0x2668e10e), SPH_C32(0x84ddc000),
    SPH_C32(0xfe020000), SPH_C32(0x8c560000), SPH_C32(0xcf0d0000),
    SPH_C32(0xfd19379d), SPH_C32(0x9fcaa88a), SPH_C32(0xf818f44e),
    SPH_C32(0xc3d48a92) },
  { SPH_C32(0x07e72830), SPH_C32(0xe67d0000), SPH_C32(0x01af0000),
    SPH_C32(0x80600000), SPH_C32(0xf5a05c92), SPH_C32(0x78be3228),
    SPH_C32(0x75baf311), SPH_C32(0xb8014e66), SPH_C32(0xa2bdc240),
    SPH_C32(0x23da0000), SPH_C32(0xfe7c0000), SPH_C32(0x800b0000),
    SPH_C32(0x6e7f5062), SPH_C32(0xb633ec44), SPH_C32(0xce93979b),
    SPH_C32(0xcff278f0) },
  { SPH_C32(0xf9b10000), SPH_C32(0x70080000), SPH_C32(0xbbcb0000),
    SPH_C32(0xac3b0000), SPH_C32(0x40651e62), SPH_C32(0x5dad5b2e),
    SPH_C32(0x6048f78a), SPH_C32(0x1bc223d4), SPH_C32(0x9087fc00),
    SPH_C32(0x47eb0000), SPH_C32(0xed710000), SPH_C32(0x3e6c0000),
    SPH_C32(0x33780af1), SPH_C32(0x2f8395f2), SPH_C32(0xbfb1936e),
    SPH_C32(0x225aae57) },
  { SPH_C32(0x30da0030), SPH_C32(0x972d0000), SPH_C32(0x944f0000),
    SPH_C32(0x8a740000), SPH_C32(0x480c459b), SPH_C32(0x3051aa19),
    SPH_C32(0x30d79e0e), SPH_C32(0x85ab8cbc), SPH_C32(0xb6e7fe40),
    SPH_C32(0x9a330000), SPH_C32(0x9f5b0000), SPH_C32(0x716a0000),
    SPH_C32(0xa01e6d0e), SPH_C32(0x067ad13c), SPH_C32(0x893af0bb),
    SPH_C32(0x2e7c5c35) },
  { SPH_C32(0xedeb3c00), SPH_C32(0xc9e10000), SPH_C32(0xdaec0000),
    SPH_C32(0x5d5a0000), SPH_C32(0x8e04230e), SPH_C32(0xede46656),
    SPH_C32(0x27e190aa), SPH_C32(0xfa4c0711), SPH_C32(0xb3e0e800),
    SPH_C32(0x8f520000), SPH_C32(0x19b60000), SPH_C32(0xc5190000),
    SPH_C32(0x40b52e94), SPH_C32(0xd72530bb), SPH_C32(0xbd759951),
    SPH_C32(0xfe7e4848) },
  { SPH_C32(0x24803c30), SPH_C32(0x2ec40000), SPH_C32(0xf5680000),
    SPH_C32(0x7b150000), SPH_C32(0x866d78f7), SPH_C32(0x80189761),
    SPH_C32(0x777ef92e), SPH_C32(0x6425a879), SPH_C32(0x9580ea40),
    SPH_C32(0x528a0000), SPH_C32(0x6b9c0000), SPH_C32(0x8a1f0000),
    SPH_C32(0xd3d3496b), SPH_C32(0xfedc7475), SPH_C32(0x8bfefa84),
    SPH_C32(0xf258ba2a) },
  { SPH_C32(0x8efe4800), SPH_C32(0x525c0000), SPH_C32(0x8ada0000),
    SPH_C32(0xf68b0000), SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86),
    SPH_C32(0x093cbc28), SPH_C32(0x92fdf249), SPH_C32(0x3b01cc00),
    SPH_C32(0x86680000), SPH_C32(0xeac00000), SPH_C32(0xd9eb0000),
    SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837), SPH_C32(0xb9dacdab),
    SPH_C32(0x673aa2a4) },
  { SPH_C32(0x47954830), SPH_C32(0xb5790000), SPH_C32(0xa55e0000),
    SPH_C32(0xd0c40000), SPH_C32(0x8863068e), SPH_C32(0x5c52cbb1),
    SPH_C32(0x59a3d5ac), SPH_C32(0x0c945d21), SPH_C32(0x1d61ce40),
    SPH_C32(0x5bb00000), SPH_C32(0x98ea0000), SPH_C32(0x96ed0000),
    SPH_C32(0x44883742), SPH_C32(0xaf819cf9), SPH_C32(0x8f51ae7e),
    SPH_C32(0x6b1c50c6) },
  { SPH_C32(0x9aa47400), SPH_C32(0xebb50000), SPH_C32(0xebfd0000),
    SPH_C32(0x07ea0000), SPH_C32(0x4e6b601b), SPH_C32(0x81e707fe),
    SPH_C32(0x4e95db08), SPH_C32(0x7373d68c), SPH_C32(0x1866d800),
    SPH_C32(0x4ed10000), SPH_C32(0x1e070000), SPH_C32(0x229e0000),
    SPH_C32(0xa42374d8), SPH_C32(0x7ede7d7e), SPH_C32(0xbb1ec794),
    SPH_C32(0xbb1e44bb) },
  { SPH_C32(0x53cf7430), SPH_C32(0x0c900000), SPH_C32(0xc4790000),
    SPH_C32(0x21a50000), SPH_C32(0x46023be2), SPH_C32(0xec1bf6c9),
    SPH_C32(0x1e0ab28c), SPH_C32(0xed1a79e4), SPH_C32(0x3e06da40),
    SPH_C32(0x93090000), SPH_C32(0x6c2d0000), SPH_C32(0x6d980000),
    SPH_C32(0x37451327), SPH_C32(0x572739b0), SPH_C32(0x8d95a441),
    SPH_C32(0xb738b6d9) },
  { SPH_C32(0xad995c00), SPH_C32(0x9ae50000), SPH_C32(0x7e1d0000),
    SPH_C32(0x0dfe0000), SPH_C32(0xf3c77912), SPH_C32(0xc9089fcf),
    SPH_C32(0x0bf8b617), SPH_C32(0x4ed91456), SPH_C32(0x0c3ce400),
    SPH_C32(0xf7380000), SPH_C32(0x7f200000), SPH_C32(0xd3ff0000),
    SPH_C32(0x6a4249b4), SPH_C32(0xce974006), SPH_C32(0xfcb7a0b4),
    SPH_C32(0x5a90607e) },
  { SPH_C32(0x64f25c30), SPH_C32(0x7dc00000), SPH_C32(0x51990000),
    SPH_C32(0x2bb10000), SPH_C32(0xfbae22eb), SPH_C32(0xa4f46ef8),
    SPH_C32(0x5b67df93), SPH_C32(0xd0b0bb3e), SPH_C32(0x2a5ce640),
    SPH_C32(0x2ae00000), SPH_C32(0x0d0a0000), SPH_C32(0x9cf90000),
    SPH_C32(0xf9242e4b), SPH_C32(0xe76e04c8), SPH_C32(0xca3cc361),
    SPH_C32(0x56b6921c) },
  { SPH_C32(0xb9c36000), SPH_C32(0x230c0000), SPH_C32(0x1f3a0000),
    SPH_C32(0xfc9f0000), SPH_C32(0x3da6447e), SPH_C32(0x7941a2b7),
    SPH_C32(0x4c51d137), SPH_C32(0xaf573093), SPH_C32(0x2f5bf000),
    SPH_C32(0x3f810000), SPH_C32(0x8be70000), SPH_C32(0x288a0000),
    SPH_C32(0x198f6dd1), SPH_C32(0x3631e54f), SPH_C32(0xfe73aa8b),
    SPH_C32(0x86b48661) },
  { SPH_C32(0x70a86030), SPH_C32(0xc4290000), SPH_C32(0x30be0000),
    SPH_C32(0xdad00000), SPH_C32(0x35cf1f87), SPH_C32(0x14bd5380),
    SPH_C32(0x1cceb8b3), SPH_C32(0x313e9ffb), SPH_C32(0x093bf240),
    SPH_C32(0xe2590000), SPH_C32(0xf9cd0000), SPH_C32(0x678c0000),
    SPH_C32(0x8ae90a2e), SPH_C32(0x1fc8a181), SPH_C32(0xc8f8c95e),
    SPH_C32(0x8a927403) },
  { SPH_C32(0x6f299000), SPH_C32(0x6c850000), SPH_C32(0x2f160000),
    SPH_C32(0x782e0000), SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6),
    SPH_C32(0xd26a8c36), SPH_C32(0x32219526), SPH_C32(0x29449c00),
    SPH_C32(0x64e70000), SPH_C32(0xf24b0000), SPH_C32(0xc2f30000),
    SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745), SPH_C32(0xf3e04259),
    SPH_C32(0x8d0d9ec4) },
  { SPH_C32(0xa6429030), SPH_C32(0x8ba00000), SPH_C32(0x00920000),
    SPH_C32(0x5e610000), SPH_C32(0x6c256c34), SPH_C32(0x7f21ede1),
    SPH_C32(0x82f5e5b2), SPH_C32(0xac483a4e), SPH_C32(0x0f249e40),
    SPH_C32(0xb93f0000), SPH_C32(0x80610000), SPH_C32(0x8df50000),
    SPH_C32(0x9db82970), SPH_C32(0x7f3b738b), SPH_C32(0xc56b218c),
    SPH_C32(0x812b6ca6) },
  { SPH_C32(0x7b73ac00), SPH_C32(0xd56c0000), SPH_C32(0x4e310000),
    SPH_C32(0x894f0000), SPH_C32(0xaa2d0aa1), SPH_C32(0xa29421ae),
    SPH_C32(0x95c3eb16), SPH_C32(0xd3afb1e3), SPH_C32(0x0a238800),
    SPH_C32(0xac5e0000), SPH_C32(0x068c0000), SPH_C32(0x39860000),
    SPH_C32(0x7d136aea), SPH_C32(0xae64920c), SPH_C32(0xf1244866),
    SPH_C32(0x512978db) },
  { SPH_C32(0xb218ac30), SPH_C32(0x32490000), SPH_C32(0x61b50000),
    SPH_C32(0xaf000000), SPH_C32(0xa2445158), SPH_C32(0xcf68d099),
    SPH_C32(0xc55c8292), SPH_C32(0x4dc61e8b), SPH_C32(0x2c438a40),
    SPH_C32(0x71860000), SPH_C32(0x74a60000), SPH_C32(0x76800000),
    SPH_C32(0xee750d15), SPH_C32(0x879dd6c2), SPH_C32(0xc7af2bb3),
    SPH_C32(0x5d0f8ab9) },
  { SPH_C32(0x4c4e8400), SPH_C32(0xa43c0000), SPH_C32(0xdbd10000),
    SPH_C32(0x835b0000), SPH_C32(0x178113a8), SPH_C32(0xea7bb99f),
    SPH_C32(0xd0ae8609), SPH_C32(0xee057339), SPH_C32(0x1e79b400),
    SPH_C32(0x15b70000), SPH_C32(0x67ab0000), SPH_C32(0xc8e70000),
    SPH_C32(0xb3725786), SPH_C32(0x1e2daf74), SPH_C32(0xb68d2f46),
    SPH_C32(0xb0a75c1e) },
  { SPH_C32(0x85258430), SPH_C32(0x43190000), SPH_C32(0xf4550000),
    SPH_C32(0xa5140000), SPH_C32(0x1fe84851), SPH_C32(0x878748a8),
    SPH_C32(0x8031ef8d), SPH_C32(0x706cdc51), SPH_C32(0x3819b640),
    SPH_C32(0xc86f0000), SPH_C32(0x15810000), SPH_C32(0x87e10000),
    SPH_C32(0x20143079), SPH_C32(0x37d4ebba), SPH_C32(0x80064c93),
    SPH_C32(0xbc81ae7c) },
  { SPH_C32(0x5814b800), SPH_C32(0x1dd50000), SPH_C32(0xbaf60000),
    SPH_C32(0x723a0000), SPH_C32(0xd9e02ec4), SPH_C32(0x5a3284e7),
    SPH_C32(0x9707e129), SPH_C32(0x0f8b57fc), SPH_C32(0x3d1ea000),
    SPH_C32(0xdd0e0000), SPH_C32(0x936c0000), SPH_C32(0x33920000),
    SPH_C32(0xc0bf73e3), SPH_C32(0xe68b0a3d), SPH_C32(0xb4492579),
    SPH_C32(0x6c83ba01) },
  { SPH_C32(0x917fb830), SPH_C32(0xfaf00000), SPH_C32(0x95720000),
    SPH_C32(0x54750000), SPH_C32(0xd189753d), SPH_C32(0x37ce75d0),
    SPH_C32(0xc79888ad), SPH_C32(0x91e2f894), SPH_C32(0x1b7ea240),
    SPH_C32(0x00d60000), SPH_C32(0xe1460000), SPH_C32(0x7c940000),
    SPH_C32(0x53d9141c), SPH_C32(0xcf724ef3), SPH_C32(0x82c246ac),
    SPH_C32(0x60a54863) },
  { SPH_C32(0x3b01cc00), SPH_C32(0x86680000), SPH_C32(0xeac00000),
    SPH_C32(0xd9eb0000), SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837),
    SPH_C32(0xb9dacdab), SPH_C32(0x673aa2a4), SPH_C32(0xb5ff8400),
    SPH_C32(0xd4340000), SPH_C32(0x601a0000), SPH_C32(0x2f600000),
    SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1), SPH_C32(0xb0e67183),
    SPH_C32(0xf5c750ed) },
  { SPH_C32(0xf26acc30), SPH_C32(0x614d0000), SPH_C32(0xc5440000),
    SPH_C32(0xffa40000), SPH_C32(0xdf870b44), SPH_C32(0xeb842900),
    SPH_C32(0xe945a42f), SPH_C32(0xf9530dcc), SPH_C32(0x939f8640),
    SPH_C32(0x09ec0000), SPH_C32(0x12300000), SPH_C32(0x60660000),
    SPH_C32(0xc4826a35), SPH_C32(0x9e2fa67f), SPH_C32(0x866d1256),
    SPH_C32(0xf9e1a28f) },
  { SPH_C32(0x2f5bf000), SPH_C32(0x3f810000), SPH_C32(0x8be70000),
    SPH_C32(0x288a0000), SPH_C32(0x198f6dd1), SPH_C32(0x3631e54f),
    SPH_C32(0xfe73aa8b), SPH_C32(0x86b48661), SPH_C32(0x96989000),
    SPH_C32(0x1c8d0000), SPH_C32(0x94dd0000), SPH_C32(0xd4150000),
    SPH_C32(0x242929af), SPH_C32(0x4f7047f8), SPH_C32(0xb2227bbc),
    SPH_C32(0x29e3b6f2) },
  { SPH_C32(0xe630f030), SPH_C32(0xd8a40000), SPH_C32(0xa4630000),
    SPH_C32(0x0ec50000), SPH_C32(0x11e63628), SPH_C32(0x5bcd1478),
    SPH_C32(0xaeecc30f), SPH_C32(0x18dd2909), SPH_C32(0xb0f89240),
    SPH_C32(0xc1550000), SPH_C32(0xe6f70000), SPH_C32(0x9b130000),
    SPH_C32(0xb74f4e50), SPH_C32(0x66890336), SPH_C32(0x84a91869),
    SPH_C32(0x25c54490) },
  { SPH_C32(0x1866d800), SPH_C32(0x4ed10000), SPH_C32(0x1e070000),
    SPH_C32(0x229e0000), SPH_C32(0xa42374d8), SPH_C32(0x7ede7d7e),
    SPH_C32(0xbb1ec794), SPH_C32(0xbb1e44bb), SPH_C32(0x82c2ac00),
    SPH_C32(0xa5640000), SPH_C32(0xf5fa0000), SPH_C32(0x25740000),
    SPH_C32(0xea4814c3), SPH_C32(0xff397a80), SPH_C32(0xf58b1c9c),
    SPH_C32(0xc86d9237) },
  { SPH_C32(0xd10dd830), SPH_C32(0xa9f40000), SPH_C32(0x31830000),
    SPH_C32(0x04d10000), SPH_C32(0xac4a2f21), SPH_C32(0x13228c49),
    SPH_C32(0xeb81ae10), SPH_C32(0x2577ebd3), SPH_C32(0xa4a2ae40),
    SPH_C32(0x78bc0000), SPH_C32(0x87d00000), SPH_C32(0x6a720000),
    SPH_C32(0x792e733c), SPH_C32(0xd6c03e4e), SPH_C32(0xc3007f49),
    SPH_C32(0xc44b6055) },
  { SPH_C32(0x0c3ce400), SPH_C32(0xf7380000), SPH_C32(0x7f200000),
    SPH_C32(0xd3ff0000), SPH_C32(0x6a4249b4), SPH_C32(0xce974006),
    SPH_C32(0xfcb7a0b4), SPH_C32(0x5a90607e), SPH_C32(0xa1a5b800),
    SPH_C32(0x6ddd0000), SPH_C32(0x013d0000), SPH_C32(0xde010000),
    SPH_C32(0x998530a6), SPH_C32(0x079fdfc9), SPH_C32(0xf74f16a3),
    SPH_C32(0x14497428) },
  { SPH_C32(0xc557e430), SPH_C32(0x101d0000), SPH_C32(0x50a40000),
    SPH_C32(0xf5b00000), SPH_C32(0x622b124d), SPH_C32(0xa36bb131),
    SPH_C32(0xac28c930), SPH_C32(0xc4f9cf16), SPH_C32(0x87c5ba40),
    SPH_C32(0xb0050000), SPH_C32(0x73170000), SPH_C32(0x91070000),
    SPH_C32(0x0ae35759), SPH_C32(0x2e669b07), SPH_C32(0xc1c47576),
    SPH_C32(0x186f864a) },
  { SPH_C32(0xf3928800), SPH_C32(0xdc560000), SPH_C32(0xbd470000),
    SPH_C32(0x95bd0000), SPH_C32(0x3d767488), SPH_C32(0xf3c9c922),
    SPH_C32(0x916cbfec), SPH_C32(0x4aeb5b0f), SPH_C32(0xe1d7d800),
    SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000), SPH_C32(0x8ea50000),
    SPH_C32(0xe4466aba), SPH_C32(0x23732650), SPH_C32(0xdb56301e),
    SPH_C32(0xa0dc676f) },
  { SPH_C32(0x3af98830), SPH_C32(0x3b730000), SPH_C32(0x92c30000),
    SPH_C32(0xb3f20000), SPH_C32(0x351f2f71), SPH_C32(0x9e353815),
    SPH_C32(0xc1f3d668), SPH_C32(0xd482f467), SPH_C32(0xc7b7da40),
    SPH_C32(0xe3010000), SPH_C32(0xd7e60000), SPH_C32(0xc1a30000),
    SPH_C32(0x77200d45), SPH_C32(0x0a8a629e), SPH_C32(0xeddd53cb),
    SPH_C32(0xacfa950d) },
  { SPH_C32(0xe7c8b400), SPH_C32(0x65bf0000), SPH_C32(0xdc600000),
    SPH_C32(0x64dc0000), SPH_C32(0xf31749e4), SPH_C32(0x4380f45a),
    SPH_C32(0xd6c5d8cc), SPH_C32(0xab657fca), SPH_C32(0xc2b0cc00),
    SPH_C32(0xf6600000), SPH_C32(0x510b0000), SPH_C32(0x75d00000),
    SPH_C32(0x978b4edf), SPH_C32(0xdbd58319), SPH_C32(0xd9923a21),
    SPH_C32(0x7cf88170) },
  { SPH_C32(0x2ea3b430), SPH_C32(0x829a0000), SPH_C32(0xf3e40000),
    SPH_C32(0x42930000), SPH_C32(0xfb7e121d), SPH_C32(0x2e7c056d),
    SPH_C32(0x865ab148), SPH_C32(0x350cd0a2), SPH_C32(0xe4d0ce40),
    SPH_C32(0x2bb80000), SPH_C32(0x23210000), SPH_C32(0x3ad60000),
    SPH_C32(0x04ed2920), SPH_C32(0xf22cc7d7), SPH_C32(0xef1959f4),
    SPH_C32(0x70de7312) },
  { SPH_C32(0xd0f59c00), SPH_C32(0x14ef0000), SPH_C32(0x49800000),
    SPH_C32(0x6ec80000), SPH_C32(0x4ebb50ed), SPH_C32(0x0b6f6c6b),
    SPH_C32(0x93a8b5d3), SPH_C32(0x96cfbd10), SPH_C32(0xd6eaf000),
    SPH_C32(0x4f890000), SPH_C32(0x302c0000), SPH_C32(0x84b10000),
    SPH_C32(0x59ea73b3), SPH_C32(0x6b9cbe61), SPH_C32(0x9e3b5d01),
    SPH_C32(0x9d76a5b5) },
  { SPH_C32(0x199e9c30), SPH_C32(0xf3ca0000), SPH_C32(0x66040000),
    SPH_C32(0x48870000), SPH_C32(0x46d20b14), SPH_C32(0x66939d5c),
    SPH_C32(0xc337dc57), SPH_C32(0x08a61278), SPH_C32(0xf08af240),
    SPH_C32(0x92510000), SPH_C32(0x42060000), SPH_C32(0xcbb70000),
    SPH_C32(0xca8c144c), SPH_C32(0x4265faaf), SPH_C32(0xa8b03ed4),
    SPH_C32(0x915057d7) },
  { SPH_C32(0xc4afa000), SPH_C32(0xad060000), SPH_C32(0x28a70000),
    SPH_C32(0x9fa90000), SPH_C32(0x80da6d81), SPH_C32(0xbb265113),
    SPH_C32(0xd401d2f3), SPH_C32(0x774199d5), SPH_C32(0xf58de400),
    SPH_C32(0x87300000), SPH_C32(0xc4eb0000), SPH_C32(0x7fc40000),
    SPH_C32(0x2a2757d6), SPH_C32(0x933a1b28), SPH_C32(0x9cff573e),
    SPH_C32(0x415243aa) },
  { SPH_C32(0x0dc4a030), SPH_C32(0x4a230000), SPH_C32(0x07230000),
    SPH_C32(0xb9e60000), SPH_C32(0x88b33678), SPH_C32(0xd6daa024),
    SPH_C32(0x849ebb77), SPH_C32(0xe92836bd), SPH_C32(0xd3ede640),
    SPH_C32(0x5ae80000), SPH_C32(0xb6c10000), SPH_C32(0x30c20000),
    SPH_C32(0xb9413029), SPH_C32(0xbac35fe6), SPH_C32(0xaa7434eb),
    SPH_C32(0x4d74b1c8) },
  { SPH_C32(0xa7bad400), SPH_C32(0x36bb0000), SPH_C32(0x78910000),
    SPH_C32(0x34780000), SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3),
    SPH_C32(0xfadcfe71), SPH_C32(0x1ff06c8d), SPH_C32(0x7d6cc000),
    SPH_C32(0x8e0a0000), SPH_C32(0x379d0000), SPH_C32(0x63360000),
    SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4), SPH_C32(0x985003c4),
    SPH_C32(0xd816a946) },
  { SPH_C32(0x6ed1d430), SPH_C32(0xd19e0000), SPH_C32(0x57150000),
    SPH_C32(0x12370000), SPH_C32(0x86bd4801), SPH_C32(0x0a90fcf4),
    SPH_C32(0xaa4397f5), SPH_C32(0x8199c3e5), SPH_C32(0x5b0cc240),
    SPH_C32(0x53d20000), SPH_C32(0x45b70000), SPH_C32(0x2c300000),
    SPH_C32(0x2e1a4e00), SPH_C32(0xeb9eb76a), SPH_C32(0xaedb6011),
    SPH_C32(0xd4305b24) },
  { SPH_C32(0xb3e0e800), SPH_C32(0x8f520000), SPH_C32(0x19b60000),
    SPH_C32(0xc5190000), SPH_C32(0x40b52e94), SPH_C32(0xd72530bb),
    SPH_C32(0xbd759951), SPH_C32(0xfe7e4848), SPH_C32(0x5e0bd400),
    SPH_C32(0x46b30000), SPH_C32(0xc35a0000), SPH_C32(0x98430000),
    SPH_C32(0xceb10d9a), SPH_C32(0x3ac156ed), SPH_C32(0x9a9409fb),
    SPH_C32(0x04324f59) },
  { SPH_C32(0x7a8be830), SPH_C32(0x68770000), SPH_C32(0x36320000),
    SPH_C32(0xe3560000), SPH_C32(0x48dc756d), SPH_C32(0xbad9c18c),
    SPH_C32(0xedeaf0d5), SPH_C32(0x6017e720), SPH_C32(0x786bd640),
    SPH_C32(0x9b6b0000), SPH_C32(0xb1700000), SPH_C32(0xd7450000),
    SPH_C32(0x5dd76a65), SPH_C32(0x13381223), SPH_C32(0xac1f6a2e),
    SPH_C32(0x0814bd3b) },
  { SPH_C32(0x84ddc000), SPH_C32(0xfe020000), SPH_C32(0x8c560000),
    SPH_C32(0xcf0d0000), SPH_C32(0xfd19379d), SPH_C32(0x9fcaa88a),
    SPH_C32(0xf818f44e), SPH_C32(0xc3d48a92), SPH_C32(0x4a51e800),
    SPH_C32(0xff5a0000), SPH_C32(0xa27d0000), SPH_C32(0x69220000),
    SPH_C32(0x00d030f6), SPH_C32(0x8a886b95), SPH_C32(0xdd3d6edb),
    SPH_C32(0xe5bc6b9c) },
  { SPH_C32(0x4db6c030), SPH_C32(0x19270000), SPH_C32(0xa3d20000),
    SPH_C32(0xe9420000), SPH_C32(0xf5706c64), SPH_C32(0xf23659bd),
    SPH_C32(0xa8879dca), SPH_C32(0x5dbd25fa), SPH_C32(0x6c31ea40),
    SPH_C32(0x22820000), SPH_C32(0xd0570000), SPH_C32(0x26240000),
    SPH_C32(0x93b65709), SPH_C32(0xa3712f5b), SPH_C32(0xebb60d0e),
    SPH_C32(0xe99a99fe) },
  { SPH_C32(0x9087fc00), SPH_C32(0x47eb0000), SPH_C32(0xed710000),
    SPH_C32(0x3e6c0000), SPH_C32(0x33780af1), SPH_C32(0x2f8395f2),
    SPH_C32(0xbfb1936e), SPH_C32(0x225aae57), SPH_C32(0x6936fc00),
    SPH_C32(0x37e30000), SPH_C32(0x56ba0000), SPH_C32(0x92570000),
    SPH_C32(0x731d1493), SPH_C32(0x722ecedc), SPH_C32(0xdff964e4),
    SPH_C32(0x39988d83) },
  { SPH_C32(0x59ecfc30), SPH_C32(0xa0ce0000), SPH_C32(0xc2f50000),
    SPH_C32(0x18230000), SPH_C32(0x3b115108), SPH_C32(0x427f64c5),
    SPH_C32(0xef2efaea), SPH_C32(0xbc33013f), SPH_C32(0x4f56fe40),
    SPH_C32(0xea3b0000), SPH_C32(0x24900000), SPH_C32(0xdd510000),
    SPH_C32(0xe07b736c), SPH_C32(0x5bd78a12), SPH_C32(0xe9720731),
    SPH_C32(0x35be7fe1) }
};

__constant static const sph_u32 T512_7[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0x231f0009), SPH_C32(0x42f40000), SPH_C32(0x66790000),
    SPH_C32(0x4ebb0000), SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6),
    SPH_C32(0xe2b1674a), SPH_C32(0x69505b3a), SPH_C32(0xf7750009),
    SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000), SPH_C32(0x04920000),
    SPH_C32(0x029519a9), SPH_C32(0xf8e836ba), SPH_C32(0x7a87f14e),
    SPH_C32(0x9e16981a) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0x803100f9), SPH_C32(0x3e66c000), SPH_C32(0x36640000),
    SPH_C32(0x30860000), SPH_C32(0x8ba26725), SPH_C32(0xa263da9f),
    SPH_C32(0x71443c50), SPH_C32(0x5121edd1), SPH_C32(0x20060050),
    SPH_C32(0x1bd0c000), SPH_C32(0xb10a0000), SPH_C32(0x49360000),
    SPH_C32(0xbeda3cc2), SPH_C32(0xaf0bf875), SPH_C32(0x0492e6d6),
    SPH_C32(0x7d72d654) },
  { SPH_C32(0xa32e00f0), SPH_C32(0x7c92c000), SPH_C32(0x501d0000),
    SPH_C32(0x7e3d0000), SPH_C32(0x75793cf6), SPH_C32(0x933f6a49),
    SPH_C32(0x93f55b1a), SPH_C32(0x3871b6eb), SPH_C32(0xd7730059),
    SPH_C32(0xd4ec0000), SPH_C32(0x72dc0000), SPH_C32(0x4da40000),
    SPH_C32(0xbc4f256b), SPH_C32(0x57e3cecf), SPH_C32(0x7e151798),
    SPH_C32(0xe3644e4e) },
  { SPH_C32(0x545b00f9), SPH_C32(0xb3ae0000), SPH_C32(0x93cb0000),
    SPH_C32(0x7aaf0000), SPH_C32(0x77ec255f), SPH_C32(0x6bd75cf3),
    SPH_C32(0xe972aa54), SPH_C32(0xa6672ef1), SPH_C32(0x03190059),
    SPH_C32(0x5924c000), SPH_C32(0xd7730000), SPH_C32(0x078d0000),
    SPH_C32(0x40016711), SPH_C32(0x9e5748a3), SPH_C32(0xe623819c),
    SPH_C32(0x14228d6e) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0x03190059), SPH_C32(0x5924c000), SPH_C32(0xd7730000),
    SPH_C32(0x078d0000), SPH_C32(0x40016711), SPH_C32(0x9e5748a3),
    SPH_C32(0xe623819c), SPH_C32(0x14228d6e), SPH_C32(0x574200a0),
    SPH_C32(0xea8ac000), SPH_C32(0x44b80000), SPH_C32(0x7d220000),
    SPH_C32(0x37ed424e), SPH_C32(0xf5801450), SPH_C32(0x0f512bc8),
    SPH_C32(0xb245a39f) },
  { SPH_C32(0x20060050), SPH_C32(0x1bd0c000), SPH_C32(0xb10a0000),
    SPH_C32(0x49360000), SPH_C32(0xbeda3cc2), SPH_C32(0xaf0bf875),
    SPH_C32(0x0492e6d6), SPH_C32(0x7d72d654), SPH_C32(0xa03700a9),
    SPH_C32(0x25b60000), SPH_C32(0x876e0000), SPH_C32(0x79b00000),
    SPH_C32(0x35785be7), SPH_C32(0x0d6822ea), SPH_C32(0x75d6da86),
    SPH_C32(0x2c533b85) },
  { SPH_C32(0xd7730059), SPH_C32(0xd4ec0000), SPH_C32(0x72dc0000),
    SPH_C32(0x4da40000), SPH_C32(0xbc4f256b), SPH_C32(0x57e3cecf),
    SPH_C32(0x7e151798), SPH_C32(0xe3644e4e), SPH_C32(0x745d00a9),
    SPH_C32(0xa87ec000), SPH_C32(0x22c10000), SPH_C32(0x33990000),
    SPH_C32(0xc936199d), SPH_C32(0xc4dca486), SPH_C32(0xede04c82),
    SPH_C32(0xdb15f8a5) },
  { SPH_C32(0x832800a0), SPH_C32(0x67420000), SPH_C32(0xe1170000),
    SPH_C32(0x370b0000), SPH_C32(0xcba30034), SPH_C32(0x3c34923c),
    SPH_C32(0x9767bdcc), SPH_C32(0x450360bf), SPH_C32(0x774400f0),
    SPH_C32(0xf15a0000), SPH_C32(0xf5b20000), SPH_C32(0x34140000),
    SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25), SPH_C32(0x0bc3cd1e),
    SPH_C32(0xcf3775cb) },
  { SPH_C32(0x745d00a9), SPH_C32(0xa87ec000), SPH_C32(0x22c10000),
    SPH_C32(0x33990000), SPH_C32(0xc936199d), SPH_C32(0xc4dca486),
    SPH_C32(0xede04c82), SPH_C32(0xdb15f8a5), SPH_C32(0xa32e00f0),
    SPH_C32(0x7c92c000), SPH_C32(0x501d0000), SPH_C32(0x7e3d0000),
    SPH_C32(0x75793cf6), SPH_C32(0x933f6a49), SPH_C32(0x93f55b1a),
    SPH_C32(0x3871b6eb) },
  { SPH_C32(0x574200a0), SPH_C32(0xea8ac000), SPH_C32(0x44b80000),
    SPH_C32(0x7d220000), SPH_C32(0x37ed424e), SPH_C32(0xf5801450),
    SPH_C32(0x0f512bc8), SPH_C32(0xb245a39f), SPH_C32(0x545b00f9),
    SPH_C32(0xb3ae0000), SPH_C32(0x93cb0000), SPH_C32(0x7aaf0000),
    SPH_C32(0x77ec255f), SPH_C32(0x6bd75cf3), SPH_C32(0xe972aa54),
    SPH_C32(0xa6672ef1) },
  { SPH_C32(0xa03700a9), SPH_C32(0x25b60000), SPH_C32(0x876e0000),
    SPH_C32(0x79b00000), SPH_C32(0x35785be7), SPH_C32(0x0d6822ea),
    SPH_C32(0x75d6da86), SPH_C32(0x2c533b85), SPH_C32(0x803100f9),
    SPH_C32(0x3e66c000), SPH_C32(0x36640000), SPH_C32(0x30860000),
    SPH_C32(0x8ba26725), SPH_C32(0xa263da9f), SPH_C32(0x71443c50),
    SPH_C32(0x5121edd1) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0x1ff20179), SPH_C32(0x524ec000), SPH_C32(0xd10d0000),
    SPH_C32(0xd0b00000), SPH_C32(0xf01d728e), SPH_C32(0x51c9d3f9),
    SPH_C32(0x347f4456), SPH_C32(0xff9e8bab), SPH_C32(0x605d0060),
    SPH_C32(0x8184c000), SPH_C32(0xf36d0000), SPH_C32(0x16870000),
    SPH_C32(0x681a5d45), SPH_C32(0xf28a7e49), SPH_C32(0x8300c939),
    SPH_C32(0x04929478) },
  { SPH_C32(0x3ced0170), SPH_C32(0x10bac000), SPH_C32(0xb7740000),
    SPH_C32(0x9e0b0000), SPH_C32(0x0ec6295d), SPH_C32(0x6095632f),
    SPH_C32(0xd6ce231c), SPH_C32(0x96ced091), SPH_C32(0x97280069),
    SPH_C32(0x4eb80000), SPH_C32(0x30bb0000), SPH_C32(0x12150000),
    SPH_C32(0x6a8f44ec), SPH_C32(0x0a6248f3), SPH_C32(0xf9873877),
    SPH_C32(0x9a840c62) },
  { SPH_C32(0xcb980179), SPH_C32(0xdf860000), SPH_C32(0x74a20000),
    SPH_C32(0x9a990000), SPH_C32(0x0c5330f4), SPH_C32(0x987d5595),
    SPH_C32(0xac49d252), SPH_C32(0x08d8488b), SPH_C32(0x43420069),
    SPH_C32(0xc370c000), SPH_C32(0x95140000), SPH_C32(0x583c0000),
    SPH_C32(0x96c10696), SPH_C32(0xc3d6ce9f), SPH_C32(0x61b1ae73),
    SPH_C32(0x6dc2cf42) },
  { SPH_C32(0x9fc30180), SPH_C32(0x6c280000), SPH_C32(0xe7690000),
    SPH_C32(0xe0360000), SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966),
    SPH_C32(0x453b7806), SPH_C32(0xaebf667a), SPH_C32(0x405b0030),
    SPH_C32(0x9a540000), SPH_C32(0x42670000), SPH_C32(0x5fb10000),
    SPH_C32(0xd6c06187), SPH_C32(0x5d81863c), SPH_C32(0x87922fef),
    SPH_C32(0x79e0422c) },
  { SPH_C32(0x68b60189), SPH_C32(0xa314c000), SPH_C32(0x24bf0000),
    SPH_C32(0xe4a40000), SPH_C32(0x792a0c02), SPH_C32(0x0b423fdc),
    SPH_C32(0x3fbc8948), SPH_C32(0x30a9fe60), SPH_C32(0x94310030),
    SPH_C32(0x179cc000), SPH_C32(0xe7c80000), SPH_C32(0x15980000),
    SPH_C32(0x2a8e23fd), SPH_C32(0x94350050), SPH_C32(0x1fa4b9eb),
    SPH_C32(0x8ea6810c) },
  { SPH_C32(0x4ba90180), SPH_C32(0xe1e0c000), SPH_C32(0x42c60000),
    SPH_C32(0xaa1f0000), SPH_C32(0x87f157d1), SPH_C32(0x3a1e8f0a),
    SPH_C32(0xdd0dee02), SPH_C32(0x59f9a55a), SPH_C32(0x63440039),
    SPH_C32(0xd8a00000), SPH_C32(0x241e0000), SPH_C32(0x110a0000),
    SPH_C32(0x281b3a54), SPH_C32(0x6cdd36ea), SPH_C32(0x652348a5),
    SPH_C32(0x10b01916) },
  { SPH_C32(0xbcdc0189), SPH_C32(0x2edc0000), SPH_C32(0x81100000),
    SPH_C32(0xae8d0000), SPH_C32(0x85644e78), SPH_C32(0xc2f6b9b0),
    SPH_C32(0xa78a1f4c), SPH_C32(0xc7ef3d40), SPH_C32(0xb72e0039),
    SPH_C32(0x5568c000), SPH_C32(0x81b10000), SPH_C32(0x5b230000),
    SPH_C32(0xd455782e), SPH_C32(0xa569b086), SPH_C32(0xfd15dea1),
    SPH_C32(0xe7f6da36) },
  { SPH_C32(0x1ceb0120), SPH_C32(0x0b6a0000), SPH_C32(0x067e0000),
    SPH_C32(0xd73d0000), SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a),
    SPH_C32(0xd25cc5ca), SPH_C32(0xebbc06c5), SPH_C32(0x371f00c0),
    SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000), SPH_C32(0x6ba50000),
    SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19), SPH_C32(0x8c51e2f1),
    SPH_C32(0xb6d737e7) },
  { SPH_C32(0xeb9e0129), SPH_C32(0xc456c000), SPH_C32(0xc5a80000),
    SPH_C32(0xd3af0000), SPH_C32(0xb2890c36), SPH_C32(0x3776ade0),
    SPH_C32(0xa8db3484), SPH_C32(0x75aa9edf), SPH_C32(0xe37500c0),
    SPH_C32(0xe6c6c000), SPH_C32(0x127a0000), SPH_C32(0x218c0000),
    SPH_C32(0xa3b95d71), SPH_C32(0xcebeec75), SPH_C32(0x146774f5),
    SPH_C32(0x4191f4c7) },
  { SPH_C32(0xc8810120), SPH_C32(0x86a2c000), SPH_C32(0xa3d10000),
    SPH_C32(0x9d140000), SPH_C32(0x4c5257e5), SPH_C32(0x062a1d36),
    SPH_C32(0x4a6a53ce), SPH_C32(0x1cfac5e5), SPH_C32(0x140000c9),
    SPH_C32(0x29fa0000), SPH_C32(0xd1ac0000), SPH_C32(0x251e0000),
    SPH_C32(0xa12c44d8), SPH_C32(0x3656dacf), SPH_C32(0x6ee085bb),
    SPH_C32(0xdf876cdd) },
  { SPH_C32(0x3ff40129), SPH_C32(0x499e0000), SPH_C32(0x60070000),
    SPH_C32(0x99860000), SPH_C32(0x4ec74e4c), SPH_C32(0xfec22b8c),
    SPH_C32(0x30eda280), SPH_C32(0x82ec5dff), SPH_C32(0xc06a00c9),
    SPH_C32(0xa432c000), SPH_C32(0x74030000), SPH_C32(0x6f370000),
    SPH_C32(0x5d6206a2), SPH_C32(0xffe25ca3), SPH_C32(0xf6d613bf),
    SPH_C32(0x28c1affd) },
  { SPH_C32(0x6baf01d0), SPH_C32(0xfa300000), SPH_C32(0xf3cc0000),
    SPH_C32(0xe3290000), SPH_C32(0x392b6b13), SPH_C32(0x9515777f),
    SPH_C32(0xd99f08d4), SPH_C32(0x248b730e), SPH_C32(0xc3730090),
    SPH_C32(0xfd160000), SPH_C32(0xa3700000), SPH_C32(0x68ba0000),
    SPH_C32(0x1d6361b3), SPH_C32(0x61b51400), SPH_C32(0x10f59223),
    SPH_C32(0x3ce32293) },
  { SPH_C32(0x9cda01d9), SPH_C32(0x350cc000), SPH_C32(0x301a0000),
    SPH_C32(0xe7bb0000), SPH_C32(0x3bbe72ba), SPH_C32(0x6dfd41c5),
    SPH_C32(0xa318f99a), SPH_C32(0xba9deb14), SPH_C32(0x17190090),
    SPH_C32(0x70dec000), SPH_C32(0x06df0000), SPH_C32(0x22930000),
    SPH_C32(0xe12d23c9), SPH_C32(0xa801926c), SPH_C32(0x88c30427),
    SPH_C32(0xcba5e1b3) },
  { SPH_C32(0xbfc501d0), SPH_C32(0x77f8c000), SPH_C32(0x56630000),
    SPH_C32(0xa9000000), SPH_C32(0xc5652969), SPH_C32(0x5ca1f113),
    SPH_C32(0x41a99ed0), SPH_C32(0xd3cdb02e), SPH_C32(0xe06c0099),
    SPH_C32(0xbfe20000), SPH_C32(0xc5090000), SPH_C32(0x26010000),
    SPH_C32(0xe3b83a60), SPH_C32(0x50e9a4d6), SPH_C32(0xf244f569),
    SPH_C32(0x55b379a9) },
  { SPH_C32(0x48b001d9), SPH_C32(0xb8c40000), SPH_C32(0x95b50000),
    SPH_C32(0xad920000), SPH_C32(0xc7f030c0), SPH_C32(0xa449c7a9),
    SPH_C32(0x3b2e6f9e), SPH_C32(0x4ddb2834), SPH_C32(0x34060099),
    SPH_C32(0x322ac000), SPH_C32(0x60a60000), SPH_C32(0x6c280000),
    SPH_C32(0x1ff6781a), SPH_C32(0x995d22ba), SPH_C32(0x6a72636d),
    SPH_C32(0xa2f5ba89) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0x43420069), SPH_C32(0xc370c000), SPH_C32(0x95140000),
    SPH_C32(0x583c0000), SPH_C32(0x96c10696), SPH_C32(0xc3d6ce9f),
    SPH_C32(0x61b1ae73), SPH_C32(0x6dc2cf42), SPH_C32(0x88da0110),
    SPH_C32(0x1cf6c000), SPH_C32(0xe1b60000), SPH_C32(0xc2a50000),
    SPH_C32(0x9a923662), SPH_C32(0x5bab9b0a), SPH_C32(0xcdf87c21),
    SPH_C32(0x651a87c9) },
  { SPH_C32(0x605d0060), SPH_C32(0x8184c000), SPH_C32(0xf36d0000),
    SPH_C32(0x16870000), SPH_C32(0x681a5d45), SPH_C32(0xf28a7e49),
    SPH_C32(0x8300c939), SPH_C32(0x04929478), SPH_C32(0x7faf0119),
    SPH_C32(0xd3ca0000), SPH_C32(0x22600000), SPH_C32(0xc6370000),
    SPH_C32(0x98072fcb), SPH_C32(0xa343adb0), SPH_C32(0xb77f8d6f),
    SPH_C32(0xfb0c1fd3) },
  { SPH_C32(0x97280069), SPH_C32(0x4eb80000), SPH_C32(0x30bb0000),
    SPH_C32(0x12150000), SPH_C32(0x6a8f44ec), SPH_C32(0x0a6248f3),
    SPH_C32(0xf9873877), SPH_C32(0x9a840c62), SPH_C32(0xabc50119),
    SPH_C32(0x5e02c000), SPH_C32(0x87cf0000), SPH_C32(0x8c1e0000),
    SPH_C32(0x64496db1), SPH_C32(0x6af72bdc), SPH_C32(0x2f491b6b),
    SPH_C32(0x0c4adcf3) },
  { SPH_C32(0xc3730090), SPH_C32(0xfd160000), SPH_C32(0xa3700000),
    SPH_C32(0x68ba0000), SPH_C32(0x1d6361b3), SPH_C32(0x61b51400),
    SPH_C32(0x10f59223), SPH_C32(0x3ce32293), SPH_C32(0xa8dc0140),
    SPH_C32(0x07260000), SPH_C32(0x50bc0000), SPH_C32(0x8b930000),
    SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f), SPH_C32(0xc96a9af7),
    SPH_C32(0x1868519d) },
  { SPH_C32(0x34060099), SPH_C32(0x322ac000), SPH_C32(0x60a60000),
    SPH_C32(0x6c280000), SPH_C32(0x1ff6781a), SPH_C32(0x995d22ba),
    SPH_C32(0x6a72636d), SPH_C32(0xa2f5ba89), SPH_C32(0x7cb60140),
    SPH_C32(0x8aeec000), SPH_C32(0xf5130000), SPH_C32(0xc1ba0000),
    SPH_C32(0xd80648da), SPH_C32(0x3d14e513), SPH_C32(0x515c0cf3),
    SPH_C32(0xef2e92bd) },
  { SPH_C32(0x17190090), SPH_C32(0x70dec000), SPH_C32(0x06df0000),
    SPH_C32(0x22930000), SPH_C32(0xe12d23c9), SPH_C32(0xa801926c),
    SPH_C32(0x88c30427), SPH_C32(0xcba5e1b3), SPH_C32(0x8bc30149),
    SPH_C32(0x45d20000), SPH_C32(0x36c50000), SPH_C32(0xc5280000),
    SPH_C32(0xda935173), SPH_C32(0xc5fcd3a9), SPH_C32(0x2bdbfdbd),
    SPH_C32(0x71380aa7) },
  { SPH_C32(0xe06c0099), SPH_C32(0xbfe20000), SPH_C32(0xc5090000),
    SPH_C32(0x26010000), SPH_C32(0xe3b83a60), SPH_C32(0x50e9a4d6),
    SPH_C32(0xf244f569), SPH_C32(0x55b379a9), SPH_C32(0x5fa90149),
    SPH_C32(0xc81ac000), SPH_C32(0x936a0000), SPH_C32(0x8f010000),
    SPH_C32(0x26dd1309), SPH_C32(0x0c4855c5), SPH_C32(0xb3ed6bb9),
    SPH_C32(0x867ec987) },
  { SPH_C32(0x405b0030), SPH_C32(0x9a540000), SPH_C32(0x42670000),
    SPH_C32(0x5fb10000), SPH_C32(0xd6c06187), SPH_C32(0x5d81863c),
    SPH_C32(0x87922fef), SPH_C32(0x79e0422c), SPH_C32(0xdf9801b0),
    SPH_C32(0xf67c0000), SPH_C32(0xa50e0000), SPH_C32(0xbf870000),
    SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a), SPH_C32(0xc2a957e9),
    SPH_C32(0xd75f2456) },
  { SPH_C32(0xb72e0039), SPH_C32(0x5568c000), SPH_C32(0x81b10000),
    SPH_C32(0x5b230000), SPH_C32(0xd455782e), SPH_C32(0xa569b086),
    SPH_C32(0xfd15dea1), SPH_C32(0xe7f6da36), SPH_C32(0x0bf201b0),
    SPH_C32(0x7bb4c000), SPH_C32(0x00a10000), SPH_C32(0xf5ae0000),
    SPH_C32(0x51313656), SPH_C32(0x679f0936), SPH_C32(0x5a9fc1ed),
    SPH_C32(0x2019e776) },
  { SPH_C32(0x94310030), SPH_C32(0x179cc000), SPH_C32(0xe7c80000),
    SPH_C32(0x15980000), SPH_C32(0x2a8e23fd), SPH_C32(0x94350050),
    SPH_C32(0x1fa4b9eb), SPH_C32(0x8ea6810c), SPH_C32(0xfc8701b9),
    SPH_C32(0xb4880000), SPH_C32(0xc3770000), SPH_C32(0xf13c0000),
    SPH_C32(0x53a42fff), SPH_C32(0x9f773f8c), SPH_C32(0x201830a3),
    SPH_C32(0xbe0f7f6c) },
  { SPH_C32(0x63440039), SPH_C32(0xd8a00000), SPH_C32(0x241e0000),
    SPH_C32(0x110a0000), SPH_C32(0x281b3a54), SPH_C32(0x6cdd36ea),
    SPH_C32(0x652348a5), SPH_C32(0x10b01916), SPH_C32(0x28ed01b9),
    SPH_C32(0x3940c000), SPH_C32(0x66d80000), SPH_C32(0xbb150000),
    SPH_C32(0xafea6d85), SPH_C32(0x56c3b9e0), SPH_C32(0xb82ea6a7),
    SPH_C32(0x4949bc4c) },
  { SPH_C32(0x371f00c0), SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000),
    SPH_C32(0x6ba50000), SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19),
    SPH_C32(0x8c51e2f1), SPH_C32(0xb6d737e7), SPH_C32(0x2bf401e0),
    SPH_C32(0x60640000), SPH_C32(0xb1ab0000), SPH_C32(0xbc980000),
    SPH_C32(0xefeb0a94), SPH_C32(0xc894f143), SPH_C32(0x5e0d273b),
    SPH_C32(0x5d6b3122) },
  { SPH_C32(0xc06a00c9), SPH_C32(0xa432c000), SPH_C32(0x74030000),
    SPH_C32(0x6f370000), SPH_C32(0x5d6206a2), SPH_C32(0xffe25ca3),
    SPH_C32(0xf6d613bf), SPH_C32(0x28c1affd), SPH_C32(0xff9e01e0),
    SPH_C32(0xedacc000), SPH_C32(0x14040000), SPH_C32(0xf6b10000),
    SPH_C32(0x13a548ee), SPH_C32(0x0120772f), SPH_C32(0xc63bb13f),
    SPH_C32(0xaa2df202) },
  { SPH_C32(0xe37500c0), SPH_C32(0xe6c6c000), SPH_C32(0x127a0000),
    SPH_C32(0x218c0000), SPH_C32(0xa3b95d71), SPH_C32(0xcebeec75),
    SPH_C32(0x146774f5), SPH_C32(0x4191f4c7), SPH_C32(0x08eb01e9),
    SPH_C32(0x22900000), SPH_C32(0xd7d20000), SPH_C32(0xf2230000),
    SPH_C32(0x11305147), SPH_C32(0xf9c84195), SPH_C32(0xbcbc4071),
    SPH_C32(0x343b6a18) },
  { SPH_C32(0x140000c9), SPH_C32(0x29fa0000), SPH_C32(0xd1ac0000),
    SPH_C32(0x251e0000), SPH_C32(0xa12c44d8), SPH_C32(0x3656dacf),
    SPH_C32(0x6ee085bb), SPH_C32(0xdf876cdd), SPH_C32(0xdc8101e9),
    SPH_C32(0xaf58c000), SPH_C32(0x727d0000), SPH_C32(0xb80a0000),
    SPH_C32(0xed7e133d), SPH_C32(0x307cc7f9), SPH_C32(0x248ad675),
    SPH_C32(0xc37da938) },
  { SPH_C32(0x5cb00110), SPH_C32(0x913e0000), SPH_C32(0x44190000),
    SPH_C32(0x888c0000), SPH_C32(0x66dc7418), SPH_C32(0x921f1d66),
    SPH_C32(0x55ceea25), SPH_C32(0x925c44e9), SPH_C32(0xe8870170),
    SPH_C32(0x9d720000), SPH_C32(0x12db0000), SPH_C32(0xd4220000),
    SPH_C32(0xf2886b27), SPH_C32(0xa921e543), SPH_C32(0x4ef8b518),
    SPH_C32(0x618813b1) },
  { SPH_C32(0xabc50119), SPH_C32(0x5e02c000), SPH_C32(0x87cf0000),
    SPH_C32(0x8c1e0000), SPH_C32(0x64496db1), SPH_C32(0x6af72bdc),
    SPH_C32(0x2f491b6b), SPH_C32(0x0c4adcf3), SPH_C32(0x3ced0170),
    SPH_C32(0x10bac000), SPH_C32(0xb7740000), SPH_C32(0x9e0b0000),
    SPH_C32(0x0ec6295d), SPH_C32(0x6095632f), SPH_C32(0xd6ce231c),
    SPH_C32(0x96ced091) },
  { SPH_C32(0x88da0110), SPH_C32(0x1cf6c000), SPH_C32(0xe1b60000),
    SPH_C32(0xc2a50000), SPH_C32(0x9a923662), SPH_C32(0x5bab9b0a),
    SPH_C32(0xcdf87c21), SPH_C32(0x651a87c9), SPH_C32(0xcb980179),
    SPH_C32(0xdf860000), SPH_C32(0x74a20000), SPH_C32(0x9a990000),
    SPH_C32(0x0c5330f4), SPH_C32(0x987d5595), SPH_C32(0xac49d252),
    SPH_C32(0x08d8488b) },
  { SPH_C32(0x7faf0119), SPH_C32(0xd3ca0000), SPH_C32(0x22600000),
    SPH_C32(0xc6370000), SPH_C32(0x98072fcb), SPH_C32(0xa343adb0),
    SPH_C32(0xb77f8d6f), SPH_C32(0xfb0c1fd3), SPH_C32(0x1ff20179),
    SPH_C32(0x524ec000), SPH_C32(0xd10d0000), SPH_C32(0xd0b00000),
    SPH_C32(0xf01d728e), SPH_C32(0x51c9d3f9), SPH_C32(0x347f4456),
    SPH_C32(0xff9e8bab) },
  { SPH_C32(0x2bf401e0), SPH_C32(0x60640000), SPH_C32(0xb1ab0000),
    SPH_C32(0xbc980000), SPH_C32(0xefeb0a94), SPH_C32(0xc894f143),
    SPH_C32(0x5e0d273b), SPH_C32(0x5d6b3122), SPH_C32(0x1ceb0120),
    SPH_C32(0x0b6a0000), SPH_C32(0x067e0000), SPH_C32(0xd73d0000),
    SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a), SPH_C32(0xd25cc5ca),
    SPH_C32(0xebbc06c5) },
  { SPH_C32(0xdc8101e9), SPH_C32(0xaf58c000), SPH_C32(0x727d0000),
    SPH_C32(0xb80a0000), SPH_C32(0xed7e133d), SPH_C32(0x307cc7f9),
    SPH_C32(0x248ad675), SPH_C32(0xc37da938), SPH_C32(0xc8810120),
    SPH_C32(0x86a2c000), SPH_C32(0xa3d10000), SPH_C32(0x9d140000),
    SPH_C32(0x4c5257e5), SPH_C32(0x062a1d36), SPH_C32(0x4a6a53ce),
    SPH_C32(0x1cfac5e5) },
  { SPH_C32(0xff9e01e0), SPH_C32(0xedacc000), SPH_C32(0x14040000),
    SPH_C32(0xf6b10000), SPH_C32(0x13a548ee), SPH_C32(0x0120772f),
    SPH_C32(0xc63bb13f), SPH_C32(0xaa2df202), SPH_C32(0x3ff40129),
    SPH_C32(0x499e0000), SPH_C32(0x60070000), SPH_C32(0x99860000),
    SPH_C32(0x4ec74e4c), SPH_C32(0xfec22b8c), SPH_C32(0x30eda280),
    SPH_C32(0x82ec5dff) },
  { SPH_C32(0x08eb01e9), SPH_C32(0x22900000), SPH_C32(0xd7d20000),
    SPH_C32(0xf2230000), SPH_C32(0x11305147), SPH_C32(0xf9c84195),
    SPH_C32(0xbcbc4071), SPH_C32(0x343b6a18), SPH_C32(0xeb9e0129),
    SPH_C32(0xc456c000), SPH_C32(0xc5a80000), SPH_C32(0xd3af0000),
    SPH_C32(0xb2890c36), SPH_C32(0x3776ade0), SPH_C32(0xa8db3484),
    SPH_C32(0x75aa9edf) },
  { SPH_C32(0xa8dc0140), SPH_C32(0x07260000), SPH_C32(0x50bc0000),
    SPH_C32(0x8b930000), SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f),
    SPH_C32(0xc96a9af7), SPH_C32(0x1868519d), SPH_C32(0x6baf01d0),
    SPH_C32(0xfa300000), SPH_C32(0xf3cc0000), SPH_C32(0xe3290000),
    SPH_C32(0x392b6b13), SPH_C32(0x9515777f), SPH_C32(0xd99f08d4),
    SPH_C32(0x248b730e) },
  { SPH_C32(0x5fa90149), SPH_C32(0xc81ac000), SPH_C32(0x936a0000),
    SPH_C32(0x8f010000), SPH_C32(0x26dd1309), SPH_C32(0x0c4855c5),
    SPH_C32(0xb3ed6bb9), SPH_C32(0x867ec987), SPH_C32(0xbfc501d0),
    SPH_C32(0x77f8c000), SPH_C32(0x56630000), SPH_C32(0xa9000000),
    SPH_C32(0xc5652969), SPH_C32(0x5ca1f113), SPH_C32(0x41a99ed0),
    SPH_C32(0xd3cdb02e) },
  { SPH_C32(0x7cb60140), SPH_C32(0x8aeec000), SPH_C32(0xf5130000),
    SPH_C32(0xc1ba0000), SPH_C32(0xd80648da), SPH_C32(0x3d14e513),
    SPH_C32(0x515c0cf3), SPH_C32(0xef2e92bd), SPH_C32(0x48b001d9),
    SPH_C32(0xb8c40000), SPH_C32(0x95b50000), SPH_C32(0xad920000),
    SPH_C32(0xc7f030c0), SPH_C32(0xa449c7a9), SPH_C32(0x3b2e6f9e),
    SPH_C32(0x4ddb2834) },
  { SPH_C32(0x8bc30149), SPH_C32(0x45d20000), SPH_C32(0x36c50000),
    SPH_C32(0xc5280000), SPH_C32(0xda935173), SPH_C32(0xc5fcd3a9),
    SPH_C32(0x2bdbfdbd), SPH_C32(0x71380aa7), SPH_C32(0x9cda01d9),
    SPH_C32(0x350cc000), SPH_C32(0x301a0000), SPH_C32(0xe7bb0000),
    SPH_C32(0x3bbe72ba), SPH_C32(0x6dfd41c5), SPH_C32(0xa318f99a),
    SPH_C32(0xba9deb14) },
  { SPH_C32(0xdf9801b0), SPH_C32(0xf67c0000), SPH_C32(0xa50e0000),
    SPH_C32(0xbf870000), SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a),
    SPH_C32(0xc2a957e9), SPH_C32(0xd75f2456), SPH_C32(0x9fc30180),
    SPH_C32(0x6c280000), SPH_C32(0xe7690000), SPH_C32(0xe0360000),
    SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966), SPH_C32(0x453b7806),
    SPH_C32(0xaebf667a) },
  { SPH_C32(0x28ed01b9), SPH_C32(0x3940c000), SPH_C32(0x66d80000),
    SPH_C32(0xbb150000), SPH_C32(0xafea6d85), SPH_C32(0x56c3b9e0),
    SPH_C32(0xb82ea6a7), SPH_C32(0x4949bc4c), SPH_C32(0x4ba90180),
    SPH_C32(0xe1e0c000), SPH_C32(0x42c60000), SPH_C32(0xaa1f0000),
    SPH_C32(0x87f157d1), SPH_C32(0x3a1e8f0a), SPH_C32(0xdd0dee02),
    SPH_C32(0x59f9a55a) },
  { SPH_C32(0x0bf201b0), SPH_C32(0x7bb4c000), SPH_C32(0x00a10000),
    SPH_C32(0xf5ae0000), SPH_C32(0x51313656), SPH_C32(0x679f0936),
    SPH_C32(0x5a9fc1ed), SPH_C32(0x2019e776), SPH_C32(0xbcdc0189),
    SPH_C32(0x2edc0000), SPH_C32(0x81100000), SPH_C32(0xae8d0000),
    SPH_C32(0x85644e78), SPH_C32(0xc2f6b9b0), SPH_C32(0xa78a1f4c),
    SPH_C32(0xc7ef3d40) },
  { SPH_C32(0xfc8701b9), SPH_C32(0xb4880000), SPH_C32(0xc3770000),
    SPH_C32(0xf13c0000), SPH_C32(0x53a42fff), SPH_C32(0x9f773f8c),
    SPH_C32(0x201830a3), SPH_C32(0xbe0f7f6c), SPH_C32(0x68b60189),
    SPH_C32(0xa314c000), SPH_C32(0x24bf0000), SPH_C32(0xe4a40000),
    SPH_C32(0x792a0c02), SPH_C32(0x0b423fdc), SPH_C32(0x3fbc8948),
    SPH_C32(0x30a9fe60) },
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0x187e0279), SPH_C32(0xf5c1c000), SPH_C32(0x9e780000),
    SPH_C32(0x6ddb0000), SPH_C32(0x999a25af), SPH_C32(0xbced8343),
    SPH_C32(0x1c93fb1f), SPH_C32(0x0c59c510), SPH_C32(0x1d010030),
    SPH_C32(0x6aedc000), SPH_C32(0x8a2b0000), SPH_C32(0x6c660000),
    SPH_C32(0xf4271983), SPH_C32(0xa448775b), SPH_C32(0xc8a9ff80),
    SPH_C32(0x692f6c48) },
  { SPH_C32(0x3b610270), SPH_C32(0xb735c000), SPH_C32(0xf8010000),
    SPH_C32(0x23600000), SPH_C32(0x67417e7c), SPH_C32(0x8db13395),
    SPH_C32(0xfe229c55), SPH_C32(0x65099e2a), SPH_C32(0xea740039),
    SPH_C32(0xa5d10000), SPH_C32(0x49fd0000), SPH_C32(0x68f40000),
    SPH_C32(0xf6b2002a), SPH_C32(0x5ca041e1), SPH_C32(0xb22e0ece),
    SPH_C32(0xf739f452) },
  { SPH_C32(0xcc140279), SPH_C32(0x78090000), SPH_C32(0x3bd70000),
    SPH_C32(0x27f20000), SPH_C32(0x65d467d5), SPH_C32(0x7559052f),
    SPH_C32(0x84a56d1b), SPH_C32(0xfb1f0630), SPH_C32(0x3e1e0039),
    SPH_C32(0x2819c000), SPH_C32(0xec520000), SPH_C32(0x22dd0000),
    SPH_C32(0x0afc4250), SPH_C32(0x9514c78d), SPH_C32(0x2a1898ca),
    SPH_C32(0x007f3772) },
  { SPH_C32(0x984f0280), SPH_C32(0xcba70000), SPH_C32(0xa81c0000),
    SPH_C32(0x5d5d0000), SPH_C32(0x1238428a), SPH_C32(0x1e8e59dc),
    SPH_C32(0x6dd7c74f), SPH_C32(0x5d7828c1), SPH_C32(0x3d070060),
    SPH_C32(0x713d0000), SPH_C32(0x3b210000), SPH_C32(0x25500000),
    SPH_C32(0x4afd2541), SPH_C32(0x0b438f2e), SPH_C32(0xcc3b1956),
    SPH_C32(0x145dba1c) },
  { SPH_C32(0x6f3a0289), SPH_C32(0x049bc000), SPH_C32(0x6bca0000),
    SPH_C32(0x59cf0000), SPH_C32(0x10ad5b23), SPH_C32(0xe6666f66),
    SPH_C32(0x17503601), SPH_C32(0xc36eb0db), SPH_C32(0xe96d0060),
    SPH_C32(0xfcf5c000), SPH_C32(0x9e8e0000), SPH_C32(0x6f790000),
    SPH_C32(0xb6b3673b), SPH_C32(0xc2f70942), SPH_C32(0x540d8f52),
    SPH_C32(0xe31b793c) },
  { SPH_C32(0x4c250280), SPH_C32(0x466fc000), SPH_C32(0x0db30000),
    SPH_C32(0x17740000), SPH_C32(0xee7600f0), SPH_C32(0xd73adfb0),
    SPH_C32(0xf5e1514b), SPH_C32(0xaa3eebe1), SPH_C32(0x1e180069),
    SPH_C32(0x33c90000), SPH_C32(0x5d580000), SPH_C32(0x6beb0000),
    SPH_C32(0xb4267e92), SPH_C32(0x3a1f3ff8), SPH_C32(0x2e8a7e1c),
    SPH_C32(0x7d0de126) },
  { SPH_C32(0xbb500289), SPH_C32(0x89530000), SPH_C32(0xce650000),
    SPH_C32(0x13e60000), SPH_C32(0xece31959), SPH_C32(0x2fd2e90a),
    SPH_C32(0x8f66a005), SPH_C32(0x342873fb), SPH_C32(0xca720069),
    SPH_C32(0xbe01c000), SPH_C32(0xf8f70000), SPH_C32(0x21c20000),
    SPH_C32(0x48683ce8), SPH_C32(0xf3abb994), SPH_C32(0xb6bce818),
    SPH_C32(0x8a4b2206) },
  { SPH_C32(0x1b670220), SPH_C32(0xace50000), SPH_C32(0x490b0000),
    SPH_C32(0x6a560000), SPH_C32(0xd99b42be), SPH_C32(0x22bacbe0),
    SPH_C32(0xfab07a83), SPH_C32(0x187b487e), SPH_C32(0x4a430090),
    SPH_C32(0x80670000), SPH_C32(0xce930000), SPH_C32(0x11440000),
    SPH_C32(0xc3ca5bcd), SPH_C32(0x51c8630b), SPH_C32(0xc7f8d448),
    SPH_C32(0xdb6acfd7) },
  { SPH_C32(0xec120229), SPH_C32(0x63d9c000), SPH_C32(0x8add0000),
    SPH_C32(0x6ec40000), SPH_C32(0xdb0e5b17), SPH_C32(0xda52fd5a),
    SPH_C32(0x80378bcd), SPH_C32(0x866dd064), SPH_C32(0x9e290090),
    SPH_C32(0x0dafc000), SPH_C32(0x6b3c0000), SPH_C32(0x5b6d0000),
    SPH_C32(0x3f8419b7), SPH_C32(0x987ce567), SPH_C32(0x5fce424c),
    SPH_C32(0x2c2c0cf7) },
  { SPH_C32(0xcf0d0220), SPH_C32(0x212dc000), SPH_C32(0xeca40000),
    SPH_C32(0x207f0000), SPH_C32(0x25d500c4), SPH_C32(0xeb0e4d8c),
    SPH_C32(0x6286ec87), SPH_C32(0xef3d8b5e), SPH_C32(0x695c0099),
    SPH_C32(0xc2930000), SPH_C32(0xa8ea0000), SPH_C32(0x5fff0000),
    SPH_C32(0x3d11001e), SPH_C32(0x6094d3dd), SPH_C32(0x2549b302),
    SPH_C32(0xb23a94ed) },
  { SPH_C32(0x38780229), SPH_C32(0xee110000), SPH_C32(0x2f720000),
    SPH_C32(0x24ed0000), SPH_C32(0x2740196d), SPH_C32(0x13e67b36),
    SPH_C32(0x18011dc9), SPH_C32(0x712b1344), SPH_C32(0xbd360099),
    SPH_C32(0x4f5bc000), SPH_C32(0x0d450000), SPH_C32(0x15d60000),
    SPH_C32(0xc15f4264), SPH_C32(0xa92055b1), SPH_C32(0xbd7f2506),
    SPH_C32(0x457c57cd) },
  { SPH_C32(0x6c2302d0), SPH_C32(0x5dbf0000), SPH_C32(0xbcb90000),
    SPH_C32(0x5e420000), SPH_C32(0x50ac3c32), SPH_C32(0x783127c5),
    SPH_C32(0xf173b79d), SPH_C32(0xd74c3db5), SPH_C32(0xbe2f00c0),
    SPH_C32(0x167f0000), SPH_C32(0xda360000), SPH_C32(0x125b0000),
    SPH_C32(0x815e2575), SPH_C32(0x37771d12), SPH_C32(0x5b5ca49a),
    SPH_C32(0x515edaa3) },
  { SPH_C32(0x9b5602d9), SPH_C32(0x9283c000), SPH_C32(0x7f6f0000),
    SPH_C32(0x5ad00000), SPH_C32(0x5239259b), SPH_C32(0x80d9117f),
    SPH_C32(0x8bf446d3), SPH_C32(0x495aa5af), SPH_C32(0x6a4500c0),
    SPH_C32(0x9bb7c000), SPH_C32(0x7f990000), SPH_C32(0x58720000),
    SPH_C32(0x7d10670f), SPH_C32(0xfec39b7e), SPH_C32(0xc36a329e),
    SPH_C32(0xa6181983) },
  { SPH_C32(0xb84902d0), SPH_C32(0xd077c000), SPH_C32(0x19160000),
    SPH_C32(0x146b0000), SPH_C32(0xace27e48), SPH_C32(0xb185a1a9),
    SPH_C32(0x69452199), SPH_C32(0x200afe95), SPH_C32(0x9d3000c9),
    SPH_C32(0x548b0000), SPH_C32(0xbc4f0000), SPH_C32(0x5ce00000),
    SPH_C32(0x7f857ea6), SPH_C32(0x062badc4), SPH_C32(0xb9edc3d0),
    SPH_C32(0x380e8199) },
  { SPH_C32(0x4f3c02d9), SPH_C32(0x1f4b0000), SPH_C32(0xdac00000),
    SPH_C32(0x10f90000), SPH_C32(0xae7767e1), SPH_C32(0x496d9713),
    SPH_C32(0x13c2d0d7), SPH_C32(0xbe1c668f), SPH_C32(0x495a00c9),
    SPH_C32(0xd943c000), SPH_C32(0x19e00000), SPH_C32(0x16c90000),
    SPH_C32(0x83cb3cdc), SPH_C32(0xcf9f2ba8), SPH_C32(0x21db55d4),
    SPH_C32(0xcf4842b9) },
  { SPH_C32(0x078c0300), SPH_C32(0xa78f0000), SPH_C32(0x4f750000),
    SPH_C32(0xbd6b0000), SPH_C32(0x69875721), SPH_C32(0xed2450ba),
    SPH_C32(0x28ecbf49), SPH_C32(0xf3c74ebb), SPH_C32(0x7d5c0050),
    SPH_C32(0xeb690000), SPH_C32(0x79460000), SPH_C32(0x7ae10000),
    SPH_C32(0x9c3d44c6), SPH_C32(0x56c20912), SPH_C32(0x4ba936b9),
    SPH_C32(0x6dbdf830) },
  { SPH_C32(0xf0f90309), SPH_C32(0x68b3c000), SPH_C32(0x8ca30000),
    SPH_C32(0xb9f90000), SPH_C32(0x6b124e88), SPH_C32(0x15cc6600),
    SPH_C32(0x526b4e07), SPH_C32(0x6dd1d6a1), SPH_C32(0xa9360050),
    SPH_C32(0x66a1c000), SPH_C32(0xdce90000), SPH_C32(0x30c80000),
    SPH_C32(0x607306bc), SPH_C32(0x9f768f7e), SPH_C32(0xd39fa0bd),
    SPH_C32(0x9afb3b10) },
  { SPH_C32(0xd3e60300), SPH_C32(0x2a47c000), SPH_C32(0xeada0000),
    SPH_C32(0xf7420000), SPH_C32(0x95c9155b), SPH_C32(0x2490d6d6),
    SPH_C32(0xb0da294d), SPH_C32(0x04818d9b), SPH_C32(0x5e430059),
    SPH_C32(0xa99d0000), SPH_C32(0x1f3f0000), SPH_C32(0x345a0000),
    SPH_C32(0x62e61f15), SPH_C32(0x679eb9c4), SPH_C32(0xa91851f3),
    SPH_C32(0x04eda30a) },
  { SPH_C32(0x24930309), SPH_C32(0xe57b0000), SPH_C32(0x290c0000),
    SPH_C32(0xf3d00000), SPH_C32(0x975c0cf2), SPH_C32(0xdc78e06c),
    SPH_C32(0xca5dd803), SPH_C32(0x9a971581), SPH_C32(0x8a290059),
    SPH_C32(0x2455c000), SPH_C32(0xba900000), SPH_C32(0x7e730000),
    SPH_C32(0x9ea85d6f), SPH_C32(0xae2a3fa8), SPH_C32(0x312ec7f7),
    SPH_C32(0xf3ab602a) },
  { SPH_C32(0x70c803f0), SPH_C32(0x56d50000), SPH_C32(0xbac70000),
    SPH_C32(0x897f0000), SPH_C32(0xe0b029ad), SPH_C32(0xb7afbc9f),
    SPH_C32(0x232f7257), SPH_C32(0x3cf03b70), SPH_C32(0x89300000),
    SPH_C32(0x7d710000), SPH_C32(0x6de30000), SPH_C32(0x79fe0000),
    SPH_C32(0xdea93a7e), SPH_C32(0x307d770b), SPH_C32(0xd70d466b),
    SPH_C32(0xe789ed44) },
  { SPH_C32(0x87bd03f9), SPH_C32(0x99e9c000), SPH_C32(0x79110000),
    SPH_C32(0x8ded0000), SPH_C32(0xe2253004), SPH_C32(0x4f478a25),
    SPH_C32(0x59a88319), SPH_C32(0xa2e6a36a), SPH_C32(0x5d5a0000),
    SPH_C32(0xf0b9c000), SPH_C32(0xc84c0000), SPH_C32(0x33d70000),
    SPH_C32(0x22e77804), SPH_C32(0xf9c9f167), SPH_C32(0x4f3bd06f),
    SPH_C32(0x10cf2e64) },
  { SPH_C32(0xa4a203f0), SPH_C32(0xdb1dc000), SPH_C32(0x1f680000),
    SPH_C32(0xc3560000), SPH_C32(0x1cfe6bd7), SPH_C32(0x7e1b3af3),
    SPH_C32(0xbb19e453), SPH_C32(0xcbb6f850), SPH_C32(0xaa2f0009),
    SPH_C32(0x3f850000), SPH_C32(0x0b9a0000), SPH_C32(0x37450000),
    SPH_C32(0x207261ad), SPH_C32(0x0121c7dd), SPH_C32(0x35bc2121),
    SPH_C32(0x8ed9b67e) },
  { SPH_C32(0x53d703f9), SPH_C32(0x14210000), SPH_C32(0xdcbe0000),
    SPH_C32(0xc7c40000), SPH_C32(0x1e6b727e), SPH_C32(0x86f30c49),
    SPH_C32(0xc19e151d), SPH_C32(0x55a0604a), SPH_C32(0x7e450009),
    SPH_C32(0xb24dc000), SPH_C32(0xae350000), SPH_C32(0x7d6c0000),
    SPH_C32(0xdc3c23d7), SPH_C32(0xc89541b1), SPH_C32(0xad8ab725),
    SPH_C32(0x799f755e) },
  { SPH_C32(0xf3e00350), SPH_C32(0x31970000), SPH_C32(0x5bd00000),
    SPH_C32(0xbe740000), SPH_C32(0x2b132999), SPH_C32(0x8b9b2ea3),
    SPH_C32(0xb448cf9b), SPH_C32(0x79f35bcf), SPH_C32(0xfe7400f0),
    SPH_C32(0x8c2b0000), SPH_C32(0x98510000), SPH_C32(0x4dea0000),
    SPH_C32(0x579e44f2), SPH_C32(0x6af69b2e), SPH_C32(0xdcce8b75),
    SPH_C32(0x28be988f) },
  { SPH_C32(0x04950359), SPH_C32(0xfeabc000), SPH_C32(0x98060000),
    SPH_C32(0xbae60000), SPH_C32(0x29863030), SPH_C32(0x73731819),
    SPH_C32(0xcecf3ed5), SPH_C32(0xe7e5c3d5), SPH_C32(0x2a1e00f0),
    SPH_C32(0x01e3c000), SPH_C32(0x3dfe0000), SPH_C32(0x07c30000),
    SPH_C32(0xabd00688), SPH_C32(0xa3421d42), SPH_C32(0x44f81d71),
    SPH_C32(0xdff85baf) },
  { SPH_C32(0x278a0350), SPH_C32(0xbc5fc000), SPH_C32(0xfe7f0000),
    SPH_C32(0xf45d0000), SPH_C32(0xd75d6be3), SPH_C32(0x422fa8cf),
    SPH_C32(0x2c7e599f), SPH_C32(0x8eb598ef), SPH_C32(0xdd6b00f9),
    SPH_C32(0xcedf0000), SPH_C32(0xfe280000), SPH_C32(0x03510000),
    SPH_C32(0xa9451f21), SPH_C32(0x5baa2bf8), SPH_C32(0x3e7fec3f),
    SPH_C32(0x41eec3b5) },
  { SPH_C32(0xd0ff0359), SPH_C32(0x73630000), SPH_C32(0x3da90000),
    SPH_C32(0xf0cf0000), SPH_C32(0xd5c8724a), SPH_C32(0xbac79e75),
    SPH_C32(0x56f9a8d1), SPH_C32(0x10a300f5), SPH_C32(0x090100f9),
    SPH_C32(0x4317c000), SPH_C32(0x5b870000), SPH_C32(0x49780000),
    SPH_C32(0x550b5d5b), SPH_C32(0x921ead94), SPH_C32(0xa6497a3b),
    SPH_C32(0xb6a80095) },
  { SPH_C32(0x84a403a0), SPH_C32(0xc0cd0000), SPH_C32(0xae620000),
    SPH_C32(0x8a600000), SPH_C32(0xa2245715), SPH_C32(0xd110c286),
    SPH_C32(0xbf8b0285), SPH_C32(0xb6c42e04), SPH_C32(0x0a1800a0),
    SPH_C32(0x1a330000), SPH_C32(0x8cf40000), SPH_C32(0x4ef50000),
    SPH_C32(0x150a3a4a), SPH_C32(0x0c49e537), SPH_C32(0x406afba7),
    SPH_C32(0xa28a8dfb) },
  { SPH_C32(0x73d103a9), SPH_C32(0x0ff1c000), SPH_C32(0x6db40000),
    SPH_C32(0x8ef20000), SPH_C32(0xa0b14ebc), SPH_C32(0x29f8f43c),
    SPH_C32(0xc50cf3cb), SPH_C32(0x28d2b61e), SPH_C32(0xde7200a0),
    SPH_C32(0x97fbc000), SPH_C32(0x295b0000), SPH_C32(0x04dc0000),
    SPH_C32(0xe9447830), SPH_C32(0xc5fd635b), SPH_C32(0xd85c6da3),
    SPH_C32(0x55cc4edb) },
  { SPH_C32(0x50ce03a0), SPH_C32(0x4d05c000), SPH_C32(0x0bcd0000),
    SPH_C32(0xc0490000), SPH_C32(0x5e6a156f), SPH_C32(0x18a444ea),
    SPH_C32(0x27bd9481), SPH_C32(0x4182ed24), SPH_C32(0x290700a9),
    SPH_C32(0x58c70000), SPH_C32(0xea8d0000), SPH_C32(0x004e0000),
    SPH_C32(0xebd16199), SPH_C32(0x3d1555e1), SPH_C32(0xa2db9ced),
    SPH_C32(0xcbdad6c1) },
  { SPH_C32(0xa7bb03a9), SPH_C32(0x82390000), SPH_C32(0xc81b0000),
    SPH_C32(0xc4db0000), SPH_C32(0x5cff0cc6), SPH_C32(0xe04c7250),
    SPH_C32(0x5d3a65cf), SPH_C32(0xdf94753e), SPH_C32(0xfd6d00a9),
    SPH_C32(0xd50fc000), SPH_C32(0x4f220000), SPH_C32(0x4a670000),
    SPH_C32(0x179f23e3), SPH_C32(0xf4a1d38d), SPH_C32(0x3aed0ae9),
    SPH_C32(0x3c9c15e1) },
  { SPH_C32(0x5b3c0210), SPH_C32(0x36b10000), SPH_C32(0x0b6c0000),
    SPH_C32(0x35e70000), SPH_C32(0x0f5b2339), SPH_C32(0x7f3b4ddc),
    SPH_C32(0x7d22556c), SPH_C32(0x619b0a52), SPH_C32(0x95db0120),
    SPH_C32(0x761b0000), SPH_C32(0x6b9d0000), SPH_C32(0xaec30000),
    SPH_C32(0x6eb52fe1), SPH_C32(0xffe3ec51), SPH_C32(0x055183a1),
    SPH_C32(0x0c35eb81) },
  { SPH_C32(0xac490219), SPH_C32(0xf98dc000), SPH_C32(0xc8ba0000),
    SPH_C32(0x31750000), SPH_C32(0x0dce3a90), SPH_C32(0x87d37b66),
    SPH_C32(0x07a5a422), SPH_C32(0xff8d9248), SPH_C32(0x41b10120),
    SPH_C32(0xfbd3c000), SPH_C32(0xce320000), SPH_C32(0xe4ea0000),
    SPH_C32(0x92fb6d9b), SPH_C32(0x36576a3d), SPH_C32(0x9d6715a5),
    SPH_C32(0xfb7328a1) },
  { SPH_C32(0x8f560210), SPH_C32(0xbb79c000), SPH_C32(0xaec30000),
    SPH_C32(0x7fce0000), SPH_C32(0xf3156143), SPH_C32(0xb68fcbb0),
    SPH_C32(0xe514c368), SPH_C32(0x96ddc972), SPH_C32(0xb6c40129),
    SPH_C32(0x34ef0000), SPH_C32(0x0de40000), SPH_C32(0xe0780000),
    SPH_C32(0x906e7432), SPH_C32(0xcebf5c87), SPH_C32(0xe7e0e4eb),
    SPH_C32(0x6565b0bb) },
  { SPH_C32(0x78230219), SPH_C32(0x74450000), SPH_C32(0x6d150000),
    SPH_C32(0x7b5c0000), SPH_C32(0xf18078ea), SPH_C32(0x4e67fd0a),
    SPH_C32(0x9f933226), SPH_C32(0x08cb5168), SPH_C32(0x62ae0129),
    SPH_C32(0xb927c000), SPH_C32(0xa84b0000), SPH_C32(0xaa510000),
    SPH_C32(0x6c203648), SPH_C32(0x070bdaeb), SPH_C32(0x7fd672ef),
    SPH_C32(0x9223739b) },
  { SPH_C32(0x2c7802e0), SPH_C32(0xc7eb0000), SPH_C32(0xfede0000),
    SPH_C32(0x01f30000), SPH_C32(0x866c5db5), SPH_C32(0x25b0a1f9),
    SPH_C32(0x76e19872), SPH_C32(0xaeac7f99), SPH_C32(0x61b70170),
    SPH_C32(0xe0030000), SPH_C32(0x7f380000), SPH_C32(0xaddc0000),
    SPH_C32(0x2c215159), SPH_C32(0x995c9248), SPH_C32(0x99f5f373),
    SPH_C32(0x8601fef5) },
  { SPH_C32(0xdb0d02e9), SPH_C32(0x08d7c000), SPH_C32(0x3d080000),
    SPH_C32(0x05610000), SPH_C32(0x84f9441c), SPH_C32(0xdd589743),
    SPH_C32(0x0c66693c), SPH_C32(0x30bae783), SPH_C32(0xb5dd0170),
    SPH_C32(0x6dcbc000), SPH_C32(0xda970000), SPH_C32(0xe7f50000),
    SPH_C32(0xd06f1323), SPH_C32(0x50e81424), SPH_C32(0x01c36577),
    SPH_C32(0x71473dd5) },
  { SPH_C32(0xf81202e0), SPH_C32(0x4a23c000), SPH_C32(0x5b710000),
    SPH_C32(0x4bda0000), SPH_C32(0x7a221fcf), SPH_C32(0xec042795),
    SPH_C32(0xeed70e76), SPH_C32(0x59eabcb9), SPH_C32(0x42a80179),
    SPH_C32(0xa2f70000), SPH_C32(0x19410000), SPH_C32(0xe3670000),
    SPH_C32(0xd2fa0a8a), SPH_C32(0xa800229e), SPH_C32(0x7b449439),
    SPH_C32(0xef51a5cf) },
  { SPH_C32(0x0f6702e9), SPH_C32(0x851f0000), SPH_C32(0x98a70000),
    SPH_C32(0x4f480000), SPH_C32(0x78b70666), SPH_C32(0x14ec112f),
    SPH_C32(0x9450ff38), SPH_C32(0xc7fc24a3), SPH_C32(0x96c20179),
    SPH_C32(0x2f3fc000), SPH_C32(0xbcee0000), SPH_C32(0xa94e0000),
    SPH_C32(0x2eb448f0), SPH_C32(0x61b4a4f2), SPH_C32(0xe372023d),
    SPH_C32(0x181766ef) },
  { SPH_C32(0xaf500240), SPH_C32(0xa0a90000), SPH_C32(0x1fc90000),
    SPH_C32(0x36f80000), SPH_C32(0x4dcf5d81), SPH_C32(0x198433c5),
    SPH_C32(0xe18625be), SPH_C32(0xebaf1f26), SPH_C32(0x16f30180),
    SPH_C32(0x11590000), SPH_C32(0x8a8a0000), SPH_C32(0x99c80000),
    SPH_C32(0xa5162fd5), SPH_C32(0xc3d77e6d), SPH_C32(0x92363e6d),
    SPH_C32(0x49368b3e) },
  { SPH_C32(0x58250249), SPH_C32(0x6f95c000), SPH_C32(0xdc1f0000),
    SPH_C32(0x326a0000), SPH_C32(0x4f5a4428), SPH_C32(0xe16c057f),
    SPH_C32(0x9b01d4f0), SPH_C32(0x75b9873c), SPH_C32(0xc2990180),
    SPH_C32(0x9c91c000), SPH_C32(0x2f250000), SPH_C32(0xd3e10000),
    SPH_C32(0x59586daf), SPH_C32(0x0a63f801), SPH_C32(0x0a00a869),
    SPH_C32(0xbe70481e) },
  { SPH_C32(0x7b3a0240), SPH_C32(0x2d61c000), SPH_C32(0xba660000),
    SPH_C32(0x7cd10000), SPH_C32(0xb1811ffb), SPH_C32(0xd030b5a9),
    SPH_C32(0x79b0b3ba), SPH_C32(0x1ce9dc06), SPH_C32(0x35ec0189),
    SPH_C32(0x53ad0000), SPH_C32(0xecf30000), SPH_C32(0xd7730000),
    SPH_C32(0x5bcd7406), SPH_C32(0xf28bcebb), SPH_C32(0x70875927),
    SPH_C32(0x2066d004) },
  { SPH_C32(0x8c4f0249), SPH_C32(0xe25d0000), SPH_C32(0x79b00000),
    SPH_C32(0x78430000), SPH_C32(0xb3140652), SPH_C32(0x28d88313),
    SPH_C32(0x033742f4), SPH_C32(0x82ff441c), SPH_C32(0xe1860189),
    SPH_C32(0xde65c000), SPH_C32(0x495c0000), SPH_C32(0x9d5a0000),
    SPH_C32(0xa783367c), SPH_C32(0x3b3f48d7), SPH_C32(0xe8b1cf23),
    SPH_C32(0xd7201324) },
  { SPH_C32(0xd81402b0), SPH_C32(0x51f30000), SPH_C32(0xea7b0000),
    SPH_C32(0x02ec0000), SPH_C32(0xc4f8230d), SPH_C32(0x430fdfe0),
    SPH_C32(0xea45e8a0), SPH_C32(0x24986aed), SPH_C32(0xe29f01d0),
    SPH_C32(0x87410000), SPH_C32(0x9e2f0000), SPH_C32(0x9ad70000),
    SPH_C32(0xe782516d), SPH_C32(0xa5680074), SPH_C32(0x0e924ebf),
    SPH_C32(0xc3029e4a) },
  { SPH_C32(0x2f6102b9), SPH_C32(0x9ecfc000), SPH_C32(0x29ad0000),
    SPH_C32(0x067e0000), SPH_C32(0xc66d3aa4), SPH_C32(0xbbe7e95a),
    SPH_C32(0x90c219ee), SPH_C32(0xba8ef2f7), SPH_C32(0x36f501d0),
    SPH_C32(0x0a89c000), SPH_C32(0x3b800000), SPH_C32(0xd0fe0000),
    SPH_C32(0x1bcc1317), SPH_C32(0x6cdc8618), SPH_C32(0x96a4d8bb),
    SPH_C32(0x34445d6a) },
  { SPH_C32(0x0c7e02b0), SPH_C32(0xdc3bc000), SPH_C32(0x4fd40000),
    SPH_C32(0x48c50000), SPH_C32(0x38b66177), SPH_C32(0x8abb598c),
    SPH_C32(0x72737ea4), SPH_C32(0xd3dea9cd), SPH_C32(0xc18001d9),
    SPH_C32(0xc5b50000), SPH_C32(0xf8560000), SPH_C32(0xd46c0000),
    SPH_C32(0x19590abe), SPH_C32(0x9434b0a2), SPH_C32(0xec2329f5),
    SPH_C32(0xaa52c570) },
  { SPH_C32(0xfb0b02b9), SPH_C32(0x13070000), SPH_C32(0x8c020000),
    SPH_C32(0x4c570000), SPH_C32(0x3a2378de), SPH_C32(0x72536f36),
    SPH_C32(0x08f48fea), SPH_C32(0x4dc831d7), SPH_C32(0x15ea01d9),
    SPH_C32(0x487dc000), SPH_C32(0x5df90000), SPH_C32(0x9e450000),
    SPH_C32(0xe51748c4), SPH_C32(0x5d8036ce), SPH_C32(0x7415bff1),
    SPH_C32(0x5d140650) },
  { SPH_C32(0xb3bb0360), SPH_C32(0xabc30000), SPH_C32(0x19b70000),
    SPH_C32(0xe1c50000), SPH_C32(0xfdd3481e), SPH_C32(0xd61aa89f),
    SPH_C32(0x33dae074), SPH_C32(0x001319e3), SPH_C32(0x21ec0140),
    SPH_C32(0x7a570000), SPH_C32(0x3d5f0000), SPH_C32(0xf26d0000),
    SPH_C32(0xfae130de), SPH_C32(0xc4dd1474), SPH_C32(0x1e67dc9c),
    SPH_C32(0xffe1bcd9) },
  { SPH_C32(0x44ce0369), SPH_C32(0x64ffc000), SPH_C32(0xda610000),
    SPH_C32(0xe5570000), SPH_C32(0xff4651b7), SPH_C32(0x2ef29e25),
    SPH_C32(0x495d113a), SPH_C32(0x9e0581f9), SPH_C32(0xf5860140),
    SPH_C32(0xf79fc000), SPH_C32(0x98f00000), SPH_C32(0xb8440000),
    SPH_C32(0x06af72a4), SPH_C32(0x0d699218), SPH_C32(0x86514a98),
    SPH_C32(0x08a77ff9) },
  { SPH_C32(0x67d10360), SPH_C32(0x260bc000), SPH_C32(0xbc180000),
    SPH_C32(0xabec0000), SPH_C32(0x019d0a64), SPH_C32(0x1fae2ef3),
    SPH_C32(0xabec7670), SPH_C32(0xf755dac3), SPH_C32(0x02f30149),
    SPH_C32(0x38a30000), SPH_C32(0x5b260000), SPH_C32(0xbcd60000),
    SPH_C32(0x043a6b0d), SPH_C32(0xf581a4a2), SPH_C32(0xfcd6bbd6),
    SPH_C32(0x96b1e7e3) },
  { SPH_C32(0x90a40369), SPH_C32(0xe9370000), SPH_C32(0x7fce0000),
    SPH_C32(0xaf7e0000), SPH_C32(0x030813cd), SPH_C32(0xe7461849),
    SPH_C32(0xd16b873e), SPH_C32(0x694342d9), SPH_C32(0xd6990149),
    SPH_C32(0xb56bc000), SPH_C32(0xfe890000), SPH_C32(0xf6ff0000),
    SPH_C32(0xf8742977), SPH_C32(0x3c3522ce), SPH_C32(0x64e02dd2),
    SPH_C32(0x61f724c3) },
  { SPH_C32(0xc4ff0390), SPH_C32(0x5a990000), SPH_C32(0xec050000),
    SPH_C32(0xd5d10000), SPH_C32(0x74e43692), SPH_C32(0x8c9144ba),
    SPH_C32(0x38192d6a), SPH_C32(0xcf246c28), SPH_C32(0xd5800110),
    SPH_C32(0xec4f0000), SPH_C32(0x29fa0000), SPH_C32(0xf1720000),
    SPH_C32(0xb8754e66), SPH_C32(0xa2626a6d), SPH_C32(0x82c3ac4e),
    SPH_C32(0x75d5a9ad) },
  { SPH_C32(0x338a0399), SPH_C32(0x95a5c000), SPH_C32(0x2fd30000),
    SPH_C32(0xd1430000), SPH_C32(0x76712f3b), SPH_C32(0x74797200),
    SPH_C32(0x429edc24), SPH_C32(0x5132f432), SPH_C32(0x01ea0110),
    SPH_C32(0x6187c000), SPH_C32(0x8c550000), SPH_C32(0xbb5b0000),
    SPH_C32(0x443b0c1c), SPH_C32(0x6bd6ec01), SPH_C32(0x1af53a4a),
    SPH_C32(0x82936a8d) },
  { SPH_C32(0x10950390), SPH_C32(0xd751c000), SPH_C32(0x49aa0000),
    SPH_C32(0x9ff80000), SPH_C32(0x88aa74e8), SPH_C32(0x4525c2d6),
    SPH_C32(0xa02fbb6e), SPH_C32(0x3862af08), SPH_C32(0xf69f0119),
    SPH_C32(0xaebb0000), SPH_C32(0x4f830000), SPH_C32(0xbfc90000),
    SPH_C32(0x46ae15b5), SPH_C32(0x933edabb), SPH_C32(0x6072cb04),
    SPH_C32(0x1c85f297) },
  { SPH_C32(0xe7e00399), SPH_C32(0x186d0000), SPH_C32(0x8a7c0000),
    SPH_C32(0x9b6a0000), SPH_C32(0x8a3f6d41), SPH_C32(0xbdcdf46c),
    SPH_C32(0xdaa84a20), SPH_C32(0xa6743712), SPH_C32(0x22f50119),
    SPH_C32(0x2373c000), SPH_C32(0xea2c0000), SPH_C32(0xf5e00000),
    SPH_C32(0xbae057cf), SPH_C32(0x5a8a5cd7), SPH_C32(0xf8445d00),
    SPH_C32(0xebc331b7) },
  { SPH_C32(0x47d70330), SPH_C32(0x3ddb0000), SPH_C32(0x0d120000),
    SPH_C32(0xe2da0000), SPH_C32(0xbf4736a6), SPH_C32(0xb0a5d686),
    SPH_C32(0xaf7e90a6), SPH_C32(0x8a270c97), SPH_C32(0xa2c401e0),
    SPH_C32(0x1d150000), SPH_C32(0xdc480000), SPH_C32(0xc5660000),
    SPH_C32(0x314230ea), SPH_C32(0xf8e98648), SPH_C32(0x89006150),
    SPH_C32(0xbae2dc66) },
  { SPH_C32(0xb0a20339), SPH_C32(0xf2e7c000), SPH_C32(0xcec40000),
    SPH_C32(0xe6480000), SPH_C32(0xbdd22f0f), SPH_C32(0x484de03c),
    SPH_C32(0xd5f961e8), SPH_C32(0x1431948d), SPH_C32(0x76ae01e0),
    SPH_C32(0x90ddc000), SPH_C32(0x79e70000), SPH_C32(0x8f4f0000),
    SPH_C32(0xcd0c7290), SPH_C32(0x315d0024), SPH_C32(0x1136f754),
    SPH_C32(0x4da41f46) },
  { SPH_C32(0x93bd0330), SPH_C32(0xb013c000), SPH_C32(0xa8bd0000),
    SPH_C32(0xa8f30000), SPH_C32(0x430974dc), SPH_C32(0x791150ea),
    SPH_C32(0x374806a2), SPH_C32(0x7d61cfb7), SPH_C32(0x81db01e9),
    SPH_C32(0x5fe10000), SPH_C32(0xba310000), SPH_C32(0x8bdd0000),
    SPH_C32(0xcf996b39), SPH_C32(0xc9b5369e), SPH_C32(0x6bb1061a),
    SPH_C32(0xd3b2875c) },
  { SPH_C32(0x64c80339), SPH_C32(0x7f2f0000), SPH_C32(0x6b6b0000),
    SPH_C32(0xac610000), SPH_C32(0x419c6d75), SPH_C32(0x81f96650),
    SPH_C32(0x4dcff7ec), SPH_C32(0xe37757ad), SPH_C32(0x55b101e9),
    SPH_C32(0xd229c000), SPH_C32(0x1f9e0000), SPH_C32(0xc1f40000),
    SPH_C32(0x33d72943), SPH_C32(0x0001b0f2), SPH_C32(0xf387901e),
    SPH_C32(0x24f4447c) },
  { SPH_C32(0x309303c0), SPH_C32(0xcc810000), SPH_C32(0xf8a00000),
    SPH_C32(0xd6ce0000), SPH_C32(0x3670482a), SPH_C32(0xea2e3aa3),
    SPH_C32(0xa4bd5db8), SPH_C32(0x4510795c), SPH_C32(0x56a801b0),
    SPH_C32(0x8b0d0000), SPH_C32(0xc8ed0000), SPH_C32(0xc6790000),
    SPH_C32(0x73d64e52), SPH_C32(0x9e56f851), SPH_C32(0x15a41182),
    SPH_C32(0x30d6c912) },
  { SPH_C32(0xc7e603c9), SPH_C32(0x03bdc000), SPH_C32(0x3b760000),
    SPH_C32(0xd25c0000), SPH_C32(0x34e55183), SPH_C32(0x12c60c19),
    SPH_C32(0xde3aacf6), SPH_C32(0xdb06e146), SPH_C32(0x82c201b0),
    SPH_C32(0x06c5c000), SPH_C32(0x6d420000), SPH_C32(0x8c500000),
    SPH_C32(0x8f980c28), SPH_C32(0x57e27e3d), SPH_C32(0x8d928786),
    SPH_C32(0xc7900a32) },
  { SPH_C32(0xe4f903c0), SPH_C32(0x4149c000), SPH_C32(0x5d0f0000),
    SPH_C32(0x9ce70000), SPH_C32(0xca3e0a50), SPH_C32(0x239abccf),
    SPH_C32(0x3c8bcbbc), SPH_C32(0xb256ba7c), SPH_C32(0x75b701b9),
    SPH_C32(0xc9f90000), SPH_C32(0xae940000), SPH_C32(0x88c20000),
    SPH_C32(0x8d0d1581), SPH_C32(0xaf0a4887), SPH_C32(0xf71576c8),
    SPH_C32(0x59869228) },
  { SPH_C32(0x138c03c9), SPH_C32(0x8e750000), SPH_C32(0x9ed90000),
    SPH_C32(0x98750000), SPH_C32(0xc8ab13f9), SPH_C32(0xdb728a75),
    SPH_C32(0x460c3af2), SPH_C32(0x2c402266), SPH_C32(0xa1dd01b9),
    SPH_C32(0x4431c000), SPH_C32(0x0b3b0000), SPH_C32(0xc2eb0000),
    SPH_C32(0x714357fb), SPH_C32(0x66beceeb), SPH_C32(0x6f23e0cc),
    SPH_C32(0xaec05108) }
};

__constant static const sph_u32 T512_14[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0xcd990000), SPH_C32(0xd4fa2100), SPH_C32(0xa33e0000),
    SPH_C32(0x65440000), SPH_C32(0xd9f9364c), SPH_C32(0xe786faeb),
    SPH_C32(0x7143d295), SPH_C32(0x6b1e8d40), SPH_C32(0x2c430000),
    SPH_C32(0xa8781200), SPH_C32(0x501c0000), SPH_C32(0x386d0000),
    SPH_C32(0x3f4f30a7), SPH_C32(0x422b9861), SPH_C32(0xc4dbabb1),
    SPH_C32(0x9f8d23ca) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0x695b0000), SPH_C32(0x0dcd0500), SPH_C32(0xa9760000),
    SPH_C32(0x03250000), SPH_C32(0x2183248b), SPH_C32(0x61380db7),
    SPH_C32(0xd2670d01), SPH_C32(0x40bed715), SPH_C32(0x59e70000),
    SPH_C32(0x6af33500), SPH_C32(0xc4b80000), SPH_C32(0xa8980000),
    SPH_C32(0xc4376747), SPH_C32(0x0be593cf), SPH_C32(0xd3bc6f32),
    SPH_C32(0x315245b4) },
  { SPH_C32(0xa4c20000), SPH_C32(0xd9372400), SPH_C32(0x0a480000),
    SPH_C32(0x66610000), SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c),
    SPH_C32(0xa324df94), SPH_C32(0x2ba05a55), SPH_C32(0x75a40000),
    SPH_C32(0xc28b2700), SPH_C32(0x94a40000), SPH_C32(0x90f50000),
    SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae), SPH_C32(0x1767c483),
    SPH_C32(0xaedf667e) },
  { SPH_C32(0x1cff0000), SPH_C32(0xcf462200), SPH_C32(0x3dd20000),
    SPH_C32(0x93d00000), SPH_C32(0xdafb736b), SPH_C32(0x28f60619),
    SPH_C32(0xc500c982), SPH_C32(0xee61b16b), SPH_C32(0x88810000),
    SPH_C32(0x714f3600), SPH_C32(0x5a540000), SPH_C32(0x5e0c0000),
    SPH_C32(0xc7352260), SPH_C32(0xc4956f3d), SPH_C32(0x67ff7425),
    SPH_C32(0xb42d799f) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0xcdf40003), SPH_C32(0x1861c600), SPH_C32(0xe6ba0000),
    SPH_C32(0x4f5b0000), SPH_C32(0xa9454e92), SPH_C32(0x29104612),
    SPH_C32(0xdd0c600b), SPH_C32(0xc576c515), SPH_C32(0x13ea0001),
    SPH_C32(0xdc925100), SPH_C32(0x3dce0000), SPH_C32(0x69670000),
    SPH_C32(0x81f80799), SPH_C32(0x3a4a8f56), SPH_C32(0x3aa3f01c),
    SPH_C32(0xe459edb5) },
  { SPH_C32(0x006d0003), SPH_C32(0xcc9be700), SPH_C32(0x45840000),
    SPH_C32(0x2a1f0000), SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9),
    SPH_C32(0xac4fb29e), SPH_C32(0xae684855), SPH_C32(0x3fa90001),
    SPH_C32(0x74ea4300), SPH_C32(0x6dd20000), SPH_C32(0x510a0000),
    SPH_C32(0xbeb7373e), SPH_C32(0x78611737), SPH_C32(0xfe785bad),
    SPH_C32(0x7bd4ce7f) },
  { SPH_C32(0xb8500003), SPH_C32(0xdaeae100), SPH_C32(0x721e0000),
    SPH_C32(0xdfae0000), SPH_C32(0x523d1972), SPH_C32(0x60de4dbc),
    SPH_C32(0xca6ba488), SPH_C32(0x6ba9a36b), SPH_C32(0xc28c0001),
    SPH_C32(0xc72e5200), SPH_C32(0xa3220000), SPH_C32(0x9ff30000),
    SPH_C32(0x82fa42be), SPH_C32(0xf53a73a4), SPH_C32(0x8ee0eb0b),
    SPH_C32(0x6126d19e) },
  { SPH_C32(0xa4af0003), SPH_C32(0x15acc300), SPH_C32(0x4fcc0000),
    SPH_C32(0x4c7e0000), SPH_C32(0x88c66a19), SPH_C32(0x48284ba5),
    SPH_C32(0x0f6b6d0a), SPH_C32(0x85c81200), SPH_C32(0x4a0d0001),
    SPH_C32(0xb6616400), SPH_C32(0xf9760000), SPH_C32(0xc1ff0000),
    SPH_C32(0x45cf60de), SPH_C32(0x31af1c99), SPH_C32(0xe91f9f2e),
    SPH_C32(0xd50ba801) },
  { SPH_C32(0x1c920003), SPH_C32(0x03ddc500), SPH_C32(0x78560000),
    SPH_C32(0xb9cf0000), SPH_C32(0xaa470bb5), SPH_C32(0xe660bae0),
    SPH_C32(0x694f7b1c), SPH_C32(0x4009f93e), SPH_C32(0xb7280001),
    SPH_C32(0x05a57500), SPH_C32(0x37860000), SPH_C32(0x0f060000),
    SPH_C32(0x7982155e), SPH_C32(0xbcf4780a), SPH_C32(0x99872f88),
    SPH_C32(0xcff9b7e0) },
  { SPH_C32(0xd10b0003), SPH_C32(0xd727e400), SPH_C32(0xdb680000),
    SPH_C32(0xdc8b0000), SPH_C32(0x73be3df9), SPH_C32(0x01e6400b),
    SPH_C32(0x180ca989), SPH_C32(0x2b17747e), SPH_C32(0x9b6b0001),
    SPH_C32(0xaddd6700), SPH_C32(0x679a0000), SPH_C32(0x376b0000),
    SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b), SPH_C32(0x5d5c8439),
    SPH_C32(0x5074942a) },
  { SPH_C32(0x69360003), SPH_C32(0xc156e200), SPH_C32(0xecf20000),
    SPH_C32(0x293a0000), SPH_C32(0x513f5c55), SPH_C32(0xafaeb14e),
    SPH_C32(0x7e28bf9f), SPH_C32(0xeed69f40), SPH_C32(0x664e0001),
    SPH_C32(0x1e197600), SPH_C32(0xa96a0000), SPH_C32(0xf9920000),
    SPH_C32(0x7a805079), SPH_C32(0x738484f8), SPH_C32(0x2dc4349f),
    SPH_C32(0x4a868bcb) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0x56f20001), SPH_C32(0x79274600), SPH_C32(0xc4a40000),
    SPH_C32(0x522f0000), SPH_C32(0x9f3413b5), SPH_C32(0x19591a80),
    SPH_C32(0x2c1f56ac), SPH_C32(0x3b6a196a), SPH_C32(0x66230002),
    SPH_C32(0xd2829100), SPH_C32(0xecee0000), SPH_C32(0xd38d0000),
    SPH_C32(0x0a3c28a7), SPH_C32(0xbd123801), SPH_C32(0x818b8601),
    SPH_C32(0xe4eec39e) },
  { SPH_C32(0x9b6b0001), SPH_C32(0xaddd6700), SPH_C32(0x679a0000),
    SPH_C32(0x376b0000), SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b),
    SPH_C32(0x5d5c8439), SPH_C32(0x5074942a), SPH_C32(0x4a600002),
    SPH_C32(0x7afa8300), SPH_C32(0xbcf20000), SPH_C32(0xebe00000),
    SPH_C32(0x35731800), SPH_C32(0xff39a060), SPH_C32(0x45502db0),
    SPH_C32(0x7b63e054) },
  { SPH_C32(0x23560001), SPH_C32(0xbbac6100), SPH_C32(0x50000000),
    SPH_C32(0xc2da0000), SPH_C32(0x644c4455), SPH_C32(0x5097112e),
    SPH_C32(0x3b78922f), SPH_C32(0x95b57f14), SPH_C32(0xb7450002),
    SPH_C32(0xc93e9200), SPH_C32(0x72020000), SPH_C32(0x25190000),
    SPH_C32(0x093e6d80), SPH_C32(0x7262c4f3), SPH_C32(0x35c89d16),
    SPH_C32(0x6191ffb5) },
  { SPH_C32(0x3fa90001), SPH_C32(0x74ea4300), SPH_C32(0x6dd20000),
    SPH_C32(0x510a0000), SPH_C32(0xbeb7373e), SPH_C32(0x78611737),
    SPH_C32(0xfe785bad), SPH_C32(0x7bd4ce7f), SPH_C32(0x3fc40002),
    SPH_C32(0xb871a400), SPH_C32(0x28560000), SPH_C32(0x7b150000),
    SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce), SPH_C32(0x5237e933),
    SPH_C32(0xd5bc862a) },
  { SPH_C32(0x87940001), SPH_C32(0x629b4500), SPH_C32(0x5a480000),
    SPH_C32(0xa4bb0000), SPH_C32(0x9c365692), SPH_C32(0xd629e672),
    SPH_C32(0x985c4dbb), SPH_C32(0xbe152541), SPH_C32(0xc2e10002),
    SPH_C32(0x0bb5b500), SPH_C32(0xe6a60000), SPH_C32(0xb5ec0000),
    SPH_C32(0xf2463a60), SPH_C32(0x3baccf5d), SPH_C32(0x22af5995),
    SPH_C32(0xcf4e99cb) },
  { SPH_C32(0x4a0d0001), SPH_C32(0xb6616400), SPH_C32(0xf9760000),
    SPH_C32(0xc1ff0000), SPH_C32(0x45cf60de), SPH_C32(0x31af1c99),
    SPH_C32(0xe91f9f2e), SPH_C32(0xd50ba801), SPH_C32(0xeea20002),
    SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000), SPH_C32(0x8d810000),
    SPH_C32(0xcd090ac7), SPH_C32(0x7987573c), SPH_C32(0xe674f224),
    SPH_C32(0x50c3ba01) },
  { SPH_C32(0xf2300001), SPH_C32(0xa0106200), SPH_C32(0xceec0000),
    SPH_C32(0x344e0000), SPH_C32(0x674e0172), SPH_C32(0x9fe7eddc),
    SPH_C32(0x8f3b8938), SPH_C32(0x10ca433f), SPH_C32(0x13870002),
    SPH_C32(0x1009b600), SPH_C32(0x784a0000), SPH_C32(0x43780000),
    SPH_C32(0xf1447f47), SPH_C32(0xf4dc33af), SPH_C32(0x96ec4282),
    SPH_C32(0x4a31a5e0) },
  { SPH_C32(0x9b060002), SPH_C32(0x61468000), SPH_C32(0x221e0000),
    SPH_C32(0x1d740000), SPH_C32(0x36715d27), SPH_C32(0x30495c92),
    SPH_C32(0xf11336a7), SPH_C32(0xfe1cdc7f), SPH_C32(0x75c90003),
    SPH_C32(0x0e10c000), SPH_C32(0xd1200000), SPH_C32(0xbaea0000),
    SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757), SPH_C32(0xbb28761d),
    SPH_C32(0x00b72e2b) },
  { SPH_C32(0x233b0002), SPH_C32(0x77378600), SPH_C32(0x15840000),
    SPH_C32(0xe8c50000), SPH_C32(0x14f03c8b), SPH_C32(0x9e01add7),
    SPH_C32(0x973720b1), SPH_C32(0x3bdd3741), SPH_C32(0x88ec0003),
    SPH_C32(0xbdd4d100), SPH_C32(0x1fd00000), SPH_C32(0x74130000),
    SPH_C32(0xb7895abe), SPH_C32(0x0a03d3c4), SPH_C32(0xcbb0c6bb),
    SPH_C32(0x1a4531ca) },
  { SPH_C32(0xeea20002), SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000),
    SPH_C32(0x8d810000), SPH_C32(0xcd090ac7), SPH_C32(0x7987573c),
    SPH_C32(0xe674f224), SPH_C32(0x50c3ba01), SPH_C32(0xa4af0003),
    SPH_C32(0x15acc300), SPH_C32(0x4fcc0000), SPH_C32(0x4c7e0000),
    SPH_C32(0x88c66a19), SPH_C32(0x48284ba5), SPH_C32(0x0f6b6d0a),
    SPH_C32(0x85c81200) },
  { SPH_C32(0x569f0002), SPH_C32(0xb5bca100), SPH_C32(0x81200000),
    SPH_C32(0x78300000), SPH_C32(0xef886b6b), SPH_C32(0xd7cfa679),
    SPH_C32(0x8050e432), SPH_C32(0x9502513f), SPH_C32(0x598a0003),
    SPH_C32(0xa668d200), SPH_C32(0x813c0000), SPH_C32(0x82870000),
    SPH_C32(0xb48b1f99), SPH_C32(0xc5732f36), SPH_C32(0x7ff3ddac),
    SPH_C32(0x9f3a0de1) },
  { SPH_C32(0x4a600002), SPH_C32(0x7afa8300), SPH_C32(0xbcf20000),
    SPH_C32(0xebe00000), SPH_C32(0x35731800), SPH_C32(0xff39a060),
    SPH_C32(0x45502db0), SPH_C32(0x7b63e054), SPH_C32(0xd10b0003),
    SPH_C32(0xd727e400), SPH_C32(0xdb680000), SPH_C32(0xdc8b0000),
    SPH_C32(0x73be3df9), SPH_C32(0x01e6400b), SPH_C32(0x180ca989),
    SPH_C32(0x2b17747e) },
  { SPH_C32(0xf25d0002), SPH_C32(0x6c8b8500), SPH_C32(0x8b680000),
    SPH_C32(0x1e510000), SPH_C32(0x17f279ac), SPH_C32(0x51715125),
    SPH_C32(0x23743ba6), SPH_C32(0xbea20b6a), SPH_C32(0x2c2e0003),
    SPH_C32(0x64e3f500), SPH_C32(0x15980000), SPH_C32(0x12720000),
    SPH_C32(0x4ff34879), SPH_C32(0x8cbd2498), SPH_C32(0x6894192f),
    SPH_C32(0x31e56b9f) },
  { SPH_C32(0x3fc40002), SPH_C32(0xb871a400), SPH_C32(0x28560000),
    SPH_C32(0x7b150000), SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce),
    SPH_C32(0x5237e933), SPH_C32(0xd5bc862a), SPH_C32(0x006d0003),
    SPH_C32(0xcc9be700), SPH_C32(0x45840000), SPH_C32(0x2a1f0000),
    SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9), SPH_C32(0xac4fb29e),
    SPH_C32(0xae684855) },
  { SPH_C32(0x87f90002), SPH_C32(0xae00a200), SPH_C32(0x1fcc0000),
    SPH_C32(0x8ea40000), SPH_C32(0xec8a2e4c), SPH_C32(0x18bf5a8b),
    SPH_C32(0x3413ff25), SPH_C32(0x107d6d14), SPH_C32(0xfd480003),
    SPH_C32(0x7f5ff600), SPH_C32(0x8b740000), SPH_C32(0xe4e60000),
    SPH_C32(0x4cf10d5e), SPH_C32(0x43cdd86a), SPH_C32(0xdcd70238),
    SPH_C32(0xb49a57b4) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0x4ebd0005), SPH_C32(0x2232c600), SPH_C32(0x139d0000),
    SPH_C32(0x7a8c0000), SPH_C32(0x03b65a57), SPH_C32(0xa4f024eb),
    SPH_C32(0xabe19d0f), SPH_C32(0x1254510f), SPH_C32(0x5b5a0001),
    SPH_C32(0xc2f39100), SPH_C32(0xd70c0000), SPH_C32(0x58220000),
    SPH_C32(0x06c6187d), SPH_C32(0x6691ca60), SPH_C32(0x5cf5f729),
    SPH_C32(0xb67c7369) },
  { SPH_C32(0x83240005), SPH_C32(0xf6c8e700), SPH_C32(0xb0a30000),
    SPH_C32(0x1fc80000), SPH_C32(0xda4f6c1b), SPH_C32(0x4376de00),
    SPH_C32(0xdaa24f9a), SPH_C32(0x794adc4f), SPH_C32(0x77190001),
    SPH_C32(0x6a8b8300), SPH_C32(0x87100000), SPH_C32(0x604f0000),
    SPH_C32(0x398928da), SPH_C32(0x24ba5201), SPH_C32(0x982e5c98),
    SPH_C32(0x29f150a3) },
  { SPH_C32(0x3b190005), SPH_C32(0xe0b9e100), SPH_C32(0x87390000),
    SPH_C32(0xea790000), SPH_C32(0xf8ce0db7), SPH_C32(0xed3e2f45),
    SPH_C32(0xbc86598c), SPH_C32(0xbc8b3771), SPH_C32(0x8a3c0001),
    SPH_C32(0xd94f9200), SPH_C32(0x49e00000), SPH_C32(0xaeb60000),
    SPH_C32(0x05c45d5a), SPH_C32(0xa9e13692), SPH_C32(0xe8b6ec3e),
    SPH_C32(0x33034f42) },
  { SPH_C32(0x27e60005), SPH_C32(0x2fffc300), SPH_C32(0xbaeb0000),
    SPH_C32(0x79a90000), SPH_C32(0x22357edc), SPH_C32(0xc5c8295c),
    SPH_C32(0x7986900e), SPH_C32(0x52ea861a), SPH_C32(0x02bd0001),
    SPH_C32(0xa800a400), SPH_C32(0x13b40000), SPH_C32(0xf0ba0000),
    SPH_C32(0xc2f17f3a), SPH_C32(0x6d7459af), SPH_C32(0x8f49981b),
    SPH_C32(0x872e36dd) },
  { SPH_C32(0x9fdb0005), SPH_C32(0x398ec500), SPH_C32(0x8d710000),
    SPH_C32(0x8c180000), SPH_C32(0x00b41f70), SPH_C32(0x6b80d819),
    SPH_C32(0x1fa28618), SPH_C32(0x972b6d24), SPH_C32(0xff980001),
    SPH_C32(0x1bc4b500), SPH_C32(0xdd440000), SPH_C32(0x3e430000),
    SPH_C32(0xfebc0aba), SPH_C32(0xe02f3d3c), SPH_C32(0xffd128bd),
    SPH_C32(0x9ddc293c) },
  { SPH_C32(0x52420005), SPH_C32(0xed74e400), SPH_C32(0x2e4f0000),
    SPH_C32(0xe95c0000), SPH_C32(0xd94d293c), SPH_C32(0x8c0622f2),
    SPH_C32(0x6ee1548d), SPH_C32(0xfc35e064), SPH_C32(0xd3db0001),
    SPH_C32(0xb3bca700), SPH_C32(0x8d580000), SPH_C32(0x062e0000),
    SPH_C32(0xc1f33a1d), SPH_C32(0xa204a55d), SPH_C32(0x3b0a830c),
    SPH_C32(0x02510af6) },
  { SPH_C32(0xea7f0005), SPH_C32(0xfb05e200), SPH_C32(0x19d50000),
    SPH_C32(0x1ced0000), SPH_C32(0xfbcc4890), SPH_C32(0x224ed3b7),
    SPH_C32(0x08c5429b), SPH_C32(0x39f40b5a), SPH_C32(0x2efe0001),
    SPH_C32(0x0078b600), SPH_C32(0x43a80000), SPH_C32(0xc8d70000),
    SPH_C32(0xfdbe4f9d), SPH_C32(0x2f5fc1ce), SPH_C32(0x4b9233aa),
    SPH_C32(0x18a31517) },
  { SPH_C32(0x83490006), SPH_C32(0x3a530000), SPH_C32(0xf5270000),
    SPH_C32(0x35d70000), SPH_C32(0xaaf314c5), SPH_C32(0x8de062f9),
    SPH_C32(0x76edfd04), SPH_C32(0xd722941a), SPH_C32(0x48b00000),
    SPH_C32(0x1e61c000), SPH_C32(0xeac20000), SPH_C32(0x31450000),
    SPH_C32(0x873e1fe4), SPH_C32(0x5cdb4536), SPH_C32(0x66560735),
    SPH_C32(0x52259edc) },
  { SPH_C32(0x3b740006), SPH_C32(0x2c220600), SPH_C32(0xc2bd0000),
    SPH_C32(0xc0660000), SPH_C32(0x88727569), SPH_C32(0x23a893bc),
    SPH_C32(0x10c9eb12), SPH_C32(0x12e37f24), SPH_C32(0xb5950000),
    SPH_C32(0xada5d100), SPH_C32(0x24320000), SPH_C32(0xffbc0000),
    SPH_C32(0xbb736a64), SPH_C32(0xd18021a5), SPH_C32(0x16ceb793),
    SPH_C32(0x48d7813d) },
  { SPH_C32(0xf6ed0006), SPH_C32(0xf8d82700), SPH_C32(0x61830000),
    SPH_C32(0xa5220000), SPH_C32(0x518b4325), SPH_C32(0xc42e6957),
    SPH_C32(0x618a3987), SPH_C32(0x79fdf264), SPH_C32(0x99d60000),
    SPH_C32(0x05ddc300), SPH_C32(0x742e0000), SPH_C32(0xc7d10000),
    SPH_C32(0x843c5ac3), SPH_C32(0x93abb9c4), SPH_C32(0xd2151c22),
    SPH_C32(0xd75aa2f7) },
  { SPH_C32(0x4ed00006), SPH_C32(0xeea92100), SPH_C32(0x56190000),
    SPH_C32(0x50930000), SPH_C32(0x730a2289), SPH_C32(0x6a669812),
    SPH_C32(0x07ae2f91), SPH_C32(0xbc3c195a), SPH_C32(0x64f30000),
    SPH_C32(0xb619d200), SPH_C32(0xbade0000), SPH_C32(0x09280000),
    SPH_C32(0xb8712f43), SPH_C32(0x1ef0dd57), SPH_C32(0xa28dac84),
    SPH_C32(0xcda8bd16) },
  { SPH_C32(0x522f0006), SPH_C32(0x21ef0300), SPH_C32(0x6bcb0000),
    SPH_C32(0xc3430000), SPH_C32(0xa9f151e2), SPH_C32(0x42909e0b),
    SPH_C32(0xc2aee613), SPH_C32(0x525da831), SPH_C32(0xec720000),
    SPH_C32(0xc756e400), SPH_C32(0xe08a0000), SPH_C32(0x57240000),
    SPH_C32(0x7f440d23), SPH_C32(0xda65b26a), SPH_C32(0xc572d8a1),
    SPH_C32(0x7985c489) },
  { SPH_C32(0xea120006), SPH_C32(0x379e0500), SPH_C32(0x5c510000),
    SPH_C32(0x36f20000), SPH_C32(0x8b70304e), SPH_C32(0xecd86f4e),
    SPH_C32(0xa48af005), SPH_C32(0x979c430f), SPH_C32(0x11570000),
    SPH_C32(0x7492f500), SPH_C32(0x2e7a0000), SPH_C32(0x99dd0000),
    SPH_C32(0x430978a3), SPH_C32(0x573ed6f9), SPH_C32(0xb5ea6807),
    SPH_C32(0x6377db68) },
  { SPH_C32(0x278b0006), SPH_C32(0xe3642400), SPH_C32(0xff6f0000),
    SPH_C32(0x53b60000), SPH_C32(0x52890602), SPH_C32(0x0b5e95a5),
    SPH_C32(0xd5c92290), SPH_C32(0xfc82ce4f), SPH_C32(0x3d140000),
    SPH_C32(0xdceae700), SPH_C32(0x7e660000), SPH_C32(0xa1b00000),
    SPH_C32(0x7c464804), SPH_C32(0x15154e98), SPH_C32(0x7131c3b6),
    SPH_C32(0xfcfaf8a2) },
  { SPH_C32(0x9fb60006), SPH_C32(0xf5152200), SPH_C32(0xc8f50000),
    SPH_C32(0xa6070000), SPH_C32(0x700867ae), SPH_C32(0xa51664e0),
    SPH_C32(0xb3ed3486), SPH_C32(0x39432571), SPH_C32(0xc0310000),
    SPH_C32(0x6f2ef600), SPH_C32(0xb0960000), SPH_C32(0x6f490000),
    SPH_C32(0x400b3d84), SPH_C32(0x984e2a0b), SPH_C32(0x01a97310),
    SPH_C32(0xe608e743) },
  { SPH_C32(0x184f0004), SPH_C32(0x5b158000), SPH_C32(0xd7390000),
    SPH_C32(0x28a30000), SPH_C32(0x9c8249e2), SPH_C32(0xbda93e6b),
    SPH_C32(0x87fecba3), SPH_C32(0x293e4865), SPH_C32(0x3d790003),
    SPH_C32(0x10710000), SPH_C32(0x3be20000), SPH_C32(0x8baf0000),
    SPH_C32(0x0cfa30da), SPH_C32(0xdb83f261), SPH_C32(0xdd7e7128),
    SPH_C32(0x5292b0f7) },
  { SPH_C32(0xa0720004), SPH_C32(0x4d648600), SPH_C32(0xe0a30000),
    SPH_C32(0xdd120000), SPH_C32(0xbe03284e), SPH_C32(0x13e1cf2e),
    SPH_C32(0xe1daddb5), SPH_C32(0xecffa35b), SPH_C32(0xc05c0003),
    SPH_C32(0xa3b51100), SPH_C32(0xf5120000), SPH_C32(0x45560000),
    SPH_C32(0x30b7455a), SPH_C32(0x56d896f2), SPH_C32(0xade6c18e),
    SPH_C32(0x4860af16) },
  { SPH_C32(0x6deb0004), SPH_C32(0x999ea700), SPH_C32(0x439d0000),
    SPH_C32(0xb8560000), SPH_C32(0x67fa1e02), SPH_C32(0xf46735c5),
    SPH_C32(0x90990f20), SPH_C32(0x87e12e1b), SPH_C32(0xec1f0003),
    SPH_C32(0x0bcd0300), SPH_C32(0xa50e0000), SPH_C32(0x7d3b0000),
    SPH_C32(0x0ff875fd), SPH_C32(0x14f30e93), SPH_C32(0x693d6a3f),
    SPH_C32(0xd7ed8cdc) },
  { SPH_C32(0xd5d60004), SPH_C32(0x8fefa100), SPH_C32(0x74070000),
    SPH_C32(0x4de70000), SPH_C32(0x457b7fae), SPH_C32(0x5a2fc480),
    SPH_C32(0xf6bd1936), SPH_C32(0x4220c525), SPH_C32(0x113a0003),
    SPH_C32(0xb8091200), SPH_C32(0x6bfe0000), SPH_C32(0xb3c20000),
    SPH_C32(0x33b5007d), SPH_C32(0x99a86a00), SPH_C32(0x19a5da99),
    SPH_C32(0xcd1f933d) },
  { SPH_C32(0xc9290004), SPH_C32(0x40a98300), SPH_C32(0x49d50000),
    SPH_C32(0xde370000), SPH_C32(0x9f800cc5), SPH_C32(0x72d9c299),
    SPH_C32(0x33bdd0b4), SPH_C32(0xac41744e), SPH_C32(0x99bb0003),
    SPH_C32(0xc9462400), SPH_C32(0x31aa0000), SPH_C32(0xedce0000),
    SPH_C32(0xf480221d), SPH_C32(0x5d3d053d), SPH_C32(0x7e5aaebc),
    SPH_C32(0x7932eaa2) },
  { SPH_C32(0x71140004), SPH_C32(0x56d88500), SPH_C32(0x7e4f0000),
    SPH_C32(0x2b860000), SPH_C32(0xbd016d69), SPH_C32(0xdc9133dc),
    SPH_C32(0x5599c6a2), SPH_C32(0x69809f70), SPH_C32(0x649e0003),
    SPH_C32(0x7a823500), SPH_C32(0xff5a0000), SPH_C32(0x23370000),
    SPH_C32(0xc8cd579d), SPH_C32(0xd06661ae), SPH_C32(0x0ec21e1a),
    SPH_C32(0x63c0f543) },
  { SPH_C32(0xbc8d0004), SPH_C32(0x8222a400), SPH_C32(0xdd710000),
    SPH_C32(0x4ec20000), SPH_C32(0x64f85b25), SPH_C32(0x3b17c937),
    SPH_C32(0x24da1437), SPH_C32(0x029e1230), SPH_C32(0x48dd0003),
    SPH_C32(0xd2fa2700), SPH_C32(0xaf460000), SPH_C32(0x1b5a0000),
    SPH_C32(0xf782673a), SPH_C32(0x924df9cf), SPH_C32(0xca19b5ab),
    SPH_C32(0xfc4dd689) },
  { SPH_C32(0x04b00004), SPH_C32(0x9453a200), SPH_C32(0xeaeb0000),
    SPH_C32(0xbb730000), SPH_C32(0x46793a89), SPH_C32(0x955f3872),
    SPH_C32(0x42fe0221), SPH_C32(0xc75ff90e), SPH_C32(0xb5f80003),
    SPH_C32(0x613e3600), SPH_C32(0x61b60000), SPH_C32(0xd5a30000),
    SPH_C32(0xcbcf12ba), SPH_C32(0x1f169d5c), SPH_C32(0xba81050d),
    SPH_C32(0xe6bfc968) },
  { SPH_C32(0x6d860007), SPH_C32(0x55054000), SPH_C32(0x06190000),
    SPH_C32(0x92490000), SPH_C32(0x174666dc), SPH_C32(0x3af1893c),
    SPH_C32(0x3cd6bdbe), SPH_C32(0x2989664e), SPH_C32(0xd3b60002),
    SPH_C32(0x7f274000), SPH_C32(0xc8dc0000), SPH_C32(0x2c310000),
    SPH_C32(0xb14f42c3), SPH_C32(0x6c9219a4), SPH_C32(0x97453192),
    SPH_C32(0xac3942a3) },
  { SPH_C32(0xd5bb0007), SPH_C32(0x43744600), SPH_C32(0x31830000),
    SPH_C32(0x67f80000), SPH_C32(0x35c70770), SPH_C32(0x94b97879),
    SPH_C32(0x5af2aba8), SPH_C32(0xec488d70), SPH_C32(0x2e930002),
    SPH_C32(0xcce35100), SPH_C32(0x062c0000), SPH_C32(0xe2c80000),
    SPH_C32(0x8d023743), SPH_C32(0xe1c97d37), SPH_C32(0xe7dd8134),
    SPH_C32(0xb6cb5d42) },
  { SPH_C32(0x18220007), SPH_C32(0x978e6700), SPH_C32(0x92bd0000),
    SPH_C32(0x02bc0000), SPH_C32(0xec3e313c), SPH_C32(0x733f8292),
    SPH_C32(0x2bb1793d), SPH_C32(0x87560030), SPH_C32(0x02d00002),
    SPH_C32(0x649b4300), SPH_C32(0x56300000), SPH_C32(0xdaa50000),
    SPH_C32(0xb24d07e4), SPH_C32(0xa3e2e556), SPH_C32(0x23062a85),
    SPH_C32(0x29467e88) },
  { SPH_C32(0xa01f0007), SPH_C32(0x81ff6100), SPH_C32(0xa5270000),
    SPH_C32(0xf70d0000), SPH_C32(0xcebf5090), SPH_C32(0xdd7773d7),
    SPH_C32(0x4d956f2b), SPH_C32(0x4297eb0e), SPH_C32(0xfff50002),
    SPH_C32(0xd75f5200), SPH_C32(0x98c00000), SPH_C32(0x145c0000),
    SPH_C32(0x8e007264), SPH_C32(0x2eb981c5), SPH_C32(0x539e9a23),
    SPH_C32(0x33b46169) },
  { SPH_C32(0xbce00007), SPH_C32(0x4eb94300), SPH_C32(0x98f50000),
    SPH_C32(0x64dd0000), SPH_C32(0x144423fb), SPH_C32(0xf58175ce),
    SPH_C32(0x8895a6a9), SPH_C32(0xacf65a65), SPH_C32(0x77740002),
    SPH_C32(0xa6106400), SPH_C32(0xc2940000), SPH_C32(0x4a500000),
    SPH_C32(0x49355004), SPH_C32(0xea2ceef8), SPH_C32(0x3461ee06),
    SPH_C32(0x879918f6) },
  { SPH_C32(0x04dd0007), SPH_C32(0x58c84500), SPH_C32(0xaf6f0000),
    SPH_C32(0x916c0000), SPH_C32(0x36c54257), SPH_C32(0x5bc9848b),
    SPH_C32(0xeeb1b0bf), SPH_C32(0x6937b15b), SPH_C32(0x8a510002),
    SPH_C32(0x15d47500), SPH_C32(0x0c640000), SPH_C32(0x84a90000),
    SPH_C32(0x75782584), SPH_C32(0x67778a6b), SPH_C32(0x44f95ea0),
    SPH_C32(0x9d6b0717) },
  { SPH_C32(0xc9440007), SPH_C32(0x8c326400), SPH_C32(0x0c510000),
    SPH_C32(0xf4280000), SPH_C32(0xef3c741b), SPH_C32(0xbc4f7e60),
    SPH_C32(0x9ff2622a), SPH_C32(0x02293c1b), SPH_C32(0xa6120002),
    SPH_C32(0xbdac6700), SPH_C32(0x5c780000), SPH_C32(0xbcc40000),
    SPH_C32(0x4a371523), SPH_C32(0x255c120a), SPH_C32(0x8022f511),
    SPH_C32(0x02e624dd) },
  { SPH_C32(0x71790007), SPH_C32(0x9a436200), SPH_C32(0x3bcb0000),
    SPH_C32(0x01990000), SPH_C32(0xcdbd15b7), SPH_C32(0x12078f25),
    SPH_C32(0xf9d6743c), SPH_C32(0xc7e8d725), SPH_C32(0x5b370002),
    SPH_C32(0x0e687600), SPH_C32(0x92880000), SPH_C32(0x723d0000),
    SPH_C32(0x767a60a3), SPH_C32(0xa8077699), SPH_C32(0xf0ba45b7),
    SPH_C32(0x18143b3c) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0x1e420001), SPH_C32(0x67468600), SPH_C32(0x2e660000),
    SPH_C32(0x636a0000), SPH_C32(0x180a0c51), SPH_C32(0x45825fb6),
    SPH_C32(0x4a495199), SPH_C32(0x694f87b6), SPH_C32(0xadda0004),
    SPH_C32(0xf6b05100), SPH_C32(0xf30b0000), SPH_C32(0xd71f0000),
    SPH_C32(0x27f12386), SPH_C32(0x6c291fce), SPH_C32(0x91307c30),
    SPH_C32(0x61e9c958) },
  { SPH_C32(0xd3db0001), SPH_C32(0xb3bca700), SPH_C32(0x8d580000),
    SPH_C32(0x062e0000), SPH_C32(0xc1f33a1d), SPH_C32(0xa204a55d),
    SPH_C32(0x3b0a830c), SPH_C32(0x02510af6), SPH_C32(0x81990004),
    SPH_C32(0x5ec84300), SPH_C32(0xa3170000), SPH_C32(0xef720000),
    SPH_C32(0x18be1321), SPH_C32(0x2e0287af), SPH_C32(0x55ebd781),
    SPH_C32(0xfe64ea92) },
  { SPH_C32(0x6be60001), SPH_C32(0xa5cda100), SPH_C32(0xbac20000),
    SPH_C32(0xf39f0000), SPH_C32(0xe3725bb1), SPH_C32(0x0c4c5418),
    SPH_C32(0x5d2e951a), SPH_C32(0xc790e1c8), SPH_C32(0x7cbc0004),
    SPH_C32(0xed0c5200), SPH_C32(0x6de70000), SPH_C32(0x218b0000),
    SPH_C32(0x24f366a1), SPH_C32(0xa359e33c), SPH_C32(0x25736727),
    SPH_C32(0xe496f573) },
  { SPH_C32(0x77190001), SPH_C32(0x6a8b8300), SPH_C32(0x87100000),
    SPH_C32(0x604f0000), SPH_C32(0x398928da), SPH_C32(0x24ba5201),
    SPH_C32(0x982e5c98), SPH_C32(0x29f150a3), SPH_C32(0xf43d0004),
    SPH_C32(0x9c436400), SPH_C32(0x37b30000), SPH_C32(0x7f870000),
    SPH_C32(0xe3c644c1), SPH_C32(0x67cc8c01), SPH_C32(0x428c1302),
    SPH_C32(0x50bb8cec) },
  { SPH_C32(0xcf240001), SPH_C32(0x7cfa8500), SPH_C32(0xb08a0000),
    SPH_C32(0x95fe0000), SPH_C32(0x1b084976), SPH_C32(0x8af2a344),
    SPH_C32(0xfe0a4a8e), SPH_C32(0xec30bb9d), SPH_C32(0x09180004),
    SPH_C32(0x2f877500), SPH_C32(0xf9430000), SPH_C32(0xb17e0000),
    SPH_C32(0xdf8b3141), SPH_C32(0xea97e892), SPH_C32(0x3214a3a4),
    SPH_C32(0x4a49930d) },
  { SPH_C32(0x02bd0001), SPH_C32(0xa800a400), SPH_C32(0x13b40000),
    SPH_C32(0xf0ba0000), SPH_C32(0xc2f17f3a), SPH_C32(0x6d7459af),
    SPH_C32(0x8f49981b), SPH_C32(0x872e36dd), SPH_C32(0x255b0004),
    SPH_C32(0x87ff6700), SPH_C32(0xa95f0000), SPH_C32(0x89130000),
    SPH_C32(0xe0c401e6), SPH_C32(0xa8bc70f3), SPH_C32(0xf6cf0815),
    SPH_C32(0xd5c4b0c7) },
  { SPH_C32(0xba800001), SPH_C32(0xbe71a200), SPH_C32(0x242e0000),
    SPH_C32(0x050b0000), SPH_C32(0xe0701e96), SPH_C32(0xc33ca8ea),
    SPH_C32(0xe96d8e0d), SPH_C32(0x42efdde3), SPH_C32(0xd87e0004),
    SPH_C32(0x343b7600), SPH_C32(0x67af0000), SPH_C32(0x47ea0000),
    SPH_C32(0xdc897466), SPH_C32(0x25e71460), SPH_C32(0x8657b8b3),
    SPH_C32(0xcf36af26) },
  { SPH_C32(0xd3b60002), SPH_C32(0x7f274000), SPH_C32(0xc8dc0000),
    SPH_C32(0x2c310000), SPH_C32(0xb14f42c3), SPH_C32(0x6c9219a4),
    SPH_C32(0x97453192), SPH_C32(0xac3942a3), SPH_C32(0xbe300005),
    SPH_C32(0x2a220000), SPH_C32(0xcec50000), SPH_C32(0xbe780000),
    SPH_C32(0xa609241f), SPH_C32(0x56639098), SPH_C32(0xab938c2c),
    SPH_C32(0x85b024ed) },
  { SPH_C32(0x6b8b0002), SPH_C32(0x69564600), SPH_C32(0xff460000),
    SPH_C32(0xd9800000), SPH_C32(0x93ce236f), SPH_C32(0xc2dae8e1),
    SPH_C32(0xf1612784), SPH_C32(0x69f8a99d), SPH_C32(0x43150005),
    SPH_C32(0x99e61100), SPH_C32(0x00350000), SPH_C32(0x70810000),
    SPH_C32(0x9a44519f), SPH_C32(0xdb38f40b), SPH_C32(0xdb0b3c8a),
    SPH_C32(0x9f423b0c) },
  { SPH_C32(0xa6120002), SPH_C32(0xbdac6700), SPH_C32(0x5c780000),
    SPH_C32(0xbcc40000), SPH_C32(0x4a371523), SPH_C32(0x255c120a),
    SPH_C32(0x8022f511), SPH_C32(0x02e624dd), SPH_C32(0x6f560005),
    SPH_C32(0x319e0300), SPH_C32(0x50290000), SPH_C32(0x48ec0000),
    SPH_C32(0xa50b6138), SPH_C32(0x99136c6a), SPH_C32(0x1fd0973b),
    SPH_C32(0x00cf18c6) },
  { SPH_C32(0x1e2f0002), SPH_C32(0xabdd6100), SPH_C32(0x6be20000),
    SPH_C32(0x49750000), SPH_C32(0x68b6748f), SPH_C32(0x8b14e34f),
    SPH_C32(0xe606e307), SPH_C32(0xc727cfe3), SPH_C32(0x92730005),
    SPH_C32(0x825a1200), SPH_C32(0x9ed90000), SPH_C32(0x86150000),
    SPH_C32(0x994614b8), SPH_C32(0x144808f9), SPH_C32(0x6f48279d),
    SPH_C32(0x1a3d0727) },
  { SPH_C32(0x02d00002), SPH_C32(0x649b4300), SPH_C32(0x56300000),
    SPH_C32(0xdaa50000), SPH_C32(0xb24d07e4), SPH_C32(0xa3e2e556),
    SPH_C32(0x23062a85), SPH_C32(0x29467e88), SPH_C32(0x1af20005),
    SPH_C32(0xf3152400), SPH_C32(0xc48d0000), SPH_C32(0xd8190000),
    SPH_C32(0x5e7336d8), SPH_C32(0xd0dd67c4), SPH_C32(0x08b753b8),
    SPH_C32(0xae107eb8) },
  { SPH_C32(0xbaed0002), SPH_C32(0x72ea4500), SPH_C32(0x61aa0000),
    SPH_C32(0x2f140000), SPH_C32(0x90cc6648), SPH_C32(0x0daa1413),
    SPH_C32(0x45223c93), SPH_C32(0xec8795b6), SPH_C32(0xe7d70005),
    SPH_C32(0x40d13500), SPH_C32(0x0a7d0000), SPH_C32(0x16e00000),
    SPH_C32(0x623e4358), SPH_C32(0x5d860357), SPH_C32(0x782fe31e),
    SPH_C32(0xb4e26159) },
  { SPH_C32(0x77740002), SPH_C32(0xa6106400), SPH_C32(0xc2940000),
    SPH_C32(0x4a500000), SPH_C32(0x49355004), SPH_C32(0xea2ceef8),
    SPH_C32(0x3461ee06), SPH_C32(0x879918f6), SPH_C32(0xcb940005),
    SPH_C32(0xe8a92700), SPH_C32(0x5a610000), SPH_C32(0x2e8d0000),
    SPH_C32(0x5d7173ff), SPH_C32(0x1fad9b36), SPH_C32(0xbcf448af),
    SPH_C32(0x2b6f4293) },
  { SPH_C32(0xcf490002), SPH_C32(0xb0616200), SPH_C32(0xf50e0000),
    SPH_C32(0xbfe10000), SPH_C32(0x6bb431a8), SPH_C32(0x44641fbd),
    SPH_C32(0x5245f810), SPH_C32(0x4258f3c8), SPH_C32(0x36b10005),
    SPH_C32(0x5b6d3600), SPH_C32(0x94910000), SPH_C32(0xe0740000),
    SPH_C32(0x613c067f), SPH_C32(0x92f6ffa5), SPH_C32(0xcc6cf809),
    SPH_C32(0x319d5d72) },
  { SPH_C32(0x48b00000), SPH_C32(0x1e61c000), SPH_C32(0xeac20000),
    SPH_C32(0x31450000), SPH_C32(0x873e1fe4), SPH_C32(0x5cdb4536),
    SPH_C32(0x66560735), SPH_C32(0x52259edc), SPH_C32(0xcbf90006),
    SPH_C32(0x2432c000), SPH_C32(0x1fe50000), SPH_C32(0x04920000),
    SPH_C32(0x2dcd0b21), SPH_C32(0xd13b27cf), SPH_C32(0x10bbfa31),
    SPH_C32(0x85070ac6) },
  { SPH_C32(0xf08d0000), SPH_C32(0x0810c600), SPH_C32(0xdd580000),
    SPH_C32(0xc4f40000), SPH_C32(0xa5bf7e48), SPH_C32(0xf293b473),
    SPH_C32(0x00721123), SPH_C32(0x97e475e2), SPH_C32(0x36dc0006),
    SPH_C32(0x97f6d100), SPH_C32(0xd1150000), SPH_C32(0xca6b0000),
    SPH_C32(0x11807ea1), SPH_C32(0x5c60435c), SPH_C32(0x60234a97),
    SPH_C32(0x9ff51527) },
  { SPH_C32(0x3d140000), SPH_C32(0xdceae700), SPH_C32(0x7e660000),
    SPH_C32(0xa1b00000), SPH_C32(0x7c464804), SPH_C32(0x15154e98),
    SPH_C32(0x7131c3b6), SPH_C32(0xfcfaf8a2), SPH_C32(0x1a9f0006),
    SPH_C32(0x3f8ec300), SPH_C32(0x81090000), SPH_C32(0xf2060000),
    SPH_C32(0x2ecf4e06), SPH_C32(0x1e4bdb3d), SPH_C32(0xa4f8e126),
    SPH_C32(0x007836ed) },
  { SPH_C32(0x85290000), SPH_C32(0xca9be100), SPH_C32(0x49fc0000),
    SPH_C32(0x54010000), SPH_C32(0x5ec729a8), SPH_C32(0xbb5dbfdd),
    SPH_C32(0x1715d5a0), SPH_C32(0x393b139c), SPH_C32(0xe7ba0006),
    SPH_C32(0x8c4ad200), SPH_C32(0x4ff90000), SPH_C32(0x3cff0000),
    SPH_C32(0x12823b86), SPH_C32(0x9310bfae), SPH_C32(0xd4605180),
    SPH_C32(0x1a8a290c) },
  { SPH_C32(0x99d60000), SPH_C32(0x05ddc300), SPH_C32(0x742e0000),
    SPH_C32(0xc7d10000), SPH_C32(0x843c5ac3), SPH_C32(0x93abb9c4),
    SPH_C32(0xd2151c22), SPH_C32(0xd75aa2f7), SPH_C32(0x6f3b0006),
    SPH_C32(0xfd05e400), SPH_C32(0x15ad0000), SPH_C32(0x62f30000),
    SPH_C32(0xd5b719e6), SPH_C32(0x5785d093), SPH_C32(0xb39f25a5),
    SPH_C32(0xaea75093) },
  { SPH_C32(0x21eb0000), SPH_C32(0x13acc500), SPH_C32(0x43b40000),
    SPH_C32(0x32600000), SPH_C32(0xa6bd3b6f), SPH_C32(0x3de34881),
    SPH_C32(0xb4310a34), SPH_C32(0x129b49c9), SPH_C32(0x921e0006),
    SPH_C32(0x4ec1f500), SPH_C32(0xdb5d0000), SPH_C32(0xac0a0000),
    SPH_C32(0xe9fa6c66), SPH_C32(0xdadeb400), SPH_C32(0xc3079503),
    SPH_C32(0xb4554f72) },
  { SPH_C32(0xec720000), SPH_C32(0xc756e400), SPH_C32(0xe08a0000),
    SPH_C32(0x57240000), SPH_C32(0x7f440d23), SPH_C32(0xda65b26a),
    SPH_C32(0xc572d8a1), SPH_C32(0x7985c489), SPH_C32(0xbe5d0006),
    SPH_C32(0xe6b9e700), SPH_C32(0x8b410000), SPH_C32(0x94670000),
    SPH_C32(0xd6b55cc1), SPH_C32(0x98f52c61), SPH_C32(0x07dc3eb2),
    SPH_C32(0x2bd86cb8) },
  { SPH_C32(0x544f0000), SPH_C32(0xd127e200), SPH_C32(0xd7100000),
    SPH_C32(0xa2950000), SPH_C32(0x5dc56c8f), SPH_C32(0x742d432f),
    SPH_C32(0xa356ceb7), SPH_C32(0xbc442fb7), SPH_C32(0x43780006),
    SPH_C32(0x557df600), SPH_C32(0x45b10000), SPH_C32(0x5a9e0000),
    SPH_C32(0xeaf82941), SPH_C32(0x15ae48f2), SPH_C32(0x77448e14),
    SPH_C32(0x312a7359) },
  { SPH_C32(0x3d790003), SPH_C32(0x10710000), SPH_C32(0x3be20000),
    SPH_C32(0x8baf0000), SPH_C32(0x0cfa30da), SPH_C32(0xdb83f261),
    SPH_C32(0xdd7e7128), SPH_C32(0x5292b0f7), SPH_C32(0x25360007),
    SPH_C32(0x4b648000), SPH_C32(0xecdb0000), SPH_C32(0xa30c0000),
    SPH_C32(0x90787938), SPH_C32(0x662acc0a), SPH_C32(0x5a80ba8b),
    SPH_C32(0x7bacf892) },
  { SPH_C32(0x85440003), SPH_C32(0x06000600), SPH_C32(0x0c780000),
    SPH_C32(0x7e1e0000), SPH_C32(0x2e7b5176), SPH_C32(0x75cb0324),
    SPH_C32(0xbb5a673e), SPH_C32(0x97535bc9), SPH_C32(0xd8130007),
    SPH_C32(0xf8a09100), SPH_C32(0x222b0000), SPH_C32(0x6df50000),
    SPH_C32(0xac350cb8), SPH_C32(0xeb71a899), SPH_C32(0x2a180a2d),
    SPH_C32(0x615ee773) },
  { SPH_C32(0x48dd0003), SPH_C32(0xd2fa2700), SPH_C32(0xaf460000),
    SPH_C32(0x1b5a0000), SPH_C32(0xf782673a), SPH_C32(0x924df9cf),
    SPH_C32(0xca19b5ab), SPH_C32(0xfc4dd689), SPH_C32(0xf4500007),
    SPH_C32(0x50d88300), SPH_C32(0x72370000), SPH_C32(0x55980000),
    SPH_C32(0x937a3c1f), SPH_C32(0xa95a30f8), SPH_C32(0xeec3a19c),
    SPH_C32(0xfed3c4b9) },
  { SPH_C32(0xf0e00003), SPH_C32(0xc48b2100), SPH_C32(0x98dc0000),
    SPH_C32(0xeeeb0000), SPH_C32(0xd5030696), SPH_C32(0x3c05088a),
    SPH_C32(0xac3da3bd), SPH_C32(0x398c3db7), SPH_C32(0x09750007),
    SPH_C32(0xe31c9200), SPH_C32(0xbcc70000), SPH_C32(0x9b610000),
    SPH_C32(0xaf37499f), SPH_C32(0x2401546b), SPH_C32(0x9e5b113a),
    SPH_C32(0xe421db58) },
  { SPH_C32(0xec1f0003), SPH_C32(0x0bcd0300), SPH_C32(0xa50e0000),
    SPH_C32(0x7d3b0000), SPH_C32(0x0ff875fd), SPH_C32(0x14f30e93),
    SPH_C32(0x693d6a3f), SPH_C32(0xd7ed8cdc), SPH_C32(0x81f40007),
    SPH_C32(0x9253a400), SPH_C32(0xe6930000), SPH_C32(0xc56d0000),
    SPH_C32(0x68026bff), SPH_C32(0xe0943b56), SPH_C32(0xf9a4651f),
    SPH_C32(0x500ca2c7) },
  { SPH_C32(0x54220003), SPH_C32(0x1dbc0500), SPH_C32(0x92940000),
    SPH_C32(0x888a0000), SPH_C32(0x2d791451), SPH_C32(0xbabbffd6),
    SPH_C32(0x0f197c29), SPH_C32(0x122c67e2), SPH_C32(0x7cd10007),
    SPH_C32(0x2197b500), SPH_C32(0x28630000), SPH_C32(0x0b940000),
    SPH_C32(0x544f1e7f), SPH_C32(0x6dcf5fc5), SPH_C32(0x893cd5b9),
    SPH_C32(0x4afebd26) },
  { SPH_C32(0x99bb0003), SPH_C32(0xc9462400), SPH_C32(0x31aa0000),
    SPH_C32(0xedce0000), SPH_C32(0xf480221d), SPH_C32(0x5d3d053d),
    SPH_C32(0x7e5aaebc), SPH_C32(0x7932eaa2), SPH_C32(0x50920007),
    SPH_C32(0x89efa700), SPH_C32(0x787f0000), SPH_C32(0x33f90000),
    SPH_C32(0x6b002ed8), SPH_C32(0x2fe4c7a4), SPH_C32(0x4de77e08),
    SPH_C32(0xd5739eec) },
  { SPH_C32(0x21860003), SPH_C32(0xdf372200), SPH_C32(0x06300000),
    SPH_C32(0x187f0000), SPH_C32(0xd60143b1), SPH_C32(0xf375f478),
    SPH_C32(0x187eb8aa), SPH_C32(0xbcf3019c), SPH_C32(0xadb70007),
    SPH_C32(0x3a2bb600), SPH_C32(0xb68f0000), SPH_C32(0xfd000000),
    SPH_C32(0x574d5b58), SPH_C32(0xa2bfa337), SPH_C32(0x3d7fceae),
    SPH_C32(0xcf81810d) },
  { SPH_C32(0x50ff0004), SPH_C32(0x45744000), SPH_C32(0x3dfb0000),
    SPH_C32(0x19e60000), SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d),
    SPH_C32(0xe1a8cc96), SPH_C32(0x7b1bd6b9), SPH_C32(0xf6800005),
    SPH_C32(0x3443c000), SPH_C32(0x24070000), SPH_C32(0x8f3d0000),
    SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae), SPH_C32(0xcdc58b19),
    SPH_C32(0xd795ba31) },
  { SPH_C32(0xe8c20004), SPH_C32(0x53054600), SPH_C32(0x0a610000),
    SPH_C32(0xec570000), SPH_C32(0x393d37aa), SPH_C32(0x4f3a8a18),
    SPH_C32(0x878cda80), SPH_C32(0xbeda3d87), SPH_C32(0x0ba50005),
    SPH_C32(0x8787d100), SPH_C32(0xeaf70000), SPH_C32(0x41c40000),
    SPH_C32(0x1d7a4e7b), SPH_C32(0x87e3b13d), SPH_C32(0xbd5d3bbf),
    SPH_C32(0xcd67a5d0) },
  { SPH_C32(0x255b0004), SPH_C32(0x87ff6700), SPH_C32(0xa95f0000),
    SPH_C32(0x89130000), SPH_C32(0xe0c401e6), SPH_C32(0xa8bc70f3),
    SPH_C32(0xf6cf0815), SPH_C32(0xd5c4b0c7), SPH_C32(0x27e60005),
    SPH_C32(0x2fffc300), SPH_C32(0xbaeb0000), SPH_C32(0x79a90000),
    SPH_C32(0x22357edc), SPH_C32(0xc5c8295c), SPH_C32(0x7986900e),
    SPH_C32(0x52ea861a) },
  { SPH_C32(0x9d660004), SPH_C32(0x918e6100), SPH_C32(0x9ec50000),
    SPH_C32(0x7ca20000), SPH_C32(0xc245604a), SPH_C32(0x06f481b6),
    SPH_C32(0x90eb1e03), SPH_C32(0x10055bf9), SPH_C32(0xdac30005),
    SPH_C32(0x9c3bd200), SPH_C32(0x741b0000), SPH_C32(0xb7500000),
    SPH_C32(0x1e780b5c), SPH_C32(0x48934dcf), SPH_C32(0x091e20a8),
    SPH_C32(0x481899fb) },
  { SPH_C32(0x81990004), SPH_C32(0x5ec84300), SPH_C32(0xa3170000),
    SPH_C32(0xef720000), SPH_C32(0x18be1321), SPH_C32(0x2e0287af),
    SPH_C32(0x55ebd781), SPH_C32(0xfe64ea92), SPH_C32(0x52420005),
    SPH_C32(0xed74e400), SPH_C32(0x2e4f0000), SPH_C32(0xe95c0000),
    SPH_C32(0xd94d293c), SPH_C32(0x8c0622f2), SPH_C32(0x6ee1548d),
    SPH_C32(0xfc35e064) },
  { SPH_C32(0x39a40004), SPH_C32(0x48b94500), SPH_C32(0x948d0000),
    SPH_C32(0x1ac30000), SPH_C32(0x3a3f728d), SPH_C32(0x804a76ea),
    SPH_C32(0x33cfc197), SPH_C32(0x3ba501ac), SPH_C32(0xaf670005),
    SPH_C32(0x5eb0f500), SPH_C32(0xe0bf0000), SPH_C32(0x27a50000),
    SPH_C32(0xe5005cbc), SPH_C32(0x015d4661), SPH_C32(0x1e79e42b),
    SPH_C32(0xe6c7ff85) },
  { SPH_C32(0xf43d0004), SPH_C32(0x9c436400), SPH_C32(0x37b30000),
    SPH_C32(0x7f870000), SPH_C32(0xe3c644c1), SPH_C32(0x67cc8c01),
    SPH_C32(0x428c1302), SPH_C32(0x50bb8cec), SPH_C32(0x83240005),
    SPH_C32(0xf6c8e700), SPH_C32(0xb0a30000), SPH_C32(0x1fc80000),
    SPH_C32(0xda4f6c1b), SPH_C32(0x4376de00), SPH_C32(0xdaa24f9a),
    SPH_C32(0x794adc4f) },
  { SPH_C32(0x4c000004), SPH_C32(0x8a326200), SPH_C32(0x00290000),
    SPH_C32(0x8a360000), SPH_C32(0xc147256d), SPH_C32(0xc9847d44),
    SPH_C32(0x24a80514), SPH_C32(0x957a67d2), SPH_C32(0x7e010005),
    SPH_C32(0x450cf600), SPH_C32(0x7e530000), SPH_C32(0xd1310000),
    SPH_C32(0xe602199b), SPH_C32(0xce2dba93), SPH_C32(0xaa3aff3c),
    SPH_C32(0x63b8c3ae) },
  { SPH_C32(0x25360007), SPH_C32(0x4b648000), SPH_C32(0xecdb0000),
    SPH_C32(0xa30c0000), SPH_C32(0x90787938), SPH_C32(0x662acc0a),
    SPH_C32(0x5a80ba8b), SPH_C32(0x7bacf892), SPH_C32(0x184f0004),
    SPH_C32(0x5b158000), SPH_C32(0xd7390000), SPH_C32(0x28a30000),
    SPH_C32(0x9c8249e2), SPH_C32(0xbda93e6b), SPH_C32(0x87fecba3),
    SPH_C32(0x293e4865) },
  { SPH_C32(0x9d0b0007), SPH_C32(0x5d158600), SPH_C32(0xdb410000),
    SPH_C32(0x56bd0000), SPH_C32(0xb2f91894), SPH_C32(0xc8623d4f),
    SPH_C32(0x3ca4ac9d), SPH_C32(0xbe6d13ac), SPH_C32(0xe56a0004),
    SPH_C32(0xe8d19100), SPH_C32(0x19c90000), SPH_C32(0xe65a0000),
    SPH_C32(0xa0cf3c62), SPH_C32(0x30f25af8), SPH_C32(0xf7667b05),
    SPH_C32(0x33cc5784) },
  { SPH_C32(0x50920007), SPH_C32(0x89efa700), SPH_C32(0x787f0000),
    SPH_C32(0x33f90000), SPH_C32(0x6b002ed8), SPH_C32(0x2fe4c7a4),
    SPH_C32(0x4de77e08), SPH_C32(0xd5739eec), SPH_C32(0xc9290004),
    SPH_C32(0x40a98300), SPH_C32(0x49d50000), SPH_C32(0xde370000),
    SPH_C32(0x9f800cc5), SPH_C32(0x72d9c299), SPH_C32(0x33bdd0b4),
    SPH_C32(0xac41744e) },
  { SPH_C32(0xe8af0007), SPH_C32(0x9f9ea100), SPH_C32(0x4fe50000),
    SPH_C32(0xc6480000), SPH_C32(0x49814f74), SPH_C32(0x81ac36e1),
    SPH_C32(0x2bc3681e), SPH_C32(0x10b275d2), SPH_C32(0x340c0004),
    SPH_C32(0xf36d9200), SPH_C32(0x87250000), SPH_C32(0x10ce0000),
    SPH_C32(0xa3cd7945), SPH_C32(0xff82a60a), SPH_C32(0x43256012),
    SPH_C32(0xb6b36baf) },
  { SPH_C32(0xf4500007), SPH_C32(0x50d88300), SPH_C32(0x72370000),
    SPH_C32(0x55980000), SPH_C32(0x937a3c1f), SPH_C32(0xa95a30f8),
    SPH_C32(0xeec3a19c), SPH_C32(0xfed3c4b9), SPH_C32(0xbc8d0004),
    SPH_C32(0x8222a400), SPH_C32(0xdd710000), SPH_C32(0x4ec20000),
    SPH_C32(0x64f85b25), SPH_C32(0x3b17c937), SPH_C32(0x24da1437),
    SPH_C32(0x029e1230) },
  { SPH_C32(0x4c6d0007), SPH_C32(0x46a98500), SPH_C32(0x45ad0000),
    SPH_C32(0xa0290000), SPH_C32(0xb1fb5db3), SPH_C32(0x0712c1bd),
    SPH_C32(0x88e7b78a), SPH_C32(0x3b122f87), SPH_C32(0x41a80004),
    SPH_C32(0x31e6b500), SPH_C32(0x13810000), SPH_C32(0x803b0000),
    SPH_C32(0x58b52ea5), SPH_C32(0xb64cada4), SPH_C32(0x5442a491),
    SPH_C32(0x186c0dd1) },
  { SPH_C32(0x81f40007), SPH_C32(0x9253a400), SPH_C32(0xe6930000),
    SPH_C32(0xc56d0000), SPH_C32(0x68026bff), SPH_C32(0xe0943b56),
    SPH_C32(0xf9a4651f), SPH_C32(0x500ca2c7), SPH_C32(0x6deb0004),
    SPH_C32(0x999ea700), SPH_C32(0x439d0000), SPH_C32(0xb8560000),
    SPH_C32(0x67fa1e02), SPH_C32(0xf46735c5), SPH_C32(0x90990f20),
    SPH_C32(0x87e12e1b) },
  { SPH_C32(0x39c90007), SPH_C32(0x8422a200), SPH_C32(0xd1090000),
    SPH_C32(0x30dc0000), SPH_C32(0x4a830a53), SPH_C32(0x4edcca13),
    SPH_C32(0x9f807309), SPH_C32(0x95cd49f9), SPH_C32(0x90ce0004),
    SPH_C32(0x2a5ab600), SPH_C32(0x8d6d0000), SPH_C32(0x76af0000),
    SPH_C32(0x5bb76b82), SPH_C32(0x793c5156), SPH_C32(0xe001bf86),
    SPH_C32(0x9d1331fa) },
  { SPH_C32(0xbe300005), SPH_C32(0x2a220000), SPH_C32(0xcec50000),
    SPH_C32(0xbe780000), SPH_C32(0xa609241f), SPH_C32(0x56639098),
    SPH_C32(0xab938c2c), SPH_C32(0x85b024ed), SPH_C32(0x6d860007),
    SPH_C32(0x55054000), SPH_C32(0x06190000), SPH_C32(0x92490000),
    SPH_C32(0x174666dc), SPH_C32(0x3af1893c), SPH_C32(0x3cd6bdbe),
    SPH_C32(0x2989664e) },
  { SPH_C32(0x060d0005), SPH_C32(0x3c530600), SPH_C32(0xf95f0000),
    SPH_C32(0x4bc90000), SPH_C32(0x848845b3), SPH_C32(0xf82b61dd),
    SPH_C32(0xcdb79a3a), SPH_C32(0x4071cfd3), SPH_C32(0x90a30007),
    SPH_C32(0xe6c15100), SPH_C32(0xc8e90000), SPH_C32(0x5cb00000),
    SPH_C32(0x2b0b135c), SPH_C32(0xb7aaedaf), SPH_C32(0x4c4e0d18),
    SPH_C32(0x337b79af) },
  { SPH_C32(0xcb940005), SPH_C32(0xe8a92700), SPH_C32(0x5a610000),
    SPH_C32(0x2e8d0000), SPH_C32(0x5d7173ff), SPH_C32(0x1fad9b36),
    SPH_C32(0xbcf448af), SPH_C32(0x2b6f4293), SPH_C32(0xbce00007),
    SPH_C32(0x4eb94300), SPH_C32(0x98f50000), SPH_C32(0x64dd0000),
    SPH_C32(0x144423fb), SPH_C32(0xf58175ce), SPH_C32(0x8895a6a9),
    SPH_C32(0xacf65a65) },
  { SPH_C32(0x73a90005), SPH_C32(0xfed82100), SPH_C32(0x6dfb0000),
    SPH_C32(0xdb3c0000), SPH_C32(0x7ff01253), SPH_C32(0xb1e56a73),
    SPH_C32(0xdad05eb9), SPH_C32(0xeeaea9ad), SPH_C32(0x41c50007),
    SPH_C32(0xfd7d5200), SPH_C32(0x56050000), SPH_C32(0xaa240000),
    SPH_C32(0x2809567b), SPH_C32(0x78da115d), SPH_C32(0xf80d160f),
    SPH_C32(0xb6044584) },
  { SPH_C32(0x6f560005), SPH_C32(0x319e0300), SPH_C32(0x50290000),
    SPH_C32(0x48ec0000), SPH_C32(0xa50b6138), SPH_C32(0x99136c6a),
    SPH_C32(0x1fd0973b), SPH_C32(0x00cf18c6), SPH_C32(0xc9440007),
    SPH_C32(0x8c326400), SPH_C32(0x0c510000), SPH_C32(0xf4280000),
    SPH_C32(0xef3c741b), SPH_C32(0xbc4f7e60), SPH_C32(0x9ff2622a),
    SPH_C32(0x02293c1b) },
  { SPH_C32(0xd76b0005), SPH_C32(0x27ef0500), SPH_C32(0x67b30000),
    SPH_C32(0xbd5d0000), SPH_C32(0x878a0094), SPH_C32(0x375b9d2f),
    SPH_C32(0x79f4812d), SPH_C32(0xc50ef3f8), SPH_C32(0x34610007),
    SPH_C32(0x3ff67500), SPH_C32(0xc2a10000), SPH_C32(0x3ad10000),
    SPH_C32(0xd371019b), SPH_C32(0x31141af3), SPH_C32(0xef6ad28c),
    SPH_C32(0x18db23fa) },
  { SPH_C32(0x1af20005), SPH_C32(0xf3152400), SPH_C32(0xc48d0000),
    SPH_C32(0xd8190000), SPH_C32(0x5e7336d8), SPH_C32(0xd0dd67c4),
    SPH_C32(0x08b753b8), SPH_C32(0xae107eb8), SPH_C32(0x18220007),
    SPH_C32(0x978e6700), SPH_C32(0x92bd0000), SPH_C32(0x02bc0000),
    SPH_C32(0xec3e313c), SPH_C32(0x733f8292), SPH_C32(0x2bb1793d),
    SPH_C32(0x87560030) },
  { SPH_C32(0xa2cf0005), SPH_C32(0xe5642200), SPH_C32(0xf3170000),
    SPH_C32(0x2da80000), SPH_C32(0x7cf25774), SPH_C32(0x7e959681),
    SPH_C32(0x6e9345ae), SPH_C32(0x6bd19586), SPH_C32(0xe5070007),
    SPH_C32(0x244a7600), SPH_C32(0x5c4d0000), SPH_C32(0xcc450000),
    SPH_C32(0xd07344bc), SPH_C32(0xfe64e601), SPH_C32(0x5b29c99b),
    SPH_C32(0x9da41fd1) },
  { SPH_C32(0xcbf90006), SPH_C32(0x2432c000), SPH_C32(0x1fe50000),
    SPH_C32(0x04920000), SPH_C32(0x2dcd0b21), SPH_C32(0xd13b27cf),
    SPH_C32(0x10bbfa31), SPH_C32(0x85070ac6), SPH_C32(0x83490006),
    SPH_C32(0x3a530000), SPH_C32(0xf5270000), SPH_C32(0x35d70000),
    SPH_C32(0xaaf314c5), SPH_C32(0x8de062f9), SPH_C32(0x76edfd04),
    SPH_C32(0xd722941a) },
  { SPH_C32(0x73c40006), SPH_C32(0x3243c600), SPH_C32(0x287f0000),
    SPH_C32(0xf1230000), SPH_C32(0x0f4c6a8d), SPH_C32(0x7f73d68a),
    SPH_C32(0x769fec27), SPH_C32(0x40c6e1f8), SPH_C32(0x7e6c0006),
    SPH_C32(0x89971100), SPH_C32(0x3bd70000), SPH_C32(0xfb2e0000),
    SPH_C32(0x96be6145), SPH_C32(0x00bb066a), SPH_C32(0x06754da2),
    SPH_C32(0xcdd08bfb) },
  { SPH_C32(0xbe5d0006), SPH_C32(0xe6b9e700), SPH_C32(0x8b410000),
    SPH_C32(0x94670000), SPH_C32(0xd6b55cc1), SPH_C32(0x98f52c61),
    SPH_C32(0x07dc3eb2), SPH_C32(0x2bd86cb8), SPH_C32(0x522f0006),
    SPH_C32(0x21ef0300), SPH_C32(0x6bcb0000), SPH_C32(0xc3430000),
    SPH_C32(0xa9f151e2), SPH_C32(0x42909e0b), SPH_C32(0xc2aee613),
    SPH_C32(0x525da831) },
  { SPH_C32(0x06600006), SPH_C32(0xf0c8e100), SPH_C32(0xbcdb0000),
    SPH_C32(0x61d60000), SPH_C32(0xf4343d6d), SPH_C32(0x36bddd24),
    SPH_C32(0x61f828a4), SPH_C32(0xee198786), SPH_C32(0xaf0a0006),
    SPH_C32(0x922b1200), SPH_C32(0xa53b0000), SPH_C32(0x0dba0000),
    SPH_C32(0x95bc2462), SPH_C32(0xcfcbfa98), SPH_C32(0xb23656b5),
    SPH_C32(0x48afb7d0) },
  { SPH_C32(0x1a9f0006), SPH_C32(0x3f8ec300), SPH_C32(0x81090000),
    SPH_C32(0xf2060000), SPH_C32(0x2ecf4e06), SPH_C32(0x1e4bdb3d),
    SPH_C32(0xa4f8e126), SPH_C32(0x007836ed), SPH_C32(0x278b0006),
    SPH_C32(0xe3642400), SPH_C32(0xff6f0000), SPH_C32(0x53b60000),
    SPH_C32(0x52890602), SPH_C32(0x0b5e95a5), SPH_C32(0xd5c92290),
    SPH_C32(0xfc82ce4f) },
  { SPH_C32(0xa2a20006), SPH_C32(0x29ffc500), SPH_C32(0xb6930000),
    SPH_C32(0x07b70000), SPH_C32(0x0c4e2faa), SPH_C32(0xb0032a78),
    SPH_C32(0xc2dcf730), SPH_C32(0xc5b9ddd3), SPH_C32(0xdaae0006),
    SPH_C32(0x50a03500), SPH_C32(0x319f0000), SPH_C32(0x9d4f0000),
    SPH_C32(0x6ec47382), SPH_C32(0x8605f136), SPH_C32(0xa5519236),
    SPH_C32(0xe670d1ae) },
  { SPH_C32(0x6f3b0006), SPH_C32(0xfd05e400), SPH_C32(0x15ad0000),
    SPH_C32(0x62f30000), SPH_C32(0xd5b719e6), SPH_C32(0x5785d093),
    SPH_C32(0xb39f25a5), SPH_C32(0xaea75093), SPH_C32(0xf6ed0006),
    SPH_C32(0xf8d82700), SPH_C32(0x61830000), SPH_C32(0xa5220000),
    SPH_C32(0x518b4325), SPH_C32(0xc42e6957), SPH_C32(0x618a3987),
    SPH_C32(0x79fdf264) },
  { SPH_C32(0xd7060006), SPH_C32(0xeb74e200), SPH_C32(0x22370000),
    SPH_C32(0x97420000), SPH_C32(0xf736784a), SPH_C32(0xf9cd21d6),
    SPH_C32(0xd5bb33b3), SPH_C32(0x6b66bbad), SPH_C32(0x0bc80006),
    SPH_C32(0x4b1c3600), SPH_C32(0xaf730000), SPH_C32(0x6bdb0000),
    SPH_C32(0x6dc636a5), SPH_C32(0x49750dc4), SPH_C32(0x11128921),
    SPH_C32(0x630fed85) }
};

__constant static const sph_u32 T512_21[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0xe8dd0000), SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000),
    SPH_C32(0xbb150000), SPH_C32(0x80bd361b), SPH_C32(0x24e81d44),
    SPH_C32(0xbfa8c2f4), SPH_C32(0x524a0d59), SPH_C32(0x54500000),
    SPH_C32(0x0671005c), SPH_C32(0x25ae0000), SPH_C32(0x6a1e0000),
    SPH_C32(0x2ea54edf), SPH_C32(0x664e8512), SPH_C32(0xbfba18c3),
    SPH_C32(0x7e715d17) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0x3d010000), SPH_C32(0xd29000c0), SPH_C32(0xe68d0000),
    SPH_C32(0xc6310000), SPH_C32(0xca304571), SPH_C32(0xa8ea90ce),
    SPH_C32(0x385630bf), SPH_C32(0xc290fed9), SPH_C32(0x7afe0000),
    SPH_C32(0x53b60014), SPH_C32(0xbd420000), SPH_C32(0xf0860000),
    SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979), SPH_C32(0x1d3a76bf),
    SPH_C32(0x1bb6813d) },
  { SPH_C32(0xd5dc0000), SPH_C32(0x28da0084), SPH_C32(0xdaa00000),
    SPH_C32(0x7d240000), SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a),
    SPH_C32(0x87fef24b), SPH_C32(0x90daf380), SPH_C32(0x2eae0000),
    SPH_C32(0x55c70048), SPH_C32(0x98ec0000), SPH_C32(0x9a980000),
    SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b), SPH_C32(0xa2806e7c),
    SPH_C32(0x65c7dc2a) },
  { SPH_C32(0x818c0000), SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000),
    SPH_C32(0x173a0000), SPH_C32(0x64283db5), SPH_C32(0xea4c0898),
    SPH_C32(0x3844ea88), SPH_C32(0xeeabae97), SPH_C32(0x92230000),
    SPH_C32(0xa9fc0050), SPH_C32(0x816f0000), SPH_C32(0x4b930000),
    SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d), SPH_C32(0xa292b44b),
    SPH_C32(0x49fc8c64) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0x92230000), SPH_C32(0xa9fc0050), SPH_C32(0x816f0000),
    SPH_C32(0x4b930000), SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d),
    SPH_C32(0xa292b44b), SPH_C32(0x49fc8c64), SPH_C32(0x13af0000),
    SPH_C32(0x87570088), SPH_C32(0x7e610000), SPH_C32(0x5ca90000),
    SPH_C32(0x699c66ed), SPH_C32(0xf511dca5), SPH_C32(0x9ad65ec3),
    SPH_C32(0xa75722f3) },
  { SPH_C32(0x7afe0000), SPH_C32(0x53b60014), SPH_C32(0xbd420000),
    SPH_C32(0xf0860000), SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979),
    SPH_C32(0x1d3a76bf), SPH_C32(0x1bb6813d), SPH_C32(0x47ff0000),
    SPH_C32(0x812600d4), SPH_C32(0x5bcf0000), SPH_C32(0x36b70000),
    SPH_C32(0x47392832), SPH_C32(0x935f59b7), SPH_C32(0x256c4600),
    SPH_C32(0xd9267fe4) },
  { SPH_C32(0x2eae0000), SPH_C32(0x55c70048), SPH_C32(0x98ec0000),
    SPH_C32(0x9a980000), SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b),
    SPH_C32(0xa2806e7c), SPH_C32(0x65c7dc2a), SPH_C32(0xfb720000),
    SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000), SPH_C32(0xe7bc0000),
    SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1), SPH_C32(0x257e9c37),
    SPH_C32(0xf51d2faa) },
  { SPH_C32(0xaf220000), SPH_C32(0x7b6c0090), SPH_C32(0x67e20000),
    SPH_C32(0x8da20000), SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3),
    SPH_C32(0x9ac484f4), SPH_C32(0x8b6c72bd), SPH_C32(0x69510000),
    SPH_C32(0xd4e1009c), SPH_C32(0xc3230000), SPH_C32(0xac2f0000),
    SPH_C32(0xe4950bae), SPH_C32(0xcea415dc), SPH_C32(0x87ec287c),
    SPH_C32(0xbce1a3ce) },
  { SPH_C32(0xfb720000), SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000),
    SPH_C32(0xe7bc0000), SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1),
    SPH_C32(0x257e9c37), SPH_C32(0xf51d2faa), SPH_C32(0xd5dc0000),
    SPH_C32(0x28da0084), SPH_C32(0xdaa00000), SPH_C32(0x7d240000),
    SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a), SPH_C32(0x87fef24b),
    SPH_C32(0x90daf380) },
  { SPH_C32(0x13af0000), SPH_C32(0x87570088), SPH_C32(0x7e610000),
    SPH_C32(0x5ca90000), SPH_C32(0x699c66ed), SPH_C32(0xf511dca5),
    SPH_C32(0x9ad65ec3), SPH_C32(0xa75722f3), SPH_C32(0x818c0000),
    SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000), SPH_C32(0x173a0000),
    SPH_C32(0x64283db5), SPH_C32(0xea4c0898), SPH_C32(0x3844ea88),
    SPH_C32(0xeeabae97) },
  { SPH_C32(0x47ff0000), SPH_C32(0x812600d4), SPH_C32(0x5bcf0000),
    SPH_C32(0x36b70000), SPH_C32(0x47392832), SPH_C32(0x935f59b7),
    SPH_C32(0x256c4600), SPH_C32(0xd9267fe4), SPH_C32(0x3d010000),
    SPH_C32(0xd29000c0), SPH_C32(0xe68d0000), SPH_C32(0xc6310000),
    SPH_C32(0xca304571), SPH_C32(0xa8ea90ce), SPH_C32(0x385630bf),
    SPH_C32(0xc290fed9) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0x58220000), SPH_C32(0x4f940f5c), SPH_C32(0x67d70000),
    SPH_C32(0x36f40000), SPH_C32(0x1d0f7ec5), SPH_C32(0x73cca006),
    SPH_C32(0x2a1953b8), SPH_C32(0xca3a5d87), SPH_C32(0x42af0000),
    SPH_C32(0x5b630518), SPH_C32(0x3c520000), SPH_C32(0x266b0000),
    SPH_C32(0x2729001e), SPH_C32(0x5d726036), SPH_C32(0x4ec27922),
    SPH_C32(0x8d18afd1) },
  { SPH_C32(0xb0ff0000), SPH_C32(0xb5de0f18), SPH_C32(0x5bfa0000),
    SPH_C32(0x8de10000), SPH_C32(0x9db248de), SPH_C32(0x5724bd42),
    SPH_C32(0x95b1914c), SPH_C32(0x987050de), SPH_C32(0x16ff0000),
    SPH_C32(0x5d120544), SPH_C32(0x19fc0000), SPH_C32(0x4c750000),
    SPH_C32(0x098c4ec1), SPH_C32(0x3b3ce524), SPH_C32(0xf17861e1),
    SPH_C32(0xf369f2c6) },
  { SPH_C32(0xe4af0000), SPH_C32(0xb3af0f44), SPH_C32(0x7e540000),
    SPH_C32(0xe7ff0000), SPH_C32(0xb3170601), SPH_C32(0x316a3850),
    SPH_C32(0x2a0b898f), SPH_C32(0xe6010dc9), SPH_C32(0xaa720000),
    SPH_C32(0xa129055c), SPH_C32(0x007f0000), SPH_C32(0x9d7e0000),
    SPH_C32(0xa7943605), SPH_C32(0x799a7d72), SPH_C32(0xf16abbd6),
    SPH_C32(0xdf52a288) },
  { SPH_C32(0x65230000), SPH_C32(0x9d040f9c), SPH_C32(0x815a0000),
    SPH_C32(0xf0c50000), SPH_C32(0xd73f3bb4), SPH_C32(0xdb2630c8),
    SPH_C32(0x124f6307), SPH_C32(0x08aaa35e), SPH_C32(0x38510000),
    SPH_C32(0x08d5050c), SPH_C32(0x81100000), SPH_C32(0xd6ed0000),
    SPH_C32(0xaa206d5d), SPH_C32(0x66c7a94f), SPH_C32(0x53f80f9d),
    SPH_C32(0x96ae2eec) },
  { SPH_C32(0x31730000), SPH_C32(0x9b750fc0), SPH_C32(0xa4f40000),
    SPH_C32(0x9adb0000), SPH_C32(0xf99a756b), SPH_C32(0xbd68b5da),
    SPH_C32(0xadf57bc4), SPH_C32(0x76dbfe49), SPH_C32(0x84dc0000),
    SPH_C32(0xf4ee0514), SPH_C32(0x98930000), SPH_C32(0x07e60000),
    SPH_C32(0x04381599), SPH_C32(0x24613119), SPH_C32(0x53ead5aa),
    SPH_C32(0xba957ea2) },
  { SPH_C32(0xd9ae0000), SPH_C32(0x613f0f84), SPH_C32(0x98d90000),
    SPH_C32(0x21ce0000), SPH_C32(0x79274370), SPH_C32(0x9980a89e),
    SPH_C32(0x125db930), SPH_C32(0x2491f310), SPH_C32(0xd08c0000),
    SPH_C32(0xf29f0548), SPH_C32(0xbd3d0000), SPH_C32(0x6df80000),
    SPH_C32(0x2a9d5b46), SPH_C32(0x422fb40b), SPH_C32(0xec50cd69),
    SPH_C32(0xc4e423b5) },
  { SPH_C32(0x8dfe0000), SPH_C32(0x674e0fd8), SPH_C32(0xbd770000),
    SPH_C32(0x4bd00000), SPH_C32(0x57820daf), SPH_C32(0xffce2d8c),
    SPH_C32(0xade7a1f3), SPH_C32(0x5ae0ae07), SPH_C32(0x6c010000),
    SPH_C32(0x0ea40550), SPH_C32(0xa4be0000), SPH_C32(0xbcf30000),
    SPH_C32(0x84852382), SPH_C32(0x00892c5d), SPH_C32(0xec42175e),
    SPH_C32(0xe8df73fb) },
  { SPH_C32(0xca010000), SPH_C32(0xe6680f0c), SPH_C32(0xe6b80000),
    SPH_C32(0x7d670000), SPH_C32(0x10bb259d), SPH_C32(0x6c91743b),
    SPH_C32(0x888be7f3), SPH_C32(0x83c6d1e3), SPH_C32(0x51000000),
    SPH_C32(0xdc340590), SPH_C32(0x42330000), SPH_C32(0x7ac20000),
    SPH_C32(0x4eb566f3), SPH_C32(0xa863bc93), SPH_C32(0xd41427e1),
    SPH_C32(0x2a4f8d22) },
  { SPH_C32(0x9e510000), SPH_C32(0xe0190f50), SPH_C32(0xc3160000),
    SPH_C32(0x17790000), SPH_C32(0x3e1e6b42), SPH_C32(0x0adff129),
    SPH_C32(0x3731ff30), SPH_C32(0xfdb78cf4), SPH_C32(0xed8d0000),
    SPH_C32(0x200f0588), SPH_C32(0x5bb00000), SPH_C32(0xabc90000),
    SPH_C32(0xe0ad1e37), SPH_C32(0xeac524c5), SPH_C32(0xd406fdd6),
    SPH_C32(0x0674dd6c) },
  { SPH_C32(0x768c0000), SPH_C32(0x1a530f14), SPH_C32(0xff3b0000),
    SPH_C32(0xac6c0000), SPH_C32(0xbea35d59), SPH_C32(0x2e37ec6d),
    SPH_C32(0x88993dc4), SPH_C32(0xaffd81ad), SPH_C32(0xb9dd0000),
    SPH_C32(0x267e05d4), SPH_C32(0x7e1e0000), SPH_C32(0xc1d70000),
    SPH_C32(0xce0850e8), SPH_C32(0x8c8ba1d7), SPH_C32(0x6bbce515),
    SPH_C32(0x7805807b) },
  { SPH_C32(0x22dc0000), SPH_C32(0x1c220f48), SPH_C32(0xda950000),
    SPH_C32(0xc6720000), SPH_C32(0x90061386), SPH_C32(0x4879697f),
    SPH_C32(0x37232507), SPH_C32(0xd18cdcba), SPH_C32(0x05500000),
    SPH_C32(0xda4505cc), SPH_C32(0x679d0000), SPH_C32(0x10dc0000),
    SPH_C32(0x6010282c), SPH_C32(0xce2d3981), SPH_C32(0x6bae3f22),
    SPH_C32(0x543ed035) },
  { SPH_C32(0xa3500000), SPH_C32(0x32890f90), SPH_C32(0x259b0000),
    SPH_C32(0xd1480000), SPH_C32(0xf42e2e33), SPH_C32(0xa23561e7),
    SPH_C32(0x0f67cf8f), SPH_C32(0x3f27722d), SPH_C32(0x97730000),
    SPH_C32(0x73b9059c), SPH_C32(0xe6f20000), SPH_C32(0x5b4f0000),
    SPH_C32(0x6da47374), SPH_C32(0xd170edbc), SPH_C32(0xc93c8b69),
    SPH_C32(0x1dc25c51) },
  { SPH_C32(0xf7000000), SPH_C32(0x34f80fcc), SPH_C32(0x00350000),
    SPH_C32(0xbb560000), SPH_C32(0xda8b60ec), SPH_C32(0xc47be4f5),
    SPH_C32(0xb0ddd74c), SPH_C32(0x41562f3a), SPH_C32(0x2bfe0000),
    SPH_C32(0x8f820584), SPH_C32(0xff710000), SPH_C32(0x8a440000),
    SPH_C32(0xc3bc0bb0), SPH_C32(0x93d675ea), SPH_C32(0xc92e515e),
    SPH_C32(0x31f90c1f) },
  { SPH_C32(0x1fdd0000), SPH_C32(0xceb20f88), SPH_C32(0x3c180000),
    SPH_C32(0x00430000), SPH_C32(0x5a3656f7), SPH_C32(0xe093f9b1),
    SPH_C32(0x0f7515b8), SPH_C32(0x131c2263), SPH_C32(0x7fae0000),
    SPH_C32(0x89f305d8), SPH_C32(0xdadf0000), SPH_C32(0xe05a0000),
    SPH_C32(0xed19456f), SPH_C32(0xf598f0f8), SPH_C32(0x7694499d),
    SPH_C32(0x4f885108) },
  { SPH_C32(0x4b8d0000), SPH_C32(0xc8c30fd4), SPH_C32(0x19b60000),
    SPH_C32(0x6a5d0000), SPH_C32(0x74931828), SPH_C32(0x86dd7ca3),
    SPH_C32(0xb0cf0d7b), SPH_C32(0x6d6d7f74), SPH_C32(0xc3230000),
    SPH_C32(0x75c805c0), SPH_C32(0xc35c0000), SPH_C32(0x31510000),
    SPH_C32(0x43013dab), SPH_C32(0xb73e68ae), SPH_C32(0x768693aa),
    SPH_C32(0x63b30146) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0xaa720000), SPH_C32(0xa129055c), SPH_C32(0x007f0000),
    SPH_C32(0x9d7e0000), SPH_C32(0xa7943605), SPH_C32(0x799a7d72),
    SPH_C32(0xf16abbd6), SPH_C32(0xdf52a288), SPH_C32(0x4edd0000),
    SPH_C32(0x12860a18), SPH_C32(0x7e2b0000), SPH_C32(0x7a810000),
    SPH_C32(0x14833004), SPH_C32(0x48f04522), SPH_C32(0xdb613259),
    SPH_C32(0x3953af41) },
  { SPH_C32(0x42af0000), SPH_C32(0x5b630518), SPH_C32(0x3c520000),
    SPH_C32(0x266b0000), SPH_C32(0x2729001e), SPH_C32(0x5d726036),
    SPH_C32(0x4ec27922), SPH_C32(0x8d18afd1), SPH_C32(0x1a8d0000),
    SPH_C32(0x14f70a44), SPH_C32(0x5b850000), SPH_C32(0x109f0000),
    SPH_C32(0x3a267edb), SPH_C32(0x2ebec030), SPH_C32(0x64db2a9a),
    SPH_C32(0x4722f256) },
  { SPH_C32(0x16ff0000), SPH_C32(0x5d120544), SPH_C32(0x19fc0000),
    SPH_C32(0x4c750000), SPH_C32(0x098c4ec1), SPH_C32(0x3b3ce524),
    SPH_C32(0xf17861e1), SPH_C32(0xf369f2c6), SPH_C32(0xa6000000),
    SPH_C32(0xe8cc0a5c), SPH_C32(0x42060000), SPH_C32(0xc1940000),
    SPH_C32(0x943e061f), SPH_C32(0x6c185866), SPH_C32(0x64c9f0ad),
    SPH_C32(0x6b19a218) },
  { SPH_C32(0x97730000), SPH_C32(0x73b9059c), SPH_C32(0xe6f20000),
    SPH_C32(0x5b4f0000), SPH_C32(0x6da47374), SPH_C32(0xd170edbc),
    SPH_C32(0xc93c8b69), SPH_C32(0x1dc25c51), SPH_C32(0x34230000),
    SPH_C32(0x41300a0c), SPH_C32(0xc3690000), SPH_C32(0x8a070000),
    SPH_C32(0x998a5d47), SPH_C32(0x73458c5b), SPH_C32(0xc65b44e6),
    SPH_C32(0x22e52e7c) },
  { SPH_C32(0xc3230000), SPH_C32(0x75c805c0), SPH_C32(0xc35c0000),
    SPH_C32(0x31510000), SPH_C32(0x43013dab), SPH_C32(0xb73e68ae),
    SPH_C32(0x768693aa), SPH_C32(0x63b30146), SPH_C32(0x88ae0000),
    SPH_C32(0xbd0b0a14), SPH_C32(0xdaea0000), SPH_C32(0x5b0c0000),
    SPH_C32(0x37922583), SPH_C32(0x31e3140d), SPH_C32(0xc6499ed1),
    SPH_C32(0x0ede7e32) },
  { SPH_C32(0x2bfe0000), SPH_C32(0x8f820584), SPH_C32(0xff710000),
    SPH_C32(0x8a440000), SPH_C32(0xc3bc0bb0), SPH_C32(0x93d675ea),
    SPH_C32(0xc92e515e), SPH_C32(0x31f90c1f), SPH_C32(0xdcfe0000),
    SPH_C32(0xbb7a0a48), SPH_C32(0xff440000), SPH_C32(0x31120000),
    SPH_C32(0x19376b5c), SPH_C32(0x57ad911f), SPH_C32(0x79f38612),
    SPH_C32(0x70af2325) },
  { SPH_C32(0x7fae0000), SPH_C32(0x89f305d8), SPH_C32(0xdadf0000),
    SPH_C32(0xe05a0000), SPH_C32(0xed19456f), SPH_C32(0xf598f0f8),
    SPH_C32(0x7694499d), SPH_C32(0x4f885108), SPH_C32(0x60730000),
    SPH_C32(0x47410a50), SPH_C32(0xe6c70000), SPH_C32(0xe0190000),
    SPH_C32(0xb72f1398), SPH_C32(0x150b0949), SPH_C32(0x79e15c25),
    SPH_C32(0x5c94736b) },
  { SPH_C32(0x38510000), SPH_C32(0x08d5050c), SPH_C32(0x81100000),
    SPH_C32(0xd6ed0000), SPH_C32(0xaa206d5d), SPH_C32(0x66c7a94f),
    SPH_C32(0x53f80f9d), SPH_C32(0x96ae2eec), SPH_C32(0x5d720000),
    SPH_C32(0x95d10a90), SPH_C32(0x004a0000), SPH_C32(0x26280000),
    SPH_C32(0x7d1f56e9), SPH_C32(0xbde19987), SPH_C32(0x41b76c9a),
    SPH_C32(0x9e048db2) },
  { SPH_C32(0x6c010000), SPH_C32(0x0ea40550), SPH_C32(0xa4be0000),
    SPH_C32(0xbcf30000), SPH_C32(0x84852382), SPH_C32(0x00892c5d),
    SPH_C32(0xec42175e), SPH_C32(0xe8df73fb), SPH_C32(0xe1ff0000),
    SPH_C32(0x69ea0a88), SPH_C32(0x19c90000), SPH_C32(0xf7230000),
    SPH_C32(0xd3072e2d), SPH_C32(0xff4701d1), SPH_C32(0x41a5b6ad),
    SPH_C32(0xb23fddfc) },
  { SPH_C32(0x84dc0000), SPH_C32(0xf4ee0514), SPH_C32(0x98930000),
    SPH_C32(0x07e60000), SPH_C32(0x04381599), SPH_C32(0x24613119),
    SPH_C32(0x53ead5aa), SPH_C32(0xba957ea2), SPH_C32(0xb5af0000),
    SPH_C32(0x6f9b0ad4), SPH_C32(0x3c670000), SPH_C32(0x9d3d0000),
    SPH_C32(0xfda260f2), SPH_C32(0x990984c3), SPH_C32(0xfe1fae6e),
    SPH_C32(0xcc4e80eb) },
  { SPH_C32(0xd08c0000), SPH_C32(0xf29f0548), SPH_C32(0xbd3d0000),
    SPH_C32(0x6df80000), SPH_C32(0x2a9d5b46), SPH_C32(0x422fb40b),
    SPH_C32(0xec50cd69), SPH_C32(0xc4e423b5), SPH_C32(0x09220000),
    SPH_C32(0x93a00acc), SPH_C32(0x25e40000), SPH_C32(0x4c360000),
    SPH_C32(0x53ba1836), SPH_C32(0xdbaf1c95), SPH_C32(0xfe0d7459),
    SPH_C32(0xe075d0a5) },
  { SPH_C32(0x51000000), SPH_C32(0xdc340590), SPH_C32(0x42330000),
    SPH_C32(0x7ac20000), SPH_C32(0x4eb566f3), SPH_C32(0xa863bc93),
    SPH_C32(0xd41427e1), SPH_C32(0x2a4f8d22), SPH_C32(0x9b010000),
    SPH_C32(0x3a5c0a9c), SPH_C32(0xa48b0000), SPH_C32(0x07a50000),
    SPH_C32(0x5e0e436e), SPH_C32(0xc4f2c8a8), SPH_C32(0x5c9fc012),
    SPH_C32(0xa9895cc1) },
  { SPH_C32(0x05500000), SPH_C32(0xda4505cc), SPH_C32(0x679d0000),
    SPH_C32(0x10dc0000), SPH_C32(0x6010282c), SPH_C32(0xce2d3981),
    SPH_C32(0x6bae3f22), SPH_C32(0x543ed035), SPH_C32(0x278c0000),
    SPH_C32(0xc6670a84), SPH_C32(0xbd080000), SPH_C32(0xd6ae0000),
    SPH_C32(0xf0163baa), SPH_C32(0x865450fe), SPH_C32(0x5c8d1a25),
    SPH_C32(0x85b20c8f) },
  { SPH_C32(0xed8d0000), SPH_C32(0x200f0588), SPH_C32(0x5bb00000),
    SPH_C32(0xabc90000), SPH_C32(0xe0ad1e37), SPH_C32(0xeac524c5),
    SPH_C32(0xd406fdd6), SPH_C32(0x0674dd6c), SPH_C32(0x73dc0000),
    SPH_C32(0xc0160ad8), SPH_C32(0x98a60000), SPH_C32(0xbcb00000),
    SPH_C32(0xdeb37575), SPH_C32(0xe01ad5ec), SPH_C32(0xe33702e6),
    SPH_C32(0xfbc35198) },
  { SPH_C32(0xb9dd0000), SPH_C32(0x267e05d4), SPH_C32(0x7e1e0000),
    SPH_C32(0xc1d70000), SPH_C32(0xce0850e8), SPH_C32(0x8c8ba1d7),
    SPH_C32(0x6bbce515), SPH_C32(0x7805807b), SPH_C32(0xcf510000),
    SPH_C32(0x3c2d0ac0), SPH_C32(0x81250000), SPH_C32(0x6dbb0000),
    SPH_C32(0x70ab0db1), SPH_C32(0xa2bc4dba), SPH_C32(0xe325d8d1),
    SPH_C32(0xd7f801d6) },
  { SPH_C32(0xf2500000), SPH_C32(0xeebd0a00), SPH_C32(0x67a80000),
    SPH_C32(0xab8a0000), SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74),
    SPH_C32(0xdb73e86e), SPH_C32(0x1568ff0f), SPH_C32(0x0c720000),
    SPH_C32(0x49e50f00), SPH_C32(0x42790000), SPH_C32(0x5cea0000),
    SPH_C32(0x33aa301a), SPH_C32(0x15822514), SPH_C32(0x95a34b7b),
    SPH_C32(0xb44b0090) },
  { SPH_C32(0xa6000000), SPH_C32(0xe8cc0a5c), SPH_C32(0x42060000),
    SPH_C32(0xc1940000), SPH_C32(0x943e061f), SPH_C32(0x6c185866),
    SPH_C32(0x64c9f0ad), SPH_C32(0x6b19a218), SPH_C32(0xb0ff0000),
    SPH_C32(0xb5de0f18), SPH_C32(0x5bfa0000), SPH_C32(0x8de10000),
    SPH_C32(0x9db248de), SPH_C32(0x5724bd42), SPH_C32(0x95b1914c),
    SPH_C32(0x987050de) },
  { SPH_C32(0x4edd0000), SPH_C32(0x12860a18), SPH_C32(0x7e2b0000),
    SPH_C32(0x7a810000), SPH_C32(0x14833004), SPH_C32(0x48f04522),
    SPH_C32(0xdb613259), SPH_C32(0x3953af41), SPH_C32(0xe4af0000),
    SPH_C32(0xb3af0f44), SPH_C32(0x7e540000), SPH_C32(0xe7ff0000),
    SPH_C32(0xb3170601), SPH_C32(0x316a3850), SPH_C32(0x2a0b898f),
    SPH_C32(0xe6010dc9) },
  { SPH_C32(0x1a8d0000), SPH_C32(0x14f70a44), SPH_C32(0x5b850000),
    SPH_C32(0x109f0000), SPH_C32(0x3a267edb), SPH_C32(0x2ebec030),
    SPH_C32(0x64db2a9a), SPH_C32(0x4722f256), SPH_C32(0x58220000),
    SPH_C32(0x4f940f5c), SPH_C32(0x67d70000), SPH_C32(0x36f40000),
    SPH_C32(0x1d0f7ec5), SPH_C32(0x73cca006), SPH_C32(0x2a1953b8),
    SPH_C32(0xca3a5d87) },
  { SPH_C32(0x9b010000), SPH_C32(0x3a5c0a9c), SPH_C32(0xa48b0000),
    SPH_C32(0x07a50000), SPH_C32(0x5e0e436e), SPH_C32(0xc4f2c8a8),
    SPH_C32(0x5c9fc012), SPH_C32(0xa9895cc1), SPH_C32(0xca010000),
    SPH_C32(0xe6680f0c), SPH_C32(0xe6b80000), SPH_C32(0x7d670000),
    SPH_C32(0x10bb259d), SPH_C32(0x6c91743b), SPH_C32(0x888be7f3),
    SPH_C32(0x83c6d1e3) },
  { SPH_C32(0xcf510000), SPH_C32(0x3c2d0ac0), SPH_C32(0x81250000),
    SPH_C32(0x6dbb0000), SPH_C32(0x70ab0db1), SPH_C32(0xa2bc4dba),
    SPH_C32(0xe325d8d1), SPH_C32(0xd7f801d6), SPH_C32(0x768c0000),
    SPH_C32(0x1a530f14), SPH_C32(0xff3b0000), SPH_C32(0xac6c0000),
    SPH_C32(0xbea35d59), SPH_C32(0x2e37ec6d), SPH_C32(0x88993dc4),
    SPH_C32(0xaffd81ad) },
  { SPH_C32(0x278c0000), SPH_C32(0xc6670a84), SPH_C32(0xbd080000),
    SPH_C32(0xd6ae0000), SPH_C32(0xf0163baa), SPH_C32(0x865450fe),
    SPH_C32(0x5c8d1a25), SPH_C32(0x85b20c8f), SPH_C32(0x22dc0000),
    SPH_C32(0x1c220f48), SPH_C32(0xda950000), SPH_C32(0xc6720000),
    SPH_C32(0x90061386), SPH_C32(0x4879697f), SPH_C32(0x37232507),
    SPH_C32(0xd18cdcba) },
  { SPH_C32(0x73dc0000), SPH_C32(0xc0160ad8), SPH_C32(0x98a60000),
    SPH_C32(0xbcb00000), SPH_C32(0xdeb37575), SPH_C32(0xe01ad5ec),
    SPH_C32(0xe33702e6), SPH_C32(0xfbc35198), SPH_C32(0x9e510000),
    SPH_C32(0xe0190f50), SPH_C32(0xc3160000), SPH_C32(0x17790000),
    SPH_C32(0x3e1e6b42), SPH_C32(0x0adff129), SPH_C32(0x3731ff30),
    SPH_C32(0xfdb78cf4) },
  { SPH_C32(0x34230000), SPH_C32(0x41300a0c), SPH_C32(0xc3690000),
    SPH_C32(0x8a070000), SPH_C32(0x998a5d47), SPH_C32(0x73458c5b),
    SPH_C32(0xc65b44e6), SPH_C32(0x22e52e7c), SPH_C32(0xa3500000),
    SPH_C32(0x32890f90), SPH_C32(0x259b0000), SPH_C32(0xd1480000),
    SPH_C32(0xf42e2e33), SPH_C32(0xa23561e7), SPH_C32(0x0f67cf8f),
    SPH_C32(0x3f27722d) },
  { SPH_C32(0x60730000), SPH_C32(0x47410a50), SPH_C32(0xe6c70000),
    SPH_C32(0xe0190000), SPH_C32(0xb72f1398), SPH_C32(0x150b0949),
    SPH_C32(0x79e15c25), SPH_C32(0x5c94736b), SPH_C32(0x1fdd0000),
    SPH_C32(0xceb20f88), SPH_C32(0x3c180000), SPH_C32(0x00430000),
    SPH_C32(0x5a3656f7), SPH_C32(0xe093f9b1), SPH_C32(0x0f7515b8),
    SPH_C32(0x131c2263) },
  { SPH_C32(0x88ae0000), SPH_C32(0xbd0b0a14), SPH_C32(0xdaea0000),
    SPH_C32(0x5b0c0000), SPH_C32(0x37922583), SPH_C32(0x31e3140d),
    SPH_C32(0xc6499ed1), SPH_C32(0x0ede7e32), SPH_C32(0x4b8d0000),
    SPH_C32(0xc8c30fd4), SPH_C32(0x19b60000), SPH_C32(0x6a5d0000),
    SPH_C32(0x74931828), SPH_C32(0x86dd7ca3), SPH_C32(0xb0cf0d7b),
    SPH_C32(0x6d6d7f74) },
  { SPH_C32(0xdcfe0000), SPH_C32(0xbb7a0a48), SPH_C32(0xff440000),
    SPH_C32(0x31120000), SPH_C32(0x19376b5c), SPH_C32(0x57ad911f),
    SPH_C32(0x79f38612), SPH_C32(0x70af2325), SPH_C32(0xf7000000),
    SPH_C32(0x34f80fcc), SPH_C32(0x00350000), SPH_C32(0xbb560000),
    SPH_C32(0xda8b60ec), SPH_C32(0xc47be4f5), SPH_C32(0xb0ddd74c),
    SPH_C32(0x41562f3a) },
  { SPH_C32(0x5d720000), SPH_C32(0x95d10a90), SPH_C32(0x004a0000),
    SPH_C32(0x26280000), SPH_C32(0x7d1f56e9), SPH_C32(0xbde19987),
    SPH_C32(0x41b76c9a), SPH_C32(0x9e048db2), SPH_C32(0x65230000),
    SPH_C32(0x9d040f9c), SPH_C32(0x815a0000), SPH_C32(0xf0c50000),
    SPH_C32(0xd73f3bb4), SPH_C32(0xdb2630c8), SPH_C32(0x124f6307),
    SPH_C32(0x08aaa35e) },
  { SPH_C32(0x09220000), SPH_C32(0x93a00acc), SPH_C32(0x25e40000),
    SPH_C32(0x4c360000), SPH_C32(0x53ba1836), SPH_C32(0xdbaf1c95),
    SPH_C32(0xfe0d7459), SPH_C32(0xe075d0a5), SPH_C32(0xd9ae0000),
    SPH_C32(0x613f0f84), SPH_C32(0x98d90000), SPH_C32(0x21ce0000),
    SPH_C32(0x79274370), SPH_C32(0x9980a89e), SPH_C32(0x125db930),
    SPH_C32(0x2491f310) },
  { SPH_C32(0xe1ff0000), SPH_C32(0x69ea0a88), SPH_C32(0x19c90000),
    SPH_C32(0xf7230000), SPH_C32(0xd3072e2d), SPH_C32(0xff4701d1),
    SPH_C32(0x41a5b6ad), SPH_C32(0xb23fddfc), SPH_C32(0x8dfe0000),
    SPH_C32(0x674e0fd8), SPH_C32(0xbd770000), SPH_C32(0x4bd00000),
    SPH_C32(0x57820daf), SPH_C32(0xffce2d8c), SPH_C32(0xade7a1f3),
    SPH_C32(0x5ae0ae07) },
  { SPH_C32(0xb5af0000), SPH_C32(0x6f9b0ad4), SPH_C32(0x3c670000),
    SPH_C32(0x9d3d0000), SPH_C32(0xfda260f2), SPH_C32(0x990984c3),
    SPH_C32(0xfe1fae6e), SPH_C32(0xcc4e80eb), SPH_C32(0x31730000),
    SPH_C32(0x9b750fc0), SPH_C32(0xa4f40000), SPH_C32(0x9adb0000),
    SPH_C32(0xf99a756b), SPH_C32(0xbd68b5da), SPH_C32(0xadf57bc4),
    SPH_C32(0x76dbfe49) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0x11480000), SPH_C32(0xa3c4175c), SPH_C32(0xdcc40000),
    SPH_C32(0x51560000), SPH_C32(0x30695af3), SPH_C32(0x455d10c4),
    SPH_C32(0xa906be73), SPH_C32(0xa142a9c8), SPH_C32(0x04b00000),
    SPH_C32(0xea4a0618), SPH_C32(0x2e190000), SPH_C32(0x24ba0000),
    SPH_C32(0x8c991968), SPH_C32(0xecee6913), SPH_C32(0x6636cc21),
    SPH_C32(0xe9fabb70) },
  { SPH_C32(0xf9950000), SPH_C32(0x598e1718), SPH_C32(0xe0e90000),
    SPH_C32(0xea430000), SPH_C32(0xb0d46ce8), SPH_C32(0x61b50d80),
    SPH_C32(0x16ae7c87), SPH_C32(0xf308a491), SPH_C32(0x50e00000),
    SPH_C32(0xec3b0644), SPH_C32(0x0bb70000), SPH_C32(0x4ea40000),
    SPH_C32(0xa23c57b7), SPH_C32(0x8aa0ec01), SPH_C32(0xd98cd4e2),
    SPH_C32(0x978be667) },
  { SPH_C32(0xadc50000), SPH_C32(0x5fff1744), SPH_C32(0xc5470000),
    SPH_C32(0x805d0000), SPH_C32(0x9e712237), SPH_C32(0x07fb8892),
    SPH_C32(0xa9146444), SPH_C32(0x8d79f986), SPH_C32(0xec6d0000),
    SPH_C32(0x1000065c), SPH_C32(0x12340000), SPH_C32(0x9faf0000),
    SPH_C32(0x0c242f73), SPH_C32(0xc8067457), SPH_C32(0xd99e0ed5),
    SPH_C32(0xbbb0b629) },
  { SPH_C32(0x2c490000), SPH_C32(0x7154179c), SPH_C32(0x3a490000),
    SPH_C32(0x97670000), SPH_C32(0xfa591f82), SPH_C32(0xedb7800a),
    SPH_C32(0x91508ecc), SPH_C32(0x63d25711), SPH_C32(0x7e4e0000),
    SPH_C32(0xb9fc060c), SPH_C32(0x935b0000), SPH_C32(0xd43c0000),
    SPH_C32(0x0190742b), SPH_C32(0xd75ba06a), SPH_C32(0x7b0cba9e),
    SPH_C32(0xf24c3a4d) },
  { SPH_C32(0x78190000), SPH_C32(0x772517c0), SPH_C32(0x1fe70000),
    SPH_C32(0xfd790000), SPH_C32(0xd4fc515d), SPH_C32(0x8bf90518),
    SPH_C32(0x2eea960f), SPH_C32(0x1da30a06), SPH_C32(0xc2c30000),
    SPH_C32(0x45c70614), SPH_C32(0x8ad80000), SPH_C32(0x05370000),
    SPH_C32(0xaf880cef), SPH_C32(0x95fd383c), SPH_C32(0x7b1e60a9),
    SPH_C32(0xde776a03) },
  { SPH_C32(0x90c40000), SPH_C32(0x8d6f1784), SPH_C32(0x23ca0000),
    SPH_C32(0x466c0000), SPH_C32(0x54416746), SPH_C32(0xaf11185c),
    SPH_C32(0x914254fb), SPH_C32(0x4fe9075f), SPH_C32(0x96930000),
    SPH_C32(0x43b60648), SPH_C32(0xaf760000), SPH_C32(0x6f290000),
    SPH_C32(0x812d4230), SPH_C32(0xf3b3bd2e), SPH_C32(0xc4a4786a),
    SPH_C32(0xa0063714) },
  { SPH_C32(0xc4940000), SPH_C32(0x8b1e17d8), SPH_C32(0x06640000),
    SPH_C32(0x2c720000), SPH_C32(0x7ae42999), SPH_C32(0xc95f9d4e),
    SPH_C32(0x2ef84c38), SPH_C32(0x31985a48), SPH_C32(0x2a1e0000),
    SPH_C32(0xbf8d0650), SPH_C32(0xb6f50000), SPH_C32(0xbe220000),
    SPH_C32(0x2f353af4), SPH_C32(0xb1152578), SPH_C32(0xc4b6a25d),
    SPH_C32(0x8c3d675a) },
  { SPH_C32(0x836b0000), SPH_C32(0x0a38170c), SPH_C32(0x5dab0000),
    SPH_C32(0x1ac50000), SPH_C32(0x3ddd01ab), SPH_C32(0x5a00c4f9),
    SPH_C32(0x0b940a38), SPH_C32(0xe8be25ac), SPH_C32(0x171f0000),
    SPH_C32(0x6d1d0690), SPH_C32(0x50780000), SPH_C32(0x78130000),
    SPH_C32(0xe5057f85), SPH_C32(0x19ffb5b6), SPH_C32(0xfce092e2),
    SPH_C32(0x4ead9983) },
  { SPH_C32(0xd73b0000), SPH_C32(0x0c491750), SPH_C32(0x78050000),
    SPH_C32(0x70db0000), SPH_C32(0x13784f74), SPH_C32(0x3c4e41eb),
    SPH_C32(0xb42e12fb), SPH_C32(0x96cf78bb), SPH_C32(0xab920000),
    SPH_C32(0x91260688), SPH_C32(0x49fb0000), SPH_C32(0xa9180000),
    SPH_C32(0x4b1d0741), SPH_C32(0x5b592de0), SPH_C32(0xfcf248d5),
    SPH_C32(0x6296c9cd) },
  { SPH_C32(0x3fe60000), SPH_C32(0xf6031714), SPH_C32(0x44280000),
    SPH_C32(0xcbce0000), SPH_C32(0x93c5796f), SPH_C32(0x18a65caf),
    SPH_C32(0x0b86d00f), SPH_C32(0xc48575e2), SPH_C32(0xffc20000),
    SPH_C32(0x975706d4), SPH_C32(0x6c550000), SPH_C32(0xc3060000),
    SPH_C32(0x65b8499e), SPH_C32(0x3d17a8f2), SPH_C32(0x43485016),
    SPH_C32(0x1ce794da) },
  { SPH_C32(0x6bb60000), SPH_C32(0xf0721748), SPH_C32(0x61860000),
    SPH_C32(0xa1d00000), SPH_C32(0xbd6037b0), SPH_C32(0x7ee8d9bd),
    SPH_C32(0xb43cc8cc), SPH_C32(0xbaf428f5), SPH_C32(0x434f0000),
    SPH_C32(0x6b6c06cc), SPH_C32(0x75d60000), SPH_C32(0x120d0000),
    SPH_C32(0xcba0315a), SPH_C32(0x7fb130a4), SPH_C32(0x435a8a21),
    SPH_C32(0x30dcc494) },
  { SPH_C32(0xea3a0000), SPH_C32(0xded91790), SPH_C32(0x9e880000),
    SPH_C32(0xb6ea0000), SPH_C32(0xd9480a05), SPH_C32(0x94a4d125),
    SPH_C32(0x8c782244), SPH_C32(0x545f8662), SPH_C32(0xd16c0000),
    SPH_C32(0xc290069c), SPH_C32(0xf4b90000), SPH_C32(0x599e0000),
    SPH_C32(0xc6146a02), SPH_C32(0x60ece499), SPH_C32(0xe1c83e6a),
    SPH_C32(0x792048f0) },
  { SPH_C32(0xbe6a0000), SPH_C32(0xd8a817cc), SPH_C32(0xbb260000),
    SPH_C32(0xdcf40000), SPH_C32(0xf7ed44da), SPH_C32(0xf2ea5437),
    SPH_C32(0x33c23a87), SPH_C32(0x2a2edb75), SPH_C32(0x6de10000),
    SPH_C32(0x3eab0684), SPH_C32(0xed3a0000), SPH_C32(0x88950000),
    SPH_C32(0x680c12c6), SPH_C32(0x224a7ccf), SPH_C32(0xe1dae45d),
    SPH_C32(0x551b18be) },
  { SPH_C32(0x56b70000), SPH_C32(0x22e21788), SPH_C32(0x870b0000),
    SPH_C32(0x67e10000), SPH_C32(0x775072c1), SPH_C32(0xd6024973),
    SPH_C32(0x8c6af873), SPH_C32(0x7864d62c), SPH_C32(0x39b10000),
    SPH_C32(0x38da06d8), SPH_C32(0xc8940000), SPH_C32(0xe28b0000),
    SPH_C32(0x46a95c19), SPH_C32(0x4404f9dd), SPH_C32(0x5e60fc9e),
    SPH_C32(0x2b6a45a9) },
  { SPH_C32(0x02e70000), SPH_C32(0x249317d4), SPH_C32(0xa2a50000),
    SPH_C32(0x0dff0000), SPH_C32(0x59f53c1e), SPH_C32(0xb04ccc61),
    SPH_C32(0x33d0e0b0), SPH_C32(0x06158b3b), SPH_C32(0x853c0000),
    SPH_C32(0xc4e106c0), SPH_C32(0xd1170000), SPH_C32(0x33800000),
    SPH_C32(0xe8b124dd), SPH_C32(0x06a2618b), SPH_C32(0x5e7226a9),
    SPH_C32(0x075115e7) },
  { SPH_C32(0x496a0000), SPH_C32(0xec501800), SPH_C32(0xbb130000),
    SPH_C32(0x67a20000), SPH_C32(0x2d662436), SPH_C32(0x3691b0c2),
    SPH_C32(0x831fedcb), SPH_C32(0x6b78f44f), SPH_C32(0x461f0000),
    SPH_C32(0xb1290300), SPH_C32(0x124b0000), SPH_C32(0x02d10000),
    SPH_C32(0xabb01976), SPH_C32(0xb19c0925), SPH_C32(0x28f4b503),
    SPH_C32(0x64e214a1) },
  { SPH_C32(0x1d3a0000), SPH_C32(0xea21185c), SPH_C32(0x9ebd0000),
    SPH_C32(0x0dbc0000), SPH_C32(0x03c36ae9), SPH_C32(0x50df35d0),
    SPH_C32(0x3ca5f508), SPH_C32(0x1509a958), SPH_C32(0xfa920000),
    SPH_C32(0x4d120318), SPH_C32(0x0bc80000), SPH_C32(0xd3da0000),
    SPH_C32(0x05a861b2), SPH_C32(0xf33a9173), SPH_C32(0x28e66f34),
    SPH_C32(0x48d944ef) },
  { SPH_C32(0xf5e70000), SPH_C32(0x106b1818), SPH_C32(0xa2900000),
    SPH_C32(0xb6a90000), SPH_C32(0x837e5cf2), SPH_C32(0x74372894),
    SPH_C32(0x830d37fc), SPH_C32(0x4743a401), SPH_C32(0xaec20000),
    SPH_C32(0x4b630344), SPH_C32(0x2e660000), SPH_C32(0xb9c40000),
    SPH_C32(0x2b0d2f6d), SPH_C32(0x95741461), SPH_C32(0x975c77f7),
    SPH_C32(0x36a819f8) },
  { SPH_C32(0xa1b70000), SPH_C32(0x161a1844), SPH_C32(0x873e0000),
    SPH_C32(0xdcb70000), SPH_C32(0xaddb122d), SPH_C32(0x1279ad86),
    SPH_C32(0x3cb72f3f), SPH_C32(0x3932f916), SPH_C32(0x124f0000),
    SPH_C32(0xb758035c), SPH_C32(0x37e50000), SPH_C32(0x68cf0000),
    SPH_C32(0x851557a9), SPH_C32(0xd7d28c37), SPH_C32(0x974eadc0),
    SPH_C32(0x1a9349b6) },
  { SPH_C32(0x203b0000), SPH_C32(0x38b1189c), SPH_C32(0x78300000),
    SPH_C32(0xcb8d0000), SPH_C32(0xc9f32f98), SPH_C32(0xf835a51e),
    SPH_C32(0x04f3c5b7), SPH_C32(0xd7995781), SPH_C32(0x806c0000),
    SPH_C32(0x1ea4030c), SPH_C32(0xb68a0000), SPH_C32(0x235c0000),
    SPH_C32(0x88a10cf1), SPH_C32(0xc88f580a), SPH_C32(0x35dc198b),
    SPH_C32(0x536fc5d2) },
  { SPH_C32(0x746b0000), SPH_C32(0x3ec018c0), SPH_C32(0x5d9e0000),
    SPH_C32(0xa1930000), SPH_C32(0xe7566147), SPH_C32(0x9e7b200c),
    SPH_C32(0xbb49dd74), SPH_C32(0xa9e80a96), SPH_C32(0x3ce10000),
    SPH_C32(0xe29f0314), SPH_C32(0xaf090000), SPH_C32(0xf2570000),
    SPH_C32(0x26b97435), SPH_C32(0x8a29c05c), SPH_C32(0x35cec3bc),
    SPH_C32(0x7f54959c) },
  { SPH_C32(0x9cb60000), SPH_C32(0xc48a1884), SPH_C32(0x61b30000),
    SPH_C32(0x1a860000), SPH_C32(0x67eb575c), SPH_C32(0xba933d48),
    SPH_C32(0x04e11f80), SPH_C32(0xfba207cf), SPH_C32(0x68b10000),
    SPH_C32(0xe4ee0348), SPH_C32(0x8aa70000), SPH_C32(0x98490000),
    SPH_C32(0x081c3aea), SPH_C32(0xec67454e), SPH_C32(0x8a74db7f),
    SPH_C32(0x0125c88b) },
  { SPH_C32(0xc8e60000), SPH_C32(0xc2fb18d8), SPH_C32(0x441d0000),
    SPH_C32(0x70980000), SPH_C32(0x494e1983), SPH_C32(0xdcddb85a),
    SPH_C32(0xbb5b0743), SPH_C32(0x85d35ad8), SPH_C32(0xd43c0000),
    SPH_C32(0x18d50350), SPH_C32(0x93240000), SPH_C32(0x49420000),
    SPH_C32(0xa604422e), SPH_C32(0xaec1dd18), SPH_C32(0x8a660148),
    SPH_C32(0x2d1e98c5) },
  { SPH_C32(0x8f190000), SPH_C32(0x43dd180c), SPH_C32(0x1fd20000),
    SPH_C32(0x462f0000), SPH_C32(0x0e7731b1), SPH_C32(0x4f82e1ed),
    SPH_C32(0x9e374143), SPH_C32(0x5cf5253c), SPH_C32(0xe93d0000),
    SPH_C32(0xca450390), SPH_C32(0x75a90000), SPH_C32(0x8f730000),
    SPH_C32(0x6c34075f), SPH_C32(0x062b4dd6), SPH_C32(0xb23031f7),
    SPH_C32(0xef8e661c) },
  { SPH_C32(0xdb490000), SPH_C32(0x45ac1850), SPH_C32(0x3a7c0000),
    SPH_C32(0x2c310000), SPH_C32(0x20d27f6e), SPH_C32(0x29cc64ff),
    SPH_C32(0x218d5980), SPH_C32(0x2284782b), SPH_C32(0x55b00000),
    SPH_C32(0x367e0388), SPH_C32(0x6c2a0000), SPH_C32(0x5e780000),
    SPH_C32(0xc22c7f9b), SPH_C32(0x448dd580), SPH_C32(0xb222ebc0),
    SPH_C32(0xc3b53652) },
  { SPH_C32(0x33940000), SPH_C32(0xbfe61814), SPH_C32(0x06510000),
    SPH_C32(0x97240000), SPH_C32(0xa06f4975), SPH_C32(0x0d2479bb),
    SPH_C32(0x9e259b74), SPH_C32(0x70ce7572), SPH_C32(0x01e00000),
    SPH_C32(0x300f03d4), SPH_C32(0x49840000), SPH_C32(0x34660000),
    SPH_C32(0xec893144), SPH_C32(0x22c35092), SPH_C32(0x0d98f303),
    SPH_C32(0xbdc46b45) },
  { SPH_C32(0x67c40000), SPH_C32(0xb9971848), SPH_C32(0x23ff0000),
    SPH_C32(0xfd3a0000), SPH_C32(0x8eca07aa), SPH_C32(0x6b6afca9),
    SPH_C32(0x219f83b7), SPH_C32(0x0ebf2865), SPH_C32(0xbd6d0000),
    SPH_C32(0xcc3403cc), SPH_C32(0x50070000), SPH_C32(0xe56d0000),
    SPH_C32(0x42914980), SPH_C32(0x6065c8c4), SPH_C32(0x0d8a2934),
    SPH_C32(0x91ff3b0b) },
  { SPH_C32(0xe6480000), SPH_C32(0x973c1890), SPH_C32(0xdcf10000),
    SPH_C32(0xea000000), SPH_C32(0xeae23a1f), SPH_C32(0x8126f431),
    SPH_C32(0x19db693f), SPH_C32(0xe01486f2), SPH_C32(0x2f4e0000),
    SPH_C32(0x65c8039c), SPH_C32(0xd1680000), SPH_C32(0xaefe0000),
    SPH_C32(0x4f2512d8), SPH_C32(0x7f381cf9), SPH_C32(0xaf189d7f),
    SPH_C32(0xd803b76f) },
  { SPH_C32(0xb2180000), SPH_C32(0x914d18cc), SPH_C32(0xf95f0000),
    SPH_C32(0x801e0000), SPH_C32(0xc44774c0), SPH_C32(0xe7687123),
    SPH_C32(0xa66171fc), SPH_C32(0x9e65dbe5), SPH_C32(0x93c30000),
    SPH_C32(0x99f30384), SPH_C32(0xc8eb0000), SPH_C32(0x7ff50000),
    SPH_C32(0xe13d6a1c), SPH_C32(0x3d9e84af), SPH_C32(0xaf0a4748),
    SPH_C32(0xf438e721) },
  { SPH_C32(0x5ac50000), SPH_C32(0x6b071888), SPH_C32(0xc5720000),
    SPH_C32(0x3b0b0000), SPH_C32(0x44fa42db), SPH_C32(0xc3806c67),
    SPH_C32(0x19c9b308), SPH_C32(0xcc2fd6bc), SPH_C32(0xc7930000),
    SPH_C32(0x9f8203d8), SPH_C32(0xed450000), SPH_C32(0x15eb0000),
    SPH_C32(0xcf9824c3), SPH_C32(0x5bd001bd), SPH_C32(0x10b05f8b),
    SPH_C32(0x8a49ba36) },
  { SPH_C32(0x0e950000), SPH_C32(0x6d7618d4), SPH_C32(0xe0dc0000),
    SPH_C32(0x51150000), SPH_C32(0x6a5f0c04), SPH_C32(0xa5cee975),
    SPH_C32(0xa673abcb), SPH_C32(0xb25e8bab), SPH_C32(0x7b1e0000),
    SPH_C32(0x63b903c0), SPH_C32(0xf4c60000), SPH_C32(0xc4e00000),
    SPH_C32(0x61805c07), SPH_C32(0x197699eb), SPH_C32(0x10a285bc),
    SPH_C32(0xa672ea78) },
  { SPH_C32(0xbb3a0000), SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000),
    SPH_C32(0xcc280000), SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6),
    SPH_C32(0x586c05a5), SPH_C32(0x7e100b40), SPH_C32(0x4a6d0000),
    SPH_C32(0xf8cc0c00), SPH_C32(0x50320000), SPH_C32(0x5e3b0000),
    SPH_C32(0x981a296c), SPH_C32(0xa41e2c31), SPH_C32(0xbd57fe78),
    SPH_C32(0xd0a91431) },
  { SPH_C32(0xef6a0000), SPH_C32(0x049c125c), SPH_C32(0xf9150000),
    SPH_C32(0xa6360000), SPH_C32(0xb9582229), SPH_C32(0x5a89e8a4),
    SPH_C32(0xe7d61d66), SPH_C32(0x00615657), SPH_C32(0xf6e00000),
    SPH_C32(0x04f70c18), SPH_C32(0x49b10000), SPH_C32(0x8f300000),
    SPH_C32(0x360251a8), SPH_C32(0xe6b8b467), SPH_C32(0xbd45244f),
    SPH_C32(0xfc92447f) },
  { SPH_C32(0x07b70000), SPH_C32(0xfed61218), SPH_C32(0xc5380000),
    SPH_C32(0x1d230000), SPH_C32(0x39e51432), SPH_C32(0x7e61f5e0),
    SPH_C32(0x587edf92), SPH_C32(0x522b5b0e), SPH_C32(0xa2b00000),
    SPH_C32(0x02860c44), SPH_C32(0x6c1f0000), SPH_C32(0xe52e0000),
    SPH_C32(0x18a71f77), SPH_C32(0x80f63175), SPH_C32(0x02ff3c8c),
    SPH_C32(0x82e31968) },
  { SPH_C32(0x53e70000), SPH_C32(0xf8a71244), SPH_C32(0xe0960000),
    SPH_C32(0x773d0000), SPH_C32(0x17405aed), SPH_C32(0x182f70f2),
    SPH_C32(0xe7c4c751), SPH_C32(0x2c5a0619), SPH_C32(0x1e3d0000),
    SPH_C32(0xfebd0c5c), SPH_C32(0x759c0000), SPH_C32(0x34250000),
    SPH_C32(0xb6bf67b3), SPH_C32(0xc250a923), SPH_C32(0x02ede6bb),
    SPH_C32(0xaed84926) },
  { SPH_C32(0xd26b0000), SPH_C32(0xd60c129c), SPH_C32(0x1f980000),
    SPH_C32(0x60070000), SPH_C32(0x73686758), SPH_C32(0xf263786a),
    SPH_C32(0xdf802dd9), SPH_C32(0xc2f1a88e), SPH_C32(0x8c1e0000),
    SPH_C32(0x57410c0c), SPH_C32(0xf4f30000), SPH_C32(0x7fb60000),
    SPH_C32(0xbb0b3ceb), SPH_C32(0xdd0d7d1e), SPH_C32(0xa07f52f0),
    SPH_C32(0xe724c542) },
  { SPH_C32(0x863b0000), SPH_C32(0xd07d12c0), SPH_C32(0x3a360000),
    SPH_C32(0x0a190000), SPH_C32(0x5dcd2987), SPH_C32(0x942dfd78),
    SPH_C32(0x603a351a), SPH_C32(0xbc80f599), SPH_C32(0x30930000),
    SPH_C32(0xab7a0c14), SPH_C32(0xed700000), SPH_C32(0xaebd0000),
    SPH_C32(0x1513442f), SPH_C32(0x9fabe548), SPH_C32(0xa06d88c7),
    SPH_C32(0xcb1f950c) },
  { SPH_C32(0x6ee60000), SPH_C32(0x2a371284), SPH_C32(0x061b0000),
    SPH_C32(0xb10c0000), SPH_C32(0xdd701f9c), SPH_C32(0xb0c5e03c),
    SPH_C32(0xdf92f7ee), SPH_C32(0xeecaf8c0), SPH_C32(0x64c30000),
    SPH_C32(0xad0b0c48), SPH_C32(0xc8de0000), SPH_C32(0xc4a30000),
    SPH_C32(0x3bb60af0), SPH_C32(0xf9e5605a), SPH_C32(0x1fd79004),
    SPH_C32(0xb56ec81b) },
  { SPH_C32(0x3ab60000), SPH_C32(0x2c4612d8), SPH_C32(0x23b50000),
    SPH_C32(0xdb120000), SPH_C32(0xf3d55143), SPH_C32(0xd68b652e),
    SPH_C32(0x6028ef2d), SPH_C32(0x90bba5d7), SPH_C32(0xd84e0000),
    SPH_C32(0x51300c50), SPH_C32(0xd15d0000), SPH_C32(0x15a80000),
    SPH_C32(0x95ae7234), SPH_C32(0xbb43f80c), SPH_C32(0x1fc54a33),
    SPH_C32(0x99559855) },
  { SPH_C32(0x7d490000), SPH_C32(0xad60120c), SPH_C32(0x787a0000),
    SPH_C32(0xeda50000), SPH_C32(0xb4ec7971), SPH_C32(0x45d43c99),
    SPH_C32(0x4544a92d), SPH_C32(0x499dda33), SPH_C32(0xe54f0000),
    SPH_C32(0x83a00c90), SPH_C32(0x37d00000), SPH_C32(0xd3990000),
    SPH_C32(0x5f9e3745), SPH_C32(0x13a968c2), SPH_C32(0x27937a8c),
    SPH_C32(0x5bc5668c) },
  { SPH_C32(0x29190000), SPH_C32(0xab111250), SPH_C32(0x5dd40000),
    SPH_C32(0x87bb0000), SPH_C32(0x9a4937ae), SPH_C32(0x239ab98b),
    SPH_C32(0xfafeb1ee), SPH_C32(0x37ec8724), SPH_C32(0x59c20000),
    SPH_C32(0x7f9b0c88), SPH_C32(0x2e530000), SPH_C32(0x02920000),
    SPH_C32(0xf1864f81), SPH_C32(0x510ff094), SPH_C32(0x2781a0bb),
    SPH_C32(0x77fe36c2) },
  { SPH_C32(0xc1c40000), SPH_C32(0x515b1214), SPH_C32(0x61f90000),
    SPH_C32(0x3cae0000), SPH_C32(0x1af401b5), SPH_C32(0x0772a4cf),
    SPH_C32(0x4556731a), SPH_C32(0x65a68a7d), SPH_C32(0x0d920000),
    SPH_C32(0x79ea0cd4), SPH_C32(0x0bfd0000), SPH_C32(0x688c0000),
    SPH_C32(0xdf23015e), SPH_C32(0x37417586), SPH_C32(0x983bb878),
    SPH_C32(0x098f6bd5) },
  { SPH_C32(0x95940000), SPH_C32(0x572a1248), SPH_C32(0x44570000),
    SPH_C32(0x56b00000), SPH_C32(0x34514f6a), SPH_C32(0x613c21dd),
    SPH_C32(0xfaec6bd9), SPH_C32(0x1bd7d76a), SPH_C32(0xb11f0000),
    SPH_C32(0x85d10ccc), SPH_C32(0x127e0000), SPH_C32(0xb9870000),
    SPH_C32(0x713b799a), SPH_C32(0x75e7edd0), SPH_C32(0x9829624f),
    SPH_C32(0x25b43b9b) },
  { SPH_C32(0x14180000), SPH_C32(0x79811290), SPH_C32(0xbb590000),
    SPH_C32(0x418a0000), SPH_C32(0x507972df), SPH_C32(0x8b702945),
    SPH_C32(0xc2a88151), SPH_C32(0xf57c79fd), SPH_C32(0x233c0000),
    SPH_C32(0x2c2d0c9c), SPH_C32(0x93110000), SPH_C32(0xf2140000),
    SPH_C32(0x7c8f22c2), SPH_C32(0x6aba39ed), SPH_C32(0x3abbd604),
    SPH_C32(0x6c48b7ff) },
  { SPH_C32(0x40480000), SPH_C32(0x7ff012cc), SPH_C32(0x9ef70000),
    SPH_C32(0x2b940000), SPH_C32(0x7edc3c00), SPH_C32(0xed3eac57),
    SPH_C32(0x7d129992), SPH_C32(0x8b0d24ea), SPH_C32(0x9fb10000),
    SPH_C32(0xd0160c84), SPH_C32(0x8a920000), SPH_C32(0x231f0000),
    SPH_C32(0xd2975a06), SPH_C32(0x281ca1bb), SPH_C32(0x3aa90c33),
    SPH_C32(0x4073e7b1) },
  { SPH_C32(0xa8950000), SPH_C32(0x85ba1288), SPH_C32(0xa2da0000),
    SPH_C32(0x90810000), SPH_C32(0xfe610a1b), SPH_C32(0xc9d6b113),
    SPH_C32(0xc2ba5b66), SPH_C32(0xd94729b3), SPH_C32(0xcbe10000),
    SPH_C32(0xd6670cd8), SPH_C32(0xaf3c0000), SPH_C32(0x49010000),
    SPH_C32(0xfc3214d9), SPH_C32(0x4e5224a9), SPH_C32(0x851314f0),
    SPH_C32(0x3e02baa6) },
  { SPH_C32(0xfcc50000), SPH_C32(0x83cb12d4), SPH_C32(0x87740000),
    SPH_C32(0xfa9f0000), SPH_C32(0xd0c444c4), SPH_C32(0xaf983401),
    SPH_C32(0x7d0043a5), SPH_C32(0xa73674a4), SPH_C32(0x776c0000),
    SPH_C32(0x2a5c0cc0), SPH_C32(0xb6bf0000), SPH_C32(0x980a0000),
    SPH_C32(0x522a6c1d), SPH_C32(0x0cf4bcff), SPH_C32(0x8501cec7),
    SPH_C32(0x1239eae8) },
  { SPH_C32(0xb7480000), SPH_C32(0x4b081d00), SPH_C32(0x9ec20000),
    SPH_C32(0x90c20000), SPH_C32(0xa4575cec), SPH_C32(0x294548a2),
    SPH_C32(0xcdcf4ede), SPH_C32(0xca5b0bd0), SPH_C32(0xb44f0000),
    SPH_C32(0x5f940900), SPH_C32(0x75e30000), SPH_C32(0xa95b0000),
    SPH_C32(0x112b51b6), SPH_C32(0xbbcad451), SPH_C32(0xf3875d6d),
    SPH_C32(0x718aebae) },
  { SPH_C32(0xe3180000), SPH_C32(0x4d791d5c), SPH_C32(0xbb6c0000),
    SPH_C32(0xfadc0000), SPH_C32(0x8af21233), SPH_C32(0x4f0bcdb0),
    SPH_C32(0x7275561d), SPH_C32(0xb42a56c7), SPH_C32(0x08c20000),
    SPH_C32(0xa3af0918), SPH_C32(0x6c600000), SPH_C32(0x78500000),
    SPH_C32(0xbf332972), SPH_C32(0xf96c4c07), SPH_C32(0xf395875a),
    SPH_C32(0x5db1bbe0) },
  { SPH_C32(0x0bc50000), SPH_C32(0xb7331d18), SPH_C32(0x87410000),
    SPH_C32(0x41c90000), SPH_C32(0x0a4f2428), SPH_C32(0x6be3d0f4),
    SPH_C32(0xcddd94e9), SPH_C32(0xe6605b9e), SPH_C32(0x5c920000),
    SPH_C32(0xa5de0944), SPH_C32(0x49ce0000), SPH_C32(0x124e0000),
    SPH_C32(0x919667ad), SPH_C32(0x9f22c915), SPH_C32(0x4c2f9f99),
    SPH_C32(0x23c0e6f7) },
  { SPH_C32(0x5f950000), SPH_C32(0xb1421d44), SPH_C32(0xa2ef0000),
    SPH_C32(0x2bd70000), SPH_C32(0x24ea6af7), SPH_C32(0x0dad55e6),
    SPH_C32(0x72678c2a), SPH_C32(0x98110689), SPH_C32(0xe01f0000),
    SPH_C32(0x59e5095c), SPH_C32(0x504d0000), SPH_C32(0xc3450000),
    SPH_C32(0x3f8e1f69), SPH_C32(0xdd845143), SPH_C32(0x4c3d45ae),
    SPH_C32(0x0ffbb6b9) },
  { SPH_C32(0xde190000), SPH_C32(0x9fe91d9c), SPH_C32(0x5de10000),
    SPH_C32(0x3ced0000), SPH_C32(0x40c25742), SPH_C32(0xe7e15d7e),
    SPH_C32(0x4a2366a2), SPH_C32(0x76baa81e), SPH_C32(0x723c0000),
    SPH_C32(0xf019090c), SPH_C32(0xd1220000), SPH_C32(0x88d60000),
    SPH_C32(0x323a4431), SPH_C32(0xc2d9857e), SPH_C32(0xeeaff1e5),
    SPH_C32(0x46073add) },
  { SPH_C32(0x8a490000), SPH_C32(0x99981dc0), SPH_C32(0x784f0000),
    SPH_C32(0x56f30000), SPH_C32(0x6e67199d), SPH_C32(0x81afd86c),
    SPH_C32(0xf5997e61), SPH_C32(0x08cbf509), SPH_C32(0xceb10000),
    SPH_C32(0x0c220914), SPH_C32(0xc8a10000), SPH_C32(0x59dd0000),
    SPH_C32(0x9c223cf5), SPH_C32(0x807f1d28), SPH_C32(0xeebd2bd2),
    SPH_C32(0x6a3c6a93) },
  { SPH_C32(0x62940000), SPH_C32(0x63d21d84), SPH_C32(0x44620000),
    SPH_C32(0xede60000), SPH_C32(0xeeda2f86), SPH_C32(0xa547c528),
    SPH_C32(0x4a31bc95), SPH_C32(0x5a81f850), SPH_C32(0x9ae10000),
    SPH_C32(0x0a530948), SPH_C32(0xed0f0000), SPH_C32(0x33c30000),
    SPH_C32(0xb287722a), SPH_C32(0xe631983a), SPH_C32(0x51073311),
    SPH_C32(0x144d3784) },
  { SPH_C32(0x36c40000), SPH_C32(0x65a31dd8), SPH_C32(0x61cc0000),
    SPH_C32(0x87f80000), SPH_C32(0xc07f6159), SPH_C32(0xc309403a),
    SPH_C32(0xf58ba456), SPH_C32(0x24f0a547), SPH_C32(0x266c0000),
    SPH_C32(0xf6680950), SPH_C32(0xf48c0000), SPH_C32(0xe2c80000),
    SPH_C32(0x1c9f0aee), SPH_C32(0xa497006c), SPH_C32(0x5115e926),
    SPH_C32(0x387667ca) },
  { SPH_C32(0x713b0000), SPH_C32(0xe4851d0c), SPH_C32(0x3a030000),
    SPH_C32(0xb14f0000), SPH_C32(0x8746496b), SPH_C32(0x5056198d),
    SPH_C32(0xd0e7e256), SPH_C32(0xfdd6daa3), SPH_C32(0x1b6d0000),
    SPH_C32(0x24f80990), SPH_C32(0x12010000), SPH_C32(0x24f90000),
    SPH_C32(0xd6af4f9f), SPH_C32(0x0c7d90a2), SPH_C32(0x6943d999),
    SPH_C32(0xfae69913) },
  { SPH_C32(0x256b0000), SPH_C32(0xe2f41d50), SPH_C32(0x1fad0000),
    SPH_C32(0xdb510000), SPH_C32(0xa9e307b4), SPH_C32(0x36189c9f),
    SPH_C32(0x6f5dfa95), SPH_C32(0x83a787b4), SPH_C32(0xa7e00000),
    SPH_C32(0xd8c30988), SPH_C32(0x0b820000), SPH_C32(0xf5f20000),
    SPH_C32(0x78b7375b), SPH_C32(0x4edb08f4), SPH_C32(0x695103ae),
    SPH_C32(0xd6ddc95d) },
  { SPH_C32(0xcdb60000), SPH_C32(0x18be1d14), SPH_C32(0x23800000),
    SPH_C32(0x60440000), SPH_C32(0x295e31af), SPH_C32(0x12f081db),
    SPH_C32(0xd0f53861), SPH_C32(0xd1ed8aed), SPH_C32(0xf3b00000),
    SPH_C32(0xdeb209d4), SPH_C32(0x2e2c0000), SPH_C32(0x9fec0000),
    SPH_C32(0x56127984), SPH_C32(0x28958de6), SPH_C32(0xd6eb1b6d),
    SPH_C32(0xa8ac944a) },
  { SPH_C32(0x99e60000), SPH_C32(0x1ecf1d48), SPH_C32(0x062e0000),
    SPH_C32(0x0a5a0000), SPH_C32(0x07fb7f70), SPH_C32(0x74be04c9),
    SPH_C32(0x6f4f20a2), SPH_C32(0xaf9cd7fa), SPH_C32(0x4f3d0000),
    SPH_C32(0x228909cc), SPH_C32(0x37af0000), SPH_C32(0x4ee70000),
    SPH_C32(0xf80a0140), SPH_C32(0x6a3315b0), SPH_C32(0xd6f9c15a),
    SPH_C32(0x8497c404) },
  { SPH_C32(0x186a0000), SPH_C32(0x30641d90), SPH_C32(0xf9200000),
    SPH_C32(0x1d600000), SPH_C32(0x63d342c5), SPH_C32(0x9ef20c51),
    SPH_C32(0x570bca2a), SPH_C32(0x4137796d), SPH_C32(0xdd1e0000),
    SPH_C32(0x8b75099c), SPH_C32(0xb6c00000), SPH_C32(0x05740000),
    SPH_C32(0xf5be5a18), SPH_C32(0x756ec18d), SPH_C32(0x746b7511),
    SPH_C32(0xcd6b4860) },
  { SPH_C32(0x4c3a0000), SPH_C32(0x36151dcc), SPH_C32(0xdc8e0000),
    SPH_C32(0x777e0000), SPH_C32(0x4d760c1a), SPH_C32(0xf8bc8943),
    SPH_C32(0xe8b1d2e9), SPH_C32(0x3f46247a), SPH_C32(0x61930000),
    SPH_C32(0x774e0984), SPH_C32(0xaf430000), SPH_C32(0xd47f0000),
    SPH_C32(0x5ba622dc), SPH_C32(0x37c859db), SPH_C32(0x7479af26),
    SPH_C32(0xe150182e) },
  { SPH_C32(0xa4e70000), SPH_C32(0xcc5f1d88), SPH_C32(0xe0a30000),
    SPH_C32(0xcc6b0000), SPH_C32(0xcdcb3a01), SPH_C32(0xdc549407),
    SPH_C32(0x5719101d), SPH_C32(0x6d0c2923), SPH_C32(0x35c30000),
    SPH_C32(0x713f09d8), SPH_C32(0x8aed0000), SPH_C32(0xbe610000),
    SPH_C32(0x75036c03), SPH_C32(0x5186dcc9), SPH_C32(0xcbc3b7e5),
    SPH_C32(0x9f214539) },
  { SPH_C32(0xf0b70000), SPH_C32(0xca2e1dd4), SPH_C32(0xc50d0000),
    SPH_C32(0xa6750000), SPH_C32(0xe36e74de), SPH_C32(0xba1a1115),
    SPH_C32(0xe8a308de), SPH_C32(0x137d7434), SPH_C32(0x894e0000),
    SPH_C32(0x8d0409c0), SPH_C32(0x936e0000), SPH_C32(0x6f6a0000),
    SPH_C32(0xdb1b14c7), SPH_C32(0x1320449f), SPH_C32(0xcbd16dd2),
    SPH_C32(0xb31a1577) }
};

__constant static const sph_u32 T512_28[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0xb08d0000), SPH_C32(0x42800001), SPH_C32(0x1429e180),
    SPH_C32(0x5b310000), SPH_C32(0xa98b722d), SPH_C32(0x92f0de78),
    SPH_C32(0x6631ef9d), SPH_C32(0x3bb81f15), SPH_C32(0x69230000),
    SPH_C32(0xcc400000), SPH_C32(0x61a9d200), SPH_C32(0xf5860000),
    SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9), SPH_C32(0x7087b49a),
    SPH_C32(0xe1228bb6) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0xc56b0000), SPH_C32(0xd7e60000), SPH_C32(0x2452c180),
    SPH_C32(0xf6c50000), SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f),
    SPH_C32(0x8ef57364), SPH_C32(0x70c6f340), SPH_C32(0xc7e00000),
    SPH_C32(0x500f0001), SPH_C32(0x18783200), SPH_C32(0xd9930000),
    SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff), SPH_C32(0xdb154315),
    SPH_C32(0x4230ddcd) },
  { SPH_C32(0x75e60000), SPH_C32(0x95660001), SPH_C32(0x307b2000),
    SPH_C32(0xadf40000), SPH_C32(0x8f321eea), SPH_C32(0x24298307),
    SPH_C32(0xe8c49cf9), SPH_C32(0x4b7eec55), SPH_C32(0xaec30000),
    SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000), SPH_C32(0x2c150000),
    SPH_C32(0x45cc75b3), SPH_C32(0x6650b736), SPH_C32(0xab92f78f),
    SPH_C32(0xa312567b) },
  { SPH_C32(0x6ba80000), SPH_C32(0x4ba90001), SPH_C32(0x5d832180),
    SPH_C32(0xdad00000), SPH_C32(0x63751974), SPH_C32(0xd089ea49),
    SPH_C32(0x256784eb), SPH_C32(0xd3d4a53b), SPH_C32(0x1cc50000),
    SPH_C32(0x59260001), SPH_C32(0x51d2f200), SPH_C32(0x58720000),
    SPH_C32(0xf30e4347), SPH_C32(0x8d428ece), SPH_C32(0x98432863),
    SPH_C32(0xaa5c67e3) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x98370000), SPH_C32(0xe1f60002), SPH_C32(0x8c62e180),
    SPH_C32(0xef720000), SPH_C32(0x79226090), SPH_C32(0xba28a1a4),
    SPH_C32(0x1e7e5156), SPH_C32(0x8eb793d7), SPH_C32(0x82b10000),
    SPH_C32(0x20b90000), SPH_C32(0xdcf77200), SPH_C32(0x36a30000),
    SPH_C32(0xd57a0b9e), SPH_C32(0x93a8ad98), SPH_C32(0x127e7e06),
    SPH_C32(0xb9eb29ac) },
  { SPH_C32(0x28ba0000), SPH_C32(0xa3760003), SPH_C32(0x984b0000),
    SPH_C32(0xb4430000), SPH_C32(0xd0a912bd), SPH_C32(0x28d87fdc),
    SPH_C32(0x784fbecb), SPH_C32(0xb50f8cc2), SPH_C32(0xeb920000),
    SPH_C32(0xecf90000), SPH_C32(0xbd5ea000), SPH_C32(0xc3250000),
    SPH_C32(0xa9465633), SPH_C32(0x3ac3a051), SPH_C32(0x62f9ca9c),
    SPH_C32(0x58c9a21a) },
  { SPH_C32(0x36f40000), SPH_C32(0x7db90003), SPH_C32(0xf5b30180),
    SPH_C32(0xc3670000), SPH_C32(0x3cee1523), SPH_C32(0xdc781692),
    SPH_C32(0xb5eca6d9), SPH_C32(0x2da5c5ac), SPH_C32(0x59940000),
    SPH_C32(0x29900000), SPH_C32(0x955db200), SPH_C32(0xb7420000),
    SPH_C32(0x1f8460c7), SPH_C32(0xd1d199a9), SPH_C32(0x51281570),
    SPH_C32(0x51879382) },
  { SPH_C32(0x5d5c0000), SPH_C32(0x36100002), SPH_C32(0xa8302000),
    SPH_C32(0x19b70000), SPH_C32(0x5f9b0c57), SPH_C32(0x0cf1fcdb),
    SPH_C32(0x908b2232), SPH_C32(0xfe716097), SPH_C32(0x45510000),
    SPH_C32(0x70b60001), SPH_C32(0xc48f4000), SPH_C32(0xef300000),
    SPH_C32(0xec8a2380), SPH_C32(0x5c931767), SPH_C32(0xc96b3d13),
    SPH_C32(0xfbdbf461) },
  { SPH_C32(0x43120000), SPH_C32(0xe8df0002), SPH_C32(0xc5c82180),
    SPH_C32(0x6e930000), SPH_C32(0xb3dc0bc9), SPH_C32(0xf8519595),
    SPH_C32(0x5d283a20), SPH_C32(0x66db29f9), SPH_C32(0xf7570000),
    SPH_C32(0xb5df0001), SPH_C32(0xec8c5200), SPH_C32(0x9b570000),
    SPH_C32(0x5a481574), SPH_C32(0xb7812e9f), SPH_C32(0xfabae2ff),
    SPH_C32(0xf295c5f9) },
  { SPH_C32(0xf39f0000), SPH_C32(0xaa5f0003), SPH_C32(0xd1e1c000),
    SPH_C32(0x35a20000), SPH_C32(0x1a5779e4), SPH_C32(0x6aa14bed),
    SPH_C32(0x3b19d5bd), SPH_C32(0x5d6336ec), SPH_C32(0x9e740000),
    SPH_C32(0x799f0001), SPH_C32(0x8d258000), SPH_C32(0x6ed10000),
    SPH_C32(0x267448d9), SPH_C32(0x1eea2356), SPH_C32(0x8a3d5665),
    SPH_C32(0x13b74e4f) },
  { SPH_C32(0xedd10000), SPH_C32(0x74900003), SPH_C32(0xbc19c180),
    SPH_C32(0x42860000), SPH_C32(0xf6107e7a), SPH_C32(0x9e0122a3),
    SPH_C32(0xf6bacdaf), SPH_C32(0xc5c97f82), SPH_C32(0x2c720000),
    SPH_C32(0xbcf60001), SPH_C32(0xa5269200), SPH_C32(0x1ab60000),
    SPH_C32(0x90b67e2d), SPH_C32(0xf5f81aae), SPH_C32(0xb9ec8989),
    SPH_C32(0x1af97fd7) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0x2ef90000), SPH_C32(0x3b1f0000), SPH_C32(0x990c6180),
    SPH_C32(0x35e00000), SPH_C32(0x8fff3af4), SPH_C32(0x8c1afd2e),
    SPH_C32(0xec0cb9f8), SPH_C32(0x280f515a), SPH_C32(0x04c80000),
    SPH_C32(0x1f800002), SPH_C32(0x3d6d9200), SPH_C32(0xaef50000),
    SPH_C32(0x401f6c90), SPH_C32(0xdd206572), SPH_C32(0xc1a33742),
    SPH_C32(0xaff6f315) },
  { SPH_C32(0x9e740000), SPH_C32(0x799f0001), SPH_C32(0x8d258000),
    SPH_C32(0x6ed10000), SPH_C32(0x267448d9), SPH_C32(0x1eea2356),
    SPH_C32(0x8a3d5665), SPH_C32(0x13b74e4f), SPH_C32(0x6deb0000),
    SPH_C32(0xd3c00002), SPH_C32(0x5cc44000), SPH_C32(0x5b730000),
    SPH_C32(0x3c23313d), SPH_C32(0x744b68bb), SPH_C32(0xb12483d8),
    SPH_C32(0x4ed478a3) },
  { SPH_C32(0x803a0000), SPH_C32(0xa7500001), SPH_C32(0xe0dd8180),
    SPH_C32(0x19f50000), SPH_C32(0xca334f47), SPH_C32(0xea4a4a18),
    SPH_C32(0x479e4e77), SPH_C32(0x8b1d0721), SPH_C32(0xdfed0000),
    SPH_C32(0x16a90002), SPH_C32(0x74c75200), SPH_C32(0x2f140000),
    SPH_C32(0x8ae107c9), SPH_C32(0x9f595143), SPH_C32(0x82f55c34),
    SPH_C32(0x479a493b) },
  { SPH_C32(0xeb920000), SPH_C32(0xecf90000), SPH_C32(0xbd5ea000),
    SPH_C32(0xc3250000), SPH_C32(0xa9465633), SPH_C32(0x3ac3a051),
    SPH_C32(0x62f9ca9c), SPH_C32(0x58c9a21a), SPH_C32(0xc3280000),
    SPH_C32(0x4f8f0003), SPH_C32(0x2515a000), SPH_C32(0x77660000),
    SPH_C32(0x79ef448e), SPH_C32(0x121bdf8d), SPH_C32(0x1ab67457),
    SPH_C32(0xedc62ed8) },
  { SPH_C32(0xf5dc0000), SPH_C32(0x32360000), SPH_C32(0xd0a6a180),
    SPH_C32(0xb4010000), SPH_C32(0x450151ad), SPH_C32(0xce63c91f),
    SPH_C32(0xaf5ad28e), SPH_C32(0xc063eb74), SPH_C32(0x712e0000),
    SPH_C32(0x8ae60003), SPH_C32(0x0d16b200), SPH_C32(0x03010000),
    SPH_C32(0xcf2d727a), SPH_C32(0xf909e675), SPH_C32(0x2967abbb),
    SPH_C32(0xe4881f40) },
  { SPH_C32(0x45510000), SPH_C32(0x70b60001), SPH_C32(0xc48f4000),
    SPH_C32(0xef300000), SPH_C32(0xec8a2380), SPH_C32(0x5c931767),
    SPH_C32(0xc96b3d13), SPH_C32(0xfbdbf461), SPH_C32(0x180d0000),
    SPH_C32(0x46a60003), SPH_C32(0x6cbf6000), SPH_C32(0xf6870000),
    SPH_C32(0xb3112fd7), SPH_C32(0x5062ebbc), SPH_C32(0x59e01f21),
    SPH_C32(0x05aa94f6) },
  { SPH_C32(0x5b1f0000), SPH_C32(0xae790001), SPH_C32(0xa9774180),
    SPH_C32(0x98140000), SPH_C32(0x00cd241e), SPH_C32(0xa8337e29),
    SPH_C32(0x04c82501), SPH_C32(0x6371bd0f), SPH_C32(0xaa0b0000),
    SPH_C32(0x83cf0003), SPH_C32(0x44bc7200), SPH_C32(0x82e00000),
    SPH_C32(0x05d31923), SPH_C32(0xbb70d244), SPH_C32(0x6a31c0cd),
    SPH_C32(0x0ce4a56e) },
  { SPH_C32(0xb6ce0000), SPH_C32(0xdae90002), SPH_C32(0x156e8000),
    SPH_C32(0xda920000), SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a),
    SPH_C32(0xf272e8ae), SPH_C32(0xa6b8c28d), SPH_C32(0x86790000),
    SPH_C32(0x3f390002), SPH_C32(0xe19ae000), SPH_C32(0x98560000),
    SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea), SPH_C32(0xd3dd4944),
    SPH_C32(0x161ddab9) },
  { SPH_C32(0xa8800000), SPH_C32(0x04260002), SPH_C32(0x78968180),
    SPH_C32(0xadb60000), SPH_C32(0x1a9a5dfa), SPH_C32(0xc29235c4),
    SPH_C32(0x3fd1f0bc), SPH_C32(0x3e128be3), SPH_C32(0x347f0000),
    SPH_C32(0xfa500002), SPH_C32(0xc999f200), SPH_C32(0xec310000),
    SPH_C32(0x23a751fa), SPH_C32(0xa59af112), SPH_C32(0xe00c96a8),
    SPH_C32(0x1f53eb21) },
  { SPH_C32(0x180d0000), SPH_C32(0x46a60003), SPH_C32(0x6cbf6000),
    SPH_C32(0xf6870000), SPH_C32(0xb3112fd7), SPH_C32(0x5062ebbc),
    SPH_C32(0x59e01f21), SPH_C32(0x05aa94f6), SPH_C32(0x5d5c0000),
    SPH_C32(0x36100002), SPH_C32(0xa8302000), SPH_C32(0x19b70000),
    SPH_C32(0x5f9b0c57), SPH_C32(0x0cf1fcdb), SPH_C32(0x908b2232),
    SPH_C32(0xfe716097) },
  { SPH_C32(0x06430000), SPH_C32(0x98690003), SPH_C32(0x01476180),
    SPH_C32(0x81a30000), SPH_C32(0x5f562849), SPH_C32(0xa4c282f2),
    SPH_C32(0x94430733), SPH_C32(0x9d00dd98), SPH_C32(0xef5a0000),
    SPH_C32(0xf3790002), SPH_C32(0x80333200), SPH_C32(0x6dd00000),
    SPH_C32(0xe9593aa3), SPH_C32(0xe7e3c523), SPH_C32(0xa35afdde),
    SPH_C32(0xf73f510f) },
  { SPH_C32(0x6deb0000), SPH_C32(0xd3c00002), SPH_C32(0x5cc44000),
    SPH_C32(0x5b730000), SPH_C32(0x3c23313d), SPH_C32(0x744b68bb),
    SPH_C32(0xb12483d8), SPH_C32(0x4ed478a3), SPH_C32(0xf39f0000),
    SPH_C32(0xaa5f0003), SPH_C32(0xd1e1c000), SPH_C32(0x35a20000),
    SPH_C32(0x1a5779e4), SPH_C32(0x6aa14bed), SPH_C32(0x3b19d5bd),
    SPH_C32(0x5d6336ec) },
  { SPH_C32(0x73a50000), SPH_C32(0x0d0f0002), SPH_C32(0x313c4180),
    SPH_C32(0x2c570000), SPH_C32(0xd06436a3), SPH_C32(0x80eb01f5),
    SPH_C32(0x7c879bca), SPH_C32(0xd67e31cd), SPH_C32(0x41990000),
    SPH_C32(0x6f360003), SPH_C32(0xf9e2d200), SPH_C32(0x41c50000),
    SPH_C32(0xac954f10), SPH_C32(0x81b37215), SPH_C32(0x08c80a51),
    SPH_C32(0x542d0774) },
  { SPH_C32(0xc3280000), SPH_C32(0x4f8f0003), SPH_C32(0x2515a000),
    SPH_C32(0x77660000), SPH_C32(0x79ef448e), SPH_C32(0x121bdf8d),
    SPH_C32(0x1ab67457), SPH_C32(0xedc62ed8), SPH_C32(0x28ba0000),
    SPH_C32(0xa3760003), SPH_C32(0x984b0000), SPH_C32(0xb4430000),
    SPH_C32(0xd0a912bd), SPH_C32(0x28d87fdc), SPH_C32(0x784fbecb),
    SPH_C32(0xb50f8cc2) },
  { SPH_C32(0xdd660000), SPH_C32(0x91400003), SPH_C32(0x48eda180),
    SPH_C32(0x00420000), SPH_C32(0x95a84310), SPH_C32(0xe6bbb6c3),
    SPH_C32(0xd7156c45), SPH_C32(0x756c67b6), SPH_C32(0x9abc0000),
    SPH_C32(0x661f0003), SPH_C32(0xb0481200), SPH_C32(0xc0240000),
    SPH_C32(0x666b2449), SPH_C32(0xc3ca4624), SPH_C32(0x4b9e6127),
    SPH_C32(0xbc41bd5a) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0x0a570000), SPH_C32(0xfd05003c), SPH_C32(0x3d270180),
    SPH_C32(0x33920000), SPH_C32(0xf72b602e), SPH_C32(0xc853c53b),
    SPH_C32(0xac4508a2), SPH_C32(0x436092ee), SPH_C32(0x51450000),
    SPH_C32(0xff270014), SPH_C32(0xdac51200), SPH_C32(0xde290000),
    SPH_C32(0x6ddc7452), SPH_C32(0xce7987ed), SPH_C32(0x21ec6eba),
    SPH_C32(0x3300a84f) },
  { SPH_C32(0xbada0000), SPH_C32(0xbf85003d), SPH_C32(0x290ee000),
    SPH_C32(0x68a30000), SPH_C32(0x5ea01203), SPH_C32(0x5aa31b43),
    SPH_C32(0xca74e73f), SPH_C32(0x78d88dfb), SPH_C32(0x38660000),
    SPH_C32(0x33670014), SPH_C32(0xbb6cc000), SPH_C32(0x2baf0000),
    SPH_C32(0x11e029ff), SPH_C32(0x67128a24), SPH_C32(0x516bda20),
    SPH_C32(0xd22223f9) },
  { SPH_C32(0xa4940000), SPH_C32(0x614a003d), SPH_C32(0x44f6e180),
    SPH_C32(0x1f870000), SPH_C32(0xb2e7159d), SPH_C32(0xae03720d),
    SPH_C32(0x07d7ff2d), SPH_C32(0xe072c495), SPH_C32(0x8a600000),
    SPH_C32(0xf60e0014), SPH_C32(0x936fd200), SPH_C32(0x5fc80000),
    SPH_C32(0xa7221f0b), SPH_C32(0x8c00b3dc), SPH_C32(0x62ba05cc),
    SPH_C32(0xdb6c1261) },
  { SPH_C32(0xcf3c0000), SPH_C32(0x2ae3003c), SPH_C32(0x1975c000),
    SPH_C32(0xc5570000), SPH_C32(0xd1920ce9), SPH_C32(0x7e8a9844),
    SPH_C32(0x22b07bc6), SPH_C32(0x33a661ae), SPH_C32(0x96a50000),
    SPH_C32(0xaf280015), SPH_C32(0xc2bd2000), SPH_C32(0x07ba0000),
    SPH_C32(0x542c5c4c), SPH_C32(0x01423d12), SPH_C32(0xfaf92daf),
    SPH_C32(0x71307582) },
  { SPH_C32(0xd1720000), SPH_C32(0xf42c003c), SPH_C32(0x748dc180),
    SPH_C32(0xb2730000), SPH_C32(0x3dd50b77), SPH_C32(0x8a2af10a),
    SPH_C32(0xef1363d4), SPH_C32(0xab0c28c0), SPH_C32(0x24a30000),
    SPH_C32(0x6a410015), SPH_C32(0xeabe3200), SPH_C32(0x73dd0000),
    SPH_C32(0xe2ee6ab8), SPH_C32(0xea5004ea), SPH_C32(0xc928f243),
    SPH_C32(0x787e441a) },
  { SPH_C32(0x61ff0000), SPH_C32(0xb6ac003d), SPH_C32(0x60a42000),
    SPH_C32(0xe9420000), SPH_C32(0x945e795a), SPH_C32(0x18da2f72),
    SPH_C32(0x89228c49), SPH_C32(0x90b437d5), SPH_C32(0x4d800000),
    SPH_C32(0xa6010015), SPH_C32(0x8b17e000), SPH_C32(0x865b0000),
    SPH_C32(0x9ed23715), SPH_C32(0x433b0923), SPH_C32(0xb9af46d9),
    SPH_C32(0x995ccfac) },
  { SPH_C32(0x7fb10000), SPH_C32(0x6863003d), SPH_C32(0x0d5c2180),
    SPH_C32(0x9e660000), SPH_C32(0x78197ec4), SPH_C32(0xec7a463c),
    SPH_C32(0x4481945b), SPH_C32(0x081e7ebb), SPH_C32(0xff860000),
    SPH_C32(0x63680015), SPH_C32(0xa314f200), SPH_C32(0xf23c0000),
    SPH_C32(0x281001e1), SPH_C32(0xa82930db), SPH_C32(0x8a7e9935),
    SPH_C32(0x9012fe34) },
  { SPH_C32(0x92600000), SPH_C32(0x1cf3003e), SPH_C32(0xb145e000),
    SPH_C32(0xdce00000), SPH_C32(0x8e0900be), SPH_C32(0x727b649f),
    SPH_C32(0xb23b59f4), SPH_C32(0xcdd70139), SPH_C32(0xd3f40000),
    SPH_C32(0xdf9e0014), SPH_C32(0x06326000), SPH_C32(0xe88a0000),
    SPH_C32(0xb8a67fcc), SPH_C32(0x5dd12a75), SPH_C32(0x339210bc),
    SPH_C32(0x8aeb81e3) },
  { SPH_C32(0x8c2e0000), SPH_C32(0xc23c003e), SPH_C32(0xdcbde180),
    SPH_C32(0xabc40000), SPH_C32(0x624e0720), SPH_C32(0x86db0dd1),
    SPH_C32(0x7f9841e6), SPH_C32(0x557d4857), SPH_C32(0x61f20000),
    SPH_C32(0x1af70014), SPH_C32(0x2e317200), SPH_C32(0x9ced0000),
    SPH_C32(0x0e644938), SPH_C32(0xb6c3138d), SPH_C32(0x0043cf50),
    SPH_C32(0x83a5b07b) },
  { SPH_C32(0x3ca30000), SPH_C32(0x80bc003f), SPH_C32(0xc8940000),
    SPH_C32(0xf0f50000), SPH_C32(0xcbc5750d), SPH_C32(0x142bd3a9),
    SPH_C32(0x19a9ae7b), SPH_C32(0x6ec55742), SPH_C32(0x08d10000),
    SPH_C32(0xd6b70014), SPH_C32(0x4f98a000), SPH_C32(0x696b0000),
    SPH_C32(0x72581495), SPH_C32(0x1fa81e44), SPH_C32(0x70c47bca),
    SPH_C32(0x62873bcd) },
  { SPH_C32(0x22ed0000), SPH_C32(0x5e73003f), SPH_C32(0xa56c0180),
    SPH_C32(0x87d10000), SPH_C32(0x27827293), SPH_C32(0xe08bbae7),
    SPH_C32(0xd40ab669), SPH_C32(0xf66f1e2c), SPH_C32(0xbad70000),
    SPH_C32(0x13de0014), SPH_C32(0x679bb200), SPH_C32(0x1d0c0000),
    SPH_C32(0xc49a2261), SPH_C32(0xf4ba27bc), SPH_C32(0x4315a426),
    SPH_C32(0x6bc90a55) },
  { SPH_C32(0x49450000), SPH_C32(0x15da003e), SPH_C32(0xf8ef2000),
    SPH_C32(0x5d010000), SPH_C32(0x44f76be7), SPH_C32(0x300250ae),
    SPH_C32(0xf16d3282), SPH_C32(0x25bbbb17), SPH_C32(0xa6120000),
    SPH_C32(0x4af80015), SPH_C32(0x36494000), SPH_C32(0x457e0000),
    SPH_C32(0x37946126), SPH_C32(0x79f8a972), SPH_C32(0xdb568c45),
    SPH_C32(0xc1956db6) },
  { SPH_C32(0x570b0000), SPH_C32(0xcb15003e), SPH_C32(0x95172180),
    SPH_C32(0x2a250000), SPH_C32(0xa8b06c79), SPH_C32(0xc4a239e0),
    SPH_C32(0x3cce2a90), SPH_C32(0xbd11f279), SPH_C32(0x14140000),
    SPH_C32(0x8f910015), SPH_C32(0x1e4a5200), SPH_C32(0x31190000),
    SPH_C32(0x815657d2), SPH_C32(0x92ea908a), SPH_C32(0xe88753a9),
    SPH_C32(0xc8db5c2e) },
  { SPH_C32(0xe7860000), SPH_C32(0x8995003f), SPH_C32(0x813ec000),
    SPH_C32(0x71140000), SPH_C32(0x013b1e54), SPH_C32(0x5652e798),
    SPH_C32(0x5affc50d), SPH_C32(0x86a9ed6c), SPH_C32(0x7d370000),
    SPH_C32(0x43d10015), SPH_C32(0x7fe38000), SPH_C32(0xc49f0000),
    SPH_C32(0xfd6a0a7f), SPH_C32(0x3b819d43), SPH_C32(0x9800e733),
    SPH_C32(0x29f9d798) },
  { SPH_C32(0xf9c80000), SPH_C32(0x575a003f), SPH_C32(0xecc6c180),
    SPH_C32(0x06300000), SPH_C32(0xed7c19ca), SPH_C32(0xa2f28ed6),
    SPH_C32(0x975cdd1f), SPH_C32(0x1e03a402), SPH_C32(0xcf310000),
    SPH_C32(0x86b80015), SPH_C32(0x57e09200), SPH_C32(0xb0f80000),
    SPH_C32(0x4ba83c8b), SPH_C32(0xd093a4bb), SPH_C32(0xabd138df),
    SPH_C32(0x20b7e600) },
  { SPH_C32(0x24ae0000), SPH_C32(0xc61a003c), SPH_C32(0xa42b6000),
    SPH_C32(0x06720000), SPH_C32(0x78d45ada), SPH_C32(0x44493815),
    SPH_C32(0x4049b15a), SPH_C32(0x6b6fc3b4), SPH_C32(0x558d0000),
    SPH_C32(0xe0a70016), SPH_C32(0xe7a88000), SPH_C32(0x70dc0000),
    SPH_C32(0x2dc318c2), SPH_C32(0x1359e29f), SPH_C32(0xe04f59f8),
    SPH_C32(0x9cf65b5a) },
  { SPH_C32(0x3ae00000), SPH_C32(0x18d5003c), SPH_C32(0xc9d36180),
    SPH_C32(0x71560000), SPH_C32(0x94935d44), SPH_C32(0xb0e9515b),
    SPH_C32(0x8deaa948), SPH_C32(0xf3c58ada), SPH_C32(0xe78b0000),
    SPH_C32(0x25ce0016), SPH_C32(0xcfab9200), SPH_C32(0x04bb0000),
    SPH_C32(0x9b012e36), SPH_C32(0xf84bdb67), SPH_C32(0xd39e8614),
    SPH_C32(0x95b86ac2) },
  { SPH_C32(0x8a6d0000), SPH_C32(0x5a55003d), SPH_C32(0xddfa8000),
    SPH_C32(0x2a670000), SPH_C32(0x3d182f69), SPH_C32(0x22198f23),
    SPH_C32(0xebdb46d5), SPH_C32(0xc87d95cf), SPH_C32(0x8ea80000),
    SPH_C32(0xe98e0016), SPH_C32(0xae024000), SPH_C32(0xf13d0000),
    SPH_C32(0xe73d739b), SPH_C32(0x5120d6ae), SPH_C32(0xa319328e),
    SPH_C32(0x749ae174) },
  { SPH_C32(0x94230000), SPH_C32(0x849a003d), SPH_C32(0xb0028180),
    SPH_C32(0x5d430000), SPH_C32(0xd15f28f7), SPH_C32(0xd6b9e66d),
    SPH_C32(0x26785ec7), SPH_C32(0x50d7dca1), SPH_C32(0x3cae0000),
    SPH_C32(0x2ce70016), SPH_C32(0x86015200), SPH_C32(0x855a0000),
    SPH_C32(0x51ff456f), SPH_C32(0xba32ef56), SPH_C32(0x90c8ed62),
    SPH_C32(0x7dd4d0ec) },
  { SPH_C32(0xff8b0000), SPH_C32(0xcf33003c), SPH_C32(0xed81a000),
    SPH_C32(0x87930000), SPH_C32(0xb22a3183), SPH_C32(0x06300c24),
    SPH_C32(0x031fda2c), SPH_C32(0x8303799a), SPH_C32(0x206b0000),
    SPH_C32(0x75c10017), SPH_C32(0xd7d3a000), SPH_C32(0xdd280000),
    SPH_C32(0xa2f10628), SPH_C32(0x37706198), SPH_C32(0x088bc501),
    SPH_C32(0xd788b70f) },
  { SPH_C32(0xe1c50000), SPH_C32(0x11fc003c), SPH_C32(0x8079a180),
    SPH_C32(0xf0b70000), SPH_C32(0x5e6d361d), SPH_C32(0xf290656a),
    SPH_C32(0xcebcc23e), SPH_C32(0x1ba930f4), SPH_C32(0x926d0000),
    SPH_C32(0xb0a80017), SPH_C32(0xffd0b200), SPH_C32(0xa94f0000),
    SPH_C32(0x143330dc), SPH_C32(0xdc625860), SPH_C32(0x3b5a1aed),
    SPH_C32(0xdec68697) },
  { SPH_C32(0x51480000), SPH_C32(0x537c003d), SPH_C32(0x94504000),
    SPH_C32(0xab860000), SPH_C32(0xf7e64430), SPH_C32(0x6060bb12),
    SPH_C32(0xa88d2da3), SPH_C32(0x20112fe1), SPH_C32(0xfb4e0000),
    SPH_C32(0x7ce80017), SPH_C32(0x9e796000), SPH_C32(0x5cc90000),
    SPH_C32(0x680f6d71), SPH_C32(0x750955a9), SPH_C32(0x4bddae77),
    SPH_C32(0x3fe40d21) },
  { SPH_C32(0x4f060000), SPH_C32(0x8db3003d), SPH_C32(0xf9a84180),
    SPH_C32(0xdca20000), SPH_C32(0x1ba143ae), SPH_C32(0x94c0d25c),
    SPH_C32(0x652e35b1), SPH_C32(0xb8bb668f), SPH_C32(0x49480000),
    SPH_C32(0xb9810017), SPH_C32(0xb67a7200), SPH_C32(0x28ae0000),
    SPH_C32(0xdecd5b85), SPH_C32(0x9e1b6c51), SPH_C32(0x780c719b),
    SPH_C32(0x36aa3cb9) },
  { SPH_C32(0xa2d70000), SPH_C32(0xf923003e), SPH_C32(0x45b18000),
    SPH_C32(0x9e240000), SPH_C32(0xedb13dd4), SPH_C32(0x0ac1f0ff),
    SPH_C32(0x9394f81e), SPH_C32(0x7d72190d), SPH_C32(0x653a0000),
    SPH_C32(0x05770016), SPH_C32(0x135ce000), SPH_C32(0x32180000),
    SPH_C32(0x4e7b25a8), SPH_C32(0x6be376ff), SPH_C32(0xc1e0f812),
    SPH_C32(0x2c53436e) },
  { SPH_C32(0xbc990000), SPH_C32(0x27ec003e), SPH_C32(0x28498180),
    SPH_C32(0xe9000000), SPH_C32(0x01f63a4a), SPH_C32(0xfe6199b1),
    SPH_C32(0x5e37e00c), SPH_C32(0xe5d85063), SPH_C32(0xd73c0000),
    SPH_C32(0xc01e0016), SPH_C32(0x3b5ff200), SPH_C32(0x467f0000),
    SPH_C32(0xf8b9135c), SPH_C32(0x80f14f07), SPH_C32(0xf23127fe),
    SPH_C32(0x251d72f6) },
  { SPH_C32(0x0c140000), SPH_C32(0x656c003f), SPH_C32(0x3c606000),
    SPH_C32(0xb2310000), SPH_C32(0xa87d4867), SPH_C32(0x6c9147c9),
    SPH_C32(0x38060f91), SPH_C32(0xde604f76), SPH_C32(0xbe1f0000),
    SPH_C32(0x0c5e0016), SPH_C32(0x5af62000), SPH_C32(0xb3f90000),
    SPH_C32(0x84854ef1), SPH_C32(0x299a42ce), SPH_C32(0x82b69364),
    SPH_C32(0xc43ff940) },
  { SPH_C32(0x125a0000), SPH_C32(0xbba3003f), SPH_C32(0x51986180),
    SPH_C32(0xc5150000), SPH_C32(0x443a4ff9), SPH_C32(0x98312e87),
    SPH_C32(0xf5a51783), SPH_C32(0x46ca0618), SPH_C32(0x0c190000),
    SPH_C32(0xc9370016), SPH_C32(0x72f53200), SPH_C32(0xc79e0000),
    SPH_C32(0x32477805), SPH_C32(0xc2887b36), SPH_C32(0xb1674c88),
    SPH_C32(0xcd71c8d8) },
  { SPH_C32(0x79f20000), SPH_C32(0xf00a003e), SPH_C32(0x0c1b4000),
    SPH_C32(0x1fc50000), SPH_C32(0x274f568d), SPH_C32(0x48b8c4ce),
    SPH_C32(0xd0c29368), SPH_C32(0x951ea323), SPH_C32(0x10dc0000),
    SPH_C32(0x90110017), SPH_C32(0x2327c000), SPH_C32(0x9fec0000),
    SPH_C32(0xc1493b42), SPH_C32(0x4fcaf5f8), SPH_C32(0x292464eb),
    SPH_C32(0x672daf3b) },
  { SPH_C32(0x67bc0000), SPH_C32(0x2ec5003e), SPH_C32(0x61e34180),
    SPH_C32(0x68e10000), SPH_C32(0xcb085113), SPH_C32(0xbc18ad80),
    SPH_C32(0x1d618b7a), SPH_C32(0x0db4ea4d), SPH_C32(0xa2da0000),
    SPH_C32(0x55780017), SPH_C32(0x0b24d200), SPH_C32(0xeb8b0000),
    SPH_C32(0x778b0db6), SPH_C32(0xa4d8cc00), SPH_C32(0x1af5bb07),
    SPH_C32(0x6e639ea3) },
  { SPH_C32(0xd7310000), SPH_C32(0x6c45003f), SPH_C32(0x75caa000),
    SPH_C32(0x33d00000), SPH_C32(0x6283233e), SPH_C32(0x2ee873f8),
    SPH_C32(0x7b5064e7), SPH_C32(0x360cf558), SPH_C32(0xcbf90000),
    SPH_C32(0x99380017), SPH_C32(0x6a8d0000), SPH_C32(0x1e0d0000),
    SPH_C32(0x0bb7501b), SPH_C32(0x0db3c1c9), SPH_C32(0x6a720f9d),
    SPH_C32(0x8f411515) },
  { SPH_C32(0xc97f0000), SPH_C32(0xb28a003f), SPH_C32(0x1832a180),
    SPH_C32(0x44f40000), SPH_C32(0x8ec424a0), SPH_C32(0xda481ab6),
    SPH_C32(0xb6f37cf5), SPH_C32(0xaea6bc36), SPH_C32(0x79ff0000),
    SPH_C32(0x5c510017), SPH_C32(0x428e1200), SPH_C32(0x6a6a0000),
    SPH_C32(0xbd7566ef), SPH_C32(0xe6a1f831), SPH_C32(0x59a3d071),
    SPH_C32(0x860f248d) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0xfd0d0000), SPH_C32(0xe4810014), SPH_C32(0x9f3e0180),
    SPH_C32(0xdd6a0000), SPH_C32(0x37594538), SPH_C32(0xd1cbd75b),
    SPH_C32(0xdf9ea944), SPH_C32(0xa2e4d0b9), SPH_C32(0x455c0000),
    SPH_C32(0xdced0028), SPH_C32(0x8a1a1200), SPH_C32(0x9a9f0000),
    SPH_C32(0x76b013e2), SPH_C32(0xf28a2b98), SPH_C32(0x400a7e0a),
    SPH_C32(0xe8ca73cf) },
  { SPH_C32(0x4d800000), SPH_C32(0xa6010015), SPH_C32(0x8b17e000),
    SPH_C32(0x865b0000), SPH_C32(0x9ed23715), SPH_C32(0x433b0923),
    SPH_C32(0xb9af46d9), SPH_C32(0x995ccfac), SPH_C32(0x2c7f0000),
    SPH_C32(0x10ad0028), SPH_C32(0xebb3c000), SPH_C32(0x6f190000),
    SPH_C32(0x0a8c4e4f), SPH_C32(0x5be12651), SPH_C32(0x308dca90),
    SPH_C32(0x09e8f879) },
  { SPH_C32(0x53ce0000), SPH_C32(0x78ce0015), SPH_C32(0xe6efe180),
    SPH_C32(0xf17f0000), SPH_C32(0x7295308b), SPH_C32(0xb79b606d),
    SPH_C32(0x740c5ecb), SPH_C32(0x01f686c2), SPH_C32(0x9e790000),
    SPH_C32(0xd5c40028), SPH_C32(0xc3b0d200), SPH_C32(0x1b7e0000),
    SPH_C32(0xbc4e78bb), SPH_C32(0xb0f31fa9), SPH_C32(0x035c157c),
    SPH_C32(0x00a6c9e1) },
  { SPH_C32(0x38660000), SPH_C32(0x33670014), SPH_C32(0xbb6cc000),
    SPH_C32(0x2baf0000), SPH_C32(0x11e029ff), SPH_C32(0x67128a24),
    SPH_C32(0x516bda20), SPH_C32(0xd22223f9), SPH_C32(0x82bc0000),
    SPH_C32(0x8ce20029), SPH_C32(0x92622000), SPH_C32(0x430c0000),
    SPH_C32(0x4f403bfc), SPH_C32(0x3db19167), SPH_C32(0x9b1f3d1f),
    SPH_C32(0xaafaae02) },
  { SPH_C32(0x26280000), SPH_C32(0xeda80014), SPH_C32(0xd694c180),
    SPH_C32(0x5c8b0000), SPH_C32(0xfda72e61), SPH_C32(0x93b2e36a),
    SPH_C32(0x9cc8c232), SPH_C32(0x4a886a97), SPH_C32(0x30ba0000),
    SPH_C32(0x498b0029), SPH_C32(0xba613200), SPH_C32(0x376b0000),
    SPH_C32(0xf9820d08), SPH_C32(0xd6a3a89f), SPH_C32(0xa8cee2f3),
    SPH_C32(0xa3b49f9a) },
  { SPH_C32(0x96a50000), SPH_C32(0xaf280015), SPH_C32(0xc2bd2000),
    SPH_C32(0x07ba0000), SPH_C32(0x542c5c4c), SPH_C32(0x01423d12),
    SPH_C32(0xfaf92daf), SPH_C32(0x71307582), SPH_C32(0x59990000),
    SPH_C32(0x85cb0029), SPH_C32(0xdbc8e000), SPH_C32(0xc2ed0000),
    SPH_C32(0x85be50a5), SPH_C32(0x7fc8a556), SPH_C32(0xd8495669),
    SPH_C32(0x4296142c) },
  { SPH_C32(0x88eb0000), SPH_C32(0x71e70015), SPH_C32(0xaf452180),
    SPH_C32(0x709e0000), SPH_C32(0xb86b5bd2), SPH_C32(0xf5e2545c),
    SPH_C32(0x375a35bd), SPH_C32(0xe99a3cec), SPH_C32(0xeb9f0000),
    SPH_C32(0x40a20029), SPH_C32(0xf3cbf200), SPH_C32(0xb68a0000),
    SPH_C32(0x337c6651), SPH_C32(0x94da9cae), SPH_C32(0xeb988985),
    SPH_C32(0x4bd825b4) },
  { SPH_C32(0x653a0000), SPH_C32(0x05770016), SPH_C32(0x135ce000),
    SPH_C32(0x32180000), SPH_C32(0x4e7b25a8), SPH_C32(0x6be376ff),
    SPH_C32(0xc1e0f812), SPH_C32(0x2c53436e), SPH_C32(0xc7ed0000),
    SPH_C32(0xfc540028), SPH_C32(0x56ed6000), SPH_C32(0xac3c0000),
    SPH_C32(0xa3ca187c), SPH_C32(0x61228600), SPH_C32(0x5274000c),
    SPH_C32(0x51215a63) },
  { SPH_C32(0x7b740000), SPH_C32(0xdbb80016), SPH_C32(0x7ea4e180),
    SPH_C32(0x453c0000), SPH_C32(0xa23c2236), SPH_C32(0x9f431fb1),
    SPH_C32(0x0c43e000), SPH_C32(0xb4f90a00), SPH_C32(0x75eb0000),
    SPH_C32(0x393d0028), SPH_C32(0x7eee7200), SPH_C32(0xd85b0000),
    SPH_C32(0x15082e88), SPH_C32(0x8a30bff8), SPH_C32(0x61a5dfe0),
    SPH_C32(0x586f6bfb) },
  { SPH_C32(0xcbf90000), SPH_C32(0x99380017), SPH_C32(0x6a8d0000),
    SPH_C32(0x1e0d0000), SPH_C32(0x0bb7501b), SPH_C32(0x0db3c1c9),
    SPH_C32(0x6a720f9d), SPH_C32(0x8f411515), SPH_C32(0x1cc80000),
    SPH_C32(0xf57d0028), SPH_C32(0x1f47a000), SPH_C32(0x2ddd0000),
    SPH_C32(0x69347325), SPH_C32(0x235bb231), SPH_C32(0x11226b7a),
    SPH_C32(0xb94de04d) },
  { SPH_C32(0xd5b70000), SPH_C32(0x47f70017), SPH_C32(0x07750180),
    SPH_C32(0x69290000), SPH_C32(0xe7f05785), SPH_C32(0xf913a887),
    SPH_C32(0xa7d1178f), SPH_C32(0x17eb5c7b), SPH_C32(0xaece0000),
    SPH_C32(0x30140028), SPH_C32(0x3744b200), SPH_C32(0x59ba0000),
    SPH_C32(0xdff645d1), SPH_C32(0xc8498bc9), SPH_C32(0x22f3b496),
    SPH_C32(0xb003d1d5) },
  { SPH_C32(0xbe1f0000), SPH_C32(0x0c5e0016), SPH_C32(0x5af62000),
    SPH_C32(0xb3f90000), SPH_C32(0x84854ef1), SPH_C32(0x299a42ce),
    SPH_C32(0x82b69364), SPH_C32(0xc43ff940), SPH_C32(0xb20b0000),
    SPH_C32(0x69320029), SPH_C32(0x66964000), SPH_C32(0x01c80000),
    SPH_C32(0x2cf80696), SPH_C32(0x450b0507), SPH_C32(0xbab09cf5),
    SPH_C32(0x1a5fb636) },
  { SPH_C32(0xa0510000), SPH_C32(0xd2910016), SPH_C32(0x370e2180),
    SPH_C32(0xc4dd0000), SPH_C32(0x68c2496f), SPH_C32(0xdd3a2b80),
    SPH_C32(0x4f158b76), SPH_C32(0x5c95b02e), SPH_C32(0x000d0000),
    SPH_C32(0xac5b0029), SPH_C32(0x4e955200), SPH_C32(0x75af0000),
    SPH_C32(0x9a3a3062), SPH_C32(0xae193cff), SPH_C32(0x89614319),
    SPH_C32(0x131187ae) },
  { SPH_C32(0x10dc0000), SPH_C32(0x90110017), SPH_C32(0x2327c000),
    SPH_C32(0x9fec0000), SPH_C32(0xc1493b42), SPH_C32(0x4fcaf5f8),
    SPH_C32(0x292464eb), SPH_C32(0x672daf3b), SPH_C32(0x692e0000),
    SPH_C32(0x601b0029), SPH_C32(0x2f3c8000), SPH_C32(0x80290000),
    SPH_C32(0xe6066dcf), SPH_C32(0x07723136), SPH_C32(0xf9e6f783),
    SPH_C32(0xf2330c18) },
  { SPH_C32(0x0e920000), SPH_C32(0x4ede0017), SPH_C32(0x4edfc180),
    SPH_C32(0xe8c80000), SPH_C32(0x2d0e3cdc), SPH_C32(0xbb6a9cb6),
    SPH_C32(0xe4877cf9), SPH_C32(0xff87e655), SPH_C32(0xdb280000),
    SPH_C32(0xa5720029), SPH_C32(0x073f9200), SPH_C32(0xf44e0000),
    SPH_C32(0x50c45b3b), SPH_C32(0xec6008ce), SPH_C32(0xca37286f),
    SPH_C32(0xfb7d3d80) },
  { SPH_C32(0xd3f40000), SPH_C32(0xdf9e0014), SPH_C32(0x06326000),
    SPH_C32(0xe88a0000), SPH_C32(0xb8a67fcc), SPH_C32(0x5dd12a75),
    SPH_C32(0x339210bc), SPH_C32(0x8aeb81e3), SPH_C32(0x41940000),
    SPH_C32(0xc36d002a), SPH_C32(0xb7778000), SPH_C32(0x346a0000),
    SPH_C32(0x36af7f72), SPH_C32(0x2faa4eea), SPH_C32(0x81a94948),
    SPH_C32(0x473c80da) },
  { SPH_C32(0xcdba0000), SPH_C32(0x01510014), SPH_C32(0x6bca6180),
    SPH_C32(0x9fae0000), SPH_C32(0x54e17852), SPH_C32(0xa971433b),
    SPH_C32(0xfe3108ae), SPH_C32(0x1241c88d), SPH_C32(0xf3920000),
    SPH_C32(0x0604002a), SPH_C32(0x9f749200), SPH_C32(0x400d0000),
    SPH_C32(0x806d4986), SPH_C32(0xc4b87712), SPH_C32(0xb27896a4),
    SPH_C32(0x4e72b142) },
  { SPH_C32(0x7d370000), SPH_C32(0x43d10015), SPH_C32(0x7fe38000),
    SPH_C32(0xc49f0000), SPH_C32(0xfd6a0a7f), SPH_C32(0x3b819d43),
    SPH_C32(0x9800e733), SPH_C32(0x29f9d798), SPH_C32(0x9ab10000),
    SPH_C32(0xca44002a), SPH_C32(0xfedd4000), SPH_C32(0xb58b0000),
    SPH_C32(0xfc51142b), SPH_C32(0x6dd37adb), SPH_C32(0xc2ff223e),
    SPH_C32(0xaf503af4) },
  { SPH_C32(0x63790000), SPH_C32(0x9d1e0015), SPH_C32(0x121b8180),
    SPH_C32(0xb3bb0000), SPH_C32(0x112d0de1), SPH_C32(0xcf21f40d),
    SPH_C32(0x55a3ff21), SPH_C32(0xb1539ef6), SPH_C32(0x28b70000),
    SPH_C32(0x0f2d002a), SPH_C32(0xd6de5200), SPH_C32(0xc1ec0000),
    SPH_C32(0x4a9322df), SPH_C32(0x86c14323), SPH_C32(0xf12efdd2),
    SPH_C32(0xa61e0b6c) },
  { SPH_C32(0x08d10000), SPH_C32(0xd6b70014), SPH_C32(0x4f98a000),
    SPH_C32(0x696b0000), SPH_C32(0x72581495), SPH_C32(0x1fa81e44),
    SPH_C32(0x70c47bca), SPH_C32(0x62873bcd), SPH_C32(0x34720000),
    SPH_C32(0x560b002b), SPH_C32(0x870ca000), SPH_C32(0x999e0000),
    SPH_C32(0xb99d6198), SPH_C32(0x0b83cded), SPH_C32(0x696dd5b1),
    SPH_C32(0x0c426c8f) },
  { SPH_C32(0x169f0000), SPH_C32(0x08780014), SPH_C32(0x2260a180),
    SPH_C32(0x1e4f0000), SPH_C32(0x9e1f130b), SPH_C32(0xeb08770a),
    SPH_C32(0xbd6763d8), SPH_C32(0xfa2d72a3), SPH_C32(0x86740000),
    SPH_C32(0x9362002b), SPH_C32(0xaf0fb200), SPH_C32(0xedf90000),
    SPH_C32(0x0f5f576c), SPH_C32(0xe091f415), SPH_C32(0x5abc0a5d),
    SPH_C32(0x050c5d17) },
  { SPH_C32(0xa6120000), SPH_C32(0x4af80015), SPH_C32(0x36494000),
    SPH_C32(0x457e0000), SPH_C32(0x37946126), SPH_C32(0x79f8a972),
    SPH_C32(0xdb568c45), SPH_C32(0xc1956db6), SPH_C32(0xef570000),
    SPH_C32(0x5f22002b), SPH_C32(0xcea66000), SPH_C32(0x187f0000),
    SPH_C32(0x73630ac1), SPH_C32(0x49faf9dc), SPH_C32(0x2a3bbec7),
    SPH_C32(0xe42ed6a1) },
  { SPH_C32(0xb85c0000), SPH_C32(0x94370015), SPH_C32(0x5bb14180),
    SPH_C32(0x325a0000), SPH_C32(0xdbd366b8), SPH_C32(0x8d58c03c),
    SPH_C32(0x16f59457), SPH_C32(0x593f24d8), SPH_C32(0x5d510000),
    SPH_C32(0x9a4b002b), SPH_C32(0xe6a57200), SPH_C32(0x6c180000),
    SPH_C32(0xc5a13c35), SPH_C32(0xa2e8c024), SPH_C32(0x19ea612b),
    SPH_C32(0xed60e739) },
  { SPH_C32(0x558d0000), SPH_C32(0xe0a70016), SPH_C32(0xe7a88000),
    SPH_C32(0x70dc0000), SPH_C32(0x2dc318c2), SPH_C32(0x1359e29f),
    SPH_C32(0xe04f59f8), SPH_C32(0x9cf65b5a), SPH_C32(0x71230000),
    SPH_C32(0x26bd002a), SPH_C32(0x4383e000), SPH_C32(0x76ae0000),
    SPH_C32(0x55174218), SPH_C32(0x5710da8a), SPH_C32(0xa006e8a2),
    SPH_C32(0xf79998ee) },
  { SPH_C32(0x4bc30000), SPH_C32(0x3e680016), SPH_C32(0x8a508180),
    SPH_C32(0x07f80000), SPH_C32(0xc1841f5c), SPH_C32(0xe7f98bd1),
    SPH_C32(0x2dec41ea), SPH_C32(0x045c1234), SPH_C32(0xc3250000),
    SPH_C32(0xe3d4002a), SPH_C32(0x6b80f200), SPH_C32(0x02c90000),
    SPH_C32(0xe3d574ec), SPH_C32(0xbc02e372), SPH_C32(0x93d7374e),
    SPH_C32(0xfed7a976) },
  { SPH_C32(0xfb4e0000), SPH_C32(0x7ce80017), SPH_C32(0x9e796000),
    SPH_C32(0x5cc90000), SPH_C32(0x680f6d71), SPH_C32(0x750955a9),
    SPH_C32(0x4bddae77), SPH_C32(0x3fe40d21), SPH_C32(0xaa060000),
    SPH_C32(0x2f94002a), SPH_C32(0x0a292000), SPH_C32(0xf74f0000),
    SPH_C32(0x9fe92941), SPH_C32(0x1569eebb), SPH_C32(0xe35083d4),
    SPH_C32(0x1ff522c0) },
  { SPH_C32(0xe5000000), SPH_C32(0xa2270017), SPH_C32(0xf3816180),
    SPH_C32(0x2bed0000), SPH_C32(0x84486aef), SPH_C32(0x81a93ce7),
    SPH_C32(0x867eb665), SPH_C32(0xa74e444f), SPH_C32(0x18000000),
    SPH_C32(0xeafd002a), SPH_C32(0x222a3200), SPH_C32(0x83280000),
    SPH_C32(0x292b1fb5), SPH_C32(0xfe7bd743), SPH_C32(0xd0815c38),
    SPH_C32(0x16bb1358) },
  { SPH_C32(0x8ea80000), SPH_C32(0xe98e0016), SPH_C32(0xae024000),
    SPH_C32(0xf13d0000), SPH_C32(0xe73d739b), SPH_C32(0x5120d6ae),
    SPH_C32(0xa319328e), SPH_C32(0x749ae174), SPH_C32(0x04c50000),
    SPH_C32(0xb3db002b), SPH_C32(0x73f8c000), SPH_C32(0xdb5a0000),
    SPH_C32(0xda255cf2), SPH_C32(0x7339598d), SPH_C32(0x48c2745b),
    SPH_C32(0xbce774bb) },
  { SPH_C32(0x90e60000), SPH_C32(0x37410016), SPH_C32(0xc3fa4180),
    SPH_C32(0x86190000), SPH_C32(0x0b7a7405), SPH_C32(0xa580bfe0),
    SPH_C32(0x6eba2a9c), SPH_C32(0xec30a81a), SPH_C32(0xb6c30000),
    SPH_C32(0x76b2002b), SPH_C32(0x5bfbd200), SPH_C32(0xaf3d0000),
    SPH_C32(0x6ce76a06), SPH_C32(0x982b6075), SPH_C32(0x7b13abb7),
    SPH_C32(0xb5a94523) },
  { SPH_C32(0x206b0000), SPH_C32(0x75c10017), SPH_C32(0xd7d3a000),
    SPH_C32(0xdd280000), SPH_C32(0xa2f10628), SPH_C32(0x37706198),
    SPH_C32(0x088bc501), SPH_C32(0xd788b70f), SPH_C32(0xdfe00000),
    SPH_C32(0xbaf2002b), SPH_C32(0x3a520000), SPH_C32(0x5abb0000),
    SPH_C32(0x10db37ab), SPH_C32(0x31406dbc), SPH_C32(0x0b941f2d),
    SPH_C32(0x548bce95) },
  { SPH_C32(0x3e250000), SPH_C32(0xab0e0017), SPH_C32(0xba2ba180),
    SPH_C32(0xaa0c0000), SPH_C32(0x4eb601b6), SPH_C32(0xc3d008d6),
    SPH_C32(0xc528dd13), SPH_C32(0x4f22fe61), SPH_C32(0x6de60000),
    SPH_C32(0x7f9b002b), SPH_C32(0x12511200), SPH_C32(0x2edc0000),
    SPH_C32(0xa619015f), SPH_C32(0xda525444), SPH_C32(0x3845c0c1),
    SPH_C32(0x5dc5ff0d) },
  { SPH_C32(0xf75a0000), SPH_C32(0x19840028), SPH_C32(0xa2190000),
    SPH_C32(0xeef80000), SPH_C32(0xc0722516), SPH_C32(0x19981260),
    SPH_C32(0x73dba1e6), SPH_C32(0xe1844257), SPH_C32(0x14190000),
    SPH_C32(0x23ca003c), SPH_C32(0x50df0000), SPH_C32(0x44b60000),
    SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75), SPH_C32(0x61e610b0),
    SPH_C32(0xdbcadb80) },
  { SPH_C32(0xe9140000), SPH_C32(0xc74b0028), SPH_C32(0xcfe10180),
    SPH_C32(0x99dc0000), SPH_C32(0x2c352288), SPH_C32(0xed387b2e),
    SPH_C32(0xbe78b9f4), SPH_C32(0x792e0b39), SPH_C32(0xa61f0000),
    SPH_C32(0xe6a3003c), SPH_C32(0x78dc1200), SPH_C32(0x30d10000),
    SPH_C32(0xadae5144), SPH_C32(0xd7e1958d), SPH_C32(0x5237cf5c),
    SPH_C32(0xd284ea18) },
  { SPH_C32(0x59990000), SPH_C32(0x85cb0029), SPH_C32(0xdbc8e000),
    SPH_C32(0xc2ed0000), SPH_C32(0x85be50a5), SPH_C32(0x7fc8a556),
    SPH_C32(0xd8495669), SPH_C32(0x4296142c), SPH_C32(0xcf3c0000),
    SPH_C32(0x2ae3003c), SPH_C32(0x1975c000), SPH_C32(0xc5570000),
    SPH_C32(0xd1920ce9), SPH_C32(0x7e8a9844), SPH_C32(0x22b07bc6),
    SPH_C32(0x33a661ae) },
  { SPH_C32(0x47d70000), SPH_C32(0x5b040029), SPH_C32(0xb630e180),
    SPH_C32(0xb5c90000), SPH_C32(0x69f9573b), SPH_C32(0x8b68cc18),
    SPH_C32(0x15ea4e7b), SPH_C32(0xda3c5d42), SPH_C32(0x7d3a0000),
    SPH_C32(0xef8a003c), SPH_C32(0x3176d200), SPH_C32(0xb1300000),
    SPH_C32(0x67503a1d), SPH_C32(0x9598a1bc), SPH_C32(0x1161a42a),
    SPH_C32(0x3ae85036) },
  { SPH_C32(0x2c7f0000), SPH_C32(0x10ad0028), SPH_C32(0xebb3c000),
    SPH_C32(0x6f190000), SPH_C32(0x0a8c4e4f), SPH_C32(0x5be12651),
    SPH_C32(0x308dca90), SPH_C32(0x09e8f879), SPH_C32(0x61ff0000),
    SPH_C32(0xb6ac003d), SPH_C32(0x60a42000), SPH_C32(0xe9420000),
    SPH_C32(0x945e795a), SPH_C32(0x18da2f72), SPH_C32(0x89228c49),
    SPH_C32(0x90b437d5) },
  { SPH_C32(0x32310000), SPH_C32(0xce620028), SPH_C32(0x864bc180),
    SPH_C32(0x183d0000), SPH_C32(0xe6cb49d1), SPH_C32(0xaf414f1f),
    SPH_C32(0xfd2ed282), SPH_C32(0x9142b117), SPH_C32(0xd3f90000),
    SPH_C32(0x73c5003d), SPH_C32(0x48a73200), SPH_C32(0x9d250000),
    SPH_C32(0x229c4fae), SPH_C32(0xf3c8168a), SPH_C32(0xbaf353a5),
    SPH_C32(0x99fa064d) },
  { SPH_C32(0x82bc0000), SPH_C32(0x8ce20029), SPH_C32(0x92622000),
    SPH_C32(0x430c0000), SPH_C32(0x4f403bfc), SPH_C32(0x3db19167),
    SPH_C32(0x9b1f3d1f), SPH_C32(0xaafaae02), SPH_C32(0xbada0000),
    SPH_C32(0xbf85003d), SPH_C32(0x290ee000), SPH_C32(0x68a30000),
    SPH_C32(0x5ea01203), SPH_C32(0x5aa31b43), SPH_C32(0xca74e73f),
    SPH_C32(0x78d88dfb) },
  { SPH_C32(0x9cf20000), SPH_C32(0x522d0029), SPH_C32(0xff9a2180),
    SPH_C32(0x34280000), SPH_C32(0xa3073c62), SPH_C32(0xc911f829),
    SPH_C32(0x56bc250d), SPH_C32(0x3250e76c), SPH_C32(0x08dc0000),
    SPH_C32(0x7aec003d), SPH_C32(0x010df200), SPH_C32(0x1cc40000),
    SPH_C32(0xe86224f7), SPH_C32(0xb1b122bb), SPH_C32(0xf9a538d3),
    SPH_C32(0x7196bc63) },
  { SPH_C32(0x71230000), SPH_C32(0x26bd002a), SPH_C32(0x4383e000),
    SPH_C32(0x76ae0000), SPH_C32(0x55174218), SPH_C32(0x5710da8a),
    SPH_C32(0xa006e8a2), SPH_C32(0xf79998ee), SPH_C32(0x24ae0000),
    SPH_C32(0xc61a003c), SPH_C32(0xa42b6000), SPH_C32(0x06720000),
    SPH_C32(0x78d45ada), SPH_C32(0x44493815), SPH_C32(0x4049b15a),
    SPH_C32(0x6b6fc3b4) },
  { SPH_C32(0x6f6d0000), SPH_C32(0xf872002a), SPH_C32(0x2e7be180),
    SPH_C32(0x018a0000), SPH_C32(0xb9504586), SPH_C32(0xa3b0b3c4),
    SPH_C32(0x6da5f0b0), SPH_C32(0x6f33d180), SPH_C32(0x96a80000),
    SPH_C32(0x0373003c), SPH_C32(0x8c287200), SPH_C32(0x72150000),
    SPH_C32(0xce166c2e), SPH_C32(0xaf5b01ed), SPH_C32(0x73986eb6),
    SPH_C32(0x6221f22c) },
  { SPH_C32(0xdfe00000), SPH_C32(0xbaf2002b), SPH_C32(0x3a520000),
    SPH_C32(0x5abb0000), SPH_C32(0x10db37ab), SPH_C32(0x31406dbc),
    SPH_C32(0x0b941f2d), SPH_C32(0x548bce95), SPH_C32(0xff8b0000),
    SPH_C32(0xcf33003c), SPH_C32(0xed81a000), SPH_C32(0x87930000),
    SPH_C32(0xb22a3183), SPH_C32(0x06300c24), SPH_C32(0x031fda2c),
    SPH_C32(0x8303799a) },
  { SPH_C32(0xc1ae0000), SPH_C32(0x643d002b), SPH_C32(0x57aa0180),
    SPH_C32(0x2d9f0000), SPH_C32(0xfc9c3035), SPH_C32(0xc5e004f2),
    SPH_C32(0xc637073f), SPH_C32(0xcc2187fb), SPH_C32(0x4d8d0000),
    SPH_C32(0x0a5a003c), SPH_C32(0xc582b200), SPH_C32(0xf3f40000),
    SPH_C32(0x04e80777), SPH_C32(0xed2235dc), SPH_C32(0x30ce05c0),
    SPH_C32(0x8a4d4802) },
  { SPH_C32(0xaa060000), SPH_C32(0x2f94002a), SPH_C32(0x0a292000),
    SPH_C32(0xf74f0000), SPH_C32(0x9fe92941), SPH_C32(0x1569eebb),
    SPH_C32(0xe35083d4), SPH_C32(0x1ff522c0), SPH_C32(0x51480000),
    SPH_C32(0x537c003d), SPH_C32(0x94504000), SPH_C32(0xab860000),
    SPH_C32(0xf7e64430), SPH_C32(0x6060bb12), SPH_C32(0xa88d2da3),
    SPH_C32(0x20112fe1) },
  { SPH_C32(0xb4480000), SPH_C32(0xf15b002a), SPH_C32(0x67d12180),
    SPH_C32(0x806b0000), SPH_C32(0x73ae2edf), SPH_C32(0xe1c987f5),
    SPH_C32(0x2ef39bc6), SPH_C32(0x875f6bae), SPH_C32(0xe34e0000),
    SPH_C32(0x9615003d), SPH_C32(0xbc535200), SPH_C32(0xdfe10000),
    SPH_C32(0x412472c4), SPH_C32(0x8b7282ea), SPH_C32(0x9b5cf24f),
    SPH_C32(0x295f1e79) },
  { SPH_C32(0x04c50000), SPH_C32(0xb3db002b), SPH_C32(0x73f8c000),
    SPH_C32(0xdb5a0000), SPH_C32(0xda255cf2), SPH_C32(0x7339598d),
    SPH_C32(0x48c2745b), SPH_C32(0xbce774bb), SPH_C32(0x8a6d0000),
    SPH_C32(0x5a55003d), SPH_C32(0xddfa8000), SPH_C32(0x2a670000),
    SPH_C32(0x3d182f69), SPH_C32(0x22198f23), SPH_C32(0xebdb46d5),
    SPH_C32(0xc87d95cf) },
  { SPH_C32(0x1a8b0000), SPH_C32(0x6d14002b), SPH_C32(0x1e00c180),
    SPH_C32(0xac7e0000), SPH_C32(0x36625b6c), SPH_C32(0x879930c3),
    SPH_C32(0x85616c49), SPH_C32(0x244d3dd5), SPH_C32(0x386b0000),
    SPH_C32(0x9f3c003d), SPH_C32(0xf5f99200), SPH_C32(0x5e000000),
    SPH_C32(0x8bda199d), SPH_C32(0xc90bb6db), SPH_C32(0xd80a9939),
    SPH_C32(0xc133a457) },
  { SPH_C32(0xc7ed0000), SPH_C32(0xfc540028), SPH_C32(0x56ed6000),
    SPH_C32(0xac3c0000), SPH_C32(0xa3ca187c), SPH_C32(0x61228600),
    SPH_C32(0x5274000c), SPH_C32(0x51215a63), SPH_C32(0xa2d70000),
    SPH_C32(0xf923003e), SPH_C32(0x45b18000), SPH_C32(0x9e240000),
    SPH_C32(0xedb13dd4), SPH_C32(0x0ac1f0ff), SPH_C32(0x9394f81e),
    SPH_C32(0x7d72190d) },
  { SPH_C32(0xd9a30000), SPH_C32(0x229b0028), SPH_C32(0x3b156180),
    SPH_C32(0xdb180000), SPH_C32(0x4f8d1fe2), SPH_C32(0x9582ef4e),
    SPH_C32(0x9fd7181e), SPH_C32(0xc98b130d), SPH_C32(0x10d10000),
    SPH_C32(0x3c4a003e), SPH_C32(0x6db29200), SPH_C32(0xea430000),
    SPH_C32(0x5b730b20), SPH_C32(0xe1d3c907), SPH_C32(0xa04527f2),
    SPH_C32(0x743c2895) },
  { SPH_C32(0x692e0000), SPH_C32(0x601b0029), SPH_C32(0x2f3c8000),
    SPH_C32(0x80290000), SPH_C32(0xe6066dcf), SPH_C32(0x07723136),
    SPH_C32(0xf9e6f783), SPH_C32(0xf2330c18), SPH_C32(0x79f20000),
    SPH_C32(0xf00a003e), SPH_C32(0x0c1b4000), SPH_C32(0x1fc50000),
    SPH_C32(0x274f568d), SPH_C32(0x48b8c4ce), SPH_C32(0xd0c29368),
    SPH_C32(0x951ea323) },
  { SPH_C32(0x77600000), SPH_C32(0xbed40029), SPH_C32(0x42c48180),
    SPH_C32(0xf70d0000), SPH_C32(0x0a416a51), SPH_C32(0xf3d25878),
    SPH_C32(0x3445ef91), SPH_C32(0x6a994576), SPH_C32(0xcbf40000),
    SPH_C32(0x3563003e), SPH_C32(0x24185200), SPH_C32(0x6ba20000),
    SPH_C32(0x918d6079), SPH_C32(0xa3aafd36), SPH_C32(0xe3134c84),
    SPH_C32(0x9c5092bb) },
  { SPH_C32(0x1cc80000), SPH_C32(0xf57d0028), SPH_C32(0x1f47a000),
    SPH_C32(0x2ddd0000), SPH_C32(0x69347325), SPH_C32(0x235bb231),
    SPH_C32(0x11226b7a), SPH_C32(0xb94de04d), SPH_C32(0xd7310000),
    SPH_C32(0x6c45003f), SPH_C32(0x75caa000), SPH_C32(0x33d00000),
    SPH_C32(0x6283233e), SPH_C32(0x2ee873f8), SPH_C32(0x7b5064e7),
    SPH_C32(0x360cf558) },
  { SPH_C32(0x02860000), SPH_C32(0x2bb20028), SPH_C32(0x72bfa180),
    SPH_C32(0x5af90000), SPH_C32(0x857374bb), SPH_C32(0xd7fbdb7f),
    SPH_C32(0xdc817368), SPH_C32(0x21e7a923), SPH_C32(0x65370000),
    SPH_C32(0xa92c003f), SPH_C32(0x5dc9b200), SPH_C32(0x47b70000),
    SPH_C32(0xd44115ca), SPH_C32(0xc5fa4a00), SPH_C32(0x4881bb0b),
    SPH_C32(0x3f42c4c0) },
  { SPH_C32(0xb20b0000), SPH_C32(0x69320029), SPH_C32(0x66964000),
    SPH_C32(0x01c80000), SPH_C32(0x2cf80696), SPH_C32(0x450b0507),
    SPH_C32(0xbab09cf5), SPH_C32(0x1a5fb636), SPH_C32(0x0c140000),
    SPH_C32(0x656c003f), SPH_C32(0x3c606000), SPH_C32(0xb2310000),
    SPH_C32(0xa87d4867), SPH_C32(0x6c9147c9), SPH_C32(0x38060f91),
    SPH_C32(0xde604f76) },
  { SPH_C32(0xac450000), SPH_C32(0xb7fd0029), SPH_C32(0x0b6e4180),
    SPH_C32(0x76ec0000), SPH_C32(0xc0bf0108), SPH_C32(0xb1ab6c49),
    SPH_C32(0x771384e7), SPH_C32(0x82f5ff58), SPH_C32(0xbe120000),
    SPH_C32(0xa005003f), SPH_C32(0x14637200), SPH_C32(0xc6560000),
    SPH_C32(0x1ebf7e93), SPH_C32(0x87837e31), SPH_C32(0x0bd7d07d),
    SPH_C32(0xd72e7eee) },
  { SPH_C32(0x41940000), SPH_C32(0xc36d002a), SPH_C32(0xb7778000),
    SPH_C32(0x346a0000), SPH_C32(0x36af7f72), SPH_C32(0x2faa4eea),
    SPH_C32(0x81a94948), SPH_C32(0x473c80da), SPH_C32(0x92600000),
    SPH_C32(0x1cf3003e), SPH_C32(0xb145e000), SPH_C32(0xdce00000),
    SPH_C32(0x8e0900be), SPH_C32(0x727b649f), SPH_C32(0xb23b59f4),
    SPH_C32(0xcdd70139) },
  { SPH_C32(0x5fda0000), SPH_C32(0x1da2002a), SPH_C32(0xda8f8180),
    SPH_C32(0x434e0000), SPH_C32(0xdae878ec), SPH_C32(0xdb0a27a4),
    SPH_C32(0x4c0a515a), SPH_C32(0xdf96c9b4), SPH_C32(0x20660000),
    SPH_C32(0xd99a003e), SPH_C32(0x9946f200), SPH_C32(0xa8870000),
    SPH_C32(0x38cb364a), SPH_C32(0x99695d67), SPH_C32(0x81ea8618),
    SPH_C32(0xc49930a1) },
  { SPH_C32(0xef570000), SPH_C32(0x5f22002b), SPH_C32(0xcea66000),
    SPH_C32(0x187f0000), SPH_C32(0x73630ac1), SPH_C32(0x49faf9dc),
    SPH_C32(0x2a3bbec7), SPH_C32(0xe42ed6a1), SPH_C32(0x49450000),
    SPH_C32(0x15da003e), SPH_C32(0xf8ef2000), SPH_C32(0x5d010000),
    SPH_C32(0x44f76be7), SPH_C32(0x300250ae), SPH_C32(0xf16d3282),
    SPH_C32(0x25bbbb17) },
  { SPH_C32(0xf1190000), SPH_C32(0x81ed002b), SPH_C32(0xa35e6180),
    SPH_C32(0x6f5b0000), SPH_C32(0x9f240d5f), SPH_C32(0xbd5a9092),
    SPH_C32(0xe798a6d5), SPH_C32(0x7c849fcf), SPH_C32(0xfb430000),
    SPH_C32(0xd0b3003e), SPH_C32(0xd0ec3200), SPH_C32(0x29660000),
    SPH_C32(0xf2355d13), SPH_C32(0xdb106956), SPH_C32(0xc2bced6e),
    SPH_C32(0x2cf58a8f) },
  { SPH_C32(0x9ab10000), SPH_C32(0xca44002a), SPH_C32(0xfedd4000),
    SPH_C32(0xb58b0000), SPH_C32(0xfc51142b), SPH_C32(0x6dd37adb),
    SPH_C32(0xc2ff223e), SPH_C32(0xaf503af4), SPH_C32(0xe7860000),
    SPH_C32(0x8995003f), SPH_C32(0x813ec000), SPH_C32(0x71140000),
    SPH_C32(0x013b1e54), SPH_C32(0x5652e798), SPH_C32(0x5affc50d),
    SPH_C32(0x86a9ed6c) },
  { SPH_C32(0x84ff0000), SPH_C32(0x148b002a), SPH_C32(0x93254180),
    SPH_C32(0xc2af0000), SPH_C32(0x101613b5), SPH_C32(0x99731395),
    SPH_C32(0x0f5c3a2c), SPH_C32(0x37fa739a), SPH_C32(0x55800000),
    SPH_C32(0x4cfc003f), SPH_C32(0xa93dd200), SPH_C32(0x05730000),
    SPH_C32(0xb7f928a0), SPH_C32(0xbd40de60), SPH_C32(0x692e1ae1),
    SPH_C32(0x8fe7dcf4) },
  { SPH_C32(0x34720000), SPH_C32(0x560b002b), SPH_C32(0x870ca000),
    SPH_C32(0x999e0000), SPH_C32(0xb99d6198), SPH_C32(0x0b83cded),
    SPH_C32(0x696dd5b1), SPH_C32(0x0c426c8f), SPH_C32(0x3ca30000),
    SPH_C32(0x80bc003f), SPH_C32(0xc8940000), SPH_C32(0xf0f50000),
    SPH_C32(0xcbc5750d), SPH_C32(0x142bd3a9), SPH_C32(0x19a9ae7b),
    SPH_C32(0x6ec55742) },
  { SPH_C32(0x2a3c0000), SPH_C32(0x88c4002b), SPH_C32(0xeaf4a180),
    SPH_C32(0xeeba0000), SPH_C32(0x55da6606), SPH_C32(0xff23a4a3),
    SPH_C32(0xa4cecda3), SPH_C32(0x94e825e1), SPH_C32(0x8ea50000),
    SPH_C32(0x45d5003f), SPH_C32(0xe0971200), SPH_C32(0x84920000),
    SPH_C32(0x7d0743f9), SPH_C32(0xff39ea51), SPH_C32(0x2a787197),
    SPH_C32(0x678b66da) }
};

__constant static const sph_u32 T512_35[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0x01dd0000), SPH_C32(0x80a80000), SPH_C32(0xf4960048),
    SPH_C32(0xa6000000), SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37),
    SPH_C32(0x6612cffd), SPH_C32(0x2c94459e), SPH_C32(0x52500000),
    SPH_C32(0x29540000), SPH_C32(0x6a61004e), SPH_C32(0xf0ff0000),
    SPH_C32(0x9a317eec), SPH_C32(0x452341ce), SPH_C32(0xcf568fe5),
    SPH_C32(0x5303130f) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x9e440000), SPH_C32(0x8c370000), SPH_C32(0x30d807ce),
    SPH_C32(0xcbaf0000), SPH_C32(0xd1e16d13), SPH_C32(0xc2b875d6),
    SPH_C32(0xa615c724), SPH_C32(0x995994f1), SPH_C32(0xd2130000),
    SPH_C32(0x45ab0000), SPH_C32(0xf8c50286), SPH_C32(0xc30c0000),
    SPH_C32(0x574d284c), SPH_C32(0xda31f145), SPH_C32(0x4f1ee235),
    SPH_C32(0xf1f0e16b) },
  { SPH_C32(0x9f990000), SPH_C32(0x0c9f0000), SPH_C32(0xc44e0786),
    SPH_C32(0x6daf0000), SPH_C32(0x413413b1), SPH_C32(0x155ef9e1),
    SPH_C32(0xc00708d9), SPH_C32(0xb5cdd16f), SPH_C32(0x80430000),
    SPH_C32(0x6cff0000), SPH_C32(0x92a402c8), SPH_C32(0x33f30000),
    SPH_C32(0xcd7c56a0), SPH_C32(0x9f12b08b), SPH_C32(0x80486dd0),
    SPH_C32(0xa2f3f264) },
  { SPH_C32(0xcdc90000), SPH_C32(0x25cb0000), SPH_C32(0xae2f07c8),
    SPH_C32(0x9d500000), SPH_C32(0xdb056d5d), SPH_C32(0x507db82f),
    SPH_C32(0x0f51873c), SPH_C32(0xe6cec260), SPH_C32(0xd3ce0000),
    SPH_C32(0xc5030000), SPH_C32(0x0c5302ce), SPH_C32(0x650c0000),
    SPH_C32(0xc79856ee), SPH_C32(0x0dd77d72), SPH_C32(0x290c2dc8),
    SPH_C32(0xdd64a4f5) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0xd3ce0000), SPH_C32(0xc5030000), SPH_C32(0x0c5302ce),
    SPH_C32(0x650c0000), SPH_C32(0xc79856ee), SPH_C32(0x0dd77d72),
    SPH_C32(0x290c2dc8), SPH_C32(0xdd64a4f5), SPH_C32(0x1e070000),
    SPH_C32(0xe0c80000), SPH_C32(0xa27c0506), SPH_C32(0xf85c0000),
    SPH_C32(0x1c9d3bb3), SPH_C32(0x5daac55d), SPH_C32(0x265daaf4),
    SPH_C32(0x3baa6695) },
  { SPH_C32(0xd2130000), SPH_C32(0x45ab0000), SPH_C32(0xf8c50286),
    SPH_C32(0xc30c0000), SPH_C32(0x574d284c), SPH_C32(0xda31f145),
    SPH_C32(0x4f1ee235), SPH_C32(0xf1f0e16b), SPH_C32(0x4c570000),
    SPH_C32(0xc99c0000), SPH_C32(0xc81d0548), SPH_C32(0x08a30000),
    SPH_C32(0x86ac455f), SPH_C32(0x18898493), SPH_C32(0xe90b2511),
    SPH_C32(0x68a9759a) },
  { SPH_C32(0x80430000), SPH_C32(0x6cff0000), SPH_C32(0x92a402c8),
    SPH_C32(0x33f30000), SPH_C32(0xcd7c56a0), SPH_C32(0x9f12b08b),
    SPH_C32(0x80486dd0), SPH_C32(0xa2f3f264), SPH_C32(0x1fda0000),
    SPH_C32(0x60600000), SPH_C32(0x56ea054e), SPH_C32(0x5e5c0000),
    SPH_C32(0x8c484511), SPH_C32(0x8a4c496a), SPH_C32(0x404f6509),
    SPH_C32(0x173e230b) },
  { SPH_C32(0x4d8a0000), SPH_C32(0x49340000), SPH_C32(0x3c8b0500),
    SPH_C32(0xaea30000), SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4),
    SPH_C32(0x8f19eaec), SPH_C32(0x443d3004), SPH_C32(0xcc140000),
    SPH_C32(0xa5630000), SPH_C32(0x5ab90780), SPH_C32(0x3b500000),
    SPH_C32(0x4bd013ff), SPH_C32(0x879b3418), SPH_C32(0x694348c1),
    SPH_C32(0xca5a87fe) },
  { SPH_C32(0x1fda0000), SPH_C32(0x60600000), SPH_C32(0x56ea054e),
    SPH_C32(0x5e5c0000), SPH_C32(0x8c484511), SPH_C32(0x8a4c496a),
    SPH_C32(0x404f6509), SPH_C32(0x173e230b), SPH_C32(0x9f990000),
    SPH_C32(0x0c9f0000), SPH_C32(0xc44e0786), SPH_C32(0x6daf0000),
    SPH_C32(0x413413b1), SPH_C32(0x155ef9e1), SPH_C32(0xc00708d9),
    SPH_C32(0xb5cdd16f) },
  { SPH_C32(0x1e070000), SPH_C32(0xe0c80000), SPH_C32(0xa27c0506),
    SPH_C32(0xf85c0000), SPH_C32(0x1c9d3bb3), SPH_C32(0x5daac55d),
    SPH_C32(0x265daaf4), SPH_C32(0x3baa6695), SPH_C32(0xcdc90000),
    SPH_C32(0x25cb0000), SPH_C32(0xae2f07c8), SPH_C32(0x9d500000),
    SPH_C32(0xdb056d5d), SPH_C32(0x507db82f), SPH_C32(0x0f51873c),
    SPH_C32(0xe6cec260) },
  { SPH_C32(0x4c570000), SPH_C32(0xc99c0000), SPH_C32(0xc81d0548),
    SPH_C32(0x08a30000), SPH_C32(0x86ac455f), SPH_C32(0x18898493),
    SPH_C32(0xe90b2511), SPH_C32(0x68a9759a), SPH_C32(0x9e440000),
    SPH_C32(0x8c370000), SPH_C32(0x30d807ce), SPH_C32(0xcbaf0000),
    SPH_C32(0xd1e16d13), SPH_C32(0xc2b875d6), SPH_C32(0xa615c724),
    SPH_C32(0x995994f1) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0x2a730000), SPH_C32(0x3ba80000), SPH_C32(0xc35b0bce),
    SPH_C32(0x605a0000), SPH_C32(0xeb0f5695), SPH_C32(0x3bcac8ea),
    SPH_C32(0x3fda2f87), SPH_C32(0x306c98a4), SPH_C32(0x51220000),
    SPH_C32(0x1ed40000), SPH_C32(0x24eb0306), SPH_C32(0x00670000),
    SPH_C32(0xb069459d), SPH_C32(0x128d0b9e), SPH_C32(0x00185482),
    SPH_C32(0x8b61bcea) },
  { SPH_C32(0x2bae0000), SPH_C32(0xbb000000), SPH_C32(0x37cd0b86),
    SPH_C32(0xc65a0000), SPH_C32(0x7bda2837), SPH_C32(0xec2c44dd),
    SPH_C32(0x59c8e07a), SPH_C32(0x1cf8dd3a), SPH_C32(0x03720000),
    SPH_C32(0x37800000), SPH_C32(0x4e8a0348), SPH_C32(0xf0980000),
    SPH_C32(0x2a583b71), SPH_C32(0x57ae4a50), SPH_C32(0xcf4edb67),
    SPH_C32(0xd862afe5) },
  { SPH_C32(0x79fe0000), SPH_C32(0x92540000), SPH_C32(0x5dac0bc8),
    SPH_C32(0x36a50000), SPH_C32(0xe1eb56db), SPH_C32(0xa90f0513),
    SPH_C32(0x969e6f9f), SPH_C32(0x4ffbce35), SPH_C32(0x50ff0000),
    SPH_C32(0x9e7c0000), SPH_C32(0xd07d034e), SPH_C32(0xa6670000),
    SPH_C32(0x20bc3b3f), SPH_C32(0xc56b87a9), SPH_C32(0x660a9b7f),
    SPH_C32(0xa7f5f974) },
  { SPH_C32(0xb4370000), SPH_C32(0xb79f0000), SPH_C32(0xf3830c00),
    SPH_C32(0xabf50000), SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c),
    SPH_C32(0x99cfe8a3), SPH_C32(0xa9350c55), SPH_C32(0x83310000),
    SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180), SPH_C32(0xc36b0000),
    SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb), SPH_C32(0x4f06b6b7),
    SPH_C32(0x7a915d81) },
  { SPH_C32(0xe6670000), SPH_C32(0x9ecb0000), SPH_C32(0x99e20c4e),
    SPH_C32(0x5b0a0000), SPH_C32(0xa0df456a), SPH_C32(0xbc51fcf2),
    SPH_C32(0x56996746), SPH_C32(0xfa361f5a), SPH_C32(0xd0bc0000),
    SPH_C32(0xf2830000), SPH_C32(0x42d90186), SPH_C32(0x95940000),
    SPH_C32(0xedc06d9f), SPH_C32(0x5a793722), SPH_C32(0xe642f6af),
    SPH_C32(0x05060b10) },
  { SPH_C32(0xe7ba0000), SPH_C32(0x1e630000), SPH_C32(0x6d740c06),
    SPH_C32(0xfd0a0000), SPH_C32(0x300a3bc8), SPH_C32(0x6bb770c5),
    SPH_C32(0x308ba8bb), SPH_C32(0xd6a25ac4), SPH_C32(0x82ec0000),
    SPH_C32(0xdbd70000), SPH_C32(0x28b801c8), SPH_C32(0x656b0000),
    SPH_C32(0x77f11373), SPH_C32(0x1f5a76ec), SPH_C32(0x2914794a),
    SPH_C32(0x5605181f) },
  { SPH_C32(0xb5ea0000), SPH_C32(0x37370000), SPH_C32(0x07150c48),
    SPH_C32(0x0df50000), SPH_C32(0xaa3b4524), SPH_C32(0x2e94310b),
    SPH_C32(0xffdd275e), SPH_C32(0x85a149cb), SPH_C32(0xd1610000),
    SPH_C32(0x722b0000), SPH_C32(0xb64f01ce), SPH_C32(0x33940000),
    SPH_C32(0x7d15133d), SPH_C32(0x8d9fbb15), SPH_C32(0x80503952),
    SPH_C32(0x29924e8e) },
  { SPH_C32(0xf9bd0000), SPH_C32(0xfeab0000), SPH_C32(0xcf080900),
    SPH_C32(0x05560000), SPH_C32(0x2c97007b), SPH_C32(0x361db598),
    SPH_C32(0x16d6024f), SPH_C32(0xed083c51), SPH_C32(0x4f250000),
    SPH_C32(0xfe1c0000), SPH_C32(0x86970600), SPH_C32(0xf83b0000),
    SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3), SPH_C32(0x2645fe76),
    SPH_C32(0xb0cbda7f) },
  { SPH_C32(0xabed0000), SPH_C32(0xd7ff0000), SPH_C32(0xa569094e),
    SPH_C32(0xf5a90000), SPH_C32(0xb6a67e97), SPH_C32(0x733ef456),
    SPH_C32(0xd9808daa), SPH_C32(0xbe0b2f5e), SPH_C32(0x1ca80000),
    SPH_C32(0x57e00000), SPH_C32(0x18600606), SPH_C32(0xaec40000),
    SPH_C32(0xa6107e60), SPH_C32(0xdde2033a), SPH_C32(0x8f01be6e),
    SPH_C32(0xcf5c8cee) },
  { SPH_C32(0xaa300000), SPH_C32(0x57570000), SPH_C32(0x51ff0906),
    SPH_C32(0x53a90000), SPH_C32(0x26730035), SPH_C32(0xa4d87861),
    SPH_C32(0xbf924257), SPH_C32(0x929f6ac0), SPH_C32(0x4ef80000),
    SPH_C32(0x7eb40000), SPH_C32(0x72010648), SPH_C32(0x5e3b0000),
    SPH_C32(0x3c21008c), SPH_C32(0x98c142f4), SPH_C32(0x4057318b),
    SPH_C32(0x9c5f9fe1) },
  { SPH_C32(0xf8600000), SPH_C32(0x7e030000), SPH_C32(0x3b9e0948),
    SPH_C32(0xa3560000), SPH_C32(0xbc427ed9), SPH_C32(0xe1fb39af),
    SPH_C32(0x70c4cdb2), SPH_C32(0xc19c79cf), SPH_C32(0x1d750000),
    SPH_C32(0xd7480000), SPH_C32(0xecf6064e), SPH_C32(0x08c40000),
    SPH_C32(0x36c500c2), SPH_C32(0x0a048f0d), SPH_C32(0xe9137193),
    SPH_C32(0xe3c8c970) },
  { SPH_C32(0x35a90000), SPH_C32(0x5bc80000), SPH_C32(0x95b10e80),
    SPH_C32(0x3e060000), SPH_C32(0x67471384), SPH_C32(0xb1868180),
    SPH_C32(0x7f954a8e), SPH_C32(0x2752bbaf), SPH_C32(0xcebb0000),
    SPH_C32(0x124b0000), SPH_C32(0xe0a50480), SPH_C32(0x6dc80000),
    SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f), SPH_C32(0xc01f5c5b),
    SPH_C32(0x3eac6d85) },
  { SPH_C32(0x67f90000), SPH_C32(0x729c0000), SPH_C32(0xffd00ece),
    SPH_C32(0xcef90000), SPH_C32(0xfd766d68), SPH_C32(0xf4a5c04e),
    SPH_C32(0xb0c3c56b), SPH_C32(0x7451a8a0), SPH_C32(0x9d360000),
    SPH_C32(0xbbb70000), SPH_C32(0x7e520486), SPH_C32(0x3b370000),
    SPH_C32(0xfbb95662), SPH_C32(0x95163f86), SPH_C32(0x695b1c43),
    SPH_C32(0x413b3b14) },
  { SPH_C32(0x66240000), SPH_C32(0xf2340000), SPH_C32(0x0b460e86),
    SPH_C32(0x68f90000), SPH_C32(0x6da313ca), SPH_C32(0x23434c79),
    SPH_C32(0xd6d10a96), SPH_C32(0x58c5ed3e), SPH_C32(0xcf660000),
    SPH_C32(0x92e30000), SPH_C32(0x143304c8), SPH_C32(0xcbc80000),
    SPH_C32(0x6188288e), SPH_C32(0xd0357e48), SPH_C32(0xa60d93a6),
    SPH_C32(0x1238281b) },
  { SPH_C32(0x34740000), SPH_C32(0xdb600000), SPH_C32(0x61270ec8),
    SPH_C32(0x98060000), SPH_C32(0xf7926d26), SPH_C32(0x66600db7),
    SPH_C32(0x19878573), SPH_C32(0x0bc6fe31), SPH_C32(0x9ceb0000),
    SPH_C32(0x3b1f0000), SPH_C32(0x8ac404ce), SPH_C32(0x9d370000),
    SPH_C32(0x6b6c28c0), SPH_C32(0x42f0b3b1), SPH_C32(0x0f49d3be),
    SPH_C32(0x6daf7e8a) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0x50ff0000), SPH_C32(0x9e7c0000), SPH_C32(0xd07d034e),
    SPH_C32(0xa6670000), SPH_C32(0x20bc3b3f), SPH_C32(0xc56b87a9),
    SPH_C32(0x660a9b7f), SPH_C32(0xa7f5f974), SPH_C32(0x29010000),
    SPH_C32(0x0c280000), SPH_C32(0x8dd10886), SPH_C32(0x90c20000),
    SPH_C32(0xc1576de4), SPH_C32(0x6c6482ba), SPH_C32(0xf094f4e0),
    SPH_C32(0xe80e3741) },
  { SPH_C32(0x51220000), SPH_C32(0x1ed40000), SPH_C32(0x24eb0306),
    SPH_C32(0x00670000), SPH_C32(0xb069459d), SPH_C32(0x128d0b9e),
    SPH_C32(0x00185482), SPH_C32(0x8b61bcea), SPH_C32(0x7b510000),
    SPH_C32(0x257c0000), SPH_C32(0xe7b008c8), SPH_C32(0x603d0000),
    SPH_C32(0x5b661308), SPH_C32(0x2947c374), SPH_C32(0x3fc27b05),
    SPH_C32(0xbb0d244e) },
  { SPH_C32(0x03720000), SPH_C32(0x37800000), SPH_C32(0x4e8a0348),
    SPH_C32(0xf0980000), SPH_C32(0x2a583b71), SPH_C32(0x57ae4a50),
    SPH_C32(0xcf4edb67), SPH_C32(0xd862afe5), SPH_C32(0x28dc0000),
    SPH_C32(0x8c800000), SPH_C32(0x794708ce), SPH_C32(0x36c20000),
    SPH_C32(0x51821346), SPH_C32(0xbb820e8d), SPH_C32(0x96863b1d),
    SPH_C32(0xc49a72df) },
  { SPH_C32(0xcebb0000), SPH_C32(0x124b0000), SPH_C32(0xe0a50480),
    SPH_C32(0x6dc80000), SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f),
    SPH_C32(0xc01f5c5b), SPH_C32(0x3eac6d85), SPH_C32(0xfb120000),
    SPH_C32(0x49830000), SPH_C32(0x75140a00), SPH_C32(0x53ce0000),
    SPH_C32(0x961a45a8), SPH_C32(0xb65573ff), SPH_C32(0xbf8a16d5),
    SPH_C32(0x19fed62a) },
  { SPH_C32(0x9ceb0000), SPH_C32(0x3b1f0000), SPH_C32(0x8ac404ce),
    SPH_C32(0x9d370000), SPH_C32(0x6b6c28c0), SPH_C32(0x42f0b3b1),
    SPH_C32(0x0f49d3be), SPH_C32(0x6daf7e8a), SPH_C32(0xa89f0000),
    SPH_C32(0xe07f0000), SPH_C32(0xebe30a06), SPH_C32(0x05310000),
    SPH_C32(0x9cfe45e6), SPH_C32(0x2490be06), SPH_C32(0x16ce56cd),
    SPH_C32(0x666980bb) },
  { SPH_C32(0x9d360000), SPH_C32(0xbbb70000), SPH_C32(0x7e520486),
    SPH_C32(0x3b370000), SPH_C32(0xfbb95662), SPH_C32(0x95163f86),
    SPH_C32(0x695b1c43), SPH_C32(0x413b3b14), SPH_C32(0xfacf0000),
    SPH_C32(0xc92b0000), SPH_C32(0x81820a48), SPH_C32(0xf5ce0000),
    SPH_C32(0x06cf3b0a), SPH_C32(0x61b3ffc8), SPH_C32(0xd998d928),
    SPH_C32(0x356a93b4) },
  { SPH_C32(0xcf660000), SPH_C32(0x92e30000), SPH_C32(0x143304c8),
    SPH_C32(0xcbc80000), SPH_C32(0x6188288e), SPH_C32(0xd0357e48),
    SPH_C32(0xa60d93a6), SPH_C32(0x1238281b), SPH_C32(0xa9420000),
    SPH_C32(0x60d70000), SPH_C32(0x1f750a4e), SPH_C32(0xa3310000),
    SPH_C32(0x0c2b3b44), SPH_C32(0xf3763231), SPH_C32(0x70dc9930),
    SPH_C32(0x4afdc525) },
  { SPH_C32(0x83310000), SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180),
    SPH_C32(0xc36b0000), SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb),
    SPH_C32(0x4f06b6b7), SPH_C32(0x7a915d81), SPH_C32(0x37060000),
    SPH_C32(0xece00000), SPH_C32(0x2fad0d80), SPH_C32(0x689e0000),
    SPH_C32(0xddca5657), SPH_C32(0x31ce47e7), SPH_C32(0xd6c95e14),
    SPH_C32(0xd3a451d4) },
  { SPH_C32(0xd1610000), SPH_C32(0x722b0000), SPH_C32(0xb64f01ce),
    SPH_C32(0x33940000), SPH_C32(0x7d15133d), SPH_C32(0x8d9fbb15),
    SPH_C32(0x80503952), SPH_C32(0x29924e8e), SPH_C32(0x648b0000),
    SPH_C32(0x451c0000), SPH_C32(0xb15a0d86), SPH_C32(0x3e610000),
    SPH_C32(0xd72e5619), SPH_C32(0xa30b8a1e), SPH_C32(0x7f8d1e0c),
    SPH_C32(0xac330745) },
  { SPH_C32(0xd0bc0000), SPH_C32(0xf2830000), SPH_C32(0x42d90186),
    SPH_C32(0x95940000), SPH_C32(0xedc06d9f), SPH_C32(0x5a793722),
    SPH_C32(0xe642f6af), SPH_C32(0x05060b10), SPH_C32(0x36db0000),
    SPH_C32(0x6c480000), SPH_C32(0xdb3b0dc8), SPH_C32(0xce9e0000),
    SPH_C32(0x4d1f28f5), SPH_C32(0xe628cbd0), SPH_C32(0xb0db91e9),
    SPH_C32(0xff30144a) },
  { SPH_C32(0x82ec0000), SPH_C32(0xdbd70000), SPH_C32(0x28b801c8),
    SPH_C32(0x656b0000), SPH_C32(0x77f11373), SPH_C32(0x1f5a76ec),
    SPH_C32(0x2914794a), SPH_C32(0x5605181f), SPH_C32(0x65560000),
    SPH_C32(0xc5b40000), SPH_C32(0x45cc0dce), SPH_C32(0x98610000),
    SPH_C32(0x47fb28bb), SPH_C32(0x74ed0629), SPH_C32(0x199fd1f1),
    SPH_C32(0x80a742db) },
  { SPH_C32(0x4f250000), SPH_C32(0xfe1c0000), SPH_C32(0x86970600),
    SPH_C32(0xf83b0000), SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3),
    SPH_C32(0x2645fe76), SPH_C32(0xb0cbda7f), SPH_C32(0xb6980000),
    SPH_C32(0x00b70000), SPH_C32(0x499f0f00), SPH_C32(0xfd6d0000),
    SPH_C32(0x80637e55), SPH_C32(0x793a7b5b), SPH_C32(0x3093fc39),
    SPH_C32(0x5dc3e62e) },
  { SPH_C32(0x1d750000), SPH_C32(0xd7480000), SPH_C32(0xecf6064e),
    SPH_C32(0x08c40000), SPH_C32(0x36c500c2), SPH_C32(0x0a048f0d),
    SPH_C32(0xe9137193), SPH_C32(0xe3c8c970), SPH_C32(0xe5150000),
    SPH_C32(0xa94b0000), SPH_C32(0xd7680f06), SPH_C32(0xab920000),
    SPH_C32(0x8a877e1b), SPH_C32(0xebffb6a2), SPH_C32(0x99d7bc21),
    SPH_C32(0x2254b0bf) },
  { SPH_C32(0x1ca80000), SPH_C32(0x57e00000), SPH_C32(0x18600606),
    SPH_C32(0xaec40000), SPH_C32(0xa6107e60), SPH_C32(0xdde2033a),
    SPH_C32(0x8f01be6e), SPH_C32(0xcf5c8cee), SPH_C32(0xb7450000),
    SPH_C32(0x801f0000), SPH_C32(0xbd090f48), SPH_C32(0x5b6d0000),
    SPH_C32(0x10b600f7), SPH_C32(0xaedcf76c), SPH_C32(0x568133c4),
    SPH_C32(0x7157a3b0) },
  { SPH_C32(0x4ef80000), SPH_C32(0x7eb40000), SPH_C32(0x72010648),
    SPH_C32(0x5e3b0000), SPH_C32(0x3c21008c), SPH_C32(0x98c142f4),
    SPH_C32(0x4057318b), SPH_C32(0x9c5f9fe1), SPH_C32(0xe4c80000),
    SPH_C32(0x29e30000), SPH_C32(0x23fe0f4e), SPH_C32(0x0d920000),
    SPH_C32(0x1a5200b9), SPH_C32(0x3c193a95), SPH_C32(0xffc573dc),
    SPH_C32(0x0ec0f521) },
  { SPH_C32(0x7a8c0000), SPH_C32(0xa5d40000), SPH_C32(0x13260880),
    SPH_C32(0xc63d0000), SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43),
    SPH_C32(0x59d0b4f8), SPH_C32(0x979961d0), SPH_C32(0x78230000),
    SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80), SPH_C32(0x90a50000),
    SPH_C32(0x713e2879), SPH_C32(0x7ee98924), SPH_C32(0xf08ca062),
    SPH_C32(0x636f8bab) },
  { SPH_C32(0x28dc0000), SPH_C32(0x8c800000), SPH_C32(0x794708ce),
    SPH_C32(0x36c20000), SPH_C32(0x51821346), SPH_C32(0xbb820e8d),
    SPH_C32(0x96863b1d), SPH_C32(0xc49a72df), SPH_C32(0x2bae0000),
    SPH_C32(0xbb000000), SPH_C32(0x37cd0b86), SPH_C32(0xc65a0000),
    SPH_C32(0x7bda2837), SPH_C32(0xec2c44dd), SPH_C32(0x59c8e07a),
    SPH_C32(0x1cf8dd3a) },
  { SPH_C32(0x29010000), SPH_C32(0x0c280000), SPH_C32(0x8dd10886),
    SPH_C32(0x90c20000), SPH_C32(0xc1576de4), SPH_C32(0x6c6482ba),
    SPH_C32(0xf094f4e0), SPH_C32(0xe80e3741), SPH_C32(0x79fe0000),
    SPH_C32(0x92540000), SPH_C32(0x5dac0bc8), SPH_C32(0x36a50000),
    SPH_C32(0xe1eb56db), SPH_C32(0xa90f0513), SPH_C32(0x969e6f9f),
    SPH_C32(0x4ffbce35) },
  { SPH_C32(0x7b510000), SPH_C32(0x257c0000), SPH_C32(0xe7b008c8),
    SPH_C32(0x603d0000), SPH_C32(0x5b661308), SPH_C32(0x2947c374),
    SPH_C32(0x3fc27b05), SPH_C32(0xbb0d244e), SPH_C32(0x2a730000),
    SPH_C32(0x3ba80000), SPH_C32(0xc35b0bce), SPH_C32(0x605a0000),
    SPH_C32(0xeb0f5695), SPH_C32(0x3bcac8ea), SPH_C32(0x3fda2f87),
    SPH_C32(0x306c98a4) },
  { SPH_C32(0xb6980000), SPH_C32(0x00b70000), SPH_C32(0x499f0f00),
    SPH_C32(0xfd6d0000), SPH_C32(0x80637e55), SPH_C32(0x793a7b5b),
    SPH_C32(0x3093fc39), SPH_C32(0x5dc3e62e), SPH_C32(0xf9bd0000),
    SPH_C32(0xfeab0000), SPH_C32(0xcf080900), SPH_C32(0x05560000),
    SPH_C32(0x2c97007b), SPH_C32(0x361db598), SPH_C32(0x16d6024f),
    SPH_C32(0xed083c51) },
  { SPH_C32(0xe4c80000), SPH_C32(0x29e30000), SPH_C32(0x23fe0f4e),
    SPH_C32(0x0d920000), SPH_C32(0x1a5200b9), SPH_C32(0x3c193a95),
    SPH_C32(0xffc573dc), SPH_C32(0x0ec0f521), SPH_C32(0xaa300000),
    SPH_C32(0x57570000), SPH_C32(0x51ff0906), SPH_C32(0x53a90000),
    SPH_C32(0x26730035), SPH_C32(0xa4d87861), SPH_C32(0xbf924257),
    SPH_C32(0x929f6ac0) },
  { SPH_C32(0xe5150000), SPH_C32(0xa94b0000), SPH_C32(0xd7680f06),
    SPH_C32(0xab920000), SPH_C32(0x8a877e1b), SPH_C32(0xebffb6a2),
    SPH_C32(0x99d7bc21), SPH_C32(0x2254b0bf), SPH_C32(0xf8600000),
    SPH_C32(0x7e030000), SPH_C32(0x3b9e0948), SPH_C32(0xa3560000),
    SPH_C32(0xbc427ed9), SPH_C32(0xe1fb39af), SPH_C32(0x70c4cdb2),
    SPH_C32(0xc19c79cf) },
  { SPH_C32(0xb7450000), SPH_C32(0x801f0000), SPH_C32(0xbd090f48),
    SPH_C32(0x5b6d0000), SPH_C32(0x10b600f7), SPH_C32(0xaedcf76c),
    SPH_C32(0x568133c4), SPH_C32(0x7157a3b0), SPH_C32(0xabed0000),
    SPH_C32(0xd7ff0000), SPH_C32(0xa569094e), SPH_C32(0xf5a90000),
    SPH_C32(0xb6a67e97), SPH_C32(0x733ef456), SPH_C32(0xd9808daa),
    SPH_C32(0xbe0b2f5e) },
  { SPH_C32(0xfb120000), SPH_C32(0x49830000), SPH_C32(0x75140a00),
    SPH_C32(0x53ce0000), SPH_C32(0x961a45a8), SPH_C32(0xb65573ff),
    SPH_C32(0xbf8a16d5), SPH_C32(0x19fed62a), SPH_C32(0x35a90000),
    SPH_C32(0x5bc80000), SPH_C32(0x95b10e80), SPH_C32(0x3e060000),
    SPH_C32(0x67471384), SPH_C32(0xb1868180), SPH_C32(0x7f954a8e),
    SPH_C32(0x2752bbaf) },
  { SPH_C32(0xa9420000), SPH_C32(0x60d70000), SPH_C32(0x1f750a4e),
    SPH_C32(0xa3310000), SPH_C32(0x0c2b3b44), SPH_C32(0xf3763231),
    SPH_C32(0x70dc9930), SPH_C32(0x4afdc525), SPH_C32(0x66240000),
    SPH_C32(0xf2340000), SPH_C32(0x0b460e86), SPH_C32(0x68f90000),
    SPH_C32(0x6da313ca), SPH_C32(0x23434c79), SPH_C32(0xd6d10a96),
    SPH_C32(0x58c5ed3e) },
  { SPH_C32(0xa89f0000), SPH_C32(0xe07f0000), SPH_C32(0xebe30a06),
    SPH_C32(0x05310000), SPH_C32(0x9cfe45e6), SPH_C32(0x2490be06),
    SPH_C32(0x16ce56cd), SPH_C32(0x666980bb), SPH_C32(0x34740000),
    SPH_C32(0xdb600000), SPH_C32(0x61270ec8), SPH_C32(0x98060000),
    SPH_C32(0xf7926d26), SPH_C32(0x66600db7), SPH_C32(0x19878573),
    SPH_C32(0x0bc6fe31) },
  { SPH_C32(0xfacf0000), SPH_C32(0xc92b0000), SPH_C32(0x81820a48),
    SPH_C32(0xf5ce0000), SPH_C32(0x06cf3b0a), SPH_C32(0x61b3ffc8),
    SPH_C32(0xd998d928), SPH_C32(0x356a93b4), SPH_C32(0x67f90000),
    SPH_C32(0x729c0000), SPH_C32(0xffd00ece), SPH_C32(0xcef90000),
    SPH_C32(0xfd766d68), SPH_C32(0xf4a5c04e), SPH_C32(0xb0c3c56b),
    SPH_C32(0x7451a8a0) },
  { SPH_C32(0x37060000), SPH_C32(0xece00000), SPH_C32(0x2fad0d80),
    SPH_C32(0x689e0000), SPH_C32(0xddca5657), SPH_C32(0x31ce47e7),
    SPH_C32(0xd6c95e14), SPH_C32(0xd3a451d4), SPH_C32(0xb4370000),
    SPH_C32(0xb79f0000), SPH_C32(0xf3830c00), SPH_C32(0xabf50000),
    SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c), SPH_C32(0x99cfe8a3),
    SPH_C32(0xa9350c55) },
  { SPH_C32(0x65560000), SPH_C32(0xc5b40000), SPH_C32(0x45cc0dce),
    SPH_C32(0x98610000), SPH_C32(0x47fb28bb), SPH_C32(0x74ed0629),
    SPH_C32(0x199fd1f1), SPH_C32(0x80a742db), SPH_C32(0xe7ba0000),
    SPH_C32(0x1e630000), SPH_C32(0x6d740c06), SPH_C32(0xfd0a0000),
    SPH_C32(0x300a3bc8), SPH_C32(0x6bb770c5), SPH_C32(0x308ba8bb),
    SPH_C32(0xd6a25ac4) },
  { SPH_C32(0x648b0000), SPH_C32(0x451c0000), SPH_C32(0xb15a0d86),
    SPH_C32(0x3e610000), SPH_C32(0xd72e5619), SPH_C32(0xa30b8a1e),
    SPH_C32(0x7f8d1e0c), SPH_C32(0xac330745), SPH_C32(0xb5ea0000),
    SPH_C32(0x37370000), SPH_C32(0x07150c48), SPH_C32(0x0df50000),
    SPH_C32(0xaa3b4524), SPH_C32(0x2e94310b), SPH_C32(0xffdd275e),
    SPH_C32(0x85a149cb) },
  { SPH_C32(0x36db0000), SPH_C32(0x6c480000), SPH_C32(0xdb3b0dc8),
    SPH_C32(0xce9e0000), SPH_C32(0x4d1f28f5), SPH_C32(0xe628cbd0),
    SPH_C32(0xb0db91e9), SPH_C32(0xff30144a), SPH_C32(0xe6670000),
    SPH_C32(0x9ecb0000), SPH_C32(0x99e20c4e), SPH_C32(0x5b0a0000),
    SPH_C32(0xa0df456a), SPH_C32(0xbc51fcf2), SPH_C32(0x56996746),
    SPH_C32(0xfa361f5a) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0xfe180000), SPH_C32(0x32f20000), SPH_C32(0x2f9a13ce),
    SPH_C32(0xf3bc0000), SPH_C32(0xc0b44f86), SPH_C32(0x5a911178),
    SPH_C32(0x3124481b), SPH_C32(0xc2e76bf9), SPH_C32(0x4dc30000),
    SPH_C32(0x77330000), SPH_C32(0xf30f0186), SPH_C32(0x21db0000),
    SPH_C32(0xe6a307d0), SPH_C32(0x6665a4b7), SPH_C32(0x64e7580a),
    SPH_C32(0xe73d1fff) },
  { SPH_C32(0xffc50000), SPH_C32(0xb25a0000), SPH_C32(0xdb0c1386),
    SPH_C32(0x55bc0000), SPH_C32(0x50613124), SPH_C32(0x8d779d4f),
    SPH_C32(0x573687e6), SPH_C32(0xee732e67), SPH_C32(0x1f930000),
    SPH_C32(0x5e670000), SPH_C32(0x996e01c8), SPH_C32(0xd1240000),
    SPH_C32(0x7c92793c), SPH_C32(0x2346e579), SPH_C32(0xabb1d7ef),
    SPH_C32(0xb43e0cf0) },
  { SPH_C32(0xad950000), SPH_C32(0x9b0e0000), SPH_C32(0xb16d13c8),
    SPH_C32(0xa5430000), SPH_C32(0xca504fc8), SPH_C32(0xc854dc81),
    SPH_C32(0x98600803), SPH_C32(0xbd703d68), SPH_C32(0x4c1e0000),
    SPH_C32(0xf79b0000), SPH_C32(0x079901ce), SPH_C32(0x87db0000),
    SPH_C32(0x76767972), SPH_C32(0xb1832880), SPH_C32(0x02f597f7),
    SPH_C32(0xcba95a61) },
  { SPH_C32(0x605c0000), SPH_C32(0xbec50000), SPH_C32(0x1f421400),
    SPH_C32(0x38130000), SPH_C32(0x11552295), SPH_C32(0x982964ae),
    SPH_C32(0x97318f3f), SPH_C32(0x5bbeff08), SPH_C32(0x9fd00000),
    SPH_C32(0x32980000), SPH_C32(0x0bca0300), SPH_C32(0xe2d70000),
    SPH_C32(0xb1ee2f9c), SPH_C32(0xbc5455f2), SPH_C32(0x2bf9ba3f),
    SPH_C32(0x16cdfe94) },
  { SPH_C32(0x320c0000), SPH_C32(0x97910000), SPH_C32(0x7523144e),
    SPH_C32(0xc8ec0000), SPH_C32(0x8b645c79), SPH_C32(0xdd0a2560),
    SPH_C32(0x586700da), SPH_C32(0x08bdec07), SPH_C32(0xcc5d0000),
    SPH_C32(0x9b640000), SPH_C32(0x953d0306), SPH_C32(0xb4280000),
    SPH_C32(0xbb0a2fd2), SPH_C32(0x2e91980b), SPH_C32(0x82bdfa27),
    SPH_C32(0x695aa805) },
  { SPH_C32(0x33d10000), SPH_C32(0x17390000), SPH_C32(0x81b51406),
    SPH_C32(0x6eec0000), SPH_C32(0x1bb122db), SPH_C32(0x0aeca957),
    SPH_C32(0x3e75cf27), SPH_C32(0x2429a999), SPH_C32(0x9e0d0000),
    SPH_C32(0xb2300000), SPH_C32(0xff5c0348), SPH_C32(0x44d70000),
    SPH_C32(0x213b513e), SPH_C32(0x6bb2d9c5), SPH_C32(0x4deb75c2),
    SPH_C32(0x3a59bb0a) },
  { SPH_C32(0x61810000), SPH_C32(0x3e6d0000), SPH_C32(0xebd41448),
    SPH_C32(0x9e130000), SPH_C32(0x81805c37), SPH_C32(0x4fcfe899),
    SPH_C32(0xf12340c2), SPH_C32(0x772aba96), SPH_C32(0xcd800000),
    SPH_C32(0x1bcc0000), SPH_C32(0x61ab034e), SPH_C32(0x12280000),
    SPH_C32(0x2bdf5170), SPH_C32(0xf977143c), SPH_C32(0xe4af35da),
    SPH_C32(0x45ceed9b) },
  { SPH_C32(0x2dd60000), SPH_C32(0xf7f10000), SPH_C32(0x23c91100),
    SPH_C32(0x96b00000), SPH_C32(0x072c1968), SPH_C32(0x57466c0a),
    SPH_C32(0x182865d3), SPH_C32(0x1f83cf0c), SPH_C32(0x53c40000),
    SPH_C32(0x97fb0000), SPH_C32(0x51730480), SPH_C32(0xd9870000),
    SPH_C32(0xfa3e3c63), SPH_C32(0x3bcf61ea), SPH_C32(0x42baf2fe),
    SPH_C32(0xdc97796a) },
  { SPH_C32(0x7f860000), SPH_C32(0xdea50000), SPH_C32(0x49a8114e),
    SPH_C32(0x664f0000), SPH_C32(0x9d1d6784), SPH_C32(0x12652dc4),
    SPH_C32(0xd77eea36), SPH_C32(0x4c80dc03), SPH_C32(0x00490000),
    SPH_C32(0x3e070000), SPH_C32(0xcf840486), SPH_C32(0x8f780000),
    SPH_C32(0xf0da3c2d), SPH_C32(0xa90aac13), SPH_C32(0xebfeb2e6),
    SPH_C32(0xa3002ffb) },
  { SPH_C32(0x7e5b0000), SPH_C32(0x5e0d0000), SPH_C32(0xbd3e1106),
    SPH_C32(0xc04f0000), SPH_C32(0x0dc81926), SPH_C32(0xc583a1f3),
    SPH_C32(0xb16c25cb), SPH_C32(0x6014999d), SPH_C32(0x52190000),
    SPH_C32(0x17530000), SPH_C32(0xa5e504c8), SPH_C32(0x7f870000),
    SPH_C32(0x6aeb42c1), SPH_C32(0xec29eddd), SPH_C32(0x24a83d03),
    SPH_C32(0xf0033cf4) },
  { SPH_C32(0x2c0b0000), SPH_C32(0x77590000), SPH_C32(0xd75f1148),
    SPH_C32(0x30b00000), SPH_C32(0x97f967ca), SPH_C32(0x80a0e03d),
    SPH_C32(0x7e3aaa2e), SPH_C32(0x33178a92), SPH_C32(0x01940000),
    SPH_C32(0xbeaf0000), SPH_C32(0x3b1204ce), SPH_C32(0x29780000),
    SPH_C32(0x600f428f), SPH_C32(0x7eec2024), SPH_C32(0x8dec7d1b),
    SPH_C32(0x8f946a65) },
  { SPH_C32(0xe1c20000), SPH_C32(0x52920000), SPH_C32(0x79701680),
    SPH_C32(0xade00000), SPH_C32(0x4cfc0a97), SPH_C32(0xd0dd5812),
    SPH_C32(0x716b2d12), SPH_C32(0xd5d948f2), SPH_C32(0xd25a0000),
    SPH_C32(0x7bac0000), SPH_C32(0x37410600), SPH_C32(0x4c740000),
    SPH_C32(0xa7971461), SPH_C32(0x733b5d56), SPH_C32(0xa4e050d3),
    SPH_C32(0x52f0ce90) },
  { SPH_C32(0xb3920000), SPH_C32(0x7bc60000), SPH_C32(0x131116ce),
    SPH_C32(0x5d1f0000), SPH_C32(0xd6cd747b), SPH_C32(0x95fe19dc),
    SPH_C32(0xbe3da2f7), SPH_C32(0x86da5bfd), SPH_C32(0x81d70000),
    SPH_C32(0xd2500000), SPH_C32(0xa9b60606), SPH_C32(0x1a8b0000),
    SPH_C32(0xad73142f), SPH_C32(0xe1fe90af), SPH_C32(0x0da410cb),
    SPH_C32(0x2d679801) },
  { SPH_C32(0xb24f0000), SPH_C32(0xfb6e0000), SPH_C32(0xe7871686),
    SPH_C32(0xfb1f0000), SPH_C32(0x46180ad9), SPH_C32(0x421895eb),
    SPH_C32(0xd82f6d0a), SPH_C32(0xaa4e1e63), SPH_C32(0xd3870000),
    SPH_C32(0xfb040000), SPH_C32(0xc3d70648), SPH_C32(0xea740000),
    SPH_C32(0x37426ac3), SPH_C32(0xa4ddd161), SPH_C32(0xc2f29f2e),
    SPH_C32(0x7e648b0e) },
  { SPH_C32(0xe01f0000), SPH_C32(0xd23a0000), SPH_C32(0x8de616c8),
    SPH_C32(0x0be00000), SPH_C32(0xdc297435), SPH_C32(0x073bd425),
    SPH_C32(0x1779e2ef), SPH_C32(0xf94d0d6c), SPH_C32(0x800a0000),
    SPH_C32(0x52f80000), SPH_C32(0x5d20064e), SPH_C32(0xbc8b0000),
    SPH_C32(0x3da66a8d), SPH_C32(0x36181c98), SPH_C32(0x6bb6df36),
    SPH_C32(0x01f3dd9f) },
  { SPH_C32(0xd46b0000), SPH_C32(0x095a0000), SPH_C32(0xecc11800),
    SPH_C32(0x93e60000), SPH_C32(0x2bbb1913), SPH_C32(0x615bd992),
    SPH_C32(0x0efe679c), SPH_C32(0xf28bf35d), SPH_C32(0x1ce10000),
    SPH_C32(0x69e70000), SPH_C32(0xd7e40280), SPH_C32(0x21bc0000),
    SPH_C32(0x56ca424d), SPH_C32(0x74e8af29), SPH_C32(0x64ff0c88),
    SPH_C32(0x6c5ca315) },
  { SPH_C32(0x863b0000), SPH_C32(0x200e0000), SPH_C32(0x86a0184e),
    SPH_C32(0x63190000), SPH_C32(0xb18a67ff), SPH_C32(0x2478985c),
    SPH_C32(0xc1a8e879), SPH_C32(0xa188e052), SPH_C32(0x4f6c0000),
    SPH_C32(0xc01b0000), SPH_C32(0x49130286), SPH_C32(0x77430000),
    SPH_C32(0x5c2e4203), SPH_C32(0xe62d62d0), SPH_C32(0xcdbb4c90),
    SPH_C32(0x13cbf584) },
  { SPH_C32(0x87e60000), SPH_C32(0xa0a60000), SPH_C32(0x72361806),
    SPH_C32(0xc5190000), SPH_C32(0x215f195d), SPH_C32(0xf39e146b),
    SPH_C32(0xa7ba2784), SPH_C32(0x8d1ca5cc), SPH_C32(0x1d3c0000),
    SPH_C32(0xe94f0000), SPH_C32(0x237202c8), SPH_C32(0x87bc0000),
    SPH_C32(0xc61f3cef), SPH_C32(0xa30e231e), SPH_C32(0x02edc375),
    SPH_C32(0x40c8e68b) },
  { SPH_C32(0xd5b60000), SPH_C32(0x89f20000), SPH_C32(0x18571848),
    SPH_C32(0x35e60000), SPH_C32(0xbb6e67b1), SPH_C32(0xb6bd55a5),
    SPH_C32(0x68eca861), SPH_C32(0xde1fb6c3), SPH_C32(0x4eb10000),
    SPH_C32(0x40b30000), SPH_C32(0xbd8502ce), SPH_C32(0xd1430000),
    SPH_C32(0xccfb3ca1), SPH_C32(0x31cbeee7), SPH_C32(0xaba9836d),
    SPH_C32(0x3f5fb01a) },
  { SPH_C32(0x187f0000), SPH_C32(0xac390000), SPH_C32(0xb6781f80),
    SPH_C32(0xa8b60000), SPH_C32(0x606b0aec), SPH_C32(0xe6c0ed8a),
    SPH_C32(0x67bd2f5d), SPH_C32(0x38d174a3), SPH_C32(0x9d7f0000),
    SPH_C32(0x85b00000), SPH_C32(0xb1d60000), SPH_C32(0xb44f0000),
    SPH_C32(0x0b636a4f), SPH_C32(0x3c1c9395), SPH_C32(0x82a5aea5),
    SPH_C32(0xe23b14ef) },
  { SPH_C32(0x4a2f0000), SPH_C32(0x856d0000), SPH_C32(0xdc191fce),
    SPH_C32(0x58490000), SPH_C32(0xfa5a7400), SPH_C32(0xa3e3ac44),
    SPH_C32(0xa8eba0b8), SPH_C32(0x6bd267ac), SPH_C32(0xcef20000),
    SPH_C32(0x2c4c0000), SPH_C32(0x2f210006), SPH_C32(0xe2b00000),
    SPH_C32(0x01876a01), SPH_C32(0xaed95e6c), SPH_C32(0x2be1eebd),
    SPH_C32(0x9dac427e) },
  { SPH_C32(0x4bf20000), SPH_C32(0x05c50000), SPH_C32(0x288f1f86),
    SPH_C32(0xfe490000), SPH_C32(0x6a8f0aa2), SPH_C32(0x74052073),
    SPH_C32(0xcef96f45), SPH_C32(0x47462232), SPH_C32(0x9ca20000),
    SPH_C32(0x05180000), SPH_C32(0x45400048), SPH_C32(0x124f0000),
    SPH_C32(0x9bb614ed), SPH_C32(0xebfa1fa2), SPH_C32(0xe4b76158),
    SPH_C32(0xceaf5171) },
  { SPH_C32(0x19a20000), SPH_C32(0x2c910000), SPH_C32(0x42ee1fc8),
    SPH_C32(0x0eb60000), SPH_C32(0xf0be744e), SPH_C32(0x312661bd),
    SPH_C32(0x01afe0a0), SPH_C32(0x1445313d), SPH_C32(0xcf2f0000),
    SPH_C32(0xace40000), SPH_C32(0xdbb7004e), SPH_C32(0x44b00000),
    SPH_C32(0x915214a3), SPH_C32(0x793fd25b), SPH_C32(0x4df32140),
    SPH_C32(0xb13807e0) },
  { SPH_C32(0x55f50000), SPH_C32(0xe50d0000), SPH_C32(0x8af31a80),
    SPH_C32(0x06150000), SPH_C32(0x76123111), SPH_C32(0x29afe52e),
    SPH_C32(0xe8a4c5b1), SPH_C32(0x7cec44a7), SPH_C32(0x516b0000),
    SPH_C32(0x20d30000), SPH_C32(0xeb6f0780), SPH_C32(0x8f1f0000),
    SPH_C32(0x40b379b0), SPH_C32(0xbb87a78d), SPH_C32(0xebe6e664),
    SPH_C32(0x28619311) },
  { SPH_C32(0x07a50000), SPH_C32(0xcc590000), SPH_C32(0xe0921ace),
    SPH_C32(0xf6ea0000), SPH_C32(0xec234ffd), SPH_C32(0x6c8ca4e0),
    SPH_C32(0x27f24a54), SPH_C32(0x2fef57a8), SPH_C32(0x02e60000),
    SPH_C32(0x892f0000), SPH_C32(0x75980786), SPH_C32(0xd9e00000),
    SPH_C32(0x4a5779fe), SPH_C32(0x29426a74), SPH_C32(0x42a2a67c),
    SPH_C32(0x57f6c580) },
  { SPH_C32(0x06780000), SPH_C32(0x4cf10000), SPH_C32(0x14041a86),
    SPH_C32(0x50ea0000), SPH_C32(0x7cf6315f), SPH_C32(0xbb6a28d7),
    SPH_C32(0x41e085a9), SPH_C32(0x037b1236), SPH_C32(0x50b60000),
    SPH_C32(0xa07b0000), SPH_C32(0x1ff907c8), SPH_C32(0x291f0000),
    SPH_C32(0xd0660712), SPH_C32(0x6c612bba), SPH_C32(0x8df42999),
    SPH_C32(0x04f5d68f) },
  { SPH_C32(0x54280000), SPH_C32(0x65a50000), SPH_C32(0x7e651ac8),
    SPH_C32(0xa0150000), SPH_C32(0xe6c74fb3), SPH_C32(0xfe496919),
    SPH_C32(0x8eb60a4c), SPH_C32(0x50780139), SPH_C32(0x033b0000),
    SPH_C32(0x09870000), SPH_C32(0x810e07ce), SPH_C32(0x7fe00000),
    SPH_C32(0xda82075c), SPH_C32(0xfea4e643), SPH_C32(0x24b06981),
    SPH_C32(0x7b62801e) },
  { SPH_C32(0x99e10000), SPH_C32(0x406e0000), SPH_C32(0xd04a1d00),
    SPH_C32(0x3d450000), SPH_C32(0x3dc222ee), SPH_C32(0xae34d136),
    SPH_C32(0x81e78d70), SPH_C32(0xb6b6c359), SPH_C32(0xd0f50000),
    SPH_C32(0xcc840000), SPH_C32(0x8d5d0500), SPH_C32(0x1aec0000),
    SPH_C32(0x1d1a51b2), SPH_C32(0xf3739b31), SPH_C32(0x0dbc4449),
    SPH_C32(0xa60624eb) },
  { SPH_C32(0xcbb10000), SPH_C32(0x693a0000), SPH_C32(0xba2b1d4e),
    SPH_C32(0xcdba0000), SPH_C32(0xa7f35c02), SPH_C32(0xeb1790f8),
    SPH_C32(0x4eb10295), SPH_C32(0xe5b5d056), SPH_C32(0x83780000),
    SPH_C32(0x65780000), SPH_C32(0x13aa0506), SPH_C32(0x4c130000),
    SPH_C32(0x17fe51fc), SPH_C32(0x61b656c8), SPH_C32(0xa4f80451),
    SPH_C32(0xd991727a) },
  { SPH_C32(0xca6c0000), SPH_C32(0xe9920000), SPH_C32(0x4ebd1d06),
    SPH_C32(0x6bba0000), SPH_C32(0x372622a0), SPH_C32(0x3cf11ccf),
    SPH_C32(0x28a3cd68), SPH_C32(0xc92195c8), SPH_C32(0xd1280000),
    SPH_C32(0x4c2c0000), SPH_C32(0x79cb0548), SPH_C32(0xbcec0000),
    SPH_C32(0x8dcf2f10), SPH_C32(0x24951706), SPH_C32(0x6bae8bb4),
    SPH_C32(0x8a926175) },
  { SPH_C32(0x983c0000), SPH_C32(0xc0c60000), SPH_C32(0x24dc1d48),
    SPH_C32(0x9b450000), SPH_C32(0xad175c4c), SPH_C32(0x79d25d01),
    SPH_C32(0xe7f5428d), SPH_C32(0x9a2286c7), SPH_C32(0x82a50000),
    SPH_C32(0xe5d00000), SPH_C32(0xe73c054e), SPH_C32(0xea130000),
    SPH_C32(0x872b2f5e), SPH_C32(0xb650daff), SPH_C32(0xc2eacbac),
    SPH_C32(0xf50537e4) },
  { SPH_C32(0xaee70000), SPH_C32(0xac8e0000), SPH_C32(0xffe71080),
    SPH_C32(0x55db0000), SPH_C32(0xe00874b9), SPH_C32(0x9ffa96d1),
    SPH_C32(0x572ed364), SPH_C32(0x6512928d), SPH_C32(0x64c20000),
    SPH_C32(0x7b1b0000), SPH_C32(0x7ede0900), SPH_C32(0xb1190000),
    SPH_C32(0x27f46a34), SPH_C32(0x0a01260d), SPH_C32(0x9473acea),
    SPH_C32(0x0f3328be) },
  { SPH_C32(0xfcb70000), SPH_C32(0x85da0000), SPH_C32(0x958610ce),
    SPH_C32(0xa5240000), SPH_C32(0x7a390a55), SPH_C32(0xdad9d71f),
    SPH_C32(0x98785c81), SPH_C32(0x36118182), SPH_C32(0x374f0000),
    SPH_C32(0xd2e70000), SPH_C32(0xe0290906), SPH_C32(0xe7e60000),
    SPH_C32(0x2d106a7a), SPH_C32(0x98c4ebf4), SPH_C32(0x3d37ecf2),
    SPH_C32(0x70a47e2f) },
  { SPH_C32(0xfd6a0000), SPH_C32(0x05720000), SPH_C32(0x61101086),
    SPH_C32(0x03240000), SPH_C32(0xeaec74f7), SPH_C32(0x0d3f5b28),
    SPH_C32(0xfe6a937c), SPH_C32(0x1a85c41c), SPH_C32(0x651f0000),
    SPH_C32(0xfbb30000), SPH_C32(0x8a480948), SPH_C32(0x17190000),
    SPH_C32(0xb7211496), SPH_C32(0xdde7aa3a), SPH_C32(0xf2616317),
    SPH_C32(0x23a76d20) },
  { SPH_C32(0xaf3a0000), SPH_C32(0x2c260000), SPH_C32(0x0b7110c8),
    SPH_C32(0xf3db0000), SPH_C32(0x70dd0a1b), SPH_C32(0x481c1ae6),
    SPH_C32(0x313c1c99), SPH_C32(0x4986d713), SPH_C32(0x36920000),
    SPH_C32(0x524f0000), SPH_C32(0x14bf094e), SPH_C32(0x41e60000),
    SPH_C32(0xbdc514d8), SPH_C32(0x4f2267c3), SPH_C32(0x5b25230f),
    SPH_C32(0x5c303bb1) },
  { SPH_C32(0x62f30000), SPH_C32(0x09ed0000), SPH_C32(0xa55e1700),
    SPH_C32(0x6e8b0000), SPH_C32(0xabd86746), SPH_C32(0x1861a2c9),
    SPH_C32(0x3e6d9ba5), SPH_C32(0xaf481573), SPH_C32(0xe55c0000),
    SPH_C32(0x974c0000), SPH_C32(0x18ec0b80), SPH_C32(0x24ea0000),
    SPH_C32(0x7a5d4236), SPH_C32(0x42f51ab1), SPH_C32(0x72290ec7),
    SPH_C32(0x81549f44) },
  { SPH_C32(0x30a30000), SPH_C32(0x20b90000), SPH_C32(0xcf3f174e),
    SPH_C32(0x9e740000), SPH_C32(0x31e919aa), SPH_C32(0x5d42e307),
    SPH_C32(0xf13b1440), SPH_C32(0xfc4b067c), SPH_C32(0xb6d10000),
    SPH_C32(0x3eb00000), SPH_C32(0x861b0b86), SPH_C32(0x72150000),
    SPH_C32(0x70b94278), SPH_C32(0xd030d748), SPH_C32(0xdb6d4edf),
    SPH_C32(0xfec3c9d5) },
  { SPH_C32(0x317e0000), SPH_C32(0xa0110000), SPH_C32(0x3ba91706),
    SPH_C32(0x38740000), SPH_C32(0xa13c6708), SPH_C32(0x8aa46f30),
    SPH_C32(0x9729dbbd), SPH_C32(0xd0df43e2), SPH_C32(0xe4810000),
    SPH_C32(0x17e40000), SPH_C32(0xec7a0bc8), SPH_C32(0x82ea0000),
    SPH_C32(0xea883c94), SPH_C32(0x95139686), SPH_C32(0x143bc13a),
    SPH_C32(0xadc0dada) },
  { SPH_C32(0x632e0000), SPH_C32(0x89450000), SPH_C32(0x51c81748),
    SPH_C32(0xc88b0000), SPH_C32(0x3b0d19e4), SPH_C32(0xcf872efe),
    SPH_C32(0x587f5458), SPH_C32(0x83dc50ed), SPH_C32(0xb70c0000),
    SPH_C32(0xbe180000), SPH_C32(0x728d0bce), SPH_C32(0xd4150000),
    SPH_C32(0xe06c3cda), SPH_C32(0x07d65b7f), SPH_C32(0xbd7f8122),
    SPH_C32(0xd2578c4b) },
  { SPH_C32(0x2f790000), SPH_C32(0x40d90000), SPH_C32(0x99d51200),
    SPH_C32(0xc0280000), SPH_C32(0xbda15cbb), SPH_C32(0xd70eaa6d),
    SPH_C32(0xb1747149), SPH_C32(0xeb752577), SPH_C32(0x29480000),
    SPH_C32(0x322f0000), SPH_C32(0x42550c00), SPH_C32(0x1fba0000),
    SPH_C32(0x318d51c9), SPH_C32(0xc56e2ea9), SPH_C32(0x1b6a4606),
    SPH_C32(0x4b0e18ba) },
  { SPH_C32(0x7d290000), SPH_C32(0x698d0000), SPH_C32(0xf3b4124e),
    SPH_C32(0x30d70000), SPH_C32(0x27902257), SPH_C32(0x922deba3),
    SPH_C32(0x7e22feac), SPH_C32(0xb8763678), SPH_C32(0x7ac50000),
    SPH_C32(0x9bd30000), SPH_C32(0xdca20c06), SPH_C32(0x49450000),
    SPH_C32(0x3b695187), SPH_C32(0x57abe350), SPH_C32(0xb22e061e),
    SPH_C32(0x34994e2b) },
  { SPH_C32(0x7cf40000), SPH_C32(0xe9250000), SPH_C32(0x07221206),
    SPH_C32(0x96d70000), SPH_C32(0xb7455cf5), SPH_C32(0x45cb6794),
    SPH_C32(0x18303151), SPH_C32(0x94e273e6), SPH_C32(0x28950000),
    SPH_C32(0xb2870000), SPH_C32(0xb6c30c48), SPH_C32(0xb9ba0000),
    SPH_C32(0xa1582f6b), SPH_C32(0x1288a29e), SPH_C32(0x7d7889fb),
    SPH_C32(0x679a5d24) },
  { SPH_C32(0x2ea40000), SPH_C32(0xc0710000), SPH_C32(0x6d431248),
    SPH_C32(0x66280000), SPH_C32(0x2d742219), SPH_C32(0x00e8265a),
    SPH_C32(0xd766beb4), SPH_C32(0xc7e160e9), SPH_C32(0x7b180000),
    SPH_C32(0x1b7b0000), SPH_C32(0x28340c4e), SPH_C32(0xef450000),
    SPH_C32(0xabbc2f25), SPH_C32(0x804d6f67), SPH_C32(0xd43cc9e3),
    SPH_C32(0x180d0bb5) },
  { SPH_C32(0xe36d0000), SPH_C32(0xe5ba0000), SPH_C32(0xc36c1580),
    SPH_C32(0xfb780000), SPH_C32(0xf6714f44), SPH_C32(0x50959e75),
    SPH_C32(0xd8373988), SPH_C32(0x212fa289), SPH_C32(0xa8d60000),
    SPH_C32(0xde780000), SPH_C32(0x24670e80), SPH_C32(0x8a490000),
    SPH_C32(0x6c2479cb), SPH_C32(0x8d9a1215), SPH_C32(0xfd30e42b),
    SPH_C32(0xc569af40) },
  { SPH_C32(0xb13d0000), SPH_C32(0xccee0000), SPH_C32(0xa90d15ce),
    SPH_C32(0x0b870000), SPH_C32(0x6c4031a8), SPH_C32(0x15b6dfbb),
    SPH_C32(0x1761b66d), SPH_C32(0x722cb186), SPH_C32(0xfb5b0000),
    SPH_C32(0x77840000), SPH_C32(0xba900e86), SPH_C32(0xdcb60000),
    SPH_C32(0x66c07985), SPH_C32(0x1f5fdfec), SPH_C32(0x5474a433),
    SPH_C32(0xbafef9d1) },
  { SPH_C32(0xb0e00000), SPH_C32(0x4c460000), SPH_C32(0x5d9b1586),
    SPH_C32(0xad870000), SPH_C32(0xfc954f0a), SPH_C32(0xc250538c),
    SPH_C32(0x71737990), SPH_C32(0x5eb8f418), SPH_C32(0xa90b0000),
    SPH_C32(0x5ed00000), SPH_C32(0xd0f10ec8), SPH_C32(0x2c490000),
    SPH_C32(0xfcf10769), SPH_C32(0x5a7c9e22), SPH_C32(0x9b222bd6),
    SPH_C32(0xe9fdeade) },
  { SPH_C32(0xe2b00000), SPH_C32(0x65120000), SPH_C32(0x37fa15c8),
    SPH_C32(0x5d780000), SPH_C32(0x66a431e6), SPH_C32(0x87731242),
    SPH_C32(0xbe25f675), SPH_C32(0x0dbbe717), SPH_C32(0xfa860000),
    SPH_C32(0xf72c0000), SPH_C32(0x4e060ece), SPH_C32(0x7ab60000),
    SPH_C32(0xf6150727), SPH_C32(0xc8b953db), SPH_C32(0x32666bce),
    SPH_C32(0x966abc4f) },
  { SPH_C32(0xd6c40000), SPH_C32(0xbe720000), SPH_C32(0x56dd1b00),
    SPH_C32(0xc57e0000), SPH_C32(0x91365cc0), SPH_C32(0xe1131ff5),
    SPH_C32(0xa7a27306), SPH_C32(0x067d1926), SPH_C32(0x666d0000),
    SPH_C32(0xcc330000), SPH_C32(0xc4c20a00), SPH_C32(0xe7810000),
    SPH_C32(0x9d792fe7), SPH_C32(0x8a49e06a), SPH_C32(0x3d2fb870),
    SPH_C32(0xfbc5c2c5) },
  { SPH_C32(0x84940000), SPH_C32(0x97260000), SPH_C32(0x3cbc1b4e),
    SPH_C32(0x35810000), SPH_C32(0x0b07222c), SPH_C32(0xa4305e3b),
    SPH_C32(0x68f4fce3), SPH_C32(0x557e0a29), SPH_C32(0x35e00000),
    SPH_C32(0x65cf0000), SPH_C32(0x5a350a06), SPH_C32(0xb17e0000),
    SPH_C32(0x979d2fa9), SPH_C32(0x188c2d93), SPH_C32(0x946bf868),
    SPH_C32(0x84529454) },
  { SPH_C32(0x85490000), SPH_C32(0x178e0000), SPH_C32(0xc82a1b06),
    SPH_C32(0x93810000), SPH_C32(0x9bd25c8e), SPH_C32(0x73d6d20c),
    SPH_C32(0x0ee6331e), SPH_C32(0x79ea4fb7), SPH_C32(0x67b00000),
    SPH_C32(0x4c9b0000), SPH_C32(0x30540a48), SPH_C32(0x41810000),
    SPH_C32(0x0dac5145), SPH_C32(0x5daf6c5d), SPH_C32(0x5b3d778d),
    SPH_C32(0xd751875b) },
  { SPH_C32(0xd7190000), SPH_C32(0x3eda0000), SPH_C32(0xa24b1b48),
    SPH_C32(0x637e0000), SPH_C32(0x01e32262), SPH_C32(0x36f593c2),
    SPH_C32(0xc1b0bcfb), SPH_C32(0x2ae95cb8), SPH_C32(0x343d0000),
    SPH_C32(0xe5670000), SPH_C32(0xaea30a4e), SPH_C32(0x177e0000),
    SPH_C32(0x0748510b), SPH_C32(0xcf6aa1a4), SPH_C32(0xf2793795),
    SPH_C32(0xa8c6d1ca) },
  { SPH_C32(0x1ad00000), SPH_C32(0x1b110000), SPH_C32(0x0c641c80),
    SPH_C32(0xfe2e0000), SPH_C32(0xdae64f3f), SPH_C32(0x66882bed),
    SPH_C32(0xcee13bc7), SPH_C32(0xcc279ed8), SPH_C32(0xe7f30000),
    SPH_C32(0x20640000), SPH_C32(0xa2f00880), SPH_C32(0x72720000),
    SPH_C32(0xc0d007e5), SPH_C32(0xc2bddcd6), SPH_C32(0xdb751a5d),
    SPH_C32(0x75a2753f) },
  { SPH_C32(0x48800000), SPH_C32(0x32450000), SPH_C32(0x66051cce),
    SPH_C32(0x0ed10000), SPH_C32(0x40d731d3), SPH_C32(0x23ab6a23),
    SPH_C32(0x01b7b422), SPH_C32(0x9f248dd7), SPH_C32(0xb47e0000),
    SPH_C32(0x89980000), SPH_C32(0x3c070886), SPH_C32(0x248d0000),
    SPH_C32(0xca3407ab), SPH_C32(0x5078112f), SPH_C32(0x72315a45),
    SPH_C32(0x0a3523ae) },
  { SPH_C32(0x495d0000), SPH_C32(0xb2ed0000), SPH_C32(0x92931c86),
    SPH_C32(0xa8d10000), SPH_C32(0xd0024f71), SPH_C32(0xf44de614),
    SPH_C32(0x67a57bdf), SPH_C32(0xb3b0c849), SPH_C32(0xe62e0000),
    SPH_C32(0xa0cc0000), SPH_C32(0x566608c8), SPH_C32(0xd4720000),
    SPH_C32(0x50057947), SPH_C32(0x155b50e1), SPH_C32(0xbd67d5a0),
    SPH_C32(0x593630a1) },
  { SPH_C32(0x1b0d0000), SPH_C32(0x9bb90000), SPH_C32(0xf8f21cc8),
    SPH_C32(0x582e0000), SPH_C32(0x4a33319d), SPH_C32(0xb16ea7da),
    SPH_C32(0xa8f3f43a), SPH_C32(0xe0b3db46), SPH_C32(0xb5a30000),
    SPH_C32(0x09300000), SPH_C32(0xc89108ce), SPH_C32(0x828d0000),
    SPH_C32(0x5ae17909), SPH_C32(0x879e9d18), SPH_C32(0x142395b8),
    SPH_C32(0x26a16630) },
  { SPH_C32(0x575a0000), SPH_C32(0x52250000), SPH_C32(0x30ef1980),
    SPH_C32(0x508d0000), SPH_C32(0xcc9f74c2), SPH_C32(0xa9e72349),
    SPH_C32(0x41f8d12b), SPH_C32(0x881aaedc), SPH_C32(0x2be70000),
    SPH_C32(0x85070000), SPH_C32(0xf8490f00), SPH_C32(0x49220000),
    SPH_C32(0x8b00141a), SPH_C32(0x4526e8ce), SPH_C32(0xb236529c),
    SPH_C32(0xbff8f2c1) },
  { SPH_C32(0x050a0000), SPH_C32(0x7b710000), SPH_C32(0x5a8e19ce),
    SPH_C32(0xa0720000), SPH_C32(0x56ae0a2e), SPH_C32(0xecc46287),
    SPH_C32(0x8eae5ece), SPH_C32(0xdb19bdd3), SPH_C32(0x786a0000),
    SPH_C32(0x2cfb0000), SPH_C32(0x66be0f06), SPH_C32(0x1fdd0000),
    SPH_C32(0x81e41454), SPH_C32(0xd7e32537), SPH_C32(0x1b721284),
    SPH_C32(0xc06fa450) },
  { SPH_C32(0x04d70000), SPH_C32(0xfbd90000), SPH_C32(0xae181986),
    SPH_C32(0x06720000), SPH_C32(0xc67b748c), SPH_C32(0x3b22eeb0),
    SPH_C32(0xe8bc9133), SPH_C32(0xf78df84d), SPH_C32(0x2a3a0000),
    SPH_C32(0x05af0000), SPH_C32(0x0cdf0f48), SPH_C32(0xef220000),
    SPH_C32(0x1bd56ab8), SPH_C32(0x92c064f9), SPH_C32(0xd4249d61),
    SPH_C32(0x936cb75f) },
  { SPH_C32(0x56870000), SPH_C32(0xd28d0000), SPH_C32(0xc47919c8),
    SPH_C32(0xf68d0000), SPH_C32(0x5c4a0a60), SPH_C32(0x7e01af7e),
    SPH_C32(0x27ea1ed6), SPH_C32(0xa48eeb42), SPH_C32(0x79b70000),
    SPH_C32(0xac530000), SPH_C32(0x92280f4e), SPH_C32(0xb9dd0000),
    SPH_C32(0x11316af6), SPH_C32(0x0005a900), SPH_C32(0x7d60dd79),
    SPH_C32(0xecfbe1ce) },
  { SPH_C32(0x9b4e0000), SPH_C32(0xf7460000), SPH_C32(0x6a561e00),
    SPH_C32(0x6bdd0000), SPH_C32(0x874f673d), SPH_C32(0x2e7c1751),
    SPH_C32(0x28bb99ea), SPH_C32(0x42402922), SPH_C32(0xaa790000),
    SPH_C32(0x69500000), SPH_C32(0x9e7b0d80), SPH_C32(0xdcd10000),
    SPH_C32(0xd6a93c18), SPH_C32(0x0dd2d472), SPH_C32(0x546cf0b1),
    SPH_C32(0x319f453b) },
  { SPH_C32(0xc91e0000), SPH_C32(0xde120000), SPH_C32(0x00371e4e),
    SPH_C32(0x9b220000), SPH_C32(0x1d7e19d1), SPH_C32(0x6b5f569f),
    SPH_C32(0xe7ed160f), SPH_C32(0x11433a2d), SPH_C32(0xf9f40000),
    SPH_C32(0xc0ac0000), SPH_C32(0x008c0d86), SPH_C32(0x8a2e0000),
    SPH_C32(0xdc4d3c56), SPH_C32(0x9f17198b), SPH_C32(0xfd28b0a9),
    SPH_C32(0x4e0813aa) },
  { SPH_C32(0xc8c30000), SPH_C32(0x5eba0000), SPH_C32(0xf4a11e06),
    SPH_C32(0x3d220000), SPH_C32(0x8dab6773), SPH_C32(0xbcb9daa8),
    SPH_C32(0x81ffd9f2), SPH_C32(0x3dd77fb3), SPH_C32(0xaba40000),
    SPH_C32(0xe9f80000), SPH_C32(0x6aed0dc8), SPH_C32(0x7ad10000),
    SPH_C32(0x467c42ba), SPH_C32(0xda345845), SPH_C32(0x327e3f4c),
    SPH_C32(0x1d0b00a5) },
  { SPH_C32(0x9a930000), SPH_C32(0x77ee0000), SPH_C32(0x9ec01e48),
    SPH_C32(0xcddd0000), SPH_C32(0x179a199f), SPH_C32(0xf99a9b66),
    SPH_C32(0x4ea95617), SPH_C32(0x6ed46cbc), SPH_C32(0xf8290000),
    SPH_C32(0x40040000), SPH_C32(0xf41a0dce), SPH_C32(0x2c2e0000),
    SPH_C32(0x4c9842f4), SPH_C32(0x48f195bc), SPH_C32(0x9b3a7f54),
    SPH_C32(0x629c5634) }
};

__constant static const sph_u32 T512_42[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0xca150000), SPH_C32(0x9ea40000), SPH_C32(0x92620001),
    SPH_C32(0x2eda0800), SPH_C32(0x4e020a79), SPH_C32(0x92565e44),
    SPH_C32(0x1d2fdc3b), SPH_C32(0x09815dfe), SPH_C32(0x91600000),
    SPH_C32(0xf1ea0000), SPH_C32(0x28f20000), SPH_C32(0xfb669000),
    SPH_C32(0xa0ba6bd6), SPH_C32(0xa87f0d93), SPH_C32(0x5af23db5),
    SPH_C32(0x942dd002) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0x8f0c0000), SPH_C32(0x35a80000), SPH_C32(0xa2dc0000),
    SPH_C32(0x47d02800), SPH_C32(0x8cfe7860), SPH_C32(0x2382de49),
    SPH_C32(0x30fe267d), SPH_C32(0x2db012e9), SPH_C32(0xc9230000),
    SPH_C32(0x71940000), SPH_C32(0x50c10001), SPH_C32(0x3d0da800),
    SPH_C32(0x478d370a), SPH_C32(0xd1d2324e), SPH_C32(0xf681c3da),
    SPH_C32(0xae69a9b3) },
  { SPH_C32(0x45190000), SPH_C32(0xab0c0000), SPH_C32(0x30be0001),
    SPH_C32(0x690a2000), SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d),
    SPH_C32(0x2dd1fa46), SPH_C32(0x24314f17), SPH_C32(0x58430000),
    SPH_C32(0x807e0000), SPH_C32(0x78330001), SPH_C32(0xc66b3800),
    SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd), SPH_C32(0xac73fe6f),
    SPH_C32(0x3a4479b1) },
  { SPH_C32(0xd74f0000), SPH_C32(0xb5d60000), SPH_C32(0xdaef0001),
    SPH_C32(0x81bb1000), SPH_C32(0x6bc924bc), SPH_C32(0x5a2fe194),
    SPH_C32(0x9c8dd812), SPH_C32(0x17f46b58), SPH_C32(0xd4790000),
    SPH_C32(0x5ae60000), SPH_C32(0x184c0001), SPH_C32(0x926cb000),
    SPH_C32(0x624619cf), SPH_C32(0x19ab8d9e), SPH_C32(0x7723c7f3),
    SPH_C32(0xb01c9f15) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0x376d0000), SPH_C32(0x0afc0000), SPH_C32(0xa461001e),
    SPH_C32(0x941f3000), SPH_C32(0x26ab5b70), SPH_C32(0x9324cba4),
    SPH_C32(0x466d4a8c), SPH_C32(0x38de6d09), SPH_C32(0x8bd70000),
    SPH_C32(0x68c80000), SPH_C32(0xe70b000a), SPH_C32(0xc30a8800),
    SPH_C32(0xc60366bd), SPH_C32(0x28c1dce7), SPH_C32(0x2f285bbe),
    SPH_C32(0x1a2d576a) },
  { SPH_C32(0xfd780000), SPH_C32(0x94580000), SPH_C32(0x3603001f),
    SPH_C32(0xbac53800), SPH_C32(0x68a95109), SPH_C32(0x017295e0),
    SPH_C32(0x5b4296b7), SPH_C32(0x315f30f7), SPH_C32(0x1ab70000),
    SPH_C32(0x99220000), SPH_C32(0xcff9000a), SPH_C32(0x386c1800),
    SPH_C32(0x66b90d6b), SPH_C32(0x80bed174), SPH_C32(0x75da660b),
    SPH_C32(0x8e008768) },
  { SPH_C32(0x6f2e0000), SPH_C32(0x8a820000), SPH_C32(0xdc52001f),
    SPH_C32(0x52740800), SPH_C32(0xc19c07ac), SPH_C32(0xea89f479),
    SPH_C32(0xea1eb4e3), SPH_C32(0x029a14b8), SPH_C32(0x968d0000),
    SPH_C32(0x43ba0000), SPH_C32(0xaf86000a), SPH_C32(0x6c6b9000),
    SPH_C32(0xe3c84878), SPH_C32(0xe0b86337), SPH_C32(0xae8a5f97),
    SPH_C32(0x045861cc) },
  { SPH_C32(0xb8610000), SPH_C32(0x3f540000), SPH_C32(0x06bd001e),
    SPH_C32(0xd3cf1800), SPH_C32(0xaa552310), SPH_C32(0xb0a615ed),
    SPH_C32(0x76936cf1), SPH_C32(0x156e7fe0), SPH_C32(0x42f40000),
    SPH_C32(0x195c0000), SPH_C32(0xb7ca000b), SPH_C32(0xfe072000),
    SPH_C32(0x818e51b7), SPH_C32(0xf913eea9), SPH_C32(0xd9a99864),
    SPH_C32(0xb444fed9) },
  { SPH_C32(0x2a370000), SPH_C32(0x218e0000), SPH_C32(0xecec001e),
    SPH_C32(0x3b7e2800), SPH_C32(0x036075b5), SPH_C32(0x5b5d7474),
    SPH_C32(0xc7cf4ea5), SPH_C32(0x26ab5baf), SPH_C32(0xcece0000),
    SPH_C32(0xc3c40000), SPH_C32(0xd7b5000b), SPH_C32(0xaa00a800),
    SPH_C32(0x04ff14a4), SPH_C32(0x99155cea), SPH_C32(0x02f9a1f8),
    SPH_C32(0x3e1c187d) },
  { SPH_C32(0xe0220000), SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f),
    SPH_C32(0x15a42000), SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30),
    SPH_C32(0xdae0929e), SPH_C32(0x2f2a0651), SPH_C32(0x5fae0000),
    SPH_C32(0x322e0000), SPH_C32(0xff47000b), SPH_C32(0x51663800),
    SPH_C32(0xa4457f72), SPH_C32(0x316a5179), SPH_C32(0x580b9c4d),
    SPH_C32(0xaa31c87f) },
  { SPH_C32(0x72740000), SPH_C32(0xa1f00000), SPH_C32(0x94df001f),
    SPH_C32(0xfd151000), SPH_C32(0xe4572969), SPH_C32(0x22f04ba9),
    SPH_C32(0x6bbcb0ca), SPH_C32(0x1cef221e), SPH_C32(0xd3940000),
    SPH_C32(0xe8b60000), SPH_C32(0x9f38000b), SPH_C32(0x0561b000),
    SPH_C32(0x21343a61), SPH_C32(0x516ce33a), SPH_C32(0x835ba5d1),
    SPH_C32(0x20692edb) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0x95bb0000), SPH_C32(0xac8a0000), SPH_C32(0x6d25000a),
    SPH_C32(0x7fbc3000), SPH_C32(0xea47750b), SPH_C32(0xa33c0f3d),
    SPH_C32(0x45244076), SPH_C32(0xa3b09581), SPH_C32(0x2eec0000),
    SPH_C32(0x7cee0000), SPH_C32(0xa93b0014), SPH_C32(0xbfa48800),
    SPH_C32(0x499d6b68), SPH_C32(0x501e76da), SPH_C32(0xd8193366),
    SPH_C32(0x11361e2c) },
  { SPH_C32(0x5fae0000), SPH_C32(0x322e0000), SPH_C32(0xff47000b),
    SPH_C32(0x51663800), SPH_C32(0xa4457f72), SPH_C32(0x316a5179),
    SPH_C32(0x580b9c4d), SPH_C32(0xaa31c87f), SPH_C32(0xbf8c0000),
    SPH_C32(0x8d040000), SPH_C32(0x81c90014), SPH_C32(0x44c21800),
    SPH_C32(0xe92700be), SPH_C32(0xf8617b49), SPH_C32(0x82eb0ed3),
    SPH_C32(0x851bce2e) },
  { SPH_C32(0xcdf80000), SPH_C32(0x2cf40000), SPH_C32(0x1516000b),
    SPH_C32(0xb9d70800), SPH_C32(0x0d7029d7), SPH_C32(0xda9130e0),
    SPH_C32(0xe957be19), SPH_C32(0x99f4ec30), SPH_C32(0x33b60000),
    SPH_C32(0x579c0000), SPH_C32(0xe1b60014), SPH_C32(0x10c59000),
    SPH_C32(0x6c5645ad), SPH_C32(0x9867c90a), SPH_C32(0x59bb374f),
    SPH_C32(0x0f43288a) },
  { SPH_C32(0x1ab70000), SPH_C32(0x99220000), SPH_C32(0xcff9000a),
    SPH_C32(0x386c1800), SPH_C32(0x66b90d6b), SPH_C32(0x80bed174),
    SPH_C32(0x75da660b), SPH_C32(0x8e008768), SPH_C32(0xe7cf0000),
    SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015), SPH_C32(0x82a92000),
    SPH_C32(0x0e105c62), SPH_C32(0x81cc4494), SPH_C32(0x2e98f0bc),
    SPH_C32(0xbf5fb79f) },
  { SPH_C32(0x88e10000), SPH_C32(0x87f80000), SPH_C32(0x25a8000a),
    SPH_C32(0xd0dd2800), SPH_C32(0xcf8c5bce), SPH_C32(0x6b45b0ed),
    SPH_C32(0xc486445f), SPH_C32(0xbdc5a327), SPH_C32(0x6bf50000),
    SPH_C32(0xd7e20000), SPH_C32(0x99850015), SPH_C32(0xd6aea800),
    SPH_C32(0x8b611971), SPH_C32(0xe1caf6d7), SPH_C32(0xf5c8c920),
    SPH_C32(0x3507513b) },
  { SPH_C32(0x42f40000), SPH_C32(0x195c0000), SPH_C32(0xb7ca000b),
    SPH_C32(0xfe072000), SPH_C32(0x818e51b7), SPH_C32(0xf913eea9),
    SPH_C32(0xd9a99864), SPH_C32(0xb444fed9), SPH_C32(0xfa950000),
    SPH_C32(0x26080000), SPH_C32(0xb1770015), SPH_C32(0x2dc83800),
    SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44), SPH_C32(0xaf3af495),
    SPH_C32(0xa12a8139) },
  { SPH_C32(0xd0a20000), SPH_C32(0x07860000), SPH_C32(0x5d9b000b),
    SPH_C32(0x16b61000), SPH_C32(0x28bb0712), SPH_C32(0x12e88f30),
    SPH_C32(0x68f5ba30), SPH_C32(0x8781da96), SPH_C32(0x76af0000),
    SPH_C32(0xfc900000), SPH_C32(0xd1080015), SPH_C32(0x79cfb000),
    SPH_C32(0xaeaa37b4), SPH_C32(0x29b34907), SPH_C32(0x746acd09),
    SPH_C32(0x2b72679d) },
  { SPH_C32(0xa2d60000), SPH_C32(0xa6760000), SPH_C32(0xc9440014),
    SPH_C32(0xeba30000), SPH_C32(0xccec2e7b), SPH_C32(0x3018c499),
    SPH_C32(0x03490afa), SPH_C32(0x9b6ef888), SPH_C32(0xa53b0000),
    SPH_C32(0x14260000), SPH_C32(0x4e30001e), SPH_C32(0x7cae0000),
    SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d), SPH_C32(0xf73168d8),
    SPH_C32(0x0b1b4946) },
  { SPH_C32(0x30800000), SPH_C32(0xb8ac0000), SPH_C32(0x23150014),
    SPH_C32(0x03123000), SPH_C32(0x65d978de), SPH_C32(0xdbe3a500),
    SPH_C32(0xb21528ae), SPH_C32(0xa8abdcc7), SPH_C32(0x29010000),
    SPH_C32(0xcebe0000), SPH_C32(0x2e4f001e), SPH_C32(0x28a98800),
    SPH_C32(0x0aef48c6), SPH_C32(0x18d9187e), SPH_C32(0x2c615144),
    SPH_C32(0x8143afe2) },
  { SPH_C32(0xfa950000), SPH_C32(0x26080000), SPH_C32(0xb1770015),
    SPH_C32(0x2dc83800), SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44),
    SPH_C32(0xaf3af495), SPH_C32(0xa12a8139), SPH_C32(0xb8610000),
    SPH_C32(0x3f540000), SPH_C32(0x06bd001e), SPH_C32(0xd3cf1800),
    SPH_C32(0xaa552310), SPH_C32(0xb0a615ed), SPH_C32(0x76936cf1),
    SPH_C32(0x156e7fe0) },
  { SPH_C32(0x68c30000), SPH_C32(0x38d20000), SPH_C32(0x5b260015),
    SPH_C32(0xc5790800), SPH_C32(0x82ee2402), SPH_C32(0xa24e9add),
    SPH_C32(0x1e66d6c1), SPH_C32(0x92efa576), SPH_C32(0x345b0000),
    SPH_C32(0xe5cc0000), SPH_C32(0x66c2001e), SPH_C32(0x87c89000),
    SPH_C32(0x2f246603), SPH_C32(0xd0a0a7ae), SPH_C32(0xadc3556d),
    SPH_C32(0x9f369944) },
  { SPH_C32(0xbf8c0000), SPH_C32(0x8d040000), SPH_C32(0x81c90014),
    SPH_C32(0x44c21800), SPH_C32(0xe92700be), SPH_C32(0xf8617b49),
    SPH_C32(0x82eb0ed3), SPH_C32(0x851bce2e), SPH_C32(0xe0220000),
    SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f), SPH_C32(0x15a42000),
    SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30), SPH_C32(0xdae0929e),
    SPH_C32(0x2f2a0651) },
  { SPH_C32(0x2dda0000), SPH_C32(0x93de0000), SPH_C32(0x6b980014),
    SPH_C32(0xac732800), SPH_C32(0x4012561b), SPH_C32(0x139a1ad0),
    SPH_C32(0x33b72c87), SPH_C32(0xb6deea61), SPH_C32(0x6c180000),
    SPH_C32(0x65b20000), SPH_C32(0x1ef1001f), SPH_C32(0x41a3a800),
    SPH_C32(0xc8133adf), SPH_C32(0xa90d9873), SPH_C32(0x01b0ab02),
    SPH_C32(0xa572e0f5) },
  { SPH_C32(0xe7cf0000), SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015),
    SPH_C32(0x82a92000), SPH_C32(0x0e105c62), SPH_C32(0x81cc4494),
    SPH_C32(0x2e98f0bc), SPH_C32(0xbf5fb79f), SPH_C32(0xfd780000),
    SPH_C32(0x94580000), SPH_C32(0x3603001f), SPH_C32(0xbac53800),
    SPH_C32(0x68a95109), SPH_C32(0x017295e0), SPH_C32(0x5b4296b7),
    SPH_C32(0x315f30f7) },
  { SPH_C32(0x75990000), SPH_C32(0x13a00000), SPH_C32(0x13ab0015),
    SPH_C32(0x6a181000), SPH_C32(0xa7250ac7), SPH_C32(0x6a37250d),
    SPH_C32(0x9fc4d2e8), SPH_C32(0x8c9a93d0), SPH_C32(0x71420000),
    SPH_C32(0x4ec00000), SPH_C32(0x567c001f), SPH_C32(0xeec2b000),
    SPH_C32(0xedd8141a), SPH_C32(0x617427a3), SPH_C32(0x8012af2b),
    SPH_C32(0xbb07d653) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0x1ace0000), SPH_C32(0x014e0000), SPH_C32(0x959e002e),
    SPH_C32(0x13ff3000), SPH_C32(0x586d513f), SPH_C32(0x8a55f0fe),
    SPH_C32(0x19c95238), SPH_C32(0xd5d550db), SPH_C32(0x87f80000),
    SPH_C32(0x01fb0000), SPH_C32(0x1ef7000c), SPH_C32(0x41818800),
    SPH_C32(0x148c0de0), SPH_C32(0x15870900), SPH_C32(0x2f307d02),
    SPH_C32(0x52eef2c7) },
  { SPH_C32(0xd0db0000), SPH_C32(0x9fea0000), SPH_C32(0x07fc002f),
    SPH_C32(0x3d253800), SPH_C32(0x166f5b46), SPH_C32(0x1803aeba),
    SPH_C32(0x04e68e03), SPH_C32(0xdc540d25), SPH_C32(0x16980000),
    SPH_C32(0xf0110000), SPH_C32(0x3605000c), SPH_C32(0xbae71800),
    SPH_C32(0xb4366636), SPH_C32(0xbdf80493), SPH_C32(0x75c240b7),
    SPH_C32(0xc6c322c5) },
  { SPH_C32(0x428d0000), SPH_C32(0x81300000), SPH_C32(0xedad002f),
    SPH_C32(0xd5940800), SPH_C32(0xbf5a0de3), SPH_C32(0xf3f8cf23),
    SPH_C32(0xb5baac57), SPH_C32(0xef91296a), SPH_C32(0x9aa20000),
    SPH_C32(0x2a890000), SPH_C32(0x567a000c), SPH_C32(0xeee09000),
    SPH_C32(0x31472325), SPH_C32(0xddfeb6d0), SPH_C32(0xae92792b),
    SPH_C32(0x4c9bc461) },
  { SPH_C32(0x95c20000), SPH_C32(0x34e60000), SPH_C32(0x3742002e),
    SPH_C32(0x542f1800), SPH_C32(0xd493295f), SPH_C32(0xa9d72eb7),
    SPH_C32(0x29377445), SPH_C32(0xf8654232), SPH_C32(0x4edb0000),
    SPH_C32(0x706f0000), SPH_C32(0x4e36000d), SPH_C32(0x7c8c2000),
    SPH_C32(0x53013aea), SPH_C32(0xc4553b4e), SPH_C32(0xd9b1bed8),
    SPH_C32(0xfc875b74) },
  { SPH_C32(0x07940000), SPH_C32(0x2a3c0000), SPH_C32(0xdd13002e),
    SPH_C32(0xbc9e2800), SPH_C32(0x7da67ffa), SPH_C32(0x422c4f2e),
    SPH_C32(0x986b5611), SPH_C32(0xcba0667d), SPH_C32(0xc2e10000),
    SPH_C32(0xaaf70000), SPH_C32(0x2e49000d), SPH_C32(0x288ba800),
    SPH_C32(0xd6707ff9), SPH_C32(0xa453890d), SPH_C32(0x02e18744),
    SPH_C32(0x76dfbdd0) },
  { SPH_C32(0xcd810000), SPH_C32(0xb4980000), SPH_C32(0x4f71002f),
    SPH_C32(0x92442000), SPH_C32(0x33a47583), SPH_C32(0xd07a116a),
    SPH_C32(0x85448a2a), SPH_C32(0xc2213b83), SPH_C32(0x53810000),
    SPH_C32(0x5b1d0000), SPH_C32(0x06bb000d), SPH_C32(0xd3ed3800),
    SPH_C32(0x76ca142f), SPH_C32(0x0c2c849e), SPH_C32(0x5813baf1),
    SPH_C32(0xe2f26dd2) },
  { SPH_C32(0x5fd70000), SPH_C32(0xaa420000), SPH_C32(0xa520002f),
    SPH_C32(0x7af51000), SPH_C32(0x9a912326), SPH_C32(0x3b8170f3),
    SPH_C32(0x3418a87e), SPH_C32(0xf1e41fcc), SPH_C32(0xdfbb0000),
    SPH_C32(0x81850000), SPH_C32(0x66c4000d), SPH_C32(0x87eab000),
    SPH_C32(0xf3bb513c), SPH_C32(0x6c2a36dd), SPH_C32(0x8343836d),
    SPH_C32(0x68aa8b76) },
  { SPH_C32(0x2da30000), SPH_C32(0x0bb20000), SPH_C32(0x31ff0030),
    SPH_C32(0x87e00000), SPH_C32(0x7ec60a4f), SPH_C32(0x19713b5a),
    SPH_C32(0x5fa418b4), SPH_C32(0xed0b3dd2), SPH_C32(0x0c2f0000),
    SPH_C32(0x69330000), SPH_C32(0xf9fc0006), SPH_C32(0x828b0000),
    SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7), SPH_C32(0x001826bc),
    SPH_C32(0x48c3a5ad) },
  { SPH_C32(0xbff50000), SPH_C32(0x15680000), SPH_C32(0xdbae0030),
    SPH_C32(0x6f513000), SPH_C32(0xd7f35cea), SPH_C32(0xf28a5ac3),
    SPH_C32(0xeef83ae0), SPH_C32(0xdece199d), SPH_C32(0x80150000),
    SPH_C32(0xb3ab0000), SPH_C32(0x99830006), SPH_C32(0xd68c8800),
    SPH_C32(0x57fe2e4e), SPH_C32(0x5d4067a4), SPH_C32(0xdb481f20),
    SPH_C32(0xc29b4309) },
  { SPH_C32(0x75e00000), SPH_C32(0x8bcc0000), SPH_C32(0x49cc0031),
    SPH_C32(0x418b3800), SPH_C32(0x99f15693), SPH_C32(0x60dc0487),
    SPH_C32(0xf3d7e6db), SPH_C32(0xd74f4463), SPH_C32(0x11750000),
    SPH_C32(0x42410000), SPH_C32(0xb1710006), SPH_C32(0x2dea1800),
    SPH_C32(0xf7444598), SPH_C32(0xf53f6a37), SPH_C32(0x81ba2295),
    SPH_C32(0x56b6930b) },
  { SPH_C32(0xe7b60000), SPH_C32(0x95160000), SPH_C32(0xa39d0031),
    SPH_C32(0xa93a0800), SPH_C32(0x30c40036), SPH_C32(0x8b27651e),
    SPH_C32(0x428bc48f), SPH_C32(0xe48a602c), SPH_C32(0x9d4f0000),
    SPH_C32(0x98d90000), SPH_C32(0xd10e0006), SPH_C32(0x79ed9000),
    SPH_C32(0x7235008b), SPH_C32(0x9539d874), SPH_C32(0x5aea1b09),
    SPH_C32(0xdcee75af) },
  { SPH_C32(0x30f90000), SPH_C32(0x20c00000), SPH_C32(0x79720030),
    SPH_C32(0x28811800), SPH_C32(0x5b0d248a), SPH_C32(0xd108848a),
    SPH_C32(0xde061c9d), SPH_C32(0xf37e0b74), SPH_C32(0x49360000),
    SPH_C32(0xc23f0000), SPH_C32(0xc9420007), SPH_C32(0xeb812000),
    SPH_C32(0x10731944), SPH_C32(0x8c9255ea), SPH_C32(0x2dc9dcfa),
    SPH_C32(0x6cf2eaba) },
  { SPH_C32(0xa2af0000), SPH_C32(0x3e1a0000), SPH_C32(0x93230030),
    SPH_C32(0xc0302800), SPH_C32(0xf238722f), SPH_C32(0x3af3e513),
    SPH_C32(0x6f5a3ec9), SPH_C32(0xc0bb2f3b), SPH_C32(0xc50c0000),
    SPH_C32(0x18a70000), SPH_C32(0xa93d0007), SPH_C32(0xbf86a800),
    SPH_C32(0x95025c57), SPH_C32(0xec94e7a9), SPH_C32(0xf699e566),
    SPH_C32(0xe6aa0c1e) },
  { SPH_C32(0x68ba0000), SPH_C32(0xa0be0000), SPH_C32(0x01410031),
    SPH_C32(0xeeea2000), SPH_C32(0xbc3a7856), SPH_C32(0xa8a5bb57),
    SPH_C32(0x7275e2f2), SPH_C32(0xc93a72c5), SPH_C32(0x546c0000),
    SPH_C32(0xe94d0000), SPH_C32(0x81cf0007), SPH_C32(0x44e03800),
    SPH_C32(0x35b83781), SPH_C32(0x44ebea3a), SPH_C32(0xac6bd8d3),
    SPH_C32(0x7287dc1c) },
  { SPH_C32(0xfaec0000), SPH_C32(0xbe640000), SPH_C32(0xeb100031),
    SPH_C32(0x065b1000), SPH_C32(0x150f2ef3), SPH_C32(0x435edace),
    SPH_C32(0xc329c0a6), SPH_C32(0xfaff568a), SPH_C32(0xd8560000),
    SPH_C32(0x33d50000), SPH_C32(0xe1b00007), SPH_C32(0x10e7b000),
    SPH_C32(0xb0c97292), SPH_C32(0x24ed5879), SPH_C32(0x773be14f),
    SPH_C32(0xf8df3ab8) },
  { SPH_C32(0x8f750000), SPH_C32(0xadc40000), SPH_C32(0xf8bb0024),
    SPH_C32(0x6c430000), SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3),
    SPH_C32(0x5ced124e), SPH_C32(0x7665c55a), SPH_C32(0xa9140000),
    SPH_C32(0x7d150000), SPH_C32(0xb7cc0018), SPH_C32(0xfe250000),
    SPH_C32(0x5d116688), SPH_C32(0x45997fda), SPH_C32(0xf7294e64),
    SPH_C32(0x43d8eceb) },
  { SPH_C32(0x1d230000), SPH_C32(0xb31e0000), SPH_C32(0x12ea0024),
    SPH_C32(0x84f23000), SPH_C32(0x1b1f7291), SPH_C32(0xc2929e5a),
    SPH_C32(0xedb1301a), SPH_C32(0x45a0e115), SPH_C32(0x252e0000),
    SPH_C32(0xa78d0000), SPH_C32(0xd7b30018), SPH_C32(0xaa228800),
    SPH_C32(0xd860239b), SPH_C32(0x259fcd99), SPH_C32(0x2c7977f8),
    SPH_C32(0xc9800a4f) },
  { SPH_C32(0xd7360000), SPH_C32(0x2dba0000), SPH_C32(0x80880025),
    SPH_C32(0xaa283800), SPH_C32(0x551d78e8), SPH_C32(0x50c4c01e),
    SPH_C32(0xf09eec21), SPH_C32(0x4c21bceb), SPH_C32(0xb44e0000),
    SPH_C32(0x56670000), SPH_C32(0xff410018), SPH_C32(0x51441800),
    SPH_C32(0x78da484d), SPH_C32(0x8de0c00a), SPH_C32(0x768b4a4d),
    SPH_C32(0x5dadda4d) },
  { SPH_C32(0x45600000), SPH_C32(0x33600000), SPH_C32(0x6ad90025),
    SPH_C32(0x42990800), SPH_C32(0xfc282e4d), SPH_C32(0xbb3fa187),
    SPH_C32(0x41c2ce75), SPH_C32(0x7fe498a4), SPH_C32(0x38740000),
    SPH_C32(0x8cff0000), SPH_C32(0x9f3e0018), SPH_C32(0x05439000),
    SPH_C32(0xfdab0d5e), SPH_C32(0xede67249), SPH_C32(0xaddb73d1),
    SPH_C32(0xd7f53ce9) },
  { SPH_C32(0x922f0000), SPH_C32(0x86b60000), SPH_C32(0xb0360024),
    SPH_C32(0xc3221800), SPH_C32(0x97e10af1), SPH_C32(0xe1104013),
    SPH_C32(0xdd4f1667), SPH_C32(0x6810f3fc), SPH_C32(0xec0d0000),
    SPH_C32(0xd6190000), SPH_C32(0x87720019), SPH_C32(0x972f2000),
    SPH_C32(0x9fed1491), SPH_C32(0xf44dffd7), SPH_C32(0xdaf8b422),
    SPH_C32(0x67e9a3fc) },
  { SPH_C32(0x00790000), SPH_C32(0x986c0000), SPH_C32(0x5a670024),
    SPH_C32(0x2b932800), SPH_C32(0x3ed45c54), SPH_C32(0x0aeb218a),
    SPH_C32(0x6c133433), SPH_C32(0x5bd5d7b3), SPH_C32(0x60370000),
    SPH_C32(0x0c810000), SPH_C32(0xe70d0019), SPH_C32(0xc328a800),
    SPH_C32(0x1a9c5182), SPH_C32(0x944b4d94), SPH_C32(0x01a88dbe),
    SPH_C32(0xedb14558) },
  { SPH_C32(0xca6c0000), SPH_C32(0x06c80000), SPH_C32(0xc8050025),
    SPH_C32(0x05492000), SPH_C32(0x70d6562d), SPH_C32(0x98bd7fce),
    SPH_C32(0x713ce808), SPH_C32(0x52548a4d), SPH_C32(0xf1570000),
    SPH_C32(0xfd6b0000), SPH_C32(0xcfff0019), SPH_C32(0x384e3800),
    SPH_C32(0xba263a54), SPH_C32(0x3c344007), SPH_C32(0x5b5ab00b),
    SPH_C32(0x799c955a) },
  { SPH_C32(0x583a0000), SPH_C32(0x18120000), SPH_C32(0x22540025),
    SPH_C32(0xedf81000), SPH_C32(0xd9e30088), SPH_C32(0x73461e57),
    SPH_C32(0xc060ca5c), SPH_C32(0x6191ae02), SPH_C32(0x7d6d0000),
    SPH_C32(0x27f30000), SPH_C32(0xaf800019), SPH_C32(0x6c49b000),
    SPH_C32(0x3f577f47), SPH_C32(0x5c32f244), SPH_C32(0x800a8997),
    SPH_C32(0xf3c473fe) },
  { SPH_C32(0x2a4e0000), SPH_C32(0xb9e20000), SPH_C32(0xb68b003a),
    SPH_C32(0x10ed0000), SPH_C32(0x3db429e1), SPH_C32(0x51b655fe),
    SPH_C32(0xabdc7a96), SPH_C32(0x7d7e8c1c), SPH_C32(0xaef90000),
    SPH_C32(0xcf450000), SPH_C32(0x30b80012), SPH_C32(0x69280000),
    SPH_C32(0x1e634526), SPH_C32(0x0d5e117e), SPH_C32(0x03512c46),
    SPH_C32(0xd3ad5d25) },
  { SPH_C32(0xb8180000), SPH_C32(0xa7380000), SPH_C32(0x5cda003a),
    SPH_C32(0xf85c3000), SPH_C32(0x94817f44), SPH_C32(0xba4d3467),
    SPH_C32(0x1a8058c2), SPH_C32(0x4ebba853), SPH_C32(0x22c30000),
    SPH_C32(0x15dd0000), SPH_C32(0x50c70012), SPH_C32(0x3d2f8800),
    SPH_C32(0x9b120035), SPH_C32(0x6d58a33d), SPH_C32(0xd80115da),
    SPH_C32(0x59f5bb81) },
  { SPH_C32(0x720d0000), SPH_C32(0x399c0000), SPH_C32(0xceb8003b),
    SPH_C32(0xd6863800), SPH_C32(0xda83753d), SPH_C32(0x281b6a23),
    SPH_C32(0x07af84f9), SPH_C32(0x473af5ad), SPH_C32(0xb3a30000),
    SPH_C32(0xe4370000), SPH_C32(0x78350012), SPH_C32(0xc6491800),
    SPH_C32(0x3ba86be3), SPH_C32(0xc527aeae), SPH_C32(0x82f3286f),
    SPH_C32(0xcdd86b83) },
  { SPH_C32(0xe05b0000), SPH_C32(0x27460000), SPH_C32(0x24e9003b),
    SPH_C32(0x3e370800), SPH_C32(0x73b62398), SPH_C32(0xc3e00bba),
    SPH_C32(0xb6f3a6ad), SPH_C32(0x74ffd1e2), SPH_C32(0x3f990000),
    SPH_C32(0x3eaf0000), SPH_C32(0x184a0012), SPH_C32(0x924e9000),
    SPH_C32(0xbed92ef0), SPH_C32(0xa5211ced), SPH_C32(0x59a311f3),
    SPH_C32(0x47808d27) },
  { SPH_C32(0x37140000), SPH_C32(0x92900000), SPH_C32(0xfe06003a),
    SPH_C32(0xbf8c1800), SPH_C32(0x187f0724), SPH_C32(0x99cfea2e),
    SPH_C32(0x2a7e7ebf), SPH_C32(0x630bbaba), SPH_C32(0xebe00000),
    SPH_C32(0x64490000), SPH_C32(0x00060013), SPH_C32(0x00222000),
    SPH_C32(0xdc9f373f), SPH_C32(0xbc8a9173), SPH_C32(0x2e80d600),
    SPH_C32(0xf79c1232) },
  { SPH_C32(0xa5420000), SPH_C32(0x8c4a0000), SPH_C32(0x1457003a),
    SPH_C32(0x573d2800), SPH_C32(0xb14a5181), SPH_C32(0x72348bb7),
    SPH_C32(0x9b225ceb), SPH_C32(0x50ce9ef5), SPH_C32(0x67da0000),
    SPH_C32(0xbed10000), SPH_C32(0x60790013), SPH_C32(0x5425a800),
    SPH_C32(0x59ee722c), SPH_C32(0xdc8c2330), SPH_C32(0xf5d0ef9c),
    SPH_C32(0x7dc4f496) },
  { SPH_C32(0x6f570000), SPH_C32(0x12ee0000), SPH_C32(0x8635003b),
    SPH_C32(0x79e72000), SPH_C32(0xff485bf8), SPH_C32(0xe062d5f3),
    SPH_C32(0x860d80d0), SPH_C32(0x594fc30b), SPH_C32(0xf6ba0000),
    SPH_C32(0x4f3b0000), SPH_C32(0x488b0013), SPH_C32(0xaf433800),
    SPH_C32(0xf95419fa), SPH_C32(0x74f32ea3), SPH_C32(0xaf22d229),
    SPH_C32(0xe9e92494) },
  { SPH_C32(0xfd010000), SPH_C32(0x0c340000), SPH_C32(0x6c64003b),
    SPH_C32(0x91561000), SPH_C32(0x567d0d5d), SPH_C32(0x0b99b46a),
    SPH_C32(0x3751a284), SPH_C32(0x6a8ae744), SPH_C32(0x7a800000),
    SPH_C32(0x95a30000), SPH_C32(0x28f40013), SPH_C32(0xfb44b000),
    SPH_C32(0x7c255ce9), SPH_C32(0x14f59ce0), SPH_C32(0x7472ebb5),
    SPH_C32(0x63b1c230) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x99940000), SPH_C32(0xc5b90000), SPH_C32(0x94d9000c),
    SPH_C32(0xfd373000), SPH_C32(0x38c81e56), SPH_C32(0x9e7adada),
    SPH_C32(0x453c66ca), SPH_C32(0xeb73302c), SPH_C32(0x0f600000),
    SPH_C32(0x1e6f0000), SPH_C32(0x61380022), SPH_C32(0xbacf8800),
    SPH_C32(0xe5d40a7a), SPH_C32(0x74299867), SPH_C32(0x87a50d6e),
    SPH_C32(0xb4fe8653) },
  { SPH_C32(0x53810000), SPH_C32(0x5b1d0000), SPH_C32(0x06bb000d),
    SPH_C32(0xd3ed3800), SPH_C32(0x76ca142f), SPH_C32(0x0c2c849e),
    SPH_C32(0x5813baf1), SPH_C32(0xe2f26dd2), SPH_C32(0x9e000000),
    SPH_C32(0xef850000), SPH_C32(0x49ca0022), SPH_C32(0x41a91800),
    SPH_C32(0x456e61ac), SPH_C32(0xdc5695f4), SPH_C32(0xdd5730db),
    SPH_C32(0x20d35651) },
  { SPH_C32(0xc1d70000), SPH_C32(0x45c70000), SPH_C32(0xecea000d),
    SPH_C32(0x3b5c0800), SPH_C32(0xdfff428a), SPH_C32(0xe7d7e507),
    SPH_C32(0xe94f98a5), SPH_C32(0xd137499d), SPH_C32(0x123a0000),
    SPH_C32(0x351d0000), SPH_C32(0x29b50022), SPH_C32(0x15ae9000),
    SPH_C32(0xc01f24bf), SPH_C32(0xbc5027b7), SPH_C32(0x06070947),
    SPH_C32(0xaa8bb0f5) },
  { SPH_C32(0x16980000), SPH_C32(0xf0110000), SPH_C32(0x3605000c),
    SPH_C32(0xbae71800), SPH_C32(0xb4366636), SPH_C32(0xbdf80493),
    SPH_C32(0x75c240b7), SPH_C32(0xc6c322c5), SPH_C32(0xc6430000),
    SPH_C32(0x6ffb0000), SPH_C32(0x31f90023), SPH_C32(0x87c22000),
    SPH_C32(0xa2593d70), SPH_C32(0xa5fbaa29), SPH_C32(0x7124ceb4),
    SPH_C32(0x1a972fe0) },
  { SPH_C32(0x84ce0000), SPH_C32(0xeecb0000), SPH_C32(0xdc54000c),
    SPH_C32(0x52562800), SPH_C32(0x1d033093), SPH_C32(0x5603650a),
    SPH_C32(0xc49e62e3), SPH_C32(0xf506068a), SPH_C32(0x4a790000),
    SPH_C32(0xb5630000), SPH_C32(0x51860023), SPH_C32(0xd3c5a800),
    SPH_C32(0x27287863), SPH_C32(0xc5fd186a), SPH_C32(0xaa74f728),
    SPH_C32(0x90cfc944) },
  { SPH_C32(0x4edb0000), SPH_C32(0x706f0000), SPH_C32(0x4e36000d),
    SPH_C32(0x7c8c2000), SPH_C32(0x53013aea), SPH_C32(0xc4553b4e),
    SPH_C32(0xd9b1bed8), SPH_C32(0xfc875b74), SPH_C32(0xdb190000),
    SPH_C32(0x44890000), SPH_C32(0x79740023), SPH_C32(0x28a33800),
    SPH_C32(0x879213b5), SPH_C32(0x6d8215f9), SPH_C32(0xf086ca9d),
    SPH_C32(0x04e21946) },
  { SPH_C32(0xdc8d0000), SPH_C32(0x6eb50000), SPH_C32(0xa467000d),
    SPH_C32(0x943d1000), SPH_C32(0xfa346c4f), SPH_C32(0x2fae5ad7),
    SPH_C32(0x68ed9c8c), SPH_C32(0xcf427f3b), SPH_C32(0x57230000),
    SPH_C32(0x9e110000), SPH_C32(0x190b0023), SPH_C32(0x7ca4b000),
    SPH_C32(0x02e356a6), SPH_C32(0x0d84a7ba), SPH_C32(0x2bd6f301),
    SPH_C32(0x8ebaffe2) },
  { SPH_C32(0xaef90000), SPH_C32(0xcf450000), SPH_C32(0x30b80012),
    SPH_C32(0x69280000), SPH_C32(0x1e634526), SPH_C32(0x0d5e117e),
    SPH_C32(0x03512c46), SPH_C32(0xd3ad5d25), SPH_C32(0x84b70000),
    SPH_C32(0x76a70000), SPH_C32(0x86330028), SPH_C32(0x79c50000),
    SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480), SPH_C32(0xa88d56d0),
    SPH_C32(0xaed3d139) },
  { SPH_C32(0x3caf0000), SPH_C32(0xd19f0000), SPH_C32(0xdae90012),
    SPH_C32(0x81993000), SPH_C32(0xb7561383), SPH_C32(0xe6a570e7),
    SPH_C32(0xb20d0e12), SPH_C32(0xe068796a), SPH_C32(0x088d0000),
    SPH_C32(0xac3f0000), SPH_C32(0xe64c0028), SPH_C32(0x2dc28800),
    SPH_C32(0xa6a629d4), SPH_C32(0x3ceef6c3), SPH_C32(0x73dd6f4c),
    SPH_C32(0x248b379d) },
  { SPH_C32(0xf6ba0000), SPH_C32(0x4f3b0000), SPH_C32(0x488b0013),
    SPH_C32(0xaf433800), SPH_C32(0xf95419fa), SPH_C32(0x74f32ea3),
    SPH_C32(0xaf22d229), SPH_C32(0xe9e92494), SPH_C32(0x99ed0000),
    SPH_C32(0x5dd50000), SPH_C32(0xcebe0028), SPH_C32(0xd6a41800),
    SPH_C32(0x061c4202), SPH_C32(0x9491fb50), SPH_C32(0x292f52f9),
    SPH_C32(0xb0a6e79f) },
  { SPH_C32(0x64ec0000), SPH_C32(0x51e10000), SPH_C32(0xa2da0013),
    SPH_C32(0x47f20800), SPH_C32(0x50614f5f), SPH_C32(0x9f084f3a),
    SPH_C32(0x1e7ef07d), SPH_C32(0xda2c00db), SPH_C32(0x15d70000),
    SPH_C32(0x874d0000), SPH_C32(0xaec10028), SPH_C32(0x82a39000),
    SPH_C32(0x836d0711), SPH_C32(0xf4974913), SPH_C32(0xf27f6b65),
    SPH_C32(0x3afe013b) },
  { SPH_C32(0xb3a30000), SPH_C32(0xe4370000), SPH_C32(0x78350012),
    SPH_C32(0xc6491800), SPH_C32(0x3ba86be3), SPH_C32(0xc527aeae),
    SPH_C32(0x82f3286f), SPH_C32(0xcdd86b83), SPH_C32(0xc1ae0000),
    SPH_C32(0xddab0000), SPH_C32(0xb68d0029), SPH_C32(0x10cf2000),
    SPH_C32(0xe12b1ede), SPH_C32(0xed3cc48d), SPH_C32(0x855cac96),
    SPH_C32(0x8ae29e2e) },
  { SPH_C32(0x21f50000), SPH_C32(0xfaed0000), SPH_C32(0x92640012),
    SPH_C32(0x2ef82800), SPH_C32(0x929d3d46), SPH_C32(0x2edccf37),
    SPH_C32(0x33af0a3b), SPH_C32(0xfe1d4fcc), SPH_C32(0x4d940000),
    SPH_C32(0x07330000), SPH_C32(0xd6f20029), SPH_C32(0x44c8a800),
    SPH_C32(0x645a5bcd), SPH_C32(0x8d3a76ce), SPH_C32(0x5e0c950a),
    SPH_C32(0x00ba788a) },
  { SPH_C32(0xebe00000), SPH_C32(0x64490000), SPH_C32(0x00060013),
    SPH_C32(0x00222000), SPH_C32(0xdc9f373f), SPH_C32(0xbc8a9173),
    SPH_C32(0x2e80d600), SPH_C32(0xf79c1232), SPH_C32(0xdcf40000),
    SPH_C32(0xf6d90000), SPH_C32(0xfe000029), SPH_C32(0xbfae3800),
    SPH_C32(0xc4e0301b), SPH_C32(0x25457b5d), SPH_C32(0x04fea8bf),
    SPH_C32(0x9497a888) },
  { SPH_C32(0x79b60000), SPH_C32(0x7a930000), SPH_C32(0xea570013),
    SPH_C32(0xe8931000), SPH_C32(0x75aa619a), SPH_C32(0x5771f0ea),
    SPH_C32(0x9fdcf454), SPH_C32(0xc459367d), SPH_C32(0x50ce0000),
    SPH_C32(0x2c410000), SPH_C32(0x9e7f0029), SPH_C32(0xeba9b000),
    SPH_C32(0x41917508), SPH_C32(0x4543c91e), SPH_C32(0xdfae9123),
    SPH_C32(0x1ecf4e2c) },
  { SPH_C32(0x0c2f0000), SPH_C32(0x69330000), SPH_C32(0xf9fc0006),
    SPH_C32(0x828b0000), SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7),
    SPH_C32(0x001826bc), SPH_C32(0x48c3a5ad), SPH_C32(0x218c0000),
    SPH_C32(0x62810000), SPH_C32(0xc8030036), SPH_C32(0x056b0000),
    SPH_C32(0xac496112), SPH_C32(0x2437eebd), SPH_C32(0x5fbc3e08),
    SPH_C32(0xa5c8987f) },
  { SPH_C32(0x9e790000), SPH_C32(0x77e90000), SPH_C32(0x13ad0006),
    SPH_C32(0x6a3a3000), SPH_C32(0x7bba3df8), SPH_C32(0xd6bdb47e),
    SPH_C32(0xb14404e8), SPH_C32(0x7b0681e2), SPH_C32(0xadb60000),
    SPH_C32(0xb8190000), SPH_C32(0xa87c0036), SPH_C32(0x516c8800),
    SPH_C32(0x29382401), SPH_C32(0x44315cfe), SPH_C32(0x84ec0794),
    SPH_C32(0x2f907edb) },
  { SPH_C32(0x546c0000), SPH_C32(0xe94d0000), SPH_C32(0x81cf0007),
    SPH_C32(0x44e03800), SPH_C32(0x35b83781), SPH_C32(0x44ebea3a),
    SPH_C32(0xac6bd8d3), SPH_C32(0x7287dc1c), SPH_C32(0x3cd60000),
    SPH_C32(0x49f30000), SPH_C32(0x808e0036), SPH_C32(0xaa0a1800),
    SPH_C32(0x89824fd7), SPH_C32(0xec4e516d), SPH_C32(0xde1e3a21),
    SPH_C32(0xbbbdaed9) },
  { SPH_C32(0xc63a0000), SPH_C32(0xf7970000), SPH_C32(0x6b9e0007),
    SPH_C32(0xac510800), SPH_C32(0x9c8d6124), SPH_C32(0xaf108ba3),
    SPH_C32(0x1d37fa87), SPH_C32(0x4142f853), SPH_C32(0xb0ec0000),
    SPH_C32(0x936b0000), SPH_C32(0xe0f10036), SPH_C32(0xfe0d9000),
    SPH_C32(0x0cf30ac4), SPH_C32(0x8c48e32e), SPH_C32(0x054e03bd),
    SPH_C32(0x31e5487d) },
  { SPH_C32(0x11750000), SPH_C32(0x42410000), SPH_C32(0xb1710006),
    SPH_C32(0x2dea1800), SPH_C32(0xf7444598), SPH_C32(0xf53f6a37),
    SPH_C32(0x81ba2295), SPH_C32(0x56b6930b), SPH_C32(0x64950000),
    SPH_C32(0xc98d0000), SPH_C32(0xf8bd0037), SPH_C32(0x6c612000),
    SPH_C32(0x6eb5130b), SPH_C32(0x95e36eb0), SPH_C32(0x726dc44e),
    SPH_C32(0x81f9d768) },
  { SPH_C32(0x83230000), SPH_C32(0x5c9b0000), SPH_C32(0x5b200006),
    SPH_C32(0xc55b2800), SPH_C32(0x5e71133d), SPH_C32(0x1ec40bae),
    SPH_C32(0x30e600c1), SPH_C32(0x6573b744), SPH_C32(0xe8af0000),
    SPH_C32(0x13150000), SPH_C32(0x98c20037), SPH_C32(0x3866a800),
    SPH_C32(0xebc45618), SPH_C32(0xf5e5dcf3), SPH_C32(0xa93dfdd2),
    SPH_C32(0x0ba131cc) },
  { SPH_C32(0x49360000), SPH_C32(0xc23f0000), SPH_C32(0xc9420007),
    SPH_C32(0xeb812000), SPH_C32(0x10731944), SPH_C32(0x8c9255ea),
    SPH_C32(0x2dc9dcfa), SPH_C32(0x6cf2eaba), SPH_C32(0x79cf0000),
    SPH_C32(0xe2ff0000), SPH_C32(0xb0300037), SPH_C32(0xc3003800),
    SPH_C32(0x4b7e3dce), SPH_C32(0x5d9ad160), SPH_C32(0xf3cfc067),
    SPH_C32(0x9f8ce1ce) },
  { SPH_C32(0xdb600000), SPH_C32(0xdce50000), SPH_C32(0x23130007),
    SPH_C32(0x03301000), SPH_C32(0xb9464fe1), SPH_C32(0x67693473),
    SPH_C32(0x9c95feae), SPH_C32(0x5f37cef5), SPH_C32(0xf5f50000),
    SPH_C32(0x38670000), SPH_C32(0xd04f0037), SPH_C32(0x9707b000),
    SPH_C32(0xce0f78dd), SPH_C32(0x3d9c6323), SPH_C32(0x289ff9fb),
    SPH_C32(0x15d4076a) },
  { SPH_C32(0xa9140000), SPH_C32(0x7d150000), SPH_C32(0xb7cc0018),
    SPH_C32(0xfe250000), SPH_C32(0x5d116688), SPH_C32(0x45997fda),
    SPH_C32(0xf7294e64), SPH_C32(0x43d8eceb), SPH_C32(0x26610000),
    SPH_C32(0xd0d10000), SPH_C32(0x4f77003c), SPH_C32(0x92660000),
    SPH_C32(0xef3b42bc), SPH_C32(0x6cf08019), SPH_C32(0xabc45c2a),
    SPH_C32(0x35bd29b1) },
  { SPH_C32(0x3b420000), SPH_C32(0x63cf0000), SPH_C32(0x5d9d0018),
    SPH_C32(0x16943000), SPH_C32(0xf424302d), SPH_C32(0xae621e43),
    SPH_C32(0x46756c30), SPH_C32(0x701dc8a4), SPH_C32(0xaa5b0000),
    SPH_C32(0x0a490000), SPH_C32(0x2f08003c), SPH_C32(0xc6618800),
    SPH_C32(0x6a4a07af), SPH_C32(0x0cf6325a), SPH_C32(0x709465b6),
    SPH_C32(0xbfe5cf15) },
  { SPH_C32(0xf1570000), SPH_C32(0xfd6b0000), SPH_C32(0xcfff0019),
    SPH_C32(0x384e3800), SPH_C32(0xba263a54), SPH_C32(0x3c344007),
    SPH_C32(0x5b5ab00b), SPH_C32(0x799c955a), SPH_C32(0x3b3b0000),
    SPH_C32(0xfba30000), SPH_C32(0x07fa003c), SPH_C32(0x3d071800),
    SPH_C32(0xcaf06c79), SPH_C32(0xa4893fc9), SPH_C32(0x2a665803),
    SPH_C32(0x2bc81f17) },
  { SPH_C32(0x63010000), SPH_C32(0xe3b10000), SPH_C32(0x25ae0019),
    SPH_C32(0xd0ff0800), SPH_C32(0x13136cf1), SPH_C32(0xd7cf219e),
    SPH_C32(0xea06925f), SPH_C32(0x4a59b115), SPH_C32(0xb7010000),
    SPH_C32(0x213b0000), SPH_C32(0x6785003c), SPH_C32(0x69009000),
    SPH_C32(0x4f81296a), SPH_C32(0xc48f8d8a), SPH_C32(0xf136619f),
    SPH_C32(0xa190f9b3) },
  { SPH_C32(0xb44e0000), SPH_C32(0x56670000), SPH_C32(0xff410018),
    SPH_C32(0x51441800), SPH_C32(0x78da484d), SPH_C32(0x8de0c00a),
    SPH_C32(0x768b4a4d), SPH_C32(0x5dadda4d), SPH_C32(0x63780000),
    SPH_C32(0x7bdd0000), SPH_C32(0x7fc9003d), SPH_C32(0xfb6c2000),
    SPH_C32(0x2dc730a5), SPH_C32(0xdd240014), SPH_C32(0x8615a66c),
    SPH_C32(0x118c66a6) },
  { SPH_C32(0x26180000), SPH_C32(0x48bd0000), SPH_C32(0x15100018),
    SPH_C32(0xb9f52800), SPH_C32(0xd1ef1ee8), SPH_C32(0x661ba193),
    SPH_C32(0xc7d76819), SPH_C32(0x6e68fe02), SPH_C32(0xef420000),
    SPH_C32(0xa1450000), SPH_C32(0x1fb6003d), SPH_C32(0xaf6ba800),
    SPH_C32(0xa8b675b6), SPH_C32(0xbd22b257), SPH_C32(0x5d459ff0),
    SPH_C32(0x9bd48002) },
  { SPH_C32(0xec0d0000), SPH_C32(0xd6190000), SPH_C32(0x87720019),
    SPH_C32(0x972f2000), SPH_C32(0x9fed1491), SPH_C32(0xf44dffd7),
    SPH_C32(0xdaf8b422), SPH_C32(0x67e9a3fc), SPH_C32(0x7e220000),
    SPH_C32(0x50af0000), SPH_C32(0x3744003d), SPH_C32(0x540d3800),
    SPH_C32(0x080c1e60), SPH_C32(0x155dbfc4), SPH_C32(0x07b7a245),
    SPH_C32(0x0ff95000) },
  { SPH_C32(0x7e5b0000), SPH_C32(0xc8c30000), SPH_C32(0x6d230019),
    SPH_C32(0x7f9e1000), SPH_C32(0x36d84234), SPH_C32(0x1fb69e4e),
    SPH_C32(0x6ba49676), SPH_C32(0x542c87b3), SPH_C32(0xf2180000),
    SPH_C32(0x8a370000), SPH_C32(0x573b003d), SPH_C32(0x000ab000),
    SPH_C32(0x8d7d5b73), SPH_C32(0x755b0d87), SPH_C32(0xdce79bd9),
    SPH_C32(0x85a1b6a4) },
  { SPH_C32(0x835a0000), SPH_C32(0xc4f70000), SPH_C32(0x01470022),
    SPH_C32(0xeec80000), SPH_C32(0x60a54f69), SPH_C32(0x142f2a24),
    SPH_C32(0x5cf534f2), SPH_C32(0x3ea660f7), SPH_C32(0x88980000),
    SPH_C32(0x1f940000), SPH_C32(0x7fcf002e), SPH_C32(0xfb4e0000),
    SPH_C32(0xf158079a), SPH_C32(0x61ae9167), SPH_C32(0xa895706c),
    SPH_C32(0xe6107494) },
  { SPH_C32(0x110c0000), SPH_C32(0xda2d0000), SPH_C32(0xeb160022),
    SPH_C32(0x06793000), SPH_C32(0xc99019cc), SPH_C32(0xffd44bbd),
    SPH_C32(0xeda916a6), SPH_C32(0x0d6344b8), SPH_C32(0x04a20000),
    SPH_C32(0xc50c0000), SPH_C32(0x1fb0002e), SPH_C32(0xaf498800),
    SPH_C32(0x74294289), SPH_C32(0x01a82324), SPH_C32(0x73c549f0),
    SPH_C32(0x6c489230) },
  { SPH_C32(0xdb190000), SPH_C32(0x44890000), SPH_C32(0x79740023),
    SPH_C32(0x28a33800), SPH_C32(0x879213b5), SPH_C32(0x6d8215f9),
    SPH_C32(0xf086ca9d), SPH_C32(0x04e21946), SPH_C32(0x95c20000),
    SPH_C32(0x34e60000), SPH_C32(0x3742002e), SPH_C32(0x542f1800),
    SPH_C32(0xd493295f), SPH_C32(0xa9d72eb7), SPH_C32(0x29377445),
    SPH_C32(0xf8654232) },
  { SPH_C32(0x494f0000), SPH_C32(0x5a530000), SPH_C32(0x93250023),
    SPH_C32(0xc0120800), SPH_C32(0x2ea74510), SPH_C32(0x86797460),
    SPH_C32(0x41dae8c9), SPH_C32(0x37273d09), SPH_C32(0x19f80000),
    SPH_C32(0xee7e0000), SPH_C32(0x573d002e), SPH_C32(0x00289000),
    SPH_C32(0x51e26c4c), SPH_C32(0xc9d19cf4), SPH_C32(0xf2674dd9),
    SPH_C32(0x723da496) },
  { SPH_C32(0x9e000000), SPH_C32(0xef850000), SPH_C32(0x49ca0022),
    SPH_C32(0x41a91800), SPH_C32(0x456e61ac), SPH_C32(0xdc5695f4),
    SPH_C32(0xdd5730db), SPH_C32(0x20d35651), SPH_C32(0xcd810000),
    SPH_C32(0xb4980000), SPH_C32(0x4f71002f), SPH_C32(0x92442000),
    SPH_C32(0x33a47583), SPH_C32(0xd07a116a), SPH_C32(0x85448a2a),
    SPH_C32(0xc2213b83) },
  { SPH_C32(0x0c560000), SPH_C32(0xf15f0000), SPH_C32(0xa39b0022),
    SPH_C32(0xa9182800), SPH_C32(0xec5b3709), SPH_C32(0x37adf46d),
    SPH_C32(0x6c0b128f), SPH_C32(0x1316721e), SPH_C32(0x41bb0000),
    SPH_C32(0x6e000000), SPH_C32(0x2f0e002f), SPH_C32(0xc643a800),
    SPH_C32(0xb6d53090), SPH_C32(0xb07ca329), SPH_C32(0x5e14b3b6),
    SPH_C32(0x4879dd27) },
  { SPH_C32(0xc6430000), SPH_C32(0x6ffb0000), SPH_C32(0x31f90023),
    SPH_C32(0x87c22000), SPH_C32(0xa2593d70), SPH_C32(0xa5fbaa29),
    SPH_C32(0x7124ceb4), SPH_C32(0x1a972fe0), SPH_C32(0xd0db0000),
    SPH_C32(0x9fea0000), SPH_C32(0x07fc002f), SPH_C32(0x3d253800),
    SPH_C32(0x166f5b46), SPH_C32(0x1803aeba), SPH_C32(0x04e68e03),
    SPH_C32(0xdc540d25) },
  { SPH_C32(0x54150000), SPH_C32(0x71210000), SPH_C32(0xdba80023),
    SPH_C32(0x6f731000), SPH_C32(0x0b6c6bd5), SPH_C32(0x4e00cbb0),
    SPH_C32(0xc078ece0), SPH_C32(0x29520baf), SPH_C32(0x5ce10000),
    SPH_C32(0x45720000), SPH_C32(0x6783002f), SPH_C32(0x6922b000),
    SPH_C32(0x931e1e55), SPH_C32(0x78051cf9), SPH_C32(0xdfb6b79f),
    SPH_C32(0x560ceb81) },
  { SPH_C32(0x26610000), SPH_C32(0xd0d10000), SPH_C32(0x4f77003c),
    SPH_C32(0x92660000), SPH_C32(0xef3b42bc), SPH_C32(0x6cf08019),
    SPH_C32(0xabc45c2a), SPH_C32(0x35bd29b1), SPH_C32(0x8f750000),
    SPH_C32(0xadc40000), SPH_C32(0xf8bb0024), SPH_C32(0x6c430000),
    SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3), SPH_C32(0x5ced124e),
    SPH_C32(0x7665c55a) },
  { SPH_C32(0xb4370000), SPH_C32(0xce0b0000), SPH_C32(0xa526003c),
    SPH_C32(0x7ad73000), SPH_C32(0x460e1419), SPH_C32(0x870be180),
    SPH_C32(0x1a987e7e), SPH_C32(0x06780dfe), SPH_C32(0x034f0000),
    SPH_C32(0x775c0000), SPH_C32(0x98c40024), SPH_C32(0x38448800),
    SPH_C32(0x375b6127), SPH_C32(0x496f4d80), SPH_C32(0x87bd2bd2),
    SPH_C32(0xfc3d23fe) },
  { SPH_C32(0x7e220000), SPH_C32(0x50af0000), SPH_C32(0x3744003d),
    SPH_C32(0x540d3800), SPH_C32(0x080c1e60), SPH_C32(0x155dbfc4),
    SPH_C32(0x07b7a245), SPH_C32(0x0ff95000), SPH_C32(0x922f0000),
    SPH_C32(0x86b60000), SPH_C32(0xb0360024), SPH_C32(0xc3221800),
    SPH_C32(0x97e10af1), SPH_C32(0xe1104013), SPH_C32(0xdd4f1667),
    SPH_C32(0x6810f3fc) },
  { SPH_C32(0xec740000), SPH_C32(0x4e750000), SPH_C32(0xdd15003d),
    SPH_C32(0xbcbc0800), SPH_C32(0xa13948c5), SPH_C32(0xfea6de5d),
    SPH_C32(0xb6eb8011), SPH_C32(0x3c3c744f), SPH_C32(0x1e150000),
    SPH_C32(0x5c2e0000), SPH_C32(0xd0490024), SPH_C32(0x97259000),
    SPH_C32(0x12904fe2), SPH_C32(0x8116f250), SPH_C32(0x061f2ffb),
    SPH_C32(0xe2481558) },
  { SPH_C32(0x3b3b0000), SPH_C32(0xfba30000), SPH_C32(0x07fa003c),
    SPH_C32(0x3d071800), SPH_C32(0xcaf06c79), SPH_C32(0xa4893fc9),
    SPH_C32(0x2a665803), SPH_C32(0x2bc81f17), SPH_C32(0xca6c0000),
    SPH_C32(0x06c80000), SPH_C32(0xc8050025), SPH_C32(0x05492000),
    SPH_C32(0x70d6562d), SPH_C32(0x98bd7fce), SPH_C32(0x713ce808),
    SPH_C32(0x52548a4d) },
  { SPH_C32(0xa96d0000), SPH_C32(0xe5790000), SPH_C32(0xedab003c),
    SPH_C32(0xd5b62800), SPH_C32(0x63c53adc), SPH_C32(0x4f725e50),
    SPH_C32(0x9b3a7a57), SPH_C32(0x180d3b58), SPH_C32(0x46560000),
    SPH_C32(0xdc500000), SPH_C32(0xa87a0025), SPH_C32(0x514ea800),
    SPH_C32(0xf5a7133e), SPH_C32(0xf8bbcd8d), SPH_C32(0xaa6cd194),
    SPH_C32(0xd80c6ce9) },
  { SPH_C32(0x63780000), SPH_C32(0x7bdd0000), SPH_C32(0x7fc9003d),
    SPH_C32(0xfb6c2000), SPH_C32(0x2dc730a5), SPH_C32(0xdd240014),
    SPH_C32(0x8615a66c), SPH_C32(0x118c66a6), SPH_C32(0xd7360000),
    SPH_C32(0x2dba0000), SPH_C32(0x80880025), SPH_C32(0xaa283800),
    SPH_C32(0x551d78e8), SPH_C32(0x50c4c01e), SPH_C32(0xf09eec21),
    SPH_C32(0x4c21bceb) },
  { SPH_C32(0xf12e0000), SPH_C32(0x65070000), SPH_C32(0x9598003d),
    SPH_C32(0x13dd1000), SPH_C32(0x84f26600), SPH_C32(0x36df618d),
    SPH_C32(0x37498438), SPH_C32(0x224942e9), SPH_C32(0x5b0c0000),
    SPH_C32(0xf7220000), SPH_C32(0xe0f70025), SPH_C32(0xfe2fb000),
    SPH_C32(0xd06c3dfb), SPH_C32(0x30c2725d), SPH_C32(0x2bced5bd),
    SPH_C32(0xc6795a4f) },
  { SPH_C32(0x84b70000), SPH_C32(0x76a70000), SPH_C32(0x86330028),
    SPH_C32(0x79c50000), SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480),
    SPH_C32(0xa88d56d0), SPH_C32(0xaed3d139), SPH_C32(0x2a4e0000),
    SPH_C32(0xb9e20000), SPH_C32(0xb68b003a), SPH_C32(0x10ed0000),
    SPH_C32(0x3db429e1), SPH_C32(0x51b655fe), SPH_C32(0xabdc7a96),
    SPH_C32(0x7d7e8c1c) },
  { SPH_C32(0x16e10000), SPH_C32(0x687d0000), SPH_C32(0x6c620028),
    SPH_C32(0x91743000), SPH_C32(0x8ae23a62), SPH_C32(0xb7132519),
    SPH_C32(0x19d17484), SPH_C32(0x9d16f576), SPH_C32(0xa6740000),
    SPH_C32(0x637a0000), SPH_C32(0xd6f4003a), SPH_C32(0x44ea8800),
    SPH_C32(0xb8c56cf2), SPH_C32(0x31b0e7bd), SPH_C32(0x708c430a),
    SPH_C32(0xf7266ab8) },
  { SPH_C32(0xdcf40000), SPH_C32(0xf6d90000), SPH_C32(0xfe000029),
    SPH_C32(0xbfae3800), SPH_C32(0xc4e0301b), SPH_C32(0x25457b5d),
    SPH_C32(0x04fea8bf), SPH_C32(0x9497a888), SPH_C32(0x37140000),
    SPH_C32(0x92900000), SPH_C32(0xfe06003a), SPH_C32(0xbf8c1800),
    SPH_C32(0x187f0724), SPH_C32(0x99cfea2e), SPH_C32(0x2a7e7ebf),
    SPH_C32(0x630bbaba) },
  { SPH_C32(0x4ea20000), SPH_C32(0xe8030000), SPH_C32(0x14510029),
    SPH_C32(0x571f0800), SPH_C32(0x6dd566be), SPH_C32(0xcebe1ac4),
    SPH_C32(0xb5a28aeb), SPH_C32(0xa7528cc7), SPH_C32(0xbb2e0000),
    SPH_C32(0x48080000), SPH_C32(0x9e79003a), SPH_C32(0xeb8b9000),
    SPH_C32(0x9d0e4237), SPH_C32(0xf9c9586d), SPH_C32(0xf12e4723),
    SPH_C32(0xe9535c1e) },
  { SPH_C32(0x99ed0000), SPH_C32(0x5dd50000), SPH_C32(0xcebe0028),
    SPH_C32(0xd6a41800), SPH_C32(0x061c4202), SPH_C32(0x9491fb50),
    SPH_C32(0x292f52f9), SPH_C32(0xb0a6e79f), SPH_C32(0x6f570000),
    SPH_C32(0x12ee0000), SPH_C32(0x8635003b), SPH_C32(0x79e72000),
    SPH_C32(0xff485bf8), SPH_C32(0xe062d5f3), SPH_C32(0x860d80d0),
    SPH_C32(0x594fc30b) },
  { SPH_C32(0x0bbb0000), SPH_C32(0x430f0000), SPH_C32(0x24ef0028),
    SPH_C32(0x3e152800), SPH_C32(0xaf2914a7), SPH_C32(0x7f6a9ac9),
    SPH_C32(0x987370ad), SPH_C32(0x8363c3d0), SPH_C32(0xe36d0000),
    SPH_C32(0xc8760000), SPH_C32(0xe64a003b), SPH_C32(0x2de0a800),
    SPH_C32(0x7a391eeb), SPH_C32(0x806467b0), SPH_C32(0x5d5db94c),
    SPH_C32(0xd31725af) },
  { SPH_C32(0xc1ae0000), SPH_C32(0xddab0000), SPH_C32(0xb68d0029),
    SPH_C32(0x10cf2000), SPH_C32(0xe12b1ede), SPH_C32(0xed3cc48d),
    SPH_C32(0x855cac96), SPH_C32(0x8ae29e2e), SPH_C32(0x720d0000),
    SPH_C32(0x399c0000), SPH_C32(0xceb8003b), SPH_C32(0xd6863800),
    SPH_C32(0xda83753d), SPH_C32(0x281b6a23), SPH_C32(0x07af84f9),
    SPH_C32(0x473af5ad) },
  { SPH_C32(0x53f80000), SPH_C32(0xc3710000), SPH_C32(0x5cdc0029),
    SPH_C32(0xf87e1000), SPH_C32(0x481e487b), SPH_C32(0x06c7a514),
    SPH_C32(0x34008ec2), SPH_C32(0xb927ba61), SPH_C32(0xfe370000),
    SPH_C32(0xe3040000), SPH_C32(0xaec7003b), SPH_C32(0x8281b000),
    SPH_C32(0x5ff2302e), SPH_C32(0x481dd860), SPH_C32(0xdcffbd65),
    SPH_C32(0xcd621309) },
  { SPH_C32(0x218c0000), SPH_C32(0x62810000), SPH_C32(0xc8030036),
    SPH_C32(0x056b0000), SPH_C32(0xac496112), SPH_C32(0x2437eebd),
    SPH_C32(0x5fbc3e08), SPH_C32(0xa5c8987f), SPH_C32(0x2da30000),
    SPH_C32(0x0bb20000), SPH_C32(0x31ff0030), SPH_C32(0x87e00000),
    SPH_C32(0x7ec60a4f), SPH_C32(0x19713b5a), SPH_C32(0x5fa418b4),
    SPH_C32(0xed0b3dd2) },
  { SPH_C32(0xb3da0000), SPH_C32(0x7c5b0000), SPH_C32(0x22520036),
    SPH_C32(0xedda3000), SPH_C32(0x057c37b7), SPH_C32(0xcfcc8f24),
    SPH_C32(0xeee01c5c), SPH_C32(0x960dbc30), SPH_C32(0xa1990000),
    SPH_C32(0xd12a0000), SPH_C32(0x51800030), SPH_C32(0xd3e78800),
    SPH_C32(0xfbb74f5c), SPH_C32(0x79778919), SPH_C32(0x84f42128),
    SPH_C32(0x6753db76) },
  { SPH_C32(0x79cf0000), SPH_C32(0xe2ff0000), SPH_C32(0xb0300037),
    SPH_C32(0xc3003800), SPH_C32(0x4b7e3dce), SPH_C32(0x5d9ad160),
    SPH_C32(0xf3cfc067), SPH_C32(0x9f8ce1ce), SPH_C32(0x30f90000),
    SPH_C32(0x20c00000), SPH_C32(0x79720030), SPH_C32(0x28811800),
    SPH_C32(0x5b0d248a), SPH_C32(0xd108848a), SPH_C32(0xde061c9d),
    SPH_C32(0xf37e0b74) },
  { SPH_C32(0xeb990000), SPH_C32(0xfc250000), SPH_C32(0x5a610037),
    SPH_C32(0x2bb10800), SPH_C32(0xe24b6b6b), SPH_C32(0xb661b0f9),
    SPH_C32(0x4293e233), SPH_C32(0xac49c581), SPH_C32(0xbcc30000),
    SPH_C32(0xfa580000), SPH_C32(0x190d0030), SPH_C32(0x7c869000),
    SPH_C32(0xde7c6199), SPH_C32(0xb10e36c9), SPH_C32(0x05562501),
    SPH_C32(0x7926edd0) },
  { SPH_C32(0x3cd60000), SPH_C32(0x49f30000), SPH_C32(0x808e0036),
    SPH_C32(0xaa0a1800), SPH_C32(0x89824fd7), SPH_C32(0xec4e516d),
    SPH_C32(0xde1e3a21), SPH_C32(0xbbbdaed9), SPH_C32(0x68ba0000),
    SPH_C32(0xa0be0000), SPH_C32(0x01410031), SPH_C32(0xeeea2000),
    SPH_C32(0xbc3a7856), SPH_C32(0xa8a5bb57), SPH_C32(0x7275e2f2),
    SPH_C32(0xc93a72c5) },
  { SPH_C32(0xae800000), SPH_C32(0x57290000), SPH_C32(0x6adf0036),
    SPH_C32(0x42bb2800), SPH_C32(0x20b71972), SPH_C32(0x07b530f4),
    SPH_C32(0x6f421875), SPH_C32(0x88788a96), SPH_C32(0xe4800000),
    SPH_C32(0x7a260000), SPH_C32(0x613e0031), SPH_C32(0xbaeda800),
    SPH_C32(0x394b3d45), SPH_C32(0xc8a30914), SPH_C32(0xa925db6e),
    SPH_C32(0x43629461) },
  { SPH_C32(0x64950000), SPH_C32(0xc98d0000), SPH_C32(0xf8bd0037),
    SPH_C32(0x6c612000), SPH_C32(0x6eb5130b), SPH_C32(0x95e36eb0),
    SPH_C32(0x726dc44e), SPH_C32(0x81f9d768), SPH_C32(0x75e00000),
    SPH_C32(0x8bcc0000), SPH_C32(0x49cc0031), SPH_C32(0x418b3800),
    SPH_C32(0x99f15693), SPH_C32(0x60dc0487), SPH_C32(0xf3d7e6db),
    SPH_C32(0xd74f4463) },
  { SPH_C32(0xf6c30000), SPH_C32(0xd7570000), SPH_C32(0x12ec0037),
    SPH_C32(0x84d01000), SPH_C32(0xc78045ae), SPH_C32(0x7e180f29),
    SPH_C32(0xc331e61a), SPH_C32(0xb23cf327), SPH_C32(0xf9da0000),
    SPH_C32(0x51540000), SPH_C32(0x29b30031), SPH_C32(0x158cb000),
    SPH_C32(0x1c801380), SPH_C32(0x00dab6c4), SPH_C32(0x2887df47),
    SPH_C32(0x5d17a2c7) }
};

__constant static const sph_u32 T512_49[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0x16ed0000), SPH_C32(0x15680000), SPH_C32(0xedd70000),
    SPH_C32(0x325d0220), SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643),
    SPH_C32(0xe375f8a8), SPH_C32(0x81fdf908), SPH_C32(0xe6280000),
    SPH_C32(0x4c4b0000), SPH_C32(0xa8550000), SPH_C32(0xd3d002e0),
    SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da), SPH_C32(0x289506b4),
    SPH_C32(0xd75a4897) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0x52190000), SPH_C32(0x3b780000), SPH_C32(0x19080000),
    SPH_C32(0xac000600), SPH_C32(0xa0c35180), SPH_C32(0x49b17387),
    SPH_C32(0xfac3d23d), SPH_C32(0x99353c49), SPH_C32(0x13c30000),
    SPH_C32(0xe4e20000), SPH_C32(0xc2910000), SPH_C32(0x5e7f00a0),
    SPH_C32(0x15d70c2b), SPH_C32(0x4f5861c8), SPH_C32(0xb825551a),
    SPH_C32(0x0d71a4a6) },
  { SPH_C32(0x44f40000), SPH_C32(0x2e100000), SPH_C32(0xf4df0000),
    SPH_C32(0x9e5d0420), SPH_C32(0x43cf6709), SPH_C32(0x13fb95c4),
    SPH_C32(0x19b62a95), SPH_C32(0x18c8c541), SPH_C32(0xf5eb0000),
    SPH_C32(0xa8a90000), SPH_C32(0x6ac40000), SPH_C32(0x8daf0240),
    SPH_C32(0xcdb63c93), SPH_C32(0xd7ffd112), SPH_C32(0x90b053ae),
    SPH_C32(0xda2bec31) },
  { SPH_C32(0xa2dc0000), SPH_C32(0x625b0000), SPH_C32(0x5c8a0000),
    SPH_C32(0x4d8d06c0), SPH_C32(0x9bae57b1), SPH_C32(0x8b5c251e),
    SPH_C32(0x31232c21), SPH_C32(0xcf928dd6), SPH_C32(0x052e0000),
    SPH_C32(0xf18a0000), SPH_C32(0x2f460000), SPH_C32(0x6c220280),
    SPH_C32(0xf6db3aa2), SPH_C32(0x1512878b), SPH_C32(0x5b50adb2),
    SPH_C32(0x8c8c5dae) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x052e0000), SPH_C32(0xf18a0000), SPH_C32(0x2f460000),
    SPH_C32(0x6c220280), SPH_C32(0xf6db3aa2), SPH_C32(0x1512878b),
    SPH_C32(0x5b50adb2), SPH_C32(0x8c8c5dae), SPH_C32(0xa7f20000),
    SPH_C32(0x93d10000), SPH_C32(0x73cc0000), SPH_C32(0x21af0440),
    SPH_C32(0x6d756d13), SPH_C32(0x9e4ea295), SPH_C32(0x6a738193),
    SPH_C32(0x431ed078) },
  { SPH_C32(0x13c30000), SPH_C32(0xe4e20000), SPH_C32(0xc2910000),
    SPH_C32(0x5e7f00a0), SPH_C32(0x15d70c2b), SPH_C32(0x4f5861c8),
    SPH_C32(0xb825551a), SPH_C32(0x0d71a4a6), SPH_C32(0x41da0000),
    SPH_C32(0xdf9a0000), SPH_C32(0xdb990000), SPH_C32(0xf27f06a0),
    SPH_C32(0xb5145dab), SPH_C32(0x06e9124f), SPH_C32(0x42e68727),
    SPH_C32(0x944498ef) },
  { SPH_C32(0xf5eb0000), SPH_C32(0xa8a90000), SPH_C32(0x6ac40000),
    SPH_C32(0x8daf0240), SPH_C32(0xcdb63c93), SPH_C32(0xd7ffd112),
    SPH_C32(0x90b053ae), SPH_C32(0xda2bec31), SPH_C32(0xb11f0000),
    SPH_C32(0x86b90000), SPH_C32(0x9e1b0000), SPH_C32(0x13f20660),
    SPH_C32(0x8e795b9a), SPH_C32(0xc40444d6), SPH_C32(0x8906793b),
    SPH_C32(0xc2e32970) },
  { SPH_C32(0x57370000), SPH_C32(0xcaf20000), SPH_C32(0x364e0000),
    SPH_C32(0xc0220480), SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c),
    SPH_C32(0xa1937f8f), SPH_C32(0x15b961e7), SPH_C32(0xb4310000),
    SPH_C32(0x77330000), SPH_C32(0xb15d0000), SPH_C32(0x7fd004e0),
    SPH_C32(0x78a26138), SPH_C32(0xd116c35d), SPH_C32(0xd256d489),
    SPH_C32(0x4e6f74de) },
  { SPH_C32(0xb11f0000), SPH_C32(0x86b90000), SPH_C32(0x9e1b0000),
    SPH_C32(0x13f20660), SPH_C32(0x8e795b9a), SPH_C32(0xc40444d6),
    SPH_C32(0x8906793b), SPH_C32(0xc2e32970), SPH_C32(0x44f40000),
    SPH_C32(0x2e100000), SPH_C32(0xf4df0000), SPH_C32(0x9e5d0420),
    SPH_C32(0x43cf6709), SPH_C32(0x13fb95c4), SPH_C32(0x19b62a95),
    SPH_C32(0x18c8c541) },
  { SPH_C32(0xa7f20000), SPH_C32(0x93d10000), SPH_C32(0x73cc0000),
    SPH_C32(0x21af0440), SPH_C32(0x6d756d13), SPH_C32(0x9e4ea295),
    SPH_C32(0x6a738193), SPH_C32(0x431ed078), SPH_C32(0xa2dc0000),
    SPH_C32(0x625b0000), SPH_C32(0x5c8a0000), SPH_C32(0x4d8d06c0),
    SPH_C32(0x9bae57b1), SPH_C32(0x8b5c251e), SPH_C32(0x31232c21),
    SPH_C32(0xcf928dd6) },
  { SPH_C32(0x41da0000), SPH_C32(0xdf9a0000), SPH_C32(0xdb990000),
    SPH_C32(0xf27f06a0), SPH_C32(0xb5145dab), SPH_C32(0x06e9124f),
    SPH_C32(0x42e68727), SPH_C32(0x944498ef), SPH_C32(0x52190000),
    SPH_C32(0x3b780000), SPH_C32(0x19080000), SPH_C32(0xac000600),
    SPH_C32(0xa0c35180), SPH_C32(0x49b17387), SPH_C32(0xfac3d23d),
    SPH_C32(0x99353c49) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xe4da0000), SPH_C32(0xeeca0000), SPH_C32(0x2f6a0000),
    SPH_C32(0x30bc7ae0), SPH_C32(0xc67c4457), SPH_C32(0x9f9a9b0c),
    SPH_C32(0xec573483), SPH_C32(0xa8686d09), SPH_C32(0x4a180000),
    SPH_C32(0x4a8e0000), SPH_C32(0xf2650000), SPH_C32(0x16a528c0),
    SPH_C32(0xe428127c), SPH_C32(0xf4f795a3), SPH_C32(0x21ba7308),
    SPH_C32(0x7c8ba96f) },
  { SPH_C32(0xf2370000), SPH_C32(0xfba20000), SPH_C32(0xc2bd0000),
    SPH_C32(0x02e178c0), SPH_C32(0x257072de), SPH_C32(0xc5d07d4f),
    SPH_C32(0x0f22cc2b), SPH_C32(0x29959401), SPH_C32(0xac300000),
    SPH_C32(0x06c50000), SPH_C32(0x5a300000), SPH_C32(0xc5752a20),
    SPH_C32(0x3c4922c4), SPH_C32(0x6c502579), SPH_C32(0x092f75bc),
    SPH_C32(0xabd1e1f8) },
  { SPH_C32(0x141f0000), SPH_C32(0xb7e90000), SPH_C32(0x6ae80000),
    SPH_C32(0xd1317a20), SPH_C32(0xfd114266), SPH_C32(0x5d77cd95),
    SPH_C32(0x27b7ca9f), SPH_C32(0xfecfdc96), SPH_C32(0x5cf50000),
    SPH_C32(0x5fe60000), SPH_C32(0x1fb20000), SPH_C32(0x24f82ae0),
    SPH_C32(0x072424f5), SPH_C32(0xaebd73e0), SPH_C32(0xc2cf8ba0),
    SPH_C32(0xfd765067) },
  { SPH_C32(0xb6c30000), SPH_C32(0xd5b20000), SPH_C32(0x36620000),
    SPH_C32(0x9cbc7ce0), SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b),
    SPH_C32(0x1694e6be), SPH_C32(0x315d5140), SPH_C32(0x59db0000),
    SPH_C32(0xae6c0000), SPH_C32(0x30f40000), SPH_C32(0x48da2860),
    SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b), SPH_C32(0x999f2612),
    SPH_C32(0x71fa0dc9) },
  { SPH_C32(0x50eb0000), SPH_C32(0x99f90000), SPH_C32(0x9e370000),
    SPH_C32(0x4f6c7e00), SPH_C32(0xbede256f), SPH_C32(0x4e8c5851),
    SPH_C32(0x3e01e00a), SPH_C32(0xe60719d7), SPH_C32(0xa91e0000),
    SPH_C32(0xf74f0000), SPH_C32(0x75760000), SPH_C32(0xa95728a0),
    SPH_C32(0xca921866), SPH_C32(0x7942a2f2), SPH_C32(0x527fd80e),
    SPH_C32(0x275dbc56) },
  { SPH_C32(0x46060000), SPH_C32(0x8c910000), SPH_C32(0x73e00000),
    SPH_C32(0x7d317c20), SPH_C32(0x5dd213e6), SPH_C32(0x14c6be12),
    SPH_C32(0xdd7418a2), SPH_C32(0x67fae0df), SPH_C32(0x4f360000),
    SPH_C32(0xbb040000), SPH_C32(0xdd230000), SPH_C32(0x7a872a40),
    SPH_C32(0x12f328de), SPH_C32(0xe1e51228), SPH_C32(0x7aeadeba),
    SPH_C32(0xf007f4c1) },
  { SPH_C32(0xa02e0000), SPH_C32(0xc0da0000), SPH_C32(0xdbb50000),
    SPH_C32(0xaee17ec0), SPH_C32(0x85b3235e), SPH_C32(0x8c610ec8),
    SPH_C32(0xf5e11e16), SPH_C32(0xb0a0a848), SPH_C32(0xbff30000),
    SPH_C32(0xe2270000), SPH_C32(0x98a10000), SPH_C32(0x9b0a2a80),
    SPH_C32(0x299e2eef), SPH_C32(0x230844b1), SPH_C32(0xb10a20a6),
    SPH_C32(0xa6a0455e) },
  { SPH_C32(0xe1f40000), SPH_C32(0x1f400000), SPH_C32(0x002c0000),
    SPH_C32(0x5c9e7860), SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87),
    SPH_C32(0xb7079931), SPH_C32(0x24e430a7), SPH_C32(0xedea0000),
    SPH_C32(0xd95f0000), SPH_C32(0x81a90000), SPH_C32(0x370a2c80),
    SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736), SPH_C32(0x4bc9f29b),
    SPH_C32(0x3f957917) },
  { SPH_C32(0x07dc0000), SPH_C32(0x530b0000), SPH_C32(0xa8790000),
    SPH_C32(0x8f4e7a80), SPH_C32(0xe8c64e4d), SPH_C32(0x122fac5d),
    SPH_C32(0x9f929f85), SPH_C32(0xf3be7830), SPH_C32(0x1d2f0000),
    SPH_C32(0x807c0000), SPH_C32(0xc42b0000), SPH_C32(0xd6872c40),
    SPH_C32(0xb230795e), SPH_C32(0xa85461af), SPH_C32(0x80290c87),
    SPH_C32(0x6932c888) },
  { SPH_C32(0x11310000), SPH_C32(0x46630000), SPH_C32(0x45ae0000),
    SPH_C32(0xbd1378a0), SPH_C32(0x0bca78c4), SPH_C32(0x48654a1e),
    SPH_C32(0x7ce7672d), SPH_C32(0x72438138), SPH_C32(0xfb070000),
    SPH_C32(0xcc370000), SPH_C32(0x6c7e0000), SPH_C32(0x05572ea0),
    SPH_C32(0x6a5149e6), SPH_C32(0x30f3d175), SPH_C32(0xa8bc0a33),
    SPH_C32(0xbe68801f) },
  { SPH_C32(0xf7190000), SPH_C32(0x0a280000), SPH_C32(0xedfb0000),
    SPH_C32(0x6ec37a40), SPH_C32(0xd3ab487c), SPH_C32(0xd0c2fac4),
    SPH_C32(0x54726199), SPH_C32(0xa519c9af), SPH_C32(0x0bc20000),
    SPH_C32(0x95140000), SPH_C32(0x29fc0000), SPH_C32(0xe4da2e60),
    SPH_C32(0x513c4fd7), SPH_C32(0xf21e87ec), SPH_C32(0x635cf42f),
    SPH_C32(0xe8cf3180) },
  { SPH_C32(0x55c50000), SPH_C32(0x68730000), SPH_C32(0xb1710000),
    SPH_C32(0x234e7c80), SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda),
    SPH_C32(0x65514db8), SPH_C32(0x6a8b4479), SPH_C32(0x0eec0000),
    SPH_C32(0x649e0000), SPH_C32(0x06ba0000), SPH_C32(0x88f82ce0),
    SPH_C32(0xa7e77575), SPH_C32(0xe70c0067), SPH_C32(0x380c599d),
    SPH_C32(0x64436c2e) },
  { SPH_C32(0xb3ed0000), SPH_C32(0x24380000), SPH_C32(0x19240000),
    SPH_C32(0xf09e7e60), SPH_C32(0x90642f75), SPH_C32(0xc3396f00),
    SPH_C32(0x4dc44b0c), SPH_C32(0xbdd10cee), SPH_C32(0xfe290000),
    SPH_C32(0x3dbd0000), SPH_C32(0x43380000), SPH_C32(0x69752c20),
    SPH_C32(0x9c8a7344), SPH_C32(0x25e156fe), SPH_C32(0xf3eca781),
    SPH_C32(0x32e4ddb1) },
  { SPH_C32(0xa5000000), SPH_C32(0x31500000), SPH_C32(0xf4f30000),
    SPH_C32(0xc2c37c40), SPH_C32(0x736819fc), SPH_C32(0x99738943),
    SPH_C32(0xaeb1b3a4), SPH_C32(0x3c2cf5e6), SPH_C32(0x18010000),
    SPH_C32(0x71f60000), SPH_C32(0xeb6d0000), SPH_C32(0xbaa52ec0),
    SPH_C32(0x44eb43fc), SPH_C32(0xbd46e624), SPH_C32(0xdb79a135),
    SPH_C32(0xe5be9526) },
  { SPH_C32(0x43280000), SPH_C32(0x7d1b0000), SPH_C32(0x5ca60000),
    SPH_C32(0x11137ea0), SPH_C32(0xab092944), SPH_C32(0x01d43999),
    SPH_C32(0x8624b510), SPH_C32(0xeb76bd71), SPH_C32(0xe8c40000),
    SPH_C32(0x28d50000), SPH_C32(0xaeef0000), SPH_C32(0x5b282e00),
    SPH_C32(0x7f8645cd), SPH_C32(0x7fabb0bd), SPH_C32(0x10995f29),
    SPH_C32(0xb31924b9) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0x5cf50000), SPH_C32(0x5fe60000), SPH_C32(0x1fb20000),
    SPH_C32(0x24f82ae0), SPH_C32(0x072424f5), SPH_C32(0xaebd73e0),
    SPH_C32(0xc2cf8ba0), SPH_C32(0xfd765067), SPH_C32(0x48ea0000),
    SPH_C32(0xe80f0000), SPH_C32(0x755a0000), SPH_C32(0xf5c950c0),
    SPH_C32(0xfa356693), SPH_C32(0xf3cabe75), SPH_C32(0xe578413f),
    SPH_C32(0x03b98cf1) },
  { SPH_C32(0x4a180000), SPH_C32(0x4a8e0000), SPH_C32(0xf2650000),
    SPH_C32(0x16a528c0), SPH_C32(0xe428127c), SPH_C32(0xf4f795a3),
    SPH_C32(0x21ba7308), SPH_C32(0x7c8ba96f), SPH_C32(0xaec20000),
    SPH_C32(0xa4440000), SPH_C32(0xdd0f0000), SPH_C32(0x26195220),
    SPH_C32(0x2254562b), SPH_C32(0x6b6d0eaf), SPH_C32(0xcded478b),
    SPH_C32(0xd4e3c466) },
  { SPH_C32(0xac300000), SPH_C32(0x06c50000), SPH_C32(0x5a300000),
    SPH_C32(0xc5752a20), SPH_C32(0x3c4922c4), SPH_C32(0x6c502579),
    SPH_C32(0x092f75bc), SPH_C32(0xabd1e1f8), SPH_C32(0x5e070000),
    SPH_C32(0xfd670000), SPH_C32(0x988d0000), SPH_C32(0xc79452e0),
    SPH_C32(0x1939501a), SPH_C32(0xa9805836), SPH_C32(0x060db997),
    SPH_C32(0x824475f9) },
  { SPH_C32(0x0eec0000), SPH_C32(0x649e0000), SPH_C32(0x06ba0000),
    SPH_C32(0x88f82ce0), SPH_C32(0xa7e77575), SPH_C32(0xe70c0067),
    SPH_C32(0x380c599d), SPH_C32(0x64436c2e), SPH_C32(0x5b290000),
    SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000), SPH_C32(0xabb65060),
    SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd), SPH_C32(0x5d5d1425),
    SPH_C32(0x0ec82857) },
  { SPH_C32(0xe8c40000), SPH_C32(0x28d50000), SPH_C32(0xaeef0000),
    SPH_C32(0x5b282e00), SPH_C32(0x7f8645cd), SPH_C32(0x7fabb0bd),
    SPH_C32(0x10995f29), SPH_C32(0xb31924b9), SPH_C32(0xabec0000),
    SPH_C32(0x55ce0000), SPH_C32(0xf2490000), SPH_C32(0x4a3b50a0),
    SPH_C32(0xd48f6c89), SPH_C32(0x7e7f8924), SPH_C32(0x96bdea39),
    SPH_C32(0x586f99c8) },
  { SPH_C32(0xfe290000), SPH_C32(0x3dbd0000), SPH_C32(0x43380000),
    SPH_C32(0x69752c20), SPH_C32(0x9c8a7344), SPH_C32(0x25e156fe),
    SPH_C32(0xf3eca781), SPH_C32(0x32e4ddb1), SPH_C32(0x4dc40000),
    SPH_C32(0x19850000), SPH_C32(0x5a1c0000), SPH_C32(0x99eb5240),
    SPH_C32(0x0cee5c31), SPH_C32(0xe6d839fe), SPH_C32(0xbe28ec8d),
    SPH_C32(0x8f35d15f) },
  { SPH_C32(0x18010000), SPH_C32(0x71f60000), SPH_C32(0xeb6d0000),
    SPH_C32(0xbaa52ec0), SPH_C32(0x44eb43fc), SPH_C32(0xbd46e624),
    SPH_C32(0xdb79a135), SPH_C32(0xe5be9526), SPH_C32(0xbd010000),
    SPH_C32(0x40a60000), SPH_C32(0x1f9e0000), SPH_C32(0x78665280),
    SPH_C32(0x37835a00), SPH_C32(0x24356f67), SPH_C32(0x75c81291),
    SPH_C32(0xd99260c0) },
  { SPH_C32(0x59db0000), SPH_C32(0xae6c0000), SPH_C32(0x30f40000),
    SPH_C32(0x48da2860), SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b),
    SPH_C32(0x999f2612), SPH_C32(0x71fa0dc9), SPH_C32(0xef180000),
    SPH_C32(0x7bde0000), SPH_C32(0x06960000), SPH_C32(0xd4665480),
    SPH_C32(0x97400b80), SPH_C32(0x6d841ce0), SPH_C32(0x8f0bc0ac),
    SPH_C32(0x40a75c89) },
  { SPH_C32(0xbff30000), SPH_C32(0xe2270000), SPH_C32(0x98a10000),
    SPH_C32(0x9b0a2a80), SPH_C32(0x299e2eef), SPH_C32(0x230844b1),
    SPH_C32(0xb10a20a6), SPH_C32(0xa6a0455e), SPH_C32(0x1fdd0000),
    SPH_C32(0x22fd0000), SPH_C32(0x43140000), SPH_C32(0x35eb5440),
    SPH_C32(0xac2d0db1), SPH_C32(0xaf694a79), SPH_C32(0x44eb3eb0),
    SPH_C32(0x1600ed16) },
  { SPH_C32(0xa91e0000), SPH_C32(0xf74f0000), SPH_C32(0x75760000),
    SPH_C32(0xa95728a0), SPH_C32(0xca921866), SPH_C32(0x7942a2f2),
    SPH_C32(0x527fd80e), SPH_C32(0x275dbc56), SPH_C32(0xf9f50000),
    SPH_C32(0x6eb60000), SPH_C32(0xeb410000), SPH_C32(0xe63b56a0),
    SPH_C32(0x744c3d09), SPH_C32(0x37cefaa3), SPH_C32(0x6c7e3804),
    SPH_C32(0xc15aa581) },
  { SPH_C32(0x4f360000), SPH_C32(0xbb040000), SPH_C32(0xdd230000),
    SPH_C32(0x7a872a40), SPH_C32(0x12f328de), SPH_C32(0xe1e51228),
    SPH_C32(0x7aeadeba), SPH_C32(0xf007f4c1), SPH_C32(0x09300000),
    SPH_C32(0x37950000), SPH_C32(0xaec30000), SPH_C32(0x07b65660),
    SPH_C32(0x4f213b38), SPH_C32(0xf523ac3a), SPH_C32(0xa79ec618),
    SPH_C32(0x97fd141e) },
  { SPH_C32(0xedea0000), SPH_C32(0xd95f0000), SPH_C32(0x81a90000),
    SPH_C32(0x370a2c80), SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736),
    SPH_C32(0x4bc9f29b), SPH_C32(0x3f957917), SPH_C32(0x0c1e0000),
    SPH_C32(0xc61f0000), SPH_C32(0x81850000), SPH_C32(0x6b9454e0),
    SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1), SPH_C32(0xfcce6baa),
    SPH_C32(0x1b7149b0) },
  { SPH_C32(0x0bc20000), SPH_C32(0x95140000), SPH_C32(0x29fc0000),
    SPH_C32(0xe4da2e60), SPH_C32(0x513c4fd7), SPH_C32(0xf21e87ec),
    SPH_C32(0x635cf42f), SPH_C32(0xe8cf3180), SPH_C32(0xfcdb0000),
    SPH_C32(0x9f3c0000), SPH_C32(0xc4070000), SPH_C32(0x8a195420),
    SPH_C32(0x829707ab), SPH_C32(0x22dc7d28), SPH_C32(0x372e95b6),
    SPH_C32(0x4dd6f82f) },
  { SPH_C32(0x1d2f0000), SPH_C32(0x807c0000), SPH_C32(0xc42b0000),
    SPH_C32(0xd6872c40), SPH_C32(0xb230795e), SPH_C32(0xa85461af),
    SPH_C32(0x80290c87), SPH_C32(0x6932c888), SPH_C32(0x1af30000),
    SPH_C32(0xd3770000), SPH_C32(0x6c520000), SPH_C32(0x59c956c0),
    SPH_C32(0x5af63713), SPH_C32(0xba7bcdf2), SPH_C32(0x1fbb9302),
    SPH_C32(0x9a8cb0b8) },
  { SPH_C32(0xfb070000), SPH_C32(0xcc370000), SPH_C32(0x6c7e0000),
    SPH_C32(0x05572ea0), SPH_C32(0x6a5149e6), SPH_C32(0x30f3d175),
    SPH_C32(0xa8bc0a33), SPH_C32(0xbe68801f), SPH_C32(0xea360000),
    SPH_C32(0x8a540000), SPH_C32(0x29d00000), SPH_C32(0xb8445600),
    SPH_C32(0x619b3122), SPH_C32(0x78969b6b), SPH_C32(0xd45b6d1e),
    SPH_C32(0xcc2b0127) },
  { SPH_C32(0xb82f0000), SPH_C32(0xb12c0000), SPH_C32(0x30d80000),
    SPH_C32(0x14445000), SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec),
    SPH_C32(0x2e98bf23), SPH_C32(0x551e3d6e), SPH_C32(0x02f20000),
    SPH_C32(0xa2810000), SPH_C32(0x873f0000), SPH_C32(0xe36c7800),
    SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6), SPH_C32(0xc4c23237),
    SPH_C32(0x7f32259e) },
  { SPH_C32(0x5e070000), SPH_C32(0xfd670000), SPH_C32(0x988d0000),
    SPH_C32(0xc79452e0), SPH_C32(0x1939501a), SPH_C32(0xa9805836),
    SPH_C32(0x060db997), SPH_C32(0x824475f9), SPH_C32(0xf2370000),
    SPH_C32(0xfba20000), SPH_C32(0xc2bd0000), SPH_C32(0x02e178c0),
    SPH_C32(0x257072de), SPH_C32(0xc5d07d4f), SPH_C32(0x0f22cc2b),
    SPH_C32(0x29959401) },
  { SPH_C32(0x48ea0000), SPH_C32(0xe80f0000), SPH_C32(0x755a0000),
    SPH_C32(0xf5c950c0), SPH_C32(0xfa356693), SPH_C32(0xf3cabe75),
    SPH_C32(0xe578413f), SPH_C32(0x03b98cf1), SPH_C32(0x141f0000),
    SPH_C32(0xb7e90000), SPH_C32(0x6ae80000), SPH_C32(0xd1317a20),
    SPH_C32(0xfd114266), SPH_C32(0x5d77cd95), SPH_C32(0x27b7ca9f),
    SPH_C32(0xfecfdc96) },
  { SPH_C32(0xaec20000), SPH_C32(0xa4440000), SPH_C32(0xdd0f0000),
    SPH_C32(0x26195220), SPH_C32(0x2254562b), SPH_C32(0x6b6d0eaf),
    SPH_C32(0xcded478b), SPH_C32(0xd4e3c466), SPH_C32(0xe4da0000),
    SPH_C32(0xeeca0000), SPH_C32(0x2f6a0000), SPH_C32(0x30bc7ae0),
    SPH_C32(0xc67c4457), SPH_C32(0x9f9a9b0c), SPH_C32(0xec573483),
    SPH_C32(0xa8686d09) },
  { SPH_C32(0x0c1e0000), SPH_C32(0xc61f0000), SPH_C32(0x81850000),
    SPH_C32(0x6b9454e0), SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1),
    SPH_C32(0xfcce6baa), SPH_C32(0x1b7149b0), SPH_C32(0xe1f40000),
    SPH_C32(0x1f400000), SPH_C32(0x002c0000), SPH_C32(0x5c9e7860),
    SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87), SPH_C32(0xb7079931),
    SPH_C32(0x24e430a7) },
  { SPH_C32(0xea360000), SPH_C32(0x8a540000), SPH_C32(0x29d00000),
    SPH_C32(0xb8445600), SPH_C32(0x619b3122), SPH_C32(0x78969b6b),
    SPH_C32(0xd45b6d1e), SPH_C32(0xcc2b0127), SPH_C32(0x11310000),
    SPH_C32(0x46630000), SPH_C32(0x45ae0000), SPH_C32(0xbd1378a0),
    SPH_C32(0x0bca78c4), SPH_C32(0x48654a1e), SPH_C32(0x7ce7672d),
    SPH_C32(0x72438138) },
  { SPH_C32(0xfcdb0000), SPH_C32(0x9f3c0000), SPH_C32(0xc4070000),
    SPH_C32(0x8a195420), SPH_C32(0x829707ab), SPH_C32(0x22dc7d28),
    SPH_C32(0x372e95b6), SPH_C32(0x4dd6f82f), SPH_C32(0xf7190000),
    SPH_C32(0x0a280000), SPH_C32(0xedfb0000), SPH_C32(0x6ec37a40),
    SPH_C32(0xd3ab487c), SPH_C32(0xd0c2fac4), SPH_C32(0x54726199),
    SPH_C32(0xa519c9af) },
  { SPH_C32(0x1af30000), SPH_C32(0xd3770000), SPH_C32(0x6c520000),
    SPH_C32(0x59c956c0), SPH_C32(0x5af63713), SPH_C32(0xba7bcdf2),
    SPH_C32(0x1fbb9302), SPH_C32(0x9a8cb0b8), SPH_C32(0x07dc0000),
    SPH_C32(0x530b0000), SPH_C32(0xa8790000), SPH_C32(0x8f4e7a80),
    SPH_C32(0xe8c64e4d), SPH_C32(0x122fac5d), SPH_C32(0x9f929f85),
    SPH_C32(0xf3be7830) },
  { SPH_C32(0x5b290000), SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000),
    SPH_C32(0xabb65060), SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd),
    SPH_C32(0x5d5d1425), SPH_C32(0x0ec82857), SPH_C32(0x55c50000),
    SPH_C32(0x68730000), SPH_C32(0xb1710000), SPH_C32(0x234e7c80),
    SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda), SPH_C32(0x65514db8),
    SPH_C32(0x6a8b4479) },
  { SPH_C32(0xbd010000), SPH_C32(0x40a60000), SPH_C32(0x1f9e0000),
    SPH_C32(0x78665280), SPH_C32(0x37835a00), SPH_C32(0x24356f67),
    SPH_C32(0x75c81291), SPH_C32(0xd99260c0), SPH_C32(0xa5000000),
    SPH_C32(0x31500000), SPH_C32(0xf4f30000), SPH_C32(0xc2c37c40),
    SPH_C32(0x736819fc), SPH_C32(0x99738943), SPH_C32(0xaeb1b3a4),
    SPH_C32(0x3c2cf5e6) },
  { SPH_C32(0xabec0000), SPH_C32(0x55ce0000), SPH_C32(0xf2490000),
    SPH_C32(0x4a3b50a0), SPH_C32(0xd48f6c89), SPH_C32(0x7e7f8924),
    SPH_C32(0x96bdea39), SPH_C32(0x586f99c8), SPH_C32(0x43280000),
    SPH_C32(0x7d1b0000), SPH_C32(0x5ca60000), SPH_C32(0x11137ea0),
    SPH_C32(0xab092944), SPH_C32(0x01d43999), SPH_C32(0x8624b510),
    SPH_C32(0xeb76bd71) },
  { SPH_C32(0x4dc40000), SPH_C32(0x19850000), SPH_C32(0x5a1c0000),
    SPH_C32(0x99eb5240), SPH_C32(0x0cee5c31), SPH_C32(0xe6d839fe),
    SPH_C32(0xbe28ec8d), SPH_C32(0x8f35d15f), SPH_C32(0xb3ed0000),
    SPH_C32(0x24380000), SPH_C32(0x19240000), SPH_C32(0xf09e7e60),
    SPH_C32(0x90642f75), SPH_C32(0xc3396f00), SPH_C32(0x4dc44b0c),
    SPH_C32(0xbdd10cee) },
  { SPH_C32(0xef180000), SPH_C32(0x7bde0000), SPH_C32(0x06960000),
    SPH_C32(0xd4665480), SPH_C32(0x97400b80), SPH_C32(0x6d841ce0),
    SPH_C32(0x8f0bc0ac), SPH_C32(0x40a75c89), SPH_C32(0xb6c30000),
    SPH_C32(0xd5b20000), SPH_C32(0x36620000), SPH_C32(0x9cbc7ce0),
    SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b), SPH_C32(0x1694e6be),
    SPH_C32(0x315d5140) },
  { SPH_C32(0x09300000), SPH_C32(0x37950000), SPH_C32(0xaec30000),
    SPH_C32(0x07b65660), SPH_C32(0x4f213b38), SPH_C32(0xf523ac3a),
    SPH_C32(0xa79ec618), SPH_C32(0x97fd141e), SPH_C32(0x46060000),
    SPH_C32(0x8c910000), SPH_C32(0x73e00000), SPH_C32(0x7d317c20),
    SPH_C32(0x5dd213e6), SPH_C32(0x14c6be12), SPH_C32(0xdd7418a2),
    SPH_C32(0x67fae0df) },
  { SPH_C32(0x1fdd0000), SPH_C32(0x22fd0000), SPH_C32(0x43140000),
    SPH_C32(0x35eb5440), SPH_C32(0xac2d0db1), SPH_C32(0xaf694a79),
    SPH_C32(0x44eb3eb0), SPH_C32(0x1600ed16), SPH_C32(0xa02e0000),
    SPH_C32(0xc0da0000), SPH_C32(0xdbb50000), SPH_C32(0xaee17ec0),
    SPH_C32(0x85b3235e), SPH_C32(0x8c610ec8), SPH_C32(0xf5e11e16),
    SPH_C32(0xb0a0a848) },
  { SPH_C32(0xf9f50000), SPH_C32(0x6eb60000), SPH_C32(0xeb410000),
    SPH_C32(0xe63b56a0), SPH_C32(0x744c3d09), SPH_C32(0x37cefaa3),
    SPH_C32(0x6c7e3804), SPH_C32(0xc15aa581), SPH_C32(0x50eb0000),
    SPH_C32(0x99f90000), SPH_C32(0x9e370000), SPH_C32(0x4f6c7e00),
    SPH_C32(0xbede256f), SPH_C32(0x4e8c5851), SPH_C32(0x3e01e00a),
    SPH_C32(0xe60719d7) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0xf8440000), SPH_C32(0x88090000), SPH_C32(0x227b0000),
    SPH_C32(0x6f66bae0), SPH_C32(0xf425230e), SPH_C32(0x135a6300),
    SPH_C32(0x42991d7c), SPH_C32(0x6ec78a7c), SPH_C32(0x62930000),
    SPH_C32(0x47f90000), SPH_C32(0xafd30000), SPH_C32(0x093c30c0),
    SPH_C32(0x92585094), SPH_C32(0x29163700), SPH_C32(0x7abcdc48),
    SPH_C32(0x656295d0) },
  { SPH_C32(0xeea90000), SPH_C32(0x9d610000), SPH_C32(0xcfac0000),
    SPH_C32(0x5d3bb8c0), SPH_C32(0x17291587), SPH_C32(0x49108543),
    SPH_C32(0xa1ece5d4), SPH_C32(0xef3a7374), SPH_C32(0x84bb0000),
    SPH_C32(0x0bb20000), SPH_C32(0x07860000), SPH_C32(0xdaec3220),
    SPH_C32(0x4a39602c), SPH_C32(0xb1b187da), SPH_C32(0x5229dafc),
    SPH_C32(0xb238dd47) },
  { SPH_C32(0x08810000), SPH_C32(0xd12a0000), SPH_C32(0x67f90000),
    SPH_C32(0x8eebba20), SPH_C32(0xcf48253f), SPH_C32(0xd1b73599),
    SPH_C32(0x8979e360), SPH_C32(0x38603be3), SPH_C32(0x747e0000),
    SPH_C32(0x52910000), SPH_C32(0x42040000), SPH_C32(0x3b6132e0),
    SPH_C32(0x7154661d), SPH_C32(0x735cd143), SPH_C32(0x99c924e0),
    SPH_C32(0xe49f6cd8) },
  { SPH_C32(0xaa5d0000), SPH_C32(0xb3710000), SPH_C32(0x3b730000),
    SPH_C32(0xc366bce0), SPH_C32(0x54e6728e), SPH_C32(0x5aeb1087),
    SPH_C32(0xb85acf41), SPH_C32(0xf7f2b635), SPH_C32(0x71500000),
    SPH_C32(0xa31b0000), SPH_C32(0x6d420000), SPH_C32(0x57433060),
    SPH_C32(0x878f5cbf), SPH_C32(0x664e56c8), SPH_C32(0xc2998952),
    SPH_C32(0x68133176) },
  { SPH_C32(0x4c750000), SPH_C32(0xff3a0000), SPH_C32(0x93260000),
    SPH_C32(0x10b6be00), SPH_C32(0x8c874236), SPH_C32(0xc24ca05d),
    SPH_C32(0x90cfc9f5), SPH_C32(0x20a8fea2), SPH_C32(0x81950000),
    SPH_C32(0xfa380000), SPH_C32(0x28c00000), SPH_C32(0xb6ce30a0),
    SPH_C32(0xbce25a8e), SPH_C32(0xa4a30051), SPH_C32(0x0979774e),
    SPH_C32(0x3eb480e9) },
  { SPH_C32(0x5a980000), SPH_C32(0xea520000), SPH_C32(0x7ef10000),
    SPH_C32(0x22ebbc20), SPH_C32(0x6f8b74bf), SPH_C32(0x9806461e),
    SPH_C32(0x73ba315d), SPH_C32(0xa15507aa), SPH_C32(0x67bd0000),
    SPH_C32(0xb6730000), SPH_C32(0x80950000), SPH_C32(0x651e3240),
    SPH_C32(0x64836a36), SPH_C32(0x3c04b08b), SPH_C32(0x21ec71fa),
    SPH_C32(0xe9eec87e) },
  { SPH_C32(0xbcb00000), SPH_C32(0xa6190000), SPH_C32(0xd6a40000),
    SPH_C32(0xf13bbec0), SPH_C32(0xb7ea4407), SPH_C32(0x00a1f6c4),
    SPH_C32(0x5b2f37e9), SPH_C32(0x760f4f3d), SPH_C32(0x97780000),
    SPH_C32(0xef500000), SPH_C32(0xc5170000), SPH_C32(0x84933280),
    SPH_C32(0x5fee6c07), SPH_C32(0xfee9e612), SPH_C32(0xea0c8fe6),
    SPH_C32(0xbf4979e1) },
  { SPH_C32(0xfd6a0000), SPH_C32(0x79830000), SPH_C32(0x0d3d0000),
    SPH_C32(0x0344b860), SPH_C32(0x02fe19ac), SPH_C32(0x0648e48b),
    SPH_C32(0x19c9b0ce), SPH_C32(0xe24bd7d2), SPH_C32(0xc5610000),
    SPH_C32(0xd4280000), SPH_C32(0xdc1f0000), SPH_C32(0x28933480),
    SPH_C32(0xff2d3d87), SPH_C32(0xb7589595), SPH_C32(0x10cf5ddb),
    SPH_C32(0x267c45a8) },
  { SPH_C32(0x1b420000), SPH_C32(0x35c80000), SPH_C32(0xa5680000),
    SPH_C32(0xd094ba80), SPH_C32(0xda9f2914), SPH_C32(0x9eef5451),
    SPH_C32(0x315cb67a), SPH_C32(0x35119f45), SPH_C32(0x35a40000),
    SPH_C32(0x8d0b0000), SPH_C32(0x999d0000), SPH_C32(0xc91e3440),
    SPH_C32(0xc4403bb6), SPH_C32(0x75b5c30c), SPH_C32(0xdb2fa3c7),
    SPH_C32(0x70dbf437) },
  { SPH_C32(0x0daf0000), SPH_C32(0x20a00000), SPH_C32(0x48bf0000),
    SPH_C32(0xe2c9b8a0), SPH_C32(0x39931f9d), SPH_C32(0xc4a5b212),
    SPH_C32(0xd2294ed2), SPH_C32(0xb4ec664d), SPH_C32(0xd38c0000),
    SPH_C32(0xc1400000), SPH_C32(0x31c80000), SPH_C32(0x1ace36a0),
    SPH_C32(0x1c210b0e), SPH_C32(0xed1273d6), SPH_C32(0xf3baa573),
    SPH_C32(0xa781bca0) },
  { SPH_C32(0xeb870000), SPH_C32(0x6ceb0000), SPH_C32(0xe0ea0000),
    SPH_C32(0x3119ba40), SPH_C32(0xe1f22f25), SPH_C32(0x5c0202c8),
    SPH_C32(0xfabc4866), SPH_C32(0x63b62eda), SPH_C32(0x23490000),
    SPH_C32(0x98630000), SPH_C32(0x744a0000), SPH_C32(0xfb433660),
    SPH_C32(0x274c0d3f), SPH_C32(0x2fff254f), SPH_C32(0x385a5b6f),
    SPH_C32(0xf1260d3f) },
  { SPH_C32(0x495b0000), SPH_C32(0x0eb00000), SPH_C32(0xbc600000),
    SPH_C32(0x7c94bc80), SPH_C32(0x7a5c7894), SPH_C32(0xd75e27d6),
    SPH_C32(0xcb9f6447), SPH_C32(0xac24a30c), SPH_C32(0x26670000),
    SPH_C32(0x69e90000), SPH_C32(0x5b0c0000), SPH_C32(0x976134e0),
    SPH_C32(0xd197379d), SPH_C32(0x3aeda2c4), SPH_C32(0x630af6dd),
    SPH_C32(0x7daa5091) },
  { SPH_C32(0xaf730000), SPH_C32(0x42fb0000), SPH_C32(0x14350000),
    SPH_C32(0xaf44be60), SPH_C32(0xa23d482c), SPH_C32(0x4ff9970c),
    SPH_C32(0xe30a62f3), SPH_C32(0x7b7eeb9b), SPH_C32(0xd6a20000),
    SPH_C32(0x30ca0000), SPH_C32(0x1e8e0000), SPH_C32(0x76ec3420),
    SPH_C32(0xeafa31ac), SPH_C32(0xf800f45d), SPH_C32(0xa8ea08c1),
    SPH_C32(0x2b0de10e) },
  { SPH_C32(0xb99e0000), SPH_C32(0x57930000), SPH_C32(0xf9e20000),
    SPH_C32(0x9d19bc40), SPH_C32(0x41317ea5), SPH_C32(0x15b3714f),
    SPH_C32(0x007f9a5b), SPH_C32(0xfa831293), SPH_C32(0x308a0000),
    SPH_C32(0x7c810000), SPH_C32(0xb6db0000), SPH_C32(0xa53c36c0),
    SPH_C32(0x329b0114), SPH_C32(0x60a74487), SPH_C32(0x807f0e75),
    SPH_C32(0xfc57a999) },
  { SPH_C32(0x5fb60000), SPH_C32(0x1bd80000), SPH_C32(0x51b70000),
    SPH_C32(0x4ec9bea0), SPH_C32(0x99504e1d), SPH_C32(0x8d14c195),
    SPH_C32(0x28ea9cef), SPH_C32(0x2dd95a04), SPH_C32(0xc04f0000),
    SPH_C32(0x25a20000), SPH_C32(0xf3590000), SPH_C32(0x44b13600),
    SPH_C32(0x09f60725), SPH_C32(0xa24a121e), SPH_C32(0x4b9ff069),
    SPH_C32(0xaaf01806) },
  { SPH_C32(0x1c9e0000), SPH_C32(0x66c30000), SPH_C32(0x0d110000),
    SPH_C32(0x5fdac000), SPH_C32(0x32596759), SPH_C32(0x8cc0f80c),
    SPH_C32(0xaece29ff), SPH_C32(0xc6afe775), SPH_C32(0x288b0000),
    SPH_C32(0x0d770000), SPH_C32(0x5db60000), SPH_C32(0x1f991800),
    SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3), SPH_C32(0x5b06af40),
    SPH_C32(0x19e93cbf) },
  { SPH_C32(0xfab60000), SPH_C32(0x2a880000), SPH_C32(0xa5440000),
    SPH_C32(0x8c0ac2e0), SPH_C32(0xea3857e1), SPH_C32(0x146748d6),
    SPH_C32(0x865b2f4b), SPH_C32(0x11f5afe2), SPH_C32(0xd84e0000),
    SPH_C32(0x54540000), SPH_C32(0x18340000), SPH_C32(0xfe1418c0),
    SPH_C32(0x4d1d44d9), SPH_C32(0x1f0cf43a), SPH_C32(0x90e6515c),
    SPH_C32(0x4f4e8d20) },
  { SPH_C32(0xec5b0000), SPH_C32(0x3fe00000), SPH_C32(0x48930000),
    SPH_C32(0xbe57c0c0), SPH_C32(0x09346168), SPH_C32(0x4e2dae95),
    SPH_C32(0x652ed7e3), SPH_C32(0x900856ea), SPH_C32(0x3e660000),
    SPH_C32(0x181f0000), SPH_C32(0xb0610000), SPH_C32(0x2dc41a20),
    SPH_C32(0x957c7461), SPH_C32(0x87ab44e0), SPH_C32(0xb87357e8),
    SPH_C32(0x9814c5b7) },
  { SPH_C32(0x0a730000), SPH_C32(0x73ab0000), SPH_C32(0xe0c60000),
    SPH_C32(0x6d87c220), SPH_C32(0xd15551d0), SPH_C32(0xd68a1e4f),
    SPH_C32(0x4dbbd157), SPH_C32(0x47521e7d), SPH_C32(0xcea30000),
    SPH_C32(0x413c0000), SPH_C32(0xf5e30000), SPH_C32(0xcc491ae0),
    SPH_C32(0xae117250), SPH_C32(0x45461279), SPH_C32(0x7393a9f4),
    SPH_C32(0xceb37428) },
  { SPH_C32(0xa8af0000), SPH_C32(0x11f00000), SPH_C32(0xbc4c0000),
    SPH_C32(0x200ac4e0), SPH_C32(0x4afb0661), SPH_C32(0x5dd63b51),
    SPH_C32(0x7c98fd76), SPH_C32(0x88c093ab), SPH_C32(0xcb8d0000),
    SPH_C32(0xb0b60000), SPH_C32(0xdaa50000), SPH_C32(0xa06b1860),
    SPH_C32(0x58ca48f2), SPH_C32(0x505495f2), SPH_C32(0x28c30446),
    SPH_C32(0x423f2986) },
  { SPH_C32(0x4e870000), SPH_C32(0x5dbb0000), SPH_C32(0x14190000),
    SPH_C32(0xf3dac600), SPH_C32(0x929a36d9), SPH_C32(0xc5718b8b),
    SPH_C32(0x540dfbc2), SPH_C32(0x5f9adb3c), SPH_C32(0x3b480000),
    SPH_C32(0xe9950000), SPH_C32(0x9f270000), SPH_C32(0x41e618a0),
    SPH_C32(0x63a74ec3), SPH_C32(0x92b9c36b), SPH_C32(0xe323fa5a),
    SPH_C32(0x14989819) },
  { SPH_C32(0x586a0000), SPH_C32(0x48d30000), SPH_C32(0xf9ce0000),
    SPH_C32(0xc187c420), SPH_C32(0x71960050), SPH_C32(0x9f3b6dc8),
    SPH_C32(0xb778036a), SPH_C32(0xde672234), SPH_C32(0xdd600000),
    SPH_C32(0xa5de0000), SPH_C32(0x37720000), SPH_C32(0x92361a40),
    SPH_C32(0xbbc67e7b), SPH_C32(0x0a1e73b1), SPH_C32(0xcbb6fcee),
    SPH_C32(0xc3c2d08e) },
  { SPH_C32(0xbe420000), SPH_C32(0x04980000), SPH_C32(0x519b0000),
    SPH_C32(0x1257c6c0), SPH_C32(0xa9f730e8), SPH_C32(0x079cdd12),
    SPH_C32(0x9fed05de), SPH_C32(0x093d6aa3), SPH_C32(0x2da50000),
    SPH_C32(0xfcfd0000), SPH_C32(0x72f00000), SPH_C32(0x73bb1a80),
    SPH_C32(0x80ab784a), SPH_C32(0xc8f32528), SPH_C32(0x005602f2),
    SPH_C32(0x95656111) },
  { SPH_C32(0xff980000), SPH_C32(0xdb020000), SPH_C32(0x8a020000),
    SPH_C32(0xe028c060), SPH_C32(0x1ce36d43), SPH_C32(0x0175cf5d),
    SPH_C32(0xdd0b82f9), SPH_C32(0x9d79f24c), SPH_C32(0x7fbc0000),
    SPH_C32(0xc7850000), SPH_C32(0x6bf80000), SPH_C32(0xdfbb1c80),
    SPH_C32(0x206829ca), SPH_C32(0x814256af), SPH_C32(0xfa95d0cf),
    SPH_C32(0x0c505d58) },
  { SPH_C32(0x19b00000), SPH_C32(0x97490000), SPH_C32(0x22570000),
    SPH_C32(0x33f8c280), SPH_C32(0xc4825dfb), SPH_C32(0x99d27f87),
    SPH_C32(0xf59e844d), SPH_C32(0x4a23badb), SPH_C32(0x8f790000),
    SPH_C32(0x9ea60000), SPH_C32(0x2e7a0000), SPH_C32(0x3e361c40),
    SPH_C32(0x1b052ffb), SPH_C32(0x43af0036), SPH_C32(0x31752ed3),
    SPH_C32(0x5af7ecc7) },
  { SPH_C32(0x0f5d0000), SPH_C32(0x82210000), SPH_C32(0xcf800000),
    SPH_C32(0x01a5c0a0), SPH_C32(0x278e6b72), SPH_C32(0xc39899c4),
    SPH_C32(0x16eb7ce5), SPH_C32(0xcbde43d3), SPH_C32(0x69510000),
    SPH_C32(0xd2ed0000), SPH_C32(0x862f0000), SPH_C32(0xede61ea0),
    SPH_C32(0xc3641f43), SPH_C32(0xdb08b0ec), SPH_C32(0x19e02867),
    SPH_C32(0x8dada450) },
  { SPH_C32(0xe9750000), SPH_C32(0xce6a0000), SPH_C32(0x67d50000),
    SPH_C32(0xd275c240), SPH_C32(0xffef5bca), SPH_C32(0x5b3f291e),
    SPH_C32(0x3e7e7a51), SPH_C32(0x1c840b44), SPH_C32(0x99940000),
    SPH_C32(0x8bce0000), SPH_C32(0xc3ad0000), SPH_C32(0x0c6b1e60),
    SPH_C32(0xf8091972), SPH_C32(0x19e5e675), SPH_C32(0xd200d67b),
    SPH_C32(0xdb0a15cf) },
  { SPH_C32(0x4ba90000), SPH_C32(0xac310000), SPH_C32(0x3b5f0000),
    SPH_C32(0x9ff8c480), SPH_C32(0x64410c7b), SPH_C32(0xd0630c00),
    SPH_C32(0x0f5d5670), SPH_C32(0xd3168692), SPH_C32(0x9cba0000),
    SPH_C32(0x7a440000), SPH_C32(0xeceb0000), SPH_C32(0x60491ce0),
    SPH_C32(0x0ed223d0), SPH_C32(0x0cf761fe), SPH_C32(0x89507bc9),
    SPH_C32(0x57864861) },
  { SPH_C32(0xad810000), SPH_C32(0xe07a0000), SPH_C32(0x930a0000),
    SPH_C32(0x4c28c660), SPH_C32(0xbc203cc3), SPH_C32(0x48c4bcda),
    SPH_C32(0x27c850c4), SPH_C32(0x044cce05), SPH_C32(0x6c7f0000),
    SPH_C32(0x23670000), SPH_C32(0xa9690000), SPH_C32(0x81c41c20),
    SPH_C32(0x35bf25e1), SPH_C32(0xce1a3767), SPH_C32(0x42b085d5),
    SPH_C32(0x0121f9fe) },
  { SPH_C32(0xbb6c0000), SPH_C32(0xf5120000), SPH_C32(0x7edd0000),
    SPH_C32(0x7e75c440), SPH_C32(0x5f2c0a4a), SPH_C32(0x128e5a99),
    SPH_C32(0xc4bda86c), SPH_C32(0x85b1370d), SPH_C32(0x8a570000),
    SPH_C32(0x6f2c0000), SPH_C32(0x013c0000), SPH_C32(0x52141ec0),
    SPH_C32(0xedde1559), SPH_C32(0x56bd87bd), SPH_C32(0x6a258361),
    SPH_C32(0xd67bb169) },
  { SPH_C32(0x5d440000), SPH_C32(0xb9590000), SPH_C32(0xd6880000),
    SPH_C32(0xada5c6a0), SPH_C32(0x874d3af2), SPH_C32(0x8a29ea43),
    SPH_C32(0xec28aed8), SPH_C32(0x52eb7f9a), SPH_C32(0x7a920000),
    SPH_C32(0x360f0000), SPH_C32(0x44be0000), SPH_C32(0xb3991e00),
    SPH_C32(0xd6b31368), SPH_C32(0x9450d124), SPH_C32(0xa1c57d7d),
    SPH_C32(0x80dc00f6) },
  { SPH_C32(0xa4b10000), SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000),
    SPH_C32(0x4b9e9000), SPH_C32(0xf30107fb), SPH_C32(0xbde710e0),
    SPH_C32(0x805696dc), SPH_C32(0x93b1da1b), SPH_C32(0x2a790000),
    SPH_C32(0xaff60000), SPH_C32(0xda890000), SPH_C32(0xfcf56000),
    SPH_C32(0x686d3607), SPH_C32(0xdadc8975), SPH_C32(0x9fc49d77),
    SPH_C32(0x66db1921) },
  { SPH_C32(0x42990000), SPH_C32(0x9ba40000), SPH_C32(0x959c0000),
    SPH_C32(0x984e92e0), SPH_C32(0x2b603743), SPH_C32(0x2540a03a),
    SPH_C32(0xa8c39068), SPH_C32(0x44eb928c), SPH_C32(0xdabc0000),
    SPH_C32(0xf6d50000), SPH_C32(0x9f0b0000), SPH_C32(0x1d7860c0),
    SPH_C32(0x53003036), SPH_C32(0x1831dfec), SPH_C32(0x5424636b),
    SPH_C32(0x307ca8be) },
  { SPH_C32(0x54740000), SPH_C32(0x8ecc0000), SPH_C32(0x784b0000),
    SPH_C32(0xaa1390c0), SPH_C32(0xc86c01ca), SPH_C32(0x7f0a4679),
    SPH_C32(0x4bb668c0), SPH_C32(0xc5166b84), SPH_C32(0x3c940000),
    SPH_C32(0xba9e0000), SPH_C32(0x375e0000), SPH_C32(0xcea86220),
    SPH_C32(0x8b61008e), SPH_C32(0x80966f36), SPH_C32(0x7cb165df),
    SPH_C32(0xe726e029) },
  { SPH_C32(0xb25c0000), SPH_C32(0xc2870000), SPH_C32(0xd01e0000),
    SPH_C32(0x79c39220), SPH_C32(0x100d3172), SPH_C32(0xe7adf6a3),
    SPH_C32(0x63236e74), SPH_C32(0x124c2313), SPH_C32(0xcc510000),
    SPH_C32(0xe3bd0000), SPH_C32(0x72dc0000), SPH_C32(0x2f2562e0),
    SPH_C32(0xb00c06bf), SPH_C32(0x427b39af), SPH_C32(0xb7519bc3),
    SPH_C32(0xb18151b6) },
  { SPH_C32(0x10800000), SPH_C32(0xa0dc0000), SPH_C32(0x8c940000),
    SPH_C32(0x344e94e0), SPH_C32(0x8ba366c3), SPH_C32(0x6cf1d3bd),
    SPH_C32(0x52004255), SPH_C32(0xdddeaec5), SPH_C32(0xc97f0000),
    SPH_C32(0x12370000), SPH_C32(0x5d9a0000), SPH_C32(0x43076060),
    SPH_C32(0x46d73c1d), SPH_C32(0x5769be24), SPH_C32(0xec013671),
    SPH_C32(0x3d0d0c18) },
  { SPH_C32(0xf6a80000), SPH_C32(0xec970000), SPH_C32(0x24c10000),
    SPH_C32(0xe79e9600), SPH_C32(0x53c2567b), SPH_C32(0xf4566367),
    SPH_C32(0x7a9544e1), SPH_C32(0x0a84e652), SPH_C32(0x39ba0000),
    SPH_C32(0x4b140000), SPH_C32(0x18180000), SPH_C32(0xa28a60a0),
    SPH_C32(0x7dba3a2c), SPH_C32(0x9584e8bd), SPH_C32(0x27e1c86d),
    SPH_C32(0x6baabd87) },
  { SPH_C32(0xe0450000), SPH_C32(0xf9ff0000), SPH_C32(0xc9160000),
    SPH_C32(0xd5c39420), SPH_C32(0xb0ce60f2), SPH_C32(0xae1c8524),
    SPH_C32(0x99e0bc49), SPH_C32(0x8b791f5a), SPH_C32(0xdf920000),
    SPH_C32(0x075f0000), SPH_C32(0xb04d0000), SPH_C32(0x715a6240),
    SPH_C32(0xa5db0a94), SPH_C32(0x0d235867), SPH_C32(0x0f74ced9),
    SPH_C32(0xbcf0f510) },
  { SPH_C32(0x066d0000), SPH_C32(0xb5b40000), SPH_C32(0x61430000),
    SPH_C32(0x061396c0), SPH_C32(0x68af504a), SPH_C32(0x36bb35fe),
    SPH_C32(0xb175bafd), SPH_C32(0x5c2357cd), SPH_C32(0x2f570000),
    SPH_C32(0x5e7c0000), SPH_C32(0xf5cf0000), SPH_C32(0x90d76280),
    SPH_C32(0x9eb60ca5), SPH_C32(0xcfce0efe), SPH_C32(0xc49430c5),
    SPH_C32(0xea57448f) },
  { SPH_C32(0x47b70000), SPH_C32(0x6a2e0000), SPH_C32(0xbada0000),
    SPH_C32(0xf46c9060), SPH_C32(0xddbb0de1), SPH_C32(0x305227b1),
    SPH_C32(0xf3933dda), SPH_C32(0xc867cf22), SPH_C32(0x7d4e0000),
    SPH_C32(0x65040000), SPH_C32(0xecc70000), SPH_C32(0x3cd76480),
    SPH_C32(0x3e755d25), SPH_C32(0x867f7d79), SPH_C32(0x3e57e2f8),
    SPH_C32(0x736278c6) },
  { SPH_C32(0xa19f0000), SPH_C32(0x26650000), SPH_C32(0x128f0000),
    SPH_C32(0x27bc9280), SPH_C32(0x05da3d59), SPH_C32(0xa8f5976b),
    SPH_C32(0xdb063b6e), SPH_C32(0x1f3d87b5), SPH_C32(0x8d8b0000),
    SPH_C32(0x3c270000), SPH_C32(0xa9450000), SPH_C32(0xdd5a6440),
    SPH_C32(0x05185b14), SPH_C32(0x44922be0), SPH_C32(0xf5b71ce4),
    SPH_C32(0x25c5c959) },
  { SPH_C32(0xb7720000), SPH_C32(0x330d0000), SPH_C32(0xff580000),
    SPH_C32(0x15e190a0), SPH_C32(0xe6d60bd0), SPH_C32(0xf2bf7128),
    SPH_C32(0x3873c3c6), SPH_C32(0x9ec07ebd), SPH_C32(0x6ba30000),
    SPH_C32(0x706c0000), SPH_C32(0x01100000), SPH_C32(0x0e8a66a0),
    SPH_C32(0xdd796bac), SPH_C32(0xdc359b3a), SPH_C32(0xdd221a50),
    SPH_C32(0xf29f81ce) },
  { SPH_C32(0x515a0000), SPH_C32(0x7f460000), SPH_C32(0x570d0000),
    SPH_C32(0xc6319240), SPH_C32(0x3eb73b68), SPH_C32(0x6a18c1f2),
    SPH_C32(0x10e6c572), SPH_C32(0x499a362a), SPH_C32(0x9b660000),
    SPH_C32(0x294f0000), SPH_C32(0x44920000), SPH_C32(0xef076660),
    SPH_C32(0xe6146d9d), SPH_C32(0x1ed8cda3), SPH_C32(0x16c2e44c),
    SPH_C32(0xa4383051) },
  { SPH_C32(0xf3860000), SPH_C32(0x1d1d0000), SPH_C32(0x0b870000),
    SPH_C32(0x8bbc9480), SPH_C32(0xa5196cd9), SPH_C32(0xe144e4ec),
    SPH_C32(0x21c5e953), SPH_C32(0x8608bbfc), SPH_C32(0x9e480000),
    SPH_C32(0xd8c50000), SPH_C32(0x6bd40000), SPH_C32(0x832564e0),
    SPH_C32(0x10cf573f), SPH_C32(0x0bca4a28), SPH_C32(0x4d9249fe),
    SPH_C32(0x28b46dff) },
  { SPH_C32(0x15ae0000), SPH_C32(0x51560000), SPH_C32(0xa3d20000),
    SPH_C32(0x586c9660), SPH_C32(0x7d785c61), SPH_C32(0x79e35436),
    SPH_C32(0x0950efe7), SPH_C32(0x5152f36b), SPH_C32(0x6e8d0000),
    SPH_C32(0x81e60000), SPH_C32(0x2e560000), SPH_C32(0x62a86420),
    SPH_C32(0x2ba2510e), SPH_C32(0xc9271cb1), SPH_C32(0x8672b7e2),
    SPH_C32(0x7e13dc60) },
  { SPH_C32(0x03430000), SPH_C32(0x443e0000), SPH_C32(0x4e050000),
    SPH_C32(0x6a319440), SPH_C32(0x9e746ae8), SPH_C32(0x23a9b275),
    SPH_C32(0xea25174f), SPH_C32(0xd0af0a63), SPH_C32(0x88a50000),
    SPH_C32(0xcdad0000), SPH_C32(0x86030000), SPH_C32(0xb17866c0),
    SPH_C32(0xf3c361b6), SPH_C32(0x5180ac6b), SPH_C32(0xaee7b156),
    SPH_C32(0xa94994f7) },
  { SPH_C32(0xe56b0000), SPH_C32(0x08750000), SPH_C32(0xe6500000),
    SPH_C32(0xb9e196a0), SPH_C32(0x46155a50), SPH_C32(0xbb0e02af),
    SPH_C32(0xc2b011fb), SPH_C32(0x07f542f4), SPH_C32(0x78600000),
    SPH_C32(0x948e0000), SPH_C32(0xc3810000), SPH_C32(0x50f56600),
    SPH_C32(0xc8ae6787), SPH_C32(0x936dfaf2), SPH_C32(0x65074f4a),
    SPH_C32(0xffee2568) },
  { SPH_C32(0xa6430000), SPH_C32(0x756e0000), SPH_C32(0xbaf60000),
    SPH_C32(0xa8f2e800), SPH_C32(0xed1c7314), SPH_C32(0xbada3b36),
    SPH_C32(0x4494a4eb), SPH_C32(0xec83ff85), SPH_C32(0x90a40000),
    SPH_C32(0xbc5b0000), SPH_C32(0x6d6e0000), SPH_C32(0x0bdd4800),
    SPH_C32(0xb728224a), SPH_C32(0xecc64a4f), SPH_C32(0x759e1063),
    SPH_C32(0x4cf701d1) },
  { SPH_C32(0x406b0000), SPH_C32(0x39250000), SPH_C32(0x12a30000),
    SPH_C32(0x7b22eae0), SPH_C32(0x357d43ac), SPH_C32(0x227d8bec),
    SPH_C32(0x6c01a25f), SPH_C32(0x3bd9b712), SPH_C32(0x60610000),
    SPH_C32(0xe5780000), SPH_C32(0x28ec0000), SPH_C32(0xea5048c0),
    SPH_C32(0x8c45247b), SPH_C32(0x2e2b1cd6), SPH_C32(0xbe7eee7f),
    SPH_C32(0x1a50b04e) },
  { SPH_C32(0x56860000), SPH_C32(0x2c4d0000), SPH_C32(0xff740000),
    SPH_C32(0x497fe8c0), SPH_C32(0xd6717525), SPH_C32(0x78376daf),
    SPH_C32(0x8f745af7), SPH_C32(0xba244e1a), SPH_C32(0x86490000),
    SPH_C32(0xa9330000), SPH_C32(0x80b90000), SPH_C32(0x39804a20),
    SPH_C32(0x542414c3), SPH_C32(0xb68cac0c), SPH_C32(0x96ebe8cb),
    SPH_C32(0xcd0af8d9) },
  { SPH_C32(0xb0ae0000), SPH_C32(0x60060000), SPH_C32(0x57210000),
    SPH_C32(0x9aafea20), SPH_C32(0x0e10459d), SPH_C32(0xe090dd75),
    SPH_C32(0xa7e15c43), SPH_C32(0x6d7e068d), SPH_C32(0x768c0000),
    SPH_C32(0xf0100000), SPH_C32(0xc53b0000), SPH_C32(0xd80d4ae0),
    SPH_C32(0x6f4912f2), SPH_C32(0x7461fa95), SPH_C32(0x5d0b16d7),
    SPH_C32(0x9bad4946) },
  { SPH_C32(0x12720000), SPH_C32(0x025d0000), SPH_C32(0x0bab0000),
    SPH_C32(0xd722ece0), SPH_C32(0x95be122c), SPH_C32(0x6bccf86b),
    SPH_C32(0x96c27062), SPH_C32(0xa2ec8b5b), SPH_C32(0x73a20000),
    SPH_C32(0x019a0000), SPH_C32(0xea7d0000), SPH_C32(0xb42f4860),
    SPH_C32(0x99922850), SPH_C32(0x61737d1e), SPH_C32(0x065bbb65),
    SPH_C32(0x172114e8) },
  { SPH_C32(0xf45a0000), SPH_C32(0x4e160000), SPH_C32(0xa3fe0000),
    SPH_C32(0x04f2ee00), SPH_C32(0x4ddf2294), SPH_C32(0xf36b48b1),
    SPH_C32(0xbe5776d6), SPH_C32(0x75b6c3cc), SPH_C32(0x83670000),
    SPH_C32(0x58b90000), SPH_C32(0xafff0000), SPH_C32(0x55a248a0),
    SPH_C32(0xa2ff2e61), SPH_C32(0xa39e2b87), SPH_C32(0xcdbb4579),
    SPH_C32(0x4186a577) },
  { SPH_C32(0xe2b70000), SPH_C32(0x5b7e0000), SPH_C32(0x4e290000),
    SPH_C32(0x36afec20), SPH_C32(0xaed3141d), SPH_C32(0xa921aef2),
    SPH_C32(0x5d228e7e), SPH_C32(0xf44b3ac4), SPH_C32(0x654f0000),
    SPH_C32(0x14f20000), SPH_C32(0x07aa0000), SPH_C32(0x86724a40),
    SPH_C32(0x7a9e1ed9), SPH_C32(0x3b399b5d), SPH_C32(0xe52e43cd),
    SPH_C32(0x96dcede0) },
  { SPH_C32(0x049f0000), SPH_C32(0x17350000), SPH_C32(0xe67c0000),
    SPH_C32(0xe57feec0), SPH_C32(0x76b224a5), SPH_C32(0x31861e28),
    SPH_C32(0x75b788ca), SPH_C32(0x23117253), SPH_C32(0x958a0000),
    SPH_C32(0x4dd10000), SPH_C32(0x42280000), SPH_C32(0x67ff4a80),
    SPH_C32(0x41f318e8), SPH_C32(0xf9d4cdc4), SPH_C32(0x2ecebdd1),
    SPH_C32(0xc07b5c7f) },
  { SPH_C32(0x45450000), SPH_C32(0xc8af0000), SPH_C32(0x3de50000),
    SPH_C32(0x1700e860), SPH_C32(0xc3a6790e), SPH_C32(0x376f0c67),
    SPH_C32(0x37510fed), SPH_C32(0xb755eabc), SPH_C32(0xc7930000),
    SPH_C32(0x76a90000), SPH_C32(0x5b200000), SPH_C32(0xcbff4c80),
    SPH_C32(0xe1304968), SPH_C32(0xb065be43), SPH_C32(0xd40d6fec),
    SPH_C32(0x594e6036) },
  { SPH_C32(0xa36d0000), SPH_C32(0x84e40000), SPH_C32(0x95b00000),
    SPH_C32(0xc4d0ea80), SPH_C32(0x1bc749b6), SPH_C32(0xafc8bcbd),
    SPH_C32(0x1fc40959), SPH_C32(0x600fa22b), SPH_C32(0x37560000),
    SPH_C32(0x2f8a0000), SPH_C32(0x1ea20000), SPH_C32(0x2a724c40),
    SPH_C32(0xda5d4f59), SPH_C32(0x7288e8da), SPH_C32(0x1fed91f0),
    SPH_C32(0x0fe9d1a9) },
  { SPH_C32(0xb5800000), SPH_C32(0x918c0000), SPH_C32(0x78670000),
    SPH_C32(0xf68de8a0), SPH_C32(0xf8cb7f3f), SPH_C32(0xf5825afe),
    SPH_C32(0xfcb1f1f1), SPH_C32(0xe1f25b23), SPH_C32(0xd17e0000),
    SPH_C32(0x63c10000), SPH_C32(0xb6f70000), SPH_C32(0xf9a24ea0),
    SPH_C32(0x023c7fe1), SPH_C32(0xea2f5800), SPH_C32(0x37789744),
    SPH_C32(0xd8b3993e) },
  { SPH_C32(0x53a80000), SPH_C32(0xddc70000), SPH_C32(0xd0320000),
    SPH_C32(0x255dea40), SPH_C32(0x20aa4f87), SPH_C32(0x6d25ea24),
    SPH_C32(0xd424f745), SPH_C32(0x36a813b4), SPH_C32(0x21bb0000),
    SPH_C32(0x3ae20000), SPH_C32(0xf3750000), SPH_C32(0x182f4e60),
    SPH_C32(0x395179d0), SPH_C32(0x28c20e99), SPH_C32(0xfc986958),
    SPH_C32(0x8e1428a1) },
  { SPH_C32(0xf1740000), SPH_C32(0xbf9c0000), SPH_C32(0x8cb80000),
    SPH_C32(0x68d0ec80), SPH_C32(0xbb041836), SPH_C32(0xe679cf3a),
    SPH_C32(0xe507db64), SPH_C32(0xf93a9e62), SPH_C32(0x24950000),
    SPH_C32(0xcb680000), SPH_C32(0xdc330000), SPH_C32(0x740d4ce0),
    SPH_C32(0xcf8a4372), SPH_C32(0x3dd08912), SPH_C32(0xa7c8c4ea),
    SPH_C32(0x0298750f) },
  { SPH_C32(0x175c0000), SPH_C32(0xf3d70000), SPH_C32(0x24ed0000),
    SPH_C32(0xbb00ee60), SPH_C32(0x6365288e), SPH_C32(0x7ede7fe0),
    SPH_C32(0xcd92ddd0), SPH_C32(0x2e60d6f5), SPH_C32(0xd4500000),
    SPH_C32(0x924b0000), SPH_C32(0x99b10000), SPH_C32(0x95804c20),
    SPH_C32(0xf4e74543), SPH_C32(0xff3ddf8b), SPH_C32(0x6c283af6),
    SPH_C32(0x543fc490) },
  { SPH_C32(0x01b10000), SPH_C32(0xe6bf0000), SPH_C32(0xc93a0000),
    SPH_C32(0x895dec40), SPH_C32(0x80691e07), SPH_C32(0x249499a3),
    SPH_C32(0x2ee72578), SPH_C32(0xaf9d2ffd), SPH_C32(0x32780000),
    SPH_C32(0xde000000), SPH_C32(0x31e40000), SPH_C32(0x46504ec0),
    SPH_C32(0x2c8675fb), SPH_C32(0x679a6f51), SPH_C32(0x44bd3c42),
    SPH_C32(0x83658c07) },
  { SPH_C32(0xe7990000), SPH_C32(0xaaf40000), SPH_C32(0x616f0000),
    SPH_C32(0x5a8deea0), SPH_C32(0x58082ebf), SPH_C32(0xbc332979),
    SPH_C32(0x067223cc), SPH_C32(0x78c7676a), SPH_C32(0xc2bd0000),
    SPH_C32(0x87230000), SPH_C32(0x74660000), SPH_C32(0xa7dd4e00),
    SPH_C32(0x17eb73ca), SPH_C32(0xa57739c8), SPH_C32(0x8f5dc25e),
    SPH_C32(0xd5c23d98) }
};

__constant static const sph_u32 T512_56[128][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0xa9490000), SPH_C32(0x713c0000), SPH_C32(0xb1e60000),
    SPH_C32(0xc8d60009), SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4),
    SPH_C32(0xbd50e9e9), SPH_C32(0x89e81e7b), SPH_C32(0x39cf0000),
    SPH_C32(0x42880000), SPH_C32(0xf8dd0000), SPH_C32(0x6bc40006),
    SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599), SPH_C32(0x250db0b9),
    SPH_C32(0x474b8a29) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x3af20000), SPH_C32(0x4a3b0000), SPH_C32(0x0be70000),
    SPH_C32(0x51060001), SPH_C32(0xc78fb695), SPH_C32(0x4577d386),
    SPH_C32(0x2ba87f5a), SPH_C32(0xa191f5d7), SPH_C32(0x385c0000),
    SPH_C32(0xa50a0000), SPH_C32(0x15260000), SPH_C32(0xa4c8000d),
    SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7), SPH_C32(0x233bd158),
    SPH_C32(0x14241452) },
  { SPH_C32(0x93bb0000), SPH_C32(0x3b070000), SPH_C32(0xba010000),
    SPH_C32(0x99d00008), SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722),
    SPH_C32(0x96f896b3), SPH_C32(0x2879ebac), SPH_C32(0x01930000),
    SPH_C32(0xe7820000), SPH_C32(0xedfb0000), SPH_C32(0xcf0c000b),
    SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e), SPH_C32(0x063661e1),
    SPH_C32(0x536f9e7b) },
  { SPH_C32(0x3b610000), SPH_C32(0xadb90000), SPH_C32(0xe61c0000),
    SPH_C32(0x9e0a000a), SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8),
    SPH_C32(0x2d9e1ebb), SPH_C32(0xf2fe6bac), SPH_C32(0xaa740000),
    SPH_C32(0x798f0000), SPH_C32(0x42dc0000), SPH_C32(0xf214000e),
    SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb), SPH_C32(0xb3f5260a),
    SPH_C32(0x6f326185) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0xf7720000), SPH_C32(0xc0bd0000), SPH_C32(0x1fb30000),
    SPH_C32(0x63290011), SPH_C32(0x5818133c), SPH_C32(0x0c89e4c4),
    SPH_C32(0xef781db7), SPH_C32(0x54235b69), SPH_C32(0xaba30000),
    SPH_C32(0xe1450000), SPH_C32(0x755b0000), SPH_C32(0x173b0004),
    SPH_C32(0x17e2d61f), SPH_C32(0xdd408a12), SPH_C32(0xb6c9d98b),
    SPH_C32(0x82579860) },
  { SPH_C32(0x5e3b0000), SPH_C32(0xb1810000), SPH_C32(0xae550000),
    SPH_C32(0xabff0018), SPH_C32(0xa8ae0be7), SPH_C32(0xafb22060),
    SPH_C32(0x5228f45e), SPH_C32(0xddcb4512), SPH_C32(0x926c0000),
    SPH_C32(0xa3cd0000), SPH_C32(0x8d860000), SPH_C32(0x7cff0002),
    SPH_C32(0x8144eada), SPH_C32(0xf3593f8b), SPH_C32(0x93c46932),
    SPH_C32(0xc51c1249) },
  { SPH_C32(0xf6e10000), SPH_C32(0x273f0000), SPH_C32(0xf2480000),
    SPH_C32(0xac25001a), SPH_C32(0xd5c89e64), SPH_C32(0xb02a50ea),
    SPH_C32(0xe94e7c56), SPH_C32(0x074cc512), SPH_C32(0x398b0000),
    SPH_C32(0x3dc00000), SPH_C32(0x22a10000), SPH_C32(0x41e70007),
    SPH_C32(0xad0bf509), SPH_C32(0x87af291e), SPH_C32(0x26072ed9),
    SPH_C32(0xf941edb7) },
  { SPH_C32(0xcd800000), SPH_C32(0x8a860000), SPH_C32(0x14540000),
    SPH_C32(0x322f0010), SPH_C32(0x9f97a5a9), SPH_C32(0x49fe3742),
    SPH_C32(0xc4d062ed), SPH_C32(0xf5b2aebe), SPH_C32(0x93ff0000),
    SPH_C32(0x444f0000), SPH_C32(0x607d0000), SPH_C32(0xb3f30009),
    SPH_C32(0x0c946782), SPH_C32(0x4ffa8ba5), SPH_C32(0x95f208d3),
    SPH_C32(0x96738c32) },
  { SPH_C32(0x655a0000), SPH_C32(0x1c380000), SPH_C32(0x48490000),
    SPH_C32(0x35f50012), SPH_C32(0xe2f1302a), SPH_C32(0x566647c8),
    SPH_C32(0x7fb6eae5), SPH_C32(0x2f352ebe), SPH_C32(0x38180000),
    SPH_C32(0xda420000), SPH_C32(0xcf5a0000), SPH_C32(0x8eeb000c),
    SPH_C32(0x20db7851), SPH_C32(0x3b0c9d30), SPH_C32(0x20314f38),
    SPH_C32(0xaa2e73cc) },
  { SPH_C32(0xcc130000), SPH_C32(0x6d040000), SPH_C32(0xf9af0000),
    SPH_C32(0xfd23001b), SPH_C32(0x124728f1), SPH_C32(0xf55d836c),
    SPH_C32(0xc2e6030c), SPH_C32(0xa6dd30c5), SPH_C32(0x01d70000),
    SPH_C32(0x98ca0000), SPH_C32(0x37870000), SPH_C32(0xe52f000a),
    SPH_C32(0xb67d4494), SPH_C32(0x151528a9), SPH_C32(0x053cff81),
    SPH_C32(0xed65f9e5) },
  { SPH_C32(0x64c90000), SPH_C32(0xfbba0000), SPH_C32(0xa5b20000),
    SPH_C32(0xfaf90019), SPH_C32(0x6f21bd72), SPH_C32(0xeac5f3e6),
    SPH_C32(0x79808b04), SPH_C32(0x7c5ab0c5), SPH_C32(0xaa300000),
    SPH_C32(0x06c70000), SPH_C32(0x98a00000), SPH_C32(0xd837000f),
    SPH_C32(0x9a325b47), SPH_C32(0x61e33e3c), SPH_C32(0xb0ffb86a),
    SPH_C32(0xd138061b) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0xa89e0000), SPH_C32(0xe9f60000), SPH_C32(0x86610000),
    SPH_C32(0x2df90003), SPH_C32(0x46cb5c4f), SPH_C32(0xb62eec0d),
    SPH_C32(0xb86c1668), SPH_C32(0x648de79e), SPH_C32(0xf40b0000),
    SPH_C32(0xb7460000), SPH_C32(0x36f50000), SPH_C32(0x73c80017),
    SPH_C32(0x329c50a0), SPH_C32(0xce511e5c), SPH_C32(0xe2d74c34),
    SPH_C32(0x0cf34309) },
  { SPH_C32(0x01d70000), SPH_C32(0x98ca0000), SPH_C32(0x37870000),
    SPH_C32(0xe52f000a), SPH_C32(0xb67d4494), SPH_C32(0x151528a9),
    SPH_C32(0x053cff81), SPH_C32(0xed65f9e5), SPH_C32(0xcdc40000),
    SPH_C32(0xf5ce0000), SPH_C32(0xce280000), SPH_C32(0x180c0011),
    SPH_C32(0xa43a6c65), SPH_C32(0xe048abc5), SPH_C32(0xc7dafc8d),
    SPH_C32(0x4bb8c920) },
  { SPH_C32(0xa90d0000), SPH_C32(0x0e740000), SPH_C32(0x6b9a0000),
    SPH_C32(0xe2f50008), SPH_C32(0xcb1bd117), SPH_C32(0x0a8d5823),
    SPH_C32(0xbe5a7789), SPH_C32(0x37e279e5), SPH_C32(0x66230000),
    SPH_C32(0x6bc30000), SPH_C32(0x610f0000), SPH_C32(0x25140014),
    SPH_C32(0x887573b6), SPH_C32(0x94bebd50), SPH_C32(0x7219bb66),
    SPH_C32(0x77e536de) },
  { SPH_C32(0x926c0000), SPH_C32(0xa3cd0000), SPH_C32(0x8d860000),
    SPH_C32(0x7cff0002), SPH_C32(0x8144eada), SPH_C32(0xf3593f8b),
    SPH_C32(0x93c46932), SPH_C32(0xc51c1249), SPH_C32(0xcc570000),
    SPH_C32(0x124c0000), SPH_C32(0x23d30000), SPH_C32(0xd700001a),
    SPH_C32(0x29eae13d), SPH_C32(0x5ceb1feb), SPH_C32(0xc1ec9d6c),
    SPH_C32(0x18d7575b) },
  { SPH_C32(0x3ab60000), SPH_C32(0x35730000), SPH_C32(0xd19b0000),
    SPH_C32(0x7b250000), SPH_C32(0xfc227f59), SPH_C32(0xecc14f01),
    SPH_C32(0x28a2e13a), SPH_C32(0x1f9b9249), SPH_C32(0x67b00000),
    SPH_C32(0x8c410000), SPH_C32(0x8cf40000), SPH_C32(0xea18001f),
    SPH_C32(0x05a5feee), SPH_C32(0x281d097e), SPH_C32(0x742fda87),
    SPH_C32(0x248aa8a5) },
  { SPH_C32(0x93ff0000), SPH_C32(0x444f0000), SPH_C32(0x607d0000),
    SPH_C32(0xb3f30009), SPH_C32(0x0c946782), SPH_C32(0x4ffa8ba5),
    SPH_C32(0x95f208d3), SPH_C32(0x96738c32), SPH_C32(0x5e7f0000),
    SPH_C32(0xcec90000), SPH_C32(0x74290000), SPH_C32(0x81dc0019),
    SPH_C32(0x9303c22b), SPH_C32(0x0604bce7), SPH_C32(0x51226a3e),
    SPH_C32(0x63c1228c) },
  { SPH_C32(0x3b250000), SPH_C32(0xd2f10000), SPH_C32(0x3c600000),
    SPH_C32(0xb429000b), SPH_C32(0x71f2f201), SPH_C32(0x5062fb2f),
    SPH_C32(0x2e9480db), SPH_C32(0x4cf40c32), SPH_C32(0xf5980000),
    SPH_C32(0x50c40000), SPH_C32(0xdb0e0000), SPH_C32(0xbcc4001c),
    SPH_C32(0xbf4cddf8), SPH_C32(0x72f2aa72), SPH_C32(0xe4e12dd5),
    SPH_C32(0x5f9cdd72) },
  { SPH_C32(0x5fec0000), SPH_C32(0x294b0000), SPH_C32(0x99d20000),
    SPH_C32(0x4ed00012), SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9),
    SPH_C32(0x57140bdf), SPH_C32(0x30aebcf7), SPH_C32(0x5fa80000),
    SPH_C32(0x56030000), SPH_C32(0x43ae0000), SPH_C32(0x64f30013),
    SPH_C32(0x257e86bf), SPH_C32(0x1311944e), SPH_C32(0x541e95bf),
    SPH_C32(0x8ea4db69) },
  { SPH_C32(0xf7360000), SPH_C32(0xbff50000), SPH_C32(0xc5cf0000),
    SPH_C32(0x490a0010), SPH_C32(0x63b5daf0), SPH_C32(0xa53f7843),
    SPH_C32(0xec7283d7), SPH_C32(0xea293cf7), SPH_C32(0xf44f0000),
    SPH_C32(0xc80e0000), SPH_C32(0xec890000), SPH_C32(0x59eb0016),
    SPH_C32(0x0931996c), SPH_C32(0x67e782db), SPH_C32(0xe1ddd254),
    SPH_C32(0xb2f92497) },
  { SPH_C32(0x5e7f0000), SPH_C32(0xcec90000), SPH_C32(0x74290000),
    SPH_C32(0x81dc0019), SPH_C32(0x9303c22b), SPH_C32(0x0604bce7),
    SPH_C32(0x51226a3e), SPH_C32(0x63c1228c), SPH_C32(0xcd800000),
    SPH_C32(0x8a860000), SPH_C32(0x14540000), SPH_C32(0x322f0010),
    SPH_C32(0x9f97a5a9), SPH_C32(0x49fe3742), SPH_C32(0xc4d062ed),
    SPH_C32(0xf5b2aebe) },
  { SPH_C32(0xf6a50000), SPH_C32(0x58770000), SPH_C32(0x28340000),
    SPH_C32(0x8606001b), SPH_C32(0xee6557a8), SPH_C32(0x199ccc6d),
    SPH_C32(0xea44e236), SPH_C32(0xb946a28c), SPH_C32(0x66670000),
    SPH_C32(0x148b0000), SPH_C32(0xbb730000), SPH_C32(0x0f370015),
    SPH_C32(0xb3d8ba7a), SPH_C32(0x3d0821d7), SPH_C32(0x71132506),
    SPH_C32(0xc9ef5140) },
  { SPH_C32(0xcdc40000), SPH_C32(0xf5ce0000), SPH_C32(0xce280000),
    SPH_C32(0x180c0011), SPH_C32(0xa43a6c65), SPH_C32(0xe048abc5),
    SPH_C32(0xc7dafc8d), SPH_C32(0x4bb8c920), SPH_C32(0xcc130000),
    SPH_C32(0x6d040000), SPH_C32(0xf9af0000), SPH_C32(0xfd23001b),
    SPH_C32(0x124728f1), SPH_C32(0xf55d836c), SPH_C32(0xc2e6030c),
    SPH_C32(0xa6dd30c5) },
  { SPH_C32(0x651e0000), SPH_C32(0x63700000), SPH_C32(0x92350000),
    SPH_C32(0x1fd60013), SPH_C32(0xd95cf9e6), SPH_C32(0xffd0db4f),
    SPH_C32(0x7cbc7485), SPH_C32(0x913f4920), SPH_C32(0x67f40000),
    SPH_C32(0xf3090000), SPH_C32(0x56880000), SPH_C32(0xc03b001e),
    SPH_C32(0x3e083722), SPH_C32(0x81ab95f9), SPH_C32(0x772544e7),
    SPH_C32(0x9a80cf3b) },
  { SPH_C32(0xcc570000), SPH_C32(0x124c0000), SPH_C32(0x23d30000),
    SPH_C32(0xd700001a), SPH_C32(0x29eae13d), SPH_C32(0x5ceb1feb),
    SPH_C32(0xc1ec9d6c), SPH_C32(0x18d7575b), SPH_C32(0x5e3b0000),
    SPH_C32(0xb1810000), SPH_C32(0xae550000), SPH_C32(0xabff0018),
    SPH_C32(0xa8ae0be7), SPH_C32(0xafb22060), SPH_C32(0x5228f45e),
    SPH_C32(0xddcb4512) },
  { SPH_C32(0x648d0000), SPH_C32(0x84f20000), SPH_C32(0x7fce0000),
    SPH_C32(0xd0da0018), SPH_C32(0x548c74be), SPH_C32(0x43736f61),
    SPH_C32(0x7a8a1564), SPH_C32(0xc250d75b), SPH_C32(0xf5dc0000),
    SPH_C32(0x2f8c0000), SPH_C32(0x01720000), SPH_C32(0x96e7001d),
    SPH_C32(0x84e11434), SPH_C32(0xdb4436f5), SPH_C32(0xe7ebb3b5),
    SPH_C32(0xe196baec) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0x46490000), SPH_C32(0x40b90000), SPH_C32(0xcedc0000),
    SPH_C32(0x2c4201e2), SPH_C32(0xe937bdff), SPH_C32(0x24f48bdd),
    SPH_C32(0xfe57ab7c), SPH_C32(0xfa98ea64), SPH_C32(0xd0cf0000),
    SPH_C32(0xc94f0000), SPH_C32(0x06c20000), SPH_C32(0x5e5b00a5),
    SPH_C32(0xb2945bfc), SPH_C32(0x196f832e), SPH_C32(0x923b7ce8),
    SPH_C32(0xfba29f0e) },
  { SPH_C32(0xef000000), SPH_C32(0x31850000), SPH_C32(0x7f3a0000),
    SPH_C32(0xe49401eb), SPH_C32(0x1981a524), SPH_C32(0x87cf4f79),
    SPH_C32(0x43074295), SPH_C32(0x7370f41f), SPH_C32(0xe9000000),
    SPH_C32(0x8bc70000), SPH_C32(0xfe1f0000), SPH_C32(0x359f00a3),
    SPH_C32(0x24326739), SPH_C32(0x377636b7), SPH_C32(0xb736cc51),
    SPH_C32(0xbce91527) },
  { SPH_C32(0x47da0000), SPH_C32(0xa73b0000), SPH_C32(0x23270000),
    SPH_C32(0xe34e01e9), SPH_C32(0x64e730a7), SPH_C32(0x98573ff3),
    SPH_C32(0xf861ca9d), SPH_C32(0xa9f7741f), SPH_C32(0x42e70000),
    SPH_C32(0x15ca0000), SPH_C32(0x51380000), SPH_C32(0x088700a6),
    SPH_C32(0x087d78ea), SPH_C32(0x43802022), SPH_C32(0x02f58bba),
    SPH_C32(0x80b4ead9) },
  { SPH_C32(0x7cbb0000), SPH_C32(0x0a820000), SPH_C32(0xc53b0000),
    SPH_C32(0x7d4401e3), SPH_C32(0x2eb80b6a), SPH_C32(0x6183585b),
    SPH_C32(0xd5ffd426), SPH_C32(0x5b091fb3), SPH_C32(0xe8930000),
    SPH_C32(0x6c450000), SPH_C32(0x13e40000), SPH_C32(0xfa9300a8),
    SPH_C32(0xa9e2ea61), SPH_C32(0x8bd58299), SPH_C32(0xb100adb0),
    SPH_C32(0xef868b5c) },
  { SPH_C32(0xd4610000), SPH_C32(0x9c3c0000), SPH_C32(0x99260000),
    SPH_C32(0x7a9e01e1), SPH_C32(0x53de9ee9), SPH_C32(0x7e1b28d1),
    SPH_C32(0x6e995c2e), SPH_C32(0x818e9fb3), SPH_C32(0x43740000),
    SPH_C32(0xf2480000), SPH_C32(0xbcc30000), SPH_C32(0xc78b00ad),
    SPH_C32(0x85adf5b2), SPH_C32(0xff23940c), SPH_C32(0x04c3ea5b),
    SPH_C32(0xd3db74a2) },
  { SPH_C32(0x7d280000), SPH_C32(0xed000000), SPH_C32(0x28c00000),
    SPH_C32(0xb24801e8), SPH_C32(0xa3688632), SPH_C32(0xdd20ec75),
    SPH_C32(0xd3c9b5c7), SPH_C32(0x086681c8), SPH_C32(0x7abb0000),
    SPH_C32(0xb0c00000), SPH_C32(0x441e0000), SPH_C32(0xac4f00ab),
    SPH_C32(0x130bc977), SPH_C32(0xd13a2195), SPH_C32(0x21ce5ae2),
    SPH_C32(0x9490fe8b) },
  { SPH_C32(0xd5f20000), SPH_C32(0x7bbe0000), SPH_C32(0x74dd0000),
    SPH_C32(0xb59201ea), SPH_C32(0xde0e13b1), SPH_C32(0xc2b89cff),
    SPH_C32(0x68af3dcf), SPH_C32(0xd2e101c8), SPH_C32(0xd15c0000),
    SPH_C32(0x2ecd0000), SPH_C32(0xeb390000), SPH_C32(0x915700ae),
    SPH_C32(0x3f44d6a4), SPH_C32(0xa5cc3700), SPH_C32(0x940d1d09),
    SPH_C32(0xa8cd0175) },
  { SPH_C32(0xb13b0000), SPH_C32(0x80040000), SPH_C32(0xd16f0000),
    SPH_C32(0x4f6b01f3), SPH_C32(0xb12faec3), SPH_C32(0x287d6f19),
    SPH_C32(0x112fb6cb), SPH_C32(0xaebbb10d), SPH_C32(0x7b6c0000),
    SPH_C32(0x280a0000), SPH_C32(0x73990000), SPH_C32(0x496000a1),
    SPH_C32(0xa5768de3), SPH_C32(0xc42f093c), SPH_C32(0x24f2a563),
    SPH_C32(0x79f5076e) },
  { SPH_C32(0x19e10000), SPH_C32(0x16ba0000), SPH_C32(0x8d720000),
    SPH_C32(0x48b101f1), SPH_C32(0xcc493b40), SPH_C32(0x37e51f93),
    SPH_C32(0xaa493ec3), SPH_C32(0x743c310d), SPH_C32(0xd08b0000),
    SPH_C32(0xb6070000), SPH_C32(0xdcbe0000), SPH_C32(0x747800a4),
    SPH_C32(0x89399230), SPH_C32(0xb0d91fa9), SPH_C32(0x9131e288),
    SPH_C32(0x45a8f890) },
  { SPH_C32(0xb0a80000), SPH_C32(0x67860000), SPH_C32(0x3c940000),
    SPH_C32(0x806701f8), SPH_C32(0x3cff239b), SPH_C32(0x94dedb37),
    SPH_C32(0x1719d72a), SPH_C32(0xfdd42f76), SPH_C32(0xe9440000),
    SPH_C32(0xf48f0000), SPH_C32(0x24630000), SPH_C32(0x1fbc00a2),
    SPH_C32(0x1f9faef5), SPH_C32(0x9ec0aa30), SPH_C32(0xb43c5231),
    SPH_C32(0x02e372b9) },
  { SPH_C32(0x18720000), SPH_C32(0xf1380000), SPH_C32(0x60890000),
    SPH_C32(0x87bd01fa), SPH_C32(0x4199b618), SPH_C32(0x8b46abbd),
    SPH_C32(0xac7f5f22), SPH_C32(0x2753af76), SPH_C32(0x42a30000),
    SPH_C32(0x6a820000), SPH_C32(0x8b440000), SPH_C32(0x22a400a7),
    SPH_C32(0x33d0b126), SPH_C32(0xea36bca5), SPH_C32(0x01ff15da),
    SPH_C32(0x3ebe8d47) },
  { SPH_C32(0x23130000), SPH_C32(0x5c810000), SPH_C32(0x86950000),
    SPH_C32(0x19b701f0), SPH_C32(0x0bc68dd5), SPH_C32(0x7292cc15),
    SPH_C32(0x81e14199), SPH_C32(0xd5adc4da), SPH_C32(0xe8d70000),
    SPH_C32(0x130d0000), SPH_C32(0xc9980000), SPH_C32(0xd0b000a9),
    SPH_C32(0x924f23ad), SPH_C32(0x22631e1e), SPH_C32(0xb20a33d0),
    SPH_C32(0x518cecc2) },
  { SPH_C32(0x8bc90000), SPH_C32(0xca3f0000), SPH_C32(0xda880000),
    SPH_C32(0x1e6d01f2), SPH_C32(0x76a01856), SPH_C32(0x6d0abc9f),
    SPH_C32(0x3a87c991), SPH_C32(0x0f2a44da), SPH_C32(0x43300000),
    SPH_C32(0x8d000000), SPH_C32(0x66bf0000), SPH_C32(0xeda800ac),
    SPH_C32(0xbe003c7e), SPH_C32(0x5695088b), SPH_C32(0x07c9743b),
    SPH_C32(0x6dd1133c) },
  { SPH_C32(0x22800000), SPH_C32(0xbb030000), SPH_C32(0x6b6e0000),
    SPH_C32(0xd6bb01fb), SPH_C32(0x8616008d), SPH_C32(0xce31783b),
    SPH_C32(0x87d72078), SPH_C32(0x86c25aa1), SPH_C32(0x7aff0000),
    SPH_C32(0xcf880000), SPH_C32(0x9e620000), SPH_C32(0x866c00aa),
    SPH_C32(0x28a600bb), SPH_C32(0x788cbd12), SPH_C32(0x22c4c482),
    SPH_C32(0x2a9a9915) },
  { SPH_C32(0x8a5a0000), SPH_C32(0x2dbd0000), SPH_C32(0x37730000),
    SPH_C32(0xd16101f9), SPH_C32(0xfb70950e), SPH_C32(0xd1a908b1),
    SPH_C32(0x3cb1a870), SPH_C32(0x5c45daa1), SPH_C32(0xd1180000),
    SPH_C32(0x51850000), SPH_C32(0x31450000), SPH_C32(0xbb7400af),
    SPH_C32(0x04e91f68), SPH_C32(0x0c7aab87), SPH_C32(0x97078369),
    SPH_C32(0x16c766eb) },
  { SPH_C32(0xeed70000), SPH_C32(0xa94f0000), SPH_C32(0x48bd0000),
    SPH_C32(0x01bb01e1), SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0),
    SPH_C32(0x463bbd14), SPH_C32(0x9e150dfa), SPH_C32(0x24c40000),
    SPH_C32(0x7e090000), SPH_C32(0x30370000), SPH_C32(0x2d9300b2),
    SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72), SPH_C32(0x70ec30dc),
    SPH_C32(0xf751dc07) },
  { SPH_C32(0x460d0000), SPH_C32(0x3ff10000), SPH_C32(0x14a00000),
    SPH_C32(0x066101e3), SPH_C32(0xd29a7433), SPH_C32(0x8d42175a),
    SPH_C32(0xfd5d351c), SPH_C32(0x44928dfa), SPH_C32(0x8f230000),
    SPH_C32(0xe0040000), SPH_C32(0x9f100000), SPH_C32(0x108b00b7),
    SPH_C32(0xac47148f), SPH_C32(0xa3c88be7), SPH_C32(0xc52f7737),
    SPH_C32(0xcb0c23f9) },
  { SPH_C32(0xef440000), SPH_C32(0x4ecd0000), SPH_C32(0xa5460000),
    SPH_C32(0xceb701ea), SPH_C32(0x222c6ce8), SPH_C32(0x2e79d3fe),
    SPH_C32(0x400ddcf5), SPH_C32(0xcd7a9381), SPH_C32(0xb6ec0000),
    SPH_C32(0xa28c0000), SPH_C32(0x67cd0000), SPH_C32(0x7b4f00b1),
    SPH_C32(0x3ae1284a), SPH_C32(0x8dd13e7e), SPH_C32(0xe022c78e),
    SPH_C32(0x8c47a9d0) },
  { SPH_C32(0x479e0000), SPH_C32(0xd8730000), SPH_C32(0xf95b0000),
    SPH_C32(0xc96d01e8), SPH_C32(0x5f4af96b), SPH_C32(0x31e1a374),
    SPH_C32(0xfb6b54fd), SPH_C32(0x17fd1381), SPH_C32(0x1d0b0000),
    SPH_C32(0x3c810000), SPH_C32(0xc8ea0000), SPH_C32(0x465700b4),
    SPH_C32(0x16ae3799), SPH_C32(0xf92728eb), SPH_C32(0x55e18065),
    SPH_C32(0xb01a562e) },
  { SPH_C32(0x7cff0000), SPH_C32(0x75ca0000), SPH_C32(0x1f470000),
    SPH_C32(0x576701e2), SPH_C32(0x1515c2a6), SPH_C32(0xc835c4dc),
    SPH_C32(0xd6f54a46), SPH_C32(0xe503782d), SPH_C32(0xb77f0000),
    SPH_C32(0x450e0000), SPH_C32(0x8a360000), SPH_C32(0xb44300ba),
    SPH_C32(0xb731a512), SPH_C32(0x31728a50), SPH_C32(0xe614a66f),
    SPH_C32(0xdf2837ab) },
  { SPH_C32(0xd4250000), SPH_C32(0xe3740000), SPH_C32(0x435a0000),
    SPH_C32(0x50bd01e0), SPH_C32(0x68735725), SPH_C32(0xd7adb456),
    SPH_C32(0x6d93c24e), SPH_C32(0x3f84f82d), SPH_C32(0x1c980000),
    SPH_C32(0xdb030000), SPH_C32(0x25110000), SPH_C32(0x895b00bf),
    SPH_C32(0x9b7ebac1), SPH_C32(0x45849cc5), SPH_C32(0x53d7e184),
    SPH_C32(0xe375c855) },
  { SPH_C32(0x7d6c0000), SPH_C32(0x92480000), SPH_C32(0xf2bc0000),
    SPH_C32(0x986b01e9), SPH_C32(0x98c54ffe), SPH_C32(0x749670f2),
    SPH_C32(0xd0c32ba7), SPH_C32(0xb66ce656), SPH_C32(0x25570000),
    SPH_C32(0x998b0000), SPH_C32(0xddcc0000), SPH_C32(0xe29f00b9),
    SPH_C32(0x0dd88604), SPH_C32(0x6b9d295c), SPH_C32(0x76da513d),
    SPH_C32(0xa43e427c) },
  { SPH_C32(0xd5b60000), SPH_C32(0x04f60000), SPH_C32(0xaea10000),
    SPH_C32(0x9fb101eb), SPH_C32(0xe5a3da7d), SPH_C32(0x6b0e0078),
    SPH_C32(0x6ba5a3af), SPH_C32(0x6ceb6656), SPH_C32(0x8eb00000),
    SPH_C32(0x07860000), SPH_C32(0x72eb0000), SPH_C32(0xdf8700bc),
    SPH_C32(0x219799d7), SPH_C32(0x1f6b3fc9), SPH_C32(0xc31916d6),
    SPH_C32(0x9863bd82) },
  { SPH_C32(0xb17f0000), SPH_C32(0xff4c0000), SPH_C32(0x0b130000),
    SPH_C32(0x654801f2), SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e),
    SPH_C32(0x122528ab), SPH_C32(0x10b1d693), SPH_C32(0x24800000),
    SPH_C32(0x01410000), SPH_C32(0xea4b0000), SPH_C32(0x07b000b3),
    SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5), SPH_C32(0x73e6aebc),
    SPH_C32(0x495bbb99) },
  { SPH_C32(0x19a50000), SPH_C32(0x69f20000), SPH_C32(0x570e0000),
    SPH_C32(0x629201f0), SPH_C32(0xf7e4f28c), SPH_C32(0x9e538314),
    SPH_C32(0xa943a0a3), SPH_C32(0xca365693), SPH_C32(0x8f670000),
    SPH_C32(0x9f4c0000), SPH_C32(0x456c0000), SPH_C32(0x3aa800b6),
    SPH_C32(0x97eadd43), SPH_C32(0x0a7e1760), SPH_C32(0xc625e957),
    SPH_C32(0x75064467) },
  { SPH_C32(0xb0ec0000), SPH_C32(0x18ce0000), SPH_C32(0xe6e80000),
    SPH_C32(0xaa4401f9), SPH_C32(0x0752ea57), SPH_C32(0x3d6847b0),
    SPH_C32(0x1413494a), SPH_C32(0x43de48e8), SPH_C32(0xb6a80000),
    SPH_C32(0xddc40000), SPH_C32(0xbdb10000), SPH_C32(0x516c00b0),
    SPH_C32(0x014ce186), SPH_C32(0x2467a2f9), SPH_C32(0xe32859ee),
    SPH_C32(0x324dce4e) },
  { SPH_C32(0x18360000), SPH_C32(0x8e700000), SPH_C32(0xbaf50000),
    SPH_C32(0xad9e01fb), SPH_C32(0x7a347fd4), SPH_C32(0x22f0373a),
    SPH_C32(0xaf75c142), SPH_C32(0x9959c8e8), SPH_C32(0x1d4f0000),
    SPH_C32(0x43c90000), SPH_C32(0x12960000), SPH_C32(0x6c7400b5),
    SPH_C32(0x2d03fe55), SPH_C32(0x5091b46c), SPH_C32(0x56eb1e05),
    SPH_C32(0x0e1031b0) },
  { SPH_C32(0x23570000), SPH_C32(0x23c90000), SPH_C32(0x5ce90000),
    SPH_C32(0x339401f1), SPH_C32(0x306b4419), SPH_C32(0xdb245092),
    SPH_C32(0x82ebdff9), SPH_C32(0x6ba7a344), SPH_C32(0xb73b0000),
    SPH_C32(0x3a460000), SPH_C32(0x504a0000), SPH_C32(0x9e6000bb),
    SPH_C32(0x8c9c6cde), SPH_C32(0x98c416d7), SPH_C32(0xe51e380f),
    SPH_C32(0x61225035) },
  { SPH_C32(0x8b8d0000), SPH_C32(0xb5770000), SPH_C32(0x00f40000),
    SPH_C32(0x344e01f3), SPH_C32(0x4d0dd19a), SPH_C32(0xc4bc2018),
    SPH_C32(0x398d57f1), SPH_C32(0xb1202344), SPH_C32(0x1cdc0000),
    SPH_C32(0xa44b0000), SPH_C32(0xff6d0000), SPH_C32(0xa37800be),
    SPH_C32(0xa0d3730d), SPH_C32(0xec320042), SPH_C32(0x50dd7fe4),
    SPH_C32(0x5d7fafcb) },
  { SPH_C32(0x22c40000), SPH_C32(0xc44b0000), SPH_C32(0xb1120000),
    SPH_C32(0xfc9801fa), SPH_C32(0xbdbbc941), SPH_C32(0x6787e4bc),
    SPH_C32(0x84ddbe18), SPH_C32(0x38c83d3f), SPH_C32(0x25130000),
    SPH_C32(0xe6c30000), SPH_C32(0x07b00000), SPH_C32(0xc8bc00b8),
    SPH_C32(0x36754fc8), SPH_C32(0xc22bb5db), SPH_C32(0x75d0cf5d),
    SPH_C32(0x1a3425e2) },
  { SPH_C32(0x8a1e0000), SPH_C32(0x52f50000), SPH_C32(0xed0f0000),
    SPH_C32(0xfb4201f8), SPH_C32(0xc0dd5cc2), SPH_C32(0x781f9436),
    SPH_C32(0x3fbb3610), SPH_C32(0xe24fbd3f), SPH_C32(0x8ef40000),
    SPH_C32(0x78ce0000), SPH_C32(0xa8970000), SPH_C32(0xf5a400bd),
    SPH_C32(0x1a3a501b), SPH_C32(0xb6dda34e), SPH_C32(0xc01388b6),
    SPH_C32(0x2669da1c) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) },
  { SPH_C32(0xd3f20000), SPH_C32(0xc1fc0000), SPH_C32(0xf5f80000),
    SPH_C32(0x649900a2), SPH_C32(0xe3bdd1ac), SPH_C32(0x7201e531),
    SPH_C32(0x9c9eb30b), SPH_C32(0x1d78e0f0), SPH_C32(0x3e5c0000),
    SPH_C32(0x1f480000), SPH_C32(0x94030000), SPH_C32(0x75c30145),
    SPH_C32(0x26c57380), SPH_C32(0x22037879), SPH_C32(0xd70a5f9c),
    SPH_C32(0xdbbdf56a) },
  { SPH_C32(0x7abb0000), SPH_C32(0xb0c00000), SPH_C32(0x441e0000),
    SPH_C32(0xac4f00ab), SPH_C32(0x130bc977), SPH_C32(0xd13a2195),
    SPH_C32(0x21ce5ae2), SPH_C32(0x9490fe8b), SPH_C32(0x07930000),
    SPH_C32(0x5dc00000), SPH_C32(0x6cde0000), SPH_C32(0x1e070143),
    SPH_C32(0xb0634f45), SPH_C32(0x0c1acde0), SPH_C32(0xf207ef25),
    SPH_C32(0x9cf67f43) },
  { SPH_C32(0xd2610000), SPH_C32(0x267e0000), SPH_C32(0x18030000),
    SPH_C32(0xab9500a9), SPH_C32(0x6e6d5cf4), SPH_C32(0xcea2511f),
    SPH_C32(0x9aa8d2ea), SPH_C32(0x4e177e8b), SPH_C32(0xac740000),
    SPH_C32(0xc3cd0000), SPH_C32(0xc3f90000), SPH_C32(0x231f0146),
    SPH_C32(0x9c2c5096), SPH_C32(0x78ecdb75), SPH_C32(0x47c4a8ce),
    SPH_C32(0xa0ab80bd) },
  { SPH_C32(0xe9000000), SPH_C32(0x8bc70000), SPH_C32(0xfe1f0000),
    SPH_C32(0x359f00a3), SPH_C32(0x24326739), SPH_C32(0x377636b7),
    SPH_C32(0xb736cc51), SPH_C32(0xbce91527), SPH_C32(0x06000000),
    SPH_C32(0xba420000), SPH_C32(0x81250000), SPH_C32(0xd10b0148),
    SPH_C32(0x3db3c21d), SPH_C32(0xb0b979ce), SPH_C32(0xf4318ec4),
    SPH_C32(0xcf99e138) },
  { SPH_C32(0x41da0000), SPH_C32(0x1d790000), SPH_C32(0xa2020000),
    SPH_C32(0x324500a1), SPH_C32(0x5954f2ba), SPH_C32(0x28ee463d),
    SPH_C32(0x0c504459), SPH_C32(0x666e9527), SPH_C32(0xade70000),
    SPH_C32(0x244f0000), SPH_C32(0x2e020000), SPH_C32(0xec13014d),
    SPH_C32(0x11fcddce), SPH_C32(0xc44f6f5b), SPH_C32(0x41f2c92f),
    SPH_C32(0xf3c41ec6) },
  { SPH_C32(0xe8930000), SPH_C32(0x6c450000), SPH_C32(0x13e40000),
    SPH_C32(0xfa9300a8), SPH_C32(0xa9e2ea61), SPH_C32(0x8bd58299),
    SPH_C32(0xb100adb0), SPH_C32(0xef868b5c), SPH_C32(0x94280000),
    SPH_C32(0x66c70000), SPH_C32(0xd6df0000), SPH_C32(0x87d7014b),
    SPH_C32(0x875ae10b), SPH_C32(0xea56dac2), SPH_C32(0x64ff7996),
    SPH_C32(0xb48f94ef) },
  { SPH_C32(0x40490000), SPH_C32(0xfafb0000), SPH_C32(0x4ff90000),
    SPH_C32(0xfd4900aa), SPH_C32(0xd4847fe2), SPH_C32(0x944df213),
    SPH_C32(0x0a6625b8), SPH_C32(0x35010b5c), SPH_C32(0x3fcf0000),
    SPH_C32(0xf8ca0000), SPH_C32(0x79f80000), SPH_C32(0xbacf014e),
    SPH_C32(0xab15fed8), SPH_C32(0x9ea0cc57), SPH_C32(0xd13c3e7d),
    SPH_C32(0x88d26b11) },
  { SPH_C32(0x24800000), SPH_C32(0x01410000), SPH_C32(0xea4b0000),
    SPH_C32(0x07b000b3), SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5),
    SPH_C32(0x73e6aebc), SPH_C32(0x495bbb99), SPH_C32(0x95ff0000),
    SPH_C32(0xfe0d0000), SPH_C32(0xe1580000), SPH_C32(0x62f80141),
    SPH_C32(0x3127a59f), SPH_C32(0xff43f26b), SPH_C32(0x61c38617),
    SPH_C32(0x59ea6d0a) },
  { SPH_C32(0x8c5a0000), SPH_C32(0x97ff0000), SPH_C32(0xb6560000),
    SPH_C32(0x006a00b1), SPH_C32(0xc6c35713), SPH_C32(0x6110717f),
    SPH_C32(0xc88026b4), SPH_C32(0x93dc3b99), SPH_C32(0x3e180000),
    SPH_C32(0x60000000), SPH_C32(0x4e7f0000), SPH_C32(0x5fe00144),
    SPH_C32(0x1d68ba4c), SPH_C32(0x8bb5e4fe), SPH_C32(0xd400c1fc),
    SPH_C32(0x65b792f4) },
  { SPH_C32(0x25130000), SPH_C32(0xe6c30000), SPH_C32(0x07b00000),
    SPH_C32(0xc8bc00b8), SPH_C32(0x36754fc8), SPH_C32(0xc22bb5db),
    SPH_C32(0x75d0cf5d), SPH_C32(0x1a3425e2), SPH_C32(0x07d70000),
    SPH_C32(0x22880000), SPH_C32(0xb6a20000), SPH_C32(0x34240142),
    SPH_C32(0x8bce8689), SPH_C32(0xa5ac5167), SPH_C32(0xf10d7145),
    SPH_C32(0x22fc18dd) },
  { SPH_C32(0x8dc90000), SPH_C32(0x707d0000), SPH_C32(0x5bad0000),
    SPH_C32(0xcf6600ba), SPH_C32(0x4b13da4b), SPH_C32(0xddb3c551),
    SPH_C32(0xceb64755), SPH_C32(0xc0b3a5e2), SPH_C32(0xac300000),
    SPH_C32(0xbc850000), SPH_C32(0x19850000), SPH_C32(0x093c0147),
    SPH_C32(0xa781995a), SPH_C32(0xd15a47f2), SPH_C32(0x44ce36ae),
    SPH_C32(0x1ea1e723) },
  { SPH_C32(0xb6a80000), SPH_C32(0xddc40000), SPH_C32(0xbdb10000),
    SPH_C32(0x516c00b0), SPH_C32(0x014ce186), SPH_C32(0x2467a2f9),
    SPH_C32(0xe32859ee), SPH_C32(0x324dce4e), SPH_C32(0x06440000),
    SPH_C32(0xc50a0000), SPH_C32(0x5b590000), SPH_C32(0xfb280149),
    SPH_C32(0x061e0bd1), SPH_C32(0x190fe549), SPH_C32(0xf73b10a4),
    SPH_C32(0x719386a6) },
  { SPH_C32(0x1e720000), SPH_C32(0x4b7a0000), SPH_C32(0xe1ac0000),
    SPH_C32(0x56b600b2), SPH_C32(0x7c2a7405), SPH_C32(0x3bffd273),
    SPH_C32(0x584ed1e6), SPH_C32(0xe8ca4e4e), SPH_C32(0xada30000),
    SPH_C32(0x5b070000), SPH_C32(0xf47e0000), SPH_C32(0xc630014c),
    SPH_C32(0x2a511402), SPH_C32(0x6df9f3dc), SPH_C32(0x42f8574f),
    SPH_C32(0x4dce7958) },
  { SPH_C32(0xb73b0000), SPH_C32(0x3a460000), SPH_C32(0x504a0000),
    SPH_C32(0x9e6000bb), SPH_C32(0x8c9c6cde), SPH_C32(0x98c416d7),
    SPH_C32(0xe51e380f), SPH_C32(0x61225035), SPH_C32(0x946c0000),
    SPH_C32(0x198f0000), SPH_C32(0x0ca30000), SPH_C32(0xadf4014a),
    SPH_C32(0xbcf728c7), SPH_C32(0x43e04645), SPH_C32(0x67f5e7f6),
    SPH_C32(0x0a85f371) },
  { SPH_C32(0x1fe10000), SPH_C32(0xacf80000), SPH_C32(0x0c570000),
    SPH_C32(0x99ba00b9), SPH_C32(0xf1faf95d), SPH_C32(0x875c665d),
    SPH_C32(0x5e78b007), SPH_C32(0xbba5d035), SPH_C32(0x3f8b0000),
    SPH_C32(0x87820000), SPH_C32(0xa3840000), SPH_C32(0x90ec014f),
    SPH_C32(0x90b83714), SPH_C32(0x371650d0), SPH_C32(0xd236a01d),
    SPH_C32(0x36d80c8f) },
  { SPH_C32(0x7b6c0000), SPH_C32(0x280a0000), SPH_C32(0x73990000),
    SPH_C32(0x496000a1), SPH_C32(0xa5768de3), SPH_C32(0xc42f093c),
    SPH_C32(0x24f2a563), SPH_C32(0x79f5076e), SPH_C32(0xca570000),
    SPH_C32(0xa80e0000), SPH_C32(0xa2f60000), SPH_C32(0x060b0152),
    SPH_C32(0x14592320), SPH_C32(0xec526625), SPH_C32(0x35dd13a8),
    SPH_C32(0xd74eb663) },
  { SPH_C32(0xd3b60000), SPH_C32(0xbeb40000), SPH_C32(0x2f840000),
    SPH_C32(0x4eba00a3), SPH_C32(0xd8101860), SPH_C32(0xdbb779b6),
    SPH_C32(0x9f942d6b), SPH_C32(0xa372876e), SPH_C32(0x61b00000),
    SPH_C32(0x36030000), SPH_C32(0x0dd10000), SPH_C32(0x3b130157),
    SPH_C32(0x38163cf3), SPH_C32(0x98a470b0), SPH_C32(0x801e5443),
    SPH_C32(0xeb13499d) },
  { SPH_C32(0x7aff0000), SPH_C32(0xcf880000), SPH_C32(0x9e620000),
    SPH_C32(0x866c00aa), SPH_C32(0x28a600bb), SPH_C32(0x788cbd12),
    SPH_C32(0x22c4c482), SPH_C32(0x2a9a9915), SPH_C32(0x587f0000),
    SPH_C32(0x748b0000), SPH_C32(0xf50c0000), SPH_C32(0x50d70151),
    SPH_C32(0xaeb00036), SPH_C32(0xb6bdc529), SPH_C32(0xa513e4fa),
    SPH_C32(0xac58c3b4) },
  { SPH_C32(0xd2250000), SPH_C32(0x59360000), SPH_C32(0xc27f0000),
    SPH_C32(0x81b600a8), SPH_C32(0x55c09538), SPH_C32(0x6714cd98),
    SPH_C32(0x99a24c8a), SPH_C32(0xf01d1915), SPH_C32(0xf3980000),
    SPH_C32(0xea860000), SPH_C32(0x5a2b0000), SPH_C32(0x6dcf0154),
    SPH_C32(0x82ff1fe5), SPH_C32(0xc24bd3bc), SPH_C32(0x10d0a311),
    SPH_C32(0x90053c4a) },
  { SPH_C32(0xe9440000), SPH_C32(0xf48f0000), SPH_C32(0x24630000),
    SPH_C32(0x1fbc00a2), SPH_C32(0x1f9faef5), SPH_C32(0x9ec0aa30),
    SPH_C32(0xb43c5231), SPH_C32(0x02e372b9), SPH_C32(0x59ec0000),
    SPH_C32(0x93090000), SPH_C32(0x18f70000), SPH_C32(0x9fdb015a),
    SPH_C32(0x23608d6e), SPH_C32(0x0a1e7107), SPH_C32(0xa325851b),
    SPH_C32(0xff375dcf) },
  { SPH_C32(0x419e0000), SPH_C32(0x62310000), SPH_C32(0x787e0000),
    SPH_C32(0x186600a0), SPH_C32(0x62f93b76), SPH_C32(0x8158daba),
    SPH_C32(0x0f5ada39), SPH_C32(0xd864f2b9), SPH_C32(0xf20b0000),
    SPH_C32(0x0d040000), SPH_C32(0xb7d00000), SPH_C32(0xa2c3015f),
    SPH_C32(0x0f2f92bd), SPH_C32(0x7ee86792), SPH_C32(0x16e6c2f0),
    SPH_C32(0xc36aa231) },
  { SPH_C32(0xe8d70000), SPH_C32(0x130d0000), SPH_C32(0xc9980000),
    SPH_C32(0xd0b000a9), SPH_C32(0x924f23ad), SPH_C32(0x22631e1e),
    SPH_C32(0xb20a33d0), SPH_C32(0x518cecc2), SPH_C32(0xcbc40000),
    SPH_C32(0x4f8c0000), SPH_C32(0x4f0d0000), SPH_C32(0xc9070159),
    SPH_C32(0x9989ae78), SPH_C32(0x50f1d20b), SPH_C32(0x33eb7249),
    SPH_C32(0x84212818) },
  { SPH_C32(0x400d0000), SPH_C32(0x85b30000), SPH_C32(0x95850000),
    SPH_C32(0xd76a00ab), SPH_C32(0xef29b62e), SPH_C32(0x3dfb6e94),
    SPH_C32(0x096cbbd8), SPH_C32(0x8b0b6cc2), SPH_C32(0x60230000),
    SPH_C32(0xd1810000), SPH_C32(0xe02a0000), SPH_C32(0xf41f015c),
    SPH_C32(0xb5c6b1ab), SPH_C32(0x2407c49e), SPH_C32(0x862835a2),
    SPH_C32(0xb87cd7e6) },
  { SPH_C32(0x24c40000), SPH_C32(0x7e090000), SPH_C32(0x30370000),
    SPH_C32(0x2d9300b2), SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72),
    SPH_C32(0x70ec30dc), SPH_C32(0xf751dc07), SPH_C32(0xca130000),
    SPH_C32(0xd7460000), SPH_C32(0x788a0000), SPH_C32(0x2c280153),
    SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2), SPH_C32(0x36d78dc8),
    SPH_C32(0x6944d1fd) },
  { SPH_C32(0x8c1e0000), SPH_C32(0xe8b70000), SPH_C32(0x6c2a0000),
    SPH_C32(0x2a4900b0), SPH_C32(0xfd6e9edf), SPH_C32(0xc8a6edf8),
    SPH_C32(0xcb8ab8d4), SPH_C32(0x2dd65c07), SPH_C32(0x61f40000),
    SPH_C32(0x494b0000), SPH_C32(0xd7ad0000), SPH_C32(0x11300156),
    SPH_C32(0x03bbf53f), SPH_C32(0x3112ec37), SPH_C32(0x8314ca23),
    SPH_C32(0x55192e03) },
  { SPH_C32(0x25570000), SPH_C32(0x998b0000), SPH_C32(0xddcc0000),
    SPH_C32(0xe29f00b9), SPH_C32(0x0dd88604), SPH_C32(0x6b9d295c),
    SPH_C32(0x76da513d), SPH_C32(0xa43e427c), SPH_C32(0x583b0000),
    SPH_C32(0x0bc30000), SPH_C32(0x2f700000), SPH_C32(0x7af40150),
    SPH_C32(0x951dc9fa), SPH_C32(0x1f0b59ae), SPH_C32(0xa6197a9a),
    SPH_C32(0x1252a42a) },
  { SPH_C32(0x8d8d0000), SPH_C32(0x0f350000), SPH_C32(0x81d10000),
    SPH_C32(0xe54500bb), SPH_C32(0x70be1387), SPH_C32(0x740559d6),
    SPH_C32(0xcdbcd935), SPH_C32(0x7eb9c27c), SPH_C32(0xf3dc0000),
    SPH_C32(0x95ce0000), SPH_C32(0x80570000), SPH_C32(0x47ec0155),
    SPH_C32(0xb952d629), SPH_C32(0x6bfd4f3b), SPH_C32(0x13da3d71),
    SPH_C32(0x2e0f5bd4) },
  { SPH_C32(0xb6ec0000), SPH_C32(0xa28c0000), SPH_C32(0x67cd0000),
    SPH_C32(0x7b4f00b1), SPH_C32(0x3ae1284a), SPH_C32(0x8dd13e7e),
    SPH_C32(0xe022c78e), SPH_C32(0x8c47a9d0), SPH_C32(0x59a80000),
    SPH_C32(0xec410000), SPH_C32(0xc28b0000), SPH_C32(0xb5f8015b),
    SPH_C32(0x18cd44a2), SPH_C32(0xa3a8ed80), SPH_C32(0xa02f1b7b),
    SPH_C32(0x413d3a51) },
  { SPH_C32(0x1e360000), SPH_C32(0x34320000), SPH_C32(0x3bd00000),
    SPH_C32(0x7c9500b3), SPH_C32(0x4787bdc9), SPH_C32(0x92494ef4),
    SPH_C32(0x5b444f86), SPH_C32(0x56c029d0), SPH_C32(0xf24f0000),
    SPH_C32(0x724c0000), SPH_C32(0x6dac0000), SPH_C32(0x88e0015e),
    SPH_C32(0x34825b71), SPH_C32(0xd75efb15), SPH_C32(0x15ec5c90),
    SPH_C32(0x7d60c5af) },
  { SPH_C32(0xb77f0000), SPH_C32(0x450e0000), SPH_C32(0x8a360000),
    SPH_C32(0xb44300ba), SPH_C32(0xb731a512), SPH_C32(0x31728a50),
    SPH_C32(0xe614a66f), SPH_C32(0xdf2837ab), SPH_C32(0xcb800000),
    SPH_C32(0x30c40000), SPH_C32(0x95710000), SPH_C32(0xe3240158),
    SPH_C32(0xa22467b4), SPH_C32(0xf9474e8c), SPH_C32(0x30e1ec29),
    SPH_C32(0x3a2b4f86) },
  { SPH_C32(0x1fa50000), SPH_C32(0xd3b00000), SPH_C32(0xd62b0000),
    SPH_C32(0xb39900b8), SPH_C32(0xca573091), SPH_C32(0x2eeafada),
    SPH_C32(0x5d722e67), SPH_C32(0x05afb7ab), SPH_C32(0x60670000),
    SPH_C32(0xaec90000), SPH_C32(0x3a560000), SPH_C32(0xde3c015d),
    SPH_C32(0x8e6b7867), SPH_C32(0x8db15819), SPH_C32(0x8522abc2),
    SPH_C32(0x0676b078) },
  { SPH_C32(0x95bb0000), SPH_C32(0x81450000), SPH_C32(0x3b240000),
    SPH_C32(0x48db0140), SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec),
    SPH_C32(0x62c91877), SPH_C32(0xe7e00a94), SPH_C32(0xee930000),
    SPH_C32(0xd6070000), SPH_C32(0x92c10000), SPH_C32(0x2b9801e0),
    SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57), SPH_C32(0x45312374),
    SPH_C32(0x201f6a64) },
  { SPH_C32(0x3d610000), SPH_C32(0x17fb0000), SPH_C32(0x67390000),
    SPH_C32(0x4f010142), SPH_C32(0x77ecf9d0), SPH_C32(0x496d1e66),
    SPH_C32(0xd9af907f), SPH_C32(0x3d678a94), SPH_C32(0x45740000),
    SPH_C32(0x480a0000), SPH_C32(0x3de60000), SPH_C32(0x168001e5),
    SPH_C32(0xb81e37af), SPH_C32(0x4f9aedc2), SPH_C32(0xf0f2649f),
    SPH_C32(0x1c42959a) },
  { SPH_C32(0x94280000), SPH_C32(0x66c70000), SPH_C32(0xd6df0000),
    SPH_C32(0x87d7014b), SPH_C32(0x875ae10b), SPH_C32(0xea56dac2),
    SPH_C32(0x64ff7996), SPH_C32(0xb48f94ef), SPH_C32(0x7cbb0000),
    SPH_C32(0x0a820000), SPH_C32(0xc53b0000), SPH_C32(0x7d4401e3),
    SPH_C32(0x2eb80b6a), SPH_C32(0x6183585b), SPH_C32(0xd5ffd426),
    SPH_C32(0x5b091fb3) },
  { SPH_C32(0x3cf20000), SPH_C32(0xf0790000), SPH_C32(0x8ac20000),
    SPH_C32(0x800d0149), SPH_C32(0xfa3c7488), SPH_C32(0xf5ceaa48),
    SPH_C32(0xdf99f19e), SPH_C32(0x6e0814ef), SPH_C32(0xd75c0000),
    SPH_C32(0x948f0000), SPH_C32(0x6a1c0000), SPH_C32(0x405c01e6),
    SPH_C32(0x02f714b9), SPH_C32(0x15754ece), SPH_C32(0x603c93cd),
    SPH_C32(0x6754e04d) },
  { SPH_C32(0x07930000), SPH_C32(0x5dc00000), SPH_C32(0x6cde0000),
    SPH_C32(0x1e070143), SPH_C32(0xb0634f45), SPH_C32(0x0c1acde0),
    SPH_C32(0xf207ef25), SPH_C32(0x9cf67f43), SPH_C32(0x7d280000),
    SPH_C32(0xed000000), SPH_C32(0x28c00000), SPH_C32(0xb24801e8),
    SPH_C32(0xa3688632), SPH_C32(0xdd20ec75), SPH_C32(0xd3c9b5c7),
    SPH_C32(0x086681c8) },
  { SPH_C32(0xaf490000), SPH_C32(0xcb7e0000), SPH_C32(0x30c30000),
    SPH_C32(0x19dd0141), SPH_C32(0xcd05dac6), SPH_C32(0x1382bd6a),
    SPH_C32(0x4961672d), SPH_C32(0x4671ff43), SPH_C32(0xd6cf0000),
    SPH_C32(0x730d0000), SPH_C32(0x87e70000), SPH_C32(0x8f5001ed),
    SPH_C32(0x8f2799e1), SPH_C32(0xa9d6fae0), SPH_C32(0x660af22c),
    SPH_C32(0x343b7e36) },
  { SPH_C32(0x06000000), SPH_C32(0xba420000), SPH_C32(0x81250000),
    SPH_C32(0xd10b0148), SPH_C32(0x3db3c21d), SPH_C32(0xb0b979ce),
    SPH_C32(0xf4318ec4), SPH_C32(0xcf99e138), SPH_C32(0xef000000),
    SPH_C32(0x31850000), SPH_C32(0x7f3a0000), SPH_C32(0xe49401eb),
    SPH_C32(0x1981a524), SPH_C32(0x87cf4f79), SPH_C32(0x43074295),
    SPH_C32(0x7370f41f) },
  { SPH_C32(0xaeda0000), SPH_C32(0x2cfc0000), SPH_C32(0xdd380000),
    SPH_C32(0xd6d1014a), SPH_C32(0x40d5579e), SPH_C32(0xaf210944),
    SPH_C32(0x4f5706cc), SPH_C32(0x151e6138), SPH_C32(0x44e70000),
    SPH_C32(0xaf880000), SPH_C32(0xd01d0000), SPH_C32(0xd98c01ee),
    SPH_C32(0x35cebaf7), SPH_C32(0xf33959ec), SPH_C32(0xf6c4057e),
    SPH_C32(0x4f2d0be1) },
  { SPH_C32(0xca130000), SPH_C32(0xd7460000), SPH_C32(0x788a0000),
    SPH_C32(0x2c280153), SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2),
    SPH_C32(0x36d78dc8), SPH_C32(0x6944d1fd), SPH_C32(0xeed70000),
    SPH_C32(0xa94f0000), SPH_C32(0x48bd0000), SPH_C32(0x01bb01e1),
    SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0), SPH_C32(0x463bbd14),
    SPH_C32(0x9e150dfa) },
  { SPH_C32(0x62c90000), SPH_C32(0x41f80000), SPH_C32(0x24970000),
    SPH_C32(0x2bf20151), SPH_C32(0x52927f6f), SPH_C32(0x5a7c8a28),
    SPH_C32(0x8db105c0), SPH_C32(0xb3c351fd), SPH_C32(0x45300000),
    SPH_C32(0x37420000), SPH_C32(0xe79a0000), SPH_C32(0x3ca301e4),
    SPH_C32(0x83b3fe63), SPH_C32(0xe62c7145), SPH_C32(0xf3f8faff),
    SPH_C32(0xa248f204) },
  { SPH_C32(0xcb800000), SPH_C32(0x30c40000), SPH_C32(0x95710000),
    SPH_C32(0xe3240158), SPH_C32(0xa22467b4), SPH_C32(0xf9474e8c),
    SPH_C32(0x30e1ec29), SPH_C32(0x3a2b4f86), SPH_C32(0x7cff0000),
    SPH_C32(0x75ca0000), SPH_C32(0x1f470000), SPH_C32(0x576701e2),
    SPH_C32(0x1515c2a6), SPH_C32(0xc835c4dc), SPH_C32(0xd6f54a46),
    SPH_C32(0xe503782d) },
  { SPH_C32(0x635a0000), SPH_C32(0xa67a0000), SPH_C32(0xc96c0000),
    SPH_C32(0xe4fe015a), SPH_C32(0xdf42f237), SPH_C32(0xe6df3e06),
    SPH_C32(0x8b876421), SPH_C32(0xe0accf86), SPH_C32(0xd7180000),
    SPH_C32(0xebc70000), SPH_C32(0xb0600000), SPH_C32(0x6a7f01e7),
    SPH_C32(0x395add75), SPH_C32(0xbcc3d249), SPH_C32(0x63360dad),
    SPH_C32(0xd95e87d3) },
  { SPH_C32(0x583b0000), SPH_C32(0x0bc30000), SPH_C32(0x2f700000),
    SPH_C32(0x7af40150), SPH_C32(0x951dc9fa), SPH_C32(0x1f0b59ae),
    SPH_C32(0xa6197a9a), SPH_C32(0x1252a42a), SPH_C32(0x7d6c0000),
    SPH_C32(0x92480000), SPH_C32(0xf2bc0000), SPH_C32(0x986b01e9),
    SPH_C32(0x98c54ffe), SPH_C32(0x749670f2), SPH_C32(0xd0c32ba7),
    SPH_C32(0xb66ce656) },
  { SPH_C32(0xf0e10000), SPH_C32(0x9d7d0000), SPH_C32(0x736d0000),
    SPH_C32(0x7d2e0152), SPH_C32(0xe87b5c79), SPH_C32(0x00932924),
    SPH_C32(0x1d7ff292), SPH_C32(0xc8d5242a), SPH_C32(0xd68b0000),
    SPH_C32(0x0c450000), SPH_C32(0x5d9b0000), SPH_C32(0xa57301ec),
    SPH_C32(0xb48a502d), SPH_C32(0x00606667), SPH_C32(0x65006c4c),
    SPH_C32(0x8a3119a8) },
  { SPH_C32(0x59a80000), SPH_C32(0xec410000), SPH_C32(0xc28b0000),
    SPH_C32(0xb5f8015b), SPH_C32(0x18cd44a2), SPH_C32(0xa3a8ed80),
    SPH_C32(0xa02f1b7b), SPH_C32(0x413d3a51), SPH_C32(0xef440000),
    SPH_C32(0x4ecd0000), SPH_C32(0xa5460000), SPH_C32(0xceb701ea),
    SPH_C32(0x222c6ce8), SPH_C32(0x2e79d3fe), SPH_C32(0x400ddcf5),
    SPH_C32(0xcd7a9381) },
  { SPH_C32(0xf1720000), SPH_C32(0x7aff0000), SPH_C32(0x9e960000),
    SPH_C32(0xb2220159), SPH_C32(0x65abd121), SPH_C32(0xbc309d0a),
    SPH_C32(0x1b499373), SPH_C32(0x9bbaba51), SPH_C32(0x44a30000),
    SPH_C32(0xd0c00000), SPH_C32(0x0a610000), SPH_C32(0xf3af01ef),
    SPH_C32(0x0e63733b), SPH_C32(0x5a8fc56b), SPH_C32(0xf5ce9b1e),
    SPH_C32(0xf1276c7f) },
  { SPH_C32(0x95ff0000), SPH_C32(0xfe0d0000), SPH_C32(0xe1580000),
    SPH_C32(0x62f80141), SPH_C32(0x3127a59f), SPH_C32(0xff43f26b),
    SPH_C32(0x61c38617), SPH_C32(0x59ea6d0a), SPH_C32(0xb17f0000),
    SPH_C32(0xff4c0000), SPH_C32(0x0b130000), SPH_C32(0x654801f2),
    SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e), SPH_C32(0x122528ab),
    SPH_C32(0x10b1d693) },
  { SPH_C32(0x3d250000), SPH_C32(0x68b30000), SPH_C32(0xbd450000),
    SPH_C32(0x65220143), SPH_C32(0x4c41301c), SPH_C32(0xe0db82e1),
    SPH_C32(0xdaa50e1f), SPH_C32(0x836ded0a), SPH_C32(0x1a980000),
    SPH_C32(0x61410000), SPH_C32(0xa4340000), SPH_C32(0x585001f7),
    SPH_C32(0xa6cd78dc), SPH_C32(0xf53de50b), SPH_C32(0xa7e66f40),
    SPH_C32(0x2cec296d) },
  { SPH_C32(0x946c0000), SPH_C32(0x198f0000), SPH_C32(0x0ca30000),
    SPH_C32(0xadf4014a), SPH_C32(0xbcf728c7), SPH_C32(0x43e04645),
    SPH_C32(0x67f5e7f6), SPH_C32(0x0a85f371), SPH_C32(0x23570000),
    SPH_C32(0x23c90000), SPH_C32(0x5ce90000), SPH_C32(0x339401f1),
    SPH_C32(0x306b4419), SPH_C32(0xdb245092), SPH_C32(0x82ebdff9),
    SPH_C32(0x6ba7a344) },
  { SPH_C32(0x3cb60000), SPH_C32(0x8f310000), SPH_C32(0x50be0000),
    SPH_C32(0xaa2e0148), SPH_C32(0xc191bd44), SPH_C32(0x5c7836cf),
    SPH_C32(0xdc936ffe), SPH_C32(0xd0027371), SPH_C32(0x88b00000),
    SPH_C32(0xbdc40000), SPH_C32(0xf3ce0000), SPH_C32(0x0e8c01f4),
    SPH_C32(0x1c245bca), SPH_C32(0xafd24607), SPH_C32(0x37289812),
    SPH_C32(0x57fa5cba) },
  { SPH_C32(0x07d70000), SPH_C32(0x22880000), SPH_C32(0xb6a20000),
    SPH_C32(0x34240142), SPH_C32(0x8bce8689), SPH_C32(0xa5ac5167),
    SPH_C32(0xf10d7145), SPH_C32(0x22fc18dd), SPH_C32(0x22c40000),
    SPH_C32(0xc44b0000), SPH_C32(0xb1120000), SPH_C32(0xfc9801fa),
    SPH_C32(0xbdbbc941), SPH_C32(0x6787e4bc), SPH_C32(0x84ddbe18),
    SPH_C32(0x38c83d3f) },
  { SPH_C32(0xaf0d0000), SPH_C32(0xb4360000), SPH_C32(0xeabf0000),
    SPH_C32(0x33fe0140), SPH_C32(0xf6a8130a), SPH_C32(0xba3421ed),
    SPH_C32(0x4a6bf94d), SPH_C32(0xf87b98dd), SPH_C32(0x89230000),
    SPH_C32(0x5a460000), SPH_C32(0x1e350000), SPH_C32(0xc18001ff),
    SPH_C32(0x91f4d692), SPH_C32(0x1371f229), SPH_C32(0x311ef9f3),
    SPH_C32(0x0495c2c1) },
  { SPH_C32(0x06440000), SPH_C32(0xc50a0000), SPH_C32(0x5b590000),
    SPH_C32(0xfb280149), SPH_C32(0x061e0bd1), SPH_C32(0x190fe549),
    SPH_C32(0xf73b10a4), SPH_C32(0x719386a6), SPH_C32(0xb0ec0000),
    SPH_C32(0x18ce0000), SPH_C32(0xe6e80000), SPH_C32(0xaa4401f9),
    SPH_C32(0x0752ea57), SPH_C32(0x3d6847b0), SPH_C32(0x1413494a),
    SPH_C32(0x43de48e8) },
  { SPH_C32(0xae9e0000), SPH_C32(0x53b40000), SPH_C32(0x07440000),
    SPH_C32(0xfcf2014b), SPH_C32(0x7b789e52), SPH_C32(0x069795c3),
    SPH_C32(0x4c5d98ac), SPH_C32(0xab1406a6), SPH_C32(0x1b0b0000),
    SPH_C32(0x86c30000), SPH_C32(0x49cf0000), SPH_C32(0x975c01fc),
    SPH_C32(0x2b1df584), SPH_C32(0x499e5125), SPH_C32(0xa1d00ea1),
    SPH_C32(0x7f83b716) },
  { SPH_C32(0xca570000), SPH_C32(0xa80e0000), SPH_C32(0xa2f60000),
    SPH_C32(0x060b0152), SPH_C32(0x14592320), SPH_C32(0xec526625),
    SPH_C32(0x35dd13a8), SPH_C32(0xd74eb663), SPH_C32(0xb13b0000),
    SPH_C32(0x80040000), SPH_C32(0xd16f0000), SPH_C32(0x4f6b01f3),
    SPH_C32(0xb12faec3), SPH_C32(0x287d6f19), SPH_C32(0x112fb6cb),
    SPH_C32(0xaebbb10d) },
  { SPH_C32(0x628d0000), SPH_C32(0x3eb00000), SPH_C32(0xfeeb0000),
    SPH_C32(0x01d10150), SPH_C32(0x693fb6a3), SPH_C32(0xf3ca16af),
    SPH_C32(0x8ebb9ba0), SPH_C32(0x0dc93663), SPH_C32(0x1adc0000),
    SPH_C32(0x1e090000), SPH_C32(0x7e480000), SPH_C32(0x727301f6),
    SPH_C32(0x9d60b110), SPH_C32(0x5c8b798c), SPH_C32(0xa4ecf120),
    SPH_C32(0x92e64ef3) },
  { SPH_C32(0xcbc40000), SPH_C32(0x4f8c0000), SPH_C32(0x4f0d0000),
    SPH_C32(0xc9070159), SPH_C32(0x9989ae78), SPH_C32(0x50f1d20b),
    SPH_C32(0x33eb7249), SPH_C32(0x84212818), SPH_C32(0x23130000),
    SPH_C32(0x5c810000), SPH_C32(0x86950000), SPH_C32(0x19b701f0),
    SPH_C32(0x0bc68dd5), SPH_C32(0x7292cc15), SPH_C32(0x81e14199),
    SPH_C32(0xd5adc4da) },
  { SPH_C32(0x631e0000), SPH_C32(0xd9320000), SPH_C32(0x13100000),
    SPH_C32(0xcedd015b), SPH_C32(0xe4ef3bfb), SPH_C32(0x4f69a281),
    SPH_C32(0x888dfa41), SPH_C32(0x5ea6a818), SPH_C32(0x88f40000),
    SPH_C32(0xc28c0000), SPH_C32(0x29b20000), SPH_C32(0x24af01f5),
    SPH_C32(0x27899206), SPH_C32(0x0664da80), SPH_C32(0x34220672),
    SPH_C32(0xe9f03b24) },
  { SPH_C32(0x587f0000), SPH_C32(0x748b0000), SPH_C32(0xf50c0000),
    SPH_C32(0x50d70151), SPH_C32(0xaeb00036), SPH_C32(0xb6bdc529),
    SPH_C32(0xa513e4fa), SPH_C32(0xac58c3b4), SPH_C32(0x22800000),
    SPH_C32(0xbb030000), SPH_C32(0x6b6e0000), SPH_C32(0xd6bb01fb),
    SPH_C32(0x8616008d), SPH_C32(0xce31783b), SPH_C32(0x87d72078),
    SPH_C32(0x86c25aa1) },
  { SPH_C32(0xf0a50000), SPH_C32(0xe2350000), SPH_C32(0xa9110000),
    SPH_C32(0x570d0153), SPH_C32(0xd3d695b5), SPH_C32(0xa925b5a3),
    SPH_C32(0x1e756cf2), SPH_C32(0x76df43b4), SPH_C32(0x89670000),
    SPH_C32(0x250e0000), SPH_C32(0xc4490000), SPH_C32(0xeba301fe),
    SPH_C32(0xaa591f5e), SPH_C32(0xbac76eae), SPH_C32(0x32146793),
    SPH_C32(0xba9fa55f) },
  { SPH_C32(0x59ec0000), SPH_C32(0x93090000), SPH_C32(0x18f70000),
    SPH_C32(0x9fdb015a), SPH_C32(0x23608d6e), SPH_C32(0x0a1e7107),
    SPH_C32(0xa325851b), SPH_C32(0xff375dcf), SPH_C32(0xb0a80000),
    SPH_C32(0x67860000), SPH_C32(0x3c940000), SPH_C32(0x806701f8),
    SPH_C32(0x3cff239b), SPH_C32(0x94dedb37), SPH_C32(0x1719d72a),
    SPH_C32(0xfdd42f76) },
  { SPH_C32(0xf1360000), SPH_C32(0x05b70000), SPH_C32(0x44ea0000),
    SPH_C32(0x98010158), SPH_C32(0x5e0618ed), SPH_C32(0x1586018d),
    SPH_C32(0x18430d13), SPH_C32(0x25b0ddcf), SPH_C32(0x1b4f0000),
    SPH_C32(0xf98b0000), SPH_C32(0x93b30000), SPH_C32(0xbd7f01fd),
    SPH_C32(0x10b03c48), SPH_C32(0xe028cda2), SPH_C32(0xa2da90c1),
    SPH_C32(0xc189d088) }
};

__constant static const sph_u32 T512_63[2][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) }
};

#define INPUT_BIG   do { \
    unsigned acc = buf(0); \
    __constant const sph_u32 *rp; \
    rp = &T512_0[acc >> 1][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    m8 = rp[8]; \
    m9 = rp[9]; \
    mA = rp[10]; \
    mB = rp[11]; \
    mC = rp[12]; \
    mD = rp[13]; \
    mE = rp[14]; \
    mF = rp[15]; \
    acc = (acc << 8) | buf(1); \
    rp = &T512_7[(acc >> 2) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(2); \
    rp = &T512_14[(acc >> 3) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(3); \
    rp = &T512_21[(acc >> 4) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(4); \
    rp = &T512_28[(acc >> 5) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(5); \
    rp = &T512_35[(acc >> 6) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = (acc << 8) | buf(6); \
    rp = &T512_42[(acc >> 7) & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_49[acc & 0x7f][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(7); \
    rp = &T512_56[acc >> 1][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    rp = &T512_63[acc & 0x01][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
  } while (0)

#endif

#if SPH_HAMSI_EXPAND_BIG == 8

__constant static const sph_u32 T512_0[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xef0b0270), SPH_C32(0x3afd0000), SPH_C32(0x5dae0000),
    SPH_C32(0x69490000), SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9),
    SPH_C32(0x66140a51), SPH_C32(0x924f5d0a), SPH_C32(0xc96b0030),
    SPH_C32(0xe7250000), SPH_C32(0x2f840000), SPH_C32(0x264f0000),
    SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137), SPH_C32(0x509f6984),
    SPH_C32(0x9e69af68) },
  { SPH_C32(0xc96b0030), SPH_C32(0xe7250000), SPH_C32(0x2f840000),
    SPH_C32(0x264f0000), SPH_C32(0x08695bf9), SPH_C32(0x6dfcf137),
    SPH_C32(0x509f6984), SPH_C32(0x9e69af68), SPH_C32(0x26600240),
    SPH_C32(0xddd80000), SPH_C32(0x722a0000), SPH_C32(0x4f060000),
    SPH_C32(0x936667ff), SPH_C32(0x29f944ce), SPH_C32(0x368b63d5),
    SPH_C32(0x0c26f262) },
  { SPH_C32(0x26600240), SPH_C32(0xddd80000), SPH_C32(0x722a0000),
    SPH_C32(0x4f060000), SPH_C32(0x936667ff), SPH_C32(0x29f944ce),
    SPH_C32(0x368b63d5), SPH_C32(0x0c26f262), SPH_C32(0xef0b0270),
    SPH_C32(0x3afd0000), SPH_C32(0x5dae0000), SPH_C32(0x69490000),
    SPH_C32(0x9b0f3c06), SPH_C32(0x4405b5f9), SPH_C32(0x66140a51),
    SPH_C32(0x924f5d0a) },
  { SPH_C32(0x145a3c00), SPH_C32(0xb9e90000), SPH_C32(0x61270000),
    SPH_C32(0xf1610000), SPH_C32(0xce613d6c), SPH_C32(0xb0493d78),
    SPH_C32(0x47a96720), SPH_C32(0xe18e24c5), SPH_C32(0x23671400),
    SPH_C32(0xc8b90000), SPH_C32(0xf4c70000), SPH_C32(0xfb750000),
    SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549), SPH_C32(0x02c40a3f),
    SPH_C32(0xdc24e61f) },
  { SPH_C32(0xfb513e70), SPH_C32(0x83140000), SPH_C32(0x3c890000),
    SPH_C32(0x98280000), SPH_C32(0x556e016a), SPH_C32(0xf44c8881),
    SPH_C32(0x21bd6d71), SPH_C32(0x73c179cf), SPH_C32(0xea0c1430),
    SPH_C32(0x2f9c0000), SPH_C32(0xdb430000), SPH_C32(0xdd3a0000),
    SPH_C32(0x7ba47f9c), SPH_C32(0x955a547e), SPH_C32(0x525b63bb),
    SPH_C32(0x424d4977) },
  { SPH_C32(0xdd313c30), SPH_C32(0x5ecc0000), SPH_C32(0x4ea30000),
    SPH_C32(0xd72e0000), SPH_C32(0xc6086695), SPH_C32(0xddb5cc4f),
    SPH_C32(0x17360ea4), SPH_C32(0x7fe78bad), SPH_C32(0x05071640),
    SPH_C32(0x15610000), SPH_C32(0x86ed0000), SPH_C32(0xb4730000),
    SPH_C32(0xe0ab439a), SPH_C32(0xd15fe187), SPH_C32(0x344f69ea),
    SPH_C32(0xd002147d) },
  { SPH_C32(0x323a3e40), SPH_C32(0x64310000), SPH_C32(0x130d0000),
    SPH_C32(0xbe670000), SPH_C32(0x5d075a93), SPH_C32(0x99b079b6),
    SPH_C32(0x712204f5), SPH_C32(0xeda8d6a7), SPH_C32(0xcc6c1670),
    SPH_C32(0xf2440000), SPH_C32(0xa9690000), SPH_C32(0x923c0000),
    SPH_C32(0xe8c21863), SPH_C32(0xbca310b0), SPH_C32(0x64d0006e),
    SPH_C32(0x4e6bbb15) },
  { SPH_C32(0x23671400), SPH_C32(0xc8b90000), SPH_C32(0xf4c70000),
    SPH_C32(0xfb750000), SPH_C32(0x73cd2465), SPH_C32(0xf8a6a549),
    SPH_C32(0x02c40a3f), SPH_C32(0xdc24e61f), SPH_C32(0x373d2800),
    SPH_C32(0x71500000), SPH_C32(0x95e00000), SPH_C32(0x0a140000),
    SPH_C32(0xbdac1909), SPH_C32(0x48ef9831), SPH_C32(0x456d6d1f),
    SPH_C32(0x3daac2da) },
  { SPH_C32(0xcc6c1670), SPH_C32(0xf2440000), SPH_C32(0xa9690000),
    SPH_C32(0x923c0000), SPH_C32(0xe8c21863), SPH_C32(0xbca310b0),
    SPH_C32(0x64d0006e), SPH_C32(0x4e6bbb15), SPH_C32(0xfe562830),
    SPH_C32(0x96750000), SPH_C32(0xba640000), SPH_C32(0x2c5b0000),
    SPH_C32(0xb5c542f0), SPH_C32(0x25136906), SPH_C32(0x15f2049b),
    SPH_C32(0xa3c36db2) },
  { SPH_C32(0xea0c1430), SPH_C32(0x2f9c0000), SPH_C32(0xdb430000),
    SPH_C32(0xdd3a0000), SPH_C32(0x7ba47f9c), SPH_C32(0x955a547e),
    SPH_C32(0x525b63bb), SPH_C32(0x424d4977), SPH_C32(0x115d2a40),
    SPH_C32(0xac880000), SPH_C32(0xe7ca0000), SPH_C32(0x45120000),
    SPH_C32(0x2eca7ef6), SPH_C32(0x6116dcff), SPH_C32(0x73e60eca),
    SPH_C32(0x318c30b8) },
  { SPH_C32(0x05071640), SPH_C32(0x15610000), SPH_C32(0x86ed0000),
    SPH_C32(0xb4730000), SPH_C32(0xe0ab439a), SPH_C32(0xd15fe187),
    SPH_C32(0x344f69ea), SPH_C32(0xd002147d), SPH_C32(0xd8362a70),
    SPH_C32(0x4bad0000), SPH_C32(0xc84e0000), SPH_C32(0x635d0000),
    SPH_C32(0x26a3250f), SPH_C32(0x0cea2dc8), SPH_C32(0x2379674e),
    SPH_C32(0xafe59fd0) },
  { SPH_C32(0x373d2800), SPH_C32(0x71500000), SPH_C32(0x95e00000),
    SPH_C32(0x0a140000), SPH_C32(0xbdac1909), SPH_C32(0x48ef9831),
    SPH_C32(0x456d6d1f), SPH_C32(0x3daac2da), SPH_C32(0x145a3c00),
    SPH_C32(0xb9e90000), SPH_C32(0x61270000), SPH_C32(0xf1610000),
    SPH_C32(0xce613d6c), SPH_C32(0xb0493d78), SPH_C32(0x47a96720),
    SPH_C32(0xe18e24c5) },
  { SPH_C32(0xd8362a70), SPH_C32(0x4bad0000), SPH_C32(0xc84e0000),
    SPH_C32(0x635d0000), SPH_C32(0x26a3250f), SPH_C32(0x0cea2dc8),
    SPH_C32(0x2379674e), SPH_C32(0xafe59fd0), SPH_C32(0xdd313c30),
    SPH_C32(0x5ecc0000), SPH_C32(0x4ea30000), SPH_C32(0xd72e0000),
    SPH_C32(0xc6086695), SPH_C32(0xddb5cc4f), SPH_C32(0x17360ea4),
    SPH_C32(0x7fe78bad) },
  { SPH_C32(0xfe562830), SPH_C32(0x96750000), SPH_C32(0xba640000),
    SPH_C32(0x2c5b0000), SPH_C32(0xb5c542f0), SPH_C32(0x25136906),
    SPH_C32(0x15f2049b), SPH_C32(0xa3c36db2), SPH_C32(0x323a3e40),
    SPH_C32(0x64310000), SPH_C32(0x130d0000), SPH_C32(0xbe670000),
    SPH_C32(0x5d075a93), SPH_C32(0x99b079b6), SPH_C32(0x712204f5),
    SPH_C32(0xeda8d6a7) },
  { SPH_C32(0x115d2a40), SPH_C32(0xac880000), SPH_C32(0xe7ca0000),
    SPH_C32(0x45120000), SPH_C32(0x2eca7ef6), SPH_C32(0x6116dcff),
    SPH_C32(0x73e60eca), SPH_C32(0x318c30b8), SPH_C32(0xfb513e70),
    SPH_C32(0x83140000), SPH_C32(0x3c890000), SPH_C32(0x98280000),
    SPH_C32(0x556e016a), SPH_C32(0xf44c8881), SPH_C32(0x21bd6d71),
    SPH_C32(0x73c179cf) },
  { SPH_C32(0x54285c00), SPH_C32(0xeaed0000), SPH_C32(0xc5d60000),
    SPH_C32(0xa1c50000), SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1),
    SPH_C32(0x6bb0419d), SPH_C32(0x551b3782), SPH_C32(0x9cbb1800),
    SPH_C32(0xb0d30000), SPH_C32(0x92510000), SPH_C32(0xed930000),
    SPH_C32(0x593a4345), SPH_C32(0xe114d5f4), SPH_C32(0x430633da),
    SPH_C32(0x78cace29) },
  { SPH_C32(0xbb235e70), SPH_C32(0xd0100000), SPH_C32(0x98780000),
    SPH_C32(0xc88c0000), SPH_C32(0x28ad5b76), SPH_C32(0xd0a07118),
    SPH_C32(0x0da44bcc), SPH_C32(0xc7546a88), SPH_C32(0x55d01830),
    SPH_C32(0x57f60000), SPH_C32(0xbdd50000), SPH_C32(0xcbdc0000),
    SPH_C32(0x515318bc), SPH_C32(0x8ce824c3), SPH_C32(0x13995a5e),
    SPH_C32(0xe6a36141) },
  { SPH_C32(0x9d435c30), SPH_C32(0x0dc80000), SPH_C32(0xea520000),
    SPH_C32(0x878a0000), SPH_C32(0xbbcb3c89), SPH_C32(0xf95935d6),
    SPH_C32(0x3b2f2819), SPH_C32(0xcb7298ea), SPH_C32(0xbadb1a40),
    SPH_C32(0x6d0b0000), SPH_C32(0xe07b0000), SPH_C32(0xa2950000),
    SPH_C32(0xca5c24ba), SPH_C32(0xc8ed913a), SPH_C32(0x758d500f),
    SPH_C32(0x74ec3c4b) },
  { SPH_C32(0x72485e40), SPH_C32(0x37350000), SPH_C32(0xb7fc0000),
    SPH_C32(0xeec30000), SPH_C32(0x20c4008f), SPH_C32(0xbd5c802f),
    SPH_C32(0x5d3b2248), SPH_C32(0x593dc5e0), SPH_C32(0x73b01a70),
    SPH_C32(0x8a2e0000), SPH_C32(0xcfff0000), SPH_C32(0x84da0000),
    SPH_C32(0xc2357f43), SPH_C32(0xa511600d), SPH_C32(0x2512398b),
    SPH_C32(0xea859323) },
  { SPH_C32(0x40726000), SPH_C32(0x53040000), SPH_C32(0xa4f10000),
    SPH_C32(0x50a40000), SPH_C32(0x7dc35a1c), SPH_C32(0x24ecf999),
    SPH_C32(0x2c1926bd), SPH_C32(0xb4951347), SPH_C32(0xbfdc0c00),
    SPH_C32(0x786a0000), SPH_C32(0x66960000), SPH_C32(0x16e60000),
    SPH_C32(0x2af76720), SPH_C32(0x19b270bd), SPH_C32(0x41c239e5),
    SPH_C32(0xa4ee2836) },
  { SPH_C32(0xaf796270), SPH_C32(0x69f90000), SPH_C32(0xf95f0000),
    SPH_C32(0x39ed0000), SPH_C32(0xe6cc661a), SPH_C32(0x60e94c60),
    SPH_C32(0x4a0d2cec), SPH_C32(0x26da4e4d), SPH_C32(0x76b70c30),
    SPH_C32(0x9f4f0000), SPH_C32(0x49120000), SPH_C32(0x30a90000),
    SPH_C32(0x229e3cd9), SPH_C32(0x744e818a), SPH_C32(0x115d5061),
    SPH_C32(0x3a87875e) },
  { SPH_C32(0x89196030), SPH_C32(0xb4210000), SPH_C32(0x8b750000),
    SPH_C32(0x76eb0000), SPH_C32(0x75aa01e5), SPH_C32(0x491008ae),
    SPH_C32(0x7c864f39), SPH_C32(0x2afcbc2f), SPH_C32(0x99bc0e40),
    SPH_C32(0xa5b20000), SPH_C32(0x14bc0000), SPH_C32(0x59e00000),
    SPH_C32(0xb99100df), SPH_C32(0x304b3473), SPH_C32(0x77495a30),
    SPH_C32(0xa8c8da54) },
  { SPH_C32(0x66126240), SPH_C32(0x8edc0000), SPH_C32(0xd6db0000),
    SPH_C32(0x1fa20000), SPH_C32(0xeea53de3), SPH_C32(0x0d15bd57),
    SPH_C32(0x1a924568), SPH_C32(0xb8b3e125), SPH_C32(0x50d70e70),
    SPH_C32(0x42970000), SPH_C32(0x3b380000), SPH_C32(0x7faf0000),
    SPH_C32(0xb1f85b26), SPH_C32(0x5db7c544), SPH_C32(0x27d633b4),
    SPH_C32(0x36a1753c) },
  { SPH_C32(0x774f4800), SPH_C32(0x22540000), SPH_C32(0x31110000),
    SPH_C32(0x5ab00000), SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8),
    SPH_C32(0x69744ba2), SPH_C32(0x893fd19d), SPH_C32(0xab863000),
    SPH_C32(0xc1830000), SPH_C32(0x07b10000), SPH_C32(0xe7870000),
    SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5), SPH_C32(0x066b5ec5),
    SPH_C32(0x45600cf3) },
  { SPH_C32(0x98444a70), SPH_C32(0x18a90000), SPH_C32(0x6cbf0000),
    SPH_C32(0x33f90000), SPH_C32(0x5b607f13), SPH_C32(0x2806d451),
    SPH_C32(0x0f6041f3), SPH_C32(0x1b708c97), SPH_C32(0x62ed3030),
    SPH_C32(0x26a60000), SPH_C32(0x28350000), SPH_C32(0xc1c80000),
    SPH_C32(0xecff01b5), SPH_C32(0xc407bcf2), SPH_C32(0x56f43741),
    SPH_C32(0xdb09a39b) },
  { SPH_C32(0xbe244830), SPH_C32(0xc5710000), SPH_C32(0x1e950000),
    SPH_C32(0x7cff0000), SPH_C32(0xc80618ec), SPH_C32(0x01ff909f),
    SPH_C32(0x39eb2226), SPH_C32(0x17567ef5), SPH_C32(0x8de63240),
    SPH_C32(0x1c5b0000), SPH_C32(0x759b0000), SPH_C32(0xa8810000),
    SPH_C32(0x77f03db3), SPH_C32(0x8002090b), SPH_C32(0x30e03d10),
    SPH_C32(0x4946fe91) },
  { SPH_C32(0x512f4a40), SPH_C32(0xff8c0000), SPH_C32(0x433b0000),
    SPH_C32(0x15b60000), SPH_C32(0x530924ea), SPH_C32(0x45fa2566),
    SPH_C32(0x5fff2877), SPH_C32(0x851923ff), SPH_C32(0x448d3270),
    SPH_C32(0xfb7e0000), SPH_C32(0x5a1f0000), SPH_C32(0x8ece0000),
    SPH_C32(0x7f99664a), SPH_C32(0xedfef83c), SPH_C32(0x607f5494),
    SPH_C32(0xd72f51f9) },
  { SPH_C32(0x63157400), SPH_C32(0x9bbd0000), SPH_C32(0x50360000),
    SPH_C32(0xabd10000), SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0),
    SPH_C32(0x2edd2c82), SPH_C32(0x68b1f558), SPH_C32(0x88e12400),
    SPH_C32(0x093a0000), SPH_C32(0xf3760000), SPH_C32(0x1cf20000),
    SPH_C32(0x975b7e29), SPH_C32(0x515de88c), SPH_C32(0x04af54fa),
    SPH_C32(0x9944eaec) },
  { SPH_C32(0x8c1e7670), SPH_C32(0xa1400000), SPH_C32(0x0d980000),
    SPH_C32(0xc2980000), SPH_C32(0x9501427f), SPH_C32(0x984fe929),
    SPH_C32(0x48c926d3), SPH_C32(0xfafea852), SPH_C32(0x418a2430),
    SPH_C32(0xee1f0000), SPH_C32(0xdcf20000), SPH_C32(0x3abd0000),
    SPH_C32(0x9f3225d0), SPH_C32(0x3ca119bb), SPH_C32(0x54303d7e),
    SPH_C32(0x072d4584) },
  { SPH_C32(0xaa7e7430), SPH_C32(0x7c980000), SPH_C32(0x7fb20000),
    SPH_C32(0x8d9e0000), SPH_C32(0x06672580), SPH_C32(0xb1b6ade7),
    SPH_C32(0x7e424506), SPH_C32(0xf6d85a30), SPH_C32(0xae812640),
    SPH_C32(0xd4e20000), SPH_C32(0x815c0000), SPH_C32(0x53f40000),
    SPH_C32(0x043d19d6), SPH_C32(0x78a4ac42), SPH_C32(0x3224372f),
    SPH_C32(0x9562188e) },
  { SPH_C32(0x45757640), SPH_C32(0x46650000), SPH_C32(0x221c0000),
    SPH_C32(0xe4d70000), SPH_C32(0x9d681986), SPH_C32(0xf5b3181e),
    SPH_C32(0x18564f57), SPH_C32(0x6497073a), SPH_C32(0x67ea2670),
    SPH_C32(0x33c70000), SPH_C32(0xaed80000), SPH_C32(0x75bb0000),
    SPH_C32(0x0c54422f), SPH_C32(0x15585d75), SPH_C32(0x62bb5eab),
    SPH_C32(0x0b0bb7e6) },
  { SPH_C32(0x9cbb1800), SPH_C32(0xb0d30000), SPH_C32(0x92510000),
    SPH_C32(0xed930000), SPH_C32(0x593a4345), SPH_C32(0xe114d5f4),
    SPH_C32(0x430633da), SPH_C32(0x78cace29), SPH_C32(0xc8934400),
    SPH_C32(0x5a3e0000), SPH_C32(0x57870000), SPH_C32(0x4c560000),
    SPH_C32(0xea982435), SPH_C32(0x75b11115), SPH_C32(0x28b67247),
    SPH_C32(0x2dd1f9ab) },
  { SPH_C32(0x73b01a70), SPH_C32(0x8a2e0000), SPH_C32(0xcfff0000),
    SPH_C32(0x84da0000), SPH_C32(0xc2357f43), SPH_C32(0xa511600d),
    SPH_C32(0x2512398b), SPH_C32(0xea859323), SPH_C32(0x01f84430),
    SPH_C32(0xbd1b0000), SPH_C32(0x78030000), SPH_C32(0x6a190000),
    SPH_C32(0xe2f17fcc), SPH_C32(0x184de022), SPH_C32(0x78291bc3),
    SPH_C32(0xb3b856c3) },
  { SPH_C32(0x55d01830), SPH_C32(0x57f60000), SPH_C32(0xbdd50000),
    SPH_C32(0xcbdc0000), SPH_C32(0x515318bc), SPH_C32(0x8ce824c3),
    SPH_C32(0x13995a5e), SPH_C32(0xe6a36141), SPH_C32(0xeef34640),
    SPH_C32(0x87e60000), SPH_C32(0x25ad0000), SPH_C32(0x03500000),
    SPH_C32(0x79fe43ca), SPH_C32(0x5c4855db), SPH_C32(0x1e3d1192),
    SPH_C32(0x21f70bc9) },
  { SPH_C32(0xbadb1a40), SPH_C32(0x6d0b0000), SPH_C32(0xe07b0000),
    SPH_C32(0xa2950000), SPH_C32(0xca5c24ba), SPH_C32(0xc8ed913a),
    SPH_C32(0x758d500f), SPH_C32(0x74ec3c4b), SPH_C32(0x27984670),
    SPH_C32(0x60c30000), SPH_C32(0x0a290000), SPH_C32(0x251f0000),
    SPH_C32(0x71971833), SPH_C32(0x31b4a4ec), SPH_C32(0x4ea27816),
    SPH_C32(0xbf9ea4a1) },
  { SPH_C32(0x88e12400), SPH_C32(0x093a0000), SPH_C32(0xf3760000),
    SPH_C32(0x1cf20000), SPH_C32(0x975b7e29), SPH_C32(0x515de88c),
    SPH_C32(0x04af54fa), SPH_C32(0x9944eaec), SPH_C32(0xebf45000),
    SPH_C32(0x92870000), SPH_C32(0xa3400000), SPH_C32(0xb7230000),
    SPH_C32(0x99550050), SPH_C32(0x8d17b45c), SPH_C32(0x2a727878),
    SPH_C32(0xf1f51fb4) },
  { SPH_C32(0x67ea2670), SPH_C32(0x33c70000), SPH_C32(0xaed80000),
    SPH_C32(0x75bb0000), SPH_C32(0x0c54422f), SPH_C32(0x15585d75),
    SPH_C32(0x62bb5eab), SPH_C32(0x0b0bb7e6), SPH_C32(0x229f5030),
    SPH_C32(0x75a20000), SPH_C32(0x8cc40000), SPH_C32(0x916c0000),
    SPH_C32(0x913c5ba9), SPH_C32(0xe0eb456b), SPH_C32(0x7aed11fc),
    SPH_C32(0x6f9cb0dc) },
  { SPH_C32(0x418a2430), SPH_C32(0xee1f0000), SPH_C32(0xdcf20000),
    SPH_C32(0x3abd0000), SPH_C32(0x9f3225d0), SPH_C32(0x3ca119bb),
    SPH_C32(0x54303d7e), SPH_C32(0x072d4584), SPH_C32(0xcd945240),
    SPH_C32(0x4f5f0000), SPH_C32(0xd16a0000), SPH_C32(0xf8250000),
    SPH_C32(0x0a3367af), SPH_C32(0xa4eef092), SPH_C32(0x1cf91bad),
    SPH_C32(0xfdd3edd6) },
  { SPH_C32(0xae812640), SPH_C32(0xd4e20000), SPH_C32(0x815c0000),
    SPH_C32(0x53f40000), SPH_C32(0x043d19d6), SPH_C32(0x78a4ac42),
    SPH_C32(0x3224372f), SPH_C32(0x9562188e), SPH_C32(0x04ff5270),
    SPH_C32(0xa87a0000), SPH_C32(0xfeee0000), SPH_C32(0xde6a0000),
    SPH_C32(0x025a3c56), SPH_C32(0xc91201a5), SPH_C32(0x4c667229),
    SPH_C32(0x63ba42be) },
  { SPH_C32(0xbfdc0c00), SPH_C32(0x786a0000), SPH_C32(0x66960000),
    SPH_C32(0x16e60000), SPH_C32(0x2af76720), SPH_C32(0x19b270bd),
    SPH_C32(0x41c239e5), SPH_C32(0xa4ee2836), SPH_C32(0xffae6c00),
    SPH_C32(0x2b6e0000), SPH_C32(0xc2670000), SPH_C32(0x46420000),
    SPH_C32(0x57343d3c), SPH_C32(0x3d5e8924), SPH_C32(0x6ddb1f58),
    SPH_C32(0x107b3b71) },
  { SPH_C32(0x50d70e70), SPH_C32(0x42970000), SPH_C32(0x3b380000),
    SPH_C32(0x7faf0000), SPH_C32(0xb1f85b26), SPH_C32(0x5db7c544),
    SPH_C32(0x27d633b4), SPH_C32(0x36a1753c), SPH_C32(0x36c56c30),
    SPH_C32(0xcc4b0000), SPH_C32(0xede30000), SPH_C32(0x600d0000),
    SPH_C32(0x5f5d66c5), SPH_C32(0x50a27813), SPH_C32(0x3d4476dc),
    SPH_C32(0x8e129419) },
  { SPH_C32(0x76b70c30), SPH_C32(0x9f4f0000), SPH_C32(0x49120000),
    SPH_C32(0x30a90000), SPH_C32(0x229e3cd9), SPH_C32(0x744e818a),
    SPH_C32(0x115d5061), SPH_C32(0x3a87875e), SPH_C32(0xd9ce6e40),
    SPH_C32(0xf6b60000), SPH_C32(0xb04d0000), SPH_C32(0x09440000),
    SPH_C32(0xc4525ac3), SPH_C32(0x14a7cdea), SPH_C32(0x5b507c8d),
    SPH_C32(0x1c5dc913) },
  { SPH_C32(0x99bc0e40), SPH_C32(0xa5b20000), SPH_C32(0x14bc0000),
    SPH_C32(0x59e00000), SPH_C32(0xb99100df), SPH_C32(0x304b3473),
    SPH_C32(0x77495a30), SPH_C32(0xa8c8da54), SPH_C32(0x10a56e70),
    SPH_C32(0x11930000), SPH_C32(0x9fc90000), SPH_C32(0x2f0b0000),
    SPH_C32(0xcc3b013a), SPH_C32(0x795b3cdd), SPH_C32(0x0bcf1509),
    SPH_C32(0x8234667b) },
  { SPH_C32(0xab863000), SPH_C32(0xc1830000), SPH_C32(0x07b10000),
    SPH_C32(0xe7870000), SPH_C32(0xe4965a4c), SPH_C32(0xa9fb4dc5),
    SPH_C32(0x066b5ec5), SPH_C32(0x45600cf3), SPH_C32(0xdcc97800),
    SPH_C32(0xe3d70000), SPH_C32(0x36a00000), SPH_C32(0xbd370000),
    SPH_C32(0x24f91959), SPH_C32(0xc5f82c6d), SPH_C32(0x6f1f1567),
    SPH_C32(0xcc5fdd6e) },
  { SPH_C32(0x448d3270), SPH_C32(0xfb7e0000), SPH_C32(0x5a1f0000),
    SPH_C32(0x8ece0000), SPH_C32(0x7f99664a), SPH_C32(0xedfef83c),
    SPH_C32(0x607f5494), SPH_C32(0xd72f51f9), SPH_C32(0x15a27830),
    SPH_C32(0x04f20000), SPH_C32(0x19240000), SPH_C32(0x9b780000),
    SPH_C32(0x2c9042a0), SPH_C32(0xa804dd5a), SPH_C32(0x3f807ce3),
    SPH_C32(0x52367206) },
  { SPH_C32(0x62ed3030), SPH_C32(0x26a60000), SPH_C32(0x28350000),
    SPH_C32(0xc1c80000), SPH_C32(0xecff01b5), SPH_C32(0xc407bcf2),
    SPH_C32(0x56f43741), SPH_C32(0xdb09a39b), SPH_C32(0xfaa97a40),
    SPH_C32(0x3e0f0000), SPH_C32(0x448a0000), SPH_C32(0xf2310000),
    SPH_C32(0xb79f7ea6), SPH_C32(0xec0168a3), SPH_C32(0x599476b2),
    SPH_C32(0xc0792f0c) },
  { SPH_C32(0x8de63240), SPH_C32(0x1c5b0000), SPH_C32(0x759b0000),
    SPH_C32(0xa8810000), SPH_C32(0x77f03db3), SPH_C32(0x8002090b),
    SPH_C32(0x30e03d10), SPH_C32(0x4946fe91), SPH_C32(0x33c27a70),
    SPH_C32(0xd92a0000), SPH_C32(0x6b0e0000), SPH_C32(0xd47e0000),
    SPH_C32(0xbff6255f), SPH_C32(0x81fd9994), SPH_C32(0x090b1f36),
    SPH_C32(0x5e108064) },
  { SPH_C32(0xc8934400), SPH_C32(0x5a3e0000), SPH_C32(0x57870000),
    SPH_C32(0x4c560000), SPH_C32(0xea982435), SPH_C32(0x75b11115),
    SPH_C32(0x28b67247), SPH_C32(0x2dd1f9ab), SPH_C32(0x54285c00),
    SPH_C32(0xeaed0000), SPH_C32(0xc5d60000), SPH_C32(0xa1c50000),
    SPH_C32(0xb3a26770), SPH_C32(0x94a5c4e1), SPH_C32(0x6bb0419d),
    SPH_C32(0x551b3782) },
  { SPH_C32(0x27984670), SPH_C32(0x60c30000), SPH_C32(0x0a290000),
    SPH_C32(0x251f0000), SPH_C32(0x71971833), SPH_C32(0x31b4a4ec),
    SPH_C32(0x4ea27816), SPH_C32(0xbf9ea4a1), SPH_C32(0x9d435c30),
    SPH_C32(0x0dc80000), SPH_C32(0xea520000), SPH_C32(0x878a0000),
    SPH_C32(0xbbcb3c89), SPH_C32(0xf95935d6), SPH_C32(0x3b2f2819),
    SPH_C32(0xcb7298ea) },
  { SPH_C32(0x01f84430), SPH_C32(0xbd1b0000), SPH_C32(0x78030000),
    SPH_C32(0x6a190000), SPH_C32(0xe2f17fcc), SPH_C32(0x184de022),
    SPH_C32(0x78291bc3), SPH_C32(0xb3b856c3), SPH_C32(0x72485e40),
    SPH_C32(0x37350000), SPH_C32(0xb7fc0000), SPH_C32(0xeec30000),
    SPH_C32(0x20c4008f), SPH_C32(0xbd5c802f), SPH_C32(0x5d3b2248),
    SPH_C32(0x593dc5e0) },
  { SPH_C32(0xeef34640), SPH_C32(0x87e60000), SPH_C32(0x25ad0000),
    SPH_C32(0x03500000), SPH_C32(0x79fe43ca), SPH_C32(0x5c4855db),
    SPH_C32(0x1e3d1192), SPH_C32(0x21f70bc9), SPH_C32(0xbb235e70),
    SPH_C32(0xd0100000), SPH_C32(0x98780000), SPH_C32(0xc88c0000),
    SPH_C32(0x28ad5b76), SPH_C32(0xd0a07118), SPH_C32(0x0da44bcc),
    SPH_C32(0xc7546a88) },
  { SPH_C32(0xdcc97800), SPH_C32(0xe3d70000), SPH_C32(0x36a00000),
    SPH_C32(0xbd370000), SPH_C32(0x24f91959), SPH_C32(0xc5f82c6d),
    SPH_C32(0x6f1f1567), SPH_C32(0xcc5fdd6e), SPH_C32(0x774f4800),
    SPH_C32(0x22540000), SPH_C32(0x31110000), SPH_C32(0x5ab00000),
    SPH_C32(0xc06f4315), SPH_C32(0x6c0361a8), SPH_C32(0x69744ba2),
    SPH_C32(0x893fd19d) },
  { SPH_C32(0x33c27a70), SPH_C32(0xd92a0000), SPH_C32(0x6b0e0000),
    SPH_C32(0xd47e0000), SPH_C32(0xbff6255f), SPH_C32(0x81fd9994),
    SPH_C32(0x090b1f36), SPH_C32(0x5e108064), SPH_C32(0xbe244830),
    SPH_C32(0xc5710000), SPH_C32(0x1e950000), SPH_C32(0x7cff0000),
    SPH_C32(0xc80618ec), SPH_C32(0x01ff909f), SPH_C32(0x39eb2226),
    SPH_C32(0x17567ef5) },
  { SPH_C32(0x15a27830), SPH_C32(0x04f20000), SPH_C32(0x19240000),
    SPH_C32(0x9b780000), SPH_C32(0x2c9042a0), SPH_C32(0xa804dd5a),
    SPH_C32(0x3f807ce3), SPH_C32(0x52367206), SPH_C32(0x512f4a40),
    SPH_C32(0xff8c0000), SPH_C32(0x433b0000), SPH_C32(0x15b60000),
    SPH_C32(0x530924ea), SPH_C32(0x45fa2566), SPH_C32(0x5fff2877),
    SPH_C32(0x851923ff) },
  { SPH_C32(0xfaa97a40), SPH_C32(0x3e0f0000), SPH_C32(0x448a0000),
    SPH_C32(0xf2310000), SPH_C32(0xb79f7ea6), SPH_C32(0xec0168a3),
    SPH_C32(0x599476b2), SPH_C32(0xc0792f0c), SPH_C32(0x98444a70),
    SPH_C32(0x18a90000), SPH_C32(0x6cbf0000), SPH_C32(0x33f90000),
    SPH_C32(0x5b607f13), SPH_C32(0x2806d451), SPH_C32(0x0f6041f3),
    SPH_C32(0x1b708c97) },
  { SPH_C32(0xebf45000), SPH_C32(0x92870000), SPH_C32(0xa3400000),
    SPH_C32(0xb7230000), SPH_C32(0x99550050), SPH_C32(0x8d17b45c),
    SPH_C32(0x2a727878), SPH_C32(0xf1f51fb4), SPH_C32(0x63157400),
    SPH_C32(0x9bbd0000), SPH_C32(0x50360000), SPH_C32(0xabd10000),
    SPH_C32(0x0e0e7e79), SPH_C32(0xdc4a5cd0), SPH_C32(0x2edd2c82),
    SPH_C32(0x68b1f558) },
  { SPH_C32(0x04ff5270), SPH_C32(0xa87a0000), SPH_C32(0xfeee0000),
    SPH_C32(0xde6a0000), SPH_C32(0x025a3c56), SPH_C32(0xc91201a5),
    SPH_C32(0x4c667229), SPH_C32(0x63ba42be), SPH_C32(0xaa7e7430),
    SPH_C32(0x7c980000), SPH_C32(0x7fb20000), SPH_C32(0x8d9e0000),
    SPH_C32(0x06672580), SPH_C32(0xb1b6ade7), SPH_C32(0x7e424506),
    SPH_C32(0xf6d85a30) },
  { SPH_C32(0x229f5030), SPH_C32(0x75a20000), SPH_C32(0x8cc40000),
    SPH_C32(0x916c0000), SPH_C32(0x913c5ba9), SPH_C32(0xe0eb456b),
    SPH_C32(0x7aed11fc), SPH_C32(0x6f9cb0dc), SPH_C32(0x45757640),
    SPH_C32(0x46650000), SPH_C32(0x221c0000), SPH_C32(0xe4d70000),
    SPH_C32(0x9d681986), SPH_C32(0xf5b3181e), SPH_C32(0x18564f57),
    SPH_C32(0x6497073a) },
  { SPH_C32(0xcd945240), SPH_C32(0x4f5f0000), SPH_C32(0xd16a0000),
    SPH_C32(0xf8250000), SPH_C32(0x0a3367af), SPH_C32(0xa4eef092),
    SPH_C32(0x1cf91bad), SPH_C32(0xfdd3edd6), SPH_C32(0x8c1e7670),
    SPH_C32(0xa1400000), SPH_C32(0x0d980000), SPH_C32(0xc2980000),
    SPH_C32(0x9501427f), SPH_C32(0x984fe929), SPH_C32(0x48c926d3),
    SPH_C32(0xfafea852) },
  { SPH_C32(0xffae6c00), SPH_C32(0x2b6e0000), SPH_C32(0xc2670000),
    SPH_C32(0x46420000), SPH_C32(0x57343d3c), SPH_C32(0x3d5e8924),
    SPH_C32(0x6ddb1f58), SPH_C32(0x107b3b71), SPH_C32(0x40726000),
    SPH_C32(0x53040000), SPH_C32(0xa4f10000), SPH_C32(0x50a40000),
    SPH_C32(0x7dc35a1c), SPH_C32(0x24ecf999), SPH_C32(0x2c1926bd),
    SPH_C32(0xb4951347) },
  { SPH_C32(0x10a56e70), SPH_C32(0x11930000), SPH_C32(0x9fc90000),
    SPH_C32(0x2f0b0000), SPH_C32(0xcc3b013a), SPH_C32(0x795b3cdd),
    SPH_C32(0x0bcf1509), SPH_C32(0x8234667b), SPH_C32(0x89196030),
    SPH_C32(0xb4210000), SPH_C32(0x8b750000), SPH_C32(0x76eb0000),
    SPH_C32(0x75aa01e5), SPH_C32(0x491008ae), SPH_C32(0x7c864f39),
    SPH_C32(0x2afcbc2f) },
  { SPH_C32(0x36c56c30), SPH_C32(0xcc4b0000), SPH_C32(0xede30000),
    SPH_C32(0x600d0000), SPH_C32(0x5f5d66c5), SPH_C32(0x50a27813),
    SPH_C32(0x3d4476dc), SPH_C32(0x8e129419), SPH_C32(0x66126240),
    SPH_C32(0x8edc0000), SPH_C32(0xd6db0000), SPH_C32(0x1fa20000),
    SPH_C32(0xeea53de3), SPH_C32(0x0d15bd57), SPH_C32(0x1a924568),
    SPH_C32(0xb8b3e125) },
  { SPH_C32(0xd9ce6e40), SPH_C32(0xf6b60000), SPH_C32(0xb04d0000),
    SPH_C32(0x09440000), SPH_C32(0xc4525ac3), SPH_C32(0x14a7cdea),
    SPH_C32(0x5b507c8d), SPH_C32(0x1c5dc913), SPH_C32(0xaf796270),
    SPH_C32(0x69f90000), SPH_C32(0xf95f0000), SPH_C32(0x39ed0000),
    SPH_C32(0xe6cc661a), SPH_C32(0x60e94c60), SPH_C32(0x4a0d2cec),
    SPH_C32(0x26da4e4d) },
  { SPH_C32(0x29449c00), SPH_C32(0x64e70000), SPH_C32(0xf24b0000),
    SPH_C32(0xc2f30000), SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745),
    SPH_C32(0xf3e04259), SPH_C32(0x8d0d9ec4), SPH_C32(0x466d0c00),
    SPH_C32(0x08620000), SPH_C32(0xdd5d0000), SPH_C32(0xbadd0000),
    SPH_C32(0x6a927942), SPH_C32(0x441f2b93), SPH_C32(0x218ace6f),
    SPH_C32(0xbf2c0be2) },
  { SPH_C32(0xc64f9e70), SPH_C32(0x5e1a0000), SPH_C32(0xafe50000),
    SPH_C32(0xabba0000), SPH_C32(0x95d17289), SPH_C32(0x12c782bc),
    SPH_C32(0x95f44808), SPH_C32(0x1f42c3ce), SPH_C32(0x8f060c30),
    SPH_C32(0xef470000), SPH_C32(0xf2d90000), SPH_C32(0x9c920000),
    SPH_C32(0x62fb22bb), SPH_C32(0x29e3daa4), SPH_C32(0x7115a7eb),
    SPH_C32(0x2145a48a) },
  { SPH_C32(0xe02f9c30), SPH_C32(0x83c20000), SPH_C32(0xddcf0000),
    SPH_C32(0xe4bc0000), SPH_C32(0x06b71576), SPH_C32(0x3b3ec672),
    SPH_C32(0xa37f2bdd), SPH_C32(0x136431ac), SPH_C32(0x600d0e40),
    SPH_C32(0xd5ba0000), SPH_C32(0xaf770000), SPH_C32(0xf5db0000),
    SPH_C32(0xf9f41ebd), SPH_C32(0x6de66f5d), SPH_C32(0x1701adba),
    SPH_C32(0xb30af980) },
  { SPH_C32(0x0f249e40), SPH_C32(0xb93f0000), SPH_C32(0x80610000),
    SPH_C32(0x8df50000), SPH_C32(0x9db82970), SPH_C32(0x7f3b738b),
    SPH_C32(0xc56b218c), SPH_C32(0x812b6ca6), SPH_C32(0xa9660e70),
    SPH_C32(0x329f0000), SPH_C32(0x80f30000), SPH_C32(0xd3940000),
    SPH_C32(0xf19d4544), SPH_C32(0x001a9e6a), SPH_C32(0x479ec43e),
    SPH_C32(0x2d6356e8) },
  { SPH_C32(0x3d1ea000), SPH_C32(0xdd0e0000), SPH_C32(0x936c0000),
    SPH_C32(0x33920000), SPH_C32(0xc0bf73e3), SPH_C32(0xe68b0a3d),
    SPH_C32(0xb4492579), SPH_C32(0x6c83ba01), SPH_C32(0x650a1800),
    SPH_C32(0xc0db0000), SPH_C32(0x299a0000), SPH_C32(0x41a80000),
    SPH_C32(0x195f5d27), SPH_C32(0xbcb98eda), SPH_C32(0x234ec450),
    SPH_C32(0x6308edfd) },
  { SPH_C32(0xd215a270), SPH_C32(0xe7f30000), SPH_C32(0xcec20000),
    SPH_C32(0x5adb0000), SPH_C32(0x5bb04fe5), SPH_C32(0xa28ebfc4),
    SPH_C32(0xd25d2f28), SPH_C32(0xfecce70b), SPH_C32(0xac611830),
    SPH_C32(0x27fe0000), SPH_C32(0x061e0000), SPH_C32(0x67e70000),
    SPH_C32(0x113606de), SPH_C32(0xd1457fed), SPH_C32(0x73d1add4),
    SPH_C32(0xfd614295) },
  { SPH_C32(0xf475a030), SPH_C32(0x3a2b0000), SPH_C32(0xbce80000),
    SPH_C32(0x15dd0000), SPH_C32(0xc8d6281a), SPH_C32(0x8b77fb0a),
    SPH_C32(0xe4d64cfd), SPH_C32(0xf2ea1569), SPH_C32(0x436a1a40),
    SPH_C32(0x1d030000), SPH_C32(0x5bb00000), SPH_C32(0x0eae0000),
    SPH_C32(0x8a393ad8), SPH_C32(0x9540ca14), SPH_C32(0x15c5a785),
    SPH_C32(0x6f2e1f9f) },
  { SPH_C32(0x1b7ea240), SPH_C32(0x00d60000), SPH_C32(0xe1460000),
    SPH_C32(0x7c940000), SPH_C32(0x53d9141c), SPH_C32(0xcf724ef3),
    SPH_C32(0x82c246ac), SPH_C32(0x60a54863), SPH_C32(0x8a011a70),
    SPH_C32(0xfa260000), SPH_C32(0x74340000), SPH_C32(0x28e10000),
    SPH_C32(0x82506121), SPH_C32(0xf8bc3b23), SPH_C32(0x455ace01),
    SPH_C32(0xf147b0f7) },
  { SPH_C32(0x0a238800), SPH_C32(0xac5e0000), SPH_C32(0x068c0000),
    SPH_C32(0x39860000), SPH_C32(0x7d136aea), SPH_C32(0xae64920c),
    SPH_C32(0xf1244866), SPH_C32(0x512978db), SPH_C32(0x71502400),
    SPH_C32(0x79320000), SPH_C32(0x48bd0000), SPH_C32(0xb0c90000),
    SPH_C32(0xd73e604b), SPH_C32(0x0cf0b3a2), SPH_C32(0x64e7a370),
    SPH_C32(0x8286c938) },
  { SPH_C32(0xe5288a70), SPH_C32(0x96a30000), SPH_C32(0x5b220000),
    SPH_C32(0x50cf0000), SPH_C32(0xe61c56ec), SPH_C32(0xea6127f5),
    SPH_C32(0x97304237), SPH_C32(0xc36625d1), SPH_C32(0xb83b2430),
    SPH_C32(0x9e170000), SPH_C32(0x67390000), SPH_C32(0x96860000),
    SPH_C32(0xdf573bb2), SPH_C32(0x610c4295), SPH_C32(0x3478caf4),
    SPH_C32(0x1cef6650) },
  { SPH_C32(0xc3488830), SPH_C32(0x4b7b0000), SPH_C32(0x29080000),
    SPH_C32(0x1fc90000), SPH_C32(0x757a3113), SPH_C32(0xc398633b),
    SPH_C32(0xa1bb21e2), SPH_C32(0xcf40d7b3), SPH_C32(0x57302640),
    SPH_C32(0xa4ea0000), SPH_C32(0x3a970000), SPH_C32(0xffcf0000),
    SPH_C32(0x445807b4), SPH_C32(0x2509f76c), SPH_C32(0x526cc0a5),
    SPH_C32(0x8ea03b5a) },
  { SPH_C32(0x2c438a40), SPH_C32(0x71860000), SPH_C32(0x74a60000),
    SPH_C32(0x76800000), SPH_C32(0xee750d15), SPH_C32(0x879dd6c2),
    SPH_C32(0xc7af2bb3), SPH_C32(0x5d0f8ab9), SPH_C32(0x9e5b2670),
    SPH_C32(0x43cf0000), SPH_C32(0x15130000), SPH_C32(0xd9800000),
    SPH_C32(0x4c315c4d), SPH_C32(0x48f5065b), SPH_C32(0x02f3a921),
    SPH_C32(0x10c99432) },
  { SPH_C32(0x1e79b400), SPH_C32(0x15b70000), SPH_C32(0x67ab0000),
    SPH_C32(0xc8e70000), SPH_C32(0xb3725786), SPH_C32(0x1e2daf74),
    SPH_C32(0xb68d2f46), SPH_C32(0xb0a75c1e), SPH_C32(0x52373000),
    SPH_C32(0xb18b0000), SPH_C32(0xbc7a0000), SPH_C32(0x4bbc0000),
    SPH_C32(0xa4f3442e), SPH_C32(0xf45616eb), SPH_C32(0x6623a94f),
    SPH_C32(0x5ea22f27) },
  { SPH_C32(0xf172b670), SPH_C32(0x2f4a0000), SPH_C32(0x3a050000),
    SPH_C32(0xa1ae0000), SPH_C32(0x287d6b80), SPH_C32(0x5a281a8d),
    SPH_C32(0xd0992517), SPH_C32(0x22e80114), SPH_C32(0x9b5c3030),
    SPH_C32(0x56ae0000), SPH_C32(0x93fe0000), SPH_C32(0x6df30000),
    SPH_C32(0xac9a1fd7), SPH_C32(0x99aae7dc), SPH_C32(0x36bcc0cb),
    SPH_C32(0xc0cb804f) },
  { SPH_C32(0xd712b430), SPH_C32(0xf2920000), SPH_C32(0x482f0000),
    SPH_C32(0xeea80000), SPH_C32(0xbb1b0c7f), SPH_C32(0x73d15e43),
    SPH_C32(0xe61246c2), SPH_C32(0x2ecef376), SPH_C32(0x74573240),
    SPH_C32(0x6c530000), SPH_C32(0xce500000), SPH_C32(0x04ba0000),
    SPH_C32(0x379523d1), SPH_C32(0xddaf5225), SPH_C32(0x50a8ca9a),
    SPH_C32(0x5284dd45) },
  { SPH_C32(0x3819b640), SPH_C32(0xc86f0000), SPH_C32(0x15810000),
    SPH_C32(0x87e10000), SPH_C32(0x20143079), SPH_C32(0x37d4ebba),
    SPH_C32(0x80064c93), SPH_C32(0xbc81ae7c), SPH_C32(0xbd3c3270),
    SPH_C32(0x8b760000), SPH_C32(0xe1d40000), SPH_C32(0x22f50000),
    SPH_C32(0x3ffc7828), SPH_C32(0xb053a312), SPH_C32(0x0037a31e),
    SPH_C32(0xcced722d) },
  { SPH_C32(0x7d6cc000), SPH_C32(0x8e0a0000), SPH_C32(0x379d0000),
    SPH_C32(0x63360000), SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4),
    SPH_C32(0x985003c4), SPH_C32(0xd816a946), SPH_C32(0xdad61400),
    SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000), SPH_C32(0x574e0000),
    SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67), SPH_C32(0x628cfdb5),
    SPH_C32(0xc7e6c5cb) },
  { SPH_C32(0x9267c270), SPH_C32(0xb4f70000), SPH_C32(0x6a330000),
    SPH_C32(0x0a7f0000), SPH_C32(0x267315f9), SPH_C32(0x8662465d),
    SPH_C32(0xfe440995), SPH_C32(0x4a59f44c), SPH_C32(0x13bd1430),
    SPH_C32(0x5f940000), SPH_C32(0x60880000), SPH_C32(0x71010000),
    SPH_C32(0x3bc161fe), SPH_C32(0xc8f70f50), SPH_C32(0x32139431),
    SPH_C32(0x598f6aa3) },
  { SPH_C32(0xb407c030), SPH_C32(0x692f0000), SPH_C32(0x18190000),
    SPH_C32(0x45790000), SPH_C32(0xb5157206), SPH_C32(0xaf9b0293),
    SPH_C32(0xc8cf6a40), SPH_C32(0x467f062e), SPH_C32(0xfcb61640),
    SPH_C32(0x65690000), SPH_C32(0x3d260000), SPH_C32(0x18480000),
    SPH_C32(0xa0ce5df8), SPH_C32(0x8cf2baa9), SPH_C32(0x54079e60),
    SPH_C32(0xcbc037a9) },
  { SPH_C32(0x5b0cc240), SPH_C32(0x53d20000), SPH_C32(0x45b70000),
    SPH_C32(0x2c300000), SPH_C32(0x2e1a4e00), SPH_C32(0xeb9eb76a),
    SPH_C32(0xaedb6011), SPH_C32(0xd4305b24), SPH_C32(0x35dd1670),
    SPH_C32(0x824c0000), SPH_C32(0x12a20000), SPH_C32(0x3e070000),
    SPH_C32(0xa8a70601), SPH_C32(0xe10e4b9e), SPH_C32(0x0498f7e4),
    SPH_C32(0x55a998c1) },
  { SPH_C32(0x6936fc00), SPH_C32(0x37e30000), SPH_C32(0x56ba0000),
    SPH_C32(0x92570000), SPH_C32(0x731d1493), SPH_C32(0x722ecedc),
    SPH_C32(0xdff964e4), SPH_C32(0x39988d83), SPH_C32(0xf9b10000),
    SPH_C32(0x70080000), SPH_C32(0xbbcb0000), SPH_C32(0xac3b0000),
    SPH_C32(0x40651e62), SPH_C32(0x5dad5b2e), SPH_C32(0x6048f78a),
    SPH_C32(0x1bc223d4) },
  { SPH_C32(0x863dfe70), SPH_C32(0x0d1e0000), SPH_C32(0x0b140000),
    SPH_C32(0xfb1e0000), SPH_C32(0xe8122895), SPH_C32(0x362b7b25),
    SPH_C32(0xb9ed6eb5), SPH_C32(0xabd7d089), SPH_C32(0x30da0030),
    SPH_C32(0x972d0000), SPH_C32(0x944f0000), SPH_C32(0x8a740000),
    SPH_C32(0x480c459b), SPH_C32(0x3051aa19), SPH_C32(0x30d79e0e),
    SPH_C32(0x85ab8cbc) },
  { SPH_C32(0xa05dfc30), SPH_C32(0xd0c60000), SPH_C32(0x793e0000),
    SPH_C32(0xb4180000), SPH_C32(0x7b744f6a), SPH_C32(0x1fd23feb),
    SPH_C32(0x8f660d60), SPH_C32(0xa7f122eb), SPH_C32(0xdfd10240),
    SPH_C32(0xadd00000), SPH_C32(0xc9e10000), SPH_C32(0xe33d0000),
    SPH_C32(0xd303799d), SPH_C32(0x74541fe0), SPH_C32(0x56c3945f),
    SPH_C32(0x17e4d1b6) },
  { SPH_C32(0x4f56fe40), SPH_C32(0xea3b0000), SPH_C32(0x24900000),
    SPH_C32(0xdd510000), SPH_C32(0xe07b736c), SPH_C32(0x5bd78a12),
    SPH_C32(0xe9720731), SPH_C32(0x35be7fe1), SPH_C32(0x16ba0270),
    SPH_C32(0x4af50000), SPH_C32(0xe6650000), SPH_C32(0xc5720000),
    SPH_C32(0xdb6a2264), SPH_C32(0x19a8eed7), SPH_C32(0x065cfddb),
    SPH_C32(0x898d7ede) },
  { SPH_C32(0x5e0bd400), SPH_C32(0x46b30000), SPH_C32(0xc35a0000),
    SPH_C32(0x98430000), SPH_C32(0xceb10d9a), SPH_C32(0x3ac156ed),
    SPH_C32(0x9a9409fb), SPH_C32(0x04324f59), SPH_C32(0xedeb3c00),
    SPH_C32(0xc9e10000), SPH_C32(0xdaec0000), SPH_C32(0x5d5a0000),
    SPH_C32(0x8e04230e), SPH_C32(0xede46656), SPH_C32(0x27e190aa),
    SPH_C32(0xfa4c0711) },
  { SPH_C32(0xb100d670), SPH_C32(0x7c4e0000), SPH_C32(0x9ef40000),
    SPH_C32(0xf10a0000), SPH_C32(0x55be319c), SPH_C32(0x7ec4e314),
    SPH_C32(0xfc8003aa), SPH_C32(0x967d1253), SPH_C32(0x24803c30),
    SPH_C32(0x2ec40000), SPH_C32(0xf5680000), SPH_C32(0x7b150000),
    SPH_C32(0x866d78f7), SPH_C32(0x80189761), SPH_C32(0x777ef92e),
    SPH_C32(0x6425a879) },
  { SPH_C32(0x9760d430), SPH_C32(0xa1960000), SPH_C32(0xecde0000),
    SPH_C32(0xbe0c0000), SPH_C32(0xc6d85663), SPH_C32(0x573da7da),
    SPH_C32(0xca0b607f), SPH_C32(0x9a5be031), SPH_C32(0xcb8b3e40),
    SPH_C32(0x14390000), SPH_C32(0xa8c60000), SPH_C32(0x125c0000),
    SPH_C32(0x1d6244f1), SPH_C32(0xc41d2298), SPH_C32(0x116af37f),
    SPH_C32(0xf66af573) },
  { SPH_C32(0x786bd640), SPH_C32(0x9b6b0000), SPH_C32(0xb1700000),
    SPH_C32(0xd7450000), SPH_C32(0x5dd76a65), SPH_C32(0x13381223),
    SPH_C32(0xac1f6a2e), SPH_C32(0x0814bd3b), SPH_C32(0x02e03e70),
    SPH_C32(0xf31c0000), SPH_C32(0x87420000), SPH_C32(0x34130000),
    SPH_C32(0x150b1f08), SPH_C32(0xa9e1d3af), SPH_C32(0x41f59afb),
    SPH_C32(0x68035a1b) },
  { SPH_C32(0x4a51e800), SPH_C32(0xff5a0000), SPH_C32(0xa27d0000),
    SPH_C32(0x69220000), SPH_C32(0x00d030f6), SPH_C32(0x8a886b95),
    SPH_C32(0xdd3d6edb), SPH_C32(0xe5bc6b9c), SPH_C32(0xce8c2800),
    SPH_C32(0x01580000), SPH_C32(0x2e2b0000), SPH_C32(0xa62f0000),
    SPH_C32(0xfdc9076b), SPH_C32(0x1542c31f), SPH_C32(0x25259a95),
    SPH_C32(0x2668e10e) },
  { SPH_C32(0xa55aea70), SPH_C32(0xc5a70000), SPH_C32(0xffd30000),
    SPH_C32(0x006b0000), SPH_C32(0x9bdf0cf0), SPH_C32(0xce8dde6c),
    SPH_C32(0xbb29648a), SPH_C32(0x77f33696), SPH_C32(0x07e72830),
    SPH_C32(0xe67d0000), SPH_C32(0x01af0000), SPH_C32(0x80600000),
    SPH_C32(0xf5a05c92), SPH_C32(0x78be3228), SPH_C32(0x75baf311),
    SPH_C32(0xb8014e66) },
  { SPH_C32(0x833ae830), SPH_C32(0x187f0000), SPH_C32(0x8df90000),
    SPH_C32(0x4f6d0000), SPH_C32(0x08b96b0f), SPH_C32(0xe7749aa2),
    SPH_C32(0x8da2075f), SPH_C32(0x7bd5c4f4), SPH_C32(0xe8ec2a40),
    SPH_C32(0xdc800000), SPH_C32(0x5c010000), SPH_C32(0xe9290000),
    SPH_C32(0x6eaf6094), SPH_C32(0x3cbb87d1), SPH_C32(0x13aef940),
    SPH_C32(0x2a4e136c) },
  { SPH_C32(0x6c31ea40), SPH_C32(0x22820000), SPH_C32(0xd0570000),
    SPH_C32(0x26240000), SPH_C32(0x93b65709), SPH_C32(0xa3712f5b),
    SPH_C32(0xebb60d0e), SPH_C32(0xe99a99fe), SPH_C32(0x21872a70),
    SPH_C32(0x3ba50000), SPH_C32(0x73850000), SPH_C32(0xcf660000),
    SPH_C32(0x66c63b6d), SPH_C32(0x514776e6), SPH_C32(0x433190c4),
    SPH_C32(0xb427bc04) },
  { SPH_C32(0xb5ff8400), SPH_C32(0xd4340000), SPH_C32(0x601a0000),
    SPH_C32(0x2f600000), SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1),
    SPH_C32(0xb0e67183), SPH_C32(0xf5c750ed), SPH_C32(0x8efe4800),
    SPH_C32(0x525c0000), SPH_C32(0x8ada0000), SPH_C32(0xf68b0000),
    SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86), SPH_C32(0x093cbc28),
    SPH_C32(0x92fdf249) },
  { SPH_C32(0x5af48670), SPH_C32(0xeec90000), SPH_C32(0x3db40000),
    SPH_C32(0x46290000), SPH_C32(0xcceb31cc), SPH_C32(0xf3d35748),
    SPH_C32(0xd6f27bd2), SPH_C32(0x67880de7), SPH_C32(0x47954830),
    SPH_C32(0xb5790000), SPH_C32(0xa55e0000), SPH_C32(0xd0c40000),
    SPH_C32(0x8863068e), SPH_C32(0x5c52cbb1), SPH_C32(0x59a3d5ac),
    SPH_C32(0x0c945d21) },
  { SPH_C32(0x7c948430), SPH_C32(0x33110000), SPH_C32(0x4f9e0000),
    SPH_C32(0x092f0000), SPH_C32(0x5f8d5633), SPH_C32(0xda2a1386),
    SPH_C32(0xe0791807), SPH_C32(0x6baeff85), SPH_C32(0xa89e4a40),
    SPH_C32(0x8f840000), SPH_C32(0xf8f00000), SPH_C32(0xb98d0000),
    SPH_C32(0x136c3a88), SPH_C32(0x18577e48), SPH_C32(0x3fb7dffd),
    SPH_C32(0x9edb002b) },
  { SPH_C32(0x939f8640), SPH_C32(0x09ec0000), SPH_C32(0x12300000),
    SPH_C32(0x60660000), SPH_C32(0xc4826a35), SPH_C32(0x9e2fa67f),
    SPH_C32(0x866d1256), SPH_C32(0xf9e1a28f), SPH_C32(0x61f54a70),
    SPH_C32(0x68a10000), SPH_C32(0xd7740000), SPH_C32(0x9fc20000),
    SPH_C32(0x1b056171), SPH_C32(0x75ab8f7f), SPH_C32(0x6f28b679),
    SPH_C32(0x00b2af43) },
  { SPH_C32(0xa1a5b800), SPH_C32(0x6ddd0000), SPH_C32(0x013d0000),
    SPH_C32(0xde010000), SPH_C32(0x998530a6), SPH_C32(0x079fdfc9),
    SPH_C32(0xf74f16a3), SPH_C32(0x14497428), SPH_C32(0xad995c00),
    SPH_C32(0x9ae50000), SPH_C32(0x7e1d0000), SPH_C32(0x0dfe0000),
    SPH_C32(0xf3c77912), SPH_C32(0xc9089fcf), SPH_C32(0x0bf8b617),
    SPH_C32(0x4ed91456) },
  { SPH_C32(0x4eaeba70), SPH_C32(0x57200000), SPH_C32(0x5c930000),
    SPH_C32(0xb7480000), SPH_C32(0x028a0ca0), SPH_C32(0x439a6a30),
    SPH_C32(0x915b1cf2), SPH_C32(0x86062922), SPH_C32(0x64f25c30),
    SPH_C32(0x7dc00000), SPH_C32(0x51990000), SPH_C32(0x2bb10000),
    SPH_C32(0xfbae22eb), SPH_C32(0xa4f46ef8), SPH_C32(0x5b67df93),
    SPH_C32(0xd0b0bb3e) },
  { SPH_C32(0x68ceb830), SPH_C32(0x8af80000), SPH_C32(0x2eb90000),
    SPH_C32(0xf84e0000), SPH_C32(0x91ec6b5f), SPH_C32(0x6a632efe),
    SPH_C32(0xa7d07f27), SPH_C32(0x8a20db40), SPH_C32(0x8bf95e40),
    SPH_C32(0x473d0000), SPH_C32(0x0c370000), SPH_C32(0x42f80000),
    SPH_C32(0x60a11eed), SPH_C32(0xe0f1db01), SPH_C32(0x3d73d5c2),
    SPH_C32(0x42ffe634) },
  { SPH_C32(0x87c5ba40), SPH_C32(0xb0050000), SPH_C32(0x73170000),
    SPH_C32(0x91070000), SPH_C32(0x0ae35759), SPH_C32(0x2e669b07),
    SPH_C32(0xc1c47576), SPH_C32(0x186f864a), SPH_C32(0x42925e70),
    SPH_C32(0xa0180000), SPH_C32(0x23b30000), SPH_C32(0x64b70000),
    SPH_C32(0x68c84514), SPH_C32(0x8d0d2a36), SPH_C32(0x6decbc46),
    SPH_C32(0xdc96495c) },
  { SPH_C32(0x96989000), SPH_C32(0x1c8d0000), SPH_C32(0x94dd0000),
    SPH_C32(0xd4150000), SPH_C32(0x242929af), SPH_C32(0x4f7047f8),
    SPH_C32(0xb2227bbc), SPH_C32(0x29e3b6f2), SPH_C32(0xb9c36000),
    SPH_C32(0x230c0000), SPH_C32(0x1f3a0000), SPH_C32(0xfc9f0000),
    SPH_C32(0x3da6447e), SPH_C32(0x7941a2b7), SPH_C32(0x4c51d137),
    SPH_C32(0xaf573093) },
  { SPH_C32(0x79939270), SPH_C32(0x26700000), SPH_C32(0xc9730000),
    SPH_C32(0xbd5c0000), SPH_C32(0xbf2615a9), SPH_C32(0x0b75f201),
    SPH_C32(0xd43671ed), SPH_C32(0xbbacebf8), SPH_C32(0x70a86030),
    SPH_C32(0xc4290000), SPH_C32(0x30be0000), SPH_C32(0xdad00000),
    SPH_C32(0x35cf1f87), SPH_C32(0x14bd5380), SPH_C32(0x1cceb8b3),
    SPH_C32(0x313e9ffb) },
  { SPH_C32(0x5ff39030), SPH_C32(0xfba80000), SPH_C32(0xbb590000),
    SPH_C32(0xf25a0000), SPH_C32(0x2c407256), SPH_C32(0x228cb6cf),
    SPH_C32(0xe2bd1238), SPH_C32(0xb78a199a), SPH_C32(0x9fa36240),
    SPH_C32(0xfed40000), SPH_C32(0x6d100000), SPH_C32(0xb3990000),
    SPH_C32(0xaec02381), SPH_C32(0x50b8e679), SPH_C32(0x7adab2e2),
    SPH_C32(0xa371c2f1) },
  { SPH_C32(0xb0f89240), SPH_C32(0xc1550000), SPH_C32(0xe6f70000),
    SPH_C32(0x9b130000), SPH_C32(0xb74f4e50), SPH_C32(0x66890336),
    SPH_C32(0x84a91869), SPH_C32(0x25c54490), SPH_C32(0x56c86270),
    SPH_C32(0x19f10000), SPH_C32(0x42940000), SPH_C32(0x95d60000),
    SPH_C32(0xa6a97878), SPH_C32(0x3d44174e), SPH_C32(0x2a45db66),
    SPH_C32(0x3d186d99) },
  { SPH_C32(0x82c2ac00), SPH_C32(0xa5640000), SPH_C32(0xf5fa0000),
    SPH_C32(0x25740000), SPH_C32(0xea4814c3), SPH_C32(0xff397a80),
    SPH_C32(0xf58b1c9c), SPH_C32(0xc86d9237), SPH_C32(0x9aa47400),
    SPH_C32(0xebb50000), SPH_C32(0xebfd0000), SPH_C32(0x07ea0000),
    SPH_C32(0x4e6b601b), SPH_C32(0x81e707fe), SPH_C32(0x4e95db08),
    SPH_C32(0x7373d68c) },
  { SPH_C32(0x6dc9ae70), SPH_C32(0x9f990000), SPH_C32(0xa8540000),
    SPH_C32(0x4c3d0000), SPH_C32(0x714728c5), SPH_C32(0xbb3ccf79),
    SPH_C32(0x939f16cd), SPH_C32(0x5a22cf3d), SPH_C32(0x53cf7430),
    SPH_C32(0x0c900000), SPH_C32(0xc4790000), SPH_C32(0x21a50000),
    SPH_C32(0x46023be2), SPH_C32(0xec1bf6c9), SPH_C32(0x1e0ab28c),
    SPH_C32(0xed1a79e4) },
  { SPH_C32(0x4ba9ac30), SPH_C32(0x42410000), SPH_C32(0xda7e0000),
    SPH_C32(0x033b0000), SPH_C32(0xe2214f3a), SPH_C32(0x92c58bb7),
    SPH_C32(0xa5147518), SPH_C32(0x56043d5f), SPH_C32(0xbcc47640),
    SPH_C32(0x366d0000), SPH_C32(0x99d70000), SPH_C32(0x48ec0000),
    SPH_C32(0xdd0d07e4), SPH_C32(0xa81e4330), SPH_C32(0x781eb8dd),
    SPH_C32(0x7f5524ee) },
  { SPH_C32(0xa4a2ae40), SPH_C32(0x78bc0000), SPH_C32(0x87d00000),
    SPH_C32(0x6a720000), SPH_C32(0x792e733c), SPH_C32(0xd6c03e4e),
    SPH_C32(0xc3007f49), SPH_C32(0xc44b6055), SPH_C32(0x75af7670),
    SPH_C32(0xd1480000), SPH_C32(0xb6530000), SPH_C32(0x6ea30000),
    SPH_C32(0xd5645c1d), SPH_C32(0xc5e2b207), SPH_C32(0x2881d159),
    SPH_C32(0xe13c8b86) },
  { SPH_C32(0xe1d7d800), SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000),
    SPH_C32(0x8ea50000), SPH_C32(0xe4466aba), SPH_C32(0x23732650),
    SPH_C32(0xdb56301e), SPH_C32(0xa0dc676f), SPH_C32(0x12455000),
    SPH_C32(0xe28f0000), SPH_C32(0x188b0000), SPH_C32(0x1b180000),
    SPH_C32(0xd9301e32), SPH_C32(0xd0baef72), SPH_C32(0x4a3a8ff2),
    SPH_C32(0xea373c60) },
  { SPH_C32(0x0edcda70), SPH_C32(0x04240000), SPH_C32(0xf8620000),
    SPH_C32(0xe7ec0000), SPH_C32(0x7f4956bc), SPH_C32(0x677693a9),
    SPH_C32(0xbd423a4f), SPH_C32(0x32933a65), SPH_C32(0xdb2e5030),
    SPH_C32(0x05aa0000), SPH_C32(0x370f0000), SPH_C32(0x3d570000),
    SPH_C32(0xd15945cb), SPH_C32(0xbd461e45), SPH_C32(0x1aa5e676),
    SPH_C32(0x745e9308) },
  { SPH_C32(0x28bcd830), SPH_C32(0xd9fc0000), SPH_C32(0x8a480000),
    SPH_C32(0xa8ea0000), SPH_C32(0xec2f3143), SPH_C32(0x4e8fd767),
    SPH_C32(0x8bc9599a), SPH_C32(0x3eb5c807), SPH_C32(0x34255240),
    SPH_C32(0x3f570000), SPH_C32(0x6aa10000), SPH_C32(0x541e0000),
    SPH_C32(0x4a5679cd), SPH_C32(0xf943abbc), SPH_C32(0x7cb1ec27),
    SPH_C32(0xe611ce02) },
  { SPH_C32(0xc7b7da40), SPH_C32(0xe3010000), SPH_C32(0xd7e60000),
    SPH_C32(0xc1a30000), SPH_C32(0x77200d45), SPH_C32(0x0a8a629e),
    SPH_C32(0xeddd53cb), SPH_C32(0xacfa950d), SPH_C32(0xfd4e5270),
    SPH_C32(0xd8720000), SPH_C32(0x45250000), SPH_C32(0x72510000),
    SPH_C32(0x423f2234), SPH_C32(0x94bf5a8b), SPH_C32(0x2c2e85a3),
    SPH_C32(0x7878616a) },
  { SPH_C32(0xf58de400), SPH_C32(0x87300000), SPH_C32(0xc4eb0000),
    SPH_C32(0x7fc40000), SPH_C32(0x2a2757d6), SPH_C32(0x933a1b28),
    SPH_C32(0x9cff573e), SPH_C32(0x415243aa), SPH_C32(0x31224400),
    SPH_C32(0x2a360000), SPH_C32(0xec4c0000), SPH_C32(0xe06d0000),
    SPH_C32(0xaafd3a57), SPH_C32(0x281c4a3b), SPH_C32(0x48fe85cd),
    SPH_C32(0x3613da7f) },
  { SPH_C32(0x1a86e670), SPH_C32(0xbdcd0000), SPH_C32(0x99450000),
    SPH_C32(0x168d0000), SPH_C32(0xb1286bd0), SPH_C32(0xd73faed1),
    SPH_C32(0xfaeb5d6f), SPH_C32(0xd31d1ea0), SPH_C32(0xf8494430),
    SPH_C32(0xcd130000), SPH_C32(0xc3c80000), SPH_C32(0xc6220000),
    SPH_C32(0xa29461ae), SPH_C32(0x45e0bb0c), SPH_C32(0x1861ec49),
    SPH_C32(0xa87a7517) },
  { SPH_C32(0x3ce6e430), SPH_C32(0x60150000), SPH_C32(0xeb6f0000),
    SPH_C32(0x598b0000), SPH_C32(0x224e0c2f), SPH_C32(0xfec6ea1f),
    SPH_C32(0xcc603eba), SPH_C32(0xdf3becc2), SPH_C32(0x17424640),
    SPH_C32(0xf7ee0000), SPH_C32(0x9e660000), SPH_C32(0xaf6b0000),
    SPH_C32(0x399b5da8), SPH_C32(0x01e50ef5), SPH_C32(0x7e75e618),
    SPH_C32(0x3a35281d) },
  { SPH_C32(0xd3ede640), SPH_C32(0x5ae80000), SPH_C32(0xb6c10000),
    SPH_C32(0x30c20000), SPH_C32(0xb9413029), SPH_C32(0xbac35fe6),
    SPH_C32(0xaa7434eb), SPH_C32(0x4d74b1c8), SPH_C32(0xde294670),
    SPH_C32(0x10cb0000), SPH_C32(0xb1e20000), SPH_C32(0x89240000),
    SPH_C32(0x31f20651), SPH_C32(0x6c19ffc2), SPH_C32(0x2eea8f9c),
    SPH_C32(0xa45c8775) },
  { SPH_C32(0xc2b0cc00), SPH_C32(0xf6600000), SPH_C32(0x510b0000),
    SPH_C32(0x75d00000), SPH_C32(0x978b4edf), SPH_C32(0xdbd58319),
    SPH_C32(0xd9923a21), SPH_C32(0x7cf88170), SPH_C32(0x25787800),
    SPH_C32(0x93df0000), SPH_C32(0x8d6b0000), SPH_C32(0x110c0000),
    SPH_C32(0x649c073b), SPH_C32(0x98557743), SPH_C32(0x0f57e2ed),
    SPH_C32(0xd79dfeba) },
  { SPH_C32(0x2dbbce70), SPH_C32(0xcc9d0000), SPH_C32(0x0ca50000),
    SPH_C32(0x1c990000), SPH_C32(0x0c8472d9), SPH_C32(0x9fd036e0),
    SPH_C32(0xbf863070), SPH_C32(0xeeb7dc7a), SPH_C32(0xec137830),
    SPH_C32(0x74fa0000), SPH_C32(0xa2ef0000), SPH_C32(0x37430000),
    SPH_C32(0x6cf55cc2), SPH_C32(0xf5a98674), SPH_C32(0x5fc88b69),
    SPH_C32(0x49f451d2) },
  { SPH_C32(0x0bdbcc30), SPH_C32(0x11450000), SPH_C32(0x7e8f0000),
    SPH_C32(0x539f0000), SPH_C32(0x9fe21526), SPH_C32(0xb629722e),
    SPH_C32(0x890d53a5), SPH_C32(0xe2912e18), SPH_C32(0x03187a40),
    SPH_C32(0x4e070000), SPH_C32(0xff410000), SPH_C32(0x5e0a0000),
    SPH_C32(0xf7fa60c4), SPH_C32(0xb1ac338d), SPH_C32(0x39dc8138),
    SPH_C32(0xdbbb0cd8) },
  { SPH_C32(0xe4d0ce40), SPH_C32(0x2bb80000), SPH_C32(0x23210000),
    SPH_C32(0x3ad60000), SPH_C32(0x04ed2920), SPH_C32(0xf22cc7d7),
    SPH_C32(0xef1959f4), SPH_C32(0x70de7312), SPH_C32(0xca737a70),
    SPH_C32(0xa9220000), SPH_C32(0xd0c50000), SPH_C32(0x78450000),
    SPH_C32(0xff933b3d), SPH_C32(0xdc50c2ba), SPH_C32(0x6943e8bc),
    SPH_C32(0x45d2a3b0) },
  { SPH_C32(0xd6eaf000), SPH_C32(0x4f890000), SPH_C32(0x302c0000),
    SPH_C32(0x84b10000), SPH_C32(0x59ea73b3), SPH_C32(0x6b9cbe61),
    SPH_C32(0x9e3b5d01), SPH_C32(0x9d76a5b5), SPH_C32(0x061f6c00),
    SPH_C32(0x5b660000), SPH_C32(0x79ac0000), SPH_C32(0xea790000),
    SPH_C32(0x1751235e), SPH_C32(0x60f3d20a), SPH_C32(0x0d93e8d2),
    SPH_C32(0x0bb918a5) },
  { SPH_C32(0x39e1f270), SPH_C32(0x75740000), SPH_C32(0x6d820000),
    SPH_C32(0xedf80000), SPH_C32(0xc2e54fb5), SPH_C32(0x2f990b98),
    SPH_C32(0xf82f5750), SPH_C32(0x0f39f8bf), SPH_C32(0xcf746c30),
    SPH_C32(0xbc430000), SPH_C32(0x56280000), SPH_C32(0xcc360000),
    SPH_C32(0x1f3878a7), SPH_C32(0x0d0f233d), SPH_C32(0x5d0c8156),
    SPH_C32(0x95d0b7cd) },
  { SPH_C32(0x1f81f030), SPH_C32(0xa8ac0000), SPH_C32(0x1fa80000),
    SPH_C32(0xa2fe0000), SPH_C32(0x5183284a), SPH_C32(0x06604f56),
    SPH_C32(0xcea43485), SPH_C32(0x031f0add), SPH_C32(0x207f6e40),
    SPH_C32(0x86be0000), SPH_C32(0x0b860000), SPH_C32(0xa57f0000),
    SPH_C32(0x843744a1), SPH_C32(0x490a96c4), SPH_C32(0x3b188b07),
    SPH_C32(0x079feac7) },
  { SPH_C32(0xf08af240), SPH_C32(0x92510000), SPH_C32(0x42060000),
    SPH_C32(0xcbb70000), SPH_C32(0xca8c144c), SPH_C32(0x4265faaf),
    SPH_C32(0xa8b03ed4), SPH_C32(0x915057d7), SPH_C32(0xe9146e70),
    SPH_C32(0x619b0000), SPH_C32(0x24020000), SPH_C32(0x83300000),
    SPH_C32(0x8c5e1f58), SPH_C32(0x24f667f3), SPH_C32(0x6b87e283),
    SPH_C32(0x99f645af) },
  { SPH_C32(0x466d0c00), SPH_C32(0x08620000), SPH_C32(0xdd5d0000),
    SPH_C32(0xbadd0000), SPH_C32(0x6a927942), SPH_C32(0x441f2b93),
    SPH_C32(0x218ace6f), SPH_C32(0xbf2c0be2), SPH_C32(0x6f299000),
    SPH_C32(0x6c850000), SPH_C32(0x2f160000), SPH_C32(0x782e0000),
    SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6), SPH_C32(0xd26a8c36),
    SPH_C32(0x32219526) },
  { SPH_C32(0xa9660e70), SPH_C32(0x329f0000), SPH_C32(0x80f30000),
    SPH_C32(0xd3940000), SPH_C32(0xf19d4544), SPH_C32(0x001a9e6a),
    SPH_C32(0x479ec43e), SPH_C32(0x2d6356e8), SPH_C32(0xa6429030),
    SPH_C32(0x8ba00000), SPH_C32(0x00920000), SPH_C32(0x5e610000),
    SPH_C32(0x6c256c34), SPH_C32(0x7f21ede1), SPH_C32(0x82f5e5b2),
    SPH_C32(0xac483a4e) },
  { SPH_C32(0x8f060c30), SPH_C32(0xef470000), SPH_C32(0xf2d90000),
    SPH_C32(0x9c920000), SPH_C32(0x62fb22bb), SPH_C32(0x29e3daa4),
    SPH_C32(0x7115a7eb), SPH_C32(0x2145a48a), SPH_C32(0x49499240),
    SPH_C32(0xb15d0000), SPH_C32(0x5d3c0000), SPH_C32(0x37280000),
    SPH_C32(0xf72a5032), SPH_C32(0x3b245818), SPH_C32(0xe4e1efe3),
    SPH_C32(0x3e076744) },
  { SPH_C32(0x600d0e40), SPH_C32(0xd5ba0000), SPH_C32(0xaf770000),
    SPH_C32(0xf5db0000), SPH_C32(0xf9f41ebd), SPH_C32(0x6de66f5d),
    SPH_C32(0x1701adba), SPH_C32(0xb30af980), SPH_C32(0x80229270),
    SPH_C32(0x56780000), SPH_C32(0x72b80000), SPH_C32(0x11670000),
    SPH_C32(0xff430bcb), SPH_C32(0x56d8a92f), SPH_C32(0xb47e8667),
    SPH_C32(0xa06ec82c) },
  { SPH_C32(0x52373000), SPH_C32(0xb18b0000), SPH_C32(0xbc7a0000),
    SPH_C32(0x4bbc0000), SPH_C32(0xa4f3442e), SPH_C32(0xf45616eb),
    SPH_C32(0x6623a94f), SPH_C32(0x5ea22f27), SPH_C32(0x4c4e8400),
    SPH_C32(0xa43c0000), SPH_C32(0xdbd10000), SPH_C32(0x835b0000),
    SPH_C32(0x178113a8), SPH_C32(0xea7bb99f), SPH_C32(0xd0ae8609),
    SPH_C32(0xee057339) },
  { SPH_C32(0xbd3c3270), SPH_C32(0x8b760000), SPH_C32(0xe1d40000),
    SPH_C32(0x22f50000), SPH_C32(0x3ffc7828), SPH_C32(0xb053a312),
    SPH_C32(0x0037a31e), SPH_C32(0xcced722d), SPH_C32(0x85258430),
    SPH_C32(0x43190000), SPH_C32(0xf4550000), SPH_C32(0xa5140000),
    SPH_C32(0x1fe84851), SPH_C32(0x878748a8), SPH_C32(0x8031ef8d),
    SPH_C32(0x706cdc51) },
  { SPH_C32(0x9b5c3030), SPH_C32(0x56ae0000), SPH_C32(0x93fe0000),
    SPH_C32(0x6df30000), SPH_C32(0xac9a1fd7), SPH_C32(0x99aae7dc),
    SPH_C32(0x36bcc0cb), SPH_C32(0xc0cb804f), SPH_C32(0x6a2e8640),
    SPH_C32(0x79e40000), SPH_C32(0xa9fb0000), SPH_C32(0xcc5d0000),
    SPH_C32(0x84e77457), SPH_C32(0xc382fd51), SPH_C32(0xe625e5dc),
    SPH_C32(0xe223815b) },
  { SPH_C32(0x74573240), SPH_C32(0x6c530000), SPH_C32(0xce500000),
    SPH_C32(0x04ba0000), SPH_C32(0x379523d1), SPH_C32(0xddaf5225),
    SPH_C32(0x50a8ca9a), SPH_C32(0x5284dd45), SPH_C32(0xa3458670),
    SPH_C32(0x9ec10000), SPH_C32(0x867f0000), SPH_C32(0xea120000),
    SPH_C32(0x8c8e2fae), SPH_C32(0xae7e0c66), SPH_C32(0xb6ba8c58),
    SPH_C32(0x7c4a2e33) },
  { SPH_C32(0x650a1800), SPH_C32(0xc0db0000), SPH_C32(0x299a0000),
    SPH_C32(0x41a80000), SPH_C32(0x195f5d27), SPH_C32(0xbcb98eda),
    SPH_C32(0x234ec450), SPH_C32(0x6308edfd), SPH_C32(0x5814b800),
    SPH_C32(0x1dd50000), SPH_C32(0xbaf60000), SPH_C32(0x723a0000),
    SPH_C32(0xd9e02ec4), SPH_C32(0x5a3284e7), SPH_C32(0x9707e129),
    SPH_C32(0x0f8b57fc) },
  { SPH_C32(0x8a011a70), SPH_C32(0xfa260000), SPH_C32(0x74340000),
    SPH_C32(0x28e10000), SPH_C32(0x82506121), SPH_C32(0xf8bc3b23),
    SPH_C32(0x455ace01), SPH_C32(0xf147b0f7), SPH_C32(0x917fb830),
    SPH_C32(0xfaf00000), SPH_C32(0x95720000), SPH_C32(0x54750000),
    SPH_C32(0xd189753d), SPH_C32(0x37ce75d0), SPH_C32(0xc79888ad),
    SPH_C32(0x91e2f894) },
  { SPH_C32(0xac611830), SPH_C32(0x27fe0000), SPH_C32(0x061e0000),
    SPH_C32(0x67e70000), SPH_C32(0x113606de), SPH_C32(0xd1457fed),
    SPH_C32(0x73d1add4), SPH_C32(0xfd614295), SPH_C32(0x7e74ba40),
    SPH_C32(0xc00d0000), SPH_C32(0xc8dc0000), SPH_C32(0x3d3c0000),
    SPH_C32(0x4a86493b), SPH_C32(0x73cbc029), SPH_C32(0xa18c82fc),
    SPH_C32(0x03ada59e) },
  { SPH_C32(0x436a1a40), SPH_C32(0x1d030000), SPH_C32(0x5bb00000),
    SPH_C32(0x0eae0000), SPH_C32(0x8a393ad8), SPH_C32(0x9540ca14),
    SPH_C32(0x15c5a785), SPH_C32(0x6f2e1f9f), SPH_C32(0xb71fba70),
    SPH_C32(0x27280000), SPH_C32(0xe7580000), SPH_C32(0x1b730000),
    SPH_C32(0x42ef12c2), SPH_C32(0x1e37311e), SPH_C32(0xf113eb78),
    SPH_C32(0x9dc40af6) },
  { SPH_C32(0x71502400), SPH_C32(0x79320000), SPH_C32(0x48bd0000),
    SPH_C32(0xb0c90000), SPH_C32(0xd73e604b), SPH_C32(0x0cf0b3a2),
    SPH_C32(0x64e7a370), SPH_C32(0x8286c938), SPH_C32(0x7b73ac00),
    SPH_C32(0xd56c0000), SPH_C32(0x4e310000), SPH_C32(0x894f0000),
    SPH_C32(0xaa2d0aa1), SPH_C32(0xa29421ae), SPH_C32(0x95c3eb16),
    SPH_C32(0xd3afb1e3) },
  { SPH_C32(0x9e5b2670), SPH_C32(0x43cf0000), SPH_C32(0x15130000),
    SPH_C32(0xd9800000), SPH_C32(0x4c315c4d), SPH_C32(0x48f5065b),
    SPH_C32(0x02f3a921), SPH_C32(0x10c99432), SPH_C32(0xb218ac30),
    SPH_C32(0x32490000), SPH_C32(0x61b50000), SPH_C32(0xaf000000),
    SPH_C32(0xa2445158), SPH_C32(0xcf68d099), SPH_C32(0xc55c8292),
    SPH_C32(0x4dc61e8b) },
  { SPH_C32(0xb83b2430), SPH_C32(0x9e170000), SPH_C32(0x67390000),
    SPH_C32(0x96860000), SPH_C32(0xdf573bb2), SPH_C32(0x610c4295),
    SPH_C32(0x3478caf4), SPH_C32(0x1cef6650), SPH_C32(0x5d13ae40),
    SPH_C32(0x08b40000), SPH_C32(0x3c1b0000), SPH_C32(0xc6490000),
    SPH_C32(0x394b6d5e), SPH_C32(0x8b6d6560), SPH_C32(0xa34888c3),
    SPH_C32(0xdf894381) },
  { SPH_C32(0x57302640), SPH_C32(0xa4ea0000), SPH_C32(0x3a970000),
    SPH_C32(0xffcf0000), SPH_C32(0x445807b4), SPH_C32(0x2509f76c),
    SPH_C32(0x526cc0a5), SPH_C32(0x8ea03b5a), SPH_C32(0x9478ae70),
    SPH_C32(0xef910000), SPH_C32(0x139f0000), SPH_C32(0xe0060000),
    SPH_C32(0x312236a7), SPH_C32(0xe6919457), SPH_C32(0xf3d7e147),
    SPH_C32(0x41e0ece9) },
  { SPH_C32(0x12455000), SPH_C32(0xe28f0000), SPH_C32(0x188b0000),
    SPH_C32(0x1b180000), SPH_C32(0xd9301e32), SPH_C32(0xd0baef72),
    SPH_C32(0x4a3a8ff2), SPH_C32(0xea373c60), SPH_C32(0xf3928800),
    SPH_C32(0xdc560000), SPH_C32(0xbd470000), SPH_C32(0x95bd0000),
    SPH_C32(0x3d767488), SPH_C32(0xf3c9c922), SPH_C32(0x916cbfec),
    SPH_C32(0x4aeb5b0f) },
  { SPH_C32(0xfd4e5270), SPH_C32(0xd8720000), SPH_C32(0x45250000),
    SPH_C32(0x72510000), SPH_C32(0x423f2234), SPH_C32(0x94bf5a8b),
    SPH_C32(0x2c2e85a3), SPH_C32(0x7878616a), SPH_C32(0x3af98830),
    SPH_C32(0x3b730000), SPH_C32(0x92c30000), SPH_C32(0xb3f20000),
    SPH_C32(0x351f2f71), SPH_C32(0x9e353815), SPH_C32(0xc1f3d668),
    SPH_C32(0xd482f467) },
  { SPH_C32(0xdb2e5030), SPH_C32(0x05aa0000), SPH_C32(0x370f0000),
    SPH_C32(0x3d570000), SPH_C32(0xd15945cb), SPH_C32(0xbd461e45),
    SPH_C32(0x1aa5e676), SPH_C32(0x745e9308), SPH_C32(0xd5f28a40),
    SPH_C32(0x018e0000), SPH_C32(0xcf6d0000), SPH_C32(0xdabb0000),
    SPH_C32(0xae101377), SPH_C32(0xda308dec), SPH_C32(0xa7e7dc39),
    SPH_C32(0x46cda96d) },
  { SPH_C32(0x34255240), SPH_C32(0x3f570000), SPH_C32(0x6aa10000),
    SPH_C32(0x541e0000), SPH_C32(0x4a5679cd), SPH_C32(0xf943abbc),
    SPH_C32(0x7cb1ec27), SPH_C32(0xe611ce02), SPH_C32(0x1c998a70),
    SPH_C32(0xe6ab0000), SPH_C32(0xe0e90000), SPH_C32(0xfcf40000),
    SPH_C32(0xa679488e), SPH_C32(0xb7cc7cdb), SPH_C32(0xf778b5bd),
    SPH_C32(0xd8a40605) },
  { SPH_C32(0x061f6c00), SPH_C32(0x5b660000), SPH_C32(0x79ac0000),
    SPH_C32(0xea790000), SPH_C32(0x1751235e), SPH_C32(0x60f3d20a),
    SPH_C32(0x0d93e8d2), SPH_C32(0x0bb918a5), SPH_C32(0xd0f59c00),
    SPH_C32(0x14ef0000), SPH_C32(0x49800000), SPH_C32(0x6ec80000),
    SPH_C32(0x4ebb50ed), SPH_C32(0x0b6f6c6b), SPH_C32(0x93a8b5d3),
    SPH_C32(0x96cfbd10) },
  { SPH_C32(0xe9146e70), SPH_C32(0x619b0000), SPH_C32(0x24020000),
    SPH_C32(0x83300000), SPH_C32(0x8c5e1f58), SPH_C32(0x24f667f3),
    SPH_C32(0x6b87e283), SPH_C32(0x99f645af), SPH_C32(0x199e9c30),
    SPH_C32(0xf3ca0000), SPH_C32(0x66040000), SPH_C32(0x48870000),
    SPH_C32(0x46d20b14), SPH_C32(0x66939d5c), SPH_C32(0xc337dc57),
    SPH_C32(0x08a61278) },
  { SPH_C32(0xcf746c30), SPH_C32(0xbc430000), SPH_C32(0x56280000),
    SPH_C32(0xcc360000), SPH_C32(0x1f3878a7), SPH_C32(0x0d0f233d),
    SPH_C32(0x5d0c8156), SPH_C32(0x95d0b7cd), SPH_C32(0xf6959e40),
    SPH_C32(0xc9370000), SPH_C32(0x3baa0000), SPH_C32(0x21ce0000),
    SPH_C32(0xdddd3712), SPH_C32(0x229628a5), SPH_C32(0xa523d606),
    SPH_C32(0x9ae94f72) },
  { SPH_C32(0x207f6e40), SPH_C32(0x86be0000), SPH_C32(0x0b860000),
    SPH_C32(0xa57f0000), SPH_C32(0x843744a1), SPH_C32(0x490a96c4),
    SPH_C32(0x3b188b07), SPH_C32(0x079feac7), SPH_C32(0x3ffe9e70),
    SPH_C32(0x2e120000), SPH_C32(0x142e0000), SPH_C32(0x07810000),
    SPH_C32(0xd5b46ceb), SPH_C32(0x4f6ad992), SPH_C32(0xf5bcbf82),
    SPH_C32(0x0480e01a) },
  { SPH_C32(0x31224400), SPH_C32(0x2a360000), SPH_C32(0xec4c0000),
    SPH_C32(0xe06d0000), SPH_C32(0xaafd3a57), SPH_C32(0x281c4a3b),
    SPH_C32(0x48fe85cd), SPH_C32(0x3613da7f), SPH_C32(0xc4afa000),
    SPH_C32(0xad060000), SPH_C32(0x28a70000), SPH_C32(0x9fa90000),
    SPH_C32(0x80da6d81), SPH_C32(0xbb265113), SPH_C32(0xd401d2f3),
    SPH_C32(0x774199d5) },
  { SPH_C32(0xde294670), SPH_C32(0x10cb0000), SPH_C32(0xb1e20000),
    SPH_C32(0x89240000), SPH_C32(0x31f20651), SPH_C32(0x6c19ffc2),
    SPH_C32(0x2eea8f9c), SPH_C32(0xa45c8775), SPH_C32(0x0dc4a030),
    SPH_C32(0x4a230000), SPH_C32(0x07230000), SPH_C32(0xb9e60000),
    SPH_C32(0x88b33678), SPH_C32(0xd6daa024), SPH_C32(0x849ebb77),
    SPH_C32(0xe92836bd) },
  { SPH_C32(0xf8494430), SPH_C32(0xcd130000), SPH_C32(0xc3c80000),
    SPH_C32(0xc6220000), SPH_C32(0xa29461ae), SPH_C32(0x45e0bb0c),
    SPH_C32(0x1861ec49), SPH_C32(0xa87a7517), SPH_C32(0xe2cfa240),
    SPH_C32(0x70de0000), SPH_C32(0x5a8d0000), SPH_C32(0xd0af0000),
    SPH_C32(0x13bc0a7e), SPH_C32(0x92df15dd), SPH_C32(0xe28ab126),
    SPH_C32(0x7b676bb7) },
  { SPH_C32(0x17424640), SPH_C32(0xf7ee0000), SPH_C32(0x9e660000),
    SPH_C32(0xaf6b0000), SPH_C32(0x399b5da8), SPH_C32(0x01e50ef5),
    SPH_C32(0x7e75e618), SPH_C32(0x3a35281d), SPH_C32(0x2ba4a270),
    SPH_C32(0x97fb0000), SPH_C32(0x75090000), SPH_C32(0xf6e00000),
    SPH_C32(0x1bd55187), SPH_C32(0xff23e4ea), SPH_C32(0xb215d8a2),
    SPH_C32(0xe50ec4df) },
  { SPH_C32(0x25787800), SPH_C32(0x93df0000), SPH_C32(0x8d6b0000),
    SPH_C32(0x110c0000), SPH_C32(0x649c073b), SPH_C32(0x98557743),
    SPH_C32(0x0f57e2ed), SPH_C32(0xd79dfeba), SPH_C32(0xe7c8b400),
    SPH_C32(0x65bf0000), SPH_C32(0xdc600000), SPH_C32(0x64dc0000),
    SPH_C32(0xf31749e4), SPH_C32(0x4380f45a), SPH_C32(0xd6c5d8cc),
    SPH_C32(0xab657fca) },
  { SPH_C32(0xca737a70), SPH_C32(0xa9220000), SPH_C32(0xd0c50000),
    SPH_C32(0x78450000), SPH_C32(0xff933b3d), SPH_C32(0xdc50c2ba),
    SPH_C32(0x6943e8bc), SPH_C32(0x45d2a3b0), SPH_C32(0x2ea3b430),
    SPH_C32(0x829a0000), SPH_C32(0xf3e40000), SPH_C32(0x42930000),
    SPH_C32(0xfb7e121d), SPH_C32(0x2e7c056d), SPH_C32(0x865ab148),
    SPH_C32(0x350cd0a2) },
  { SPH_C32(0xec137830), SPH_C32(0x74fa0000), SPH_C32(0xa2ef0000),
    SPH_C32(0x37430000), SPH_C32(0x6cf55cc2), SPH_C32(0xf5a98674),
    SPH_C32(0x5fc88b69), SPH_C32(0x49f451d2), SPH_C32(0xc1a8b640),
    SPH_C32(0xb8670000), SPH_C32(0xae4a0000), SPH_C32(0x2bda0000),
    SPH_C32(0x60712e1b), SPH_C32(0x6a79b094), SPH_C32(0xe04ebb19),
    SPH_C32(0xa7438da8) },
  { SPH_C32(0x03187a40), SPH_C32(0x4e070000), SPH_C32(0xff410000),
    SPH_C32(0x5e0a0000), SPH_C32(0xf7fa60c4), SPH_C32(0xb1ac338d),
    SPH_C32(0x39dc8138), SPH_C32(0xdbbb0cd8), SPH_C32(0x08c3b670),
    SPH_C32(0x5f420000), SPH_C32(0x81ce0000), SPH_C32(0x0d950000),
    SPH_C32(0x681875e2), SPH_C32(0x078541a3), SPH_C32(0xb0d1d29d),
    SPH_C32(0x392a22c0) },
  { SPH_C32(0xdad61400), SPH_C32(0xb8b10000), SPH_C32(0x4f0c0000),
    SPH_C32(0x574e0000), SPH_C32(0x33a83a07), SPH_C32(0xa50bfe67),
    SPH_C32(0x628cfdb5), SPH_C32(0xc7e6c5cb), SPH_C32(0xa7bad400),
    SPH_C32(0x36bb0000), SPH_C32(0x78910000), SPH_C32(0x34780000),
    SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3), SPH_C32(0xfadcfe71),
    SPH_C32(0x1ff06c8d) },
  { SPH_C32(0x35dd1670), SPH_C32(0x824c0000), SPH_C32(0x12a20000),
    SPH_C32(0x3e070000), SPH_C32(0xa8a70601), SPH_C32(0xe10e4b9e),
    SPH_C32(0x0498f7e4), SPH_C32(0x55a998c1), SPH_C32(0x6ed1d430),
    SPH_C32(0xd19e0000), SPH_C32(0x57150000), SPH_C32(0x12370000),
    SPH_C32(0x86bd4801), SPH_C32(0x0a90fcf4), SPH_C32(0xaa4397f5),
    SPH_C32(0x8199c3e5) },
  { SPH_C32(0x13bd1430), SPH_C32(0x5f940000), SPH_C32(0x60880000),
    SPH_C32(0x71010000), SPH_C32(0x3bc161fe), SPH_C32(0xc8f70f50),
    SPH_C32(0x32139431), SPH_C32(0x598f6aa3), SPH_C32(0x81dad640),
    SPH_C32(0xeb630000), SPH_C32(0x0abb0000), SPH_C32(0x7b7e0000),
    SPH_C32(0x1db27407), SPH_C32(0x4e95490d), SPH_C32(0xcc579da4),
    SPH_C32(0x13d69eef) },
  { SPH_C32(0xfcb61640), SPH_C32(0x65690000), SPH_C32(0x3d260000),
    SPH_C32(0x18480000), SPH_C32(0xa0ce5df8), SPH_C32(0x8cf2baa9),
    SPH_C32(0x54079e60), SPH_C32(0xcbc037a9), SPH_C32(0x48b1d670),
    SPH_C32(0x0c460000), SPH_C32(0x253f0000), SPH_C32(0x5d310000),
    SPH_C32(0x15db2ffe), SPH_C32(0x2369b83a), SPH_C32(0x9cc8f420),
    SPH_C32(0x8dbf3187) },
  { SPH_C32(0xce8c2800), SPH_C32(0x01580000), SPH_C32(0x2e2b0000),
    SPH_C32(0xa62f0000), SPH_C32(0xfdc9076b), SPH_C32(0x1542c31f),
    SPH_C32(0x25259a95), SPH_C32(0x2668e10e), SPH_C32(0x84ddc000),
    SPH_C32(0xfe020000), SPH_C32(0x8c560000), SPH_C32(0xcf0d0000),
    SPH_C32(0xfd19379d), SPH_C32(0x9fcaa88a), SPH_C32(0xf818f44e),
    SPH_C32(0xc3d48a92) },
  { SPH_C32(0x21872a70), SPH_C32(0x3ba50000), SPH_C32(0x73850000),
    SPH_C32(0xcf660000), SPH_C32(0x66c63b6d), SPH_C32(0x514776e6),
    SPH_C32(0x433190c4), SPH_C32(0xb427bc04), SPH_C32(0x4db6c030),
    SPH_C32(0x19270000), SPH_C32(0xa3d20000), SPH_C32(0xe9420000),
    SPH_C32(0xf5706c64), SPH_C32(0xf23659bd), SPH_C32(0xa8879dca),
    SPH_C32(0x5dbd25fa) },
  { SPH_C32(0x07e72830), SPH_C32(0xe67d0000), SPH_C32(0x01af0000),
    SPH_C32(0x80600000), SPH_C32(0xf5a05c92), SPH_C32(0x78be3228),
    SPH_C32(0x75baf311), SPH_C32(0xb8014e66), SPH_C32(0xa2bdc240),
    SPH_C32(0x23da0000), SPH_C32(0xfe7c0000), SPH_C32(0x800b0000),
    SPH_C32(0x6e7f5062), SPH_C32(0xb633ec44), SPH_C32(0xce93979b),
    SPH_C32(0xcff278f0) },
  { SPH_C32(0xe8ec2a40), SPH_C32(0xdc800000), SPH_C32(0x5c010000),
    SPH_C32(0xe9290000), SPH_C32(0x6eaf6094), SPH_C32(0x3cbb87d1),
    SPH_C32(0x13aef940), SPH_C32(0x2a4e136c), SPH_C32(0x6bd6c270),
    SPH_C32(0xc4ff0000), SPH_C32(0xd1f80000), SPH_C32(0xa6440000),
    SPH_C32(0x66160b9b), SPH_C32(0xdbcf1d73), SPH_C32(0x9e0cfe1f),
    SPH_C32(0x519bd798) },
  { SPH_C32(0xf9b10000), SPH_C32(0x70080000), SPH_C32(0xbbcb0000),
    SPH_C32(0xac3b0000), SPH_C32(0x40651e62), SPH_C32(0x5dad5b2e),
    SPH_C32(0x6048f78a), SPH_C32(0x1bc223d4), SPH_C32(0x9087fc00),
    SPH_C32(0x47eb0000), SPH_C32(0xed710000), SPH_C32(0x3e6c0000),
    SPH_C32(0x33780af1), SPH_C32(0x2f8395f2), SPH_C32(0xbfb1936e),
    SPH_C32(0x225aae57) },
  { SPH_C32(0x16ba0270), SPH_C32(0x4af50000), SPH_C32(0xe6650000),
    SPH_C32(0xc5720000), SPH_C32(0xdb6a2264), SPH_C32(0x19a8eed7),
    SPH_C32(0x065cfddb), SPH_C32(0x898d7ede), SPH_C32(0x59ecfc30),
    SPH_C32(0xa0ce0000), SPH_C32(0xc2f50000), SPH_C32(0x18230000),
    SPH_C32(0x3b115108), SPH_C32(0x427f64c5), SPH_C32(0xef2efaea),
    SPH_C32(0xbc33013f) },
  { SPH_C32(0x30da0030), SPH_C32(0x972d0000), SPH_C32(0x944f0000),
    SPH_C32(0x8a740000), SPH_C32(0x480c459b), SPH_C32(0x3051aa19),
    SPH_C32(0x30d79e0e), SPH_C32(0x85ab8cbc), SPH_C32(0xb6e7fe40),
    SPH_C32(0x9a330000), SPH_C32(0x9f5b0000), SPH_C32(0x716a0000),
    SPH_C32(0xa01e6d0e), SPH_C32(0x067ad13c), SPH_C32(0x893af0bb),
    SPH_C32(0x2e7c5c35) },
  { SPH_C32(0xdfd10240), SPH_C32(0xadd00000), SPH_C32(0xc9e10000),
    SPH_C32(0xe33d0000), SPH_C32(0xd303799d), SPH_C32(0x74541fe0),
    SPH_C32(0x56c3945f), SPH_C32(0x17e4d1b6), SPH_C32(0x7f8cfe70),
    SPH_C32(0x7d160000), SPH_C32(0xb0df0000), SPH_C32(0x57250000),
    SPH_C32(0xa87736f7), SPH_C32(0x6b86200b), SPH_C32(0xd9a5993f),
    SPH_C32(0xb015f35d) },
  { SPH_C32(0xedeb3c00), SPH_C32(0xc9e10000), SPH_C32(0xdaec0000),
    SPH_C32(0x5d5a0000), SPH_C32(0x8e04230e), SPH_C32(0xede46656),
    SPH_C32(0x27e190aa), SPH_C32(0xfa4c0711), SPH_C32(0xb3e0e800),
    SPH_C32(0x8f520000), SPH_C32(0x19b60000), SPH_C32(0xc5190000),
    SPH_C32(0x40b52e94), SPH_C32(0xd72530bb), SPH_C32(0xbd759951),
    SPH_C32(0xfe7e4848) },
  { SPH_C32(0x02e03e70), SPH_C32(0xf31c0000), SPH_C32(0x87420000),
    SPH_C32(0x34130000), SPH_C32(0x150b1f08), SPH_C32(0xa9e1d3af),
    SPH_C32(0x41f59afb), SPH_C32(0x68035a1b), SPH_C32(0x7a8be830),
    SPH_C32(0x68770000), SPH_C32(0x36320000), SPH_C32(0xe3560000),
    SPH_C32(0x48dc756d), SPH_C32(0xbad9c18c), SPH_C32(0xedeaf0d5),
    SPH_C32(0x6017e720) },
  { SPH_C32(0x24803c30), SPH_C32(0x2ec40000), SPH_C32(0xf5680000),
    SPH_C32(0x7b150000), SPH_C32(0x866d78f7), SPH_C32(0x80189761),
    SPH_C32(0x777ef92e), SPH_C32(0x6425a879), SPH_C32(0x9580ea40),
    SPH_C32(0x528a0000), SPH_C32(0x6b9c0000), SPH_C32(0x8a1f0000),
    SPH_C32(0xd3d3496b), SPH_C32(0xfedc7475), SPH_C32(0x8bfefa84),
    SPH_C32(0xf258ba2a) },
  { SPH_C32(0xcb8b3e40), SPH_C32(0x14390000), SPH_C32(0xa8c60000),
    SPH_C32(0x125c0000), SPH_C32(0x1d6244f1), SPH_C32(0xc41d2298),
    SPH_C32(0x116af37f), SPH_C32(0xf66af573), SPH_C32(0x5cebea70),
    SPH_C32(0xb5af0000), SPH_C32(0x44180000), SPH_C32(0xac500000),
    SPH_C32(0xdbba1292), SPH_C32(0x93208542), SPH_C32(0xdb619300),
    SPH_C32(0x6c311542) },
  { SPH_C32(0x8efe4800), SPH_C32(0x525c0000), SPH_C32(0x8ada0000),
    SPH_C32(0xf68b0000), SPH_C32(0x800a5d77), SPH_C32(0x31ae3a86),
    SPH_C32(0x093cbc28), SPH_C32(0x92fdf249), SPH_C32(0x3b01cc00),
    SPH_C32(0x86680000), SPH_C32(0xeac00000), SPH_C32(0xd9eb0000),
    SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837), SPH_C32(0xb9dacdab),
    SPH_C32(0x673aa2a4) },
  { SPH_C32(0x61f54a70), SPH_C32(0x68a10000), SPH_C32(0xd7740000),
    SPH_C32(0x9fc20000), SPH_C32(0x1b056171), SPH_C32(0x75ab8f7f),
    SPH_C32(0x6f28b679), SPH_C32(0x00b2af43), SPH_C32(0xf26acc30),
    SPH_C32(0x614d0000), SPH_C32(0xc5440000), SPH_C32(0xffa40000),
    SPH_C32(0xdf870b44), SPH_C32(0xeb842900), SPH_C32(0xe945a42f),
    SPH_C32(0xf9530dcc) },
  { SPH_C32(0x47954830), SPH_C32(0xb5790000), SPH_C32(0xa55e0000),
    SPH_C32(0xd0c40000), SPH_C32(0x8863068e), SPH_C32(0x5c52cbb1),
    SPH_C32(0x59a3d5ac), SPH_C32(0x0c945d21), SPH_C32(0x1d61ce40),
    SPH_C32(0x5bb00000), SPH_C32(0x98ea0000), SPH_C32(0x96ed0000),
    SPH_C32(0x44883742), SPH_C32(0xaf819cf9), SPH_C32(0x8f51ae7e),
    SPH_C32(0x6b1c50c6) },
  { SPH_C32(0xa89e4a40), SPH_C32(0x8f840000), SPH_C32(0xf8f00000),
    SPH_C32(0xb98d0000), SPH_C32(0x136c3a88), SPH_C32(0x18577e48),
    SPH_C32(0x3fb7dffd), SPH_C32(0x9edb002b), SPH_C32(0xd40ace70),
    SPH_C32(0xbc950000), SPH_C32(0xb76e0000), SPH_C32(0xb0a20000),
    SPH_C32(0x4ce16cbb), SPH_C32(0xc27d6dce), SPH_C32(0xdfcec7fa),
    SPH_C32(0xf575ffae) },
  { SPH_C32(0x9aa47400), SPH_C32(0xebb50000), SPH_C32(0xebfd0000),
    SPH_C32(0x07ea0000), SPH_C32(0x4e6b601b), SPH_C32(0x81e707fe),
    SPH_C32(0x4e95db08), SPH_C32(0x7373d68c), SPH_C32(0x1866d800),
    SPH_C32(0x4ed10000), SPH_C32(0x1e070000), SPH_C32(0x229e0000),
    SPH_C32(0xa42374d8), SPH_C32(0x7ede7d7e), SPH_C32(0xbb1ec794),
    SPH_C32(0xbb1e44bb) },
  { SPH_C32(0x75af7670), SPH_C32(0xd1480000), SPH_C32(0xb6530000),
    SPH_C32(0x6ea30000), SPH_C32(0xd5645c1d), SPH_C32(0xc5e2b207),
    SPH_C32(0x2881d159), SPH_C32(0xe13c8b86), SPH_C32(0xd10dd830),
    SPH_C32(0xa9f40000), SPH_C32(0x31830000), SPH_C32(0x04d10000),
    SPH_C32(0xac4a2f21), SPH_C32(0x13228c49), SPH_C32(0xeb81ae10),
    SPH_C32(0x2577ebd3) },
  { SPH_C32(0x53cf7430), SPH_C32(0x0c900000), SPH_C32(0xc4790000),
    SPH_C32(0x21a50000), SPH_C32(0x46023be2), SPH_C32(0xec1bf6c9),
    SPH_C32(0x1e0ab28c), SPH_C32(0xed1a79e4), SPH_C32(0x3e06da40),
    SPH_C32(0x93090000), SPH_C32(0x6c2d0000), SPH_C32(0x6d980000),
    SPH_C32(0x37451327), SPH_C32(0x572739b0), SPH_C32(0x8d95a441),
    SPH_C32(0xb738b6d9) },
  { SPH_C32(0xbcc47640), SPH_C32(0x366d0000), SPH_C32(0x99d70000),
    SPH_C32(0x48ec0000), SPH_C32(0xdd0d07e4), SPH_C32(0xa81e4330),
    SPH_C32(0x781eb8dd), SPH_C32(0x7f5524ee), SPH_C32(0xf76dda70),
    SPH_C32(0x742c0000), SPH_C32(0x43a90000), SPH_C32(0x4bd70000),
    SPH_C32(0x3f2c48de), SPH_C32(0x3adbc887), SPH_C32(0xdd0acdc5),
    SPH_C32(0x295119b1) },
  { SPH_C32(0xad995c00), SPH_C32(0x9ae50000), SPH_C32(0x7e1d0000),
    SPH_C32(0x0dfe0000), SPH_C32(0xf3c77912), SPH_C32(0xc9089fcf),
    SPH_C32(0x0bf8b617), SPH_C32(0x4ed91456), SPH_C32(0x0c3ce400),
    SPH_C32(0xf7380000), SPH_C32(0x7f200000), SPH_C32(0xd3ff0000),
    SPH_C32(0x6a4249b4), SPH_C32(0xce974006), SPH_C32(0xfcb7a0b4),
    SPH_C32(0x5a90607e) },
  { SPH_C32(0x42925e70), SPH_C32(0xa0180000), SPH_C32(0x23b30000),
    SPH_C32(0x64b70000), SPH_C32(0x68c84514), SPH_C32(0x8d0d2a36),
    SPH_C32(0x6decbc46), SPH_C32(0xdc96495c), SPH_C32(0xc557e430),
    SPH_C32(0x101d0000), SPH_C32(0x50a40000), SPH_C32(0xf5b00000),
    SPH_C32(0x622b124d), SPH_C32(0xa36bb131), SPH_C32(0xac28c930),
    SPH_C32(0xc4f9cf16) },
  { SPH_C32(0x64f25c30), SPH_C32(0x7dc00000), SPH_C32(0x51990000),
    SPH_C32(0x2bb10000), SPH_C32(0xfbae22eb), SPH_C32(0xa4f46ef8),
    SPH_C32(0x5b67df93), SPH_C32(0xd0b0bb3e), SPH_C32(0x2a5ce640),
    SPH_C32(0x2ae00000), SPH_C32(0x0d0a0000), SPH_C32(0x9cf90000),
    SPH_C32(0xf9242e4b), SPH_C32(0xe76e04c8), SPH_C32(0xca3cc361),
    SPH_C32(0x56b6921c) },
  { SPH_C32(0x8bf95e40), SPH_C32(0x473d0000), SPH_C32(0x0c370000),
    SPH_C32(0x42f80000), SPH_C32(0x60a11eed), SPH_C32(0xe0f1db01),
    SPH_C32(0x3d73d5c2), SPH_C32(0x42ffe634), SPH_C32(0xe337e670),
    SPH_C32(0xcdc50000), SPH_C32(0x228e0000), SPH_C32(0xbab60000),
    SPH_C32(0xf14d75b2), SPH_C32(0x8a92f5ff), SPH_C32(0x9aa3aae5),
    SPH_C32(0xc8df3d74) },
  { SPH_C32(0xb9c36000), SPH_C32(0x230c0000), SPH_C32(0x1f3a0000),
    SPH_C32(0xfc9f0000), SPH_C32(0x3da6447e), SPH_C32(0x7941a2b7),
    SPH_C32(0x4c51d137), SPH_C32(0xaf573093), SPH_C32(0x2f5bf000),
    SPH_C32(0x3f810000), SPH_C32(0x8be70000), SPH_C32(0x288a0000),
    SPH_C32(0x198f6dd1), SPH_C32(0x3631e54f), SPH_C32(0xfe73aa8b),
    SPH_C32(0x86b48661) },
  { SPH_C32(0x56c86270), SPH_C32(0x19f10000), SPH_C32(0x42940000),
    SPH_C32(0x95d60000), SPH_C32(0xa6a97878), SPH_C32(0x3d44174e),
    SPH_C32(0x2a45db66), SPH_C32(0x3d186d99), SPH_C32(0xe630f030),
    SPH_C32(0xd8a40000), SPH_C32(0xa4630000), SPH_C32(0x0ec50000),
    SPH_C32(0x11e63628), SPH_C32(0x5bcd1478), SPH_C32(0xaeecc30f),
    SPH_C32(0x18dd2909) },
  { SPH_C32(0x70a86030), SPH_C32(0xc4290000), SPH_C32(0x30be0000),
    SPH_C32(0xdad00000), SPH_C32(0x35cf1f87), SPH_C32(0x14bd5380),
    SPH_C32(0x1cceb8b3), SPH_C32(0x313e9ffb), SPH_C32(0x093bf240),
    SPH_C32(0xe2590000), SPH_C32(0xf9cd0000), SPH_C32(0x678c0000),
    SPH_C32(0x8ae90a2e), SPH_C32(0x1fc8a181), SPH_C32(0xc8f8c95e),
    SPH_C32(0x8a927403) },
  { SPH_C32(0x9fa36240), SPH_C32(0xfed40000), SPH_C32(0x6d100000),
    SPH_C32(0xb3990000), SPH_C32(0xaec02381), SPH_C32(0x50b8e679),
    SPH_C32(0x7adab2e2), SPH_C32(0xa371c2f1), SPH_C32(0xc050f270),
    SPH_C32(0x057c0000), SPH_C32(0xd6490000), SPH_C32(0x41c30000),
    SPH_C32(0x828051d7), SPH_C32(0x723450b6), SPH_C32(0x9867a0da),
    SPH_C32(0x14fbdb6b) },
  { SPH_C32(0x6f299000), SPH_C32(0x6c850000), SPH_C32(0x2f160000),
    SPH_C32(0x782e0000), SPH_C32(0x644c37cd), SPH_C32(0x12dd1cd6),
    SPH_C32(0xd26a8c36), SPH_C32(0x32219526), SPH_C32(0x29449c00),
    SPH_C32(0x64e70000), SPH_C32(0xf24b0000), SPH_C32(0xc2f30000),
    SPH_C32(0x0ede4e8f), SPH_C32(0x56c23745), SPH_C32(0xf3e04259),
    SPH_C32(0x8d0d9ec4) },
  { SPH_C32(0x80229270), SPH_C32(0x56780000), SPH_C32(0x72b80000),
    SPH_C32(0x11670000), SPH_C32(0xff430bcb), SPH_C32(0x56d8a92f),
    SPH_C32(0xb47e8667), SPH_C32(0xa06ec82c), SPH_C32(0xe02f9c30),
    SPH_C32(0x83c20000), SPH_C32(0xddcf0000), SPH_C32(0xe4bc0000),
    SPH_C32(0x06b71576), SPH_C32(0x3b3ec672), SPH_C32(0xa37f2bdd),
    SPH_C32(0x136431ac) },
  { SPH_C32(0xa6429030), SPH_C32(0x8ba00000), SPH_C32(0x00920000),
    SPH_C32(0x5e610000), SPH_C32(0x6c256c34), SPH_C32(0x7f21ede1),
    SPH_C32(0x82f5e5b2), SPH_C32(0xac483a4e), SPH_C32(0x0f249e40),
    SPH_C32(0xb93f0000), SPH_C32(0x80610000), SPH_C32(0x8df50000),
    SPH_C32(0x9db82970), SPH_C32(0x7f3b738b), SPH_C32(0xc56b218c),
    SPH_C32(0x812b6ca6) },
  { SPH_C32(0x49499240), SPH_C32(0xb15d0000), SPH_C32(0x5d3c0000),
    SPH_C32(0x37280000), SPH_C32(0xf72a5032), SPH_C32(0x3b245818),
    SPH_C32(0xe4e1efe3), SPH_C32(0x3e076744), SPH_C32(0xc64f9e70),
    SPH_C32(0x5e1a0000), SPH_C32(0xafe50000), SPH_C32(0xabba0000),
    SPH_C32(0x95d17289), SPH_C32(0x12c782bc), SPH_C32(0x95f44808),
    SPH_C32(0x1f42c3ce) },
  { SPH_C32(0x7b73ac00), SPH_C32(0xd56c0000), SPH_C32(0x4e310000),
    SPH_C32(0x894f0000), SPH_C32(0xaa2d0aa1), SPH_C32(0xa29421ae),
    SPH_C32(0x95c3eb16), SPH_C32(0xd3afb1e3), SPH_C32(0x0a238800),
    SPH_C32(0xac5e0000), SPH_C32(0x068c0000), SPH_C32(0x39860000),
    SPH_C32(0x7d136aea), SPH_C32(0xae64920c), SPH_C32(0xf1244866),
    SPH_C32(0x512978db) },
  { SPH_C32(0x9478ae70), SPH_C32(0xef910000), SPH_C32(0x139f0000),
    SPH_C32(0xe0060000), SPH_C32(0x312236a7), SPH_C32(0xe6919457),
    SPH_C32(0xf3d7e147), SPH_C32(0x41e0ece9), SPH_C32(0xc3488830),
    SPH_C32(0x4b7b0000), SPH_C32(0x29080000), SPH_C32(0x1fc90000),
    SPH_C32(0x757a3113), SPH_C32(0xc398633b), SPH_C32(0xa1bb21e2),
    SPH_C32(0xcf40d7b3) },
  { SPH_C32(0xb218ac30), SPH_C32(0x32490000), SPH_C32(0x61b50000),
    SPH_C32(0xaf000000), SPH_C32(0xa2445158), SPH_C32(0xcf68d099),
    SPH_C32(0xc55c8292), SPH_C32(0x4dc61e8b), SPH_C32(0x2c438a40),
    SPH_C32(0x71860000), SPH_C32(0x74a60000), SPH_C32(0x76800000),
    SPH_C32(0xee750d15), SPH_C32(0x879dd6c2), SPH_C32(0xc7af2bb3),
    SPH_C32(0x5d0f8ab9) },
  { SPH_C32(0x5d13ae40), SPH_C32(0x08b40000), SPH_C32(0x3c1b0000),
    SPH_C32(0xc6490000), SPH_C32(0x394b6d5e), SPH_C32(0x8b6d6560),
    SPH_C32(0xa34888c3), SPH_C32(0xdf894381), SPH_C32(0xe5288a70),
    SPH_C32(0x96a30000), SPH_C32(0x5b220000), SPH_C32(0x50cf0000),
    SPH_C32(0xe61c56ec), SPH_C32(0xea6127f5), SPH_C32(0x97304237),
    SPH_C32(0xc36625d1) },
  { SPH_C32(0x4c4e8400), SPH_C32(0xa43c0000), SPH_C32(0xdbd10000),
    SPH_C32(0x835b0000), SPH_C32(0x178113a8), SPH_C32(0xea7bb99f),
    SPH_C32(0xd0ae8609), SPH_C32(0xee057339), SPH_C32(0x1e79b400),
    SPH_C32(0x15b70000), SPH_C32(0x67ab0000), SPH_C32(0xc8e70000),
    SPH_C32(0xb3725786), SPH_C32(0x1e2daf74), SPH_C32(0xb68d2f46),
    SPH_C32(0xb0a75c1e) },
  { SPH_C32(0xa3458670), SPH_C32(0x9ec10000), SPH_C32(0x867f0000),
    SPH_C32(0xea120000), SPH_C32(0x8c8e2fae), SPH_C32(0xae7e0c66),
    SPH_C32(0xb6ba8c58), SPH_C32(0x7c4a2e33), SPH_C32(0xd712b430),
    SPH_C32(0xf2920000), SPH_C32(0x482f0000), SPH_C32(0xeea80000),
    SPH_C32(0xbb1b0c7f), SPH_C32(0x73d15e43), SPH_C32(0xe61246c2),
    SPH_C32(0x2ecef376) },
  { SPH_C32(0x85258430), SPH_C32(0x43190000), SPH_C32(0xf4550000),
    SPH_C32(0xa5140000), SPH_C32(0x1fe84851), SPH_C32(0x878748a8),
    SPH_C32(0x8031ef8d), SPH_C32(0x706cdc51), SPH_C32(0x3819b640),
    SPH_C32(0xc86f0000), SPH_C32(0x15810000), SPH_C32(0x87e10000),
    SPH_C32(0x20143079), SPH_C32(0x37d4ebba), SPH_C32(0x80064c93),
    SPH_C32(0xbc81ae7c) },
  { SPH_C32(0x6a2e8640), SPH_C32(0x79e40000), SPH_C32(0xa9fb0000),
    SPH_C32(0xcc5d0000), SPH_C32(0x84e77457), SPH_C32(0xc382fd51),
    SPH_C32(0xe625e5dc), SPH_C32(0xe223815b), SPH_C32(0xf172b670),
    SPH_C32(0x2f4a0000), SPH_C32(0x3a050000), SPH_C32(0xa1ae0000),
    SPH_C32(0x287d6b80), SPH_C32(0x5a281a8d), SPH_C32(0xd0992517),
    SPH_C32(0x22e80114) },
  { SPH_C32(0x5814b800), SPH_C32(0x1dd50000), SPH_C32(0xbaf60000),
    SPH_C32(0x723a0000), SPH_C32(0xd9e02ec4), SPH_C32(0x5a3284e7),
    SPH_C32(0x9707e129), SPH_C32(0x0f8b57fc), SPH_C32(0x3d1ea000),
    SPH_C32(0xdd0e0000), SPH_C32(0x936c0000), SPH_C32(0x33920000),
    SPH_C32(0xc0bf73e3), SPH_C32(0xe68b0a3d), SPH_C32(0xb4492579),
    SPH_C32(0x6c83ba01) },
  { SPH_C32(0xb71fba70), SPH_C32(0x27280000), SPH_C32(0xe7580000),
    SPH_C32(0x1b730000), SPH_C32(0x42ef12c2), SPH_C32(0x1e37311e),
    SPH_C32(0xf113eb78), SPH_C32(0x9dc40af6), SPH_C32(0xf475a030),
    SPH_C32(0x3a2b0000), SPH_C32(0xbce80000), SPH_C32(0x15dd0000),
    SPH_C32(0xc8d6281a), SPH_C32(0x8b77fb0a), SPH_C32(0xe4d64cfd),
    SPH_C32(0xf2ea1569) },
  { SPH_C32(0x917fb830), SPH_C32(0xfaf00000), SPH_C32(0x95720000),
    SPH_C32(0x54750000), SPH_C32(0xd189753d), SPH_C32(0x37ce75d0),
    SPH_C32(0xc79888ad), SPH_C32(0x91e2f894), SPH_C32(0x1b7ea240),
    SPH_C32(0x00d60000), SPH_C32(0xe1460000), SPH_C32(0x7c940000),
    SPH_C32(0x53d9141c), SPH_C32(0xcf724ef3), SPH_C32(0x82c246ac),
    SPH_C32(0x60a54863) },
  { SPH_C32(0x7e74ba40), SPH_C32(0xc00d0000), SPH_C32(0xc8dc0000),
    SPH_C32(0x3d3c0000), SPH_C32(0x4a86493b), SPH_C32(0x73cbc029),
    SPH_C32(0xa18c82fc), SPH_C32(0x03ada59e), SPH_C32(0xd215a270),
    SPH_C32(0xe7f30000), SPH_C32(0xcec20000), SPH_C32(0x5adb0000),
    SPH_C32(0x5bb04fe5), SPH_C32(0xa28ebfc4), SPH_C32(0xd25d2f28),
    SPH_C32(0xfecce70b) },
  { SPH_C32(0x3b01cc00), SPH_C32(0x86680000), SPH_C32(0xeac00000),
    SPH_C32(0xd9eb0000), SPH_C32(0xd7ee50bd), SPH_C32(0x8678d837),
    SPH_C32(0xb9dacdab), SPH_C32(0x673aa2a4), SPH_C32(0xb5ff8400),
    SPH_C32(0xd4340000), SPH_C32(0x601a0000), SPH_C32(0x2f600000),
    SPH_C32(0x57e40dca), SPH_C32(0xb7d6e2b1), SPH_C32(0xb0e67183),
    SPH_C32(0xf5c750ed) },
  { SPH_C32(0xd40ace70), SPH_C32(0xbc950000), SPH_C32(0xb76e0000),
    SPH_C32(0xb0a20000), SPH_C32(0x4ce16cbb), SPH_C32(0xc27d6dce),
    SPH_C32(0xdfcec7fa), SPH_C32(0xf575ffae), SPH_C32(0x7c948430),
    SPH_C32(0x33110000), SPH_C32(0x4f9e0000), SPH_C32(0x092f0000),
    SPH_C32(0x5f8d5633), SPH_C32(0xda2a1386), SPH_C32(0xe0791807),
    SPH_C32(0x6baeff85) },
  { SPH_C32(0xf26acc30), SPH_C32(0x614d0000), SPH_C32(0xc5440000),
    SPH_C32(0xffa40000), SPH_C32(0xdf870b44), SPH_C32(0xeb842900),
    SPH_C32(0xe945a42f), SPH_C32(0xf9530dcc), SPH_C32(0x939f8640),
    SPH_C32(0x09ec0000), SPH_C32(0x12300000), SPH_C32(0x60660000),
    SPH_C32(0xc4826a35), SPH_C32(0x9e2fa67f), SPH_C32(0x866d1256),
    SPH_C32(0xf9e1a28f) },
  { SPH_C32(0x1d61ce40), SPH_C32(0x5bb00000), SPH_C32(0x98ea0000),
    SPH_C32(0x96ed0000), SPH_C32(0x44883742), SPH_C32(0xaf819cf9),
    SPH_C32(0x8f51ae7e), SPH_C32(0x6b1c50c6), SPH_C32(0x5af48670),
    SPH_C32(0xeec90000), SPH_C32(0x3db40000), SPH_C32(0x46290000),
    SPH_C32(0xcceb31cc), SPH_C32(0xf3d35748), SPH_C32(0xd6f27bd2),
    SPH_C32(0x67880de7) },
  { SPH_C32(0x2f5bf000), SPH_C32(0x3f810000), SPH_C32(0x8be70000),
    SPH_C32(0x288a0000), SPH_C32(0x198f6dd1), SPH_C32(0x3631e54f),
    SPH_C32(0xfe73aa8b), SPH_C32(0x86b48661), SPH_C32(0x96989000),
    SPH_C32(0x1c8d0000), SPH_C32(0x94dd0000), SPH_C32(0xd4150000),
    SPH_C32(0x242929af), SPH_C32(0x4f7047f8), SPH_C32(0xb2227bbc),
    SPH_C32(0x29e3b6f2) },
  { SPH_C32(0xc050f270), SPH_C32(0x057c0000), SPH_C32(0xd6490000),
    SPH_C32(0x41c30000), SPH_C32(0x828051d7), SPH_C32(0x723450b6),
    SPH_C32(0x9867a0da), SPH_C32(0x14fbdb6b), SPH_C32(0x5ff39030),
    SPH_C32(0xfba80000), SPH_C32(0xbb590000), SPH_C32(0xf25a0000),
    SPH_C32(0x2c407256), SPH_C32(0x228cb6cf), SPH_C32(0xe2bd1238),
    SPH_C32(0xb78a199a) },
  { SPH_C32(0xe630f030), SPH_C32(0xd8a40000), SPH_C32(0xa4630000),
    SPH_C32(0x0ec50000), SPH_C32(0x11e63628), SPH_C32(0x5bcd1478),
    SPH_C32(0xaeecc30f), SPH_C32(0x18dd2909), SPH_C32(0xb0f89240),
    SPH_C32(0xc1550000), SPH_C32(0xe6f70000), SPH_C32(0x9b130000),
    SPH_C32(0xb74f4e50), SPH_C32(0x66890336), SPH_C32(0x84a91869),
    SPH_C32(0x25c54490) },
  { SPH_C32(0x093bf240), SPH_C32(0xe2590000), SPH_C32(0xf9cd0000),
    SPH_C32(0x678c0000), SPH_C32(0x8ae90a2e), SPH_C32(0x1fc8a181),
    SPH_C32(0xc8f8c95e), SPH_C32(0x8a927403), SPH_C32(0x79939270),
    SPH_C32(0x26700000), SPH_C32(0xc9730000), SPH_C32(0xbd5c0000),
    SPH_C32(0xbf2615a9), SPH_C32(0x0b75f201), SPH_C32(0xd43671ed),
    SPH_C32(0xbbacebf8) },
  { SPH_C32(0x1866d800), SPH_C32(0x4ed10000), SPH_C32(0x1e070000),
    SPH_C32(0x229e0000), SPH_C32(0xa42374d8), SPH_C32(0x7ede7d7e),
    SPH_C32(0xbb1ec794), SPH_C32(0xbb1e44bb), SPH_C32(0x82c2ac00),
    SPH_C32(0xa5640000), SPH_C32(0xf5fa0000), SPH_C32(0x25740000),
    SPH_C32(0xea4814c3), SPH_C32(0xff397a80), SPH_C32(0xf58b1c9c),
    SPH_C32(0xc86d9237) },
  { SPH_C32(0xf76dda70), SPH_C32(0x742c0000), SPH_C32(0x43a90000),
    SPH_C32(0x4bd70000), SPH_C32(0x3f2c48de), SPH_C32(0x3adbc887),
    SPH_C32(0xdd0acdc5), SPH_C32(0x295119b1), SPH_C32(0x4ba9ac30),
    SPH_C32(0x42410000), SPH_C32(0xda7e0000), SPH_C32(0x033b0000),
    SPH_C32(0xe2214f3a), SPH_C32(0x92c58bb7), SPH_C32(0xa5147518),
    SPH_C32(0x56043d5f) },
  { SPH_C32(0xd10dd830), SPH_C32(0xa9f40000), SPH_C32(0x31830000),
    SPH_C32(0x04d10000), SPH_C32(0xac4a2f21), SPH_C32(0x13228c49),
    SPH_C32(0xeb81ae10), SPH_C32(0x2577ebd3), SPH_C32(0xa4a2ae40),
    SPH_C32(0x78bc0000), SPH_C32(0x87d00000), SPH_C32(0x6a720000),
    SPH_C32(0x792e733c), SPH_C32(0xd6c03e4e), SPH_C32(0xc3007f49),
    SPH_C32(0xc44b6055) },
  { SPH_C32(0x3e06da40), SPH_C32(0x93090000), SPH_C32(0x6c2d0000),
    SPH_C32(0x6d980000), SPH_C32(0x37451327), SPH_C32(0x572739b0),
    SPH_C32(0x8d95a441), SPH_C32(0xb738b6d9), SPH_C32(0x6dc9ae70),
    SPH_C32(0x9f990000), SPH_C32(0xa8540000), SPH_C32(0x4c3d0000),
    SPH_C32(0x714728c5), SPH_C32(0xbb3ccf79), SPH_C32(0x939f16cd),
    SPH_C32(0x5a22cf3d) },
  { SPH_C32(0x0c3ce400), SPH_C32(0xf7380000), SPH_C32(0x7f200000),
    SPH_C32(0xd3ff0000), SPH_C32(0x6a4249b4), SPH_C32(0xce974006),
    SPH_C32(0xfcb7a0b4), SPH_C32(0x5a90607e), SPH_C32(0xa1a5b800),
    SPH_C32(0x6ddd0000), SPH_C32(0x013d0000), SPH_C32(0xde010000),
    SPH_C32(0x998530a6), SPH_C32(0x079fdfc9), SPH_C32(0xf74f16a3),
    SPH_C32(0x14497428) },
  { SPH_C32(0xe337e670), SPH_C32(0xcdc50000), SPH_C32(0x228e0000),
    SPH_C32(0xbab60000), SPH_C32(0xf14d75b2), SPH_C32(0x8a92f5ff),
    SPH_C32(0x9aa3aae5), SPH_C32(0xc8df3d74), SPH_C32(0x68ceb830),
    SPH_C32(0x8af80000), SPH_C32(0x2eb90000), SPH_C32(0xf84e0000),
    SPH_C32(0x91ec6b5f), SPH_C32(0x6a632efe), SPH_C32(0xa7d07f27),
    SPH_C32(0x8a20db40) },
  { SPH_C32(0xc557e430), SPH_C32(0x101d0000), SPH_C32(0x50a40000),
    SPH_C32(0xf5b00000), SPH_C32(0x622b124d), SPH_C32(0xa36bb131),
    SPH_C32(0xac28c930), SPH_C32(0xc4f9cf16), SPH_C32(0x87c5ba40),
    SPH_C32(0xb0050000), SPH_C32(0x73170000), SPH_C32(0x91070000),
    SPH_C32(0x0ae35759), SPH_C32(0x2e669b07), SPH_C32(0xc1c47576),
    SPH_C32(0x186f864a) },
  { SPH_C32(0x2a5ce640), SPH_C32(0x2ae00000), SPH_C32(0x0d0a0000),
    SPH_C32(0x9cf90000), SPH_C32(0xf9242e4b), SPH_C32(0xe76e04c8),
    SPH_C32(0xca3cc361), SPH_C32(0x56b6921c), SPH_C32(0x4eaeba70),
    SPH_C32(0x57200000), SPH_C32(0x5c930000), SPH_C32(0xb7480000),
    SPH_C32(0x028a0ca0), SPH_C32(0x439a6a30), SPH_C32(0x915b1cf2),
    SPH_C32(0x86062922) },
  { SPH_C32(0xf3928800), SPH_C32(0xdc560000), SPH_C32(0xbd470000),
    SPH_C32(0x95bd0000), SPH_C32(0x3d767488), SPH_C32(0xf3c9c922),
    SPH_C32(0x916cbfec), SPH_C32(0x4aeb5b0f), SPH_C32(0xe1d7d800),
    SPH_C32(0x3ed90000), SPH_C32(0xa5cc0000), SPH_C32(0x8ea50000),
    SPH_C32(0xe4466aba), SPH_C32(0x23732650), SPH_C32(0xdb56301e),
    SPH_C32(0xa0dc676f) },
  { SPH_C32(0x1c998a70), SPH_C32(0xe6ab0000), SPH_C32(0xe0e90000),
    SPH_C32(0xfcf40000), SPH_C32(0xa679488e), SPH_C32(0xb7cc7cdb),
    SPH_C32(0xf778b5bd), SPH_C32(0xd8a40605), SPH_C32(0x28bcd830),
    SPH_C32(0xd9fc0000), SPH_C32(0x8a480000), SPH_C32(0xa8ea0000),
    SPH_C32(0xec2f3143), SPH_C32(0x4e8fd767), SPH_C32(0x8bc9599a),
    SPH_C32(0x3eb5c807) },
  { SPH_C32(0x3af98830), SPH_C32(0x3b730000), SPH_C32(0x92c30000),
    SPH_C32(0xb3f20000), SPH_C32(0x351f2f71), SPH_C32(0x9e353815),
    SPH_C32(0xc1f3d668), SPH_C32(0xd482f467), SPH_C32(0xc7b7da40),
    SPH_C32(0xe3010000), SPH_C32(0xd7e60000), SPH_C32(0xc1a30000),
    SPH_C32(0x77200d45), SPH_C32(0x0a8a629e), SPH_C32(0xeddd53cb),
    SPH_C32(0xacfa950d) },
  { SPH_C32(0xd5f28a40), SPH_C32(0x018e0000), SPH_C32(0xcf6d0000),
    SPH_C32(0xdabb0000), SPH_C32(0xae101377), SPH_C32(0xda308dec),
    SPH_C32(0xa7e7dc39), SPH_C32(0x46cda96d), SPH_C32(0x0edcda70),
    SPH_C32(0x04240000), SPH_C32(0xf8620000), SPH_C32(0xe7ec0000),
    SPH_C32(0x7f4956bc), SPH_C32(0x677693a9), SPH_C32(0xbd423a4f),
    SPH_C32(0x32933a65) },
  { SPH_C32(0xe7c8b400), SPH_C32(0x65bf0000), SPH_C32(0xdc600000),
    SPH_C32(0x64dc0000), SPH_C32(0xf31749e4), SPH_C32(0x4380f45a),
    SPH_C32(0xd6c5d8cc), SPH_C32(0xab657fca), SPH_C32(0xc2b0cc00),
    SPH_C32(0xf6600000), SPH_C32(0x510b0000), SPH_C32(0x75d00000),
    SPH_C32(0x978b4edf), SPH_C32(0xdbd58319), SPH_C32(0xd9923a21),
    SPH_C32(0x7cf88170) },
  { SPH_C32(0x08c3b670), SPH_C32(0x5f420000), SPH_C32(0x81ce0000),
    SPH_C32(0x0d950000), SPH_C32(0x681875e2), SPH_C32(0x078541a3),
    SPH_C32(0xb0d1d29d), SPH_C32(0x392a22c0), SPH_C32(0x0bdbcc30),
    SPH_C32(0x11450000), SPH_C32(0x7e8f0000), SPH_C32(0x539f0000),
    SPH_C32(0x9fe21526), SPH_C32(0xb629722e), SPH_C32(0x890d53a5),
    SPH_C32(0xe2912e18) },
  { SPH_C32(0x2ea3b430), SPH_C32(0x829a0000), SPH_C32(0xf3e40000),
    SPH_C32(0x42930000), SPH_C32(0xfb7e121d), SPH_C32(0x2e7c056d),
    SPH_C32(0x865ab148), SPH_C32(0x350cd0a2), SPH_C32(0xe4d0ce40),
    SPH_C32(0x2bb80000), SPH_C32(0x23210000), SPH_C32(0x3ad60000),
    SPH_C32(0x04ed2920), SPH_C32(0xf22cc7d7), SPH_C32(0xef1959f4),
    SPH_C32(0x70de7312) },
  { SPH_C32(0xc1a8b640), SPH_C32(0xb8670000), SPH_C32(0xae4a0000),
    SPH_C32(0x2bda0000), SPH_C32(0x60712e1b), SPH_C32(0x6a79b094),
    SPH_C32(0xe04ebb19), SPH_C32(0xa7438da8), SPH_C32(0x2dbbce70),
    SPH_C32(0xcc9d0000), SPH_C32(0x0ca50000), SPH_C32(0x1c990000),
    SPH_C32(0x0c8472d9), SPH_C32(0x9fd036e0), SPH_C32(0xbf863070),
    SPH_C32(0xeeb7dc7a) },
  { SPH_C32(0xd0f59c00), SPH_C32(0x14ef0000), SPH_C32(0x49800000),
    SPH_C32(0x6ec80000), SPH_C32(0x4ebb50ed), SPH_C32(0x0b6f6c6b),
    SPH_C32(0x93a8b5d3), SPH_C32(0x96cfbd10), SPH_C32(0xd6eaf000),
    SPH_C32(0x4f890000), SPH_C32(0x302c0000), SPH_C32(0x84b10000),
    SPH_C32(0x59ea73b3), SPH_C32(0x6b9cbe61), SPH_C32(0x9e3b5d01),
    SPH_C32(0x9d76a5b5) },
  { SPH_C32(0x3ffe9e70), SPH_C32(0x2e120000), SPH_C32(0x142e0000),
    SPH_C32(0x07810000), SPH_C32(0xd5b46ceb), SPH_C32(0x4f6ad992),
    SPH_C32(0xf5bcbf82), SPH_C32(0x0480e01a), SPH_C32(0x1f81f030),
    SPH_C32(0xa8ac0000), SPH_C32(0x1fa80000), SPH_C32(0xa2fe0000),
    SPH_C32(0x5183284a), SPH_C32(0x06604f56), SPH_C32(0xcea43485),
    SPH_C32(0x031f0add) },
  { SPH_C32(0x199e9c30), SPH_C32(0xf3ca0000), SPH_C32(0x66040000),
    SPH_C32(0x48870000), SPH_C32(0x46d20b14), SPH_C32(0x66939d5c),
    SPH_C32(0xc337dc57), SPH_C32(0x08a61278), SPH_C32(0xf08af240),
    SPH_C32(0x92510000), SPH_C32(0x42060000), SPH_C32(0xcbb70000),
    SPH_C32(0xca8c144c), SPH_C32(0x4265faaf), SPH_C32(0xa8b03ed4),
    SPH_C32(0x915057d7) },
  { SPH_C32(0xf6959e40), SPH_C32(0xc9370000), SPH_C32(0x3baa0000),
    SPH_C32(0x21ce0000), SPH_C32(0xdddd3712), SPH_C32(0x229628a5),
    SPH_C32(0xa523d606), SPH_C32(0x9ae94f72), SPH_C32(0x39e1f270),
    SPH_C32(0x75740000), SPH_C32(0x6d820000), SPH_C32(0xedf80000),
    SPH_C32(0xc2e54fb5), SPH_C32(0x2f990b98), SPH_C32(0xf82f5750),
    SPH_C32(0x0f39f8bf) },
  { SPH_C32(0xc4afa000), SPH_C32(0xad060000), SPH_C32(0x28a70000),
    SPH_C32(0x9fa90000), SPH_C32(0x80da6d81), SPH_C32(0xbb265113),
    SPH_C32(0xd401d2f3), SPH_C32(0x774199d5), SPH_C32(0xf58de400),
    SPH_C32(0x87300000), SPH_C32(0xc4eb0000), SPH_C32(0x7fc40000),
    SPH_C32(0x2a2757d6), SPH_C32(0x933a1b28), SPH_C32(0x9cff573e),
    SPH_C32(0x415243aa) },
  { SPH_C32(0x2ba4a270), SPH_C32(0x97fb0000), SPH_C32(0x75090000),
    SPH_C32(0xf6e00000), SPH_C32(0x1bd55187), SPH_C32(0xff23e4ea),
    SPH_C32(0xb215d8a2), SPH_C32(0xe50ec4df), SPH_C32(0x3ce6e430),
    SPH_C32(0x60150000), SPH_C32(0xeb6f0000), SPH_C32(0x598b0000),
    SPH_C32(0x224e0c2f), SPH_C32(0xfec6ea1f), SPH_C32(0xcc603eba),
    SPH_C32(0xdf3becc2) },
  { SPH_C32(0x0dc4a030), SPH_C32(0x4a230000), SPH_C32(0x07230000),
    SPH_C32(0xb9e60000), SPH_C32(0x88b33678), SPH_C32(0xd6daa024),
    SPH_C32(0x849ebb77), SPH_C32(0xe92836bd), SPH_C32(0xd3ede640),
    SPH_C32(0x5ae80000), SPH_C32(0xb6c10000), SPH_C32(0x30c20000),
    SPH_C32(0xb9413029), SPH_C32(0xbac35fe6), SPH_C32(0xaa7434eb),
    SPH_C32(0x4d74b1c8) },
  { SPH_C32(0xe2cfa240), SPH_C32(0x70de0000), SPH_C32(0x5a8d0000),
    SPH_C32(0xd0af0000), SPH_C32(0x13bc0a7e), SPH_C32(0x92df15dd),
    SPH_C32(0xe28ab126), SPH_C32(0x7b676bb7), SPH_C32(0x1a86e670),
    SPH_C32(0xbdcd0000), SPH_C32(0x99450000), SPH_C32(0x168d0000),
    SPH_C32(0xb1286bd0), SPH_C32(0xd73faed1), SPH_C32(0xfaeb5d6f),
    SPH_C32(0xd31d1ea0) },
  { SPH_C32(0xa7bad400), SPH_C32(0x36bb0000), SPH_C32(0x78910000),
    SPH_C32(0x34780000), SPH_C32(0x8ed413f8), SPH_C32(0x676c0dc3),
    SPH_C32(0xfadcfe71), SPH_C32(0x1ff06c8d), SPH_C32(0x7d6cc000),
    SPH_C32(0x8e0a0000), SPH_C32(0x379d0000), SPH_C32(0x63360000),
    SPH_C32(0xbd7c29ff), SPH_C32(0xc267f3a4), SPH_C32(0x985003c4),
    SPH_C32(0xd816a946) },
  { SPH_C32(0x48b1d670), SPH_C32(0x0c460000), SPH_C32(0x253f0000),
    SPH_C32(0x5d310000), SPH_C32(0x15db2ffe), SPH_C32(0x2369b83a),
    SPH_C32(0x9cc8f420), SPH_C32(0x8dbf3187), SPH_C32(0xb407c030),
    SPH_C32(0x692f0000), SPH_C32(0x18190000), SPH_C32(0x45790000),
    SPH_C32(0xb5157206), SPH_C32(0xaf9b0293), SPH_C32(0xc8cf6a40),
    SPH_C32(0x467f062e) },
  { SPH_C32(0x6ed1d430), SPH_C32(0xd19e0000), SPH_C32(0x57150000),
    SPH_C32(0x12370000), SPH_C32(0x86bd4801), SPH_C32(0x0a90fcf4),
    SPH_C32(0xaa4397f5), SPH_C32(0x8199c3e5), SPH_C32(0x5b0cc240),
    SPH_C32(0x53d20000), SPH_C32(0x45b70000), SPH_C32(0x2c300000),
    SPH_C32(0x2e1a4e00), SPH_C32(0xeb9eb76a), SPH_C32(0xaedb6011),
    SPH_C32(0xd4305b24) },
  { SPH_C32(0x81dad640), SPH_C32(0xeb630000), SPH_C32(0x0abb0000),
    SPH_C32(0x7b7e0000), SPH_C32(0x1db27407), SPH_C32(0x4e95490d),
    SPH_C32(0xcc579da4), SPH_C32(0x13d69eef), SPH_C32(0x9267c270),
    SPH_C32(0xb4f70000), SPH_C32(0x6a330000), SPH_C32(0x0a7f0000),
    SPH_C32(0x267315f9), SPH_C32(0x8662465d), SPH_C32(0xfe440995),
    SPH_C32(0x4a59f44c) },
  { SPH_C32(0xb3e0e800), SPH_C32(0x8f520000), SPH_C32(0x19b60000),
    SPH_C32(0xc5190000), SPH_C32(0x40b52e94), SPH_C32(0xd72530bb),
    SPH_C32(0xbd759951), SPH_C32(0xfe7e4848), SPH_C32(0x5e0bd400),
    SPH_C32(0x46b30000), SPH_C32(0xc35a0000), SPH_C32(0x98430000),
    SPH_C32(0xceb10d9a), SPH_C32(0x3ac156ed), SPH_C32(0x9a9409fb),
    SPH_C32(0x04324f59) },
  { SPH_C32(0x5cebea70), SPH_C32(0xb5af0000), SPH_C32(0x44180000),
    SPH_C32(0xac500000), SPH_C32(0xdbba1292), SPH_C32(0x93208542),
    SPH_C32(0xdb619300), SPH_C32(0x6c311542), SPH_C32(0x9760d430),
    SPH_C32(0xa1960000), SPH_C32(0xecde0000), SPH_C32(0xbe0c0000),
    SPH_C32(0xc6d85663), SPH_C32(0x573da7da), SPH_C32(0xca0b607f),
    SPH_C32(0x9a5be031) },
  { SPH_C32(0x7a8be830), SPH_C32(0x68770000), SPH_C32(0x36320000),
    SPH_C32(0xe3560000), SPH_C32(0x48dc756d), SPH_C32(0xbad9c18c),
    SPH_C32(0xedeaf0d5), SPH_C32(0x6017e720), SPH_C32(0x786bd640),
    SPH_C32(0x9b6b0000), SPH_C32(0xb1700000), SPH_C32(0xd7450000),
    SPH_C32(0x5dd76a65), SPH_C32(0x13381223), SPH_C32(0xac1f6a2e),
    SPH_C32(0x0814bd3b) },
  { SPH_C32(0x9580ea40), SPH_C32(0x528a0000), SPH_C32(0x6b9c0000),
    SPH_C32(0x8a1f0000), SPH_C32(0xd3d3496b), SPH_C32(0xfedc7475),
    SPH_C32(0x8bfefa84), SPH_C32(0xf258ba2a), SPH_C32(0xb100d670),
    SPH_C32(0x7c4e0000), SPH_C32(0x9ef40000), SPH_C32(0xf10a0000),
    SPH_C32(0x55be319c), SPH_C32(0x7ec4e314), SPH_C32(0xfc8003aa),
    SPH_C32(0x967d1253) },
  { SPH_C32(0x84ddc000), SPH_C32(0xfe020000), SPH_C32(0x8c560000),
    SPH_C32(0xcf0d0000), SPH_C32(0xfd19379d), SPH_C32(0x9fcaa88a),
    SPH_C32(0xf818f44e), SPH_C32(0xc3d48a92), SPH_C32(0x4a51e800),
    SPH_C32(0xff5a0000), SPH_C32(0xa27d0000), SPH_C32(0x69220000),
    SPH_C32(0x00d030f6), SPH_C32(0x8a886b95), SPH_C32(0xdd3d6edb),
    SPH_C32(0xe5bc6b9c) },
  { SPH_C32(0x6bd6c270), SPH_C32(0xc4ff0000), SPH_C32(0xd1f80000),
    SPH_C32(0xa6440000), SPH_C32(0x66160b9b), SPH_C32(0xdbcf1d73),
    SPH_C32(0x9e0cfe1f), SPH_C32(0x519bd798), SPH_C32(0x833ae830),
    SPH_C32(0x187f0000), SPH_C32(0x8df90000), SPH_C32(0x4f6d0000),
    SPH_C32(0x08b96b0f), SPH_C32(0xe7749aa2), SPH_C32(0x8da2075f),
    SPH_C32(0x7bd5c4f4) },
  { SPH_C32(0x4db6c030), SPH_C32(0x19270000), SPH_C32(0xa3d20000),
    SPH_C32(0xe9420000), SPH_C32(0xf5706c64), SPH_C32(0xf23659bd),
    SPH_C32(0xa8879dca), SPH_C32(0x5dbd25fa), SPH_C32(0x6c31ea40),
    SPH_C32(0x22820000), SPH_C32(0xd0570000), SPH_C32(0x26240000),
    SPH_C32(0x93b65709), SPH_C32(0xa3712f5b), SPH_C32(0xebb60d0e),
    SPH_C32(0xe99a99fe) },
  { SPH_C32(0xa2bdc240), SPH_C32(0x23da0000), SPH_C32(0xfe7c0000),
    SPH_C32(0x800b0000), SPH_C32(0x6e7f5062), SPH_C32(0xb633ec44),
    SPH_C32(0xce93979b), SPH_C32(0xcff278f0), SPH_C32(0xa55aea70),
    SPH_C32(0xc5a70000), SPH_C32(0xffd30000), SPH_C32(0x006b0000),
    SPH_C32(0x9bdf0cf0), SPH_C32(0xce8dde6c), SPH_C32(0xbb29648a),
    SPH_C32(0x77f33696) },
  { SPH_C32(0x9087fc00), SPH_C32(0x47eb0000), SPH_C32(0xed710000),
    SPH_C32(0x3e6c0000), SPH_C32(0x33780af1), SPH_C32(0x2f8395f2),
    SPH_C32(0xbfb1936e), SPH_C32(0x225aae57), SPH_C32(0x6936fc00),
    SPH_C32(0x37e30000), SPH_C32(0x56ba0000), SPH_C32(0x92570000),
    SPH_C32(0x731d1493), SPH_C32(0x722ecedc), SPH_C32(0xdff964e4),
    SPH_C32(0x39988d83) },
  { SPH_C32(0x7f8cfe70), SPH_C32(0x7d160000), SPH_C32(0xb0df0000),
    SPH_C32(0x57250000), SPH_C32(0xa87736f7), SPH_C32(0x6b86200b),
    SPH_C32(0xd9a5993f), SPH_C32(0xb015f35d), SPH_C32(0xa05dfc30),
    SPH_C32(0xd0c60000), SPH_C32(0x793e0000), SPH_C32(0xb4180000),
    SPH_C32(0x7b744f6a), SPH_C32(0x1fd23feb), SPH_C32(0x8f660d60),
    SPH_C32(0xa7f122eb) },
  { SPH_C32(0x59ecfc30), SPH_C32(0xa0ce0000), SPH_C32(0xc2f50000),
    SPH_C32(0x18230000), SPH_C32(0x3b115108), SPH_C32(0x427f64c5),
    SPH_C32(0xef2efaea), SPH_C32(0xbc33013f), SPH_C32(0x4f56fe40),
    SPH_C32(0xea3b0000), SPH_C32(0x24900000), SPH_C32(0xdd510000),
    SPH_C32(0xe07b736c), SPH_C32(0x5bd78a12), SPH_C32(0xe9720731),
    SPH_C32(0x35be7fe1) },
  { SPH_C32(0xb6e7fe40), SPH_C32(0x9a330000), SPH_C32(0x9f5b0000),
    SPH_C32(0x716a0000), SPH_C32(0xa01e6d0e), SPH_C32(0x067ad13c),
    SPH_C32(0x893af0bb), SPH_C32(0x2e7c5c35), SPH_C32(0x863dfe70),
    SPH_C32(0x0d1e0000), SPH_C32(0x0b140000), SPH_C32(0xfb1e0000),
    SPH_C32(0xe8122895), SPH_C32(0x362b7b25), SPH_C32(0xb9ed6eb5),
    SPH_C32(0xabd7d089) }
};

__constant static const sph_u32 T512_8[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xf6800005), SPH_C32(0x3443c000), SPH_C32(0x24070000),
    SPH_C32(0x8f3d0000), SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae),
    SPH_C32(0xcdc58b19), SPH_C32(0xd795ba31), SPH_C32(0xa67f0001),
    SPH_C32(0x71378000), SPH_C32(0x19fc0000), SPH_C32(0x96db0000),
    SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3), SPH_C32(0x2c6d478f),
    SPH_C32(0xac8e6c88) },
  { SPH_C32(0xa67f0001), SPH_C32(0x71378000), SPH_C32(0x19fc0000),
    SPH_C32(0x96db0000), SPH_C32(0x3a8b6dfd), SPH_C32(0xebcaaef3),
    SPH_C32(0x2c6d478f), SPH_C32(0xac8e6c88), SPH_C32(0x50ff0004),
    SPH_C32(0x45744000), SPH_C32(0x3dfb0000), SPH_C32(0x19e60000),
    SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d), SPH_C32(0xe1a8cc96),
    SPH_C32(0x7b1bd6b9) },
  { SPH_C32(0x50ff0004), SPH_C32(0x45744000), SPH_C32(0x3dfb0000),
    SPH_C32(0x19e60000), SPH_C32(0x1bbc5606), SPH_C32(0xe1727b5d),
    SPH_C32(0xe1a8cc96), SPH_C32(0x7b1bd6b9), SPH_C32(0xf6800005),
    SPH_C32(0x3443c000), SPH_C32(0x24070000), SPH_C32(0x8f3d0000),
    SPH_C32(0x21373bfb), SPH_C32(0x0ab8d5ae), SPH_C32(0xcdc58b19),
    SPH_C32(0xd795ba31) },
  { SPH_C32(0xf7750009), SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000),
    SPH_C32(0x04920000), SPH_C32(0x029519a9), SPH_C32(0xf8e836ba),
    SPH_C32(0x7a87f14e), SPH_C32(0x9e16981a), SPH_C32(0xd46a0000),
    SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000), SPH_C32(0x4a290000),
    SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c), SPH_C32(0x98369604),
    SPH_C32(0xf746c320) },
  { SPH_C32(0x01f5000c), SPH_C32(0xfb7f0000), SPH_C32(0xe7d10000),
    SPH_C32(0x8baf0000), SPH_C32(0x23a22252), SPH_C32(0xf250e314),
    SPH_C32(0xb7427a57), SPH_C32(0x4983222b), SPH_C32(0x72150001),
    SPH_C32(0xfcff4000), SPH_C32(0xbc530000), SPH_C32(0xdcf20000),
    SPH_C32(0xc6c52f87), SPH_C32(0x227e289f), SPH_C32(0xb45bd18b),
    SPH_C32(0x5bc8afa8) },
  { SPH_C32(0x510a0008), SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000),
    SPH_C32(0x92490000), SPH_C32(0x381e7454), SPH_C32(0x13229849),
    SPH_C32(0x56eab6c1), SPH_C32(0x3298f492), SPH_C32(0x84950004),
    SPH_C32(0xc8bc8000), SPH_C32(0x98540000), SPH_C32(0x53cf0000),
    SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31), SPH_C32(0x799e5a92),
    SPH_C32(0x8c5d1599) },
  { SPH_C32(0xa78a000d), SPH_C32(0x8a488000), SPH_C32(0xfe2d0000),
    SPH_C32(0x1d740000), SPH_C32(0x19294faf), SPH_C32(0x199a4de7),
    SPH_C32(0x9b2f3dd8), SPH_C32(0xe50d4ea3), SPH_C32(0x22ea0005),
    SPH_C32(0xb98b0000), SPH_C32(0x81a80000), SPH_C32(0xc5140000),
    SPH_C32(0xdd797981), SPH_C32(0xc30c53c2), SPH_C32(0x55f31d1d),
    SPH_C32(0x20d37911) },
  { SPH_C32(0xd46a0000), SPH_C32(0x8dc8c000), SPH_C32(0xa5af0000),
    SPH_C32(0x4a290000), SPH_C32(0xfc4e427a), SPH_C32(0xc9b4866c),
    SPH_C32(0x98369604), SPH_C32(0xf746c320), SPH_C32(0x231f0009),
    SPH_C32(0x42f40000), SPH_C32(0x66790000), SPH_C32(0x4ebb0000),
    SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6), SPH_C32(0xe2b1674a),
    SPH_C32(0x69505b3a) },
  { SPH_C32(0x22ea0005), SPH_C32(0xb98b0000), SPH_C32(0x81a80000),
    SPH_C32(0xc5140000), SPH_C32(0xdd797981), SPH_C32(0xc30c53c2),
    SPH_C32(0x55f31d1d), SPH_C32(0x20d37911), SPH_C32(0x85600008),
    SPH_C32(0x33c38000), SPH_C32(0x7f850000), SPH_C32(0xd8600000),
    SPH_C32(0xc450362e), SPH_C32(0xda961e25), SPH_C32(0xcedc20c5),
    SPH_C32(0xc5de37b2) },
  { SPH_C32(0x72150001), SPH_C32(0xfcff4000), SPH_C32(0xbc530000),
    SPH_C32(0xdcf20000), SPH_C32(0xc6c52f87), SPH_C32(0x227e289f),
    SPH_C32(0xb45bd18b), SPH_C32(0x5bc8afa8), SPH_C32(0x73e0000d),
    SPH_C32(0x07804000), SPH_C32(0x5b820000), SPH_C32(0x575d0000),
    SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b), SPH_C32(0x0319abdc),
    SPH_C32(0x124b8d83) },
  { SPH_C32(0x84950004), SPH_C32(0xc8bc8000), SPH_C32(0x98540000),
    SPH_C32(0x53cf0000), SPH_C32(0xe7f2147c), SPH_C32(0x28c6fd31),
    SPH_C32(0x799e5a92), SPH_C32(0x8c5d1599), SPH_C32(0xd59f000c),
    SPH_C32(0x76b7c000), SPH_C32(0x427e0000), SPH_C32(0xc1860000),
    SPH_C32(0xdfec6028), SPH_C32(0x3be46578), SPH_C32(0x2f74ec53),
    SPH_C32(0xbec5e10b) },
  { SPH_C32(0x231f0009), SPH_C32(0x42f40000), SPH_C32(0x66790000),
    SPH_C32(0x4ebb0000), SPH_C32(0xfedb5bd3), SPH_C32(0x315cb0d6),
    SPH_C32(0xe2b1674a), SPH_C32(0x69505b3a), SPH_C32(0xf7750009),
    SPH_C32(0xcf3cc000), SPH_C32(0xc3d60000), SPH_C32(0x04920000),
    SPH_C32(0x029519a9), SPH_C32(0xf8e836ba), SPH_C32(0x7a87f14e),
    SPH_C32(0x9e16981a) },
  { SPH_C32(0xd59f000c), SPH_C32(0x76b7c000), SPH_C32(0x427e0000),
    SPH_C32(0xc1860000), SPH_C32(0xdfec6028), SPH_C32(0x3be46578),
    SPH_C32(0x2f74ec53), SPH_C32(0xbec5e10b), SPH_C32(0x510a0008),
    SPH_C32(0xbe0b4000), SPH_C32(0xda2a0000), SPH_C32(0x92490000),
    SPH_C32(0x381e7454), SPH_C32(0x13229849), SPH_C32(0x56eab6c1),
    SPH_C32(0x3298f492) },
  { SPH_C32(0x85600008), SPH_C32(0x33c38000), SPH_C32(0x7f850000),
    SPH_C32(0xd8600000), SPH_C32(0xc450362e), SPH_C32(0xda961e25),
    SPH_C32(0xcedc20c5), SPH_C32(0xc5de37b2), SPH_C32(0xa78a000d),
    SPH_C32(0x8a488000), SPH_C32(0xfe2d0000), SPH_C32(0x1d740000),
    SPH_C32(0x19294faf), SPH_C32(0x199a4de7), SPH_C32(0x9b2f3dd8),
    SPH_C32(0xe50d4ea3) },
  { SPH_C32(0x73e0000d), SPH_C32(0x07804000), SPH_C32(0x5b820000),
    SPH_C32(0x575d0000), SPH_C32(0xe5670dd5), SPH_C32(0xd02ecb8b),
    SPH_C32(0x0319abdc), SPH_C32(0x124b8d83), SPH_C32(0x01f5000c),
    SPH_C32(0xfb7f0000), SPH_C32(0xe7d10000), SPH_C32(0x8baf0000),
    SPH_C32(0x23a22252), SPH_C32(0xf250e314), SPH_C32(0xb7427a57),
    SPH_C32(0x4983222b) },
  { SPH_C32(0x774400f0), SPH_C32(0xf15a0000), SPH_C32(0xf5b20000),
    SPH_C32(0x34140000), SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25),
    SPH_C32(0x0bc3cd1e), SPH_C32(0xcf3775cb), SPH_C32(0xf46c0050),
    SPH_C32(0x96180000), SPH_C32(0x14a50000), SPH_C32(0x031f0000),
    SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19), SPH_C32(0x9ca470d2),
    SPH_C32(0x8a341574) },
  { SPH_C32(0x81c400f5), SPH_C32(0xc519c000), SPH_C32(0xd1b50000),
    SPH_C32(0xbb290000), SPH_C32(0xa8004577), SPH_C32(0x5033398b),
    SPH_C32(0xc6064607), SPH_C32(0x18a2cffa), SPH_C32(0x52130051),
    SPH_C32(0xe72f8000), SPH_C32(0x0d590000), SPH_C32(0x95c40000),
    SPH_C32(0x781f1345), SPH_C32(0x8d75d0ea), SPH_C32(0xb0c9375d),
    SPH_C32(0x26ba79fc) },
  { SPH_C32(0xd13b00f1), SPH_C32(0x806d8000), SPH_C32(0xec4e0000),
    SPH_C32(0xa2cf0000), SPH_C32(0xb3bc1371), SPH_C32(0xb14142d6),
    SPH_C32(0x27ae8a91), SPH_C32(0x63b91943), SPH_C32(0xa4930054),
    SPH_C32(0xd36c4000), SPH_C32(0x295e0000), SPH_C32(0x1af90000),
    SPH_C32(0x592828be), SPH_C32(0x87cd0544), SPH_C32(0x7d0cbc44),
    SPH_C32(0xf12fc3cd) },
  { SPH_C32(0x27bb00f4), SPH_C32(0xb42e4000), SPH_C32(0xc8490000),
    SPH_C32(0x2df20000), SPH_C32(0x928b288a), SPH_C32(0xbbf99778),
    SPH_C32(0xea6b0188), SPH_C32(0xb42ca372), SPH_C32(0x02ec0055),
    SPH_C32(0xa25bc000), SPH_C32(0x30a20000), SPH_C32(0x8c220000),
    SPH_C32(0x63a34543), SPH_C32(0x6c07abb7), SPH_C32(0x5161fbcb),
    SPH_C32(0x5da1af45) },
  { SPH_C32(0x803100f9), SPH_C32(0x3e66c000), SPH_C32(0x36640000),
    SPH_C32(0x30860000), SPH_C32(0x8ba26725), SPH_C32(0xa263da9f),
    SPH_C32(0x71443c50), SPH_C32(0x5121edd1), SPH_C32(0x20060050),
    SPH_C32(0x1bd0c000), SPH_C32(0xb10a0000), SPH_C32(0x49360000),
    SPH_C32(0xbeda3cc2), SPH_C32(0xaf0bf875), SPH_C32(0x0492e6d6),
    SPH_C32(0x7d72d654) },
  { SPH_C32(0x76b100fc), SPH_C32(0x0a250000), SPH_C32(0x12630000),
    SPH_C32(0xbfbb0000), SPH_C32(0xaa955cde), SPH_C32(0xa8db0f31),
    SPH_C32(0xbc81b749), SPH_C32(0x86b457e0), SPH_C32(0x86790051),
    SPH_C32(0x6ae74000), SPH_C32(0xa8f60000), SPH_C32(0xdfed0000),
    SPH_C32(0x8451513f), SPH_C32(0x44c15686), SPH_C32(0x28ffa159),
    SPH_C32(0xd1fcbadc) },
  { SPH_C32(0x264e00f8), SPH_C32(0x4f514000), SPH_C32(0x2f980000),
    SPH_C32(0xa65d0000), SPH_C32(0xb1290ad8), SPH_C32(0x49a9746c),
    SPH_C32(0x5d297bdf), SPH_C32(0xfdaf8159), SPH_C32(0x70f90054),
    SPH_C32(0x5ea48000), SPH_C32(0x8cf10000), SPH_C32(0x50d00000),
    SPH_C32(0xa5666ac4), SPH_C32(0x4e798328), SPH_C32(0xe53a2a40),
    SPH_C32(0x066900ed) },
  { SPH_C32(0xd0ce00fd), SPH_C32(0x7b128000), SPH_C32(0x0b9f0000),
    SPH_C32(0x29600000), SPH_C32(0x901e3123), SPH_C32(0x4311a1c2),
    SPH_C32(0x90ecf0c6), SPH_C32(0x2a3a3b68), SPH_C32(0xd6860055),
    SPH_C32(0x2f930000), SPH_C32(0x950d0000), SPH_C32(0xc60b0000),
    SPH_C32(0x9fed0739), SPH_C32(0xa5b32ddb), SPH_C32(0xc9576dcf),
    SPH_C32(0xaae76c65) },
  { SPH_C32(0xa32e00f0), SPH_C32(0x7c92c000), SPH_C32(0x501d0000),
    SPH_C32(0x7e3d0000), SPH_C32(0x75793cf6), SPH_C32(0x933f6a49),
    SPH_C32(0x93f55b1a), SPH_C32(0x3871b6eb), SPH_C32(0xd7730059),
    SPH_C32(0xd4ec0000), SPH_C32(0x72dc0000), SPH_C32(0x4da40000),
    SPH_C32(0xbc4f256b), SPH_C32(0x57e3cecf), SPH_C32(0x7e151798),
    SPH_C32(0xe3644e4e) },
  { SPH_C32(0x55ae00f5), SPH_C32(0x48d10000), SPH_C32(0x741a0000),
    SPH_C32(0xf1000000), SPH_C32(0x544e070d), SPH_C32(0x9987bfe7),
    SPH_C32(0x5e30d003), SPH_C32(0xefe40cda), SPH_C32(0x710c0058),
    SPH_C32(0xa5db8000), SPH_C32(0x6b200000), SPH_C32(0xdb7f0000),
    SPH_C32(0x86c44896), SPH_C32(0xbc29603c), SPH_C32(0x52785017),
    SPH_C32(0x4fea22c6) },
  { SPH_C32(0x055100f1), SPH_C32(0x0da54000), SPH_C32(0x49e10000),
    SPH_C32(0xe8e60000), SPH_C32(0x4ff2510b), SPH_C32(0x78f5c4ba),
    SPH_C32(0xbf981c95), SPH_C32(0x94ffda63), SPH_C32(0x878c005d),
    SPH_C32(0x91984000), SPH_C32(0x4f270000), SPH_C32(0x54420000),
    SPH_C32(0xa7f3736d), SPH_C32(0xb691b592), SPH_C32(0x9fbddb0e),
    SPH_C32(0x987f98f7) },
  { SPH_C32(0xf3d100f4), SPH_C32(0x39e68000), SPH_C32(0x6de60000),
    SPH_C32(0x67db0000), SPH_C32(0x6ec56af0), SPH_C32(0x724d1114),
    SPH_C32(0x725d978c), SPH_C32(0x436a6052), SPH_C32(0x21f3005c),
    SPH_C32(0xe0afc000), SPH_C32(0x56db0000), SPH_C32(0xc2990000),
    SPH_C32(0x9d781e90), SPH_C32(0x5d5b1b61), SPH_C32(0xb3d09c81),
    SPH_C32(0x34f1f47f) },
  { SPH_C32(0x545b00f9), SPH_C32(0xb3ae0000), SPH_C32(0x93cb0000),
    SPH_C32(0x7aaf0000), SPH_C32(0x77ec255f), SPH_C32(0x6bd75cf3),
    SPH_C32(0xe972aa54), SPH_C32(0xa6672ef1), SPH_C32(0x03190059),
    SPH_C32(0x5924c000), SPH_C32(0xd7730000), SPH_C32(0x078d0000),
    SPH_C32(0x40016711), SPH_C32(0x9e5748a3), SPH_C32(0xe623819c),
    SPH_C32(0x14228d6e) },
  { SPH_C32(0xa2db00fc), SPH_C32(0x87edc000), SPH_C32(0xb7cc0000),
    SPH_C32(0xf5920000), SPH_C32(0x56db1ea4), SPH_C32(0x616f895d),
    SPH_C32(0x24b7214d), SPH_C32(0x71f294c0), SPH_C32(0xa5660058),
    SPH_C32(0x28134000), SPH_C32(0xce8f0000), SPH_C32(0x91560000),
    SPH_C32(0x7a8a0aec), SPH_C32(0x759de650), SPH_C32(0xca4ec613),
    SPH_C32(0xb8ace1e6) },
  { SPH_C32(0xf22400f8), SPH_C32(0xc2998000), SPH_C32(0x8a370000),
    SPH_C32(0xec740000), SPH_C32(0x4d6748a2), SPH_C32(0x801df200),
    SPH_C32(0xc51feddb), SPH_C32(0x0ae94279), SPH_C32(0x53e6005d),
    SPH_C32(0x1c508000), SPH_C32(0xea880000), SPH_C32(0x1e6b0000),
    SPH_C32(0x5bbd3117), SPH_C32(0x7f2533fe), SPH_C32(0x078b4d0a),
    SPH_C32(0x6f395bd7) },
  { SPH_C32(0x04a400fd), SPH_C32(0xf6da4000), SPH_C32(0xae300000),
    SPH_C32(0x63490000), SPH_C32(0x6c507359), SPH_C32(0x8aa527ae),
    SPH_C32(0x08da66c2), SPH_C32(0xdd7cf848), SPH_C32(0xf599005c),
    SPH_C32(0x6d670000), SPH_C32(0xf3740000), SPH_C32(0x88b00000),
    SPH_C32(0x61365cea), SPH_C32(0x94ef9d0d), SPH_C32(0x2be60a85),
    SPH_C32(0xc3b7375f) },
  { SPH_C32(0xf46c0050), SPH_C32(0x96180000), SPH_C32(0x14a50000),
    SPH_C32(0x031f0000), SPH_C32(0x42947eb8), SPH_C32(0x66bf7e19),
    SPH_C32(0x9ca470d2), SPH_C32(0x8a341574), SPH_C32(0x832800a0),
    SPH_C32(0x67420000), SPH_C32(0xe1170000), SPH_C32(0x370b0000),
    SPH_C32(0xcba30034), SPH_C32(0x3c34923c), SPH_C32(0x9767bdcc),
    SPH_C32(0x450360bf) },
  { SPH_C32(0x02ec0055), SPH_C32(0xa25bc000), SPH_C32(0x30a20000),
    SPH_C32(0x8c220000), SPH_C32(0x63a34543), SPH_C32(0x6c07abb7),
    SPH_C32(0x5161fbcb), SPH_C32(0x5da1af45), SPH_C32(0x255700a1),
    SPH_C32(0x16758000), SPH_C32(0xf8eb0000), SPH_C32(0xa1d00000),
    SPH_C32(0xf1286dc9), SPH_C32(0xd7fe3ccf), SPH_C32(0xbb0afa43),
    SPH_C32(0xe98d0c37) },
  { SPH_C32(0x52130051), SPH_C32(0xe72f8000), SPH_C32(0x0d590000),
    SPH_C32(0x95c40000), SPH_C32(0x781f1345), SPH_C32(0x8d75d0ea),
    SPH_C32(0xb0c9375d), SPH_C32(0x26ba79fc), SPH_C32(0xd3d700a4),
    SPH_C32(0x22364000), SPH_C32(0xdcec0000), SPH_C32(0x2eed0000),
    SPH_C32(0xd01f5632), SPH_C32(0xdd46e961), SPH_C32(0x76cf715a),
    SPH_C32(0x3e18b606) },
  { SPH_C32(0xa4930054), SPH_C32(0xd36c4000), SPH_C32(0x295e0000),
    SPH_C32(0x1af90000), SPH_C32(0x592828be), SPH_C32(0x87cd0544),
    SPH_C32(0x7d0cbc44), SPH_C32(0xf12fc3cd), SPH_C32(0x75a800a5),
    SPH_C32(0x5301c000), SPH_C32(0xc5100000), SPH_C32(0xb8360000),
    SPH_C32(0xea943bcf), SPH_C32(0x368c4792), SPH_C32(0x5aa236d5),
    SPH_C32(0x9296da8e) },
  { SPH_C32(0x03190059), SPH_C32(0x5924c000), SPH_C32(0xd7730000),
    SPH_C32(0x078d0000), SPH_C32(0x40016711), SPH_C32(0x9e5748a3),
    SPH_C32(0xe623819c), SPH_C32(0x14228d6e), SPH_C32(0x574200a0),
    SPH_C32(0xea8ac000), SPH_C32(0x44b80000), SPH_C32(0x7d220000),
    SPH_C32(0x37ed424e), SPH_C32(0xf5801450), SPH_C32(0x0f512bc8),
    SPH_C32(0xb245a39f) },
  { SPH_C32(0xf599005c), SPH_C32(0x6d670000), SPH_C32(0xf3740000),
    SPH_C32(0x88b00000), SPH_C32(0x61365cea), SPH_C32(0x94ef9d0d),
    SPH_C32(0x2be60a85), SPH_C32(0xc3b7375f), SPH_C32(0xf13d00a1),
    SPH_C32(0x9bbd4000), SPH_C32(0x5d440000), SPH_C32(0xebf90000),
    SPH_C32(0x0d662fb3), SPH_C32(0x1e4abaa3), SPH_C32(0x233c6c47),
    SPH_C32(0x1ecbcf17) },
  { SPH_C32(0xa5660058), SPH_C32(0x28134000), SPH_C32(0xce8f0000),
    SPH_C32(0x91560000), SPH_C32(0x7a8a0aec), SPH_C32(0x759de650),
    SPH_C32(0xca4ec613), SPH_C32(0xb8ace1e6), SPH_C32(0x07bd00a4),
    SPH_C32(0xaffe8000), SPH_C32(0x79430000), SPH_C32(0x64c40000),
    SPH_C32(0x2c511448), SPH_C32(0x14f26f0d), SPH_C32(0xeef9e75e),
    SPH_C32(0xc95e7526) },
  { SPH_C32(0x53e6005d), SPH_C32(0x1c508000), SPH_C32(0xea880000),
    SPH_C32(0x1e6b0000), SPH_C32(0x5bbd3117), SPH_C32(0x7f2533fe),
    SPH_C32(0x078b4d0a), SPH_C32(0x6f395bd7), SPH_C32(0xa1c200a5),
    SPH_C32(0xdec90000), SPH_C32(0x60bf0000), SPH_C32(0xf21f0000),
    SPH_C32(0x16da79b5), SPH_C32(0xff38c1fe), SPH_C32(0xc294a0d1),
    SPH_C32(0x65d019ae) },
  { SPH_C32(0x20060050), SPH_C32(0x1bd0c000), SPH_C32(0xb10a0000),
    SPH_C32(0x49360000), SPH_C32(0xbeda3cc2), SPH_C32(0xaf0bf875),
    SPH_C32(0x0492e6d6), SPH_C32(0x7d72d654), SPH_C32(0xa03700a9),
    SPH_C32(0x25b60000), SPH_C32(0x876e0000), SPH_C32(0x79b00000),
    SPH_C32(0x35785be7), SPH_C32(0x0d6822ea), SPH_C32(0x75d6da86),
    SPH_C32(0x2c533b85) },
  { SPH_C32(0xd6860055), SPH_C32(0x2f930000), SPH_C32(0x950d0000),
    SPH_C32(0xc60b0000), SPH_C32(0x9fed0739), SPH_C32(0xa5b32ddb),
    SPH_C32(0xc9576dcf), SPH_C32(0xaae76c65), SPH_C32(0x064800a8),
    SPH_C32(0x54818000), SPH_C32(0x9e920000), SPH_C32(0xef6b0000),
    SPH_C32(0x0ff3361a), SPH_C32(0xe6a28c19), SPH_C32(0x59bb9d09),
    SPH_C32(0x80dd570d) },
  { SPH_C32(0x86790051), SPH_C32(0x6ae74000), SPH_C32(0xa8f60000),
    SPH_C32(0xdfed0000), SPH_C32(0x8451513f), SPH_C32(0x44c15686),
    SPH_C32(0x28ffa159), SPH_C32(0xd1fcbadc), SPH_C32(0xf0c800ad),
    SPH_C32(0x60c24000), SPH_C32(0xba950000), SPH_C32(0x60560000),
    SPH_C32(0x2ec40de1), SPH_C32(0xec1a59b7), SPH_C32(0x947e1610),
    SPH_C32(0x5748ed3c) },
  { SPH_C32(0x70f90054), SPH_C32(0x5ea48000), SPH_C32(0x8cf10000),
    SPH_C32(0x50d00000), SPH_C32(0xa5666ac4), SPH_C32(0x4e798328),
    SPH_C32(0xe53a2a40), SPH_C32(0x066900ed), SPH_C32(0x56b700ac),
    SPH_C32(0x11f5c000), SPH_C32(0xa3690000), SPH_C32(0xf68d0000),
    SPH_C32(0x144f601c), SPH_C32(0x07d0f744), SPH_C32(0xb813519f),
    SPH_C32(0xfbc681b4) },
  { SPH_C32(0xd7730059), SPH_C32(0xd4ec0000), SPH_C32(0x72dc0000),
    SPH_C32(0x4da40000), SPH_C32(0xbc4f256b), SPH_C32(0x57e3cecf),
    SPH_C32(0x7e151798), SPH_C32(0xe3644e4e), SPH_C32(0x745d00a9),
    SPH_C32(0xa87ec000), SPH_C32(0x22c10000), SPH_C32(0x33990000),
    SPH_C32(0xc936199d), SPH_C32(0xc4dca486), SPH_C32(0xede04c82),
    SPH_C32(0xdb15f8a5) },
  { SPH_C32(0x21f3005c), SPH_C32(0xe0afc000), SPH_C32(0x56db0000),
    SPH_C32(0xc2990000), SPH_C32(0x9d781e90), SPH_C32(0x5d5b1b61),
    SPH_C32(0xb3d09c81), SPH_C32(0x34f1f47f), SPH_C32(0xd22200a8),
    SPH_C32(0xd9494000), SPH_C32(0x3b3d0000), SPH_C32(0xa5420000),
    SPH_C32(0xf3bd7460), SPH_C32(0x2f160a75), SPH_C32(0xc18d0b0d),
    SPH_C32(0x779b942d) },
  { SPH_C32(0x710c0058), SPH_C32(0xa5db8000), SPH_C32(0x6b200000),
    SPH_C32(0xdb7f0000), SPH_C32(0x86c44896), SPH_C32(0xbc29603c),
    SPH_C32(0x52785017), SPH_C32(0x4fea22c6), SPH_C32(0x24a200ad),
    SPH_C32(0xed0a8000), SPH_C32(0x1f3a0000), SPH_C32(0x2a7f0000),
    SPH_C32(0xd28a4f9b), SPH_C32(0x25aedfdb), SPH_C32(0x0c488014),
    SPH_C32(0xa00e2e1c) },
  { SPH_C32(0x878c005d), SPH_C32(0x91984000), SPH_C32(0x4f270000),
    SPH_C32(0x54420000), SPH_C32(0xa7f3736d), SPH_C32(0xb691b592),
    SPH_C32(0x9fbddb0e), SPH_C32(0x987f98f7), SPH_C32(0x82dd00ac),
    SPH_C32(0x9c3d0000), SPH_C32(0x06c60000), SPH_C32(0xbca40000),
    SPH_C32(0xe8012266), SPH_C32(0xce647128), SPH_C32(0x2025c79b),
    SPH_C32(0x0c804294) },
  { SPH_C32(0x832800a0), SPH_C32(0x67420000), SPH_C32(0xe1170000),
    SPH_C32(0x370b0000), SPH_C32(0xcba30034), SPH_C32(0x3c34923c),
    SPH_C32(0x9767bdcc), SPH_C32(0x450360bf), SPH_C32(0x774400f0),
    SPH_C32(0xf15a0000), SPH_C32(0xf5b20000), SPH_C32(0x34140000),
    SPH_C32(0x89377e8c), SPH_C32(0x5a8bec25), SPH_C32(0x0bc3cd1e),
    SPH_C32(0xcf3775cb) },
  { SPH_C32(0x75a800a5), SPH_C32(0x5301c000), SPH_C32(0xc5100000),
    SPH_C32(0xb8360000), SPH_C32(0xea943bcf), SPH_C32(0x368c4792),
    SPH_C32(0x5aa236d5), SPH_C32(0x9296da8e), SPH_C32(0xd13b00f1),
    SPH_C32(0x806d8000), SPH_C32(0xec4e0000), SPH_C32(0xa2cf0000),
    SPH_C32(0xb3bc1371), SPH_C32(0xb14142d6), SPH_C32(0x27ae8a91),
    SPH_C32(0x63b91943) },
  { SPH_C32(0x255700a1), SPH_C32(0x16758000), SPH_C32(0xf8eb0000),
    SPH_C32(0xa1d00000), SPH_C32(0xf1286dc9), SPH_C32(0xd7fe3ccf),
    SPH_C32(0xbb0afa43), SPH_C32(0xe98d0c37), SPH_C32(0x27bb00f4),
    SPH_C32(0xb42e4000), SPH_C32(0xc8490000), SPH_C32(0x2df20000),
    SPH_C32(0x928b288a), SPH_C32(0xbbf99778), SPH_C32(0xea6b0188),
    SPH_C32(0xb42ca372) },
  { SPH_C32(0xd3d700a4), SPH_C32(0x22364000), SPH_C32(0xdcec0000),
    SPH_C32(0x2eed0000), SPH_C32(0xd01f5632), SPH_C32(0xdd46e961),
    SPH_C32(0x76cf715a), SPH_C32(0x3e18b606), SPH_C32(0x81c400f5),
    SPH_C32(0xc519c000), SPH_C32(0xd1b50000), SPH_C32(0xbb290000),
    SPH_C32(0xa8004577), SPH_C32(0x5033398b), SPH_C32(0xc6064607),
    SPH_C32(0x18a2cffa) },
  { SPH_C32(0x745d00a9), SPH_C32(0xa87ec000), SPH_C32(0x22c10000),
    SPH_C32(0x33990000), SPH_C32(0xc936199d), SPH_C32(0xc4dca486),
    SPH_C32(0xede04c82), SPH_C32(0xdb15f8a5), SPH_C32(0xa32e00f0),
    SPH_C32(0x7c92c000), SPH_C32(0x501d0000), SPH_C32(0x7e3d0000),
    SPH_C32(0x75793cf6), SPH_C32(0x933f6a49), SPH_C32(0x93f55b1a),
    SPH_C32(0x3871b6eb) },
  { SPH_C32(0x82dd00ac), SPH_C32(0x9c3d0000), SPH_C32(0x06c60000),
    SPH_C32(0xbca40000), SPH_C32(0xe8012266), SPH_C32(0xce647128),
    SPH_C32(0x2025c79b), SPH_C32(0x0c804294), SPH_C32(0x055100f1),
    SPH_C32(0x0da54000), SPH_C32(0x49e10000), SPH_C32(0xe8e60000),
    SPH_C32(0x4ff2510b), SPH_C32(0x78f5c4ba), SPH_C32(0xbf981c95),
    SPH_C32(0x94ffda63) },
  { SPH_C32(0xd22200a8), SPH_C32(0xd9494000), SPH_C32(0x3b3d0000),
    SPH_C32(0xa5420000), SPH_C32(0xf3bd7460), SPH_C32(0x2f160a75),
    SPH_C32(0xc18d0b0d), SPH_C32(0x779b942d), SPH_C32(0xf3d100f4),
    SPH_C32(0x39e68000), SPH_C32(0x6de60000), SPH_C32(0x67db0000),
    SPH_C32(0x6ec56af0), SPH_C32(0x724d1114), SPH_C32(0x725d978c),
    SPH_C32(0x436a6052) },
  { SPH_C32(0x24a200ad), SPH_C32(0xed0a8000), SPH_C32(0x1f3a0000),
    SPH_C32(0x2a7f0000), SPH_C32(0xd28a4f9b), SPH_C32(0x25aedfdb),
    SPH_C32(0x0c488014), SPH_C32(0xa00e2e1c), SPH_C32(0x55ae00f5),
    SPH_C32(0x48d10000), SPH_C32(0x741a0000), SPH_C32(0xf1000000),
    SPH_C32(0x544e070d), SPH_C32(0x9987bfe7), SPH_C32(0x5e30d003),
    SPH_C32(0xefe40cda) },
  { SPH_C32(0x574200a0), SPH_C32(0xea8ac000), SPH_C32(0x44b80000),
    SPH_C32(0x7d220000), SPH_C32(0x37ed424e), SPH_C32(0xf5801450),
    SPH_C32(0x0f512bc8), SPH_C32(0xb245a39f), SPH_C32(0x545b00f9),
    SPH_C32(0xb3ae0000), SPH_C32(0x93cb0000), SPH_C32(0x7aaf0000),
    SPH_C32(0x77ec255f), SPH_C32(0x6bd75cf3), SPH_C32(0xe972aa54),
    SPH_C32(0xa6672ef1) },
  { SPH_C32(0xa1c200a5), SPH_C32(0xdec90000), SPH_C32(0x60bf0000),
    SPH_C32(0xf21f0000), SPH_C32(0x16da79b5), SPH_C32(0xff38c1fe),
    SPH_C32(0xc294a0d1), SPH_C32(0x65d019ae), SPH_C32(0xf22400f8),
    SPH_C32(0xc2998000), SPH_C32(0x8a370000), SPH_C32(0xec740000),
    SPH_C32(0x4d6748a2), SPH_C32(0x801df200), SPH_C32(0xc51feddb),
    SPH_C32(0x0ae94279) },
  { SPH_C32(0xf13d00a1), SPH_C32(0x9bbd4000), SPH_C32(0x5d440000),
    SPH_C32(0xebf90000), SPH_C32(0x0d662fb3), SPH_C32(0x1e4abaa3),
    SPH_C32(0x233c6c47), SPH_C32(0x1ecbcf17), SPH_C32(0x04a400fd),
    SPH_C32(0xf6da4000), SPH_C32(0xae300000), SPH_C32(0x63490000),
    SPH_C32(0x6c507359), SPH_C32(0x8aa527ae), SPH_C32(0x08da66c2),
    SPH_C32(0xdd7cf848) },
  { SPH_C32(0x07bd00a4), SPH_C32(0xaffe8000), SPH_C32(0x79430000),
    SPH_C32(0x64c40000), SPH_C32(0x2c511448), SPH_C32(0x14f26f0d),
    SPH_C32(0xeef9e75e), SPH_C32(0xc95e7526), SPH_C32(0xa2db00fc),
    SPH_C32(0x87edc000), SPH_C32(0xb7cc0000), SPH_C32(0xf5920000),
    SPH_C32(0x56db1ea4), SPH_C32(0x616f895d), SPH_C32(0x24b7214d),
    SPH_C32(0x71f294c0) },
  { SPH_C32(0xa03700a9), SPH_C32(0x25b60000), SPH_C32(0x876e0000),
    SPH_C32(0x79b00000), SPH_C32(0x35785be7), SPH_C32(0x0d6822ea),
    SPH_C32(0x75d6da86), SPH_C32(0x2c533b85), SPH_C32(0x803100f9),
    SPH_C32(0x3e66c000), SPH_C32(0x36640000), SPH_C32(0x30860000),
    SPH_C32(0x8ba26725), SPH_C32(0xa263da9f), SPH_C32(0x71443c50),
    SPH_C32(0x5121edd1) },
  { SPH_C32(0x56b700ac), SPH_C32(0x11f5c000), SPH_C32(0xa3690000),
    SPH_C32(0xf68d0000), SPH_C32(0x144f601c), SPH_C32(0x07d0f744),
    SPH_C32(0xb813519f), SPH_C32(0xfbc681b4), SPH_C32(0x264e00f8),
    SPH_C32(0x4f514000), SPH_C32(0x2f980000), SPH_C32(0xa65d0000),
    SPH_C32(0xb1290ad8), SPH_C32(0x49a9746c), SPH_C32(0x5d297bdf),
    SPH_C32(0xfdaf8159) },
  { SPH_C32(0x064800a8), SPH_C32(0x54818000), SPH_C32(0x9e920000),
    SPH_C32(0xef6b0000), SPH_C32(0x0ff3361a), SPH_C32(0xe6a28c19),
    SPH_C32(0x59bb9d09), SPH_C32(0x80dd570d), SPH_C32(0xd0ce00fd),
    SPH_C32(0x7b128000), SPH_C32(0x0b9f0000), SPH_C32(0x29600000),
    SPH_C32(0x901e3123), SPH_C32(0x4311a1c2), SPH_C32(0x90ecf0c6),
    SPH_C32(0x2a3a3b68) },
  { SPH_C32(0xf0c800ad), SPH_C32(0x60c24000), SPH_C32(0xba950000),
    SPH_C32(0x60560000), SPH_C32(0x2ec40de1), SPH_C32(0xec1a59b7),
    SPH_C32(0x947e1610), SPH_C32(0x5748ed3c), SPH_C32(0x76b100fc),
    SPH_C32(0x0a250000), SPH_C32(0x12630000), SPH_C32(0xbfbb0000),
    SPH_C32(0xaa955cde), SPH_C32(0xa8db0f31), SPH_C32(0xbc81b749),
    SPH_C32(0x86b457e0) },
  { SPH_C32(0xe8870170), SPH_C32(0x9d720000), SPH_C32(0x12db0000),
    SPH_C32(0xd4220000), SPH_C32(0xf2886b27), SPH_C32(0xa921e543),
    SPH_C32(0x4ef8b518), SPH_C32(0x618813b1), SPH_C32(0xb4370060),
    SPH_C32(0x0c4c0000), SPH_C32(0x56c20000), SPH_C32(0x5cae0000),
    SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825), SPH_C32(0x1b365f3d),
    SPH_C32(0xf3d45758) },
  { SPH_C32(0x1e070175), SPH_C32(0xa931c000), SPH_C32(0x36dc0000),
    SPH_C32(0x5b1f0000), SPH_C32(0xd3bf50dc), SPH_C32(0xa39930ed),
    SPH_C32(0x833d3e01), SPH_C32(0xb61da980), SPH_C32(0x12480061),
    SPH_C32(0x7d7b8000), SPH_C32(0x4f3e0000), SPH_C32(0xca750000),
    SPH_C32(0xaedf72c2), SPH_C32(0xd0f456d6), SPH_C32(0x375b18b2),
    SPH_C32(0x5f5a3bd0) },
  { SPH_C32(0x4ef80171), SPH_C32(0xec458000), SPH_C32(0x0b270000),
    SPH_C32(0x42f90000), SPH_C32(0xc80306da), SPH_C32(0x42eb4bb0),
    SPH_C32(0x6295f297), SPH_C32(0xcd067f39), SPH_C32(0xe4c80064),
    SPH_C32(0x49384000), SPH_C32(0x6b390000), SPH_C32(0x45480000),
    SPH_C32(0x8fe84939), SPH_C32(0xda4c8378), SPH_C32(0xfa9e93ab),
    SPH_C32(0x88cf81e1) },
  { SPH_C32(0xb8780174), SPH_C32(0xd8064000), SPH_C32(0x2f200000),
    SPH_C32(0xcdc40000), SPH_C32(0xe9343d21), SPH_C32(0x48539e1e),
    SPH_C32(0xaf50798e), SPH_C32(0x1a93c508), SPH_C32(0x42b70065),
    SPH_C32(0x380fc000), SPH_C32(0x72c50000), SPH_C32(0xd3930000),
    SPH_C32(0xb56324c4), SPH_C32(0x31862d8b), SPH_C32(0xd6f3d424),
    SPH_C32(0x2441ed69) },
  { SPH_C32(0x1ff20179), SPH_C32(0x524ec000), SPH_C32(0xd10d0000),
    SPH_C32(0xd0b00000), SPH_C32(0xf01d728e), SPH_C32(0x51c9d3f9),
    SPH_C32(0x347f4456), SPH_C32(0xff9e8bab), SPH_C32(0x605d0060),
    SPH_C32(0x8184c000), SPH_C32(0xf36d0000), SPH_C32(0x16870000),
    SPH_C32(0x681a5d45), SPH_C32(0xf28a7e49), SPH_C32(0x8300c939),
    SPH_C32(0x04929478) },
  { SPH_C32(0xe972017c), SPH_C32(0x660d0000), SPH_C32(0xf50a0000),
    SPH_C32(0x5f8d0000), SPH_C32(0xd12a4975), SPH_C32(0x5b710657),
    SPH_C32(0xf9bacf4f), SPH_C32(0x280b319a), SPH_C32(0xc6220061),
    SPH_C32(0xf0b34000), SPH_C32(0xea910000), SPH_C32(0x805c0000),
    SPH_C32(0x529130b8), SPH_C32(0x1940d0ba), SPH_C32(0xaf6d8eb6),
    SPH_C32(0xa81cf8f0) },
  { SPH_C32(0xb98d0178), SPH_C32(0x23794000), SPH_C32(0xc8f10000),
    SPH_C32(0x466b0000), SPH_C32(0xca961f73), SPH_C32(0xba037d0a),
    SPH_C32(0x181203d9), SPH_C32(0x5310e723), SPH_C32(0x30a20064),
    SPH_C32(0xc4f08000), SPH_C32(0xce960000), SPH_C32(0x0f610000),
    SPH_C32(0x73a60b43), SPH_C32(0x13f80514), SPH_C32(0x62a805af),
    SPH_C32(0x7f8942c1) },
  { SPH_C32(0x4f0d017d), SPH_C32(0x173a8000), SPH_C32(0xecf60000),
    SPH_C32(0xc9560000), SPH_C32(0xeba12488), SPH_C32(0xb0bba8a4),
    SPH_C32(0xd5d788c0), SPH_C32(0x84855d12), SPH_C32(0x96dd0065),
    SPH_C32(0xb5c70000), SPH_C32(0xd76a0000), SPH_C32(0x99ba0000),
    SPH_C32(0x492d66be), SPH_C32(0xf832abe7), SPH_C32(0x4ec54220),
    SPH_C32(0xd3072e49) },
  { SPH_C32(0x3ced0170), SPH_C32(0x10bac000), SPH_C32(0xb7740000),
    SPH_C32(0x9e0b0000), SPH_C32(0x0ec6295d), SPH_C32(0x6095632f),
    SPH_C32(0xd6ce231c), SPH_C32(0x96ced091), SPH_C32(0x97280069),
    SPH_C32(0x4eb80000), SPH_C32(0x30bb0000), SPH_C32(0x12150000),
    SPH_C32(0x6a8f44ec), SPH_C32(0x0a6248f3), SPH_C32(0xf9873877),
    SPH_C32(0x9a840c62) },
  { SPH_C32(0xca6d0175), SPH_C32(0x24f90000), SPH_C32(0x93730000),
    SPH_C32(0x11360000), SPH_C32(0x2ff112a6), SPH_C32(0x6a2db681),
    SPH_C32(0x1b0ba805), SPH_C32(0x415b6aa0), SPH_C32(0x31570068),
    SPH_C32(0x3f8f8000), SPH_C32(0x29470000), SPH_C32(0x84ce0000),
    SPH_C32(0x50042911), SPH_C32(0xe1a8e600), SPH_C32(0xd5ea7ff8),
    SPH_C32(0x360a60ea) },
  { SPH_C32(0x9a920171), SPH_C32(0x618d4000), SPH_C32(0xae880000),
    SPH_C32(0x08d00000), SPH_C32(0x344d44a0), SPH_C32(0x8b5fcddc),
    SPH_C32(0xfaa36493), SPH_C32(0x3a40bc19), SPH_C32(0xc7d7006d),
    SPH_C32(0x0bcc4000), SPH_C32(0x0d400000), SPH_C32(0x0bf30000),
    SPH_C32(0x713312ea), SPH_C32(0xeb1033ae), SPH_C32(0x182ff4e1),
    SPH_C32(0xe19fdadb) },
  { SPH_C32(0x6c120174), SPH_C32(0x55ce8000), SPH_C32(0x8a8f0000),
    SPH_C32(0x87ed0000), SPH_C32(0x157a7f5b), SPH_C32(0x81e71872),
    SPH_C32(0x3766ef8a), SPH_C32(0xedd50628), SPH_C32(0x61a8006c),
    SPH_C32(0x7afbc000), SPH_C32(0x14bc0000), SPH_C32(0x9d280000),
    SPH_C32(0x4bb87f17), SPH_C32(0x00da9d5d), SPH_C32(0x3442b36e),
    SPH_C32(0x4d11b653) },
  { SPH_C32(0xcb980179), SPH_C32(0xdf860000), SPH_C32(0x74a20000),
    SPH_C32(0x9a990000), SPH_C32(0x0c5330f4), SPH_C32(0x987d5595),
    SPH_C32(0xac49d252), SPH_C32(0x08d8488b), SPH_C32(0x43420069),
    SPH_C32(0xc370c000), SPH_C32(0x95140000), SPH_C32(0x583c0000),
    SPH_C32(0x96c10696), SPH_C32(0xc3d6ce9f), SPH_C32(0x61b1ae73),
    SPH_C32(0x6dc2cf42) },
  { SPH_C32(0x3d18017c), SPH_C32(0xebc5c000), SPH_C32(0x50a50000),
    SPH_C32(0x15a40000), SPH_C32(0x2d640b0f), SPH_C32(0x92c5803b),
    SPH_C32(0x618c594b), SPH_C32(0xdf4df2ba), SPH_C32(0xe53d0068),
    SPH_C32(0xb2474000), SPH_C32(0x8ce80000), SPH_C32(0xcee70000),
    SPH_C32(0xac4a6b6b), SPH_C32(0x281c606c), SPH_C32(0x4ddce9fc),
    SPH_C32(0xc14ca3ca) },
  { SPH_C32(0x6de70178), SPH_C32(0xaeb18000), SPH_C32(0x6d5e0000),
    SPH_C32(0x0c420000), SPH_C32(0x36d85d09), SPH_C32(0x73b7fb66),
    SPH_C32(0x802495dd), SPH_C32(0xa4562403), SPH_C32(0x13bd006d),
    SPH_C32(0x86048000), SPH_C32(0xa8ef0000), SPH_C32(0x41da0000),
    SPH_C32(0x8d7d5090), SPH_C32(0x22a4b5c2), SPH_C32(0x801962e5),
    SPH_C32(0x16d919fb) },
  { SPH_C32(0x9b67017d), SPH_C32(0x9af24000), SPH_C32(0x49590000),
    SPH_C32(0x837f0000), SPH_C32(0x17ef66f2), SPH_C32(0x790f2ec8),
    SPH_C32(0x4de11ec4), SPH_C32(0x73c39e32), SPH_C32(0xb5c2006c),
    SPH_C32(0xf7330000), SPH_C32(0xb1130000), SPH_C32(0xd7010000),
    SPH_C32(0xb7f63d6d), SPH_C32(0xc96e1b31), SPH_C32(0xac74256a),
    SPH_C32(0xba577573) },
  { SPH_C32(0x9fc30180), SPH_C32(0x6c280000), SPH_C32(0xe7690000),
    SPH_C32(0xe0360000), SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966),
    SPH_C32(0x453b7806), SPH_C32(0xaebf667a), SPH_C32(0x405b0030),
    SPH_C32(0x9a540000), SPH_C32(0x42670000), SPH_C32(0x5fb10000),
    SPH_C32(0xd6c06187), SPH_C32(0x5d81863c), SPH_C32(0x87922fef),
    SPH_C32(0x79e0422c) },
  { SPH_C32(0x69430185), SPH_C32(0x586bc000), SPH_C32(0xc36e0000),
    SPH_C32(0x6f0b0000), SPH_C32(0x5a882e50), SPH_C32(0xf912dcc8),
    SPH_C32(0x88fef31f), SPH_C32(0x792adc4b), SPH_C32(0xe6240031),
    SPH_C32(0xeb638000), SPH_C32(0x5b9b0000), SPH_C32(0xc96a0000),
    SPH_C32(0xec4b0c7a), SPH_C32(0xb64b28cf), SPH_C32(0xabff6860),
    SPH_C32(0xd56e2ea4) },
  { SPH_C32(0x39bc0181), SPH_C32(0x1d1f8000), SPH_C32(0xfe950000),
    SPH_C32(0x76ed0000), SPH_C32(0x41347856), SPH_C32(0x1860a795),
    SPH_C32(0x69563f89), SPH_C32(0x02310af2), SPH_C32(0x10a40034),
    SPH_C32(0xdf204000), SPH_C32(0x7f9c0000), SPH_C32(0x46570000),
    SPH_C32(0xcd7c3781), SPH_C32(0xbcf3fd61), SPH_C32(0x663ae379),
    SPH_C32(0x02fb9495) },
  { SPH_C32(0xcf3c0184), SPH_C32(0x295c4000), SPH_C32(0xda920000),
    SPH_C32(0xf9d00000), SPH_C32(0x600343ad), SPH_C32(0x12d8723b),
    SPH_C32(0xa493b490), SPH_C32(0xd5a4b0c3), SPH_C32(0xb6db0035),
    SPH_C32(0xae17c000), SPH_C32(0x66600000), SPH_C32(0xd08c0000),
    SPH_C32(0xf7f75a7c), SPH_C32(0x57395392), SPH_C32(0x4a57a4f6),
    SPH_C32(0xae75f81d) },
  { SPH_C32(0x68b60189), SPH_C32(0xa314c000), SPH_C32(0x24bf0000),
    SPH_C32(0xe4a40000), SPH_C32(0x792a0c02), SPH_C32(0x0b423fdc),
    SPH_C32(0x3fbc8948), SPH_C32(0x30a9fe60), SPH_C32(0x94310030),
    SPH_C32(0x179cc000), SPH_C32(0xe7c80000), SPH_C32(0x15980000),
    SPH_C32(0x2a8e23fd), SPH_C32(0x94350050), SPH_C32(0x1fa4b9eb),
    SPH_C32(0x8ea6810c) },
  { SPH_C32(0x9e36018c), SPH_C32(0x97570000), SPH_C32(0x00b80000),
    SPH_C32(0x6b990000), SPH_C32(0x581d37f9), SPH_C32(0x01faea72),
    SPH_C32(0xf2790251), SPH_C32(0xe73c4451), SPH_C32(0x324e0031),
    SPH_C32(0x66ab4000), SPH_C32(0xfe340000), SPH_C32(0x83430000),
    SPH_C32(0x10054e00), SPH_C32(0x7fffaea3), SPH_C32(0x33c9fe64),
    SPH_C32(0x2228ed84) },
  { SPH_C32(0xcec90188), SPH_C32(0xd2234000), SPH_C32(0x3d430000),
    SPH_C32(0x727f0000), SPH_C32(0x43a161ff), SPH_C32(0xe088912f),
    SPH_C32(0x13d1cec7), SPH_C32(0x9c2792e8), SPH_C32(0xc4ce0034),
    SPH_C32(0x52e88000), SPH_C32(0xda330000), SPH_C32(0x0c7e0000),
    SPH_C32(0x313275fb), SPH_C32(0x75477b0d), SPH_C32(0xfe0c757d),
    SPH_C32(0xf5bd57b5) },
  { SPH_C32(0x3849018d), SPH_C32(0xe6608000), SPH_C32(0x19440000),
    SPH_C32(0xfd420000), SPH_C32(0x62965a04), SPH_C32(0xea304481),
    SPH_C32(0xde1445de), SPH_C32(0x4bb228d9), SPH_C32(0x62b10035),
    SPH_C32(0x23df0000), SPH_C32(0xc3cf0000), SPH_C32(0x9aa50000),
    SPH_C32(0x0bb91806), SPH_C32(0x9e8dd5fe), SPH_C32(0xd26132f2),
    SPH_C32(0x59333b3d) },
  { SPH_C32(0x4ba90180), SPH_C32(0xe1e0c000), SPH_C32(0x42c60000),
    SPH_C32(0xaa1f0000), SPH_C32(0x87f157d1), SPH_C32(0x3a1e8f0a),
    SPH_C32(0xdd0dee02), SPH_C32(0x59f9a55a), SPH_C32(0x63440039),
    SPH_C32(0xd8a00000), SPH_C32(0x241e0000), SPH_C32(0x110a0000),
    SPH_C32(0x281b3a54), SPH_C32(0x6cdd36ea), SPH_C32(0x652348a5),
    SPH_C32(0x10b01916) },
  { SPH_C32(0xbd290185), SPH_C32(0xd5a30000), SPH_C32(0x66c10000),
    SPH_C32(0x25220000), SPH_C32(0xa6c66c2a), SPH_C32(0x30a65aa4),
    SPH_C32(0x10c8651b), SPH_C32(0x8e6c1f6b), SPH_C32(0xc53b0038),
    SPH_C32(0xa9978000), SPH_C32(0x3de20000), SPH_C32(0x87d10000),
    SPH_C32(0x129057a9), SPH_C32(0x87179819), SPH_C32(0x494e0f2a),
    SPH_C32(0xbc3e759e) },
  { SPH_C32(0xedd60181), SPH_C32(0x90d74000), SPH_C32(0x5b3a0000),
    SPH_C32(0x3cc40000), SPH_C32(0xbd7a3a2c), SPH_C32(0xd1d421f9),
    SPH_C32(0xf160a98d), SPH_C32(0xf577c9d2), SPH_C32(0x33bb003d),
    SPH_C32(0x9dd44000), SPH_C32(0x19e50000), SPH_C32(0x08ec0000),
    SPH_C32(0x33a76c52), SPH_C32(0x8daf4db7), SPH_C32(0x848b8433),
    SPH_C32(0x6babcfaf) },
  { SPH_C32(0x1b560184), SPH_C32(0xa4948000), SPH_C32(0x7f3d0000),
    SPH_C32(0xb3f90000), SPH_C32(0x9c4d01d7), SPH_C32(0xdb6cf457),
    SPH_C32(0x3ca52294), SPH_C32(0x22e273e3), SPH_C32(0x95c4003c),
    SPH_C32(0xece3c000), SPH_C32(0x00190000), SPH_C32(0x9e370000),
    SPH_C32(0x092c01af), SPH_C32(0x6665e344), SPH_C32(0xa8e6c3bc),
    SPH_C32(0xc725a327) },
  { SPH_C32(0xbcdc0189), SPH_C32(0x2edc0000), SPH_C32(0x81100000),
    SPH_C32(0xae8d0000), SPH_C32(0x85644e78), SPH_C32(0xc2f6b9b0),
    SPH_C32(0xa78a1f4c), SPH_C32(0xc7ef3d40), SPH_C32(0xb72e0039),
    SPH_C32(0x5568c000), SPH_C32(0x81b10000), SPH_C32(0x5b230000),
    SPH_C32(0xd455782e), SPH_C32(0xa569b086), SPH_C32(0xfd15dea1),
    SPH_C32(0xe7f6da36) },
  { SPH_C32(0x4a5c018c), SPH_C32(0x1a9fc000), SPH_C32(0xa5170000),
    SPH_C32(0x21b00000), SPH_C32(0xa4537583), SPH_C32(0xc84e6c1e),
    SPH_C32(0x6a4f9455), SPH_C32(0x107a8771), SPH_C32(0x11510038),
    SPH_C32(0x245f4000), SPH_C32(0x984d0000), SPH_C32(0xcdf80000),
    SPH_C32(0xeede15d3), SPH_C32(0x4ea31e75), SPH_C32(0xd178992e),
    SPH_C32(0x4b78b6be) },
  { SPH_C32(0x1aa30188), SPH_C32(0x5feb8000), SPH_C32(0x98ec0000),
    SPH_C32(0x38560000), SPH_C32(0xbfef2385), SPH_C32(0x293c1743),
    SPH_C32(0x8be758c3), SPH_C32(0x6b6151c8), SPH_C32(0xe7d1003d),
    SPH_C32(0x101c8000), SPH_C32(0xbc4a0000), SPH_C32(0x42c50000),
    SPH_C32(0xcfe92e28), SPH_C32(0x441bcbdb), SPH_C32(0x1cbd1237),
    SPH_C32(0x9ced0c8f) },
  { SPH_C32(0xec23018d), SPH_C32(0x6ba84000), SPH_C32(0xbceb0000),
    SPH_C32(0xb76b0000), SPH_C32(0x9ed8187e), SPH_C32(0x2384c2ed),
    SPH_C32(0x4622d3da), SPH_C32(0xbcf4ebf9), SPH_C32(0x41ae003c),
    SPH_C32(0x612b0000), SPH_C32(0xa5b60000), SPH_C32(0xd41e0000),
    SPH_C32(0xf56243d5), SPH_C32(0xafd16528), SPH_C32(0x30d055b8),
    SPH_C32(0x30636007) },
  { SPH_C32(0x1ceb0120), SPH_C32(0x0b6a0000), SPH_C32(0x067e0000),
    SPH_C32(0xd73d0000), SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a),
    SPH_C32(0xd25cc5ca), SPH_C32(0xebbc06c5), SPH_C32(0x371f00c0),
    SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000), SPH_C32(0x6ba50000),
    SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19), SPH_C32(0x8c51e2f1),
    SPH_C32(0xb6d737e7) },
  { SPH_C32(0xea6b0125), SPH_C32(0x3f29c000), SPH_C32(0x22790000),
    SPH_C32(0x58000000), SPH_C32(0x912b2e64), SPH_C32(0xc5264ef4),
    SPH_C32(0x1f994ed3), SPH_C32(0x3c29bcf4), SPH_C32(0x916000c1),
    SPH_C32(0x1a398000), SPH_C32(0xae290000), SPH_C32(0xfd7e0000),
    SPH_C32(0x657c72f6), SPH_C32(0xecc0c4ea), SPH_C32(0xa03ca57e),
    SPH_C32(0x1a595b6f) },
  { SPH_C32(0xba940121), SPH_C32(0x7a5d8000), SPH_C32(0x1f820000),
    SPH_C32(0x41e60000), SPH_C32(0x8a977862), SPH_C32(0x245435a9),
    SPH_C32(0xfe318245), SPH_C32(0x47326a4d), SPH_C32(0x67e000c4),
    SPH_C32(0x2e7a4000), SPH_C32(0x8a2e0000), SPH_C32(0x72430000),
    SPH_C32(0x444b490d), SPH_C32(0xe6781144), SPH_C32(0x6df92e67),
    SPH_C32(0xcdcce15e) },
  { SPH_C32(0x4c140124), SPH_C32(0x4e1e4000), SPH_C32(0x3b850000),
    SPH_C32(0xcedb0000), SPH_C32(0xaba04399), SPH_C32(0x2eece007),
    SPH_C32(0x33f4095c), SPH_C32(0x90a7d07c), SPH_C32(0xc19f00c5),
    SPH_C32(0x5f4dc000), SPH_C32(0x93d20000), SPH_C32(0xe4980000),
    SPH_C32(0x7ec024f0), SPH_C32(0x0db2bfb7), SPH_C32(0x419469e8),
    SPH_C32(0x61428dd6) },
  { SPH_C32(0xeb9e0129), SPH_C32(0xc456c000), SPH_C32(0xc5a80000),
    SPH_C32(0xd3af0000), SPH_C32(0xb2890c36), SPH_C32(0x3776ade0),
    SPH_C32(0xa8db3484), SPH_C32(0x75aa9edf), SPH_C32(0xe37500c0),
    SPH_C32(0xe6c6c000), SPH_C32(0x127a0000), SPH_C32(0x218c0000),
    SPH_C32(0xa3b95d71), SPH_C32(0xcebeec75), SPH_C32(0x146774f5),
    SPH_C32(0x4191f4c7) },
  { SPH_C32(0x1d1e012c), SPH_C32(0xf0150000), SPH_C32(0xe1af0000),
    SPH_C32(0x5c920000), SPH_C32(0x93be37cd), SPH_C32(0x3dce784e),
    SPH_C32(0x651ebf9d), SPH_C32(0xa23f24ee), SPH_C32(0x450a00c1),
    SPH_C32(0x97f14000), SPH_C32(0x0b860000), SPH_C32(0xb7570000),
    SPH_C32(0x9932308c), SPH_C32(0x25744286), SPH_C32(0x380a337a),
    SPH_C32(0xed1f984f) },
  { SPH_C32(0x4de10128), SPH_C32(0xb5614000), SPH_C32(0xdc540000),
    SPH_C32(0x45740000), SPH_C32(0x880261cb), SPH_C32(0xdcbc0313),
    SPH_C32(0x84b6730b), SPH_C32(0xd924f257), SPH_C32(0xb38a00c4),
    SPH_C32(0xa3b28000), SPH_C32(0x2f810000), SPH_C32(0x386a0000),
    SPH_C32(0xb8050b77), SPH_C32(0x2fcc9728), SPH_C32(0xf5cfb863),
    SPH_C32(0x3a8a227e) },
  { SPH_C32(0xbb61012d), SPH_C32(0x81228000), SPH_C32(0xf8530000),
    SPH_C32(0xca490000), SPH_C32(0xa9355a30), SPH_C32(0xd604d6bd),
    SPH_C32(0x4973f812), SPH_C32(0x0eb14866), SPH_C32(0x15f500c5),
    SPH_C32(0xd2850000), SPH_C32(0x367d0000), SPH_C32(0xaeb10000),
    SPH_C32(0x828e668a), SPH_C32(0xc40639db), SPH_C32(0xd9a2ffec),
    SPH_C32(0x96044ef6) },
  { SPH_C32(0xc8810120), SPH_C32(0x86a2c000), SPH_C32(0xa3d10000),
    SPH_C32(0x9d140000), SPH_C32(0x4c5257e5), SPH_C32(0x062a1d36),
    SPH_C32(0x4a6a53ce), SPH_C32(0x1cfac5e5), SPH_C32(0x140000c9),
    SPH_C32(0x29fa0000), SPH_C32(0xd1ac0000), SPH_C32(0x251e0000),
    SPH_C32(0xa12c44d8), SPH_C32(0x3656dacf), SPH_C32(0x6ee085bb),
    SPH_C32(0xdf876cdd) },
  { SPH_C32(0x3e010125), SPH_C32(0xb2e10000), SPH_C32(0x87d60000),
    SPH_C32(0x12290000), SPH_C32(0x6d656c1e), SPH_C32(0x0c92c898),
    SPH_C32(0x87afd8d7), SPH_C32(0xcb6f7fd4), SPH_C32(0xb27f00c8),
    SPH_C32(0x58cd8000), SPH_C32(0xc8500000), SPH_C32(0xb3c50000),
    SPH_C32(0x9ba72925), SPH_C32(0xdd9c743c), SPH_C32(0x428dc234),
    SPH_C32(0x73090055) },
  { SPH_C32(0x6efe0121), SPH_C32(0xf7954000), SPH_C32(0xba2d0000),
    SPH_C32(0x0bcf0000), SPH_C32(0x76d93a18), SPH_C32(0xede0b3c5),
    SPH_C32(0x66071441), SPH_C32(0xb074a96d), SPH_C32(0x44ff00cd),
    SPH_C32(0x6c8e4000), SPH_C32(0xec570000), SPH_C32(0x3cf80000),
    SPH_C32(0xba9012de), SPH_C32(0xd724a192), SPH_C32(0x8f48492d),
    SPH_C32(0xa49cba64) },
  { SPH_C32(0x987e0124), SPH_C32(0xc3d68000), SPH_C32(0x9e2a0000),
    SPH_C32(0x84f20000), SPH_C32(0x57ee01e3), SPH_C32(0xe758666b),
    SPH_C32(0xabc29f58), SPH_C32(0x67e1135c), SPH_C32(0xe28000cc),
    SPH_C32(0x1db9c000), SPH_C32(0xf5ab0000), SPH_C32(0xaa230000),
    SPH_C32(0x801b7f23), SPH_C32(0x3cee0f61), SPH_C32(0xa3250ea2),
    SPH_C32(0x0812d6ec) },
  { SPH_C32(0x3ff40129), SPH_C32(0x499e0000), SPH_C32(0x60070000),
    SPH_C32(0x99860000), SPH_C32(0x4ec74e4c), SPH_C32(0xfec22b8c),
    SPH_C32(0x30eda280), SPH_C32(0x82ec5dff), SPH_C32(0xc06a00c9),
    SPH_C32(0xa432c000), SPH_C32(0x74030000), SPH_C32(0x6f370000),
    SPH_C32(0x5d6206a2), SPH_C32(0xffe25ca3), SPH_C32(0xf6d613bf),
    SPH_C32(0x28c1affd) },
  { SPH_C32(0xc974012c), SPH_C32(0x7dddc000), SPH_C32(0x44000000),
    SPH_C32(0x16bb0000), SPH_C32(0x6ff075b7), SPH_C32(0xf47afe22),
    SPH_C32(0xfd282999), SPH_C32(0x5579e7ce), SPH_C32(0x661500c8),
    SPH_C32(0xd5054000), SPH_C32(0x6dff0000), SPH_C32(0xf9ec0000),
    SPH_C32(0x67e96b5f), SPH_C32(0x1428f250), SPH_C32(0xdabb5430),
    SPH_C32(0x844fc375) },
  { SPH_C32(0x998b0128), SPH_C32(0x38a98000), SPH_C32(0x79fb0000),
    SPH_C32(0x0f5d0000), SPH_C32(0x744c23b1), SPH_C32(0x1508857f),
    SPH_C32(0x1c80e50f), SPH_C32(0x2e623177), SPH_C32(0x909500cd),
    SPH_C32(0xe1468000), SPH_C32(0x49f80000), SPH_C32(0x76d10000),
    SPH_C32(0x46de50a4), SPH_C32(0x1e9027fe), SPH_C32(0x177edf29),
    SPH_C32(0x53da7944) },
  { SPH_C32(0x6f0b012d), SPH_C32(0x0cea4000), SPH_C32(0x5dfc0000),
    SPH_C32(0x80600000), SPH_C32(0x557b184a), SPH_C32(0x1fb050d1),
    SPH_C32(0xd1456e16), SPH_C32(0xf9f78b46), SPH_C32(0x36ea00cc),
    SPH_C32(0x90710000), SPH_C32(0x50040000), SPH_C32(0xe00a0000),
    SPH_C32(0x7c553d59), SPH_C32(0xf55a890d), SPH_C32(0x3b1398a6),
    SPH_C32(0xff5415cc) },
  { SPH_C32(0x6baf01d0), SPH_C32(0xfa300000), SPH_C32(0xf3cc0000),
    SPH_C32(0xe3290000), SPH_C32(0x392b6b13), SPH_C32(0x9515777f),
    SPH_C32(0xd99f08d4), SPH_C32(0x248b730e), SPH_C32(0xc3730090),
    SPH_C32(0xfd160000), SPH_C32(0xa3700000), SPH_C32(0x68ba0000),
    SPH_C32(0x1d6361b3), SPH_C32(0x61b51400), SPH_C32(0x10f59223),
    SPH_C32(0x3ce32293) },
  { SPH_C32(0x9d2f01d5), SPH_C32(0xce73c000), SPH_C32(0xd7cb0000),
    SPH_C32(0x6c140000), SPH_C32(0x181c50e8), SPH_C32(0x9fada2d1),
    SPH_C32(0x145a83cd), SPH_C32(0xf31ec93f), SPH_C32(0x650c0091),
    SPH_C32(0x8c218000), SPH_C32(0xba8c0000), SPH_C32(0xfe610000),
    SPH_C32(0x27e80c4e), SPH_C32(0x8a7fbaf3), SPH_C32(0x3c98d5ac),
    SPH_C32(0x906d4e1b) },
  { SPH_C32(0xcdd001d1), SPH_C32(0x8b078000), SPH_C32(0xea300000),
    SPH_C32(0x75f20000), SPH_C32(0x03a006ee), SPH_C32(0x7edfd98c),
    SPH_C32(0xf5f24f5b), SPH_C32(0x88051f86), SPH_C32(0x938c0094),
    SPH_C32(0xb8624000), SPH_C32(0x9e8b0000), SPH_C32(0x715c0000),
    SPH_C32(0x06df37b5), SPH_C32(0x80c76f5d), SPH_C32(0xf15d5eb5),
    SPH_C32(0x47f8f42a) },
  { SPH_C32(0x3b5001d4), SPH_C32(0xbf444000), SPH_C32(0xce370000),
    SPH_C32(0xfacf0000), SPH_C32(0x22973d15), SPH_C32(0x74670c22),
    SPH_C32(0x3837c442), SPH_C32(0x5f90a5b7), SPH_C32(0x35f30095),
    SPH_C32(0xc955c000), SPH_C32(0x87770000), SPH_C32(0xe7870000),
    SPH_C32(0x3c545a48), SPH_C32(0x6b0dc1ae), SPH_C32(0xdd30193a),
    SPH_C32(0xeb7698a2) },
  { SPH_C32(0x9cda01d9), SPH_C32(0x350cc000), SPH_C32(0x301a0000),
    SPH_C32(0xe7bb0000), SPH_C32(0x3bbe72ba), SPH_C32(0x6dfd41c5),
    SPH_C32(0xa318f99a), SPH_C32(0xba9deb14), SPH_C32(0x17190090),
    SPH_C32(0x70dec000), SPH_C32(0x06df0000), SPH_C32(0x22930000),
    SPH_C32(0xe12d23c9), SPH_C32(0xa801926c), SPH_C32(0x88c30427),
    SPH_C32(0xcba5e1b3) },
  { SPH_C32(0x6a5a01dc), SPH_C32(0x014f0000), SPH_C32(0x141d0000),
    SPH_C32(0x68860000), SPH_C32(0x1a894941), SPH_C32(0x6745946b),
    SPH_C32(0x6edd7283), SPH_C32(0x6d085125), SPH_C32(0xb1660091),
    SPH_C32(0x01e94000), SPH_C32(0x1f230000), SPH_C32(0xb4480000),
    SPH_C32(0xdba64e34), SPH_C32(0x43cb3c9f), SPH_C32(0xa4ae43a8),
    SPH_C32(0x672b8d3b) },
  { SPH_C32(0x3aa501d8), SPH_C32(0x443b4000), SPH_C32(0x29e60000),
    SPH_C32(0x71600000), SPH_C32(0x01351f47), SPH_C32(0x8637ef36),
    SPH_C32(0x8f75be15), SPH_C32(0x1613879c), SPH_C32(0x47e60094),
    SPH_C32(0x35aa8000), SPH_C32(0x3b240000), SPH_C32(0x3b750000),
    SPH_C32(0xfa9175cf), SPH_C32(0x4973e931), SPH_C32(0x696bc8b1),
    SPH_C32(0xb0be370a) },
  { SPH_C32(0xcc2501dd), SPH_C32(0x70788000), SPH_C32(0x0de10000),
    SPH_C32(0xfe5d0000), SPH_C32(0x200224bc), SPH_C32(0x8c8f3a98),
    SPH_C32(0x42b0350c), SPH_C32(0xc1863dad), SPH_C32(0xe1990095),
    SPH_C32(0x449d0000), SPH_C32(0x22d80000), SPH_C32(0xadae0000),
    SPH_C32(0xc01a1832), SPH_C32(0xa2b947c2), SPH_C32(0x45068f3e),
    SPH_C32(0x1c305b82) },
  { SPH_C32(0xbfc501d0), SPH_C32(0x77f8c000), SPH_C32(0x56630000),
    SPH_C32(0xa9000000), SPH_C32(0xc5652969), SPH_C32(0x5ca1f113),
    SPH_C32(0x41a99ed0), SPH_C32(0xd3cdb02e), SPH_C32(0xe06c0099),
    SPH_C32(0xbfe20000), SPH_C32(0xc5090000), SPH_C32(0x26010000),
    SPH_C32(0xe3b83a60), SPH_C32(0x50e9a4d6), SPH_C32(0xf244f569),
    SPH_C32(0x55b379a9) },
  { SPH_C32(0x494501d5), SPH_C32(0x43bb0000), SPH_C32(0x72640000),
    SPH_C32(0x263d0000), SPH_C32(0xe4521292), SPH_C32(0x561924bd),
    SPH_C32(0x8c6c15c9), SPH_C32(0x04580a1f), SPH_C32(0x46130098),
    SPH_C32(0xced58000), SPH_C32(0xdcf50000), SPH_C32(0xb0da0000),
    SPH_C32(0xd933579d), SPH_C32(0xbb230a25), SPH_C32(0xde29b2e6),
    SPH_C32(0xf93d1521) },
  { SPH_C32(0x19ba01d1), SPH_C32(0x06cf4000), SPH_C32(0x4f9f0000),
    SPH_C32(0x3fdb0000), SPH_C32(0xffee4494), SPH_C32(0xb76b5fe0),
    SPH_C32(0x6dc4d95f), SPH_C32(0x7f43dca6), SPH_C32(0xb093009d),
    SPH_C32(0xfa964000), SPH_C32(0xf8f20000), SPH_C32(0x3fe70000),
    SPH_C32(0xf8046c66), SPH_C32(0xb19bdf8b), SPH_C32(0x13ec39ff),
    SPH_C32(0x2ea8af10) },
  { SPH_C32(0xef3a01d4), SPH_C32(0x328c8000), SPH_C32(0x6b980000),
    SPH_C32(0xb0e60000), SPH_C32(0xded97f6f), SPH_C32(0xbdd38a4e),
    SPH_C32(0xa0015246), SPH_C32(0xa8d66697), SPH_C32(0x16ec009c),
    SPH_C32(0x8ba1c000), SPH_C32(0xe10e0000), SPH_C32(0xa93c0000),
    SPH_C32(0xc28f019b), SPH_C32(0x5a517178), SPH_C32(0x3f817e70),
    SPH_C32(0x8226c398) },
  { SPH_C32(0x48b001d9), SPH_C32(0xb8c40000), SPH_C32(0x95b50000),
    SPH_C32(0xad920000), SPH_C32(0xc7f030c0), SPH_C32(0xa449c7a9),
    SPH_C32(0x3b2e6f9e), SPH_C32(0x4ddb2834), SPH_C32(0x34060099),
    SPH_C32(0x322ac000), SPH_C32(0x60a60000), SPH_C32(0x6c280000),
    SPH_C32(0x1ff6781a), SPH_C32(0x995d22ba), SPH_C32(0x6a72636d),
    SPH_C32(0xa2f5ba89) },
  { SPH_C32(0xbe3001dc), SPH_C32(0x8c87c000), SPH_C32(0xb1b20000),
    SPH_C32(0x22af0000), SPH_C32(0xe6c70b3b), SPH_C32(0xaef11207),
    SPH_C32(0xf6ebe487), SPH_C32(0x9a4e9205), SPH_C32(0x92790098),
    SPH_C32(0x431d4000), SPH_C32(0x795a0000), SPH_C32(0xfaf30000),
    SPH_C32(0x257d15e7), SPH_C32(0x72978c49), SPH_C32(0x461f24e2),
    SPH_C32(0x0e7bd601) },
  { SPH_C32(0xeecf01d8), SPH_C32(0xc9f38000), SPH_C32(0x8c490000),
    SPH_C32(0x3b490000), SPH_C32(0xfd7b5d3d), SPH_C32(0x4f83695a),
    SPH_C32(0x17432811), SPH_C32(0xe15544bc), SPH_C32(0x64f9009d),
    SPH_C32(0x775e8000), SPH_C32(0x5d5d0000), SPH_C32(0x75ce0000),
    SPH_C32(0x044a2e1c), SPH_C32(0x782f59e7), SPH_C32(0x8bdaaffb),
    SPH_C32(0xd9ee6c30) },
  { SPH_C32(0x184f01dd), SPH_C32(0xfdb04000), SPH_C32(0xa84e0000),
    SPH_C32(0xb4740000), SPH_C32(0xdc4c66c6), SPH_C32(0x453bbcf4),
    SPH_C32(0xda86a308), SPH_C32(0x36c0fe8d), SPH_C32(0xc286009c),
    SPH_C32(0x06690000), SPH_C32(0x44a10000), SPH_C32(0xe3150000),
    SPH_C32(0x3ec143e1), SPH_C32(0x93e5f714), SPH_C32(0xa7b7e874),
    SPH_C32(0x756000b8) },
  { SPH_C32(0xb4370060), SPH_C32(0x0c4c0000), SPH_C32(0x56c20000),
    SPH_C32(0x5cae0000), SPH_C32(0x94541f3f), SPH_C32(0x3b3ef825),
    SPH_C32(0x1b365f3d), SPH_C32(0xf3d45758), SPH_C32(0x5cb00110),
    SPH_C32(0x913e0000), SPH_C32(0x44190000), SPH_C32(0x888c0000),
    SPH_C32(0x66dc7418), SPH_C32(0x921f1d66), SPH_C32(0x55ceea25),
    SPH_C32(0x925c44e9) },
  { SPH_C32(0x42b70065), SPH_C32(0x380fc000), SPH_C32(0x72c50000),
    SPH_C32(0xd3930000), SPH_C32(0xb56324c4), SPH_C32(0x31862d8b),
    SPH_C32(0xd6f3d424), SPH_C32(0x2441ed69), SPH_C32(0xfacf0111),
    SPH_C32(0xe0098000), SPH_C32(0x5de50000), SPH_C32(0x1e570000),
    SPH_C32(0x5c5719e5), SPH_C32(0x79d5b395), SPH_C32(0x79a3adaa),
    SPH_C32(0x3ed22861) },
  { SPH_C32(0x12480061), SPH_C32(0x7d7b8000), SPH_C32(0x4f3e0000),
    SPH_C32(0xca750000), SPH_C32(0xaedf72c2), SPH_C32(0xd0f456d6),
    SPH_C32(0x375b18b2), SPH_C32(0x5f5a3bd0), SPH_C32(0x0c4f0114),
    SPH_C32(0xd44a4000), SPH_C32(0x79e20000), SPH_C32(0x916a0000),
    SPH_C32(0x7d60221e), SPH_C32(0x736d663b), SPH_C32(0xb46626b3),
    SPH_C32(0xe9479250) },
  { SPH_C32(0xe4c80064), SPH_C32(0x49384000), SPH_C32(0x6b390000),
    SPH_C32(0x45480000), SPH_C32(0x8fe84939), SPH_C32(0xda4c8378),
    SPH_C32(0xfa9e93ab), SPH_C32(0x88cf81e1), SPH_C32(0xaa300115),
    SPH_C32(0xa57dc000), SPH_C32(0x601e0000), SPH_C32(0x07b10000),
    SPH_C32(0x47eb4fe3), SPH_C32(0x98a7c8c8), SPH_C32(0x980b613c),
    SPH_C32(0x45c9fed8) },
  { SPH_C32(0x43420069), SPH_C32(0xc370c000), SPH_C32(0x95140000),
    SPH_C32(0x583c0000), SPH_C32(0x96c10696), SPH_C32(0xc3d6ce9f),
    SPH_C32(0x61b1ae73), SPH_C32(0x6dc2cf42), SPH_C32(0x88da0110),
    SPH_C32(0x1cf6c000), SPH_C32(0xe1b60000), SPH_C32(0xc2a50000),
    SPH_C32(0x9a923662), SPH_C32(0x5bab9b0a), SPH_C32(0xcdf87c21),
    SPH_C32(0x651a87c9) },
  { SPH_C32(0xb5c2006c), SPH_C32(0xf7330000), SPH_C32(0xb1130000),
    SPH_C32(0xd7010000), SPH_C32(0xb7f63d6d), SPH_C32(0xc96e1b31),
    SPH_C32(0xac74256a), SPH_C32(0xba577573), SPH_C32(0x2ea50111),
    SPH_C32(0x6dc14000), SPH_C32(0xf84a0000), SPH_C32(0x547e0000),
    SPH_C32(0xa0195b9f), SPH_C32(0xb06135f9), SPH_C32(0xe1953bae),
    SPH_C32(0xc994eb41) },
  { SPH_C32(0xe53d0068), SPH_C32(0xb2474000), SPH_C32(0x8ce80000),
    SPH_C32(0xcee70000), SPH_C32(0xac4a6b6b), SPH_C32(0x281c606c),
    SPH_C32(0x4ddce9fc), SPH_C32(0xc14ca3ca), SPH_C32(0xd8250114),
    SPH_C32(0x59828000), SPH_C32(0xdc4d0000), SPH_C32(0xdb430000),
    SPH_C32(0x812e6064), SPH_C32(0xbad9e057), SPH_C32(0x2c50b0b7),
    SPH_C32(0x1e015170) },
  { SPH_C32(0x13bd006d), SPH_C32(0x86048000), SPH_C32(0xa8ef0000),
    SPH_C32(0x41da0000), SPH_C32(0x8d7d5090), SPH_C32(0x22a4b5c2),
    SPH_C32(0x801962e5), SPH_C32(0x16d919fb), SPH_C32(0x7e5a0115),
    SPH_C32(0x28b50000), SPH_C32(0xc5b10000), SPH_C32(0x4d980000),
    SPH_C32(0xbba50d99), SPH_C32(0x51134ea4), SPH_C32(0x003df738),
    SPH_C32(0xb28f3df8) },
  { SPH_C32(0x605d0060), SPH_C32(0x8184c000), SPH_C32(0xf36d0000),
    SPH_C32(0x16870000), SPH_C32(0x681a5d45), SPH_C32(0xf28a7e49),
    SPH_C32(0x8300c939), SPH_C32(0x04929478), SPH_C32(0x7faf0119),
    SPH_C32(0xd3ca0000), SPH_C32(0x22600000), SPH_C32(0xc6370000),
    SPH_C32(0x98072fcb), SPH_C32(0xa343adb0), SPH_C32(0xb77f8d6f),
    SPH_C32(0xfb0c1fd3) },
  { SPH_C32(0x96dd0065), SPH_C32(0xb5c70000), SPH_C32(0xd76a0000),
    SPH_C32(0x99ba0000), SPH_C32(0x492d66be), SPH_C32(0xf832abe7),
    SPH_C32(0x4ec54220), SPH_C32(0xd3072e49), SPH_C32(0xd9d00118),
    SPH_C32(0xa2fd8000), SPH_C32(0x3b9c0000), SPH_C32(0x50ec0000),
    SPH_C32(0xa28c4236), SPH_C32(0x48890343), SPH_C32(0x9b12cae0),
    SPH_C32(0x5782735b) },
  { SPH_C32(0xc6220061), SPH_C32(0xf0b34000), SPH_C32(0xea910000),
    SPH_C32(0x805c0000), SPH_C32(0x529130b8), SPH_C32(0x1940d0ba),
    SPH_C32(0xaf6d8eb6), SPH_C32(0xa81cf8f0), SPH_C32(0x2f50011d),
    SPH_C32(0x96be4000), SPH_C32(0x1f9b0000), SPH_C32(0xdfd10000),
    SPH_C32(0x83bb79cd), SPH_C32(0x4231d6ed), SPH_C32(0x56d741f9),
    SPH_C32(0x8017c96a) },
  { SPH_C32(0x30a20064), SPH_C32(0xc4f08000), SPH_C32(0xce960000),
    SPH_C32(0x0f610000), SPH_C32(0x73a60b43), SPH_C32(0x13f80514),
    SPH_C32(0x62a805af), SPH_C32(0x7f8942c1), SPH_C32(0x892f011c),
    SPH_C32(0xe789c000), SPH_C32(0x06670000), SPH_C32(0x490a0000),
    SPH_C32(0xb9301430), SPH_C32(0xa9fb781e), SPH_C32(0x7aba0676),
    SPH_C32(0x2c99a5e2) },
  { SPH_C32(0x97280069), SPH_C32(0x4eb80000), SPH_C32(0x30bb0000),
    SPH_C32(0x12150000), SPH_C32(0x6a8f44ec), SPH_C32(0x0a6248f3),
    SPH_C32(0xf9873877), SPH_C32(0x9a840c62), SPH_C32(0xabc50119),
    SPH_C32(0x5e02c000), SPH_C32(0x87cf0000), SPH_C32(0x8c1e0000),
    SPH_C32(0x64496db1), SPH_C32(0x6af72bdc), SPH_C32(0x2f491b6b),
    SPH_C32(0x0c4adcf3) },
  { SPH_C32(0x61a8006c), SPH_C32(0x7afbc000), SPH_C32(0x14bc0000),
    SPH_C32(0x9d280000), SPH_C32(0x4bb87f17), SPH_C32(0x00da9d5d),
    SPH_C32(0x3442b36e), SPH_C32(0x4d11b653), SPH_C32(0x0dba0118),
    SPH_C32(0x2f354000), SPH_C32(0x9e330000), SPH_C32(0x1ac50000),
    SPH_C32(0x5ec2004c), SPH_C32(0x813d852f), SPH_C32(0x03245ce4),
    SPH_C32(0xa0c4b07b) },
  { SPH_C32(0x31570068), SPH_C32(0x3f8f8000), SPH_C32(0x29470000),
    SPH_C32(0x84ce0000), SPH_C32(0x50042911), SPH_C32(0xe1a8e600),
    SPH_C32(0xd5ea7ff8), SPH_C32(0x360a60ea), SPH_C32(0xfb3a011d),
    SPH_C32(0x1b768000), SPH_C32(0xba340000), SPH_C32(0x95f80000),
    SPH_C32(0x7ff53bb7), SPH_C32(0x8b855081), SPH_C32(0xcee1d7fd),
    SPH_C32(0x77510a4a) },
  { SPH_C32(0xc7d7006d), SPH_C32(0x0bcc4000), SPH_C32(0x0d400000),
    SPH_C32(0x0bf30000), SPH_C32(0x713312ea), SPH_C32(0xeb1033ae),
    SPH_C32(0x182ff4e1), SPH_C32(0xe19fdadb), SPH_C32(0x5d45011c),
    SPH_C32(0x6a410000), SPH_C32(0xa3c80000), SPH_C32(0x03230000),
    SPH_C32(0x457e564a), SPH_C32(0x604ffe72), SPH_C32(0xe28c9072),
    SPH_C32(0xdbdf66c2) },
  { SPH_C32(0xc3730090), SPH_C32(0xfd160000), SPH_C32(0xa3700000),
    SPH_C32(0x68ba0000), SPH_C32(0x1d6361b3), SPH_C32(0x61b51400),
    SPH_C32(0x10f59223), SPH_C32(0x3ce32293), SPH_C32(0xa8dc0140),
    SPH_C32(0x07260000), SPH_C32(0x50bc0000), SPH_C32(0x8b930000),
    SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f), SPH_C32(0xc96a9af7),
    SPH_C32(0x1868519d) },
  { SPH_C32(0x35f30095), SPH_C32(0xc955c000), SPH_C32(0x87770000),
    SPH_C32(0xe7870000), SPH_C32(0x3c545a48), SPH_C32(0x6b0dc1ae),
    SPH_C32(0xdd30193a), SPH_C32(0xeb7698a2), SPH_C32(0x0ea30141),
    SPH_C32(0x76118000), SPH_C32(0x49400000), SPH_C32(0x1d480000),
    SPH_C32(0x1ec3675d), SPH_C32(0x1f6acd8c), SPH_C32(0xe507dd78),
    SPH_C32(0xb4e63d15) },
  { SPH_C32(0x650c0091), SPH_C32(0x8c218000), SPH_C32(0xba8c0000),
    SPH_C32(0xfe610000), SPH_C32(0x27e80c4e), SPH_C32(0x8a7fbaf3),
    SPH_C32(0x3c98d5ac), SPH_C32(0x906d4e1b), SPH_C32(0xf8230144),
    SPH_C32(0x42524000), SPH_C32(0x6d470000), SPH_C32(0x92750000),
    SPH_C32(0x3ff45ca6), SPH_C32(0x15d21822), SPH_C32(0x28c25661),
    SPH_C32(0x63738724) },
  { SPH_C32(0x938c0094), SPH_C32(0xb8624000), SPH_C32(0x9e8b0000),
    SPH_C32(0x715c0000), SPH_C32(0x06df37b5), SPH_C32(0x80c76f5d),
    SPH_C32(0xf15d5eb5), SPH_C32(0x47f8f42a), SPH_C32(0x5e5c0145),
    SPH_C32(0x3365c000), SPH_C32(0x74bb0000), SPH_C32(0x04ae0000),
    SPH_C32(0x057f315b), SPH_C32(0xfe18b6d1), SPH_C32(0x04af11ee),
    SPH_C32(0xcffdebac) },
  { SPH_C32(0x34060099), SPH_C32(0x322ac000), SPH_C32(0x60a60000),
    SPH_C32(0x6c280000), SPH_C32(0x1ff6781a), SPH_C32(0x995d22ba),
    SPH_C32(0x6a72636d), SPH_C32(0xa2f5ba89), SPH_C32(0x7cb60140),
    SPH_C32(0x8aeec000), SPH_C32(0xf5130000), SPH_C32(0xc1ba0000),
    SPH_C32(0xd80648da), SPH_C32(0x3d14e513), SPH_C32(0x515c0cf3),
    SPH_C32(0xef2e92bd) },
  { SPH_C32(0xc286009c), SPH_C32(0x06690000), SPH_C32(0x44a10000),
    SPH_C32(0xe3150000), SPH_C32(0x3ec143e1), SPH_C32(0x93e5f714),
    SPH_C32(0xa7b7e874), SPH_C32(0x756000b8), SPH_C32(0xdac90141),
    SPH_C32(0xfbd94000), SPH_C32(0xecef0000), SPH_C32(0x57610000),
    SPH_C32(0xe28d2527), SPH_C32(0xd6de4be0), SPH_C32(0x7d314b7c),
    SPH_C32(0x43a0fe35) },
  { SPH_C32(0x92790098), SPH_C32(0x431d4000), SPH_C32(0x795a0000),
    SPH_C32(0xfaf30000), SPH_C32(0x257d15e7), SPH_C32(0x72978c49),
    SPH_C32(0x461f24e2), SPH_C32(0x0e7bd601), SPH_C32(0x2c490144),
    SPH_C32(0xcf9a8000), SPH_C32(0xc8e80000), SPH_C32(0xd85c0000),
    SPH_C32(0xc3ba1edc), SPH_C32(0xdc669e4e), SPH_C32(0xb0f4c065),
    SPH_C32(0x94354404) },
  { SPH_C32(0x64f9009d), SPH_C32(0x775e8000), SPH_C32(0x5d5d0000),
    SPH_C32(0x75ce0000), SPH_C32(0x044a2e1c), SPH_C32(0x782f59e7),
    SPH_C32(0x8bdaaffb), SPH_C32(0xd9ee6c30), SPH_C32(0x8a360145),
    SPH_C32(0xbead0000), SPH_C32(0xd1140000), SPH_C32(0x4e870000),
    SPH_C32(0xf9317321), SPH_C32(0x37ac30bd), SPH_C32(0x9c9987ea),
    SPH_C32(0x38bb288c) },
  { SPH_C32(0x17190090), SPH_C32(0x70dec000), SPH_C32(0x06df0000),
    SPH_C32(0x22930000), SPH_C32(0xe12d23c9), SPH_C32(0xa801926c),
    SPH_C32(0x88c30427), SPH_C32(0xcba5e1b3), SPH_C32(0x8bc30149),
    SPH_C32(0x45d20000), SPH_C32(0x36c50000), SPH_C32(0xc5280000),
    SPH_C32(0xda935173), SPH_C32(0xc5fcd3a9), SPH_C32(0x2bdbfdbd),
    SPH_C32(0x71380aa7) },
  { SPH_C32(0xe1990095), SPH_C32(0x449d0000), SPH_C32(0x22d80000),
    SPH_C32(0xadae0000), SPH_C32(0xc01a1832), SPH_C32(0xa2b947c2),
    SPH_C32(0x45068f3e), SPH_C32(0x1c305b82), SPH_C32(0x2dbc0148),
    SPH_C32(0x34e58000), SPH_C32(0x2f390000), SPH_C32(0x53f30000),
    SPH_C32(0xe0183c8e), SPH_C32(0x2e367d5a), SPH_C32(0x07b6ba32),
    SPH_C32(0xddb6662f) },
  { SPH_C32(0xb1660091), SPH_C32(0x01e94000), SPH_C32(0x1f230000),
    SPH_C32(0xb4480000), SPH_C32(0xdba64e34), SPH_C32(0x43cb3c9f),
    SPH_C32(0xa4ae43a8), SPH_C32(0x672b8d3b), SPH_C32(0xdb3c014d),
    SPH_C32(0x00a64000), SPH_C32(0x0b3e0000), SPH_C32(0xdcce0000),
    SPH_C32(0xc12f0775), SPH_C32(0x248ea8f4), SPH_C32(0xca73312b),
    SPH_C32(0x0a23dc1e) },
  { SPH_C32(0x47e60094), SPH_C32(0x35aa8000), SPH_C32(0x3b240000),
    SPH_C32(0x3b750000), SPH_C32(0xfa9175cf), SPH_C32(0x4973e931),
    SPH_C32(0x696bc8b1), SPH_C32(0xb0be370a), SPH_C32(0x7d43014c),
    SPH_C32(0x7191c000), SPH_C32(0x12c20000), SPH_C32(0x4a150000),
    SPH_C32(0xfba46a88), SPH_C32(0xcf440607), SPH_C32(0xe61e76a4),
    SPH_C32(0xa6adb096) },
  { SPH_C32(0xe06c0099), SPH_C32(0xbfe20000), SPH_C32(0xc5090000),
    SPH_C32(0x26010000), SPH_C32(0xe3b83a60), SPH_C32(0x50e9a4d6),
    SPH_C32(0xf244f569), SPH_C32(0x55b379a9), SPH_C32(0x5fa90149),
    SPH_C32(0xc81ac000), SPH_C32(0x936a0000), SPH_C32(0x8f010000),
    SPH_C32(0x26dd1309), SPH_C32(0x0c4855c5), SPH_C32(0xb3ed6bb9),
    SPH_C32(0x867ec987) },
  { SPH_C32(0x16ec009c), SPH_C32(0x8ba1c000), SPH_C32(0xe10e0000),
    SPH_C32(0xa93c0000), SPH_C32(0xc28f019b), SPH_C32(0x5a517178),
    SPH_C32(0x3f817e70), SPH_C32(0x8226c398), SPH_C32(0xf9d60148),
    SPH_C32(0xb92d4000), SPH_C32(0x8a960000), SPH_C32(0x19da0000),
    SPH_C32(0x1c567ef4), SPH_C32(0xe782fb36), SPH_C32(0x9f802c36),
    SPH_C32(0x2af0a50f) },
  { SPH_C32(0x46130098), SPH_C32(0xced58000), SPH_C32(0xdcf50000),
    SPH_C32(0xb0da0000), SPH_C32(0xd933579d), SPH_C32(0xbb230a25),
    SPH_C32(0xde29b2e6), SPH_C32(0xf93d1521), SPH_C32(0x0f56014d),
    SPH_C32(0x8d6e8000), SPH_C32(0xae910000), SPH_C32(0x96e70000),
    SPH_C32(0x3d61450f), SPH_C32(0xed3a2e98), SPH_C32(0x5245a72f),
    SPH_C32(0xfd651f3e) },
  { SPH_C32(0xb093009d), SPH_C32(0xfa964000), SPH_C32(0xf8f20000),
    SPH_C32(0x3fe70000), SPH_C32(0xf8046c66), SPH_C32(0xb19bdf8b),
    SPH_C32(0x13ec39ff), SPH_C32(0x2ea8af10), SPH_C32(0xa929014c),
    SPH_C32(0xfc590000), SPH_C32(0xb76d0000), SPH_C32(0x003c0000),
    SPH_C32(0x07ea28f2), SPH_C32(0x06f0806b), SPH_C32(0x7e28e0a0),
    SPH_C32(0x51eb73b6) },
  { SPH_C32(0x405b0030), SPH_C32(0x9a540000), SPH_C32(0x42670000),
    SPH_C32(0x5fb10000), SPH_C32(0xd6c06187), SPH_C32(0x5d81863c),
    SPH_C32(0x87922fef), SPH_C32(0x79e0422c), SPH_C32(0xdf9801b0),
    SPH_C32(0xf67c0000), SPH_C32(0xa50e0000), SPH_C32(0xbf870000),
    SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a), SPH_C32(0xc2a957e9),
    SPH_C32(0xd75f2456) },
  { SPH_C32(0xb6db0035), SPH_C32(0xae17c000), SPH_C32(0x66600000),
    SPH_C32(0xd08c0000), SPH_C32(0xf7f75a7c), SPH_C32(0x57395392),
    SPH_C32(0x4a57a4f6), SPH_C32(0xae75f81d), SPH_C32(0x79e701b1),
    SPH_C32(0x874b8000), SPH_C32(0xbcf20000), SPH_C32(0x295c0000),
    SPH_C32(0x97f419d1), SPH_C32(0x45e121a9), SPH_C32(0xeec41066),
    SPH_C32(0x7bd148de) },
  { SPH_C32(0xe6240031), SPH_C32(0xeb638000), SPH_C32(0x5b9b0000),
    SPH_C32(0xc96a0000), SPH_C32(0xec4b0c7a), SPH_C32(0xb64b28cf),
    SPH_C32(0xabff6860), SPH_C32(0xd56e2ea4), SPH_C32(0x8f6701b4),
    SPH_C32(0xb3084000), SPH_C32(0x98f50000), SPH_C32(0xa6610000),
    SPH_C32(0xb6c3222a), SPH_C32(0x4f59f407), SPH_C32(0x23019b7f),
    SPH_C32(0xac44f2ef) },
  { SPH_C32(0x10a40034), SPH_C32(0xdf204000), SPH_C32(0x7f9c0000),
    SPH_C32(0x46570000), SPH_C32(0xcd7c3781), SPH_C32(0xbcf3fd61),
    SPH_C32(0x663ae379), SPH_C32(0x02fb9495), SPH_C32(0x291801b5),
    SPH_C32(0xc23fc000), SPH_C32(0x81090000), SPH_C32(0x30ba0000),
    SPH_C32(0x8c484fd7), SPH_C32(0xa4935af4), SPH_C32(0x0f6cdcf0),
    SPH_C32(0x00ca9e67) },
  { SPH_C32(0xb72e0039), SPH_C32(0x5568c000), SPH_C32(0x81b10000),
    SPH_C32(0x5b230000), SPH_C32(0xd455782e), SPH_C32(0xa569b086),
    SPH_C32(0xfd15dea1), SPH_C32(0xe7f6da36), SPH_C32(0x0bf201b0),
    SPH_C32(0x7bb4c000), SPH_C32(0x00a10000), SPH_C32(0xf5ae0000),
    SPH_C32(0x51313656), SPH_C32(0x679f0936), SPH_C32(0x5a9fc1ed),
    SPH_C32(0x2019e776) },
  { SPH_C32(0x41ae003c), SPH_C32(0x612b0000), SPH_C32(0xa5b60000),
    SPH_C32(0xd41e0000), SPH_C32(0xf56243d5), SPH_C32(0xafd16528),
    SPH_C32(0x30d055b8), SPH_C32(0x30636007), SPH_C32(0xad8d01b1),
    SPH_C32(0x0a834000), SPH_C32(0x195d0000), SPH_C32(0x63750000),
    SPH_C32(0x6bba5bab), SPH_C32(0x8c55a7c5), SPH_C32(0x76f28662),
    SPH_C32(0x8c978bfe) },
  { SPH_C32(0x11510038), SPH_C32(0x245f4000), SPH_C32(0x984d0000),
    SPH_C32(0xcdf80000), SPH_C32(0xeede15d3), SPH_C32(0x4ea31e75),
    SPH_C32(0xd178992e), SPH_C32(0x4b78b6be), SPH_C32(0x5b0d01b4),
    SPH_C32(0x3ec08000), SPH_C32(0x3d5a0000), SPH_C32(0xec480000),
    SPH_C32(0x4a8d6050), SPH_C32(0x86ed726b), SPH_C32(0xbb370d7b),
    SPH_C32(0x5b0231cf) },
  { SPH_C32(0xe7d1003d), SPH_C32(0x101c8000), SPH_C32(0xbc4a0000),
    SPH_C32(0x42c50000), SPH_C32(0xcfe92e28), SPH_C32(0x441bcbdb),
    SPH_C32(0x1cbd1237), SPH_C32(0x9ced0c8f), SPH_C32(0xfd7201b5),
    SPH_C32(0x4ff70000), SPH_C32(0x24a60000), SPH_C32(0x7a930000),
    SPH_C32(0x70060dad), SPH_C32(0x6d27dc98), SPH_C32(0x975a4af4),
    SPH_C32(0xf78c5d47) },
  { SPH_C32(0x94310030), SPH_C32(0x179cc000), SPH_C32(0xe7c80000),
    SPH_C32(0x15980000), SPH_C32(0x2a8e23fd), SPH_C32(0x94350050),
    SPH_C32(0x1fa4b9eb), SPH_C32(0x8ea6810c), SPH_C32(0xfc8701b9),
    SPH_C32(0xb4880000), SPH_C32(0xc3770000), SPH_C32(0xf13c0000),
    SPH_C32(0x53a42fff), SPH_C32(0x9f773f8c), SPH_C32(0x201830a3),
    SPH_C32(0xbe0f7f6c) },
  { SPH_C32(0x62b10035), SPH_C32(0x23df0000), SPH_C32(0xc3cf0000),
    SPH_C32(0x9aa50000), SPH_C32(0x0bb91806), SPH_C32(0x9e8dd5fe),
    SPH_C32(0xd26132f2), SPH_C32(0x59333b3d), SPH_C32(0x5af801b8),
    SPH_C32(0xc5bf8000), SPH_C32(0xda8b0000), SPH_C32(0x67e70000),
    SPH_C32(0x692f4202), SPH_C32(0x74bd917f), SPH_C32(0x0c75772c),
    SPH_C32(0x128113e4) },
  { SPH_C32(0x324e0031), SPH_C32(0x66ab4000), SPH_C32(0xfe340000),
    SPH_C32(0x83430000), SPH_C32(0x10054e00), SPH_C32(0x7fffaea3),
    SPH_C32(0x33c9fe64), SPH_C32(0x2228ed84), SPH_C32(0xac7801bd),
    SPH_C32(0xf1fc4000), SPH_C32(0xfe8c0000), SPH_C32(0xe8da0000),
    SPH_C32(0x481879f9), SPH_C32(0x7e0544d1), SPH_C32(0xc1b0fc35),
    SPH_C32(0xc514a9d5) },
  { SPH_C32(0xc4ce0034), SPH_C32(0x52e88000), SPH_C32(0xda330000),
    SPH_C32(0x0c7e0000), SPH_C32(0x313275fb), SPH_C32(0x75477b0d),
    SPH_C32(0xfe0c757d), SPH_C32(0xf5bd57b5), SPH_C32(0x0a0701bc),
    SPH_C32(0x80cbc000), SPH_C32(0xe7700000), SPH_C32(0x7e010000),
    SPH_C32(0x72931404), SPH_C32(0x95cfea22), SPH_C32(0xedddbbba),
    SPH_C32(0x699ac55d) },
  { SPH_C32(0x63440039), SPH_C32(0xd8a00000), SPH_C32(0x241e0000),
    SPH_C32(0x110a0000), SPH_C32(0x281b3a54), SPH_C32(0x6cdd36ea),
    SPH_C32(0x652348a5), SPH_C32(0x10b01916), SPH_C32(0x28ed01b9),
    SPH_C32(0x3940c000), SPH_C32(0x66d80000), SPH_C32(0xbb150000),
    SPH_C32(0xafea6d85), SPH_C32(0x56c3b9e0), SPH_C32(0xb82ea6a7),
    SPH_C32(0x4949bc4c) },
  { SPH_C32(0x95c4003c), SPH_C32(0xece3c000), SPH_C32(0x00190000),
    SPH_C32(0x9e370000), SPH_C32(0x092c01af), SPH_C32(0x6665e344),
    SPH_C32(0xa8e6c3bc), SPH_C32(0xc725a327), SPH_C32(0x8e9201b8),
    SPH_C32(0x48774000), SPH_C32(0x7f240000), SPH_C32(0x2dce0000),
    SPH_C32(0x95610078), SPH_C32(0xbd091713), SPH_C32(0x9443e128),
    SPH_C32(0xe5c7d0c4) },
  { SPH_C32(0xc53b0038), SPH_C32(0xa9978000), SPH_C32(0x3de20000),
    SPH_C32(0x87d10000), SPH_C32(0x129057a9), SPH_C32(0x87179819),
    SPH_C32(0x494e0f2a), SPH_C32(0xbc3e759e), SPH_C32(0x781201bd),
    SPH_C32(0x7c348000), SPH_C32(0x5b230000), SPH_C32(0xa2f30000),
    SPH_C32(0xb4563b83), SPH_C32(0xb7b1c2bd), SPH_C32(0x59866a31),
    SPH_C32(0x32526af5) },
  { SPH_C32(0x33bb003d), SPH_C32(0x9dd44000), SPH_C32(0x19e50000),
    SPH_C32(0x08ec0000), SPH_C32(0x33a76c52), SPH_C32(0x8daf4db7),
    SPH_C32(0x848b8433), SPH_C32(0x6babcfaf), SPH_C32(0xde6d01bc),
    SPH_C32(0x0d030000), SPH_C32(0x42df0000), SPH_C32(0x34280000),
    SPH_C32(0x8edd567e), SPH_C32(0x5c7b6c4e), SPH_C32(0x75eb2dbe),
    SPH_C32(0x9edc067d) },
  { SPH_C32(0x371f00c0), SPH_C32(0x6b0e0000), SPH_C32(0xb7d50000),
    SPH_C32(0x6ba50000), SPH_C32(0x5ff71f0b), SPH_C32(0x070a6a19),
    SPH_C32(0x8c51e2f1), SPH_C32(0xb6d737e7), SPH_C32(0x2bf401e0),
    SPH_C32(0x60640000), SPH_C32(0xb1ab0000), SPH_C32(0xbc980000),
    SPH_C32(0xefeb0a94), SPH_C32(0xc894f143), SPH_C32(0x5e0d273b),
    SPH_C32(0x5d6b3122) },
  { SPH_C32(0xc19f00c5), SPH_C32(0x5f4dc000), SPH_C32(0x93d20000),
    SPH_C32(0xe4980000), SPH_C32(0x7ec024f0), SPH_C32(0x0db2bfb7),
    SPH_C32(0x419469e8), SPH_C32(0x61428dd6), SPH_C32(0x8d8b01e1),
    SPH_C32(0x11538000), SPH_C32(0xa8570000), SPH_C32(0x2a430000),
    SPH_C32(0xd5606769), SPH_C32(0x235e5fb0), SPH_C32(0x726060b4),
    SPH_C32(0xf1e55daa) },
  { SPH_C32(0x916000c1), SPH_C32(0x1a398000), SPH_C32(0xae290000),
    SPH_C32(0xfd7e0000), SPH_C32(0x657c72f6), SPH_C32(0xecc0c4ea),
    SPH_C32(0xa03ca57e), SPH_C32(0x1a595b6f), SPH_C32(0x7b0b01e4),
    SPH_C32(0x25104000), SPH_C32(0x8c500000), SPH_C32(0xa57e0000),
    SPH_C32(0xf4575c92), SPH_C32(0x29e68a1e), SPH_C32(0xbfa5ebad),
    SPH_C32(0x2670e79b) },
  { SPH_C32(0x67e000c4), SPH_C32(0x2e7a4000), SPH_C32(0x8a2e0000),
    SPH_C32(0x72430000), SPH_C32(0x444b490d), SPH_C32(0xe6781144),
    SPH_C32(0x6df92e67), SPH_C32(0xcdcce15e), SPH_C32(0xdd7401e5),
    SPH_C32(0x5427c000), SPH_C32(0x95ac0000), SPH_C32(0x33a50000),
    SPH_C32(0xcedc316f), SPH_C32(0xc22c24ed), SPH_C32(0x93c8ac22),
    SPH_C32(0x8afe8b13) },
  { SPH_C32(0xc06a00c9), SPH_C32(0xa432c000), SPH_C32(0x74030000),
    SPH_C32(0x6f370000), SPH_C32(0x5d6206a2), SPH_C32(0xffe25ca3),
    SPH_C32(0xf6d613bf), SPH_C32(0x28c1affd), SPH_C32(0xff9e01e0),
    SPH_C32(0xedacc000), SPH_C32(0x14040000), SPH_C32(0xf6b10000),
    SPH_C32(0x13a548ee), SPH_C32(0x0120772f), SPH_C32(0xc63bb13f),
    SPH_C32(0xaa2df202) },
  { SPH_C32(0x36ea00cc), SPH_C32(0x90710000), SPH_C32(0x50040000),
    SPH_C32(0xe00a0000), SPH_C32(0x7c553d59), SPH_C32(0xf55a890d),
    SPH_C32(0x3b1398a6), SPH_C32(0xff5415cc), SPH_C32(0x59e101e1),
    SPH_C32(0x9c9b4000), SPH_C32(0x0df80000), SPH_C32(0x606a0000),
    SPH_C32(0x292e2513), SPH_C32(0xeaead9dc), SPH_C32(0xea56f6b0),
    SPH_C32(0x06a39e8a) },
  { SPH_C32(0x661500c8), SPH_C32(0xd5054000), SPH_C32(0x6dff0000),
    SPH_C32(0xf9ec0000), SPH_C32(0x67e96b5f), SPH_C32(0x1428f250),
    SPH_C32(0xdabb5430), SPH_C32(0x844fc375), SPH_C32(0xaf6101e4),
    SPH_C32(0xa8d88000), SPH_C32(0x29ff0000), SPH_C32(0xef570000),
    SPH_C32(0x08191ee8), SPH_C32(0xe0520c72), SPH_C32(0x27937da9),
    SPH_C32(0xd13624bb) },
  { SPH_C32(0x909500cd), SPH_C32(0xe1468000), SPH_C32(0x49f80000),
    SPH_C32(0x76d10000), SPH_C32(0x46de50a4), SPH_C32(0x1e9027fe),
    SPH_C32(0x177edf29), SPH_C32(0x53da7944), SPH_C32(0x091e01e5),
    SPH_C32(0xd9ef0000), SPH_C32(0x30030000), SPH_C32(0x798c0000),
    SPH_C32(0x32927315), SPH_C32(0x0b98a281), SPH_C32(0x0bfe3a26),
    SPH_C32(0x7db84833) },
  { SPH_C32(0xe37500c0), SPH_C32(0xe6c6c000), SPH_C32(0x127a0000),
    SPH_C32(0x218c0000), SPH_C32(0xa3b95d71), SPH_C32(0xcebeec75),
    SPH_C32(0x146774f5), SPH_C32(0x4191f4c7), SPH_C32(0x08eb01e9),
    SPH_C32(0x22900000), SPH_C32(0xd7d20000), SPH_C32(0xf2230000),
    SPH_C32(0x11305147), SPH_C32(0xf9c84195), SPH_C32(0xbcbc4071),
    SPH_C32(0x343b6a18) },
  { SPH_C32(0x15f500c5), SPH_C32(0xd2850000), SPH_C32(0x367d0000),
    SPH_C32(0xaeb10000), SPH_C32(0x828e668a), SPH_C32(0xc40639db),
    SPH_C32(0xd9a2ffec), SPH_C32(0x96044ef6), SPH_C32(0xae9401e8),
    SPH_C32(0x53a78000), SPH_C32(0xce2e0000), SPH_C32(0x64f80000),
    SPH_C32(0x2bbb3cba), SPH_C32(0x1202ef66), SPH_C32(0x90d107fe),
    SPH_C32(0x98b50690) },
  { SPH_C32(0x450a00c1), SPH_C32(0x97f14000), SPH_C32(0x0b860000),
    SPH_C32(0xb7570000), SPH_C32(0x9932308c), SPH_C32(0x25744286),
    SPH_C32(0x380a337a), SPH_C32(0xed1f984f), SPH_C32(0x581401ed),
    SPH_C32(0x67e44000), SPH_C32(0xea290000), SPH_C32(0xebc50000),
    SPH_C32(0x0a8c0741), SPH_C32(0x18ba3ac8), SPH_C32(0x5d148ce7),
    SPH_C32(0x4f20bca1) },
  { SPH_C32(0xb38a00c4), SPH_C32(0xa3b28000), SPH_C32(0x2f810000),
    SPH_C32(0x386a0000), SPH_C32(0xb8050b77), SPH_C32(0x2fcc9728),
    SPH_C32(0xf5cfb863), SPH_C32(0x3a8a227e), SPH_C32(0xfe6b01ec),
    SPH_C32(0x16d3c000), SPH_C32(0xf3d50000), SPH_C32(0x7d1e0000),
    SPH_C32(0x30076abc), SPH_C32(0xf370943b), SPH_C32(0x7179cb68),
    SPH_C32(0xe3aed029) },
  { SPH_C32(0x140000c9), SPH_C32(0x29fa0000), SPH_C32(0xd1ac0000),
    SPH_C32(0x251e0000), SPH_C32(0xa12c44d8), SPH_C32(0x3656dacf),
    SPH_C32(0x6ee085bb), SPH_C32(0xdf876cdd), SPH_C32(0xdc8101e9),
    SPH_C32(0xaf58c000), SPH_C32(0x727d0000), SPH_C32(0xb80a0000),
    SPH_C32(0xed7e133d), SPH_C32(0x307cc7f9), SPH_C32(0x248ad675),
    SPH_C32(0xc37da938) },
  { SPH_C32(0xe28000cc), SPH_C32(0x1db9c000), SPH_C32(0xf5ab0000),
    SPH_C32(0xaa230000), SPH_C32(0x801b7f23), SPH_C32(0x3cee0f61),
    SPH_C32(0xa3250ea2), SPH_C32(0x0812d6ec), SPH_C32(0x7afe01e8),
    SPH_C32(0xde6f4000), SPH_C32(0x6b810000), SPH_C32(0x2ed10000),
    SPH_C32(0xd7f57ec0), SPH_C32(0xdbb6690a), SPH_C32(0x08e791fa),
    SPH_C32(0x6ff3c5b0) },
  { SPH_C32(0xb27f00c8), SPH_C32(0x58cd8000), SPH_C32(0xc8500000),
    SPH_C32(0xb3c50000), SPH_C32(0x9ba72925), SPH_C32(0xdd9c743c),
    SPH_C32(0x428dc234), SPH_C32(0x73090055), SPH_C32(0x8c7e01ed),
    SPH_C32(0xea2c8000), SPH_C32(0x4f860000), SPH_C32(0xa1ec0000),
    SPH_C32(0xf6c2453b), SPH_C32(0xd10ebca4), SPH_C32(0xc5221ae3),
    SPH_C32(0xb8667f81) },
  { SPH_C32(0x44ff00cd), SPH_C32(0x6c8e4000), SPH_C32(0xec570000),
    SPH_C32(0x3cf80000), SPH_C32(0xba9012de), SPH_C32(0xd724a192),
    SPH_C32(0x8f48492d), SPH_C32(0xa49cba64), SPH_C32(0x2a0101ec),
    SPH_C32(0x9b1b0000), SPH_C32(0x567a0000), SPH_C32(0x37370000),
    SPH_C32(0xcc4928c6), SPH_C32(0x3ac41257), SPH_C32(0xe94f5d6c),
    SPH_C32(0x14e81309) },
  { SPH_C32(0x5cb00110), SPH_C32(0x913e0000), SPH_C32(0x44190000),
    SPH_C32(0x888c0000), SPH_C32(0x66dc7418), SPH_C32(0x921f1d66),
    SPH_C32(0x55ceea25), SPH_C32(0x925c44e9), SPH_C32(0xe8870170),
    SPH_C32(0x9d720000), SPH_C32(0x12db0000), SPH_C32(0xd4220000),
    SPH_C32(0xf2886b27), SPH_C32(0xa921e543), SPH_C32(0x4ef8b518),
    SPH_C32(0x618813b1) },
  { SPH_C32(0xaa300115), SPH_C32(0xa57dc000), SPH_C32(0x601e0000),
    SPH_C32(0x07b10000), SPH_C32(0x47eb4fe3), SPH_C32(0x98a7c8c8),
    SPH_C32(0x980b613c), SPH_C32(0x45c9fed8), SPH_C32(0x4ef80171),
    SPH_C32(0xec458000), SPH_C32(0x0b270000), SPH_C32(0x42f90000),
    SPH_C32(0xc80306da), SPH_C32(0x42eb4bb0), SPH_C32(0x6295f297),
    SPH_C32(0xcd067f39) },
  { SPH_C32(0xfacf0111), SPH_C32(0xe0098000), SPH_C32(0x5de50000),
    SPH_C32(0x1e570000), SPH_C32(0x5c5719e5), SPH_C32(0x79d5b395),
    SPH_C32(0x79a3adaa), SPH_C32(0x3ed22861), SPH_C32(0xb8780174),
    SPH_C32(0xd8064000), SPH_C32(0x2f200000), SPH_C32(0xcdc40000),
    SPH_C32(0xe9343d21), SPH_C32(0x48539e1e), SPH_C32(0xaf50798e),
    SPH_C32(0x1a93c508) },
  { SPH_C32(0x0c4f0114), SPH_C32(0xd44a4000), SPH_C32(0x79e20000),
    SPH_C32(0x916a0000), SPH_C32(0x7d60221e), SPH_C32(0x736d663b),
    SPH_C32(0xb46626b3), SPH_C32(0xe9479250), SPH_C32(0x1e070175),
    SPH_C32(0xa931c000), SPH_C32(0x36dc0000), SPH_C32(0x5b1f0000),
    SPH_C32(0xd3bf50dc), SPH_C32(0xa39930ed), SPH_C32(0x833d3e01),
    SPH_C32(0xb61da980) },
  { SPH_C32(0xabc50119), SPH_C32(0x5e02c000), SPH_C32(0x87cf0000),
    SPH_C32(0x8c1e0000), SPH_C32(0x64496db1), SPH_C32(0x6af72bdc),
    SPH_C32(0x2f491b6b), SPH_C32(0x0c4adcf3), SPH_C32(0x3ced0170),
    SPH_C32(0x10bac000), SPH_C32(0xb7740000), SPH_C32(0x9e0b0000),
    SPH_C32(0x0ec6295d), SPH_C32(0x6095632f), SPH_C32(0xd6ce231c),
    SPH_C32(0x96ced091) },
  { SPH_C32(0x5d45011c), SPH_C32(0x6a410000), SPH_C32(0xa3c80000),
    SPH_C32(0x03230000), SPH_C32(0x457e564a), SPH_C32(0x604ffe72),
    SPH_C32(0xe28c9072), SPH_C32(0xdbdf66c2), SPH_C32(0x9a920171),
    SPH_C32(0x618d4000), SPH_C32(0xae880000), SPH_C32(0x08d00000),
    SPH_C32(0x344d44a0), SPH_C32(0x8b5fcddc), SPH_C32(0xfaa36493),
    SPH_C32(0x3a40bc19) },
  { SPH_C32(0x0dba0118), SPH_C32(0x2f354000), SPH_C32(0x9e330000),
    SPH_C32(0x1ac50000), SPH_C32(0x5ec2004c), SPH_C32(0x813d852f),
    SPH_C32(0x03245ce4), SPH_C32(0xa0c4b07b), SPH_C32(0x6c120174),
    SPH_C32(0x55ce8000), SPH_C32(0x8a8f0000), SPH_C32(0x87ed0000),
    SPH_C32(0x157a7f5b), SPH_C32(0x81e71872), SPH_C32(0x3766ef8a),
    SPH_C32(0xedd50628) },
  { SPH_C32(0xfb3a011d), SPH_C32(0x1b768000), SPH_C32(0xba340000),
    SPH_C32(0x95f80000), SPH_C32(0x7ff53bb7), SPH_C32(0x8b855081),
    SPH_C32(0xcee1d7fd), SPH_C32(0x77510a4a), SPH_C32(0xca6d0175),
    SPH_C32(0x24f90000), SPH_C32(0x93730000), SPH_C32(0x11360000),
    SPH_C32(0x2ff112a6), SPH_C32(0x6a2db681), SPH_C32(0x1b0ba805),
    SPH_C32(0x415b6aa0) },
  { SPH_C32(0x88da0110), SPH_C32(0x1cf6c000), SPH_C32(0xe1b60000),
    SPH_C32(0xc2a50000), SPH_C32(0x9a923662), SPH_C32(0x5bab9b0a),
    SPH_C32(0xcdf87c21), SPH_C32(0x651a87c9), SPH_C32(0xcb980179),
    SPH_C32(0xdf860000), SPH_C32(0x74a20000), SPH_C32(0x9a990000),
    SPH_C32(0x0c5330f4), SPH_C32(0x987d5595), SPH_C32(0xac49d252),
    SPH_C32(0x08d8488b) },
  { SPH_C32(0x7e5a0115), SPH_C32(0x28b50000), SPH_C32(0xc5b10000),
    SPH_C32(0x4d980000), SPH_C32(0xbba50d99), SPH_C32(0x51134ea4),
    SPH_C32(0x003df738), SPH_C32(0xb28f3df8), SPH_C32(0x6de70178),
    SPH_C32(0xaeb18000), SPH_C32(0x6d5e0000), SPH_C32(0x0c420000),
    SPH_C32(0x36d85d09), SPH_C32(0x73b7fb66), SPH_C32(0x802495dd),
    SPH_C32(0xa4562403) },
  { SPH_C32(0x2ea50111), SPH_C32(0x6dc14000), SPH_C32(0xf84a0000),
    SPH_C32(0x547e0000), SPH_C32(0xa0195b9f), SPH_C32(0xb06135f9),
    SPH_C32(0xe1953bae), SPH_C32(0xc994eb41), SPH_C32(0x9b67017d),
    SPH_C32(0x9af24000), SPH_C32(0x49590000), SPH_C32(0x837f0000),
    SPH_C32(0x17ef66f2), SPH_C32(0x790f2ec8), SPH_C32(0x4de11ec4),
    SPH_C32(0x73c39e32) },
  { SPH_C32(0xd8250114), SPH_C32(0x59828000), SPH_C32(0xdc4d0000),
    SPH_C32(0xdb430000), SPH_C32(0x812e6064), SPH_C32(0xbad9e057),
    SPH_C32(0x2c50b0b7), SPH_C32(0x1e015170), SPH_C32(0x3d18017c),
    SPH_C32(0xebc5c000), SPH_C32(0x50a50000), SPH_C32(0x15a40000),
    SPH_C32(0x2d640b0f), SPH_C32(0x92c5803b), SPH_C32(0x618c594b),
    SPH_C32(0xdf4df2ba) },
  { SPH_C32(0x7faf0119), SPH_C32(0xd3ca0000), SPH_C32(0x22600000),
    SPH_C32(0xc6370000), SPH_C32(0x98072fcb), SPH_C32(0xa343adb0),
    SPH_C32(0xb77f8d6f), SPH_C32(0xfb0c1fd3), SPH_C32(0x1ff20179),
    SPH_C32(0x524ec000), SPH_C32(0xd10d0000), SPH_C32(0xd0b00000),
    SPH_C32(0xf01d728e), SPH_C32(0x51c9d3f9), SPH_C32(0x347f4456),
    SPH_C32(0xff9e8bab) },
  { SPH_C32(0x892f011c), SPH_C32(0xe789c000), SPH_C32(0x06670000),
    SPH_C32(0x490a0000), SPH_C32(0xb9301430), SPH_C32(0xa9fb781e),
    SPH_C32(0x7aba0676), SPH_C32(0x2c99a5e2), SPH_C32(0xb98d0178),
    SPH_C32(0x23794000), SPH_C32(0xc8f10000), SPH_C32(0x466b0000),
    SPH_C32(0xca961f73), SPH_C32(0xba037d0a), SPH_C32(0x181203d9),
    SPH_C32(0x5310e723) },
  { SPH_C32(0xd9d00118), SPH_C32(0xa2fd8000), SPH_C32(0x3b9c0000),
    SPH_C32(0x50ec0000), SPH_C32(0xa28c4236), SPH_C32(0x48890343),
    SPH_C32(0x9b12cae0), SPH_C32(0x5782735b), SPH_C32(0x4f0d017d),
    SPH_C32(0x173a8000), SPH_C32(0xecf60000), SPH_C32(0xc9560000),
    SPH_C32(0xeba12488), SPH_C32(0xb0bba8a4), SPH_C32(0xd5d788c0),
    SPH_C32(0x84855d12) },
  { SPH_C32(0x2f50011d), SPH_C32(0x96be4000), SPH_C32(0x1f9b0000),
    SPH_C32(0xdfd10000), SPH_C32(0x83bb79cd), SPH_C32(0x4231d6ed),
    SPH_C32(0x56d741f9), SPH_C32(0x8017c96a), SPH_C32(0xe972017c),
    SPH_C32(0x660d0000), SPH_C32(0xf50a0000), SPH_C32(0x5f8d0000),
    SPH_C32(0xd12a4975), SPH_C32(0x5b710657), SPH_C32(0xf9bacf4f),
    SPH_C32(0x280b319a) },
  { SPH_C32(0x2bf401e0), SPH_C32(0x60640000), SPH_C32(0xb1ab0000),
    SPH_C32(0xbc980000), SPH_C32(0xefeb0a94), SPH_C32(0xc894f143),
    SPH_C32(0x5e0d273b), SPH_C32(0x5d6b3122), SPH_C32(0x1ceb0120),
    SPH_C32(0x0b6a0000), SPH_C32(0x067e0000), SPH_C32(0xd73d0000),
    SPH_C32(0xb01c159f), SPH_C32(0xcf9e9b5a), SPH_C32(0xd25cc5ca),
    SPH_C32(0xebbc06c5) },
  { SPH_C32(0xdd7401e5), SPH_C32(0x5427c000), SPH_C32(0x95ac0000),
    SPH_C32(0x33a50000), SPH_C32(0xcedc316f), SPH_C32(0xc22c24ed),
    SPH_C32(0x93c8ac22), SPH_C32(0x8afe8b13), SPH_C32(0xba940121),
    SPH_C32(0x7a5d8000), SPH_C32(0x1f820000), SPH_C32(0x41e60000),
    SPH_C32(0x8a977862), SPH_C32(0x245435a9), SPH_C32(0xfe318245),
    SPH_C32(0x47326a4d) },
  { SPH_C32(0x8d8b01e1), SPH_C32(0x11538000), SPH_C32(0xa8570000),
    SPH_C32(0x2a430000), SPH_C32(0xd5606769), SPH_C32(0x235e5fb0),
    SPH_C32(0x726060b4), SPH_C32(0xf1e55daa), SPH_C32(0x4c140124),
    SPH_C32(0x4e1e4000), SPH_C32(0x3b850000), SPH_C32(0xcedb0000),
    SPH_C32(0xaba04399), SPH_C32(0x2eece007), SPH_C32(0x33f4095c),
    SPH_C32(0x90a7d07c) },
  { SPH_C32(0x7b0b01e4), SPH_C32(0x25104000), SPH_C32(0x8c500000),
    SPH_C32(0xa57e0000), SPH_C32(0xf4575c92), SPH_C32(0x29e68a1e),
    SPH_C32(0xbfa5ebad), SPH_C32(0x2670e79b), SPH_C32(0xea6b0125),
    SPH_C32(0x3f29c000), SPH_C32(0x22790000), SPH_C32(0x58000000),
    SPH_C32(0x912b2e64), SPH_C32(0xc5264ef4), SPH_C32(0x1f994ed3),
    SPH_C32(0x3c29bcf4) },
  { SPH_C32(0xdc8101e9), SPH_C32(0xaf58c000), SPH_C32(0x727d0000),
    SPH_C32(0xb80a0000), SPH_C32(0xed7e133d), SPH_C32(0x307cc7f9),
    SPH_C32(0x248ad675), SPH_C32(0xc37da938), SPH_C32(0xc8810120),
    SPH_C32(0x86a2c000), SPH_C32(0xa3d10000), SPH_C32(0x9d140000),
    SPH_C32(0x4c5257e5), SPH_C32(0x062a1d36), SPH_C32(0x4a6a53ce),
    SPH_C32(0x1cfac5e5) },
  { SPH_C32(0x2a0101ec), SPH_C32(0x9b1b0000), SPH_C32(0x567a0000),
    SPH_C32(0x37370000), SPH_C32(0xcc4928c6), SPH_C32(0x3ac41257),
    SPH_C32(0xe94f5d6c), SPH_C32(0x14e81309), SPH_C32(0x6efe0121),
    SPH_C32(0xf7954000), SPH_C32(0xba2d0000), SPH_C32(0x0bcf0000),
    SPH_C32(0x76d93a18), SPH_C32(0xede0b3c5), SPH_C32(0x66071441),
    SPH_C32(0xb074a96d) },
  { SPH_C32(0x7afe01e8), SPH_C32(0xde6f4000), SPH_C32(0x6b810000),
    SPH_C32(0x2ed10000), SPH_C32(0xd7f57ec0), SPH_C32(0xdbb6690a),
    SPH_C32(0x08e791fa), SPH_C32(0x6ff3c5b0), SPH_C32(0x987e0124),
    SPH_C32(0xc3d68000), SPH_C32(0x9e2a0000), SPH_C32(0x84f20000),
    SPH_C32(0x57ee01e3), SPH_C32(0xe758666b), SPH_C32(0xabc29f58),
    SPH_C32(0x67e1135c) },
  { SPH_C32(0x8c7e01ed), SPH_C32(0xea2c8000), SPH_C32(0x4f860000),
    SPH_C32(0xa1ec0000), SPH_C32(0xf6c2453b), SPH_C32(0xd10ebca4),
    SPH_C32(0xc5221ae3), SPH_C32(0xb8667f81), SPH_C32(0x3e010125),
    SPH_C32(0xb2e10000), SPH_C32(0x87d60000), SPH_C32(0x12290000),
    SPH_C32(0x6d656c1e), SPH_C32(0x0c92c898), SPH_C32(0x87afd8d7),
    SPH_C32(0xcb6f7fd4) },
  { SPH_C32(0xff9e01e0), SPH_C32(0xedacc000), SPH_C32(0x14040000),
    SPH_C32(0xf6b10000), SPH_C32(0x13a548ee), SPH_C32(0x0120772f),
    SPH_C32(0xc63bb13f), SPH_C32(0xaa2df202), SPH_C32(0x3ff40129),
    SPH_C32(0x499e0000), SPH_C32(0x60070000), SPH_C32(0x99860000),
    SPH_C32(0x4ec74e4c), SPH_C32(0xfec22b8c), SPH_C32(0x30eda280),
    SPH_C32(0x82ec5dff) },
  { SPH_C32(0x091e01e5), SPH_C32(0xd9ef0000), SPH_C32(0x30030000),
    SPH_C32(0x798c0000), SPH_C32(0x32927315), SPH_C32(0x0b98a281),
    SPH_C32(0x0bfe3a26), SPH_C32(0x7db84833), SPH_C32(0x998b0128),
    SPH_C32(0x38a98000), SPH_C32(0x79fb0000), SPH_C32(0x0f5d0000),
    SPH_C32(0x744c23b1), SPH_C32(0x1508857f), SPH_C32(0x1c80e50f),
    SPH_C32(0x2e623177) },
  { SPH_C32(0x59e101e1), SPH_C32(0x9c9b4000), SPH_C32(0x0df80000),
    SPH_C32(0x606a0000), SPH_C32(0x292e2513), SPH_C32(0xeaead9dc),
    SPH_C32(0xea56f6b0), SPH_C32(0x06a39e8a), SPH_C32(0x6f0b012d),
    SPH_C32(0x0cea4000), SPH_C32(0x5dfc0000), SPH_C32(0x80600000),
    SPH_C32(0x557b184a), SPH_C32(0x1fb050d1), SPH_C32(0xd1456e16),
    SPH_C32(0xf9f78b46) },
  { SPH_C32(0xaf6101e4), SPH_C32(0xa8d88000), SPH_C32(0x29ff0000),
    SPH_C32(0xef570000), SPH_C32(0x08191ee8), SPH_C32(0xe0520c72),
    SPH_C32(0x27937da9), SPH_C32(0xd13624bb), SPH_C32(0xc974012c),
    SPH_C32(0x7dddc000), SPH_C32(0x44000000), SPH_C32(0x16bb0000),
    SPH_C32(0x6ff075b7), SPH_C32(0xf47afe22), SPH_C32(0xfd282999),
    SPH_C32(0x5579e7ce) },
  { SPH_C32(0x08eb01e9), SPH_C32(0x22900000), SPH_C32(0xd7d20000),
    SPH_C32(0xf2230000), SPH_C32(0x11305147), SPH_C32(0xf9c84195),
    SPH_C32(0xbcbc4071), SPH_C32(0x343b6a18), SPH_C32(0xeb9e0129),
    SPH_C32(0xc456c000), SPH_C32(0xc5a80000), SPH_C32(0xd3af0000),
    SPH_C32(0xb2890c36), SPH_C32(0x3776ade0), SPH_C32(0xa8db3484),
    SPH_C32(0x75aa9edf) },
  { SPH_C32(0xfe6b01ec), SPH_C32(0x16d3c000), SPH_C32(0xf3d50000),
    SPH_C32(0x7d1e0000), SPH_C32(0x30076abc), SPH_C32(0xf370943b),
    SPH_C32(0x7179cb68), SPH_C32(0xe3aed029), SPH_C32(0x4de10128),
    SPH_C32(0xb5614000), SPH_C32(0xdc540000), SPH_C32(0x45740000),
    SPH_C32(0x880261cb), SPH_C32(0xdcbc0313), SPH_C32(0x84b6730b),
    SPH_C32(0xd924f257) },
  { SPH_C32(0xae9401e8), SPH_C32(0x53a78000), SPH_C32(0xce2e0000),
    SPH_C32(0x64f80000), SPH_C32(0x2bbb3cba), SPH_C32(0x1202ef66),
    SPH_C32(0x90d107fe), SPH_C32(0x98b50690), SPH_C32(0xbb61012d),
    SPH_C32(0x81228000), SPH_C32(0xf8530000), SPH_C32(0xca490000),
    SPH_C32(0xa9355a30), SPH_C32(0xd604d6bd), SPH_C32(0x4973f812),
    SPH_C32(0x0eb14866) },
  { SPH_C32(0x581401ed), SPH_C32(0x67e44000), SPH_C32(0xea290000),
    SPH_C32(0xebc50000), SPH_C32(0x0a8c0741), SPH_C32(0x18ba3ac8),
    SPH_C32(0x5d148ce7), SPH_C32(0x4f20bca1), SPH_C32(0x1d1e012c),
    SPH_C32(0xf0150000), SPH_C32(0xe1af0000), SPH_C32(0x5c920000),
    SPH_C32(0x93be37cd), SPH_C32(0x3dce784e), SPH_C32(0x651ebf9d),
    SPH_C32(0xa23f24ee) },
  { SPH_C32(0xa8dc0140), SPH_C32(0x07260000), SPH_C32(0x50bc0000),
    SPH_C32(0x8b930000), SPH_C32(0x24480aa0), SPH_C32(0xf4a0637f),
    SPH_C32(0xc96a9af7), SPH_C32(0x1868519d), SPH_C32(0x6baf01d0),
    SPH_C32(0xfa300000), SPH_C32(0xf3cc0000), SPH_C32(0xe3290000),
    SPH_C32(0x392b6b13), SPH_C32(0x9515777f), SPH_C32(0xd99f08d4),
    SPH_C32(0x248b730e) },
  { SPH_C32(0x5e5c0145), SPH_C32(0x3365c000), SPH_C32(0x74bb0000),
    SPH_C32(0x04ae0000), SPH_C32(0x057f315b), SPH_C32(0xfe18b6d1),
    SPH_C32(0x04af11ee), SPH_C32(0xcffdebac), SPH_C32(0xcdd001d1),
    SPH_C32(0x8b078000), SPH_C32(0xea300000), SPH_C32(0x75f20000),
    SPH_C32(0x03a006ee), SPH_C32(0x7edfd98c), SPH_C32(0xf5f24f5b),
    SPH_C32(0x88051f86) },
  { SPH_C32(0x0ea30141), SPH_C32(0x76118000), SPH_C32(0x49400000),
    SPH_C32(0x1d480000), SPH_C32(0x1ec3675d), SPH_C32(0x1f6acd8c),
    SPH_C32(0xe507dd78), SPH_C32(0xb4e63d15), SPH_C32(0x3b5001d4),
    SPH_C32(0xbf444000), SPH_C32(0xce370000), SPH_C32(0xfacf0000),
    SPH_C32(0x22973d15), SPH_C32(0x74670c22), SPH_C32(0x3837c442),
    SPH_C32(0x5f90a5b7) },
  { SPH_C32(0xf8230144), SPH_C32(0x42524000), SPH_C32(0x6d470000),
    SPH_C32(0x92750000), SPH_C32(0x3ff45ca6), SPH_C32(0x15d21822),
    SPH_C32(0x28c25661), SPH_C32(0x63738724), SPH_C32(0x9d2f01d5),
    SPH_C32(0xce73c000), SPH_C32(0xd7cb0000), SPH_C32(0x6c140000),
    SPH_C32(0x181c50e8), SPH_C32(0x9fada2d1), SPH_C32(0x145a83cd),
    SPH_C32(0xf31ec93f) },
  { SPH_C32(0x5fa90149), SPH_C32(0xc81ac000), SPH_C32(0x936a0000),
    SPH_C32(0x8f010000), SPH_C32(0x26dd1309), SPH_C32(0x0c4855c5),
    SPH_C32(0xb3ed6bb9), SPH_C32(0x867ec987), SPH_C32(0xbfc501d0),
    SPH_C32(0x77f8c000), SPH_C32(0x56630000), SPH_C32(0xa9000000),
    SPH_C32(0xc5652969), SPH_C32(0x5ca1f113), SPH_C32(0x41a99ed0),
    SPH_C32(0xd3cdb02e) },
  { SPH_C32(0xa929014c), SPH_C32(0xfc590000), SPH_C32(0xb76d0000),
    SPH_C32(0x003c0000), SPH_C32(0x07ea28f2), SPH_C32(0x06f0806b),
    SPH_C32(0x7e28e0a0), SPH_C32(0x51eb73b6), SPH_C32(0x19ba01d1),
    SPH_C32(0x06cf4000), SPH_C32(0x4f9f0000), SPH_C32(0x3fdb0000),
    SPH_C32(0xffee4494), SPH_C32(0xb76b5fe0), SPH_C32(0x6dc4d95f),
    SPH_C32(0x7f43dca6) },
  { SPH_C32(0xf9d60148), SPH_C32(0xb92d4000), SPH_C32(0x8a960000),
    SPH_C32(0x19da0000), SPH_C32(0x1c567ef4), SPH_C32(0xe782fb36),
    SPH_C32(0x9f802c36), SPH_C32(0x2af0a50f), SPH_C32(0xef3a01d4),
    SPH_C32(0x328c8000), SPH_C32(0x6b980000), SPH_C32(0xb0e60000),
    SPH_C32(0xded97f6f), SPH_C32(0xbdd38a4e), SPH_C32(0xa0015246),
    SPH_C32(0xa8d66697) },
  { SPH_C32(0x0f56014d), SPH_C32(0x8d6e8000), SPH_C32(0xae910000),
    SPH_C32(0x96e70000), SPH_C32(0x3d61450f), SPH_C32(0xed3a2e98),
    SPH_C32(0x5245a72f), SPH_C32(0xfd651f3e), SPH_C32(0x494501d5),
    SPH_C32(0x43bb0000), SPH_C32(0x72640000), SPH_C32(0x263d0000),
    SPH_C32(0xe4521292), SPH_C32(0x561924bd), SPH_C32(0x8c6c15c9),
    SPH_C32(0x04580a1f) },
  { SPH_C32(0x7cb60140), SPH_C32(0x8aeec000), SPH_C32(0xf5130000),
    SPH_C32(0xc1ba0000), SPH_C32(0xd80648da), SPH_C32(0x3d14e513),
    SPH_C32(0x515c0cf3), SPH_C32(0xef2e92bd), SPH_C32(0x48b001d9),
    SPH_C32(0xb8c40000), SPH_C32(0x95b50000), SPH_C32(0xad920000),
    SPH_C32(0xc7f030c0), SPH_C32(0xa449c7a9), SPH_C32(0x3b2e6f9e),
    SPH_C32(0x4ddb2834) },
  { SPH_C32(0x8a360145), SPH_C32(0xbead0000), SPH_C32(0xd1140000),
    SPH_C32(0x4e870000), SPH_C32(0xf9317321), SPH_C32(0x37ac30bd),
    SPH_C32(0x9c9987ea), SPH_C32(0x38bb288c), SPH_C32(0xeecf01d8),
    SPH_C32(0xc9f38000), SPH_C32(0x8c490000), SPH_C32(0x3b490000),
    SPH_C32(0xfd7b5d3d), SPH_C32(0x4f83695a), SPH_C32(0x17432811),
    SPH_C32(0xe15544bc) },
  { SPH_C32(0xdac90141), SPH_C32(0xfbd94000), SPH_C32(0xecef0000),
    SPH_C32(0x57610000), SPH_C32(0xe28d2527), SPH_C32(0xd6de4be0),
    SPH_C32(0x7d314b7c), SPH_C32(0x43a0fe35), SPH_C32(0x184f01dd),
    SPH_C32(0xfdb04000), SPH_C32(0xa84e0000), SPH_C32(0xb4740000),
    SPH_C32(0xdc4c66c6), SPH_C32(0x453bbcf4), SPH_C32(0xda86a308),
    SPH_C32(0x36c0fe8d) },
  { SPH_C32(0x2c490144), SPH_C32(0xcf9a8000), SPH_C32(0xc8e80000),
    SPH_C32(0xd85c0000), SPH_C32(0xc3ba1edc), SPH_C32(0xdc669e4e),
    SPH_C32(0xb0f4c065), SPH_C32(0x94354404), SPH_C32(0xbe3001dc),
    SPH_C32(0x8c87c000), SPH_C32(0xb1b20000), SPH_C32(0x22af0000),
    SPH_C32(0xe6c70b3b), SPH_C32(0xaef11207), SPH_C32(0xf6ebe487),
    SPH_C32(0x9a4e9205) },
  { SPH_C32(0x8bc30149), SPH_C32(0x45d20000), SPH_C32(0x36c50000),
    SPH_C32(0xc5280000), SPH_C32(0xda935173), SPH_C32(0xc5fcd3a9),
    SPH_C32(0x2bdbfdbd), SPH_C32(0x71380aa7), SPH_C32(0x9cda01d9),
    SPH_C32(0x350cc000), SPH_C32(0x301a0000), SPH_C32(0xe7bb0000),
    SPH_C32(0x3bbe72ba), SPH_C32(0x6dfd41c5), SPH_C32(0xa318f99a),
    SPH_C32(0xba9deb14) },
  { SPH_C32(0x7d43014c), SPH_C32(0x7191c000), SPH_C32(0x12c20000),
    SPH_C32(0x4a150000), SPH_C32(0xfba46a88), SPH_C32(0xcf440607),
    SPH_C32(0xe61e76a4), SPH_C32(0xa6adb096), SPH_C32(0x3aa501d8),
    SPH_C32(0x443b4000), SPH_C32(0x29e60000), SPH_C32(0x71600000),
    SPH_C32(0x01351f47), SPH_C32(0x8637ef36), SPH_C32(0x8f75be15),
    SPH_C32(0x1613879c) },
  { SPH_C32(0x2dbc0148), SPH_C32(0x34e58000), SPH_C32(0x2f390000),
    SPH_C32(0x53f30000), SPH_C32(0xe0183c8e), SPH_C32(0x2e367d5a),
    SPH_C32(0x07b6ba32), SPH_C32(0xddb6662f), SPH_C32(0xcc2501dd),
    SPH_C32(0x70788000), SPH_C32(0x0de10000), SPH_C32(0xfe5d0000),
    SPH_C32(0x200224bc), SPH_C32(0x8c8f3a98), SPH_C32(0x42b0350c),
    SPH_C32(0xc1863dad) },
  { SPH_C32(0xdb3c014d), SPH_C32(0x00a64000), SPH_C32(0x0b3e0000),
    SPH_C32(0xdcce0000), SPH_C32(0xc12f0775), SPH_C32(0x248ea8f4),
    SPH_C32(0xca73312b), SPH_C32(0x0a23dc1e), SPH_C32(0x6a5a01dc),
    SPH_C32(0x014f0000), SPH_C32(0x141d0000), SPH_C32(0x68860000),
    SPH_C32(0x1a894941), SPH_C32(0x6745946b), SPH_C32(0x6edd7283),
    SPH_C32(0x6d085125) },
  { SPH_C32(0xdf9801b0), SPH_C32(0xf67c0000), SPH_C32(0xa50e0000),
    SPH_C32(0xbf870000), SPH_C32(0xad7f742c), SPH_C32(0xae2b8f5a),
    SPH_C32(0xc2a957e9), SPH_C32(0xd75f2456), SPH_C32(0x9fc30180),
    SPH_C32(0x6c280000), SPH_C32(0xe7690000), SPH_C32(0xe0360000),
    SPH_C32(0x7bbf15ab), SPH_C32(0xf3aa0966), SPH_C32(0x453b7806),
    SPH_C32(0xaebf667a) },
  { SPH_C32(0x291801b5), SPH_C32(0xc23fc000), SPH_C32(0x81090000),
    SPH_C32(0x30ba0000), SPH_C32(0x8c484fd7), SPH_C32(0xa4935af4),
    SPH_C32(0x0f6cdcf0), SPH_C32(0x00ca9e67), SPH_C32(0x39bc0181),
    SPH_C32(0x1d1f8000), SPH_C32(0xfe950000), SPH_C32(0x76ed0000),
    SPH_C32(0x41347856), SPH_C32(0x1860a795), SPH_C32(0x69563f89),
    SPH_C32(0x02310af2) },
  { SPH_C32(0x79e701b1), SPH_C32(0x874b8000), SPH_C32(0xbcf20000),
    SPH_C32(0x295c0000), SPH_C32(0x97f419d1), SPH_C32(0x45e121a9),
    SPH_C32(0xeec41066), SPH_C32(0x7bd148de), SPH_C32(0xcf3c0184),
    SPH_C32(0x295c4000), SPH_C32(0xda920000), SPH_C32(0xf9d00000),
    SPH_C32(0x600343ad), SPH_C32(0x12d8723b), SPH_C32(0xa493b490),
    SPH_C32(0xd5a4b0c3) },
  { SPH_C32(0x8f6701b4), SPH_C32(0xb3084000), SPH_C32(0x98f50000),
    SPH_C32(0xa6610000), SPH_C32(0xb6c3222a), SPH_C32(0x4f59f407),
    SPH_C32(0x23019b7f), SPH_C32(0xac44f2ef), SPH_C32(0x69430185),
    SPH_C32(0x586bc000), SPH_C32(0xc36e0000), SPH_C32(0x6f0b0000),
    SPH_C32(0x5a882e50), SPH_C32(0xf912dcc8), SPH_C32(0x88fef31f),
    SPH_C32(0x792adc4b) },
  { SPH_C32(0x28ed01b9), SPH_C32(0x3940c000), SPH_C32(0x66d80000),
    SPH_C32(0xbb150000), SPH_C32(0xafea6d85), SPH_C32(0x56c3b9e0),
    SPH_C32(0xb82ea6a7), SPH_C32(0x4949bc4c), SPH_C32(0x4ba90180),
    SPH_C32(0xe1e0c000), SPH_C32(0x42c60000), SPH_C32(0xaa1f0000),
    SPH_C32(0x87f157d1), SPH_C32(0x3a1e8f0a), SPH_C32(0xdd0dee02),
    SPH_C32(0x59f9a55a) },
  { SPH_C32(0xde6d01bc), SPH_C32(0x0d030000), SPH_C32(0x42df0000),
    SPH_C32(0x34280000), SPH_C32(0x8edd567e), SPH_C32(0x5c7b6c4e),
    SPH_C32(0x75eb2dbe), SPH_C32(0x9edc067d), SPH_C32(0xedd60181),
    SPH_C32(0x90d74000), SPH_C32(0x5b3a0000), SPH_C32(0x3cc40000),
    SPH_C32(0xbd7a3a2c), SPH_C32(0xd1d421f9), SPH_C32(0xf160a98d),
    SPH_C32(0xf577c9d2) },
  { SPH_C32(0x8e9201b8), SPH_C32(0x48774000), SPH_C32(0x7f240000),
    SPH_C32(0x2dce0000), SPH_C32(0x95610078), SPH_C32(0xbd091713),
    SPH_C32(0x9443e128), SPH_C32(0xe5c7d0c4), SPH_C32(0x1b560184),
    SPH_C32(0xa4948000), SPH_C32(0x7f3d0000), SPH_C32(0xb3f90000),
    SPH_C32(0x9c4d01d7), SPH_C32(0xdb6cf457), SPH_C32(0x3ca52294),
    SPH_C32(0x22e273e3) },
  { SPH_C32(0x781201bd), SPH_C32(0x7c348000), SPH_C32(0x5b230000),
    SPH_C32(0xa2f30000), SPH_C32(0xb4563b83), SPH_C32(0xb7b1c2bd),
    SPH_C32(0x59866a31), SPH_C32(0x32526af5), SPH_C32(0xbd290185),
    SPH_C32(0xd5a30000), SPH_C32(0x66c10000), SPH_C32(0x25220000),
    SPH_C32(0xa6c66c2a), SPH_C32(0x30a65aa4), SPH_C32(0x10c8651b),
    SPH_C32(0x8e6c1f6b) },
  { SPH_C32(0x0bf201b0), SPH_C32(0x7bb4c000), SPH_C32(0x00a10000),
    SPH_C32(0xf5ae0000), SPH_C32(0x51313656), SPH_C32(0x679f0936),
    SPH_C32(0x5a9fc1ed), SPH_C32(0x2019e776), SPH_C32(0xbcdc0189),
    SPH_C32(0x2edc0000), SPH_C32(0x81100000), SPH_C32(0xae8d0000),
    SPH_C32(0x85644e78), SPH_C32(0xc2f6b9b0), SPH_C32(0xa78a1f4c),
    SPH_C32(0xc7ef3d40) },
  { SPH_C32(0xfd7201b5), SPH_C32(0x4ff70000), SPH_C32(0x24a60000),
    SPH_C32(0x7a930000), SPH_C32(0x70060dad), SPH_C32(0x6d27dc98),
    SPH_C32(0x975a4af4), SPH_C32(0xf78c5d47), SPH_C32(0x1aa30188),
    SPH_C32(0x5feb8000), SPH_C32(0x98ec0000), SPH_C32(0x38560000),
    SPH_C32(0xbfef2385), SPH_C32(0x293c1743), SPH_C32(0x8be758c3),
    SPH_C32(0x6b6151c8) },
  { SPH_C32(0xad8d01b1), SPH_C32(0x0a834000), SPH_C32(0x195d0000),
    SPH_C32(0x63750000), SPH_C32(0x6bba5bab), SPH_C32(0x8c55a7c5),
    SPH_C32(0x76f28662), SPH_C32(0x8c978bfe), SPH_C32(0xec23018d),
    SPH_C32(0x6ba84000), SPH_C32(0xbceb0000), SPH_C32(0xb76b0000),
    SPH_C32(0x9ed8187e), SPH_C32(0x2384c2ed), SPH_C32(0x4622d3da),
    SPH_C32(0xbcf4ebf9) },
  { SPH_C32(0x5b0d01b4), SPH_C32(0x3ec08000), SPH_C32(0x3d5a0000),
    SPH_C32(0xec480000), SPH_C32(0x4a8d6050), SPH_C32(0x86ed726b),
    SPH_C32(0xbb370d7b), SPH_C32(0x5b0231cf), SPH_C32(0x4a5c018c),
    SPH_C32(0x1a9fc000), SPH_C32(0xa5170000), SPH_C32(0x21b00000),
    SPH_C32(0xa4537583), SPH_C32(0xc84e6c1e), SPH_C32(0x6a4f9455),
    SPH_C32(0x107a8771) },
  { SPH_C32(0xfc8701b9), SPH_C32(0xb4880000), SPH_C32(0xc3770000),
    SPH_C32(0xf13c0000), SPH_C32(0x53a42fff), SPH_C32(0x9f773f8c),
    SPH_C32(0x201830a3), SPH_C32(0xbe0f7f6c), SPH_C32(0x68b60189),
    SPH_C32(0xa314c000), SPH_C32(0x24bf0000), SPH_C32(0xe4a40000),
    SPH_C32(0x792a0c02), SPH_C32(0x0b423fdc), SPH_C32(0x3fbc8948),
    SPH_C32(0x30a9fe60) },
  { SPH_C32(0x0a0701bc), SPH_C32(0x80cbc000), SPH_C32(0xe7700000),
    SPH_C32(0x7e010000), SPH_C32(0x72931404), SPH_C32(0x95cfea22),
    SPH_C32(0xedddbbba), SPH_C32(0x699ac55d), SPH_C32(0xcec90188),
    SPH_C32(0xd2234000), SPH_C32(0x3d430000), SPH_C32(0x727f0000),
    SPH_C32(0x43a161ff), SPH_C32(0xe088912f), SPH_C32(0x13d1cec7),
    SPH_C32(0x9c2792e8) },
  { SPH_C32(0x5af801b8), SPH_C32(0xc5bf8000), SPH_C32(0xda8b0000),
    SPH_C32(0x67e70000), SPH_C32(0x692f4202), SPH_C32(0x74bd917f),
    SPH_C32(0x0c75772c), SPH_C32(0x128113e4), SPH_C32(0x3849018d),
    SPH_C32(0xe6608000), SPH_C32(0x19440000), SPH_C32(0xfd420000),
    SPH_C32(0x62965a04), SPH_C32(0xea304481), SPH_C32(0xde1445de),
    SPH_C32(0x4bb228d9) },
  { SPH_C32(0xac7801bd), SPH_C32(0xf1fc4000), SPH_C32(0xfe8c0000),
    SPH_C32(0xe8da0000), SPH_C32(0x481879f9), SPH_C32(0x7e0544d1),
    SPH_C32(0xc1b0fc35), SPH_C32(0xc514a9d5), SPH_C32(0x9e36018c),
    SPH_C32(0x97570000), SPH_C32(0x00b80000), SPH_C32(0x6b990000),
    SPH_C32(0x581d37f9), SPH_C32(0x01faea72), SPH_C32(0xf2790251),
    SPH_C32(0xe73c4451) }
};

__constant static const sph_u32 T512_16[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x0c720000), SPH_C32(0x49e50f00), SPH_C32(0x42790000),
    SPH_C32(0x5cea0000), SPH_C32(0x33aa301a), SPH_C32(0x15822514),
    SPH_C32(0x95a34b7b), SPH_C32(0xb44b0090), SPH_C32(0xfe220000),
    SPH_C32(0xa7580500), SPH_C32(0x25d10000), SPH_C32(0xf7600000),
    SPH_C32(0x893178da), SPH_C32(0x1fd4f860), SPH_C32(0x4ed0a315),
    SPH_C32(0xa123ff9f) },
  { SPH_C32(0xfe220000), SPH_C32(0xa7580500), SPH_C32(0x25d10000),
    SPH_C32(0xf7600000), SPH_C32(0x893178da), SPH_C32(0x1fd4f860),
    SPH_C32(0x4ed0a315), SPH_C32(0xa123ff9f), SPH_C32(0xf2500000),
    SPH_C32(0xeebd0a00), SPH_C32(0x67a80000), SPH_C32(0xab8a0000),
    SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74), SPH_C32(0xdb73e86e),
    SPH_C32(0x1568ff0f) },
  { SPH_C32(0xf2500000), SPH_C32(0xeebd0a00), SPH_C32(0x67a80000),
    SPH_C32(0xab8a0000), SPH_C32(0xba9b48c0), SPH_C32(0x0a56dd74),
    SPH_C32(0xdb73e86e), SPH_C32(0x1568ff0f), SPH_C32(0x0c720000),
    SPH_C32(0x49e50f00), SPH_C32(0x42790000), SPH_C32(0x5cea0000),
    SPH_C32(0x33aa301a), SPH_C32(0x15822514), SPH_C32(0x95a34b7b),
    SPH_C32(0xb44b0090) },
  { SPH_C32(0x45180000), SPH_C32(0xa5b51700), SPH_C32(0xf96a0000),
    SPH_C32(0x3b480000), SPH_C32(0x1ecc142c), SPH_C32(0x231395d6),
    SPH_C32(0x16bca6b0), SPH_C32(0xdf33f4df), SPH_C32(0xb83d0000),
    SPH_C32(0x16710600), SPH_C32(0x379a0000), SPH_C32(0xf5b10000),
    SPH_C32(0x228161ac), SPH_C32(0xae48f145), SPH_C32(0x66241616),
    SPH_C32(0xc5c1eb3e) },
  { SPH_C32(0x496a0000), SPH_C32(0xec501800), SPH_C32(0xbb130000),
    SPH_C32(0x67a20000), SPH_C32(0x2d662436), SPH_C32(0x3691b0c2),
    SPH_C32(0x831fedcb), SPH_C32(0x6b78f44f), SPH_C32(0x461f0000),
    SPH_C32(0xb1290300), SPH_C32(0x124b0000), SPH_C32(0x02d10000),
    SPH_C32(0xabb01976), SPH_C32(0xb19c0925), SPH_C32(0x28f4b503),
    SPH_C32(0x64e214a1) },
  { SPH_C32(0xbb3a0000), SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000),
    SPH_C32(0xcc280000), SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6),
    SPH_C32(0x586c05a5), SPH_C32(0x7e100b40), SPH_C32(0x4a6d0000),
    SPH_C32(0xf8cc0c00), SPH_C32(0x50320000), SPH_C32(0x5e3b0000),
    SPH_C32(0x981a296c), SPH_C32(0xa41e2c31), SPH_C32(0xbd57fe78),
    SPH_C32(0xd0a91431) },
  { SPH_C32(0xb7480000), SPH_C32(0x4b081d00), SPH_C32(0x9ec20000),
    SPH_C32(0x90c20000), SPH_C32(0xa4575cec), SPH_C32(0x294548a2),
    SPH_C32(0xcdcf4ede), SPH_C32(0xca5b0bd0), SPH_C32(0xb44f0000),
    SPH_C32(0x5f940900), SPH_C32(0x75e30000), SPH_C32(0xa95b0000),
    SPH_C32(0x112b51b6), SPH_C32(0xbbcad451), SPH_C32(0xf3875d6d),
    SPH_C32(0x718aebae) },
  { SPH_C32(0xb83d0000), SPH_C32(0x16710600), SPH_C32(0x379a0000),
    SPH_C32(0xf5b10000), SPH_C32(0x228161ac), SPH_C32(0xae48f145),
    SPH_C32(0x66241616), SPH_C32(0xc5c1eb3e), SPH_C32(0xfd250000),
    SPH_C32(0xb3c41100), SPH_C32(0xcef00000), SPH_C32(0xcef90000),
    SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493), SPH_C32(0x7098b0a6),
    SPH_C32(0x1af21fe1) },
  { SPH_C32(0xb44f0000), SPH_C32(0x5f940900), SPH_C32(0x75e30000),
    SPH_C32(0xa95b0000), SPH_C32(0x112b51b6), SPH_C32(0xbbcad451),
    SPH_C32(0xf3875d6d), SPH_C32(0x718aebae), SPH_C32(0x03070000),
    SPH_C32(0x149c1400), SPH_C32(0xeb210000), SPH_C32(0x39990000),
    SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3), SPH_C32(0x3e4813b3),
    SPH_C32(0xbbd1e07e) },
  { SPH_C32(0x461f0000), SPH_C32(0xb1290300), SPH_C32(0x124b0000),
    SPH_C32(0x02d10000), SPH_C32(0xabb01976), SPH_C32(0xb19c0925),
    SPH_C32(0x28f4b503), SPH_C32(0x64e214a1), SPH_C32(0x0f750000),
    SPH_C32(0x5d791b00), SPH_C32(0xa9580000), SPH_C32(0x65730000),
    SPH_C32(0x86d63d40), SPH_C32(0x870db9e7), SPH_C32(0xabeb58c8),
    SPH_C32(0x0f9ae0ee) },
  { SPH_C32(0x4a6d0000), SPH_C32(0xf8cc0c00), SPH_C32(0x50320000),
    SPH_C32(0x5e3b0000), SPH_C32(0x981a296c), SPH_C32(0xa41e2c31),
    SPH_C32(0xbd57fe78), SPH_C32(0xd0a91431), SPH_C32(0xf1570000),
    SPH_C32(0xfa211e00), SPH_C32(0x8c890000), SPH_C32(0x92130000),
    SPH_C32(0x0fe7459a), SPH_C32(0x98d94187), SPH_C32(0xe53bfbdd),
    SPH_C32(0xaeb91f71) },
  { SPH_C32(0xfd250000), SPH_C32(0xb3c41100), SPH_C32(0xcef00000),
    SPH_C32(0xcef90000), SPH_C32(0x3c4d7580), SPH_C32(0x8d5b6493),
    SPH_C32(0x7098b0a6), SPH_C32(0x1af21fe1), SPH_C32(0x45180000),
    SPH_C32(0xa5b51700), SPH_C32(0xf96a0000), SPH_C32(0x3b480000),
    SPH_C32(0x1ecc142c), SPH_C32(0x231395d6), SPH_C32(0x16bca6b0),
    SPH_C32(0xdf33f4df) },
  { SPH_C32(0xf1570000), SPH_C32(0xfa211e00), SPH_C32(0x8c890000),
    SPH_C32(0x92130000), SPH_C32(0x0fe7459a), SPH_C32(0x98d94187),
    SPH_C32(0xe53bfbdd), SPH_C32(0xaeb91f71), SPH_C32(0xbb3a0000),
    SPH_C32(0x02ed1200), SPH_C32(0xdcbb0000), SPH_C32(0xcc280000),
    SPH_C32(0x97fd6cf6), SPH_C32(0x3cc76db6), SPH_C32(0x586c05a5),
    SPH_C32(0x7e100b40) },
  { SPH_C32(0x03070000), SPH_C32(0x149c1400), SPH_C32(0xeb210000),
    SPH_C32(0x39990000), SPH_C32(0xb57c0d5a), SPH_C32(0x928f9cf3),
    SPH_C32(0x3e4813b3), SPH_C32(0xbbd1e07e), SPH_C32(0xb7480000),
    SPH_C32(0x4b081d00), SPH_C32(0x9ec20000), SPH_C32(0x90c20000),
    SPH_C32(0xa4575cec), SPH_C32(0x294548a2), SPH_C32(0xcdcf4ede),
    SPH_C32(0xca5b0bd0) },
  { SPH_C32(0x0f750000), SPH_C32(0x5d791b00), SPH_C32(0xa9580000),
    SPH_C32(0x65730000), SPH_C32(0x86d63d40), SPH_C32(0x870db9e7),
    SPH_C32(0xabeb58c8), SPH_C32(0x0f9ae0ee), SPH_C32(0x496a0000),
    SPH_C32(0xec501800), SPH_C32(0xbb130000), SPH_C32(0x67a20000),
    SPH_C32(0x2d662436), SPH_C32(0x3691b0c2), SPH_C32(0x831fedcb),
    SPH_C32(0x6b78f44f) },
  { SPH_C32(0x75a40000), SPH_C32(0xc28b2700), SPH_C32(0x94a40000),
    SPH_C32(0x90f50000), SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae),
    SPH_C32(0x1767c483), SPH_C32(0xaedf667e), SPH_C32(0xd1660000),
    SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000), SPH_C32(0xf6940000),
    SPH_C32(0x03024527), SPH_C32(0xcf70fcf2), SPH_C32(0xb4431b17),
    SPH_C32(0x857f3c2b) },
  { SPH_C32(0x79d60000), SPH_C32(0x8b6e2800), SPH_C32(0xd6dd0000),
    SPH_C32(0xcc1f0000), SPH_C32(0xc8d267fa), SPH_C32(0x5c4c2eba),
    SPH_C32(0x82c48ff8), SPH_C32(0x1a9466ee), SPH_C32(0x2f440000),
    SPH_C32(0xbce40600), SPH_C32(0xbb3d0000), SPH_C32(0x01f40000),
    SPH_C32(0x8a333dfd), SPH_C32(0xd0a40492), SPH_C32(0xfa93b802),
    SPH_C32(0x245cc3b4) },
  { SPH_C32(0x8b860000), SPH_C32(0x65d32200), SPH_C32(0xb1750000),
    SPH_C32(0x67950000), SPH_C32(0x72492f3a), SPH_C32(0x561af3ce),
    SPH_C32(0x59b76796), SPH_C32(0x0ffc99e1), SPH_C32(0x23360000),
    SPH_C32(0xf5010900), SPH_C32(0xf9440000), SPH_C32(0x5d1e0000),
    SPH_C32(0xb9990de7), SPH_C32(0xc5262186), SPH_C32(0x6f30f379),
    SPH_C32(0x9017c324) },
  { SPH_C32(0x87f40000), SPH_C32(0x2c362d00), SPH_C32(0xf30c0000),
    SPH_C32(0x3b7f0000), SPH_C32(0x41e31f20), SPH_C32(0x4398d6da),
    SPH_C32(0xcc142ced), SPH_C32(0xbbb79971), SPH_C32(0xdd140000),
    SPH_C32(0x52590c00), SPH_C32(0xdc950000), SPH_C32(0xaa7e0000),
    SPH_C32(0x30a8753d), SPH_C32(0xdaf2d9e6), SPH_C32(0x21e0506c),
    SPH_C32(0x31343cbb) },
  { SPH_C32(0x30bc0000), SPH_C32(0x673e3000), SPH_C32(0x6dce0000),
    SPH_C32(0xabbd0000), SPH_C32(0xe5b443cc), SPH_C32(0x6add9e78),
    SPH_C32(0x01db6233), SPH_C32(0x71ec92a1), SPH_C32(0x695b0000),
    SPH_C32(0x0dcd0500), SPH_C32(0xa9760000), SPH_C32(0x03250000),
    SPH_C32(0x2183248b), SPH_C32(0x61380db7), SPH_C32(0xd2670d01),
    SPH_C32(0x40bed715) },
  { SPH_C32(0x3cce0000), SPH_C32(0x2edb3f00), SPH_C32(0x2fb70000),
    SPH_C32(0xf7570000), SPH_C32(0xd61e73d6), SPH_C32(0x7f5fbb6c),
    SPH_C32(0x94782948), SPH_C32(0xc5a79231), SPH_C32(0x97790000),
    SPH_C32(0xaa950000), SPH_C32(0x8ca70000), SPH_C32(0xf4450000),
    SPH_C32(0xa8b25c51), SPH_C32(0x7eecf5d7), SPH_C32(0x9cb7ae14),
    SPH_C32(0xe19d288a) },
  { SPH_C32(0xce9e0000), SPH_C32(0xc0663500), SPH_C32(0x481f0000),
    SPH_C32(0x5cdd0000), SPH_C32(0x6c853b16), SPH_C32(0x75096618),
    SPH_C32(0x4f0bc126), SPH_C32(0xd0cf6d3e), SPH_C32(0x9b0b0000),
    SPH_C32(0xe3700f00), SPH_C32(0xcede0000), SPH_C32(0xa8af0000),
    SPH_C32(0x9b186c4b), SPH_C32(0x6b6ed0c3), SPH_C32(0x0914e56f),
    SPH_C32(0x55d6281a) },
  { SPH_C32(0xc2ec0000), SPH_C32(0x89833a00), SPH_C32(0x0a660000),
    SPH_C32(0x00370000), SPH_C32(0x5f2f0b0c), SPH_C32(0x608b430c),
    SPH_C32(0xdaa88a5d), SPH_C32(0x64846dae), SPH_C32(0x65290000),
    SPH_C32(0x44280a00), SPH_C32(0xeb0f0000), SPH_C32(0x5fcf0000),
    SPH_C32(0x12291491), SPH_C32(0x74ba28a3), SPH_C32(0x47c4467a),
    SPH_C32(0xf4f5d785) },
  { SPH_C32(0xcd990000), SPH_C32(0xd4fa2100), SPH_C32(0xa33e0000),
    SPH_C32(0x65440000), SPH_C32(0xd9f9364c), SPH_C32(0xe786faeb),
    SPH_C32(0x7143d295), SPH_C32(0x6b1e8d40), SPH_C32(0x2c430000),
    SPH_C32(0xa8781200), SPH_C32(0x501c0000), SPH_C32(0x386d0000),
    SPH_C32(0x3f4f30a7), SPH_C32(0x422b9861), SPH_C32(0xc4dbabb1),
    SPH_C32(0x9f8d23ca) },
  { SPH_C32(0xc1eb0000), SPH_C32(0x9d1f2e00), SPH_C32(0xe1470000),
    SPH_C32(0x39ae0000), SPH_C32(0xea530656), SPH_C32(0xf204dfff),
    SPH_C32(0xe4e099ee), SPH_C32(0xdf558dd0), SPH_C32(0xd2610000),
    SPH_C32(0x0f201700), SPH_C32(0x75cd0000), SPH_C32(0xcf0d0000),
    SPH_C32(0xb67e487d), SPH_C32(0x5dff6001), SPH_C32(0x8a0b08a4),
    SPH_C32(0x3eaedc55) },
  { SPH_C32(0x33bb0000), SPH_C32(0x73a22400), SPH_C32(0x86ef0000),
    SPH_C32(0x92240000), SPH_C32(0x50c84e96), SPH_C32(0xf852028b),
    SPH_C32(0x3f937180), SPH_C32(0xca3d72df), SPH_C32(0xde130000),
    SPH_C32(0x46c51800), SPH_C32(0x37b40000), SPH_C32(0x93e70000),
    SPH_C32(0x85d47867), SPH_C32(0x487d4515), SPH_C32(0x1fa843df),
    SPH_C32(0x8ae5dcc5) },
  { SPH_C32(0x3fc90000), SPH_C32(0x3a472b00), SPH_C32(0xc4960000),
    SPH_C32(0xcece0000), SPH_C32(0x63627e8c), SPH_C32(0xedd0279f),
    SPH_C32(0xaa303afb), SPH_C32(0x7e76724f), SPH_C32(0x20310000),
    SPH_C32(0xe19d1d00), SPH_C32(0x12650000), SPH_C32(0x64870000),
    SPH_C32(0x0ce500bd), SPH_C32(0x57a9bd75), SPH_C32(0x5178e0ca),
    SPH_C32(0x2bc6235a) },
  { SPH_C32(0x88810000), SPH_C32(0x714f3600), SPH_C32(0x5a540000),
    SPH_C32(0x5e0c0000), SPH_C32(0xc7352260), SPH_C32(0xc4956f3d),
    SPH_C32(0x67ff7425), SPH_C32(0xb42d799f), SPH_C32(0x947e0000),
    SPH_C32(0xbe091400), SPH_C32(0x67860000), SPH_C32(0xcddc0000),
    SPH_C32(0x1dce510b), SPH_C32(0xec636924), SPH_C32(0xa2ffbda7),
    SPH_C32(0x5a4cc8f4) },
  { SPH_C32(0x84f30000), SPH_C32(0x38aa3900), SPH_C32(0x182d0000),
    SPH_C32(0x02e60000), SPH_C32(0xf49f127a), SPH_C32(0xd1174a29),
    SPH_C32(0xf25c3f5e), SPH_C32(0x0066790f), SPH_C32(0x6a5c0000),
    SPH_C32(0x19511100), SPH_C32(0x42570000), SPH_C32(0x3abc0000),
    SPH_C32(0x94ff29d1), SPH_C32(0xf3b79144), SPH_C32(0xec2f1eb2),
    SPH_C32(0xfb6f376b) },
  { SPH_C32(0x76a30000), SPH_C32(0xd6173300), SPH_C32(0x7f850000),
    SPH_C32(0xa96c0000), SPH_C32(0x4e045aba), SPH_C32(0xdb41975d),
    SPH_C32(0x292fd730), SPH_C32(0x150e8600), SPH_C32(0x662e0000),
    SPH_C32(0x50b41e00), SPH_C32(0x002e0000), SPH_C32(0x66560000),
    SPH_C32(0xa75519cb), SPH_C32(0xe635b450), SPH_C32(0x798c55c9),
    SPH_C32(0x4f2437fb) },
  { SPH_C32(0x7ad10000), SPH_C32(0x9ff23c00), SPH_C32(0x3dfc0000),
    SPH_C32(0xf5860000), SPH_C32(0x7dae6aa0), SPH_C32(0xcec3b249),
    SPH_C32(0xbc8c9c4b), SPH_C32(0xa1458690), SPH_C32(0x980c0000),
    SPH_C32(0xf7ec1b00), SPH_C32(0x25ff0000), SPH_C32(0x91360000),
    SPH_C32(0x2e646111), SPH_C32(0xf9e14c30), SPH_C32(0x375cf6dc),
    SPH_C32(0xee07c864) },
  { SPH_C32(0xd1660000), SPH_C32(0x1bbc0300), SPH_C32(0x9eec0000),
    SPH_C32(0xf6940000), SPH_C32(0x03024527), SPH_C32(0xcf70fcf2),
    SPH_C32(0xb4431b17), SPH_C32(0x857f3c2b), SPH_C32(0xa4c20000),
    SPH_C32(0xd9372400), SPH_C32(0x0a480000), SPH_C32(0x66610000),
    SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c), SPH_C32(0xa324df94),
    SPH_C32(0x2ba05a55) },
  { SPH_C32(0xdd140000), SPH_C32(0x52590c00), SPH_C32(0xdc950000),
    SPH_C32(0xaa7e0000), SPH_C32(0x30a8753d), SPH_C32(0xdaf2d9e6),
    SPH_C32(0x21e0506c), SPH_C32(0x31343cbb), SPH_C32(0x5ae00000),
    SPH_C32(0x7e6f2100), SPH_C32(0x2f990000), SPH_C32(0x91010000),
    SPH_C32(0x714b6a1d), SPH_C32(0x996a0f3c), SPH_C32(0xedf47c81),
    SPH_C32(0x8a83a5ca) },
  { SPH_C32(0x2f440000), SPH_C32(0xbce40600), SPH_C32(0xbb3d0000),
    SPH_C32(0x01f40000), SPH_C32(0x8a333dfd), SPH_C32(0xd0a40492),
    SPH_C32(0xfa93b802), SPH_C32(0x245cc3b4), SPH_C32(0x56920000),
    SPH_C32(0x378a2e00), SPH_C32(0x6de00000), SPH_C32(0xcdeb0000),
    SPH_C32(0x42e15a07), SPH_C32(0x8ce82a28), SPH_C32(0x785737fa),
    SPH_C32(0x3ec8a55a) },
  { SPH_C32(0x23360000), SPH_C32(0xf5010900), SPH_C32(0xf9440000),
    SPH_C32(0x5d1e0000), SPH_C32(0xb9990de7), SPH_C32(0xc5262186),
    SPH_C32(0x6f30f379), SPH_C32(0x9017c324), SPH_C32(0xa8b00000),
    SPH_C32(0x90d22b00), SPH_C32(0x48310000), SPH_C32(0x3a8b0000),
    SPH_C32(0xcbd022dd), SPH_C32(0x933cd248), SPH_C32(0x368794ef),
    SPH_C32(0x9feb5ac5) },
  { SPH_C32(0x947e0000), SPH_C32(0xbe091400), SPH_C32(0x67860000),
    SPH_C32(0xcddc0000), SPH_C32(0x1dce510b), SPH_C32(0xec636924),
    SPH_C32(0xa2ffbda7), SPH_C32(0x5a4cc8f4), SPH_C32(0x1cff0000),
    SPH_C32(0xcf462200), SPH_C32(0x3dd20000), SPH_C32(0x93d00000),
    SPH_C32(0xdafb736b), SPH_C32(0x28f60619), SPH_C32(0xc500c982),
    SPH_C32(0xee61b16b) },
  { SPH_C32(0x980c0000), SPH_C32(0xf7ec1b00), SPH_C32(0x25ff0000),
    SPH_C32(0x91360000), SPH_C32(0x2e646111), SPH_C32(0xf9e14c30),
    SPH_C32(0x375cf6dc), SPH_C32(0xee07c864), SPH_C32(0xe2dd0000),
    SPH_C32(0x681e2700), SPH_C32(0x18030000), SPH_C32(0x64b00000),
    SPH_C32(0x53ca0bb1), SPH_C32(0x3722fe79), SPH_C32(0x8bd06a97),
    SPH_C32(0x4f424ef4) },
  { SPH_C32(0x6a5c0000), SPH_C32(0x19511100), SPH_C32(0x42570000),
    SPH_C32(0x3abc0000), SPH_C32(0x94ff29d1), SPH_C32(0xf3b79144),
    SPH_C32(0xec2f1eb2), SPH_C32(0xfb6f376b), SPH_C32(0xeeaf0000),
    SPH_C32(0x21fb2800), SPH_C32(0x5a7a0000), SPH_C32(0x385a0000),
    SPH_C32(0x60603bab), SPH_C32(0x22a0db6d), SPH_C32(0x1e7321ec),
    SPH_C32(0xfb094e64) },
  { SPH_C32(0x662e0000), SPH_C32(0x50b41e00), SPH_C32(0x002e0000),
    SPH_C32(0x66560000), SPH_C32(0xa75519cb), SPH_C32(0xe635b450),
    SPH_C32(0x798c55c9), SPH_C32(0x4f2437fb), SPH_C32(0x108d0000),
    SPH_C32(0x86a32d00), SPH_C32(0x7fab0000), SPH_C32(0xcf3a0000),
    SPH_C32(0xe9514371), SPH_C32(0x3d74230d), SPH_C32(0x50a382f9),
    SPH_C32(0x5a2ab1fb) },
  { SPH_C32(0x695b0000), SPH_C32(0x0dcd0500), SPH_C32(0xa9760000),
    SPH_C32(0x03250000), SPH_C32(0x2183248b), SPH_C32(0x61380db7),
    SPH_C32(0xd2670d01), SPH_C32(0x40bed715), SPH_C32(0x59e70000),
    SPH_C32(0x6af33500), SPH_C32(0xc4b80000), SPH_C32(0xa8980000),
    SPH_C32(0xc4376747), SPH_C32(0x0be593cf), SPH_C32(0xd3bc6f32),
    SPH_C32(0x315245b4) },
  { SPH_C32(0x65290000), SPH_C32(0x44280a00), SPH_C32(0xeb0f0000),
    SPH_C32(0x5fcf0000), SPH_C32(0x12291491), SPH_C32(0x74ba28a3),
    SPH_C32(0x47c4467a), SPH_C32(0xf4f5d785), SPH_C32(0xa7c50000),
    SPH_C32(0xcdab3000), SPH_C32(0xe1690000), SPH_C32(0x5ff80000),
    SPH_C32(0x4d061f9d), SPH_C32(0x14316baf), SPH_C32(0x9d6ccc27),
    SPH_C32(0x9071ba2b) },
  { SPH_C32(0x97790000), SPH_C32(0xaa950000), SPH_C32(0x8ca70000),
    SPH_C32(0xf4450000), SPH_C32(0xa8b25c51), SPH_C32(0x7eecf5d7),
    SPH_C32(0x9cb7ae14), SPH_C32(0xe19d288a), SPH_C32(0xabb70000),
    SPH_C32(0x844e3f00), SPH_C32(0xa3100000), SPH_C32(0x03120000),
    SPH_C32(0x7eac2f87), SPH_C32(0x01b34ebb), SPH_C32(0x08cf875c),
    SPH_C32(0x243ababb) },
  { SPH_C32(0x9b0b0000), SPH_C32(0xe3700f00), SPH_C32(0xcede0000),
    SPH_C32(0xa8af0000), SPH_C32(0x9b186c4b), SPH_C32(0x6b6ed0c3),
    SPH_C32(0x0914e56f), SPH_C32(0x55d6281a), SPH_C32(0x55950000),
    SPH_C32(0x23163a00), SPH_C32(0x86c10000), SPH_C32(0xf4720000),
    SPH_C32(0xf79d575d), SPH_C32(0x1e67b6db), SPH_C32(0x461f2449),
    SPH_C32(0x85194524) },
  { SPH_C32(0x2c430000), SPH_C32(0xa8781200), SPH_C32(0x501c0000),
    SPH_C32(0x386d0000), SPH_C32(0x3f4f30a7), SPH_C32(0x422b9861),
    SPH_C32(0xc4dbabb1), SPH_C32(0x9f8d23ca), SPH_C32(0xe1da0000),
    SPH_C32(0x7c823300), SPH_C32(0xf3220000), SPH_C32(0x5d290000),
    SPH_C32(0xe6b606eb), SPH_C32(0xa5ad628a), SPH_C32(0xb5987924),
    SPH_C32(0xf493ae8a) },
  { SPH_C32(0x20310000), SPH_C32(0xe19d1d00), SPH_C32(0x12650000),
    SPH_C32(0x64870000), SPH_C32(0x0ce500bd), SPH_C32(0x57a9bd75),
    SPH_C32(0x5178e0ca), SPH_C32(0x2bc6235a), SPH_C32(0x1ff80000),
    SPH_C32(0xdbda3600), SPH_C32(0xd6f30000), SPH_C32(0xaa490000),
    SPH_C32(0x6f877e31), SPH_C32(0xba799aea), SPH_C32(0xfb48da31),
    SPH_C32(0x55b05115) },
  { SPH_C32(0xd2610000), SPH_C32(0x0f201700), SPH_C32(0x75cd0000),
    SPH_C32(0xcf0d0000), SPH_C32(0xb67e487d), SPH_C32(0x5dff6001),
    SPH_C32(0x8a0b08a4), SPH_C32(0x3eaedc55), SPH_C32(0x138a0000),
    SPH_C32(0x923f3900), SPH_C32(0x948a0000), SPH_C32(0xf6a30000),
    SPH_C32(0x5c2d4e2b), SPH_C32(0xaffbbffe), SPH_C32(0x6eeb914a),
    SPH_C32(0xe1fb5185) },
  { SPH_C32(0xde130000), SPH_C32(0x46c51800), SPH_C32(0x37b40000),
    SPH_C32(0x93e70000), SPH_C32(0x85d47867), SPH_C32(0x487d4515),
    SPH_C32(0x1fa843df), SPH_C32(0x8ae5dcc5), SPH_C32(0xeda80000),
    SPH_C32(0x35673c00), SPH_C32(0xb15b0000), SPH_C32(0x01c30000),
    SPH_C32(0xd51c36f1), SPH_C32(0xb02f479e), SPH_C32(0x203b325f),
    SPH_C32(0x40d8ae1a) },
  { SPH_C32(0xa4c20000), SPH_C32(0xd9372400), SPH_C32(0x0a480000),
    SPH_C32(0x66610000), SPH_C32(0xf87a12c7), SPH_C32(0x86bef75c),
    SPH_C32(0xa324df94), SPH_C32(0x2ba05a55), SPH_C32(0x75a40000),
    SPH_C32(0xc28b2700), SPH_C32(0x94a40000), SPH_C32(0x90f50000),
    SPH_C32(0xfb7857e0), SPH_C32(0x49ce0bae), SPH_C32(0x1767c483),
    SPH_C32(0xaedf667e) },
  { SPH_C32(0xa8b00000), SPH_C32(0x90d22b00), SPH_C32(0x48310000),
    SPH_C32(0x3a8b0000), SPH_C32(0xcbd022dd), SPH_C32(0x933cd248),
    SPH_C32(0x368794ef), SPH_C32(0x9feb5ac5), SPH_C32(0x8b860000),
    SPH_C32(0x65d32200), SPH_C32(0xb1750000), SPH_C32(0x67950000),
    SPH_C32(0x72492f3a), SPH_C32(0x561af3ce), SPH_C32(0x59b76796),
    SPH_C32(0x0ffc99e1) },
  { SPH_C32(0x5ae00000), SPH_C32(0x7e6f2100), SPH_C32(0x2f990000),
    SPH_C32(0x91010000), SPH_C32(0x714b6a1d), SPH_C32(0x996a0f3c),
    SPH_C32(0xedf47c81), SPH_C32(0x8a83a5ca), SPH_C32(0x87f40000),
    SPH_C32(0x2c362d00), SPH_C32(0xf30c0000), SPH_C32(0x3b7f0000),
    SPH_C32(0x41e31f20), SPH_C32(0x4398d6da), SPH_C32(0xcc142ced),
    SPH_C32(0xbbb79971) },
  { SPH_C32(0x56920000), SPH_C32(0x378a2e00), SPH_C32(0x6de00000),
    SPH_C32(0xcdeb0000), SPH_C32(0x42e15a07), SPH_C32(0x8ce82a28),
    SPH_C32(0x785737fa), SPH_C32(0x3ec8a55a), SPH_C32(0x79d60000),
    SPH_C32(0x8b6e2800), SPH_C32(0xd6dd0000), SPH_C32(0xcc1f0000),
    SPH_C32(0xc8d267fa), SPH_C32(0x5c4c2eba), SPH_C32(0x82c48ff8),
    SPH_C32(0x1a9466ee) },
  { SPH_C32(0xe1da0000), SPH_C32(0x7c823300), SPH_C32(0xf3220000),
    SPH_C32(0x5d290000), SPH_C32(0xe6b606eb), SPH_C32(0xa5ad628a),
    SPH_C32(0xb5987924), SPH_C32(0xf493ae8a), SPH_C32(0xcd990000),
    SPH_C32(0xd4fa2100), SPH_C32(0xa33e0000), SPH_C32(0x65440000),
    SPH_C32(0xd9f9364c), SPH_C32(0xe786faeb), SPH_C32(0x7143d295),
    SPH_C32(0x6b1e8d40) },
  { SPH_C32(0xeda80000), SPH_C32(0x35673c00), SPH_C32(0xb15b0000),
    SPH_C32(0x01c30000), SPH_C32(0xd51c36f1), SPH_C32(0xb02f479e),
    SPH_C32(0x203b325f), SPH_C32(0x40d8ae1a), SPH_C32(0x33bb0000),
    SPH_C32(0x73a22400), SPH_C32(0x86ef0000), SPH_C32(0x92240000),
    SPH_C32(0x50c84e96), SPH_C32(0xf852028b), SPH_C32(0x3f937180),
    SPH_C32(0xca3d72df) },
  { SPH_C32(0x1ff80000), SPH_C32(0xdbda3600), SPH_C32(0xd6f30000),
    SPH_C32(0xaa490000), SPH_C32(0x6f877e31), SPH_C32(0xba799aea),
    SPH_C32(0xfb48da31), SPH_C32(0x55b05115), SPH_C32(0x3fc90000),
    SPH_C32(0x3a472b00), SPH_C32(0xc4960000), SPH_C32(0xcece0000),
    SPH_C32(0x63627e8c), SPH_C32(0xedd0279f), SPH_C32(0xaa303afb),
    SPH_C32(0x7e76724f) },
  { SPH_C32(0x138a0000), SPH_C32(0x923f3900), SPH_C32(0x948a0000),
    SPH_C32(0xf6a30000), SPH_C32(0x5c2d4e2b), SPH_C32(0xaffbbffe),
    SPH_C32(0x6eeb914a), SPH_C32(0xe1fb5185), SPH_C32(0xc1eb0000),
    SPH_C32(0x9d1f2e00), SPH_C32(0xe1470000), SPH_C32(0x39ae0000),
    SPH_C32(0xea530656), SPH_C32(0xf204dfff), SPH_C32(0xe4e099ee),
    SPH_C32(0xdf558dd0) },
  { SPH_C32(0x1cff0000), SPH_C32(0xcf462200), SPH_C32(0x3dd20000),
    SPH_C32(0x93d00000), SPH_C32(0xdafb736b), SPH_C32(0x28f60619),
    SPH_C32(0xc500c982), SPH_C32(0xee61b16b), SPH_C32(0x88810000),
    SPH_C32(0x714f3600), SPH_C32(0x5a540000), SPH_C32(0x5e0c0000),
    SPH_C32(0xc7352260), SPH_C32(0xc4956f3d), SPH_C32(0x67ff7425),
    SPH_C32(0xb42d799f) },
  { SPH_C32(0x108d0000), SPH_C32(0x86a32d00), SPH_C32(0x7fab0000),
    SPH_C32(0xcf3a0000), SPH_C32(0xe9514371), SPH_C32(0x3d74230d),
    SPH_C32(0x50a382f9), SPH_C32(0x5a2ab1fb), SPH_C32(0x76a30000),
    SPH_C32(0xd6173300), SPH_C32(0x7f850000), SPH_C32(0xa96c0000),
    SPH_C32(0x4e045aba), SPH_C32(0xdb41975d), SPH_C32(0x292fd730),
    SPH_C32(0x150e8600) },
  { SPH_C32(0xe2dd0000), SPH_C32(0x681e2700), SPH_C32(0x18030000),
    SPH_C32(0x64b00000), SPH_C32(0x53ca0bb1), SPH_C32(0x3722fe79),
    SPH_C32(0x8bd06a97), SPH_C32(0x4f424ef4), SPH_C32(0x7ad10000),
    SPH_C32(0x9ff23c00), SPH_C32(0x3dfc0000), SPH_C32(0xf5860000),
    SPH_C32(0x7dae6aa0), SPH_C32(0xcec3b249), SPH_C32(0xbc8c9c4b),
    SPH_C32(0xa1458690) },
  { SPH_C32(0xeeaf0000), SPH_C32(0x21fb2800), SPH_C32(0x5a7a0000),
    SPH_C32(0x385a0000), SPH_C32(0x60603bab), SPH_C32(0x22a0db6d),
    SPH_C32(0x1e7321ec), SPH_C32(0xfb094e64), SPH_C32(0x84f30000),
    SPH_C32(0x38aa3900), SPH_C32(0x182d0000), SPH_C32(0x02e60000),
    SPH_C32(0xf49f127a), SPH_C32(0xd1174a29), SPH_C32(0xf25c3f5e),
    SPH_C32(0x0066790f) },
  { SPH_C32(0x59e70000), SPH_C32(0x6af33500), SPH_C32(0xc4b80000),
    SPH_C32(0xa8980000), SPH_C32(0xc4376747), SPH_C32(0x0be593cf),
    SPH_C32(0xd3bc6f32), SPH_C32(0x315245b4), SPH_C32(0x30bc0000),
    SPH_C32(0x673e3000), SPH_C32(0x6dce0000), SPH_C32(0xabbd0000),
    SPH_C32(0xe5b443cc), SPH_C32(0x6add9e78), SPH_C32(0x01db6233),
    SPH_C32(0x71ec92a1) },
  { SPH_C32(0x55950000), SPH_C32(0x23163a00), SPH_C32(0x86c10000),
    SPH_C32(0xf4720000), SPH_C32(0xf79d575d), SPH_C32(0x1e67b6db),
    SPH_C32(0x461f2449), SPH_C32(0x85194524), SPH_C32(0xce9e0000),
    SPH_C32(0xc0663500), SPH_C32(0x481f0000), SPH_C32(0x5cdd0000),
    SPH_C32(0x6c853b16), SPH_C32(0x75096618), SPH_C32(0x4f0bc126),
    SPH_C32(0xd0cf6d3e) },
  { SPH_C32(0xa7c50000), SPH_C32(0xcdab3000), SPH_C32(0xe1690000),
    SPH_C32(0x5ff80000), SPH_C32(0x4d061f9d), SPH_C32(0x14316baf),
    SPH_C32(0x9d6ccc27), SPH_C32(0x9071ba2b), SPH_C32(0xc2ec0000),
    SPH_C32(0x89833a00), SPH_C32(0x0a660000), SPH_C32(0x00370000),
    SPH_C32(0x5f2f0b0c), SPH_C32(0x608b430c), SPH_C32(0xdaa88a5d),
    SPH_C32(0x64846dae) },
  { SPH_C32(0xabb70000), SPH_C32(0x844e3f00), SPH_C32(0xa3100000),
    SPH_C32(0x03120000), SPH_C32(0x7eac2f87), SPH_C32(0x01b34ebb),
    SPH_C32(0x08cf875c), SPH_C32(0x243ababb), SPH_C32(0x3cce0000),
    SPH_C32(0x2edb3f00), SPH_C32(0x2fb70000), SPH_C32(0xf7570000),
    SPH_C32(0xd61e73d6), SPH_C32(0x7f5fbb6c), SPH_C32(0x94782948),
    SPH_C32(0xc5a79231) },
  { SPH_C32(0x75c90003), SPH_C32(0x0e10c000), SPH_C32(0xd1200000),
    SPH_C32(0xbaea0000), SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757),
    SPH_C32(0xbb28761d), SPH_C32(0x00b72e2b), SPH_C32(0xeecf0001),
    SPH_C32(0x6f564000), SPH_C32(0xf33e0000), SPH_C32(0xa79e0000),
    SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5), SPH_C32(0x4a3b40ba),
    SPH_C32(0xfeabf254) },
  { SPH_C32(0x79bb0003), SPH_C32(0x47f5cf00), SPH_C32(0x93590000),
    SPH_C32(0xe6000000), SPH_C32(0xb86e1f24), SPH_C32(0x92da9243),
    SPH_C32(0x2e8b3d66), SPH_C32(0xb4fc2ebb), SPH_C32(0x10ed0001),
    SPH_C32(0xc80e4500), SPH_C32(0xd6ef0000), SPH_C32(0x50fe0000),
    SPH_C32(0x34840ac3), SPH_C32(0xa8c513a5), SPH_C32(0x04ebe3af),
    SPH_C32(0x5f880dcb) },
  { SPH_C32(0x8beb0003), SPH_C32(0xa948c500), SPH_C32(0xf4f10000),
    SPH_C32(0x4d8a0000), SPH_C32(0x02f557e4), SPH_C32(0x988c4f37),
    SPH_C32(0xf5f8d508), SPH_C32(0xa194d1b4), SPH_C32(0x1c9f0001),
    SPH_C32(0x81eb4a00), SPH_C32(0x94960000), SPH_C32(0x0c140000),
    SPH_C32(0x072e3ad9), SPH_C32(0xbd4736b1), SPH_C32(0x9148a8d4),
    SPH_C32(0xebc30d5b) },
  { SPH_C32(0x87990003), SPH_C32(0xe0adca00), SPH_C32(0xb6880000),
    SPH_C32(0x11600000), SPH_C32(0x315f67fe), SPH_C32(0x8d0e6a23),
    SPH_C32(0x605b9e73), SPH_C32(0x15dfd124), SPH_C32(0xe2bd0001),
    SPH_C32(0x26b34f00), SPH_C32(0xb1470000), SPH_C32(0xfb740000),
    SPH_C32(0x8e1f4203), SPH_C32(0xa293ced1), SPH_C32(0xdf980bc1),
    SPH_C32(0x4ae0f2c4) },
  { SPH_C32(0x30d10003), SPH_C32(0xaba5d700), SPH_C32(0x284a0000),
    SPH_C32(0x81a20000), SPH_C32(0x95083b12), SPH_C32(0xa44b2281),
    SPH_C32(0xad94d0ad), SPH_C32(0xdf84daf4), SPH_C32(0x56f20001),
    SPH_C32(0x79274600), SPH_C32(0xc4a40000), SPH_C32(0x522f0000),
    SPH_C32(0x9f3413b5), SPH_C32(0x19591a80), SPH_C32(0x2c1f56ac),
    SPH_C32(0x3b6a196a) },
  { SPH_C32(0x3ca30003), SPH_C32(0xe240d800), SPH_C32(0x6a330000),
    SPH_C32(0xdd480000), SPH_C32(0xa6a20b08), SPH_C32(0xb1c90795),
    SPH_C32(0x38379bd6), SPH_C32(0x6bcfda64), SPH_C32(0xa8d00001),
    SPH_C32(0xde7f4300), SPH_C32(0xe1750000), SPH_C32(0xa54f0000),
    SPH_C32(0x16056b6f), SPH_C32(0x068de2e0), SPH_C32(0x62cff5b9),
    SPH_C32(0x9a49e6f5) },
  { SPH_C32(0xcef30003), SPH_C32(0x0cfdd200), SPH_C32(0x0d9b0000),
    SPH_C32(0x76c20000), SPH_C32(0x1c3943c8), SPH_C32(0xbb9fdae1),
    SPH_C32(0xe34473b8), SPH_C32(0x7ea7256b), SPH_C32(0xa4a20001),
    SPH_C32(0x979a4c00), SPH_C32(0xa30c0000), SPH_C32(0xf9a50000),
    SPH_C32(0x25af5b75), SPH_C32(0x130fc7f4), SPH_C32(0xf76cbec2),
    SPH_C32(0x2e02e665) },
  { SPH_C32(0xc2810003), SPH_C32(0x4518dd00), SPH_C32(0x4fe20000),
    SPH_C32(0x2a280000), SPH_C32(0x2f9373d2), SPH_C32(0xae1dfff5),
    SPH_C32(0x76e738c3), SPH_C32(0xcaec25fb), SPH_C32(0x5a800001),
    SPH_C32(0x30c24900), SPH_C32(0x86dd0000), SPH_C32(0x0ec50000),
    SPH_C32(0xac9e23af), SPH_C32(0x0cdb3f94), SPH_C32(0xb9bc1dd7),
    SPH_C32(0x8f2119fa) },
  { SPH_C32(0xcdf40003), SPH_C32(0x1861c600), SPH_C32(0xe6ba0000),
    SPH_C32(0x4f5b0000), SPH_C32(0xa9454e92), SPH_C32(0x29104612),
    SPH_C32(0xdd0c600b), SPH_C32(0xc576c515), SPH_C32(0x13ea0001),
    SPH_C32(0xdc925100), SPH_C32(0x3dce0000), SPH_C32(0x69670000),
    SPH_C32(0x81f80799), SPH_C32(0x3a4a8f56), SPH_C32(0x3aa3f01c),
    SPH_C32(0xe459edb5) },
  { SPH_C32(0xc1860003), SPH_C32(0x5184c900), SPH_C32(0xa4c30000),
    SPH_C32(0x13b10000), SPH_C32(0x9aef7e88), SPH_C32(0x3c926306),
    SPH_C32(0x48af2b70), SPH_C32(0x713dc585), SPH_C32(0xedc80001),
    SPH_C32(0x7bca5400), SPH_C32(0x181f0000), SPH_C32(0x9e070000),
    SPH_C32(0x08c97f43), SPH_C32(0x259e7736), SPH_C32(0x74735309),
    SPH_C32(0x457a122a) },
  { SPH_C32(0x33d60003), SPH_C32(0xbf39c300), SPH_C32(0xc36b0000),
    SPH_C32(0xb83b0000), SPH_C32(0x20743648), SPH_C32(0x36c4be72),
    SPH_C32(0x93dcc31e), SPH_C32(0x64553a8a), SPH_C32(0xe1ba0001),
    SPH_C32(0x322f5b00), SPH_C32(0x5a660000), SPH_C32(0xc2ed0000),
    SPH_C32(0x3b634f59), SPH_C32(0x301c5222), SPH_C32(0xe1d01872),
    SPH_C32(0xf13112ba) },
  { SPH_C32(0x3fa40003), SPH_C32(0xf6dccc00), SPH_C32(0x81120000),
    SPH_C32(0xe4d10000), SPH_C32(0x13de0652), SPH_C32(0x23469b66),
    SPH_C32(0x067f8865), SPH_C32(0xd01e3a1a), SPH_C32(0x1f980001),
    SPH_C32(0x95775e00), SPH_C32(0x7fb70000), SPH_C32(0x358d0000),
    SPH_C32(0xb2523783), SPH_C32(0x2fc8aa42), SPH_C32(0xaf00bb67),
    SPH_C32(0x5012ed25) },
  { SPH_C32(0x88ec0003), SPH_C32(0xbdd4d100), SPH_C32(0x1fd00000),
    SPH_C32(0x74130000), SPH_C32(0xb7895abe), SPH_C32(0x0a03d3c4),
    SPH_C32(0xcbb0c6bb), SPH_C32(0x1a4531ca), SPH_C32(0xabd70001),
    SPH_C32(0xcae35700), SPH_C32(0x0a540000), SPH_C32(0x9cd60000),
    SPH_C32(0xa3796635), SPH_C32(0x94027e13), SPH_C32(0x5c87e60a),
    SPH_C32(0x2198068b) },
  { SPH_C32(0x849e0003), SPH_C32(0xf431de00), SPH_C32(0x5da90000),
    SPH_C32(0x28f90000), SPH_C32(0x84236aa4), SPH_C32(0x1f81f6d0),
    SPH_C32(0x5e138dc0), SPH_C32(0xae0e315a), SPH_C32(0x55f50001),
    SPH_C32(0x6dbb5200), SPH_C32(0x2f850000), SPH_C32(0x6bb60000),
    SPH_C32(0x2a481eef), SPH_C32(0x8bd68673), SPH_C32(0x1257451f),
    SPH_C32(0x80bbf914) },
  { SPH_C32(0x76ce0003), SPH_C32(0x1a8cd400), SPH_C32(0x3a010000),
    SPH_C32(0x83730000), SPH_C32(0x3eb82264), SPH_C32(0x15d72ba4),
    SPH_C32(0x856065ae), SPH_C32(0xbb66ce55), SPH_C32(0x59870001),
    SPH_C32(0x245e5d00), SPH_C32(0x6dfc0000), SPH_C32(0x375c0000),
    SPH_C32(0x19e22ef5), SPH_C32(0x9e54a367), SPH_C32(0x87f40e64),
    SPH_C32(0x34f0f984) },
  { SPH_C32(0x7abc0003), SPH_C32(0x5369db00), SPH_C32(0x78780000),
    SPH_C32(0xdf990000), SPH_C32(0x0d12127e), SPH_C32(0x00550eb0),
    SPH_C32(0x10c32ed5), SPH_C32(0x0f2dcec5), SPH_C32(0xa7a50001),
    SPH_C32(0x83065800), SPH_C32(0x482d0000), SPH_C32(0xc03c0000),
    SPH_C32(0x90d3562f), SPH_C32(0x81805b07), SPH_C32(0xc924ad71),
    SPH_C32(0x95d3061b) },
  { SPH_C32(0x006d0003), SPH_C32(0xcc9be700), SPH_C32(0x45840000),
    SPH_C32(0x2a1f0000), SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9),
    SPH_C32(0xac4fb29e), SPH_C32(0xae684855), SPH_C32(0x3fa90001),
    SPH_C32(0x74ea4300), SPH_C32(0x6dd20000), SPH_C32(0x510a0000),
    SPH_C32(0xbeb7373e), SPH_C32(0x78611737), SPH_C32(0xfe785bad),
    SPH_C32(0x7bd4ce7f) },
  { SPH_C32(0x0c1f0003), SPH_C32(0x857ee800), SPH_C32(0x07fd0000),
    SPH_C32(0x76f50000), SPH_C32(0x431648c4), SPH_C32(0xdb1499ed),
    SPH_C32(0x39ecf9e5), SPH_C32(0x1a2348c5), SPH_C32(0xc18b0001),
    SPH_C32(0xd3b24600), SPH_C32(0x48030000), SPH_C32(0xa66a0000),
    SPH_C32(0x37864fe4), SPH_C32(0x67b5ef57), SPH_C32(0xb0a8f8b8),
    SPH_C32(0xdaf731e0) },
  { SPH_C32(0xfe4f0003), SPH_C32(0x6bc3e200), SPH_C32(0x60550000),
    SPH_C32(0xdd7f0000), SPH_C32(0xf98d0004), SPH_C32(0xd1424499),
    SPH_C32(0xe29f118b), SPH_C32(0x0f4bb7ca), SPH_C32(0xcdf90001),
    SPH_C32(0x9a574900), SPH_C32(0x0a7a0000), SPH_C32(0xfa800000),
    SPH_C32(0x042c7ffe), SPH_C32(0x7237ca43), SPH_C32(0x250bb3c3),
    SPH_C32(0x6ebc3170) },
  { SPH_C32(0xf23d0003), SPH_C32(0x2226ed00), SPH_C32(0x222c0000),
    SPH_C32(0x81950000), SPH_C32(0xca27301e), SPH_C32(0xc4c0618d),
    SPH_C32(0x773c5af0), SPH_C32(0xbb00b75a), SPH_C32(0x33db0001),
    SPH_C32(0x3d0f4c00), SPH_C32(0x2fab0000), SPH_C32(0x0de00000),
    SPH_C32(0x8d1d0724), SPH_C32(0x6de33223), SPH_C32(0x6bdb10d6),
    SPH_C32(0xcf9fceef) },
  { SPH_C32(0x45750003), SPH_C32(0x692ef000), SPH_C32(0xbcee0000),
    SPH_C32(0x11570000), SPH_C32(0x6e706cf2), SPH_C32(0xed85292f),
    SPH_C32(0xbaf3142e), SPH_C32(0x715bbc8a), SPH_C32(0x87940001),
    SPH_C32(0x629b4500), SPH_C32(0x5a480000), SPH_C32(0xa4bb0000),
    SPH_C32(0x9c365692), SPH_C32(0xd629e672), SPH_C32(0x985c4dbb),
    SPH_C32(0xbe152541) },
  { SPH_C32(0x49070003), SPH_C32(0x20cbff00), SPH_C32(0xfe970000),
    SPH_C32(0x4dbd0000), SPH_C32(0x5dda5ce8), SPH_C32(0xf8070c3b),
    SPH_C32(0x2f505f55), SPH_C32(0xc510bc1a), SPH_C32(0x79b60001),
    SPH_C32(0xc5c34000), SPH_C32(0x7f990000), SPH_C32(0x53db0000),
    SPH_C32(0x15072e48), SPH_C32(0xc9fd1e12), SPH_C32(0xd68ceeae),
    SPH_C32(0x1f36dade) },
  { SPH_C32(0xbb570003), SPH_C32(0xce76f500), SPH_C32(0x993f0000),
    SPH_C32(0xe6370000), SPH_C32(0xe7411428), SPH_C32(0xf251d14f),
    SPH_C32(0xf423b73b), SPH_C32(0xd0784315), SPH_C32(0x75c40001),
    SPH_C32(0x8c264f00), SPH_C32(0x3de00000), SPH_C32(0x0f310000),
    SPH_C32(0x26ad1e52), SPH_C32(0xdc7f3b06), SPH_C32(0x432fa5d5),
    SPH_C32(0xab7dda4e) },
  { SPH_C32(0xb7250003), SPH_C32(0x8793fa00), SPH_C32(0xdb460000),
    SPH_C32(0xbadd0000), SPH_C32(0xd4eb2432), SPH_C32(0xe7d3f45b),
    SPH_C32(0x6180fc40), SPH_C32(0x64334385), SPH_C32(0x8be60001),
    SPH_C32(0x2b7e4a00), SPH_C32(0x18310000), SPH_C32(0xf8510000),
    SPH_C32(0xaf9c6688), SPH_C32(0xc3abc366), SPH_C32(0x0dff06c0),
    SPH_C32(0x0a5e25d1) },
  { SPH_C32(0xb8500003), SPH_C32(0xdaeae100), SPH_C32(0x721e0000),
    SPH_C32(0xdfae0000), SPH_C32(0x523d1972), SPH_C32(0x60de4dbc),
    SPH_C32(0xca6ba488), SPH_C32(0x6ba9a36b), SPH_C32(0xc28c0001),
    SPH_C32(0xc72e5200), SPH_C32(0xa3220000), SPH_C32(0x9ff30000),
    SPH_C32(0x82fa42be), SPH_C32(0xf53a73a4), SPH_C32(0x8ee0eb0b),
    SPH_C32(0x6126d19e) },
  { SPH_C32(0xb4220003), SPH_C32(0x930fee00), SPH_C32(0x30670000),
    SPH_C32(0x83440000), SPH_C32(0x61972968), SPH_C32(0x755c68a8),
    SPH_C32(0x5fc8eff3), SPH_C32(0xdfe2a3fb), SPH_C32(0x3cae0001),
    SPH_C32(0x60765700), SPH_C32(0x86f30000), SPH_C32(0x68930000),
    SPH_C32(0x0bcb3a64), SPH_C32(0xeaee8bc4), SPH_C32(0xc030481e),
    SPH_C32(0xc0052e01) },
  { SPH_C32(0x46720003), SPH_C32(0x7db2e400), SPH_C32(0x57cf0000),
    SPH_C32(0x28ce0000), SPH_C32(0xdb0c61a8), SPH_C32(0x7f0ab5dc),
    SPH_C32(0x84bb079d), SPH_C32(0xca8a5cf4), SPH_C32(0x30dc0001),
    SPH_C32(0x29935800), SPH_C32(0xc48a0000), SPH_C32(0x34790000),
    SPH_C32(0x38610a7e), SPH_C32(0xff6caed0), SPH_C32(0x55930365),
    SPH_C32(0x744e2e91) },
  { SPH_C32(0x4a000003), SPH_C32(0x3457eb00), SPH_C32(0x15b60000),
    SPH_C32(0x74240000), SPH_C32(0xe8a651b2), SPH_C32(0x6a8890c8),
    SPH_C32(0x11184ce6), SPH_C32(0x7ec15c64), SPH_C32(0xcefe0001),
    SPH_C32(0x8ecb5d00), SPH_C32(0xe15b0000), SPH_C32(0xc3190000),
    SPH_C32(0xb15072a4), SPH_C32(0xe0b856b0), SPH_C32(0x1b43a070),
    SPH_C32(0xd56dd10e) },
  { SPH_C32(0xfd480003), SPH_C32(0x7f5ff600), SPH_C32(0x8b740000),
    SPH_C32(0xe4e60000), SPH_C32(0x4cf10d5e), SPH_C32(0x43cdd86a),
    SPH_C32(0xdcd70238), SPH_C32(0xb49a57b4), SPH_C32(0x7ab10001),
    SPH_C32(0xd15f5400), SPH_C32(0x94b80000), SPH_C32(0x6a420000),
    SPH_C32(0xa07b2312), SPH_C32(0x5b7282e1), SPH_C32(0xe8c4fd1d),
    SPH_C32(0xa4e73aa0) },
  { SPH_C32(0xf13a0003), SPH_C32(0x36baf900), SPH_C32(0xc90d0000),
    SPH_C32(0xb80c0000), SPH_C32(0x7f5b3d44), SPH_C32(0x564ffd7e),
    SPH_C32(0x49744943), SPH_C32(0x00d15724), SPH_C32(0x84930001),
    SPH_C32(0x76075100), SPH_C32(0xb1690000), SPH_C32(0x9d220000),
    SPH_C32(0x294a5bc8), SPH_C32(0x44a67a81), SPH_C32(0xa6145e08),
    SPH_C32(0x05c4c53f) },
  { SPH_C32(0x036a0003), SPH_C32(0xd807f300), SPH_C32(0xaea50000),
    SPH_C32(0x13860000), SPH_C32(0xc5c07584), SPH_C32(0x5c19200a),
    SPH_C32(0x9207a12d), SPH_C32(0x15b9a82b), SPH_C32(0x88e10001),
    SPH_C32(0x3fe25e00), SPH_C32(0xf3100000), SPH_C32(0xc1c80000),
    SPH_C32(0x1ae06bd2), SPH_C32(0x51245f95), SPH_C32(0x33b71573),
    SPH_C32(0xb18fc5af) },
  { SPH_C32(0x0f180003), SPH_C32(0x91e2fc00), SPH_C32(0xecdc0000),
    SPH_C32(0x4f6c0000), SPH_C32(0xf66a459e), SPH_C32(0x499b051e),
    SPH_C32(0x07a4ea56), SPH_C32(0xa1f2a8bb), SPH_C32(0x76c30001),
    SPH_C32(0x98ba5b00), SPH_C32(0xd6c10000), SPH_C32(0x36a80000),
    SPH_C32(0x93d11308), SPH_C32(0x4ef0a7f5), SPH_C32(0x7d67b666),
    SPH_C32(0x10ac3a30) },
  { SPH_C32(0xa4af0003), SPH_C32(0x15acc300), SPH_C32(0x4fcc0000),
    SPH_C32(0x4c7e0000), SPH_C32(0x88c66a19), SPH_C32(0x48284ba5),
    SPH_C32(0x0f6b6d0a), SPH_C32(0x85c81200), SPH_C32(0x4a0d0001),
    SPH_C32(0xb6616400), SPH_C32(0xf9760000), SPH_C32(0xc1ff0000),
    SPH_C32(0x45cf60de), SPH_C32(0x31af1c99), SPH_C32(0xe91f9f2e),
    SPH_C32(0xd50ba801) },
  { SPH_C32(0xa8dd0003), SPH_C32(0x5c49cc00), SPH_C32(0x0db50000),
    SPH_C32(0x10940000), SPH_C32(0xbb6c5a03), SPH_C32(0x5daa6eb1),
    SPH_C32(0x9ac82671), SPH_C32(0x31831290), SPH_C32(0xb42f0001),
    SPH_C32(0x11396100), SPH_C32(0xdca70000), SPH_C32(0x369f0000),
    SPH_C32(0xccfe1804), SPH_C32(0x2e7be4f9), SPH_C32(0xa7cf3c3b),
    SPH_C32(0x7428579e) },
  { SPH_C32(0x5a8d0003), SPH_C32(0xb2f4c600), SPH_C32(0x6a1d0000),
    SPH_C32(0xbb1e0000), SPH_C32(0x01f712c3), SPH_C32(0x57fcb3c5),
    SPH_C32(0x41bbce1f), SPH_C32(0x24ebed9f), SPH_C32(0xb85d0001),
    SPH_C32(0x58dc6e00), SPH_C32(0x9ede0000), SPH_C32(0x6a750000),
    SPH_C32(0xff54281e), SPH_C32(0x3bf9c1ed), SPH_C32(0x326c7740),
    SPH_C32(0xc063570e) },
  { SPH_C32(0x56ff0003), SPH_C32(0xfb11c900), SPH_C32(0x28640000),
    SPH_C32(0xe7f40000), SPH_C32(0x325d22d9), SPH_C32(0x427e96d1),
    SPH_C32(0xd4188564), SPH_C32(0x90a0ed0f), SPH_C32(0x467f0001),
    SPH_C32(0xff846b00), SPH_C32(0xbb0f0000), SPH_C32(0x9d150000),
    SPH_C32(0x766550c4), SPH_C32(0x242d398d), SPH_C32(0x7cbcd455),
    SPH_C32(0x6140a891) },
  { SPH_C32(0xe1b70003), SPH_C32(0xb019d400), SPH_C32(0xb6a60000),
    SPH_C32(0x77360000), SPH_C32(0x960a7e35), SPH_C32(0x6b3bde73),
    SPH_C32(0x19d7cbba), SPH_C32(0x5afbe6df), SPH_C32(0xf2300001),
    SPH_C32(0xa0106200), SPH_C32(0xceec0000), SPH_C32(0x344e0000),
    SPH_C32(0x674e0172), SPH_C32(0x9fe7eddc), SPH_C32(0x8f3b8938),
    SPH_C32(0x10ca433f) },
  { SPH_C32(0xedc50003), SPH_C32(0xf9fcdb00), SPH_C32(0xf4df0000),
    SPH_C32(0x2bdc0000), SPH_C32(0xa5a04e2f), SPH_C32(0x7eb9fb67),
    SPH_C32(0x8c7480c1), SPH_C32(0xeeb0e64f), SPH_C32(0x0c120001),
    SPH_C32(0x07486700), SPH_C32(0xeb3d0000), SPH_C32(0xc32e0000),
    SPH_C32(0xee7f79a8), SPH_C32(0x803315bc), SPH_C32(0xc1eb2a2d),
    SPH_C32(0xb1e9bca0) },
  { SPH_C32(0x1f950003), SPH_C32(0x1741d100), SPH_C32(0x93770000),
    SPH_C32(0x80560000), SPH_C32(0x1f3b06ef), SPH_C32(0x74ef2613),
    SPH_C32(0x570768af), SPH_C32(0xfbd81940), SPH_C32(0x00600001),
    SPH_C32(0x4ead6800), SPH_C32(0xa9440000), SPH_C32(0x9fc40000),
    SPH_C32(0xddd549b2), SPH_C32(0x95b130a8), SPH_C32(0x54486156),
    SPH_C32(0x05a2bc30) },
  { SPH_C32(0x13e70003), SPH_C32(0x5ea4de00), SPH_C32(0xd10e0000),
    SPH_C32(0xdcbc0000), SPH_C32(0x2c9136f5), SPH_C32(0x616d0307),
    SPH_C32(0xc2a423d4), SPH_C32(0x4f9319d0), SPH_C32(0xfe420001),
    SPH_C32(0xe9f56d00), SPH_C32(0x8c950000), SPH_C32(0x68a40000),
    SPH_C32(0x54e43168), SPH_C32(0x8a65c8c8), SPH_C32(0x1a98c243),
    SPH_C32(0xa48143af) },
  { SPH_C32(0x1c920003), SPH_C32(0x03ddc500), SPH_C32(0x78560000),
    SPH_C32(0xb9cf0000), SPH_C32(0xaa470bb5), SPH_C32(0xe660bae0),
    SPH_C32(0x694f7b1c), SPH_C32(0x4009f93e), SPH_C32(0xb7280001),
    SPH_C32(0x05a57500), SPH_C32(0x37860000), SPH_C32(0x0f060000),
    SPH_C32(0x7982155e), SPH_C32(0xbcf4780a), SPH_C32(0x99872f88),
    SPH_C32(0xcff9b7e0) },
  { SPH_C32(0x10e00003), SPH_C32(0x4a38ca00), SPH_C32(0x3a2f0000),
    SPH_C32(0xe5250000), SPH_C32(0x99ed3baf), SPH_C32(0xf3e29ff4),
    SPH_C32(0xfcec3067), SPH_C32(0xf442f9ae), SPH_C32(0x490a0001),
    SPH_C32(0xa2fd7000), SPH_C32(0x12570000), SPH_C32(0xf8660000),
    SPH_C32(0xf0b36d84), SPH_C32(0xa320806a), SPH_C32(0xd7578c9d),
    SPH_C32(0x6eda487f) },
  { SPH_C32(0xe2b00003), SPH_C32(0xa485c000), SPH_C32(0x5d870000),
    SPH_C32(0x4eaf0000), SPH_C32(0x2376736f), SPH_C32(0xf9b44280),
    SPH_C32(0x279fd809), SPH_C32(0xe12a06a1), SPH_C32(0x45780001),
    SPH_C32(0xeb187f00), SPH_C32(0x502e0000), SPH_C32(0xa48c0000),
    SPH_C32(0xc3195d9e), SPH_C32(0xb6a2a57e), SPH_C32(0x42f4c7e6),
    SPH_C32(0xda9148ef) },
  { SPH_C32(0xeec20003), SPH_C32(0xed60cf00), SPH_C32(0x1ffe0000),
    SPH_C32(0x12450000), SPH_C32(0x10dc4375), SPH_C32(0xec366794),
    SPH_C32(0xb23c9372), SPH_C32(0x55610631), SPH_C32(0xbb5a0001),
    SPH_C32(0x4c407a00), SPH_C32(0x75ff0000), SPH_C32(0x53ec0000),
    SPH_C32(0x4a282544), SPH_C32(0xa9765d1e), SPH_C32(0x0c2464f3),
    SPH_C32(0x7bb2b770) },
  { SPH_C32(0x598a0003), SPH_C32(0xa668d200), SPH_C32(0x813c0000),
    SPH_C32(0x82870000), SPH_C32(0xb48b1f99), SPH_C32(0xc5732f36),
    SPH_C32(0x7ff3ddac), SPH_C32(0x9f3a0de1), SPH_C32(0x0f150001),
    SPH_C32(0x13d47300), SPH_C32(0x001c0000), SPH_C32(0xfab70000),
    SPH_C32(0x5b0374f2), SPH_C32(0x12bc894f), SPH_C32(0xffa3399e),
    SPH_C32(0x0a385cde) },
  { SPH_C32(0x55f80003), SPH_C32(0xef8ddd00), SPH_C32(0xc3450000),
    SPH_C32(0xde6d0000), SPH_C32(0x87212f83), SPH_C32(0xd0f10a22),
    SPH_C32(0xea5096d7), SPH_C32(0x2b710d71), SPH_C32(0xf1370001),
    SPH_C32(0xb48c7600), SPH_C32(0x25cd0000), SPH_C32(0x0dd70000),
    SPH_C32(0xd2320c28), SPH_C32(0x0d68712f), SPH_C32(0xb1739a8b),
    SPH_C32(0xab1ba341) },
  { SPH_C32(0xa7a80003), SPH_C32(0x0130d700), SPH_C32(0xa4ed0000),
    SPH_C32(0x75e70000), SPH_C32(0x3dba6743), SPH_C32(0xdaa7d756),
    SPH_C32(0x31237eb9), SPH_C32(0x3e19f27e), SPH_C32(0xfd450001),
    SPH_C32(0xfd697900), SPH_C32(0x67b40000), SPH_C32(0x513d0000),
    SPH_C32(0xe1983c32), SPH_C32(0x18ea543b), SPH_C32(0x24d0d1f0),
    SPH_C32(0x1f50a3d1) },
  { SPH_C32(0xabda0003), SPH_C32(0x48d5d800), SPH_C32(0xe6940000),
    SPH_C32(0x290d0000), SPH_C32(0x0e105759), SPH_C32(0xcf25f242),
    SPH_C32(0xa48035c2), SPH_C32(0x8a52f2ee), SPH_C32(0x03670001),
    SPH_C32(0x5a317c00), SPH_C32(0x42650000), SPH_C32(0xa65d0000),
    SPH_C32(0x68a944e8), SPH_C32(0x073eac5b), SPH_C32(0x6a0072e5),
    SPH_C32(0xbe735c4e) },
  { SPH_C32(0xd10b0003), SPH_C32(0xd727e400), SPH_C32(0xdb680000),
    SPH_C32(0xdc8b0000), SPH_C32(0x73be3df9), SPH_C32(0x01e6400b),
    SPH_C32(0x180ca989), SPH_C32(0x2b17747e), SPH_C32(0x9b6b0001),
    SPH_C32(0xaddd6700), SPH_C32(0x679a0000), SPH_C32(0x376b0000),
    SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b), SPH_C32(0x5d5c8439),
    SPH_C32(0x5074942a) },
  { SPH_C32(0xdd790003), SPH_C32(0x9ec2eb00), SPH_C32(0x99110000),
    SPH_C32(0x80610000), SPH_C32(0x40140de3), SPH_C32(0x1464651f),
    SPH_C32(0x8dafe2f2), SPH_C32(0x9f5c74ee), SPH_C32(0x65490001),
    SPH_C32(0x0a856200), SPH_C32(0x424b0000), SPH_C32(0xc00b0000),
    SPH_C32(0xcffc5d23), SPH_C32(0xe10b180b), SPH_C32(0x138c272c),
    SPH_C32(0xf1576bb5) },
  { SPH_C32(0x2f290003), SPH_C32(0x707fe100), SPH_C32(0xfeb90000),
    SPH_C32(0x2beb0000), SPH_C32(0xfa8f4523), SPH_C32(0x1e32b86b),
    SPH_C32(0x56dc0a9c), SPH_C32(0x8a348be1), SPH_C32(0x693b0001),
    SPH_C32(0x43606d00), SPH_C32(0x00320000), SPH_C32(0x9ce10000),
    SPH_C32(0xfc566d39), SPH_C32(0xf4893d1f), SPH_C32(0x862f6c57),
    SPH_C32(0x451c6b25) },
  { SPH_C32(0x235b0003), SPH_C32(0x399aee00), SPH_C32(0xbcc00000),
    SPH_C32(0x77010000), SPH_C32(0xc9257539), SPH_C32(0x0bb09d7f),
    SPH_C32(0xc37f41e7), SPH_C32(0x3e7f8b71), SPH_C32(0x97190001),
    SPH_C32(0xe4386800), SPH_C32(0x25e30000), SPH_C32(0x6b810000),
    SPH_C32(0x756715e3), SPH_C32(0xeb5dc57f), SPH_C32(0xc8ffcf42),
    SPH_C32(0xe43f94ba) },
  { SPH_C32(0x94130003), SPH_C32(0x7292f300), SPH_C32(0x22020000),
    SPH_C32(0xe7c30000), SPH_C32(0x6d7229d5), SPH_C32(0x22f5d5dd),
    SPH_C32(0x0eb00f39), SPH_C32(0xf42480a1), SPH_C32(0x23560001),
    SPH_C32(0xbbac6100), SPH_C32(0x50000000), SPH_C32(0xc2da0000),
    SPH_C32(0x644c4455), SPH_C32(0x5097112e), SPH_C32(0x3b78922f),
    SPH_C32(0x95b57f14) },
  { SPH_C32(0x98610003), SPH_C32(0x3b77fc00), SPH_C32(0x607b0000),
    SPH_C32(0xbb290000), SPH_C32(0x5ed819cf), SPH_C32(0x3777f0c9),
    SPH_C32(0x9b134442), SPH_C32(0x406f8031), SPH_C32(0xdd740001),
    SPH_C32(0x1cf46400), SPH_C32(0x75d10000), SPH_C32(0x35ba0000),
    SPH_C32(0xed7d3c8f), SPH_C32(0x4f43e94e), SPH_C32(0x75a8313a),
    SPH_C32(0x3496808b) },
  { SPH_C32(0x6a310003), SPH_C32(0xd5caf600), SPH_C32(0x07d30000),
    SPH_C32(0x10a30000), SPH_C32(0xe443510f), SPH_C32(0x3d212dbd),
    SPH_C32(0x4060ac2c), SPH_C32(0x55077f3e), SPH_C32(0xd1060001),
    SPH_C32(0x55116b00), SPH_C32(0x37a80000), SPH_C32(0x69500000),
    SPH_C32(0xded70c95), SPH_C32(0x5ac1cc5a), SPH_C32(0xe00b7a41),
    SPH_C32(0x80dd801b) },
  { SPH_C32(0x66430003), SPH_C32(0x9c2ff900), SPH_C32(0x45aa0000),
    SPH_C32(0x4c490000), SPH_C32(0xd7e96115), SPH_C32(0x28a308a9),
    SPH_C32(0xd5c3e757), SPH_C32(0xe14c7fae), SPH_C32(0x2f240001),
    SPH_C32(0xf2496e00), SPH_C32(0x12790000), SPH_C32(0x9e300000),
    SPH_C32(0x57e6744f), SPH_C32(0x4515343a), SPH_C32(0xaedbd954),
    SPH_C32(0x21fe7f84) },
  { SPH_C32(0x69360003), SPH_C32(0xc156e200), SPH_C32(0xecf20000),
    SPH_C32(0x293a0000), SPH_C32(0x513f5c55), SPH_C32(0xafaeb14e),
    SPH_C32(0x7e28bf9f), SPH_C32(0xeed69f40), SPH_C32(0x664e0001),
    SPH_C32(0x1e197600), SPH_C32(0xa96a0000), SPH_C32(0xf9920000),
    SPH_C32(0x7a805079), SPH_C32(0x738484f8), SPH_C32(0x2dc4349f),
    SPH_C32(0x4a868bcb) },
  { SPH_C32(0x65440003), SPH_C32(0x88b3ed00), SPH_C32(0xae8b0000),
    SPH_C32(0x75d00000), SPH_C32(0x62956c4f), SPH_C32(0xba2c945a),
    SPH_C32(0xeb8bf4e4), SPH_C32(0x5a9d9fd0), SPH_C32(0x986c0001),
    SPH_C32(0xb9417300), SPH_C32(0x8cbb0000), SPH_C32(0x0ef20000),
    SPH_C32(0xf3b128a3), SPH_C32(0x6c507c98), SPH_C32(0x6314978a),
    SPH_C32(0xeba57454) },
  { SPH_C32(0x97140003), SPH_C32(0x660ee700), SPH_C32(0xc9230000),
    SPH_C32(0xde5a0000), SPH_C32(0xd80e248f), SPH_C32(0xb07a492e),
    SPH_C32(0x30f81c8a), SPH_C32(0x4ff560df), SPH_C32(0x941e0001),
    SPH_C32(0xf0a47c00), SPH_C32(0xcec20000), SPH_C32(0x52180000),
    SPH_C32(0xc01b18b9), SPH_C32(0x79d2598c), SPH_C32(0xf6b7dcf1),
    SPH_C32(0x5fee74c4) },
  { SPH_C32(0x9b660003), SPH_C32(0x2febe800), SPH_C32(0x8b5a0000),
    SPH_C32(0x82b00000), SPH_C32(0xeba41495), SPH_C32(0xa5f86c3a),
    SPH_C32(0xa55b57f1), SPH_C32(0xfbbe604f), SPH_C32(0x6a3c0001),
    SPH_C32(0x57fc7900), SPH_C32(0xeb130000), SPH_C32(0xa5780000),
    SPH_C32(0x492a6063), SPH_C32(0x6606a1ec), SPH_C32(0xb8677fe4),
    SPH_C32(0xfecd8b5b) },
  { SPH_C32(0x2c2e0003), SPH_C32(0x64e3f500), SPH_C32(0x15980000),
    SPH_C32(0x12720000), SPH_C32(0x4ff34879), SPH_C32(0x8cbd2498),
    SPH_C32(0x6894192f), SPH_C32(0x31e56b9f), SPH_C32(0xde730001),
    SPH_C32(0x08687000), SPH_C32(0x9ef00000), SPH_C32(0x0c230000),
    SPH_C32(0x580131d5), SPH_C32(0xddcc75bd), SPH_C32(0x4be02289),
    SPH_C32(0x8f4760f5) },
  { SPH_C32(0x205c0003), SPH_C32(0x2d06fa00), SPH_C32(0x57e10000),
    SPH_C32(0x4e980000), SPH_C32(0x7c597863), SPH_C32(0x993f018c),
    SPH_C32(0xfd375254), SPH_C32(0x85ae6b0f), SPH_C32(0x20510001),
    SPH_C32(0xaf307500), SPH_C32(0xbb210000), SPH_C32(0xfb430000),
    SPH_C32(0xd130490f), SPH_C32(0xc2188ddd), SPH_C32(0x0530819c),
    SPH_C32(0x2e649f6a) },
  { SPH_C32(0xd20c0003), SPH_C32(0xc3bbf000), SPH_C32(0x30490000),
    SPH_C32(0xe5120000), SPH_C32(0xc6c230a3), SPH_C32(0x9369dcf8),
    SPH_C32(0x2644ba3a), SPH_C32(0x90c69400), SPH_C32(0x2c230001),
    SPH_C32(0xe6d57a00), SPH_C32(0xf9580000), SPH_C32(0xa7a90000),
    SPH_C32(0xe29a7915), SPH_C32(0xd79aa8c9), SPH_C32(0x9093cae7),
    SPH_C32(0x9a2f9ffa) },
  { SPH_C32(0xde7e0003), SPH_C32(0x8a5eff00), SPH_C32(0x72300000),
    SPH_C32(0xb9f80000), SPH_C32(0xf56800b9), SPH_C32(0x86ebf9ec),
    SPH_C32(0xb3e7f141), SPH_C32(0x248d9490), SPH_C32(0xd2010001),
    SPH_C32(0x418d7f00), SPH_C32(0xdc890000), SPH_C32(0x50c90000),
    SPH_C32(0x6bab01cf), SPH_C32(0xc84e50a9), SPH_C32(0xde4369f2),
    SPH_C32(0x3b0c6065) },
  { SPH_C32(0xeecf0001), SPH_C32(0x6f564000), SPH_C32(0xf33e0000),
    SPH_C32(0xa79e0000), SPH_C32(0xbdb57219), SPH_C32(0xb711ebc5),
    SPH_C32(0x4a3b40ba), SPH_C32(0xfeabf254), SPH_C32(0x9b060002),
    SPH_C32(0x61468000), SPH_C32(0x221e0000), SPH_C32(0x1d740000),
    SPH_C32(0x36715d27), SPH_C32(0x30495c92), SPH_C32(0xf11336a7),
    SPH_C32(0xfe1cdc7f) },
  { SPH_C32(0xe2bd0001), SPH_C32(0x26b34f00), SPH_C32(0xb1470000),
    SPH_C32(0xfb740000), SPH_C32(0x8e1f4203), SPH_C32(0xa293ced1),
    SPH_C32(0xdf980bc1), SPH_C32(0x4ae0f2c4), SPH_C32(0x65240002),
    SPH_C32(0xc61e8500), SPH_C32(0x07cf0000), SPH_C32(0xea140000),
    SPH_C32(0xbf4025fd), SPH_C32(0x2f9da4f2), SPH_C32(0xbfc395b2),
    SPH_C32(0x5f3f23e0) },
  { SPH_C32(0x10ed0001), SPH_C32(0xc80e4500), SPH_C32(0xd6ef0000),
    SPH_C32(0x50fe0000), SPH_C32(0x34840ac3), SPH_C32(0xa8c513a5),
    SPH_C32(0x04ebe3af), SPH_C32(0x5f880dcb), SPH_C32(0x69560002),
    SPH_C32(0x8ffb8a00), SPH_C32(0x45b60000), SPH_C32(0xb6fe0000),
    SPH_C32(0x8cea15e7), SPH_C32(0x3a1f81e6), SPH_C32(0x2a60dec9),
    SPH_C32(0xeb742370) },
  { SPH_C32(0x1c9f0001), SPH_C32(0x81eb4a00), SPH_C32(0x94960000),
    SPH_C32(0x0c140000), SPH_C32(0x072e3ad9), SPH_C32(0xbd4736b1),
    SPH_C32(0x9148a8d4), SPH_C32(0xebc30d5b), SPH_C32(0x97740002),
    SPH_C32(0x28a38f00), SPH_C32(0x60670000), SPH_C32(0x419e0000),
    SPH_C32(0x05db6d3d), SPH_C32(0x25cb7986), SPH_C32(0x64b07ddc),
    SPH_C32(0x4a57dcef) },
  { SPH_C32(0xabd70001), SPH_C32(0xcae35700), SPH_C32(0x0a540000),
    SPH_C32(0x9cd60000), SPH_C32(0xa3796635), SPH_C32(0x94027e13),
    SPH_C32(0x5c87e60a), SPH_C32(0x2198068b), SPH_C32(0x233b0002),
    SPH_C32(0x77378600), SPH_C32(0x15840000), SPH_C32(0xe8c50000),
    SPH_C32(0x14f03c8b), SPH_C32(0x9e01add7), SPH_C32(0x973720b1),
    SPH_C32(0x3bdd3741) },
  { SPH_C32(0xa7a50001), SPH_C32(0x83065800), SPH_C32(0x482d0000),
    SPH_C32(0xc03c0000), SPH_C32(0x90d3562f), SPH_C32(0x81805b07),
    SPH_C32(0xc924ad71), SPH_C32(0x95d3061b), SPH_C32(0xdd190002),
    SPH_C32(0xd06f8300), SPH_C32(0x30550000), SPH_C32(0x1fa50000),
    SPH_C32(0x9dc14451), SPH_C32(0x81d555b7), SPH_C32(0xd9e783a4),
    SPH_C32(0x9afec8de) },
  { SPH_C32(0x55f50001), SPH_C32(0x6dbb5200), SPH_C32(0x2f850000),
    SPH_C32(0x6bb60000), SPH_C32(0x2a481eef), SPH_C32(0x8bd68673),
    SPH_C32(0x1257451f), SPH_C32(0x80bbf914), SPH_C32(0xd16b0002),
    SPH_C32(0x998a8c00), SPH_C32(0x722c0000), SPH_C32(0x434f0000),
    SPH_C32(0xae6b744b), SPH_C32(0x945770a3), SPH_C32(0x4c44c8df),
    SPH_C32(0x2eb5c84e) },
  { SPH_C32(0x59870001), SPH_C32(0x245e5d00), SPH_C32(0x6dfc0000),
    SPH_C32(0x375c0000), SPH_C32(0x19e22ef5), SPH_C32(0x9e54a367),
    SPH_C32(0x87f40e64), SPH_C32(0x34f0f984), SPH_C32(0x2f490002),
    SPH_C32(0x3ed28900), SPH_C32(0x57fd0000), SPH_C32(0xb42f0000),
    SPH_C32(0x275a0c91), SPH_C32(0x8b8388c3), SPH_C32(0x02946bca),
    SPH_C32(0x8f9637d1) },
  { SPH_C32(0x56f20001), SPH_C32(0x79274600), SPH_C32(0xc4a40000),
    SPH_C32(0x522f0000), SPH_C32(0x9f3413b5), SPH_C32(0x19591a80),
    SPH_C32(0x2c1f56ac), SPH_C32(0x3b6a196a), SPH_C32(0x66230002),
    SPH_C32(0xd2829100), SPH_C32(0xecee0000), SPH_C32(0xd38d0000),
    SPH_C32(0x0a3c28a7), SPH_C32(0xbd123801), SPH_C32(0x818b8601),
    SPH_C32(0xe4eec39e) },
  { SPH_C32(0x5a800001), SPH_C32(0x30c24900), SPH_C32(0x86dd0000),
    SPH_C32(0x0ec50000), SPH_C32(0xac9e23af), SPH_C32(0x0cdb3f94),
    SPH_C32(0xb9bc1dd7), SPH_C32(0x8f2119fa), SPH_C32(0x98010002),
    SPH_C32(0x75da9400), SPH_C32(0xc93f0000), SPH_C32(0x24ed0000),
    SPH_C32(0x830d507d), SPH_C32(0xa2c6c061), SPH_C32(0xcf5b2514),
    SPH_C32(0x45cd3c01) },
  { SPH_C32(0xa8d00001), SPH_C32(0xde7f4300), SPH_C32(0xe1750000),
    SPH_C32(0xa54f0000), SPH_C32(0x16056b6f), SPH_C32(0x068de2e0),
    SPH_C32(0x62cff5b9), SPH_C32(0x9a49e6f5), SPH_C32(0x94730002),
    SPH_C32(0x3c3f9b00), SPH_C32(0x8b460000), SPH_C32(0x78070000),
    SPH_C32(0xb0a76067), SPH_C32(0xb744e575), SPH_C32(0x5af86e6f),
    SPH_C32(0xf1863c91) },
  { SPH_C32(0xa4a20001), SPH_C32(0x979a4c00), SPH_C32(0xa30c0000),
    SPH_C32(0xf9a50000), SPH_C32(0x25af5b75), SPH_C32(0x130fc7f4),
    SPH_C32(0xf76cbec2), SPH_C32(0x2e02e665), SPH_C32(0x6a510002),
    SPH_C32(0x9b679e00), SPH_C32(0xae970000), SPH_C32(0x8f670000),
    SPH_C32(0x399618bd), SPH_C32(0xa8901d15), SPH_C32(0x1428cd7a),
    SPH_C32(0x50a5c30e) },
  { SPH_C32(0x13ea0001), SPH_C32(0xdc925100), SPH_C32(0x3dce0000),
    SPH_C32(0x69670000), SPH_C32(0x81f80799), SPH_C32(0x3a4a8f56),
    SPH_C32(0x3aa3f01c), SPH_C32(0xe459edb5), SPH_C32(0xde1e0002),
    SPH_C32(0xc4f39700), SPH_C32(0xdb740000), SPH_C32(0x263c0000),
    SPH_C32(0x28bd490b), SPH_C32(0x135ac944), SPH_C32(0xe7af9017),
    SPH_C32(0x212f28a0) },
  { SPH_C32(0x1f980001), SPH_C32(0x95775e00), SPH_C32(0x7fb70000),
    SPH_C32(0x358d0000), SPH_C32(0xb2523783), SPH_C32(0x2fc8aa42),
    SPH_C32(0xaf00bb67), SPH_C32(0x5012ed25), SPH_C32(0x203c0002),
    SPH_C32(0x63ab9200), SPH_C32(0xfea50000), SPH_C32(0xd15c0000),
    SPH_C32(0xa18c31d1), SPH_C32(0x0c8e3124), SPH_C32(0xa97f3302),
    SPH_C32(0x800cd73f) },
  { SPH_C32(0xedc80001), SPH_C32(0x7bca5400), SPH_C32(0x181f0000),
    SPH_C32(0x9e070000), SPH_C32(0x08c97f43), SPH_C32(0x259e7736),
    SPH_C32(0x74735309), SPH_C32(0x457a122a), SPH_C32(0x2c4e0002),
    SPH_C32(0x2a4e9d00), SPH_C32(0xbcdc0000), SPH_C32(0x8db60000),
    SPH_C32(0x922601cb), SPH_C32(0x190c1430), SPH_C32(0x3cdc7879),
    SPH_C32(0x3447d7af) },
  { SPH_C32(0xe1ba0001), SPH_C32(0x322f5b00), SPH_C32(0x5a660000),
    SPH_C32(0xc2ed0000), SPH_C32(0x3b634f59), SPH_C32(0x301c5222),
    SPH_C32(0xe1d01872), SPH_C32(0xf13112ba), SPH_C32(0xd26c0002),
    SPH_C32(0x8d169800), SPH_C32(0x990d0000), SPH_C32(0x7ad60000),
    SPH_C32(0x1b177911), SPH_C32(0x06d8ec50), SPH_C32(0x720cdb6c),
    SPH_C32(0x95642830) },
  { SPH_C32(0x9b6b0001), SPH_C32(0xaddd6700), SPH_C32(0x679a0000),
    SPH_C32(0x376b0000), SPH_C32(0x46cd25f9), SPH_C32(0xfedfe06b),
    SPH_C32(0x5d5c8439), SPH_C32(0x5074942a), SPH_C32(0x4a600002),
    SPH_C32(0x7afa8300), SPH_C32(0xbcf20000), SPH_C32(0xebe00000),
    SPH_C32(0x35731800), SPH_C32(0xff39a060), SPH_C32(0x45502db0),
    SPH_C32(0x7b63e054) },
  { SPH_C32(0x97190001), SPH_C32(0xe4386800), SPH_C32(0x25e30000),
    SPH_C32(0x6b810000), SPH_C32(0x756715e3), SPH_C32(0xeb5dc57f),
    SPH_C32(0xc8ffcf42), SPH_C32(0xe43f94ba), SPH_C32(0xb4420002),
    SPH_C32(0xdda28600), SPH_C32(0x99230000), SPH_C32(0x1c800000),
    SPH_C32(0xbc4260da), SPH_C32(0xe0ed5800), SPH_C32(0x0b808ea5),
    SPH_C32(0xda401fcb) },
  { SPH_C32(0x65490001), SPH_C32(0x0a856200), SPH_C32(0x424b0000),
    SPH_C32(0xc00b0000), SPH_C32(0xcffc5d23), SPH_C32(0xe10b180b),
    SPH_C32(0x138c272c), SPH_C32(0xf1576bb5), SPH_C32(0xb8300002),
    SPH_C32(0x94478900), SPH_C32(0xdb5a0000), SPH_C32(0x406a0000),
    SPH_C32(0x8fe850c0), SPH_C32(0xf56f7d14), SPH_C32(0x9e23c5de),
    SPH_C32(0x6e0b1f5b) },
  { SPH_C32(0x693b0001), SPH_C32(0x43606d00), SPH_C32(0x00320000),
    SPH_C32(0x9ce10000), SPH_C32(0xfc566d39), SPH_C32(0xf4893d1f),
    SPH_C32(0x862f6c57), SPH_C32(0x451c6b25), SPH_C32(0x46120002),
    SPH_C32(0x331f8c00), SPH_C32(0xfe8b0000), SPH_C32(0xb70a0000),
    SPH_C32(0x06d9281a), SPH_C32(0xeabb8574), SPH_C32(0xd0f366cb),
    SPH_C32(0xcf28e0c4) },
  { SPH_C32(0xde730001), SPH_C32(0x08687000), SPH_C32(0x9ef00000),
    SPH_C32(0x0c230000), SPH_C32(0x580131d5), SPH_C32(0xddcc75bd),
    SPH_C32(0x4be02289), SPH_C32(0x8f4760f5), SPH_C32(0xf25d0002),
    SPH_C32(0x6c8b8500), SPH_C32(0x8b680000), SPH_C32(0x1e510000),
    SPH_C32(0x17f279ac), SPH_C32(0x51715125), SPH_C32(0x23743ba6),
    SPH_C32(0xbea20b6a) },
  { SPH_C32(0xd2010001), SPH_C32(0x418d7f00), SPH_C32(0xdc890000),
    SPH_C32(0x50c90000), SPH_C32(0x6bab01cf), SPH_C32(0xc84e50a9),
    SPH_C32(0xde4369f2), SPH_C32(0x3b0c6065), SPH_C32(0x0c7f0002),
    SPH_C32(0xcbd38000), SPH_C32(0xaeb90000), SPH_C32(0xe9310000),
    SPH_C32(0x9ec30176), SPH_C32(0x4ea5a945), SPH_C32(0x6da498b3),
    SPH_C32(0x1f81f4f5) },
  { SPH_C32(0x20510001), SPH_C32(0xaf307500), SPH_C32(0xbb210000),
    SPH_C32(0xfb430000), SPH_C32(0xd130490f), SPH_C32(0xc2188ddd),
    SPH_C32(0x0530819c), SPH_C32(0x2e649f6a), SPH_C32(0x000d0002),
    SPH_C32(0x82368f00), SPH_C32(0xecc00000), SPH_C32(0xb5db0000),
    SPH_C32(0xad69316c), SPH_C32(0x5b278c51), SPH_C32(0xf807d3c8),
    SPH_C32(0xabcaf465) },
  { SPH_C32(0x2c230001), SPH_C32(0xe6d57a00), SPH_C32(0xf9580000),
    SPH_C32(0xa7a90000), SPH_C32(0xe29a7915), SPH_C32(0xd79aa8c9),
    SPH_C32(0x9093cae7), SPH_C32(0x9a2f9ffa), SPH_C32(0xfe2f0002),
    SPH_C32(0x256e8a00), SPH_C32(0xc9110000), SPH_C32(0x42bb0000),
    SPH_C32(0x245849b6), SPH_C32(0x44f37431), SPH_C32(0xb6d770dd),
    SPH_C32(0x0ae90bfa) },
  { SPH_C32(0x23560001), SPH_C32(0xbbac6100), SPH_C32(0x50000000),
    SPH_C32(0xc2da0000), SPH_C32(0x644c4455), SPH_C32(0x5097112e),
    SPH_C32(0x3b78922f), SPH_C32(0x95b57f14), SPH_C32(0xb7450002),
    SPH_C32(0xc93e9200), SPH_C32(0x72020000), SPH_C32(0x25190000),
    SPH_C32(0x093e6d80), SPH_C32(0x7262c4f3), SPH_C32(0x35c89d16),
    SPH_C32(0x6191ffb5) },
  { SPH_C32(0x2f240001), SPH_C32(0xf2496e00), SPH_C32(0x12790000),
    SPH_C32(0x9e300000), SPH_C32(0x57e6744f), SPH_C32(0x4515343a),
    SPH_C32(0xaedbd954), SPH_C32(0x21fe7f84), SPH_C32(0x49670002),
    SPH_C32(0x6e669700), SPH_C32(0x57d30000), SPH_C32(0xd2790000),
    SPH_C32(0x800f155a), SPH_C32(0x6db63c93), SPH_C32(0x7b183e03),
    SPH_C32(0xc0b2002a) },
  { SPH_C32(0xdd740001), SPH_C32(0x1cf46400), SPH_C32(0x75d10000),
    SPH_C32(0x35ba0000), SPH_C32(0xed7d3c8f), SPH_C32(0x4f43e94e),
    SPH_C32(0x75a8313a), SPH_C32(0x3496808b), SPH_C32(0x45150002),
    SPH_C32(0x27839800), SPH_C32(0x15aa0000), SPH_C32(0x8e930000),
    SPH_C32(0xb3a52540), SPH_C32(0x78341987), SPH_C32(0xeebb7578),
    SPH_C32(0x74f900ba) },
  { SPH_C32(0xd1060001), SPH_C32(0x55116b00), SPH_C32(0x37a80000),
    SPH_C32(0x69500000), SPH_C32(0xded70c95), SPH_C32(0x5ac1cc5a),
    SPH_C32(0xe00b7a41), SPH_C32(0x80dd801b), SPH_C32(0xbb370002),
    SPH_C32(0x80db9d00), SPH_C32(0x307b0000), SPH_C32(0x79f30000),
    SPH_C32(0x3a945d9a), SPH_C32(0x67e0e1e7), SPH_C32(0xa06bd66d),
    SPH_C32(0xd5daff25) },
  { SPH_C32(0x664e0001), SPH_C32(0x1e197600), SPH_C32(0xa96a0000),
    SPH_C32(0xf9920000), SPH_C32(0x7a805079), SPH_C32(0x738484f8),
    SPH_C32(0x2dc4349f), SPH_C32(0x4a868bcb), SPH_C32(0x0f780002),
    SPH_C32(0xdf4f9400), SPH_C32(0x45980000), SPH_C32(0xd0a80000),
    SPH_C32(0x2bbf0c2c), SPH_C32(0xdc2a35b6), SPH_C32(0x53ec8b00),
    SPH_C32(0xa450148b) },
  { SPH_C32(0x6a3c0001), SPH_C32(0x57fc7900), SPH_C32(0xeb130000),
    SPH_C32(0xa5780000), SPH_C32(0x492a6063), SPH_C32(0x6606a1ec),
    SPH_C32(0xb8677fe4), SPH_C32(0xfecd8b5b), SPH_C32(0xf15a0002),
    SPH_C32(0x78179100), SPH_C32(0x60490000), SPH_C32(0x27c80000),
    SPH_C32(0xa28e74f6), SPH_C32(0xc3fecdd6), SPH_C32(0x1d3c2815),
    SPH_C32(0x0573eb14) },
  { SPH_C32(0x986c0001), SPH_C32(0xb9417300), SPH_C32(0x8cbb0000),
    SPH_C32(0x0ef20000), SPH_C32(0xf3b128a3), SPH_C32(0x6c507c98),
    SPH_C32(0x6314978a), SPH_C32(0xeba57454), SPH_C32(0xfd280002),
    SPH_C32(0x31f29e00), SPH_C32(0x22300000), SPH_C32(0x7b220000),
    SPH_C32(0x912444ec), SPH_C32(0xd67ce8c2), SPH_C32(0x889f636e),
    SPH_C32(0xb138eb84) },
  { SPH_C32(0x941e0001), SPH_C32(0xf0a47c00), SPH_C32(0xcec20000),
    SPH_C32(0x52180000), SPH_C32(0xc01b18b9), SPH_C32(0x79d2598c),
    SPH_C32(0xf6b7dcf1), SPH_C32(0x5fee74c4), SPH_C32(0x030a0002),
    SPH_C32(0x96aa9b00), SPH_C32(0x07e10000), SPH_C32(0x8c420000),
    SPH_C32(0x18153c36), SPH_C32(0xc9a810a2), SPH_C32(0xc64fc07b),
    SPH_C32(0x101b141b) },
  { SPH_C32(0x3fa90001), SPH_C32(0x74ea4300), SPH_C32(0x6dd20000),
    SPH_C32(0x510a0000), SPH_C32(0xbeb7373e), SPH_C32(0x78611737),
    SPH_C32(0xfe785bad), SPH_C32(0x7bd4ce7f), SPH_C32(0x3fc40002),
    SPH_C32(0xb871a400), SPH_C32(0x28560000), SPH_C32(0x7b150000),
    SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce), SPH_C32(0x5237e933),
    SPH_C32(0xd5bc862a) },
  { SPH_C32(0x33db0001), SPH_C32(0x3d0f4c00), SPH_C32(0x2fab0000),
    SPH_C32(0x0de00000), SPH_C32(0x8d1d0724), SPH_C32(0x6de33223),
    SPH_C32(0x6bdb10d6), SPH_C32(0xcf9fceef), SPH_C32(0xc1e60002),
    SPH_C32(0x1f29a100), SPH_C32(0x0d870000), SPH_C32(0x8c750000),
    SPH_C32(0x473a373a), SPH_C32(0xa92353ae), SPH_C32(0x1ce74a26),
    SPH_C32(0x749f79b5) },
  { SPH_C32(0xc18b0001), SPH_C32(0xd3b24600), SPH_C32(0x48030000),
    SPH_C32(0xa66a0000), SPH_C32(0x37864fe4), SPH_C32(0x67b5ef57),
    SPH_C32(0xb0a8f8b8), SPH_C32(0xdaf731e0), SPH_C32(0xcd940002),
    SPH_C32(0x56ccae00), SPH_C32(0x4ffe0000), SPH_C32(0xd09f0000),
    SPH_C32(0x74900720), SPH_C32(0xbca176ba), SPH_C32(0x8944015d),
    SPH_C32(0xc0d47925) },
  { SPH_C32(0xcdf90001), SPH_C32(0x9a574900), SPH_C32(0x0a7a0000),
    SPH_C32(0xfa800000), SPH_C32(0x042c7ffe), SPH_C32(0x7237ca43),
    SPH_C32(0x250bb3c3), SPH_C32(0x6ebc3170), SPH_C32(0x33b60002),
    SPH_C32(0xf194ab00), SPH_C32(0x6a2f0000), SPH_C32(0x27ff0000),
    SPH_C32(0xfda17ffa), SPH_C32(0xa3758eda), SPH_C32(0xc794a248),
    SPH_C32(0x61f786ba) },
  { SPH_C32(0x7ab10001), SPH_C32(0xd15f5400), SPH_C32(0x94b80000),
    SPH_C32(0x6a420000), SPH_C32(0xa07b2312), SPH_C32(0x5b7282e1),
    SPH_C32(0xe8c4fd1d), SPH_C32(0xa4e73aa0), SPH_C32(0x87f90002),
    SPH_C32(0xae00a200), SPH_C32(0x1fcc0000), SPH_C32(0x8ea40000),
    SPH_C32(0xec8a2e4c), SPH_C32(0x18bf5a8b), SPH_C32(0x3413ff25),
    SPH_C32(0x107d6d14) },
  { SPH_C32(0x76c30001), SPH_C32(0x98ba5b00), SPH_C32(0xd6c10000),
    SPH_C32(0x36a80000), SPH_C32(0x93d11308), SPH_C32(0x4ef0a7f5),
    SPH_C32(0x7d67b666), SPH_C32(0x10ac3a30), SPH_C32(0x79db0002),
    SPH_C32(0x0958a700), SPH_C32(0x3a1d0000), SPH_C32(0x79c40000),
    SPH_C32(0x65bb5696), SPH_C32(0x076ba2eb), SPH_C32(0x7ac35c30),
    SPH_C32(0xb15e928b) },
  { SPH_C32(0x84930001), SPH_C32(0x76075100), SPH_C32(0xb1690000),
    SPH_C32(0x9d220000), SPH_C32(0x294a5bc8), SPH_C32(0x44a67a81),
    SPH_C32(0xa6145e08), SPH_C32(0x05c4c53f), SPH_C32(0x75a90002),
    SPH_C32(0x40bda800), SPH_C32(0x78640000), SPH_C32(0x252e0000),
    SPH_C32(0x5611668c), SPH_C32(0x12e987ff), SPH_C32(0xef60174b),
    SPH_C32(0x0515921b) },
  { SPH_C32(0x88e10001), SPH_C32(0x3fe25e00), SPH_C32(0xf3100000),
    SPH_C32(0xc1c80000), SPH_C32(0x1ae06bd2), SPH_C32(0x51245f95),
    SPH_C32(0x33b71573), SPH_C32(0xb18fc5af), SPH_C32(0x8b8b0002),
    SPH_C32(0xe7e5ad00), SPH_C32(0x5db50000), SPH_C32(0xd24e0000),
    SPH_C32(0xdf201e56), SPH_C32(0x0d3d7f9f), SPH_C32(0xa1b0b45e),
    SPH_C32(0xa4366d84) },
  { SPH_C32(0x87940001), SPH_C32(0x629b4500), SPH_C32(0x5a480000),
    SPH_C32(0xa4bb0000), SPH_C32(0x9c365692), SPH_C32(0xd629e672),
    SPH_C32(0x985c4dbb), SPH_C32(0xbe152541), SPH_C32(0xc2e10002),
    SPH_C32(0x0bb5b500), SPH_C32(0xe6a60000), SPH_C32(0xb5ec0000),
    SPH_C32(0xf2463a60), SPH_C32(0x3baccf5d), SPH_C32(0x22af5995),
    SPH_C32(0xcf4e99cb) },
  { SPH_C32(0x8be60001), SPH_C32(0x2b7e4a00), SPH_C32(0x18310000),
    SPH_C32(0xf8510000), SPH_C32(0xaf9c6688), SPH_C32(0xc3abc366),
    SPH_C32(0x0dff06c0), SPH_C32(0x0a5e25d1), SPH_C32(0x3cc30002),
    SPH_C32(0xacedb000), SPH_C32(0xc3770000), SPH_C32(0x428c0000),
    SPH_C32(0x7b7742ba), SPH_C32(0x2478373d), SPH_C32(0x6c7ffa80),
    SPH_C32(0x6e6d6654) },
  { SPH_C32(0x79b60001), SPH_C32(0xc5c34000), SPH_C32(0x7f990000),
    SPH_C32(0x53db0000), SPH_C32(0x15072e48), SPH_C32(0xc9fd1e12),
    SPH_C32(0xd68ceeae), SPH_C32(0x1f36dade), SPH_C32(0x30b10002),
    SPH_C32(0xe508bf00), SPH_C32(0x810e0000), SPH_C32(0x1e660000),
    SPH_C32(0x48dd72a0), SPH_C32(0x31fa1229), SPH_C32(0xf9dcb1fb),
    SPH_C32(0xda2666c4) },
  { SPH_C32(0x75c40001), SPH_C32(0x8c264f00), SPH_C32(0x3de00000),
    SPH_C32(0x0f310000), SPH_C32(0x26ad1e52), SPH_C32(0xdc7f3b06),
    SPH_C32(0x432fa5d5), SPH_C32(0xab7dda4e), SPH_C32(0xce930002),
    SPH_C32(0x4250ba00), SPH_C32(0xa4df0000), SPH_C32(0xe9060000),
    SPH_C32(0xc1ec0a7a), SPH_C32(0x2e2eea49), SPH_C32(0xb70c12ee),
    SPH_C32(0x7b05995b) },
  { SPH_C32(0xc28c0001), SPH_C32(0xc72e5200), SPH_C32(0xa3220000),
    SPH_C32(0x9ff30000), SPH_C32(0x82fa42be), SPH_C32(0xf53a73a4),
    SPH_C32(0x8ee0eb0b), SPH_C32(0x6126d19e), SPH_C32(0x7adc0002),
    SPH_C32(0x1dc4b300), SPH_C32(0xd13c0000), SPH_C32(0x405d0000),
    SPH_C32(0xd0c75bcc), SPH_C32(0x95e43e18), SPH_C32(0x448b4f83),
    SPH_C32(0x0a8f72f5) },
  { SPH_C32(0xcefe0001), SPH_C32(0x8ecb5d00), SPH_C32(0xe15b0000),
    SPH_C32(0xc3190000), SPH_C32(0xb15072a4), SPH_C32(0xe0b856b0),
    SPH_C32(0x1b43a070), SPH_C32(0xd56dd10e), SPH_C32(0x84fe0002),
    SPH_C32(0xba9cb600), SPH_C32(0xf4ed0000), SPH_C32(0xb73d0000),
    SPH_C32(0x59f62316), SPH_C32(0x8a30c678), SPH_C32(0x0a5bec96),
    SPH_C32(0xabac8d6a) },
  { SPH_C32(0x3cae0001), SPH_C32(0x60765700), SPH_C32(0x86f30000),
    SPH_C32(0x68930000), SPH_C32(0x0bcb3a64), SPH_C32(0xeaee8bc4),
    SPH_C32(0xc030481e), SPH_C32(0xc0052e01), SPH_C32(0x888c0002),
    SPH_C32(0xf379b900), SPH_C32(0xb6940000), SPH_C32(0xebd70000),
    SPH_C32(0x6a5c130c), SPH_C32(0x9fb2e36c), SPH_C32(0x9ff8a7ed),
    SPH_C32(0x1fe78dfa) },
  { SPH_C32(0x30dc0001), SPH_C32(0x29935800), SPH_C32(0xc48a0000),
    SPH_C32(0x34790000), SPH_C32(0x38610a7e), SPH_C32(0xff6caed0),
    SPH_C32(0x55930365), SPH_C32(0x744e2e91), SPH_C32(0x76ae0002),
    SPH_C32(0x5421bc00), SPH_C32(0x93450000), SPH_C32(0x1cb70000),
    SPH_C32(0xe36d6bd6), SPH_C32(0x80661b0c), SPH_C32(0xd12804f8),
    SPH_C32(0xbec47265) },
  { SPH_C32(0x4a0d0001), SPH_C32(0xb6616400), SPH_C32(0xf9760000),
    SPH_C32(0xc1ff0000), SPH_C32(0x45cf60de), SPH_C32(0x31af1c99),
    SPH_C32(0xe91f9f2e), SPH_C32(0xd50ba801), SPH_C32(0xeea20002),
    SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000), SPH_C32(0x8d810000),
    SPH_C32(0xcd090ac7), SPH_C32(0x7987573c), SPH_C32(0xe674f224),
    SPH_C32(0x50c3ba01) },
  { SPH_C32(0x467f0001), SPH_C32(0xff846b00), SPH_C32(0xbb0f0000),
    SPH_C32(0x9d150000), SPH_C32(0x766550c4), SPH_C32(0x242d398d),
    SPH_C32(0x7cbcd455), SPH_C32(0x6140a891), SPH_C32(0x10800002),
    SPH_C32(0x0495a200), SPH_C32(0x936b0000), SPH_C32(0x7ae10000),
    SPH_C32(0x4438721d), SPH_C32(0x6653af5c), SPH_C32(0xa8a45131),
    SPH_C32(0xf1e0459e) },
  { SPH_C32(0xb42f0001), SPH_C32(0x11396100), SPH_C32(0xdca70000),
    SPH_C32(0x369f0000), SPH_C32(0xccfe1804), SPH_C32(0x2e7be4f9),
    SPH_C32(0xa7cf3c3b), SPH_C32(0x7428579e), SPH_C32(0x1cf20002),
    SPH_C32(0x4d70ad00), SPH_C32(0xd1120000), SPH_C32(0x260b0000),
    SPH_C32(0x77924207), SPH_C32(0x73d18a48), SPH_C32(0x3d071a4a),
    SPH_C32(0x45ab450e) },
  { SPH_C32(0xb85d0001), SPH_C32(0x58dc6e00), SPH_C32(0x9ede0000),
    SPH_C32(0x6a750000), SPH_C32(0xff54281e), SPH_C32(0x3bf9c1ed),
    SPH_C32(0x326c7740), SPH_C32(0xc063570e), SPH_C32(0xe2d00002),
    SPH_C32(0xea28a800), SPH_C32(0xf4c30000), SPH_C32(0xd16b0000),
    SPH_C32(0xfea33add), SPH_C32(0x6c057228), SPH_C32(0x73d7b95f),
    SPH_C32(0xe488ba91) },
  { SPH_C32(0x0f150001), SPH_C32(0x13d47300), SPH_C32(0x001c0000),
    SPH_C32(0xfab70000), SPH_C32(0x5b0374f2), SPH_C32(0x12bc894f),
    SPH_C32(0xffa3399e), SPH_C32(0x0a385cde), SPH_C32(0x569f0002),
    SPH_C32(0xb5bca100), SPH_C32(0x81200000), SPH_C32(0x78300000),
    SPH_C32(0xef886b6b), SPH_C32(0xd7cfa679), SPH_C32(0x8050e432),
    SPH_C32(0x9502513f) },
  { SPH_C32(0x03670001), SPH_C32(0x5a317c00), SPH_C32(0x42650000),
    SPH_C32(0xa65d0000), SPH_C32(0x68a944e8), SPH_C32(0x073eac5b),
    SPH_C32(0x6a0072e5), SPH_C32(0xbe735c4e), SPH_C32(0xa8bd0002),
    SPH_C32(0x12e4a400), SPH_C32(0xa4f10000), SPH_C32(0x8f500000),
    SPH_C32(0x66b913b1), SPH_C32(0xc81b5e19), SPH_C32(0xce804727),
    SPH_C32(0x3421aea0) },
  { SPH_C32(0xf1370001), SPH_C32(0xb48c7600), SPH_C32(0x25cd0000),
    SPH_C32(0x0dd70000), SPH_C32(0xd2320c28), SPH_C32(0x0d68712f),
    SPH_C32(0xb1739a8b), SPH_C32(0xab1ba341), SPH_C32(0xa4cf0002),
    SPH_C32(0x5b01ab00), SPH_C32(0xe6880000), SPH_C32(0xd3ba0000),
    SPH_C32(0x551323ab), SPH_C32(0xdd997b0d), SPH_C32(0x5b230c5c),
    SPH_C32(0x806aae30) },
  { SPH_C32(0xfd450001), SPH_C32(0xfd697900), SPH_C32(0x67b40000),
    SPH_C32(0x513d0000), SPH_C32(0xe1983c32), SPH_C32(0x18ea543b),
    SPH_C32(0x24d0d1f0), SPH_C32(0x1f50a3d1), SPH_C32(0x5aed0002),
    SPH_C32(0xfc59ae00), SPH_C32(0xc3590000), SPH_C32(0x24da0000),
    SPH_C32(0xdc225b71), SPH_C32(0xc24d836d), SPH_C32(0x15f3af49),
    SPH_C32(0x214951af) },
  { SPH_C32(0xf2300001), SPH_C32(0xa0106200), SPH_C32(0xceec0000),
    SPH_C32(0x344e0000), SPH_C32(0x674e0172), SPH_C32(0x9fe7eddc),
    SPH_C32(0x8f3b8938), SPH_C32(0x10ca433f), SPH_C32(0x13870002),
    SPH_C32(0x1009b600), SPH_C32(0x784a0000), SPH_C32(0x43780000),
    SPH_C32(0xf1447f47), SPH_C32(0xf4dc33af), SPH_C32(0x96ec4282),
    SPH_C32(0x4a31a5e0) },
  { SPH_C32(0xfe420001), SPH_C32(0xe9f56d00), SPH_C32(0x8c950000),
    SPH_C32(0x68a40000), SPH_C32(0x54e43168), SPH_C32(0x8a65c8c8),
    SPH_C32(0x1a98c243), SPH_C32(0xa48143af), SPH_C32(0xeda50002),
    SPH_C32(0xb751b300), SPH_C32(0x5d9b0000), SPH_C32(0xb4180000),
    SPH_C32(0x7875079d), SPH_C32(0xeb08cbcf), SPH_C32(0xd83ce197),
    SPH_C32(0xeb125a7f) },
  { SPH_C32(0x0c120001), SPH_C32(0x07486700), SPH_C32(0xeb3d0000),
    SPH_C32(0xc32e0000), SPH_C32(0xee7f79a8), SPH_C32(0x803315bc),
    SPH_C32(0xc1eb2a2d), SPH_C32(0xb1e9bca0), SPH_C32(0xe1d70002),
    SPH_C32(0xfeb4bc00), SPH_C32(0x1fe20000), SPH_C32(0xe8f20000),
    SPH_C32(0x4bdf3787), SPH_C32(0xfe8aeedb), SPH_C32(0x4d9faaec),
    SPH_C32(0x5f595aef) },
  { SPH_C32(0x00600001), SPH_C32(0x4ead6800), SPH_C32(0xa9440000),
    SPH_C32(0x9fc40000), SPH_C32(0xddd549b2), SPH_C32(0x95b130a8),
    SPH_C32(0x54486156), SPH_C32(0x05a2bc30), SPH_C32(0x1ff50002),
    SPH_C32(0x59ecb900), SPH_C32(0x3a330000), SPH_C32(0x1f920000),
    SPH_C32(0xc2ee4f5d), SPH_C32(0xe15e16bb), SPH_C32(0x034f09f9),
    SPH_C32(0xfe7aa570) },
  { SPH_C32(0xb7280001), SPH_C32(0x05a57500), SPH_C32(0x37860000),
    SPH_C32(0x0f060000), SPH_C32(0x7982155e), SPH_C32(0xbcf4780a),
    SPH_C32(0x99872f88), SPH_C32(0xcff9b7e0), SPH_C32(0xabba0002),
    SPH_C32(0x0678b000), SPH_C32(0x4fd00000), SPH_C32(0xb6c90000),
    SPH_C32(0xd3c51eeb), SPH_C32(0x5a94c2ea), SPH_C32(0xf0c85494),
    SPH_C32(0x8ff04ede) },
  { SPH_C32(0xbb5a0001), SPH_C32(0x4c407a00), SPH_C32(0x75ff0000),
    SPH_C32(0x53ec0000), SPH_C32(0x4a282544), SPH_C32(0xa9765d1e),
    SPH_C32(0x0c2464f3), SPH_C32(0x7bb2b770), SPH_C32(0x55980002),
    SPH_C32(0xa120b500), SPH_C32(0x6a010000), SPH_C32(0x41a90000),
    SPH_C32(0x5af46631), SPH_C32(0x45403a8a), SPH_C32(0xbe18f781),
    SPH_C32(0x2ed3b141) },
  { SPH_C32(0x490a0001), SPH_C32(0xa2fd7000), SPH_C32(0x12570000),
    SPH_C32(0xf8660000), SPH_C32(0xf0b36d84), SPH_C32(0xa320806a),
    SPH_C32(0xd7578c9d), SPH_C32(0x6eda487f), SPH_C32(0x59ea0002),
    SPH_C32(0xe8c5ba00), SPH_C32(0x28780000), SPH_C32(0x1d430000),
    SPH_C32(0x695e562b), SPH_C32(0x50c21f9e), SPH_C32(0x2bbbbcfa),
    SPH_C32(0x9a98b1d1) },
  { SPH_C32(0x45780001), SPH_C32(0xeb187f00), SPH_C32(0x502e0000),
    SPH_C32(0xa48c0000), SPH_C32(0xc3195d9e), SPH_C32(0xb6a2a57e),
    SPH_C32(0x42f4c7e6), SPH_C32(0xda9148ef), SPH_C32(0xa7c80002),
    SPH_C32(0x4f9dbf00), SPH_C32(0x0da90000), SPH_C32(0xea230000),
    SPH_C32(0xe06f2ef1), SPH_C32(0x4f16e7fe), SPH_C32(0x656b1fef),
    SPH_C32(0x3bbb4e4e) },
  { SPH_C32(0x9b060002), SPH_C32(0x61468000), SPH_C32(0x221e0000),
    SPH_C32(0x1d740000), SPH_C32(0x36715d27), SPH_C32(0x30495c92),
    SPH_C32(0xf11336a7), SPH_C32(0xfe1cdc7f), SPH_C32(0x75c90003),
    SPH_C32(0x0e10c000), SPH_C32(0xd1200000), SPH_C32(0xbaea0000),
    SPH_C32(0x8bc42f3e), SPH_C32(0x8758b757), SPH_C32(0xbb28761d),
    SPH_C32(0x00b72e2b) },
  { SPH_C32(0x97740002), SPH_C32(0x28a38f00), SPH_C32(0x60670000),
    SPH_C32(0x419e0000), SPH_C32(0x05db6d3d), SPH_C32(0x25cb7986),
    SPH_C32(0x64b07ddc), SPH_C32(0x4a57dcef), SPH_C32(0x8beb0003),
    SPH_C32(0xa948c500), SPH_C32(0xf4f10000), SPH_C32(0x4d8a0000),
    SPH_C32(0x02f557e4), SPH_C32(0x988c4f37), SPH_C32(0xf5f8d508),
    SPH_C32(0xa194d1b4) },
  { SPH_C32(0x65240002), SPH_C32(0xc61e8500), SPH_C32(0x07cf0000),
    SPH_C32(0xea140000), SPH_C32(0xbf4025fd), SPH_C32(0x2f9da4f2),
    SPH_C32(0xbfc395b2), SPH_C32(0x5f3f23e0), SPH_C32(0x87990003),
    SPH_C32(0xe0adca00), SPH_C32(0xb6880000), SPH_C32(0x11600000),
    SPH_C32(0x315f67fe), SPH_C32(0x8d0e6a23), SPH_C32(0x605b9e73),
    SPH_C32(0x15dfd124) },
  { SPH_C32(0x69560002), SPH_C32(0x8ffb8a00), SPH_C32(0x45b60000),
    SPH_C32(0xb6fe0000), SPH_C32(0x8cea15e7), SPH_C32(0x3a1f81e6),
    SPH_C32(0x2a60dec9), SPH_C32(0xeb742370), SPH_C32(0x79bb0003),
    SPH_C32(0x47f5cf00), SPH_C32(0x93590000), SPH_C32(0xe6000000),
    SPH_C32(0xb86e1f24), SPH_C32(0x92da9243), SPH_C32(0x2e8b3d66),
    SPH_C32(0xb4fc2ebb) },
  { SPH_C32(0xde1e0002), SPH_C32(0xc4f39700), SPH_C32(0xdb740000),
    SPH_C32(0x263c0000), SPH_C32(0x28bd490b), SPH_C32(0x135ac944),
    SPH_C32(0xe7af9017), SPH_C32(0x212f28a0), SPH_C32(0xcdf40003),
    SPH_C32(0x1861c600), SPH_C32(0xe6ba0000), SPH_C32(0x4f5b0000),
    SPH_C32(0xa9454e92), SPH_C32(0x29104612), SPH_C32(0xdd0c600b),
    SPH_C32(0xc576c515) },
  { SPH_C32(0xd26c0002), SPH_C32(0x8d169800), SPH_C32(0x990d0000),
    SPH_C32(0x7ad60000), SPH_C32(0x1b177911), SPH_C32(0x06d8ec50),
    SPH_C32(0x720cdb6c), SPH_C32(0x95642830), SPH_C32(0x33d60003),
    SPH_C32(0xbf39c300), SPH_C32(0xc36b0000), SPH_C32(0xb83b0000),
    SPH_C32(0x20743648), SPH_C32(0x36c4be72), SPH_C32(0x93dcc31e),
    SPH_C32(0x64553a8a) },
  { SPH_C32(0x203c0002), SPH_C32(0x63ab9200), SPH_C32(0xfea50000),
    SPH_C32(0xd15c0000), SPH_C32(0xa18c31d1), SPH_C32(0x0c8e3124),
    SPH_C32(0xa97f3302), SPH_C32(0x800cd73f), SPH_C32(0x3fa40003),
    SPH_C32(0xf6dccc00), SPH_C32(0x81120000), SPH_C32(0xe4d10000),
    SPH_C32(0x13de0652), SPH_C32(0x23469b66), SPH_C32(0x067f8865),
    SPH_C32(0xd01e3a1a) },
  { SPH_C32(0x2c4e0002), SPH_C32(0x2a4e9d00), SPH_C32(0xbcdc0000),
    SPH_C32(0x8db60000), SPH_C32(0x922601cb), SPH_C32(0x190c1430),
    SPH_C32(0x3cdc7879), SPH_C32(0x3447d7af), SPH_C32(0xc1860003),
    SPH_C32(0x5184c900), SPH_C32(0xa4c30000), SPH_C32(0x13b10000),
    SPH_C32(0x9aef7e88), SPH_C32(0x3c926306), SPH_C32(0x48af2b70),
    SPH_C32(0x713dc585) },
  { SPH_C32(0x233b0002), SPH_C32(0x77378600), SPH_C32(0x15840000),
    SPH_C32(0xe8c50000), SPH_C32(0x14f03c8b), SPH_C32(0x9e01add7),
    SPH_C32(0x973720b1), SPH_C32(0x3bdd3741), SPH_C32(0x88ec0003),
    SPH_C32(0xbdd4d100), SPH_C32(0x1fd00000), SPH_C32(0x74130000),
    SPH_C32(0xb7895abe), SPH_C32(0x0a03d3c4), SPH_C32(0xcbb0c6bb),
    SPH_C32(0x1a4531ca) },
  { SPH_C32(0x2f490002), SPH_C32(0x3ed28900), SPH_C32(0x57fd0000),
    SPH_C32(0xb42f0000), SPH_C32(0x275a0c91), SPH_C32(0x8b8388c3),
    SPH_C32(0x02946bca), SPH_C32(0x8f9637d1), SPH_C32(0x76ce0003),
    SPH_C32(0x1a8cd400), SPH_C32(0x3a010000), SPH_C32(0x83730000),
    SPH_C32(0x3eb82264), SPH_C32(0x15d72ba4), SPH_C32(0x856065ae),
    SPH_C32(0xbb66ce55) },
  { SPH_C32(0xdd190002), SPH_C32(0xd06f8300), SPH_C32(0x30550000),
    SPH_C32(0x1fa50000), SPH_C32(0x9dc14451), SPH_C32(0x81d555b7),
    SPH_C32(0xd9e783a4), SPH_C32(0x9afec8de), SPH_C32(0x7abc0003),
    SPH_C32(0x5369db00), SPH_C32(0x78780000), SPH_C32(0xdf990000),
    SPH_C32(0x0d12127e), SPH_C32(0x00550eb0), SPH_C32(0x10c32ed5),
    SPH_C32(0x0f2dcec5) },
  { SPH_C32(0xd16b0002), SPH_C32(0x998a8c00), SPH_C32(0x722c0000),
    SPH_C32(0x434f0000), SPH_C32(0xae6b744b), SPH_C32(0x945770a3),
    SPH_C32(0x4c44c8df), SPH_C32(0x2eb5c84e), SPH_C32(0x849e0003),
    SPH_C32(0xf431de00), SPH_C32(0x5da90000), SPH_C32(0x28f90000),
    SPH_C32(0x84236aa4), SPH_C32(0x1f81f6d0), SPH_C32(0x5e138dc0),
    SPH_C32(0xae0e315a) },
  { SPH_C32(0x66230002), SPH_C32(0xd2829100), SPH_C32(0xecee0000),
    SPH_C32(0xd38d0000), SPH_C32(0x0a3c28a7), SPH_C32(0xbd123801),
    SPH_C32(0x818b8601), SPH_C32(0xe4eec39e), SPH_C32(0x30d10003),
    SPH_C32(0xaba5d700), SPH_C32(0x284a0000), SPH_C32(0x81a20000),
    SPH_C32(0x95083b12), SPH_C32(0xa44b2281), SPH_C32(0xad94d0ad),
    SPH_C32(0xdf84daf4) },
  { SPH_C32(0x6a510002), SPH_C32(0x9b679e00), SPH_C32(0xae970000),
    SPH_C32(0x8f670000), SPH_C32(0x399618bd), SPH_C32(0xa8901d15),
    SPH_C32(0x1428cd7a), SPH_C32(0x50a5c30e), SPH_C32(0xcef30003),
    SPH_C32(0x0cfdd200), SPH_C32(0x0d9b0000), SPH_C32(0x76c20000),
    SPH_C32(0x1c3943c8), SPH_C32(0xbb9fdae1), SPH_C32(0xe34473b8),
    SPH_C32(0x7ea7256b) },
  { SPH_C32(0x98010002), SPH_C32(0x75da9400), SPH_C32(0xc93f0000),
    SPH_C32(0x24ed0000), SPH_C32(0x830d507d), SPH_C32(0xa2c6c061),
    SPH_C32(0xcf5b2514), SPH_C32(0x45cd3c01), SPH_C32(0xc2810003),
    SPH_C32(0x4518dd00), SPH_C32(0x4fe20000), SPH_C32(0x2a280000),
    SPH_C32(0x2f9373d2), SPH_C32(0xae1dfff5), SPH_C32(0x76e738c3),
    SPH_C32(0xcaec25fb) },
  { SPH_C32(0x94730002), SPH_C32(0x3c3f9b00), SPH_C32(0x8b460000),
    SPH_C32(0x78070000), SPH_C32(0xb0a76067), SPH_C32(0xb744e575),
    SPH_C32(0x5af86e6f), SPH_C32(0xf1863c91), SPH_C32(0x3ca30003),
    SPH_C32(0xe240d800), SPH_C32(0x6a330000), SPH_C32(0xdd480000),
    SPH_C32(0xa6a20b08), SPH_C32(0xb1c90795), SPH_C32(0x38379bd6),
    SPH_C32(0x6bcfda64) },
  { SPH_C32(0xeea20002), SPH_C32(0xa3cda700), SPH_C32(0xb6ba0000),
    SPH_C32(0x8d810000), SPH_C32(0xcd090ac7), SPH_C32(0x7987573c),
    SPH_C32(0xe674f224), SPH_C32(0x50c3ba01), SPH_C32(0xa4af0003),
    SPH_C32(0x15acc300), SPH_C32(0x4fcc0000), SPH_C32(0x4c7e0000),
    SPH_C32(0x88c66a19), SPH_C32(0x48284ba5), SPH_C32(0x0f6b6d0a),
    SPH_C32(0x85c81200) },
  { SPH_C32(0xe2d00002), SPH_C32(0xea28a800), SPH_C32(0xf4c30000),
    SPH_C32(0xd16b0000), SPH_C32(0xfea33add), SPH_C32(0x6c057228),
    SPH_C32(0x73d7b95f), SPH_C32(0xe488ba91), SPH_C32(0x5a8d0003),
    SPH_C32(0xb2f4c600), SPH_C32(0x6a1d0000), SPH_C32(0xbb1e0000),
    SPH_C32(0x01f712c3), SPH_C32(0x57fcb3c5), SPH_C32(0x41bbce1f),
    SPH_C32(0x24ebed9f) },
  { SPH_C32(0x10800002), SPH_C32(0x0495a200), SPH_C32(0x936b0000),
    SPH_C32(0x7ae10000), SPH_C32(0x4438721d), SPH_C32(0x6653af5c),
    SPH_C32(0xa8a45131), SPH_C32(0xf1e0459e), SPH_C32(0x56ff0003),
    SPH_C32(0xfb11c900), SPH_C32(0x28640000), SPH_C32(0xe7f40000),
    SPH_C32(0x325d22d9), SPH_C32(0x427e96d1), SPH_C32(0xd4188564),
    SPH_C32(0x90a0ed0f) },
  { SPH_C32(0x1cf20002), SPH_C32(0x4d70ad00), SPH_C32(0xd1120000),
    SPH_C32(0x260b0000), SPH_C32(0x77924207), SPH_C32(0x73d18a48),
    SPH_C32(0x3d071a4a), SPH_C32(0x45ab450e), SPH_C32(0xa8dd0003),
    SPH_C32(0x5c49cc00), SPH_C32(0x0db50000), SPH_C32(0x10940000),
    SPH_C32(0xbb6c5a03), SPH_C32(0x5daa6eb1), SPH_C32(0x9ac82671),
    SPH_C32(0x31831290) },
  { SPH_C32(0xabba0002), SPH_C32(0x0678b000), SPH_C32(0x4fd00000),
    SPH_C32(0xb6c90000), SPH_C32(0xd3c51eeb), SPH_C32(0x5a94c2ea),
    SPH_C32(0xf0c85494), SPH_C32(0x8ff04ede), SPH_C32(0x1c920003),
    SPH_C32(0x03ddc500), SPH_C32(0x78560000), SPH_C32(0xb9cf0000),
    SPH_C32(0xaa470bb5), SPH_C32(0xe660bae0), SPH_C32(0x694f7b1c),
    SPH_C32(0x4009f93e) },
  { SPH_C32(0xa7c80002), SPH_C32(0x4f9dbf00), SPH_C32(0x0da90000),
    SPH_C32(0xea230000), SPH_C32(0xe06f2ef1), SPH_C32(0x4f16e7fe),
    SPH_C32(0x656b1fef), SPH_C32(0x3bbb4e4e), SPH_C32(0xe2b00003),
    SPH_C32(0xa485c000), SPH_C32(0x5d870000), SPH_C32(0x4eaf0000),
    SPH_C32(0x2376736f), SPH_C32(0xf9b44280), SPH_C32(0x279fd809),
    SPH_C32(0xe12a06a1) },
  { SPH_C32(0x55980002), SPH_C32(0xa120b500), SPH_C32(0x6a010000),
    SPH_C32(0x41a90000), SPH_C32(0x5af46631), SPH_C32(0x45403a8a),
    SPH_C32(0xbe18f781), SPH_C32(0x2ed3b141), SPH_C32(0xeec20003),
    SPH_C32(0xed60cf00), SPH_C32(0x1ffe0000), SPH_C32(0x12450000),
    SPH_C32(0x10dc4375), SPH_C32(0xec366794), SPH_C32(0xb23c9372),
    SPH_C32(0x55610631) },
  { SPH_C32(0x59ea0002), SPH_C32(0xe8c5ba00), SPH_C32(0x28780000),
    SPH_C32(0x1d430000), SPH_C32(0x695e562b), SPH_C32(0x50c21f9e),
    SPH_C32(0x2bbbbcfa), SPH_C32(0x9a98b1d1), SPH_C32(0x10e00003),
    SPH_C32(0x4a38ca00), SPH_C32(0x3a2f0000), SPH_C32(0xe5250000),
    SPH_C32(0x99ed3baf), SPH_C32(0xf3e29ff4), SPH_C32(0xfcec3067),
    SPH_C32(0xf442f9ae) },
  { SPH_C32(0x569f0002), SPH_C32(0xb5bca100), SPH_C32(0x81200000),
    SPH_C32(0x78300000), SPH_C32(0xef886b6b), SPH_C32(0xd7cfa679),
    SPH_C32(0x8050e432), SPH_C32(0x9502513f), SPH_C32(0x598a0003),
    SPH_C32(0xa668d200), SPH_C32(0x813c0000), SPH_C32(0x82870000),
    SPH_C32(0xb48b1f99), SPH_C32(0xc5732f36), SPH_C32(0x7ff3ddac),
    SPH_C32(0x9f3a0de1) },
  { SPH_C32(0x5aed0002), SPH_C32(0xfc59ae00), SPH_C32(0xc3590000),
    SPH_C32(0x24da0000), SPH_C32(0xdc225b71), SPH_C32(0xc24d836d),
    SPH_C32(0x15f3af49), SPH_C32(0x214951af), SPH_C32(0xa7a80003),
    SPH_C32(0x0130d700), SPH_C32(0xa4ed0000), SPH_C32(0x75e70000),
    SPH_C32(0x3dba6743), SPH_C32(0xdaa7d756), SPH_C32(0x31237eb9),
    SPH_C32(0x3e19f27e) },
  { SPH_C32(0xa8bd0002), SPH_C32(0x12e4a400), SPH_C32(0xa4f10000),
    SPH_C32(0x8f500000), SPH_C32(0x66b913b1), SPH_C32(0xc81b5e19),
    SPH_C32(0xce804727), SPH_C32(0x3421aea0), SPH_C32(0xabda0003),
    SPH_C32(0x48d5d800), SPH_C32(0xe6940000), SPH_C32(0x290d0000),
    SPH_C32(0x0e105759), SPH_C32(0xcf25f242), SPH_C32(0xa48035c2),
    SPH_C32(0x8a52f2ee) },
  { SPH_C32(0xa4cf0002), SPH_C32(0x5b01ab00), SPH_C32(0xe6880000),
    SPH_C32(0xd3ba0000), SPH_C32(0x551323ab), SPH_C32(0xdd997b0d),
    SPH_C32(0x5b230c5c), SPH_C32(0x806aae30), SPH_C32(0x55f80003),
    SPH_C32(0xef8ddd00), SPH_C32(0xc3450000), SPH_C32(0xde6d0000),
    SPH_C32(0x87212f83), SPH_C32(0xd0f10a22), SPH_C32(0xea5096d7),
    SPH_C32(0x2b710d71) },
  { SPH_C32(0x13870002), SPH_C32(0x1009b600), SPH_C32(0x784a0000),
    SPH_C32(0x43780000), SPH_C32(0xf1447f47), SPH_C32(0xf4dc33af),
    SPH_C32(0x96ec4282), SPH_C32(0x4a31a5e0), SPH_C32(0xe1b70003),
    SPH_C32(0xb019d400), SPH_C32(0xb6a60000), SPH_C32(0x77360000),
    SPH_C32(0x960a7e35), SPH_C32(0x6b3bde73), SPH_C32(0x19d7cbba),
    SPH_C32(0x5afbe6df) },
  { SPH_C32(0x1ff50002), SPH_C32(0x59ecb900), SPH_C32(0x3a330000),
    SPH_C32(0x1f920000), SPH_C32(0xc2ee4f5d), SPH_C32(0xe15e16bb),
    SPH_C32(0x034f09f9), SPH_C32(0xfe7aa570), SPH_C32(0x1f950003),
    SPH_C32(0x1741d100), SPH_C32(0x93770000), SPH_C32(0x80560000),
    SPH_C32(0x1f3b06ef), SPH_C32(0x74ef2613), SPH_C32(0x570768af),
    SPH_C32(0xfbd81940) },
  { SPH_C32(0xeda50002), SPH_C32(0xb751b300), SPH_C32(0x5d9b0000),
    SPH_C32(0xb4180000), SPH_C32(0x7875079d), SPH_C32(0xeb08cbcf),
    SPH_C32(0xd83ce197), SPH_C32(0xeb125a7f), SPH_C32(0x13e70003),
    SPH_C32(0x5ea4de00), SPH_C32(0xd10e0000), SPH_C32(0xdcbc0000),
    SPH_C32(0x2c9136f5), SPH_C32(0x616d0307), SPH_C32(0xc2a423d4),
    SPH_C32(0x4f9319d0) },
  { SPH_C32(0xe1d70002), SPH_C32(0xfeb4bc00), SPH_C32(0x1fe20000),
    SPH_C32(0xe8f20000), SPH_C32(0x4bdf3787), SPH_C32(0xfe8aeedb),
    SPH_C32(0x4d9faaec), SPH_C32(0x5f595aef), SPH_C32(0xedc50003),
    SPH_C32(0xf9fcdb00), SPH_C32(0xf4df0000), SPH_C32(0x2bdc0000),
    SPH_C32(0xa5a04e2f), SPH_C32(0x7eb9fb67), SPH_C32(0x8c7480c1),
    SPH_C32(0xeeb0e64f) },
  { SPH_C32(0x4a600002), SPH_C32(0x7afa8300), SPH_C32(0xbcf20000),
    SPH_C32(0xebe00000), SPH_C32(0x35731800), SPH_C32(0xff39a060),
    SPH_C32(0x45502db0), SPH_C32(0x7b63e054), SPH_C32(0xd10b0003),
    SPH_C32(0xd727e400), SPH_C32(0xdb680000), SPH_C32(0xdc8b0000),
    SPH_C32(0x73be3df9), SPH_C32(0x01e6400b), SPH_C32(0x180ca989),
    SPH_C32(0x2b17747e) },
  { SPH_C32(0x46120002), SPH_C32(0x331f8c00), SPH_C32(0xfe8b0000),
    SPH_C32(0xb70a0000), SPH_C32(0x06d9281a), SPH_C32(0xeabb8574),
    SPH_C32(0xd0f366cb), SPH_C32(0xcf28e0c4), SPH_C32(0x2f290003),
    SPH_C32(0x707fe100), SPH_C32(0xfeb90000), SPH_C32(0x2beb0000),
    SPH_C32(0xfa8f4523), SPH_C32(0x1e32b86b), SPH_C32(0x56dc0a9c),
    SPH_C32(0x8a348be1) },
  { SPH_C32(0xb4420002), SPH_C32(0xdda28600), SPH_C32(0x99230000),
    SPH_C32(0x1c800000), SPH_C32(0xbc4260da), SPH_C32(0xe0ed5800),
    SPH_C32(0x0b808ea5), SPH_C32(0xda401fcb), SPH_C32(0x235b0003),
    SPH_C32(0x399aee00), SPH_C32(0xbcc00000), SPH_C32(0x77010000),
    SPH_C32(0xc9257539), SPH_C32(0x0bb09d7f), SPH_C32(0xc37f41e7),
    SPH_C32(0x3e7f8b71) },
  { SPH_C32(0xb8300002), SPH_C32(0x94478900), SPH_C32(0xdb5a0000),
    SPH_C32(0x406a0000), SPH_C32(0x8fe850c0), SPH_C32(0xf56f7d14),
    SPH_C32(0x9e23c5de), SPH_C32(0x6e0b1f5b), SPH_C32(0xdd790003),
    SPH_C32(0x9ec2eb00), SPH_C32(0x99110000), SPH_C32(0x80610000),
    SPH_C32(0x40140de3), SPH_C32(0x1464651f), SPH_C32(0x8dafe2f2),
    SPH_C32(0x9f5c74ee) },
  { SPH_C32(0x0f780002), SPH_C32(0xdf4f9400), SPH_C32(0x45980000),
    SPH_C32(0xd0a80000), SPH_C32(0x2bbf0c2c), SPH_C32(0xdc2a35b6),
    SPH_C32(0x53ec8b00), SPH_C32(0xa450148b), SPH_C32(0x69360003),
    SPH_C32(0xc156e200), SPH_C32(0xecf20000), SPH_C32(0x293a0000),
    SPH_C32(0x513f5c55), SPH_C32(0xafaeb14e), SPH_C32(0x7e28bf9f),
    SPH_C32(0xeed69f40) },
  { SPH_C32(0x030a0002), SPH_C32(0x96aa9b00), SPH_C32(0x07e10000),
    SPH_C32(0x8c420000), SPH_C32(0x18153c36), SPH_C32(0xc9a810a2),
    SPH_C32(0xc64fc07b), SPH_C32(0x101b141b), SPH_C32(0x97140003),
    SPH_C32(0x660ee700), SPH_C32(0xc9230000), SPH_C32(0xde5a0000),
    SPH_C32(0xd80e248f), SPH_C32(0xb07a492e), SPH_C32(0x30f81c8a),
    SPH_C32(0x4ff560df) },
  { SPH_C32(0xf15a0002), SPH_C32(0x78179100), SPH_C32(0x60490000),
    SPH_C32(0x27c80000), SPH_C32(0xa28e74f6), SPH_C32(0xc3fecdd6),
    SPH_C32(0x1d3c2815), SPH_C32(0x0573eb14), SPH_C32(0x9b660003),
    SPH_C32(0x2febe800), SPH_C32(0x8b5a0000), SPH_C32(0x82b00000),
    SPH_C32(0xeba41495), SPH_C32(0xa5f86c3a), SPH_C32(0xa55b57f1),
    SPH_C32(0xfbbe604f) },
  { SPH_C32(0xfd280002), SPH_C32(0x31f29e00), SPH_C32(0x22300000),
    SPH_C32(0x7b220000), SPH_C32(0x912444ec), SPH_C32(0xd67ce8c2),
    SPH_C32(0x889f636e), SPH_C32(0xb138eb84), SPH_C32(0x65440003),
    SPH_C32(0x88b3ed00), SPH_C32(0xae8b0000), SPH_C32(0x75d00000),
    SPH_C32(0x62956c4f), SPH_C32(0xba2c945a), SPH_C32(0xeb8bf4e4),
    SPH_C32(0x5a9d9fd0) },
  { SPH_C32(0xf25d0002), SPH_C32(0x6c8b8500), SPH_C32(0x8b680000),
    SPH_C32(0x1e510000), SPH_C32(0x17f279ac), SPH_C32(0x51715125),
    SPH_C32(0x23743ba6), SPH_C32(0xbea20b6a), SPH_C32(0x2c2e0003),
    SPH_C32(0x64e3f500), SPH_C32(0x15980000), SPH_C32(0x12720000),
    SPH_C32(0x4ff34879), SPH_C32(0x8cbd2498), SPH_C32(0x6894192f),
    SPH_C32(0x31e56b9f) },
  { SPH_C32(0xfe2f0002), SPH_C32(0x256e8a00), SPH_C32(0xc9110000),
    SPH_C32(0x42bb0000), SPH_C32(0x245849b6), SPH_C32(0x44f37431),
    SPH_C32(0xb6d770dd), SPH_C32(0x0ae90bfa), SPH_C32(0xd20c0003),
    SPH_C32(0xc3bbf000), SPH_C32(0x30490000), SPH_C32(0xe5120000),
    SPH_C32(0xc6c230a3), SPH_C32(0x9369dcf8), SPH_C32(0x2644ba3a),
    SPH_C32(0x90c69400) },
  { SPH_C32(0x0c7f0002), SPH_C32(0xcbd38000), SPH_C32(0xaeb90000),
    SPH_C32(0xe9310000), SPH_C32(0x9ec30176), SPH_C32(0x4ea5a945),
    SPH_C32(0x6da498b3), SPH_C32(0x1f81f4f5), SPH_C32(0xde7e0003),
    SPH_C32(0x8a5eff00), SPH_C32(0x72300000), SPH_C32(0xb9f80000),
    SPH_C32(0xf56800b9), SPH_C32(0x86ebf9ec), SPH_C32(0xb3e7f141),
    SPH_C32(0x248d9490) },
  { SPH_C32(0x000d0002), SPH_C32(0x82368f00), SPH_C32(0xecc00000),
    SPH_C32(0xb5db0000), SPH_C32(0xad69316c), SPH_C32(0x5b278c51),
    SPH_C32(0xf807d3c8), SPH_C32(0xabcaf465), SPH_C32(0x205c0003),
    SPH_C32(0x2d06fa00), SPH_C32(0x57e10000), SPH_C32(0x4e980000),
    SPH_C32(0x7c597863), SPH_C32(0x993f018c), SPH_C32(0xfd375254),
    SPH_C32(0x85ae6b0f) },
  { SPH_C32(0xb7450002), SPH_C32(0xc93e9200), SPH_C32(0x72020000),
    SPH_C32(0x25190000), SPH_C32(0x093e6d80), SPH_C32(0x7262c4f3),
    SPH_C32(0x35c89d16), SPH_C32(0x6191ffb5), SPH_C32(0x94130003),
    SPH_C32(0x7292f300), SPH_C32(0x22020000), SPH_C32(0xe7c30000),
    SPH_C32(0x6d7229d5), SPH_C32(0x22f5d5dd), SPH_C32(0x0eb00f39),
    SPH_C32(0xf42480a1) },
  { SPH_C32(0xbb370002), SPH_C32(0x80db9d00), SPH_C32(0x307b0000),
    SPH_C32(0x79f30000), SPH_C32(0x3a945d9a), SPH_C32(0x67e0e1e7),
    SPH_C32(0xa06bd66d), SPH_C32(0xd5daff25), SPH_C32(0x6a310003),
    SPH_C32(0xd5caf600), SPH_C32(0x07d30000), SPH_C32(0x10a30000),
    SPH_C32(0xe443510f), SPH_C32(0x3d212dbd), SPH_C32(0x4060ac2c),
    SPH_C32(0x55077f3e) },
  { SPH_C32(0x49670002), SPH_C32(0x6e669700), SPH_C32(0x57d30000),
    SPH_C32(0xd2790000), SPH_C32(0x800f155a), SPH_C32(0x6db63c93),
    SPH_C32(0x7b183e03), SPH_C32(0xc0b2002a), SPH_C32(0x66430003),
    SPH_C32(0x9c2ff900), SPH_C32(0x45aa0000), SPH_C32(0x4c490000),
    SPH_C32(0xd7e96115), SPH_C32(0x28a308a9), SPH_C32(0xd5c3e757),
    SPH_C32(0xe14c7fae) },
  { SPH_C32(0x45150002), SPH_C32(0x27839800), SPH_C32(0x15aa0000),
    SPH_C32(0x8e930000), SPH_C32(0xb3a52540), SPH_C32(0x78341987),
    SPH_C32(0xeebb7578), SPH_C32(0x74f900ba), SPH_C32(0x98610003),
    SPH_C32(0x3b77fc00), SPH_C32(0x607b0000), SPH_C32(0xbb290000),
    SPH_C32(0x5ed819cf), SPH_C32(0x3777f0c9), SPH_C32(0x9b134442),
    SPH_C32(0x406f8031) },
  { SPH_C32(0x3fc40002), SPH_C32(0xb871a400), SPH_C32(0x28560000),
    SPH_C32(0x7b150000), SPH_C32(0xce0b4fe0), SPH_C32(0xb6f7abce),
    SPH_C32(0x5237e933), SPH_C32(0xd5bc862a), SPH_C32(0x006d0003),
    SPH_C32(0xcc9be700), SPH_C32(0x45840000), SPH_C32(0x2a1f0000),
    SPH_C32(0x70bc78de), SPH_C32(0xce96bcf9), SPH_C32(0xac4fb29e),
    SPH_C32(0xae684855) },
  { SPH_C32(0x33b60002), SPH_C32(0xf194ab00), SPH_C32(0x6a2f0000),
    SPH_C32(0x27ff0000), SPH_C32(0xfda17ffa), SPH_C32(0xa3758eda),
    SPH_C32(0xc794a248), SPH_C32(0x61f786ba), SPH_C32(0xfe4f0003),
    SPH_C32(0x6bc3e200), SPH_C32(0x60550000), SPH_C32(0xdd7f0000),
    SPH_C32(0xf98d0004), SPH_C32(0xd1424499), SPH_C32(0xe29f118b),
    SPH_C32(0x0f4bb7ca) },
  { SPH_C32(0xc1e60002), SPH_C32(0x1f29a100), SPH_C32(0x0d870000),
    SPH_C32(0x8c750000), SPH_C32(0x473a373a), SPH_C32(0xa92353ae),
    SPH_C32(0x1ce74a26), SPH_C32(0x749f79b5), SPH_C32(0xf23d0003),
    SPH_C32(0x2226ed00), SPH_C32(0x222c0000), SPH_C32(0x81950000),
    SPH_C32(0xca27301e), SPH_C32(0xc4c0618d), SPH_C32(0x773c5af0),
    SPH_C32(0xbb00b75a) },
  { SPH_C32(0xcd940002), SPH_C32(0x56ccae00), SPH_C32(0x4ffe0000),
    SPH_C32(0xd09f0000), SPH_C32(0x74900720), SPH_C32(0xbca176ba),
    SPH_C32(0x8944015d), SPH_C32(0xc0d47925), SPH_C32(0x0c1f0003),
    SPH_C32(0x857ee800), SPH_C32(0x07fd0000), SPH_C32(0x76f50000),
    SPH_C32(0x431648c4), SPH_C32(0xdb1499ed), SPH_C32(0x39ecf9e5),
    SPH_C32(0x1a2348c5) },
  { SPH_C32(0x7adc0002), SPH_C32(0x1dc4b300), SPH_C32(0xd13c0000),
    SPH_C32(0x405d0000), SPH_C32(0xd0c75bcc), SPH_C32(0x95e43e18),
    SPH_C32(0x448b4f83), SPH_C32(0x0a8f72f5), SPH_C32(0xb8500003),
    SPH_C32(0xdaeae100), SPH_C32(0x721e0000), SPH_C32(0xdfae0000),
    SPH_C32(0x523d1972), SPH_C32(0x60de4dbc), SPH_C32(0xca6ba488),
    SPH_C32(0x6ba9a36b) },
  { SPH_C32(0x76ae0002), SPH_C32(0x5421bc00), SPH_C32(0x93450000),
    SPH_C32(0x1cb70000), SPH_C32(0xe36d6bd6), SPH_C32(0x80661b0c),
    SPH_C32(0xd12804f8), SPH_C32(0xbec47265), SPH_C32(0x46720003),
    SPH_C32(0x7db2e400), SPH_C32(0x57cf0000), SPH_C32(0x28ce0000),
    SPH_C32(0xdb0c61a8), SPH_C32(0x7f0ab5dc), SPH_C32(0x84bb079d),
    SPH_C32(0xca8a5cf4) },
  { SPH_C32(0x84fe0002), SPH_C32(0xba9cb600), SPH_C32(0xf4ed0000),
    SPH_C32(0xb73d0000), SPH_C32(0x59f62316), SPH_C32(0x8a30c678),
    SPH_C32(0x0a5bec96), SPH_C32(0xabac8d6a), SPH_C32(0x4a000003),
    SPH_C32(0x3457eb00), SPH_C32(0x15b60000), SPH_C32(0x74240000),
    SPH_C32(0xe8a651b2), SPH_C32(0x6a8890c8), SPH_C32(0x11184ce6),
    SPH_C32(0x7ec15c64) },
  { SPH_C32(0x888c0002), SPH_C32(0xf379b900), SPH_C32(0xb6940000),
    SPH_C32(0xebd70000), SPH_C32(0x6a5c130c), SPH_C32(0x9fb2e36c),
    SPH_C32(0x9ff8a7ed), SPH_C32(0x1fe78dfa), SPH_C32(0xb4220003),
    SPH_C32(0x930fee00), SPH_C32(0x30670000), SPH_C32(0x83440000),
    SPH_C32(0x61972968), SPH_C32(0x755c68a8), SPH_C32(0x5fc8eff3),
    SPH_C32(0xdfe2a3fb) },
  { SPH_C32(0x87f90002), SPH_C32(0xae00a200), SPH_C32(0x1fcc0000),
    SPH_C32(0x8ea40000), SPH_C32(0xec8a2e4c), SPH_C32(0x18bf5a8b),
    SPH_C32(0x3413ff25), SPH_C32(0x107d6d14), SPH_C32(0xfd480003),
    SPH_C32(0x7f5ff600), SPH_C32(0x8b740000), SPH_C32(0xe4e60000),
    SPH_C32(0x4cf10d5e), SPH_C32(0x43cdd86a), SPH_C32(0xdcd70238),
    SPH_C32(0xb49a57b4) },
  { SPH_C32(0x8b8b0002), SPH_C32(0xe7e5ad00), SPH_C32(0x5db50000),
    SPH_C32(0xd24e0000), SPH_C32(0xdf201e56), SPH_C32(0x0d3d7f9f),
    SPH_C32(0xa1b0b45e), SPH_C32(0xa4366d84), SPH_C32(0x036a0003),
    SPH_C32(0xd807f300), SPH_C32(0xaea50000), SPH_C32(0x13860000),
    SPH_C32(0xc5c07584), SPH_C32(0x5c19200a), SPH_C32(0x9207a12d),
    SPH_C32(0x15b9a82b) },
  { SPH_C32(0x79db0002), SPH_C32(0x0958a700), SPH_C32(0x3a1d0000),
    SPH_C32(0x79c40000), SPH_C32(0x65bb5696), SPH_C32(0x076ba2eb),
    SPH_C32(0x7ac35c30), SPH_C32(0xb15e928b), SPH_C32(0x0f180003),
    SPH_C32(0x91e2fc00), SPH_C32(0xecdc0000), SPH_C32(0x4f6c0000),
    SPH_C32(0xf66a459e), SPH_C32(0x499b051e), SPH_C32(0x07a4ea56),
    SPH_C32(0xa1f2a8bb) },
  { SPH_C32(0x75a90002), SPH_C32(0x40bda800), SPH_C32(0x78640000),
    SPH_C32(0x252e0000), SPH_C32(0x5611668c), SPH_C32(0x12e987ff),
    SPH_C32(0xef60174b), SPH_C32(0x0515921b), SPH_C32(0xf13a0003),
    SPH_C32(0x36baf900), SPH_C32(0xc90d0000), SPH_C32(0xb80c0000),
    SPH_C32(0x7f5b3d44), SPH_C32(0x564ffd7e), SPH_C32(0x49744943),
    SPH_C32(0x00d15724) },
  { SPH_C32(0xc2e10002), SPH_C32(0x0bb5b500), SPH_C32(0xe6a60000),
    SPH_C32(0xb5ec0000), SPH_C32(0xf2463a60), SPH_C32(0x3baccf5d),
    SPH_C32(0x22af5995), SPH_C32(0xcf4e99cb), SPH_C32(0x45750003),
    SPH_C32(0x692ef000), SPH_C32(0xbcee0000), SPH_C32(0x11570000),
    SPH_C32(0x6e706cf2), SPH_C32(0xed85292f), SPH_C32(0xbaf3142e),
    SPH_C32(0x715bbc8a) },
  { SPH_C32(0xce930002), SPH_C32(0x4250ba00), SPH_C32(0xa4df0000),
    SPH_C32(0xe9060000), SPH_C32(0xc1ec0a7a), SPH_C32(0x2e2eea49),
    SPH_C32(0xb70c12ee), SPH_C32(0x7b05995b), SPH_C32(0xbb570003),
    SPH_C32(0xce76f500), SPH_C32(0x993f0000), SPH_C32(0xe6370000),
    SPH_C32(0xe7411428), SPH_C32(0xf251d14f), SPH_C32(0xf423b73b),
    SPH_C32(0xd0784315) },
  { SPH_C32(0x3cc30002), SPH_C32(0xacedb000), SPH_C32(0xc3770000),
    SPH_C32(0x428c0000), SPH_C32(0x7b7742ba), SPH_C32(0x2478373d),
    SPH_C32(0x6c7ffa80), SPH_C32(0x6e6d6654), SPH_C32(0xb7250003),
    SPH_C32(0x8793fa00), SPH_C32(0xdb460000), SPH_C32(0xbadd0000),
    SPH_C32(0xd4eb2432), SPH_C32(0xe7d3f45b), SPH_C32(0x6180fc40),
    SPH_C32(0x64334385) },
  { SPH_C32(0x30b10002), SPH_C32(0xe508bf00), SPH_C32(0x810e0000),
    SPH_C32(0x1e660000), SPH_C32(0x48dd72a0), SPH_C32(0x31fa1229),
    SPH_C32(0xf9dcb1fb), SPH_C32(0xda2666c4), SPH_C32(0x49070003),
    SPH_C32(0x20cbff00), SPH_C32(0xfe970000), SPH_C32(0x4dbd0000),
    SPH_C32(0x5dda5ce8), SPH_C32(0xf8070c3b), SPH_C32(0x2f505f55),
    SPH_C32(0xc510bc1a) }
};

__constant static const sph_u32 T512_24[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x86790000), SPH_C32(0x3f390002), SPH_C32(0xe19ae000),
    SPH_C32(0x98560000), SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea),
    SPH_C32(0xd3dd4944), SPH_C32(0x161ddab9), SPH_C32(0x30b70000),
    SPH_C32(0xe5d00000), SPH_C32(0xf4f46000), SPH_C32(0x42c40000),
    SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460), SPH_C32(0x21afa1ea),
    SPH_C32(0xb0a51834) },
  { SPH_C32(0x30b70000), SPH_C32(0xe5d00000), SPH_C32(0xf4f46000),
    SPH_C32(0x42c40000), SPH_C32(0x63b83d6a), SPH_C32(0x78ba9460),
    SPH_C32(0x21afa1ea), SPH_C32(0xb0a51834), SPH_C32(0xb6ce0000),
    SPH_C32(0xdae90002), SPH_C32(0x156e8000), SPH_C32(0xda920000),
    SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a), SPH_C32(0xf272e8ae),
    SPH_C32(0xa6b8c28d) },
  { SPH_C32(0xb6ce0000), SPH_C32(0xdae90002), SPH_C32(0x156e8000),
    SPH_C32(0xda920000), SPH_C32(0xf6dd5a64), SPH_C32(0x36325c8a),
    SPH_C32(0xf272e8ae), SPH_C32(0xa6b8c28d), SPH_C32(0x86790000),
    SPH_C32(0x3f390002), SPH_C32(0xe19ae000), SPH_C32(0x98560000),
    SPH_C32(0x9565670e), SPH_C32(0x4e88c8ea), SPH_C32(0xd3dd4944),
    SPH_C32(0x161ddab9) },
  { SPH_C32(0x14190000), SPH_C32(0x23ca003c), SPH_C32(0x50df0000),
    SPH_C32(0x44b60000), SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75),
    SPH_C32(0x61e610b0), SPH_C32(0xdbcadb80), SPH_C32(0xe3430000),
    SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000), SPH_C32(0xaa4e0000),
    SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15), SPH_C32(0x123db156),
    SPH_C32(0x3a4e99d7) },
  { SPH_C32(0x92600000), SPH_C32(0x1cf3003e), SPH_C32(0xb145e000),
    SPH_C32(0xdce00000), SPH_C32(0x8e0900be), SPH_C32(0x727b649f),
    SPH_C32(0xb23b59f4), SPH_C32(0xcdd70139), SPH_C32(0xd3f40000),
    SPH_C32(0xdf9e0014), SPH_C32(0x06326000), SPH_C32(0xe88a0000),
    SPH_C32(0xb8a67fcc), SPH_C32(0x5dd12a75), SPH_C32(0x339210bc),
    SPH_C32(0x8aeb81e3) },
  { SPH_C32(0x24ae0000), SPH_C32(0xc61a003c), SPH_C32(0xa42b6000),
    SPH_C32(0x06720000), SPH_C32(0x78d45ada), SPH_C32(0x44493815),
    SPH_C32(0x4049b15a), SPH_C32(0x6b6fc3b4), SPH_C32(0x558d0000),
    SPH_C32(0xe0a70016), SPH_C32(0xe7a88000), SPH_C32(0x70dc0000),
    SPH_C32(0x2dc318c2), SPH_C32(0x1359e29f), SPH_C32(0xe04f59f8),
    SPH_C32(0x9cf65b5a) },
  { SPH_C32(0xa2d70000), SPH_C32(0xf923003e), SPH_C32(0x45b18000),
    SPH_C32(0x9e240000), SPH_C32(0xedb13dd4), SPH_C32(0x0ac1f0ff),
    SPH_C32(0x9394f81e), SPH_C32(0x7d72190d), SPH_C32(0x653a0000),
    SPH_C32(0x05770016), SPH_C32(0x135ce000), SPH_C32(0x32180000),
    SPH_C32(0x4e7b25a8), SPH_C32(0x6be376ff), SPH_C32(0xc1e0f812),
    SPH_C32(0x2c53436e) },
  { SPH_C32(0xe3430000), SPH_C32(0x3a4e0014), SPH_C32(0xf2c60000),
    SPH_C32(0xaa4e0000), SPH_C32(0xdb1e42a6), SPH_C32(0x256bbe15),
    SPH_C32(0x123db156), SPH_C32(0x3a4e99d7), SPH_C32(0xf75a0000),
    SPH_C32(0x19840028), SPH_C32(0xa2190000), SPH_C32(0xeef80000),
    SPH_C32(0xc0722516), SPH_C32(0x19981260), SPH_C32(0x73dba1e6),
    SPH_C32(0xe1844257) },
  { SPH_C32(0x653a0000), SPH_C32(0x05770016), SPH_C32(0x135ce000),
    SPH_C32(0x32180000), SPH_C32(0x4e7b25a8), SPH_C32(0x6be376ff),
    SPH_C32(0xc1e0f812), SPH_C32(0x2c53436e), SPH_C32(0xc7ed0000),
    SPH_C32(0xfc540028), SPH_C32(0x56ed6000), SPH_C32(0xac3c0000),
    SPH_C32(0xa3ca187c), SPH_C32(0x61228600), SPH_C32(0x5274000c),
    SPH_C32(0x51215a63) },
  { SPH_C32(0xd3f40000), SPH_C32(0xdf9e0014), SPH_C32(0x06326000),
    SPH_C32(0xe88a0000), SPH_C32(0xb8a67fcc), SPH_C32(0x5dd12a75),
    SPH_C32(0x339210bc), SPH_C32(0x8aeb81e3), SPH_C32(0x41940000),
    SPH_C32(0xc36d002a), SPH_C32(0xb7778000), SPH_C32(0x346a0000),
    SPH_C32(0x36af7f72), SPH_C32(0x2faa4eea), SPH_C32(0x81a94948),
    SPH_C32(0x473c80da) },
  { SPH_C32(0x558d0000), SPH_C32(0xe0a70016), SPH_C32(0xe7a88000),
    SPH_C32(0x70dc0000), SPH_C32(0x2dc318c2), SPH_C32(0x1359e29f),
    SPH_C32(0xe04f59f8), SPH_C32(0x9cf65b5a), SPH_C32(0x71230000),
    SPH_C32(0x26bd002a), SPH_C32(0x4383e000), SPH_C32(0x76ae0000),
    SPH_C32(0x55174218), SPH_C32(0x5710da8a), SPH_C32(0xa006e8a2),
    SPH_C32(0xf79998ee) },
  { SPH_C32(0xf75a0000), SPH_C32(0x19840028), SPH_C32(0xa2190000),
    SPH_C32(0xeef80000), SPH_C32(0xc0722516), SPH_C32(0x19981260),
    SPH_C32(0x73dba1e6), SPH_C32(0xe1844257), SPH_C32(0x14190000),
    SPH_C32(0x23ca003c), SPH_C32(0x50df0000), SPH_C32(0x44b60000),
    SPH_C32(0x1b6c67b0), SPH_C32(0x3cf3ac75), SPH_C32(0x61e610b0),
    SPH_C32(0xdbcadb80) },
  { SPH_C32(0x71230000), SPH_C32(0x26bd002a), SPH_C32(0x4383e000),
    SPH_C32(0x76ae0000), SPH_C32(0x55174218), SPH_C32(0x5710da8a),
    SPH_C32(0xa006e8a2), SPH_C32(0xf79998ee), SPH_C32(0x24ae0000),
    SPH_C32(0xc61a003c), SPH_C32(0xa42b6000), SPH_C32(0x06720000),
    SPH_C32(0x78d45ada), SPH_C32(0x44493815), SPH_C32(0x4049b15a),
    SPH_C32(0x6b6fc3b4) },
  { SPH_C32(0xc7ed0000), SPH_C32(0xfc540028), SPH_C32(0x56ed6000),
    SPH_C32(0xac3c0000), SPH_C32(0xa3ca187c), SPH_C32(0x61228600),
    SPH_C32(0x5274000c), SPH_C32(0x51215a63), SPH_C32(0xa2d70000),
    SPH_C32(0xf923003e), SPH_C32(0x45b18000), SPH_C32(0x9e240000),
    SPH_C32(0xedb13dd4), SPH_C32(0x0ac1f0ff), SPH_C32(0x9394f81e),
    SPH_C32(0x7d72190d) },
  { SPH_C32(0x41940000), SPH_C32(0xc36d002a), SPH_C32(0xb7778000),
    SPH_C32(0x346a0000), SPH_C32(0x36af7f72), SPH_C32(0x2faa4eea),
    SPH_C32(0x81a94948), SPH_C32(0x473c80da), SPH_C32(0x92600000),
    SPH_C32(0x1cf3003e), SPH_C32(0xb145e000), SPH_C32(0xdce00000),
    SPH_C32(0x8e0900be), SPH_C32(0x727b649f), SPH_C32(0xb23b59f4),
    SPH_C32(0xcdd70139) },
  { SPH_C32(0x54500000), SPH_C32(0x0671005c), SPH_C32(0x25ae0000),
    SPH_C32(0x6a1e0000), SPH_C32(0x2ea54edf), SPH_C32(0x664e8512),
    SPH_C32(0xbfba18c3), SPH_C32(0x7e715d17), SPH_C32(0xbc8d0000),
    SPH_C32(0xfc3b0018), SPH_C32(0x19830000), SPH_C32(0xd10b0000),
    SPH_C32(0xae1878c4), SPH_C32(0x42a69856), SPH_C32(0x0012da37),
    SPH_C32(0x2c3b504e) },
  { SPH_C32(0xd2290000), SPH_C32(0x3948005e), SPH_C32(0xc434e000),
    SPH_C32(0xf2480000), SPH_C32(0xbbc029d1), SPH_C32(0x28c64df8),
    SPH_C32(0x6c675187), SPH_C32(0x686c87ae), SPH_C32(0x8c3a0000),
    SPH_C32(0x19eb0018), SPH_C32(0xed776000), SPH_C32(0x93cf0000),
    SPH_C32(0xcda045ae), SPH_C32(0x3a1c0c36), SPH_C32(0x21bd7bdd),
    SPH_C32(0x9c9e487a) },
  { SPH_C32(0x64e70000), SPH_C32(0xe3a1005c), SPH_C32(0xd15a6000),
    SPH_C32(0x28da0000), SPH_C32(0x4d1d73b5), SPH_C32(0x1ef41172),
    SPH_C32(0x9e15b929), SPH_C32(0xced44523), SPH_C32(0x0a430000),
    SPH_C32(0x26d2001a), SPH_C32(0x0ced8000), SPH_C32(0x0b990000),
    SPH_C32(0x58c522a0), SPH_C32(0x7494c4dc), SPH_C32(0xf2603299),
    SPH_C32(0x8a8392c3) },
  { SPH_C32(0xe29e0000), SPH_C32(0xdc98005e), SPH_C32(0x30c08000),
    SPH_C32(0xb08c0000), SPH_C32(0xd87814bb), SPH_C32(0x507cd998),
    SPH_C32(0x4dc8f06d), SPH_C32(0xd8c99f9a), SPH_C32(0x3af40000),
    SPH_C32(0xc302001a), SPH_C32(0xf819e000), SPH_C32(0x495d0000),
    SPH_C32(0x3b7d1fca), SPH_C32(0x0c2e50bc), SPH_C32(0xd3cf9373),
    SPH_C32(0x3a268af7) },
  { SPH_C32(0x40490000), SPH_C32(0x25bb0060), SPH_C32(0x75710000),
    SPH_C32(0x2ea80000), SPH_C32(0x35c9296f), SPH_C32(0x5abd2967),
    SPH_C32(0xde5c0873), SPH_C32(0xa5bb8697), SPH_C32(0x5fce0000),
    SPH_C32(0xc675000c), SPH_C32(0xeb450000), SPH_C32(0x7b450000),
    SPH_C32(0x75063a62), SPH_C32(0x67cd2643), SPH_C32(0x122f6b61),
    SPH_C32(0x1675c999) },
  { SPH_C32(0xc6300000), SPH_C32(0x1a820062), SPH_C32(0x94ebe000),
    SPH_C32(0xb6fe0000), SPH_C32(0xa0ac4e61), SPH_C32(0x1435e18d),
    SPH_C32(0x0d814137), SPH_C32(0xb3a65c2e), SPH_C32(0x6f790000),
    SPH_C32(0x23a5000c), SPH_C32(0x1fb16000), SPH_C32(0x39810000),
    SPH_C32(0x16be0708), SPH_C32(0x1f77b223), SPH_C32(0x3380ca8b),
    SPH_C32(0xa6d0d1ad) },
  { SPH_C32(0x70fe0000), SPH_C32(0xc06b0060), SPH_C32(0x81856000),
    SPH_C32(0x6c6c0000), SPH_C32(0x56711405), SPH_C32(0x2207bd07),
    SPH_C32(0xfff3a999), SPH_C32(0x151e9ea3), SPH_C32(0xe9000000),
    SPH_C32(0x1c9c000e), SPH_C32(0xfe2b8000), SPH_C32(0xa1d70000),
    SPH_C32(0x83db6006), SPH_C32(0x51ff7ac9), SPH_C32(0xe05d83cf),
    SPH_C32(0xb0cd0b14) },
  { SPH_C32(0xf6870000), SPH_C32(0xff520062), SPH_C32(0x601f8000),
    SPH_C32(0xf43a0000), SPH_C32(0xc314730b), SPH_C32(0x6c8f75ed),
    SPH_C32(0x2c2ee0dd), SPH_C32(0x0303441a), SPH_C32(0xd9b70000),
    SPH_C32(0xf94c000e), SPH_C32(0x0adfe000), SPH_C32(0xe3130000),
    SPH_C32(0xe0635d6c), SPH_C32(0x2945eea9), SPH_C32(0xc1f22225),
    SPH_C32(0x00681320) },
  { SPH_C32(0xb7130000), SPH_C32(0x3c3f0048), SPH_C32(0xd7680000),
    SPH_C32(0xc0500000), SPH_C32(0xf5bb0c79), SPH_C32(0x43253b07),
    SPH_C32(0xad87a995), SPH_C32(0x443fc4c0), SPH_C32(0x4bd70000),
    SPH_C32(0xe5bf0030), SPH_C32(0xbb9a0000), SPH_C32(0x3ff30000),
    SPH_C32(0x6e6a5dd2), SPH_C32(0x5b3e8a36), SPH_C32(0x73c97bd1),
    SPH_C32(0xcdbf1219) },
  { SPH_C32(0x316a0000), SPH_C32(0x0306004a), SPH_C32(0x36f2e000),
    SPH_C32(0x58060000), SPH_C32(0x60de6b77), SPH_C32(0x0dadf3ed),
    SPH_C32(0x7e5ae0d1), SPH_C32(0x52221e79), SPH_C32(0x7b600000),
    SPH_C32(0x006f0030), SPH_C32(0x4f6e6000), SPH_C32(0x7d370000),
    SPH_C32(0x0dd260b8), SPH_C32(0x23841e56), SPH_C32(0x5266da3b),
    SPH_C32(0x7d1a0a2d) },
  { SPH_C32(0x87a40000), SPH_C32(0xd9ef0048), SPH_C32(0x239c6000),
    SPH_C32(0x82940000), SPH_C32(0x96033113), SPH_C32(0x3b9faf67),
    SPH_C32(0x8c28087f), SPH_C32(0xf49adcf4), SPH_C32(0xfd190000),
    SPH_C32(0x3f560032), SPH_C32(0xaef48000), SPH_C32(0xe5610000),
    SPH_C32(0x98b707b6), SPH_C32(0x6d0cd6bc), SPH_C32(0x81bb937f),
    SPH_C32(0x6b07d094) },
  { SPH_C32(0x01dd0000), SPH_C32(0xe6d6004a), SPH_C32(0xc2068000),
    SPH_C32(0x1ac20000), SPH_C32(0x0366561d), SPH_C32(0x7517678d),
    SPH_C32(0x5ff5413b), SPH_C32(0xe287064d), SPH_C32(0xcdae0000),
    SPH_C32(0xda860032), SPH_C32(0x5a00e000), SPH_C32(0xa7a50000),
    SPH_C32(0xfb0f3adc), SPH_C32(0x15b642dc), SPH_C32(0xa0143295),
    SPH_C32(0xdba2c8a0) },
  { SPH_C32(0xa30a0000), SPH_C32(0x1ff50074), SPH_C32(0x87b70000),
    SPH_C32(0x84e60000), SPH_C32(0xeed76bc9), SPH_C32(0x7fd69772),
    SPH_C32(0xcc61b925), SPH_C32(0x9ff51f40), SPH_C32(0xa8940000),
    SPH_C32(0xdff10024), SPH_C32(0x495c0000), SPH_C32(0x95bd0000),
    SPH_C32(0xb5741f74), SPH_C32(0x7e553423), SPH_C32(0x61f4ca87),
    SPH_C32(0xf7f18bce) },
  { SPH_C32(0x25730000), SPH_C32(0x20cc0076), SPH_C32(0x662de000),
    SPH_C32(0x1cb00000), SPH_C32(0x7bb20cc7), SPH_C32(0x315e5f98),
    SPH_C32(0x1fbcf061), SPH_C32(0x89e8c5f9), SPH_C32(0x98230000),
    SPH_C32(0x3a210024), SPH_C32(0xbda86000), SPH_C32(0xd7790000),
    SPH_C32(0xd6cc221e), SPH_C32(0x06efa043), SPH_C32(0x405b6b6d),
    SPH_C32(0x475493fa) },
  { SPH_C32(0x93bd0000), SPH_C32(0xfa250074), SPH_C32(0x73436000),
    SPH_C32(0xc6220000), SPH_C32(0x8d6f56a3), SPH_C32(0x076c0312),
    SPH_C32(0xedce18cf), SPH_C32(0x2f500774), SPH_C32(0x1e5a0000),
    SPH_C32(0x05180026), SPH_C32(0x5c328000), SPH_C32(0x4f2f0000),
    SPH_C32(0x43a94510), SPH_C32(0x486768a9), SPH_C32(0x93862229),
    SPH_C32(0x51494943) },
  { SPH_C32(0x15c40000), SPH_C32(0xc51c0076), SPH_C32(0x92d98000),
    SPH_C32(0x5e740000), SPH_C32(0x180a31ad), SPH_C32(0x49e4cbf8),
    SPH_C32(0x3e13518b), SPH_C32(0x394dddcd), SPH_C32(0x2eed0000),
    SPH_C32(0xe0c80026), SPH_C32(0xa8c6e000), SPH_C32(0x0deb0000),
    SPH_C32(0x2011787a), SPH_C32(0x30ddfcc9), SPH_C32(0xb22983c3),
    SPH_C32(0xe1ec5177) },
  { SPH_C32(0xbc8d0000), SPH_C32(0xfc3b0018), SPH_C32(0x19830000),
    SPH_C32(0xd10b0000), SPH_C32(0xae1878c4), SPH_C32(0x42a69856),
    SPH_C32(0x0012da37), SPH_C32(0x2c3b504e), SPH_C32(0xe8dd0000),
    SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000), SPH_C32(0xbb150000),
    SPH_C32(0x80bd361b), SPH_C32(0x24e81d44), SPH_C32(0xbfa8c2f4),
    SPH_C32(0x524a0d59) },
  { SPH_C32(0x3af40000), SPH_C32(0xc302001a), SPH_C32(0xf819e000),
    SPH_C32(0x495d0000), SPH_C32(0x3b7d1fca), SPH_C32(0x0c2e50bc),
    SPH_C32(0xd3cf9373), SPH_C32(0x3a268af7), SPH_C32(0xd86a0000),
    SPH_C32(0x1f9a0044), SPH_C32(0xc8d96000), SPH_C32(0xf9d10000),
    SPH_C32(0xe3050b71), SPH_C32(0x5c528924), SPH_C32(0x9e07631e),
    SPH_C32(0xe2ef156d) },
  { SPH_C32(0x8c3a0000), SPH_C32(0x19eb0018), SPH_C32(0xed776000),
    SPH_C32(0x93cf0000), SPH_C32(0xcda045ae), SPH_C32(0x3a1c0c36),
    SPH_C32(0x21bd7bdd), SPH_C32(0x9c9e487a), SPH_C32(0x5e130000),
    SPH_C32(0x20a30046), SPH_C32(0x29438000), SPH_C32(0x61870000),
    SPH_C32(0x76606c7f), SPH_C32(0x12da41ce), SPH_C32(0x4dda2a5a),
    SPH_C32(0xf4f2cfd4) },
  { SPH_C32(0x0a430000), SPH_C32(0x26d2001a), SPH_C32(0x0ced8000),
    SPH_C32(0x0b990000), SPH_C32(0x58c522a0), SPH_C32(0x7494c4dc),
    SPH_C32(0xf2603299), SPH_C32(0x8a8392c3), SPH_C32(0x6ea40000),
    SPH_C32(0xc5730046), SPH_C32(0xddb7e000), SPH_C32(0x23430000),
    SPH_C32(0x15d85115), SPH_C32(0x6a60d5ae), SPH_C32(0x6c758bb0),
    SPH_C32(0x4457d7e0) },
  { SPH_C32(0xa8940000), SPH_C32(0xdff10024), SPH_C32(0x495c0000),
    SPH_C32(0x95bd0000), SPH_C32(0xb5741f74), SPH_C32(0x7e553423),
    SPH_C32(0x61f4ca87), SPH_C32(0xf7f18bce), SPH_C32(0x0b9e0000),
    SPH_C32(0xc0040050), SPH_C32(0xceeb0000), SPH_C32(0x115b0000),
    SPH_C32(0x5ba374bd), SPH_C32(0x0183a351), SPH_C32(0xad9573a2),
    SPH_C32(0x6804948e) },
  { SPH_C32(0x2eed0000), SPH_C32(0xe0c80026), SPH_C32(0xa8c6e000),
    SPH_C32(0x0deb0000), SPH_C32(0x2011787a), SPH_C32(0x30ddfcc9),
    SPH_C32(0xb22983c3), SPH_C32(0xe1ec5177), SPH_C32(0x3b290000),
    SPH_C32(0x25d40050), SPH_C32(0x3a1f6000), SPH_C32(0x539f0000),
    SPH_C32(0x381b49d7), SPH_C32(0x79393731), SPH_C32(0x8c3ad248),
    SPH_C32(0xd8a18cba) },
  { SPH_C32(0x98230000), SPH_C32(0x3a210024), SPH_C32(0xbda86000),
    SPH_C32(0xd7790000), SPH_C32(0xd6cc221e), SPH_C32(0x06efa043),
    SPH_C32(0x405b6b6d), SPH_C32(0x475493fa), SPH_C32(0xbd500000),
    SPH_C32(0x1aed0052), SPH_C32(0xdb858000), SPH_C32(0xcbc90000),
    SPH_C32(0xad7e2ed9), SPH_C32(0x37b1ffdb), SPH_C32(0x5fe79b0c),
    SPH_C32(0xcebc5603) },
  { SPH_C32(0x1e5a0000), SPH_C32(0x05180026), SPH_C32(0x5c328000),
    SPH_C32(0x4f2f0000), SPH_C32(0x43a94510), SPH_C32(0x486768a9),
    SPH_C32(0x93862229), SPH_C32(0x51494943), SPH_C32(0x8de70000),
    SPH_C32(0xff3d0052), SPH_C32(0x2f71e000), SPH_C32(0x890d0000),
    SPH_C32(0xcec613b3), SPH_C32(0x4f0b6bbb), SPH_C32(0x7e483ae6),
    SPH_C32(0x7e194e37) },
  { SPH_C32(0x5fce0000), SPH_C32(0xc675000c), SPH_C32(0xeb450000),
    SPH_C32(0x7b450000), SPH_C32(0x75063a62), SPH_C32(0x67cd2643),
    SPH_C32(0x122f6b61), SPH_C32(0x1675c999), SPH_C32(0x1f870000),
    SPH_C32(0xe3ce006c), SPH_C32(0x9e340000), SPH_C32(0x55ed0000),
    SPH_C32(0x40cf130d), SPH_C32(0x3d700f24), SPH_C32(0xcc736312),
    SPH_C32(0xb3ce4f0e) },
  { SPH_C32(0xd9b70000), SPH_C32(0xf94c000e), SPH_C32(0x0adfe000),
    SPH_C32(0xe3130000), SPH_C32(0xe0635d6c), SPH_C32(0x2945eea9),
    SPH_C32(0xc1f22225), SPH_C32(0x00681320), SPH_C32(0x2f300000),
    SPH_C32(0x061e006c), SPH_C32(0x6ac06000), SPH_C32(0x17290000),
    SPH_C32(0x23772e67), SPH_C32(0x45ca9b44), SPH_C32(0xeddcc2f8),
    SPH_C32(0x036b573a) },
  { SPH_C32(0x6f790000), SPH_C32(0x23a5000c), SPH_C32(0x1fb16000),
    SPH_C32(0x39810000), SPH_C32(0x16be0708), SPH_C32(0x1f77b223),
    SPH_C32(0x3380ca8b), SPH_C32(0xa6d0d1ad), SPH_C32(0xa9490000),
    SPH_C32(0x3927006e), SPH_C32(0x8b5a8000), SPH_C32(0x8f7f0000),
    SPH_C32(0xb6124969), SPH_C32(0x0b4253ae), SPH_C32(0x3e018bbc),
    SPH_C32(0x15768d83) },
  { SPH_C32(0xe9000000), SPH_C32(0x1c9c000e), SPH_C32(0xfe2b8000),
    SPH_C32(0xa1d70000), SPH_C32(0x83db6006), SPH_C32(0x51ff7ac9),
    SPH_C32(0xe05d83cf), SPH_C32(0xb0cd0b14), SPH_C32(0x99fe0000),
    SPH_C32(0xdcf7006e), SPH_C32(0x7faee000), SPH_C32(0xcdbb0000),
    SPH_C32(0xd5aa7403), SPH_C32(0x73f8c7ce), SPH_C32(0x1fae2a56),
    SPH_C32(0xa5d395b7) },
  { SPH_C32(0x4bd70000), SPH_C32(0xe5bf0030), SPH_C32(0xbb9a0000),
    SPH_C32(0x3ff30000), SPH_C32(0x6e6a5dd2), SPH_C32(0x5b3e8a36),
    SPH_C32(0x73c97bd1), SPH_C32(0xcdbf1219), SPH_C32(0xfcc40000),
    SPH_C32(0xd9800078), SPH_C32(0x6cf20000), SPH_C32(0xffa30000),
    SPH_C32(0x9bd151ab), SPH_C32(0x181bb131), SPH_C32(0xde4ed244),
    SPH_C32(0x8980d6d9) },
  { SPH_C32(0xcdae0000), SPH_C32(0xda860032), SPH_C32(0x5a00e000),
    SPH_C32(0xa7a50000), SPH_C32(0xfb0f3adc), SPH_C32(0x15b642dc),
    SPH_C32(0xa0143295), SPH_C32(0xdba2c8a0), SPH_C32(0xcc730000),
    SPH_C32(0x3c500078), SPH_C32(0x98066000), SPH_C32(0xbd670000),
    SPH_C32(0xf8696cc1), SPH_C32(0x60a12551), SPH_C32(0xffe173ae),
    SPH_C32(0x3925ceed) },
  { SPH_C32(0x7b600000), SPH_C32(0x006f0030), SPH_C32(0x4f6e6000),
    SPH_C32(0x7d370000), SPH_C32(0x0dd260b8), SPH_C32(0x23841e56),
    SPH_C32(0x5266da3b), SPH_C32(0x7d1a0a2d), SPH_C32(0x4a0a0000),
    SPH_C32(0x0369007a), SPH_C32(0x799c8000), SPH_C32(0x25310000),
    SPH_C32(0x6d0c0bcf), SPH_C32(0x2e29edbb), SPH_C32(0x2c3c3aea),
    SPH_C32(0x2f381454) },
  { SPH_C32(0xfd190000), SPH_C32(0x3f560032), SPH_C32(0xaef48000),
    SPH_C32(0xe5610000), SPH_C32(0x98b707b6), SPH_C32(0x6d0cd6bc),
    SPH_C32(0x81bb937f), SPH_C32(0x6b07d094), SPH_C32(0x7abd0000),
    SPH_C32(0xe6b9007a), SPH_C32(0x8d68e000), SPH_C32(0x67f50000),
    SPH_C32(0x0eb436a5), SPH_C32(0x569379db), SPH_C32(0x0d939b00),
    SPH_C32(0x9f9d0c60) },
  { SPH_C32(0xe8dd0000), SPH_C32(0xfa4a0044), SPH_C32(0x3c2d0000),
    SPH_C32(0xbb150000), SPH_C32(0x80bd361b), SPH_C32(0x24e81d44),
    SPH_C32(0xbfa8c2f4), SPH_C32(0x524a0d59), SPH_C32(0x54500000),
    SPH_C32(0x0671005c), SPH_C32(0x25ae0000), SPH_C32(0x6a1e0000),
    SPH_C32(0x2ea54edf), SPH_C32(0x664e8512), SPH_C32(0xbfba18c3),
    SPH_C32(0x7e715d17) },
  { SPH_C32(0x6ea40000), SPH_C32(0xc5730046), SPH_C32(0xddb7e000),
    SPH_C32(0x23430000), SPH_C32(0x15d85115), SPH_C32(0x6a60d5ae),
    SPH_C32(0x6c758bb0), SPH_C32(0x4457d7e0), SPH_C32(0x64e70000),
    SPH_C32(0xe3a1005c), SPH_C32(0xd15a6000), SPH_C32(0x28da0000),
    SPH_C32(0x4d1d73b5), SPH_C32(0x1ef41172), SPH_C32(0x9e15b929),
    SPH_C32(0xced44523) },
  { SPH_C32(0xd86a0000), SPH_C32(0x1f9a0044), SPH_C32(0xc8d96000),
    SPH_C32(0xf9d10000), SPH_C32(0xe3050b71), SPH_C32(0x5c528924),
    SPH_C32(0x9e07631e), SPH_C32(0xe2ef156d), SPH_C32(0xe29e0000),
    SPH_C32(0xdc98005e), SPH_C32(0x30c08000), SPH_C32(0xb08c0000),
    SPH_C32(0xd87814bb), SPH_C32(0x507cd998), SPH_C32(0x4dc8f06d),
    SPH_C32(0xd8c99f9a) },
  { SPH_C32(0x5e130000), SPH_C32(0x20a30046), SPH_C32(0x29438000),
    SPH_C32(0x61870000), SPH_C32(0x76606c7f), SPH_C32(0x12da41ce),
    SPH_C32(0x4dda2a5a), SPH_C32(0xf4f2cfd4), SPH_C32(0xd2290000),
    SPH_C32(0x3948005e), SPH_C32(0xc434e000), SPH_C32(0xf2480000),
    SPH_C32(0xbbc029d1), SPH_C32(0x28c64df8), SPH_C32(0x6c675187),
    SPH_C32(0x686c87ae) },
  { SPH_C32(0xfcc40000), SPH_C32(0xd9800078), SPH_C32(0x6cf20000),
    SPH_C32(0xffa30000), SPH_C32(0x9bd151ab), SPH_C32(0x181bb131),
    SPH_C32(0xde4ed244), SPH_C32(0x8980d6d9), SPH_C32(0xb7130000),
    SPH_C32(0x3c3f0048), SPH_C32(0xd7680000), SPH_C32(0xc0500000),
    SPH_C32(0xf5bb0c79), SPH_C32(0x43253b07), SPH_C32(0xad87a995),
    SPH_C32(0x443fc4c0) },
  { SPH_C32(0x7abd0000), SPH_C32(0xe6b9007a), SPH_C32(0x8d68e000),
    SPH_C32(0x67f50000), SPH_C32(0x0eb436a5), SPH_C32(0x569379db),
    SPH_C32(0x0d939b00), SPH_C32(0x9f9d0c60), SPH_C32(0x87a40000),
    SPH_C32(0xd9ef0048), SPH_C32(0x239c6000), SPH_C32(0x82940000),
    SPH_C32(0x96033113), SPH_C32(0x3b9faf67), SPH_C32(0x8c28087f),
    SPH_C32(0xf49adcf4) },
  { SPH_C32(0xcc730000), SPH_C32(0x3c500078), SPH_C32(0x98066000),
    SPH_C32(0xbd670000), SPH_C32(0xf8696cc1), SPH_C32(0x60a12551),
    SPH_C32(0xffe173ae), SPH_C32(0x3925ceed), SPH_C32(0x01dd0000),
    SPH_C32(0xe6d6004a), SPH_C32(0xc2068000), SPH_C32(0x1ac20000),
    SPH_C32(0x0366561d), SPH_C32(0x7517678d), SPH_C32(0x5ff5413b),
    SPH_C32(0xe287064d) },
  { SPH_C32(0x4a0a0000), SPH_C32(0x0369007a), SPH_C32(0x799c8000),
    SPH_C32(0x25310000), SPH_C32(0x6d0c0bcf), SPH_C32(0x2e29edbb),
    SPH_C32(0x2c3c3aea), SPH_C32(0x2f381454), SPH_C32(0x316a0000),
    SPH_C32(0x0306004a), SPH_C32(0x36f2e000), SPH_C32(0x58060000),
    SPH_C32(0x60de6b77), SPH_C32(0x0dadf3ed), SPH_C32(0x7e5ae0d1),
    SPH_C32(0x52221e79) },
  { SPH_C32(0x0b9e0000), SPH_C32(0xc0040050), SPH_C32(0xceeb0000),
    SPH_C32(0x115b0000), SPH_C32(0x5ba374bd), SPH_C32(0x0183a351),
    SPH_C32(0xad9573a2), SPH_C32(0x6804948e), SPH_C32(0xa30a0000),
    SPH_C32(0x1ff50074), SPH_C32(0x87b70000), SPH_C32(0x84e60000),
    SPH_C32(0xeed76bc9), SPH_C32(0x7fd69772), SPH_C32(0xcc61b925),
    SPH_C32(0x9ff51f40) },
  { SPH_C32(0x8de70000), SPH_C32(0xff3d0052), SPH_C32(0x2f71e000),
    SPH_C32(0x890d0000), SPH_C32(0xcec613b3), SPH_C32(0x4f0b6bbb),
    SPH_C32(0x7e483ae6), SPH_C32(0x7e194e37), SPH_C32(0x93bd0000),
    SPH_C32(0xfa250074), SPH_C32(0x73436000), SPH_C32(0xc6220000),
    SPH_C32(0x8d6f56a3), SPH_C32(0x076c0312), SPH_C32(0xedce18cf),
    SPH_C32(0x2f500774) },
  { SPH_C32(0x3b290000), SPH_C32(0x25d40050), SPH_C32(0x3a1f6000),
    SPH_C32(0x539f0000), SPH_C32(0x381b49d7), SPH_C32(0x79393731),
    SPH_C32(0x8c3ad248), SPH_C32(0xd8a18cba), SPH_C32(0x15c40000),
    SPH_C32(0xc51c0076), SPH_C32(0x92d98000), SPH_C32(0x5e740000),
    SPH_C32(0x180a31ad), SPH_C32(0x49e4cbf8), SPH_C32(0x3e13518b),
    SPH_C32(0x394dddcd) },
  { SPH_C32(0xbd500000), SPH_C32(0x1aed0052), SPH_C32(0xdb858000),
    SPH_C32(0xcbc90000), SPH_C32(0xad7e2ed9), SPH_C32(0x37b1ffdb),
    SPH_C32(0x5fe79b0c), SPH_C32(0xcebc5603), SPH_C32(0x25730000),
    SPH_C32(0x20cc0076), SPH_C32(0x662de000), SPH_C32(0x1cb00000),
    SPH_C32(0x7bb20cc7), SPH_C32(0x315e5f98), SPH_C32(0x1fbcf061),
    SPH_C32(0x89e8c5f9) },
  { SPH_C32(0x1f870000), SPH_C32(0xe3ce006c), SPH_C32(0x9e340000),
    SPH_C32(0x55ed0000), SPH_C32(0x40cf130d), SPH_C32(0x3d700f24),
    SPH_C32(0xcc736312), SPH_C32(0xb3ce4f0e), SPH_C32(0x40490000),
    SPH_C32(0x25bb0060), SPH_C32(0x75710000), SPH_C32(0x2ea80000),
    SPH_C32(0x35c9296f), SPH_C32(0x5abd2967), SPH_C32(0xde5c0873),
    SPH_C32(0xa5bb8697) },
  { SPH_C32(0x99fe0000), SPH_C32(0xdcf7006e), SPH_C32(0x7faee000),
    SPH_C32(0xcdbb0000), SPH_C32(0xd5aa7403), SPH_C32(0x73f8c7ce),
    SPH_C32(0x1fae2a56), SPH_C32(0xa5d395b7), SPH_C32(0x70fe0000),
    SPH_C32(0xc06b0060), SPH_C32(0x81856000), SPH_C32(0x6c6c0000),
    SPH_C32(0x56711405), SPH_C32(0x2207bd07), SPH_C32(0xfff3a999),
    SPH_C32(0x151e9ea3) },
  { SPH_C32(0x2f300000), SPH_C32(0x061e006c), SPH_C32(0x6ac06000),
    SPH_C32(0x17290000), SPH_C32(0x23772e67), SPH_C32(0x45ca9b44),
    SPH_C32(0xeddcc2f8), SPH_C32(0x036b573a), SPH_C32(0xf6870000),
    SPH_C32(0xff520062), SPH_C32(0x601f8000), SPH_C32(0xf43a0000),
    SPH_C32(0xc314730b), SPH_C32(0x6c8f75ed), SPH_C32(0x2c2ee0dd),
    SPH_C32(0x0303441a) },
  { SPH_C32(0xa9490000), SPH_C32(0x3927006e), SPH_C32(0x8b5a8000),
    SPH_C32(0x8f7f0000), SPH_C32(0xb6124969), SPH_C32(0x0b4253ae),
    SPH_C32(0x3e018bbc), SPH_C32(0x15768d83), SPH_C32(0xc6300000),
    SPH_C32(0x1a820062), SPH_C32(0x94ebe000), SPH_C32(0xb6fe0000),
    SPH_C32(0xa0ac4e61), SPH_C32(0x1435e18d), SPH_C32(0x0d814137),
    SPH_C32(0xb3a65c2e) },
  { SPH_C32(0x69510000), SPH_C32(0xd4e1009c), SPH_C32(0xc3230000),
    SPH_C32(0xac2f0000), SPH_C32(0xe4950bae), SPH_C32(0xcea415dc),
    SPH_C32(0x87ec287c), SPH_C32(0xbce1a3ce), SPH_C32(0xc6730000),
    SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000), SPH_C32(0x218d0000),
    SPH_C32(0x23111587), SPH_C32(0x7913512f), SPH_C32(0x1d28ac88),
    SPH_C32(0x378dd173) },
  { SPH_C32(0xef280000), SPH_C32(0xebd8009e), SPH_C32(0x22b9e000),
    SPH_C32(0x34790000), SPH_C32(0x71f06ca0), SPH_C32(0x802cdd36),
    SPH_C32(0x54316138), SPH_C32(0xaafc7977), SPH_C32(0xf6c40000),
    SPH_C32(0x4a5d000c), SPH_C32(0x50356000), SPH_C32(0x63490000),
    SPH_C32(0x40a928ed), SPH_C32(0x01a9c54f), SPH_C32(0x3c870d62),
    SPH_C32(0x8728c947) },
  { SPH_C32(0x59e60000), SPH_C32(0x3131009c), SPH_C32(0x37d76000),
    SPH_C32(0xeeeb0000), SPH_C32(0x872d36c4), SPH_C32(0xb61e81bc),
    SPH_C32(0xa6438996), SPH_C32(0x0c44bbfa), SPH_C32(0x70bd0000),
    SPH_C32(0x7564000e), SPH_C32(0xb1af8000), SPH_C32(0xfb1f0000),
    SPH_C32(0xd5cc4fe3), SPH_C32(0x4f210da5), SPH_C32(0xef5a4426),
    SPH_C32(0x913513fe) },
  { SPH_C32(0xdf9f0000), SPH_C32(0x0e08009e), SPH_C32(0xd64d8000),
    SPH_C32(0x76bd0000), SPH_C32(0x124851ca), SPH_C32(0xf8964956),
    SPH_C32(0x759ec0d2), SPH_C32(0x1a596143), SPH_C32(0x400a0000),
    SPH_C32(0x90b4000e), SPH_C32(0x455be000), SPH_C32(0xb9db0000),
    SPH_C32(0xb6747289), SPH_C32(0x379b99c5), SPH_C32(0xcef5e5cc),
    SPH_C32(0x21900bca) },
  { SPH_C32(0x7d480000), SPH_C32(0xf72b00a0), SPH_C32(0x93fc0000),
    SPH_C32(0xe8990000), SPH_C32(0xfff96c1e), SPH_C32(0xf257b9a9),
    SPH_C32(0xe60a38cc), SPH_C32(0x672b784e), SPH_C32(0x25300000),
    SPH_C32(0x95c30018), SPH_C32(0x56070000), SPH_C32(0x8bc30000),
    SPH_C32(0xf80f5721), SPH_C32(0x5c78ef3a), SPH_C32(0x0f151dde),
    SPH_C32(0x0dc348a4) },
  { SPH_C32(0xfb310000), SPH_C32(0xc81200a2), SPH_C32(0x7266e000),
    SPH_C32(0x70cf0000), SPH_C32(0x6a9c0b10), SPH_C32(0xbcdf7143),
    SPH_C32(0x35d77188), SPH_C32(0x7136a2f7), SPH_C32(0x15870000),
    SPH_C32(0x70130018), SPH_C32(0xa2f36000), SPH_C32(0xc9070000),
    SPH_C32(0x9bb76a4b), SPH_C32(0x24c27b5a), SPH_C32(0x2ebabc34),
    SPH_C32(0xbd665090) },
  { SPH_C32(0x4dff0000), SPH_C32(0x12fb00a0), SPH_C32(0x67086000),
    SPH_C32(0xaa5d0000), SPH_C32(0x9c415174), SPH_C32(0x8aed2dc9),
    SPH_C32(0xc7a59926), SPH_C32(0xd78e607a), SPH_C32(0x93fe0000),
    SPH_C32(0x4f2a001a), SPH_C32(0x43698000), SPH_C32(0x51510000),
    SPH_C32(0x0ed20d45), SPH_C32(0x6a4ab3b0), SPH_C32(0xfd67f570),
    SPH_C32(0xab7b8a29) },
  { SPH_C32(0xcb860000), SPH_C32(0x2dc200a2), SPH_C32(0x86928000),
    SPH_C32(0x320b0000), SPH_C32(0x0924367a), SPH_C32(0xc465e523),
    SPH_C32(0x1478d062), SPH_C32(0xc193bac3), SPH_C32(0xa3490000),
    SPH_C32(0xaafa001a), SPH_C32(0xb79de000), SPH_C32(0x13950000),
    SPH_C32(0x6d6a302f), SPH_C32(0x12f027d0), SPH_C32(0xdcc8549a),
    SPH_C32(0x1bde921d) },
  { SPH_C32(0x8a120000), SPH_C32(0xeeaf0088), SPH_C32(0x31e50000),
    SPH_C32(0x06610000), SPH_C32(0x3f8b4908), SPH_C32(0xebcfabc9),
    SPH_C32(0x95d1992a), SPH_C32(0x86af3a19), SPH_C32(0x31290000),
    SPH_C32(0xb6090024), SPH_C32(0x06d80000), SPH_C32(0xcf750000),
    SPH_C32(0xe3633091), SPH_C32(0x608b434f), SPH_C32(0x6ef30d6e),
    SPH_C32(0xd6099324) },
  { SPH_C32(0x0c6b0000), SPH_C32(0xd196008a), SPH_C32(0xd07fe000),
    SPH_C32(0x9e370000), SPH_C32(0xaaee2e06), SPH_C32(0xa5476323),
    SPH_C32(0x460cd06e), SPH_C32(0x90b2e0a0), SPH_C32(0x019e0000),
    SPH_C32(0x53d90024), SPH_C32(0xf22c6000), SPH_C32(0x8db10000),
    SPH_C32(0x80db0dfb), SPH_C32(0x1831d72f), SPH_C32(0x4f5cac84),
    SPH_C32(0x66ac8b10) },
  { SPH_C32(0xbaa50000), SPH_C32(0x0b7f0088), SPH_C32(0xc5116000),
    SPH_C32(0x44a50000), SPH_C32(0x5c337462), SPH_C32(0x93753fa9),
    SPH_C32(0xb47e38c0), SPH_C32(0x360a222d), SPH_C32(0x87e70000),
    SPH_C32(0x6ce00026), SPH_C32(0x13b68000), SPH_C32(0x15e70000),
    SPH_C32(0x15be6af5), SPH_C32(0x56b91fc5), SPH_C32(0x9c81e5c0),
    SPH_C32(0x70b151a9) },
  { SPH_C32(0x3cdc0000), SPH_C32(0x3446008a), SPH_C32(0x248b8000),
    SPH_C32(0xdcf30000), SPH_C32(0xc956136c), SPH_C32(0xddfdf743),
    SPH_C32(0x67a37184), SPH_C32(0x2017f894), SPH_C32(0xb7500000),
    SPH_C32(0x89300026), SPH_C32(0xe742e000), SPH_C32(0x57230000),
    SPH_C32(0x7606579f), SPH_C32(0x2e038ba5), SPH_C32(0xbd2e442a),
    SPH_C32(0xc014499d) },
  { SPH_C32(0x9e0b0000), SPH_C32(0xcd6500b4), SPH_C32(0x613a0000),
    SPH_C32(0x42d70000), SPH_C32(0x24e72eb8), SPH_C32(0xd73c07bc),
    SPH_C32(0xf437899a), SPH_C32(0x5d65e199), SPH_C32(0xd26a0000),
    SPH_C32(0x8c470030), SPH_C32(0xf41e0000), SPH_C32(0x653b0000),
    SPH_C32(0x387d7237), SPH_C32(0x45e0fd5a), SPH_C32(0x7ccebc38),
    SPH_C32(0xec470af3) },
  { SPH_C32(0x18720000), SPH_C32(0xf25c00b6), SPH_C32(0x80a0e000),
    SPH_C32(0xda810000), SPH_C32(0xb18249b6), SPH_C32(0x99b4cf56),
    SPH_C32(0x27eac0de), SPH_C32(0x4b783b20), SPH_C32(0xe2dd0000),
    SPH_C32(0x69970030), SPH_C32(0x00ea6000), SPH_C32(0x27ff0000),
    SPH_C32(0x5bc54f5d), SPH_C32(0x3d5a693a), SPH_C32(0x5d611dd2),
    SPH_C32(0x5ce212c7) },
  { SPH_C32(0xaebc0000), SPH_C32(0x28b500b4), SPH_C32(0x95ce6000),
    SPH_C32(0x00130000), SPH_C32(0x475f13d2), SPH_C32(0xaf8693dc),
    SPH_C32(0xd5982870), SPH_C32(0xedc0f9ad), SPH_C32(0x64a40000),
    SPH_C32(0x56ae0032), SPH_C32(0xe1708000), SPH_C32(0xbfa90000),
    SPH_C32(0xcea02853), SPH_C32(0x73d2a1d0), SPH_C32(0x8ebc5496),
    SPH_C32(0x4affc87e) },
  { SPH_C32(0x28c50000), SPH_C32(0x178c00b6), SPH_C32(0x74548000),
    SPH_C32(0x98450000), SPH_C32(0xd23a74dc), SPH_C32(0xe10e5b36),
    SPH_C32(0x06456134), SPH_C32(0xfbdd2314), SPH_C32(0x54130000),
    SPH_C32(0xb37e0032), SPH_C32(0x1584e000), SPH_C32(0xfd6d0000),
    SPH_C32(0xad181539), SPH_C32(0x0b6835b0), SPH_C32(0xaf13f57c),
    SPH_C32(0xfa5ad04a) },
  { SPH_C32(0x3d010000), SPH_C32(0xd29000c0), SPH_C32(0xe68d0000),
    SPH_C32(0xc6310000), SPH_C32(0xca304571), SPH_C32(0xa8ea90ce),
    SPH_C32(0x385630bf), SPH_C32(0xc290fed9), SPH_C32(0x7afe0000),
    SPH_C32(0x53b60014), SPH_C32(0xbd420000), SPH_C32(0xf0860000),
    SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979), SPH_C32(0x1d3a76bf),
    SPH_C32(0x1bb6813d) },
  { SPH_C32(0xbb780000), SPH_C32(0xeda900c2), SPH_C32(0x0717e000),
    SPH_C32(0x5e670000), SPH_C32(0x5f55227f), SPH_C32(0xe6625824),
    SPH_C32(0xeb8b79fb), SPH_C32(0xd48d2460), SPH_C32(0x4a490000),
    SPH_C32(0xb6660014), SPH_C32(0x49b66000), SPH_C32(0xb2420000),
    SPH_C32(0xeeb15029), SPH_C32(0x430f5d19), SPH_C32(0x3c95d755),
    SPH_C32(0xab139909) },
  { SPH_C32(0x0db60000), SPH_C32(0x374000c0), SPH_C32(0x12796000),
    SPH_C32(0x84f50000), SPH_C32(0xa988781b), SPH_C32(0xd05004ae),
    SPH_C32(0x19f99155), SPH_C32(0x7235e6ed), SPH_C32(0xcc300000),
    SPH_C32(0x895f0016), SPH_C32(0xa82c8000), SPH_C32(0x2a140000),
    SPH_C32(0x7bd43727), SPH_C32(0x0d8795f3), SPH_C32(0xef489e11),
    SPH_C32(0xbd0e43b0) },
  { SPH_C32(0x8bcf0000), SPH_C32(0x087900c2), SPH_C32(0xf3e38000),
    SPH_C32(0x1ca30000), SPH_C32(0x3ced1f15), SPH_C32(0x9ed8cc44),
    SPH_C32(0xca24d811), SPH_C32(0x64283c54), SPH_C32(0xfc870000),
    SPH_C32(0x6c8f0016), SPH_C32(0x5cd8e000), SPH_C32(0x68d00000),
    SPH_C32(0x186c0a4d), SPH_C32(0x753d0193), SPH_C32(0xcee73ffb),
    SPH_C32(0x0dab5b84) },
  { SPH_C32(0x29180000), SPH_C32(0xf15a00fc), SPH_C32(0xb6520000),
    SPH_C32(0x82870000), SPH_C32(0xd15c22c1), SPH_C32(0x94193cbb),
    SPH_C32(0x59b0200f), SPH_C32(0x195a2559), SPH_C32(0x99bd0000),
    SPH_C32(0x69f80000), SPH_C32(0x4f840000), SPH_C32(0x5ac80000),
    SPH_C32(0x56172fe5), SPH_C32(0x1ede776c), SPH_C32(0x0f07c7e9),
    SPH_C32(0x21f818ea) },
  { SPH_C32(0xaf610000), SPH_C32(0xce6300fe), SPH_C32(0x57c8e000),
    SPH_C32(0x1ad10000), SPH_C32(0x443945cf), SPH_C32(0xda91f451),
    SPH_C32(0x8a6d694b), SPH_C32(0x0f47ffe0), SPH_C32(0xa90a0000),
    SPH_C32(0x8c280000), SPH_C32(0xbb706000), SPH_C32(0x180c0000),
    SPH_C32(0x35af128f), SPH_C32(0x6664e30c), SPH_C32(0x2ea86603),
    SPH_C32(0x915d00de) },
  { SPH_C32(0x19af0000), SPH_C32(0x148a00fc), SPH_C32(0x42a66000),
    SPH_C32(0xc0430000), SPH_C32(0xb2e41fab), SPH_C32(0xeca3a8db),
    SPH_C32(0x781f81e5), SPH_C32(0xa9ff3d6d), SPH_C32(0x2f730000),
    SPH_C32(0xb3110002), SPH_C32(0x5aea8000), SPH_C32(0x805a0000),
    SPH_C32(0xa0ca7581), SPH_C32(0x28ec2be6), SPH_C32(0xfd752f47),
    SPH_C32(0x8740da67) },
  { SPH_C32(0x9fd60000), SPH_C32(0x2bb300fe), SPH_C32(0xa33c8000),
    SPH_C32(0x58150000), SPH_C32(0x278178a5), SPH_C32(0xa22b6031),
    SPH_C32(0xabc2c8a1), SPH_C32(0xbfe2e7d4), SPH_C32(0x1fc40000),
    SPH_C32(0x56c10002), SPH_C32(0xae1ee000), SPH_C32(0xc29e0000),
    SPH_C32(0xc37248eb), SPH_C32(0x5056bf86), SPH_C32(0xdcda8ead),
    SPH_C32(0x37e5c253) },
  { SPH_C32(0xde420000), SPH_C32(0xe8de00d4), SPH_C32(0x144b0000),
    SPH_C32(0x6c7f0000), SPH_C32(0x112e07d7), SPH_C32(0x8d812edb),
    SPH_C32(0x2a6b81e9), SPH_C32(0xf8de670e), SPH_C32(0x8da40000),
    SPH_C32(0x4a32003c), SPH_C32(0x1f5b0000), SPH_C32(0x1e7e0000),
    SPH_C32(0x4d7b4855), SPH_C32(0x222ddb19), SPH_C32(0x6ee1d759),
    SPH_C32(0xfa32c36a) },
  { SPH_C32(0x583b0000), SPH_C32(0xd7e700d6), SPH_C32(0xf5d1e000),
    SPH_C32(0xf4290000), SPH_C32(0x844b60d9), SPH_C32(0xc309e631),
    SPH_C32(0xf9b6c8ad), SPH_C32(0xeec3bdb7), SPH_C32(0xbd130000),
    SPH_C32(0xafe2003c), SPH_C32(0xebaf6000), SPH_C32(0x5cba0000),
    SPH_C32(0x2ec3753f), SPH_C32(0x5a974f79), SPH_C32(0x4f4e76b3),
    SPH_C32(0x4a97db5e) },
  { SPH_C32(0xeef50000), SPH_C32(0x0d0e00d4), SPH_C32(0xe0bf6000),
    SPH_C32(0x2ebb0000), SPH_C32(0x72963abd), SPH_C32(0xf53bbabb),
    SPH_C32(0x0bc42003), SPH_C32(0x487b7f3a), SPH_C32(0x3b6a0000),
    SPH_C32(0x90db003e), SPH_C32(0x0a358000), SPH_C32(0xc4ec0000),
    SPH_C32(0xbba61231), SPH_C32(0x141f8793), SPH_C32(0x9c933ff7),
    SPH_C32(0x5c8a01e7) },
  { SPH_C32(0x688c0000), SPH_C32(0x323700d6), SPH_C32(0x01258000),
    SPH_C32(0xb6ed0000), SPH_C32(0xe7f35db3), SPH_C32(0xbbb37251),
    SPH_C32(0xd8196947), SPH_C32(0x5e66a583), SPH_C32(0x0bdd0000),
    SPH_C32(0x750b003e), SPH_C32(0xfec1e000), SPH_C32(0x86280000),
    SPH_C32(0xd81e2f5b), SPH_C32(0x6ca513f3), SPH_C32(0xbd3c9e1d),
    SPH_C32(0xec2f19d3) },
  { SPH_C32(0xca5b0000), SPH_C32(0xcb1400e8), SPH_C32(0x44940000),
    SPH_C32(0x28c90000), SPH_C32(0x0a426067), SPH_C32(0xb17282ae),
    SPH_C32(0x4b8d9159), SPH_C32(0x2314bc8e), SPH_C32(0x6ee70000),
    SPH_C32(0x707c0028), SPH_C32(0xed9d0000), SPH_C32(0xb4300000),
    SPH_C32(0x96650af3), SPH_C32(0x0746650c), SPH_C32(0x7cdc660f),
    SPH_C32(0xc07c5abd) },
  { SPH_C32(0x4c220000), SPH_C32(0xf42d00ea), SPH_C32(0xa50ee000),
    SPH_C32(0xb09f0000), SPH_C32(0x9f270769), SPH_C32(0xfffa4a44),
    SPH_C32(0x9850d81d), SPH_C32(0x35096637), SPH_C32(0x5e500000),
    SPH_C32(0x95ac0028), SPH_C32(0x19696000), SPH_C32(0xf6f40000),
    SPH_C32(0xf5dd3799), SPH_C32(0x7ffcf16c), SPH_C32(0x5d73c7e5),
    SPH_C32(0x70d94289) },
  { SPH_C32(0xfaec0000), SPH_C32(0x2ec400e8), SPH_C32(0xb0606000),
    SPH_C32(0x6a0d0000), SPH_C32(0x69fa5d0d), SPH_C32(0xc9c816ce),
    SPH_C32(0x6a2230b3), SPH_C32(0x93b1a4ba), SPH_C32(0xd8290000),
    SPH_C32(0xaa95002a), SPH_C32(0xf8f38000), SPH_C32(0x6ea20000),
    SPH_C32(0x60b85097), SPH_C32(0x31743986), SPH_C32(0x8eae8ea1),
    SPH_C32(0x66c49830) },
  { SPH_C32(0x7c950000), SPH_C32(0x11fd00ea), SPH_C32(0x51fa8000),
    SPH_C32(0xf25b0000), SPH_C32(0xfc9f3a03), SPH_C32(0x8740de24),
    SPH_C32(0xb9ff79f7), SPH_C32(0x85ac7e03), SPH_C32(0xe89e0000),
    SPH_C32(0x4f45002a), SPH_C32(0x0c07e000), SPH_C32(0x2c660000),
    SPH_C32(0x03006dfd), SPH_C32(0x49ceade6), SPH_C32(0xaf012f4b),
    SPH_C32(0xd6618004) },
  { SPH_C32(0xd5dc0000), SPH_C32(0x28da0084), SPH_C32(0xdaa00000),
    SPH_C32(0x7d240000), SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a),
    SPH_C32(0x87fef24b), SPH_C32(0x90daf380), SPH_C32(0x2eae0000),
    SPH_C32(0x55c70048), SPH_C32(0x98ec0000), SPH_C32(0x9a980000),
    SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b), SPH_C32(0xa2806e7c),
    SPH_C32(0x65c7dc2a) },
  { SPH_C32(0x53a50000), SPH_C32(0x17e30086), SPH_C32(0x3b3ae000),
    SPH_C32(0xe5720000), SPH_C32(0xdfe81464), SPH_C32(0xc28a4560),
    SPH_C32(0x5423bb0f), SPH_C32(0x86c72939), SPH_C32(0x1e190000),
    SPH_C32(0xb0170048), SPH_C32(0x6c186000), SPH_C32(0xd85c0000),
    SPH_C32(0xc0141ef6), SPH_C32(0x2541d80b), SPH_C32(0x832fcf96),
    SPH_C32(0xd562c41e) },
  { SPH_C32(0xe56b0000), SPH_C32(0xcd0a0084), SPH_C32(0x2e546000),
    SPH_C32(0x3fe00000), SPH_C32(0x29354e00), SPH_C32(0xf4b819ea),
    SPH_C32(0xa65153a1), SPH_C32(0x207febb4), SPH_C32(0x98600000),
    SPH_C32(0x8f2e004a), SPH_C32(0x8d828000), SPH_C32(0x400a0000),
    SPH_C32(0x557179f8), SPH_C32(0x6bc910e1), SPH_C32(0x50f286d2),
    SPH_C32(0xc37f1ea7) },
  { SPH_C32(0x63120000), SPH_C32(0xf2330086), SPH_C32(0xcfce8000),
    SPH_C32(0xa7b60000), SPH_C32(0xbc50290e), SPH_C32(0xba30d100),
    SPH_C32(0x758c1ae5), SPH_C32(0x3662310d), SPH_C32(0xa8d70000),
    SPH_C32(0x6afe004a), SPH_C32(0x7976e000), SPH_C32(0x02ce0000),
    SPH_C32(0x36c94492), SPH_C32(0x13738481), SPH_C32(0x715d2738),
    SPH_C32(0x73da0693) },
  { SPH_C32(0xc1c50000), SPH_C32(0x0b1000b8), SPH_C32(0x8a7f0000),
    SPH_C32(0x39920000), SPH_C32(0x51e114da), SPH_C32(0xb0f121ff),
    SPH_C32(0xe618e2fb), SPH_C32(0x4b102800), SPH_C32(0xcded0000),
    SPH_C32(0x6f89005c), SPH_C32(0x6a2a0000), SPH_C32(0x30d60000),
    SPH_C32(0x78b2613a), SPH_C32(0x7890f27e), SPH_C32(0xb0bddf2a),
    SPH_C32(0x5f8945fd) },
  { SPH_C32(0x47bc0000), SPH_C32(0x342900ba), SPH_C32(0x6be5e000),
    SPH_C32(0xa1c40000), SPH_C32(0xc48473d4), SPH_C32(0xfe79e915),
    SPH_C32(0x35c5abbf), SPH_C32(0x5d0df2b9), SPH_C32(0xfd5a0000),
    SPH_C32(0x8a59005c), SPH_C32(0x9ede6000), SPH_C32(0x72120000),
    SPH_C32(0x1b0a5c50), SPH_C32(0x002a661e), SPH_C32(0x91127ec0),
    SPH_C32(0xef2c5dc9) },
  { SPH_C32(0xf1720000), SPH_C32(0xeec000b8), SPH_C32(0x7e8b6000),
    SPH_C32(0x7b560000), SPH_C32(0x325929b0), SPH_C32(0xc84bb59f),
    SPH_C32(0xc7b74311), SPH_C32(0xfbb53034), SPH_C32(0x7b230000),
    SPH_C32(0xb560005e), SPH_C32(0x7f448000), SPH_C32(0xea440000),
    SPH_C32(0x8e6f3b5e), SPH_C32(0x4ea2aef4), SPH_C32(0x42cf3784),
    SPH_C32(0xf9318770) },
  { SPH_C32(0x770b0000), SPH_C32(0xd1f900ba), SPH_C32(0x9f118000),
    SPH_C32(0xe3000000), SPH_C32(0xa73c4ebe), SPH_C32(0x86c37d75),
    SPH_C32(0x146a0a55), SPH_C32(0xeda8ea8d), SPH_C32(0x4b940000),
    SPH_C32(0x50b0005e), SPH_C32(0x8bb0e000), SPH_C32(0xa8800000),
    SPH_C32(0xedd70634), SPH_C32(0x36183a94), SPH_C32(0x6360966e),
    SPH_C32(0x49949f44) },
  { SPH_C32(0x369f0000), SPH_C32(0x12940090), SPH_C32(0x28660000),
    SPH_C32(0xd76a0000), SPH_C32(0x919331cc), SPH_C32(0xa969339f),
    SPH_C32(0x95c3431d), SPH_C32(0xaa946a57), SPH_C32(0xd9f40000),
    SPH_C32(0x4c430060), SPH_C32(0x3af50000), SPH_C32(0x74600000),
    SPH_C32(0x63de068a), SPH_C32(0x44635e0b), SPH_C32(0xd15bcf9a),
    SPH_C32(0x84439e7d) },
  { SPH_C32(0xb0e60000), SPH_C32(0x2dad0092), SPH_C32(0xc9fce000),
    SPH_C32(0x4f3c0000), SPH_C32(0x04f656c2), SPH_C32(0xe7e1fb75),
    SPH_C32(0x461e0a59), SPH_C32(0xbc89b0ee), SPH_C32(0xe9430000),
    SPH_C32(0xa9930060), SPH_C32(0xce016000), SPH_C32(0x36a40000),
    SPH_C32(0x00663be0), SPH_C32(0x3cd9ca6b), SPH_C32(0xf0f46e70),
    SPH_C32(0x34e68649) },
  { SPH_C32(0x06280000), SPH_C32(0xf7440090), SPH_C32(0xdc926000),
    SPH_C32(0x95ae0000), SPH_C32(0xf22b0ca6), SPH_C32(0xd1d3a7ff),
    SPH_C32(0xb46ce2f7), SPH_C32(0x1a317263), SPH_C32(0x6f3a0000),
    SPH_C32(0x96aa0062), SPH_C32(0x2f9b8000), SPH_C32(0xaef20000),
    SPH_C32(0x95035cee), SPH_C32(0x72510281), SPH_C32(0x23292734),
    SPH_C32(0x22fb5cf0) },
  { SPH_C32(0x80510000), SPH_C32(0xc87d0092), SPH_C32(0x3d088000),
    SPH_C32(0x0df80000), SPH_C32(0x674e6ba8), SPH_C32(0x9f5b6f15),
    SPH_C32(0x67b1abb3), SPH_C32(0x0c2ca8da), SPH_C32(0x5f8d0000),
    SPH_C32(0x737a0062), SPH_C32(0xdb6fe000), SPH_C32(0xec360000),
    SPH_C32(0xf6bb6184), SPH_C32(0x0aeb96e1), SPH_C32(0x028686de),
    SPH_C32(0x925e44c4) },
  { SPH_C32(0x22860000), SPH_C32(0x315e00ac), SPH_C32(0x78b90000),
    SPH_C32(0x93dc0000), SPH_C32(0x8aff567c), SPH_C32(0x959a9fea),
    SPH_C32(0xf42553ad), SPH_C32(0x715eb1d7), SPH_C32(0x3ab70000),
    SPH_C32(0x760d0074), SPH_C32(0xc8330000), SPH_C32(0xde2e0000),
    SPH_C32(0xb8c0442c), SPH_C32(0x6108e01e), SPH_C32(0xc3667ecc),
    SPH_C32(0xbe0d07aa) },
  { SPH_C32(0xa4ff0000), SPH_C32(0x0e6700ae), SPH_C32(0x9923e000),
    SPH_C32(0x0b8a0000), SPH_C32(0x1f9a3172), SPH_C32(0xdb125700),
    SPH_C32(0x27f81ae9), SPH_C32(0x67436b6e), SPH_C32(0x0a000000),
    SPH_C32(0x93dd0074), SPH_C32(0x3cc76000), SPH_C32(0x9cea0000),
    SPH_C32(0xdb787946), SPH_C32(0x19b2747e), SPH_C32(0xe2c9df26),
    SPH_C32(0x0ea81f9e) },
  { SPH_C32(0x12310000), SPH_C32(0xd48e00ac), SPH_C32(0x8c4d6000),
    SPH_C32(0xd1180000), SPH_C32(0xe9476b16), SPH_C32(0xed200b8a),
    SPH_C32(0xd58af247), SPH_C32(0xc1fba9e3), SPH_C32(0x8c790000),
    SPH_C32(0xace40076), SPH_C32(0xdd5d8000), SPH_C32(0x04bc0000),
    SPH_C32(0x4e1d1e48), SPH_C32(0x573abc94), SPH_C32(0x31149662),
    SPH_C32(0x18b5c527) },
  { SPH_C32(0x94480000), SPH_C32(0xebb700ae), SPH_C32(0x6dd78000),
    SPH_C32(0x494e0000), SPH_C32(0x7c220c18), SPH_C32(0xa3a8c360),
    SPH_C32(0x0657bb03), SPH_C32(0xd7e6735a), SPH_C32(0xbcce0000),
    SPH_C32(0x49340076), SPH_C32(0x29a9e000), SPH_C32(0x46780000),
    SPH_C32(0x2da52322), SPH_C32(0x2f8028f4), SPH_C32(0x10bb3788),
    SPH_C32(0xa810dd13) },
  { SPH_C32(0x818c0000), SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000),
    SPH_C32(0x173a0000), SPH_C32(0x64283db5), SPH_C32(0xea4c0898),
    SPH_C32(0x3844ea88), SPH_C32(0xeeabae97), SPH_C32(0x92230000),
    SPH_C32(0xa9fc0050), SPH_C32(0x816f0000), SPH_C32(0x4b930000),
    SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d), SPH_C32(0xa292b44b),
    SPH_C32(0x49fc8c64) },
  { SPH_C32(0x07f50000), SPH_C32(0x119200da), SPH_C32(0x1e94e000),
    SPH_C32(0x8f6c0000), SPH_C32(0xf14d5abb), SPH_C32(0xa4c4c072),
    SPH_C32(0xeb99a3cc), SPH_C32(0xf8b6742e), SPH_C32(0xa2940000),
    SPH_C32(0x4c2c0050), SPH_C32(0x759b6000), SPH_C32(0x09570000),
    SPH_C32(0x6e0c6632), SPH_C32(0x67e7405d), SPH_C32(0x833d15a1),
    SPH_C32(0xf9599450) },
  { SPH_C32(0xb13b0000), SPH_C32(0xcb7b00d8), SPH_C32(0x0bfa6000),
    SPH_C32(0x55fe0000), SPH_C32(0x079000df), SPH_C32(0x92f69cf8),
    SPH_C32(0x19eb4b62), SPH_C32(0x5e0eb6a3), SPH_C32(0x24ed0000),
    SPH_C32(0x73150052), SPH_C32(0x94018000), SPH_C32(0x91010000),
    SPH_C32(0xfb69013c), SPH_C32(0x296f88b7), SPH_C32(0x50e05ce5),
    SPH_C32(0xef444ee9) },
  { SPH_C32(0x37420000), SPH_C32(0xf44200da), SPH_C32(0xea608000),
    SPH_C32(0xcda80000), SPH_C32(0x92f567d1), SPH_C32(0xdc7e5412),
    SPH_C32(0xca360226), SPH_C32(0x48136c1a), SPH_C32(0x145a0000),
    SPH_C32(0x96c50052), SPH_C32(0x60f5e000), SPH_C32(0xd3c50000),
    SPH_C32(0x98d13c56), SPH_C32(0x51d51cd7), SPH_C32(0x714ffd0f),
    SPH_C32(0x5fe156dd) },
  { SPH_C32(0x95950000), SPH_C32(0x0d6100e4), SPH_C32(0xafd10000),
    SPH_C32(0x538c0000), SPH_C32(0x7f445a05), SPH_C32(0xd6bfa4ed),
    SPH_C32(0x59a2fa38), SPH_C32(0x35617517), SPH_C32(0x71600000),
    SPH_C32(0x93b20044), SPH_C32(0x73a90000), SPH_C32(0xe1dd0000),
    SPH_C32(0xd6aa19fe), SPH_C32(0x3a366a28), SPH_C32(0xb0af051d),
    SPH_C32(0x73b215b3) },
  { SPH_C32(0x13ec0000), SPH_C32(0x325800e6), SPH_C32(0x4e4be000),
    SPH_C32(0xcbda0000), SPH_C32(0xea213d0b), SPH_C32(0x98376c07),
    SPH_C32(0x8a7fb37c), SPH_C32(0x237cafae), SPH_C32(0x41d70000),
    SPH_C32(0x76620044), SPH_C32(0x875d6000), SPH_C32(0xa3190000),
    SPH_C32(0xb5122494), SPH_C32(0x428cfe48), SPH_C32(0x9100a4f7),
    SPH_C32(0xc3170d87) },
  { SPH_C32(0xa5220000), SPH_C32(0xe8b100e4), SPH_C32(0x5b256000),
    SPH_C32(0x11480000), SPH_C32(0x1cfc676f), SPH_C32(0xae05308d),
    SPH_C32(0x780d5bd2), SPH_C32(0x85c46d23), SPH_C32(0xc7ae0000),
    SPH_C32(0x495b0046), SPH_C32(0x66c78000), SPH_C32(0x3b4f0000),
    SPH_C32(0x2077439a), SPH_C32(0x0c0436a2), SPH_C32(0x42ddedb3),
    SPH_C32(0xd50ad73e) },
  { SPH_C32(0x235b0000), SPH_C32(0xd78800e6), SPH_C32(0xbabf8000),
    SPH_C32(0x891e0000), SPH_C32(0x89990061), SPH_C32(0xe08df867),
    SPH_C32(0xabd01296), SPH_C32(0x93d9b79a), SPH_C32(0xf7190000),
    SPH_C32(0xac8b0046), SPH_C32(0x9233e000), SPH_C32(0x798b0000),
    SPH_C32(0x43cf7ef0), SPH_C32(0x74bea2c2), SPH_C32(0x63724c59),
    SPH_C32(0x65afcf0a) },
  { SPH_C32(0x62cf0000), SPH_C32(0x14e500cc), SPH_C32(0x0dc80000),
    SPH_C32(0xbd740000), SPH_C32(0xbf367f13), SPH_C32(0xcf27b68d),
    SPH_C32(0x2a795bde), SPH_C32(0xd4e53740), SPH_C32(0x65790000),
    SPH_C32(0xb0780078), SPH_C32(0x23760000), SPH_C32(0xa56b0000),
    SPH_C32(0xcdc67e4e), SPH_C32(0x06c5c65d), SPH_C32(0xd14915ad),
    SPH_C32(0xa878ce33) },
  { SPH_C32(0xe4b60000), SPH_C32(0x2bdc00ce), SPH_C32(0xec52e000),
    SPH_C32(0x25220000), SPH_C32(0x2a53181d), SPH_C32(0x81af7e67),
    SPH_C32(0xf9a4129a), SPH_C32(0xc2f8edf9), SPH_C32(0x55ce0000),
    SPH_C32(0x55a80078), SPH_C32(0xd7826000), SPH_C32(0xe7af0000),
    SPH_C32(0xae7e4324), SPH_C32(0x7e7f523d), SPH_C32(0xf0e6b447),
    SPH_C32(0x18ddd607) },
  { SPH_C32(0x52780000), SPH_C32(0xf13500cc), SPH_C32(0xf93c6000),
    SPH_C32(0xffb00000), SPH_C32(0xdc8e4279), SPH_C32(0xb79d22ed),
    SPH_C32(0x0bd6fa34), SPH_C32(0x64402f74), SPH_C32(0xd3b70000),
    SPH_C32(0x6a91007a), SPH_C32(0x36188000), SPH_C32(0x7ff90000),
    SPH_C32(0x3b1b242a), SPH_C32(0x30f79ad7), SPH_C32(0x233bfd03),
    SPH_C32(0x0ec00cbe) },
  { SPH_C32(0xd4010000), SPH_C32(0xce0c00ce), SPH_C32(0x18a68000),
    SPH_C32(0x67e60000), SPH_C32(0x49eb2577), SPH_C32(0xf915ea07),
    SPH_C32(0xd80bb370), SPH_C32(0x725df5cd), SPH_C32(0xe3000000),
    SPH_C32(0x8f41007a), SPH_C32(0xc2ece000), SPH_C32(0x3d3d0000),
    SPH_C32(0x58a31940), SPH_C32(0x484d0eb7), SPH_C32(0x02945ce9),
    SPH_C32(0xbe65148a) },
  { SPH_C32(0x76d60000), SPH_C32(0x372f00f0), SPH_C32(0x5d170000),
    SPH_C32(0xf9c20000), SPH_C32(0xa45a18a3), SPH_C32(0xf3d41af8),
    SPH_C32(0x4b9f4b6e), SPH_C32(0x0f2fecc0), SPH_C32(0x863a0000),
    SPH_C32(0x8a36006c), SPH_C32(0xd1b00000), SPH_C32(0x0f250000),
    SPH_C32(0x16d83ce8), SPH_C32(0x23ae7848), SPH_C32(0xc374a4fb),
    SPH_C32(0x923657e4) },
  { SPH_C32(0xf0af0000), SPH_C32(0x081600f2), SPH_C32(0xbc8de000),
    SPH_C32(0x61940000), SPH_C32(0x313f7fad), SPH_C32(0xbd5cd212),
    SPH_C32(0x9842022a), SPH_C32(0x19323679), SPH_C32(0xb68d0000),
    SPH_C32(0x6fe6006c), SPH_C32(0x25446000), SPH_C32(0x4de10000),
    SPH_C32(0x75600182), SPH_C32(0x5b14ec28), SPH_C32(0xe2db0511),
    SPH_C32(0x22934fd0) },
  { SPH_C32(0x46610000), SPH_C32(0xd2ff00f0), SPH_C32(0xa9e36000),
    SPH_C32(0xbb060000), SPH_C32(0xc7e225c9), SPH_C32(0x8b6e8e98),
    SPH_C32(0x6a30ea84), SPH_C32(0xbf8af4f4), SPH_C32(0x30f40000),
    SPH_C32(0x50df006e), SPH_C32(0xc4de8000), SPH_C32(0xd5b70000),
    SPH_C32(0xe005668c), SPH_C32(0x159c24c2), SPH_C32(0x31064c55),
    SPH_C32(0x348e9569) },
  { SPH_C32(0xc0180000), SPH_C32(0xedc600f2), SPH_C32(0x48798000),
    SPH_C32(0x23500000), SPH_C32(0x528742c7), SPH_C32(0xc5e64672),
    SPH_C32(0xb9eda3c0), SPH_C32(0xa9972e4d), SPH_C32(0x00430000),
    SPH_C32(0xb50f006e), SPH_C32(0x302ae000), SPH_C32(0x97730000),
    SPH_C32(0x83bd5be6), SPH_C32(0x6d26b0a2), SPH_C32(0x10a9edbf),
    SPH_C32(0x842b8d5d) },
  { SPH_C32(0xc6730000), SPH_C32(0xaf8d000c), SPH_C32(0xa4c10000),
    SPH_C32(0x218d0000), SPH_C32(0x23111587), SPH_C32(0x7913512f),
    SPH_C32(0x1d28ac88), SPH_C32(0x378dd173), SPH_C32(0xaf220000),
    SPH_C32(0x7b6c0090), SPH_C32(0x67e20000), SPH_C32(0x8da20000),
    SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3), SPH_C32(0x9ac484f4),
    SPH_C32(0x8b6c72bd) },
  { SPH_C32(0x400a0000), SPH_C32(0x90b4000e), SPH_C32(0x455be000),
    SPH_C32(0xb9db0000), SPH_C32(0xb6747289), SPH_C32(0x379b99c5),
    SPH_C32(0xcef5e5cc), SPH_C32(0x21900bca), SPH_C32(0x9f950000),
    SPH_C32(0x9ebc0090), SPH_C32(0x93166000), SPH_C32(0xcf660000),
    SPH_C32(0xa43c2343), SPH_C32(0xcf0dd093), SPH_C32(0xbb6b251e),
    SPH_C32(0x3bc96a89) },
  { SPH_C32(0xf6c40000), SPH_C32(0x4a5d000c), SPH_C32(0x50356000),
    SPH_C32(0x63490000), SPH_C32(0x40a928ed), SPH_C32(0x01a9c54f),
    SPH_C32(0x3c870d62), SPH_C32(0x8728c947), SPH_C32(0x19ec0000),
    SPH_C32(0xa1850092), SPH_C32(0x728c8000), SPH_C32(0x57300000),
    SPH_C32(0x3159444d), SPH_C32(0x81851879), SPH_C32(0x68b66c5a),
    SPH_C32(0x2dd4b030) },
  { SPH_C32(0x70bd0000), SPH_C32(0x7564000e), SPH_C32(0xb1af8000),
    SPH_C32(0xfb1f0000), SPH_C32(0xd5cc4fe3), SPH_C32(0x4f210da5),
    SPH_C32(0xef5a4426), SPH_C32(0x913513fe), SPH_C32(0x295b0000),
    SPH_C32(0x44550092), SPH_C32(0x8678e000), SPH_C32(0x15f40000),
    SPH_C32(0x52e17927), SPH_C32(0xf93f8c19), SPH_C32(0x4919cdb0),
    SPH_C32(0x9d71a804) },
  { SPH_C32(0xd26a0000), SPH_C32(0x8c470030), SPH_C32(0xf41e0000),
    SPH_C32(0x653b0000), SPH_C32(0x387d7237), SPH_C32(0x45e0fd5a),
    SPH_C32(0x7ccebc38), SPH_C32(0xec470af3), SPH_C32(0x4c610000),
    SPH_C32(0x41220084), SPH_C32(0x95240000), SPH_C32(0x27ec0000),
    SPH_C32(0x1c9a5c8f), SPH_C32(0x92dcfae6), SPH_C32(0x88f935a2),
    SPH_C32(0xb122eb6a) },
  { SPH_C32(0x54130000), SPH_C32(0xb37e0032), SPH_C32(0x1584e000),
    SPH_C32(0xfd6d0000), SPH_C32(0xad181539), SPH_C32(0x0b6835b0),
    SPH_C32(0xaf13f57c), SPH_C32(0xfa5ad04a), SPH_C32(0x7cd60000),
    SPH_C32(0xa4f20084), SPH_C32(0x61d06000), SPH_C32(0x65280000),
    SPH_C32(0x7f2261e5), SPH_C32(0xea666e86), SPH_C32(0xa9569448),
    SPH_C32(0x0187f35e) },
  { SPH_C32(0xe2dd0000), SPH_C32(0x69970030), SPH_C32(0x00ea6000),
    SPH_C32(0x27ff0000), SPH_C32(0x5bc54f5d), SPH_C32(0x3d5a693a),
    SPH_C32(0x5d611dd2), SPH_C32(0x5ce212c7), SPH_C32(0xfaaf0000),
    SPH_C32(0x9bcb0086), SPH_C32(0x804a8000), SPH_C32(0xfd7e0000),
    SPH_C32(0xea4706eb), SPH_C32(0xa4eea66c), SPH_C32(0x7a8bdd0c),
    SPH_C32(0x179a29e7) },
  { SPH_C32(0x64a40000), SPH_C32(0x56ae0032), SPH_C32(0xe1708000),
    SPH_C32(0xbfa90000), SPH_C32(0xcea02853), SPH_C32(0x73d2a1d0),
    SPH_C32(0x8ebc5496), SPH_C32(0x4affc87e), SPH_C32(0xca180000),
    SPH_C32(0x7e1b0086), SPH_C32(0x74bee000), SPH_C32(0xbfba0000),
    SPH_C32(0x89ff3b81), SPH_C32(0xdc54320c), SPH_C32(0x5b247ce6),
    SPH_C32(0xa73f31d3) },
  { SPH_C32(0x25300000), SPH_C32(0x95c30018), SPH_C32(0x56070000),
    SPH_C32(0x8bc30000), SPH_C32(0xf80f5721), SPH_C32(0x5c78ef3a),
    SPH_C32(0x0f151dde), SPH_C32(0x0dc348a4), SPH_C32(0x58780000),
    SPH_C32(0x62e800b8), SPH_C32(0xc5fb0000), SPH_C32(0x635a0000),
    SPH_C32(0x07f63b3f), SPH_C32(0xae2f5693), SPH_C32(0xe91f2512),
    SPH_C32(0x6ae830ea) },
  { SPH_C32(0xa3490000), SPH_C32(0xaafa001a), SPH_C32(0xb79de000),
    SPH_C32(0x13950000), SPH_C32(0x6d6a302f), SPH_C32(0x12f027d0),
    SPH_C32(0xdcc8549a), SPH_C32(0x1bde921d), SPH_C32(0x68cf0000),
    SPH_C32(0x873800b8), SPH_C32(0x310f6000), SPH_C32(0x219e0000),
    SPH_C32(0x644e0655), SPH_C32(0xd695c2f3), SPH_C32(0xc8b084f8),
    SPH_C32(0xda4d28de) },
  { SPH_C32(0x15870000), SPH_C32(0x70130018), SPH_C32(0xa2f36000),
    SPH_C32(0xc9070000), SPH_C32(0x9bb76a4b), SPH_C32(0x24c27b5a),
    SPH_C32(0x2ebabc34), SPH_C32(0xbd665090), SPH_C32(0xeeb60000),
    SPH_C32(0xb80100ba), SPH_C32(0xd0958000), SPH_C32(0xb9c80000),
    SPH_C32(0xf12b615b), SPH_C32(0x981d0a19), SPH_C32(0x1b6dcdbc),
    SPH_C32(0xcc50f267) },
  { SPH_C32(0x93fe0000), SPH_C32(0x4f2a001a), SPH_C32(0x43698000),
    SPH_C32(0x51510000), SPH_C32(0x0ed20d45), SPH_C32(0x6a4ab3b0),
    SPH_C32(0xfd67f570), SPH_C32(0xab7b8a29), SPH_C32(0xde010000),
    SPH_C32(0x5dd100ba), SPH_C32(0x2461e000), SPH_C32(0xfb0c0000),
    SPH_C32(0x92935c31), SPH_C32(0xe0a79e79), SPH_C32(0x3ac26c56),
    SPH_C32(0x7cf5ea53) },
  { SPH_C32(0x31290000), SPH_C32(0xb6090024), SPH_C32(0x06d80000),
    SPH_C32(0xcf750000), SPH_C32(0xe3633091), SPH_C32(0x608b434f),
    SPH_C32(0x6ef30d6e), SPH_C32(0xd6099324), SPH_C32(0xbb3b0000),
    SPH_C32(0x58a600ac), SPH_C32(0x373d0000), SPH_C32(0xc9140000),
    SPH_C32(0xdce87999), SPH_C32(0x8b44e886), SPH_C32(0xfb229444),
    SPH_C32(0x50a6a93d) },
  { SPH_C32(0xb7500000), SPH_C32(0x89300026), SPH_C32(0xe742e000),
    SPH_C32(0x57230000), SPH_C32(0x7606579f), SPH_C32(0x2e038ba5),
    SPH_C32(0xbd2e442a), SPH_C32(0xc014499d), SPH_C32(0x8b8c0000),
    SPH_C32(0xbd7600ac), SPH_C32(0xc3c96000), SPH_C32(0x8bd00000),
    SPH_C32(0xbf5044f3), SPH_C32(0xf3fe7ce6), SPH_C32(0xda8d35ae),
    SPH_C32(0xe003b109) },
  { SPH_C32(0x019e0000), SPH_C32(0x53d90024), SPH_C32(0xf22c6000),
    SPH_C32(0x8db10000), SPH_C32(0x80db0dfb), SPH_C32(0x1831d72f),
    SPH_C32(0x4f5cac84), SPH_C32(0x66ac8b10), SPH_C32(0x0df50000),
    SPH_C32(0x824f00ae), SPH_C32(0x22538000), SPH_C32(0x13860000),
    SPH_C32(0x2a3523fd), SPH_C32(0xbd76b40c), SPH_C32(0x09507cea),
    SPH_C32(0xf61e6bb0) },
  { SPH_C32(0x87e70000), SPH_C32(0x6ce00026), SPH_C32(0x13b68000),
    SPH_C32(0x15e70000), SPH_C32(0x15be6af5), SPH_C32(0x56b91fc5),
    SPH_C32(0x9c81e5c0), SPH_C32(0x70b151a9), SPH_C32(0x3d420000),
    SPH_C32(0x679f00ae), SPH_C32(0xd6a7e000), SPH_C32(0x51420000),
    SPH_C32(0x498d1e97), SPH_C32(0xc5cc206c), SPH_C32(0x28ffdd00),
    SPH_C32(0x46bb7384) },
  { SPH_C32(0x92230000), SPH_C32(0xa9fc0050), SPH_C32(0x816f0000),
    SPH_C32(0x4b930000), SPH_C32(0x0db45b58), SPH_C32(0x1f5dd43d),
    SPH_C32(0xa292b44b), SPH_C32(0x49fc8c64), SPH_C32(0x13af0000),
    SPH_C32(0x87570088), SPH_C32(0x7e610000), SPH_C32(0x5ca90000),
    SPH_C32(0x699c66ed), SPH_C32(0xf511dca5), SPH_C32(0x9ad65ec3),
    SPH_C32(0xa75722f3) },
  { SPH_C32(0x145a0000), SPH_C32(0x96c50052), SPH_C32(0x60f5e000),
    SPH_C32(0xd3c50000), SPH_C32(0x98d13c56), SPH_C32(0x51d51cd7),
    SPH_C32(0x714ffd0f), SPH_C32(0x5fe156dd), SPH_C32(0x23180000),
    SPH_C32(0x62870088), SPH_C32(0x8a956000), SPH_C32(0x1e6d0000),
    SPH_C32(0x0a245b87), SPH_C32(0x8dab48c5), SPH_C32(0xbb79ff29),
    SPH_C32(0x17f23ac7) },
  { SPH_C32(0xa2940000), SPH_C32(0x4c2c0050), SPH_C32(0x759b6000),
    SPH_C32(0x09570000), SPH_C32(0x6e0c6632), SPH_C32(0x67e7405d),
    SPH_C32(0x833d15a1), SPH_C32(0xf9599450), SPH_C32(0xa5610000),
    SPH_C32(0x5dbe008a), SPH_C32(0x6b0f8000), SPH_C32(0x863b0000),
    SPH_C32(0x9f413c89), SPH_C32(0xc323802f), SPH_C32(0x68a4b66d),
    SPH_C32(0x01efe07e) },
  { SPH_C32(0x24ed0000), SPH_C32(0x73150052), SPH_C32(0x94018000),
    SPH_C32(0x91010000), SPH_C32(0xfb69013c), SPH_C32(0x296f88b7),
    SPH_C32(0x50e05ce5), SPH_C32(0xef444ee9), SPH_C32(0x95d60000),
    SPH_C32(0xb86e008a), SPH_C32(0x9ffbe000), SPH_C32(0xc4ff0000),
    SPH_C32(0xfcf901e3), SPH_C32(0xbb99144f), SPH_C32(0x490b1787),
    SPH_C32(0xb14af84a) },
  { SPH_C32(0x863a0000), SPH_C32(0x8a36006c), SPH_C32(0xd1b00000),
    SPH_C32(0x0f250000), SPH_C32(0x16d83ce8), SPH_C32(0x23ae7848),
    SPH_C32(0xc374a4fb), SPH_C32(0x923657e4), SPH_C32(0xf0ec0000),
    SPH_C32(0xbd19009c), SPH_C32(0x8ca70000), SPH_C32(0xf6e70000),
    SPH_C32(0xb282244b), SPH_C32(0xd07a62b0), SPH_C32(0x88ebef95),
    SPH_C32(0x9d19bb24) },
  { SPH_C32(0x00430000), SPH_C32(0xb50f006e), SPH_C32(0x302ae000),
    SPH_C32(0x97730000), SPH_C32(0x83bd5be6), SPH_C32(0x6d26b0a2),
    SPH_C32(0x10a9edbf), SPH_C32(0x842b8d5d), SPH_C32(0xc05b0000),
    SPH_C32(0x58c9009c), SPH_C32(0x78536000), SPH_C32(0xb4230000),
    SPH_C32(0xd13a1921), SPH_C32(0xa8c0f6d0), SPH_C32(0xa9444e7f),
    SPH_C32(0x2dbca310) },
  { SPH_C32(0xb68d0000), SPH_C32(0x6fe6006c), SPH_C32(0x25446000),
    SPH_C32(0x4de10000), SPH_C32(0x75600182), SPH_C32(0x5b14ec28),
    SPH_C32(0xe2db0511), SPH_C32(0x22934fd0), SPH_C32(0x46220000),
    SPH_C32(0x67f0009e), SPH_C32(0x99c98000), SPH_C32(0x2c750000),
    SPH_C32(0x445f7e2f), SPH_C32(0xe6483e3a), SPH_C32(0x7a99073b),
    SPH_C32(0x3ba179a9) },
  { SPH_C32(0x30f40000), SPH_C32(0x50df006e), SPH_C32(0xc4de8000),
    SPH_C32(0xd5b70000), SPH_C32(0xe005668c), SPH_C32(0x159c24c2),
    SPH_C32(0x31064c55), SPH_C32(0x348e9569), SPH_C32(0x76950000),
    SPH_C32(0x8220009e), SPH_C32(0x6d3de000), SPH_C32(0x6eb10000),
    SPH_C32(0x27e74345), SPH_C32(0x9ef2aa5a), SPH_C32(0x5b36a6d1),
    SPH_C32(0x8b04619d) },
  { SPH_C32(0x71600000), SPH_C32(0x93b20044), SPH_C32(0x73a90000),
    SPH_C32(0xe1dd0000), SPH_C32(0xd6aa19fe), SPH_C32(0x3a366a28),
    SPH_C32(0xb0af051d), SPH_C32(0x73b215b3), SPH_C32(0xe4f50000),
    SPH_C32(0x9ed300a0), SPH_C32(0xdc780000), SPH_C32(0xb2510000),
    SPH_C32(0xa9ee43fb), SPH_C32(0xec89cec5), SPH_C32(0xe90dff25),
    SPH_C32(0x46d360a4) },
  { SPH_C32(0xf7190000), SPH_C32(0xac8b0046), SPH_C32(0x9233e000),
    SPH_C32(0x798b0000), SPH_C32(0x43cf7ef0), SPH_C32(0x74bea2c2),
    SPH_C32(0x63724c59), SPH_C32(0x65afcf0a), SPH_C32(0xd4420000),
    SPH_C32(0x7b0300a0), SPH_C32(0x288c6000), SPH_C32(0xf0950000),
    SPH_C32(0xca567e91), SPH_C32(0x94335aa5), SPH_C32(0xc8a25ecf),
    SPH_C32(0xf6767890) },
  { SPH_C32(0x41d70000), SPH_C32(0x76620044), SPH_C32(0x875d6000),
    SPH_C32(0xa3190000), SPH_C32(0xb5122494), SPH_C32(0x428cfe48),
    SPH_C32(0x9100a4f7), SPH_C32(0xc3170d87), SPH_C32(0x523b0000),
    SPH_C32(0x443a00a2), SPH_C32(0xc9168000), SPH_C32(0x68c30000),
    SPH_C32(0x5f33199f), SPH_C32(0xdabb924f), SPH_C32(0x1b7f178b),
    SPH_C32(0xe06ba229) },
  { SPH_C32(0xc7ae0000), SPH_C32(0x495b0046), SPH_C32(0x66c78000),
    SPH_C32(0x3b4f0000), SPH_C32(0x2077439a), SPH_C32(0x0c0436a2),
    SPH_C32(0x42ddedb3), SPH_C32(0xd50ad73e), SPH_C32(0x628c0000),
    SPH_C32(0xa1ea00a2), SPH_C32(0x3de2e000), SPH_C32(0x2a070000),
    SPH_C32(0x3c8b24f5), SPH_C32(0xa201062f), SPH_C32(0x3ad0b661),
    SPH_C32(0x50ceba1d) },
  { SPH_C32(0x65790000), SPH_C32(0xb0780078), SPH_C32(0x23760000),
    SPH_C32(0xa56b0000), SPH_C32(0xcdc67e4e), SPH_C32(0x06c5c65d),
    SPH_C32(0xd14915ad), SPH_C32(0xa878ce33), SPH_C32(0x07b60000),
    SPH_C32(0xa49d00b4), SPH_C32(0x2ebe0000), SPH_C32(0x181f0000),
    SPH_C32(0x72f0015d), SPH_C32(0xc9e270d0), SPH_C32(0xfb304e73),
    SPH_C32(0x7c9df973) },
  { SPH_C32(0xe3000000), SPH_C32(0x8f41007a), SPH_C32(0xc2ece000),
    SPH_C32(0x3d3d0000), SPH_C32(0x58a31940), SPH_C32(0x484d0eb7),
    SPH_C32(0x02945ce9), SPH_C32(0xbe65148a), SPH_C32(0x37010000),
    SPH_C32(0x414d00b4), SPH_C32(0xda4a6000), SPH_C32(0x5adb0000),
    SPH_C32(0x11483c37), SPH_C32(0xb158e4b0), SPH_C32(0xda9fef99),
    SPH_C32(0xcc38e147) },
  { SPH_C32(0x55ce0000), SPH_C32(0x55a80078), SPH_C32(0xd7826000),
    SPH_C32(0xe7af0000), SPH_C32(0xae7e4324), SPH_C32(0x7e7f523d),
    SPH_C32(0xf0e6b447), SPH_C32(0x18ddd607), SPH_C32(0xb1780000),
    SPH_C32(0x7e7400b6), SPH_C32(0x3bd08000), SPH_C32(0xc28d0000),
    SPH_C32(0x842d5b39), SPH_C32(0xffd02c5a), SPH_C32(0x0942a6dd),
    SPH_C32(0xda253bfe) },
  { SPH_C32(0xd3b70000), SPH_C32(0x6a91007a), SPH_C32(0x36188000),
    SPH_C32(0x7ff90000), SPH_C32(0x3b1b242a), SPH_C32(0x30f79ad7),
    SPH_C32(0x233bfd03), SPH_C32(0x0ec00cbe), SPH_C32(0x81cf0000),
    SPH_C32(0x9ba400b6), SPH_C32(0xcf24e000), SPH_C32(0x80490000),
    SPH_C32(0xe7956653), SPH_C32(0x876ab83a), SPH_C32(0x28ed0737),
    SPH_C32(0x6a8023ca) },
  { SPH_C32(0x7afe0000), SPH_C32(0x53b60014), SPH_C32(0xbd420000),
    SPH_C32(0xf0860000), SPH_C32(0x8d096d43), SPH_C32(0x3bb5c979),
    SPH_C32(0x1d3a76bf), SPH_C32(0x1bb6813d), SPH_C32(0x47ff0000),
    SPH_C32(0x812600d4), SPH_C32(0x5bcf0000), SPH_C32(0x36b70000),
    SPH_C32(0x47392832), SPH_C32(0x935f59b7), SPH_C32(0x256c4600),
    SPH_C32(0xd9267fe4) },
  { SPH_C32(0xfc870000), SPH_C32(0x6c8f0016), SPH_C32(0x5cd8e000),
    SPH_C32(0x68d00000), SPH_C32(0x186c0a4d), SPH_C32(0x753d0193),
    SPH_C32(0xcee73ffb), SPH_C32(0x0dab5b84), SPH_C32(0x77480000),
    SPH_C32(0x64f600d4), SPH_C32(0xaf3b6000), SPH_C32(0x74730000),
    SPH_C32(0x24811558), SPH_C32(0xebe5cdd7), SPH_C32(0x04c3e7ea),
    SPH_C32(0x698367d0) },
  { SPH_C32(0x4a490000), SPH_C32(0xb6660014), SPH_C32(0x49b66000),
    SPH_C32(0xb2420000), SPH_C32(0xeeb15029), SPH_C32(0x430f5d19),
    SPH_C32(0x3c95d755), SPH_C32(0xab139909), SPH_C32(0xf1310000),
    SPH_C32(0x5bcf00d6), SPH_C32(0x4ea18000), SPH_C32(0xec250000),
    SPH_C32(0xb1e47256), SPH_C32(0xa56d053d), SPH_C32(0xd71eaeae),
    SPH_C32(0x7f9ebd69) },
  { SPH_C32(0xcc300000), SPH_C32(0x895f0016), SPH_C32(0xa82c8000),
    SPH_C32(0x2a140000), SPH_C32(0x7bd43727), SPH_C32(0x0d8795f3),
    SPH_C32(0xef489e11), SPH_C32(0xbd0e43b0), SPH_C32(0xc1860000),
    SPH_C32(0xbe1f00d6), SPH_C32(0xba55e000), SPH_C32(0xaee10000),
    SPH_C32(0xd25c4f3c), SPH_C32(0xddd7915d), SPH_C32(0xf6b10f44),
    SPH_C32(0xcf3ba55d) },
  { SPH_C32(0x6ee70000), SPH_C32(0x707c0028), SPH_C32(0xed9d0000),
    SPH_C32(0xb4300000), SPH_C32(0x96650af3), SPH_C32(0x0746650c),
    SPH_C32(0x7cdc660f), SPH_C32(0xc07c5abd), SPH_C32(0xa4bc0000),
    SPH_C32(0xbb6800c0), SPH_C32(0xa9090000), SPH_C32(0x9cf90000),
    SPH_C32(0x9c276a94), SPH_C32(0xb634e7a2), SPH_C32(0x3751f756),
    SPH_C32(0xe368e633) },
  { SPH_C32(0xe89e0000), SPH_C32(0x4f45002a), SPH_C32(0x0c07e000),
    SPH_C32(0x2c660000), SPH_C32(0x03006dfd), SPH_C32(0x49ceade6),
    SPH_C32(0xaf012f4b), SPH_C32(0xd6618004), SPH_C32(0x940b0000),
    SPH_C32(0x5eb800c0), SPH_C32(0x5dfd6000), SPH_C32(0xde3d0000),
    SPH_C32(0xff9f57fe), SPH_C32(0xce8e73c2), SPH_C32(0x16fe56bc),
    SPH_C32(0x53cdfe07) },
  { SPH_C32(0x5e500000), SPH_C32(0x95ac0028), SPH_C32(0x19696000),
    SPH_C32(0xf6f40000), SPH_C32(0xf5dd3799), SPH_C32(0x7ffcf16c),
    SPH_C32(0x5d73c7e5), SPH_C32(0x70d94289), SPH_C32(0x12720000),
    SPH_C32(0x618100c2), SPH_C32(0xbc678000), SPH_C32(0x466b0000),
    SPH_C32(0x6afa30f0), SPH_C32(0x8006bb28), SPH_C32(0xc5231ff8),
    SPH_C32(0x45d024be) },
  { SPH_C32(0xd8290000), SPH_C32(0xaa95002a), SPH_C32(0xf8f38000),
    SPH_C32(0x6ea20000), SPH_C32(0x60b85097), SPH_C32(0x31743986),
    SPH_C32(0x8eae8ea1), SPH_C32(0x66c49830), SPH_C32(0x22c50000),
    SPH_C32(0x845100c2), SPH_C32(0x4893e000), SPH_C32(0x04af0000),
    SPH_C32(0x09420d9a), SPH_C32(0xf8bc2f48), SPH_C32(0xe48cbe12),
    SPH_C32(0xf5753c8a) },
  { SPH_C32(0x99bd0000), SPH_C32(0x69f80000), SPH_C32(0x4f840000),
    SPH_C32(0x5ac80000), SPH_C32(0x56172fe5), SPH_C32(0x1ede776c),
    SPH_C32(0x0f07c7e9), SPH_C32(0x21f818ea), SPH_C32(0xb0a50000),
    SPH_C32(0x98a200fc), SPH_C32(0xf9d60000), SPH_C32(0xd84f0000),
    SPH_C32(0x874b0d24), SPH_C32(0x8ac74bd7), SPH_C32(0x56b7e7e6),
    SPH_C32(0x38a23db3) },
  { SPH_C32(0x1fc40000), SPH_C32(0x56c10002), SPH_C32(0xae1ee000),
    SPH_C32(0xc29e0000), SPH_C32(0xc37248eb), SPH_C32(0x5056bf86),
    SPH_C32(0xdcda8ead), SPH_C32(0x37e5c253), SPH_C32(0x80120000),
    SPH_C32(0x7d7200fc), SPH_C32(0x0d226000), SPH_C32(0x9a8b0000),
    SPH_C32(0xe4f3304e), SPH_C32(0xf27ddfb7), SPH_C32(0x7718460c),
    SPH_C32(0x88072587) },
  { SPH_C32(0xa90a0000), SPH_C32(0x8c280000), SPH_C32(0xbb706000),
    SPH_C32(0x180c0000), SPH_C32(0x35af128f), SPH_C32(0x6664e30c),
    SPH_C32(0x2ea86603), SPH_C32(0x915d00de), SPH_C32(0x066b0000),
    SPH_C32(0x424b00fe), SPH_C32(0xecb88000), SPH_C32(0x02dd0000),
    SPH_C32(0x71965740), SPH_C32(0xbcf5175d), SPH_C32(0xa4c50f48),
    SPH_C32(0x9e1aff3e) },
  { SPH_C32(0x2f730000), SPH_C32(0xb3110002), SPH_C32(0x5aea8000),
    SPH_C32(0x805a0000), SPH_C32(0xa0ca7581), SPH_C32(0x28ec2be6),
    SPH_C32(0xfd752f47), SPH_C32(0x8740da67), SPH_C32(0x36dc0000),
    SPH_C32(0xa79b00fe), SPH_C32(0x184ce000), SPH_C32(0x40190000),
    SPH_C32(0x122e6a2a), SPH_C32(0xc44f833d), SPH_C32(0x856aaea2),
    SPH_C32(0x2ebfe70a) },
  { SPH_C32(0x8da40000), SPH_C32(0x4a32003c), SPH_C32(0x1f5b0000),
    SPH_C32(0x1e7e0000), SPH_C32(0x4d7b4855), SPH_C32(0x222ddb19),
    SPH_C32(0x6ee1d759), SPH_C32(0xfa32c36a), SPH_C32(0x53e60000),
    SPH_C32(0xa2ec00e8), SPH_C32(0x0b100000), SPH_C32(0x72010000),
    SPH_C32(0x5c554f82), SPH_C32(0xafacf5c2), SPH_C32(0x448a56b0),
    SPH_C32(0x02eca464) },
  { SPH_C32(0x0bdd0000), SPH_C32(0x750b003e), SPH_C32(0xfec1e000),
    SPH_C32(0x86280000), SPH_C32(0xd81e2f5b), SPH_C32(0x6ca513f3),
    SPH_C32(0xbd3c9e1d), SPH_C32(0xec2f19d3), SPH_C32(0x63510000),
    SPH_C32(0x473c00e8), SPH_C32(0xffe46000), SPH_C32(0x30c50000),
    SPH_C32(0x3fed72e8), SPH_C32(0xd71661a2), SPH_C32(0x6525f75a),
    SPH_C32(0xb249bc50) },
  { SPH_C32(0xbd130000), SPH_C32(0xafe2003c), SPH_C32(0xebaf6000),
    SPH_C32(0x5cba0000), SPH_C32(0x2ec3753f), SPH_C32(0x5a974f79),
    SPH_C32(0x4f4e76b3), SPH_C32(0x4a97db5e), SPH_C32(0xe5280000),
    SPH_C32(0x780500ea), SPH_C32(0x1e7e8000), SPH_C32(0xa8930000),
    SPH_C32(0xaa8815e6), SPH_C32(0x999ea948), SPH_C32(0xb6f8be1e),
    SPH_C32(0xa45466e9) },
  { SPH_C32(0x3b6a0000), SPH_C32(0x90db003e), SPH_C32(0x0a358000),
    SPH_C32(0xc4ec0000), SPH_C32(0xbba61231), SPH_C32(0x141f8793),
    SPH_C32(0x9c933ff7), SPH_C32(0x5c8a01e7), SPH_C32(0xd59f0000),
    SPH_C32(0x9dd500ea), SPH_C32(0xea8ae000), SPH_C32(0xea570000),
    SPH_C32(0xc930288c), SPH_C32(0xe1243d28), SPH_C32(0x97571ff4),
    SPH_C32(0x14f17edd) },
  { SPH_C32(0x2eae0000), SPH_C32(0x55c70048), SPH_C32(0x98ec0000),
    SPH_C32(0x9a980000), SPH_C32(0xa3ac239c), SPH_C32(0x5dfb4c6b),
    SPH_C32(0xa2806e7c), SPH_C32(0x65c7dc2a), SPH_C32(0xfb720000),
    SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000), SPH_C32(0xe7bc0000),
    SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1), SPH_C32(0x257e9c37),
    SPH_C32(0xf51d2faa) },
  { SPH_C32(0xa8d70000), SPH_C32(0x6afe004a), SPH_C32(0x7976e000),
    SPH_C32(0x02ce0000), SPH_C32(0x36c94492), SPH_C32(0x13738481),
    SPH_C32(0x715d2738), SPH_C32(0x73da0693), SPH_C32(0xcbc50000),
    SPH_C32(0x98cd00cc), SPH_C32(0xb6b86000), SPH_C32(0xa5780000),
    SPH_C32(0x8a996d9c), SPH_C32(0xa9435581), SPH_C32(0x04d13ddd),
    SPH_C32(0x45b8379e) },
  { SPH_C32(0x1e190000), SPH_C32(0xb0170048), SPH_C32(0x6c186000),
    SPH_C32(0xd85c0000), SPH_C32(0xc0141ef6), SPH_C32(0x2541d80b),
    SPH_C32(0x832fcf96), SPH_C32(0xd562c41e), SPH_C32(0x4dbc0000),
    SPH_C32(0xa7f400ce), SPH_C32(0x57228000), SPH_C32(0x3d2e0000),
    SPH_C32(0x1ffc0a92), SPH_C32(0xe7cb9d6b), SPH_C32(0xd70c7499),
    SPH_C32(0x53a5ed27) },
  { SPH_C32(0x98600000), SPH_C32(0x8f2e004a), SPH_C32(0x8d828000),
    SPH_C32(0x400a0000), SPH_C32(0x557179f8), SPH_C32(0x6bc910e1),
    SPH_C32(0x50f286d2), SPH_C32(0xc37f1ea7), SPH_C32(0x7d0b0000),
    SPH_C32(0x422400ce), SPH_C32(0xa3d6e000), SPH_C32(0x7fea0000),
    SPH_C32(0x7c4437f8), SPH_C32(0x9f71090b), SPH_C32(0xf6a3d573),
    SPH_C32(0xe300f513) },
  { SPH_C32(0x3ab70000), SPH_C32(0x760d0074), SPH_C32(0xc8330000),
    SPH_C32(0xde2e0000), SPH_C32(0xb8c0442c), SPH_C32(0x6108e01e),
    SPH_C32(0xc3667ecc), SPH_C32(0xbe0d07aa), SPH_C32(0x18310000),
    SPH_C32(0x475300d8), SPH_C32(0xb08a0000), SPH_C32(0x4df20000),
    SPH_C32(0x323f1250), SPH_C32(0xf4927ff4), SPH_C32(0x37432d61),
    SPH_C32(0xcf53b67d) },
  { SPH_C32(0xbcce0000), SPH_C32(0x49340076), SPH_C32(0x29a9e000),
    SPH_C32(0x46780000), SPH_C32(0x2da52322), SPH_C32(0x2f8028f4),
    SPH_C32(0x10bb3788), SPH_C32(0xa810dd13), SPH_C32(0x28860000),
    SPH_C32(0xa28300d8), SPH_C32(0x447e6000), SPH_C32(0x0f360000),
    SPH_C32(0x51872f3a), SPH_C32(0x8c28eb94), SPH_C32(0x16ec8c8b),
    SPH_C32(0x7ff6ae49) },
  { SPH_C32(0x0a000000), SPH_C32(0x93dd0074), SPH_C32(0x3cc76000),
    SPH_C32(0x9cea0000), SPH_C32(0xdb787946), SPH_C32(0x19b2747e),
    SPH_C32(0xe2c9df26), SPH_C32(0x0ea81f9e), SPH_C32(0xaeff0000),
    SPH_C32(0x9dba00da), SPH_C32(0xa5e48000), SPH_C32(0x97600000),
    SPH_C32(0xc4e24834), SPH_C32(0xc2a0237e), SPH_C32(0xc531c5cf),
    SPH_C32(0x69eb74f0) },
  { SPH_C32(0x8c790000), SPH_C32(0xace40076), SPH_C32(0xdd5d8000),
    SPH_C32(0x04bc0000), SPH_C32(0x4e1d1e48), SPH_C32(0x573abc94),
    SPH_C32(0x31149662), SPH_C32(0x18b5c527), SPH_C32(0x9e480000),
    SPH_C32(0x786a00da), SPH_C32(0x5110e000), SPH_C32(0xd5a40000),
    SPH_C32(0xa75a755e), SPH_C32(0xba1ab71e), SPH_C32(0xe49e6425),
    SPH_C32(0xd94e6cc4) },
  { SPH_C32(0xcded0000), SPH_C32(0x6f89005c), SPH_C32(0x6a2a0000),
    SPH_C32(0x30d60000), SPH_C32(0x78b2613a), SPH_C32(0x7890f27e),
    SPH_C32(0xb0bddf2a), SPH_C32(0x5f8945fd), SPH_C32(0x0c280000),
    SPH_C32(0x649900e4), SPH_C32(0xe0550000), SPH_C32(0x09440000),
    SPH_C32(0x295375e0), SPH_C32(0xc861d381), SPH_C32(0x56a53dd1),
    SPH_C32(0x14996dfd) },
  { SPH_C32(0x4b940000), SPH_C32(0x50b0005e), SPH_C32(0x8bb0e000),
    SPH_C32(0xa8800000), SPH_C32(0xedd70634), SPH_C32(0x36183a94),
    SPH_C32(0x6360966e), SPH_C32(0x49949f44), SPH_C32(0x3c9f0000),
    SPH_C32(0x814900e4), SPH_C32(0x14a16000), SPH_C32(0x4b800000),
    SPH_C32(0x4aeb488a), SPH_C32(0xb0db47e1), SPH_C32(0x770a9c3b),
    SPH_C32(0xa43c75c9) },
  { SPH_C32(0xfd5a0000), SPH_C32(0x8a59005c), SPH_C32(0x9ede6000),
    SPH_C32(0x72120000), SPH_C32(0x1b0a5c50), SPH_C32(0x002a661e),
    SPH_C32(0x91127ec0), SPH_C32(0xef2c5dc9), SPH_C32(0xbae60000),
    SPH_C32(0xbe7000e6), SPH_C32(0xf53b8000), SPH_C32(0xd3d60000),
    SPH_C32(0xdf8e2f84), SPH_C32(0xfe538f0b), SPH_C32(0xa4d7d57f),
    SPH_C32(0xb221af70) },
  { SPH_C32(0x7b230000), SPH_C32(0xb560005e), SPH_C32(0x7f448000),
    SPH_C32(0xea440000), SPH_C32(0x8e6f3b5e), SPH_C32(0x4ea2aef4),
    SPH_C32(0x42cf3784), SPH_C32(0xf9318770), SPH_C32(0x8a510000),
    SPH_C32(0x5ba000e6), SPH_C32(0x01cfe000), SPH_C32(0x91120000),
    SPH_C32(0xbc3612ee), SPH_C32(0x86e91b6b), SPH_C32(0x85787495),
    SPH_C32(0x0284b744) },
  { SPH_C32(0xd9f40000), SPH_C32(0x4c430060), SPH_C32(0x3af50000),
    SPH_C32(0x74600000), SPH_C32(0x63de068a), SPH_C32(0x44635e0b),
    SPH_C32(0xd15bcf9a), SPH_C32(0x84439e7d), SPH_C32(0xef6b0000),
    SPH_C32(0x5ed700f0), SPH_C32(0x12930000), SPH_C32(0xa30a0000),
    SPH_C32(0xf24d3746), SPH_C32(0xed0a6d94), SPH_C32(0x44988c87),
    SPH_C32(0x2ed7f42a) },
  { SPH_C32(0x5f8d0000), SPH_C32(0x737a0062), SPH_C32(0xdb6fe000),
    SPH_C32(0xec360000), SPH_C32(0xf6bb6184), SPH_C32(0x0aeb96e1),
    SPH_C32(0x028686de), SPH_C32(0x925e44c4), SPH_C32(0xdfdc0000),
    SPH_C32(0xbb0700f0), SPH_C32(0xe6676000), SPH_C32(0xe1ce0000),
    SPH_C32(0x91f50a2c), SPH_C32(0x95b0f9f4), SPH_C32(0x65372d6d),
    SPH_C32(0x9e72ec1e) },
  { SPH_C32(0xe9430000), SPH_C32(0xa9930060), SPH_C32(0xce016000),
    SPH_C32(0x36a40000), SPH_C32(0x00663be0), SPH_C32(0x3cd9ca6b),
    SPH_C32(0xf0f46e70), SPH_C32(0x34e68649), SPH_C32(0x59a50000),
    SPH_C32(0x843e00f2), SPH_C32(0x07fd8000), SPH_C32(0x79980000),
    SPH_C32(0x04906d22), SPH_C32(0xdb38311e), SPH_C32(0xb6ea6429),
    SPH_C32(0x886f36a7) },
  { SPH_C32(0x6f3a0000), SPH_C32(0x96aa0062), SPH_C32(0x2f9b8000),
    SPH_C32(0xaef20000), SPH_C32(0x95035cee), SPH_C32(0x72510281),
    SPH_C32(0x23292734), SPH_C32(0x22fb5cf0), SPH_C32(0x69120000),
    SPH_C32(0x61ee00f2), SPH_C32(0xf309e000), SPH_C32(0x3b5c0000),
    SPH_C32(0x67285048), SPH_C32(0xa382a57e), SPH_C32(0x9745c5c3),
    SPH_C32(0x38ca2e93) },
  { SPH_C32(0xaf220000), SPH_C32(0x7b6c0090), SPH_C32(0x67e20000),
    SPH_C32(0x8da20000), SPH_C32(0xc7841e29), SPH_C32(0xb7b744f3),
    SPH_C32(0x9ac484f4), SPH_C32(0x8b6c72bd), SPH_C32(0x69510000),
    SPH_C32(0xd4e1009c), SPH_C32(0xc3230000), SPH_C32(0xac2f0000),
    SPH_C32(0xe4950bae), SPH_C32(0xcea415dc), SPH_C32(0x87ec287c),
    SPH_C32(0xbce1a3ce) },
  { SPH_C32(0x295b0000), SPH_C32(0x44550092), SPH_C32(0x8678e000),
    SPH_C32(0x15f40000), SPH_C32(0x52e17927), SPH_C32(0xf93f8c19),
    SPH_C32(0x4919cdb0), SPH_C32(0x9d71a804), SPH_C32(0x59e60000),
    SPH_C32(0x3131009c), SPH_C32(0x37d76000), SPH_C32(0xeeeb0000),
    SPH_C32(0x872d36c4), SPH_C32(0xb61e81bc), SPH_C32(0xa6438996),
    SPH_C32(0x0c44bbfa) },
  { SPH_C32(0x9f950000), SPH_C32(0x9ebc0090), SPH_C32(0x93166000),
    SPH_C32(0xcf660000), SPH_C32(0xa43c2343), SPH_C32(0xcf0dd093),
    SPH_C32(0xbb6b251e), SPH_C32(0x3bc96a89), SPH_C32(0xdf9f0000),
    SPH_C32(0x0e08009e), SPH_C32(0xd64d8000), SPH_C32(0x76bd0000),
    SPH_C32(0x124851ca), SPH_C32(0xf8964956), SPH_C32(0x759ec0d2),
    SPH_C32(0x1a596143) },
  { SPH_C32(0x19ec0000), SPH_C32(0xa1850092), SPH_C32(0x728c8000),
    SPH_C32(0x57300000), SPH_C32(0x3159444d), SPH_C32(0x81851879),
    SPH_C32(0x68b66c5a), SPH_C32(0x2dd4b030), SPH_C32(0xef280000),
    SPH_C32(0xebd8009e), SPH_C32(0x22b9e000), SPH_C32(0x34790000),
    SPH_C32(0x71f06ca0), SPH_C32(0x802cdd36), SPH_C32(0x54316138),
    SPH_C32(0xaafc7977) },
  { SPH_C32(0xbb3b0000), SPH_C32(0x58a600ac), SPH_C32(0x373d0000),
    SPH_C32(0xc9140000), SPH_C32(0xdce87999), SPH_C32(0x8b44e886),
    SPH_C32(0xfb229444), SPH_C32(0x50a6a93d), SPH_C32(0x8a120000),
    SPH_C32(0xeeaf0088), SPH_C32(0x31e50000), SPH_C32(0x06610000),
    SPH_C32(0x3f8b4908), SPH_C32(0xebcfabc9), SPH_C32(0x95d1992a),
    SPH_C32(0x86af3a19) },
  { SPH_C32(0x3d420000), SPH_C32(0x679f00ae), SPH_C32(0xd6a7e000),
    SPH_C32(0x51420000), SPH_C32(0x498d1e97), SPH_C32(0xc5cc206c),
    SPH_C32(0x28ffdd00), SPH_C32(0x46bb7384), SPH_C32(0xbaa50000),
    SPH_C32(0x0b7f0088), SPH_C32(0xc5116000), SPH_C32(0x44a50000),
    SPH_C32(0x5c337462), SPH_C32(0x93753fa9), SPH_C32(0xb47e38c0),
    SPH_C32(0x360a222d) },
  { SPH_C32(0x8b8c0000), SPH_C32(0xbd7600ac), SPH_C32(0xc3c96000),
    SPH_C32(0x8bd00000), SPH_C32(0xbf5044f3), SPH_C32(0xf3fe7ce6),
    SPH_C32(0xda8d35ae), SPH_C32(0xe003b109), SPH_C32(0x3cdc0000),
    SPH_C32(0x3446008a), SPH_C32(0x248b8000), SPH_C32(0xdcf30000),
    SPH_C32(0xc956136c), SPH_C32(0xddfdf743), SPH_C32(0x67a37184),
    SPH_C32(0x2017f894) },
  { SPH_C32(0x0df50000), SPH_C32(0x824f00ae), SPH_C32(0x22538000),
    SPH_C32(0x13860000), SPH_C32(0x2a3523fd), SPH_C32(0xbd76b40c),
    SPH_C32(0x09507cea), SPH_C32(0xf61e6bb0), SPH_C32(0x0c6b0000),
    SPH_C32(0xd196008a), SPH_C32(0xd07fe000), SPH_C32(0x9e370000),
    SPH_C32(0xaaee2e06), SPH_C32(0xa5476323), SPH_C32(0x460cd06e),
    SPH_C32(0x90b2e0a0) },
  { SPH_C32(0x4c610000), SPH_C32(0x41220084), SPH_C32(0x95240000),
    SPH_C32(0x27ec0000), SPH_C32(0x1c9a5c8f), SPH_C32(0x92dcfae6),
    SPH_C32(0x88f935a2), SPH_C32(0xb122eb6a), SPH_C32(0x9e0b0000),
    SPH_C32(0xcd6500b4), SPH_C32(0x613a0000), SPH_C32(0x42d70000),
    SPH_C32(0x24e72eb8), SPH_C32(0xd73c07bc), SPH_C32(0xf437899a),
    SPH_C32(0x5d65e199) },
  { SPH_C32(0xca180000), SPH_C32(0x7e1b0086), SPH_C32(0x74bee000),
    SPH_C32(0xbfba0000), SPH_C32(0x89ff3b81), SPH_C32(0xdc54320c),
    SPH_C32(0x5b247ce6), SPH_C32(0xa73f31d3), SPH_C32(0xaebc0000),
    SPH_C32(0x28b500b4), SPH_C32(0x95ce6000), SPH_C32(0x00130000),
    SPH_C32(0x475f13d2), SPH_C32(0xaf8693dc), SPH_C32(0xd5982870),
    SPH_C32(0xedc0f9ad) },
  { SPH_C32(0x7cd60000), SPH_C32(0xa4f20084), SPH_C32(0x61d06000),
    SPH_C32(0x65280000), SPH_C32(0x7f2261e5), SPH_C32(0xea666e86),
    SPH_C32(0xa9569448), SPH_C32(0x0187f35e), SPH_C32(0x28c50000),
    SPH_C32(0x178c00b6), SPH_C32(0x74548000), SPH_C32(0x98450000),
    SPH_C32(0xd23a74dc), SPH_C32(0xe10e5b36), SPH_C32(0x06456134),
    SPH_C32(0xfbdd2314) },
  { SPH_C32(0xfaaf0000), SPH_C32(0x9bcb0086), SPH_C32(0x804a8000),
    SPH_C32(0xfd7e0000), SPH_C32(0xea4706eb), SPH_C32(0xa4eea66c),
    SPH_C32(0x7a8bdd0c), SPH_C32(0x179a29e7), SPH_C32(0x18720000),
    SPH_C32(0xf25c00b6), SPH_C32(0x80a0e000), SPH_C32(0xda810000),
    SPH_C32(0xb18249b6), SPH_C32(0x99b4cf56), SPH_C32(0x27eac0de),
    SPH_C32(0x4b783b20) },
  { SPH_C32(0x58780000), SPH_C32(0x62e800b8), SPH_C32(0xc5fb0000),
    SPH_C32(0x635a0000), SPH_C32(0x07f63b3f), SPH_C32(0xae2f5693),
    SPH_C32(0xe91f2512), SPH_C32(0x6ae830ea), SPH_C32(0x7d480000),
    SPH_C32(0xf72b00a0), SPH_C32(0x93fc0000), SPH_C32(0xe8990000),
    SPH_C32(0xfff96c1e), SPH_C32(0xf257b9a9), SPH_C32(0xe60a38cc),
    SPH_C32(0x672b784e) },
  { SPH_C32(0xde010000), SPH_C32(0x5dd100ba), SPH_C32(0x2461e000),
    SPH_C32(0xfb0c0000), SPH_C32(0x92935c31), SPH_C32(0xe0a79e79),
    SPH_C32(0x3ac26c56), SPH_C32(0x7cf5ea53), SPH_C32(0x4dff0000),
    SPH_C32(0x12fb00a0), SPH_C32(0x67086000), SPH_C32(0xaa5d0000),
    SPH_C32(0x9c415174), SPH_C32(0x8aed2dc9), SPH_C32(0xc7a59926),
    SPH_C32(0xd78e607a) },
  { SPH_C32(0x68cf0000), SPH_C32(0x873800b8), SPH_C32(0x310f6000),
    SPH_C32(0x219e0000), SPH_C32(0x644e0655), SPH_C32(0xd695c2f3),
    SPH_C32(0xc8b084f8), SPH_C32(0xda4d28de), SPH_C32(0xcb860000),
    SPH_C32(0x2dc200a2), SPH_C32(0x86928000), SPH_C32(0x320b0000),
    SPH_C32(0x0924367a), SPH_C32(0xc465e523), SPH_C32(0x1478d062),
    SPH_C32(0xc193bac3) },
  { SPH_C32(0xeeb60000), SPH_C32(0xb80100ba), SPH_C32(0xd0958000),
    SPH_C32(0xb9c80000), SPH_C32(0xf12b615b), SPH_C32(0x981d0a19),
    SPH_C32(0x1b6dcdbc), SPH_C32(0xcc50f267), SPH_C32(0xfb310000),
    SPH_C32(0xc81200a2), SPH_C32(0x7266e000), SPH_C32(0x70cf0000),
    SPH_C32(0x6a9c0b10), SPH_C32(0xbcdf7143), SPH_C32(0x35d77188),
    SPH_C32(0x7136a2f7) },
  { SPH_C32(0xfb720000), SPH_C32(0x7d1d00cc), SPH_C32(0x424c0000),
    SPH_C32(0xe7bc0000), SPH_C32(0xe92150f6), SPH_C32(0xd1f9c1e1),
    SPH_C32(0x257e9c37), SPH_C32(0xf51d2faa), SPH_C32(0xd5dc0000),
    SPH_C32(0x28da0084), SPH_C32(0xdaa00000), SPH_C32(0x7d240000),
    SPH_C32(0x4a8d736a), SPH_C32(0x8c028d8a), SPH_C32(0x87fef24b),
    SPH_C32(0x90daf380) },
  { SPH_C32(0x7d0b0000), SPH_C32(0x422400ce), SPH_C32(0xa3d6e000),
    SPH_C32(0x7fea0000), SPH_C32(0x7c4437f8), SPH_C32(0x9f71090b),
    SPH_C32(0xf6a3d573), SPH_C32(0xe300f513), SPH_C32(0xe56b0000),
    SPH_C32(0xcd0a0084), SPH_C32(0x2e546000), SPH_C32(0x3fe00000),
    SPH_C32(0x29354e00), SPH_C32(0xf4b819ea), SPH_C32(0xa65153a1),
    SPH_C32(0x207febb4) },
  { SPH_C32(0xcbc50000), SPH_C32(0x98cd00cc), SPH_C32(0xb6b86000),
    SPH_C32(0xa5780000), SPH_C32(0x8a996d9c), SPH_C32(0xa9435581),
    SPH_C32(0x04d13ddd), SPH_C32(0x45b8379e), SPH_C32(0x63120000),
    SPH_C32(0xf2330086), SPH_C32(0xcfce8000), SPH_C32(0xa7b60000),
    SPH_C32(0xbc50290e), SPH_C32(0xba30d100), SPH_C32(0x758c1ae5),
    SPH_C32(0x3662310d) },
  { SPH_C32(0x4dbc0000), SPH_C32(0xa7f400ce), SPH_C32(0x57228000),
    SPH_C32(0x3d2e0000), SPH_C32(0x1ffc0a92), SPH_C32(0xe7cb9d6b),
    SPH_C32(0xd70c7499), SPH_C32(0x53a5ed27), SPH_C32(0x53a50000),
    SPH_C32(0x17e30086), SPH_C32(0x3b3ae000), SPH_C32(0xe5720000),
    SPH_C32(0xdfe81464), SPH_C32(0xc28a4560), SPH_C32(0x5423bb0f),
    SPH_C32(0x86c72939) },
  { SPH_C32(0xef6b0000), SPH_C32(0x5ed700f0), SPH_C32(0x12930000),
    SPH_C32(0xa30a0000), SPH_C32(0xf24d3746), SPH_C32(0xed0a6d94),
    SPH_C32(0x44988c87), SPH_C32(0x2ed7f42a), SPH_C32(0x369f0000),
    SPH_C32(0x12940090), SPH_C32(0x28660000), SPH_C32(0xd76a0000),
    SPH_C32(0x919331cc), SPH_C32(0xa969339f), SPH_C32(0x95c3431d),
    SPH_C32(0xaa946a57) },
  { SPH_C32(0x69120000), SPH_C32(0x61ee00f2), SPH_C32(0xf309e000),
    SPH_C32(0x3b5c0000), SPH_C32(0x67285048), SPH_C32(0xa382a57e),
    SPH_C32(0x9745c5c3), SPH_C32(0x38ca2e93), SPH_C32(0x06280000),
    SPH_C32(0xf7440090), SPH_C32(0xdc926000), SPH_C32(0x95ae0000),
    SPH_C32(0xf22b0ca6), SPH_C32(0xd1d3a7ff), SPH_C32(0xb46ce2f7),
    SPH_C32(0x1a317263) },
  { SPH_C32(0xdfdc0000), SPH_C32(0xbb0700f0), SPH_C32(0xe6676000),
    SPH_C32(0xe1ce0000), SPH_C32(0x91f50a2c), SPH_C32(0x95b0f9f4),
    SPH_C32(0x65372d6d), SPH_C32(0x9e72ec1e), SPH_C32(0x80510000),
    SPH_C32(0xc87d0092), SPH_C32(0x3d088000), SPH_C32(0x0df80000),
    SPH_C32(0x674e6ba8), SPH_C32(0x9f5b6f15), SPH_C32(0x67b1abb3),
    SPH_C32(0x0c2ca8da) },
  { SPH_C32(0x59a50000), SPH_C32(0x843e00f2), SPH_C32(0x07fd8000),
    SPH_C32(0x79980000), SPH_C32(0x04906d22), SPH_C32(0xdb38311e),
    SPH_C32(0xb6ea6429), SPH_C32(0x886f36a7), SPH_C32(0xb0e60000),
    SPH_C32(0x2dad0092), SPH_C32(0xc9fce000), SPH_C32(0x4f3c0000),
    SPH_C32(0x04f656c2), SPH_C32(0xe7e1fb75), SPH_C32(0x461e0a59),
    SPH_C32(0xbc89b0ee) },
  { SPH_C32(0x18310000), SPH_C32(0x475300d8), SPH_C32(0xb08a0000),
    SPH_C32(0x4df20000), SPH_C32(0x323f1250), SPH_C32(0xf4927ff4),
    SPH_C32(0x37432d61), SPH_C32(0xcf53b67d), SPH_C32(0x22860000),
    SPH_C32(0x315e00ac), SPH_C32(0x78b90000), SPH_C32(0x93dc0000),
    SPH_C32(0x8aff567c), SPH_C32(0x959a9fea), SPH_C32(0xf42553ad),
    SPH_C32(0x715eb1d7) },
  { SPH_C32(0x9e480000), SPH_C32(0x786a00da), SPH_C32(0x5110e000),
    SPH_C32(0xd5a40000), SPH_C32(0xa75a755e), SPH_C32(0xba1ab71e),
    SPH_C32(0xe49e6425), SPH_C32(0xd94e6cc4), SPH_C32(0x12310000),
    SPH_C32(0xd48e00ac), SPH_C32(0x8c4d6000), SPH_C32(0xd1180000),
    SPH_C32(0xe9476b16), SPH_C32(0xed200b8a), SPH_C32(0xd58af247),
    SPH_C32(0xc1fba9e3) },
  { SPH_C32(0x28860000), SPH_C32(0xa28300d8), SPH_C32(0x447e6000),
    SPH_C32(0x0f360000), SPH_C32(0x51872f3a), SPH_C32(0x8c28eb94),
    SPH_C32(0x16ec8c8b), SPH_C32(0x7ff6ae49), SPH_C32(0x94480000),
    SPH_C32(0xebb700ae), SPH_C32(0x6dd78000), SPH_C32(0x494e0000),
    SPH_C32(0x7c220c18), SPH_C32(0xa3a8c360), SPH_C32(0x0657bb03),
    SPH_C32(0xd7e6735a) },
  { SPH_C32(0xaeff0000), SPH_C32(0x9dba00da), SPH_C32(0xa5e48000),
    SPH_C32(0x97600000), SPH_C32(0xc4e24834), SPH_C32(0xc2a0237e),
    SPH_C32(0xc531c5cf), SPH_C32(0x69eb74f0), SPH_C32(0xa4ff0000),
    SPH_C32(0x0e6700ae), SPH_C32(0x9923e000), SPH_C32(0x0b8a0000),
    SPH_C32(0x1f9a3172), SPH_C32(0xdb125700), SPH_C32(0x27f81ae9),
    SPH_C32(0x67436b6e) },
  { SPH_C32(0x0c280000), SPH_C32(0x649900e4), SPH_C32(0xe0550000),
    SPH_C32(0x09440000), SPH_C32(0x295375e0), SPH_C32(0xc861d381),
    SPH_C32(0x56a53dd1), SPH_C32(0x14996dfd), SPH_C32(0xc1c50000),
    SPH_C32(0x0b1000b8), SPH_C32(0x8a7f0000), SPH_C32(0x39920000),
    SPH_C32(0x51e114da), SPH_C32(0xb0f121ff), SPH_C32(0xe618e2fb),
    SPH_C32(0x4b102800) },
  { SPH_C32(0x8a510000), SPH_C32(0x5ba000e6), SPH_C32(0x01cfe000),
    SPH_C32(0x91120000), SPH_C32(0xbc3612ee), SPH_C32(0x86e91b6b),
    SPH_C32(0x85787495), SPH_C32(0x0284b744), SPH_C32(0xf1720000),
    SPH_C32(0xeec000b8), SPH_C32(0x7e8b6000), SPH_C32(0x7b560000),
    SPH_C32(0x325929b0), SPH_C32(0xc84bb59f), SPH_C32(0xc7b74311),
    SPH_C32(0xfbb53034) },
  { SPH_C32(0x3c9f0000), SPH_C32(0x814900e4), SPH_C32(0x14a16000),
    SPH_C32(0x4b800000), SPH_C32(0x4aeb488a), SPH_C32(0xb0db47e1),
    SPH_C32(0x770a9c3b), SPH_C32(0xa43c75c9), SPH_C32(0x770b0000),
    SPH_C32(0xd1f900ba), SPH_C32(0x9f118000), SPH_C32(0xe3000000),
    SPH_C32(0xa73c4ebe), SPH_C32(0x86c37d75), SPH_C32(0x146a0a55),
    SPH_C32(0xeda8ea8d) },
  { SPH_C32(0xbae60000), SPH_C32(0xbe7000e6), SPH_C32(0xf53b8000),
    SPH_C32(0xd3d60000), SPH_C32(0xdf8e2f84), SPH_C32(0xfe538f0b),
    SPH_C32(0xa4d7d57f), SPH_C32(0xb221af70), SPH_C32(0x47bc0000),
    SPH_C32(0x342900ba), SPH_C32(0x6be5e000), SPH_C32(0xa1c40000),
    SPH_C32(0xc48473d4), SPH_C32(0xfe79e915), SPH_C32(0x35c5abbf),
    SPH_C32(0x5d0df2b9) },
  { SPH_C32(0x13af0000), SPH_C32(0x87570088), SPH_C32(0x7e610000),
    SPH_C32(0x5ca90000), SPH_C32(0x699c66ed), SPH_C32(0xf511dca5),
    SPH_C32(0x9ad65ec3), SPH_C32(0xa75722f3), SPH_C32(0x818c0000),
    SPH_C32(0x2eab00d8), SPH_C32(0xff0e0000), SPH_C32(0x173a0000),
    SPH_C32(0x64283db5), SPH_C32(0xea4c0898), SPH_C32(0x3844ea88),
    SPH_C32(0xeeabae97) },
  { SPH_C32(0x95d60000), SPH_C32(0xb86e008a), SPH_C32(0x9ffbe000),
    SPH_C32(0xc4ff0000), SPH_C32(0xfcf901e3), SPH_C32(0xbb99144f),
    SPH_C32(0x490b1787), SPH_C32(0xb14af84a), SPH_C32(0xb13b0000),
    SPH_C32(0xcb7b00d8), SPH_C32(0x0bfa6000), SPH_C32(0x55fe0000),
    SPH_C32(0x079000df), SPH_C32(0x92f69cf8), SPH_C32(0x19eb4b62),
    SPH_C32(0x5e0eb6a3) },
  { SPH_C32(0x23180000), SPH_C32(0x62870088), SPH_C32(0x8a956000),
    SPH_C32(0x1e6d0000), SPH_C32(0x0a245b87), SPH_C32(0x8dab48c5),
    SPH_C32(0xbb79ff29), SPH_C32(0x17f23ac7), SPH_C32(0x37420000),
    SPH_C32(0xf44200da), SPH_C32(0xea608000), SPH_C32(0xcda80000),
    SPH_C32(0x92f567d1), SPH_C32(0xdc7e5412), SPH_C32(0xca360226),
    SPH_C32(0x48136c1a) },
  { SPH_C32(0xa5610000), SPH_C32(0x5dbe008a), SPH_C32(0x6b0f8000),
    SPH_C32(0x863b0000), SPH_C32(0x9f413c89), SPH_C32(0xc323802f),
    SPH_C32(0x68a4b66d), SPH_C32(0x01efe07e), SPH_C32(0x07f50000),
    SPH_C32(0x119200da), SPH_C32(0x1e94e000), SPH_C32(0x8f6c0000),
    SPH_C32(0xf14d5abb), SPH_C32(0xa4c4c072), SPH_C32(0xeb99a3cc),
    SPH_C32(0xf8b6742e) },
  { SPH_C32(0x07b60000), SPH_C32(0xa49d00b4), SPH_C32(0x2ebe0000),
    SPH_C32(0x181f0000), SPH_C32(0x72f0015d), SPH_C32(0xc9e270d0),
    SPH_C32(0xfb304e73), SPH_C32(0x7c9df973), SPH_C32(0x62cf0000),
    SPH_C32(0x14e500cc), SPH_C32(0x0dc80000), SPH_C32(0xbd740000),
    SPH_C32(0xbf367f13), SPH_C32(0xcf27b68d), SPH_C32(0x2a795bde),
    SPH_C32(0xd4e53740) },
  { SPH_C32(0x81cf0000), SPH_C32(0x9ba400b6), SPH_C32(0xcf24e000),
    SPH_C32(0x80490000), SPH_C32(0xe7956653), SPH_C32(0x876ab83a),
    SPH_C32(0x28ed0737), SPH_C32(0x6a8023ca), SPH_C32(0x52780000),
    SPH_C32(0xf13500cc), SPH_C32(0xf93c6000), SPH_C32(0xffb00000),
    SPH_C32(0xdc8e4279), SPH_C32(0xb79d22ed), SPH_C32(0x0bd6fa34),
    SPH_C32(0x64402f74) },
  { SPH_C32(0x37010000), SPH_C32(0x414d00b4), SPH_C32(0xda4a6000),
    SPH_C32(0x5adb0000), SPH_C32(0x11483c37), SPH_C32(0xb158e4b0),
    SPH_C32(0xda9fef99), SPH_C32(0xcc38e147), SPH_C32(0xd4010000),
    SPH_C32(0xce0c00ce), SPH_C32(0x18a68000), SPH_C32(0x67e60000),
    SPH_C32(0x49eb2577), SPH_C32(0xf915ea07), SPH_C32(0xd80bb370),
    SPH_C32(0x725df5cd) },
  { SPH_C32(0xb1780000), SPH_C32(0x7e7400b6), SPH_C32(0x3bd08000),
    SPH_C32(0xc28d0000), SPH_C32(0x842d5b39), SPH_C32(0xffd02c5a),
    SPH_C32(0x0942a6dd), SPH_C32(0xda253bfe), SPH_C32(0xe4b60000),
    SPH_C32(0x2bdc00ce), SPH_C32(0xec52e000), SPH_C32(0x25220000),
    SPH_C32(0x2a53181d), SPH_C32(0x81af7e67), SPH_C32(0xf9a4129a),
    SPH_C32(0xc2f8edf9) },
  { SPH_C32(0xf0ec0000), SPH_C32(0xbd19009c), SPH_C32(0x8ca70000),
    SPH_C32(0xf6e70000), SPH_C32(0xb282244b), SPH_C32(0xd07a62b0),
    SPH_C32(0x88ebef95), SPH_C32(0x9d19bb24), SPH_C32(0x76d60000),
    SPH_C32(0x372f00f0), SPH_C32(0x5d170000), SPH_C32(0xf9c20000),
    SPH_C32(0xa45a18a3), SPH_C32(0xf3d41af8), SPH_C32(0x4b9f4b6e),
    SPH_C32(0x0f2fecc0) },
  { SPH_C32(0x76950000), SPH_C32(0x8220009e), SPH_C32(0x6d3de000),
    SPH_C32(0x6eb10000), SPH_C32(0x27e74345), SPH_C32(0x9ef2aa5a),
    SPH_C32(0x5b36a6d1), SPH_C32(0x8b04619d), SPH_C32(0x46610000),
    SPH_C32(0xd2ff00f0), SPH_C32(0xa9e36000), SPH_C32(0xbb060000),
    SPH_C32(0xc7e225c9), SPH_C32(0x8b6e8e98), SPH_C32(0x6a30ea84),
    SPH_C32(0xbf8af4f4) },
  { SPH_C32(0xc05b0000), SPH_C32(0x58c9009c), SPH_C32(0x78536000),
    SPH_C32(0xb4230000), SPH_C32(0xd13a1921), SPH_C32(0xa8c0f6d0),
    SPH_C32(0xa9444e7f), SPH_C32(0x2dbca310), SPH_C32(0xc0180000),
    SPH_C32(0xedc600f2), SPH_C32(0x48798000), SPH_C32(0x23500000),
    SPH_C32(0x528742c7), SPH_C32(0xc5e64672), SPH_C32(0xb9eda3c0),
    SPH_C32(0xa9972e4d) },
  { SPH_C32(0x46220000), SPH_C32(0x67f0009e), SPH_C32(0x99c98000),
    SPH_C32(0x2c750000), SPH_C32(0x445f7e2f), SPH_C32(0xe6483e3a),
    SPH_C32(0x7a99073b), SPH_C32(0x3ba179a9), SPH_C32(0xf0af0000),
    SPH_C32(0x081600f2), SPH_C32(0xbc8de000), SPH_C32(0x61940000),
    SPH_C32(0x313f7fad), SPH_C32(0xbd5cd212), SPH_C32(0x9842022a),
    SPH_C32(0x19323679) },
  { SPH_C32(0xe4f50000), SPH_C32(0x9ed300a0), SPH_C32(0xdc780000),
    SPH_C32(0xb2510000), SPH_C32(0xa9ee43fb), SPH_C32(0xec89cec5),
    SPH_C32(0xe90dff25), SPH_C32(0x46d360a4), SPH_C32(0x95950000),
    SPH_C32(0x0d6100e4), SPH_C32(0xafd10000), SPH_C32(0x538c0000),
    SPH_C32(0x7f445a05), SPH_C32(0xd6bfa4ed), SPH_C32(0x59a2fa38),
    SPH_C32(0x35617517) },
  { SPH_C32(0x628c0000), SPH_C32(0xa1ea00a2), SPH_C32(0x3de2e000),
    SPH_C32(0x2a070000), SPH_C32(0x3c8b24f5), SPH_C32(0xa201062f),
    SPH_C32(0x3ad0b661), SPH_C32(0x50ceba1d), SPH_C32(0xa5220000),
    SPH_C32(0xe8b100e4), SPH_C32(0x5b256000), SPH_C32(0x11480000),
    SPH_C32(0x1cfc676f), SPH_C32(0xae05308d), SPH_C32(0x780d5bd2),
    SPH_C32(0x85c46d23) },
  { SPH_C32(0xd4420000), SPH_C32(0x7b0300a0), SPH_C32(0x288c6000),
    SPH_C32(0xf0950000), SPH_C32(0xca567e91), SPH_C32(0x94335aa5),
    SPH_C32(0xc8a25ecf), SPH_C32(0xf6767890), SPH_C32(0x235b0000),
    SPH_C32(0xd78800e6), SPH_C32(0xbabf8000), SPH_C32(0x891e0000),
    SPH_C32(0x89990061), SPH_C32(0xe08df867), SPH_C32(0xabd01296),
    SPH_C32(0x93d9b79a) },
  { SPH_C32(0x523b0000), SPH_C32(0x443a00a2), SPH_C32(0xc9168000),
    SPH_C32(0x68c30000), SPH_C32(0x5f33199f), SPH_C32(0xdabb924f),
    SPH_C32(0x1b7f178b), SPH_C32(0xe06ba229), SPH_C32(0x13ec0000),
    SPH_C32(0x325800e6), SPH_C32(0x4e4be000), SPH_C32(0xcbda0000),
    SPH_C32(0xea213d0b), SPH_C32(0x98376c07), SPH_C32(0x8a7fb37c),
    SPH_C32(0x237cafae) },
  { SPH_C32(0x47ff0000), SPH_C32(0x812600d4), SPH_C32(0x5bcf0000),
    SPH_C32(0x36b70000), SPH_C32(0x47392832), SPH_C32(0x935f59b7),
    SPH_C32(0x256c4600), SPH_C32(0xd9267fe4), SPH_C32(0x3d010000),
    SPH_C32(0xd29000c0), SPH_C32(0xe68d0000), SPH_C32(0xc6310000),
    SPH_C32(0xca304571), SPH_C32(0xa8ea90ce), SPH_C32(0x385630bf),
    SPH_C32(0xc290fed9) },
  { SPH_C32(0xc1860000), SPH_C32(0xbe1f00d6), SPH_C32(0xba55e000),
    SPH_C32(0xaee10000), SPH_C32(0xd25c4f3c), SPH_C32(0xddd7915d),
    SPH_C32(0xf6b10f44), SPH_C32(0xcf3ba55d), SPH_C32(0x0db60000),
    SPH_C32(0x374000c0), SPH_C32(0x12796000), SPH_C32(0x84f50000),
    SPH_C32(0xa988781b), SPH_C32(0xd05004ae), SPH_C32(0x19f99155),
    SPH_C32(0x7235e6ed) },
  { SPH_C32(0x77480000), SPH_C32(0x64f600d4), SPH_C32(0xaf3b6000),
    SPH_C32(0x74730000), SPH_C32(0x24811558), SPH_C32(0xebe5cdd7),
    SPH_C32(0x04c3e7ea), SPH_C32(0x698367d0), SPH_C32(0x8bcf0000),
    SPH_C32(0x087900c2), SPH_C32(0xf3e38000), SPH_C32(0x1ca30000),
    SPH_C32(0x3ced1f15), SPH_C32(0x9ed8cc44), SPH_C32(0xca24d811),
    SPH_C32(0x64283c54) },
  { SPH_C32(0xf1310000), SPH_C32(0x5bcf00d6), SPH_C32(0x4ea18000),
    SPH_C32(0xec250000), SPH_C32(0xb1e47256), SPH_C32(0xa56d053d),
    SPH_C32(0xd71eaeae), SPH_C32(0x7f9ebd69), SPH_C32(0xbb780000),
    SPH_C32(0xeda900c2), SPH_C32(0x0717e000), SPH_C32(0x5e670000),
    SPH_C32(0x5f55227f), SPH_C32(0xe6625824), SPH_C32(0xeb8b79fb),
    SPH_C32(0xd48d2460) },
  { SPH_C32(0x53e60000), SPH_C32(0xa2ec00e8), SPH_C32(0x0b100000),
    SPH_C32(0x72010000), SPH_C32(0x5c554f82), SPH_C32(0xafacf5c2),
    SPH_C32(0x448a56b0), SPH_C32(0x02eca464), SPH_C32(0xde420000),
    SPH_C32(0xe8de00d4), SPH_C32(0x144b0000), SPH_C32(0x6c7f0000),
    SPH_C32(0x112e07d7), SPH_C32(0x8d812edb), SPH_C32(0x2a6b81e9),
    SPH_C32(0xf8de670e) },
  { SPH_C32(0xd59f0000), SPH_C32(0x9dd500ea), SPH_C32(0xea8ae000),
    SPH_C32(0xea570000), SPH_C32(0xc930288c), SPH_C32(0xe1243d28),
    SPH_C32(0x97571ff4), SPH_C32(0x14f17edd), SPH_C32(0xeef50000),
    SPH_C32(0x0d0e00d4), SPH_C32(0xe0bf6000), SPH_C32(0x2ebb0000),
    SPH_C32(0x72963abd), SPH_C32(0xf53bbabb), SPH_C32(0x0bc42003),
    SPH_C32(0x487b7f3a) },
  { SPH_C32(0x63510000), SPH_C32(0x473c00e8), SPH_C32(0xffe46000),
    SPH_C32(0x30c50000), SPH_C32(0x3fed72e8), SPH_C32(0xd71661a2),
    SPH_C32(0x6525f75a), SPH_C32(0xb249bc50), SPH_C32(0x688c0000),
    SPH_C32(0x323700d6), SPH_C32(0x01258000), SPH_C32(0xb6ed0000),
    SPH_C32(0xe7f35db3), SPH_C32(0xbbb37251), SPH_C32(0xd8196947),
    SPH_C32(0x5e66a583) },
  { SPH_C32(0xe5280000), SPH_C32(0x780500ea), SPH_C32(0x1e7e8000),
    SPH_C32(0xa8930000), SPH_C32(0xaa8815e6), SPH_C32(0x999ea948),
    SPH_C32(0xb6f8be1e), SPH_C32(0xa45466e9), SPH_C32(0x583b0000),
    SPH_C32(0xd7e700d6), SPH_C32(0xf5d1e000), SPH_C32(0xf4290000),
    SPH_C32(0x844b60d9), SPH_C32(0xc309e631), SPH_C32(0xf9b6c8ad),
    SPH_C32(0xeec3bdb7) },
  { SPH_C32(0xa4bc0000), SPH_C32(0xbb6800c0), SPH_C32(0xa9090000),
    SPH_C32(0x9cf90000), SPH_C32(0x9c276a94), SPH_C32(0xb634e7a2),
    SPH_C32(0x3751f756), SPH_C32(0xe368e633), SPH_C32(0xca5b0000),
    SPH_C32(0xcb1400e8), SPH_C32(0x44940000), SPH_C32(0x28c90000),
    SPH_C32(0x0a426067), SPH_C32(0xb17282ae), SPH_C32(0x4b8d9159),
    SPH_C32(0x2314bc8e) },
  { SPH_C32(0x22c50000), SPH_C32(0x845100c2), SPH_C32(0x4893e000),
    SPH_C32(0x04af0000), SPH_C32(0x09420d9a), SPH_C32(0xf8bc2f48),
    SPH_C32(0xe48cbe12), SPH_C32(0xf5753c8a), SPH_C32(0xfaec0000),
    SPH_C32(0x2ec400e8), SPH_C32(0xb0606000), SPH_C32(0x6a0d0000),
    SPH_C32(0x69fa5d0d), SPH_C32(0xc9c816ce), SPH_C32(0x6a2230b3),
    SPH_C32(0x93b1a4ba) },
  { SPH_C32(0x940b0000), SPH_C32(0x5eb800c0), SPH_C32(0x5dfd6000),
    SPH_C32(0xde3d0000), SPH_C32(0xff9f57fe), SPH_C32(0xce8e73c2),
    SPH_C32(0x16fe56bc), SPH_C32(0x53cdfe07), SPH_C32(0x7c950000),
    SPH_C32(0x11fd00ea), SPH_C32(0x51fa8000), SPH_C32(0xf25b0000),
    SPH_C32(0xfc9f3a03), SPH_C32(0x8740de24), SPH_C32(0xb9ff79f7),
    SPH_C32(0x85ac7e03) },
  { SPH_C32(0x12720000), SPH_C32(0x618100c2), SPH_C32(0xbc678000),
    SPH_C32(0x466b0000), SPH_C32(0x6afa30f0), SPH_C32(0x8006bb28),
    SPH_C32(0xc5231ff8), SPH_C32(0x45d024be), SPH_C32(0x4c220000),
    SPH_C32(0xf42d00ea), SPH_C32(0xa50ee000), SPH_C32(0xb09f0000),
    SPH_C32(0x9f270769), SPH_C32(0xfffa4a44), SPH_C32(0x9850d81d),
    SPH_C32(0x35096637) },
  { SPH_C32(0xb0a50000), SPH_C32(0x98a200fc), SPH_C32(0xf9d60000),
    SPH_C32(0xd84f0000), SPH_C32(0x874b0d24), SPH_C32(0x8ac74bd7),
    SPH_C32(0x56b7e7e6), SPH_C32(0x38a23db3), SPH_C32(0x29180000),
    SPH_C32(0xf15a00fc), SPH_C32(0xb6520000), SPH_C32(0x82870000),
    SPH_C32(0xd15c22c1), SPH_C32(0x94193cbb), SPH_C32(0x59b0200f),
    SPH_C32(0x195a2559) },
  { SPH_C32(0x36dc0000), SPH_C32(0xa79b00fe), SPH_C32(0x184ce000),
    SPH_C32(0x40190000), SPH_C32(0x122e6a2a), SPH_C32(0xc44f833d),
    SPH_C32(0x856aaea2), SPH_C32(0x2ebfe70a), SPH_C32(0x19af0000),
    SPH_C32(0x148a00fc), SPH_C32(0x42a66000), SPH_C32(0xc0430000),
    SPH_C32(0xb2e41fab), SPH_C32(0xeca3a8db), SPH_C32(0x781f81e5),
    SPH_C32(0xa9ff3d6d) },
  { SPH_C32(0x80120000), SPH_C32(0x7d7200fc), SPH_C32(0x0d226000),
    SPH_C32(0x9a8b0000), SPH_C32(0xe4f3304e), SPH_C32(0xf27ddfb7),
    SPH_C32(0x7718460c), SPH_C32(0x88072587), SPH_C32(0x9fd60000),
    SPH_C32(0x2bb300fe), SPH_C32(0xa33c8000), SPH_C32(0x58150000),
    SPH_C32(0x278178a5), SPH_C32(0xa22b6031), SPH_C32(0xabc2c8a1),
    SPH_C32(0xbfe2e7d4) },
  { SPH_C32(0x066b0000), SPH_C32(0x424b00fe), SPH_C32(0xecb88000),
    SPH_C32(0x02dd0000), SPH_C32(0x71965740), SPH_C32(0xbcf5175d),
    SPH_C32(0xa4c50f48), SPH_C32(0x9e1aff3e), SPH_C32(0xaf610000),
    SPH_C32(0xce6300fe), SPH_C32(0x57c8e000), SPH_C32(0x1ad10000),
    SPH_C32(0x443945cf), SPH_C32(0xda91f451), SPH_C32(0x8a6d694b),
    SPH_C32(0x0f47ffe0) }
};

__constant static const sph_u32 T512_32[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xcc140000), SPH_C32(0xa5630000), SPH_C32(0x5ab90780),
    SPH_C32(0x3b500000), SPH_C32(0x4bd013ff), SPH_C32(0x879b3418),
    SPH_C32(0x694348c1), SPH_C32(0xca5a87fe), SPH_C32(0x819e0000),
    SPH_C32(0xec570000), SPH_C32(0x66320280), SPH_C32(0x95f30000),
    SPH_C32(0x5da92802), SPH_C32(0x48f43cbc), SPH_C32(0xe65aa22d),
    SPH_C32(0x8e67b7fa) },
  { SPH_C32(0x819e0000), SPH_C32(0xec570000), SPH_C32(0x66320280),
    SPH_C32(0x95f30000), SPH_C32(0x5da92802), SPH_C32(0x48f43cbc),
    SPH_C32(0xe65aa22d), SPH_C32(0x8e67b7fa), SPH_C32(0x4d8a0000),
    SPH_C32(0x49340000), SPH_C32(0x3c8b0500), SPH_C32(0xaea30000),
    SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4), SPH_C32(0x8f19eaec),
    SPH_C32(0x443d3004) },
  { SPH_C32(0x4d8a0000), SPH_C32(0x49340000), SPH_C32(0x3c8b0500),
    SPH_C32(0xaea30000), SPH_C32(0x16793bfd), SPH_C32(0xcf6f08a4),
    SPH_C32(0x8f19eaec), SPH_C32(0x443d3004), SPH_C32(0xcc140000),
    SPH_C32(0xa5630000), SPH_C32(0x5ab90780), SPH_C32(0x3b500000),
    SPH_C32(0x4bd013ff), SPH_C32(0x879b3418), SPH_C32(0x694348c1),
    SPH_C32(0xca5a87fe) },
  { SPH_C32(0x78230000), SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80),
    SPH_C32(0x90a50000), SPH_C32(0x713e2879), SPH_C32(0x7ee98924),
    SPH_C32(0xf08ca062), SPH_C32(0x636f8bab), SPH_C32(0x02af0000),
    SPH_C32(0xb7280000), SPH_C32(0xba1c0300), SPH_C32(0x56980000),
    SPH_C32(0xba8d45d3), SPH_C32(0x8048c667), SPH_C32(0xa95c149a),
    SPH_C32(0xf4f6ea7b) },
  { SPH_C32(0xb4370000), SPH_C32(0xb79f0000), SPH_C32(0xf3830c00),
    SPH_C32(0xabf50000), SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c),
    SPH_C32(0x99cfe8a3), SPH_C32(0xa9350c55), SPH_C32(0x83310000),
    SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180), SPH_C32(0xc36b0000),
    SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb), SPH_C32(0x4f06b6b7),
    SPH_C32(0x7a915d81) },
  { SPH_C32(0xf9bd0000), SPH_C32(0xfeab0000), SPH_C32(0xcf080900),
    SPH_C32(0x05560000), SPH_C32(0x2c97007b), SPH_C32(0x361db598),
    SPH_C32(0x16d6024f), SPH_C32(0xed083c51), SPH_C32(0x4f250000),
    SPH_C32(0xfe1c0000), SPH_C32(0x86970600), SPH_C32(0xf83b0000),
    SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3), SPH_C32(0x2645fe76),
    SPH_C32(0xb0cbda7f) },
  { SPH_C32(0x35a90000), SPH_C32(0x5bc80000), SPH_C32(0x95b10e80),
    SPH_C32(0x3e060000), SPH_C32(0x67471384), SPH_C32(0xb1868180),
    SPH_C32(0x7f954a8e), SPH_C32(0x2752bbaf), SPH_C32(0xcebb0000),
    SPH_C32(0x124b0000), SPH_C32(0xe0a50480), SPH_C32(0x6dc80000),
    SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f), SPH_C32(0xc01f5c5b),
    SPH_C32(0x3eac6d85) },
  { SPH_C32(0x02af0000), SPH_C32(0xb7280000), SPH_C32(0xba1c0300),
    SPH_C32(0x56980000), SPH_C32(0xba8d45d3), SPH_C32(0x8048c667),
    SPH_C32(0xa95c149a), SPH_C32(0xf4f6ea7b), SPH_C32(0x7a8c0000),
    SPH_C32(0xa5d40000), SPH_C32(0x13260880), SPH_C32(0xc63d0000),
    SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43), SPH_C32(0x59d0b4f8),
    SPH_C32(0x979961d0) },
  { SPH_C32(0xcebb0000), SPH_C32(0x124b0000), SPH_C32(0xe0a50480),
    SPH_C32(0x6dc80000), SPH_C32(0xf15d562c), SPH_C32(0x07d3f27f),
    SPH_C32(0xc01f5c5b), SPH_C32(0x3eac6d85), SPH_C32(0xfb120000),
    SPH_C32(0x49830000), SPH_C32(0x75140a00), SPH_C32(0x53ce0000),
    SPH_C32(0x961a45a8), SPH_C32(0xb65573ff), SPH_C32(0xbf8a16d5),
    SPH_C32(0x19fed62a) },
  { SPH_C32(0x83310000), SPH_C32(0x5b7f0000), SPH_C32(0xdc2e0180),
    SPH_C32(0xc36b0000), SPH_C32(0xe7246dd1), SPH_C32(0xc8bcfadb),
    SPH_C32(0x4f06b6b7), SPH_C32(0x7a915d81), SPH_C32(0x37060000),
    SPH_C32(0xece00000), SPH_C32(0x2fad0d80), SPH_C32(0x689e0000),
    SPH_C32(0xddca5657), SPH_C32(0x31ce47e7), SPH_C32(0xd6c95e14),
    SPH_C32(0xd3a451d4) },
  { SPH_C32(0x4f250000), SPH_C32(0xfe1c0000), SPH_C32(0x86970600),
    SPH_C32(0xf83b0000), SPH_C32(0xacf47e2e), SPH_C32(0x4f27cec3),
    SPH_C32(0x2645fe76), SPH_C32(0xb0cbda7f), SPH_C32(0xb6980000),
    SPH_C32(0x00b70000), SPH_C32(0x499f0f00), SPH_C32(0xfd6d0000),
    SPH_C32(0x80637e55), SPH_C32(0x793a7b5b), SPH_C32(0x3093fc39),
    SPH_C32(0x5dc3e62e) },
  { SPH_C32(0x7a8c0000), SPH_C32(0xa5d40000), SPH_C32(0x13260880),
    SPH_C32(0xc63d0000), SPH_C32(0xcbb36daa), SPH_C32(0xfea14f43),
    SPH_C32(0x59d0b4f8), SPH_C32(0x979961d0), SPH_C32(0x78230000),
    SPH_C32(0x12fc0000), SPH_C32(0xa93a0b80), SPH_C32(0x90a50000),
    SPH_C32(0x713e2879), SPH_C32(0x7ee98924), SPH_C32(0xf08ca062),
    SPH_C32(0x636f8bab) },
  { SPH_C32(0xb6980000), SPH_C32(0x00b70000), SPH_C32(0x499f0f00),
    SPH_C32(0xfd6d0000), SPH_C32(0x80637e55), SPH_C32(0x793a7b5b),
    SPH_C32(0x3093fc39), SPH_C32(0x5dc3e62e), SPH_C32(0xf9bd0000),
    SPH_C32(0xfeab0000), SPH_C32(0xcf080900), SPH_C32(0x05560000),
    SPH_C32(0x2c97007b), SPH_C32(0x361db598), SPH_C32(0x16d6024f),
    SPH_C32(0xed083c51) },
  { SPH_C32(0xfb120000), SPH_C32(0x49830000), SPH_C32(0x75140a00),
    SPH_C32(0x53ce0000), SPH_C32(0x961a45a8), SPH_C32(0xb65573ff),
    SPH_C32(0xbf8a16d5), SPH_C32(0x19fed62a), SPH_C32(0x35a90000),
    SPH_C32(0x5bc80000), SPH_C32(0x95b10e80), SPH_C32(0x3e060000),
    SPH_C32(0x67471384), SPH_C32(0xb1868180), SPH_C32(0x7f954a8e),
    SPH_C32(0x2752bbaf) },
  { SPH_C32(0x37060000), SPH_C32(0xece00000), SPH_C32(0x2fad0d80),
    SPH_C32(0x689e0000), SPH_C32(0xddca5657), SPH_C32(0x31ce47e7),
    SPH_C32(0xd6c95e14), SPH_C32(0xd3a451d4), SPH_C32(0xb4370000),
    SPH_C32(0xb79f0000), SPH_C32(0xf3830c00), SPH_C32(0xabf50000),
    SPH_C32(0x3aee3b86), SPH_C32(0xf972bd3c), SPH_C32(0x99cfe8a3),
    SPH_C32(0xa9350c55) },
  { SPH_C32(0xac480000), SPH_C32(0x1ba60000), SPH_C32(0x45fb1380),
    SPH_C32(0x03430000), SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6),
    SPH_C32(0xfe72c7fe), SPH_C32(0x91e478f6), SPH_C32(0x1e4e0000),
    SPH_C32(0xdecf0000), SPH_C32(0x6df80180), SPH_C32(0x77240000),
    SPH_C32(0xec47079e), SPH_C32(0xf4a0694e), SPH_C32(0xcda31812),
    SPH_C32(0x98aa496e) },
  { SPH_C32(0x605c0000), SPH_C32(0xbec50000), SPH_C32(0x1f421400),
    SPH_C32(0x38130000), SPH_C32(0x11552295), SPH_C32(0x982964ae),
    SPH_C32(0x97318f3f), SPH_C32(0x5bbeff08), SPH_C32(0x9fd00000),
    SPH_C32(0x32980000), SPH_C32(0x0bca0300), SPH_C32(0xe2d70000),
    SPH_C32(0xb1ee2f9c), SPH_C32(0xbc5455f2), SPH_C32(0x2bf9ba3f),
    SPH_C32(0x16cdfe94) },
  { SPH_C32(0x2dd60000), SPH_C32(0xf7f10000), SPH_C32(0x23c91100),
    SPH_C32(0x96b00000), SPH_C32(0x072c1968), SPH_C32(0x57466c0a),
    SPH_C32(0x182865d3), SPH_C32(0x1f83cf0c), SPH_C32(0x53c40000),
    SPH_C32(0x97fb0000), SPH_C32(0x51730480), SPH_C32(0xd9870000),
    SPH_C32(0xfa3e3c63), SPH_C32(0x3bcf61ea), SPH_C32(0x42baf2fe),
    SPH_C32(0xdc97796a) },
  { SPH_C32(0xe1c20000), SPH_C32(0x52920000), SPH_C32(0x79701680),
    SPH_C32(0xade00000), SPH_C32(0x4cfc0a97), SPH_C32(0xd0dd5812),
    SPH_C32(0x716b2d12), SPH_C32(0xd5d948f2), SPH_C32(0xd25a0000),
    SPH_C32(0x7bac0000), SPH_C32(0x37410600), SPH_C32(0x4c740000),
    SPH_C32(0xa7971461), SPH_C32(0x733b5d56), SPH_C32(0xa4e050d3),
    SPH_C32(0x52f0ce90) },
  { SPH_C32(0xd46b0000), SPH_C32(0x095a0000), SPH_C32(0xecc11800),
    SPH_C32(0x93e60000), SPH_C32(0x2bbb1913), SPH_C32(0x615bd992),
    SPH_C32(0x0efe679c), SPH_C32(0xf28bf35d), SPH_C32(0x1ce10000),
    SPH_C32(0x69e70000), SPH_C32(0xd7e40280), SPH_C32(0x21bc0000),
    SPH_C32(0x56ca424d), SPH_C32(0x74e8af29), SPH_C32(0x64ff0c88),
    SPH_C32(0x6c5ca315) },
  { SPH_C32(0x187f0000), SPH_C32(0xac390000), SPH_C32(0xb6781f80),
    SPH_C32(0xa8b60000), SPH_C32(0x606b0aec), SPH_C32(0xe6c0ed8a),
    SPH_C32(0x67bd2f5d), SPH_C32(0x38d174a3), SPH_C32(0x9d7f0000),
    SPH_C32(0x85b00000), SPH_C32(0xb1d60000), SPH_C32(0xb44f0000),
    SPH_C32(0x0b636a4f), SPH_C32(0x3c1c9395), SPH_C32(0x82a5aea5),
    SPH_C32(0xe23b14ef) },
  { SPH_C32(0x55f50000), SPH_C32(0xe50d0000), SPH_C32(0x8af31a80),
    SPH_C32(0x06150000), SPH_C32(0x76123111), SPH_C32(0x29afe52e),
    SPH_C32(0xe8a4c5b1), SPH_C32(0x7cec44a7), SPH_C32(0x516b0000),
    SPH_C32(0x20d30000), SPH_C32(0xeb6f0780), SPH_C32(0x8f1f0000),
    SPH_C32(0x40b379b0), SPH_C32(0xbb87a78d), SPH_C32(0xebe6e664),
    SPH_C32(0x28619311) },
  { SPH_C32(0x99e10000), SPH_C32(0x406e0000), SPH_C32(0xd04a1d00),
    SPH_C32(0x3d450000), SPH_C32(0x3dc222ee), SPH_C32(0xae34d136),
    SPH_C32(0x81e78d70), SPH_C32(0xb6b6c359), SPH_C32(0xd0f50000),
    SPH_C32(0xcc840000), SPH_C32(0x8d5d0500), SPH_C32(0x1aec0000),
    SPH_C32(0x1d1a51b2), SPH_C32(0xf3739b31), SPH_C32(0x0dbc4449),
    SPH_C32(0xa60624eb) },
  { SPH_C32(0xaee70000), SPH_C32(0xac8e0000), SPH_C32(0xffe71080),
    SPH_C32(0x55db0000), SPH_C32(0xe00874b9), SPH_C32(0x9ffa96d1),
    SPH_C32(0x572ed364), SPH_C32(0x6512928d), SPH_C32(0x64c20000),
    SPH_C32(0x7b1b0000), SPH_C32(0x7ede0900), SPH_C32(0xb1190000),
    SPH_C32(0x27f46a34), SPH_C32(0x0a01260d), SPH_C32(0x9473acea),
    SPH_C32(0x0f3328be) },
  { SPH_C32(0x62f30000), SPH_C32(0x09ed0000), SPH_C32(0xa55e1700),
    SPH_C32(0x6e8b0000), SPH_C32(0xabd86746), SPH_C32(0x1861a2c9),
    SPH_C32(0x3e6d9ba5), SPH_C32(0xaf481573), SPH_C32(0xe55c0000),
    SPH_C32(0x974c0000), SPH_C32(0x18ec0b80), SPH_C32(0x24ea0000),
    SPH_C32(0x7a5d4236), SPH_C32(0x42f51ab1), SPH_C32(0x72290ec7),
    SPH_C32(0x81549f44) },
  { SPH_C32(0x2f790000), SPH_C32(0x40d90000), SPH_C32(0x99d51200),
    SPH_C32(0xc0280000), SPH_C32(0xbda15cbb), SPH_C32(0xd70eaa6d),
    SPH_C32(0xb1747149), SPH_C32(0xeb752577), SPH_C32(0x29480000),
    SPH_C32(0x322f0000), SPH_C32(0x42550c00), SPH_C32(0x1fba0000),
    SPH_C32(0x318d51c9), SPH_C32(0xc56e2ea9), SPH_C32(0x1b6a4606),
    SPH_C32(0x4b0e18ba) },
  { SPH_C32(0xe36d0000), SPH_C32(0xe5ba0000), SPH_C32(0xc36c1580),
    SPH_C32(0xfb780000), SPH_C32(0xf6714f44), SPH_C32(0x50959e75),
    SPH_C32(0xd8373988), SPH_C32(0x212fa289), SPH_C32(0xa8d60000),
    SPH_C32(0xde780000), SPH_C32(0x24670e80), SPH_C32(0x8a490000),
    SPH_C32(0x6c2479cb), SPH_C32(0x8d9a1215), SPH_C32(0xfd30e42b),
    SPH_C32(0xc569af40) },
  { SPH_C32(0xd6c40000), SPH_C32(0xbe720000), SPH_C32(0x56dd1b00),
    SPH_C32(0xc57e0000), SPH_C32(0x91365cc0), SPH_C32(0xe1131ff5),
    SPH_C32(0xa7a27306), SPH_C32(0x067d1926), SPH_C32(0x666d0000),
    SPH_C32(0xcc330000), SPH_C32(0xc4c20a00), SPH_C32(0xe7810000),
    SPH_C32(0x9d792fe7), SPH_C32(0x8a49e06a), SPH_C32(0x3d2fb870),
    SPH_C32(0xfbc5c2c5) },
  { SPH_C32(0x1ad00000), SPH_C32(0x1b110000), SPH_C32(0x0c641c80),
    SPH_C32(0xfe2e0000), SPH_C32(0xdae64f3f), SPH_C32(0x66882bed),
    SPH_C32(0xcee13bc7), SPH_C32(0xcc279ed8), SPH_C32(0xe7f30000),
    SPH_C32(0x20640000), SPH_C32(0xa2f00880), SPH_C32(0x72720000),
    SPH_C32(0xc0d007e5), SPH_C32(0xc2bddcd6), SPH_C32(0xdb751a5d),
    SPH_C32(0x75a2753f) },
  { SPH_C32(0x575a0000), SPH_C32(0x52250000), SPH_C32(0x30ef1980),
    SPH_C32(0x508d0000), SPH_C32(0xcc9f74c2), SPH_C32(0xa9e72349),
    SPH_C32(0x41f8d12b), SPH_C32(0x881aaedc), SPH_C32(0x2be70000),
    SPH_C32(0x85070000), SPH_C32(0xf8490f00), SPH_C32(0x49220000),
    SPH_C32(0x8b00141a), SPH_C32(0x4526e8ce), SPH_C32(0xb236529c),
    SPH_C32(0xbff8f2c1) },
  { SPH_C32(0x9b4e0000), SPH_C32(0xf7460000), SPH_C32(0x6a561e00),
    SPH_C32(0x6bdd0000), SPH_C32(0x874f673d), SPH_C32(0x2e7c1751),
    SPH_C32(0x28bb99ea), SPH_C32(0x42402922), SPH_C32(0xaa790000),
    SPH_C32(0x69500000), SPH_C32(0x9e7b0d80), SPH_C32(0xdcd10000),
    SPH_C32(0xd6a93c18), SPH_C32(0x0dd2d472), SPH_C32(0x546cf0b1),
    SPH_C32(0x319f453b) },
  { SPH_C32(0x1e4e0000), SPH_C32(0xdecf0000), SPH_C32(0x6df80180),
    SPH_C32(0x77240000), SPH_C32(0xec47079e), SPH_C32(0xf4a0694e),
    SPH_C32(0xcda31812), SPH_C32(0x98aa496e), SPH_C32(0xb2060000),
    SPH_C32(0xc5690000), SPH_C32(0x28031200), SPH_C32(0x74670000),
    SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8), SPH_C32(0x33d1dfec),
    SPH_C32(0x094e3198) },
  { SPH_C32(0xd25a0000), SPH_C32(0x7bac0000), SPH_C32(0x37410600),
    SPH_C32(0x4c740000), SPH_C32(0xa7971461), SPH_C32(0x733b5d56),
    SPH_C32(0xa4e050d3), SPH_C32(0x52f0ce90), SPH_C32(0x33980000),
    SPH_C32(0x293e0000), SPH_C32(0x4e311080), SPH_C32(0xe1940000),
    SPH_C32(0xeb6b1ef6), SPH_C32(0xa3e60544), SPH_C32(0xd58b7dc1),
    SPH_C32(0x87298662) },
  { SPH_C32(0x9fd00000), SPH_C32(0x32980000), SPH_C32(0x0bca0300),
    SPH_C32(0xe2d70000), SPH_C32(0xb1ee2f9c), SPH_C32(0xbc5455f2),
    SPH_C32(0x2bf9ba3f), SPH_C32(0x16cdfe94), SPH_C32(0xff8c0000),
    SPH_C32(0x8c5d0000), SPH_C32(0x14881700), SPH_C32(0xdac40000),
    SPH_C32(0xa0bb0d09), SPH_C32(0x247d315c), SPH_C32(0xbcc83500),
    SPH_C32(0x4d73019c) },
  { SPH_C32(0x53c40000), SPH_C32(0x97fb0000), SPH_C32(0x51730480),
    SPH_C32(0xd9870000), SPH_C32(0xfa3e3c63), SPH_C32(0x3bcf61ea),
    SPH_C32(0x42baf2fe), SPH_C32(0xdc97796a), SPH_C32(0x7e120000),
    SPH_C32(0x600a0000), SPH_C32(0x72ba1580), SPH_C32(0x4f370000),
    SPH_C32(0xfd12250b), SPH_C32(0x6c890de0), SPH_C32(0x5a92972d),
    SPH_C32(0xc314b666) },
  { SPH_C32(0x666d0000), SPH_C32(0xcc330000), SPH_C32(0xc4c20a00),
    SPH_C32(0xe7810000), SPH_C32(0x9d792fe7), SPH_C32(0x8a49e06a),
    SPH_C32(0x3d2fb870), SPH_C32(0xfbc5c2c5), SPH_C32(0xb0a90000),
    SPH_C32(0x72410000), SPH_C32(0x921f1100), SPH_C32(0x22ff0000),
    SPH_C32(0x0c4f7327), SPH_C32(0x6b5aff9f), SPH_C32(0x9a8dcb76),
    SPH_C32(0xfdb8dbe3) },
  { SPH_C32(0xaa790000), SPH_C32(0x69500000), SPH_C32(0x9e7b0d80),
    SPH_C32(0xdcd10000), SPH_C32(0xd6a93c18), SPH_C32(0x0dd2d472),
    SPH_C32(0x546cf0b1), SPH_C32(0x319f453b), SPH_C32(0x31370000),
    SPH_C32(0x9e160000), SPH_C32(0xf42d1380), SPH_C32(0xb70c0000),
    SPH_C32(0x51e65b25), SPH_C32(0x23aec323), SPH_C32(0x7cd7695b),
    SPH_C32(0x73df6c19) },
  { SPH_C32(0xe7f30000), SPH_C32(0x20640000), SPH_C32(0xa2f00880),
    SPH_C32(0x72720000), SPH_C32(0xc0d007e5), SPH_C32(0xc2bddcd6),
    SPH_C32(0xdb751a5d), SPH_C32(0x75a2753f), SPH_C32(0xfd230000),
    SPH_C32(0x3b750000), SPH_C32(0xae941400), SPH_C32(0x8c5c0000),
    SPH_C32(0x1a3648da), SPH_C32(0xa435f73b), SPH_C32(0x1594219a),
    SPH_C32(0xb985ebe7) },
  { SPH_C32(0x2be70000), SPH_C32(0x85070000), SPH_C32(0xf8490f00),
    SPH_C32(0x49220000), SPH_C32(0x8b00141a), SPH_C32(0x4526e8ce),
    SPH_C32(0xb236529c), SPH_C32(0xbff8f2c1), SPH_C32(0x7cbd0000),
    SPH_C32(0xd7220000), SPH_C32(0xc8a61680), SPH_C32(0x19af0000),
    SPH_C32(0x479f60d8), SPH_C32(0xecc1cb87), SPH_C32(0xf3ce83b7),
    SPH_C32(0x37e25c1d) },
  { SPH_C32(0x1ce10000), SPH_C32(0x69e70000), SPH_C32(0xd7e40280),
    SPH_C32(0x21bc0000), SPH_C32(0x56ca424d), SPH_C32(0x74e8af29),
    SPH_C32(0x64ff0c88), SPH_C32(0x6c5ca315), SPH_C32(0xc88a0000),
    SPH_C32(0x60bd0000), SPH_C32(0x3b251a80), SPH_C32(0xb25a0000),
    SPH_C32(0x7d715b5e), SPH_C32(0x15b376bb), SPH_C32(0x6a016b14),
    SPH_C32(0x9ed75048) },
  { SPH_C32(0xd0f50000), SPH_C32(0xcc840000), SPH_C32(0x8d5d0500),
    SPH_C32(0x1aec0000), SPH_C32(0x1d1a51b2), SPH_C32(0xf3739b31),
    SPH_C32(0x0dbc4449), SPH_C32(0xa60624eb), SPH_C32(0x49140000),
    SPH_C32(0x8cea0000), SPH_C32(0x5d171800), SPH_C32(0x27a90000),
    SPH_C32(0x20d8735c), SPH_C32(0x5d474a07), SPH_C32(0x8c5bc939),
    SPH_C32(0x10b0e7b2) },
  { SPH_C32(0x9d7f0000), SPH_C32(0x85b00000), SPH_C32(0xb1d60000),
    SPH_C32(0xb44f0000), SPH_C32(0x0b636a4f), SPH_C32(0x3c1c9395),
    SPH_C32(0x82a5aea5), SPH_C32(0xe23b14ef), SPH_C32(0x85000000),
    SPH_C32(0x29890000), SPH_C32(0x07ae1f80), SPH_C32(0x1cf90000),
    SPH_C32(0x6b0860a3), SPH_C32(0xdadc7e1f), SPH_C32(0xe51881f8),
    SPH_C32(0xdaea604c) },
  { SPH_C32(0x516b0000), SPH_C32(0x20d30000), SPH_C32(0xeb6f0780),
    SPH_C32(0x8f1f0000), SPH_C32(0x40b379b0), SPH_C32(0xbb87a78d),
    SPH_C32(0xebe6e664), SPH_C32(0x28619311), SPH_C32(0x049e0000),
    SPH_C32(0xc5de0000), SPH_C32(0x619c1d00), SPH_C32(0x890a0000),
    SPH_C32(0x36a148a1), SPH_C32(0x922842a3), SPH_C32(0x034223d5),
    SPH_C32(0x548dd7b6) },
  { SPH_C32(0x64c20000), SPH_C32(0x7b1b0000), SPH_C32(0x7ede0900),
    SPH_C32(0xb1190000), SPH_C32(0x27f46a34), SPH_C32(0x0a01260d),
    SPH_C32(0x9473acea), SPH_C32(0x0f3328be), SPH_C32(0xca250000),
    SPH_C32(0xd7950000), SPH_C32(0x81391980), SPH_C32(0xe4c20000),
    SPH_C32(0xc7fc1e8d), SPH_C32(0x95fbb0dc), SPH_C32(0xc35d7f8e),
    SPH_C32(0x6a21ba33) },
  { SPH_C32(0xa8d60000), SPH_C32(0xde780000), SPH_C32(0x24670e80),
    SPH_C32(0x8a490000), SPH_C32(0x6c2479cb), SPH_C32(0x8d9a1215),
    SPH_C32(0xfd30e42b), SPH_C32(0xc569af40), SPH_C32(0x4bbb0000),
    SPH_C32(0x3bc20000), SPH_C32(0xe70b1b00), SPH_C32(0x71310000),
    SPH_C32(0x9a55368f), SPH_C32(0xdd0f8c60), SPH_C32(0x2507dda3),
    SPH_C32(0xe4460dc9) },
  { SPH_C32(0xe55c0000), SPH_C32(0x974c0000), SPH_C32(0x18ec0b80),
    SPH_C32(0x24ea0000), SPH_C32(0x7a5d4236), SPH_C32(0x42f51ab1),
    SPH_C32(0x72290ec7), SPH_C32(0x81549f44), SPH_C32(0x87af0000),
    SPH_C32(0x9ea10000), SPH_C32(0xbdb21c80), SPH_C32(0x4a610000),
    SPH_C32(0xd1852570), SPH_C32(0x5a94b878), SPH_C32(0x4c449562),
    SPH_C32(0x2e1c8a37) },
  { SPH_C32(0x29480000), SPH_C32(0x322f0000), SPH_C32(0x42550c00),
    SPH_C32(0x1fba0000), SPH_C32(0x318d51c9), SPH_C32(0xc56e2ea9),
    SPH_C32(0x1b6a4606), SPH_C32(0x4b0e18ba), SPH_C32(0x06310000),
    SPH_C32(0x72f60000), SPH_C32(0xdb801e00), SPH_C32(0xdf920000),
    SPH_C32(0x8c2c0d72), SPH_C32(0x126084c4), SPH_C32(0xaa1e374f),
    SPH_C32(0xa07b3dcd) },
  { SPH_C32(0xb2060000), SPH_C32(0xc5690000), SPH_C32(0x28031200),
    SPH_C32(0x74670000), SPH_C32(0xb6c236f4), SPH_C32(0xeb1239f8),
    SPH_C32(0x33d1dfec), SPH_C32(0x094e3198), SPH_C32(0xac480000),
    SPH_C32(0x1ba60000), SPH_C32(0x45fb1380), SPH_C32(0x03430000),
    SPH_C32(0x5a85316a), SPH_C32(0x1fb250b6), SPH_C32(0xfe72c7fe),
    SPH_C32(0x91e478f6) },
  { SPH_C32(0x7e120000), SPH_C32(0x600a0000), SPH_C32(0x72ba1580),
    SPH_C32(0x4f370000), SPH_C32(0xfd12250b), SPH_C32(0x6c890de0),
    SPH_C32(0x5a92972d), SPH_C32(0xc314b666), SPH_C32(0x2dd60000),
    SPH_C32(0xf7f10000), SPH_C32(0x23c91100), SPH_C32(0x96b00000),
    SPH_C32(0x072c1968), SPH_C32(0x57466c0a), SPH_C32(0x182865d3),
    SPH_C32(0x1f83cf0c) },
  { SPH_C32(0x33980000), SPH_C32(0x293e0000), SPH_C32(0x4e311080),
    SPH_C32(0xe1940000), SPH_C32(0xeb6b1ef6), SPH_C32(0xa3e60544),
    SPH_C32(0xd58b7dc1), SPH_C32(0x87298662), SPH_C32(0xe1c20000),
    SPH_C32(0x52920000), SPH_C32(0x79701680), SPH_C32(0xade00000),
    SPH_C32(0x4cfc0a97), SPH_C32(0xd0dd5812), SPH_C32(0x716b2d12),
    SPH_C32(0xd5d948f2) },
  { SPH_C32(0xff8c0000), SPH_C32(0x8c5d0000), SPH_C32(0x14881700),
    SPH_C32(0xdac40000), SPH_C32(0xa0bb0d09), SPH_C32(0x247d315c),
    SPH_C32(0xbcc83500), SPH_C32(0x4d73019c), SPH_C32(0x605c0000),
    SPH_C32(0xbec50000), SPH_C32(0x1f421400), SPH_C32(0x38130000),
    SPH_C32(0x11552295), SPH_C32(0x982964ae), SPH_C32(0x97318f3f),
    SPH_C32(0x5bbeff08) },
  { SPH_C32(0xca250000), SPH_C32(0xd7950000), SPH_C32(0x81391980),
    SPH_C32(0xe4c20000), SPH_C32(0xc7fc1e8d), SPH_C32(0x95fbb0dc),
    SPH_C32(0xc35d7f8e), SPH_C32(0x6a21ba33), SPH_C32(0xaee70000),
    SPH_C32(0xac8e0000), SPH_C32(0xffe71080), SPH_C32(0x55db0000),
    SPH_C32(0xe00874b9), SPH_C32(0x9ffa96d1), SPH_C32(0x572ed364),
    SPH_C32(0x6512928d) },
  { SPH_C32(0x06310000), SPH_C32(0x72f60000), SPH_C32(0xdb801e00),
    SPH_C32(0xdf920000), SPH_C32(0x8c2c0d72), SPH_C32(0x126084c4),
    SPH_C32(0xaa1e374f), SPH_C32(0xa07b3dcd), SPH_C32(0x2f790000),
    SPH_C32(0x40d90000), SPH_C32(0x99d51200), SPH_C32(0xc0280000),
    SPH_C32(0xbda15cbb), SPH_C32(0xd70eaa6d), SPH_C32(0xb1747149),
    SPH_C32(0xeb752577) },
  { SPH_C32(0x4bbb0000), SPH_C32(0x3bc20000), SPH_C32(0xe70b1b00),
    SPH_C32(0x71310000), SPH_C32(0x9a55368f), SPH_C32(0xdd0f8c60),
    SPH_C32(0x2507dda3), SPH_C32(0xe4460dc9), SPH_C32(0xe36d0000),
    SPH_C32(0xe5ba0000), SPH_C32(0xc36c1580), SPH_C32(0xfb780000),
    SPH_C32(0xf6714f44), SPH_C32(0x50959e75), SPH_C32(0xd8373988),
    SPH_C32(0x212fa289) },
  { SPH_C32(0x87af0000), SPH_C32(0x9ea10000), SPH_C32(0xbdb21c80),
    SPH_C32(0x4a610000), SPH_C32(0xd1852570), SPH_C32(0x5a94b878),
    SPH_C32(0x4c449562), SPH_C32(0x2e1c8a37), SPH_C32(0x62f30000),
    SPH_C32(0x09ed0000), SPH_C32(0xa55e1700), SPH_C32(0x6e8b0000),
    SPH_C32(0xabd86746), SPH_C32(0x1861a2c9), SPH_C32(0x3e6d9ba5),
    SPH_C32(0xaf481573) },
  { SPH_C32(0xb0a90000), SPH_C32(0x72410000), SPH_C32(0x921f1100),
    SPH_C32(0x22ff0000), SPH_C32(0x0c4f7327), SPH_C32(0x6b5aff9f),
    SPH_C32(0x9a8dcb76), SPH_C32(0xfdb8dbe3), SPH_C32(0xd6c40000),
    SPH_C32(0xbe720000), SPH_C32(0x56dd1b00), SPH_C32(0xc57e0000),
    SPH_C32(0x91365cc0), SPH_C32(0xe1131ff5), SPH_C32(0xa7a27306),
    SPH_C32(0x067d1926) },
  { SPH_C32(0x7cbd0000), SPH_C32(0xd7220000), SPH_C32(0xc8a61680),
    SPH_C32(0x19af0000), SPH_C32(0x479f60d8), SPH_C32(0xecc1cb87),
    SPH_C32(0xf3ce83b7), SPH_C32(0x37e25c1d), SPH_C32(0x575a0000),
    SPH_C32(0x52250000), SPH_C32(0x30ef1980), SPH_C32(0x508d0000),
    SPH_C32(0xcc9f74c2), SPH_C32(0xa9e72349), SPH_C32(0x41f8d12b),
    SPH_C32(0x881aaedc) },
  { SPH_C32(0x31370000), SPH_C32(0x9e160000), SPH_C32(0xf42d1380),
    SPH_C32(0xb70c0000), SPH_C32(0x51e65b25), SPH_C32(0x23aec323),
    SPH_C32(0x7cd7695b), SPH_C32(0x73df6c19), SPH_C32(0x9b4e0000),
    SPH_C32(0xf7460000), SPH_C32(0x6a561e00), SPH_C32(0x6bdd0000),
    SPH_C32(0x874f673d), SPH_C32(0x2e7c1751), SPH_C32(0x28bb99ea),
    SPH_C32(0x42402922) },
  { SPH_C32(0xfd230000), SPH_C32(0x3b750000), SPH_C32(0xae941400),
    SPH_C32(0x8c5c0000), SPH_C32(0x1a3648da), SPH_C32(0xa435f73b),
    SPH_C32(0x1594219a), SPH_C32(0xb985ebe7), SPH_C32(0x1ad00000),
    SPH_C32(0x1b110000), SPH_C32(0x0c641c80), SPH_C32(0xfe2e0000),
    SPH_C32(0xdae64f3f), SPH_C32(0x66882bed), SPH_C32(0xcee13bc7),
    SPH_C32(0xcc279ed8) },
  { SPH_C32(0xc88a0000), SPH_C32(0x60bd0000), SPH_C32(0x3b251a80),
    SPH_C32(0xb25a0000), SPH_C32(0x7d715b5e), SPH_C32(0x15b376bb),
    SPH_C32(0x6a016b14), SPH_C32(0x9ed75048), SPH_C32(0xd46b0000),
    SPH_C32(0x095a0000), SPH_C32(0xecc11800), SPH_C32(0x93e60000),
    SPH_C32(0x2bbb1913), SPH_C32(0x615bd992), SPH_C32(0x0efe679c),
    SPH_C32(0xf28bf35d) },
  { SPH_C32(0x049e0000), SPH_C32(0xc5de0000), SPH_C32(0x619c1d00),
    SPH_C32(0x890a0000), SPH_C32(0x36a148a1), SPH_C32(0x922842a3),
    SPH_C32(0x034223d5), SPH_C32(0x548dd7b6), SPH_C32(0x55f50000),
    SPH_C32(0xe50d0000), SPH_C32(0x8af31a80), SPH_C32(0x06150000),
    SPH_C32(0x76123111), SPH_C32(0x29afe52e), SPH_C32(0xe8a4c5b1),
    SPH_C32(0x7cec44a7) },
  { SPH_C32(0x49140000), SPH_C32(0x8cea0000), SPH_C32(0x5d171800),
    SPH_C32(0x27a90000), SPH_C32(0x20d8735c), SPH_C32(0x5d474a07),
    SPH_C32(0x8c5bc939), SPH_C32(0x10b0e7b2), SPH_C32(0x99e10000),
    SPH_C32(0x406e0000), SPH_C32(0xd04a1d00), SPH_C32(0x3d450000),
    SPH_C32(0x3dc222ee), SPH_C32(0xae34d136), SPH_C32(0x81e78d70),
    SPH_C32(0xb6b6c359) },
  { SPH_C32(0x85000000), SPH_C32(0x29890000), SPH_C32(0x07ae1f80),
    SPH_C32(0x1cf90000), SPH_C32(0x6b0860a3), SPH_C32(0xdadc7e1f),
    SPH_C32(0xe51881f8), SPH_C32(0xdaea604c), SPH_C32(0x187f0000),
    SPH_C32(0xac390000), SPH_C32(0xb6781f80), SPH_C32(0xa8b60000),
    SPH_C32(0x606b0aec), SPH_C32(0xe6c0ed8a), SPH_C32(0x67bd2f5d),
    SPH_C32(0x38d174a3) },
  { SPH_C32(0xaec30000), SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000),
    SPH_C32(0x2c150000), SPH_C32(0x45cc75b3), SPH_C32(0x6650b736),
    SPH_C32(0xab92f78f), SPH_C32(0xa312567b), SPH_C32(0xdb250000),
    SPH_C32(0x09290000), SPH_C32(0x49aac000), SPH_C32(0x81e10000),
    SPH_C32(0xcafe6b59), SPH_C32(0x42793431), SPH_C32(0x43566b76),
    SPH_C32(0xe86cba2e) },
  { SPH_C32(0x62d70000), SPH_C32(0x392c0001), SPH_C32(0x2368e780),
    SPH_C32(0x17450000), SPH_C32(0x0e1c664c), SPH_C32(0xe1cb832e),
    SPH_C32(0xc2d1bf4e), SPH_C32(0x6948d185), SPH_C32(0x5abb0000),
    SPH_C32(0xe57e0000), SPH_C32(0x2f98c280), SPH_C32(0x14120000),
    SPH_C32(0x9757435b), SPH_C32(0x0a8d088d), SPH_C32(0xa50cc95b),
    SPH_C32(0x660b0dd4) },
  { SPH_C32(0x2f5d0000), SPH_C32(0x70180001), SPH_C32(0x1fe3e280),
    SPH_C32(0xb9e60000), SPH_C32(0x18655db1), SPH_C32(0x2ea48b8a),
    SPH_C32(0x4dc855a2), SPH_C32(0x2d75e181), SPH_C32(0x96af0000),
    SPH_C32(0x401d0000), SPH_C32(0x7521c500), SPH_C32(0x2f420000),
    SPH_C32(0xdc8750a4), SPH_C32(0x8d163c95), SPH_C32(0xcc4f819a),
    SPH_C32(0xac518a2a) },
  { SPH_C32(0xe3490000), SPH_C32(0xd57b0001), SPH_C32(0x455ae500),
    SPH_C32(0x82b60000), SPH_C32(0x53b54e4e), SPH_C32(0xa93fbf92),
    SPH_C32(0x248b1d63), SPH_C32(0xe72f667f), SPH_C32(0x17310000),
    SPH_C32(0xac4a0000), SPH_C32(0x1313c780), SPH_C32(0xbab10000),
    SPH_C32(0x812e78a6), SPH_C32(0xc5e20029), SPH_C32(0x2a1523b7),
    SPH_C32(0x22363dd0) },
  { SPH_C32(0xd6e00000), SPH_C32(0x8eb30001), SPH_C32(0xd0ebeb80),
    SPH_C32(0xbcb00000), SPH_C32(0x34f25dca), SPH_C32(0x18b93e12),
    SPH_C32(0x5b1e57ed), SPH_C32(0xc07dddd0), SPH_C32(0xd98a0000),
    SPH_C32(0xbe010000), SPH_C32(0xf3b6c300), SPH_C32(0xd7790000),
    SPH_C32(0x70732e8a), SPH_C32(0xc231f256), SPH_C32(0xea0a7fec),
    SPH_C32(0x1c9a5055) },
  { SPH_C32(0x1af40000), SPH_C32(0x2bd00001), SPH_C32(0x8a52ec00),
    SPH_C32(0x87e00000), SPH_C32(0x7f224e35), SPH_C32(0x9f220a0a),
    SPH_C32(0x325d1f2c), SPH_C32(0x0a275a2e), SPH_C32(0x58140000),
    SPH_C32(0x52560000), SPH_C32(0x9584c180), SPH_C32(0x428a0000),
    SPH_C32(0x2dda0688), SPH_C32(0x8ac5ceea), SPH_C32(0x0c50ddc1),
    SPH_C32(0x92fde7af) },
  { SPH_C32(0x577e0000), SPH_C32(0x62e40001), SPH_C32(0xb6d9e900),
    SPH_C32(0x29430000), SPH_C32(0x695b75c8), SPH_C32(0x504d02ae),
    SPH_C32(0xbd44f5c0), SPH_C32(0x4e1a6a2a), SPH_C32(0x94000000),
    SPH_C32(0xf7350000), SPH_C32(0xcf3dc600), SPH_C32(0x79da0000),
    SPH_C32(0x660a1577), SPH_C32(0x0d5efaf2), SPH_C32(0x65139500),
    SPH_C32(0x58a76051) },
  { SPH_C32(0x9b6a0000), SPH_C32(0xc7870001), SPH_C32(0xec60ee80),
    SPH_C32(0x12130000), SPH_C32(0x228b6637), SPH_C32(0xd7d636b6),
    SPH_C32(0xd407bd01), SPH_C32(0x8440edd4), SPH_C32(0x159e0000),
    SPH_C32(0x1b620000), SPH_C32(0xa90fc480), SPH_C32(0xec290000),
    SPH_C32(0x3ba33d75), SPH_C32(0x45aac64e), SPH_C32(0x8349372d),
    SPH_C32(0xd6c0d7ab) },
  { SPH_C32(0xac6c0000), SPH_C32(0x2b670001), SPH_C32(0xc3cde300),
    SPH_C32(0x7a8d0000), SPH_C32(0xff413060), SPH_C32(0xe6187151),
    SPH_C32(0x02cee315), SPH_C32(0x57e4bc00), SPH_C32(0xa1a90000),
    SPH_C32(0xacfd0000), SPH_C32(0x5a8cc880), SPH_C32(0x47dc0000),
    SPH_C32(0x014d06f3), SPH_C32(0xbcd87b72), SPH_C32(0x1a86df8e),
    SPH_C32(0x7ff5dbfe) },
  { SPH_C32(0x60780000), SPH_C32(0x8e040001), SPH_C32(0x9974e480),
    SPH_C32(0x41dd0000), SPH_C32(0xb491239f), SPH_C32(0x61834549),
    SPH_C32(0x6b8dabd4), SPH_C32(0x9dbe3bfe), SPH_C32(0x20370000),
    SPH_C32(0x40aa0000), SPH_C32(0x3cbeca00), SPH_C32(0xd22f0000),
    SPH_C32(0x5ce42ef1), SPH_C32(0xf42c47ce), SPH_C32(0xfcdc7da3),
    SPH_C32(0xf1926c04) },
  { SPH_C32(0x2df20000), SPH_C32(0xc7300001), SPH_C32(0xa5ffe180),
    SPH_C32(0xef7e0000), SPH_C32(0xa2e81862), SPH_C32(0xaeec4ded),
    SPH_C32(0xe4944138), SPH_C32(0xd9830bfa), SPH_C32(0xec230000),
    SPH_C32(0xe5c90000), SPH_C32(0x6607cd80), SPH_C32(0xe97f0000),
    SPH_C32(0x17343d0e), SPH_C32(0x73b773d6), SPH_C32(0x959f3562),
    SPH_C32(0x3bc8ebfa) },
  { SPH_C32(0xe1e60000), SPH_C32(0x62530001), SPH_C32(0xff46e600),
    SPH_C32(0xd42e0000), SPH_C32(0xe9380b9d), SPH_C32(0x297779f5),
    SPH_C32(0x8dd709f9), SPH_C32(0x13d98c04), SPH_C32(0x6dbd0000),
    SPH_C32(0x099e0000), SPH_C32(0x0035cf00), SPH_C32(0x7c8c0000),
    SPH_C32(0x4a9d150c), SPH_C32(0x3b434f6a), SPH_C32(0x73c5974f),
    SPH_C32(0xb5af5c00) },
  { SPH_C32(0xd44f0000), SPH_C32(0x399b0001), SPH_C32(0x6af7e880),
    SPH_C32(0xea280000), SPH_C32(0x8e7f1819), SPH_C32(0x98f1f875),
    SPH_C32(0xf2424377), SPH_C32(0x348b37ab), SPH_C32(0xa3060000),
    SPH_C32(0x1bd50000), SPH_C32(0xe090cb80), SPH_C32(0x11440000),
    SPH_C32(0xbbc04320), SPH_C32(0x3c90bd15), SPH_C32(0xb3dacb14),
    SPH_C32(0x8b033185) },
  { SPH_C32(0x185b0000), SPH_C32(0x9cf80001), SPH_C32(0x304eef00),
    SPH_C32(0xd1780000), SPH_C32(0xc5af0be6), SPH_C32(0x1f6acc6d),
    SPH_C32(0x9b010bb6), SPH_C32(0xfed1b055), SPH_C32(0x22980000),
    SPH_C32(0xf7820000), SPH_C32(0x86a2c900), SPH_C32(0x84b70000),
    SPH_C32(0xe6696b22), SPH_C32(0x746481a9), SPH_C32(0x55806939),
    SPH_C32(0x0564867f) },
  { SPH_C32(0x55d10000), SPH_C32(0xd5cc0001), SPH_C32(0x0cc5ea00),
    SPH_C32(0x7fdb0000), SPH_C32(0xd3d6301b), SPH_C32(0xd005c4c9),
    SPH_C32(0x1418e15a), SPH_C32(0xbaec8051), SPH_C32(0xee8c0000),
    SPH_C32(0x52e10000), SPH_C32(0xdc1bce80), SPH_C32(0xbfe70000),
    SPH_C32(0xadb978dd), SPH_C32(0xf3ffb5b1), SPH_C32(0x3cc321f8),
    SPH_C32(0xcf3e0181) },
  { SPH_C32(0x99c50000), SPH_C32(0x70af0001), SPH_C32(0x567ced80),
    SPH_C32(0x448b0000), SPH_C32(0x980623e4), SPH_C32(0x579ef0d1),
    SPH_C32(0x7d5ba99b), SPH_C32(0x70b607af), SPH_C32(0x6f120000),
    SPH_C32(0xbeb60000), SPH_C32(0xba29cc00), SPH_C32(0x2a140000),
    SPH_C32(0xf01050df), SPH_C32(0xbb0b890d), SPH_C32(0xda9983d5),
    SPH_C32(0x4159b67b) },
  { SPH_C32(0x028b0000), SPH_C32(0x87e90001), SPH_C32(0x3c2af380),
    SPH_C32(0x2f560000), SPH_C32(0x1f4944d9), SPH_C32(0x79e2e780),
    SPH_C32(0x55e03071), SPH_C32(0x32f62e8d), SPH_C32(0xc56b0000),
    SPH_C32(0xd7e60000), SPH_C32(0x2452c180), SPH_C32(0xf6c50000),
    SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f), SPH_C32(0x8ef57364),
    SPH_C32(0x70c6f340) },
  { SPH_C32(0xce9f0000), SPH_C32(0x228a0001), SPH_C32(0x6693f400),
    SPH_C32(0x14060000), SPH_C32(0x54995726), SPH_C32(0xfe79d398),
    SPH_C32(0x3ca378b0), SPH_C32(0xf8aca973), SPH_C32(0x44f50000),
    SPH_C32(0x3bb10000), SPH_C32(0x4260c300), SPH_C32(0x63360000),
    SPH_C32(0x7b1044c5), SPH_C32(0xfe2d61c3), SPH_C32(0x68afd149),
    SPH_C32(0xfea144ba) },
  { SPH_C32(0x83150000), SPH_C32(0x6bbe0001), SPH_C32(0x5a18f100),
    SPH_C32(0xbaa50000), SPH_C32(0x42e06cdb), SPH_C32(0x3116db3c),
    SPH_C32(0xb3ba925c), SPH_C32(0xbc919977), SPH_C32(0x88e10000),
    SPH_C32(0x9ed20000), SPH_C32(0x18d9c480), SPH_C32(0x58660000),
    SPH_C32(0x30c0573a), SPH_C32(0x79b655db), SPH_C32(0x01ec9988),
    SPH_C32(0x34fbc344) },
  { SPH_C32(0x4f010000), SPH_C32(0xcedd0001), SPH_C32(0x00a1f680),
    SPH_C32(0x81f50000), SPH_C32(0x09307f24), SPH_C32(0xb68def24),
    SPH_C32(0xdaf9da9d), SPH_C32(0x76cb1e89), SPH_C32(0x097f0000),
    SPH_C32(0x72850000), SPH_C32(0x7eebc600), SPH_C32(0xcd950000),
    SPH_C32(0x6d697f38), SPH_C32(0x31426967), SPH_C32(0xe7b63ba5),
    SPH_C32(0xba9c74be) },
  { SPH_C32(0x7aa80000), SPH_C32(0x95150001), SPH_C32(0x9510f800),
    SPH_C32(0xbff30000), SPH_C32(0x6e776ca0), SPH_C32(0x070b6ea4),
    SPH_C32(0xa56c9013), SPH_C32(0x5199a526), SPH_C32(0xc7c40000),
    SPH_C32(0x60ce0000), SPH_C32(0x9e4ec280), SPH_C32(0xa05d0000),
    SPH_C32(0x9c342914), SPH_C32(0x36919b18), SPH_C32(0x27a967fe),
    SPH_C32(0x8430193b) },
  { SPH_C32(0xb6bc0000), SPH_C32(0x30760001), SPH_C32(0xcfa9ff80),
    SPH_C32(0x84a30000), SPH_C32(0x25a77f5f), SPH_C32(0x80905abc),
    SPH_C32(0xcc2fd8d2), SPH_C32(0x9bc322d8), SPH_C32(0x465a0000),
    SPH_C32(0x8c990000), SPH_C32(0xf87cc000), SPH_C32(0x35ae0000),
    SPH_C32(0xc19d0116), SPH_C32(0x7e65a7a4), SPH_C32(0xc1f3c5d3),
    SPH_C32(0x0a57aec1) },
  { SPH_C32(0xfb360000), SPH_C32(0x79420001), SPH_C32(0xf322fa80),
    SPH_C32(0x2a000000), SPH_C32(0x33de44a2), SPH_C32(0x4fff5218),
    SPH_C32(0x4336323e), SPH_C32(0xdffe12dc), SPH_C32(0x8a4e0000),
    SPH_C32(0x29fa0000), SPH_C32(0xa2c5c780), SPH_C32(0x0efe0000),
    SPH_C32(0x8a4d12e9), SPH_C32(0xf9fe93bc), SPH_C32(0xa8b08d12),
    SPH_C32(0xc00d293f) },
  { SPH_C32(0x37220000), SPH_C32(0xdc210001), SPH_C32(0xa99bfd00),
    SPH_C32(0x11500000), SPH_C32(0x780e575d), SPH_C32(0xc8646600),
    SPH_C32(0x2a757aff), SPH_C32(0x15a49522), SPH_C32(0x0bd00000),
    SPH_C32(0xc5ad0000), SPH_C32(0xc4f7c500), SPH_C32(0x9b0d0000),
    SPH_C32(0xd7e43aeb), SPH_C32(0xb10aaf00), SPH_C32(0x4eea2f3f),
    SPH_C32(0x4e6a9ec5) },
  { SPH_C32(0x00240000), SPH_C32(0x30c10001), SPH_C32(0x8636f080),
    SPH_C32(0x79ce0000), SPH_C32(0xa5c4010a), SPH_C32(0xf9aa21e7),
    SPH_C32(0xfcbc24eb), SPH_C32(0xc600c4f6), SPH_C32(0xbfe70000),
    SPH_C32(0x72320000), SPH_C32(0x3774c900), SPH_C32(0x30f80000),
    SPH_C32(0xed0a016d), SPH_C32(0x4878123c), SPH_C32(0xd725c79c),
    SPH_C32(0xe75f9290) },
  { SPH_C32(0xcc300000), SPH_C32(0x95a20001), SPH_C32(0xdc8ff700),
    SPH_C32(0x429e0000), SPH_C32(0xee1412f5), SPH_C32(0x7e3115ff),
    SPH_C32(0x95ff6c2a), SPH_C32(0x0c5a4308), SPH_C32(0x3e790000),
    SPH_C32(0x9e650000), SPH_C32(0x5146cb80), SPH_C32(0xa50b0000),
    SPH_C32(0xb0a3296f), SPH_C32(0x008c2e80), SPH_C32(0x317f65b1),
    SPH_C32(0x6938256a) },
  { SPH_C32(0x81ba0000), SPH_C32(0xdc960001), SPH_C32(0xe004f200),
    SPH_C32(0xec3d0000), SPH_C32(0xf86d2908), SPH_C32(0xb15e1d5b),
    SPH_C32(0x1ae686c6), SPH_C32(0x4867730c), SPH_C32(0xf26d0000),
    SPH_C32(0x3b060000), SPH_C32(0x0bffcc00), SPH_C32(0x9e5b0000),
    SPH_C32(0xfb733a90), SPH_C32(0x87171a98), SPH_C32(0x583c2d70),
    SPH_C32(0xa362a294) },
  { SPH_C32(0x4dae0000), SPH_C32(0x79f50001), SPH_C32(0xbabdf580),
    SPH_C32(0xd76d0000), SPH_C32(0xb3bd3af7), SPH_C32(0x36c52943),
    SPH_C32(0x73a5ce07), SPH_C32(0x823df4f2), SPH_C32(0x73f30000),
    SPH_C32(0xd7510000), SPH_C32(0x6dcdce80), SPH_C32(0x0ba80000),
    SPH_C32(0xa6da1292), SPH_C32(0xcfe32624), SPH_C32(0xbe668f5d),
    SPH_C32(0x2d05156e) },
  { SPH_C32(0x78070000), SPH_C32(0x223d0001), SPH_C32(0x2f0cfb00),
    SPH_C32(0xe96b0000), SPH_C32(0xd4fa2973), SPH_C32(0x8743a8c3),
    SPH_C32(0x0c308489), SPH_C32(0xa56f4f5d), SPH_C32(0xbd480000),
    SPH_C32(0xc51a0000), SPH_C32(0x8d68ca00), SPH_C32(0x66600000),
    SPH_C32(0x578744be), SPH_C32(0xc830d45b), SPH_C32(0x7e79d306),
    SPH_C32(0x13a978eb) },
  { SPH_C32(0xb4130000), SPH_C32(0x875e0001), SPH_C32(0x75b5fc80),
    SPH_C32(0xd23b0000), SPH_C32(0x9f2a3a8c), SPH_C32(0x00d89cdb),
    SPH_C32(0x6573cc48), SPH_C32(0x6f35c8a3), SPH_C32(0x3cd60000),
    SPH_C32(0x294d0000), SPH_C32(0xeb5ac880), SPH_C32(0xf3930000),
    SPH_C32(0x0a2e6cbc), SPH_C32(0x80c4e8e7), SPH_C32(0x9823712b),
    SPH_C32(0x9dcecf11) },
  { SPH_C32(0xf9990000), SPH_C32(0xce6a0001), SPH_C32(0x493ef980),
    SPH_C32(0x7c980000), SPH_C32(0x89530171), SPH_C32(0xcfb7947f),
    SPH_C32(0xea6a26a4), SPH_C32(0x2b08f8a7), SPH_C32(0xf0c20000),
    SPH_C32(0x8c2e0000), SPH_C32(0xb1e3cf00), SPH_C32(0xc8c30000),
    SPH_C32(0x41fe7f43), SPH_C32(0x075fdcff), SPH_C32(0xf16039ea),
    SPH_C32(0x579448ef) },
  { SPH_C32(0x358d0000), SPH_C32(0x6b090001), SPH_C32(0x1387fe00),
    SPH_C32(0x47c80000), SPH_C32(0xc283128e), SPH_C32(0x482ca067),
    SPH_C32(0x83296e65), SPH_C32(0xe1527f59), SPH_C32(0x715c0000),
    SPH_C32(0x60790000), SPH_C32(0xd7d1cd80), SPH_C32(0x5d300000),
    SPH_C32(0x1c575741), SPH_C32(0x4fabe043), SPH_C32(0x173a9bc7),
    SPH_C32(0xd9f3ff15) },
  { SPH_C32(0xb08d0000), SPH_C32(0x42800001), SPH_C32(0x1429e180),
    SPH_C32(0x5b310000), SPH_C32(0xa98b722d), SPH_C32(0x92f0de78),
    SPH_C32(0x6631ef9d), SPH_C32(0x3bb81f15), SPH_C32(0x69230000),
    SPH_C32(0xcc400000), SPH_C32(0x61a9d200), SPH_C32(0xf5860000),
    SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9), SPH_C32(0x7087b49a),
    SPH_C32(0xe1228bb6) },
  { SPH_C32(0x7c990000), SPH_C32(0xe7e30001), SPH_C32(0x4e90e600),
    SPH_C32(0x60610000), SPH_C32(0xe25b61d2), SPH_C32(0x156bea60),
    SPH_C32(0x0f72a75c), SPH_C32(0xf1e298eb), SPH_C32(0xe8bd0000),
    SPH_C32(0x20170000), SPH_C32(0x079bd080), SPH_C32(0x60750000),
    SPH_C32(0x219575af), SPH_C32(0xe19f3175), SPH_C32(0x96dd16b7),
    SPH_C32(0x6f453c4c) },
  { SPH_C32(0x31130000), SPH_C32(0xaed70001), SPH_C32(0x721be300),
    SPH_C32(0xcec20000), SPH_C32(0xf4225a2f), SPH_C32(0xda04e2c4),
    SPH_C32(0x806b4db0), SPH_C32(0xb5dfa8ef), SPH_C32(0x24a90000),
    SPH_C32(0x85740000), SPH_C32(0x5d22d700), SPH_C32(0x5b250000),
    SPH_C32(0x6a456650), SPH_C32(0x6604056d), SPH_C32(0xff9e5e76),
    SPH_C32(0xa51fbbb2) },
  { SPH_C32(0xfd070000), SPH_C32(0x0bb40001), SPH_C32(0x28a2e480),
    SPH_C32(0xf5920000), SPH_C32(0xbff249d0), SPH_C32(0x5d9fd6dc),
    SPH_C32(0xe9280571), SPH_C32(0x7f852f11), SPH_C32(0xa5370000),
    SPH_C32(0x69230000), SPH_C32(0x3b10d580), SPH_C32(0xced60000),
    SPH_C32(0x37ec4e52), SPH_C32(0x2ef039d1), SPH_C32(0x19c4fc5b),
    SPH_C32(0x2b780c48) },
  { SPH_C32(0xc8ae0000), SPH_C32(0x507c0001), SPH_C32(0xbd13ea00),
    SPH_C32(0xcb940000), SPH_C32(0xd8b55a54), SPH_C32(0xec19575c),
    SPH_C32(0x96bd4fff), SPH_C32(0x58d794be), SPH_C32(0x6b8c0000),
    SPH_C32(0x7b680000), SPH_C32(0xdbb5d100), SPH_C32(0xa31e0000),
    SPH_C32(0xc6b1187e), SPH_C32(0x2923cbae), SPH_C32(0xd9dba000),
    SPH_C32(0x15d461cd) },
  { SPH_C32(0x04ba0000), SPH_C32(0xf51f0001), SPH_C32(0xe7aaed80),
    SPH_C32(0xf0c40000), SPH_C32(0x936549ab), SPH_C32(0x6b826344),
    SPH_C32(0xfffe073e), SPH_C32(0x928d1340), SPH_C32(0xea120000),
    SPH_C32(0x973f0000), SPH_C32(0xbd87d380), SPH_C32(0x36ed0000),
    SPH_C32(0x9b18307c), SPH_C32(0x61d7f712), SPH_C32(0x3f81022d),
    SPH_C32(0x9bb3d637) },
  { SPH_C32(0x49300000), SPH_C32(0xbc2b0001), SPH_C32(0xdb21e880),
    SPH_C32(0x5e670000), SPH_C32(0x851c7256), SPH_C32(0xa4ed6be0),
    SPH_C32(0x70e7edd2), SPH_C32(0xd6b02344), SPH_C32(0x26060000),
    SPH_C32(0x325c0000), SPH_C32(0xe73ed400), SPH_C32(0x0dbd0000),
    SPH_C32(0xd0c82383), SPH_C32(0xe64cc30a), SPH_C32(0x56c24aec),
    SPH_C32(0x51e951c9) },
  { SPH_C32(0x85240000), SPH_C32(0x19480001), SPH_C32(0x8198ef00),
    SPH_C32(0x65370000), SPH_C32(0xcecc61a9), SPH_C32(0x23765ff8),
    SPH_C32(0x19a4a513), SPH_C32(0x1ceaa4ba), SPH_C32(0xa7980000),
    SPH_C32(0xde0b0000), SPH_C32(0x810cd680), SPH_C32(0x984e0000),
    SPH_C32(0x8d610b81), SPH_C32(0xaeb8ffb6), SPH_C32(0xb098e8c1),
    SPH_C32(0xdf8ee633) },
  { SPH_C32(0xb2220000), SPH_C32(0xf5a80001), SPH_C32(0xae35e280),
    SPH_C32(0x0da90000), SPH_C32(0x130637fe), SPH_C32(0x12b8181f),
    SPH_C32(0xcf6dfb07), SPH_C32(0xcf4ef56e), SPH_C32(0x13af0000),
    SPH_C32(0x69940000), SPH_C32(0x728fda80), SPH_C32(0x33bb0000),
    SPH_C32(0xb78f3007), SPH_C32(0x57ca428a), SPH_C32(0x29570062),
    SPH_C32(0x76bbea66) },
  { SPH_C32(0x7e360000), SPH_C32(0x50cb0001), SPH_C32(0xf48ce500),
    SPH_C32(0x36f90000), SPH_C32(0x58d62401), SPH_C32(0x95232c07),
    SPH_C32(0xa62eb3c6), SPH_C32(0x05147290), SPH_C32(0x92310000),
    SPH_C32(0x85c30000), SPH_C32(0x14bdd800), SPH_C32(0xa6480000),
    SPH_C32(0xea261805), SPH_C32(0x1f3e7e36), SPH_C32(0xcf0da24f),
    SPH_C32(0xf8dc5d9c) },
  { SPH_C32(0x33bc0000), SPH_C32(0x19ff0001), SPH_C32(0xc807e000),
    SPH_C32(0x985a0000), SPH_C32(0x4eaf1ffc), SPH_C32(0x5a4c24a3),
    SPH_C32(0x2937592a), SPH_C32(0x41294294), SPH_C32(0x5e250000),
    SPH_C32(0x20a00000), SPH_C32(0x4e04df80), SPH_C32(0x9d180000),
    SPH_C32(0xa1f60bfa), SPH_C32(0x98a54a2e), SPH_C32(0xa64eea8e),
    SPH_C32(0x3286da62) },
  { SPH_C32(0xffa80000), SPH_C32(0xbc9c0001), SPH_C32(0x92bee780),
    SPH_C32(0xa30a0000), SPH_C32(0x057f0c03), SPH_C32(0xddd710bb),
    SPH_C32(0x407411eb), SPH_C32(0x8b73c56a), SPH_C32(0xdfbb0000),
    SPH_C32(0xccf70000), SPH_C32(0x2836dd00), SPH_C32(0x08eb0000),
    SPH_C32(0xfc5f23f8), SPH_C32(0xd0517692), SPH_C32(0x401448a3),
    SPH_C32(0xbce16d98) },
  { SPH_C32(0xca010000), SPH_C32(0xe7540001), SPH_C32(0x070fe900),
    SPH_C32(0x9d0c0000), SPH_C32(0x62381f87), SPH_C32(0x6c51913b),
    SPH_C32(0x3fe15b65), SPH_C32(0xac217ec5), SPH_C32(0x11000000),
    SPH_C32(0xdebc0000), SPH_C32(0xc893d980), SPH_C32(0x65230000),
    SPH_C32(0x0d0275d4), SPH_C32(0xd78284ed), SPH_C32(0x800b14f8),
    SPH_C32(0x824d001d) },
  { SPH_C32(0x06150000), SPH_C32(0x42370001), SPH_C32(0x5db6ee80),
    SPH_C32(0xa65c0000), SPH_C32(0x29e80c78), SPH_C32(0xebcaa523),
    SPH_C32(0x56a213a4), SPH_C32(0x667bf93b), SPH_C32(0x909e0000),
    SPH_C32(0x32eb0000), SPH_C32(0xaea1db00), SPH_C32(0xf0d00000),
    SPH_C32(0x50ab5dd6), SPH_C32(0x9f76b851), SPH_C32(0x6651b6d5),
    SPH_C32(0x0c2ab7e7) },
  { SPH_C32(0x4b9f0000), SPH_C32(0x0b030001), SPH_C32(0x613deb80),
    SPH_C32(0x08ff0000), SPH_C32(0x3f913785), SPH_C32(0x24a5ad87),
    SPH_C32(0xd9bbf948), SPH_C32(0x2246c93f), SPH_C32(0x5c8a0000),
    SPH_C32(0x97880000), SPH_C32(0xf418dc80), SPH_C32(0xcb800000),
    SPH_C32(0x1b7b4e29), SPH_C32(0x18ed8c49), SPH_C32(0x0f12fe14),
    SPH_C32(0xc6703019) },
  { SPH_C32(0x878b0000), SPH_C32(0xae600001), SPH_C32(0x3b84ec00),
    SPH_C32(0x33af0000), SPH_C32(0x7441247a), SPH_C32(0xa33e999f),
    SPH_C32(0xb0f8b189), SPH_C32(0xe81c4ec1), SPH_C32(0xdd140000),
    SPH_C32(0x7bdf0000), SPH_C32(0x922ade00), SPH_C32(0x5e730000),
    SPH_C32(0x46d2662b), SPH_C32(0x5019b0f5), SPH_C32(0xe9485c39),
    SPH_C32(0x481787e3) },
  { SPH_C32(0x1cc50000), SPH_C32(0x59260001), SPH_C32(0x51d2f200),
    SPH_C32(0x58720000), SPH_C32(0xf30e4347), SPH_C32(0x8d428ece),
    SPH_C32(0x98432863), SPH_C32(0xaa5c67e3), SPH_C32(0x776d0000),
    SPH_C32(0x128f0000), SPH_C32(0x0c51d380), SPH_C32(0x82a20000),
    SPH_C32(0x907b5a33), SPH_C32(0x5dcb6487), SPH_C32(0xbd24ac88),
    SPH_C32(0x7988c2d8) },
  { SPH_C32(0xd0d10000), SPH_C32(0xfc450001), SPH_C32(0x0b6bf580),
    SPH_C32(0x63220000), SPH_C32(0xb8de50b8), SPH_C32(0x0ad9bad6),
    SPH_C32(0xf10060a2), SPH_C32(0x6006e01d), SPH_C32(0xf6f30000),
    SPH_C32(0xfed80000), SPH_C32(0x6a63d100), SPH_C32(0x17510000),
    SPH_C32(0xcdd27231), SPH_C32(0x153f583b), SPH_C32(0x5b7e0ea5),
    SPH_C32(0xf7ef7522) },
  { SPH_C32(0x9d5b0000), SPH_C32(0xb5710001), SPH_C32(0x37e0f080),
    SPH_C32(0xcd810000), SPH_C32(0xaea76b45), SPH_C32(0xc5b6b272),
    SPH_C32(0x7e198a4e), SPH_C32(0x243bd019), SPH_C32(0x3ae70000),
    SPH_C32(0x5bbb0000), SPH_C32(0x30dad680), SPH_C32(0x2c010000),
    SPH_C32(0x860261ce), SPH_C32(0x92a46c23), SPH_C32(0x323d4664),
    SPH_C32(0x3db5f2dc) },
  { SPH_C32(0x514f0000), SPH_C32(0x10120001), SPH_C32(0x6d59f700),
    SPH_C32(0xf6d10000), SPH_C32(0xe57778ba), SPH_C32(0x422d866a),
    SPH_C32(0x175ac28f), SPH_C32(0xee6157e7), SPH_C32(0xbb790000),
    SPH_C32(0xb7ec0000), SPH_C32(0x56e8d400), SPH_C32(0xb9f20000),
    SPH_C32(0xdbab49cc), SPH_C32(0xda50509f), SPH_C32(0xd467e449),
    SPH_C32(0xb3d24526) },
  { SPH_C32(0x64e60000), SPH_C32(0x4bda0001), SPH_C32(0xf8e8f980),
    SPH_C32(0xc8d70000), SPH_C32(0x82306b3e), SPH_C32(0xf3ab07ea),
    SPH_C32(0x68cf8801), SPH_C32(0xc933ec48), SPH_C32(0x75c20000),
    SPH_C32(0xa5a70000), SPH_C32(0xb64dd080), SPH_C32(0xd43a0000),
    SPH_C32(0x2af61fe0), SPH_C32(0xdd83a2e0), SPH_C32(0x1478b812),
    SPH_C32(0x8d7e28a3) },
  { SPH_C32(0xa8f20000), SPH_C32(0xeeb90001), SPH_C32(0xa251fe00),
    SPH_C32(0xf3870000), SPH_C32(0xc9e078c1), SPH_C32(0x743033f2),
    SPH_C32(0x018cc0c0), SPH_C32(0x03696bb6), SPH_C32(0xf45c0000),
    SPH_C32(0x49f00000), SPH_C32(0xd07fd200), SPH_C32(0x41c90000),
    SPH_C32(0x775f37e2), SPH_C32(0x95779e5c), SPH_C32(0xf2221a3f),
    SPH_C32(0x03199f59) },
  { SPH_C32(0xe5780000), SPH_C32(0xa78d0001), SPH_C32(0x9edafb00),
    SPH_C32(0x5d240000), SPH_C32(0xdf99433c), SPH_C32(0xbb5f3b56),
    SPH_C32(0x8e952a2c), SPH_C32(0x47545bb2), SPH_C32(0x38480000),
    SPH_C32(0xec930000), SPH_C32(0x8ac6d580), SPH_C32(0x7a990000),
    SPH_C32(0x3c8f241d), SPH_C32(0x12ecaa44), SPH_C32(0x9b6152fe),
    SPH_C32(0xc94318a7) },
  { SPH_C32(0x296c0000), SPH_C32(0x02ee0001), SPH_C32(0xc463fc80),
    SPH_C32(0x66740000), SPH_C32(0x944950c3), SPH_C32(0x3cc40f4e),
    SPH_C32(0xe7d662ed), SPH_C32(0x8d0edc4c), SPH_C32(0xb9d60000),
    SPH_C32(0x00c40000), SPH_C32(0xecf4d700), SPH_C32(0xef6a0000),
    SPH_C32(0x61260c1f), SPH_C32(0x5a1896f8), SPH_C32(0x7d3bf0d3),
    SPH_C32(0x4724af5d) },
  { SPH_C32(0x1e6a0000), SPH_C32(0xee0e0001), SPH_C32(0xebcef100),
    SPH_C32(0x0eea0000), SPH_C32(0x49830694), SPH_C32(0x0d0a48a9),
    SPH_C32(0x311f3cf9), SPH_C32(0x5eaa8d98), SPH_C32(0x0de10000),
    SPH_C32(0xb75b0000), SPH_C32(0x1f77db00), SPH_C32(0x449f0000),
    SPH_C32(0x5bc83799), SPH_C32(0xa36a2bc4), SPH_C32(0xe4f41870),
    SPH_C32(0xee11a308) },
  { SPH_C32(0xd27e0000), SPH_C32(0x4b6d0001), SPH_C32(0xb177f680),
    SPH_C32(0x35ba0000), SPH_C32(0x0253156b), SPH_C32(0x8a917cb1),
    SPH_C32(0x585c7438), SPH_C32(0x94f00a66), SPH_C32(0x8c7f0000),
    SPH_C32(0x5b0c0000), SPH_C32(0x7945d980), SPH_C32(0xd16c0000),
    SPH_C32(0x06611f9b), SPH_C32(0xeb9e1778), SPH_C32(0x02aeba5d),
    SPH_C32(0x607614f2) },
  { SPH_C32(0x9ff40000), SPH_C32(0x02590001), SPH_C32(0x8dfcf380),
    SPH_C32(0x9b190000), SPH_C32(0x142a2e96), SPH_C32(0x45fe7415),
    SPH_C32(0xd7459ed4), SPH_C32(0xd0cd3a62), SPH_C32(0x406b0000),
    SPH_C32(0xfe6f0000), SPH_C32(0x23fcde00), SPH_C32(0xea3c0000),
    SPH_C32(0x4db10c64), SPH_C32(0x6c052360), SPH_C32(0x6bedf29c),
    SPH_C32(0xaa2c930c) },
  { SPH_C32(0x53e00000), SPH_C32(0xa73a0001), SPH_C32(0xd745f400),
    SPH_C32(0xa0490000), SPH_C32(0x5ffa3d69), SPH_C32(0xc265400d),
    SPH_C32(0xbe06d615), SPH_C32(0x1a97bd9c), SPH_C32(0xc1f50000),
    SPH_C32(0x12380000), SPH_C32(0x45cedc80), SPH_C32(0x7fcf0000),
    SPH_C32(0x10182466), SPH_C32(0x24f11fdc), SPH_C32(0x8db750b1),
    SPH_C32(0x244b24f6) },
  { SPH_C32(0x66490000), SPH_C32(0xfcf20001), SPH_C32(0x42f4fa80),
    SPH_C32(0x9e4f0000), SPH_C32(0x38bd2eed), SPH_C32(0x73e3c18d),
    SPH_C32(0xc1939c9b), SPH_C32(0x3dc50633), SPH_C32(0x0f4e0000),
    SPH_C32(0x00730000), SPH_C32(0xa56bd800), SPH_C32(0x12070000),
    SPH_C32(0xe145724a), SPH_C32(0x2322eda3), SPH_C32(0x4da80cea),
    SPH_C32(0x1ae74973) },
  { SPH_C32(0xaa5d0000), SPH_C32(0x59910001), SPH_C32(0x184dfd00),
    SPH_C32(0xa51f0000), SPH_C32(0x736d3d12), SPH_C32(0xf478f595),
    SPH_C32(0xa8d0d45a), SPH_C32(0xf79f81cd), SPH_C32(0x8ed00000),
    SPH_C32(0xec240000), SPH_C32(0xc359da80), SPH_C32(0x87f40000),
    SPH_C32(0xbcec5a48), SPH_C32(0x6bd6d11f), SPH_C32(0xabf2aec7),
    SPH_C32(0x9480fe89) },
  { SPH_C32(0xe7d70000), SPH_C32(0x10a50001), SPH_C32(0x24c6f800),
    SPH_C32(0x0bbc0000), SPH_C32(0x651406ef), SPH_C32(0x3b17fd31),
    SPH_C32(0x27c93eb6), SPH_C32(0xb3a2b1c9), SPH_C32(0x42c40000),
    SPH_C32(0x49470000), SPH_C32(0x99e0dd00), SPH_C32(0xbca40000),
    SPH_C32(0xf73c49b7), SPH_C32(0xec4de507), SPH_C32(0xc2b1e606),
    SPH_C32(0x5eda7977) },
  { SPH_C32(0x2bc30000), SPH_C32(0xb5c60001), SPH_C32(0x7e7fff80),
    SPH_C32(0x30ec0000), SPH_C32(0x2ec41510), SPH_C32(0xbc8cc929),
    SPH_C32(0x4e8a7677), SPH_C32(0x79f83637), SPH_C32(0xc35a0000),
    SPH_C32(0xa5100000), SPH_C32(0xffd2df80), SPH_C32(0x29570000),
    SPH_C32(0xaa9561b5), SPH_C32(0xa4b9d9bb), SPH_C32(0x24eb442b),
    SPH_C32(0xd0bdce8d) },
  { SPH_C32(0xdb250000), SPH_C32(0x09290000), SPH_C32(0x49aac000),
    SPH_C32(0x81e10000), SPH_C32(0xcafe6b59), SPH_C32(0x42793431),
    SPH_C32(0x43566b76), SPH_C32(0xe86cba2e), SPH_C32(0x75e60000),
    SPH_C32(0x95660001), SPH_C32(0x307b2000), SPH_C32(0xadf40000),
    SPH_C32(0x8f321eea), SPH_C32(0x24298307), SPH_C32(0xe8c49cf9),
    SPH_C32(0x4b7eec55) },
  { SPH_C32(0x17310000), SPH_C32(0xac4a0000), SPH_C32(0x1313c780),
    SPH_C32(0xbab10000), SPH_C32(0x812e78a6), SPH_C32(0xc5e20029),
    SPH_C32(0x2a1523b7), SPH_C32(0x22363dd0), SPH_C32(0xf4780000),
    SPH_C32(0x79310001), SPH_C32(0x56492280), SPH_C32(0x38070000),
    SPH_C32(0xd29b36e8), SPH_C32(0x6cddbfbb), SPH_C32(0x0e9e3ed4),
    SPH_C32(0xc5195baf) },
  { SPH_C32(0x5abb0000), SPH_C32(0xe57e0000), SPH_C32(0x2f98c280),
    SPH_C32(0x14120000), SPH_C32(0x9757435b), SPH_C32(0x0a8d088d),
    SPH_C32(0xa50cc95b), SPH_C32(0x660b0dd4), SPH_C32(0x386c0000),
    SPH_C32(0xdc520001), SPH_C32(0x0cf02500), SPH_C32(0x03570000),
    SPH_C32(0x994b2517), SPH_C32(0xeb468ba3), SPH_C32(0x67dd7615),
    SPH_C32(0x0f43dc51) },
  { SPH_C32(0x96af0000), SPH_C32(0x401d0000), SPH_C32(0x7521c500),
    SPH_C32(0x2f420000), SPH_C32(0xdc8750a4), SPH_C32(0x8d163c95),
    SPH_C32(0xcc4f819a), SPH_C32(0xac518a2a), SPH_C32(0xb9f20000),
    SPH_C32(0x30050001), SPH_C32(0x6ac22780), SPH_C32(0x96a40000),
    SPH_C32(0xc4e20d15), SPH_C32(0xa3b2b71f), SPH_C32(0x8187d438),
    SPH_C32(0x81246bab) },
  { SPH_C32(0xa3060000), SPH_C32(0x1bd50000), SPH_C32(0xe090cb80),
    SPH_C32(0x11440000), SPH_C32(0xbbc04320), SPH_C32(0x3c90bd15),
    SPH_C32(0xb3dacb14), SPH_C32(0x8b033185), SPH_C32(0x77490000),
    SPH_C32(0x224e0001), SPH_C32(0x8a672300), SPH_C32(0xfb6c0000),
    SPH_C32(0x35bf5b39), SPH_C32(0xa4614560), SPH_C32(0x41988863),
    SPH_C32(0xbf88062e) },
  { SPH_C32(0x6f120000), SPH_C32(0xbeb60000), SPH_C32(0xba29cc00),
    SPH_C32(0x2a140000), SPH_C32(0xf01050df), SPH_C32(0xbb0b890d),
    SPH_C32(0xda9983d5), SPH_C32(0x4159b67b), SPH_C32(0xf6d70000),
    SPH_C32(0xce190001), SPH_C32(0xec552180), SPH_C32(0x6e9f0000),
    SPH_C32(0x6816733b), SPH_C32(0xec9579dc), SPH_C32(0xa7c22a4e),
    SPH_C32(0x31efb1d4) },
  { SPH_C32(0x22980000), SPH_C32(0xf7820000), SPH_C32(0x86a2c900),
    SPH_C32(0x84b70000), SPH_C32(0xe6696b22), SPH_C32(0x746481a9),
    SPH_C32(0x55806939), SPH_C32(0x0564867f), SPH_C32(0x3ac30000),
    SPH_C32(0x6b7a0001), SPH_C32(0xb6ec2600), SPH_C32(0x55cf0000),
    SPH_C32(0x23c660c4), SPH_C32(0x6b0e4dc4), SPH_C32(0xce81628f),
    SPH_C32(0xfbb5362a) },
  { SPH_C32(0xee8c0000), SPH_C32(0x52e10000), SPH_C32(0xdc1bce80),
    SPH_C32(0xbfe70000), SPH_C32(0xadb978dd), SPH_C32(0xf3ffb5b1),
    SPH_C32(0x3cc321f8), SPH_C32(0xcf3e0181), SPH_C32(0xbb5d0000),
    SPH_C32(0x872d0001), SPH_C32(0xd0de2480), SPH_C32(0xc03c0000),
    SPH_C32(0x7e6f48c6), SPH_C32(0x23fa7178), SPH_C32(0x28dbc0a2),
    SPH_C32(0x75d281d0) },
  { SPH_C32(0xd98a0000), SPH_C32(0xbe010000), SPH_C32(0xf3b6c300),
    SPH_C32(0xd7790000), SPH_C32(0x70732e8a), SPH_C32(0xc231f256),
    SPH_C32(0xea0a7fec), SPH_C32(0x1c9a5055), SPH_C32(0x0f6a0000),
    SPH_C32(0x30b20001), SPH_C32(0x235d2880), SPH_C32(0x6bc90000),
    SPH_C32(0x44817340), SPH_C32(0xda88cc44), SPH_C32(0xb1142801),
    SPH_C32(0xdce78d85) },
  { SPH_C32(0x159e0000), SPH_C32(0x1b620000), SPH_C32(0xa90fc480),
    SPH_C32(0xec290000), SPH_C32(0x3ba33d75), SPH_C32(0x45aac64e),
    SPH_C32(0x8349372d), SPH_C32(0xd6c0d7ab), SPH_C32(0x8ef40000),
    SPH_C32(0xdce50001), SPH_C32(0x456f2a00), SPH_C32(0xfe3a0000),
    SPH_C32(0x19285b42), SPH_C32(0x927cf0f8), SPH_C32(0x574e8a2c),
    SPH_C32(0x52803a7f) },
  { SPH_C32(0x58140000), SPH_C32(0x52560000), SPH_C32(0x9584c180),
    SPH_C32(0x428a0000), SPH_C32(0x2dda0688), SPH_C32(0x8ac5ceea),
    SPH_C32(0x0c50ddc1), SPH_C32(0x92fde7af), SPH_C32(0x42e00000),
    SPH_C32(0x79860001), SPH_C32(0x1fd62d80), SPH_C32(0xc56a0000),
    SPH_C32(0x52f848bd), SPH_C32(0x15e7c4e0), SPH_C32(0x3e0dc2ed),
    SPH_C32(0x98dabd81) },
  { SPH_C32(0x94000000), SPH_C32(0xf7350000), SPH_C32(0xcf3dc600),
    SPH_C32(0x79da0000), SPH_C32(0x660a1577), SPH_C32(0x0d5efaf2),
    SPH_C32(0x65139500), SPH_C32(0x58a76051), SPH_C32(0xc37e0000),
    SPH_C32(0x95d10001), SPH_C32(0x79e42f00), SPH_C32(0x50990000),
    SPH_C32(0x0f5160bf), SPH_C32(0x5d13f85c), SPH_C32(0xd85760c0),
    SPH_C32(0x16bd0a7b) },
  { SPH_C32(0xa1a90000), SPH_C32(0xacfd0000), SPH_C32(0x5a8cc880),
    SPH_C32(0x47dc0000), SPH_C32(0x014d06f3), SPH_C32(0xbcd87b72),
    SPH_C32(0x1a86df8e), SPH_C32(0x7ff5dbfe), SPH_C32(0x0dc50000),
    SPH_C32(0x879a0001), SPH_C32(0x99412b80), SPH_C32(0x3d510000),
    SPH_C32(0xfe0c3693), SPH_C32(0x5ac00a23), SPH_C32(0x18483c9b),
    SPH_C32(0x281167fe) },
  { SPH_C32(0x6dbd0000), SPH_C32(0x099e0000), SPH_C32(0x0035cf00),
    SPH_C32(0x7c8c0000), SPH_C32(0x4a9d150c), SPH_C32(0x3b434f6a),
    SPH_C32(0x73c5974f), SPH_C32(0xb5af5c00), SPH_C32(0x8c5b0000),
    SPH_C32(0x6bcd0001), SPH_C32(0xff732900), SPH_C32(0xa8a20000),
    SPH_C32(0xa3a51e91), SPH_C32(0x1234369f), SPH_C32(0xfe129eb6),
    SPH_C32(0xa676d004) },
  { SPH_C32(0x20370000), SPH_C32(0x40aa0000), SPH_C32(0x3cbeca00),
    SPH_C32(0xd22f0000), SPH_C32(0x5ce42ef1), SPH_C32(0xf42c47ce),
    SPH_C32(0xfcdc7da3), SPH_C32(0xf1926c04), SPH_C32(0x404f0000),
    SPH_C32(0xceae0001), SPH_C32(0xa5ca2e80), SPH_C32(0x93f20000),
    SPH_C32(0xe8750d6e), SPH_C32(0x95af0287), SPH_C32(0x9751d677),
    SPH_C32(0x6c2c57fa) },
  { SPH_C32(0xec230000), SPH_C32(0xe5c90000), SPH_C32(0x6607cd80),
    SPH_C32(0xe97f0000), SPH_C32(0x17343d0e), SPH_C32(0x73b773d6),
    SPH_C32(0x959f3562), SPH_C32(0x3bc8ebfa), SPH_C32(0xc1d10000),
    SPH_C32(0x22f90001), SPH_C32(0xc3f82c00), SPH_C32(0x06010000),
    SPH_C32(0xb5dc256c), SPH_C32(0xdd5b3e3b), SPH_C32(0x710b745a),
    SPH_C32(0xe24be000) },
  { SPH_C32(0x776d0000), SPH_C32(0x128f0000), SPH_C32(0x0c51d380),
    SPH_C32(0x82a20000), SPH_C32(0x907b5a33), SPH_C32(0x5dcb6487),
    SPH_C32(0xbd24ac88), SPH_C32(0x7988c2d8), SPH_C32(0x6ba80000),
    SPH_C32(0x4ba90001), SPH_C32(0x5d832180), SPH_C32(0xdad00000),
    SPH_C32(0x63751974), SPH_C32(0xd089ea49), SPH_C32(0x256784eb),
    SPH_C32(0xd3d4a53b) },
  { SPH_C32(0xbb790000), SPH_C32(0xb7ec0000), SPH_C32(0x56e8d400),
    SPH_C32(0xb9f20000), SPH_C32(0xdbab49cc), SPH_C32(0xda50509f),
    SPH_C32(0xd467e449), SPH_C32(0xb3d24526), SPH_C32(0xea360000),
    SPH_C32(0xa7fe0001), SPH_C32(0x3bb12300), SPH_C32(0x4f230000),
    SPH_C32(0x3edc3176), SPH_C32(0x987dd6f5), SPH_C32(0xc33d26c6),
    SPH_C32(0x5db312c1) },
  { SPH_C32(0xf6f30000), SPH_C32(0xfed80000), SPH_C32(0x6a63d100),
    SPH_C32(0x17510000), SPH_C32(0xcdd27231), SPH_C32(0x153f583b),
    SPH_C32(0x5b7e0ea5), SPH_C32(0xf7ef7522), SPH_C32(0x26220000),
    SPH_C32(0x029d0001), SPH_C32(0x61082480), SPH_C32(0x74730000),
    SPH_C32(0x750c2289), SPH_C32(0x1fe6e2ed), SPH_C32(0xaa7e6e07),
    SPH_C32(0x97e9953f) },
  { SPH_C32(0x3ae70000), SPH_C32(0x5bbb0000), SPH_C32(0x30dad680),
    SPH_C32(0x2c010000), SPH_C32(0x860261ce), SPH_C32(0x92a46c23),
    SPH_C32(0x323d4664), SPH_C32(0x3db5f2dc), SPH_C32(0xa7bc0000),
    SPH_C32(0xeeca0001), SPH_C32(0x073a2600), SPH_C32(0xe1800000),
    SPH_C32(0x28a50a8b), SPH_C32(0x5712de51), SPH_C32(0x4c24cc2a),
    SPH_C32(0x198e22c5) },
  { SPH_C32(0x0f4e0000), SPH_C32(0x00730000), SPH_C32(0xa56bd800),
    SPH_C32(0x12070000), SPH_C32(0xe145724a), SPH_C32(0x2322eda3),
    SPH_C32(0x4da80cea), SPH_C32(0x1ae74973), SPH_C32(0x69070000),
    SPH_C32(0xfc810001), SPH_C32(0xe79f2280), SPH_C32(0x8c480000),
    SPH_C32(0xd9f85ca7), SPH_C32(0x50c12c2e), SPH_C32(0x8c3b9071),
    SPH_C32(0x27224f40) },
  { SPH_C32(0xc35a0000), SPH_C32(0xa5100000), SPH_C32(0xffd2df80),
    SPH_C32(0x29570000), SPH_C32(0xaa9561b5), SPH_C32(0xa4b9d9bb),
    SPH_C32(0x24eb442b), SPH_C32(0xd0bdce8d), SPH_C32(0xe8990000),
    SPH_C32(0x10d60001), SPH_C32(0x81ad2000), SPH_C32(0x19bb0000),
    SPH_C32(0x845174a5), SPH_C32(0x18351092), SPH_C32(0x6a61325c),
    SPH_C32(0xa945f8ba) },
  { SPH_C32(0x8ed00000), SPH_C32(0xec240000), SPH_C32(0xc359da80),
    SPH_C32(0x87f40000), SPH_C32(0xbcec5a48), SPH_C32(0x6bd6d11f),
    SPH_C32(0xabf2aec7), SPH_C32(0x9480fe89), SPH_C32(0x248d0000),
    SPH_C32(0xb5b50001), SPH_C32(0xdb142780), SPH_C32(0x22eb0000),
    SPH_C32(0xcf81675a), SPH_C32(0x9fae248a), SPH_C32(0x03227a9d),
    SPH_C32(0x631f7f44) },
  { SPH_C32(0x42c40000), SPH_C32(0x49470000), SPH_C32(0x99e0dd00),
    SPH_C32(0xbca40000), SPH_C32(0xf73c49b7), SPH_C32(0xec4de507),
    SPH_C32(0xc2b1e606), SPH_C32(0x5eda7977), SPH_C32(0xa5130000),
    SPH_C32(0x59e20001), SPH_C32(0xbd262500), SPH_C32(0xb7180000),
    SPH_C32(0x92284f58), SPH_C32(0xd75a1836), SPH_C32(0xe578d8b0),
    SPH_C32(0xed78c8be) },
  { SPH_C32(0x75c20000), SPH_C32(0xa5a70000), SPH_C32(0xb64dd080),
    SPH_C32(0xd43a0000), SPH_C32(0x2af61fe0), SPH_C32(0xdd83a2e0),
    SPH_C32(0x1478b812), SPH_C32(0x8d7e28a3), SPH_C32(0x11240000),
    SPH_C32(0xee7d0001), SPH_C32(0x4ea52900), SPH_C32(0x1ced0000),
    SPH_C32(0xa8c674de), SPH_C32(0x2e28a50a), SPH_C32(0x7cb73013),
    SPH_C32(0x444dc4eb) },
  { SPH_C32(0xb9d60000), SPH_C32(0x00c40000), SPH_C32(0xecf4d700),
    SPH_C32(0xef6a0000), SPH_C32(0x61260c1f), SPH_C32(0x5a1896f8),
    SPH_C32(0x7d3bf0d3), SPH_C32(0x4724af5d), SPH_C32(0x90ba0000),
    SPH_C32(0x022a0001), SPH_C32(0x28972b80), SPH_C32(0x891e0000),
    SPH_C32(0xf56f5cdc), SPH_C32(0x66dc99b6), SPH_C32(0x9aed923e),
    SPH_C32(0xca2a7311) },
  { SPH_C32(0xf45c0000), SPH_C32(0x49f00000), SPH_C32(0xd07fd200),
    SPH_C32(0x41c90000), SPH_C32(0x775f37e2), SPH_C32(0x95779e5c),
    SPH_C32(0xf2221a3f), SPH_C32(0x03199f59), SPH_C32(0x5cae0000),
    SPH_C32(0xa7490001), SPH_C32(0x722e2c00), SPH_C32(0xb24e0000),
    SPH_C32(0xbebf4f23), SPH_C32(0xe147adae), SPH_C32(0xf3aedaff),
    SPH_C32(0x0070f4ef) },
  { SPH_C32(0x38480000), SPH_C32(0xec930000), SPH_C32(0x8ac6d580),
    SPH_C32(0x7a990000), SPH_C32(0x3c8f241d), SPH_C32(0x12ecaa44),
    SPH_C32(0x9b6152fe), SPH_C32(0xc94318a7), SPH_C32(0xdd300000),
    SPH_C32(0x4b1e0001), SPH_C32(0x141c2e80), SPH_C32(0x27bd0000),
    SPH_C32(0xe3166721), SPH_C32(0xa9b39112), SPH_C32(0x15f478d2),
    SPH_C32(0x8e174315) },
  { SPH_C32(0x0de10000), SPH_C32(0xb75b0000), SPH_C32(0x1f77db00),
    SPH_C32(0x449f0000), SPH_C32(0x5bc83799), SPH_C32(0xa36a2bc4),
    SPH_C32(0xe4f41870), SPH_C32(0xee11a308), SPH_C32(0x138b0000),
    SPH_C32(0x59550001), SPH_C32(0xf4b92a00), SPH_C32(0x4a750000),
    SPH_C32(0x124b310d), SPH_C32(0xae60636d), SPH_C32(0xd5eb2489),
    SPH_C32(0xb0bb2e90) },
  { SPH_C32(0xc1f50000), SPH_C32(0x12380000), SPH_C32(0x45cedc80),
    SPH_C32(0x7fcf0000), SPH_C32(0x10182466), SPH_C32(0x24f11fdc),
    SPH_C32(0x8db750b1), SPH_C32(0x244b24f6), SPH_C32(0x92150000),
    SPH_C32(0xb5020001), SPH_C32(0x928b2880), SPH_C32(0xdf860000),
    SPH_C32(0x4fe2190f), SPH_C32(0xe6945fd1), SPH_C32(0x33b186a4),
    SPH_C32(0x3edc996a) },
  { SPH_C32(0x8c7f0000), SPH_C32(0x5b0c0000), SPH_C32(0x7945d980),
    SPH_C32(0xd16c0000), SPH_C32(0x06611f9b), SPH_C32(0xeb9e1778),
    SPH_C32(0x02aeba5d), SPH_C32(0x607614f2), SPH_C32(0x5e010000),
    SPH_C32(0x10610001), SPH_C32(0xc8322f00), SPH_C32(0xe4d60000),
    SPH_C32(0x04320af0), SPH_C32(0x610f6bc9), SPH_C32(0x5af2ce65),
    SPH_C32(0xf4861e94) },
  { SPH_C32(0x406b0000), SPH_C32(0xfe6f0000), SPH_C32(0x23fcde00),
    SPH_C32(0xea3c0000), SPH_C32(0x4db10c64), SPH_C32(0x6c052360),
    SPH_C32(0x6bedf29c), SPH_C32(0xaa2c930c), SPH_C32(0xdf9f0000),
    SPH_C32(0xfc360001), SPH_C32(0xae002d80), SPH_C32(0x71250000),
    SPH_C32(0x599b22f2), SPH_C32(0x29fb5775), SPH_C32(0xbca86c48),
    SPH_C32(0x7ae1a96e) },
  { SPH_C32(0xc56b0000), SPH_C32(0xd7e60000), SPH_C32(0x2452c180),
    SPH_C32(0xf6c50000), SPH_C32(0x26b96cc7), SPH_C32(0xb6d95d7f),
    SPH_C32(0x8ef57364), SPH_C32(0x70c6f340), SPH_C32(0xc7e00000),
    SPH_C32(0x500f0001), SPH_C32(0x18783200), SPH_C32(0xd9930000),
    SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff), SPH_C32(0xdb154315),
    SPH_C32(0x4230ddcd) },
  { SPH_C32(0x097f0000), SPH_C32(0x72850000), SPH_C32(0x7eebc600),
    SPH_C32(0xcd950000), SPH_C32(0x6d697f38), SPH_C32(0x31426967),
    SPH_C32(0xe7b63ba5), SPH_C32(0xba9c74be), SPH_C32(0x467e0000),
    SPH_C32(0xbc580001), SPH_C32(0x7e4a3080), SPH_C32(0x4c600000),
    SPH_C32(0x6459001c), SPH_C32(0x87cf8643), SPH_C32(0x3d4fe138),
    SPH_C32(0xcc576a37) },
  { SPH_C32(0x44f50000), SPH_C32(0x3bb10000), SPH_C32(0x4260c300),
    SPH_C32(0x63360000), SPH_C32(0x7b1044c5), SPH_C32(0xfe2d61c3),
    SPH_C32(0x68afd149), SPH_C32(0xfea144ba), SPH_C32(0x8a6a0000),
    SPH_C32(0x193b0001), SPH_C32(0x24f33700), SPH_C32(0x77300000),
    SPH_C32(0x2f8913e3), SPH_C32(0x0054b25b), SPH_C32(0x540ca9f9),
    SPH_C32(0x060dedc9) },
  { SPH_C32(0x88e10000), SPH_C32(0x9ed20000), SPH_C32(0x18d9c480),
    SPH_C32(0x58660000), SPH_C32(0x30c0573a), SPH_C32(0x79b655db),
    SPH_C32(0x01ec9988), SPH_C32(0x34fbc344), SPH_C32(0x0bf40000),
    SPH_C32(0xf56c0001), SPH_C32(0x42c13580), SPH_C32(0xe2c30000),
    SPH_C32(0x72203be1), SPH_C32(0x48a08ee7), SPH_C32(0xb2560bd4),
    SPH_C32(0x886a5a33) },
  { SPH_C32(0xbd480000), SPH_C32(0xc51a0000), SPH_C32(0x8d68ca00),
    SPH_C32(0x66600000), SPH_C32(0x578744be), SPH_C32(0xc830d45b),
    SPH_C32(0x7e79d306), SPH_C32(0x13a978eb), SPH_C32(0xc54f0000),
    SPH_C32(0xe7270001), SPH_C32(0xa2643100), SPH_C32(0x8f0b0000),
    SPH_C32(0x837d6dcd), SPH_C32(0x4f737c98), SPH_C32(0x7249578f),
    SPH_C32(0xb6c637b6) },
  { SPH_C32(0x715c0000), SPH_C32(0x60790000), SPH_C32(0xd7d1cd80),
    SPH_C32(0x5d300000), SPH_C32(0x1c575741), SPH_C32(0x4fabe043),
    SPH_C32(0x173a9bc7), SPH_C32(0xd9f3ff15), SPH_C32(0x44d10000),
    SPH_C32(0x0b700001), SPH_C32(0xc4563380), SPH_C32(0x1af80000),
    SPH_C32(0xded445cf), SPH_C32(0x07874024), SPH_C32(0x9413f5a2),
    SPH_C32(0x38a1804c) },
  { SPH_C32(0x3cd60000), SPH_C32(0x294d0000), SPH_C32(0xeb5ac880),
    SPH_C32(0xf3930000), SPH_C32(0x0a2e6cbc), SPH_C32(0x80c4e8e7),
    SPH_C32(0x9823712b), SPH_C32(0x9dcecf11), SPH_C32(0x88c50000),
    SPH_C32(0xae130001), SPH_C32(0x9eef3400), SPH_C32(0x21a80000),
    SPH_C32(0x95045630), SPH_C32(0x801c743c), SPH_C32(0xfd50bd63),
    SPH_C32(0xf2fb07b2) },
  { SPH_C32(0xf0c20000), SPH_C32(0x8c2e0000), SPH_C32(0xb1e3cf00),
    SPH_C32(0xc8c30000), SPH_C32(0x41fe7f43), SPH_C32(0x075fdcff),
    SPH_C32(0xf16039ea), SPH_C32(0x579448ef), SPH_C32(0x095b0000),
    SPH_C32(0x42440001), SPH_C32(0xf8dd3680), SPH_C32(0xb45b0000),
    SPH_C32(0xc8ad7e32), SPH_C32(0xc8e84880), SPH_C32(0x1b0a1f4e),
    SPH_C32(0x7c9cb048) },
  { SPH_C32(0xc7c40000), SPH_C32(0x60ce0000), SPH_C32(0x9e4ec280),
    SPH_C32(0xa05d0000), SPH_C32(0x9c342914), SPH_C32(0x36919b18),
    SPH_C32(0x27a967fe), SPH_C32(0x8430193b), SPH_C32(0xbd6c0000),
    SPH_C32(0xf5db0001), SPH_C32(0x0b5e3a80), SPH_C32(0x1fae0000),
    SPH_C32(0xf24345b4), SPH_C32(0x319af5bc), SPH_C32(0x82c5f7ed),
    SPH_C32(0xd5a9bc1d) },
  { SPH_C32(0x0bd00000), SPH_C32(0xc5ad0000), SPH_C32(0xc4f7c500),
    SPH_C32(0x9b0d0000), SPH_C32(0xd7e43aeb), SPH_C32(0xb10aaf00),
    SPH_C32(0x4eea2f3f), SPH_C32(0x4e6a9ec5), SPH_C32(0x3cf20000),
    SPH_C32(0x198c0001), SPH_C32(0x6d6c3800), SPH_C32(0x8a5d0000),
    SPH_C32(0xafea6db6), SPH_C32(0x796ec900), SPH_C32(0x649f55c0),
    SPH_C32(0x5bce0be7) },
  { SPH_C32(0x465a0000), SPH_C32(0x8c990000), SPH_C32(0xf87cc000),
    SPH_C32(0x35ae0000), SPH_C32(0xc19d0116), SPH_C32(0x7e65a7a4),
    SPH_C32(0xc1f3c5d3), SPH_C32(0x0a57aec1), SPH_C32(0xf0e60000),
    SPH_C32(0xbcef0001), SPH_C32(0x37d53f80), SPH_C32(0xb10d0000),
    SPH_C32(0xe43a7e49), SPH_C32(0xfef5fd18), SPH_C32(0x0ddc1d01),
    SPH_C32(0x91948c19) },
  { SPH_C32(0x8a4e0000), SPH_C32(0x29fa0000), SPH_C32(0xa2c5c780),
    SPH_C32(0x0efe0000), SPH_C32(0x8a4d12e9), SPH_C32(0xf9fe93bc),
    SPH_C32(0xa8b08d12), SPH_C32(0xc00d293f), SPH_C32(0x71780000),
    SPH_C32(0x50b80001), SPH_C32(0x51e73d00), SPH_C32(0x24fe0000),
    SPH_C32(0xb993564b), SPH_C32(0xb601c1a4), SPH_C32(0xeb86bf2c),
    SPH_C32(0x1ff33be3) },
  { SPH_C32(0xbfe70000), SPH_C32(0x72320000), SPH_C32(0x3774c900),
    SPH_C32(0x30f80000), SPH_C32(0xed0a016d), SPH_C32(0x4878123c),
    SPH_C32(0xd725c79c), SPH_C32(0xe75f9290), SPH_C32(0xbfc30000),
    SPH_C32(0x42f30001), SPH_C32(0xb1423980), SPH_C32(0x49360000),
    SPH_C32(0x48ce0067), SPH_C32(0xb1d233db), SPH_C32(0x2b99e377),
    SPH_C32(0x215f5666) },
  { SPH_C32(0x73f30000), SPH_C32(0xd7510000), SPH_C32(0x6dcdce80),
    SPH_C32(0x0ba80000), SPH_C32(0xa6da1292), SPH_C32(0xcfe32624),
    SPH_C32(0xbe668f5d), SPH_C32(0x2d05156e), SPH_C32(0x3e5d0000),
    SPH_C32(0xaea40001), SPH_C32(0xd7703b00), SPH_C32(0xdcc50000),
    SPH_C32(0x15672865), SPH_C32(0xf9260f67), SPH_C32(0xcdc3415a),
    SPH_C32(0xaf38e19c) },
  { SPH_C32(0x3e790000), SPH_C32(0x9e650000), SPH_C32(0x5146cb80),
    SPH_C32(0xa50b0000), SPH_C32(0xb0a3296f), SPH_C32(0x008c2e80),
    SPH_C32(0x317f65b1), SPH_C32(0x6938256a), SPH_C32(0xf2490000),
    SPH_C32(0x0bc70001), SPH_C32(0x8dc93c80), SPH_C32(0xe7950000),
    SPH_C32(0x5eb73b9a), SPH_C32(0x7ebd3b7f), SPH_C32(0xa480099b),
    SPH_C32(0x65626662) },
  { SPH_C32(0xf26d0000), SPH_C32(0x3b060000), SPH_C32(0x0bffcc00),
    SPH_C32(0x9e5b0000), SPH_C32(0xfb733a90), SPH_C32(0x87171a98),
    SPH_C32(0x583c2d70), SPH_C32(0xa362a294), SPH_C32(0x73d70000),
    SPH_C32(0xe7900001), SPH_C32(0xebfb3e00), SPH_C32(0x72660000),
    SPH_C32(0x031e1398), SPH_C32(0x364907c3), SPH_C32(0x42daabb6),
    SPH_C32(0xeb05d198) },
  { SPH_C32(0x69230000), SPH_C32(0xcc400000), SPH_C32(0x61a9d200),
    SPH_C32(0xf5860000), SPH_C32(0x7c3c5dad), SPH_C32(0xa96b0dc9),
    SPH_C32(0x7087b49a), SPH_C32(0xe1228bb6), SPH_C32(0xd9ae0000),
    SPH_C32(0x8ec00001), SPH_C32(0x75803380), SPH_C32(0xaeb70000),
    SPH_C32(0xd5b72f80), SPH_C32(0x3b9bd3b1), SPH_C32(0x16b65b07),
    SPH_C32(0xda9a94a3) },
  { SPH_C32(0xa5370000), SPH_C32(0x69230000), SPH_C32(0x3b10d580),
    SPH_C32(0xced60000), SPH_C32(0x37ec4e52), SPH_C32(0x2ef039d1),
    SPH_C32(0x19c4fc5b), SPH_C32(0x2b780c48), SPH_C32(0x58300000),
    SPH_C32(0x62970001), SPH_C32(0x13b23100), SPH_C32(0x3b440000),
    SPH_C32(0x881e0782), SPH_C32(0x736fef0d), SPH_C32(0xf0ecf92a),
    SPH_C32(0x54fd2359) },
  { SPH_C32(0xe8bd0000), SPH_C32(0x20170000), SPH_C32(0x079bd080),
    SPH_C32(0x60750000), SPH_C32(0x219575af), SPH_C32(0xe19f3175),
    SPH_C32(0x96dd16b7), SPH_C32(0x6f453c4c), SPH_C32(0x94240000),
    SPH_C32(0xc7f40001), SPH_C32(0x490b3680), SPH_C32(0x00140000),
    SPH_C32(0xc3ce147d), SPH_C32(0xf4f4db15), SPH_C32(0x99afb1eb),
    SPH_C32(0x9ea7a4a7) },
  { SPH_C32(0x24a90000), SPH_C32(0x85740000), SPH_C32(0x5d22d700),
    SPH_C32(0x5b250000), SPH_C32(0x6a456650), SPH_C32(0x6604056d),
    SPH_C32(0xff9e5e76), SPH_C32(0xa51fbbb2), SPH_C32(0x15ba0000),
    SPH_C32(0x2ba30001), SPH_C32(0x2f393400), SPH_C32(0x95e70000),
    SPH_C32(0x9e673c7f), SPH_C32(0xbc00e7a9), SPH_C32(0x7ff513c6),
    SPH_C32(0x10c0135d) },
  { SPH_C32(0x11000000), SPH_C32(0xdebc0000), SPH_C32(0xc893d980),
    SPH_C32(0x65230000), SPH_C32(0x0d0275d4), SPH_C32(0xd78284ed),
    SPH_C32(0x800b14f8), SPH_C32(0x824d001d), SPH_C32(0xdb010000),
    SPH_C32(0x39e80001), SPH_C32(0xcf9c3080), SPH_C32(0xf82f0000),
    SPH_C32(0x6f3a6a53), SPH_C32(0xbbd315d6), SPH_C32(0xbfea4f9d),
    SPH_C32(0x2e6c7ed8) },
  { SPH_C32(0xdd140000), SPH_C32(0x7bdf0000), SPH_C32(0x922ade00),
    SPH_C32(0x5e730000), SPH_C32(0x46d2662b), SPH_C32(0x5019b0f5),
    SPH_C32(0xe9485c39), SPH_C32(0x481787e3), SPH_C32(0x5a9f0000),
    SPH_C32(0xd5bf0001), SPH_C32(0xa9ae3200), SPH_C32(0x6ddc0000),
    SPH_C32(0x32934251), SPH_C32(0xf327296a), SPH_C32(0x59b0edb0),
    SPH_C32(0xa00bc922) },
  { SPH_C32(0x909e0000), SPH_C32(0x32eb0000), SPH_C32(0xaea1db00),
    SPH_C32(0xf0d00000), SPH_C32(0x50ab5dd6), SPH_C32(0x9f76b851),
    SPH_C32(0x6651b6d5), SPH_C32(0x0c2ab7e7), SPH_C32(0x968b0000),
    SPH_C32(0x70dc0001), SPH_C32(0xf3173580), SPH_C32(0x568c0000),
    SPH_C32(0x794351ae), SPH_C32(0x74bc1d72), SPH_C32(0x30f3a571),
    SPH_C32(0x6a514edc) },
  { SPH_C32(0x5c8a0000), SPH_C32(0x97880000), SPH_C32(0xf418dc80),
    SPH_C32(0xcb800000), SPH_C32(0x1b7b4e29), SPH_C32(0x18ed8c49),
    SPH_C32(0x0f12fe14), SPH_C32(0xc6703019), SPH_C32(0x17150000),
    SPH_C32(0x9c8b0001), SPH_C32(0x95253700), SPH_C32(0xc37f0000),
    SPH_C32(0x24ea79ac), SPH_C32(0x3c4821ce), SPH_C32(0xd6a9075c),
    SPH_C32(0xe436f926) },
  { SPH_C32(0x6b8c0000), SPH_C32(0x7b680000), SPH_C32(0xdbb5d100),
    SPH_C32(0xa31e0000), SPH_C32(0xc6b1187e), SPH_C32(0x2923cbae),
    SPH_C32(0xd9dba000), SPH_C32(0x15d461cd), SPH_C32(0xa3220000),
    SPH_C32(0x2b140001), SPH_C32(0x66a63b00), SPH_C32(0x688a0000),
    SPH_C32(0x1e04422a), SPH_C32(0xc53a9cf2), SPH_C32(0x4f66efff),
    SPH_C32(0x4d03f573) },
  { SPH_C32(0xa7980000), SPH_C32(0xde0b0000), SPH_C32(0x810cd680),
    SPH_C32(0x984e0000), SPH_C32(0x8d610b81), SPH_C32(0xaeb8ffb6),
    SPH_C32(0xb098e8c1), SPH_C32(0xdf8ee633), SPH_C32(0x22bc0000),
    SPH_C32(0xc7430001), SPH_C32(0x00943980), SPH_C32(0xfd790000),
    SPH_C32(0x43ad6a28), SPH_C32(0x8dcea04e), SPH_C32(0xa93c4dd2),
    SPH_C32(0xc3644289) },
  { SPH_C32(0xea120000), SPH_C32(0x973f0000), SPH_C32(0xbd87d380),
    SPH_C32(0x36ed0000), SPH_C32(0x9b18307c), SPH_C32(0x61d7f712),
    SPH_C32(0x3f81022d), SPH_C32(0x9bb3d637), SPH_C32(0xeea80000),
    SPH_C32(0x62200001), SPH_C32(0x5a2d3e00), SPH_C32(0xc6290000),
    SPH_C32(0x087d79d7), SPH_C32(0x0a559456), SPH_C32(0xc07f0513),
    SPH_C32(0x093ec577) },
  { SPH_C32(0x26060000), SPH_C32(0x325c0000), SPH_C32(0xe73ed400),
    SPH_C32(0x0dbd0000), SPH_C32(0xd0c82383), SPH_C32(0xe64cc30a),
    SPH_C32(0x56c24aec), SPH_C32(0x51e951c9), SPH_C32(0x6f360000),
    SPH_C32(0x8e770001), SPH_C32(0x3c1f3c80), SPH_C32(0x53da0000),
    SPH_C32(0x55d451d5), SPH_C32(0x42a1a8ea), SPH_C32(0x2625a73e),
    SPH_C32(0x8759728d) },
  { SPH_C32(0x13af0000), SPH_C32(0x69940000), SPH_C32(0x728fda80),
    SPH_C32(0x33bb0000), SPH_C32(0xb78f3007), SPH_C32(0x57ca428a),
    SPH_C32(0x29570062), SPH_C32(0x76bbea66), SPH_C32(0xa18d0000),
    SPH_C32(0x9c3c0001), SPH_C32(0xdcba3800), SPH_C32(0x3e120000),
    SPH_C32(0xa48907f9), SPH_C32(0x45725a95), SPH_C32(0xe63afb65),
    SPH_C32(0xb9f51f08) },
  { SPH_C32(0xdfbb0000), SPH_C32(0xccf70000), SPH_C32(0x2836dd00),
    SPH_C32(0x08eb0000), SPH_C32(0xfc5f23f8), SPH_C32(0xd0517692),
    SPH_C32(0x401448a3), SPH_C32(0xbce16d98), SPH_C32(0x20130000),
    SPH_C32(0x706b0001), SPH_C32(0xba883a80), SPH_C32(0xabe10000),
    SPH_C32(0xf9202ffb), SPH_C32(0x0d866629), SPH_C32(0x00605948),
    SPH_C32(0x3792a8f2) },
  { SPH_C32(0x92310000), SPH_C32(0x85c30000), SPH_C32(0x14bdd800),
    SPH_C32(0xa6480000), SPH_C32(0xea261805), SPH_C32(0x1f3e7e36),
    SPH_C32(0xcf0da24f), SPH_C32(0xf8dc5d9c), SPH_C32(0xec070000),
    SPH_C32(0xd5080001), SPH_C32(0xe0313d00), SPH_C32(0x90b10000),
    SPH_C32(0xb2f03c04), SPH_C32(0x8a1d5231), SPH_C32(0x69231189),
    SPH_C32(0xfdc82f0c) },
  { SPH_C32(0x5e250000), SPH_C32(0x20a00000), SPH_C32(0x4e04df80),
    SPH_C32(0x9d180000), SPH_C32(0xa1f60bfa), SPH_C32(0x98a54a2e),
    SPH_C32(0xa64eea8e), SPH_C32(0x3286da62), SPH_C32(0x6d990000),
    SPH_C32(0x395f0001), SPH_C32(0x86033f80), SPH_C32(0x05420000),
    SPH_C32(0xef591406), SPH_C32(0xc2e96e8d), SPH_C32(0x8f79b3a4),
    SPH_C32(0x73af98f6) },
  { SPH_C32(0x75e60000), SPH_C32(0x95660001), SPH_C32(0x307b2000),
    SPH_C32(0xadf40000), SPH_C32(0x8f321eea), SPH_C32(0x24298307),
    SPH_C32(0xe8c49cf9), SPH_C32(0x4b7eec55), SPH_C32(0xaec30000),
    SPH_C32(0x9c4f0001), SPH_C32(0x79d1e000), SPH_C32(0x2c150000),
    SPH_C32(0x45cc75b3), SPH_C32(0x6650b736), SPH_C32(0xab92f78f),
    SPH_C32(0xa312567b) },
  { SPH_C32(0xb9f20000), SPH_C32(0x30050001), SPH_C32(0x6ac22780),
    SPH_C32(0x96a40000), SPH_C32(0xc4e20d15), SPH_C32(0xa3b2b71f),
    SPH_C32(0x8187d438), SPH_C32(0x81246bab), SPH_C32(0x2f5d0000),
    SPH_C32(0x70180001), SPH_C32(0x1fe3e280), SPH_C32(0xb9e60000),
    SPH_C32(0x18655db1), SPH_C32(0x2ea48b8a), SPH_C32(0x4dc855a2),
    SPH_C32(0x2d75e181) },
  { SPH_C32(0xf4780000), SPH_C32(0x79310001), SPH_C32(0x56492280),
    SPH_C32(0x38070000), SPH_C32(0xd29b36e8), SPH_C32(0x6cddbfbb),
    SPH_C32(0x0e9e3ed4), SPH_C32(0xc5195baf), SPH_C32(0xe3490000),
    SPH_C32(0xd57b0001), SPH_C32(0x455ae500), SPH_C32(0x82b60000),
    SPH_C32(0x53b54e4e), SPH_C32(0xa93fbf92), SPH_C32(0x248b1d63),
    SPH_C32(0xe72f667f) },
  { SPH_C32(0x386c0000), SPH_C32(0xdc520001), SPH_C32(0x0cf02500),
    SPH_C32(0x03570000), SPH_C32(0x994b2517), SPH_C32(0xeb468ba3),
    SPH_C32(0x67dd7615), SPH_C32(0x0f43dc51), SPH_C32(0x62d70000),
    SPH_C32(0x392c0001), SPH_C32(0x2368e780), SPH_C32(0x17450000),
    SPH_C32(0x0e1c664c), SPH_C32(0xe1cb832e), SPH_C32(0xc2d1bf4e),
    SPH_C32(0x6948d185) },
  { SPH_C32(0x0dc50000), SPH_C32(0x879a0001), SPH_C32(0x99412b80),
    SPH_C32(0x3d510000), SPH_C32(0xfe0c3693), SPH_C32(0x5ac00a23),
    SPH_C32(0x18483c9b), SPH_C32(0x281167fe), SPH_C32(0xac6c0000),
    SPH_C32(0x2b670001), SPH_C32(0xc3cde300), SPH_C32(0x7a8d0000),
    SPH_C32(0xff413060), SPH_C32(0xe6187151), SPH_C32(0x02cee315),
    SPH_C32(0x57e4bc00) },
  { SPH_C32(0xc1d10000), SPH_C32(0x22f90001), SPH_C32(0xc3f82c00),
    SPH_C32(0x06010000), SPH_C32(0xb5dc256c), SPH_C32(0xdd5b3e3b),
    SPH_C32(0x710b745a), SPH_C32(0xe24be000), SPH_C32(0x2df20000),
    SPH_C32(0xc7300001), SPH_C32(0xa5ffe180), SPH_C32(0xef7e0000),
    SPH_C32(0xa2e81862), SPH_C32(0xaeec4ded), SPH_C32(0xe4944138),
    SPH_C32(0xd9830bfa) },
  { SPH_C32(0x8c5b0000), SPH_C32(0x6bcd0001), SPH_C32(0xff732900),
    SPH_C32(0xa8a20000), SPH_C32(0xa3a51e91), SPH_C32(0x1234369f),
    SPH_C32(0xfe129eb6), SPH_C32(0xa676d004), SPH_C32(0xe1e60000),
    SPH_C32(0x62530001), SPH_C32(0xff46e600), SPH_C32(0xd42e0000),
    SPH_C32(0xe9380b9d), SPH_C32(0x297779f5), SPH_C32(0x8dd709f9),
    SPH_C32(0x13d98c04) },
  { SPH_C32(0x404f0000), SPH_C32(0xceae0001), SPH_C32(0xa5ca2e80),
    SPH_C32(0x93f20000), SPH_C32(0xe8750d6e), SPH_C32(0x95af0287),
    SPH_C32(0x9751d677), SPH_C32(0x6c2c57fa), SPH_C32(0x60780000),
    SPH_C32(0x8e040001), SPH_C32(0x9974e480), SPH_C32(0x41dd0000),
    SPH_C32(0xb491239f), SPH_C32(0x61834549), SPH_C32(0x6b8dabd4),
    SPH_C32(0x9dbe3bfe) },
  { SPH_C32(0x77490000), SPH_C32(0x224e0001), SPH_C32(0x8a672300),
    SPH_C32(0xfb6c0000), SPH_C32(0x35bf5b39), SPH_C32(0xa4614560),
    SPH_C32(0x41988863), SPH_C32(0xbf88062e), SPH_C32(0xd44f0000),
    SPH_C32(0x399b0001), SPH_C32(0x6af7e880), SPH_C32(0xea280000),
    SPH_C32(0x8e7f1819), SPH_C32(0x98f1f875), SPH_C32(0xf2424377),
    SPH_C32(0x348b37ab) },
  { SPH_C32(0xbb5d0000), SPH_C32(0x872d0001), SPH_C32(0xd0de2480),
    SPH_C32(0xc03c0000), SPH_C32(0x7e6f48c6), SPH_C32(0x23fa7178),
    SPH_C32(0x28dbc0a2), SPH_C32(0x75d281d0), SPH_C32(0x55d10000),
    SPH_C32(0xd5cc0001), SPH_C32(0x0cc5ea00), SPH_C32(0x7fdb0000),
    SPH_C32(0xd3d6301b), SPH_C32(0xd005c4c9), SPH_C32(0x1418e15a),
    SPH_C32(0xbaec8051) },
  { SPH_C32(0xf6d70000), SPH_C32(0xce190001), SPH_C32(0xec552180),
    SPH_C32(0x6e9f0000), SPH_C32(0x6816733b), SPH_C32(0xec9579dc),
    SPH_C32(0xa7c22a4e), SPH_C32(0x31efb1d4), SPH_C32(0x99c50000),
    SPH_C32(0x70af0001), SPH_C32(0x567ced80), SPH_C32(0x448b0000),
    SPH_C32(0x980623e4), SPH_C32(0x579ef0d1), SPH_C32(0x7d5ba99b),
    SPH_C32(0x70b607af) },
  { SPH_C32(0x3ac30000), SPH_C32(0x6b7a0001), SPH_C32(0xb6ec2600),
    SPH_C32(0x55cf0000), SPH_C32(0x23c660c4), SPH_C32(0x6b0e4dc4),
    SPH_C32(0xce81628f), SPH_C32(0xfbb5362a), SPH_C32(0x185b0000),
    SPH_C32(0x9cf80001), SPH_C32(0x304eef00), SPH_C32(0xd1780000),
    SPH_C32(0xc5af0be6), SPH_C32(0x1f6acc6d), SPH_C32(0x9b010bb6),
    SPH_C32(0xfed1b055) },
  { SPH_C32(0x0f6a0000), SPH_C32(0x30b20001), SPH_C32(0x235d2880),
    SPH_C32(0x6bc90000), SPH_C32(0x44817340), SPH_C32(0xda88cc44),
    SPH_C32(0xb1142801), SPH_C32(0xdce78d85), SPH_C32(0xd6e00000),
    SPH_C32(0x8eb30001), SPH_C32(0xd0ebeb80), SPH_C32(0xbcb00000),
    SPH_C32(0x34f25dca), SPH_C32(0x18b93e12), SPH_C32(0x5b1e57ed),
    SPH_C32(0xc07dddd0) },
  { SPH_C32(0xc37e0000), SPH_C32(0x95d10001), SPH_C32(0x79e42f00),
    SPH_C32(0x50990000), SPH_C32(0x0f5160bf), SPH_C32(0x5d13f85c),
    SPH_C32(0xd85760c0), SPH_C32(0x16bd0a7b), SPH_C32(0x577e0000),
    SPH_C32(0x62e40001), SPH_C32(0xb6d9e900), SPH_C32(0x29430000),
    SPH_C32(0x695b75c8), SPH_C32(0x504d02ae), SPH_C32(0xbd44f5c0),
    SPH_C32(0x4e1a6a2a) },
  { SPH_C32(0x8ef40000), SPH_C32(0xdce50001), SPH_C32(0x456f2a00),
    SPH_C32(0xfe3a0000), SPH_C32(0x19285b42), SPH_C32(0x927cf0f8),
    SPH_C32(0x574e8a2c), SPH_C32(0x52803a7f), SPH_C32(0x9b6a0000),
    SPH_C32(0xc7870001), SPH_C32(0xec60ee80), SPH_C32(0x12130000),
    SPH_C32(0x228b6637), SPH_C32(0xd7d636b6), SPH_C32(0xd407bd01),
    SPH_C32(0x8440edd4) },
  { SPH_C32(0x42e00000), SPH_C32(0x79860001), SPH_C32(0x1fd62d80),
    SPH_C32(0xc56a0000), SPH_C32(0x52f848bd), SPH_C32(0x15e7c4e0),
    SPH_C32(0x3e0dc2ed), SPH_C32(0x98dabd81), SPH_C32(0x1af40000),
    SPH_C32(0x2bd00001), SPH_C32(0x8a52ec00), SPH_C32(0x87e00000),
    SPH_C32(0x7f224e35), SPH_C32(0x9f220a0a), SPH_C32(0x325d1f2c),
    SPH_C32(0x0a275a2e) },
  { SPH_C32(0xd9ae0000), SPH_C32(0x8ec00001), SPH_C32(0x75803380),
    SPH_C32(0xaeb70000), SPH_C32(0xd5b72f80), SPH_C32(0x3b9bd3b1),
    SPH_C32(0x16b65b07), SPH_C32(0xda9a94a3), SPH_C32(0xb08d0000),
    SPH_C32(0x42800001), SPH_C32(0x1429e180), SPH_C32(0x5b310000),
    SPH_C32(0xa98b722d), SPH_C32(0x92f0de78), SPH_C32(0x6631ef9d),
    SPH_C32(0x3bb81f15) },
  { SPH_C32(0x15ba0000), SPH_C32(0x2ba30001), SPH_C32(0x2f393400),
    SPH_C32(0x95e70000), SPH_C32(0x9e673c7f), SPH_C32(0xbc00e7a9),
    SPH_C32(0x7ff513c6), SPH_C32(0x10c0135d), SPH_C32(0x31130000),
    SPH_C32(0xaed70001), SPH_C32(0x721be300), SPH_C32(0xcec20000),
    SPH_C32(0xf4225a2f), SPH_C32(0xda04e2c4), SPH_C32(0x806b4db0),
    SPH_C32(0xb5dfa8ef) },
  { SPH_C32(0x58300000), SPH_C32(0x62970001), SPH_C32(0x13b23100),
    SPH_C32(0x3b440000), SPH_C32(0x881e0782), SPH_C32(0x736fef0d),
    SPH_C32(0xf0ecf92a), SPH_C32(0x54fd2359), SPH_C32(0xfd070000),
    SPH_C32(0x0bb40001), SPH_C32(0x28a2e480), SPH_C32(0xf5920000),
    SPH_C32(0xbff249d0), SPH_C32(0x5d9fd6dc), SPH_C32(0xe9280571),
    SPH_C32(0x7f852f11) },
  { SPH_C32(0x94240000), SPH_C32(0xc7f40001), SPH_C32(0x490b3680),
    SPH_C32(0x00140000), SPH_C32(0xc3ce147d), SPH_C32(0xf4f4db15),
    SPH_C32(0x99afb1eb), SPH_C32(0x9ea7a4a7), SPH_C32(0x7c990000),
    SPH_C32(0xe7e30001), SPH_C32(0x4e90e600), SPH_C32(0x60610000),
    SPH_C32(0xe25b61d2), SPH_C32(0x156bea60), SPH_C32(0x0f72a75c),
    SPH_C32(0xf1e298eb) },
  { SPH_C32(0xa18d0000), SPH_C32(0x9c3c0001), SPH_C32(0xdcba3800),
    SPH_C32(0x3e120000), SPH_C32(0xa48907f9), SPH_C32(0x45725a95),
    SPH_C32(0xe63afb65), SPH_C32(0xb9f51f08), SPH_C32(0xb2220000),
    SPH_C32(0xf5a80001), SPH_C32(0xae35e280), SPH_C32(0x0da90000),
    SPH_C32(0x130637fe), SPH_C32(0x12b8181f), SPH_C32(0xcf6dfb07),
    SPH_C32(0xcf4ef56e) },
  { SPH_C32(0x6d990000), SPH_C32(0x395f0001), SPH_C32(0x86033f80),
    SPH_C32(0x05420000), SPH_C32(0xef591406), SPH_C32(0xc2e96e8d),
    SPH_C32(0x8f79b3a4), SPH_C32(0x73af98f6), SPH_C32(0x33bc0000),
    SPH_C32(0x19ff0001), SPH_C32(0xc807e000), SPH_C32(0x985a0000),
    SPH_C32(0x4eaf1ffc), SPH_C32(0x5a4c24a3), SPH_C32(0x2937592a),
    SPH_C32(0x41294294) },
  { SPH_C32(0x20130000), SPH_C32(0x706b0001), SPH_C32(0xba883a80),
    SPH_C32(0xabe10000), SPH_C32(0xf9202ffb), SPH_C32(0x0d866629),
    SPH_C32(0x00605948), SPH_C32(0x3792a8f2), SPH_C32(0xffa80000),
    SPH_C32(0xbc9c0001), SPH_C32(0x92bee780), SPH_C32(0xa30a0000),
    SPH_C32(0x057f0c03), SPH_C32(0xddd710bb), SPH_C32(0x407411eb),
    SPH_C32(0x8b73c56a) },
  { SPH_C32(0xec070000), SPH_C32(0xd5080001), SPH_C32(0xe0313d00),
    SPH_C32(0x90b10000), SPH_C32(0xb2f03c04), SPH_C32(0x8a1d5231),
    SPH_C32(0x69231189), SPH_C32(0xfdc82f0c), SPH_C32(0x7e360000),
    SPH_C32(0x50cb0001), SPH_C32(0xf48ce500), SPH_C32(0x36f90000),
    SPH_C32(0x58d62401), SPH_C32(0x95232c07), SPH_C32(0xa62eb3c6),
    SPH_C32(0x05147290) },
  { SPH_C32(0xdb010000), SPH_C32(0x39e80001), SPH_C32(0xcf9c3080),
    SPH_C32(0xf82f0000), SPH_C32(0x6f3a6a53), SPH_C32(0xbbd315d6),
    SPH_C32(0xbfea4f9d), SPH_C32(0x2e6c7ed8), SPH_C32(0xca010000),
    SPH_C32(0xe7540001), SPH_C32(0x070fe900), SPH_C32(0x9d0c0000),
    SPH_C32(0x62381f87), SPH_C32(0x6c51913b), SPH_C32(0x3fe15b65),
    SPH_C32(0xac217ec5) },
  { SPH_C32(0x17150000), SPH_C32(0x9c8b0001), SPH_C32(0x95253700),
    SPH_C32(0xc37f0000), SPH_C32(0x24ea79ac), SPH_C32(0x3c4821ce),
    SPH_C32(0xd6a9075c), SPH_C32(0xe436f926), SPH_C32(0x4b9f0000),
    SPH_C32(0x0b030001), SPH_C32(0x613deb80), SPH_C32(0x08ff0000),
    SPH_C32(0x3f913785), SPH_C32(0x24a5ad87), SPH_C32(0xd9bbf948),
    SPH_C32(0x2246c93f) },
  { SPH_C32(0x5a9f0000), SPH_C32(0xd5bf0001), SPH_C32(0xa9ae3200),
    SPH_C32(0x6ddc0000), SPH_C32(0x32934251), SPH_C32(0xf327296a),
    SPH_C32(0x59b0edb0), SPH_C32(0xa00bc922), SPH_C32(0x878b0000),
    SPH_C32(0xae600001), SPH_C32(0x3b84ec00), SPH_C32(0x33af0000),
    SPH_C32(0x7441247a), SPH_C32(0xa33e999f), SPH_C32(0xb0f8b189),
    SPH_C32(0xe81c4ec1) },
  { SPH_C32(0x968b0000), SPH_C32(0x70dc0001), SPH_C32(0xf3173580),
    SPH_C32(0x568c0000), SPH_C32(0x794351ae), SPH_C32(0x74bc1d72),
    SPH_C32(0x30f3a571), SPH_C32(0x6a514edc), SPH_C32(0x06150000),
    SPH_C32(0x42370001), SPH_C32(0x5db6ee80), SPH_C32(0xa65c0000),
    SPH_C32(0x29e80c78), SPH_C32(0xebcaa523), SPH_C32(0x56a213a4),
    SPH_C32(0x667bf93b) },
  { SPH_C32(0xa3220000), SPH_C32(0x2b140001), SPH_C32(0x66a63b00),
    SPH_C32(0x688a0000), SPH_C32(0x1e04422a), SPH_C32(0xc53a9cf2),
    SPH_C32(0x4f66efff), SPH_C32(0x4d03f573), SPH_C32(0xc8ae0000),
    SPH_C32(0x507c0001), SPH_C32(0xbd13ea00), SPH_C32(0xcb940000),
    SPH_C32(0xd8b55a54), SPH_C32(0xec19575c), SPH_C32(0x96bd4fff),
    SPH_C32(0x58d794be) },
  { SPH_C32(0x6f360000), SPH_C32(0x8e770001), SPH_C32(0x3c1f3c80),
    SPH_C32(0x53da0000), SPH_C32(0x55d451d5), SPH_C32(0x42a1a8ea),
    SPH_C32(0x2625a73e), SPH_C32(0x8759728d), SPH_C32(0x49300000),
    SPH_C32(0xbc2b0001), SPH_C32(0xdb21e880), SPH_C32(0x5e670000),
    SPH_C32(0x851c7256), SPH_C32(0xa4ed6be0), SPH_C32(0x70e7edd2),
    SPH_C32(0xd6b02344) },
  { SPH_C32(0x22bc0000), SPH_C32(0xc7430001), SPH_C32(0x00943980),
    SPH_C32(0xfd790000), SPH_C32(0x43ad6a28), SPH_C32(0x8dcea04e),
    SPH_C32(0xa93c4dd2), SPH_C32(0xc3644289), SPH_C32(0x85240000),
    SPH_C32(0x19480001), SPH_C32(0x8198ef00), SPH_C32(0x65370000),
    SPH_C32(0xcecc61a9), SPH_C32(0x23765ff8), SPH_C32(0x19a4a513),
    SPH_C32(0x1ceaa4ba) },
  { SPH_C32(0xeea80000), SPH_C32(0x62200001), SPH_C32(0x5a2d3e00),
    SPH_C32(0xc6290000), SPH_C32(0x087d79d7), SPH_C32(0x0a559456),
    SPH_C32(0xc07f0513), SPH_C32(0x093ec577), SPH_C32(0x04ba0000),
    SPH_C32(0xf51f0001), SPH_C32(0xe7aaed80), SPH_C32(0xf0c40000),
    SPH_C32(0x936549ab), SPH_C32(0x6b826344), SPH_C32(0xfffe073e),
    SPH_C32(0x928d1340) },
  { SPH_C32(0x6ba80000), SPH_C32(0x4ba90001), SPH_C32(0x5d832180),
    SPH_C32(0xdad00000), SPH_C32(0x63751974), SPH_C32(0xd089ea49),
    SPH_C32(0x256784eb), SPH_C32(0xd3d4a53b), SPH_C32(0x1cc50000),
    SPH_C32(0x59260001), SPH_C32(0x51d2f200), SPH_C32(0x58720000),
    SPH_C32(0xf30e4347), SPH_C32(0x8d428ece), SPH_C32(0x98432863),
    SPH_C32(0xaa5c67e3) },
  { SPH_C32(0xa7bc0000), SPH_C32(0xeeca0001), SPH_C32(0x073a2600),
    SPH_C32(0xe1800000), SPH_C32(0x28a50a8b), SPH_C32(0x5712de51),
    SPH_C32(0x4c24cc2a), SPH_C32(0x198e22c5), SPH_C32(0x9d5b0000),
    SPH_C32(0xb5710001), SPH_C32(0x37e0f080), SPH_C32(0xcd810000),
    SPH_C32(0xaea76b45), SPH_C32(0xc5b6b272), SPH_C32(0x7e198a4e),
    SPH_C32(0x243bd019) },
  { SPH_C32(0xea360000), SPH_C32(0xa7fe0001), SPH_C32(0x3bb12300),
    SPH_C32(0x4f230000), SPH_C32(0x3edc3176), SPH_C32(0x987dd6f5),
    SPH_C32(0xc33d26c6), SPH_C32(0x5db312c1), SPH_C32(0x514f0000),
    SPH_C32(0x10120001), SPH_C32(0x6d59f700), SPH_C32(0xf6d10000),
    SPH_C32(0xe57778ba), SPH_C32(0x422d866a), SPH_C32(0x175ac28f),
    SPH_C32(0xee6157e7) },
  { SPH_C32(0x26220000), SPH_C32(0x029d0001), SPH_C32(0x61082480),
    SPH_C32(0x74730000), SPH_C32(0x750c2289), SPH_C32(0x1fe6e2ed),
    SPH_C32(0xaa7e6e07), SPH_C32(0x97e9953f), SPH_C32(0xd0d10000),
    SPH_C32(0xfc450001), SPH_C32(0x0b6bf580), SPH_C32(0x63220000),
    SPH_C32(0xb8de50b8), SPH_C32(0x0ad9bad6), SPH_C32(0xf10060a2),
    SPH_C32(0x6006e01d) },
  { SPH_C32(0x138b0000), SPH_C32(0x59550001), SPH_C32(0xf4b92a00),
    SPH_C32(0x4a750000), SPH_C32(0x124b310d), SPH_C32(0xae60636d),
    SPH_C32(0xd5eb2489), SPH_C32(0xb0bb2e90), SPH_C32(0x1e6a0000),
    SPH_C32(0xee0e0001), SPH_C32(0xebcef100), SPH_C32(0x0eea0000),
    SPH_C32(0x49830694), SPH_C32(0x0d0a48a9), SPH_C32(0x311f3cf9),
    SPH_C32(0x5eaa8d98) },
  { SPH_C32(0xdf9f0000), SPH_C32(0xfc360001), SPH_C32(0xae002d80),
    SPH_C32(0x71250000), SPH_C32(0x599b22f2), SPH_C32(0x29fb5775),
    SPH_C32(0xbca86c48), SPH_C32(0x7ae1a96e), SPH_C32(0x9ff40000),
    SPH_C32(0x02590001), SPH_C32(0x8dfcf380), SPH_C32(0x9b190000),
    SPH_C32(0x142a2e96), SPH_C32(0x45fe7415), SPH_C32(0xd7459ed4),
    SPH_C32(0xd0cd3a62) },
  { SPH_C32(0x92150000), SPH_C32(0xb5020001), SPH_C32(0x928b2880),
    SPH_C32(0xdf860000), SPH_C32(0x4fe2190f), SPH_C32(0xe6945fd1),
    SPH_C32(0x33b186a4), SPH_C32(0x3edc996a), SPH_C32(0x53e00000),
    SPH_C32(0xa73a0001), SPH_C32(0xd745f400), SPH_C32(0xa0490000),
    SPH_C32(0x5ffa3d69), SPH_C32(0xc265400d), SPH_C32(0xbe06d615),
    SPH_C32(0x1a97bd9c) },
  { SPH_C32(0x5e010000), SPH_C32(0x10610001), SPH_C32(0xc8322f00),
    SPH_C32(0xe4d60000), SPH_C32(0x04320af0), SPH_C32(0x610f6bc9),
    SPH_C32(0x5af2ce65), SPH_C32(0xf4861e94), SPH_C32(0xd27e0000),
    SPH_C32(0x4b6d0001), SPH_C32(0xb177f680), SPH_C32(0x35ba0000),
    SPH_C32(0x0253156b), SPH_C32(0x8a917cb1), SPH_C32(0x585c7438),
    SPH_C32(0x94f00a66) },
  { SPH_C32(0x69070000), SPH_C32(0xfc810001), SPH_C32(0xe79f2280),
    SPH_C32(0x8c480000), SPH_C32(0xd9f85ca7), SPH_C32(0x50c12c2e),
    SPH_C32(0x8c3b9071), SPH_C32(0x27224f40), SPH_C32(0x66490000),
    SPH_C32(0xfcf20001), SPH_C32(0x42f4fa80), SPH_C32(0x9e4f0000),
    SPH_C32(0x38bd2eed), SPH_C32(0x73e3c18d), SPH_C32(0xc1939c9b),
    SPH_C32(0x3dc50633) },
  { SPH_C32(0xa5130000), SPH_C32(0x59e20001), SPH_C32(0xbd262500),
    SPH_C32(0xb7180000), SPH_C32(0x92284f58), SPH_C32(0xd75a1836),
    SPH_C32(0xe578d8b0), SPH_C32(0xed78c8be), SPH_C32(0xe7d70000),
    SPH_C32(0x10a50001), SPH_C32(0x24c6f800), SPH_C32(0x0bbc0000),
    SPH_C32(0x651406ef), SPH_C32(0x3b17fd31), SPH_C32(0x27c93eb6),
    SPH_C32(0xb3a2b1c9) },
  { SPH_C32(0xe8990000), SPH_C32(0x10d60001), SPH_C32(0x81ad2000),
    SPH_C32(0x19bb0000), SPH_C32(0x845174a5), SPH_C32(0x18351092),
    SPH_C32(0x6a61325c), SPH_C32(0xa945f8ba), SPH_C32(0x2bc30000),
    SPH_C32(0xb5c60001), SPH_C32(0x7e7fff80), SPH_C32(0x30ec0000),
    SPH_C32(0x2ec41510), SPH_C32(0xbc8cc929), SPH_C32(0x4e8a7677),
    SPH_C32(0x79f83637) },
  { SPH_C32(0x248d0000), SPH_C32(0xb5b50001), SPH_C32(0xdb142780),
    SPH_C32(0x22eb0000), SPH_C32(0xcf81675a), SPH_C32(0x9fae248a),
    SPH_C32(0x03227a9d), SPH_C32(0x631f7f44), SPH_C32(0xaa5d0000),
    SPH_C32(0x59910001), SPH_C32(0x184dfd00), SPH_C32(0xa51f0000),
    SPH_C32(0x736d3d12), SPH_C32(0xf478f595), SPH_C32(0xa8d0d45a),
    SPH_C32(0xf79f81cd) },
  { SPH_C32(0x11240000), SPH_C32(0xee7d0001), SPH_C32(0x4ea52900),
    SPH_C32(0x1ced0000), SPH_C32(0xa8c674de), SPH_C32(0x2e28a50a),
    SPH_C32(0x7cb73013), SPH_C32(0x444dc4eb), SPH_C32(0x64e60000),
    SPH_C32(0x4bda0001), SPH_C32(0xf8e8f980), SPH_C32(0xc8d70000),
    SPH_C32(0x82306b3e), SPH_C32(0xf3ab07ea), SPH_C32(0x68cf8801),
    SPH_C32(0xc933ec48) },
  { SPH_C32(0xdd300000), SPH_C32(0x4b1e0001), SPH_C32(0x141c2e80),
    SPH_C32(0x27bd0000), SPH_C32(0xe3166721), SPH_C32(0xa9b39112),
    SPH_C32(0x15f478d2), SPH_C32(0x8e174315), SPH_C32(0xe5780000),
    SPH_C32(0xa78d0001), SPH_C32(0x9edafb00), SPH_C32(0x5d240000),
    SPH_C32(0xdf99433c), SPH_C32(0xbb5f3b56), SPH_C32(0x8e952a2c),
    SPH_C32(0x47545bb2) },
  { SPH_C32(0x90ba0000), SPH_C32(0x022a0001), SPH_C32(0x28972b80),
    SPH_C32(0x891e0000), SPH_C32(0xf56f5cdc), SPH_C32(0x66dc99b6),
    SPH_C32(0x9aed923e), SPH_C32(0xca2a7311), SPH_C32(0x296c0000),
    SPH_C32(0x02ee0001), SPH_C32(0xc463fc80), SPH_C32(0x66740000),
    SPH_C32(0x944950c3), SPH_C32(0x3cc40f4e), SPH_C32(0xe7d662ed),
    SPH_C32(0x8d0edc4c) },
  { SPH_C32(0x5cae0000), SPH_C32(0xa7490001), SPH_C32(0x722e2c00),
    SPH_C32(0xb24e0000), SPH_C32(0xbebf4f23), SPH_C32(0xe147adae),
    SPH_C32(0xf3aedaff), SPH_C32(0x0070f4ef), SPH_C32(0xa8f20000),
    SPH_C32(0xeeb90001), SPH_C32(0xa251fe00), SPH_C32(0xf3870000),
    SPH_C32(0xc9e078c1), SPH_C32(0x743033f2), SPH_C32(0x018cc0c0),
    SPH_C32(0x03696bb6) },
  { SPH_C32(0xc7e00000), SPH_C32(0x500f0001), SPH_C32(0x18783200),
    SPH_C32(0xd9930000), SPH_C32(0x39f0281e), SPH_C32(0xcf3bbaff),
    SPH_C32(0xdb154315), SPH_C32(0x4230ddcd), SPH_C32(0x028b0000),
    SPH_C32(0x87e90001), SPH_C32(0x3c2af380), SPH_C32(0x2f560000),
    SPH_C32(0x1f4944d9), SPH_C32(0x79e2e780), SPH_C32(0x55e03071),
    SPH_C32(0x32f62e8d) },
  { SPH_C32(0x0bf40000), SPH_C32(0xf56c0001), SPH_C32(0x42c13580),
    SPH_C32(0xe2c30000), SPH_C32(0x72203be1), SPH_C32(0x48a08ee7),
    SPH_C32(0xb2560bd4), SPH_C32(0x886a5a33), SPH_C32(0x83150000),
    SPH_C32(0x6bbe0001), SPH_C32(0x5a18f100), SPH_C32(0xbaa50000),
    SPH_C32(0x42e06cdb), SPH_C32(0x3116db3c), SPH_C32(0xb3ba925c),
    SPH_C32(0xbc919977) },
  { SPH_C32(0x467e0000), SPH_C32(0xbc580001), SPH_C32(0x7e4a3080),
    SPH_C32(0x4c600000), SPH_C32(0x6459001c), SPH_C32(0x87cf8643),
    SPH_C32(0x3d4fe138), SPH_C32(0xcc576a37), SPH_C32(0x4f010000),
    SPH_C32(0xcedd0001), SPH_C32(0x00a1f680), SPH_C32(0x81f50000),
    SPH_C32(0x09307f24), SPH_C32(0xb68def24), SPH_C32(0xdaf9da9d),
    SPH_C32(0x76cb1e89) },
  { SPH_C32(0x8a6a0000), SPH_C32(0x193b0001), SPH_C32(0x24f33700),
    SPH_C32(0x77300000), SPH_C32(0x2f8913e3), SPH_C32(0x0054b25b),
    SPH_C32(0x540ca9f9), SPH_C32(0x060dedc9), SPH_C32(0xce9f0000),
    SPH_C32(0x228a0001), SPH_C32(0x6693f400), SPH_C32(0x14060000),
    SPH_C32(0x54995726), SPH_C32(0xfe79d398), SPH_C32(0x3ca378b0),
    SPH_C32(0xf8aca973) },
  { SPH_C32(0xbfc30000), SPH_C32(0x42f30001), SPH_C32(0xb1423980),
    SPH_C32(0x49360000), SPH_C32(0x48ce0067), SPH_C32(0xb1d233db),
    SPH_C32(0x2b99e377), SPH_C32(0x215f5666), SPH_C32(0x00240000),
    SPH_C32(0x30c10001), SPH_C32(0x8636f080), SPH_C32(0x79ce0000),
    SPH_C32(0xa5c4010a), SPH_C32(0xf9aa21e7), SPH_C32(0xfcbc24eb),
    SPH_C32(0xc600c4f6) },
  { SPH_C32(0x73d70000), SPH_C32(0xe7900001), SPH_C32(0xebfb3e00),
    SPH_C32(0x72660000), SPH_C32(0x031e1398), SPH_C32(0x364907c3),
    SPH_C32(0x42daabb6), SPH_C32(0xeb05d198), SPH_C32(0x81ba0000),
    SPH_C32(0xdc960001), SPH_C32(0xe004f200), SPH_C32(0xec3d0000),
    SPH_C32(0xf86d2908), SPH_C32(0xb15e1d5b), SPH_C32(0x1ae686c6),
    SPH_C32(0x4867730c) },
  { SPH_C32(0x3e5d0000), SPH_C32(0xaea40001), SPH_C32(0xd7703b00),
    SPH_C32(0xdcc50000), SPH_C32(0x15672865), SPH_C32(0xf9260f67),
    SPH_C32(0xcdc3415a), SPH_C32(0xaf38e19c), SPH_C32(0x4dae0000),
    SPH_C32(0x79f50001), SPH_C32(0xbabdf580), SPH_C32(0xd76d0000),
    SPH_C32(0xb3bd3af7), SPH_C32(0x36c52943), SPH_C32(0x73a5ce07),
    SPH_C32(0x823df4f2) },
  { SPH_C32(0xf2490000), SPH_C32(0x0bc70001), SPH_C32(0x8dc93c80),
    SPH_C32(0xe7950000), SPH_C32(0x5eb73b9a), SPH_C32(0x7ebd3b7f),
    SPH_C32(0xa480099b), SPH_C32(0x65626662), SPH_C32(0xcc300000),
    SPH_C32(0x95a20001), SPH_C32(0xdc8ff700), SPH_C32(0x429e0000),
    SPH_C32(0xee1412f5), SPH_C32(0x7e3115ff), SPH_C32(0x95ff6c2a),
    SPH_C32(0x0c5a4308) },
  { SPH_C32(0xc54f0000), SPH_C32(0xe7270001), SPH_C32(0xa2643100),
    SPH_C32(0x8f0b0000), SPH_C32(0x837d6dcd), SPH_C32(0x4f737c98),
    SPH_C32(0x7249578f), SPH_C32(0xb6c637b6), SPH_C32(0x78070000),
    SPH_C32(0x223d0001), SPH_C32(0x2f0cfb00), SPH_C32(0xe96b0000),
    SPH_C32(0xd4fa2973), SPH_C32(0x8743a8c3), SPH_C32(0x0c308489),
    SPH_C32(0xa56f4f5d) },
  { SPH_C32(0x095b0000), SPH_C32(0x42440001), SPH_C32(0xf8dd3680),
    SPH_C32(0xb45b0000), SPH_C32(0xc8ad7e32), SPH_C32(0xc8e84880),
    SPH_C32(0x1b0a1f4e), SPH_C32(0x7c9cb048), SPH_C32(0xf9990000),
    SPH_C32(0xce6a0001), SPH_C32(0x493ef980), SPH_C32(0x7c980000),
    SPH_C32(0x89530171), SPH_C32(0xcfb7947f), SPH_C32(0xea6a26a4),
    SPH_C32(0x2b08f8a7) },
  { SPH_C32(0x44d10000), SPH_C32(0x0b700001), SPH_C32(0xc4563380),
    SPH_C32(0x1af80000), SPH_C32(0xded445cf), SPH_C32(0x07874024),
    SPH_C32(0x9413f5a2), SPH_C32(0x38a1804c), SPH_C32(0x358d0000),
    SPH_C32(0x6b090001), SPH_C32(0x1387fe00), SPH_C32(0x47c80000),
    SPH_C32(0xc283128e), SPH_C32(0x482ca067), SPH_C32(0x83296e65),
    SPH_C32(0xe1527f59) },
  { SPH_C32(0x88c50000), SPH_C32(0xae130001), SPH_C32(0x9eef3400),
    SPH_C32(0x21a80000), SPH_C32(0x95045630), SPH_C32(0x801c743c),
    SPH_C32(0xfd50bd63), SPH_C32(0xf2fb07b2), SPH_C32(0xb4130000),
    SPH_C32(0x875e0001), SPH_C32(0x75b5fc80), SPH_C32(0xd23b0000),
    SPH_C32(0x9f2a3a8c), SPH_C32(0x00d89cdb), SPH_C32(0x6573cc48),
    SPH_C32(0x6f35c8a3) },
  { SPH_C32(0xbd6c0000), SPH_C32(0xf5db0001), SPH_C32(0x0b5e3a80),
    SPH_C32(0x1fae0000), SPH_C32(0xf24345b4), SPH_C32(0x319af5bc),
    SPH_C32(0x82c5f7ed), SPH_C32(0xd5a9bc1d), SPH_C32(0x7aa80000),
    SPH_C32(0x95150001), SPH_C32(0x9510f800), SPH_C32(0xbff30000),
    SPH_C32(0x6e776ca0), SPH_C32(0x070b6ea4), SPH_C32(0xa56c9013),
    SPH_C32(0x5199a526) },
  { SPH_C32(0x71780000), SPH_C32(0x50b80001), SPH_C32(0x51e73d00),
    SPH_C32(0x24fe0000), SPH_C32(0xb993564b), SPH_C32(0xb601c1a4),
    SPH_C32(0xeb86bf2c), SPH_C32(0x1ff33be3), SPH_C32(0xfb360000),
    SPH_C32(0x79420001), SPH_C32(0xf322fa80), SPH_C32(0x2a000000),
    SPH_C32(0x33de44a2), SPH_C32(0x4fff5218), SPH_C32(0x4336323e),
    SPH_C32(0xdffe12dc) },
  { SPH_C32(0x3cf20000), SPH_C32(0x198c0001), SPH_C32(0x6d6c3800),
    SPH_C32(0x8a5d0000), SPH_C32(0xafea6db6), SPH_C32(0x796ec900),
    SPH_C32(0x649f55c0), SPH_C32(0x5bce0be7), SPH_C32(0x37220000),
    SPH_C32(0xdc210001), SPH_C32(0xa99bfd00), SPH_C32(0x11500000),
    SPH_C32(0x780e575d), SPH_C32(0xc8646600), SPH_C32(0x2a757aff),
    SPH_C32(0x15a49522) },
  { SPH_C32(0xf0e60000), SPH_C32(0xbcef0001), SPH_C32(0x37d53f80),
    SPH_C32(0xb10d0000), SPH_C32(0xe43a7e49), SPH_C32(0xfef5fd18),
    SPH_C32(0x0ddc1d01), SPH_C32(0x91948c19), SPH_C32(0xb6bc0000),
    SPH_C32(0x30760001), SPH_C32(0xcfa9ff80), SPH_C32(0x84a30000),
    SPH_C32(0x25a77f5f), SPH_C32(0x80905abc), SPH_C32(0xcc2fd8d2),
    SPH_C32(0x9bc322d8) }
};

__constant static const sph_u32 T512_40[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x58430000), SPH_C32(0x807e0000), SPH_C32(0x78330001),
    SPH_C32(0xc66b3800), SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd),
    SPH_C32(0xac73fe6f), SPH_C32(0x3a4479b1), SPH_C32(0x1d5a0000),
    SPH_C32(0x2b720000), SPH_C32(0x488d0000), SPH_C32(0xaf611800),
    SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0), SPH_C32(0x81a20429),
    SPH_C32(0x1e7536a6) },
  { SPH_C32(0x1d5a0000), SPH_C32(0x2b720000), SPH_C32(0x488d0000),
    SPH_C32(0xaf611800), SPH_C32(0x25cb2ec5), SPH_C32(0xc879bfd0),
    SPH_C32(0x81a20429), SPH_C32(0x1e7536a6), SPH_C32(0x45190000),
    SPH_C32(0xab0c0000), SPH_C32(0x30be0001), SPH_C32(0x690a2000),
    SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d), SPH_C32(0x2dd1fa46),
    SPH_C32(0x24314f17) },
  { SPH_C32(0x45190000), SPH_C32(0xab0c0000), SPH_C32(0x30be0001),
    SPH_C32(0x690a2000), SPH_C32(0xc2fc7219), SPH_C32(0xb1d4800d),
    SPH_C32(0x2dd1fa46), SPH_C32(0x24314f17), SPH_C32(0x58430000),
    SPH_C32(0x807e0000), SPH_C32(0x78330001), SPH_C32(0xc66b3800),
    SPH_C32(0xe7375cdc), SPH_C32(0x79ad3fdd), SPH_C32(0xac73fe6f),
    SPH_C32(0x3a4479b1) },
  { SPH_C32(0xa53b0000), SPH_C32(0x14260000), SPH_C32(0x4e30001e),
    SPH_C32(0x7cae0000), SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d),
    SPH_C32(0xf73168d8), SPH_C32(0x0b1b4946), SPH_C32(0x07ed0000),
    SPH_C32(0xb2500000), SPH_C32(0x8774000a), SPH_C32(0x970d0000),
    SPH_C32(0x437223ae), SPH_C32(0x48c76ea4), SPH_C32(0xf4786222),
    SPH_C32(0x9075b1ce) },
  { SPH_C32(0xfd780000), SPH_C32(0x94580000), SPH_C32(0x3603001f),
    SPH_C32(0xbac53800), SPH_C32(0x68a95109), SPH_C32(0x017295e0),
    SPH_C32(0x5b4296b7), SPH_C32(0x315f30f7), SPH_C32(0x1ab70000),
    SPH_C32(0x99220000), SPH_C32(0xcff9000a), SPH_C32(0x386c1800),
    SPH_C32(0x66b90d6b), SPH_C32(0x80bed174), SPH_C32(0x75da660b),
    SPH_C32(0x8e008768) },
  { SPH_C32(0xb8610000), SPH_C32(0x3f540000), SPH_C32(0x06bd001e),
    SPH_C32(0xd3cf1800), SPH_C32(0xaa552310), SPH_C32(0xb0a615ed),
    SPH_C32(0x76936cf1), SPH_C32(0x156e7fe0), SPH_C32(0x42f40000),
    SPH_C32(0x195c0000), SPH_C32(0xb7ca000b), SPH_C32(0xfe072000),
    SPH_C32(0x818e51b7), SPH_C32(0xf913eea9), SPH_C32(0xd9a99864),
    SPH_C32(0xb444fed9) },
  { SPH_C32(0xe0220000), SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f),
    SPH_C32(0x15a42000), SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30),
    SPH_C32(0xdae0929e), SPH_C32(0x2f2a0651), SPH_C32(0x5fae0000),
    SPH_C32(0x322e0000), SPH_C32(0xff47000b), SPH_C32(0x51663800),
    SPH_C32(0xa4457f72), SPH_C32(0x316a5179), SPH_C32(0x580b9c4d),
    SPH_C32(0xaa31c87f) },
  { SPH_C32(0x07ed0000), SPH_C32(0xb2500000), SPH_C32(0x8774000a),
    SPH_C32(0x970d0000), SPH_C32(0x437223ae), SPH_C32(0x48c76ea4),
    SPH_C32(0xf4786222), SPH_C32(0x9075b1ce), SPH_C32(0xa2d60000),
    SPH_C32(0xa6760000), SPH_C32(0xc9440014), SPH_C32(0xeba30000),
    SPH_C32(0xccec2e7b), SPH_C32(0x3018c499), SPH_C32(0x03490afa),
    SPH_C32(0x9b6ef888) },
  { SPH_C32(0x5fae0000), SPH_C32(0x322e0000), SPH_C32(0xff47000b),
    SPH_C32(0x51663800), SPH_C32(0xa4457f72), SPH_C32(0x316a5179),
    SPH_C32(0x580b9c4d), SPH_C32(0xaa31c87f), SPH_C32(0xbf8c0000),
    SPH_C32(0x8d040000), SPH_C32(0x81c90014), SPH_C32(0x44c21800),
    SPH_C32(0xe92700be), SPH_C32(0xf8617b49), SPH_C32(0x82eb0ed3),
    SPH_C32(0x851bce2e) },
  { SPH_C32(0x1ab70000), SPH_C32(0x99220000), SPH_C32(0xcff9000a),
    SPH_C32(0x386c1800), SPH_C32(0x66b90d6b), SPH_C32(0x80bed174),
    SPH_C32(0x75da660b), SPH_C32(0x8e008768), SPH_C32(0xe7cf0000),
    SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015), SPH_C32(0x82a92000),
    SPH_C32(0x0e105c62), SPH_C32(0x81cc4494), SPH_C32(0x2e98f0bc),
    SPH_C32(0xbf5fb79f) },
  { SPH_C32(0x42f40000), SPH_C32(0x195c0000), SPH_C32(0xb7ca000b),
    SPH_C32(0xfe072000), SPH_C32(0x818e51b7), SPH_C32(0xf913eea9),
    SPH_C32(0xd9a99864), SPH_C32(0xb444fed9), SPH_C32(0xfa950000),
    SPH_C32(0x26080000), SPH_C32(0xb1770015), SPH_C32(0x2dc83800),
    SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44), SPH_C32(0xaf3af495),
    SPH_C32(0xa12a8139) },
  { SPH_C32(0xa2d60000), SPH_C32(0xa6760000), SPH_C32(0xc9440014),
    SPH_C32(0xeba30000), SPH_C32(0xccec2e7b), SPH_C32(0x3018c499),
    SPH_C32(0x03490afa), SPH_C32(0x9b6ef888), SPH_C32(0xa53b0000),
    SPH_C32(0x14260000), SPH_C32(0x4e30001e), SPH_C32(0x7cae0000),
    SPH_C32(0x8f9e0dd5), SPH_C32(0x78dfaa3d), SPH_C32(0xf73168d8),
    SPH_C32(0x0b1b4946) },
  { SPH_C32(0xfa950000), SPH_C32(0x26080000), SPH_C32(0xb1770015),
    SPH_C32(0x2dc83800), SPH_C32(0x2bdb72a7), SPH_C32(0x49b5fb44),
    SPH_C32(0xaf3af495), SPH_C32(0xa12a8139), SPH_C32(0xb8610000),
    SPH_C32(0x3f540000), SPH_C32(0x06bd001e), SPH_C32(0xd3cf1800),
    SPH_C32(0xaa552310), SPH_C32(0xb0a615ed), SPH_C32(0x76936cf1),
    SPH_C32(0x156e7fe0) },
  { SPH_C32(0xbf8c0000), SPH_C32(0x8d040000), SPH_C32(0x81c90014),
    SPH_C32(0x44c21800), SPH_C32(0xe92700be), SPH_C32(0xf8617b49),
    SPH_C32(0x82eb0ed3), SPH_C32(0x851bce2e), SPH_C32(0xe0220000),
    SPH_C32(0xbf2a0000), SPH_C32(0x7e8e001f), SPH_C32(0x15a42000),
    SPH_C32(0x4d627fcc), SPH_C32(0xc90b2a30), SPH_C32(0xdae0929e),
    SPH_C32(0x2f2a0651) },
  { SPH_C32(0xe7cf0000), SPH_C32(0x0d7a0000), SPH_C32(0xf9fa0015),
    SPH_C32(0x82a92000), SPH_C32(0x0e105c62), SPH_C32(0x81cc4494),
    SPH_C32(0x2e98f0bc), SPH_C32(0xbf5fb79f), SPH_C32(0xfd780000),
    SPH_C32(0x94580000), SPH_C32(0x3603001f), SPH_C32(0xbac53800),
    SPH_C32(0x68a95109), SPH_C32(0x017295e0), SPH_C32(0x5b4296b7),
    SPH_C32(0x315f30f7) },
  { SPH_C32(0x88980000), SPH_C32(0x1f940000), SPH_C32(0x7fcf002e),
    SPH_C32(0xfb4e0000), SPH_C32(0xf158079a), SPH_C32(0x61ae9167),
    SPH_C32(0xa895706c), SPH_C32(0xe6107494), SPH_C32(0x0bc20000),
    SPH_C32(0xdb630000), SPH_C32(0x7e88000c), SPH_C32(0x15860000),
    SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43), SPH_C32(0xf460449e),
    SPH_C32(0xd8b61463) },
  { SPH_C32(0xd0db0000), SPH_C32(0x9fea0000), SPH_C32(0x07fc002f),
    SPH_C32(0x3d253800), SPH_C32(0x166f5b46), SPH_C32(0x1803aeba),
    SPH_C32(0x04e68e03), SPH_C32(0xdc540d25), SPH_C32(0x16980000),
    SPH_C32(0xf0110000), SPH_C32(0x3605000c), SPH_C32(0xbae71800),
    SPH_C32(0xb4366636), SPH_C32(0xbdf80493), SPH_C32(0x75c240b7),
    SPH_C32(0xc6c322c5) },
  { SPH_C32(0x95c20000), SPH_C32(0x34e60000), SPH_C32(0x3742002e),
    SPH_C32(0x542f1800), SPH_C32(0xd493295f), SPH_C32(0xa9d72eb7),
    SPH_C32(0x29377445), SPH_C32(0xf8654232), SPH_C32(0x4edb0000),
    SPH_C32(0x706f0000), SPH_C32(0x4e36000d), SPH_C32(0x7c8c2000),
    SPH_C32(0x53013aea), SPH_C32(0xc4553b4e), SPH_C32(0xd9b1bed8),
    SPH_C32(0xfc875b74) },
  { SPH_C32(0xcd810000), SPH_C32(0xb4980000), SPH_C32(0x4f71002f),
    SPH_C32(0x92442000), SPH_C32(0x33a47583), SPH_C32(0xd07a116a),
    SPH_C32(0x85448a2a), SPH_C32(0xc2213b83), SPH_C32(0x53810000),
    SPH_C32(0x5b1d0000), SPH_C32(0x06bb000d), SPH_C32(0xd3ed3800),
    SPH_C32(0x76ca142f), SPH_C32(0x0c2c849e), SPH_C32(0x5813baf1),
    SPH_C32(0xe2f26dd2) },
  { SPH_C32(0x2da30000), SPH_C32(0x0bb20000), SPH_C32(0x31ff0030),
    SPH_C32(0x87e00000), SPH_C32(0x7ec60a4f), SPH_C32(0x19713b5a),
    SPH_C32(0x5fa418b4), SPH_C32(0xed0b3dd2), SPH_C32(0x0c2f0000),
    SPH_C32(0x69330000), SPH_C32(0xf9fc0006), SPH_C32(0x828b0000),
    SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7), SPH_C32(0x001826bc),
    SPH_C32(0x48c3a5ad) },
  { SPH_C32(0x75e00000), SPH_C32(0x8bcc0000), SPH_C32(0x49cc0031),
    SPH_C32(0x418b3800), SPH_C32(0x99f15693), SPH_C32(0x60dc0487),
    SPH_C32(0xf3d7e6db), SPH_C32(0xd74f4463), SPH_C32(0x11750000),
    SPH_C32(0x42410000), SPH_C32(0xb1710006), SPH_C32(0x2dea1800),
    SPH_C32(0xf7444598), SPH_C32(0xf53f6a37), SPH_C32(0x81ba2295),
    SPH_C32(0x56b6930b) },
  { SPH_C32(0x30f90000), SPH_C32(0x20c00000), SPH_C32(0x79720030),
    SPH_C32(0x28811800), SPH_C32(0x5b0d248a), SPH_C32(0xd108848a),
    SPH_C32(0xde061c9d), SPH_C32(0xf37e0b74), SPH_C32(0x49360000),
    SPH_C32(0xc23f0000), SPH_C32(0xc9420007), SPH_C32(0xeb812000),
    SPH_C32(0x10731944), SPH_C32(0x8c9255ea), SPH_C32(0x2dc9dcfa),
    SPH_C32(0x6cf2eaba) },
  { SPH_C32(0x68ba0000), SPH_C32(0xa0be0000), SPH_C32(0x01410031),
    SPH_C32(0xeeea2000), SPH_C32(0xbc3a7856), SPH_C32(0xa8a5bb57),
    SPH_C32(0x7275e2f2), SPH_C32(0xc93a72c5), SPH_C32(0x546c0000),
    SPH_C32(0xe94d0000), SPH_C32(0x81cf0007), SPH_C32(0x44e03800),
    SPH_C32(0x35b83781), SPH_C32(0x44ebea3a), SPH_C32(0xac6bd8d3),
    SPH_C32(0x7287dc1c) },
  { SPH_C32(0x8f750000), SPH_C32(0xadc40000), SPH_C32(0xf8bb0024),
    SPH_C32(0x6c430000), SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3),
    SPH_C32(0x5ced124e), SPH_C32(0x7665c55a), SPH_C32(0xa9140000),
    SPH_C32(0x7d150000), SPH_C32(0xb7cc0018), SPH_C32(0xfe250000),
    SPH_C32(0x5d116688), SPH_C32(0x45997fda), SPH_C32(0xf7294e64),
    SPH_C32(0x43d8eceb) },
  { SPH_C32(0xd7360000), SPH_C32(0x2dba0000), SPH_C32(0x80880025),
    SPH_C32(0xaa283800), SPH_C32(0x551d78e8), SPH_C32(0x50c4c01e),
    SPH_C32(0xf09eec21), SPH_C32(0x4c21bceb), SPH_C32(0xb44e0000),
    SPH_C32(0x56670000), SPH_C32(0xff410018), SPH_C32(0x51441800),
    SPH_C32(0x78da484d), SPH_C32(0x8de0c00a), SPH_C32(0x768b4a4d),
    SPH_C32(0x5dadda4d) },
  { SPH_C32(0x922f0000), SPH_C32(0x86b60000), SPH_C32(0xb0360024),
    SPH_C32(0xc3221800), SPH_C32(0x97e10af1), SPH_C32(0xe1104013),
    SPH_C32(0xdd4f1667), SPH_C32(0x6810f3fc), SPH_C32(0xec0d0000),
    SPH_C32(0xd6190000), SPH_C32(0x87720019), SPH_C32(0x972f2000),
    SPH_C32(0x9fed1491), SPH_C32(0xf44dffd7), SPH_C32(0xdaf8b422),
    SPH_C32(0x67e9a3fc) },
  { SPH_C32(0xca6c0000), SPH_C32(0x06c80000), SPH_C32(0xc8050025),
    SPH_C32(0x05492000), SPH_C32(0x70d6562d), SPH_C32(0x98bd7fce),
    SPH_C32(0x713ce808), SPH_C32(0x52548a4d), SPH_C32(0xf1570000),
    SPH_C32(0xfd6b0000), SPH_C32(0xcfff0019), SPH_C32(0x384e3800),
    SPH_C32(0xba263a54), SPH_C32(0x3c344007), SPH_C32(0x5b5ab00b),
    SPH_C32(0x799c955a) },
  { SPH_C32(0x2a4e0000), SPH_C32(0xb9e20000), SPH_C32(0xb68b003a),
    SPH_C32(0x10ed0000), SPH_C32(0x3db429e1), SPH_C32(0x51b655fe),
    SPH_C32(0xabdc7a96), SPH_C32(0x7d7e8c1c), SPH_C32(0xaef90000),
    SPH_C32(0xcf450000), SPH_C32(0x30b80012), SPH_C32(0x69280000),
    SPH_C32(0x1e634526), SPH_C32(0x0d5e117e), SPH_C32(0x03512c46),
    SPH_C32(0xd3ad5d25) },
  { SPH_C32(0x720d0000), SPH_C32(0x399c0000), SPH_C32(0xceb8003b),
    SPH_C32(0xd6863800), SPH_C32(0xda83753d), SPH_C32(0x281b6a23),
    SPH_C32(0x07af84f9), SPH_C32(0x473af5ad), SPH_C32(0xb3a30000),
    SPH_C32(0xe4370000), SPH_C32(0x78350012), SPH_C32(0xc6491800),
    SPH_C32(0x3ba86be3), SPH_C32(0xc527aeae), SPH_C32(0x82f3286f),
    SPH_C32(0xcdd86b83) },
  { SPH_C32(0x37140000), SPH_C32(0x92900000), SPH_C32(0xfe06003a),
    SPH_C32(0xbf8c1800), SPH_C32(0x187f0724), SPH_C32(0x99cfea2e),
    SPH_C32(0x2a7e7ebf), SPH_C32(0x630bbaba), SPH_C32(0xebe00000),
    SPH_C32(0x64490000), SPH_C32(0x00060013), SPH_C32(0x00222000),
    SPH_C32(0xdc9f373f), SPH_C32(0xbc8a9173), SPH_C32(0x2e80d600),
    SPH_C32(0xf79c1232) },
  { SPH_C32(0x6f570000), SPH_C32(0x12ee0000), SPH_C32(0x8635003b),
    SPH_C32(0x79e72000), SPH_C32(0xff485bf8), SPH_C32(0xe062d5f3),
    SPH_C32(0x860d80d0), SPH_C32(0x594fc30b), SPH_C32(0xf6ba0000),
    SPH_C32(0x4f3b0000), SPH_C32(0x488b0013), SPH_C32(0xaf433800),
    SPH_C32(0xf95419fa), SPH_C32(0x74f32ea3), SPH_C32(0xaf22d229),
    SPH_C32(0xe9e92494) },
  { SPH_C32(0x0bc20000), SPH_C32(0xdb630000), SPH_C32(0x7e88000c),
    SPH_C32(0x15860000), SPH_C32(0x91fd48f3), SPH_C32(0x7581bb43),
    SPH_C32(0xf460449e), SPH_C32(0xd8b61463), SPH_C32(0x835a0000),
    SPH_C32(0xc4f70000), SPH_C32(0x01470022), SPH_C32(0xeec80000),
    SPH_C32(0x60a54f69), SPH_C32(0x142f2a24), SPH_C32(0x5cf534f2),
    SPH_C32(0x3ea660f7) },
  { SPH_C32(0x53810000), SPH_C32(0x5b1d0000), SPH_C32(0x06bb000d),
    SPH_C32(0xd3ed3800), SPH_C32(0x76ca142f), SPH_C32(0x0c2c849e),
    SPH_C32(0x5813baf1), SPH_C32(0xe2f26dd2), SPH_C32(0x9e000000),
    SPH_C32(0xef850000), SPH_C32(0x49ca0022), SPH_C32(0x41a91800),
    SPH_C32(0x456e61ac), SPH_C32(0xdc5695f4), SPH_C32(0xdd5730db),
    SPH_C32(0x20d35651) },
  { SPH_C32(0x16980000), SPH_C32(0xf0110000), SPH_C32(0x3605000c),
    SPH_C32(0xbae71800), SPH_C32(0xb4366636), SPH_C32(0xbdf80493),
    SPH_C32(0x75c240b7), SPH_C32(0xc6c322c5), SPH_C32(0xc6430000),
    SPH_C32(0x6ffb0000), SPH_C32(0x31f90023), SPH_C32(0x87c22000),
    SPH_C32(0xa2593d70), SPH_C32(0xa5fbaa29), SPH_C32(0x7124ceb4),
    SPH_C32(0x1a972fe0) },
  { SPH_C32(0x4edb0000), SPH_C32(0x706f0000), SPH_C32(0x4e36000d),
    SPH_C32(0x7c8c2000), SPH_C32(0x53013aea), SPH_C32(0xc4553b4e),
    SPH_C32(0xd9b1bed8), SPH_C32(0xfc875b74), SPH_C32(0xdb190000),
    SPH_C32(0x44890000), SPH_C32(0x79740023), SPH_C32(0x28a33800),
    SPH_C32(0x879213b5), SPH_C32(0x6d8215f9), SPH_C32(0xf086ca9d),
    SPH_C32(0x04e21946) },
  { SPH_C32(0xaef90000), SPH_C32(0xcf450000), SPH_C32(0x30b80012),
    SPH_C32(0x69280000), SPH_C32(0x1e634526), SPH_C32(0x0d5e117e),
    SPH_C32(0x03512c46), SPH_C32(0xd3ad5d25), SPH_C32(0x84b70000),
    SPH_C32(0x76a70000), SPH_C32(0x86330028), SPH_C32(0x79c50000),
    SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480), SPH_C32(0xa88d56d0),
    SPH_C32(0xaed3d139) },
  { SPH_C32(0xf6ba0000), SPH_C32(0x4f3b0000), SPH_C32(0x488b0013),
    SPH_C32(0xaf433800), SPH_C32(0xf95419fa), SPH_C32(0x74f32ea3),
    SPH_C32(0xaf22d229), SPH_C32(0xe9e92494), SPH_C32(0x99ed0000),
    SPH_C32(0x5dd50000), SPH_C32(0xcebe0028), SPH_C32(0xd6a41800),
    SPH_C32(0x061c4202), SPH_C32(0x9491fb50), SPH_C32(0x292f52f9),
    SPH_C32(0xb0a6e79f) },
  { SPH_C32(0xb3a30000), SPH_C32(0xe4370000), SPH_C32(0x78350012),
    SPH_C32(0xc6491800), SPH_C32(0x3ba86be3), SPH_C32(0xc527aeae),
    SPH_C32(0x82f3286f), SPH_C32(0xcdd86b83), SPH_C32(0xc1ae0000),
    SPH_C32(0xddab0000), SPH_C32(0xb68d0029), SPH_C32(0x10cf2000),
    SPH_C32(0xe12b1ede), SPH_C32(0xed3cc48d), SPH_C32(0x855cac96),
    SPH_C32(0x8ae29e2e) },
  { SPH_C32(0xebe00000), SPH_C32(0x64490000), SPH_C32(0x00060013),
    SPH_C32(0x00222000), SPH_C32(0xdc9f373f), SPH_C32(0xbc8a9173),
    SPH_C32(0x2e80d600), SPH_C32(0xf79c1232), SPH_C32(0xdcf40000),
    SPH_C32(0xf6d90000), SPH_C32(0xfe000029), SPH_C32(0xbfae3800),
    SPH_C32(0xc4e0301b), SPH_C32(0x25457b5d), SPH_C32(0x04fea8bf),
    SPH_C32(0x9497a888) },
  { SPH_C32(0x0c2f0000), SPH_C32(0x69330000), SPH_C32(0xf9fc0006),
    SPH_C32(0x828b0000), SPH_C32(0xd28f6b5d), SPH_C32(0x3d46d5e7),
    SPH_C32(0x001826bc), SPH_C32(0x48c3a5ad), SPH_C32(0x218c0000),
    SPH_C32(0x62810000), SPH_C32(0xc8030036), SPH_C32(0x056b0000),
    SPH_C32(0xac496112), SPH_C32(0x2437eebd), SPH_C32(0x5fbc3e08),
    SPH_C32(0xa5c8987f) },
  { SPH_C32(0x546c0000), SPH_C32(0xe94d0000), SPH_C32(0x81cf0007),
    SPH_C32(0x44e03800), SPH_C32(0x35b83781), SPH_C32(0x44ebea3a),
    SPH_C32(0xac6bd8d3), SPH_C32(0x7287dc1c), SPH_C32(0x3cd60000),
    SPH_C32(0x49f30000), SPH_C32(0x808e0036), SPH_C32(0xaa0a1800),
    SPH_C32(0x89824fd7), SPH_C32(0xec4e516d), SPH_C32(0xde1e3a21),
    SPH_C32(0xbbbdaed9) },
  { SPH_C32(0x11750000), SPH_C32(0x42410000), SPH_C32(0xb1710006),
    SPH_C32(0x2dea1800), SPH_C32(0xf7444598), SPH_C32(0xf53f6a37),
    SPH_C32(0x81ba2295), SPH_C32(0x56b6930b), SPH_C32(0x64950000),
    SPH_C32(0xc98d0000), SPH_C32(0xf8bd0037), SPH_C32(0x6c612000),
    SPH_C32(0x6eb5130b), SPH_C32(0x95e36eb0), SPH_C32(0x726dc44e),
    SPH_C32(0x81f9d768) },
  { SPH_C32(0x49360000), SPH_C32(0xc23f0000), SPH_C32(0xc9420007),
    SPH_C32(0xeb812000), SPH_C32(0x10731944), SPH_C32(0x8c9255ea),
    SPH_C32(0x2dc9dcfa), SPH_C32(0x6cf2eaba), SPH_C32(0x79cf0000),
    SPH_C32(0xe2ff0000), SPH_C32(0xb0300037), SPH_C32(0xc3003800),
    SPH_C32(0x4b7e3dce), SPH_C32(0x5d9ad160), SPH_C32(0xf3cfc067),
    SPH_C32(0x9f8ce1ce) },
  { SPH_C32(0xa9140000), SPH_C32(0x7d150000), SPH_C32(0xb7cc0018),
    SPH_C32(0xfe250000), SPH_C32(0x5d116688), SPH_C32(0x45997fda),
    SPH_C32(0xf7294e64), SPH_C32(0x43d8eceb), SPH_C32(0x26610000),
    SPH_C32(0xd0d10000), SPH_C32(0x4f77003c), SPH_C32(0x92660000),
    SPH_C32(0xef3b42bc), SPH_C32(0x6cf08019), SPH_C32(0xabc45c2a),
    SPH_C32(0x35bd29b1) },
  { SPH_C32(0xf1570000), SPH_C32(0xfd6b0000), SPH_C32(0xcfff0019),
    SPH_C32(0x384e3800), SPH_C32(0xba263a54), SPH_C32(0x3c344007),
    SPH_C32(0x5b5ab00b), SPH_C32(0x799c955a), SPH_C32(0x3b3b0000),
    SPH_C32(0xfba30000), SPH_C32(0x07fa003c), SPH_C32(0x3d071800),
    SPH_C32(0xcaf06c79), SPH_C32(0xa4893fc9), SPH_C32(0x2a665803),
    SPH_C32(0x2bc81f17) },
  { SPH_C32(0xb44e0000), SPH_C32(0x56670000), SPH_C32(0xff410018),
    SPH_C32(0x51441800), SPH_C32(0x78da484d), SPH_C32(0x8de0c00a),
    SPH_C32(0x768b4a4d), SPH_C32(0x5dadda4d), SPH_C32(0x63780000),
    SPH_C32(0x7bdd0000), SPH_C32(0x7fc9003d), SPH_C32(0xfb6c2000),
    SPH_C32(0x2dc730a5), SPH_C32(0xdd240014), SPH_C32(0x8615a66c),
    SPH_C32(0x118c66a6) },
  { SPH_C32(0xec0d0000), SPH_C32(0xd6190000), SPH_C32(0x87720019),
    SPH_C32(0x972f2000), SPH_C32(0x9fed1491), SPH_C32(0xf44dffd7),
    SPH_C32(0xdaf8b422), SPH_C32(0x67e9a3fc), SPH_C32(0x7e220000),
    SPH_C32(0x50af0000), SPH_C32(0x3744003d), SPH_C32(0x540d3800),
    SPH_C32(0x080c1e60), SPH_C32(0x155dbfc4), SPH_C32(0x07b7a245),
    SPH_C32(0x0ff95000) },
  { SPH_C32(0x835a0000), SPH_C32(0xc4f70000), SPH_C32(0x01470022),
    SPH_C32(0xeec80000), SPH_C32(0x60a54f69), SPH_C32(0x142f2a24),
    SPH_C32(0x5cf534f2), SPH_C32(0x3ea660f7), SPH_C32(0x88980000),
    SPH_C32(0x1f940000), SPH_C32(0x7fcf002e), SPH_C32(0xfb4e0000),
    SPH_C32(0xf158079a), SPH_C32(0x61ae9167), SPH_C32(0xa895706c),
    SPH_C32(0xe6107494) },
  { SPH_C32(0xdb190000), SPH_C32(0x44890000), SPH_C32(0x79740023),
    SPH_C32(0x28a33800), SPH_C32(0x879213b5), SPH_C32(0x6d8215f9),
    SPH_C32(0xf086ca9d), SPH_C32(0x04e21946), SPH_C32(0x95c20000),
    SPH_C32(0x34e60000), SPH_C32(0x3742002e), SPH_C32(0x542f1800),
    SPH_C32(0xd493295f), SPH_C32(0xa9d72eb7), SPH_C32(0x29377445),
    SPH_C32(0xf8654232) },
  { SPH_C32(0x9e000000), SPH_C32(0xef850000), SPH_C32(0x49ca0022),
    SPH_C32(0x41a91800), SPH_C32(0x456e61ac), SPH_C32(0xdc5695f4),
    SPH_C32(0xdd5730db), SPH_C32(0x20d35651), SPH_C32(0xcd810000),
    SPH_C32(0xb4980000), SPH_C32(0x4f71002f), SPH_C32(0x92442000),
    SPH_C32(0x33a47583), SPH_C32(0xd07a116a), SPH_C32(0x85448a2a),
    SPH_C32(0xc2213b83) },
  { SPH_C32(0xc6430000), SPH_C32(0x6ffb0000), SPH_C32(0x31f90023),
    SPH_C32(0x87c22000), SPH_C32(0xa2593d70), SPH_C32(0xa5fbaa29),
    SPH_C32(0x7124ceb4), SPH_C32(0x1a972fe0), SPH_C32(0xd0db0000),
    SPH_C32(0x9fea0000), SPH_C32(0x07fc002f), SPH_C32(0x3d253800),
    SPH_C32(0x166f5b46), SPH_C32(0x1803aeba), SPH_C32(0x04e68e03),
    SPH_C32(0xdc540d25) },
  { SPH_C32(0x26610000), SPH_C32(0xd0d10000), SPH_C32(0x4f77003c),
    SPH_C32(0x92660000), SPH_C32(0xef3b42bc), SPH_C32(0x6cf08019),
    SPH_C32(0xabc45c2a), SPH_C32(0x35bd29b1), SPH_C32(0x8f750000),
    SPH_C32(0xadc40000), SPH_C32(0xf8bb0024), SPH_C32(0x6c430000),
    SPH_C32(0xb22a2434), SPH_C32(0x2969ffc3), SPH_C32(0x5ced124e),
    SPH_C32(0x7665c55a) },
  { SPH_C32(0x7e220000), SPH_C32(0x50af0000), SPH_C32(0x3744003d),
    SPH_C32(0x540d3800), SPH_C32(0x080c1e60), SPH_C32(0x155dbfc4),
    SPH_C32(0x07b7a245), SPH_C32(0x0ff95000), SPH_C32(0x922f0000),
    SPH_C32(0x86b60000), SPH_C32(0xb0360024), SPH_C32(0xc3221800),
    SPH_C32(0x97e10af1), SPH_C32(0xe1104013), SPH_C32(0xdd4f1667),
    SPH_C32(0x6810f3fc) },
  { SPH_C32(0x3b3b0000), SPH_C32(0xfba30000), SPH_C32(0x07fa003c),
    SPH_C32(0x3d071800), SPH_C32(0xcaf06c79), SPH_C32(0xa4893fc9),
    SPH_C32(0x2a665803), SPH_C32(0x2bc81f17), SPH_C32(0xca6c0000),
    SPH_C32(0x06c80000), SPH_C32(0xc8050025), SPH_C32(0x05492000),
    SPH_C32(0x70d6562d), SPH_C32(0x98bd7fce), SPH_C32(0x713ce808),
    SPH_C32(0x52548a4d) },
  { SPH_C32(0x63780000), SPH_C32(0x7bdd0000), SPH_C32(0x7fc9003d),
    SPH_C32(0xfb6c2000), SPH_C32(0x2dc730a5), SPH_C32(0xdd240014),
    SPH_C32(0x8615a66c), SPH_C32(0x118c66a6), SPH_C32(0xd7360000),
    SPH_C32(0x2dba0000), SPH_C32(0x80880025), SPH_C32(0xaa283800),
    SPH_C32(0x551d78e8), SPH_C32(0x50c4c01e), SPH_C32(0xf09eec21),
    SPH_C32(0x4c21bceb) },
  { SPH_C32(0x84b70000), SPH_C32(0x76a70000), SPH_C32(0x86330028),
    SPH_C32(0x79c50000), SPH_C32(0x23d76cc7), SPH_C32(0x5ce84480),
    SPH_C32(0xa88d56d0), SPH_C32(0xaed3d139), SPH_C32(0x2a4e0000),
    SPH_C32(0xb9e20000), SPH_C32(0xb68b003a), SPH_C32(0x10ed0000),
    SPH_C32(0x3db429e1), SPH_C32(0x51b655fe), SPH_C32(0xabdc7a96),
    SPH_C32(0x7d7e8c1c) },
  { SPH_C32(0xdcf40000), SPH_C32(0xf6d90000), SPH_C32(0xfe000029),
    SPH_C32(0xbfae3800), SPH_C32(0xc4e0301b), SPH_C32(0x25457b5d),
    SPH_C32(0x04fea8bf), SPH_C32(0x9497a888), SPH_C32(0x37140000),
    SPH_C32(0x92900000), SPH_C32(0xfe06003a), SPH_C32(0xbf8c1800),
    SPH_C32(0x187f0724), SPH_C32(0x99cfea2e), SPH_C32(0x2a7e7ebf),
    SPH_C32(0x630bbaba) },
  { SPH_C32(0x99ed0000), SPH_C32(0x5dd50000), SPH_C32(0xcebe0028),
    SPH_C32(0xd6a41800), SPH_C32(0x061c4202), SPH_C32(0x9491fb50),
    SPH_C32(0x292f52f9), SPH_C32(0xb0a6e79f), SPH_C32(0x6f570000),
    SPH_C32(0x12ee0000), SPH_C32(0x8635003b), SPH_C32(0x79e72000),
    SPH_C32(0xff485bf8), SPH_C32(0xe062d5f3), SPH_C32(0x860d80d0),
    SPH_C32(0x594fc30b) },
  { SPH_C32(0xc1ae0000), SPH_C32(0xddab0000), SPH_C32(0xb68d0029),
    SPH_C32(0x10cf2000), SPH_C32(0xe12b1ede), SPH_C32(0xed3cc48d),
    SPH_C32(0x855cac96), SPH_C32(0x8ae29e2e), SPH_C32(0x720d0000),
    SPH_C32(0x399c0000), SPH_C32(0xceb8003b), SPH_C32(0xd6863800),
    SPH_C32(0xda83753d), SPH_C32(0x281b6a23), SPH_C32(0x07af84f9),
    SPH_C32(0x473af5ad) },
  { SPH_C32(0x218c0000), SPH_C32(0x62810000), SPH_C32(0xc8030036),
    SPH_C32(0x056b0000), SPH_C32(0xac496112), SPH_C32(0x2437eebd),
    SPH_C32(0x5fbc3e08), SPH_C32(0xa5c8987f), SPH_C32(0x2da30000),
    SPH_C32(0x0bb20000), SPH_C32(0x31ff0030), SPH_C32(0x87e00000),
    SPH_C32(0x7ec60a4f), SPH_C32(0x19713b5a), SPH_C32(0x5fa418b4),
    SPH_C32(0xed0b3dd2) },
  { SPH_C32(0x79cf0000), SPH_C32(0xe2ff0000), SPH_C32(0xb0300037),
    SPH_C32(0xc3003800), SPH_C32(0x4b7e3dce), SPH_C32(0x5d9ad160),
    SPH_C32(0xf3cfc067), SPH_C32(0x9f8ce1ce), SPH_C32(0x30f90000),
    SPH_C32(0x20c00000), SPH_C32(0x79720030), SPH_C32(0x28811800),
    SPH_C32(0x5b0d248a), SPH_C32(0xd108848a), SPH_C32(0xde061c9d),
    SPH_C32(0xf37e0b74) },
  { SPH_C32(0x3cd60000), SPH_C32(0x49f30000), SPH_C32(0x808e0036),
    SPH_C32(0xaa0a1800), SPH_C32(0x89824fd7), SPH_C32(0xec4e516d),
    SPH_C32(0xde1e3a21), SPH_C32(0xbbbdaed9), SPH_C32(0x68ba0000),
    SPH_C32(0xa0be0000), SPH_C32(0x01410031), SPH_C32(0xeeea2000),
    SPH_C32(0xbc3a7856), SPH_C32(0xa8a5bb57), SPH_C32(0x7275e2f2),
    SPH_C32(0xc93a72c5) },
  { SPH_C32(0x64950000), SPH_C32(0xc98d0000), SPH_C32(0xf8bd0037),
    SPH_C32(0x6c612000), SPH_C32(0x6eb5130b), SPH_C32(0x95e36eb0),
    SPH_C32(0x726dc44e), SPH_C32(0x81f9d768), SPH_C32(0x75e00000),
    SPH_C32(0x8bcc0000), SPH_C32(0x49cc0031), SPH_C32(0x418b3800),
    SPH_C32(0x99f15693), SPH_C32(0x60dc0487), SPH_C32(0xf3d7e6db),
    SPH_C32(0xd74f4463) },
  { SPH_C32(0x52500000), SPH_C32(0x29540000), SPH_C32(0x6a61004e),
    SPH_C32(0xf0ff0000), SPH_C32(0x9a317eec), SPH_C32(0x452341ce),
    SPH_C32(0xcf568fe5), SPH_C32(0x5303130f), SPH_C32(0x538d0000),
    SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006), SPH_C32(0x56ff0000),
    SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9), SPH_C32(0xa9444018),
    SPH_C32(0x7f975691) },
  { SPH_C32(0x0a130000), SPH_C32(0xa92a0000), SPH_C32(0x1252004f),
    SPH_C32(0x36943800), SPH_C32(0x7d062230), SPH_C32(0x3c8e7e13),
    SPH_C32(0x6325718a), SPH_C32(0x69476abe), SPH_C32(0x4ed70000),
    SPH_C32(0x828e0000), SPH_C32(0xd67a0006), SPH_C32(0xf99e1800),
    SPH_C32(0x2f2f2e8b), SPH_C32(0x5abc7229), SPH_C32(0x28e64431),
    SPH_C32(0x61e26037) },
  { SPH_C32(0x4f0a0000), SPH_C32(0x02260000), SPH_C32(0x22ec004e),
    SPH_C32(0x5f9e1800), SPH_C32(0xbffa5029), SPH_C32(0x8d5afe1e),
    SPH_C32(0x4ef48bcc), SPH_C32(0x4d7625a9), SPH_C32(0x16940000),
    SPH_C32(0x02f00000), SPH_C32(0xae490007), SPH_C32(0x3ff52000),
    SPH_C32(0xc8187257), SPH_C32(0x23114df4), SPH_C32(0x8495ba5e),
    SPH_C32(0x5ba61986) },
  { SPH_C32(0x17490000), SPH_C32(0x82580000), SPH_C32(0x5adf004f),
    SPH_C32(0x99f52000), SPH_C32(0x58cd0cf5), SPH_C32(0xf4f7c1c3),
    SPH_C32(0xe28775a3), SPH_C32(0x77325c18), SPH_C32(0x0bce0000),
    SPH_C32(0x29820000), SPH_C32(0xe6c40007), SPH_C32(0x90943800),
    SPH_C32(0xedd35c92), SPH_C32(0xeb68f224), SPH_C32(0x0537be77),
    SPH_C32(0x45d32f20) },
  { SPH_C32(0xf76b0000), SPH_C32(0x3d720000), SPH_C32(0x24510050),
    SPH_C32(0x8c510000), SPH_C32(0x15af7339), SPH_C32(0x3dfcebf3),
    SPH_C32(0x3867e73d), SPH_C32(0x58185a49), SPH_C32(0x54600000),
    SPH_C32(0x1bac0000), SPH_C32(0x1983000c), SPH_C32(0xc1f20000),
    SPH_C32(0x499623e0), SPH_C32(0xda02a35d), SPH_C32(0x5d3c223a),
    SPH_C32(0xefe2e75f) },
  { SPH_C32(0xaf280000), SPH_C32(0xbd0c0000), SPH_C32(0x5c620051),
    SPH_C32(0x4a3a3800), SPH_C32(0xf2982fe5), SPH_C32(0x4451d42e),
    SPH_C32(0x94141952), SPH_C32(0x625c23f8), SPH_C32(0x493a0000),
    SPH_C32(0x30de0000), SPH_C32(0x510e000c), SPH_C32(0x6e931800),
    SPH_C32(0x6c5d0d25), SPH_C32(0x127b1c8d), SPH_C32(0xdc9e2613),
    SPH_C32(0xf197d1f9) },
  { SPH_C32(0xea310000), SPH_C32(0x16000000), SPH_C32(0x6cdc0050),
    SPH_C32(0x23301800), SPH_C32(0x30645dfc), SPH_C32(0xf5855423),
    SPH_C32(0xb9c5e314), SPH_C32(0x466d6cef), SPH_C32(0x11790000),
    SPH_C32(0xb0a00000), SPH_C32(0x293d000d), SPH_C32(0xa8f82000),
    SPH_C32(0x8b6a51f9), SPH_C32(0x6bd62350), SPH_C32(0x70edd87c),
    SPH_C32(0xcbd3a848) },
  { SPH_C32(0xb2720000), SPH_C32(0x967e0000), SPH_C32(0x14ef0051),
    SPH_C32(0xe55b2000), SPH_C32(0xd7530120), SPH_C32(0x8c286bfe),
    SPH_C32(0x15b61d7b), SPH_C32(0x7c29155e), SPH_C32(0x0c230000),
    SPH_C32(0x9bd20000), SPH_C32(0x61b0000d), SPH_C32(0x07993800),
    SPH_C32(0xaea17f3c), SPH_C32(0xa3af9c80), SPH_C32(0xf14fdc55),
    SPH_C32(0xd5a69eee) },
  { SPH_C32(0x55bd0000), SPH_C32(0x9b040000), SPH_C32(0xed150044),
    SPH_C32(0x67f20000), SPH_C32(0xd9435d42), SPH_C32(0x0de42f6a),
    SPH_C32(0x3b2eedc7), SPH_C32(0xc376a2c1), SPH_C32(0xf15b0000),
    SPH_C32(0x0f8a0000), SPH_C32(0x57b30012), SPH_C32(0xbd5c0000),
    SPH_C32(0xc6082e35), SPH_C32(0xa2dd0960), SPH_C32(0xaa0d4ae2),
    SPH_C32(0xe4f9ae19) },
  { SPH_C32(0x0dfe0000), SPH_C32(0x1b7a0000), SPH_C32(0x95260045),
    SPH_C32(0xa1993800), SPH_C32(0x3e74019e), SPH_C32(0x744910b7),
    SPH_C32(0x975d13a8), SPH_C32(0xf932db70), SPH_C32(0xec010000),
    SPH_C32(0x24f80000), SPH_C32(0x1f3e0012), SPH_C32(0x123d1800),
    SPH_C32(0xe3c300f0), SPH_C32(0x6aa4b6b0), SPH_C32(0x2baf4ecb),
    SPH_C32(0xfa8c98bf) },
  { SPH_C32(0x48e70000), SPH_C32(0xb0760000), SPH_C32(0xa5980044),
    SPH_C32(0xc8931800), SPH_C32(0xfc887387), SPH_C32(0xc59d90ba),
    SPH_C32(0xba8ce9ee), SPH_C32(0xdd039467), SPH_C32(0xb4420000),
    SPH_C32(0xa4860000), SPH_C32(0x670d0013), SPH_C32(0xd4562000),
    SPH_C32(0x04f45c2c), SPH_C32(0x1309896d), SPH_C32(0x87dcb0a4),
    SPH_C32(0xc0c8e10e) },
  { SPH_C32(0x10a40000), SPH_C32(0x30080000), SPH_C32(0xddab0045),
    SPH_C32(0x0ef82000), SPH_C32(0x1bbf2f5b), SPH_C32(0xbc30af67),
    SPH_C32(0x16ff1781), SPH_C32(0xe747edd6), SPH_C32(0xa9180000),
    SPH_C32(0x8ff40000), SPH_C32(0x2f800013), SPH_C32(0x7b373800),
    SPH_C32(0x213f72e9), SPH_C32(0xdb7036bd), SPH_C32(0x067eb48d),
    SPH_C32(0xdebdd7a8) },
  { SPH_C32(0xf0860000), SPH_C32(0x8f220000), SPH_C32(0xa325005a),
    SPH_C32(0x1b5c0000), SPH_C32(0x56dd5097), SPH_C32(0x753b8557),
    SPH_C32(0xcc1f851f), SPH_C32(0xc86deb87), SPH_C32(0xf6b60000),
    SPH_C32(0xbdda0000), SPH_C32(0xd0c70018), SPH_C32(0x2a510000),
    SPH_C32(0x857a0d9b), SPH_C32(0xea1a67c4), SPH_C32(0x5e7528c0),
    SPH_C32(0x748c1fd7) },
  { SPH_C32(0xa8c50000), SPH_C32(0x0f5c0000), SPH_C32(0xdb16005b),
    SPH_C32(0xdd373800), SPH_C32(0xb1ea0c4b), SPH_C32(0x0c96ba8a),
    SPH_C32(0x606c7b70), SPH_C32(0xf2299236), SPH_C32(0xebec0000),
    SPH_C32(0x96a80000), SPH_C32(0x984a0018), SPH_C32(0x85301800),
    SPH_C32(0xa0b1235e), SPH_C32(0x2263d814), SPH_C32(0xdfd72ce9),
    SPH_C32(0x6af92971) },
  { SPH_C32(0xeddc0000), SPH_C32(0xa4500000), SPH_C32(0xeba8005a),
    SPH_C32(0xb43d1800), SPH_C32(0x73167e52), SPH_C32(0xbd423a87),
    SPH_C32(0x4dbd8136), SPH_C32(0xd618dd21), SPH_C32(0xb3af0000),
    SPH_C32(0x16d60000), SPH_C32(0xe0790019), SPH_C32(0x435b2000),
    SPH_C32(0x47867f82), SPH_C32(0x5bcee7c9), SPH_C32(0x73a4d286),
    SPH_C32(0x50bd50c0) },
  { SPH_C32(0xb59f0000), SPH_C32(0x242e0000), SPH_C32(0x939b005b),
    SPH_C32(0x72562000), SPH_C32(0x9421228e), SPH_C32(0xc4ef055a),
    SPH_C32(0xe1ce7f59), SPH_C32(0xec5ca490), SPH_C32(0xaef50000),
    SPH_C32(0x3da40000), SPH_C32(0xa8f40019), SPH_C32(0xec3a3800),
    SPH_C32(0x624d5147), SPH_C32(0x93b75819), SPH_C32(0xf206d6af),
    SPH_C32(0x4ec86666) },
  { SPH_C32(0xdac80000), SPH_C32(0x36c00000), SPH_C32(0x15ae0060),
    SPH_C32(0x0bb10000), SPH_C32(0x6b697976), SPH_C32(0x248dd0a9),
    SPH_C32(0x67c3ff89), SPH_C32(0xb513679b), SPH_C32(0x584f0000),
    SPH_C32(0x729f0000), SPH_C32(0xe07f000a), SPH_C32(0x43790000),
    SPH_C32(0x9b1948bd), SPH_C32(0xe74476ba), SPH_C32(0x5d240486),
    SPH_C32(0xa72142f2) },
  { SPH_C32(0x828b0000), SPH_C32(0xb6be0000), SPH_C32(0x6d9d0061),
    SPH_C32(0xcdda3800), SPH_C32(0x8c5e25aa), SPH_C32(0x5d20ef74),
    SPH_C32(0xcbb001e6), SPH_C32(0x8f571e2a), SPH_C32(0x45150000),
    SPH_C32(0x59ed0000), SPH_C32(0xa8f2000a), SPH_C32(0xec181800),
    SPH_C32(0xbed26678), SPH_C32(0x2f3dc96a), SPH_C32(0xdc8600af),
    SPH_C32(0xb9547454) },
  { SPH_C32(0xc7920000), SPH_C32(0x1db20000), SPH_C32(0x5d230060),
    SPH_C32(0xa4d01800), SPH_C32(0x4ea257b3), SPH_C32(0xecf46f79),
    SPH_C32(0xe661fba0), SPH_C32(0xab66513d), SPH_C32(0x1d560000),
    SPH_C32(0xd9930000), SPH_C32(0xd0c1000b), SPH_C32(0x2a732000),
    SPH_C32(0x59e53aa4), SPH_C32(0x5690f6b7), SPH_C32(0x70f5fec0),
    SPH_C32(0x83100de5) },
  { SPH_C32(0x9fd10000), SPH_C32(0x9dcc0000), SPH_C32(0x25100061),
    SPH_C32(0x62bb2000), SPH_C32(0xa9950b6f), SPH_C32(0x955950a4),
    SPH_C32(0x4a1205cf), SPH_C32(0x9122288c), SPH_C32(0x000c0000),
    SPH_C32(0xf2e10000), SPH_C32(0x984c000b), SPH_C32(0x85123800),
    SPH_C32(0x7c2e1461), SPH_C32(0x9ee94967), SPH_C32(0xf157fae9),
    SPH_C32(0x9d653b43) },
  { SPH_C32(0x7ff30000), SPH_C32(0x22e60000), SPH_C32(0x5b9e007e),
    SPH_C32(0x771f0000), SPH_C32(0xe4f774a3), SPH_C32(0x5c527a94),
    SPH_C32(0x90f29751), SPH_C32(0xbe082edd), SPH_C32(0x5fa20000),
    SPH_C32(0xc0cf0000), SPH_C32(0x670b0000), SPH_C32(0xd4740000),
    SPH_C32(0xd86b6b13), SPH_C32(0xaf83181e), SPH_C32(0xa95c66a4),
    SPH_C32(0x3754f33c) },
  { SPH_C32(0x27b00000), SPH_C32(0xa2980000), SPH_C32(0x23ad007f),
    SPH_C32(0xb1743800), SPH_C32(0x03c0287f), SPH_C32(0x25ff4549),
    SPH_C32(0x3c81693e), SPH_C32(0x844c576c), SPH_C32(0x42f80000),
    SPH_C32(0xebbd0000), SPH_C32(0x2f860000), SPH_C32(0x7b151800),
    SPH_C32(0xfda045d6), SPH_C32(0x67faa7ce), SPH_C32(0x28fe628d),
    SPH_C32(0x2921c59a) },
  { SPH_C32(0x62a90000), SPH_C32(0x09940000), SPH_C32(0x1313007e),
    SPH_C32(0xd87e1800), SPH_C32(0xc13c5a66), SPH_C32(0x942bc544),
    SPH_C32(0x11509378), SPH_C32(0xa07d187b), SPH_C32(0x1abb0000),
    SPH_C32(0x6bc30000), SPH_C32(0x57b50001), SPH_C32(0xbd7e2000),
    SPH_C32(0x1a97190a), SPH_C32(0x1e579813), SPH_C32(0x848d9ce2),
    SPH_C32(0x1365bc2b) },
  { SPH_C32(0x3aea0000), SPH_C32(0x89ea0000), SPH_C32(0x6b20007f),
    SPH_C32(0x1e152000), SPH_C32(0x260b06ba), SPH_C32(0xed86fa99),
    SPH_C32(0xbd236d17), SPH_C32(0x9a3961ca), SPH_C32(0x07e10000),
    SPH_C32(0x40b10000), SPH_C32(0x1f380001), SPH_C32(0x121f3800),
    SPH_C32(0x3f5c37cf), SPH_C32(0xd62e27c3), SPH_C32(0x052f98cb),
    SPH_C32(0x0d108a8d) },
  { SPH_C32(0xdd250000), SPH_C32(0x84900000), SPH_C32(0x92da006a),
    SPH_C32(0x9cbc0000), SPH_C32(0x281b5ad8), SPH_C32(0x6c4abe0d),
    SPH_C32(0x93bb9dab), SPH_C32(0x2566d655), SPH_C32(0xfa990000),
    SPH_C32(0xd4e90000), SPH_C32(0x293b001e), SPH_C32(0xa8da0000),
    SPH_C32(0x57f566c6), SPH_C32(0xd75cb223), SPH_C32(0x5e6d0e7c),
    SPH_C32(0x3c4fba7a) },
  { SPH_C32(0x85660000), SPH_C32(0x04ee0000), SPH_C32(0xeae9006b),
    SPH_C32(0x5ad73800), SPH_C32(0xcf2c0604), SPH_C32(0x15e781d0),
    SPH_C32(0x3fc863c4), SPH_C32(0x1f22afe4), SPH_C32(0xe7c30000),
    SPH_C32(0xff9b0000), SPH_C32(0x61b6001e), SPH_C32(0x07bb1800),
    SPH_C32(0x723e4803), SPH_C32(0x1f250df3), SPH_C32(0xdfcf0a55),
    SPH_C32(0x223a8cdc) },
  { SPH_C32(0xc07f0000), SPH_C32(0xafe20000), SPH_C32(0xda57006a),
    SPH_C32(0x33dd1800), SPH_C32(0x0dd0741d), SPH_C32(0xa43301dd),
    SPH_C32(0x12199982), SPH_C32(0x3b13e0f3), SPH_C32(0xbf800000),
    SPH_C32(0x7fe50000), SPH_C32(0x1985001f), SPH_C32(0xc1d02000),
    SPH_C32(0x950914df), SPH_C32(0x6688322e), SPH_C32(0x73bcf43a),
    SPH_C32(0x187ef56d) },
  { SPH_C32(0x983c0000), SPH_C32(0x2f9c0000), SPH_C32(0xa264006b),
    SPH_C32(0xf5b62000), SPH_C32(0xeae728c1), SPH_C32(0xdd9e3e00),
    SPH_C32(0xbe6a67ed), SPH_C32(0x01579942), SPH_C32(0xa2da0000),
    SPH_C32(0x54970000), SPH_C32(0x5108001f), SPH_C32(0x6eb13800),
    SPH_C32(0xb0c23a1a), SPH_C32(0xaef18dfe), SPH_C32(0xf21ef013),
    SPH_C32(0x060bc3cb) },
  { SPH_C32(0x781e0000), SPH_C32(0x90b60000), SPH_C32(0xdcea0074),
    SPH_C32(0xe0120000), SPH_C32(0xa785570d), SPH_C32(0x14951430),
    SPH_C32(0x648af573), SPH_C32(0x2e7d9f13), SPH_C32(0xfd740000),
    SPH_C32(0x66b90000), SPH_C32(0xae4f0014), SPH_C32(0x3fd70000),
    SPH_C32(0x14874568), SPH_C32(0x9f9bdc87), SPH_C32(0xaa156c5e),
    SPH_C32(0xac3a0bb4) },
  { SPH_C32(0x205d0000), SPH_C32(0x10c80000), SPH_C32(0xa4d90075),
    SPH_C32(0x26793800), SPH_C32(0x40b20bd1), SPH_C32(0x6d382bed),
    SPH_C32(0xc8f90b1c), SPH_C32(0x1439e6a2), SPH_C32(0xe02e0000),
    SPH_C32(0x4dcb0000), SPH_C32(0xe6c20014), SPH_C32(0x90b61800),
    SPH_C32(0x314c6bad), SPH_C32(0x57e26357), SPH_C32(0x2bb76877),
    SPH_C32(0xb24f3d12) },
  { SPH_C32(0x65440000), SPH_C32(0xbbc40000), SPH_C32(0x94670074),
    SPH_C32(0x4f731800), SPH_C32(0x824e79c8), SPH_C32(0xdcecabe0),
    SPH_C32(0xe528f15a), SPH_C32(0x3008a9b5), SPH_C32(0xb86d0000),
    SPH_C32(0xcdb50000), SPH_C32(0x9ef10015), SPH_C32(0x56dd2000),
    SPH_C32(0xd67b3771), SPH_C32(0x2e4f5c8a), SPH_C32(0x87c49618),
    SPH_C32(0x880b44a3) },
  { SPH_C32(0x3d070000), SPH_C32(0x3bba0000), SPH_C32(0xec540075),
    SPH_C32(0x89182000), SPH_C32(0x65792514), SPH_C32(0xa541943d),
    SPH_C32(0x495b0f35), SPH_C32(0x0a4cd004), SPH_C32(0xa5370000),
    SPH_C32(0xe6c70000), SPH_C32(0xd67c0015), SPH_C32(0xf9bc3800),
    SPH_C32(0xf3b019b4), SPH_C32(0xe636e35a), SPH_C32(0x06669231),
    SPH_C32(0x967e7205) },
  { SPH_C32(0x59920000), SPH_C32(0xf2370000), SPH_C32(0x14e90042),
    SPH_C32(0xe5790000), SPH_C32(0x0bcc361f), SPH_C32(0x30a2fa8d),
    SPH_C32(0x3b36cb7b), SPH_C32(0x8bb5076c), SPH_C32(0xd0d70000),
    SPH_C32(0x6d0b0000), SPH_C32(0x9fb00024), SPH_C32(0xb8370000),
    SPH_C32(0x6a414f27), SPH_C32(0x86eae7dd), SPH_C32(0xf5b174ea),
    SPH_C32(0x41313666) },
  { SPH_C32(0x01d10000), SPH_C32(0x72490000), SPH_C32(0x6cda0043),
    SPH_C32(0x23123800), SPH_C32(0xecfb6ac3), SPH_C32(0x490fc550),
    SPH_C32(0x97453514), SPH_C32(0xb1f17edd), SPH_C32(0xcd8d0000),
    SPH_C32(0x46790000), SPH_C32(0xd73d0024), SPH_C32(0x17561800),
    SPH_C32(0x4f8a61e2), SPH_C32(0x4e93580d), SPH_C32(0x741370c3),
    SPH_C32(0x5f4400c0) },
  { SPH_C32(0x44c80000), SPH_C32(0xd9450000), SPH_C32(0x5c640042),
    SPH_C32(0x4a181800), SPH_C32(0x2e0718da), SPH_C32(0xf8db455d),
    SPH_C32(0xba94cf52), SPH_C32(0x95c031ca), SPH_C32(0x95ce0000),
    SPH_C32(0xc6070000), SPH_C32(0xaf0e0025), SPH_C32(0xd13d2000),
    SPH_C32(0xa8bd3d3e), SPH_C32(0x373e67d0), SPH_C32(0xd8608eac),
    SPH_C32(0x65007971) },
  { SPH_C32(0x1c8b0000), SPH_C32(0x593b0000), SPH_C32(0x24570043),
    SPH_C32(0x8c732000), SPH_C32(0xc9304406), SPH_C32(0x81767a80),
    SPH_C32(0x16e7313d), SPH_C32(0xaf84487b), SPH_C32(0x88940000),
    SPH_C32(0xed750000), SPH_C32(0xe7830025), SPH_C32(0x7e5c3800),
    SPH_C32(0x8d7613fb), SPH_C32(0xff47d800), SPH_C32(0x59c28a85),
    SPH_C32(0x7b754fd7) },
  { SPH_C32(0xfca90000), SPH_C32(0xe6110000), SPH_C32(0x5ad9005c),
    SPH_C32(0x99d70000), SPH_C32(0x84523bca), SPH_C32(0x487d50b0),
    SPH_C32(0xcc07a3a3), SPH_C32(0x80ae4e2a), SPH_C32(0xd73a0000),
    SPH_C32(0xdf5b0000), SPH_C32(0x18c4002e), SPH_C32(0x2f3a0000),
    SPH_C32(0x29336c89), SPH_C32(0xce2d8979), SPH_C32(0x01c916c8),
    SPH_C32(0xd14487a8) },
  { SPH_C32(0xa4ea0000), SPH_C32(0x666f0000), SPH_C32(0x22ea005d),
    SPH_C32(0x5fbc3800), SPH_C32(0x63656716), SPH_C32(0x31d06f6d),
    SPH_C32(0x60745dcc), SPH_C32(0xbaea379b), SPH_C32(0xca600000),
    SPH_C32(0xf4290000), SPH_C32(0x5049002e), SPH_C32(0x805b1800),
    SPH_C32(0x0cf8424c), SPH_C32(0x065436a9), SPH_C32(0x806b12e1),
    SPH_C32(0xcf31b10e) },
  { SPH_C32(0xe1f30000), SPH_C32(0xcd630000), SPH_C32(0x1254005c),
    SPH_C32(0x36b61800), SPH_C32(0xa199150f), SPH_C32(0x8004ef60),
    SPH_C32(0x4da5a78a), SPH_C32(0x9edb788c), SPH_C32(0x92230000),
    SPH_C32(0x74570000), SPH_C32(0x287a002f), SPH_C32(0x46302000),
    SPH_C32(0xebcf1e90), SPH_C32(0x7ff90974), SPH_C32(0x2c18ec8e),
    SPH_C32(0xf575c8bf) },
  { SPH_C32(0xb9b00000), SPH_C32(0x4d1d0000), SPH_C32(0x6a67005d),
    SPH_C32(0xf0dd2000), SPH_C32(0x46ae49d3), SPH_C32(0xf9a9d0bd),
    SPH_C32(0xe1d659e5), SPH_C32(0xa49f013d), SPH_C32(0x8f790000),
    SPH_C32(0x5f250000), SPH_C32(0x60f7002f), SPH_C32(0xe9513800),
    SPH_C32(0xce043055), SPH_C32(0xb780b6a4), SPH_C32(0xadbae8a7),
    SPH_C32(0xeb00fe19) },
  { SPH_C32(0x5e7f0000), SPH_C32(0x40670000), SPH_C32(0x939d0048),
    SPH_C32(0x72740000), SPH_C32(0x48be15b1), SPH_C32(0x78659429),
    SPH_C32(0xcf4ea959), SPH_C32(0x1bc0b6a2), SPH_C32(0x72010000),
    SPH_C32(0xcb7d0000), SPH_C32(0x56f40030), SPH_C32(0x53940000),
    SPH_C32(0xa6ad615c), SPH_C32(0xb6f22344), SPH_C32(0xf6f87e10),
    SPH_C32(0xda5fceee) },
  { SPH_C32(0x063c0000), SPH_C32(0xc0190000), SPH_C32(0xebae0049),
    SPH_C32(0xb41f3800), SPH_C32(0xaf89496d), SPH_C32(0x01c8abf4),
    SPH_C32(0x633d5736), SPH_C32(0x2184cf13), SPH_C32(0x6f5b0000),
    SPH_C32(0xe00f0000), SPH_C32(0x1e790030), SPH_C32(0xfcf51800),
    SPH_C32(0x83664f99), SPH_C32(0x7e8b9c94), SPH_C32(0x775a7a39),
    SPH_C32(0xc42af848) },
  { SPH_C32(0x43250000), SPH_C32(0x6b150000), SPH_C32(0xdb100048),
    SPH_C32(0xdd151800), SPH_C32(0x6d753b74), SPH_C32(0xb01c2bf9),
    SPH_C32(0x4eecad70), SPH_C32(0x05b58004), SPH_C32(0x37180000),
    SPH_C32(0x60710000), SPH_C32(0x664a0031), SPH_C32(0x3a9e2000),
    SPH_C32(0x64511345), SPH_C32(0x0726a349), SPH_C32(0xdb298456),
    SPH_C32(0xfe6e81f9) },
  { SPH_C32(0x1b660000), SPH_C32(0xeb6b0000), SPH_C32(0xa3230049),
    SPH_C32(0x1b7e2000), SPH_C32(0x8a4267a8), SPH_C32(0xc9b11424),
    SPH_C32(0xe29f531f), SPH_C32(0x3ff1f9b5), SPH_C32(0x2a420000),
    SPH_C32(0x4b030000), SPH_C32(0x2ec70031), SPH_C32(0x95ff3800),
    SPH_C32(0x419a3d80), SPH_C32(0xcf5f1c99), SPH_C32(0x5a8b807f),
    SPH_C32(0xe01bb75f) },
  { SPH_C32(0xfb440000), SPH_C32(0x54410000), SPH_C32(0xddad0056),
    SPH_C32(0x0eda0000), SPH_C32(0xc7201864), SPH_C32(0x00ba3e14),
    SPH_C32(0x387fc181), SPH_C32(0x10dbffe4), SPH_C32(0x75ec0000),
    SPH_C32(0x792d0000), SPH_C32(0xd180003a), SPH_C32(0xc4990000),
    SPH_C32(0xe5df42f2), SPH_C32(0xfe354de0), SPH_C32(0x02801c32),
    SPH_C32(0x4a2a7f20) },
  { SPH_C32(0xa3070000), SPH_C32(0xd43f0000), SPH_C32(0xa59e0057),
    SPH_C32(0xc8b13800), SPH_C32(0x201744b8), SPH_C32(0x791701c9),
    SPH_C32(0x940c3fee), SPH_C32(0x2a9f8655), SPH_C32(0x68b60000),
    SPH_C32(0x525f0000), SPH_C32(0x990d003a), SPH_C32(0x6bf81800),
    SPH_C32(0xc0146c37), SPH_C32(0x364cf230), SPH_C32(0x8322181b),
    SPH_C32(0x545f4986) },
  { SPH_C32(0xe61e0000), SPH_C32(0x7f330000), SPH_C32(0x95200056),
    SPH_C32(0xa1bb1800), SPH_C32(0xe2eb36a1), SPH_C32(0xc8c381c4),
    SPH_C32(0xb9ddc5a8), SPH_C32(0x0eaec942), SPH_C32(0x30f50000),
    SPH_C32(0xd2210000), SPH_C32(0xe13e003b), SPH_C32(0xad932000),
    SPH_C32(0x272330eb), SPH_C32(0x4fe1cded), SPH_C32(0x2f51e674),
    SPH_C32(0x6e1b3037) },
  { SPH_C32(0xbe5d0000), SPH_C32(0xff4d0000), SPH_C32(0xed130057),
    SPH_C32(0x67d02000), SPH_C32(0x05dc6a7d), SPH_C32(0xb16ebe19),
    SPH_C32(0x15ae3bc7), SPH_C32(0x34eab0f3), SPH_C32(0x2daf0000),
    SPH_C32(0xf9530000), SPH_C32(0xa9b3003b), SPH_C32(0x02f23800),
    SPH_C32(0x02e81e2e), SPH_C32(0x8798723d), SPH_C32(0xaef3e25d),
    SPH_C32(0x706e0691) },
  { SPH_C32(0xd10a0000), SPH_C32(0xeda30000), SPH_C32(0x6b26006c),
    SPH_C32(0x1e370000), SPH_C32(0xfa943185), SPH_C32(0x510c6bea),
    SPH_C32(0x93a3bb17), SPH_C32(0x6da573f8), SPH_C32(0xdb150000),
    SPH_C32(0xb6680000), SPH_C32(0xe1380028), SPH_C32(0xadb10000),
    SPH_C32(0xfbbc07d4), SPH_C32(0xf36b5c9e), SPH_C32(0x01d13074),
    SPH_C32(0x99872205) },
  { SPH_C32(0x89490000), SPH_C32(0x6ddd0000), SPH_C32(0x1315006d),
    SPH_C32(0xd85c3800), SPH_C32(0x1da36d59), SPH_C32(0x28a15437),
    SPH_C32(0x3fd04578), SPH_C32(0x57e10a49), SPH_C32(0xc64f0000),
    SPH_C32(0x9d1a0000), SPH_C32(0xa9b50028), SPH_C32(0x02d01800),
    SPH_C32(0xde772911), SPH_C32(0x3b12e34e), SPH_C32(0x8073345d),
    SPH_C32(0x87f214a3) },
  { SPH_C32(0xcc500000), SPH_C32(0xc6d10000), SPH_C32(0x23ab006c),
    SPH_C32(0xb1561800), SPH_C32(0xdf5f1f40), SPH_C32(0x9975d43a),
    SPH_C32(0x1201bf3e), SPH_C32(0x73d0455e), SPH_C32(0x9e0c0000),
    SPH_C32(0x1d640000), SPH_C32(0xd1860029), SPH_C32(0xc4bb2000),
    SPH_C32(0x394075cd), SPH_C32(0x42bfdc93), SPH_C32(0x2c00ca32),
    SPH_C32(0xbdb66d12) },
  { SPH_C32(0x94130000), SPH_C32(0x46af0000), SPH_C32(0x5b98006d),
    SPH_C32(0x773d2000), SPH_C32(0x3868439c), SPH_C32(0xe0d8ebe7),
    SPH_C32(0xbe724151), SPH_C32(0x49943cef), SPH_C32(0x83560000),
    SPH_C32(0x36160000), SPH_C32(0x990b0029), SPH_C32(0x6bda3800),
    SPH_C32(0x1c8b5b08), SPH_C32(0x8ac66343), SPH_C32(0xada2ce1b),
    SPH_C32(0xa3c35bb4) },
  { SPH_C32(0x74310000), SPH_C32(0xf9850000), SPH_C32(0x25160072),
    SPH_C32(0x62990000), SPH_C32(0x750a3c50), SPH_C32(0x29d3c1d7),
    SPH_C32(0x6492d3cf), SPH_C32(0x66be3abe), SPH_C32(0xdcf80000),
    SPH_C32(0x04380000), SPH_C32(0x664c0022), SPH_C32(0x3abc0000),
    SPH_C32(0xb8ce247a), SPH_C32(0xbbac323a), SPH_C32(0xf5a95256),
    SPH_C32(0x09f293cb) },
  { SPH_C32(0x2c720000), SPH_C32(0x79fb0000), SPH_C32(0x5d250073),
    SPH_C32(0xa4f23800), SPH_C32(0x923d608c), SPH_C32(0x507efe0a),
    SPH_C32(0xc8e12da0), SPH_C32(0x5cfa430f), SPH_C32(0xc1a20000),
    SPH_C32(0x2f4a0000), SPH_C32(0x2ec10022), SPH_C32(0x95dd1800),
    SPH_C32(0x9d050abf), SPH_C32(0x73d58dea), SPH_C32(0x740b567f),
    SPH_C32(0x1787a56d) },
  { SPH_C32(0x696b0000), SPH_C32(0xd2f70000), SPH_C32(0x6d9b0072),
    SPH_C32(0xcdf81800), SPH_C32(0x50c11295), SPH_C32(0xe1aa7e07),
    SPH_C32(0xe530d7e6), SPH_C32(0x78cb0c18), SPH_C32(0x99e10000),
    SPH_C32(0xaf340000), SPH_C32(0x56f20023), SPH_C32(0x53b62000),
    SPH_C32(0x7a325663), SPH_C32(0x0a78b237), SPH_C32(0xd878a810),
    SPH_C32(0x2dc3dcdc) },
  { SPH_C32(0x31280000), SPH_C32(0x52890000), SPH_C32(0x15a80073),
    SPH_C32(0x0b932000), SPH_C32(0xb7f64e49), SPH_C32(0x980741da),
    SPH_C32(0x49432989), SPH_C32(0x428f75a9), SPH_C32(0x84bb0000),
    SPH_C32(0x84460000), SPH_C32(0x1e7f0023), SPH_C32(0xfcd73800),
    SPH_C32(0x5ff978a6), SPH_C32(0xc2010de7), SPH_C32(0x59daac39),
    SPH_C32(0x33b6ea7a) },
  { SPH_C32(0xd6e70000), SPH_C32(0x5ff30000), SPH_C32(0xec520066),
    SPH_C32(0x893a0000), SPH_C32(0xb9e6122b), SPH_C32(0x19cb054e),
    SPH_C32(0x67dbd935), SPH_C32(0xfdd0c236), SPH_C32(0x79c30000),
    SPH_C32(0x101e0000), SPH_C32(0x287c003c), SPH_C32(0x46120000),
    SPH_C32(0x375029af), SPH_C32(0xc3739807), SPH_C32(0x02983a8e),
    SPH_C32(0x02e9da8d) },
  { SPH_C32(0x8ea40000), SPH_C32(0xdf8d0000), SPH_C32(0x94610067),
    SPH_C32(0x4f513800), SPH_C32(0x5ed14ef7), SPH_C32(0x60663a93),
    SPH_C32(0xcba8275a), SPH_C32(0xc794bb87), SPH_C32(0x64990000),
    SPH_C32(0x3b6c0000), SPH_C32(0x60f1003c), SPH_C32(0xe9731800),
    SPH_C32(0x129b076a), SPH_C32(0x0b0a27d7), SPH_C32(0x833a3ea7),
    SPH_C32(0x1c9cec2b) },
  { SPH_C32(0xcbbd0000), SPH_C32(0x74810000), SPH_C32(0xa4df0066),
    SPH_C32(0x265b1800), SPH_C32(0x9c2d3cee), SPH_C32(0xd1b2ba9e),
    SPH_C32(0xe679dd1c), SPH_C32(0xe3a5f490), SPH_C32(0x3cda0000),
    SPH_C32(0xbb120000), SPH_C32(0x18c2003d), SPH_C32(0x2f182000),
    SPH_C32(0xf5ac5bb6), SPH_C32(0x72a7180a), SPH_C32(0x2f49c0c8),
    SPH_C32(0x26d8959a) },
  { SPH_C32(0x93fe0000), SPH_C32(0xf4ff0000), SPH_C32(0xdcec0067),
    SPH_C32(0xe0302000), SPH_C32(0x7b1a6032), SPH_C32(0xa81f8543),
    SPH_C32(0x4a0a2373), SPH_C32(0xd9e18d21), SPH_C32(0x21800000),
    SPH_C32(0x90600000), SPH_C32(0x504f003d), SPH_C32(0x80793800),
    SPH_C32(0xd0677573), SPH_C32(0xbadea7da), SPH_C32(0xaeebc4e1),
    SPH_C32(0x38ada33c) },
  { SPH_C32(0x73dc0000), SPH_C32(0x4bd50000), SPH_C32(0xa2620078),
    SPH_C32(0xf5940000), SPH_C32(0x36781ffe), SPH_C32(0x6114af73),
    SPH_C32(0x90eab1ed), SPH_C32(0xf6cb8b70), SPH_C32(0x7e2e0000),
    SPH_C32(0xa24e0000), SPH_C32(0xaf080036), SPH_C32(0xd11f0000),
    SPH_C32(0x74220a01), SPH_C32(0x8bb4f6a3), SPH_C32(0xf6e058ac),
    SPH_C32(0x929c6b43) },
  { SPH_C32(0x2b9f0000), SPH_C32(0xcbab0000), SPH_C32(0xda510079),
    SPH_C32(0x33ff3800), SPH_C32(0xd14f4322), SPH_C32(0x18b990ae),
    SPH_C32(0x3c994f82), SPH_C32(0xcc8ff2c1), SPH_C32(0x63740000),
    SPH_C32(0x893c0000), SPH_C32(0xe7850036), SPH_C32(0x7e7e1800),
    SPH_C32(0x51e924c4), SPH_C32(0x43cd4973), SPH_C32(0x77425c85),
    SPH_C32(0x8ce95de5) },
  { SPH_C32(0x6e860000), SPH_C32(0x60a70000), SPH_C32(0xeaef0078),
    SPH_C32(0x5af51800), SPH_C32(0x13b3313b), SPH_C32(0xa96d10a3),
    SPH_C32(0x1148b5c4), SPH_C32(0xe8bebdd6), SPH_C32(0x3b370000),
    SPH_C32(0x09420000), SPH_C32(0x9fb60037), SPH_C32(0xb8152000),
    SPH_C32(0xb6de7818), SPH_C32(0x3a6076ae), SPH_C32(0xdb31a2ea),
    SPH_C32(0xb6ad2454) },
  { SPH_C32(0x36c50000), SPH_C32(0xe0d90000), SPH_C32(0x92dc0079),
    SPH_C32(0x9c9e2000), SPH_C32(0xf4846de7), SPH_C32(0xd0c02f7e),
    SPH_C32(0xbd3b4bab), SPH_C32(0xd2fac467), SPH_C32(0x266d0000),
    SPH_C32(0x22300000), SPH_C32(0xd73b0037), SPH_C32(0x17743800),
    SPH_C32(0x931556dd), SPH_C32(0xf219c97e), SPH_C32(0x5a93a6c3),
    SPH_C32(0xa8d812f2) },
  { SPH_C32(0x538d0000), SPH_C32(0xa9fc0000), SPH_C32(0x9ef70006),
    SPH_C32(0x56ff0000), SPH_C32(0x0ae4004e), SPH_C32(0x92c5cdf9),
    SPH_C32(0xa9444018), SPH_C32(0x7f975691), SPH_C32(0x01dd0000),
    SPH_C32(0x80a80000), SPH_C32(0xf4960048), SPH_C32(0xa6000000),
    SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37), SPH_C32(0x6612cffd),
    SPH_C32(0x2c94459e) },
  { SPH_C32(0x0bce0000), SPH_C32(0x29820000), SPH_C32(0xe6c40007),
    SPH_C32(0x90943800), SPH_C32(0xedd35c92), SPH_C32(0xeb68f224),
    SPH_C32(0x0537be77), SPH_C32(0x45d32f20), SPH_C32(0x1c870000),
    SPH_C32(0xabda0000), SPH_C32(0xbc1b0048), SPH_C32(0x09611800),
    SPH_C32(0xb51e5067), SPH_C32(0x1f9f33e7), SPH_C32(0xe7b0cbd4),
    SPH_C32(0x32e17338) },
  { SPH_C32(0x4ed70000), SPH_C32(0x828e0000), SPH_C32(0xd67a0006),
    SPH_C32(0xf99e1800), SPH_C32(0x2f2f2e8b), SPH_C32(0x5abc7229),
    SPH_C32(0x28e64431), SPH_C32(0x61e26037), SPH_C32(0x44c40000),
    SPH_C32(0x2ba40000), SPH_C32(0xc4280049), SPH_C32(0xcf0a2000),
    SPH_C32(0x52290cbb), SPH_C32(0x66320c3a), SPH_C32(0x4bc335bb),
    SPH_C32(0x08a50a89) },
  { SPH_C32(0x16940000), SPH_C32(0x02f00000), SPH_C32(0xae490007),
    SPH_C32(0x3ff52000), SPH_C32(0xc8187257), SPH_C32(0x23114df4),
    SPH_C32(0x8495ba5e), SPH_C32(0x5ba61986), SPH_C32(0x599e0000),
    SPH_C32(0x00d60000), SPH_C32(0x8ca50049), SPH_C32(0x606b3800),
    SPH_C32(0x77e2227e), SPH_C32(0xae4bb3ea), SPH_C32(0xca613192),
    SPH_C32(0x16d03c2f) },
  { SPH_C32(0xf6b60000), SPH_C32(0xbdda0000), SPH_C32(0xd0c70018),
    SPH_C32(0x2a510000), SPH_C32(0x857a0d9b), SPH_C32(0xea1a67c4),
    SPH_C32(0x5e7528c0), SPH_C32(0x748c1fd7), SPH_C32(0x06300000),
    SPH_C32(0x32f80000), SPH_C32(0x73e20042), SPH_C32(0x310d0000),
    SPH_C32(0xd3a75d0c), SPH_C32(0x9f21e293), SPH_C32(0x926aaddf),
    SPH_C32(0xbce1f450) },
  { SPH_C32(0xaef50000), SPH_C32(0x3da40000), SPH_C32(0xa8f40019),
    SPH_C32(0xec3a3800), SPH_C32(0x624d5147), SPH_C32(0x93b75819),
    SPH_C32(0xf206d6af), SPH_C32(0x4ec86666), SPH_C32(0x1b6a0000),
    SPH_C32(0x198a0000), SPH_C32(0x3b6f0042), SPH_C32(0x9e6c1800),
    SPH_C32(0xf66c73c9), SPH_C32(0x57585d43), SPH_C32(0x13c8a9f6),
    SPH_C32(0xa294c2f6) },
  { SPH_C32(0xebec0000), SPH_C32(0x96a80000), SPH_C32(0x984a0018),
    SPH_C32(0x85301800), SPH_C32(0xa0b1235e), SPH_C32(0x2263d814),
    SPH_C32(0xdfd72ce9), SPH_C32(0x6af92971), SPH_C32(0x43290000),
    SPH_C32(0x99f40000), SPH_C32(0x435c0043), SPH_C32(0x58072000),
    SPH_C32(0x115b2f15), SPH_C32(0x2ef5629e), SPH_C32(0xbfbb5799),
    SPH_C32(0x98d0bb47) },
  { SPH_C32(0xb3af0000), SPH_C32(0x16d60000), SPH_C32(0xe0790019),
    SPH_C32(0x435b2000), SPH_C32(0x47867f82), SPH_C32(0x5bcee7c9),
    SPH_C32(0x73a4d286), SPH_C32(0x50bd50c0), SPH_C32(0x5e730000),
    SPH_C32(0xb2860000), SPH_C32(0x0bd10043), SPH_C32(0xf7663800),
    SPH_C32(0x349001d0), SPH_C32(0xe68cdd4e), SPH_C32(0x3e1953b0),
    SPH_C32(0x86a58de1) },
  { SPH_C32(0x54600000), SPH_C32(0x1bac0000), SPH_C32(0x1983000c),
    SPH_C32(0xc1f20000), SPH_C32(0x499623e0), SPH_C32(0xda02a35d),
    SPH_C32(0x5d3c223a), SPH_C32(0xefe2e75f), SPH_C32(0xa30b0000),
    SPH_C32(0x26de0000), SPH_C32(0x3dd2005c), SPH_C32(0x4da30000),
    SPH_C32(0x5c3950d9), SPH_C32(0xe7fe48ae), SPH_C32(0x655bc507),
    SPH_C32(0xb7fabd16) },
  { SPH_C32(0x0c230000), SPH_C32(0x9bd20000), SPH_C32(0x61b0000d),
    SPH_C32(0x07993800), SPH_C32(0xaea17f3c), SPH_C32(0xa3af9c80),
    SPH_C32(0xf14fdc55), SPH_C32(0xd5a69eee), SPH_C32(0xbe510000),
    SPH_C32(0x0dac0000), SPH_C32(0x755f005c), SPH_C32(0xe2c21800),
    SPH_C32(0x79f27e1c), SPH_C32(0x2f87f77e), SPH_C32(0xe4f9c12e),
    SPH_C32(0xa98f8bb0) },
  { SPH_C32(0x493a0000), SPH_C32(0x30de0000), SPH_C32(0x510e000c),
    SPH_C32(0x6e931800), SPH_C32(0x6c5d0d25), SPH_C32(0x127b1c8d),
    SPH_C32(0xdc9e2613), SPH_C32(0xf197d1f9), SPH_C32(0xe6120000),
    SPH_C32(0x8dd20000), SPH_C32(0x0d6c005d), SPH_C32(0x24a92000),
    SPH_C32(0x9ec522c0), SPH_C32(0x562ac8a3), SPH_C32(0x488a3f41),
    SPH_C32(0x93cbf201) },
  { SPH_C32(0x11790000), SPH_C32(0xb0a00000), SPH_C32(0x293d000d),
    SPH_C32(0xa8f82000), SPH_C32(0x8b6a51f9), SPH_C32(0x6bd62350),
    SPH_C32(0x70edd87c), SPH_C32(0xcbd3a848), SPH_C32(0xfb480000),
    SPH_C32(0xa6a00000), SPH_C32(0x45e1005d), SPH_C32(0x8bc83800),
    SPH_C32(0xbb0e0c05), SPH_C32(0x9e537773), SPH_C32(0xc9283b68),
    SPH_C32(0x8dbec4a7) },
  { SPH_C32(0xf15b0000), SPH_C32(0x0f8a0000), SPH_C32(0x57b30012),
    SPH_C32(0xbd5c0000), SPH_C32(0xc6082e35), SPH_C32(0xa2dd0960),
    SPH_C32(0xaa0d4ae2), SPH_C32(0xe4f9ae19), SPH_C32(0xa4e60000),
    SPH_C32(0x948e0000), SPH_C32(0xbaa60056), SPH_C32(0xdaae0000),
    SPH_C32(0x1f4b7377), SPH_C32(0xaf39260a), SPH_C32(0x9123a725),
    SPH_C32(0x278f0cd8) },
  { SPH_C32(0xa9180000), SPH_C32(0x8ff40000), SPH_C32(0x2f800013),
    SPH_C32(0x7b373800), SPH_C32(0x213f72e9), SPH_C32(0xdb7036bd),
    SPH_C32(0x067eb48d), SPH_C32(0xdebdd7a8), SPH_C32(0xb9bc0000),
    SPH_C32(0xbffc0000), SPH_C32(0xf22b0056), SPH_C32(0x75cf1800),
    SPH_C32(0x3a805db2), SPH_C32(0x674099da), SPH_C32(0x1081a30c),
    SPH_C32(0x39fa3a7e) },
  { SPH_C32(0xec010000), SPH_C32(0x24f80000), SPH_C32(0x1f3e0012),
    SPH_C32(0x123d1800), SPH_C32(0xe3c300f0), SPH_C32(0x6aa4b6b0),
    SPH_C32(0x2baf4ecb), SPH_C32(0xfa8c98bf), SPH_C32(0xe1ff0000),
    SPH_C32(0x3f820000), SPH_C32(0x8a180057), SPH_C32(0xb3a42000),
    SPH_C32(0xddb7016e), SPH_C32(0x1eeda607), SPH_C32(0xbcf25d63),
    SPH_C32(0x03be43cf) },
  { SPH_C32(0xb4420000), SPH_C32(0xa4860000), SPH_C32(0x670d0013),
    SPH_C32(0xd4562000), SPH_C32(0x04f45c2c), SPH_C32(0x1309896d),
    SPH_C32(0x87dcb0a4), SPH_C32(0xc0c8e10e), SPH_C32(0xfca50000),
    SPH_C32(0x14f00000), SPH_C32(0xc2950057), SPH_C32(0x1cc53800),
    SPH_C32(0xf87c2fab), SPH_C32(0xd69419d7), SPH_C32(0x3d50594a),
    SPH_C32(0x1dcb7569) },
  { SPH_C32(0xdb150000), SPH_C32(0xb6680000), SPH_C32(0xe1380028),
    SPH_C32(0xadb10000), SPH_C32(0xfbbc07d4), SPH_C32(0xf36b5c9e),
    SPH_C32(0x01d13074), SPH_C32(0x99872205), SPH_C32(0x0a1f0000),
    SPH_C32(0x5bcb0000), SPH_C32(0x8a1e0044), SPH_C32(0xb3860000),
    SPH_C32(0x01283651), SPH_C32(0xa2673774), SPH_C32(0x92728b63),
    SPH_C32(0xf42251fd) },
  { SPH_C32(0x83560000), SPH_C32(0x36160000), SPH_C32(0x990b0029),
    SPH_C32(0x6bda3800), SPH_C32(0x1c8b5b08), SPH_C32(0x8ac66343),
    SPH_C32(0xada2ce1b), SPH_C32(0xa3c35bb4), SPH_C32(0x17450000),
    SPH_C32(0x70b90000), SPH_C32(0xc2930044), SPH_C32(0x1ce71800),
    SPH_C32(0x24e31894), SPH_C32(0x6a1e88a4), SPH_C32(0x13d08f4a),
    SPH_C32(0xea57675b) },
  { SPH_C32(0xc64f0000), SPH_C32(0x9d1a0000), SPH_C32(0xa9b50028),
    SPH_C32(0x02d01800), SPH_C32(0xde772911), SPH_C32(0x3b12e34e),
    SPH_C32(0x8073345d), SPH_C32(0x87f214a3), SPH_C32(0x4f060000),
    SPH_C32(0xf0c70000), SPH_C32(0xbaa00045), SPH_C32(0xda8c2000),
    SPH_C32(0xc3d44448), SPH_C32(0x13b3b779), SPH_C32(0xbfa37125),
    SPH_C32(0xd0131eea) },
  { SPH_C32(0x9e0c0000), SPH_C32(0x1d640000), SPH_C32(0xd1860029),
    SPH_C32(0xc4bb2000), SPH_C32(0x394075cd), SPH_C32(0x42bfdc93),
    SPH_C32(0x2c00ca32), SPH_C32(0xbdb66d12), SPH_C32(0x525c0000),
    SPH_C32(0xdbb50000), SPH_C32(0xf22d0045), SPH_C32(0x75ed3800),
    SPH_C32(0xe61f6a8d), SPH_C32(0xdbca08a9), SPH_C32(0x3e01750c),
    SPH_C32(0xce66284c) },
  { SPH_C32(0x7e2e0000), SPH_C32(0xa24e0000), SPH_C32(0xaf080036),
    SPH_C32(0xd11f0000), SPH_C32(0x74220a01), SPH_C32(0x8bb4f6a3),
    SPH_C32(0xf6e058ac), SPH_C32(0x929c6b43), SPH_C32(0x0df20000),
    SPH_C32(0xe99b0000), SPH_C32(0x0d6a004e), SPH_C32(0x248b0000),
    SPH_C32(0x425a15ff), SPH_C32(0xeaa059d0), SPH_C32(0x660ae941),
    SPH_C32(0x6457e033) },
  { SPH_C32(0x266d0000), SPH_C32(0x22300000), SPH_C32(0xd73b0037),
    SPH_C32(0x17743800), SPH_C32(0x931556dd), SPH_C32(0xf219c97e),
    SPH_C32(0x5a93a6c3), SPH_C32(0xa8d812f2), SPH_C32(0x10a80000),
    SPH_C32(0xc2e90000), SPH_C32(0x45e7004e), SPH_C32(0x8bea1800),
    SPH_C32(0x67913b3a), SPH_C32(0x22d9e600), SPH_C32(0xe7a8ed68),
    SPH_C32(0x7a22d695) },
  { SPH_C32(0x63740000), SPH_C32(0x893c0000), SPH_C32(0xe7850036),
    SPH_C32(0x7e7e1800), SPH_C32(0x51e924c4), SPH_C32(0x43cd4973),
    SPH_C32(0x77425c85), SPH_C32(0x8ce95de5), SPH_C32(0x48eb0000),
    SPH_C32(0x42970000), SPH_C32(0x3dd4004f), SPH_C32(0x4d812000),
    SPH_C32(0x80a667e6), SPH_C32(0x5b74d9dd), SPH_C32(0x4bdb1307),
    SPH_C32(0x4066af24) },
  { SPH_C32(0x3b370000), SPH_C32(0x09420000), SPH_C32(0x9fb60037),
    SPH_C32(0xb8152000), SPH_C32(0xb6de7818), SPH_C32(0x3a6076ae),
    SPH_C32(0xdb31a2ea), SPH_C32(0xb6ad2454), SPH_C32(0x55b10000),
    SPH_C32(0x69e50000), SPH_C32(0x7559004f), SPH_C32(0xe2e03800),
    SPH_C32(0xa56d4923), SPH_C32(0x930d660d), SPH_C32(0xca79172e),
    SPH_C32(0x5e139982) },
  { SPH_C32(0xdcf80000), SPH_C32(0x04380000), SPH_C32(0x664c0022),
    SPH_C32(0x3abc0000), SPH_C32(0xb8ce247a), SPH_C32(0xbbac323a),
    SPH_C32(0xf5a95256), SPH_C32(0x09f293cb), SPH_C32(0xa8c90000),
    SPH_C32(0xfdbd0000), SPH_C32(0x435a0050), SPH_C32(0x58250000),
    SPH_C32(0xcdc4182a), SPH_C32(0x927ff3ed), SPH_C32(0x913b8199),
    SPH_C32(0x6f4ca975) },
  { SPH_C32(0x84bb0000), SPH_C32(0x84460000), SPH_C32(0x1e7f0023),
    SPH_C32(0xfcd73800), SPH_C32(0x5ff978a6), SPH_C32(0xc2010de7),
    SPH_C32(0x59daac39), SPH_C32(0x33b6ea7a), SPH_C32(0xb5930000),
    SPH_C32(0xd6cf0000), SPH_C32(0x0bd70050), SPH_C32(0xf7441800),
    SPH_C32(0xe80f36ef), SPH_C32(0x5a064c3d), SPH_C32(0x109985b0),
    SPH_C32(0x71399fd3) },
  { SPH_C32(0xc1a20000), SPH_C32(0x2f4a0000), SPH_C32(0x2ec10022),
    SPH_C32(0x95dd1800), SPH_C32(0x9d050abf), SPH_C32(0x73d58dea),
    SPH_C32(0x740b567f), SPH_C32(0x1787a56d), SPH_C32(0xedd00000),
    SPH_C32(0x56b10000), SPH_C32(0x73e40051), SPH_C32(0x312f2000),
    SPH_C32(0x0f386a33), SPH_C32(0x23ab73e0), SPH_C32(0xbcea7bdf),
    SPH_C32(0x4b7de662) },
  { SPH_C32(0x99e10000), SPH_C32(0xaf340000), SPH_C32(0x56f20023),
    SPH_C32(0x53b62000), SPH_C32(0x7a325663), SPH_C32(0x0a78b237),
    SPH_C32(0xd878a810), SPH_C32(0x2dc3dcdc), SPH_C32(0xf08a0000),
    SPH_C32(0x7dc30000), SPH_C32(0x3b690051), SPH_C32(0x9e4e3800),
    SPH_C32(0x2af344f6), SPH_C32(0xebd2cc30), SPH_C32(0x3d487ff6),
    SPH_C32(0x5508d0c4) },
  { SPH_C32(0x79c30000), SPH_C32(0x101e0000), SPH_C32(0x287c003c),
    SPH_C32(0x46120000), SPH_C32(0x375029af), SPH_C32(0xc3739807),
    SPH_C32(0x02983a8e), SPH_C32(0x02e9da8d), SPH_C32(0xaf240000),
    SPH_C32(0x4fed0000), SPH_C32(0xc42e005a), SPH_C32(0xcf280000),
    SPH_C32(0x8eb63b84), SPH_C32(0xdab89d49), SPH_C32(0x6543e3bb),
    SPH_C32(0xff3918bb) },
  { SPH_C32(0x21800000), SPH_C32(0x90600000), SPH_C32(0x504f003d),
    SPH_C32(0x80793800), SPH_C32(0xd0677573), SPH_C32(0xbadea7da),
    SPH_C32(0xaeebc4e1), SPH_C32(0x38ada33c), SPH_C32(0xb27e0000),
    SPH_C32(0x649f0000), SPH_C32(0x8ca3005a), SPH_C32(0x60491800),
    SPH_C32(0xab7d1541), SPH_C32(0x12c12299), SPH_C32(0xe4e1e792),
    SPH_C32(0xe14c2e1d) },
  { SPH_C32(0x64990000), SPH_C32(0x3b6c0000), SPH_C32(0x60f1003c),
    SPH_C32(0xe9731800), SPH_C32(0x129b076a), SPH_C32(0x0b0a27d7),
    SPH_C32(0x833a3ea7), SPH_C32(0x1c9cec2b), SPH_C32(0xea3d0000),
    SPH_C32(0xe4e10000), SPH_C32(0xf490005b), SPH_C32(0xa6222000),
    SPH_C32(0x4c4a499d), SPH_C32(0x6b6c1d44), SPH_C32(0x489219fd),
    SPH_C32(0xdb0857ac) },
  { SPH_C32(0x3cda0000), SPH_C32(0xbb120000), SPH_C32(0x18c2003d),
    SPH_C32(0x2f182000), SPH_C32(0xf5ac5bb6), SPH_C32(0x72a7180a),
    SPH_C32(0x2f49c0c8), SPH_C32(0x26d8959a), SPH_C32(0xf7670000),
    SPH_C32(0xcf930000), SPH_C32(0xbc1d005b), SPH_C32(0x09433800),
    SPH_C32(0x69816758), SPH_C32(0xa315a294), SPH_C32(0xc9301dd4),
    SPH_C32(0xc57d610a) },
  { SPH_C32(0x584f0000), SPH_C32(0x729f0000), SPH_C32(0xe07f000a),
    SPH_C32(0x43790000), SPH_C32(0x9b1948bd), SPH_C32(0xe74476ba),
    SPH_C32(0x5d240486), SPH_C32(0xa72142f2), SPH_C32(0x82870000),
    SPH_C32(0x445f0000), SPH_C32(0xf5d1006a), SPH_C32(0x48c80000),
    SPH_C32(0xf07031cb), SPH_C32(0xc3c9a613), SPH_C32(0x3ae7fb0f),
    SPH_C32(0x12322569) },
  { SPH_C32(0x000c0000), SPH_C32(0xf2e10000), SPH_C32(0x984c000b),
    SPH_C32(0x85123800), SPH_C32(0x7c2e1461), SPH_C32(0x9ee94967),
    SPH_C32(0xf157fae9), SPH_C32(0x9d653b43), SPH_C32(0x9fdd0000),
    SPH_C32(0x6f2d0000), SPH_C32(0xbd5c006a), SPH_C32(0xe7a91800),
    SPH_C32(0xd5bb1f0e), SPH_C32(0x0bb019c3), SPH_C32(0xbb45ff26),
    SPH_C32(0x0c4713cf) },
  { SPH_C32(0x45150000), SPH_C32(0x59ed0000), SPH_C32(0xa8f2000a),
    SPH_C32(0xec181800), SPH_C32(0xbed26678), SPH_C32(0x2f3dc96a),
    SPH_C32(0xdc8600af), SPH_C32(0xb9547454), SPH_C32(0xc79e0000),
    SPH_C32(0xef530000), SPH_C32(0xc56f006b), SPH_C32(0x21c22000),
    SPH_C32(0x328c43d2), SPH_C32(0x721d261e), SPH_C32(0x17360149),
    SPH_C32(0x36036a7e) },
  { SPH_C32(0x1d560000), SPH_C32(0xd9930000), SPH_C32(0xd0c1000b),
    SPH_C32(0x2a732000), SPH_C32(0x59e53aa4), SPH_C32(0x5690f6b7),
    SPH_C32(0x70f5fec0), SPH_C32(0x83100de5), SPH_C32(0xdac40000),
    SPH_C32(0xc4210000), SPH_C32(0x8de2006b), SPH_C32(0x8ea33800),
    SPH_C32(0x17476d17), SPH_C32(0xba6499ce), SPH_C32(0x96940560),
    SPH_C32(0x28765cd8) },
  { SPH_C32(0xfd740000), SPH_C32(0x66b90000), SPH_C32(0xae4f0014),
    SPH_C32(0x3fd70000), SPH_C32(0x14874568), SPH_C32(0x9f9bdc87),
    SPH_C32(0xaa156c5e), SPH_C32(0xac3a0bb4), SPH_C32(0x856a0000),
    SPH_C32(0xf60f0000), SPH_C32(0x72a50060), SPH_C32(0xdfc50000),
    SPH_C32(0xb3021265), SPH_C32(0x8b0ec8b7), SPH_C32(0xce9f992d),
    SPH_C32(0x824794a7) },
  { SPH_C32(0xa5370000), SPH_C32(0xe6c70000), SPH_C32(0xd67c0015),
    SPH_C32(0xf9bc3800), SPH_C32(0xf3b019b4), SPH_C32(0xe636e35a),
    SPH_C32(0x06669231), SPH_C32(0x967e7205), SPH_C32(0x98300000),
    SPH_C32(0xdd7d0000), SPH_C32(0x3a280060), SPH_C32(0x70a41800),
    SPH_C32(0x96c93ca0), SPH_C32(0x43777767), SPH_C32(0x4f3d9d04),
    SPH_C32(0x9c32a201) },
  { SPH_C32(0xe02e0000), SPH_C32(0x4dcb0000), SPH_C32(0xe6c20014),
    SPH_C32(0x90b61800), SPH_C32(0x314c6bad), SPH_C32(0x57e26357),
    SPH_C32(0x2bb76877), SPH_C32(0xb24f3d12), SPH_C32(0xc0730000),
    SPH_C32(0x5d030000), SPH_C32(0x421b0061), SPH_C32(0xb6cf2000),
    SPH_C32(0x71fe607c), SPH_C32(0x3ada48ba), SPH_C32(0xe34e636b),
    SPH_C32(0xa676dbb0) },
  { SPH_C32(0xb86d0000), SPH_C32(0xcdb50000), SPH_C32(0x9ef10015),
    SPH_C32(0x56dd2000), SPH_C32(0xd67b3771), SPH_C32(0x2e4f5c8a),
    SPH_C32(0x87c49618), SPH_C32(0x880b44a3), SPH_C32(0xdd290000),
    SPH_C32(0x76710000), SPH_C32(0x0a960061), SPH_C32(0x19ae3800),
    SPH_C32(0x54354eb9), SPH_C32(0xf2a3f76a), SPH_C32(0x62ec6742),
    SPH_C32(0xb803ed16) },
  { SPH_C32(0x5fa20000), SPH_C32(0xc0cf0000), SPH_C32(0x670b0000),
    SPH_C32(0xd4740000), SPH_C32(0xd86b6b13), SPH_C32(0xaf83181e),
    SPH_C32(0xa95c66a4), SPH_C32(0x3754f33c), SPH_C32(0x20510000),
    SPH_C32(0xe2290000), SPH_C32(0x3c95007e), SPH_C32(0xa36b0000),
    SPH_C32(0x3c9c1fb0), SPH_C32(0xf3d1628a), SPH_C32(0x39aef1f5),
    SPH_C32(0x895cdde1) },
  { SPH_C32(0x07e10000), SPH_C32(0x40b10000), SPH_C32(0x1f380001),
    SPH_C32(0x121f3800), SPH_C32(0x3f5c37cf), SPH_C32(0xd62e27c3),
    SPH_C32(0x052f98cb), SPH_C32(0x0d108a8d), SPH_C32(0x3d0b0000),
    SPH_C32(0xc95b0000), SPH_C32(0x7418007e), SPH_C32(0x0c0a1800),
    SPH_C32(0x19573175), SPH_C32(0x3ba8dd5a), SPH_C32(0xb80cf5dc),
    SPH_C32(0x9729eb47) },
  { SPH_C32(0x42f80000), SPH_C32(0xebbd0000), SPH_C32(0x2f860000),
    SPH_C32(0x7b151800), SPH_C32(0xfda045d6), SPH_C32(0x67faa7ce),
    SPH_C32(0x28fe628d), SPH_C32(0x2921c59a), SPH_C32(0x65480000),
    SPH_C32(0x49250000), SPH_C32(0x0c2b007f), SPH_C32(0xca612000),
    SPH_C32(0xfe606da9), SPH_C32(0x4205e287), SPH_C32(0x147f0bb3),
    SPH_C32(0xad6d92f6) },
  { SPH_C32(0x1abb0000), SPH_C32(0x6bc30000), SPH_C32(0x57b50001),
    SPH_C32(0xbd7e2000), SPH_C32(0x1a97190a), SPH_C32(0x1e579813),
    SPH_C32(0x848d9ce2), SPH_C32(0x1365bc2b), SPH_C32(0x78120000),
    SPH_C32(0x62570000), SPH_C32(0x44a6007f), SPH_C32(0x65003800),
    SPH_C32(0xdbab436c), SPH_C32(0x8a7c5d57), SPH_C32(0x95dd0f9a),
    SPH_C32(0xb318a450) },
  { SPH_C32(0xfa990000), SPH_C32(0xd4e90000), SPH_C32(0x293b001e),
    SPH_C32(0xa8da0000), SPH_C32(0x57f566c6), SPH_C32(0xd75cb223),
    SPH_C32(0x5e6d0e7c), SPH_C32(0x3c4fba7a), SPH_C32(0x27bc0000),
    SPH_C32(0x50790000), SPH_C32(0xbbe10074), SPH_C32(0x34660000),
    SPH_C32(0x7fee3c1e), SPH_C32(0xbb160c2e), SPH_C32(0xcdd693d7),
    SPH_C32(0x19296c2f) },
  { SPH_C32(0xa2da0000), SPH_C32(0x54970000), SPH_C32(0x5108001f),
    SPH_C32(0x6eb13800), SPH_C32(0xb0c23a1a), SPH_C32(0xaef18dfe),
    SPH_C32(0xf21ef013), SPH_C32(0x060bc3cb), SPH_C32(0x3ae60000),
    SPH_C32(0x7b0b0000), SPH_C32(0xf36c0074), SPH_C32(0x9b071800),
    SPH_C32(0x5a2512db), SPH_C32(0x736fb3fe), SPH_C32(0x4c7497fe),
    SPH_C32(0x075c5a89) },
  { SPH_C32(0xe7c30000), SPH_C32(0xff9b0000), SPH_C32(0x61b6001e),
    SPH_C32(0x07bb1800), SPH_C32(0x723e4803), SPH_C32(0x1f250df3),
    SPH_C32(0xdfcf0a55), SPH_C32(0x223a8cdc), SPH_C32(0x62a50000),
    SPH_C32(0xfb750000), SPH_C32(0x8b5f0075), SPH_C32(0x5d6c2000),
    SPH_C32(0xbd124e07), SPH_C32(0x0ac28c23), SPH_C32(0xe0076991),
    SPH_C32(0x3d182338) },
  { SPH_C32(0xbf800000), SPH_C32(0x7fe50000), SPH_C32(0x1985001f),
    SPH_C32(0xc1d02000), SPH_C32(0x950914df), SPH_C32(0x6688322e),
    SPH_C32(0x73bcf43a), SPH_C32(0x187ef56d), SPH_C32(0x7fff0000),
    SPH_C32(0xd0070000), SPH_C32(0xc3d20075), SPH_C32(0xf20d3800),
    SPH_C32(0x98d960c2), SPH_C32(0xc2bb33f3), SPH_C32(0x61a56db8),
    SPH_C32(0x236d159e) },
  { SPH_C32(0xd0d70000), SPH_C32(0x6d0b0000), SPH_C32(0x9fb00024),
    SPH_C32(0xb8370000), SPH_C32(0x6a414f27), SPH_C32(0x86eae7dd),
    SPH_C32(0xf5b174ea), SPH_C32(0x41313666), SPH_C32(0x89450000),
    SPH_C32(0x9f3c0000), SPH_C32(0x8b590066), SPH_C32(0x5d4e0000),
    SPH_C32(0x618d7938), SPH_C32(0xb6481d50), SPH_C32(0xce87bf91),
    SPH_C32(0xca84310a) },
  { SPH_C32(0x88940000), SPH_C32(0xed750000), SPH_C32(0xe7830025),
    SPH_C32(0x7e5c3800), SPH_C32(0x8d7613fb), SPH_C32(0xff47d800),
    SPH_C32(0x59c28a85), SPH_C32(0x7b754fd7), SPH_C32(0x941f0000),
    SPH_C32(0xb44e0000), SPH_C32(0xc3d40066), SPH_C32(0xf22f1800),
    SPH_C32(0x444657fd), SPH_C32(0x7e31a280), SPH_C32(0x4f25bbb8),
    SPH_C32(0xd4f107ac) },
  { SPH_C32(0xcd8d0000), SPH_C32(0x46790000), SPH_C32(0xd73d0024),
    SPH_C32(0x17561800), SPH_C32(0x4f8a61e2), SPH_C32(0x4e93580d),
    SPH_C32(0x741370c3), SPH_C32(0x5f4400c0), SPH_C32(0xcc5c0000),
    SPH_C32(0x34300000), SPH_C32(0xbbe70067), SPH_C32(0x34442000),
    SPH_C32(0xa3710b21), SPH_C32(0x079c9d5d), SPH_C32(0xe35645d7),
    SPH_C32(0xeeb57e1d) },
  { SPH_C32(0x95ce0000), SPH_C32(0xc6070000), SPH_C32(0xaf0e0025),
    SPH_C32(0xd13d2000), SPH_C32(0xa8bd3d3e), SPH_C32(0x373e67d0),
    SPH_C32(0xd8608eac), SPH_C32(0x65007971), SPH_C32(0xd1060000),
    SPH_C32(0x1f420000), SPH_C32(0xf36a0067), SPH_C32(0x9b253800),
    SPH_C32(0x86ba25e4), SPH_C32(0xcfe5228d), SPH_C32(0x62f441fe),
    SPH_C32(0xf0c048bb) },
  { SPH_C32(0x75ec0000), SPH_C32(0x792d0000), SPH_C32(0xd180003a),
    SPH_C32(0xc4990000), SPH_C32(0xe5df42f2), SPH_C32(0xfe354de0),
    SPH_C32(0x02801c32), SPH_C32(0x4a2a7f20), SPH_C32(0x8ea80000),
    SPH_C32(0x2d6c0000), SPH_C32(0x0c2d006c), SPH_C32(0xca430000),
    SPH_C32(0x22ff5a96), SPH_C32(0xfe8f73f4), SPH_C32(0x3affddb3),
    SPH_C32(0x5af180c4) },
  { SPH_C32(0x2daf0000), SPH_C32(0xf9530000), SPH_C32(0xa9b3003b),
    SPH_C32(0x02f23800), SPH_C32(0x02e81e2e), SPH_C32(0x8798723d),
    SPH_C32(0xaef3e25d), SPH_C32(0x706e0691), SPH_C32(0x93f20000),
    SPH_C32(0x061e0000), SPH_C32(0x44a0006c), SPH_C32(0x65221800),
    SPH_C32(0x07347453), SPH_C32(0x36f6cc24), SPH_C32(0xbb5dd99a),
    SPH_C32(0x4484b662) },
  { SPH_C32(0x68b60000), SPH_C32(0x525f0000), SPH_C32(0x990d003a),
    SPH_C32(0x6bf81800), SPH_C32(0xc0146c37), SPH_C32(0x364cf230),
    SPH_C32(0x8322181b), SPH_C32(0x545f4986), SPH_C32(0xcbb10000),
    SPH_C32(0x86600000), SPH_C32(0x3c93006d), SPH_C32(0xa3492000),
    SPH_C32(0xe003288f), SPH_C32(0x4f5bf3f9), SPH_C32(0x172e27f5),
    SPH_C32(0x7ec0cfd3) },
  { SPH_C32(0x30f50000), SPH_C32(0xd2210000), SPH_C32(0xe13e003b),
    SPH_C32(0xad932000), SPH_C32(0x272330eb), SPH_C32(0x4fe1cded),
    SPH_C32(0x2f51e674), SPH_C32(0x6e1b3037), SPH_C32(0xd6eb0000),
    SPH_C32(0xad120000), SPH_C32(0x741e006d), SPH_C32(0x0c283800),
    SPH_C32(0xc5c8064a), SPH_C32(0x87224c29), SPH_C32(0x968c23dc),
    SPH_C32(0x60b5f975) },
  { SPH_C32(0xd73a0000), SPH_C32(0xdf5b0000), SPH_C32(0x18c4002e),
    SPH_C32(0x2f3a0000), SPH_C32(0x29336c89), SPH_C32(0xce2d8979),
    SPH_C32(0x01c916c8), SPH_C32(0xd14487a8), SPH_C32(0x2b930000),
    SPH_C32(0x394a0000), SPH_C32(0x421d0072), SPH_C32(0xb6ed0000),
    SPH_C32(0xad615743), SPH_C32(0x8650d9c9), SPH_C32(0xcdceb56b),
    SPH_C32(0x51eac982) },
  { SPH_C32(0x8f790000), SPH_C32(0x5f250000), SPH_C32(0x60f7002f),
    SPH_C32(0xe9513800), SPH_C32(0xce043055), SPH_C32(0xb780b6a4),
    SPH_C32(0xadbae8a7), SPH_C32(0xeb00fe19), SPH_C32(0x36c90000),
    SPH_C32(0x12380000), SPH_C32(0x0a900072), SPH_C32(0x198c1800),
    SPH_C32(0x88aa7986), SPH_C32(0x4e296619), SPH_C32(0x4c6cb142),
    SPH_C32(0x4f9fff24) },
  { SPH_C32(0xca600000), SPH_C32(0xf4290000), SPH_C32(0x5049002e),
    SPH_C32(0x805b1800), SPH_C32(0x0cf8424c), SPH_C32(0x065436a9),
    SPH_C32(0x806b12e1), SPH_C32(0xcf31b10e), SPH_C32(0x6e8a0000),
    SPH_C32(0x92460000), SPH_C32(0x72a30073), SPH_C32(0xdfe72000),
    SPH_C32(0x6f9d255a), SPH_C32(0x378459c4), SPH_C32(0xe01f4f2d),
    SPH_C32(0x75db8695) },
  { SPH_C32(0x92230000), SPH_C32(0x74570000), SPH_C32(0x287a002f),
    SPH_C32(0x46302000), SPH_C32(0xebcf1e90), SPH_C32(0x7ff90974),
    SPH_C32(0x2c18ec8e), SPH_C32(0xf575c8bf), SPH_C32(0x73d00000),
    SPH_C32(0xb9340000), SPH_C32(0x3a2e0073), SPH_C32(0x70863800),
    SPH_C32(0x4a560b9f), SPH_C32(0xfffde614), SPH_C32(0x61bd4b04),
    SPH_C32(0x6baeb033) },
  { SPH_C32(0x72010000), SPH_C32(0xcb7d0000), SPH_C32(0x56f40030),
    SPH_C32(0x53940000), SPH_C32(0xa6ad615c), SPH_C32(0xb6f22344),
    SPH_C32(0xf6f87e10), SPH_C32(0xda5fceee), SPH_C32(0x2c7e0000),
    SPH_C32(0x8b1a0000), SPH_C32(0xc5690078), SPH_C32(0x21e00000),
    SPH_C32(0xee1374ed), SPH_C32(0xce97b76d), SPH_C32(0x39b6d749),
    SPH_C32(0xc19f784c) },
  { SPH_C32(0x2a420000), SPH_C32(0x4b030000), SPH_C32(0x2ec70031),
    SPH_C32(0x95ff3800), SPH_C32(0x419a3d80), SPH_C32(0xcf5f1c99),
    SPH_C32(0x5a8b807f), SPH_C32(0xe01bb75f), SPH_C32(0x31240000),
    SPH_C32(0xa0680000), SPH_C32(0x8de40078), SPH_C32(0x8e811800),
    SPH_C32(0xcbd85a28), SPH_C32(0x06ee08bd), SPH_C32(0xb814d360),
    SPH_C32(0xdfea4eea) },
  { SPH_C32(0x6f5b0000), SPH_C32(0xe00f0000), SPH_C32(0x1e790030),
    SPH_C32(0xfcf51800), SPH_C32(0x83664f99), SPH_C32(0x7e8b9c94),
    SPH_C32(0x775a7a39), SPH_C32(0xc42af848), SPH_C32(0x69670000),
    SPH_C32(0x20160000), SPH_C32(0xf5d70079), SPH_C32(0x48ea2000),
    SPH_C32(0x2cef06f4), SPH_C32(0x7f433760), SPH_C32(0x14672d0f),
    SPH_C32(0xe5ae375b) },
  { SPH_C32(0x37180000), SPH_C32(0x60710000), SPH_C32(0x664a0031),
    SPH_C32(0x3a9e2000), SPH_C32(0x64511345), SPH_C32(0x0726a349),
    SPH_C32(0xdb298456), SPH_C32(0xfe6e81f9), SPH_C32(0x743d0000),
    SPH_C32(0x0b640000), SPH_C32(0xbd5a0079), SPH_C32(0xe78b3800),
    SPH_C32(0x09242831), SPH_C32(0xb73a88b0), SPH_C32(0x95c52926),
    SPH_C32(0xfbdb01fd) },
  { SPH_C32(0x01dd0000), SPH_C32(0x80a80000), SPH_C32(0xf4960048),
    SPH_C32(0xa6000000), SPH_C32(0x90d57ea2), SPH_C32(0xd7e68c37),
    SPH_C32(0x6612cffd), SPH_C32(0x2c94459e), SPH_C32(0x52500000),
    SPH_C32(0x29540000), SPH_C32(0x6a61004e), SPH_C32(0xf0ff0000),
    SPH_C32(0x9a317eec), SPH_C32(0x452341ce), SPH_C32(0xcf568fe5),
    SPH_C32(0x5303130f) },
  { SPH_C32(0x599e0000), SPH_C32(0x00d60000), SPH_C32(0x8ca50049),
    SPH_C32(0x606b3800), SPH_C32(0x77e2227e), SPH_C32(0xae4bb3ea),
    SPH_C32(0xca613192), SPH_C32(0x16d03c2f), SPH_C32(0x4f0a0000),
    SPH_C32(0x02260000), SPH_C32(0x22ec004e), SPH_C32(0x5f9e1800),
    SPH_C32(0xbffa5029), SPH_C32(0x8d5afe1e), SPH_C32(0x4ef48bcc),
    SPH_C32(0x4d7625a9) },
  { SPH_C32(0x1c870000), SPH_C32(0xabda0000), SPH_C32(0xbc1b0048),
    SPH_C32(0x09611800), SPH_C32(0xb51e5067), SPH_C32(0x1f9f33e7),
    SPH_C32(0xe7b0cbd4), SPH_C32(0x32e17338), SPH_C32(0x17490000),
    SPH_C32(0x82580000), SPH_C32(0x5adf004f), SPH_C32(0x99f52000),
    SPH_C32(0x58cd0cf5), SPH_C32(0xf4f7c1c3), SPH_C32(0xe28775a3),
    SPH_C32(0x77325c18) },
  { SPH_C32(0x44c40000), SPH_C32(0x2ba40000), SPH_C32(0xc4280049),
    SPH_C32(0xcf0a2000), SPH_C32(0x52290cbb), SPH_C32(0x66320c3a),
    SPH_C32(0x4bc335bb), SPH_C32(0x08a50a89), SPH_C32(0x0a130000),
    SPH_C32(0xa92a0000), SPH_C32(0x1252004f), SPH_C32(0x36943800),
    SPH_C32(0x7d062230), SPH_C32(0x3c8e7e13), SPH_C32(0x6325718a),
    SPH_C32(0x69476abe) },
  { SPH_C32(0xa4e60000), SPH_C32(0x948e0000), SPH_C32(0xbaa60056),
    SPH_C32(0xdaae0000), SPH_C32(0x1f4b7377), SPH_C32(0xaf39260a),
    SPH_C32(0x9123a725), SPH_C32(0x278f0cd8), SPH_C32(0x55bd0000),
    SPH_C32(0x9b040000), SPH_C32(0xed150044), SPH_C32(0x67f20000),
    SPH_C32(0xd9435d42), SPH_C32(0x0de42f6a), SPH_C32(0x3b2eedc7),
    SPH_C32(0xc376a2c1) },
  { SPH_C32(0xfca50000), SPH_C32(0x14f00000), SPH_C32(0xc2950057),
    SPH_C32(0x1cc53800), SPH_C32(0xf87c2fab), SPH_C32(0xd69419d7),
    SPH_C32(0x3d50594a), SPH_C32(0x1dcb7569), SPH_C32(0x48e70000),
    SPH_C32(0xb0760000), SPH_C32(0xa5980044), SPH_C32(0xc8931800),
    SPH_C32(0xfc887387), SPH_C32(0xc59d90ba), SPH_C32(0xba8ce9ee),
    SPH_C32(0xdd039467) },
  { SPH_C32(0xb9bc0000), SPH_C32(0xbffc0000), SPH_C32(0xf22b0056),
    SPH_C32(0x75cf1800), SPH_C32(0x3a805db2), SPH_C32(0x674099da),
    SPH_C32(0x1081a30c), SPH_C32(0x39fa3a7e), SPH_C32(0x10a40000),
    SPH_C32(0x30080000), SPH_C32(0xddab0045), SPH_C32(0x0ef82000),
    SPH_C32(0x1bbf2f5b), SPH_C32(0xbc30af67), SPH_C32(0x16ff1781),
    SPH_C32(0xe747edd6) },
  { SPH_C32(0xe1ff0000), SPH_C32(0x3f820000), SPH_C32(0x8a180057),
    SPH_C32(0xb3a42000), SPH_C32(0xddb7016e), SPH_C32(0x1eeda607),
    SPH_C32(0xbcf25d63), SPH_C32(0x03be43cf), SPH_C32(0x0dfe0000),
    SPH_C32(0x1b7a0000), SPH_C32(0x95260045), SPH_C32(0xa1993800),
    SPH_C32(0x3e74019e), SPH_C32(0x744910b7), SPH_C32(0x975d13a8),
    SPH_C32(0xf932db70) },
  { SPH_C32(0x06300000), SPH_C32(0x32f80000), SPH_C32(0x73e20042),
    SPH_C32(0x310d0000), SPH_C32(0xd3a75d0c), SPH_C32(0x9f21e293),
    SPH_C32(0x926aaddf), SPH_C32(0xbce1f450), SPH_C32(0xf0860000),
    SPH_C32(0x8f220000), SPH_C32(0xa325005a), SPH_C32(0x1b5c0000),
    SPH_C32(0x56dd5097), SPH_C32(0x753b8557), SPH_C32(0xcc1f851f),
    SPH_C32(0xc86deb87) },
  { SPH_C32(0x5e730000), SPH_C32(0xb2860000), SPH_C32(0x0bd10043),
    SPH_C32(0xf7663800), SPH_C32(0x349001d0), SPH_C32(0xe68cdd4e),
    SPH_C32(0x3e1953b0), SPH_C32(0x86a58de1), SPH_C32(0xeddc0000),
    SPH_C32(0xa4500000), SPH_C32(0xeba8005a), SPH_C32(0xb43d1800),
    SPH_C32(0x73167e52), SPH_C32(0xbd423a87), SPH_C32(0x4dbd8136),
    SPH_C32(0xd618dd21) },
  { SPH_C32(0x1b6a0000), SPH_C32(0x198a0000), SPH_C32(0x3b6f0042),
    SPH_C32(0x9e6c1800), SPH_C32(0xf66c73c9), SPH_C32(0x57585d43),
    SPH_C32(0x13c8a9f6), SPH_C32(0xa294c2f6), SPH_C32(0xb59f0000),
    SPH_C32(0x242e0000), SPH_C32(0x939b005b), SPH_C32(0x72562000),
    SPH_C32(0x9421228e), SPH_C32(0xc4ef055a), SPH_C32(0xe1ce7f59),
    SPH_C32(0xec5ca490) },
  { SPH_C32(0x43290000), SPH_C32(0x99f40000), SPH_C32(0x435c0043),
    SPH_C32(0x58072000), SPH_C32(0x115b2f15), SPH_C32(0x2ef5629e),
    SPH_C32(0xbfbb5799), SPH_C32(0x98d0bb47), SPH_C32(0xa8c50000),
    SPH_C32(0x0f5c0000), SPH_C32(0xdb16005b), SPH_C32(0xdd373800),
    SPH_C32(0xb1ea0c4b), SPH_C32(0x0c96ba8a), SPH_C32(0x606c7b70),
    SPH_C32(0xf2299236) },
  { SPH_C32(0xa30b0000), SPH_C32(0x26de0000), SPH_C32(0x3dd2005c),
    SPH_C32(0x4da30000), SPH_C32(0x5c3950d9), SPH_C32(0xe7fe48ae),
    SPH_C32(0x655bc507), SPH_C32(0xb7fabd16), SPH_C32(0xf76b0000),
    SPH_C32(0x3d720000), SPH_C32(0x24510050), SPH_C32(0x8c510000),
    SPH_C32(0x15af7339), SPH_C32(0x3dfcebf3), SPH_C32(0x3867e73d),
    SPH_C32(0x58185a49) },
  { SPH_C32(0xfb480000), SPH_C32(0xa6a00000), SPH_C32(0x45e1005d),
    SPH_C32(0x8bc83800), SPH_C32(0xbb0e0c05), SPH_C32(0x9e537773),
    SPH_C32(0xc9283b68), SPH_C32(0x8dbec4a7), SPH_C32(0xea310000),
    SPH_C32(0x16000000), SPH_C32(0x6cdc0050), SPH_C32(0x23301800),
    SPH_C32(0x30645dfc), SPH_C32(0xf5855423), SPH_C32(0xb9c5e314),
    SPH_C32(0x466d6cef) },
  { SPH_C32(0xbe510000), SPH_C32(0x0dac0000), SPH_C32(0x755f005c),
    SPH_C32(0xe2c21800), SPH_C32(0x79f27e1c), SPH_C32(0x2f87f77e),
    SPH_C32(0xe4f9c12e), SPH_C32(0xa98f8bb0), SPH_C32(0xb2720000),
    SPH_C32(0x967e0000), SPH_C32(0x14ef0051), SPH_C32(0xe55b2000),
    SPH_C32(0xd7530120), SPH_C32(0x8c286bfe), SPH_C32(0x15b61d7b),
    SPH_C32(0x7c29155e) },
  { SPH_C32(0xe6120000), SPH_C32(0x8dd20000), SPH_C32(0x0d6c005d),
    SPH_C32(0x24a92000), SPH_C32(0x9ec522c0), SPH_C32(0x562ac8a3),
    SPH_C32(0x488a3f41), SPH_C32(0x93cbf201), SPH_C32(0xaf280000),
    SPH_C32(0xbd0c0000), SPH_C32(0x5c620051), SPH_C32(0x4a3a3800),
    SPH_C32(0xf2982fe5), SPH_C32(0x4451d42e), SPH_C32(0x94141952),
    SPH_C32(0x625c23f8) },
  { SPH_C32(0x89450000), SPH_C32(0x9f3c0000), SPH_C32(0x8b590066),
    SPH_C32(0x5d4e0000), SPH_C32(0x618d7938), SPH_C32(0xb6481d50),
    SPH_C32(0xce87bf91), SPH_C32(0xca84310a), SPH_C32(0x59920000),
    SPH_C32(0xf2370000), SPH_C32(0x14e90042), SPH_C32(0xe5790000),
    SPH_C32(0x0bcc361f), SPH_C32(0x30a2fa8d), SPH_C32(0x3b36cb7b),
    SPH_C32(0x8bb5076c) },
  { SPH_C32(0xd1060000), SPH_C32(0x1f420000), SPH_C32(0xf36a0067),
    SPH_C32(0x9b253800), SPH_C32(0x86ba25e4), SPH_C32(0xcfe5228d),
    SPH_C32(0x62f441fe), SPH_C32(0xf0c048bb), SPH_C32(0x44c80000),
    SPH_C32(0xd9450000), SPH_C32(0x5c640042), SPH_C32(0x4a181800),
    SPH_C32(0x2e0718da), SPH_C32(0xf8db455d), SPH_C32(0xba94cf52),
    SPH_C32(0x95c031ca) },
  { SPH_C32(0x941f0000), SPH_C32(0xb44e0000), SPH_C32(0xc3d40066),
    SPH_C32(0xf22f1800), SPH_C32(0x444657fd), SPH_C32(0x7e31a280),
    SPH_C32(0x4f25bbb8), SPH_C32(0xd4f107ac), SPH_C32(0x1c8b0000),
    SPH_C32(0x593b0000), SPH_C32(0x24570043), SPH_C32(0x8c732000),
    SPH_C32(0xc9304406), SPH_C32(0x81767a80), SPH_C32(0x16e7313d),
    SPH_C32(0xaf84487b) },
  { SPH_C32(0xcc5c0000), SPH_C32(0x34300000), SPH_C32(0xbbe70067),
    SPH_C32(0x34442000), SPH_C32(0xa3710b21), SPH_C32(0x079c9d5d),
    SPH_C32(0xe35645d7), SPH_C32(0xeeb57e1d), SPH_C32(0x01d10000),
    SPH_C32(0x72490000), SPH_C32(0x6cda0043), SPH_C32(0x23123800),
    SPH_C32(0xecfb6ac3), SPH_C32(0x490fc550), SPH_C32(0x97453514),
    SPH_C32(0xb1f17edd) },
  { SPH_C32(0x2c7e0000), SPH_C32(0x8b1a0000), SPH_C32(0xc5690078),
    SPH_C32(0x21e00000), SPH_C32(0xee1374ed), SPH_C32(0xce97b76d),
    SPH_C32(0x39b6d749), SPH_C32(0xc19f784c), SPH_C32(0x5e7f0000),
    SPH_C32(0x40670000), SPH_C32(0x939d0048), SPH_C32(0x72740000),
    SPH_C32(0x48be15b1), SPH_C32(0x78659429), SPH_C32(0xcf4ea959),
    SPH_C32(0x1bc0b6a2) },
  { SPH_C32(0x743d0000), SPH_C32(0x0b640000), SPH_C32(0xbd5a0079),
    SPH_C32(0xe78b3800), SPH_C32(0x09242831), SPH_C32(0xb73a88b0),
    SPH_C32(0x95c52926), SPH_C32(0xfbdb01fd), SPH_C32(0x43250000),
    SPH_C32(0x6b150000), SPH_C32(0xdb100048), SPH_C32(0xdd151800),
    SPH_C32(0x6d753b74), SPH_C32(0xb01c2bf9), SPH_C32(0x4eecad70),
    SPH_C32(0x05b58004) },
  { SPH_C32(0x31240000), SPH_C32(0xa0680000), SPH_C32(0x8de40078),
    SPH_C32(0x8e811800), SPH_C32(0xcbd85a28), SPH_C32(0x06ee08bd),
    SPH_C32(0xb814d360), SPH_C32(0xdfea4eea), SPH_C32(0x1b660000),
    SPH_C32(0xeb6b0000), SPH_C32(0xa3230049), SPH_C32(0x1b7e2000),
    SPH_C32(0x8a4267a8), SPH_C32(0xc9b11424), SPH_C32(0xe29f531f),
    SPH_C32(0x3ff1f9b5) },
  { SPH_C32(0x69670000), SPH_C32(0x20160000), SPH_C32(0xf5d70079),
    SPH_C32(0x48ea2000), SPH_C32(0x2cef06f4), SPH_C32(0x7f433760),
    SPH_C32(0x14672d0f), SPH_C32(0xe5ae375b), SPH_C32(0x063c0000),
    SPH_C32(0xc0190000), SPH_C32(0xebae0049), SPH_C32(0xb41f3800),
    SPH_C32(0xaf89496d), SPH_C32(0x01c8abf4), SPH_C32(0x633d5736),
    SPH_C32(0x2184cf13) },
  { SPH_C32(0x8ea80000), SPH_C32(0x2d6c0000), SPH_C32(0x0c2d006c),
    SPH_C32(0xca430000), SPH_C32(0x22ff5a96), SPH_C32(0xfe8f73f4),
    SPH_C32(0x3affddb3), SPH_C32(0x5af180c4), SPH_C32(0xfb440000),
    SPH_C32(0x54410000), SPH_C32(0xddad0056), SPH_C32(0x0eda0000),
    SPH_C32(0xc7201864), SPH_C32(0x00ba3e14), SPH_C32(0x387fc181),
    SPH_C32(0x10dbffe4) },
  { SPH_C32(0xd6eb0000), SPH_C32(0xad120000), SPH_C32(0x741e006d),
    SPH_C32(0x0c283800), SPH_C32(0xc5c8064a), SPH_C32(0x87224c29),
    SPH_C32(0x968c23dc), SPH_C32(0x60b5f975), SPH_C32(0xe61e0000),
    SPH_C32(0x7f330000), SPH_C32(0x95200056), SPH_C32(0xa1bb1800),
    SPH_C32(0xe2eb36a1), SPH_C32(0xc8c381c4), SPH_C32(0xb9ddc5a8),
    SPH_C32(0x0eaec942) },
  { SPH_C32(0x93f20000), SPH_C32(0x061e0000), SPH_C32(0x44a0006c),
    SPH_C32(0x65221800), SPH_C32(0x07347453), SPH_C32(0x36f6cc24),
    SPH_C32(0xbb5dd99a), SPH_C32(0x4484b662), SPH_C32(0xbe5d0000),
    SPH_C32(0xff4d0000), SPH_C32(0xed130057), SPH_C32(0x67d02000),
    SPH_C32(0x05dc6a7d), SPH_C32(0xb16ebe19), SPH_C32(0x15ae3bc7),
    SPH_C32(0x34eab0f3) },
  { SPH_C32(0xcbb10000), SPH_C32(0x86600000), SPH_C32(0x3c93006d),
    SPH_C32(0xa3492000), SPH_C32(0xe003288f), SPH_C32(0x4f5bf3f9),
    SPH_C32(0x172e27f5), SPH_C32(0x7ec0cfd3), SPH_C32(0xa3070000),
    SPH_C32(0xd43f0000), SPH_C32(0xa59e0057), SPH_C32(0xc8b13800),
    SPH_C32(0x201744b8), SPH_C32(0x791701c9), SPH_C32(0x940c3fee),
    SPH_C32(0x2a9f8655) },
  { SPH_C32(0x2b930000), SPH_C32(0x394a0000), SPH_C32(0x421d0072),
    SPH_C32(0xb6ed0000), SPH_C32(0xad615743), SPH_C32(0x8650d9c9),
    SPH_C32(0xcdceb56b), SPH_C32(0x51eac982), SPH_C32(0xfca90000),
    SPH_C32(0xe6110000), SPH_C32(0x5ad9005c), SPH_C32(0x99d70000),
    SPH_C32(0x84523bca), SPH_C32(0x487d50b0), SPH_C32(0xcc07a3a3),
    SPH_C32(0x80ae4e2a) },
  { SPH_C32(0x73d00000), SPH_C32(0xb9340000), SPH_C32(0x3a2e0073),
    SPH_C32(0x70863800), SPH_C32(0x4a560b9f), SPH_C32(0xfffde614),
    SPH_C32(0x61bd4b04), SPH_C32(0x6baeb033), SPH_C32(0xe1f30000),
    SPH_C32(0xcd630000), SPH_C32(0x1254005c), SPH_C32(0x36b61800),
    SPH_C32(0xa199150f), SPH_C32(0x8004ef60), SPH_C32(0x4da5a78a),
    SPH_C32(0x9edb788c) },
  { SPH_C32(0x36c90000), SPH_C32(0x12380000), SPH_C32(0x0a900072),
    SPH_C32(0x198c1800), SPH_C32(0x88aa7986), SPH_C32(0x4e296619),
    SPH_C32(0x4c6cb142), SPH_C32(0x4f9fff24), SPH_C32(0xb9b00000),
    SPH_C32(0x4d1d0000), SPH_C32(0x6a67005d), SPH_C32(0xf0dd2000),
    SPH_C32(0x46ae49d3), SPH_C32(0xf9a9d0bd), SPH_C32(0xe1d659e5),
    SPH_C32(0xa49f013d) },
  { SPH_C32(0x6e8a0000), SPH_C32(0x92460000), SPH_C32(0x72a30073),
    SPH_C32(0xdfe72000), SPH_C32(0x6f9d255a), SPH_C32(0x378459c4),
    SPH_C32(0xe01f4f2d), SPH_C32(0x75db8695), SPH_C32(0xa4ea0000),
    SPH_C32(0x666f0000), SPH_C32(0x22ea005d), SPH_C32(0x5fbc3800),
    SPH_C32(0x63656716), SPH_C32(0x31d06f6d), SPH_C32(0x60745dcc),
    SPH_C32(0xbaea379b) },
  { SPH_C32(0x0a1f0000), SPH_C32(0x5bcb0000), SPH_C32(0x8a1e0044),
    SPH_C32(0xb3860000), SPH_C32(0x01283651), SPH_C32(0xa2673774),
    SPH_C32(0x92728b63), SPH_C32(0xf42251fd), SPH_C32(0xd10a0000),
    SPH_C32(0xeda30000), SPH_C32(0x6b26006c), SPH_C32(0x1e370000),
    SPH_C32(0xfa943185), SPH_C32(0x510c6bea), SPH_C32(0x93a3bb17),
    SPH_C32(0x6da573f8) },
  { SPH_C32(0x525c0000), SPH_C32(0xdbb50000), SPH_C32(0xf22d0045),
    SPH_C32(0x75ed3800), SPH_C32(0xe61f6a8d), SPH_C32(0xdbca08a9),
    SPH_C32(0x3e01750c), SPH_C32(0xce66284c), SPH_C32(0xcc500000),
    SPH_C32(0xc6d10000), SPH_C32(0x23ab006c), SPH_C32(0xb1561800),
    SPH_C32(0xdf5f1f40), SPH_C32(0x9975d43a), SPH_C32(0x1201bf3e),
    SPH_C32(0x73d0455e) },
  { SPH_C32(0x17450000), SPH_C32(0x70b90000), SPH_C32(0xc2930044),
    SPH_C32(0x1ce71800), SPH_C32(0x24e31894), SPH_C32(0x6a1e88a4),
    SPH_C32(0x13d08f4a), SPH_C32(0xea57675b), SPH_C32(0x94130000),
    SPH_C32(0x46af0000), SPH_C32(0x5b98006d), SPH_C32(0x773d2000),
    SPH_C32(0x3868439c), SPH_C32(0xe0d8ebe7), SPH_C32(0xbe724151),
    SPH_C32(0x49943cef) },
  { SPH_C32(0x4f060000), SPH_C32(0xf0c70000), SPH_C32(0xbaa00045),
    SPH_C32(0xda8c2000), SPH_C32(0xc3d44448), SPH_C32(0x13b3b779),
    SPH_C32(0xbfa37125), SPH_C32(0xd0131eea), SPH_C32(0x89490000),
    SPH_C32(0x6ddd0000), SPH_C32(0x1315006d), SPH_C32(0xd85c3800),
    SPH_C32(0x1da36d59), SPH_C32(0x28a15437), SPH_C32(0x3fd04578),
    SPH_C32(0x57e10a49) },
  { SPH_C32(0xaf240000), SPH_C32(0x4fed0000), SPH_C32(0xc42e005a),
    SPH_C32(0xcf280000), SPH_C32(0x8eb63b84), SPH_C32(0xdab89d49),
    SPH_C32(0x6543e3bb), SPH_C32(0xff3918bb), SPH_C32(0xd6e70000),
    SPH_C32(0x5ff30000), SPH_C32(0xec520066), SPH_C32(0x893a0000),
    SPH_C32(0xb9e6122b), SPH_C32(0x19cb054e), SPH_C32(0x67dbd935),
    SPH_C32(0xfdd0c236) },
  { SPH_C32(0xf7670000), SPH_C32(0xcf930000), SPH_C32(0xbc1d005b),
    SPH_C32(0x09433800), SPH_C32(0x69816758), SPH_C32(0xa315a294),
    SPH_C32(0xc9301dd4), SPH_C32(0xc57d610a), SPH_C32(0xcbbd0000),
    SPH_C32(0x74810000), SPH_C32(0xa4df0066), SPH_C32(0x265b1800),
    SPH_C32(0x9c2d3cee), SPH_C32(0xd1b2ba9e), SPH_C32(0xe679dd1c),
    SPH_C32(0xe3a5f490) },
  { SPH_C32(0xb27e0000), SPH_C32(0x649f0000), SPH_C32(0x8ca3005a),
    SPH_C32(0x60491800), SPH_C32(0xab7d1541), SPH_C32(0x12c12299),
    SPH_C32(0xe4e1e792), SPH_C32(0xe14c2e1d), SPH_C32(0x93fe0000),
    SPH_C32(0xf4ff0000), SPH_C32(0xdcec0067), SPH_C32(0xe0302000),
    SPH_C32(0x7b1a6032), SPH_C32(0xa81f8543), SPH_C32(0x4a0a2373),
    SPH_C32(0xd9e18d21) },
  { SPH_C32(0xea3d0000), SPH_C32(0xe4e10000), SPH_C32(0xf490005b),
    SPH_C32(0xa6222000), SPH_C32(0x4c4a499d), SPH_C32(0x6b6c1d44),
    SPH_C32(0x489219fd), SPH_C32(0xdb0857ac), SPH_C32(0x8ea40000),
    SPH_C32(0xdf8d0000), SPH_C32(0x94610067), SPH_C32(0x4f513800),
    SPH_C32(0x5ed14ef7), SPH_C32(0x60663a93), SPH_C32(0xcba8275a),
    SPH_C32(0xc794bb87) },
  { SPH_C32(0x0df20000), SPH_C32(0xe99b0000), SPH_C32(0x0d6a004e),
    SPH_C32(0x248b0000), SPH_C32(0x425a15ff), SPH_C32(0xeaa059d0),
    SPH_C32(0x660ae941), SPH_C32(0x6457e033), SPH_C32(0x73dc0000),
    SPH_C32(0x4bd50000), SPH_C32(0xa2620078), SPH_C32(0xf5940000),
    SPH_C32(0x36781ffe), SPH_C32(0x6114af73), SPH_C32(0x90eab1ed),
    SPH_C32(0xf6cb8b70) },
  { SPH_C32(0x55b10000), SPH_C32(0x69e50000), SPH_C32(0x7559004f),
    SPH_C32(0xe2e03800), SPH_C32(0xa56d4923), SPH_C32(0x930d660d),
    SPH_C32(0xca79172e), SPH_C32(0x5e139982), SPH_C32(0x6e860000),
    SPH_C32(0x60a70000), SPH_C32(0xeaef0078), SPH_C32(0x5af51800),
    SPH_C32(0x13b3313b), SPH_C32(0xa96d10a3), SPH_C32(0x1148b5c4),
    SPH_C32(0xe8bebdd6) },
  { SPH_C32(0x10a80000), SPH_C32(0xc2e90000), SPH_C32(0x45e7004e),
    SPH_C32(0x8bea1800), SPH_C32(0x67913b3a), SPH_C32(0x22d9e600),
    SPH_C32(0xe7a8ed68), SPH_C32(0x7a22d695), SPH_C32(0x36c50000),
    SPH_C32(0xe0d90000), SPH_C32(0x92dc0079), SPH_C32(0x9c9e2000),
    SPH_C32(0xf4846de7), SPH_C32(0xd0c02f7e), SPH_C32(0xbd3b4bab),
    SPH_C32(0xd2fac467) },
  { SPH_C32(0x48eb0000), SPH_C32(0x42970000), SPH_C32(0x3dd4004f),
    SPH_C32(0x4d812000), SPH_C32(0x80a667e6), SPH_C32(0x5b74d9dd),
    SPH_C32(0x4bdb1307), SPH_C32(0x4066af24), SPH_C32(0x2b9f0000),
    SPH_C32(0xcbab0000), SPH_C32(0xda510079), SPH_C32(0x33ff3800),
    SPH_C32(0xd14f4322), SPH_C32(0x18b990ae), SPH_C32(0x3c994f82),
    SPH_C32(0xcc8ff2c1) },
  { SPH_C32(0xa8c90000), SPH_C32(0xfdbd0000), SPH_C32(0x435a0050),
    SPH_C32(0x58250000), SPH_C32(0xcdc4182a), SPH_C32(0x927ff3ed),
    SPH_C32(0x913b8199), SPH_C32(0x6f4ca975), SPH_C32(0x74310000),
    SPH_C32(0xf9850000), SPH_C32(0x25160072), SPH_C32(0x62990000),
    SPH_C32(0x750a3c50), SPH_C32(0x29d3c1d7), SPH_C32(0x6492d3cf),
    SPH_C32(0x66be3abe) },
  { SPH_C32(0xf08a0000), SPH_C32(0x7dc30000), SPH_C32(0x3b690051),
    SPH_C32(0x9e4e3800), SPH_C32(0x2af344f6), SPH_C32(0xebd2cc30),
    SPH_C32(0x3d487ff6), SPH_C32(0x5508d0c4), SPH_C32(0x696b0000),
    SPH_C32(0xd2f70000), SPH_C32(0x6d9b0072), SPH_C32(0xcdf81800),
    SPH_C32(0x50c11295), SPH_C32(0xe1aa7e07), SPH_C32(0xe530d7e6),
    SPH_C32(0x78cb0c18) },
  { SPH_C32(0xb5930000), SPH_C32(0xd6cf0000), SPH_C32(0x0bd70050),
    SPH_C32(0xf7441800), SPH_C32(0xe80f36ef), SPH_C32(0x5a064c3d),
    SPH_C32(0x109985b0), SPH_C32(0x71399fd3), SPH_C32(0x31280000),
    SPH_C32(0x52890000), SPH_C32(0x15a80073), SPH_C32(0x0b932000),
    SPH_C32(0xb7f64e49), SPH_C32(0x980741da), SPH_C32(0x49432989),
    SPH_C32(0x428f75a9) },
  { SPH_C32(0xedd00000), SPH_C32(0x56b10000), SPH_C32(0x73e40051),
    SPH_C32(0x312f2000), SPH_C32(0x0f386a33), SPH_C32(0x23ab73e0),
    SPH_C32(0xbcea7bdf), SPH_C32(0x4b7de662), SPH_C32(0x2c720000),
    SPH_C32(0x79fb0000), SPH_C32(0x5d250073), SPH_C32(0xa4f23800),
    SPH_C32(0x923d608c), SPH_C32(0x507efe0a), SPH_C32(0xc8e12da0),
    SPH_C32(0x5cfa430f) },
  { SPH_C32(0x82870000), SPH_C32(0x445f0000), SPH_C32(0xf5d1006a),
    SPH_C32(0x48c80000), SPH_C32(0xf07031cb), SPH_C32(0xc3c9a613),
    SPH_C32(0x3ae7fb0f), SPH_C32(0x12322569), SPH_C32(0xdac80000),
    SPH_C32(0x36c00000), SPH_C32(0x15ae0060), SPH_C32(0x0bb10000),
    SPH_C32(0x6b697976), SPH_C32(0x248dd0a9), SPH_C32(0x67c3ff89),
    SPH_C32(0xb513679b) },
  { SPH_C32(0xdac40000), SPH_C32(0xc4210000), SPH_C32(0x8de2006b),
    SPH_C32(0x8ea33800), SPH_C32(0x17476d17), SPH_C32(0xba6499ce),
    SPH_C32(0x96940560), SPH_C32(0x28765cd8), SPH_C32(0xc7920000),
    SPH_C32(0x1db20000), SPH_C32(0x5d230060), SPH_C32(0xa4d01800),
    SPH_C32(0x4ea257b3), SPH_C32(0xecf46f79), SPH_C32(0xe661fba0),
    SPH_C32(0xab66513d) },
  { SPH_C32(0x9fdd0000), SPH_C32(0x6f2d0000), SPH_C32(0xbd5c006a),
    SPH_C32(0xe7a91800), SPH_C32(0xd5bb1f0e), SPH_C32(0x0bb019c3),
    SPH_C32(0xbb45ff26), SPH_C32(0x0c4713cf), SPH_C32(0x9fd10000),
    SPH_C32(0x9dcc0000), SPH_C32(0x25100061), SPH_C32(0x62bb2000),
    SPH_C32(0xa9950b6f), SPH_C32(0x955950a4), SPH_C32(0x4a1205cf),
    SPH_C32(0x9122288c) },
  { SPH_C32(0xc79e0000), SPH_C32(0xef530000), SPH_C32(0xc56f006b),
    SPH_C32(0x21c22000), SPH_C32(0x328c43d2), SPH_C32(0x721d261e),
    SPH_C32(0x17360149), SPH_C32(0x36036a7e), SPH_C32(0x828b0000),
    SPH_C32(0xb6be0000), SPH_C32(0x6d9d0061), SPH_C32(0xcdda3800),
    SPH_C32(0x8c5e25aa), SPH_C32(0x5d20ef74), SPH_C32(0xcbb001e6),
    SPH_C32(0x8f571e2a) },
  { SPH_C32(0x27bc0000), SPH_C32(0x50790000), SPH_C32(0xbbe10074),
    SPH_C32(0x34660000), SPH_C32(0x7fee3c1e), SPH_C32(0xbb160c2e),
    SPH_C32(0xcdd693d7), SPH_C32(0x19296c2f), SPH_C32(0xdd250000),
    SPH_C32(0x84900000), SPH_C32(0x92da006a), SPH_C32(0x9cbc0000),
    SPH_C32(0x281b5ad8), SPH_C32(0x6c4abe0d), SPH_C32(0x93bb9dab),
    SPH_C32(0x2566d655) },
  { SPH_C32(0x7fff0000), SPH_C32(0xd0070000), SPH_C32(0xc3d20075),
    SPH_C32(0xf20d3800), SPH_C32(0x98d960c2), SPH_C32(0xc2bb33f3),
    SPH_C32(0x61a56db8), SPH_C32(0x236d159e), SPH_C32(0xc07f0000),
    SPH_C32(0xafe20000), SPH_C32(0xda57006a), SPH_C32(0x33dd1800),
    SPH_C32(0x0dd0741d), SPH_C32(0xa43301dd), SPH_C32(0x12199982),
    SPH_C32(0x3b13e0f3) },
  { SPH_C32(0x3ae60000), SPH_C32(0x7b0b0000), SPH_C32(0xf36c0074),
    SPH_C32(0x9b071800), SPH_C32(0x5a2512db), SPH_C32(0x736fb3fe),
    SPH_C32(0x4c7497fe), SPH_C32(0x075c5a89), SPH_C32(0x983c0000),
    SPH_C32(0x2f9c0000), SPH_C32(0xa264006b), SPH_C32(0xf5b62000),
    SPH_C32(0xeae728c1), SPH_C32(0xdd9e3e00), SPH_C32(0xbe6a67ed),
    SPH_C32(0x01579942) },
  { SPH_C32(0x62a50000), SPH_C32(0xfb750000), SPH_C32(0x8b5f0075),
    SPH_C32(0x5d6c2000), SPH_C32(0xbd124e07), SPH_C32(0x0ac28c23),
    SPH_C32(0xe0076991), SPH_C32(0x3d182338), SPH_C32(0x85660000),
    SPH_C32(0x04ee0000), SPH_C32(0xeae9006b), SPH_C32(0x5ad73800),
    SPH_C32(0xcf2c0604), SPH_C32(0x15e781d0), SPH_C32(0x3fc863c4),
    SPH_C32(0x1f22afe4) },
  { SPH_C32(0x856a0000), SPH_C32(0xf60f0000), SPH_C32(0x72a50060),
    SPH_C32(0xdfc50000), SPH_C32(0xb3021265), SPH_C32(0x8b0ec8b7),
    SPH_C32(0xce9f992d), SPH_C32(0x824794a7), SPH_C32(0x781e0000),
    SPH_C32(0x90b60000), SPH_C32(0xdcea0074), SPH_C32(0xe0120000),
    SPH_C32(0xa785570d), SPH_C32(0x14951430), SPH_C32(0x648af573),
    SPH_C32(0x2e7d9f13) },
  { SPH_C32(0xdd290000), SPH_C32(0x76710000), SPH_C32(0x0a960061),
    SPH_C32(0x19ae3800), SPH_C32(0x54354eb9), SPH_C32(0xf2a3f76a),
    SPH_C32(0x62ec6742), SPH_C32(0xb803ed16), SPH_C32(0x65440000),
    SPH_C32(0xbbc40000), SPH_C32(0x94670074), SPH_C32(0x4f731800),
    SPH_C32(0x824e79c8), SPH_C32(0xdcecabe0), SPH_C32(0xe528f15a),
    SPH_C32(0x3008a9b5) },
  { SPH_C32(0x98300000), SPH_C32(0xdd7d0000), SPH_C32(0x3a280060),
    SPH_C32(0x70a41800), SPH_C32(0x96c93ca0), SPH_C32(0x43777767),
    SPH_C32(0x4f3d9d04), SPH_C32(0x9c32a201), SPH_C32(0x3d070000),
    SPH_C32(0x3bba0000), SPH_C32(0xec540075), SPH_C32(0x89182000),
    SPH_C32(0x65792514), SPH_C32(0xa541943d), SPH_C32(0x495b0f35),
    SPH_C32(0x0a4cd004) },
  { SPH_C32(0xc0730000), SPH_C32(0x5d030000), SPH_C32(0x421b0061),
    SPH_C32(0xb6cf2000), SPH_C32(0x71fe607c), SPH_C32(0x3ada48ba),
    SPH_C32(0xe34e636b), SPH_C32(0xa676dbb0), SPH_C32(0x205d0000),
    SPH_C32(0x10c80000), SPH_C32(0xa4d90075), SPH_C32(0x26793800),
    SPH_C32(0x40b20bd1), SPH_C32(0x6d382bed), SPH_C32(0xc8f90b1c),
    SPH_C32(0x1439e6a2) },
  { SPH_C32(0x20510000), SPH_C32(0xe2290000), SPH_C32(0x3c95007e),
    SPH_C32(0xa36b0000), SPH_C32(0x3c9c1fb0), SPH_C32(0xf3d1628a),
    SPH_C32(0x39aef1f5), SPH_C32(0x895cdde1), SPH_C32(0x7ff30000),
    SPH_C32(0x22e60000), SPH_C32(0x5b9e007e), SPH_C32(0x771f0000),
    SPH_C32(0xe4f774a3), SPH_C32(0x5c527a94), SPH_C32(0x90f29751),
    SPH_C32(0xbe082edd) },
  { SPH_C32(0x78120000), SPH_C32(0x62570000), SPH_C32(0x44a6007f),
    SPH_C32(0x65003800), SPH_C32(0xdbab436c), SPH_C32(0x8a7c5d57),
    SPH_C32(0x95dd0f9a), SPH_C32(0xb318a450), SPH_C32(0x62a90000),
    SPH_C32(0x09940000), SPH_C32(0x1313007e), SPH_C32(0xd87e1800),
    SPH_C32(0xc13c5a66), SPH_C32(0x942bc544), SPH_C32(0x11509378),
    SPH_C32(0xa07d187b) },
  { SPH_C32(0x3d0b0000), SPH_C32(0xc95b0000), SPH_C32(0x7418007e),
    SPH_C32(0x0c0a1800), SPH_C32(0x19573175), SPH_C32(0x3ba8dd5a),
    SPH_C32(0xb80cf5dc), SPH_C32(0x9729eb47), SPH_C32(0x3aea0000),
    SPH_C32(0x89ea0000), SPH_C32(0x6b20007f), SPH_C32(0x1e152000),
    SPH_C32(0x260b06ba), SPH_C32(0xed86fa99), SPH_C32(0xbd236d17),
    SPH_C32(0x9a3961ca) },
  { SPH_C32(0x65480000), SPH_C32(0x49250000), SPH_C32(0x0c2b007f),
    SPH_C32(0xca612000), SPH_C32(0xfe606da9), SPH_C32(0x4205e287),
    SPH_C32(0x147f0bb3), SPH_C32(0xad6d92f6), SPH_C32(0x27b00000),
    SPH_C32(0xa2980000), SPH_C32(0x23ad007f), SPH_C32(0xb1743800),
    SPH_C32(0x03c0287f), SPH_C32(0x25ff4549), SPH_C32(0x3c81693e),
    SPH_C32(0x844c576c) }
};

__constant static const sph_u32 T512_48[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0xe6280000), SPH_C32(0x4c4b0000), SPH_C32(0xa8550000),
    SPH_C32(0xd3d002e0), SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da),
    SPH_C32(0x289506b4), SPH_C32(0xd75a4897), SPH_C32(0xf0c50000),
    SPH_C32(0x59230000), SPH_C32(0x45820000), SPH_C32(0xe18d00c0),
    SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699), SPH_C32(0xcbe0fe1c),
    SPH_C32(0x56a7b19f) },
  { SPH_C32(0xf0c50000), SPH_C32(0x59230000), SPH_C32(0x45820000),
    SPH_C32(0xe18d00c0), SPH_C32(0x3b6d0631), SPH_C32(0xc2ed5699),
    SPH_C32(0xcbe0fe1c), SPH_C32(0x56a7b19f), SPH_C32(0x16ed0000),
    SPH_C32(0x15680000), SPH_C32(0xedd70000), SPH_C32(0x325d0220),
    SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643), SPH_C32(0xe375f8a8),
    SPH_C32(0x81fdf908) },
  { SPH_C32(0x16ed0000), SPH_C32(0x15680000), SPH_C32(0xedd70000),
    SPH_C32(0x325d0220), SPH_C32(0xe30c3689), SPH_C32(0x5a4ae643),
    SPH_C32(0xe375f8a8), SPH_C32(0x81fdf908), SPH_C32(0xe6280000),
    SPH_C32(0x4c4b0000), SPH_C32(0xa8550000), SPH_C32(0xd3d002e0),
    SPH_C32(0xd86130b8), SPH_C32(0x98a7b0da), SPH_C32(0x289506b4),
    SPH_C32(0xd75a4897) },
  { SPH_C32(0xb4310000), SPH_C32(0x77330000), SPH_C32(0xb15d0000),
    SPH_C32(0x7fd004e0), SPH_C32(0x78a26138), SPH_C32(0xd116c35d),
    SPH_C32(0xd256d489), SPH_C32(0x4e6f74de), SPH_C32(0xe3060000),
    SPH_C32(0xbdc10000), SPH_C32(0x87130000), SPH_C32(0xbff20060),
    SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751), SPH_C32(0x73c5ab06),
    SPH_C32(0x5bd61539) },
  { SPH_C32(0x52190000), SPH_C32(0x3b780000), SPH_C32(0x19080000),
    SPH_C32(0xac000600), SPH_C32(0xa0c35180), SPH_C32(0x49b17387),
    SPH_C32(0xfac3d23d), SPH_C32(0x99353c49), SPH_C32(0x13c30000),
    SPH_C32(0xe4e20000), SPH_C32(0xc2910000), SPH_C32(0x5e7f00a0),
    SPH_C32(0x15d70c2b), SPH_C32(0x4f5861c8), SPH_C32(0xb825551a),
    SPH_C32(0x0d71a4a6) },
  { SPH_C32(0x44f40000), SPH_C32(0x2e100000), SPH_C32(0xf4df0000),
    SPH_C32(0x9e5d0420), SPH_C32(0x43cf6709), SPH_C32(0x13fb95c4),
    SPH_C32(0x19b62a95), SPH_C32(0x18c8c541), SPH_C32(0xf5eb0000),
    SPH_C32(0xa8a90000), SPH_C32(0x6ac40000), SPH_C32(0x8daf0240),
    SPH_C32(0xcdb63c93), SPH_C32(0xd7ffd112), SPH_C32(0x90b053ae),
    SPH_C32(0xda2bec31) },
  { SPH_C32(0xa2dc0000), SPH_C32(0x625b0000), SPH_C32(0x5c8a0000),
    SPH_C32(0x4d8d06c0), SPH_C32(0x9bae57b1), SPH_C32(0x8b5c251e),
    SPH_C32(0x31232c21), SPH_C32(0xcf928dd6), SPH_C32(0x052e0000),
    SPH_C32(0xf18a0000), SPH_C32(0x2f460000), SPH_C32(0x6c220280),
    SPH_C32(0xf6db3aa2), SPH_C32(0x1512878b), SPH_C32(0x5b50adb2),
    SPH_C32(0x8c8c5dae) },
  { SPH_C32(0xe3060000), SPH_C32(0xbdc10000), SPH_C32(0x87130000),
    SPH_C32(0xbff20060), SPH_C32(0x2eba0a1a), SPH_C32(0x8db53751),
    SPH_C32(0x73c5ab06), SPH_C32(0x5bd61539), SPH_C32(0x57370000),
    SPH_C32(0xcaf20000), SPH_C32(0x364e0000), SPH_C32(0xc0220480),
    SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c), SPH_C32(0xa1937f8f),
    SPH_C32(0x15b961e7) },
  { SPH_C32(0x052e0000), SPH_C32(0xf18a0000), SPH_C32(0x2f460000),
    SPH_C32(0x6c220280), SPH_C32(0xf6db3aa2), SPH_C32(0x1512878b),
    SPH_C32(0x5b50adb2), SPH_C32(0x8c8c5dae), SPH_C32(0xa7f20000),
    SPH_C32(0x93d10000), SPH_C32(0x73cc0000), SPH_C32(0x21af0440),
    SPH_C32(0x6d756d13), SPH_C32(0x9e4ea295), SPH_C32(0x6a738193),
    SPH_C32(0x431ed078) },
  { SPH_C32(0x13c30000), SPH_C32(0xe4e20000), SPH_C32(0xc2910000),
    SPH_C32(0x5e7f00a0), SPH_C32(0x15d70c2b), SPH_C32(0x4f5861c8),
    SPH_C32(0xb825551a), SPH_C32(0x0d71a4a6), SPH_C32(0x41da0000),
    SPH_C32(0xdf9a0000), SPH_C32(0xdb990000), SPH_C32(0xf27f06a0),
    SPH_C32(0xb5145dab), SPH_C32(0x06e9124f), SPH_C32(0x42e68727),
    SPH_C32(0x944498ef) },
  { SPH_C32(0xf5eb0000), SPH_C32(0xa8a90000), SPH_C32(0x6ac40000),
    SPH_C32(0x8daf0240), SPH_C32(0xcdb63c93), SPH_C32(0xd7ffd112),
    SPH_C32(0x90b053ae), SPH_C32(0xda2bec31), SPH_C32(0xb11f0000),
    SPH_C32(0x86b90000), SPH_C32(0x9e1b0000), SPH_C32(0x13f20660),
    SPH_C32(0x8e795b9a), SPH_C32(0xc40444d6), SPH_C32(0x8906793b),
    SPH_C32(0xc2e32970) },
  { SPH_C32(0x57370000), SPH_C32(0xcaf20000), SPH_C32(0x364e0000),
    SPH_C32(0xc0220480), SPH_C32(0x56186b22), SPH_C32(0x5ca3f40c),
    SPH_C32(0xa1937f8f), SPH_C32(0x15b961e7), SPH_C32(0xb4310000),
    SPH_C32(0x77330000), SPH_C32(0xb15d0000), SPH_C32(0x7fd004e0),
    SPH_C32(0x78a26138), SPH_C32(0xd116c35d), SPH_C32(0xd256d489),
    SPH_C32(0x4e6f74de) },
  { SPH_C32(0xb11f0000), SPH_C32(0x86b90000), SPH_C32(0x9e1b0000),
    SPH_C32(0x13f20660), SPH_C32(0x8e795b9a), SPH_C32(0xc40444d6),
    SPH_C32(0x8906793b), SPH_C32(0xc2e32970), SPH_C32(0x44f40000),
    SPH_C32(0x2e100000), SPH_C32(0xf4df0000), SPH_C32(0x9e5d0420),
    SPH_C32(0x43cf6709), SPH_C32(0x13fb95c4), SPH_C32(0x19b62a95),
    SPH_C32(0x18c8c541) },
  { SPH_C32(0xa7f20000), SPH_C32(0x93d10000), SPH_C32(0x73cc0000),
    SPH_C32(0x21af0440), SPH_C32(0x6d756d13), SPH_C32(0x9e4ea295),
    SPH_C32(0x6a738193), SPH_C32(0x431ed078), SPH_C32(0xa2dc0000),
    SPH_C32(0x625b0000), SPH_C32(0x5c8a0000), SPH_C32(0x4d8d06c0),
    SPH_C32(0x9bae57b1), SPH_C32(0x8b5c251e), SPH_C32(0x31232c21),
    SPH_C32(0xcf928dd6) },
  { SPH_C32(0x41da0000), SPH_C32(0xdf9a0000), SPH_C32(0xdb990000),
    SPH_C32(0xf27f06a0), SPH_C32(0xb5145dab), SPH_C32(0x06e9124f),
    SPH_C32(0x42e68727), SPH_C32(0x944498ef), SPH_C32(0x52190000),
    SPH_C32(0x3b780000), SPH_C32(0x19080000), SPH_C32(0xac000600),
    SPH_C32(0xa0c35180), SPH_C32(0x49b17387), SPH_C32(0xfac3d23d),
    SPH_C32(0x99353c49) },
  { SPH_C32(0x02f20000), SPH_C32(0xa2810000), SPH_C32(0x873f0000),
    SPH_C32(0xe36c7800), SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6),
    SPH_C32(0xc4c23237), SPH_C32(0x7f32259e), SPH_C32(0xbadd0000),
    SPH_C32(0x13ad0000), SPH_C32(0xb7e70000), SPH_C32(0xf7282800),
    SPH_C32(0xdf45144d), SPH_C32(0x361ac33a), SPH_C32(0xea5a8d14),
    SPH_C32(0x2a2c18f0) },
  { SPH_C32(0xe4da0000), SPH_C32(0xeeca0000), SPH_C32(0x2f6a0000),
    SPH_C32(0x30bc7ae0), SPH_C32(0xc67c4457), SPH_C32(0x9f9a9b0c),
    SPH_C32(0xec573483), SPH_C32(0xa8686d09), SPH_C32(0x4a180000),
    SPH_C32(0x4a8e0000), SPH_C32(0xf2650000), SPH_C32(0x16a528c0),
    SPH_C32(0xe428127c), SPH_C32(0xf4f795a3), SPH_C32(0x21ba7308),
    SPH_C32(0x7c8ba96f) },
  { SPH_C32(0xf2370000), SPH_C32(0xfba20000), SPH_C32(0xc2bd0000),
    SPH_C32(0x02e178c0), SPH_C32(0x257072de), SPH_C32(0xc5d07d4f),
    SPH_C32(0x0f22cc2b), SPH_C32(0x29959401), SPH_C32(0xac300000),
    SPH_C32(0x06c50000), SPH_C32(0x5a300000), SPH_C32(0xc5752a20),
    SPH_C32(0x3c4922c4), SPH_C32(0x6c502579), SPH_C32(0x092f75bc),
    SPH_C32(0xabd1e1f8) },
  { SPH_C32(0x141f0000), SPH_C32(0xb7e90000), SPH_C32(0x6ae80000),
    SPH_C32(0xd1317a20), SPH_C32(0xfd114266), SPH_C32(0x5d77cd95),
    SPH_C32(0x27b7ca9f), SPH_C32(0xfecfdc96), SPH_C32(0x5cf50000),
    SPH_C32(0x5fe60000), SPH_C32(0x1fb20000), SPH_C32(0x24f82ae0),
    SPH_C32(0x072424f5), SPH_C32(0xaebd73e0), SPH_C32(0xc2cf8ba0),
    SPH_C32(0xfd765067) },
  { SPH_C32(0xb6c30000), SPH_C32(0xd5b20000), SPH_C32(0x36620000),
    SPH_C32(0x9cbc7ce0), SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b),
    SPH_C32(0x1694e6be), SPH_C32(0x315d5140), SPH_C32(0x59db0000),
    SPH_C32(0xae6c0000), SPH_C32(0x30f40000), SPH_C32(0x48da2860),
    SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b), SPH_C32(0x999f2612),
    SPH_C32(0x71fa0dc9) },
  { SPH_C32(0x50eb0000), SPH_C32(0x99f90000), SPH_C32(0x9e370000),
    SPH_C32(0x4f6c7e00), SPH_C32(0xbede256f), SPH_C32(0x4e8c5851),
    SPH_C32(0x3e01e00a), SPH_C32(0xe60719d7), SPH_C32(0xa91e0000),
    SPH_C32(0xf74f0000), SPH_C32(0x75760000), SPH_C32(0xa95728a0),
    SPH_C32(0xca921866), SPH_C32(0x7942a2f2), SPH_C32(0x527fd80e),
    SPH_C32(0x275dbc56) },
  { SPH_C32(0x46060000), SPH_C32(0x8c910000), SPH_C32(0x73e00000),
    SPH_C32(0x7d317c20), SPH_C32(0x5dd213e6), SPH_C32(0x14c6be12),
    SPH_C32(0xdd7418a2), SPH_C32(0x67fae0df), SPH_C32(0x4f360000),
    SPH_C32(0xbb040000), SPH_C32(0xdd230000), SPH_C32(0x7a872a40),
    SPH_C32(0x12f328de), SPH_C32(0xe1e51228), SPH_C32(0x7aeadeba),
    SPH_C32(0xf007f4c1) },
  { SPH_C32(0xa02e0000), SPH_C32(0xc0da0000), SPH_C32(0xdbb50000),
    SPH_C32(0xaee17ec0), SPH_C32(0x85b3235e), SPH_C32(0x8c610ec8),
    SPH_C32(0xf5e11e16), SPH_C32(0xb0a0a848), SPH_C32(0xbff30000),
    SPH_C32(0xe2270000), SPH_C32(0x98a10000), SPH_C32(0x9b0a2a80),
    SPH_C32(0x299e2eef), SPH_C32(0x230844b1), SPH_C32(0xb10a20a6),
    SPH_C32(0xa6a0455e) },
  { SPH_C32(0xe1f40000), SPH_C32(0x1f400000), SPH_C32(0x002c0000),
    SPH_C32(0x5c9e7860), SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87),
    SPH_C32(0xb7079931), SPH_C32(0x24e430a7), SPH_C32(0xedea0000),
    SPH_C32(0xd95f0000), SPH_C32(0x81a90000), SPH_C32(0x370a2c80),
    SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736), SPH_C32(0x4bc9f29b),
    SPH_C32(0x3f957917) },
  { SPH_C32(0x07dc0000), SPH_C32(0x530b0000), SPH_C32(0xa8790000),
    SPH_C32(0x8f4e7a80), SPH_C32(0xe8c64e4d), SPH_C32(0x122fac5d),
    SPH_C32(0x9f929f85), SPH_C32(0xf3be7830), SPH_C32(0x1d2f0000),
    SPH_C32(0x807c0000), SPH_C32(0xc42b0000), SPH_C32(0xd6872c40),
    SPH_C32(0xb230795e), SPH_C32(0xa85461af), SPH_C32(0x80290c87),
    SPH_C32(0x6932c888) },
  { SPH_C32(0x11310000), SPH_C32(0x46630000), SPH_C32(0x45ae0000),
    SPH_C32(0xbd1378a0), SPH_C32(0x0bca78c4), SPH_C32(0x48654a1e),
    SPH_C32(0x7ce7672d), SPH_C32(0x72438138), SPH_C32(0xfb070000),
    SPH_C32(0xcc370000), SPH_C32(0x6c7e0000), SPH_C32(0x05572ea0),
    SPH_C32(0x6a5149e6), SPH_C32(0x30f3d175), SPH_C32(0xa8bc0a33),
    SPH_C32(0xbe68801f) },
  { SPH_C32(0xf7190000), SPH_C32(0x0a280000), SPH_C32(0xedfb0000),
    SPH_C32(0x6ec37a40), SPH_C32(0xd3ab487c), SPH_C32(0xd0c2fac4),
    SPH_C32(0x54726199), SPH_C32(0xa519c9af), SPH_C32(0x0bc20000),
    SPH_C32(0x95140000), SPH_C32(0x29fc0000), SPH_C32(0xe4da2e60),
    SPH_C32(0x513c4fd7), SPH_C32(0xf21e87ec), SPH_C32(0x635cf42f),
    SPH_C32(0xe8cf3180) },
  { SPH_C32(0x55c50000), SPH_C32(0x68730000), SPH_C32(0xb1710000),
    SPH_C32(0x234e7c80), SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda),
    SPH_C32(0x65514db8), SPH_C32(0x6a8b4479), SPH_C32(0x0eec0000),
    SPH_C32(0x649e0000), SPH_C32(0x06ba0000), SPH_C32(0x88f82ce0),
    SPH_C32(0xa7e77575), SPH_C32(0xe70c0067), SPH_C32(0x380c599d),
    SPH_C32(0x64436c2e) },
  { SPH_C32(0xb3ed0000), SPH_C32(0x24380000), SPH_C32(0x19240000),
    SPH_C32(0xf09e7e60), SPH_C32(0x90642f75), SPH_C32(0xc3396f00),
    SPH_C32(0x4dc44b0c), SPH_C32(0xbdd10cee), SPH_C32(0xfe290000),
    SPH_C32(0x3dbd0000), SPH_C32(0x43380000), SPH_C32(0x69752c20),
    SPH_C32(0x9c8a7344), SPH_C32(0x25e156fe), SPH_C32(0xf3eca781),
    SPH_C32(0x32e4ddb1) },
  { SPH_C32(0xa5000000), SPH_C32(0x31500000), SPH_C32(0xf4f30000),
    SPH_C32(0xc2c37c40), SPH_C32(0x736819fc), SPH_C32(0x99738943),
    SPH_C32(0xaeb1b3a4), SPH_C32(0x3c2cf5e6), SPH_C32(0x18010000),
    SPH_C32(0x71f60000), SPH_C32(0xeb6d0000), SPH_C32(0xbaa52ec0),
    SPH_C32(0x44eb43fc), SPH_C32(0xbd46e624), SPH_C32(0xdb79a135),
    SPH_C32(0xe5be9526) },
  { SPH_C32(0x43280000), SPH_C32(0x7d1b0000), SPH_C32(0x5ca60000),
    SPH_C32(0x11137ea0), SPH_C32(0xab092944), SPH_C32(0x01d43999),
    SPH_C32(0x8624b510), SPH_C32(0xeb76bd71), SPH_C32(0xe8c40000),
    SPH_C32(0x28d50000), SPH_C32(0xaeef0000), SPH_C32(0x5b282e00),
    SPH_C32(0x7f8645cd), SPH_C32(0x7fabb0bd), SPH_C32(0x10995f29),
    SPH_C32(0xb31924b9) },
  { SPH_C32(0xbadd0000), SPH_C32(0x13ad0000), SPH_C32(0xb7e70000),
    SPH_C32(0xf7282800), SPH_C32(0xdf45144d), SPH_C32(0x361ac33a),
    SPH_C32(0xea5a8d14), SPH_C32(0x2a2c18f0), SPH_C32(0xb82f0000),
    SPH_C32(0xb12c0000), SPH_C32(0x30d80000), SPH_C32(0x14445000),
    SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec), SPH_C32(0x2e98bf23),
    SPH_C32(0x551e3d6e) },
  { SPH_C32(0x5cf50000), SPH_C32(0x5fe60000), SPH_C32(0x1fb20000),
    SPH_C32(0x24f82ae0), SPH_C32(0x072424f5), SPH_C32(0xaebd73e0),
    SPH_C32(0xc2cf8ba0), SPH_C32(0xfd765067), SPH_C32(0x48ea0000),
    SPH_C32(0xe80f0000), SPH_C32(0x755a0000), SPH_C32(0xf5c950c0),
    SPH_C32(0xfa356693), SPH_C32(0xf3cabe75), SPH_C32(0xe578413f),
    SPH_C32(0x03b98cf1) },
  { SPH_C32(0x4a180000), SPH_C32(0x4a8e0000), SPH_C32(0xf2650000),
    SPH_C32(0x16a528c0), SPH_C32(0xe428127c), SPH_C32(0xf4f795a3),
    SPH_C32(0x21ba7308), SPH_C32(0x7c8ba96f), SPH_C32(0xaec20000),
    SPH_C32(0xa4440000), SPH_C32(0xdd0f0000), SPH_C32(0x26195220),
    SPH_C32(0x2254562b), SPH_C32(0x6b6d0eaf), SPH_C32(0xcded478b),
    SPH_C32(0xd4e3c466) },
  { SPH_C32(0xac300000), SPH_C32(0x06c50000), SPH_C32(0x5a300000),
    SPH_C32(0xc5752a20), SPH_C32(0x3c4922c4), SPH_C32(0x6c502579),
    SPH_C32(0x092f75bc), SPH_C32(0xabd1e1f8), SPH_C32(0x5e070000),
    SPH_C32(0xfd670000), SPH_C32(0x988d0000), SPH_C32(0xc79452e0),
    SPH_C32(0x1939501a), SPH_C32(0xa9805836), SPH_C32(0x060db997),
    SPH_C32(0x824475f9) },
  { SPH_C32(0x0eec0000), SPH_C32(0x649e0000), SPH_C32(0x06ba0000),
    SPH_C32(0x88f82ce0), SPH_C32(0xa7e77575), SPH_C32(0xe70c0067),
    SPH_C32(0x380c599d), SPH_C32(0x64436c2e), SPH_C32(0x5b290000),
    SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000), SPH_C32(0xabb65060),
    SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd), SPH_C32(0x5d5d1425),
    SPH_C32(0x0ec82857) },
  { SPH_C32(0xe8c40000), SPH_C32(0x28d50000), SPH_C32(0xaeef0000),
    SPH_C32(0x5b282e00), SPH_C32(0x7f8645cd), SPH_C32(0x7fabb0bd),
    SPH_C32(0x10995f29), SPH_C32(0xb31924b9), SPH_C32(0xabec0000),
    SPH_C32(0x55ce0000), SPH_C32(0xf2490000), SPH_C32(0x4a3b50a0),
    SPH_C32(0xd48f6c89), SPH_C32(0x7e7f8924), SPH_C32(0x96bdea39),
    SPH_C32(0x586f99c8) },
  { SPH_C32(0xfe290000), SPH_C32(0x3dbd0000), SPH_C32(0x43380000),
    SPH_C32(0x69752c20), SPH_C32(0x9c8a7344), SPH_C32(0x25e156fe),
    SPH_C32(0xf3eca781), SPH_C32(0x32e4ddb1), SPH_C32(0x4dc40000),
    SPH_C32(0x19850000), SPH_C32(0x5a1c0000), SPH_C32(0x99eb5240),
    SPH_C32(0x0cee5c31), SPH_C32(0xe6d839fe), SPH_C32(0xbe28ec8d),
    SPH_C32(0x8f35d15f) },
  { SPH_C32(0x18010000), SPH_C32(0x71f60000), SPH_C32(0xeb6d0000),
    SPH_C32(0xbaa52ec0), SPH_C32(0x44eb43fc), SPH_C32(0xbd46e624),
    SPH_C32(0xdb79a135), SPH_C32(0xe5be9526), SPH_C32(0xbd010000),
    SPH_C32(0x40a60000), SPH_C32(0x1f9e0000), SPH_C32(0x78665280),
    SPH_C32(0x37835a00), SPH_C32(0x24356f67), SPH_C32(0x75c81291),
    SPH_C32(0xd99260c0) },
  { SPH_C32(0x59db0000), SPH_C32(0xae6c0000), SPH_C32(0x30f40000),
    SPH_C32(0x48da2860), SPH_C32(0xf1ff1e57), SPH_C32(0xbbaff46b),
    SPH_C32(0x999f2612), SPH_C32(0x71fa0dc9), SPH_C32(0xef180000),
    SPH_C32(0x7bde0000), SPH_C32(0x06960000), SPH_C32(0xd4665480),
    SPH_C32(0x97400b80), SPH_C32(0x6d841ce0), SPH_C32(0x8f0bc0ac),
    SPH_C32(0x40a75c89) },
  { SPH_C32(0xbff30000), SPH_C32(0xe2270000), SPH_C32(0x98a10000),
    SPH_C32(0x9b0a2a80), SPH_C32(0x299e2eef), SPH_C32(0x230844b1),
    SPH_C32(0xb10a20a6), SPH_C32(0xa6a0455e), SPH_C32(0x1fdd0000),
    SPH_C32(0x22fd0000), SPH_C32(0x43140000), SPH_C32(0x35eb5440),
    SPH_C32(0xac2d0db1), SPH_C32(0xaf694a79), SPH_C32(0x44eb3eb0),
    SPH_C32(0x1600ed16) },
  { SPH_C32(0xa91e0000), SPH_C32(0xf74f0000), SPH_C32(0x75760000),
    SPH_C32(0xa95728a0), SPH_C32(0xca921866), SPH_C32(0x7942a2f2),
    SPH_C32(0x527fd80e), SPH_C32(0x275dbc56), SPH_C32(0xf9f50000),
    SPH_C32(0x6eb60000), SPH_C32(0xeb410000), SPH_C32(0xe63b56a0),
    SPH_C32(0x744c3d09), SPH_C32(0x37cefaa3), SPH_C32(0x6c7e3804),
    SPH_C32(0xc15aa581) },
  { SPH_C32(0x4f360000), SPH_C32(0xbb040000), SPH_C32(0xdd230000),
    SPH_C32(0x7a872a40), SPH_C32(0x12f328de), SPH_C32(0xe1e51228),
    SPH_C32(0x7aeadeba), SPH_C32(0xf007f4c1), SPH_C32(0x09300000),
    SPH_C32(0x37950000), SPH_C32(0xaec30000), SPH_C32(0x07b65660),
    SPH_C32(0x4f213b38), SPH_C32(0xf523ac3a), SPH_C32(0xa79ec618),
    SPH_C32(0x97fd141e) },
  { SPH_C32(0xedea0000), SPH_C32(0xd95f0000), SPH_C32(0x81a90000),
    SPH_C32(0x370a2c80), SPH_C32(0x895d7f6f), SPH_C32(0x6ab93736),
    SPH_C32(0x4bc9f29b), SPH_C32(0x3f957917), SPH_C32(0x0c1e0000),
    SPH_C32(0xc61f0000), SPH_C32(0x81850000), SPH_C32(0x6b9454e0),
    SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1), SPH_C32(0xfcce6baa),
    SPH_C32(0x1b7149b0) },
  { SPH_C32(0x0bc20000), SPH_C32(0x95140000), SPH_C32(0x29fc0000),
    SPH_C32(0xe4da2e60), SPH_C32(0x513c4fd7), SPH_C32(0xf21e87ec),
    SPH_C32(0x635cf42f), SPH_C32(0xe8cf3180), SPH_C32(0xfcdb0000),
    SPH_C32(0x9f3c0000), SPH_C32(0xc4070000), SPH_C32(0x8a195420),
    SPH_C32(0x829707ab), SPH_C32(0x22dc7d28), SPH_C32(0x372e95b6),
    SPH_C32(0x4dd6f82f) },
  { SPH_C32(0x1d2f0000), SPH_C32(0x807c0000), SPH_C32(0xc42b0000),
    SPH_C32(0xd6872c40), SPH_C32(0xb230795e), SPH_C32(0xa85461af),
    SPH_C32(0x80290c87), SPH_C32(0x6932c888), SPH_C32(0x1af30000),
    SPH_C32(0xd3770000), SPH_C32(0x6c520000), SPH_C32(0x59c956c0),
    SPH_C32(0x5af63713), SPH_C32(0xba7bcdf2), SPH_C32(0x1fbb9302),
    SPH_C32(0x9a8cb0b8) },
  { SPH_C32(0xfb070000), SPH_C32(0xcc370000), SPH_C32(0x6c7e0000),
    SPH_C32(0x05572ea0), SPH_C32(0x6a5149e6), SPH_C32(0x30f3d175),
    SPH_C32(0xa8bc0a33), SPH_C32(0xbe68801f), SPH_C32(0xea360000),
    SPH_C32(0x8a540000), SPH_C32(0x29d00000), SPH_C32(0xb8445600),
    SPH_C32(0x619b3122), SPH_C32(0x78969b6b), SPH_C32(0xd45b6d1e),
    SPH_C32(0xcc2b0127) },
  { SPH_C32(0xb82f0000), SPH_C32(0xb12c0000), SPH_C32(0x30d80000),
    SPH_C32(0x14445000), SPH_C32(0xc15860a2), SPH_C32(0x3127e8ec),
    SPH_C32(0x2e98bf23), SPH_C32(0x551e3d6e), SPH_C32(0x02f20000),
    SPH_C32(0xa2810000), SPH_C32(0x873f0000), SPH_C32(0xe36c7800),
    SPH_C32(0x1e1d74ef), SPH_C32(0x073d2bd6), SPH_C32(0xc4c23237),
    SPH_C32(0x7f32259e) },
  { SPH_C32(0x5e070000), SPH_C32(0xfd670000), SPH_C32(0x988d0000),
    SPH_C32(0xc79452e0), SPH_C32(0x1939501a), SPH_C32(0xa9805836),
    SPH_C32(0x060db997), SPH_C32(0x824475f9), SPH_C32(0xf2370000),
    SPH_C32(0xfba20000), SPH_C32(0xc2bd0000), SPH_C32(0x02e178c0),
    SPH_C32(0x257072de), SPH_C32(0xc5d07d4f), SPH_C32(0x0f22cc2b),
    SPH_C32(0x29959401) },
  { SPH_C32(0x48ea0000), SPH_C32(0xe80f0000), SPH_C32(0x755a0000),
    SPH_C32(0xf5c950c0), SPH_C32(0xfa356693), SPH_C32(0xf3cabe75),
    SPH_C32(0xe578413f), SPH_C32(0x03b98cf1), SPH_C32(0x141f0000),
    SPH_C32(0xb7e90000), SPH_C32(0x6ae80000), SPH_C32(0xd1317a20),
    SPH_C32(0xfd114266), SPH_C32(0x5d77cd95), SPH_C32(0x27b7ca9f),
    SPH_C32(0xfecfdc96) },
  { SPH_C32(0xaec20000), SPH_C32(0xa4440000), SPH_C32(0xdd0f0000),
    SPH_C32(0x26195220), SPH_C32(0x2254562b), SPH_C32(0x6b6d0eaf),
    SPH_C32(0xcded478b), SPH_C32(0xd4e3c466), SPH_C32(0xe4da0000),
    SPH_C32(0xeeca0000), SPH_C32(0x2f6a0000), SPH_C32(0x30bc7ae0),
    SPH_C32(0xc67c4457), SPH_C32(0x9f9a9b0c), SPH_C32(0xec573483),
    SPH_C32(0xa8686d09) },
  { SPH_C32(0x0c1e0000), SPH_C32(0xc61f0000), SPH_C32(0x81850000),
    SPH_C32(0x6b9454e0), SPH_C32(0xb9fa019a), SPH_C32(0xe0312bb1),
    SPH_C32(0xfcce6baa), SPH_C32(0x1b7149b0), SPH_C32(0xe1f40000),
    SPH_C32(0x1f400000), SPH_C32(0x002c0000), SPH_C32(0x5c9e7860),
    SPH_C32(0x30a77ef5), SPH_C32(0x8a881c87), SPH_C32(0xb7079931),
    SPH_C32(0x24e430a7) },
  { SPH_C32(0xea360000), SPH_C32(0x8a540000), SPH_C32(0x29d00000),
    SPH_C32(0xb8445600), SPH_C32(0x619b3122), SPH_C32(0x78969b6b),
    SPH_C32(0xd45b6d1e), SPH_C32(0xcc2b0127), SPH_C32(0x11310000),
    SPH_C32(0x46630000), SPH_C32(0x45ae0000), SPH_C32(0xbd1378a0),
    SPH_C32(0x0bca78c4), SPH_C32(0x48654a1e), SPH_C32(0x7ce7672d),
    SPH_C32(0x72438138) },
  { SPH_C32(0xfcdb0000), SPH_C32(0x9f3c0000), SPH_C32(0xc4070000),
    SPH_C32(0x8a195420), SPH_C32(0x829707ab), SPH_C32(0x22dc7d28),
    SPH_C32(0x372e95b6), SPH_C32(0x4dd6f82f), SPH_C32(0xf7190000),
    SPH_C32(0x0a280000), SPH_C32(0xedfb0000), SPH_C32(0x6ec37a40),
    SPH_C32(0xd3ab487c), SPH_C32(0xd0c2fac4), SPH_C32(0x54726199),
    SPH_C32(0xa519c9af) },
  { SPH_C32(0x1af30000), SPH_C32(0xd3770000), SPH_C32(0x6c520000),
    SPH_C32(0x59c956c0), SPH_C32(0x5af63713), SPH_C32(0xba7bcdf2),
    SPH_C32(0x1fbb9302), SPH_C32(0x9a8cb0b8), SPH_C32(0x07dc0000),
    SPH_C32(0x530b0000), SPH_C32(0xa8790000), SPH_C32(0x8f4e7a80),
    SPH_C32(0xe8c64e4d), SPH_C32(0x122fac5d), SPH_C32(0x9f929f85),
    SPH_C32(0xf3be7830) },
  { SPH_C32(0x5b290000), SPH_C32(0x0ced0000), SPH_C32(0xb7cb0000),
    SPH_C32(0xabb65060), SPH_C32(0xefe26ab8), SPH_C32(0xbc92dfbd),
    SPH_C32(0x5d5d1425), SPH_C32(0x0ec82857), SPH_C32(0x55c50000),
    SPH_C32(0x68730000), SPH_C32(0xb1710000), SPH_C32(0x234e7c80),
    SPH_C32(0x48051fcd), SPH_C32(0x5b9edfda), SPH_C32(0x65514db8),
    SPH_C32(0x6a8b4479) },
  { SPH_C32(0xbd010000), SPH_C32(0x40a60000), SPH_C32(0x1f9e0000),
    SPH_C32(0x78665280), SPH_C32(0x37835a00), SPH_C32(0x24356f67),
    SPH_C32(0x75c81291), SPH_C32(0xd99260c0), SPH_C32(0xa5000000),
    SPH_C32(0x31500000), SPH_C32(0xf4f30000), SPH_C32(0xc2c37c40),
    SPH_C32(0x736819fc), SPH_C32(0x99738943), SPH_C32(0xaeb1b3a4),
    SPH_C32(0x3c2cf5e6) },
  { SPH_C32(0xabec0000), SPH_C32(0x55ce0000), SPH_C32(0xf2490000),
    SPH_C32(0x4a3b50a0), SPH_C32(0xd48f6c89), SPH_C32(0x7e7f8924),
    SPH_C32(0x96bdea39), SPH_C32(0x586f99c8), SPH_C32(0x43280000),
    SPH_C32(0x7d1b0000), SPH_C32(0x5ca60000), SPH_C32(0x11137ea0),
    SPH_C32(0xab092944), SPH_C32(0x01d43999), SPH_C32(0x8624b510),
    SPH_C32(0xeb76bd71) },
  { SPH_C32(0x4dc40000), SPH_C32(0x19850000), SPH_C32(0x5a1c0000),
    SPH_C32(0x99eb5240), SPH_C32(0x0cee5c31), SPH_C32(0xe6d839fe),
    SPH_C32(0xbe28ec8d), SPH_C32(0x8f35d15f), SPH_C32(0xb3ed0000),
    SPH_C32(0x24380000), SPH_C32(0x19240000), SPH_C32(0xf09e7e60),
    SPH_C32(0x90642f75), SPH_C32(0xc3396f00), SPH_C32(0x4dc44b0c),
    SPH_C32(0xbdd10cee) },
  { SPH_C32(0xef180000), SPH_C32(0x7bde0000), SPH_C32(0x06960000),
    SPH_C32(0xd4665480), SPH_C32(0x97400b80), SPH_C32(0x6d841ce0),
    SPH_C32(0x8f0bc0ac), SPH_C32(0x40a75c89), SPH_C32(0xb6c30000),
    SPH_C32(0xd5b20000), SPH_C32(0x36620000), SPH_C32(0x9cbc7ce0),
    SPH_C32(0x66bf15d7), SPH_C32(0xd62be88b), SPH_C32(0x1694e6be),
    SPH_C32(0x315d5140) },
  { SPH_C32(0x09300000), SPH_C32(0x37950000), SPH_C32(0xaec30000),
    SPH_C32(0x07b65660), SPH_C32(0x4f213b38), SPH_C32(0xf523ac3a),
    SPH_C32(0xa79ec618), SPH_C32(0x97fd141e), SPH_C32(0x46060000),
    SPH_C32(0x8c910000), SPH_C32(0x73e00000), SPH_C32(0x7d317c20),
    SPH_C32(0x5dd213e6), SPH_C32(0x14c6be12), SPH_C32(0xdd7418a2),
    SPH_C32(0x67fae0df) },
  { SPH_C32(0x1fdd0000), SPH_C32(0x22fd0000), SPH_C32(0x43140000),
    SPH_C32(0x35eb5440), SPH_C32(0xac2d0db1), SPH_C32(0xaf694a79),
    SPH_C32(0x44eb3eb0), SPH_C32(0x1600ed16), SPH_C32(0xa02e0000),
    SPH_C32(0xc0da0000), SPH_C32(0xdbb50000), SPH_C32(0xaee17ec0),
    SPH_C32(0x85b3235e), SPH_C32(0x8c610ec8), SPH_C32(0xf5e11e16),
    SPH_C32(0xb0a0a848) },
  { SPH_C32(0xf9f50000), SPH_C32(0x6eb60000), SPH_C32(0xeb410000),
    SPH_C32(0xe63b56a0), SPH_C32(0x744c3d09), SPH_C32(0x37cefaa3),
    SPH_C32(0x6c7e3804), SPH_C32(0xc15aa581), SPH_C32(0x50eb0000),
    SPH_C32(0x99f90000), SPH_C32(0x9e370000), SPH_C32(0x4f6c7e00),
    SPH_C32(0xbede256f), SPH_C32(0x4e8c5851), SPH_C32(0x3e01e00a),
    SPH_C32(0xe60719d7) },
  { SPH_C32(0x1e6c0000), SPH_C32(0xc4420000), SPH_C32(0x8a2e0000),
    SPH_C32(0xbcb6b800), SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da),
    SPH_C32(0x6a0c1bc8), SPH_C32(0xb99dc2eb), SPH_C32(0x92560000),
    SPH_C32(0x1eda0000), SPH_C32(0xea510000), SPH_C32(0xe8b13000),
    SPH_C32(0xa93556a5), SPH_C32(0xebfb6199), SPH_C32(0xb15c2254),
    SPH_C32(0x33c5244f) },
  { SPH_C32(0xf8440000), SPH_C32(0x88090000), SPH_C32(0x227b0000),
    SPH_C32(0x6f66bae0), SPH_C32(0xf425230e), SPH_C32(0x135a6300),
    SPH_C32(0x42991d7c), SPH_C32(0x6ec78a7c), SPH_C32(0x62930000),
    SPH_C32(0x47f90000), SPH_C32(0xafd30000), SPH_C32(0x093c30c0),
    SPH_C32(0x92585094), SPH_C32(0x29163700), SPH_C32(0x7abcdc48),
    SPH_C32(0x656295d0) },
  { SPH_C32(0xeea90000), SPH_C32(0x9d610000), SPH_C32(0xcfac0000),
    SPH_C32(0x5d3bb8c0), SPH_C32(0x17291587), SPH_C32(0x49108543),
    SPH_C32(0xa1ece5d4), SPH_C32(0xef3a7374), SPH_C32(0x84bb0000),
    SPH_C32(0x0bb20000), SPH_C32(0x07860000), SPH_C32(0xdaec3220),
    SPH_C32(0x4a39602c), SPH_C32(0xb1b187da), SPH_C32(0x5229dafc),
    SPH_C32(0xb238dd47) },
  { SPH_C32(0x08810000), SPH_C32(0xd12a0000), SPH_C32(0x67f90000),
    SPH_C32(0x8eebba20), SPH_C32(0xcf48253f), SPH_C32(0xd1b73599),
    SPH_C32(0x8979e360), SPH_C32(0x38603be3), SPH_C32(0x747e0000),
    SPH_C32(0x52910000), SPH_C32(0x42040000), SPH_C32(0x3b6132e0),
    SPH_C32(0x7154661d), SPH_C32(0x735cd143), SPH_C32(0x99c924e0),
    SPH_C32(0xe49f6cd8) },
  { SPH_C32(0xaa5d0000), SPH_C32(0xb3710000), SPH_C32(0x3b730000),
    SPH_C32(0xc366bce0), SPH_C32(0x54e6728e), SPH_C32(0x5aeb1087),
    SPH_C32(0xb85acf41), SPH_C32(0xf7f2b635), SPH_C32(0x71500000),
    SPH_C32(0xa31b0000), SPH_C32(0x6d420000), SPH_C32(0x57433060),
    SPH_C32(0x878f5cbf), SPH_C32(0x664e56c8), SPH_C32(0xc2998952),
    SPH_C32(0x68133176) },
  { SPH_C32(0x4c750000), SPH_C32(0xff3a0000), SPH_C32(0x93260000),
    SPH_C32(0x10b6be00), SPH_C32(0x8c874236), SPH_C32(0xc24ca05d),
    SPH_C32(0x90cfc9f5), SPH_C32(0x20a8fea2), SPH_C32(0x81950000),
    SPH_C32(0xfa380000), SPH_C32(0x28c00000), SPH_C32(0xb6ce30a0),
    SPH_C32(0xbce25a8e), SPH_C32(0xa4a30051), SPH_C32(0x0979774e),
    SPH_C32(0x3eb480e9) },
  { SPH_C32(0x5a980000), SPH_C32(0xea520000), SPH_C32(0x7ef10000),
    SPH_C32(0x22ebbc20), SPH_C32(0x6f8b74bf), SPH_C32(0x9806461e),
    SPH_C32(0x73ba315d), SPH_C32(0xa15507aa), SPH_C32(0x67bd0000),
    SPH_C32(0xb6730000), SPH_C32(0x80950000), SPH_C32(0x651e3240),
    SPH_C32(0x64836a36), SPH_C32(0x3c04b08b), SPH_C32(0x21ec71fa),
    SPH_C32(0xe9eec87e) },
  { SPH_C32(0xbcb00000), SPH_C32(0xa6190000), SPH_C32(0xd6a40000),
    SPH_C32(0xf13bbec0), SPH_C32(0xb7ea4407), SPH_C32(0x00a1f6c4),
    SPH_C32(0x5b2f37e9), SPH_C32(0x760f4f3d), SPH_C32(0x97780000),
    SPH_C32(0xef500000), SPH_C32(0xc5170000), SPH_C32(0x84933280),
    SPH_C32(0x5fee6c07), SPH_C32(0xfee9e612), SPH_C32(0xea0c8fe6),
    SPH_C32(0xbf4979e1) },
  { SPH_C32(0xfd6a0000), SPH_C32(0x79830000), SPH_C32(0x0d3d0000),
    SPH_C32(0x0344b860), SPH_C32(0x02fe19ac), SPH_C32(0x0648e48b),
    SPH_C32(0x19c9b0ce), SPH_C32(0xe24bd7d2), SPH_C32(0xc5610000),
    SPH_C32(0xd4280000), SPH_C32(0xdc1f0000), SPH_C32(0x28933480),
    SPH_C32(0xff2d3d87), SPH_C32(0xb7589595), SPH_C32(0x10cf5ddb),
    SPH_C32(0x267c45a8) },
  { SPH_C32(0x1b420000), SPH_C32(0x35c80000), SPH_C32(0xa5680000),
    SPH_C32(0xd094ba80), SPH_C32(0xda9f2914), SPH_C32(0x9eef5451),
    SPH_C32(0x315cb67a), SPH_C32(0x35119f45), SPH_C32(0x35a40000),
    SPH_C32(0x8d0b0000), SPH_C32(0x999d0000), SPH_C32(0xc91e3440),
    SPH_C32(0xc4403bb6), SPH_C32(0x75b5c30c), SPH_C32(0xdb2fa3c7),
    SPH_C32(0x70dbf437) },
  { SPH_C32(0x0daf0000), SPH_C32(0x20a00000), SPH_C32(0x48bf0000),
    SPH_C32(0xe2c9b8a0), SPH_C32(0x39931f9d), SPH_C32(0xc4a5b212),
    SPH_C32(0xd2294ed2), SPH_C32(0xb4ec664d), SPH_C32(0xd38c0000),
    SPH_C32(0xc1400000), SPH_C32(0x31c80000), SPH_C32(0x1ace36a0),
    SPH_C32(0x1c210b0e), SPH_C32(0xed1273d6), SPH_C32(0xf3baa573),
    SPH_C32(0xa781bca0) },
  { SPH_C32(0xeb870000), SPH_C32(0x6ceb0000), SPH_C32(0xe0ea0000),
    SPH_C32(0x3119ba40), SPH_C32(0xe1f22f25), SPH_C32(0x5c0202c8),
    SPH_C32(0xfabc4866), SPH_C32(0x63b62eda), SPH_C32(0x23490000),
    SPH_C32(0x98630000), SPH_C32(0x744a0000), SPH_C32(0xfb433660),
    SPH_C32(0x274c0d3f), SPH_C32(0x2fff254f), SPH_C32(0x385a5b6f),
    SPH_C32(0xf1260d3f) },
  { SPH_C32(0x495b0000), SPH_C32(0x0eb00000), SPH_C32(0xbc600000),
    SPH_C32(0x7c94bc80), SPH_C32(0x7a5c7894), SPH_C32(0xd75e27d6),
    SPH_C32(0xcb9f6447), SPH_C32(0xac24a30c), SPH_C32(0x26670000),
    SPH_C32(0x69e90000), SPH_C32(0x5b0c0000), SPH_C32(0x976134e0),
    SPH_C32(0xd197379d), SPH_C32(0x3aeda2c4), SPH_C32(0x630af6dd),
    SPH_C32(0x7daa5091) },
  { SPH_C32(0xaf730000), SPH_C32(0x42fb0000), SPH_C32(0x14350000),
    SPH_C32(0xaf44be60), SPH_C32(0xa23d482c), SPH_C32(0x4ff9970c),
    SPH_C32(0xe30a62f3), SPH_C32(0x7b7eeb9b), SPH_C32(0xd6a20000),
    SPH_C32(0x30ca0000), SPH_C32(0x1e8e0000), SPH_C32(0x76ec3420),
    SPH_C32(0xeafa31ac), SPH_C32(0xf800f45d), SPH_C32(0xa8ea08c1),
    SPH_C32(0x2b0de10e) },
  { SPH_C32(0xb99e0000), SPH_C32(0x57930000), SPH_C32(0xf9e20000),
    SPH_C32(0x9d19bc40), SPH_C32(0x41317ea5), SPH_C32(0x15b3714f),
    SPH_C32(0x007f9a5b), SPH_C32(0xfa831293), SPH_C32(0x308a0000),
    SPH_C32(0x7c810000), SPH_C32(0xb6db0000), SPH_C32(0xa53c36c0),
    SPH_C32(0x329b0114), SPH_C32(0x60a74487), SPH_C32(0x807f0e75),
    SPH_C32(0xfc57a999) },
  { SPH_C32(0x5fb60000), SPH_C32(0x1bd80000), SPH_C32(0x51b70000),
    SPH_C32(0x4ec9bea0), SPH_C32(0x99504e1d), SPH_C32(0x8d14c195),
    SPH_C32(0x28ea9cef), SPH_C32(0x2dd95a04), SPH_C32(0xc04f0000),
    SPH_C32(0x25a20000), SPH_C32(0xf3590000), SPH_C32(0x44b13600),
    SPH_C32(0x09f60725), SPH_C32(0xa24a121e), SPH_C32(0x4b9ff069),
    SPH_C32(0xaaf01806) },
  { SPH_C32(0x1c9e0000), SPH_C32(0x66c30000), SPH_C32(0x0d110000),
    SPH_C32(0x5fdac000), SPH_C32(0x32596759), SPH_C32(0x8cc0f80c),
    SPH_C32(0xaece29ff), SPH_C32(0xc6afe775), SPH_C32(0x288b0000),
    SPH_C32(0x0d770000), SPH_C32(0x5db60000), SPH_C32(0x1f991800),
    SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3), SPH_C32(0x5b06af40),
    SPH_C32(0x19e93cbf) },
  { SPH_C32(0xfab60000), SPH_C32(0x2a880000), SPH_C32(0xa5440000),
    SPH_C32(0x8c0ac2e0), SPH_C32(0xea3857e1), SPH_C32(0x146748d6),
    SPH_C32(0x865b2f4b), SPH_C32(0x11f5afe2), SPH_C32(0xd84e0000),
    SPH_C32(0x54540000), SPH_C32(0x18340000), SPH_C32(0xfe1418c0),
    SPH_C32(0x4d1d44d9), SPH_C32(0x1f0cf43a), SPH_C32(0x90e6515c),
    SPH_C32(0x4f4e8d20) },
  { SPH_C32(0xec5b0000), SPH_C32(0x3fe00000), SPH_C32(0x48930000),
    SPH_C32(0xbe57c0c0), SPH_C32(0x09346168), SPH_C32(0x4e2dae95),
    SPH_C32(0x652ed7e3), SPH_C32(0x900856ea), SPH_C32(0x3e660000),
    SPH_C32(0x181f0000), SPH_C32(0xb0610000), SPH_C32(0x2dc41a20),
    SPH_C32(0x957c7461), SPH_C32(0x87ab44e0), SPH_C32(0xb87357e8),
    SPH_C32(0x9814c5b7) },
  { SPH_C32(0x0a730000), SPH_C32(0x73ab0000), SPH_C32(0xe0c60000),
    SPH_C32(0x6d87c220), SPH_C32(0xd15551d0), SPH_C32(0xd68a1e4f),
    SPH_C32(0x4dbbd157), SPH_C32(0x47521e7d), SPH_C32(0xcea30000),
    SPH_C32(0x413c0000), SPH_C32(0xf5e30000), SPH_C32(0xcc491ae0),
    SPH_C32(0xae117250), SPH_C32(0x45461279), SPH_C32(0x7393a9f4),
    SPH_C32(0xceb37428) },
  { SPH_C32(0xa8af0000), SPH_C32(0x11f00000), SPH_C32(0xbc4c0000),
    SPH_C32(0x200ac4e0), SPH_C32(0x4afb0661), SPH_C32(0x5dd63b51),
    SPH_C32(0x7c98fd76), SPH_C32(0x88c093ab), SPH_C32(0xcb8d0000),
    SPH_C32(0xb0b60000), SPH_C32(0xdaa50000), SPH_C32(0xa06b1860),
    SPH_C32(0x58ca48f2), SPH_C32(0x505495f2), SPH_C32(0x28c30446),
    SPH_C32(0x423f2986) },
  { SPH_C32(0x4e870000), SPH_C32(0x5dbb0000), SPH_C32(0x14190000),
    SPH_C32(0xf3dac600), SPH_C32(0x929a36d9), SPH_C32(0xc5718b8b),
    SPH_C32(0x540dfbc2), SPH_C32(0x5f9adb3c), SPH_C32(0x3b480000),
    SPH_C32(0xe9950000), SPH_C32(0x9f270000), SPH_C32(0x41e618a0),
    SPH_C32(0x63a74ec3), SPH_C32(0x92b9c36b), SPH_C32(0xe323fa5a),
    SPH_C32(0x14989819) },
  { SPH_C32(0x586a0000), SPH_C32(0x48d30000), SPH_C32(0xf9ce0000),
    SPH_C32(0xc187c420), SPH_C32(0x71960050), SPH_C32(0x9f3b6dc8),
    SPH_C32(0xb778036a), SPH_C32(0xde672234), SPH_C32(0xdd600000),
    SPH_C32(0xa5de0000), SPH_C32(0x37720000), SPH_C32(0x92361a40),
    SPH_C32(0xbbc67e7b), SPH_C32(0x0a1e73b1), SPH_C32(0xcbb6fcee),
    SPH_C32(0xc3c2d08e) },
  { SPH_C32(0xbe420000), SPH_C32(0x04980000), SPH_C32(0x519b0000),
    SPH_C32(0x1257c6c0), SPH_C32(0xa9f730e8), SPH_C32(0x079cdd12),
    SPH_C32(0x9fed05de), SPH_C32(0x093d6aa3), SPH_C32(0x2da50000),
    SPH_C32(0xfcfd0000), SPH_C32(0x72f00000), SPH_C32(0x73bb1a80),
    SPH_C32(0x80ab784a), SPH_C32(0xc8f32528), SPH_C32(0x005602f2),
    SPH_C32(0x95656111) },
  { SPH_C32(0xff980000), SPH_C32(0xdb020000), SPH_C32(0x8a020000),
    SPH_C32(0xe028c060), SPH_C32(0x1ce36d43), SPH_C32(0x0175cf5d),
    SPH_C32(0xdd0b82f9), SPH_C32(0x9d79f24c), SPH_C32(0x7fbc0000),
    SPH_C32(0xc7850000), SPH_C32(0x6bf80000), SPH_C32(0xdfbb1c80),
    SPH_C32(0x206829ca), SPH_C32(0x814256af), SPH_C32(0xfa95d0cf),
    SPH_C32(0x0c505d58) },
  { SPH_C32(0x19b00000), SPH_C32(0x97490000), SPH_C32(0x22570000),
    SPH_C32(0x33f8c280), SPH_C32(0xc4825dfb), SPH_C32(0x99d27f87),
    SPH_C32(0xf59e844d), SPH_C32(0x4a23badb), SPH_C32(0x8f790000),
    SPH_C32(0x9ea60000), SPH_C32(0x2e7a0000), SPH_C32(0x3e361c40),
    SPH_C32(0x1b052ffb), SPH_C32(0x43af0036), SPH_C32(0x31752ed3),
    SPH_C32(0x5af7ecc7) },
  { SPH_C32(0x0f5d0000), SPH_C32(0x82210000), SPH_C32(0xcf800000),
    SPH_C32(0x01a5c0a0), SPH_C32(0x278e6b72), SPH_C32(0xc39899c4),
    SPH_C32(0x16eb7ce5), SPH_C32(0xcbde43d3), SPH_C32(0x69510000),
    SPH_C32(0xd2ed0000), SPH_C32(0x862f0000), SPH_C32(0xede61ea0),
    SPH_C32(0xc3641f43), SPH_C32(0xdb08b0ec), SPH_C32(0x19e02867),
    SPH_C32(0x8dada450) },
  { SPH_C32(0xe9750000), SPH_C32(0xce6a0000), SPH_C32(0x67d50000),
    SPH_C32(0xd275c240), SPH_C32(0xffef5bca), SPH_C32(0x5b3f291e),
    SPH_C32(0x3e7e7a51), SPH_C32(0x1c840b44), SPH_C32(0x99940000),
    SPH_C32(0x8bce0000), SPH_C32(0xc3ad0000), SPH_C32(0x0c6b1e60),
    SPH_C32(0xf8091972), SPH_C32(0x19e5e675), SPH_C32(0xd200d67b),
    SPH_C32(0xdb0a15cf) },
  { SPH_C32(0x4ba90000), SPH_C32(0xac310000), SPH_C32(0x3b5f0000),
    SPH_C32(0x9ff8c480), SPH_C32(0x64410c7b), SPH_C32(0xd0630c00),
    SPH_C32(0x0f5d5670), SPH_C32(0xd3168692), SPH_C32(0x9cba0000),
    SPH_C32(0x7a440000), SPH_C32(0xeceb0000), SPH_C32(0x60491ce0),
    SPH_C32(0x0ed223d0), SPH_C32(0x0cf761fe), SPH_C32(0x89507bc9),
    SPH_C32(0x57864861) },
  { SPH_C32(0xad810000), SPH_C32(0xe07a0000), SPH_C32(0x930a0000),
    SPH_C32(0x4c28c660), SPH_C32(0xbc203cc3), SPH_C32(0x48c4bcda),
    SPH_C32(0x27c850c4), SPH_C32(0x044cce05), SPH_C32(0x6c7f0000),
    SPH_C32(0x23670000), SPH_C32(0xa9690000), SPH_C32(0x81c41c20),
    SPH_C32(0x35bf25e1), SPH_C32(0xce1a3767), SPH_C32(0x42b085d5),
    SPH_C32(0x0121f9fe) },
  { SPH_C32(0xbb6c0000), SPH_C32(0xf5120000), SPH_C32(0x7edd0000),
    SPH_C32(0x7e75c440), SPH_C32(0x5f2c0a4a), SPH_C32(0x128e5a99),
    SPH_C32(0xc4bda86c), SPH_C32(0x85b1370d), SPH_C32(0x8a570000),
    SPH_C32(0x6f2c0000), SPH_C32(0x013c0000), SPH_C32(0x52141ec0),
    SPH_C32(0xedde1559), SPH_C32(0x56bd87bd), SPH_C32(0x6a258361),
    SPH_C32(0xd67bb169) },
  { SPH_C32(0x5d440000), SPH_C32(0xb9590000), SPH_C32(0xd6880000),
    SPH_C32(0xada5c6a0), SPH_C32(0x874d3af2), SPH_C32(0x8a29ea43),
    SPH_C32(0xec28aed8), SPH_C32(0x52eb7f9a), SPH_C32(0x7a920000),
    SPH_C32(0x360f0000), SPH_C32(0x44be0000), SPH_C32(0xb3991e00),
    SPH_C32(0xd6b31368), SPH_C32(0x9450d124), SPH_C32(0xa1c57d7d),
    SPH_C32(0x80dc00f6) },
  { SPH_C32(0xa4b10000), SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000),
    SPH_C32(0x4b9e9000), SPH_C32(0xf30107fb), SPH_C32(0xbde710e0),
    SPH_C32(0x805696dc), SPH_C32(0x93b1da1b), SPH_C32(0x2a790000),
    SPH_C32(0xaff60000), SPH_C32(0xda890000), SPH_C32(0xfcf56000),
    SPH_C32(0x686d3607), SPH_C32(0xdadc8975), SPH_C32(0x9fc49d77),
    SPH_C32(0x66db1921) },
  { SPH_C32(0x42990000), SPH_C32(0x9ba40000), SPH_C32(0x959c0000),
    SPH_C32(0x984e92e0), SPH_C32(0x2b603743), SPH_C32(0x2540a03a),
    SPH_C32(0xa8c39068), SPH_C32(0x44eb928c), SPH_C32(0xdabc0000),
    SPH_C32(0xf6d50000), SPH_C32(0x9f0b0000), SPH_C32(0x1d7860c0),
    SPH_C32(0x53003036), SPH_C32(0x1831dfec), SPH_C32(0x5424636b),
    SPH_C32(0x307ca8be) },
  { SPH_C32(0x54740000), SPH_C32(0x8ecc0000), SPH_C32(0x784b0000),
    SPH_C32(0xaa1390c0), SPH_C32(0xc86c01ca), SPH_C32(0x7f0a4679),
    SPH_C32(0x4bb668c0), SPH_C32(0xc5166b84), SPH_C32(0x3c940000),
    SPH_C32(0xba9e0000), SPH_C32(0x375e0000), SPH_C32(0xcea86220),
    SPH_C32(0x8b61008e), SPH_C32(0x80966f36), SPH_C32(0x7cb165df),
    SPH_C32(0xe726e029) },
  { SPH_C32(0xb25c0000), SPH_C32(0xc2870000), SPH_C32(0xd01e0000),
    SPH_C32(0x79c39220), SPH_C32(0x100d3172), SPH_C32(0xe7adf6a3),
    SPH_C32(0x63236e74), SPH_C32(0x124c2313), SPH_C32(0xcc510000),
    SPH_C32(0xe3bd0000), SPH_C32(0x72dc0000), SPH_C32(0x2f2562e0),
    SPH_C32(0xb00c06bf), SPH_C32(0x427b39af), SPH_C32(0xb7519bc3),
    SPH_C32(0xb18151b6) },
  { SPH_C32(0x10800000), SPH_C32(0xa0dc0000), SPH_C32(0x8c940000),
    SPH_C32(0x344e94e0), SPH_C32(0x8ba366c3), SPH_C32(0x6cf1d3bd),
    SPH_C32(0x52004255), SPH_C32(0xdddeaec5), SPH_C32(0xc97f0000),
    SPH_C32(0x12370000), SPH_C32(0x5d9a0000), SPH_C32(0x43076060),
    SPH_C32(0x46d73c1d), SPH_C32(0x5769be24), SPH_C32(0xec013671),
    SPH_C32(0x3d0d0c18) },
  { SPH_C32(0xf6a80000), SPH_C32(0xec970000), SPH_C32(0x24c10000),
    SPH_C32(0xe79e9600), SPH_C32(0x53c2567b), SPH_C32(0xf4566367),
    SPH_C32(0x7a9544e1), SPH_C32(0x0a84e652), SPH_C32(0x39ba0000),
    SPH_C32(0x4b140000), SPH_C32(0x18180000), SPH_C32(0xa28a60a0),
    SPH_C32(0x7dba3a2c), SPH_C32(0x9584e8bd), SPH_C32(0x27e1c86d),
    SPH_C32(0x6baabd87) },
  { SPH_C32(0xe0450000), SPH_C32(0xf9ff0000), SPH_C32(0xc9160000),
    SPH_C32(0xd5c39420), SPH_C32(0xb0ce60f2), SPH_C32(0xae1c8524),
    SPH_C32(0x99e0bc49), SPH_C32(0x8b791f5a), SPH_C32(0xdf920000),
    SPH_C32(0x075f0000), SPH_C32(0xb04d0000), SPH_C32(0x715a6240),
    SPH_C32(0xa5db0a94), SPH_C32(0x0d235867), SPH_C32(0x0f74ced9),
    SPH_C32(0xbcf0f510) },
  { SPH_C32(0x066d0000), SPH_C32(0xb5b40000), SPH_C32(0x61430000),
    SPH_C32(0x061396c0), SPH_C32(0x68af504a), SPH_C32(0x36bb35fe),
    SPH_C32(0xb175bafd), SPH_C32(0x5c2357cd), SPH_C32(0x2f570000),
    SPH_C32(0x5e7c0000), SPH_C32(0xf5cf0000), SPH_C32(0x90d76280),
    SPH_C32(0x9eb60ca5), SPH_C32(0xcfce0efe), SPH_C32(0xc49430c5),
    SPH_C32(0xea57448f) },
  { SPH_C32(0x47b70000), SPH_C32(0x6a2e0000), SPH_C32(0xbada0000),
    SPH_C32(0xf46c9060), SPH_C32(0xddbb0de1), SPH_C32(0x305227b1),
    SPH_C32(0xf3933dda), SPH_C32(0xc867cf22), SPH_C32(0x7d4e0000),
    SPH_C32(0x65040000), SPH_C32(0xecc70000), SPH_C32(0x3cd76480),
    SPH_C32(0x3e755d25), SPH_C32(0x867f7d79), SPH_C32(0x3e57e2f8),
    SPH_C32(0x736278c6) },
  { SPH_C32(0xa19f0000), SPH_C32(0x26650000), SPH_C32(0x128f0000),
    SPH_C32(0x27bc9280), SPH_C32(0x05da3d59), SPH_C32(0xa8f5976b),
    SPH_C32(0xdb063b6e), SPH_C32(0x1f3d87b5), SPH_C32(0x8d8b0000),
    SPH_C32(0x3c270000), SPH_C32(0xa9450000), SPH_C32(0xdd5a6440),
    SPH_C32(0x05185b14), SPH_C32(0x44922be0), SPH_C32(0xf5b71ce4),
    SPH_C32(0x25c5c959) },
  { SPH_C32(0xb7720000), SPH_C32(0x330d0000), SPH_C32(0xff580000),
    SPH_C32(0x15e190a0), SPH_C32(0xe6d60bd0), SPH_C32(0xf2bf7128),
    SPH_C32(0x3873c3c6), SPH_C32(0x9ec07ebd), SPH_C32(0x6ba30000),
    SPH_C32(0x706c0000), SPH_C32(0x01100000), SPH_C32(0x0e8a66a0),
    SPH_C32(0xdd796bac), SPH_C32(0xdc359b3a), SPH_C32(0xdd221a50),
    SPH_C32(0xf29f81ce) },
  { SPH_C32(0x515a0000), SPH_C32(0x7f460000), SPH_C32(0x570d0000),
    SPH_C32(0xc6319240), SPH_C32(0x3eb73b68), SPH_C32(0x6a18c1f2),
    SPH_C32(0x10e6c572), SPH_C32(0x499a362a), SPH_C32(0x9b660000),
    SPH_C32(0x294f0000), SPH_C32(0x44920000), SPH_C32(0xef076660),
    SPH_C32(0xe6146d9d), SPH_C32(0x1ed8cda3), SPH_C32(0x16c2e44c),
    SPH_C32(0xa4383051) },
  { SPH_C32(0xf3860000), SPH_C32(0x1d1d0000), SPH_C32(0x0b870000),
    SPH_C32(0x8bbc9480), SPH_C32(0xa5196cd9), SPH_C32(0xe144e4ec),
    SPH_C32(0x21c5e953), SPH_C32(0x8608bbfc), SPH_C32(0x9e480000),
    SPH_C32(0xd8c50000), SPH_C32(0x6bd40000), SPH_C32(0x832564e0),
    SPH_C32(0x10cf573f), SPH_C32(0x0bca4a28), SPH_C32(0x4d9249fe),
    SPH_C32(0x28b46dff) },
  { SPH_C32(0x15ae0000), SPH_C32(0x51560000), SPH_C32(0xa3d20000),
    SPH_C32(0x586c9660), SPH_C32(0x7d785c61), SPH_C32(0x79e35436),
    SPH_C32(0x0950efe7), SPH_C32(0x5152f36b), SPH_C32(0x6e8d0000),
    SPH_C32(0x81e60000), SPH_C32(0x2e560000), SPH_C32(0x62a86420),
    SPH_C32(0x2ba2510e), SPH_C32(0xc9271cb1), SPH_C32(0x8672b7e2),
    SPH_C32(0x7e13dc60) },
  { SPH_C32(0x03430000), SPH_C32(0x443e0000), SPH_C32(0x4e050000),
    SPH_C32(0x6a319440), SPH_C32(0x9e746ae8), SPH_C32(0x23a9b275),
    SPH_C32(0xea25174f), SPH_C32(0xd0af0a63), SPH_C32(0x88a50000),
    SPH_C32(0xcdad0000), SPH_C32(0x86030000), SPH_C32(0xb17866c0),
    SPH_C32(0xf3c361b6), SPH_C32(0x5180ac6b), SPH_C32(0xaee7b156),
    SPH_C32(0xa94994f7) },
  { SPH_C32(0xe56b0000), SPH_C32(0x08750000), SPH_C32(0xe6500000),
    SPH_C32(0xb9e196a0), SPH_C32(0x46155a50), SPH_C32(0xbb0e02af),
    SPH_C32(0xc2b011fb), SPH_C32(0x07f542f4), SPH_C32(0x78600000),
    SPH_C32(0x948e0000), SPH_C32(0xc3810000), SPH_C32(0x50f56600),
    SPH_C32(0xc8ae6787), SPH_C32(0x936dfaf2), SPH_C32(0x65074f4a),
    SPH_C32(0xffee2568) },
  { SPH_C32(0xa6430000), SPH_C32(0x756e0000), SPH_C32(0xbaf60000),
    SPH_C32(0xa8f2e800), SPH_C32(0xed1c7314), SPH_C32(0xbada3b36),
    SPH_C32(0x4494a4eb), SPH_C32(0xec83ff85), SPH_C32(0x90a40000),
    SPH_C32(0xbc5b0000), SPH_C32(0x6d6e0000), SPH_C32(0x0bdd4800),
    SPH_C32(0xb728224a), SPH_C32(0xecc64a4f), SPH_C32(0x759e1063),
    SPH_C32(0x4cf701d1) },
  { SPH_C32(0x406b0000), SPH_C32(0x39250000), SPH_C32(0x12a30000),
    SPH_C32(0x7b22eae0), SPH_C32(0x357d43ac), SPH_C32(0x227d8bec),
    SPH_C32(0x6c01a25f), SPH_C32(0x3bd9b712), SPH_C32(0x60610000),
    SPH_C32(0xe5780000), SPH_C32(0x28ec0000), SPH_C32(0xea5048c0),
    SPH_C32(0x8c45247b), SPH_C32(0x2e2b1cd6), SPH_C32(0xbe7eee7f),
    SPH_C32(0x1a50b04e) },
  { SPH_C32(0x56860000), SPH_C32(0x2c4d0000), SPH_C32(0xff740000),
    SPH_C32(0x497fe8c0), SPH_C32(0xd6717525), SPH_C32(0x78376daf),
    SPH_C32(0x8f745af7), SPH_C32(0xba244e1a), SPH_C32(0x86490000),
    SPH_C32(0xa9330000), SPH_C32(0x80b90000), SPH_C32(0x39804a20),
    SPH_C32(0x542414c3), SPH_C32(0xb68cac0c), SPH_C32(0x96ebe8cb),
    SPH_C32(0xcd0af8d9) },
  { SPH_C32(0xb0ae0000), SPH_C32(0x60060000), SPH_C32(0x57210000),
    SPH_C32(0x9aafea20), SPH_C32(0x0e10459d), SPH_C32(0xe090dd75),
    SPH_C32(0xa7e15c43), SPH_C32(0x6d7e068d), SPH_C32(0x768c0000),
    SPH_C32(0xf0100000), SPH_C32(0xc53b0000), SPH_C32(0xd80d4ae0),
    SPH_C32(0x6f4912f2), SPH_C32(0x7461fa95), SPH_C32(0x5d0b16d7),
    SPH_C32(0x9bad4946) },
  { SPH_C32(0x12720000), SPH_C32(0x025d0000), SPH_C32(0x0bab0000),
    SPH_C32(0xd722ece0), SPH_C32(0x95be122c), SPH_C32(0x6bccf86b),
    SPH_C32(0x96c27062), SPH_C32(0xa2ec8b5b), SPH_C32(0x73a20000),
    SPH_C32(0x019a0000), SPH_C32(0xea7d0000), SPH_C32(0xb42f4860),
    SPH_C32(0x99922850), SPH_C32(0x61737d1e), SPH_C32(0x065bbb65),
    SPH_C32(0x172114e8) },
  { SPH_C32(0xf45a0000), SPH_C32(0x4e160000), SPH_C32(0xa3fe0000),
    SPH_C32(0x04f2ee00), SPH_C32(0x4ddf2294), SPH_C32(0xf36b48b1),
    SPH_C32(0xbe5776d6), SPH_C32(0x75b6c3cc), SPH_C32(0x83670000),
    SPH_C32(0x58b90000), SPH_C32(0xafff0000), SPH_C32(0x55a248a0),
    SPH_C32(0xa2ff2e61), SPH_C32(0xa39e2b87), SPH_C32(0xcdbb4579),
    SPH_C32(0x4186a577) },
  { SPH_C32(0xe2b70000), SPH_C32(0x5b7e0000), SPH_C32(0x4e290000),
    SPH_C32(0x36afec20), SPH_C32(0xaed3141d), SPH_C32(0xa921aef2),
    SPH_C32(0x5d228e7e), SPH_C32(0xf44b3ac4), SPH_C32(0x654f0000),
    SPH_C32(0x14f20000), SPH_C32(0x07aa0000), SPH_C32(0x86724a40),
    SPH_C32(0x7a9e1ed9), SPH_C32(0x3b399b5d), SPH_C32(0xe52e43cd),
    SPH_C32(0x96dcede0) },
  { SPH_C32(0x049f0000), SPH_C32(0x17350000), SPH_C32(0xe67c0000),
    SPH_C32(0xe57feec0), SPH_C32(0x76b224a5), SPH_C32(0x31861e28),
    SPH_C32(0x75b788ca), SPH_C32(0x23117253), SPH_C32(0x958a0000),
    SPH_C32(0x4dd10000), SPH_C32(0x42280000), SPH_C32(0x67ff4a80),
    SPH_C32(0x41f318e8), SPH_C32(0xf9d4cdc4), SPH_C32(0x2ecebdd1),
    SPH_C32(0xc07b5c7f) },
  { SPH_C32(0x45450000), SPH_C32(0xc8af0000), SPH_C32(0x3de50000),
    SPH_C32(0x1700e860), SPH_C32(0xc3a6790e), SPH_C32(0x376f0c67),
    SPH_C32(0x37510fed), SPH_C32(0xb755eabc), SPH_C32(0xc7930000),
    SPH_C32(0x76a90000), SPH_C32(0x5b200000), SPH_C32(0xcbff4c80),
    SPH_C32(0xe1304968), SPH_C32(0xb065be43), SPH_C32(0xd40d6fec),
    SPH_C32(0x594e6036) },
  { SPH_C32(0xa36d0000), SPH_C32(0x84e40000), SPH_C32(0x95b00000),
    SPH_C32(0xc4d0ea80), SPH_C32(0x1bc749b6), SPH_C32(0xafc8bcbd),
    SPH_C32(0x1fc40959), SPH_C32(0x600fa22b), SPH_C32(0x37560000),
    SPH_C32(0x2f8a0000), SPH_C32(0x1ea20000), SPH_C32(0x2a724c40),
    SPH_C32(0xda5d4f59), SPH_C32(0x7288e8da), SPH_C32(0x1fed91f0),
    SPH_C32(0x0fe9d1a9) },
  { SPH_C32(0xb5800000), SPH_C32(0x918c0000), SPH_C32(0x78670000),
    SPH_C32(0xf68de8a0), SPH_C32(0xf8cb7f3f), SPH_C32(0xf5825afe),
    SPH_C32(0xfcb1f1f1), SPH_C32(0xe1f25b23), SPH_C32(0xd17e0000),
    SPH_C32(0x63c10000), SPH_C32(0xb6f70000), SPH_C32(0xf9a24ea0),
    SPH_C32(0x023c7fe1), SPH_C32(0xea2f5800), SPH_C32(0x37789744),
    SPH_C32(0xd8b3993e) },
  { SPH_C32(0x53a80000), SPH_C32(0xddc70000), SPH_C32(0xd0320000),
    SPH_C32(0x255dea40), SPH_C32(0x20aa4f87), SPH_C32(0x6d25ea24),
    SPH_C32(0xd424f745), SPH_C32(0x36a813b4), SPH_C32(0x21bb0000),
    SPH_C32(0x3ae20000), SPH_C32(0xf3750000), SPH_C32(0x182f4e60),
    SPH_C32(0x395179d0), SPH_C32(0x28c20e99), SPH_C32(0xfc986958),
    SPH_C32(0x8e1428a1) },
  { SPH_C32(0xf1740000), SPH_C32(0xbf9c0000), SPH_C32(0x8cb80000),
    SPH_C32(0x68d0ec80), SPH_C32(0xbb041836), SPH_C32(0xe679cf3a),
    SPH_C32(0xe507db64), SPH_C32(0xf93a9e62), SPH_C32(0x24950000),
    SPH_C32(0xcb680000), SPH_C32(0xdc330000), SPH_C32(0x740d4ce0),
    SPH_C32(0xcf8a4372), SPH_C32(0x3dd08912), SPH_C32(0xa7c8c4ea),
    SPH_C32(0x0298750f) },
  { SPH_C32(0x175c0000), SPH_C32(0xf3d70000), SPH_C32(0x24ed0000),
    SPH_C32(0xbb00ee60), SPH_C32(0x6365288e), SPH_C32(0x7ede7fe0),
    SPH_C32(0xcd92ddd0), SPH_C32(0x2e60d6f5), SPH_C32(0xd4500000),
    SPH_C32(0x924b0000), SPH_C32(0x99b10000), SPH_C32(0x95804c20),
    SPH_C32(0xf4e74543), SPH_C32(0xff3ddf8b), SPH_C32(0x6c283af6),
    SPH_C32(0x543fc490) },
  { SPH_C32(0x01b10000), SPH_C32(0xe6bf0000), SPH_C32(0xc93a0000),
    SPH_C32(0x895dec40), SPH_C32(0x80691e07), SPH_C32(0x249499a3),
    SPH_C32(0x2ee72578), SPH_C32(0xaf9d2ffd), SPH_C32(0x32780000),
    SPH_C32(0xde000000), SPH_C32(0x31e40000), SPH_C32(0x46504ec0),
    SPH_C32(0x2c8675fb), SPH_C32(0x679a6f51), SPH_C32(0x44bd3c42),
    SPH_C32(0x83658c07) },
  { SPH_C32(0xe7990000), SPH_C32(0xaaf40000), SPH_C32(0x616f0000),
    SPH_C32(0x5a8deea0), SPH_C32(0x58082ebf), SPH_C32(0xbc332979),
    SPH_C32(0x067223cc), SPH_C32(0x78c7676a), SPH_C32(0xc2bd0000),
    SPH_C32(0x87230000), SPH_C32(0x74660000), SPH_C32(0xa7dd4e00),
    SPH_C32(0x17eb73ca), SPH_C32(0xa57739c8), SPH_C32(0x8f5dc25e),
    SPH_C32(0xd5c23d98) },
  { SPH_C32(0x92560000), SPH_C32(0x1eda0000), SPH_C32(0xea510000),
    SPH_C32(0xe8b13000), SPH_C32(0xa93556a5), SPH_C32(0xebfb6199),
    SPH_C32(0xb15c2254), SPH_C32(0x33c5244f), SPH_C32(0x8c3a0000),
    SPH_C32(0xda980000), SPH_C32(0x607f0000), SPH_C32(0x54078800),
    SPH_C32(0x85714513), SPH_C32(0x6006b243), SPH_C32(0xdb50399c),
    SPH_C32(0x8a58e6a4) },
  { SPH_C32(0x747e0000), SPH_C32(0x52910000), SPH_C32(0x42040000),
    SPH_C32(0x3b6132e0), SPH_C32(0x7154661d), SPH_C32(0x735cd143),
    SPH_C32(0x99c924e0), SPH_C32(0xe49f6cd8), SPH_C32(0x7cff0000),
    SPH_C32(0x83bb0000), SPH_C32(0x25fd0000), SPH_C32(0xb58a88c0),
    SPH_C32(0xbe1c4322), SPH_C32(0xa2ebe4da), SPH_C32(0x10b0c780),
    SPH_C32(0xdcff573b) },
  { SPH_C32(0x62930000), SPH_C32(0x47f90000), SPH_C32(0xafd30000),
    SPH_C32(0x093c30c0), SPH_C32(0x92585094), SPH_C32(0x29163700),
    SPH_C32(0x7abcdc48), SPH_C32(0x656295d0), SPH_C32(0x9ad70000),
    SPH_C32(0xcff00000), SPH_C32(0x8da80000), SPH_C32(0x665a8a20),
    SPH_C32(0x667d739a), SPH_C32(0x3a4c5400), SPH_C32(0x3825c134),
    SPH_C32(0x0ba51fac) },
  { SPH_C32(0x84bb0000), SPH_C32(0x0bb20000), SPH_C32(0x07860000),
    SPH_C32(0xdaec3220), SPH_C32(0x4a39602c), SPH_C32(0xb1b187da),
    SPH_C32(0x5229dafc), SPH_C32(0xb238dd47), SPH_C32(0x6a120000),
    SPH_C32(0x96d30000), SPH_C32(0xc82a0000), SPH_C32(0x87d78ae0),
    SPH_C32(0x5d1075ab), SPH_C32(0xf8a10299), SPH_C32(0xf3c53f28),
    SPH_C32(0x5d02ae33) },
  { SPH_C32(0x26670000), SPH_C32(0x69e90000), SPH_C32(0x5b0c0000),
    SPH_C32(0x976134e0), SPH_C32(0xd197379d), SPH_C32(0x3aeda2c4),
    SPH_C32(0x630af6dd), SPH_C32(0x7daa5091), SPH_C32(0x6f3c0000),
    SPH_C32(0x67590000), SPH_C32(0xe76c0000), SPH_C32(0xebf58860),
    SPH_C32(0xabcb4f09), SPH_C32(0xedb38512), SPH_C32(0xa895929a),
    SPH_C32(0xd18ef39d) },
  { SPH_C32(0xc04f0000), SPH_C32(0x25a20000), SPH_C32(0xf3590000),
    SPH_C32(0x44b13600), SPH_C32(0x09f60725), SPH_C32(0xa24a121e),
    SPH_C32(0x4b9ff069), SPH_C32(0xaaf01806), SPH_C32(0x9ff90000),
    SPH_C32(0x3e7a0000), SPH_C32(0xa2ee0000), SPH_C32(0x0a7888a0),
    SPH_C32(0x90a64938), SPH_C32(0x2f5ed38b), SPH_C32(0x63756c86),
    SPH_C32(0x87294202) },
  { SPH_C32(0xd6a20000), SPH_C32(0x30ca0000), SPH_C32(0x1e8e0000),
    SPH_C32(0x76ec3420), SPH_C32(0xeafa31ac), SPH_C32(0xf800f45d),
    SPH_C32(0xa8ea08c1), SPH_C32(0x2b0de10e), SPH_C32(0x79d10000),
    SPH_C32(0x72310000), SPH_C32(0x0abb0000), SPH_C32(0xd9a88a40),
    SPH_C32(0x48c77980), SPH_C32(0xb7f96351), SPH_C32(0x4be06a32),
    SPH_C32(0x50730a95) },
  { SPH_C32(0x308a0000), SPH_C32(0x7c810000), SPH_C32(0xb6db0000),
    SPH_C32(0xa53c36c0), SPH_C32(0x329b0114), SPH_C32(0x60a74487),
    SPH_C32(0x807f0e75), SPH_C32(0xfc57a999), SPH_C32(0x89140000),
    SPH_C32(0x2b120000), SPH_C32(0x4f390000), SPH_C32(0x38258a80),
    SPH_C32(0x73aa7fb1), SPH_C32(0x751435c8), SPH_C32(0x8000942e),
    SPH_C32(0x06d4bb0a) },
  { SPH_C32(0x71500000), SPH_C32(0xa31b0000), SPH_C32(0x6d420000),
    SPH_C32(0x57433060), SPH_C32(0x878f5cbf), SPH_C32(0x664e56c8),
    SPH_C32(0xc2998952), SPH_C32(0x68133176), SPH_C32(0xdb0d0000),
    SPH_C32(0x106a0000), SPH_C32(0x56310000), SPH_C32(0x94258c80),
    SPH_C32(0xd3692e31), SPH_C32(0x3ca5464f), SPH_C32(0x7ac34613),
    SPH_C32(0x9fe18743) },
  { SPH_C32(0x97780000), SPH_C32(0xef500000), SPH_C32(0xc5170000),
    SPH_C32(0x84933280), SPH_C32(0x5fee6c07), SPH_C32(0xfee9e612),
    SPH_C32(0xea0c8fe6), SPH_C32(0xbf4979e1), SPH_C32(0x2bc80000),
    SPH_C32(0x49490000), SPH_C32(0x13b30000), SPH_C32(0x75a88c40),
    SPH_C32(0xe8042800), SPH_C32(0xfe4810d6), SPH_C32(0xb123b80f),
    SPH_C32(0xc94636dc) },
  { SPH_C32(0x81950000), SPH_C32(0xfa380000), SPH_C32(0x28c00000),
    SPH_C32(0xb6ce30a0), SPH_C32(0xbce25a8e), SPH_C32(0xa4a30051),
    SPH_C32(0x0979774e), SPH_C32(0x3eb480e9), SPH_C32(0xcde00000),
    SPH_C32(0x05020000), SPH_C32(0xbbe60000), SPH_C32(0xa6788ea0),
    SPH_C32(0x306518b8), SPH_C32(0x66efa00c), SPH_C32(0x99b6bebb),
    SPH_C32(0x1e1c7e4b) },
  { SPH_C32(0x67bd0000), SPH_C32(0xb6730000), SPH_C32(0x80950000),
    SPH_C32(0x651e3240), SPH_C32(0x64836a36), SPH_C32(0x3c04b08b),
    SPH_C32(0x21ec71fa), SPH_C32(0xe9eec87e), SPH_C32(0x3d250000),
    SPH_C32(0x5c210000), SPH_C32(0xfe640000), SPH_C32(0x47f58e60),
    SPH_C32(0x0b081e89), SPH_C32(0xa402f695), SPH_C32(0x525640a7),
    SPH_C32(0x48bbcfd4) },
  { SPH_C32(0xc5610000), SPH_C32(0xd4280000), SPH_C32(0xdc1f0000),
    SPH_C32(0x28933480), SPH_C32(0xff2d3d87), SPH_C32(0xb7589595),
    SPH_C32(0x10cf5ddb), SPH_C32(0x267c45a8), SPH_C32(0x380b0000),
    SPH_C32(0xadab0000), SPH_C32(0xd1220000), SPH_C32(0x2bd78ce0),
    SPH_C32(0xfdd3242b), SPH_C32(0xb110711e), SPH_C32(0x0906ed15),
    SPH_C32(0xc437927a) },
  { SPH_C32(0x23490000), SPH_C32(0x98630000), SPH_C32(0x744a0000),
    SPH_C32(0xfb433660), SPH_C32(0x274c0d3f), SPH_C32(0x2fff254f),
    SPH_C32(0x385a5b6f), SPH_C32(0xf1260d3f), SPH_C32(0xc8ce0000),
    SPH_C32(0xf4880000), SPH_C32(0x94a00000), SPH_C32(0xca5a8c20),
    SPH_C32(0xc6be221a), SPH_C32(0x73fd2787), SPH_C32(0xc2e61309),
    SPH_C32(0x929023e5) },
  { SPH_C32(0x35a40000), SPH_C32(0x8d0b0000), SPH_C32(0x999d0000),
    SPH_C32(0xc91e3440), SPH_C32(0xc4403bb6), SPH_C32(0x75b5c30c),
    SPH_C32(0xdb2fa3c7), SPH_C32(0x70dbf437), SPH_C32(0x2ee60000),
    SPH_C32(0xb8c30000), SPH_C32(0x3cf50000), SPH_C32(0x198a8ec0),
    SPH_C32(0x1edf12a2), SPH_C32(0xeb5a975d), SPH_C32(0xea7315bd),
    SPH_C32(0x45ca6b72) },
  { SPH_C32(0xd38c0000), SPH_C32(0xc1400000), SPH_C32(0x31c80000),
    SPH_C32(0x1ace36a0), SPH_C32(0x1c210b0e), SPH_C32(0xed1273d6),
    SPH_C32(0xf3baa573), SPH_C32(0xa781bca0), SPH_C32(0xde230000),
    SPH_C32(0xe1e00000), SPH_C32(0x79770000), SPH_C32(0xf8078e00),
    SPH_C32(0x25b21493), SPH_C32(0x29b7c1c4), SPH_C32(0x2193eba1),
    SPH_C32(0x136ddaed) },
  { SPH_C32(0x90a40000), SPH_C32(0xbc5b0000), SPH_C32(0x6d6e0000),
    SPH_C32(0x0bdd4800), SPH_C32(0xb728224a), SPH_C32(0xecc64a4f),
    SPH_C32(0x759e1063), SPH_C32(0x4cf701d1), SPH_C32(0x36e70000),
    SPH_C32(0xc9350000), SPH_C32(0xd7980000), SPH_C32(0xa32fa000),
    SPH_C32(0x5a34515e), SPH_C32(0x561c7179), SPH_C32(0x310ab488),
    SPH_C32(0xa074fe54) },
  { SPH_C32(0x768c0000), SPH_C32(0xf0100000), SPH_C32(0xc53b0000),
    SPH_C32(0xd80d4ae0), SPH_C32(0x6f4912f2), SPH_C32(0x7461fa95),
    SPH_C32(0x5d0b16d7), SPH_C32(0x9bad4946), SPH_C32(0xc6220000),
    SPH_C32(0x90160000), SPH_C32(0x921a0000), SPH_C32(0x42a2a0c0),
    SPH_C32(0x6159576f), SPH_C32(0x94f127e0), SPH_C32(0xfaea4a94),
    SPH_C32(0xf6d34fcb) },
  { SPH_C32(0x60610000), SPH_C32(0xe5780000), SPH_C32(0x28ec0000),
    SPH_C32(0xea5048c0), SPH_C32(0x8c45247b), SPH_C32(0x2e2b1cd6),
    SPH_C32(0xbe7eee7f), SPH_C32(0x1a50b04e), SPH_C32(0x200a0000),
    SPH_C32(0xdc5d0000), SPH_C32(0x3a4f0000), SPH_C32(0x9172a220),
    SPH_C32(0xb93867d7), SPH_C32(0x0c56973a), SPH_C32(0xd27f4c20),
    SPH_C32(0x2189075c) },
  { SPH_C32(0x86490000), SPH_C32(0xa9330000), SPH_C32(0x80b90000),
    SPH_C32(0x39804a20), SPH_C32(0x542414c3), SPH_C32(0xb68cac0c),
    SPH_C32(0x96ebe8cb), SPH_C32(0xcd0af8d9), SPH_C32(0xd0cf0000),
    SPH_C32(0x857e0000), SPH_C32(0x7fcd0000), SPH_C32(0x70ffa2e0),
    SPH_C32(0x825561e6), SPH_C32(0xcebbc1a3), SPH_C32(0x199fb23c),
    SPH_C32(0x772eb6c3) },
  { SPH_C32(0x24950000), SPH_C32(0xcb680000), SPH_C32(0xdc330000),
    SPH_C32(0x740d4ce0), SPH_C32(0xcf8a4372), SPH_C32(0x3dd08912),
    SPH_C32(0xa7c8c4ea), SPH_C32(0x0298750f), SPH_C32(0xd5e10000),
    SPH_C32(0x74f40000), SPH_C32(0x508b0000), SPH_C32(0x1cdda060),
    SPH_C32(0x748e5b44), SPH_C32(0xdba94628), SPH_C32(0x42cf1f8e),
    SPH_C32(0xfba2eb6d) },
  { SPH_C32(0xc2bd0000), SPH_C32(0x87230000), SPH_C32(0x74660000),
    SPH_C32(0xa7dd4e00), SPH_C32(0x17eb73ca), SPH_C32(0xa57739c8),
    SPH_C32(0x8f5dc25e), SPH_C32(0xd5c23d98), SPH_C32(0x25240000),
    SPH_C32(0x2dd70000), SPH_C32(0x15090000), SPH_C32(0xfd50a0a0),
    SPH_C32(0x4fe35d75), SPH_C32(0x194410b1), SPH_C32(0x892fe192),
    SPH_C32(0xad055af2) },
  { SPH_C32(0xd4500000), SPH_C32(0x924b0000), SPH_C32(0x99b10000),
    SPH_C32(0x95804c20), SPH_C32(0xf4e74543), SPH_C32(0xff3ddf8b),
    SPH_C32(0x6c283af6), SPH_C32(0x543fc490), SPH_C32(0xc30c0000),
    SPH_C32(0x619c0000), SPH_C32(0xbd5c0000), SPH_C32(0x2e80a240),
    SPH_C32(0x97826dcd), SPH_C32(0x81e3a06b), SPH_C32(0xa1bae726),
    SPH_C32(0x7a5f1265) },
  { SPH_C32(0x32780000), SPH_C32(0xde000000), SPH_C32(0x31e40000),
    SPH_C32(0x46504ec0), SPH_C32(0x2c8675fb), SPH_C32(0x679a6f51),
    SPH_C32(0x44bd3c42), SPH_C32(0x83658c07), SPH_C32(0x33c90000),
    SPH_C32(0x38bf0000), SPH_C32(0xf8de0000), SPH_C32(0xcf0da280),
    SPH_C32(0xacef6bfc), SPH_C32(0x430ef6f2), SPH_C32(0x6a5a193a),
    SPH_C32(0x2cf8a3fa) },
  { SPH_C32(0x73a20000), SPH_C32(0x019a0000), SPH_C32(0xea7d0000),
    SPH_C32(0xb42f4860), SPH_C32(0x99922850), SPH_C32(0x61737d1e),
    SPH_C32(0x065bbb65), SPH_C32(0x172114e8), SPH_C32(0x61d00000),
    SPH_C32(0x03c70000), SPH_C32(0xe1d60000), SPH_C32(0x630da480),
    SPH_C32(0x0c2c3a7c), SPH_C32(0x0abf8575), SPH_C32(0x9099cb07),
    SPH_C32(0xb5cd9fb3) },
  { SPH_C32(0x958a0000), SPH_C32(0x4dd10000), SPH_C32(0x42280000),
    SPH_C32(0x67ff4a80), SPH_C32(0x41f318e8), SPH_C32(0xf9d4cdc4),
    SPH_C32(0x2ecebdd1), SPH_C32(0xc07b5c7f), SPH_C32(0x91150000),
    SPH_C32(0x5ae40000), SPH_C32(0xa4540000), SPH_C32(0x8280a440),
    SPH_C32(0x37413c4d), SPH_C32(0xc852d3ec), SPH_C32(0x5b79351b),
    SPH_C32(0xe36a2e2c) },
  { SPH_C32(0x83670000), SPH_C32(0x58b90000), SPH_C32(0xafff0000),
    SPH_C32(0x55a248a0), SPH_C32(0xa2ff2e61), SPH_C32(0xa39e2b87),
    SPH_C32(0xcdbb4579), SPH_C32(0x4186a577), SPH_C32(0x773d0000),
    SPH_C32(0x16af0000), SPH_C32(0x0c010000), SPH_C32(0x5150a6a0),
    SPH_C32(0xef200cf5), SPH_C32(0x50f56336), SPH_C32(0x73ec33af),
    SPH_C32(0x343066bb) },
  { SPH_C32(0x654f0000), SPH_C32(0x14f20000), SPH_C32(0x07aa0000),
    SPH_C32(0x86724a40), SPH_C32(0x7a9e1ed9), SPH_C32(0x3b399b5d),
    SPH_C32(0xe52e43cd), SPH_C32(0x96dcede0), SPH_C32(0x87f80000),
    SPH_C32(0x4f8c0000), SPH_C32(0x49830000), SPH_C32(0xb0dda660),
    SPH_C32(0xd44d0ac4), SPH_C32(0x921835af), SPH_C32(0xb80ccdb3),
    SPH_C32(0x6297d724) },
  { SPH_C32(0xc7930000), SPH_C32(0x76a90000), SPH_C32(0x5b200000),
    SPH_C32(0xcbff4c80), SPH_C32(0xe1304968), SPH_C32(0xb065be43),
    SPH_C32(0xd40d6fec), SPH_C32(0x594e6036), SPH_C32(0x82d60000),
    SPH_C32(0xbe060000), SPH_C32(0x66c50000), SPH_C32(0xdcffa4e0),
    SPH_C32(0x22963066), SPH_C32(0x870ab224), SPH_C32(0xe35c6001),
    SPH_C32(0xee1b8a8a) },
  { SPH_C32(0x21bb0000), SPH_C32(0x3ae20000), SPH_C32(0xf3750000),
    SPH_C32(0x182f4e60), SPH_C32(0x395179d0), SPH_C32(0x28c20e99),
    SPH_C32(0xfc986958), SPH_C32(0x8e1428a1), SPH_C32(0x72130000),
    SPH_C32(0xe7250000), SPH_C32(0x23470000), SPH_C32(0x3d72a420),
    SPH_C32(0x19fb3657), SPH_C32(0x45e7e4bd), SPH_C32(0x28bc9e1d),
    SPH_C32(0xb8bc3b15) },
  { SPH_C32(0x37560000), SPH_C32(0x2f8a0000), SPH_C32(0x1ea20000),
    SPH_C32(0x2a724c40), SPH_C32(0xda5d4f59), SPH_C32(0x7288e8da),
    SPH_C32(0x1fed91f0), SPH_C32(0x0fe9d1a9), SPH_C32(0x943b0000),
    SPH_C32(0xab6e0000), SPH_C32(0x8b120000), SPH_C32(0xeea2a6c0),
    SPH_C32(0xc19a06ef), SPH_C32(0xdd405467), SPH_C32(0x002998a9),
    SPH_C32(0x6fe67382) },
  { SPH_C32(0xd17e0000), SPH_C32(0x63c10000), SPH_C32(0xb6f70000),
    SPH_C32(0xf9a24ea0), SPH_C32(0x023c7fe1), SPH_C32(0xea2f5800),
    SPH_C32(0x37789744), SPH_C32(0xd8b3993e), SPH_C32(0x64fe0000),
    SPH_C32(0xf24d0000), SPH_C32(0xce900000), SPH_C32(0x0f2fa600),
    SPH_C32(0xfaf700de), SPH_C32(0x1fad02fe), SPH_C32(0xcbc966b5),
    SPH_C32(0x3941c21d) },
  { SPH_C32(0x288b0000), SPH_C32(0x0d770000), SPH_C32(0x5db60000),
    SPH_C32(0x1f991800), SPH_C32(0x767042e8), SPH_C32(0xdde1a2a3),
    SPH_C32(0x5b06af40), SPH_C32(0x19e93cbf), SPH_C32(0x34150000),
    SPH_C32(0x6bb40000), SPH_C32(0x50a70000), SPH_C32(0x4043d800),
    SPH_C32(0x442925b1), SPH_C32(0x51215aaf), SPH_C32(0xf5c886bf),
    SPH_C32(0xdf46dbca) },
  { SPH_C32(0xcea30000), SPH_C32(0x413c0000), SPH_C32(0xf5e30000),
    SPH_C32(0xcc491ae0), SPH_C32(0xae117250), SPH_C32(0x45461279),
    SPH_C32(0x7393a9f4), SPH_C32(0xceb37428), SPH_C32(0xc4d00000),
    SPH_C32(0x32970000), SPH_C32(0x15250000), SPH_C32(0xa1ced8c0),
    SPH_C32(0x7f442380), SPH_C32(0x93cc0c36), SPH_C32(0x3e2878a3),
    SPH_C32(0x89e16a55) },
  { SPH_C32(0xd84e0000), SPH_C32(0x54540000), SPH_C32(0x18340000),
    SPH_C32(0xfe1418c0), SPH_C32(0x4d1d44d9), SPH_C32(0x1f0cf43a),
    SPH_C32(0x90e6515c), SPH_C32(0x4f4e8d20), SPH_C32(0x22f80000),
    SPH_C32(0x7edc0000), SPH_C32(0xbd700000), SPH_C32(0x721eda20),
    SPH_C32(0xa7251338), SPH_C32(0x0b6bbcec), SPH_C32(0x16bd7e17),
    SPH_C32(0x5ebb22c2) },
  { SPH_C32(0x3e660000), SPH_C32(0x181f0000), SPH_C32(0xb0610000),
    SPH_C32(0x2dc41a20), SPH_C32(0x957c7461), SPH_C32(0x87ab44e0),
    SPH_C32(0xb87357e8), SPH_C32(0x9814c5b7), SPH_C32(0xd23d0000),
    SPH_C32(0x27ff0000), SPH_C32(0xf8f20000), SPH_C32(0x9393dae0),
    SPH_C32(0x9c481509), SPH_C32(0xc986ea75), SPH_C32(0xdd5d800b),
    SPH_C32(0x081c935d) },
  { SPH_C32(0x9cba0000), SPH_C32(0x7a440000), SPH_C32(0xeceb0000),
    SPH_C32(0x60491ce0), SPH_C32(0x0ed223d0), SPH_C32(0x0cf761fe),
    SPH_C32(0x89507bc9), SPH_C32(0x57864861), SPH_C32(0xd7130000),
    SPH_C32(0xd6750000), SPH_C32(0xd7b40000), SPH_C32(0xffb1d860),
    SPH_C32(0x6a932fab), SPH_C32(0xdc946dfe), SPH_C32(0x860d2db9),
    SPH_C32(0x8490cef3) },
  { SPH_C32(0x7a920000), SPH_C32(0x360f0000), SPH_C32(0x44be0000),
    SPH_C32(0xb3991e00), SPH_C32(0xd6b31368), SPH_C32(0x9450d124),
    SPH_C32(0xa1c57d7d), SPH_C32(0x80dc00f6), SPH_C32(0x27d60000),
    SPH_C32(0x8f560000), SPH_C32(0x92360000), SPH_C32(0x1e3cd8a0),
    SPH_C32(0x51fe299a), SPH_C32(0x1e793b67), SPH_C32(0x4dedd3a5),
    SPH_C32(0xd2377f6c) },
  { SPH_C32(0x6c7f0000), SPH_C32(0x23670000), SPH_C32(0xa9690000),
    SPH_C32(0x81c41c20), SPH_C32(0x35bf25e1), SPH_C32(0xce1a3767),
    SPH_C32(0x42b085d5), SPH_C32(0x0121f9fe), SPH_C32(0xc1fe0000),
    SPH_C32(0xc31d0000), SPH_C32(0x3a630000), SPH_C32(0xcdecda40),
    SPH_C32(0x899f1922), SPH_C32(0x86de8bbd), SPH_C32(0x6578d511),
    SPH_C32(0x056d37fb) },
  { SPH_C32(0x8a570000), SPH_C32(0x6f2c0000), SPH_C32(0x013c0000),
    SPH_C32(0x52141ec0), SPH_C32(0xedde1559), SPH_C32(0x56bd87bd),
    SPH_C32(0x6a258361), SPH_C32(0xd67bb169), SPH_C32(0x313b0000),
    SPH_C32(0x9a3e0000), SPH_C32(0x7fe10000), SPH_C32(0x2c61da80),
    SPH_C32(0xb2f21f13), SPH_C32(0x4433dd24), SPH_C32(0xae982b0d),
    SPH_C32(0x53ca8664) },
  { SPH_C32(0xcb8d0000), SPH_C32(0xb0b60000), SPH_C32(0xdaa50000),
    SPH_C32(0xa06b1860), SPH_C32(0x58ca48f2), SPH_C32(0x505495f2),
    SPH_C32(0x28c30446), SPH_C32(0x423f2986), SPH_C32(0x63220000),
    SPH_C32(0xa1460000), SPH_C32(0x66e90000), SPH_C32(0x8061dc80),
    SPH_C32(0x12314e93), SPH_C32(0x0d82aea3), SPH_C32(0x545bf930),
    SPH_C32(0xcaffba2d) },
  { SPH_C32(0x2da50000), SPH_C32(0xfcfd0000), SPH_C32(0x72f00000),
    SPH_C32(0x73bb1a80), SPH_C32(0x80ab784a), SPH_C32(0xc8f32528),
    SPH_C32(0x005602f2), SPH_C32(0x95656111), SPH_C32(0x93e70000),
    SPH_C32(0xf8650000), SPH_C32(0x236b0000), SPH_C32(0x61ecdc40),
    SPH_C32(0x295c48a2), SPH_C32(0xcf6ff83a), SPH_C32(0x9fbb072c),
    SPH_C32(0x9c580bb2) },
  { SPH_C32(0x3b480000), SPH_C32(0xe9950000), SPH_C32(0x9f270000),
    SPH_C32(0x41e618a0), SPH_C32(0x63a74ec3), SPH_C32(0x92b9c36b),
    SPH_C32(0xe323fa5a), SPH_C32(0x14989819), SPH_C32(0x75cf0000),
    SPH_C32(0xb42e0000), SPH_C32(0x8b3e0000), SPH_C32(0xb23cdea0),
    SPH_C32(0xf13d781a), SPH_C32(0x57c848e0), SPH_C32(0xb72e0198),
    SPH_C32(0x4b024325) },
  { SPH_C32(0xdd600000), SPH_C32(0xa5de0000), SPH_C32(0x37720000),
    SPH_C32(0x92361a40), SPH_C32(0xbbc67e7b), SPH_C32(0x0a1e73b1),
    SPH_C32(0xcbb6fcee), SPH_C32(0xc3c2d08e), SPH_C32(0x850a0000),
    SPH_C32(0xed0d0000), SPH_C32(0xcebc0000), SPH_C32(0x53b1de60),
    SPH_C32(0xca507e2b), SPH_C32(0x95251e79), SPH_C32(0x7cceff84),
    SPH_C32(0x1da5f2ba) },
  { SPH_C32(0x7fbc0000), SPH_C32(0xc7850000), SPH_C32(0x6bf80000),
    SPH_C32(0xdfbb1c80), SPH_C32(0x206829ca), SPH_C32(0x814256af),
    SPH_C32(0xfa95d0cf), SPH_C32(0x0c505d58), SPH_C32(0x80240000),
    SPH_C32(0x1c870000), SPH_C32(0xe1fa0000), SPH_C32(0x3f93dce0),
    SPH_C32(0x3c8b4489), SPH_C32(0x803799f2), SPH_C32(0x279e5236),
    SPH_C32(0x9129af14) },
  { SPH_C32(0x99940000), SPH_C32(0x8bce0000), SPH_C32(0xc3ad0000),
    SPH_C32(0x0c6b1e60), SPH_C32(0xf8091972), SPH_C32(0x19e5e675),
    SPH_C32(0xd200d67b), SPH_C32(0xdb0a15cf), SPH_C32(0x70e10000),
    SPH_C32(0x45a40000), SPH_C32(0xa4780000), SPH_C32(0xde1edc20),
    SPH_C32(0x07e642b8), SPH_C32(0x42dacf6b), SPH_C32(0xec7eac2a),
    SPH_C32(0xc78e1e8b) },
  { SPH_C32(0x8f790000), SPH_C32(0x9ea60000), SPH_C32(0x2e7a0000),
    SPH_C32(0x3e361c40), SPH_C32(0x1b052ffb), SPH_C32(0x43af0036),
    SPH_C32(0x31752ed3), SPH_C32(0x5af7ecc7), SPH_C32(0x96c90000),
    SPH_C32(0x09ef0000), SPH_C32(0x0c2d0000), SPH_C32(0x0dcedec0),
    SPH_C32(0xdf877200), SPH_C32(0xda7d7fb1), SPH_C32(0xc4ebaa9e),
    SPH_C32(0x10d4561c) },
  { SPH_C32(0x69510000), SPH_C32(0xd2ed0000), SPH_C32(0x862f0000),
    SPH_C32(0xede61ea0), SPH_C32(0xc3641f43), SPH_C32(0xdb08b0ec),
    SPH_C32(0x19e02867), SPH_C32(0x8dada450), SPH_C32(0x660c0000),
    SPH_C32(0x50cc0000), SPH_C32(0x49af0000), SPH_C32(0xec43de00),
    SPH_C32(0xe4ea7431), SPH_C32(0x18902928), SPH_C32(0x0f0b5482),
    SPH_C32(0x4673e783) },
  { SPH_C32(0x2a790000), SPH_C32(0xaff60000), SPH_C32(0xda890000),
    SPH_C32(0xfcf56000), SPH_C32(0x686d3607), SPH_C32(0xdadc8975),
    SPH_C32(0x9fc49d77), SPH_C32(0x66db1921), SPH_C32(0x8ec80000),
    SPH_C32(0x78190000), SPH_C32(0xe7400000), SPH_C32(0xb76bf000),
    SPH_C32(0x9b6c31fc), SPH_C32(0x673b9995), SPH_C32(0x1f920bab),
    SPH_C32(0xf56ac33a) },
  { SPH_C32(0xcc510000), SPH_C32(0xe3bd0000), SPH_C32(0x72dc0000),
    SPH_C32(0x2f2562e0), SPH_C32(0xb00c06bf), SPH_C32(0x427b39af),
    SPH_C32(0xb7519bc3), SPH_C32(0xb18151b6), SPH_C32(0x7e0d0000),
    SPH_C32(0x213a0000), SPH_C32(0xa2c20000), SPH_C32(0x56e6f0c0),
    SPH_C32(0xa00137cd), SPH_C32(0xa5d6cf0c), SPH_C32(0xd472f5b7),
    SPH_C32(0xa3cd72a5) },
  { SPH_C32(0xdabc0000), SPH_C32(0xf6d50000), SPH_C32(0x9f0b0000),
    SPH_C32(0x1d7860c0), SPH_C32(0x53003036), SPH_C32(0x1831dfec),
    SPH_C32(0x5424636b), SPH_C32(0x307ca8be), SPH_C32(0x98250000),
    SPH_C32(0x6d710000), SPH_C32(0x0a970000), SPH_C32(0x8536f220),
    SPH_C32(0x78600775), SPH_C32(0x3d717fd6), SPH_C32(0xfce7f303),
    SPH_C32(0x74973a32) },
  { SPH_C32(0x3c940000), SPH_C32(0xba9e0000), SPH_C32(0x375e0000),
    SPH_C32(0xcea86220), SPH_C32(0x8b61008e), SPH_C32(0x80966f36),
    SPH_C32(0x7cb165df), SPH_C32(0xe726e029), SPH_C32(0x68e00000),
    SPH_C32(0x34520000), SPH_C32(0x4f150000), SPH_C32(0x64bbf2e0),
    SPH_C32(0x430d0144), SPH_C32(0xff9c294f), SPH_C32(0x37070d1f),
    SPH_C32(0x22308bad) },
  { SPH_C32(0x9e480000), SPH_C32(0xd8c50000), SPH_C32(0x6bd40000),
    SPH_C32(0x832564e0), SPH_C32(0x10cf573f), SPH_C32(0x0bca4a28),
    SPH_C32(0x4d9249fe), SPH_C32(0x28b46dff), SPH_C32(0x6dce0000),
    SPH_C32(0xc5d80000), SPH_C32(0x60530000), SPH_C32(0x0899f060),
    SPH_C32(0xb5d63be6), SPH_C32(0xea8eaec4), SPH_C32(0x6c57a0ad),
    SPH_C32(0xaebcd603) },
  { SPH_C32(0x78600000), SPH_C32(0x948e0000), SPH_C32(0xc3810000),
    SPH_C32(0x50f56600), SPH_C32(0xc8ae6787), SPH_C32(0x936dfaf2),
    SPH_C32(0x65074f4a), SPH_C32(0xffee2568), SPH_C32(0x9d0b0000),
    SPH_C32(0x9cfb0000), SPH_C32(0x25d10000), SPH_C32(0xe914f0a0),
    SPH_C32(0x8ebb3dd7), SPH_C32(0x2863f85d), SPH_C32(0xa7b75eb1),
    SPH_C32(0xf81b679c) },
  { SPH_C32(0x6e8d0000), SPH_C32(0x81e60000), SPH_C32(0x2e560000),
    SPH_C32(0x62a86420), SPH_C32(0x2ba2510e), SPH_C32(0xc9271cb1),
    SPH_C32(0x8672b7e2), SPH_C32(0x7e13dc60), SPH_C32(0x7b230000),
    SPH_C32(0xd0b00000), SPH_C32(0x8d840000), SPH_C32(0x3ac4f240),
    SPH_C32(0x56da0d6f), SPH_C32(0xb0c44887), SPH_C32(0x8f225805),
    SPH_C32(0x2f412f0b) },
  { SPH_C32(0x88a50000), SPH_C32(0xcdad0000), SPH_C32(0x86030000),
    SPH_C32(0xb17866c0), SPH_C32(0xf3c361b6), SPH_C32(0x5180ac6b),
    SPH_C32(0xaee7b156), SPH_C32(0xa94994f7), SPH_C32(0x8be60000),
    SPH_C32(0x89930000), SPH_C32(0xc8060000), SPH_C32(0xdb49f280),
    SPH_C32(0x6db70b5e), SPH_C32(0x72291e1e), SPH_C32(0x44c2a619),
    SPH_C32(0x79e69e94) },
  { SPH_C32(0xc97f0000), SPH_C32(0x12370000), SPH_C32(0x5d9a0000),
    SPH_C32(0x43076060), SPH_C32(0x46d73c1d), SPH_C32(0x5769be24),
    SPH_C32(0xec013671), SPH_C32(0x3d0d0c18), SPH_C32(0xd9ff0000),
    SPH_C32(0xb2eb0000), SPH_C32(0xd10e0000), SPH_C32(0x7749f480),
    SPH_C32(0xcd745ade), SPH_C32(0x3b986d99), SPH_C32(0xbe017424),
    SPH_C32(0xe0d3a2dd) },
  { SPH_C32(0x2f570000), SPH_C32(0x5e7c0000), SPH_C32(0xf5cf0000),
    SPH_C32(0x90d76280), SPH_C32(0x9eb60ca5), SPH_C32(0xcfce0efe),
    SPH_C32(0xc49430c5), SPH_C32(0xea57448f), SPH_C32(0x293a0000),
    SPH_C32(0xebc80000), SPH_C32(0x948c0000), SPH_C32(0x96c4f440),
    SPH_C32(0xf6195cef), SPH_C32(0xf9753b00), SPH_C32(0x75e18a38),
    SPH_C32(0xb6741342) },
  { SPH_C32(0x39ba0000), SPH_C32(0x4b140000), SPH_C32(0x18180000),
    SPH_C32(0xa28a60a0), SPH_C32(0x7dba3a2c), SPH_C32(0x9584e8bd),
    SPH_C32(0x27e1c86d), SPH_C32(0x6baabd87), SPH_C32(0xcf120000),
    SPH_C32(0xa7830000), SPH_C32(0x3cd90000), SPH_C32(0x4514f6a0),
    SPH_C32(0x2e786c57), SPH_C32(0x61d28bda), SPH_C32(0x5d748c8c),
    SPH_C32(0x612e5bd5) },
  { SPH_C32(0xdf920000), SPH_C32(0x075f0000), SPH_C32(0xb04d0000),
    SPH_C32(0x715a6240), SPH_C32(0xa5db0a94), SPH_C32(0x0d235867),
    SPH_C32(0x0f74ced9), SPH_C32(0xbcf0f510), SPH_C32(0x3fd70000),
    SPH_C32(0xfea00000), SPH_C32(0x795b0000), SPH_C32(0xa499f660),
    SPH_C32(0x15156a66), SPH_C32(0xa33fdd43), SPH_C32(0x96947290),
    SPH_C32(0x3789ea4a) },
  { SPH_C32(0x7d4e0000), SPH_C32(0x65040000), SPH_C32(0xecc70000),
    SPH_C32(0x3cd76480), SPH_C32(0x3e755d25), SPH_C32(0x867f7d79),
    SPH_C32(0x3e57e2f8), SPH_C32(0x736278c6), SPH_C32(0x3af90000),
    SPH_C32(0x0f2a0000), SPH_C32(0x561d0000), SPH_C32(0xc8bbf4e0),
    SPH_C32(0xe3ce50c4), SPH_C32(0xb62d5ac8), SPH_C32(0xcdc4df22),
    SPH_C32(0xbb05b7e4) },
  { SPH_C32(0x9b660000), SPH_C32(0x294f0000), SPH_C32(0x44920000),
    SPH_C32(0xef076660), SPH_C32(0xe6146d9d), SPH_C32(0x1ed8cda3),
    SPH_C32(0x16c2e44c), SPH_C32(0xa4383051), SPH_C32(0xca3c0000),
    SPH_C32(0x56090000), SPH_C32(0x139f0000), SPH_C32(0x2936f420),
    SPH_C32(0xd8a356f5), SPH_C32(0x74c00c51), SPH_C32(0x0624213e),
    SPH_C32(0xeda2067b) },
  { SPH_C32(0x8d8b0000), SPH_C32(0x3c270000), SPH_C32(0xa9450000),
    SPH_C32(0xdd5a6440), SPH_C32(0x05185b14), SPH_C32(0x44922be0),
    SPH_C32(0xf5b71ce4), SPH_C32(0x25c5c959), SPH_C32(0x2c140000),
    SPH_C32(0x1a420000), SPH_C32(0xbbca0000), SPH_C32(0xfae6f6c0),
    SPH_C32(0x00c2664d), SPH_C32(0xec67bc8b), SPH_C32(0x2eb1278a),
    SPH_C32(0x3af84eec) },
  { SPH_C32(0x6ba30000), SPH_C32(0x706c0000), SPH_C32(0x01100000),
    SPH_C32(0x0e8a66a0), SPH_C32(0xdd796bac), SPH_C32(0xdc359b3a),
    SPH_C32(0xdd221a50), SPH_C32(0xf29f81ce), SPH_C32(0xdcd10000),
    SPH_C32(0x43610000), SPH_C32(0xfe480000), SPH_C32(0x1b6bf600),
    SPH_C32(0x3baf607c), SPH_C32(0x2e8aea12), SPH_C32(0xe551d996),
    SPH_C32(0x6c5fff73) },
  { SPH_C32(0x8c3a0000), SPH_C32(0xda980000), SPH_C32(0x607f0000),
    SPH_C32(0x54078800), SPH_C32(0x85714513), SPH_C32(0x6006b243),
    SPH_C32(0xdb50399c), SPH_C32(0x8a58e6a4), SPH_C32(0x1e6c0000),
    SPH_C32(0xc4420000), SPH_C32(0x8a2e0000), SPH_C32(0xbcb6b800),
    SPH_C32(0x2c4413b6), SPH_C32(0x8bfdd3da), SPH_C32(0x6a0c1bc8),
    SPH_C32(0xb99dc2eb) },
  { SPH_C32(0x6a120000), SPH_C32(0x96d30000), SPH_C32(0xc82a0000),
    SPH_C32(0x87d78ae0), SPH_C32(0x5d1075ab), SPH_C32(0xf8a10299),
    SPH_C32(0xf3c53f28), SPH_C32(0x5d02ae33), SPH_C32(0xeea90000),
    SPH_C32(0x9d610000), SPH_C32(0xcfac0000), SPH_C32(0x5d3bb8c0),
    SPH_C32(0x17291587), SPH_C32(0x49108543), SPH_C32(0xa1ece5d4),
    SPH_C32(0xef3a7374) },
  { SPH_C32(0x7cff0000), SPH_C32(0x83bb0000), SPH_C32(0x25fd0000),
    SPH_C32(0xb58a88c0), SPH_C32(0xbe1c4322), SPH_C32(0xa2ebe4da),
    SPH_C32(0x10b0c780), SPH_C32(0xdcff573b), SPH_C32(0x08810000),
    SPH_C32(0xd12a0000), SPH_C32(0x67f90000), SPH_C32(0x8eebba20),
    SPH_C32(0xcf48253f), SPH_C32(0xd1b73599), SPH_C32(0x8979e360),
    SPH_C32(0x38603be3) },
  { SPH_C32(0x9ad70000), SPH_C32(0xcff00000), SPH_C32(0x8da80000),
    SPH_C32(0x665a8a20), SPH_C32(0x667d739a), SPH_C32(0x3a4c5400),
    SPH_C32(0x3825c134), SPH_C32(0x0ba51fac), SPH_C32(0xf8440000),
    SPH_C32(0x88090000), SPH_C32(0x227b0000), SPH_C32(0x6f66bae0),
    SPH_C32(0xf425230e), SPH_C32(0x135a6300), SPH_C32(0x42991d7c),
    SPH_C32(0x6ec78a7c) },
  { SPH_C32(0x380b0000), SPH_C32(0xadab0000), SPH_C32(0xd1220000),
    SPH_C32(0x2bd78ce0), SPH_C32(0xfdd3242b), SPH_C32(0xb110711e),
    SPH_C32(0x0906ed15), SPH_C32(0xc437927a), SPH_C32(0xfd6a0000),
    SPH_C32(0x79830000), SPH_C32(0x0d3d0000), SPH_C32(0x0344b860),
    SPH_C32(0x02fe19ac), SPH_C32(0x0648e48b), SPH_C32(0x19c9b0ce),
    SPH_C32(0xe24bd7d2) },
  { SPH_C32(0xde230000), SPH_C32(0xe1e00000), SPH_C32(0x79770000),
    SPH_C32(0xf8078e00), SPH_C32(0x25b21493), SPH_C32(0x29b7c1c4),
    SPH_C32(0x2193eba1), SPH_C32(0x136ddaed), SPH_C32(0x0daf0000),
    SPH_C32(0x20a00000), SPH_C32(0x48bf0000), SPH_C32(0xe2c9b8a0),
    SPH_C32(0x39931f9d), SPH_C32(0xc4a5b212), SPH_C32(0xd2294ed2),
    SPH_C32(0xb4ec664d) },
  { SPH_C32(0xc8ce0000), SPH_C32(0xf4880000), SPH_C32(0x94a00000),
    SPH_C32(0xca5a8c20), SPH_C32(0xc6be221a), SPH_C32(0x73fd2787),
    SPH_C32(0xc2e61309), SPH_C32(0x929023e5), SPH_C32(0xeb870000),
    SPH_C32(0x6ceb0000), SPH_C32(0xe0ea0000), SPH_C32(0x3119ba40),
    SPH_C32(0xe1f22f25), SPH_C32(0x5c0202c8), SPH_C32(0xfabc4866),
    SPH_C32(0x63b62eda) },
  { SPH_C32(0x2ee60000), SPH_C32(0xb8c30000), SPH_C32(0x3cf50000),
    SPH_C32(0x198a8ec0), SPH_C32(0x1edf12a2), SPH_C32(0xeb5a975d),
    SPH_C32(0xea7315bd), SPH_C32(0x45ca6b72), SPH_C32(0x1b420000),
    SPH_C32(0x35c80000), SPH_C32(0xa5680000), SPH_C32(0xd094ba80),
    SPH_C32(0xda9f2914), SPH_C32(0x9eef5451), SPH_C32(0x315cb67a),
    SPH_C32(0x35119f45) },
  { SPH_C32(0x6f3c0000), SPH_C32(0x67590000), SPH_C32(0xe76c0000),
    SPH_C32(0xebf58860), SPH_C32(0xabcb4f09), SPH_C32(0xedb38512),
    SPH_C32(0xa895929a), SPH_C32(0xd18ef39d), SPH_C32(0x495b0000),
    SPH_C32(0x0eb00000), SPH_C32(0xbc600000), SPH_C32(0x7c94bc80),
    SPH_C32(0x7a5c7894), SPH_C32(0xd75e27d6), SPH_C32(0xcb9f6447),
    SPH_C32(0xac24a30c) },
  { SPH_C32(0x89140000), SPH_C32(0x2b120000), SPH_C32(0x4f390000),
    SPH_C32(0x38258a80), SPH_C32(0x73aa7fb1), SPH_C32(0x751435c8),
    SPH_C32(0x8000942e), SPH_C32(0x06d4bb0a), SPH_C32(0xb99e0000),
    SPH_C32(0x57930000), SPH_C32(0xf9e20000), SPH_C32(0x9d19bc40),
    SPH_C32(0x41317ea5), SPH_C32(0x15b3714f), SPH_C32(0x007f9a5b),
    SPH_C32(0xfa831293) },
  { SPH_C32(0x9ff90000), SPH_C32(0x3e7a0000), SPH_C32(0xa2ee0000),
    SPH_C32(0x0a7888a0), SPH_C32(0x90a64938), SPH_C32(0x2f5ed38b),
    SPH_C32(0x63756c86), SPH_C32(0x87294202), SPH_C32(0x5fb60000),
    SPH_C32(0x1bd80000), SPH_C32(0x51b70000), SPH_C32(0x4ec9bea0),
    SPH_C32(0x99504e1d), SPH_C32(0x8d14c195), SPH_C32(0x28ea9cef),
    SPH_C32(0x2dd95a04) },
  { SPH_C32(0x79d10000), SPH_C32(0x72310000), SPH_C32(0x0abb0000),
    SPH_C32(0xd9a88a40), SPH_C32(0x48c77980), SPH_C32(0xb7f96351),
    SPH_C32(0x4be06a32), SPH_C32(0x50730a95), SPH_C32(0xaf730000),
    SPH_C32(0x42fb0000), SPH_C32(0x14350000), SPH_C32(0xaf44be60),
    SPH_C32(0xa23d482c), SPH_C32(0x4ff9970c), SPH_C32(0xe30a62f3),
    SPH_C32(0x7b7eeb9b) },
  { SPH_C32(0xdb0d0000), SPH_C32(0x106a0000), SPH_C32(0x56310000),
    SPH_C32(0x94258c80), SPH_C32(0xd3692e31), SPH_C32(0x3ca5464f),
    SPH_C32(0x7ac34613), SPH_C32(0x9fe18743), SPH_C32(0xaa5d0000),
    SPH_C32(0xb3710000), SPH_C32(0x3b730000), SPH_C32(0xc366bce0),
    SPH_C32(0x54e6728e), SPH_C32(0x5aeb1087), SPH_C32(0xb85acf41),
    SPH_C32(0xf7f2b635) },
  { SPH_C32(0x3d250000), SPH_C32(0x5c210000), SPH_C32(0xfe640000),
    SPH_C32(0x47f58e60), SPH_C32(0x0b081e89), SPH_C32(0xa402f695),
    SPH_C32(0x525640a7), SPH_C32(0x48bbcfd4), SPH_C32(0x5a980000),
    SPH_C32(0xea520000), SPH_C32(0x7ef10000), SPH_C32(0x22ebbc20),
    SPH_C32(0x6f8b74bf), SPH_C32(0x9806461e), SPH_C32(0x73ba315d),
    SPH_C32(0xa15507aa) },
  { SPH_C32(0x2bc80000), SPH_C32(0x49490000), SPH_C32(0x13b30000),
    SPH_C32(0x75a88c40), SPH_C32(0xe8042800), SPH_C32(0xfe4810d6),
    SPH_C32(0xb123b80f), SPH_C32(0xc94636dc), SPH_C32(0xbcb00000),
    SPH_C32(0xa6190000), SPH_C32(0xd6a40000), SPH_C32(0xf13bbec0),
    SPH_C32(0xb7ea4407), SPH_C32(0x00a1f6c4), SPH_C32(0x5b2f37e9),
    SPH_C32(0x760f4f3d) },
  { SPH_C32(0xcde00000), SPH_C32(0x05020000), SPH_C32(0xbbe60000),
    SPH_C32(0xa6788ea0), SPH_C32(0x306518b8), SPH_C32(0x66efa00c),
    SPH_C32(0x99b6bebb), SPH_C32(0x1e1c7e4b), SPH_C32(0x4c750000),
    SPH_C32(0xff3a0000), SPH_C32(0x93260000), SPH_C32(0x10b6be00),
    SPH_C32(0x8c874236), SPH_C32(0xc24ca05d), SPH_C32(0x90cfc9f5),
    SPH_C32(0x20a8fea2) },
  { SPH_C32(0x8ec80000), SPH_C32(0x78190000), SPH_C32(0xe7400000),
    SPH_C32(0xb76bf000), SPH_C32(0x9b6c31fc), SPH_C32(0x673b9995),
    SPH_C32(0x1f920bab), SPH_C32(0xf56ac33a), SPH_C32(0xa4b10000),
    SPH_C32(0xd7ef0000), SPH_C32(0x3dc90000), SPH_C32(0x4b9e9000),
    SPH_C32(0xf30107fb), SPH_C32(0xbde710e0), SPH_C32(0x805696dc),
    SPH_C32(0x93b1da1b) },
  { SPH_C32(0x68e00000), SPH_C32(0x34520000), SPH_C32(0x4f150000),
    SPH_C32(0x64bbf2e0), SPH_C32(0x430d0144), SPH_C32(0xff9c294f),
    SPH_C32(0x37070d1f), SPH_C32(0x22308bad), SPH_C32(0x54740000),
    SPH_C32(0x8ecc0000), SPH_C32(0x784b0000), SPH_C32(0xaa1390c0),
    SPH_C32(0xc86c01ca), SPH_C32(0x7f0a4679), SPH_C32(0x4bb668c0),
    SPH_C32(0xc5166b84) },
  { SPH_C32(0x7e0d0000), SPH_C32(0x213a0000), SPH_C32(0xa2c20000),
    SPH_C32(0x56e6f0c0), SPH_C32(0xa00137cd), SPH_C32(0xa5d6cf0c),
    SPH_C32(0xd472f5b7), SPH_C32(0xa3cd72a5), SPH_C32(0xb25c0000),
    SPH_C32(0xc2870000), SPH_C32(0xd01e0000), SPH_C32(0x79c39220),
    SPH_C32(0x100d3172), SPH_C32(0xe7adf6a3), SPH_C32(0x63236e74),
    SPH_C32(0x124c2313) },
  { SPH_C32(0x98250000), SPH_C32(0x6d710000), SPH_C32(0x0a970000),
    SPH_C32(0x8536f220), SPH_C32(0x78600775), SPH_C32(0x3d717fd6),
    SPH_C32(0xfce7f303), SPH_C32(0x74973a32), SPH_C32(0x42990000),
    SPH_C32(0x9ba40000), SPH_C32(0x959c0000), SPH_C32(0x984e92e0),
    SPH_C32(0x2b603743), SPH_C32(0x2540a03a), SPH_C32(0xa8c39068),
    SPH_C32(0x44eb928c) },
  { SPH_C32(0x3af90000), SPH_C32(0x0f2a0000), SPH_C32(0x561d0000),
    SPH_C32(0xc8bbf4e0), SPH_C32(0xe3ce50c4), SPH_C32(0xb62d5ac8),
    SPH_C32(0xcdc4df22), SPH_C32(0xbb05b7e4), SPH_C32(0x47b70000),
    SPH_C32(0x6a2e0000), SPH_C32(0xbada0000), SPH_C32(0xf46c9060),
    SPH_C32(0xddbb0de1), SPH_C32(0x305227b1), SPH_C32(0xf3933dda),
    SPH_C32(0xc867cf22) },
  { SPH_C32(0xdcd10000), SPH_C32(0x43610000), SPH_C32(0xfe480000),
    SPH_C32(0x1b6bf600), SPH_C32(0x3baf607c), SPH_C32(0x2e8aea12),
    SPH_C32(0xe551d996), SPH_C32(0x6c5fff73), SPH_C32(0xb7720000),
    SPH_C32(0x330d0000), SPH_C32(0xff580000), SPH_C32(0x15e190a0),
    SPH_C32(0xe6d60bd0), SPH_C32(0xf2bf7128), SPH_C32(0x3873c3c6),
    SPH_C32(0x9ec07ebd) },
  { SPH_C32(0xca3c0000), SPH_C32(0x56090000), SPH_C32(0x139f0000),
    SPH_C32(0x2936f420), SPH_C32(0xd8a356f5), SPH_C32(0x74c00c51),
    SPH_C32(0x0624213e), SPH_C32(0xeda2067b), SPH_C32(0x515a0000),
    SPH_C32(0x7f460000), SPH_C32(0x570d0000), SPH_C32(0xc6319240),
    SPH_C32(0x3eb73b68), SPH_C32(0x6a18c1f2), SPH_C32(0x10e6c572),
    SPH_C32(0x499a362a) },
  { SPH_C32(0x2c140000), SPH_C32(0x1a420000), SPH_C32(0xbbca0000),
    SPH_C32(0xfae6f6c0), SPH_C32(0x00c2664d), SPH_C32(0xec67bc8b),
    SPH_C32(0x2eb1278a), SPH_C32(0x3af84eec), SPH_C32(0xa19f0000),
    SPH_C32(0x26650000), SPH_C32(0x128f0000), SPH_C32(0x27bc9280),
    SPH_C32(0x05da3d59), SPH_C32(0xa8f5976b), SPH_C32(0xdb063b6e),
    SPH_C32(0x1f3d87b5) },
  { SPH_C32(0x6dce0000), SPH_C32(0xc5d80000), SPH_C32(0x60530000),
    SPH_C32(0x0899f060), SPH_C32(0xb5d63be6), SPH_C32(0xea8eaec4),
    SPH_C32(0x6c57a0ad), SPH_C32(0xaebcd603), SPH_C32(0xf3860000),
    SPH_C32(0x1d1d0000), SPH_C32(0x0b870000), SPH_C32(0x8bbc9480),
    SPH_C32(0xa5196cd9), SPH_C32(0xe144e4ec), SPH_C32(0x21c5e953),
    SPH_C32(0x8608bbfc) },
  { SPH_C32(0x8be60000), SPH_C32(0x89930000), SPH_C32(0xc8060000),
    SPH_C32(0xdb49f280), SPH_C32(0x6db70b5e), SPH_C32(0x72291e1e),
    SPH_C32(0x44c2a619), SPH_C32(0x79e69e94), SPH_C32(0x03430000),
    SPH_C32(0x443e0000), SPH_C32(0x4e050000), SPH_C32(0x6a319440),
    SPH_C32(0x9e746ae8), SPH_C32(0x23a9b275), SPH_C32(0xea25174f),
    SPH_C32(0xd0af0a63) },
  { SPH_C32(0x9d0b0000), SPH_C32(0x9cfb0000), SPH_C32(0x25d10000),
    SPH_C32(0xe914f0a0), SPH_C32(0x8ebb3dd7), SPH_C32(0x2863f85d),
    SPH_C32(0xa7b75eb1), SPH_C32(0xf81b679c), SPH_C32(0xe56b0000),
    SPH_C32(0x08750000), SPH_C32(0xe6500000), SPH_C32(0xb9e196a0),
    SPH_C32(0x46155a50), SPH_C32(0xbb0e02af), SPH_C32(0xc2b011fb),
    SPH_C32(0x07f542f4) },
  { SPH_C32(0x7b230000), SPH_C32(0xd0b00000), SPH_C32(0x8d840000),
    SPH_C32(0x3ac4f240), SPH_C32(0x56da0d6f), SPH_C32(0xb0c44887),
    SPH_C32(0x8f225805), SPH_C32(0x2f412f0b), SPH_C32(0x15ae0000),
    SPH_C32(0x51560000), SPH_C32(0xa3d20000), SPH_C32(0x586c9660),
    SPH_C32(0x7d785c61), SPH_C32(0x79e35436), SPH_C32(0x0950efe7),
    SPH_C32(0x5152f36b) },
  { SPH_C32(0xd9ff0000), SPH_C32(0xb2eb0000), SPH_C32(0xd10e0000),
    SPH_C32(0x7749f480), SPH_C32(0xcd745ade), SPH_C32(0x3b986d99),
    SPH_C32(0xbe017424), SPH_C32(0xe0d3a2dd), SPH_C32(0x10800000),
    SPH_C32(0xa0dc0000), SPH_C32(0x8c940000), SPH_C32(0x344e94e0),
    SPH_C32(0x8ba366c3), SPH_C32(0x6cf1d3bd), SPH_C32(0x52004255),
    SPH_C32(0xdddeaec5) },
  { SPH_C32(0x3fd70000), SPH_C32(0xfea00000), SPH_C32(0x795b0000),
    SPH_C32(0xa499f660), SPH_C32(0x15156a66), SPH_C32(0xa33fdd43),
    SPH_C32(0x96947290), SPH_C32(0x3789ea4a), SPH_C32(0xe0450000),
    SPH_C32(0xf9ff0000), SPH_C32(0xc9160000), SPH_C32(0xd5c39420),
    SPH_C32(0xb0ce60f2), SPH_C32(0xae1c8524), SPH_C32(0x99e0bc49),
    SPH_C32(0x8b791f5a) },
  { SPH_C32(0x293a0000), SPH_C32(0xebc80000), SPH_C32(0x948c0000),
    SPH_C32(0x96c4f440), SPH_C32(0xf6195cef), SPH_C32(0xf9753b00),
    SPH_C32(0x75e18a38), SPH_C32(0xb6741342), SPH_C32(0x066d0000),
    SPH_C32(0xb5b40000), SPH_C32(0x61430000), SPH_C32(0x061396c0),
    SPH_C32(0x68af504a), SPH_C32(0x36bb35fe), SPH_C32(0xb175bafd),
    SPH_C32(0x5c2357cd) },
  { SPH_C32(0xcf120000), SPH_C32(0xa7830000), SPH_C32(0x3cd90000),
    SPH_C32(0x4514f6a0), SPH_C32(0x2e786c57), SPH_C32(0x61d28bda),
    SPH_C32(0x5d748c8c), SPH_C32(0x612e5bd5), SPH_C32(0xf6a80000),
    SPH_C32(0xec970000), SPH_C32(0x24c10000), SPH_C32(0xe79e9600),
    SPH_C32(0x53c2567b), SPH_C32(0xf4566367), SPH_C32(0x7a9544e1),
    SPH_C32(0x0a84e652) },
  { SPH_C32(0x36e70000), SPH_C32(0xc9350000), SPH_C32(0xd7980000),
    SPH_C32(0xa32fa000), SPH_C32(0x5a34515e), SPH_C32(0x561c7179),
    SPH_C32(0x310ab488), SPH_C32(0xa074fe54), SPH_C32(0xa6430000),
    SPH_C32(0x756e0000), SPH_C32(0xbaf60000), SPH_C32(0xa8f2e800),
    SPH_C32(0xed1c7314), SPH_C32(0xbada3b36), SPH_C32(0x4494a4eb),
    SPH_C32(0xec83ff85) },
  { SPH_C32(0xd0cf0000), SPH_C32(0x857e0000), SPH_C32(0x7fcd0000),
    SPH_C32(0x70ffa2e0), SPH_C32(0x825561e6), SPH_C32(0xcebbc1a3),
    SPH_C32(0x199fb23c), SPH_C32(0x772eb6c3), SPH_C32(0x56860000),
    SPH_C32(0x2c4d0000), SPH_C32(0xff740000), SPH_C32(0x497fe8c0),
    SPH_C32(0xd6717525), SPH_C32(0x78376daf), SPH_C32(0x8f745af7),
    SPH_C32(0xba244e1a) },
  { SPH_C32(0xc6220000), SPH_C32(0x90160000), SPH_C32(0x921a0000),
    SPH_C32(0x42a2a0c0), SPH_C32(0x6159576f), SPH_C32(0x94f127e0),
    SPH_C32(0xfaea4a94), SPH_C32(0xf6d34fcb), SPH_C32(0xb0ae0000),
    SPH_C32(0x60060000), SPH_C32(0x57210000), SPH_C32(0x9aafea20),
    SPH_C32(0x0e10459d), SPH_C32(0xe090dd75), SPH_C32(0xa7e15c43),
    SPH_C32(0x6d7e068d) },
  { SPH_C32(0x200a0000), SPH_C32(0xdc5d0000), SPH_C32(0x3a4f0000),
    SPH_C32(0x9172a220), SPH_C32(0xb93867d7), SPH_C32(0x0c56973a),
    SPH_C32(0xd27f4c20), SPH_C32(0x2189075c), SPH_C32(0x406b0000),
    SPH_C32(0x39250000), SPH_C32(0x12a30000), SPH_C32(0x7b22eae0),
    SPH_C32(0x357d43ac), SPH_C32(0x227d8bec), SPH_C32(0x6c01a25f),
    SPH_C32(0x3bd9b712) },
  { SPH_C32(0x82d60000), SPH_C32(0xbe060000), SPH_C32(0x66c50000),
    SPH_C32(0xdcffa4e0), SPH_C32(0x22963066), SPH_C32(0x870ab224),
    SPH_C32(0xe35c6001), SPH_C32(0xee1b8a8a), SPH_C32(0x45450000),
    SPH_C32(0xc8af0000), SPH_C32(0x3de50000), SPH_C32(0x1700e860),
    SPH_C32(0xc3a6790e), SPH_C32(0x376f0c67), SPH_C32(0x37510fed),
    SPH_C32(0xb755eabc) },
  { SPH_C32(0x64fe0000), SPH_C32(0xf24d0000), SPH_C32(0xce900000),
    SPH_C32(0x0f2fa600), SPH_C32(0xfaf700de), SPH_C32(0x1fad02fe),
    SPH_C32(0xcbc966b5), SPH_C32(0x3941c21d), SPH_C32(0xb5800000),
    SPH_C32(0x918c0000), SPH_C32(0x78670000), SPH_C32(0xf68de8a0),
    SPH_C32(0xf8cb7f3f), SPH_C32(0xf5825afe), SPH_C32(0xfcb1f1f1),
    SPH_C32(0xe1f25b23) },
  { SPH_C32(0x72130000), SPH_C32(0xe7250000), SPH_C32(0x23470000),
    SPH_C32(0x3d72a420), SPH_C32(0x19fb3657), SPH_C32(0x45e7e4bd),
    SPH_C32(0x28bc9e1d), SPH_C32(0xb8bc3b15), SPH_C32(0x53a80000),
    SPH_C32(0xddc70000), SPH_C32(0xd0320000), SPH_C32(0x255dea40),
    SPH_C32(0x20aa4f87), SPH_C32(0x6d25ea24), SPH_C32(0xd424f745),
    SPH_C32(0x36a813b4) },
  { SPH_C32(0x943b0000), SPH_C32(0xab6e0000), SPH_C32(0x8b120000),
    SPH_C32(0xeea2a6c0), SPH_C32(0xc19a06ef), SPH_C32(0xdd405467),
    SPH_C32(0x002998a9), SPH_C32(0x6fe67382), SPH_C32(0xa36d0000),
    SPH_C32(0x84e40000), SPH_C32(0x95b00000), SPH_C32(0xc4d0ea80),
    SPH_C32(0x1bc749b6), SPH_C32(0xafc8bcbd), SPH_C32(0x1fc40959),
    SPH_C32(0x600fa22b) },
  { SPH_C32(0xd5e10000), SPH_C32(0x74f40000), SPH_C32(0x508b0000),
    SPH_C32(0x1cdda060), SPH_C32(0x748e5b44), SPH_C32(0xdba94628),
    SPH_C32(0x42cf1f8e), SPH_C32(0xfba2eb6d), SPH_C32(0xf1740000),
    SPH_C32(0xbf9c0000), SPH_C32(0x8cb80000), SPH_C32(0x68d0ec80),
    SPH_C32(0xbb041836), SPH_C32(0xe679cf3a), SPH_C32(0xe507db64),
    SPH_C32(0xf93a9e62) },
  { SPH_C32(0x33c90000), SPH_C32(0x38bf0000), SPH_C32(0xf8de0000),
    SPH_C32(0xcf0da280), SPH_C32(0xacef6bfc), SPH_C32(0x430ef6f2),
    SPH_C32(0x6a5a193a), SPH_C32(0x2cf8a3fa), SPH_C32(0x01b10000),
    SPH_C32(0xe6bf0000), SPH_C32(0xc93a0000), SPH_C32(0x895dec40),
    SPH_C32(0x80691e07), SPH_C32(0x249499a3), SPH_C32(0x2ee72578),
    SPH_C32(0xaf9d2ffd) },
  { SPH_C32(0x25240000), SPH_C32(0x2dd70000), SPH_C32(0x15090000),
    SPH_C32(0xfd50a0a0), SPH_C32(0x4fe35d75), SPH_C32(0x194410b1),
    SPH_C32(0x892fe192), SPH_C32(0xad055af2), SPH_C32(0xe7990000),
    SPH_C32(0xaaf40000), SPH_C32(0x616f0000), SPH_C32(0x5a8deea0),
    SPH_C32(0x58082ebf), SPH_C32(0xbc332979), SPH_C32(0x067223cc),
    SPH_C32(0x78c7676a) },
  { SPH_C32(0xc30c0000), SPH_C32(0x619c0000), SPH_C32(0xbd5c0000),
    SPH_C32(0x2e80a240), SPH_C32(0x97826dcd), SPH_C32(0x81e3a06b),
    SPH_C32(0xa1bae726), SPH_C32(0x7a5f1265), SPH_C32(0x175c0000),
    SPH_C32(0xf3d70000), SPH_C32(0x24ed0000), SPH_C32(0xbb00ee60),
    SPH_C32(0x6365288e), SPH_C32(0x7ede7fe0), SPH_C32(0xcd92ddd0),
    SPH_C32(0x2e60d6f5) },
  { SPH_C32(0x61d00000), SPH_C32(0x03c70000), SPH_C32(0xe1d60000),
    SPH_C32(0x630da480), SPH_C32(0x0c2c3a7c), SPH_C32(0x0abf8575),
    SPH_C32(0x9099cb07), SPH_C32(0xb5cd9fb3), SPH_C32(0x12720000),
    SPH_C32(0x025d0000), SPH_C32(0x0bab0000), SPH_C32(0xd722ece0),
    SPH_C32(0x95be122c), SPH_C32(0x6bccf86b), SPH_C32(0x96c27062),
    SPH_C32(0xa2ec8b5b) },
  { SPH_C32(0x87f80000), SPH_C32(0x4f8c0000), SPH_C32(0x49830000),
    SPH_C32(0xb0dda660), SPH_C32(0xd44d0ac4), SPH_C32(0x921835af),
    SPH_C32(0xb80ccdb3), SPH_C32(0x6297d724), SPH_C32(0xe2b70000),
    SPH_C32(0x5b7e0000), SPH_C32(0x4e290000), SPH_C32(0x36afec20),
    SPH_C32(0xaed3141d), SPH_C32(0xa921aef2), SPH_C32(0x5d228e7e),
    SPH_C32(0xf44b3ac4) },
  { SPH_C32(0x91150000), SPH_C32(0x5ae40000), SPH_C32(0xa4540000),
    SPH_C32(0x8280a440), SPH_C32(0x37413c4d), SPH_C32(0xc852d3ec),
    SPH_C32(0x5b79351b), SPH_C32(0xe36a2e2c), SPH_C32(0x049f0000),
    SPH_C32(0x17350000), SPH_C32(0xe67c0000), SPH_C32(0xe57feec0),
    SPH_C32(0x76b224a5), SPH_C32(0x31861e28), SPH_C32(0x75b788ca),
    SPH_C32(0x23117253) },
  { SPH_C32(0x773d0000), SPH_C32(0x16af0000), SPH_C32(0x0c010000),
    SPH_C32(0x5150a6a0), SPH_C32(0xef200cf5), SPH_C32(0x50f56336),
    SPH_C32(0x73ec33af), SPH_C32(0x343066bb), SPH_C32(0xf45a0000),
    SPH_C32(0x4e160000), SPH_C32(0xa3fe0000), SPH_C32(0x04f2ee00),
    SPH_C32(0x4ddf2294), SPH_C32(0xf36b48b1), SPH_C32(0xbe5776d6),
    SPH_C32(0x75b6c3cc) },
  { SPH_C32(0x34150000), SPH_C32(0x6bb40000), SPH_C32(0x50a70000),
    SPH_C32(0x4043d800), SPH_C32(0x442925b1), SPH_C32(0x51215aaf),
    SPH_C32(0xf5c886bf), SPH_C32(0xdf46dbca), SPH_C32(0x1c9e0000),
    SPH_C32(0x66c30000), SPH_C32(0x0d110000), SPH_C32(0x5fdac000),
    SPH_C32(0x32596759), SPH_C32(0x8cc0f80c), SPH_C32(0xaece29ff),
    SPH_C32(0xc6afe775) },
  { SPH_C32(0xd23d0000), SPH_C32(0x27ff0000), SPH_C32(0xf8f20000),
    SPH_C32(0x9393dae0), SPH_C32(0x9c481509), SPH_C32(0xc986ea75),
    SPH_C32(0xdd5d800b), SPH_C32(0x081c935d), SPH_C32(0xec5b0000),
    SPH_C32(0x3fe00000), SPH_C32(0x48930000), SPH_C32(0xbe57c0c0),
    SPH_C32(0x09346168), SPH_C32(0x4e2dae95), SPH_C32(0x652ed7e3),
    SPH_C32(0x900856ea) },
  { SPH_C32(0xc4d00000), SPH_C32(0x32970000), SPH_C32(0x15250000),
    SPH_C32(0xa1ced8c0), SPH_C32(0x7f442380), SPH_C32(0x93cc0c36),
    SPH_C32(0x3e2878a3), SPH_C32(0x89e16a55), SPH_C32(0x0a730000),
    SPH_C32(0x73ab0000), SPH_C32(0xe0c60000), SPH_C32(0x6d87c220),
    SPH_C32(0xd15551d0), SPH_C32(0xd68a1e4f), SPH_C32(0x4dbbd157),
    SPH_C32(0x47521e7d) },
  { SPH_C32(0x22f80000), SPH_C32(0x7edc0000), SPH_C32(0xbd700000),
    SPH_C32(0x721eda20), SPH_C32(0xa7251338), SPH_C32(0x0b6bbcec),
    SPH_C32(0x16bd7e17), SPH_C32(0x5ebb22c2), SPH_C32(0xfab60000),
    SPH_C32(0x2a880000), SPH_C32(0xa5440000), SPH_C32(0x8c0ac2e0),
    SPH_C32(0xea3857e1), SPH_C32(0x146748d6), SPH_C32(0x865b2f4b),
    SPH_C32(0x11f5afe2) },
  { SPH_C32(0x80240000), SPH_C32(0x1c870000), SPH_C32(0xe1fa0000),
    SPH_C32(0x3f93dce0), SPH_C32(0x3c8b4489), SPH_C32(0x803799f2),
    SPH_C32(0x279e5236), SPH_C32(0x9129af14), SPH_C32(0xff980000),
    SPH_C32(0xdb020000), SPH_C32(0x8a020000), SPH_C32(0xe028c060),
    SPH_C32(0x1ce36d43), SPH_C32(0x0175cf5d), SPH_C32(0xdd0b82f9),
    SPH_C32(0x9d79f24c) },
  { SPH_C32(0x660c0000), SPH_C32(0x50cc0000), SPH_C32(0x49af0000),
    SPH_C32(0xec43de00), SPH_C32(0xe4ea7431), SPH_C32(0x18902928),
    SPH_C32(0x0f0b5482), SPH_C32(0x4673e783), SPH_C32(0x0f5d0000),
    SPH_C32(0x82210000), SPH_C32(0xcf800000), SPH_C32(0x01a5c0a0),
    SPH_C32(0x278e6b72), SPH_C32(0xc39899c4), SPH_C32(0x16eb7ce5),
    SPH_C32(0xcbde43d3) },
  { SPH_C32(0x70e10000), SPH_C32(0x45a40000), SPH_C32(0xa4780000),
    SPH_C32(0xde1edc20), SPH_C32(0x07e642b8), SPH_C32(0x42dacf6b),
    SPH_C32(0xec7eac2a), SPH_C32(0xc78e1e8b), SPH_C32(0xe9750000),
    SPH_C32(0xce6a0000), SPH_C32(0x67d50000), SPH_C32(0xd275c240),
    SPH_C32(0xffef5bca), SPH_C32(0x5b3f291e), SPH_C32(0x3e7e7a51),
    SPH_C32(0x1c840b44) },
  { SPH_C32(0x96c90000), SPH_C32(0x09ef0000), SPH_C32(0x0c2d0000),
    SPH_C32(0x0dcedec0), SPH_C32(0xdf877200), SPH_C32(0xda7d7fb1),
    SPH_C32(0xc4ebaa9e), SPH_C32(0x10d4561c), SPH_C32(0x19b00000),
    SPH_C32(0x97490000), SPH_C32(0x22570000), SPH_C32(0x33f8c280),
    SPH_C32(0xc4825dfb), SPH_C32(0x99d27f87), SPH_C32(0xf59e844d),
    SPH_C32(0x4a23badb) },
  { SPH_C32(0xd7130000), SPH_C32(0xd6750000), SPH_C32(0xd7b40000),
    SPH_C32(0xffb1d860), SPH_C32(0x6a932fab), SPH_C32(0xdc946dfe),
    SPH_C32(0x860d2db9), SPH_C32(0x8490cef3), SPH_C32(0x4ba90000),
    SPH_C32(0xac310000), SPH_C32(0x3b5f0000), SPH_C32(0x9ff8c480),
    SPH_C32(0x64410c7b), SPH_C32(0xd0630c00), SPH_C32(0x0f5d5670),
    SPH_C32(0xd3168692) },
  { SPH_C32(0x313b0000), SPH_C32(0x9a3e0000), SPH_C32(0x7fe10000),
    SPH_C32(0x2c61da80), SPH_C32(0xb2f21f13), SPH_C32(0x4433dd24),
    SPH_C32(0xae982b0d), SPH_C32(0x53ca8664), SPH_C32(0xbb6c0000),
    SPH_C32(0xf5120000), SPH_C32(0x7edd0000), SPH_C32(0x7e75c440),
    SPH_C32(0x5f2c0a4a), SPH_C32(0x128e5a99), SPH_C32(0xc4bda86c),
    SPH_C32(0x85b1370d) },
  { SPH_C32(0x27d60000), SPH_C32(0x8f560000), SPH_C32(0x92360000),
    SPH_C32(0x1e3cd8a0), SPH_C32(0x51fe299a), SPH_C32(0x1e793b67),
    SPH_C32(0x4dedd3a5), SPH_C32(0xd2377f6c), SPH_C32(0x5d440000),
    SPH_C32(0xb9590000), SPH_C32(0xd6880000), SPH_C32(0xada5c6a0),
    SPH_C32(0x874d3af2), SPH_C32(0x8a29ea43), SPH_C32(0xec28aed8),
    SPH_C32(0x52eb7f9a) },
  { SPH_C32(0xc1fe0000), SPH_C32(0xc31d0000), SPH_C32(0x3a630000),
    SPH_C32(0xcdecda40), SPH_C32(0x899f1922), SPH_C32(0x86de8bbd),
    SPH_C32(0x6578d511), SPH_C32(0x056d37fb), SPH_C32(0xad810000),
    SPH_C32(0xe07a0000), SPH_C32(0x930a0000), SPH_C32(0x4c28c660),
    SPH_C32(0xbc203cc3), SPH_C32(0x48c4bcda), SPH_C32(0x27c850c4),
    SPH_C32(0x044cce05) },
  { SPH_C32(0x63220000), SPH_C32(0xa1460000), SPH_C32(0x66e90000),
    SPH_C32(0x8061dc80), SPH_C32(0x12314e93), SPH_C32(0x0d82aea3),
    SPH_C32(0x545bf930), SPH_C32(0xcaffba2d), SPH_C32(0xa8af0000),
    SPH_C32(0x11f00000), SPH_C32(0xbc4c0000), SPH_C32(0x200ac4e0),
    SPH_C32(0x4afb0661), SPH_C32(0x5dd63b51), SPH_C32(0x7c98fd76),
    SPH_C32(0x88c093ab) },
  { SPH_C32(0x850a0000), SPH_C32(0xed0d0000), SPH_C32(0xcebc0000),
    SPH_C32(0x53b1de60), SPH_C32(0xca507e2b), SPH_C32(0x95251e79),
    SPH_C32(0x7cceff84), SPH_C32(0x1da5f2ba), SPH_C32(0x586a0000),
    SPH_C32(0x48d30000), SPH_C32(0xf9ce0000), SPH_C32(0xc187c420),
    SPH_C32(0x71960050), SPH_C32(0x9f3b6dc8), SPH_C32(0xb778036a),
    SPH_C32(0xde672234) },
  { SPH_C32(0x93e70000), SPH_C32(0xf8650000), SPH_C32(0x236b0000),
    SPH_C32(0x61ecdc40), SPH_C32(0x295c48a2), SPH_C32(0xcf6ff83a),
    SPH_C32(0x9fbb072c), SPH_C32(0x9c580bb2), SPH_C32(0xbe420000),
    SPH_C32(0x04980000), SPH_C32(0x519b0000), SPH_C32(0x1257c6c0),
    SPH_C32(0xa9f730e8), SPH_C32(0x079cdd12), SPH_C32(0x9fed05de),
    SPH_C32(0x093d6aa3) },
  { SPH_C32(0x75cf0000), SPH_C32(0xb42e0000), SPH_C32(0x8b3e0000),
    SPH_C32(0xb23cdea0), SPH_C32(0xf13d781a), SPH_C32(0x57c848e0),
    SPH_C32(0xb72e0198), SPH_C32(0x4b024325), SPH_C32(0x4e870000),
    SPH_C32(0x5dbb0000), SPH_C32(0x14190000), SPH_C32(0xf3dac600),
    SPH_C32(0x929a36d9), SPH_C32(0xc5718b8b), SPH_C32(0x540dfbc2),
    SPH_C32(0x5f9adb3c) }
};

__constant static const sph_u32 T512_56[256][16] = {
  { SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000), SPH_C32(0x00000000), SPH_C32(0x00000000),
    SPH_C32(0x00000000) },
  { SPH_C32(0x033d0000), SPH_C32(0x08b30000), SPH_C32(0xf33a0000),
    SPH_C32(0x3ac20007), SPH_C32(0x51298a50), SPH_C32(0x6b6e661f),
    SPH_C32(0x0ea5cfe3), SPH_C32(0xe6da7ffe), SPH_C32(0xa8da0000),
    SPH_C32(0x96be0000), SPH_C32(0x5c1d0000), SPH_C32(0x07da0002),
    SPH_C32(0x7d669583), SPH_C32(0x1f98708a), SPH_C32(0xbb668808),
    SPH_C32(0xda878000) },
  { SPH_C32(0xa8da0000), SPH_C32(0x96be0000), SPH_C32(0x5c1d0000),
    SPH_C32(0x07da0002), SPH_C32(0x7d669583), SPH_C32(0x1f98708a),
    SPH_C32(0xbb668808), SPH_C32(0xda878000), SPH_C32(0xabe70000),
    SPH_C32(0x9e0d0000), SPH_C32(0xaf270000), SPH_C32(0x3d180005),
    SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695), SPH_C32(0xb5c347eb),
    SPH_C32(0x3c5dfffe) },
  { SPH_C32(0xabe70000), SPH_C32(0x9e0d0000), SPH_C32(0xaf270000),
    SPH_C32(0x3d180005), SPH_C32(0x2c4f1fd3), SPH_C32(0x74f61695),
    SPH_C32(0xb5c347eb), SPH_C32(0x3c5dfffe), SPH_C32(0x033d0000),
    SPH_C32(0x08b30000), SPH_C32(0xf33a0000), SPH_C32(0x3ac20007),
    SPH_C32(0x51298a50), SPH_C32(0x6b6e661f), SPH_C32(0x0ea5cfe3),
    SPH_C32(0xe6da7ffe) },
  { SPH_C32(0x01930000), SPH_C32(0xe7820000), SPH_C32(0xedfb0000),
    SPH_C32(0xcf0c000b), SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e),
    SPH_C32(0x063661e1), SPH_C32(0x536f9e7b), SPH_C32(0x92280000),
    SPH_C32(0xdc850000), SPH_C32(0x57fa0000), SPH_C32(0x56dc0003),
    SPH_C32(0xbae92316), SPH_C32(0x5aefa30c), SPH_C32(0x90cef752),
    SPH_C32(0x7b1675d7) },
  { SPH_C32(0x02ae0000), SPH_C32(0xef310000), SPH_C32(0x1ec10000),
    SPH_C32(0xf5ce000c), SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231),
    SPH_C32(0x0893ae02), SPH_C32(0xb5b5e185), SPH_C32(0x3af20000),
    SPH_C32(0x4a3b0000), SPH_C32(0x0be70000), SPH_C32(0x51060001),
    SPH_C32(0xc78fb695), SPH_C32(0x4577d386), SPH_C32(0x2ba87f5a),
    SPH_C32(0xa191f5d7) },
  { SPH_C32(0xa9490000), SPH_C32(0x713c0000), SPH_C32(0xb1e60000),
    SPH_C32(0xc8d60009), SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4),
    SPH_C32(0xbd50e9e9), SPH_C32(0x89e81e7b), SPH_C32(0x39cf0000),
    SPH_C32(0x42880000), SPH_C32(0xf8dd0000), SPH_C32(0x6bc40006),
    SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599), SPH_C32(0x250db0b9),
    SPH_C32(0x474b8a29) },
  { SPH_C32(0xaa740000), SPH_C32(0x798f0000), SPH_C32(0x42dc0000),
    SPH_C32(0xf214000e), SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb),
    SPH_C32(0xb3f5260a), SPH_C32(0x6f326185), SPH_C32(0x91150000),
    SPH_C32(0xd4360000), SPH_C32(0xa4c00000), SPH_C32(0x6c1e0004),
    SPH_C32(0xebc0a946), SPH_C32(0x3181c513), SPH_C32(0x9e6b38b1),
    SPH_C32(0x9dcc0a29) },
  { SPH_C32(0x92280000), SPH_C32(0xdc850000), SPH_C32(0x57fa0000),
    SPH_C32(0x56dc0003), SPH_C32(0xbae92316), SPH_C32(0x5aefa30c),
    SPH_C32(0x90cef752), SPH_C32(0x7b1675d7), SPH_C32(0x93bb0000),
    SPH_C32(0x3b070000), SPH_C32(0xba010000), SPH_C32(0x99d00008),
    SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722), SPH_C32(0x96f896b3),
    SPH_C32(0x2879ebac) },
  { SPH_C32(0x91150000), SPH_C32(0xd4360000), SPH_C32(0xa4c00000),
    SPH_C32(0x6c1e0004), SPH_C32(0xebc0a946), SPH_C32(0x3181c513),
    SPH_C32(0x9e6b38b1), SPH_C32(0x9dcc0a29), SPH_C32(0x3b610000),
    SPH_C32(0xadb90000), SPH_C32(0xe61c0000), SPH_C32(0x9e0a000a),
    SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8), SPH_C32(0x2d9e1ebb),
    SPH_C32(0xf2fe6bac) },
  { SPH_C32(0x3af20000), SPH_C32(0x4a3b0000), SPH_C32(0x0be70000),
    SPH_C32(0x51060001), SPH_C32(0xc78fb695), SPH_C32(0x4577d386),
    SPH_C32(0x2ba87f5a), SPH_C32(0xa191f5d7), SPH_C32(0x385c0000),
    SPH_C32(0xa50a0000), SPH_C32(0x15260000), SPH_C32(0xa4c8000d),
    SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7), SPH_C32(0x233bd158),
    SPH_C32(0x14241452) },
  { SPH_C32(0x39cf0000), SPH_C32(0x42880000), SPH_C32(0xf8dd0000),
    SPH_C32(0x6bc40006), SPH_C32(0x96a63cc5), SPH_C32(0x2e19b599),
    SPH_C32(0x250db0b9), SPH_C32(0x474b8a29), SPH_C32(0x90860000),
    SPH_C32(0x33b40000), SPH_C32(0x493b0000), SPH_C32(0xa312000f),
    SPH_C32(0x6610241e), SPH_C32(0x8d22713d), SPH_C32(0x985d5950),
    SPH_C32(0xcea39452) },
  { SPH_C32(0x93bb0000), SPH_C32(0x3b070000), SPH_C32(0xba010000),
    SPH_C32(0x99d00008), SPH_C32(0x3739ae4e), SPH_C32(0xe64c1722),
    SPH_C32(0x96f896b3), SPH_C32(0x2879ebac), SPH_C32(0x01930000),
    SPH_C32(0xe7820000), SPH_C32(0xedfb0000), SPH_C32(0xcf0c000b),
    SPH_C32(0x8dd08d58), SPH_C32(0xbca3b42e), SPH_C32(0x063661e1),
    SPH_C32(0x536f9e7b) },
  { SPH_C32(0x90860000), SPH_C32(0x33b40000), SPH_C32(0x493b0000),
    SPH_C32(0xa312000f), SPH_C32(0x6610241e), SPH_C32(0x8d22713d),
    SPH_C32(0x985d5950), SPH_C32(0xcea39452), SPH_C32(0xa9490000),
    SPH_C32(0x713c0000), SPH_C32(0xb1e60000), SPH_C32(0xc8d60009),
    SPH_C32(0xf0b618db), SPH_C32(0xa33bc4a4), SPH_C32(0xbd50e9e9),
    SPH_C32(0x89e81e7b) },
  { SPH_C32(0x3b610000), SPH_C32(0xadb90000), SPH_C32(0xe61c0000),
    SPH_C32(0x9e0a000a), SPH_C32(0x4a5f3bcd), SPH_C32(0xf9d467a8),
    SPH_C32(0x2d9e1ebb), SPH_C32(0xf2fe6bac), SPH_C32(0xaa740000),
    SPH_C32(0x798f0000), SPH_C32(0x42dc0000), SPH_C32(0xf214000e),
    SPH_C32(0xa19f928b), SPH_C32(0xc855a2bb), SPH_C32(0xb3f5260a),
    SPH_C32(0x6f326185) },
  { SPH_C32(0x385c0000), SPH_C32(0xa50a0000), SPH_C32(0x15260000),
    SPH_C32(0xa4c8000d), SPH_C32(0x1b76b19d), SPH_C32(0x92ba01b7),
    SPH_C32(0x233bd158), SPH_C32(0x14241452), SPH_C32(0x02ae0000),
    SPH_C32(0xef310000), SPH_C32(0x1ec10000), SPH_C32(0xf5ce000c),
    SPH_C32(0xdcf90708), SPH_C32(0xd7cdd231), SPH_C32(0x0893ae02),
    SPH_C32(0xb5b5e185) },
  { SPH_C32(0x5fa80000), SPH_C32(0x56030000), SPH_C32(0x43ae0000),
    SPH_C32(0x64f30013), SPH_C32(0x257e86bf), SPH_C32(0x1311944e),
    SPH_C32(0x541e95bf), SPH_C32(0x8ea4db69), SPH_C32(0x00440000),
    SPH_C32(0x7f480000), SPH_C32(0xda7c0000), SPH_C32(0x2a230001),
    SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87), SPH_C32(0x030a9e60),
    SPH_C32(0xbe0a679e) },
  { SPH_C32(0x5c950000), SPH_C32(0x5eb00000), SPH_C32(0xb0940000),
    SPH_C32(0x5e310014), SPH_C32(0x74570cef), SPH_C32(0x787ff251),
    SPH_C32(0x5abb5a5c), SPH_C32(0x687ea497), SPH_C32(0xa89e0000),
    SPH_C32(0xe9f60000), SPH_C32(0x86610000), SPH_C32(0x2df90003),
    SPH_C32(0x46cb5c4f), SPH_C32(0xb62eec0d), SPH_C32(0xb86c1668),
    SPH_C32(0x648de79e) },
  { SPH_C32(0xf7720000), SPH_C32(0xc0bd0000), SPH_C32(0x1fb30000),
    SPH_C32(0x63290011), SPH_C32(0x5818133c), SPH_C32(0x0c89e4c4),
    SPH_C32(0xef781db7), SPH_C32(0x54235b69), SPH_C32(0xaba30000),
    SPH_C32(0xe1450000), SPH_C32(0x755b0000), SPH_C32(0x173b0004),
    SPH_C32(0x17e2d61f), SPH_C32(0xdd408a12), SPH_C32(0xb6c9d98b),
    SPH_C32(0x82579860) },
  { SPH_C32(0xf44f0000), SPH_C32(0xc80e0000), SPH_C32(0xec890000),
    SPH_C32(0x59eb0016), SPH_C32(0x0931996c), SPH_C32(0x67e782db),
    SPH_C32(0xe1ddd254), SPH_C32(0xb2f92497), SPH_C32(0x03790000),
    SPH_C32(0x77fb0000), SPH_C32(0x29460000), SPH_C32(0x10e10006),
    SPH_C32(0x6a84439c), SPH_C32(0xc2d8fa98), SPH_C32(0x0daf5183),
    SPH_C32(0x58d01860) },
  { SPH_C32(0x5e3b0000), SPH_C32(0xb1810000), SPH_C32(0xae550000),
    SPH_C32(0xabff0018), SPH_C32(0xa8ae0be7), SPH_C32(0xafb22060),
    SPH_C32(0x5228f45e), SPH_C32(0xddcb4512), SPH_C32(0x926c0000),
    SPH_C32(0xa3cd0000), SPH_C32(0x8d860000), SPH_C32(0x7cff0002),
    SPH_C32(0x8144eada), SPH_C32(0xf3593f8b), SPH_C32(0x93c46932),
    SPH_C32(0xc51c1249) },
  { SPH_C32(0x5d060000), SPH_C32(0xb9320000), SPH_C32(0x5d6f0000),
    SPH_C32(0x913d001f), SPH_C32(0xf98781b7), SPH_C32(0xc4dc467f),
    SPH_C32(0x5c8d3bbd), SPH_C32(0x3b113aec), SPH_C32(0x3ab60000),
    SPH_C32(0x35730000), SPH_C32(0xd19b0000), SPH_C32(0x7b250000),
    SPH_C32(0xfc227f59), SPH_C32(0xecc14f01), SPH_C32(0x28a2e13a),
    SPH_C32(0x1f9b9249) },
  { SPH_C32(0xf6e10000), SPH_C32(0x273f0000), SPH_C32(0xf2480000),
    SPH_C32(0xac25001a), SPH_C32(0xd5c89e64), SPH_C32(0xb02a50ea),
    SPH_C32(0xe94e7c56), SPH_C32(0x074cc512), SPH_C32(0x398b0000),
    SPH_C32(0x3dc00000), SPH_C32(0x22a10000), SPH_C32(0x41e70007),
    SPH_C32(0xad0bf509), SPH_C32(0x87af291e), SPH_C32(0x26072ed9),
    SPH_C32(0xf941edb7) },
  { SPH_C32(0xf5dc0000), SPH_C32(0x2f8c0000), SPH_C32(0x01720000),
    SPH_C32(0x96e7001d), SPH_C32(0x84e11434), SPH_C32(0xdb4436f5),
    SPH_C32(0xe7ebb3b5), SPH_C32(0xe196baec), SPH_C32(0x91510000),
    SPH_C32(0xab7e0000), SPH_C32(0x7ebc0000), SPH_C32(0x463d0005),
    SPH_C32(0xd06d608a), SPH_C32(0x98375994), SPH_C32(0x9d61a6d1),
    SPH_C32(0x23c66db7) },
  { SPH_C32(0xcd800000), SPH_C32(0x8a860000), SPH_C32(0x14540000),
    SPH_C32(0x322f0010), SPH_C32(0x9f97a5a9), SPH_C32(0x49fe3742),
    SPH_C32(0xc4d062ed), SPH_C32(0xf5b2aebe), SPH_C32(0x93ff0000),
    SPH_C32(0x444f0000), SPH_C32(0x607d0000), SPH_C32(0xb3f30009),
    SPH_C32(0x0c946782), SPH_C32(0x4ffa8ba5), SPH_C32(0x95f208d3),
    SPH_C32(0x96738c32) },
  { SPH_C32(0xcebd0000), SPH_C32(0x82350000), SPH_C32(0xe76e0000),
    SPH_C32(0x08ed0017), SPH_C32(0xcebe2ff9), SPH_C32(0x2290515d),
    SPH_C32(0xca75ad0e), SPH_C32(0x1368d140), SPH_C32(0x3b250000),
    SPH_C32(0xd2f10000), SPH_C32(0x3c600000), SPH_C32(0xb429000b),
    SPH_C32(0x71f2f201), SPH_C32(0x5062fb2f), SPH_C32(0x2e9480db),
    SPH_C32(0x4cf40c32) },
  { SPH_C32(0x655a0000), SPH_C32(0x1c380000), SPH_C32(0x48490000),
    SPH_C32(0x35f50012), SPH_C32(0xe2f1302a), SPH_C32(0x566647c8),
    SPH_C32(0x7fb6eae5), SPH_C32(0x2f352ebe), SPH_C32(0x38180000),
    SPH_C32(0xda420000), SPH_C32(0xcf5a0000), SPH_C32(0x8eeb000c),
    SPH_C32(0x20db7851), SPH_C32(0x3b0c9d30), SPH_C32(0x20314f38),
    SPH_C32(0xaa2e73cc) },
  { SPH_C32(0x66670000), SPH_C32(0x148b0000), SPH_C32(0xbb730000),
    SPH_C32(0x0f370015), SPH_C32(0xb3d8ba7a), SPH_C32(0x3d0821d7),
    SPH_C32(0x71132506), SPH_C32(0xc9ef5140), SPH_C32(0x90c20000),
    SPH_C32(0x4cfc0000), SPH_C32(0x93470000), SPH_C32(0x8931000e),
    SPH_C32(0x5dbdedd2), SPH_C32(0x2494edba), SPH_C32(0x9b57c730),
    SPH_C32(0x70a9f3cc) },
  { SPH_C32(0xcc130000), SPH_C32(0x6d040000), SPH_C32(0xf9af0000),
    SPH_C32(0xfd23001b), SPH_C32(0x124728f1), SPH_C32(0xf55d836c),
    SPH_C32(0xc2e6030c), SPH_C32(0xa6dd30c5), SPH_C32(0x01d70000),
    SPH_C32(0x98ca0000), SPH_C32(0x37870000), SPH_C32(0xe52f000a),
    SPH_C32(0xb67d4494), SPH_C32(0x151528a9), SPH_C32(0x053cff81),
    SPH_C32(0xed65f9e5) },
  { SPH_C32(0xcf2e0000), SPH_C32(0x65b70000), SPH_C32(0x0a950000),
    SPH_C32(0xc7e1001c), SPH_C32(0x436ea2a1), SPH_C32(0x9e33e573),
    SPH_C32(0xcc43ccef), SPH_C32(0x40074f3b), SPH_C32(0xa90d0000),
    SPH_C32(0x0e740000), SPH_C32(0x6b9a0000), SPH_C32(0xe2f50008),
    SPH_C32(0xcb1bd117), SPH_C32(0x0a8d5823), SPH_C32(0xbe5a7789),
    SPH_C32(0x37e279e5) },
  { SPH_C32(0x64c90000), SPH_C32(0xfbba0000), SPH_C32(0xa5b20000),
    SPH_C32(0xfaf90019), SPH_C32(0x6f21bd72), SPH_C32(0xeac5f3e6),
    SPH_C32(0x79808b04), SPH_C32(0x7c5ab0c5), SPH_C32(0xaa300000),
    SPH_C32(0x06c70000), SPH_C32(0x98a00000), SPH_C32(0xd837000f),
    SPH_C32(0x9a325b47), SPH_C32(0x61e33e3c), SPH_C32(0xb0ffb86a),
    SPH_C32(0xd138061b) },
  { SPH_C32(0x67f40000), SPH_C32(0xf3090000), SPH_C32(0x56880000),
    SPH_C32(0xc03b001e), SPH_C32(0x3e083722), SPH_C32(0x81ab95f9),
    SPH_C32(0x772544e7), SPH_C32(0x9a80cf3b), SPH_C32(0x02ea0000),
    SPH_C32(0x90790000), SPH_C32(0xc4bd0000), SPH_C32(0xdfed000d),
    SPH_C32(0xe754cec4), SPH_C32(0x7e7b4eb6), SPH_C32(0x0b993062),
    SPH_C32(0x0bbf861b) },
  { SPH_C32(0x00440000), SPH_C32(0x7f480000), SPH_C32(0xda7c0000),
    SPH_C32(0x2a230001), SPH_C32(0x3badc9cc), SPH_C32(0xa9b69c87),
    SPH_C32(0x030a9e60), SPH_C32(0xbe0a679e), SPH_C32(0x5fec0000),
    SPH_C32(0x294b0000), SPH_C32(0x99d20000), SPH_C32(0x4ed00012),
    SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9), SPH_C32(0x57140bdf),
    SPH_C32(0x30aebcf7) },
  { SPH_C32(0x03790000), SPH_C32(0x77fb0000), SPH_C32(0x29460000),
    SPH_C32(0x10e10006), SPH_C32(0x6a84439c), SPH_C32(0xc2d8fa98),
    SPH_C32(0x0daf5183), SPH_C32(0x58d01860), SPH_C32(0xf7360000),
    SPH_C32(0xbff50000), SPH_C32(0xc5cf0000), SPH_C32(0x490a0010),
    SPH_C32(0x63b5daf0), SPH_C32(0xa53f7843), SPH_C32(0xec7283d7),
    SPH_C32(0xea293cf7) },
  { SPH_C32(0xa89e0000), SPH_C32(0xe9f60000), SPH_C32(0x86610000),
    SPH_C32(0x2df90003), SPH_C32(0x46cb5c4f), SPH_C32(0xb62eec0d),
    SPH_C32(0xb86c1668), SPH_C32(0x648de79e), SPH_C32(0xf40b0000),
    SPH_C32(0xb7460000), SPH_C32(0x36f50000), SPH_C32(0x73c80017),
    SPH_C32(0x329c50a0), SPH_C32(0xce511e5c), SPH_C32(0xe2d74c34),
    SPH_C32(0x0cf34309) },
  { SPH_C32(0xaba30000), SPH_C32(0xe1450000), SPH_C32(0x755b0000),
    SPH_C32(0x173b0004), SPH_C32(0x17e2d61f), SPH_C32(0xdd408a12),
    SPH_C32(0xb6c9d98b), SPH_C32(0x82579860), SPH_C32(0x5cd10000),
    SPH_C32(0x21f80000), SPH_C32(0x6ae80000), SPH_C32(0x74120015),
    SPH_C32(0x4ffac523), SPH_C32(0xd1c96ed6), SPH_C32(0x59b1c43c),
    SPH_C32(0xd674c309) },
  { SPH_C32(0x01d70000), SPH_C32(0x98ca0000), SPH_C32(0x37870000),
    SPH_C32(0xe52f000a), SPH_C32(0xb67d4494), SPH_C32(0x151528a9),
    SPH_C32(0x053cff81), SPH_C32(0xed65f9e5), SPH_C32(0xcdc40000),
    SPH_C32(0xf5ce0000), SPH_C32(0xce280000), SPH_C32(0x180c0011),
    SPH_C32(0xa43a6c65), SPH_C32(0xe048abc5), SPH_C32(0xc7dafc8d),
    SPH_C32(0x4bb8c920) },
  { SPH_C32(0x02ea0000), SPH_C32(0x90790000), SPH_C32(0xc4bd0000),
    SPH_C32(0xdfed000d), SPH_C32(0xe754cec4), SPH_C32(0x7e7b4eb6),
    SPH_C32(0x0b993062), SPH_C32(0x0bbf861b), SPH_C32(0x651e0000),
    SPH_C32(0x63700000), SPH_C32(0x92350000), SPH_C32(0x1fd60013),
    SPH_C32(0xd95cf9e6), SPH_C32(0xffd0db4f), SPH_C32(0x7cbc7485),
    SPH_C32(0x913f4920) },
  { SPH_C32(0xa90d0000), SPH_C32(0x0e740000), SPH_C32(0x6b9a0000),
    SPH_C32(0xe2f50008), SPH_C32(0xcb1bd117), SPH_C32(0x0a8d5823),
    SPH_C32(0xbe5a7789), SPH_C32(0x37e279e5), SPH_C32(0x66230000),
    SPH_C32(0x6bc30000), SPH_C32(0x610f0000), SPH_C32(0x25140014),
    SPH_C32(0x887573b6), SPH_C32(0x94bebd50), SPH_C32(0x7219bb66),
    SPH_C32(0x77e536de) },
  { SPH_C32(0xaa300000), SPH_C32(0x06c70000), SPH_C32(0x98a00000),
    SPH_C32(0xd837000f), SPH_C32(0x9a325b47), SPH_C32(0x61e33e3c),
    SPH_C32(0xb0ffb86a), SPH_C32(0xd138061b), SPH_C32(0xcef90000),
    SPH_C32(0xfd7d0000), SPH_C32(0x3d120000), SPH_C32(0x22ce0016),
    SPH_C32(0xf513e635), SPH_C32(0x8b26cdda), SPH_C32(0xc97f336e),
    SPH_C32(0xad62b6de) },
  { SPH_C32(0x926c0000), SPH_C32(0xa3cd0000), SPH_C32(0x8d860000),
    SPH_C32(0x7cff0002), SPH_C32(0x8144eada), SPH_C32(0xf3593f8b),
    SPH_C32(0x93c46932), SPH_C32(0xc51c1249), SPH_C32(0xcc570000),
    SPH_C32(0x124c0000), SPH_C32(0x23d30000), SPH_C32(0xd700001a),
    SPH_C32(0x29eae13d), SPH_C32(0x5ceb1feb), SPH_C32(0xc1ec9d6c),
    SPH_C32(0x18d7575b) },
  { SPH_C32(0x91510000), SPH_C32(0xab7e0000), SPH_C32(0x7ebc0000),
    SPH_C32(0x463d0005), SPH_C32(0xd06d608a), SPH_C32(0x98375994),
    SPH_C32(0x9d61a6d1), SPH_C32(0x23c66db7), SPH_C32(0x648d0000),
    SPH_C32(0x84f20000), SPH_C32(0x7fce0000), SPH_C32(0xd0da0018),
    SPH_C32(0x548c74be), SPH_C32(0x43736f61), SPH_C32(0x7a8a1564),
    SPH_C32(0xc250d75b) },
  { SPH_C32(0x3ab60000), SPH_C32(0x35730000), SPH_C32(0xd19b0000),
    SPH_C32(0x7b250000), SPH_C32(0xfc227f59), SPH_C32(0xecc14f01),
    SPH_C32(0x28a2e13a), SPH_C32(0x1f9b9249), SPH_C32(0x67b00000),
    SPH_C32(0x8c410000), SPH_C32(0x8cf40000), SPH_C32(0xea18001f),
    SPH_C32(0x05a5feee), SPH_C32(0x281d097e), SPH_C32(0x742fda87),
    SPH_C32(0x248aa8a5) },
  { SPH_C32(0x398b0000), SPH_C32(0x3dc00000), SPH_C32(0x22a10000),
    SPH_C32(0x41e70007), SPH_C32(0xad0bf509), SPH_C32(0x87af291e),
    SPH_C32(0x26072ed9), SPH_C32(0xf941edb7), SPH_C32(0xcf6a0000),
    SPH_C32(0x1aff0000), SPH_C32(0xd0e90000), SPH_C32(0xedc2001d),
    SPH_C32(0x78c36b6d), SPH_C32(0x378579f4), SPH_C32(0xcf49528f),
    SPH_C32(0xfe0d28a5) },
  { SPH_C32(0x93ff0000), SPH_C32(0x444f0000), SPH_C32(0x607d0000),
    SPH_C32(0xb3f30009), SPH_C32(0x0c946782), SPH_C32(0x4ffa8ba5),
    SPH_C32(0x95f208d3), SPH_C32(0x96738c32), SPH_C32(0x5e7f0000),
    SPH_C32(0xcec90000), SPH_C32(0x74290000), SPH_C32(0x81dc0019),
    SPH_C32(0x9303c22b), SPH_C32(0x0604bce7), SPH_C32(0x51226a3e),
    SPH_C32(0x63c1228c) },
  { SPH_C32(0x90c20000), SPH_C32(0x4cfc0000), SPH_C32(0x93470000),
    SPH_C32(0x8931000e), SPH_C32(0x5dbdedd2), SPH_C32(0x2494edba),
    SPH_C32(0x9b57c730), SPH_C32(0x70a9f3cc), SPH_C32(0xf6a50000),
    SPH_C32(0x58770000), SPH_C32(0x28340000), SPH_C32(0x8606001b),
    SPH_C32(0xee6557a8), SPH_C32(0x199ccc6d), SPH_C32(0xea44e236),
    SPH_C32(0xb946a28c) },
  { SPH_C32(0x3b250000), SPH_C32(0xd2f10000), SPH_C32(0x3c600000),
    SPH_C32(0xb429000b), SPH_C32(0x71f2f201), SPH_C32(0x5062fb2f),
    SPH_C32(0x2e9480db), SPH_C32(0x4cf40c32), SPH_C32(0xf5980000),
    SPH_C32(0x50c40000), SPH_C32(0xdb0e0000), SPH_C32(0xbcc4001c),
    SPH_C32(0xbf4cddf8), SPH_C32(0x72f2aa72), SPH_C32(0xe4e12dd5),
    SPH_C32(0x5f9cdd72) },
  { SPH_C32(0x38180000), SPH_C32(0xda420000), SPH_C32(0xcf5a0000),
    SPH_C32(0x8eeb000c), SPH_C32(0x20db7851), SPH_C32(0x3b0c9d30),
    SPH_C32(0x20314f38), SPH_C32(0xaa2e73cc), SPH_C32(0x5d420000),
    SPH_C32(0xc67a0000), SPH_C32(0x87130000), SPH_C32(0xbb1e001e),
    SPH_C32(0xc22a487b), SPH_C32(0x6d6adaf8), SPH_C32(0x5f87a5dd),
    SPH_C32(0x851b5d72) },
  { SPH_C32(0x5fec0000), SPH_C32(0x294b0000), SPH_C32(0x99d20000),
    SPH_C32(0x4ed00012), SPH_C32(0x1ed34f73), SPH_C32(0xbaa708c9),
    SPH_C32(0x57140bdf), SPH_C32(0x30aebcf7), SPH_C32(0x5fa80000),
    SPH_C32(0x56030000), SPH_C32(0x43ae0000), SPH_C32(0x64f30013),
    SPH_C32(0x257e86bf), SPH_C32(0x1311944e), SPH_C32(0x541e95bf),
    SPH_C32(0x8ea4db69) },
  { SPH_C32(0x5cd10000), SPH_C32(0x21f80000), SPH_C32(0x6ae80000),
    SPH_C32(0x74120015), SPH_C32(0x4ffac523), SPH_C32(0xd1c96ed6),
    SPH_C32(0x59b1c43c), SPH_C32(0xd674c309), SPH_C32(0xf7720000),
    SPH_C32(0xc0bd0000), SPH_C32(0x1fb30000), SPH_C32(0x63290011),
    SPH_C32(0x5818133c), SPH_C32(0x0c89e4c4), SPH_C32(0xef781db7),
    SPH_C32(0x54235b69) },
  { SPH_C32(0xf7360000), SPH_C32(0xbff50000), SPH_C32(0xc5cf0000),
    SPH_C32(0x490a0010), SPH_C32(0x63b5daf0), SPH_C32(0xa53f7843),
    SPH_C32(0xec7283d7), SPH_C32(0xea293cf7), SPH_C32(0xf44f0000),
    SPH_C32(0xc80e0000), SPH_C32(0xec890000), SPH_C32(0x59eb0016),
    SPH_C32(0x0931996c), SPH_C32(0x67e782db), SPH_C32(0xe1ddd254),
    SPH_C32(0xb2f92497) },
  { SPH_C32(0xf40b0000), SPH_C32(0xb7460000), SPH_C32(0x36f50000),
    SPH_C32(0x73c80017), SPH_C32(0x329c50a0), SPH_C32(0xce511e5c),
    SPH_C32(0xe2d74c34), SPH_C32(0x0cf34309), SPH_C32(0x5c950000),
    SPH_C32(0x5eb00000), SPH_C32(0xb0940000), SPH_C32(0x5e310014),
    SPH_C32(0x74570cef), SPH_C32(0x787ff251), SPH_C32(0x5abb5a5c),
    SPH_C32(0x687ea497) },
  { SPH_C32(0x5e7f0000), SPH_C32(0xcec90000), SPH_C32(0x74290000),
    SPH_C32(0x81dc0019), SPH_C32(0x9303c22b), SPH_C32(0x0604bce7),
    SPH_C32(0x51226a3e), SPH_C32(0x63c1228c), SPH_C32(0xcd800000),
    SPH_C32(0x8a860000), SPH_C32(0x14540000), SPH_C32(0x322f0010),
    SPH_C32(0x9f97a5a9), SPH_C32(0x49fe3742), SPH_C32(0xc4d062ed),
    SPH_C32(0xf5b2aebe) },
  { SPH_C32(0x5d420000), SPH_C32(0xc67a0000), SPH_C32(0x87130000),
    SPH_C32(0xbb1e001e), SPH_C32(0xc22a487b), SPH_C32(0x6d6adaf8),
    SPH_C32(0x5f87a5dd), SPH_C32(0x851b5d72), SPH_C32(0x655a0000),
    SPH_C32(0x1c380000), SPH_C32(0x48490000), SPH_C32(0x35f50012),
    SPH_C32(0xe2f1302a), SPH_C32(0x566647c8), SPH_C32(0x7fb6eae5),
    SPH_C32(0x2f352ebe) },
  { SPH_C32(0xf6a50000), SPH_C32(0x58770000), SPH_C32(0x28340000),
    SPH_C32(0x8606001b), SPH_C32(0xee6557a8), SPH_C32(0x199ccc6d),
    SPH_C32(0xea44e236), SPH_C32(0xb946a28c), SPH_C32(0x66670000),
    SPH_C32(0x148b0000), SPH_C32(0xbb730000), SPH_C32(0x0f370015),
    SPH_C32(0xb3d8ba7a), SPH_C32(0x3d0821d7), SPH_C32(0x71132506),
    SPH_C32(0xc9ef5140) },
  { SPH_C32(0xf5980000), SPH_C32(0x50c40000), SPH_C32(0xdb0e0000),
    SPH_C32(0xbcc4001c), SPH_C32(0xbf4cddf8), SPH_C32(0x72f2aa72),
    SPH_C32(0xe4e12dd5), SPH_C32(0x5f9cdd72), SPH_C32(0xcebd0000),
    SPH_C32(0x82350000), SPH_C32(0xe76e0000), SPH_C32(0x08ed0017),
    SPH_C32(0xcebe2ff9), SPH_C32(0x2290515d), SPH_C32(0xca75ad0e),
    SPH_C32(0x1368d140) },
  { SPH_C32(0xcdc40000), SPH_C32(0xf5ce0000), SPH_C32(0xce280000),
    SPH_C32(0x180c0011), SPH_C32(0xa43a6c65), SPH_C32(0xe048abc5),
    SPH_C32(0xc7dafc8d), SPH_C32(0x4bb8c920), SPH_C32(0xcc130000),
    SPH_C32(0x6d040000), SPH_C32(0xf9af0000), SPH_C32(0xfd23001b),
    SPH_C32(0x124728f1), SPH_C32(0xf55d836c), SPH_C32(0xc2e6030c),
    SPH_C32(0xa6dd30c5) },
  { SPH_C32(0xcef90000), SPH_C32(0xfd7d0000), SPH_C32(0x3d120000),
    SPH_C32(0x22ce0016), SPH_C32(0xf513e635), SPH_C32(0x8b26cdda),
    SPH_C32(0xc97f336e), SPH_C32(0xad62b6de), SPH_C32(0x64c90000),
    SPH_C32(0xfbba0000), SPH_C32(0xa5b20000), SPH_C32(0xfaf90019),
    SPH_C32(0x6f21bd72), SPH_C32(0xeac5f3e6), SPH_C32(0x79808b04),
    SPH_C32(0x7c5ab0c5) },
  { SPH_C32(0x651e0000), SPH_C32(0x63700000), SPH_C32(0x92350000),
    SPH_C32(0x1fd60013), SPH_C32(0xd95cf9e6), SPH_C32(0xffd0db4f),
    SPH_C32(0x7cbc7485), SPH_C32(0x913f4920), SPH_C32(0x67f40000),
    SPH_C32(0xf3090000), SPH_C32(0x56880000), SPH_C32(0xc03b001e),
    SPH_C32(0x3e083722), SPH_C32(0x81ab95f9), SPH_C32(0x772544e7),
    SPH_C32(0x9a80cf3b) },
  { SPH_C32(0x66230000), SPH_C32(0x6bc30000), SPH_C32(0x610f0000),
    SPH_C32(0x25140014), SPH_C32(0x887573b6), SPH_C32(0x94bebd50),
    SPH_C32(0x7219bb66), SPH_C32(0x77e536de), SPH_C32(0xcf2e0000),
    SPH_C32(0x65b70000), SPH_C32(0x0a950000), SPH_C32(0xc7e1001c),
    SPH_C32(0x436ea2a1), SPH_C32(0x9e33e573), SPH_C32(0xcc43ccef),
    SPH_C32(0x40074f3b) },
  { SPH_C32(0xcc570000), SPH_C32(0x124c0000), SPH_C32(0x23d30000),
    SPH_C32(0xd700001a), SPH_C32(0x29eae13d), SPH_C32(0x5ceb1feb),
    SPH_C32(0xc1ec9d6c), SPH_C32(0x18d7575b), SPH_C32(0x5e3b0000),
    SPH_C32(0xb1810000), SPH_C32(0xae550000), SPH_C32(0xabff0018),
    SPH_C32(0xa8ae0be7), SPH_C32(0xafb22060), SPH_C32(0x5228f45e),
    SPH_C32(0xddcb4512) },
  { SPH_C32(0xcf6a0000), SPH_C32(0x1aff0000), SPH_C32(0xd0e90000),
    SPH_C32(0xedc2001d), SPH_C32(0x78c36b6d), SPH_C32(0x378579f4),
    SPH_C32(0xcf49528f), SPH_C32(0xfe0d28a5), SPH_C32(0xf6e10000),
    SPH_C32(0x273f0000), SPH_C32(0xf2480000), SPH_C32(0xac25001a),
    SPH_C32(0xd5c89e64), SPH_C32(0xb02a50ea), SPH_C32(0xe94e7c56),
    SPH_C32(0x074cc512) },
  { SPH_C32(0x648d0000), SPH_C32(0x84f20000), SPH_C32(0x7fce0000),
    SPH_C32(0xd0da0018), SPH_C32(0x548c74be), SPH_C32(0x43736f61),
    SPH_C32(0x7a8a1564), SPH_C32(0xc250d75b), SPH_C32(0xf5dc0000),
    SPH_C32(0x2f8c0000), SPH_C32(0x01720000), SPH_C32(0x96e7001d),
    SPH_C32(0x84e11434), SPH_C32(0xdb4436f5), SPH_C32(0xe7ebb3b5),
    SPH_C32(0xe196baec) },
  { SPH_C32(0x67b00000), SPH_C32(0x8c410000), SPH_C32(0x8cf40000),
    SPH_C32(0xea18001f), SPH_C32(0x05a5feee), SPH_C32(0x281d097e),
    SPH_C32(0x742fda87), SPH_C32(0x248aa8a5), SPH_C32(0x5d060000),
    SPH_C32(0xb9320000), SPH_C32(0x5d6f0000), SPH_C32(0x913d001f),
    SPH_C32(0xf98781b7), SPH_C32(0xc4dc467f), SPH_C32(0x5c8d3bbd),
    SPH_C32(0x3b113aec) },
  { SPH_C32(0xee930000), SPH_C32(0xd6070000), SPH_C32(0x92c10000),
    SPH_C32(0x2b9801e0), SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57),
    SPH_C32(0x45312374), SPH_C32(0x201f6a64), SPH_C32(0x7b280000),
    SPH_C32(0x57420000), SPH_C32(0xa9e50000), SPH_C32(0x634300a0),
    SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb), SPH_C32(0x27f83b03),
    SPH_C32(0xc7ff60f0) },
  { SPH_C32(0xedae0000), SPH_C32(0xdeb40000), SPH_C32(0x61fb0000),
    SPH_C32(0x115a01e7), SPH_C32(0xc578a22c), SPH_C32(0x50029d48),
    SPH_C32(0x4b94ec97), SPH_C32(0xc6c5159a), SPH_C32(0xd3f20000),
    SPH_C32(0xc1fc0000), SPH_C32(0xf5f80000), SPH_C32(0x649900a2),
    SPH_C32(0xe3bdd1ac), SPH_C32(0x7201e531), SPH_C32(0x9c9eb30b),
    SPH_C32(0x1d78e0f0) },
  { SPH_C32(0x46490000), SPH_C32(0x40b90000), SPH_C32(0xcedc0000),
    SPH_C32(0x2c4201e2), SPH_C32(0xe937bdff), SPH_C32(0x24f48bdd),
    SPH_C32(0xfe57ab7c), SPH_C32(0xfa98ea64), SPH_C32(0xd0cf0000),
    SPH_C32(0xc94f0000), SPH_C32(0x06c20000), SPH_C32(0x5e5b00a5),
    SPH_C32(0xb2945bfc), SPH_C32(0x196f832e), SPH_C32(0x923b7ce8),
    SPH_C32(0xfba29f0e) },
  { SPH_C32(0x45740000), SPH_C32(0x480a0000), SPH_C32(0x3de60000),
    SPH_C32(0x168001e5), SPH_C32(0xb81e37af), SPH_C32(0x4f9aedc2),
    SPH_C32(0xf0f2649f), SPH_C32(0x1c42959a), SPH_C32(0x78150000),
    SPH_C32(0x5ff10000), SPH_C32(0x5adf0000), SPH_C32(0x598100a7),
    SPH_C32(0xcff2ce7f), SPH_C32(0x06f7f3a4), SPH_C32(0x295df4e0),
    SPH_C32(0x21251f0e) },
  { SPH_C32(0xef000000), SPH_C32(0x31850000), SPH_C32(0x7f3a0000),
    SPH_C32(0xe49401eb), SPH_C32(0x1981a524), SPH_C32(0x87cf4f79),
    SPH_C32(0x43074295), SPH_C32(0x7370f41f), SPH_C32(0xe9000000),
    SPH_C32(0x8bc70000), SPH_C32(0xfe1f0000), SPH_C32(0x359f00a3),
    SPH_C32(0x24326739), SPH_C32(0x377636b7), SPH_C32(0xb736cc51),
    SPH_C32(0xbce91527) },
  { SPH_C32(0xec3d0000), SPH_C32(0x39360000), SPH_C32(0x8c000000),
    SPH_C32(0xde5601ec), SPH_C32(0x48a82f74), SPH_C32(0xeca12966),
    SPH_C32(0x4da28d76), SPH_C32(0x95aa8be1), SPH_C32(0x41da0000),
    SPH_C32(0x1d790000), SPH_C32(0xa2020000), SPH_C32(0x324500a1),
    SPH_C32(0x5954f2ba), SPH_C32(0x28ee463d), SPH_C32(0x0c504459),
    SPH_C32(0x666e9527) },
  { SPH_C32(0x47da0000), SPH_C32(0xa73b0000), SPH_C32(0x23270000),
    SPH_C32(0xe34e01e9), SPH_C32(0x64e730a7), SPH_C32(0x98573ff3),
    SPH_C32(0xf861ca9d), SPH_C32(0xa9f7741f), SPH_C32(0x42e70000),
    SPH_C32(0x15ca0000), SPH_C32(0x51380000), SPH_C32(0x088700a6),
    SPH_C32(0x087d78ea), SPH_C32(0x43802022), SPH_C32(0x02f58bba),
    SPH_C32(0x80b4ead9) },
  { SPH_C32(0x44e70000), SPH_C32(0xaf880000), SPH_C32(0xd01d0000),
    SPH_C32(0xd98c01ee), SPH_C32(0x35cebaf7), SPH_C32(0xf33959ec),
    SPH_C32(0xf6c4057e), SPH_C32(0x4f2d0be1), SPH_C32(0xea3d0000),
    SPH_C32(0x83740000), SPH_C32(0x0d250000), SPH_C32(0x0f5d00a4),
    SPH_C32(0x751bed69), SPH_C32(0x5c1850a8), SPH_C32(0xb99303b2),
    SPH_C32(0x5a336ad9) },
  { SPH_C32(0x7cbb0000), SPH_C32(0x0a820000), SPH_C32(0xc53b0000),
    SPH_C32(0x7d4401e3), SPH_C32(0x2eb80b6a), SPH_C32(0x6183585b),
    SPH_C32(0xd5ffd426), SPH_C32(0x5b091fb3), SPH_C32(0xe8930000),
    SPH_C32(0x6c450000), SPH_C32(0x13e40000), SPH_C32(0xfa9300a8),
    SPH_C32(0xa9e2ea61), SPH_C32(0x8bd58299), SPH_C32(0xb100adb0),
    SPH_C32(0xef868b5c) },
  { SPH_C32(0x7f860000), SPH_C32(0x02310000), SPH_C32(0x36010000),
    SPH_C32(0x478601e4), SPH_C32(0x7f91813a), SPH_C32(0x0aed3e44),
    SPH_C32(0xdb5a1bc5), SPH_C32(0xbdd3604d), SPH_C32(0x40490000),
    SPH_C32(0xfafb0000), SPH_C32(0x4ff90000), SPH_C32(0xfd4900aa),
    SPH_C32(0xd4847fe2), SPH_C32(0x944df213), SPH_C32(0x0a6625b8),
    SPH_C32(0x35010b5c) },
  { SPH_C32(0xd4610000), SPH_C32(0x9c3c0000), SPH_C32(0x99260000),
    SPH_C32(0x7a9e01e1), SPH_C32(0x53de9ee9), SPH_C32(0x7e1b28d1),
    SPH_C32(0x6e995c2e), SPH_C32(0x818e9fb3), SPH_C32(0x43740000),
    SPH_C32(0xf2480000), SPH_C32(0xbcc30000), SPH_C32(0xc78b00ad),
    SPH_C32(0x85adf5b2), SPH_C32(0xff23940c), SPH_C32(0x04c3ea5b),
    SPH_C32(0xd3db74a2) },
  { SPH_C32(0xd75c0000), SPH_C32(0x948f0000), SPH_C32(0x6a1c0000),
    SPH_C32(0x405c01e6), SPH_C32(0x02f714b9), SPH_C32(0x15754ece),
    SPH_C32(0x603c93cd), SPH_C32(0x6754e04d), SPH_C32(0xebae0000),
    SPH_C32(0x64f60000), SPH_C32(0xe0de0000), SPH_C32(0xc05100af),
    SPH_C32(0xf8cb6031), SPH_C32(0xe0bbe486), SPH_C32(0xbfa56253),
    SPH_C32(0x095cf4a2) },
  { SPH_C32(0x7d280000), SPH_C32(0xed000000), SPH_C32(0x28c00000),
    SPH_C32(0xb24801e8), SPH_C32(0xa3688632), SPH_C32(0xdd20ec75),
    SPH_C32(0xd3c9b5c7), SPH_C32(0x086681c8), SPH_C32(0x7abb0000),
    SPH_C32(0xb0c00000), SPH_C32(0x441e0000), SPH_C32(0xac4f00ab),
    SPH_C32(0x130bc977), SPH_C32(0xd13a2195), SPH_C32(0x21ce5ae2),
    SPH_C32(0x9490fe8b) },
  { SPH_C32(0x7e150000), SPH_C32(0xe5b30000), SPH_C32(0xdbfa0000),
    SPH_C32(0x888a01ef), SPH_C32(0xf2410c62), SPH_C32(0xb64e8a6a),
    SPH_C32(0xdd6c7a24), SPH_C32(0xeebcfe36), SPH_C32(0xd2610000),
    SPH_C32(0x267e0000), SPH_C32(0x18030000), SPH_C32(0xab9500a9),
    SPH_C32(0x6e6d5cf4), SPH_C32(0xcea2511f), SPH_C32(0x9aa8d2ea),
    SPH_C32(0x4e177e8b) },
  { SPH_C32(0xd5f20000), SPH_C32(0x7bbe0000), SPH_C32(0x74dd0000),
    SPH_C32(0xb59201ea), SPH_C32(0xde0e13b1), SPH_C32(0xc2b89cff),
    SPH_C32(0x68af3dcf), SPH_C32(0xd2e101c8), SPH_C32(0xd15c0000),
    SPH_C32(0x2ecd0000), SPH_C32(0xeb390000), SPH_C32(0x915700ae),
    SPH_C32(0x3f44d6a4), SPH_C32(0xa5cc3700), SPH_C32(0x940d1d09),
    SPH_C32(0xa8cd0175) },
  { SPH_C32(0xd6cf0000), SPH_C32(0x730d0000), SPH_C32(0x87e70000),
    SPH_C32(0x8f5001ed), SPH_C32(0x8f2799e1), SPH_C32(0xa9d6fae0),
    SPH_C32(0x660af22c), SPH_C32(0x343b7e36), SPH_C32(0x79860000),
    SPH_C32(0xb8730000), SPH_C32(0xb7240000), SPH_C32(0x968d00ac),
    SPH_C32(0x42224327), SPH_C32(0xba54478a), SPH_C32(0x2f6b9501),
    SPH_C32(0x724a8175) },
  { SPH_C32(0xb13b0000), SPH_C32(0x80040000), SPH_C32(0xd16f0000),
    SPH_C32(0x4f6b01f3), SPH_C32(0xb12faec3), SPH_C32(0x287d6f19),
    SPH_C32(0x112fb6cb), SPH_C32(0xaebbb10d), SPH_C32(0x7b6c0000),
    SPH_C32(0x280a0000), SPH_C32(0x73990000), SPH_C32(0x496000a1),
    SPH_C32(0xa5768de3), SPH_C32(0xc42f093c), SPH_C32(0x24f2a563),
    SPH_C32(0x79f5076e) },
  { SPH_C32(0xb2060000), SPH_C32(0x88b70000), SPH_C32(0x22550000),
    SPH_C32(0x75a901f4), SPH_C32(0xe0062493), SPH_C32(0x43130906),
    SPH_C32(0x1f8a7928), SPH_C32(0x4861cef3), SPH_C32(0xd3b60000),
    SPH_C32(0xbeb40000), SPH_C32(0x2f840000), SPH_C32(0x4eba00a3),
    SPH_C32(0xd8101860), SPH_C32(0xdbb779b6), SPH_C32(0x9f942d6b),
    SPH_C32(0xa372876e) },
  { SPH_C32(0x19e10000), SPH_C32(0x16ba0000), SPH_C32(0x8d720000),
    SPH_C32(0x48b101f1), SPH_C32(0xcc493b40), SPH_C32(0x37e51f93),
    SPH_C32(0xaa493ec3), SPH_C32(0x743c310d), SPH_C32(0xd08b0000),
    SPH_C32(0xb6070000), SPH_C32(0xdcbe0000), SPH_C32(0x747800a4),
    SPH_C32(0x89399230), SPH_C32(0xb0d91fa9), SPH_C32(0x9131e288),
    SPH_C32(0x45a8f890) },
  { SPH_C32(0x1adc0000), SPH_C32(0x1e090000), SPH_C32(0x7e480000),
    SPH_C32(0x727301f6), SPH_C32(0x9d60b110), SPH_C32(0x5c8b798c),
    SPH_C32(0xa4ecf120), SPH_C32(0x92e64ef3), SPH_C32(0x78510000),
    SPH_C32(0x20b90000), SPH_C32(0x80a30000), SPH_C32(0x73a200a6),
    SPH_C32(0xf45f07b3), SPH_C32(0xaf416f23), SPH_C32(0x2a576a80),
    SPH_C32(0x9f2f7890) },
  { SPH_C32(0xb0a80000), SPH_C32(0x67860000), SPH_C32(0x3c940000),
    SPH_C32(0x806701f8), SPH_C32(0x3cff239b), SPH_C32(0x94dedb37),
    SPH_C32(0x1719d72a), SPH_C32(0xfdd42f76), SPH_C32(0xe9440000),
    SPH_C32(0xf48f0000), SPH_C32(0x24630000), SPH_C32(0x1fbc00a2),
    SPH_C32(0x1f9faef5), SPH_C32(0x9ec0aa30), SPH_C32(0xb43c5231),
    SPH_C32(0x02e372b9) },
  { SPH_C32(0xb3950000), SPH_C32(0x6f350000), SPH_C32(0xcfae0000),
    SPH_C32(0xbaa501ff), SPH_C32(0x6dd6a9cb), SPH_C32(0xffb0bd28),
    SPH_C32(0x19bc18c9), SPH_C32(0x1b0e5088), SPH_C32(0x419e0000),
    SPH_C32(0x62310000), SPH_C32(0x787e0000), SPH_C32(0x186600a0),
    SPH_C32(0x62f93b76), SPH_C32(0x8158daba), SPH_C32(0x0f5ada39),
    SPH_C32(0xd864f2b9) },
  { SPH_C32(0x18720000), SPH_C32(0xf1380000), SPH_C32(0x60890000),
    SPH_C32(0x87bd01fa), SPH_C32(0x4199b618), SPH_C32(0x8b46abbd),
    SPH_C32(0xac7f5f22), SPH_C32(0x2753af76), SPH_C32(0x42a30000),
    SPH_C32(0x6a820000), SPH_C32(0x8b440000), SPH_C32(0x22a400a7),
    SPH_C32(0x33d0b126), SPH_C32(0xea36bca5), SPH_C32(0x01ff15da),
    SPH_C32(0x3ebe8d47) },
  { SPH_C32(0x1b4f0000), SPH_C32(0xf98b0000), SPH_C32(0x93b30000),
    SPH_C32(0xbd7f01fd), SPH_C32(0x10b03c48), SPH_C32(0xe028cda2),
    SPH_C32(0xa2da90c1), SPH_C32(0xc189d088), SPH_C32(0xea790000),
    SPH_C32(0xfc3c0000), SPH_C32(0xd7590000), SPH_C32(0x257e00a5),
    SPH_C32(0x4eb624a5), SPH_C32(0xf5aecc2f), SPH_C32(0xba999dd2),
    SPH_C32(0xe4390d47) },
  { SPH_C32(0x23130000), SPH_C32(0x5c810000), SPH_C32(0x86950000),
    SPH_C32(0x19b701f0), SPH_C32(0x0bc68dd5), SPH_C32(0x7292cc15),
    SPH_C32(0x81e14199), SPH_C32(0xd5adc4da), SPH_C32(0xe8d70000),
    SPH_C32(0x130d0000), SPH_C32(0xc9980000), SPH_C32(0xd0b000a9),
    SPH_C32(0x924f23ad), SPH_C32(0x22631e1e), SPH_C32(0xb20a33d0),
    SPH_C32(0x518cecc2) },
  { SPH_C32(0x202e0000), SPH_C32(0x54320000), SPH_C32(0x75af0000),
    SPH_C32(0x237501f7), SPH_C32(0x5aef0785), SPH_C32(0x19fcaa0a),
    SPH_C32(0x8f448e7a), SPH_C32(0x3377bb24), SPH_C32(0x400d0000),
    SPH_C32(0x85b30000), SPH_C32(0x95850000), SPH_C32(0xd76a00ab),
    SPH_C32(0xef29b62e), SPH_C32(0x3dfb6e94), SPH_C32(0x096cbbd8),
    SPH_C32(0x8b0b6cc2) },
  { SPH_C32(0x8bc90000), SPH_C32(0xca3f0000), SPH_C32(0xda880000),
    SPH_C32(0x1e6d01f2), SPH_C32(0x76a01856), SPH_C32(0x6d0abc9f),
    SPH_C32(0x3a87c991), SPH_C32(0x0f2a44da), SPH_C32(0x43300000),
    SPH_C32(0x8d000000), SPH_C32(0x66bf0000), SPH_C32(0xeda800ac),
    SPH_C32(0xbe003c7e), SPH_C32(0x5695088b), SPH_C32(0x07c9743b),
    SPH_C32(0x6dd1133c) },
  { SPH_C32(0x88f40000), SPH_C32(0xc28c0000), SPH_C32(0x29b20000),
    SPH_C32(0x24af01f5), SPH_C32(0x27899206), SPH_C32(0x0664da80),
    SPH_C32(0x34220672), SPH_C32(0xe9f03b24), SPH_C32(0xebea0000),
    SPH_C32(0x1bbe0000), SPH_C32(0x3aa20000), SPH_C32(0xea7200ae),
    SPH_C32(0xc366a9fd), SPH_C32(0x490d7801), SPH_C32(0xbcaffc33),
    SPH_C32(0xb756933c) },
  { SPH_C32(0x22800000), SPH_C32(0xbb030000), SPH_C32(0x6b6e0000),
    SPH_C32(0xd6bb01fb), SPH_C32(0x8616008d), SPH_C32(0xce31783b),
    SPH_C32(0x87d72078), SPH_C32(0x86c25aa1), SPH_C32(0x7aff0000),
    SPH_C32(0xcf880000), SPH_C32(0x9e620000), SPH_C32(0x866c00aa),
    SPH_C32(0x28a600bb), SPH_C32(0x788cbd12), SPH_C32(0x22c4c482),
    SPH_C32(0x2a9a9915) },
  { SPH_C32(0x21bd0000), SPH_C32(0xb3b00000), SPH_C32(0x98540000),
    SPH_C32(0xec7901fc), SPH_C32(0xd73f8add), SPH_C32(0xa55f1e24),
    SPH_C32(0x8972ef9b), SPH_C32(0x6018255f), SPH_C32(0xd2250000),
    SPH_C32(0x59360000), SPH_C32(0xc27f0000), SPH_C32(0x81b600a8),
    SPH_C32(0x55c09538), SPH_C32(0x6714cd98), SPH_C32(0x99a24c8a),
    SPH_C32(0xf01d1915) },
  { SPH_C32(0x8a5a0000), SPH_C32(0x2dbd0000), SPH_C32(0x37730000),
    SPH_C32(0xd16101f9), SPH_C32(0xfb70950e), SPH_C32(0xd1a908b1),
    SPH_C32(0x3cb1a870), SPH_C32(0x5c45daa1), SPH_C32(0xd1180000),
    SPH_C32(0x51850000), SPH_C32(0x31450000), SPH_C32(0xbb7400af),
    SPH_C32(0x04e91f68), SPH_C32(0x0c7aab87), SPH_C32(0x97078369),
    SPH_C32(0x16c766eb) },
  { SPH_C32(0x89670000), SPH_C32(0x250e0000), SPH_C32(0xc4490000),
    SPH_C32(0xeba301fe), SPH_C32(0xaa591f5e), SPH_C32(0xbac76eae),
    SPH_C32(0x32146793), SPH_C32(0xba9fa55f), SPH_C32(0x79c20000),
    SPH_C32(0xc73b0000), SPH_C32(0x6d580000), SPH_C32(0xbcae00ad),
    SPH_C32(0x798f8aeb), SPH_C32(0x13e2db0d), SPH_C32(0x2c610b61),
    SPH_C32(0xcc40e6eb) },
  { SPH_C32(0xeed70000), SPH_C32(0xa94f0000), SPH_C32(0x48bd0000),
    SPH_C32(0x01bb01e1), SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0),
    SPH_C32(0x463bbd14), SPH_C32(0x9e150dfa), SPH_C32(0x24c40000),
    SPH_C32(0x7e090000), SPH_C32(0x30370000), SPH_C32(0x2d9300b2),
    SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72), SPH_C32(0x70ec30dc),
    SPH_C32(0xf751dc07) },
  { SPH_C32(0xedea0000), SPH_C32(0xa1fc0000), SPH_C32(0xbb870000),
    SPH_C32(0x3b7901e6), SPH_C32(0xfed56be0), SPH_C32(0xf9b401cf),
    SPH_C32(0x489e72f7), SPH_C32(0x78cf7204), SPH_C32(0x8c1e0000),
    SPH_C32(0xe8b70000), SPH_C32(0x6c2a0000), SPH_C32(0x2a4900b0),
    SPH_C32(0xfd6e9edf), SPH_C32(0xc8a6edf8), SPH_C32(0xcb8ab8d4),
    SPH_C32(0x2dd65c07) },
  { SPH_C32(0x460d0000), SPH_C32(0x3ff10000), SPH_C32(0x14a00000),
    SPH_C32(0x066101e3), SPH_C32(0xd29a7433), SPH_C32(0x8d42175a),
    SPH_C32(0xfd5d351c), SPH_C32(0x44928dfa), SPH_C32(0x8f230000),
    SPH_C32(0xe0040000), SPH_C32(0x9f100000), SPH_C32(0x108b00b7),
    SPH_C32(0xac47148f), SPH_C32(0xa3c88be7), SPH_C32(0xc52f7737),
    SPH_C32(0xcb0c23f9) },
  { SPH_C32(0x45300000), SPH_C32(0x37420000), SPH_C32(0xe79a0000),
    SPH_C32(0x3ca301e4), SPH_C32(0x83b3fe63), SPH_C32(0xe62c7145),
    SPH_C32(0xf3f8faff), SPH_C32(0xa248f204), SPH_C32(0x27f90000),
    SPH_C32(0x76ba0000), SPH_C32(0xc30d0000), SPH_C32(0x175100b5),
    SPH_C32(0xd121810c), SPH_C32(0xbc50fb6d), SPH_C32(0x7e49ff3f),
    SPH_C32(0x118ba3f9) },
  { SPH_C32(0xef440000), SPH_C32(0x4ecd0000), SPH_C32(0xa5460000),
    SPH_C32(0xceb701ea), SPH_C32(0x222c6ce8), SPH_C32(0x2e79d3fe),
    SPH_C32(0x400ddcf5), SPH_C32(0xcd7a9381), SPH_C32(0xb6ec0000),
    SPH_C32(0xa28c0000), SPH_C32(0x67cd0000), SPH_C32(0x7b4f00b1),
    SPH_C32(0x3ae1284a), SPH_C32(0x8dd13e7e), SPH_C32(0xe022c78e),
    SPH_C32(0x8c47a9d0) },
  { SPH_C32(0xec790000), SPH_C32(0x467e0000), SPH_C32(0x567c0000),
    SPH_C32(0xf47501ed), SPH_C32(0x7305e6b8), SPH_C32(0x4517b5e1),
    SPH_C32(0x4ea81316), SPH_C32(0x2ba0ec7f), SPH_C32(0x1e360000),
    SPH_C32(0x34320000), SPH_C32(0x3bd00000), SPH_C32(0x7c9500b3),
    SPH_C32(0x4787bdc9), SPH_C32(0x92494ef4), SPH_C32(0x5b444f86),
    SPH_C32(0x56c029d0) },
  { SPH_C32(0x479e0000), SPH_C32(0xd8730000), SPH_C32(0xf95b0000),
    SPH_C32(0xc96d01e8), SPH_C32(0x5f4af96b), SPH_C32(0x31e1a374),
    SPH_C32(0xfb6b54fd), SPH_C32(0x17fd1381), SPH_C32(0x1d0b0000),
    SPH_C32(0x3c810000), SPH_C32(0xc8ea0000), SPH_C32(0x465700b4),
    SPH_C32(0x16ae3799), SPH_C32(0xf92728eb), SPH_C32(0x55e18065),
    SPH_C32(0xb01a562e) },
  { SPH_C32(0x44a30000), SPH_C32(0xd0c00000), SPH_C32(0x0a610000),
    SPH_C32(0xf3af01ef), SPH_C32(0x0e63733b), SPH_C32(0x5a8fc56b),
    SPH_C32(0xf5ce9b1e), SPH_C32(0xf1276c7f), SPH_C32(0xb5d10000),
    SPH_C32(0xaa3f0000), SPH_C32(0x94f70000), SPH_C32(0x418d00b6),
    SPH_C32(0x6bc8a21a), SPH_C32(0xe6bf5861), SPH_C32(0xee87086d),
    SPH_C32(0x6a9dd62e) },
  { SPH_C32(0x7cff0000), SPH_C32(0x75ca0000), SPH_C32(0x1f470000),
    SPH_C32(0x576701e2), SPH_C32(0x1515c2a6), SPH_C32(0xc835c4dc),
    SPH_C32(0xd6f54a46), SPH_C32(0xe503782d), SPH_C32(0xb77f0000),
    SPH_C32(0x450e0000), SPH_C32(0x8a360000), SPH_C32(0xb44300ba),
    SPH_C32(0xb731a512), SPH_C32(0x31728a50), SPH_C32(0xe614a66f),
    SPH_C32(0xdf2837ab) },
  { SPH_C32(0x7fc20000), SPH_C32(0x7d790000), SPH_C32(0xec7d0000),
    SPH_C32(0x6da501e5), SPH_C32(0x443c48f6), SPH_C32(0xa35ba2c3),
    SPH_C32(0xd85085a5), SPH_C32(0x03d907d3), SPH_C32(0x1fa50000),
    SPH_C32(0xd3b00000), SPH_C32(0xd62b0000), SPH_C32(0xb39900b8),
    SPH_C32(0xca573091), SPH_C32(0x2eeafada), SPH_C32(0x5d722e67),
    SPH_C32(0x05afb7ab) },
  { SPH_C32(0xd4250000), SPH_C32(0xe3740000), SPH_C32(0x435a0000),
    SPH_C32(0x50bd01e0), SPH_C32(0x68735725), SPH_C32(0xd7adb456),
    SPH_C32(0x6d93c24e), SPH_C32(0x3f84f82d), SPH_C32(0x1c980000),
    SPH_C32(0xdb030000), SPH_C32(0x25110000), SPH_C32(0x895b00bf),
    SPH_C32(0x9b7ebac1), SPH_C32(0x45849cc5), SPH_C32(0x53d7e184),
    SPH_C32(0xe375c855) },
  { SPH_C32(0xd7180000), SPH_C32(0xebc70000), SPH_C32(0xb0600000),
    SPH_C32(0x6a7f01e7), SPH_C32(0x395add75), SPH_C32(0xbcc3d249),
    SPH_C32(0x63360dad), SPH_C32(0xd95e87d3), SPH_C32(0xb4420000),
    SPH_C32(0x4dbd0000), SPH_C32(0x790c0000), SPH_C32(0x8e8100bd),
    SPH_C32(0xe6182f42), SPH_C32(0x5a1cec4f), SPH_C32(0xe8b1698c),
    SPH_C32(0x39f24855) },
  { SPH_C32(0x7d6c0000), SPH_C32(0x92480000), SPH_C32(0xf2bc0000),
    SPH_C32(0x986b01e9), SPH_C32(0x98c54ffe), SPH_C32(0x749670f2),
    SPH_C32(0xd0c32ba7), SPH_C32(0xb66ce656), SPH_C32(0x25570000),
    SPH_C32(0x998b0000), SPH_C32(0xddcc0000), SPH_C32(0xe29f00b9),
    SPH_C32(0x0dd88604), SPH_C32(0x6b9d295c), SPH_C32(0x76da513d),
    SPH_C32(0xa43e427c) },
  { SPH_C32(0x7e510000), SPH_C32(0x9afb0000), SPH_C32(0x01860000),
    SPH_C32(0xa2a901ee), SPH_C32(0xc9ecc5ae), SPH_C32(0x1ff816ed),
    SPH_C32(0xde66e444), SPH_C32(0x50b699a8), SPH_C32(0x8d8d0000),
    SPH_C32(0x0f350000), SPH_C32(0x81d10000), SPH_C32(0xe54500bb),
    SPH_C32(0x70be1387), SPH_C32(0x740559d6), SPH_C32(0xcdbcd935),
    SPH_C32(0x7eb9c27c) },
  { SPH_C32(0xd5b60000), SPH_C32(0x04f60000), SPH_C32(0xaea10000),
    SPH_C32(0x9fb101eb), SPH_C32(0xe5a3da7d), SPH_C32(0x6b0e0078),
    SPH_C32(0x6ba5a3af), SPH_C32(0x6ceb6656), SPH_C32(0x8eb00000),
    SPH_C32(0x07860000), SPH_C32(0x72eb0000), SPH_C32(0xdf8700bc),
    SPH_C32(0x219799d7), SPH_C32(0x1f6b3fc9), SPH_C32(0xc31916d6),
    SPH_C32(0x9863bd82) },
  { SPH_C32(0xd68b0000), SPH_C32(0x0c450000), SPH_C32(0x5d9b0000),
    SPH_C32(0xa57301ec), SPH_C32(0xb48a502d), SPH_C32(0x00606667),
    SPH_C32(0x65006c4c), SPH_C32(0x8a3119a8), SPH_C32(0x266a0000),
    SPH_C32(0x91380000), SPH_C32(0x2ef60000), SPH_C32(0xd85d00be),
    SPH_C32(0x5cf10c54), SPH_C32(0x00f34f43), SPH_C32(0x787f9ede),
    SPH_C32(0x42e43d82) },
  { SPH_C32(0xb17f0000), SPH_C32(0xff4c0000), SPH_C32(0x0b130000),
    SPH_C32(0x654801f2), SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e),
    SPH_C32(0x122528ab), SPH_C32(0x10b1d693), SPH_C32(0x24800000),
    SPH_C32(0x01410000), SPH_C32(0xea4b0000), SPH_C32(0x07b000b3),
    SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5), SPH_C32(0x73e6aebc),
    SPH_C32(0x495bbb99) },
  { SPH_C32(0xb2420000), SPH_C32(0xf7ff0000), SPH_C32(0xf8290000),
    SPH_C32(0x5f8a01f5), SPH_C32(0xdbabed5f), SPH_C32(0xeaa59581),
    SPH_C32(0x1c80e748), SPH_C32(0xf66ba96d), SPH_C32(0x8c5a0000),
    SPH_C32(0x97ff0000), SPH_C32(0xb6560000), SPH_C32(0x006a00b1),
    SPH_C32(0xc6c35713), SPH_C32(0x6110717f), SPH_C32(0xc88026b4),
    SPH_C32(0x93dc3b99) },
  { SPH_C32(0x19a50000), SPH_C32(0x69f20000), SPH_C32(0x570e0000),
    SPH_C32(0x629201f0), SPH_C32(0xf7e4f28c), SPH_C32(0x9e538314),
    SPH_C32(0xa943a0a3), SPH_C32(0xca365693), SPH_C32(0x8f670000),
    SPH_C32(0x9f4c0000), SPH_C32(0x456c0000), SPH_C32(0x3aa800b6),
    SPH_C32(0x97eadd43), SPH_C32(0x0a7e1760), SPH_C32(0xc625e957),
    SPH_C32(0x75064467) },
  { SPH_C32(0x1a980000), SPH_C32(0x61410000), SPH_C32(0xa4340000),
    SPH_C32(0x585001f7), SPH_C32(0xa6cd78dc), SPH_C32(0xf53de50b),
    SPH_C32(0xa7e66f40), SPH_C32(0x2cec296d), SPH_C32(0x27bd0000),
    SPH_C32(0x09f20000), SPH_C32(0x19710000), SPH_C32(0x3d7200b4),
    SPH_C32(0xea8c48c0), SPH_C32(0x15e667ea), SPH_C32(0x7d43615f),
    SPH_C32(0xaf81c467) },
  { SPH_C32(0xb0ec0000), SPH_C32(0x18ce0000), SPH_C32(0xe6e80000),
    SPH_C32(0xaa4401f9), SPH_C32(0x0752ea57), SPH_C32(0x3d6847b0),
    SPH_C32(0x1413494a), SPH_C32(0x43de48e8), SPH_C32(0xb6a80000),
    SPH_C32(0xddc40000), SPH_C32(0xbdb10000), SPH_C32(0x516c00b0),
    SPH_C32(0x014ce186), SPH_C32(0x2467a2f9), SPH_C32(0xe32859ee),
    SPH_C32(0x324dce4e) },
  { SPH_C32(0xb3d10000), SPH_C32(0x107d0000), SPH_C32(0x15d20000),
    SPH_C32(0x908601fe), SPH_C32(0x567b6007), SPH_C32(0x560621af),
    SPH_C32(0x1ab686a9), SPH_C32(0xa5043716), SPH_C32(0x1e720000),
    SPH_C32(0x4b7a0000), SPH_C32(0xe1ac0000), SPH_C32(0x56b600b2),
    SPH_C32(0x7c2a7405), SPH_C32(0x3bffd273), SPH_C32(0x584ed1e6),
    SPH_C32(0xe8ca4e4e) },
  { SPH_C32(0x18360000), SPH_C32(0x8e700000), SPH_C32(0xbaf50000),
    SPH_C32(0xad9e01fb), SPH_C32(0x7a347fd4), SPH_C32(0x22f0373a),
    SPH_C32(0xaf75c142), SPH_C32(0x9959c8e8), SPH_C32(0x1d4f0000),
    SPH_C32(0x43c90000), SPH_C32(0x12960000), SPH_C32(0x6c7400b5),
    SPH_C32(0x2d03fe55), SPH_C32(0x5091b46c), SPH_C32(0x56eb1e05),
    SPH_C32(0x0e1031b0) },
  { SPH_C32(0x1b0b0000), SPH_C32(0x86c30000), SPH_C32(0x49cf0000),
    SPH_C32(0x975c01fc), SPH_C32(0x2b1df584), SPH_C32(0x499e5125),
    SPH_C32(0xa1d00ea1), SPH_C32(0x7f83b716), SPH_C32(0xb5950000),
    SPH_C32(0xd5770000), SPH_C32(0x4e8b0000), SPH_C32(0x6bae00b7),
    SPH_C32(0x50656bd6), SPH_C32(0x4f09c4e6), SPH_C32(0xed8d960d),
    SPH_C32(0xd497b1b0) },
  { SPH_C32(0x23570000), SPH_C32(0x23c90000), SPH_C32(0x5ce90000),
    SPH_C32(0x339401f1), SPH_C32(0x306b4419), SPH_C32(0xdb245092),
    SPH_C32(0x82ebdff9), SPH_C32(0x6ba7a344), SPH_C32(0xb73b0000),
    SPH_C32(0x3a460000), SPH_C32(0x504a0000), SPH_C32(0x9e6000bb),
    SPH_C32(0x8c9c6cde), SPH_C32(0x98c416d7), SPH_C32(0xe51e380f),
    SPH_C32(0x61225035) },
  { SPH_C32(0x206a0000), SPH_C32(0x2b7a0000), SPH_C32(0xafd30000),
    SPH_C32(0x095601f6), SPH_C32(0x6142ce49), SPH_C32(0xb04a368d),
    SPH_C32(0x8c4e101a), SPH_C32(0x8d7ddcba), SPH_C32(0x1fe10000),
    SPH_C32(0xacf80000), SPH_C32(0x0c570000), SPH_C32(0x99ba00b9),
    SPH_C32(0xf1faf95d), SPH_C32(0x875c665d), SPH_C32(0x5e78b007),
    SPH_C32(0xbba5d035) },
  { SPH_C32(0x8b8d0000), SPH_C32(0xb5770000), SPH_C32(0x00f40000),
    SPH_C32(0x344e01f3), SPH_C32(0x4d0dd19a), SPH_C32(0xc4bc2018),
    SPH_C32(0x398d57f1), SPH_C32(0xb1202344), SPH_C32(0x1cdc0000),
    SPH_C32(0xa44b0000), SPH_C32(0xff6d0000), SPH_C32(0xa37800be),
    SPH_C32(0xa0d3730d), SPH_C32(0xec320042), SPH_C32(0x50dd7fe4),
    SPH_C32(0x5d7fafcb) },
  { SPH_C32(0x88b00000), SPH_C32(0xbdc40000), SPH_C32(0xf3ce0000),
    SPH_C32(0x0e8c01f4), SPH_C32(0x1c245bca), SPH_C32(0xafd24607),
    SPH_C32(0x37289812), SPH_C32(0x57fa5cba), SPH_C32(0xb4060000),
    SPH_C32(0x32f50000), SPH_C32(0xa3700000), SPH_C32(0xa4a200bc),
    SPH_C32(0xddb5e68e), SPH_C32(0xf3aa70c8), SPH_C32(0xebbbf7ec),
    SPH_C32(0x87f82fcb) },
  { SPH_C32(0x22c40000), SPH_C32(0xc44b0000), SPH_C32(0xb1120000),
    SPH_C32(0xfc9801fa), SPH_C32(0xbdbbc941), SPH_C32(0x6787e4bc),
    SPH_C32(0x84ddbe18), SPH_C32(0x38c83d3f), SPH_C32(0x25130000),
    SPH_C32(0xe6c30000), SPH_C32(0x07b00000), SPH_C32(0xc8bc00b8),
    SPH_C32(0x36754fc8), SPH_C32(0xc22bb5db), SPH_C32(0x75d0cf5d),
    SPH_C32(0x1a3425e2) },
  { SPH_C32(0x21f90000), SPH_C32(0xccf80000), SPH_C32(0x42280000),
    SPH_C32(0xc65a01fd), SPH_C32(0xec924311), SPH_C32(0x0ce982a3),
    SPH_C32(0x8a7871fb), SPH_C32(0xde1242c1), SPH_C32(0x8dc90000),
    SPH_C32(0x707d0000), SPH_C32(0x5bad0000), SPH_C32(0xcf6600ba),
    SPH_C32(0x4b13da4b), SPH_C32(0xddb3c551), SPH_C32(0xceb64755),
    SPH_C32(0xc0b3a5e2) },
  { SPH_C32(0x8a1e0000), SPH_C32(0x52f50000), SPH_C32(0xed0f0000),
    SPH_C32(0xfb4201f8), SPH_C32(0xc0dd5cc2), SPH_C32(0x781f9436),
    SPH_C32(0x3fbb3610), SPH_C32(0xe24fbd3f), SPH_C32(0x8ef40000),
    SPH_C32(0x78ce0000), SPH_C32(0xa8970000), SPH_C32(0xf5a400bd),
    SPH_C32(0x1a3a501b), SPH_C32(0xb6dda34e), SPH_C32(0xc01388b6),
    SPH_C32(0x2669da1c) },
  { SPH_C32(0x89230000), SPH_C32(0x5a460000), SPH_C32(0x1e350000),
    SPH_C32(0xc18001ff), SPH_C32(0x91f4d692), SPH_C32(0x1371f229),
    SPH_C32(0x311ef9f3), SPH_C32(0x0495c2c1), SPH_C32(0x262e0000),
    SPH_C32(0xee700000), SPH_C32(0xf48a0000), SPH_C32(0xf27e00bf),
    SPH_C32(0x675cc598), SPH_C32(0xa945d3c4), SPH_C32(0x7b7500be),
    SPH_C32(0xfcee5a1c) },
  { SPH_C32(0x7b280000), SPH_C32(0x57420000), SPH_C32(0xa9e50000),
    SPH_C32(0x634300a0), SPH_C32(0x9edb442f), SPH_C32(0x6d9995bb),
    SPH_C32(0x27f83b03), SPH_C32(0xc7ff60f0), SPH_C32(0x95bb0000),
    SPH_C32(0x81450000), SPH_C32(0x3b240000), SPH_C32(0x48db0140),
    SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec), SPH_C32(0x62c91877),
    SPH_C32(0xe7e00a94) },
  { SPH_C32(0x78150000), SPH_C32(0x5ff10000), SPH_C32(0x5adf0000),
    SPH_C32(0x598100a7), SPH_C32(0xcff2ce7f), SPH_C32(0x06f7f3a4),
    SPH_C32(0x295df4e0), SPH_C32(0x21251f0e), SPH_C32(0x3d610000),
    SPH_C32(0x17fb0000), SPH_C32(0x67390000), SPH_C32(0x4f010142),
    SPH_C32(0x77ecf9d0), SPH_C32(0x496d1e66), SPH_C32(0xd9af907f),
    SPH_C32(0x3d678a94) },
  { SPH_C32(0xd3f20000), SPH_C32(0xc1fc0000), SPH_C32(0xf5f80000),
    SPH_C32(0x649900a2), SPH_C32(0xe3bdd1ac), SPH_C32(0x7201e531),
    SPH_C32(0x9c9eb30b), SPH_C32(0x1d78e0f0), SPH_C32(0x3e5c0000),
    SPH_C32(0x1f480000), SPH_C32(0x94030000), SPH_C32(0x75c30145),
    SPH_C32(0x26c57380), SPH_C32(0x22037879), SPH_C32(0xd70a5f9c),
    SPH_C32(0xdbbdf56a) },
  { SPH_C32(0xd0cf0000), SPH_C32(0xc94f0000), SPH_C32(0x06c20000),
    SPH_C32(0x5e5b00a5), SPH_C32(0xb2945bfc), SPH_C32(0x196f832e),
    SPH_C32(0x923b7ce8), SPH_C32(0xfba29f0e), SPH_C32(0x96860000),
    SPH_C32(0x89f60000), SPH_C32(0xc81e0000), SPH_C32(0x72190147),
    SPH_C32(0x5ba3e603), SPH_C32(0x3d9b08f3), SPH_C32(0x6c6cd794),
    SPH_C32(0x013a756a) },
  { SPH_C32(0x7abb0000), SPH_C32(0xb0c00000), SPH_C32(0x441e0000),
    SPH_C32(0xac4f00ab), SPH_C32(0x130bc977), SPH_C32(0xd13a2195),
    SPH_C32(0x21ce5ae2), SPH_C32(0x9490fe8b), SPH_C32(0x07930000),
    SPH_C32(0x5dc00000), SPH_C32(0x6cde0000), SPH_C32(0x1e070143),
    SPH_C32(0xb0634f45), SPH_C32(0x0c1acde0), SPH_C32(0xf207ef25),
    SPH_C32(0x9cf67f43) },
  { SPH_C32(0x79860000), SPH_C32(0xb8730000), SPH_C32(0xb7240000),
    SPH_C32(0x968d00ac), SPH_C32(0x42224327), SPH_C32(0xba54478a),
    SPH_C32(0x2f6b9501), SPH_C32(0x724a8175), SPH_C32(0xaf490000),
    SPH_C32(0xcb7e0000), SPH_C32(0x30c30000), SPH_C32(0x19dd0141),
    SPH_C32(0xcd05dac6), SPH_C32(0x1382bd6a), SPH_C32(0x4961672d),
    SPH_C32(0x4671ff43) },
  { SPH_C32(0xd2610000), SPH_C32(0x267e0000), SPH_C32(0x18030000),
    SPH_C32(0xab9500a9), SPH_C32(0x6e6d5cf4), SPH_C32(0xcea2511f),
    SPH_C32(0x9aa8d2ea), SPH_C32(0x4e177e8b), SPH_C32(0xac740000),
    SPH_C32(0xc3cd0000), SPH_C32(0xc3f90000), SPH_C32(0x231f0146),
    SPH_C32(0x9c2c5096), SPH_C32(0x78ecdb75), SPH_C32(0x47c4a8ce),
    SPH_C32(0xa0ab80bd) },
  { SPH_C32(0xd15c0000), SPH_C32(0x2ecd0000), SPH_C32(0xeb390000),
    SPH_C32(0x915700ae), SPH_C32(0x3f44d6a4), SPH_C32(0xa5cc3700),
    SPH_C32(0x940d1d09), SPH_C32(0xa8cd0175), SPH_C32(0x04ae0000),
    SPH_C32(0x55730000), SPH_C32(0x9fe40000), SPH_C32(0x24c50144),
    SPH_C32(0xe14ac515), SPH_C32(0x6774abff), SPH_C32(0xfca220c6),
    SPH_C32(0x7a2c00bd) },
  { SPH_C32(0xe9000000), SPH_C32(0x8bc70000), SPH_C32(0xfe1f0000),
    SPH_C32(0x359f00a3), SPH_C32(0x24326739), SPH_C32(0x377636b7),
    SPH_C32(0xb736cc51), SPH_C32(0xbce91527), SPH_C32(0x06000000),
    SPH_C32(0xba420000), SPH_C32(0x81250000), SPH_C32(0xd10b0148),
    SPH_C32(0x3db3c21d), SPH_C32(0xb0b979ce), SPH_C32(0xf4318ec4),
    SPH_C32(0xcf99e138) },
  { SPH_C32(0xea3d0000), SPH_C32(0x83740000), SPH_C32(0x0d250000),
    SPH_C32(0x0f5d00a4), SPH_C32(0x751bed69), SPH_C32(0x5c1850a8),
    SPH_C32(0xb99303b2), SPH_C32(0x5a336ad9), SPH_C32(0xaeda0000),
    SPH_C32(0x2cfc0000), SPH_C32(0xdd380000), SPH_C32(0xd6d1014a),
    SPH_C32(0x40d5579e), SPH_C32(0xaf210944), SPH_C32(0x4f5706cc),
    SPH_C32(0x151e6138) },
  { SPH_C32(0x41da0000), SPH_C32(0x1d790000), SPH_C32(0xa2020000),
    SPH_C32(0x324500a1), SPH_C32(0x5954f2ba), SPH_C32(0x28ee463d),
    SPH_C32(0x0c504459), SPH_C32(0x666e9527), SPH_C32(0xade70000),
    SPH_C32(0x244f0000), SPH_C32(0x2e020000), SPH_C32(0xec13014d),
    SPH_C32(0x11fcddce), SPH_C32(0xc44f6f5b), SPH_C32(0x41f2c92f),
    SPH_C32(0xf3c41ec6) },
  { SPH_C32(0x42e70000), SPH_C32(0x15ca0000), SPH_C32(0x51380000),
    SPH_C32(0x088700a6), SPH_C32(0x087d78ea), SPH_C32(0x43802022),
    SPH_C32(0x02f58bba), SPH_C32(0x80b4ead9), SPH_C32(0x053d0000),
    SPH_C32(0xb2f10000), SPH_C32(0x721f0000), SPH_C32(0xebc9014f),
    SPH_C32(0x6c9a484d), SPH_C32(0xdbd71fd1), SPH_C32(0xfa944127),
    SPH_C32(0x29439ec6) },
  { SPH_C32(0xe8930000), SPH_C32(0x6c450000), SPH_C32(0x13e40000),
    SPH_C32(0xfa9300a8), SPH_C32(0xa9e2ea61), SPH_C32(0x8bd58299),
    SPH_C32(0xb100adb0), SPH_C32(0xef868b5c), SPH_C32(0x94280000),
    SPH_C32(0x66c70000), SPH_C32(0xd6df0000), SPH_C32(0x87d7014b),
    SPH_C32(0x875ae10b), SPH_C32(0xea56dac2), SPH_C32(0x64ff7996),
    SPH_C32(0xb48f94ef) },
  { SPH_C32(0xebae0000), SPH_C32(0x64f60000), SPH_C32(0xe0de0000),
    SPH_C32(0xc05100af), SPH_C32(0xf8cb6031), SPH_C32(0xe0bbe486),
    SPH_C32(0xbfa56253), SPH_C32(0x095cf4a2), SPH_C32(0x3cf20000),
    SPH_C32(0xf0790000), SPH_C32(0x8ac20000), SPH_C32(0x800d0149),
    SPH_C32(0xfa3c7488), SPH_C32(0xf5ceaa48), SPH_C32(0xdf99f19e),
    SPH_C32(0x6e0814ef) },
  { SPH_C32(0x40490000), SPH_C32(0xfafb0000), SPH_C32(0x4ff90000),
    SPH_C32(0xfd4900aa), SPH_C32(0xd4847fe2), SPH_C32(0x944df213),
    SPH_C32(0x0a6625b8), SPH_C32(0x35010b5c), SPH_C32(0x3fcf0000),
    SPH_C32(0xf8ca0000), SPH_C32(0x79f80000), SPH_C32(0xbacf014e),
    SPH_C32(0xab15fed8), SPH_C32(0x9ea0cc57), SPH_C32(0xd13c3e7d),
    SPH_C32(0x88d26b11) },
  { SPH_C32(0x43740000), SPH_C32(0xf2480000), SPH_C32(0xbcc30000),
    SPH_C32(0xc78b00ad), SPH_C32(0x85adf5b2), SPH_C32(0xff23940c),
    SPH_C32(0x04c3ea5b), SPH_C32(0xd3db74a2), SPH_C32(0x97150000),
    SPH_C32(0x6e740000), SPH_C32(0x25e50000), SPH_C32(0xbd15014c),
    SPH_C32(0xd6736b5b), SPH_C32(0x8138bcdd), SPH_C32(0x6a5ab675),
    SPH_C32(0x5255eb11) },
  { SPH_C32(0x24800000), SPH_C32(0x01410000), SPH_C32(0xea4b0000),
    SPH_C32(0x07b000b3), SPH_C32(0xbba5c290), SPH_C32(0x7e8801f5),
    SPH_C32(0x73e6aebc), SPH_C32(0x495bbb99), SPH_C32(0x95ff0000),
    SPH_C32(0xfe0d0000), SPH_C32(0xe1580000), SPH_C32(0x62f80141),
    SPH_C32(0x3127a59f), SPH_C32(0xff43f26b), SPH_C32(0x61c38617),
    SPH_C32(0x59ea6d0a) },
  { SPH_C32(0x27bd0000), SPH_C32(0x09f20000), SPH_C32(0x19710000),
    SPH_C32(0x3d7200b4), SPH_C32(0xea8c48c0), SPH_C32(0x15e667ea),
    SPH_C32(0x7d43615f), SPH_C32(0xaf81c467), SPH_C32(0x3d250000),
    SPH_C32(0x68b30000), SPH_C32(0xbd450000), SPH_C32(0x65220143),
    SPH_C32(0x4c41301c), SPH_C32(0xe0db82e1), SPH_C32(0xdaa50e1f),
    SPH_C32(0x836ded0a) },
  { SPH_C32(0x8c5a0000), SPH_C32(0x97ff0000), SPH_C32(0xb6560000),
    SPH_C32(0x006a00b1), SPH_C32(0xc6c35713), SPH_C32(0x6110717f),
    SPH_C32(0xc88026b4), SPH_C32(0x93dc3b99), SPH_C32(0x3e180000),
    SPH_C32(0x60000000), SPH_C32(0x4e7f0000), SPH_C32(0x5fe00144),
    SPH_C32(0x1d68ba4c), SPH_C32(0x8bb5e4fe), SPH_C32(0xd400c1fc),
    SPH_C32(0x65b792f4) },
  { SPH_C32(0x8f670000), SPH_C32(0x9f4c0000), SPH_C32(0x456c0000),
    SPH_C32(0x3aa800b6), SPH_C32(0x97eadd43), SPH_C32(0x0a7e1760),
    SPH_C32(0xc625e957), SPH_C32(0x75064467), SPH_C32(0x96c20000),
    SPH_C32(0xf6be0000), SPH_C32(0x12620000), SPH_C32(0x583a0146),
    SPH_C32(0x600e2fcf), SPH_C32(0x942d9474), SPH_C32(0x6f6649f4),
    SPH_C32(0xbf3012f4) },
  { SPH_C32(0x25130000), SPH_C32(0xe6c30000), SPH_C32(0x07b00000),
    SPH_C32(0xc8bc00b8), SPH_C32(0x36754fc8), SPH_C32(0xc22bb5db),
    SPH_C32(0x75d0cf5d), SPH_C32(0x1a3425e2), SPH_C32(0x07d70000),
    SPH_C32(0x22880000), SPH_C32(0xb6a20000), SPH_C32(0x34240142),
    SPH_C32(0x8bce8689), SPH_C32(0xa5ac5167), SPH_C32(0xf10d7145),
    SPH_C32(0x22fc18dd) },
  { SPH_C32(0x262e0000), SPH_C32(0xee700000), SPH_C32(0xf48a0000),
    SPH_C32(0xf27e00bf), SPH_C32(0x675cc598), SPH_C32(0xa945d3c4),
    SPH_C32(0x7b7500be), SPH_C32(0xfcee5a1c), SPH_C32(0xaf0d0000),
    SPH_C32(0xb4360000), SPH_C32(0xeabf0000), SPH_C32(0x33fe0140),
    SPH_C32(0xf6a8130a), SPH_C32(0xba3421ed), SPH_C32(0x4a6bf94d),
    SPH_C32(0xf87b98dd) },
  { SPH_C32(0x8dc90000), SPH_C32(0x707d0000), SPH_C32(0x5bad0000),
    SPH_C32(0xcf6600ba), SPH_C32(0x4b13da4b), SPH_C32(0xddb3c551),
    SPH_C32(0xceb64755), SPH_C32(0xc0b3a5e2), SPH_C32(0xac300000),
    SPH_C32(0xbc850000), SPH_C32(0x19850000), SPH_C32(0x093c0147),
    SPH_C32(0xa781995a), SPH_C32(0xd15a47f2), SPH_C32(0x44ce36ae),
    SPH_C32(0x1ea1e723) },
  { SPH_C32(0x8ef40000), SPH_C32(0x78ce0000), SPH_C32(0xa8970000),
    SPH_C32(0xf5a400bd), SPH_C32(0x1a3a501b), SPH_C32(0xb6dda34e),
    SPH_C32(0xc01388b6), SPH_C32(0x2669da1c), SPH_C32(0x04ea0000),
    SPH_C32(0x2a3b0000), SPH_C32(0x45980000), SPH_C32(0x0ee60145),
    SPH_C32(0xdae70cd9), SPH_C32(0xcec23778), SPH_C32(0xffa8bea6),
    SPH_C32(0xc4266723) },
  { SPH_C32(0xb6a80000), SPH_C32(0xddc40000), SPH_C32(0xbdb10000),
    SPH_C32(0x516c00b0), SPH_C32(0x014ce186), SPH_C32(0x2467a2f9),
    SPH_C32(0xe32859ee), SPH_C32(0x324dce4e), SPH_C32(0x06440000),
    SPH_C32(0xc50a0000), SPH_C32(0x5b590000), SPH_C32(0xfb280149),
    SPH_C32(0x061e0bd1), SPH_C32(0x190fe549), SPH_C32(0xf73b10a4),
    SPH_C32(0x719386a6) },
  { SPH_C32(0xb5950000), SPH_C32(0xd5770000), SPH_C32(0x4e8b0000),
    SPH_C32(0x6bae00b7), SPH_C32(0x50656bd6), SPH_C32(0x4f09c4e6),
    SPH_C32(0xed8d960d), SPH_C32(0xd497b1b0), SPH_C32(0xae9e0000),
    SPH_C32(0x53b40000), SPH_C32(0x07440000), SPH_C32(0xfcf2014b),
    SPH_C32(0x7b789e52), SPH_C32(0x069795c3), SPH_C32(0x4c5d98ac),
    SPH_C32(0xab1406a6) },
  { SPH_C32(0x1e720000), SPH_C32(0x4b7a0000), SPH_C32(0xe1ac0000),
    SPH_C32(0x56b600b2), SPH_C32(0x7c2a7405), SPH_C32(0x3bffd273),
    SPH_C32(0x584ed1e6), SPH_C32(0xe8ca4e4e), SPH_C32(0xada30000),
    SPH_C32(0x5b070000), SPH_C32(0xf47e0000), SPH_C32(0xc630014c),
    SPH_C32(0x2a511402), SPH_C32(0x6df9f3dc), SPH_C32(0x42f8574f),
    SPH_C32(0x4dce7958) },
  { SPH_C32(0x1d4f0000), SPH_C32(0x43c90000), SPH_C32(0x12960000),
    SPH_C32(0x6c7400b5), SPH_C32(0x2d03fe55), SPH_C32(0x5091b46c),
    SPH_C32(0x56eb1e05), SPH_C32(0x0e1031b0), SPH_C32(0x05790000),
    SPH_C32(0xcdb90000), SPH_C32(0xa8630000), SPH_C32(0xc1ea014e),
    SPH_C32(0x57378181), SPH_C32(0x72618356), SPH_C32(0xf99edf47),
    SPH_C32(0x9749f958) },
  { SPH_C32(0xb73b0000), SPH_C32(0x3a460000), SPH_C32(0x504a0000),
    SPH_C32(0x9e6000bb), SPH_C32(0x8c9c6cde), SPH_C32(0x98c416d7),
    SPH_C32(0xe51e380f), SPH_C32(0x61225035), SPH_C32(0x946c0000),
    SPH_C32(0x198f0000), SPH_C32(0x0ca30000), SPH_C32(0xadf4014a),
    SPH_C32(0xbcf728c7), SPH_C32(0x43e04645), SPH_C32(0x67f5e7f6),
    SPH_C32(0x0a85f371) },
  { SPH_C32(0xb4060000), SPH_C32(0x32f50000), SPH_C32(0xa3700000),
    SPH_C32(0xa4a200bc), SPH_C32(0xddb5e68e), SPH_C32(0xf3aa70c8),
    SPH_C32(0xebbbf7ec), SPH_C32(0x87f82fcb), SPH_C32(0x3cb60000),
    SPH_C32(0x8f310000), SPH_C32(0x50be0000), SPH_C32(0xaa2e0148),
    SPH_C32(0xc191bd44), SPH_C32(0x5c7836cf), SPH_C32(0xdc936ffe),
    SPH_C32(0xd0027371) },
  { SPH_C32(0x1fe10000), SPH_C32(0xacf80000), SPH_C32(0x0c570000),
    SPH_C32(0x99ba00b9), SPH_C32(0xf1faf95d), SPH_C32(0x875c665d),
    SPH_C32(0x5e78b007), SPH_C32(0xbba5d035), SPH_C32(0x3f8b0000),
    SPH_C32(0x87820000), SPH_C32(0xa3840000), SPH_C32(0x90ec014f),
    SPH_C32(0x90b83714), SPH_C32(0x371650d0), SPH_C32(0xd236a01d),
    SPH_C32(0x36d80c8f) },
  { SPH_C32(0x1cdc0000), SPH_C32(0xa44b0000), SPH_C32(0xff6d0000),
    SPH_C32(0xa37800be), SPH_C32(0xa0d3730d), SPH_C32(0xec320042),
    SPH_C32(0x50dd7fe4), SPH_C32(0x5d7fafcb), SPH_C32(0x97510000),
    SPH_C32(0x113c0000), SPH_C32(0xff990000), SPH_C32(0x9736014d),
    SPH_C32(0xeddea297), SPH_C32(0x288e205a), SPH_C32(0x69502815),
    SPH_C32(0xec5f8c8f) },
  { SPH_C32(0x7b6c0000), SPH_C32(0x280a0000), SPH_C32(0x73990000),
    SPH_C32(0x496000a1), SPH_C32(0xa5768de3), SPH_C32(0xc42f093c),
    SPH_C32(0x24f2a563), SPH_C32(0x79f5076e), SPH_C32(0xca570000),
    SPH_C32(0xa80e0000), SPH_C32(0xa2f60000), SPH_C32(0x060b0152),
    SPH_C32(0x14592320), SPH_C32(0xec526625), SPH_C32(0x35dd13a8),
    SPH_C32(0xd74eb663) },
  { SPH_C32(0x78510000), SPH_C32(0x20b90000), SPH_C32(0x80a30000),
    SPH_C32(0x73a200a6), SPH_C32(0xf45f07b3), SPH_C32(0xaf416f23),
    SPH_C32(0x2a576a80), SPH_C32(0x9f2f7890), SPH_C32(0x628d0000),
    SPH_C32(0x3eb00000), SPH_C32(0xfeeb0000), SPH_C32(0x01d10150),
    SPH_C32(0x693fb6a3), SPH_C32(0xf3ca16af), SPH_C32(0x8ebb9ba0),
    SPH_C32(0x0dc93663) },
  { SPH_C32(0xd3b60000), SPH_C32(0xbeb40000), SPH_C32(0x2f840000),
    SPH_C32(0x4eba00a3), SPH_C32(0xd8101860), SPH_C32(0xdbb779b6),
    SPH_C32(0x9f942d6b), SPH_C32(0xa372876e), SPH_C32(0x61b00000),
    SPH_C32(0x36030000), SPH_C32(0x0dd10000), SPH_C32(0x3b130157),
    SPH_C32(0x38163cf3), SPH_C32(0x98a470b0), SPH_C32(0x801e5443),
    SPH_C32(0xeb13499d) },
  { SPH_C32(0xd08b0000), SPH_C32(0xb6070000), SPH_C32(0xdcbe0000),
    SPH_C32(0x747800a4), SPH_C32(0x89399230), SPH_C32(0xb0d91fa9),
    SPH_C32(0x9131e288), SPH_C32(0x45a8f890), SPH_C32(0xc96a0000),
    SPH_C32(0xa0bd0000), SPH_C32(0x51cc0000), SPH_C32(0x3cc90155),
    SPH_C32(0x4570a970), SPH_C32(0x873c003a), SPH_C32(0x3b78dc4b),
    SPH_C32(0x3194c99d) },
  { SPH_C32(0x7aff0000), SPH_C32(0xcf880000), SPH_C32(0x9e620000),
    SPH_C32(0x866c00aa), SPH_C32(0x28a600bb), SPH_C32(0x788cbd12),
    SPH_C32(0x22c4c482), SPH_C32(0x2a9a9915), SPH_C32(0x587f0000),
    SPH_C32(0x748b0000), SPH_C32(0xf50c0000), SPH_C32(0x50d70151),
    SPH_C32(0xaeb00036), SPH_C32(0xb6bdc529), SPH_C32(0xa513e4fa),
    SPH_C32(0xac58c3b4) },
  { SPH_C32(0x79c20000), SPH_C32(0xc73b0000), SPH_C32(0x6d580000),
    SPH_C32(0xbcae00ad), SPH_C32(0x798f8aeb), SPH_C32(0x13e2db0d),
    SPH_C32(0x2c610b61), SPH_C32(0xcc40e6eb), SPH_C32(0xf0a50000),
    SPH_C32(0xe2350000), SPH_C32(0xa9110000), SPH_C32(0x570d0153),
    SPH_C32(0xd3d695b5), SPH_C32(0xa925b5a3), SPH_C32(0x1e756cf2),
    SPH_C32(0x76df43b4) },
  { SPH_C32(0xd2250000), SPH_C32(0x59360000), SPH_C32(0xc27f0000),
    SPH_C32(0x81b600a8), SPH_C32(0x55c09538), SPH_C32(0x6714cd98),
    SPH_C32(0x99a24c8a), SPH_C32(0xf01d1915), SPH_C32(0xf3980000),
    SPH_C32(0xea860000), SPH_C32(0x5a2b0000), SPH_C32(0x6dcf0154),
    SPH_C32(0x82ff1fe5), SPH_C32(0xc24bd3bc), SPH_C32(0x10d0a311),
    SPH_C32(0x90053c4a) },
  { SPH_C32(0xd1180000), SPH_C32(0x51850000), SPH_C32(0x31450000),
    SPH_C32(0xbb7400af), SPH_C32(0x04e91f68), SPH_C32(0x0c7aab87),
    SPH_C32(0x97078369), SPH_C32(0x16c766eb), SPH_C32(0x5b420000),
    SPH_C32(0x7c380000), SPH_C32(0x06360000), SPH_C32(0x6a150156),
    SPH_C32(0xff998a66), SPH_C32(0xddd3a336), SPH_C32(0xabb62b19),
    SPH_C32(0x4a82bc4a) },
  { SPH_C32(0xe9440000), SPH_C32(0xf48f0000), SPH_C32(0x24630000),
    SPH_C32(0x1fbc00a2), SPH_C32(0x1f9faef5), SPH_C32(0x9ec0aa30),
    SPH_C32(0xb43c5231), SPH_C32(0x02e372b9), SPH_C32(0x59ec0000),
    SPH_C32(0x93090000), SPH_C32(0x18f70000), SPH_C32(0x9fdb015a),
    SPH_C32(0x23608d6e), SPH_C32(0x0a1e7107), SPH_C32(0xa325851b),
    SPH_C32(0xff375dcf) },
  { SPH_C32(0xea790000), SPH_C32(0xfc3c0000), SPH_C32(0xd7590000),
    SPH_C32(0x257e00a5), SPH_C32(0x4eb624a5), SPH_C32(0xf5aecc2f),
    SPH_C32(0xba999dd2), SPH_C32(0xe4390d47), SPH_C32(0xf1360000),
    SPH_C32(0x05b70000), SPH_C32(0x44ea0000), SPH_C32(0x98010158),
    SPH_C32(0x5e0618ed), SPH_C32(0x1586018d), SPH_C32(0x18430d13),
    SPH_C32(0x25b0ddcf) },
  { SPH_C32(0x419e0000), SPH_C32(0x62310000), SPH_C32(0x787e0000),
    SPH_C32(0x186600a0), SPH_C32(0x62f93b76), SPH_C32(0x8158daba),
    SPH_C32(0x0f5ada39), SPH_C32(0xd864f2b9), SPH_C32(0xf20b0000),
    SPH_C32(0x0d040000), SPH_C32(0xb7d00000), SPH_C32(0xa2c3015f),
    SPH_C32(0x0f2f92bd), SPH_C32(0x7ee86792), SPH_C32(0x16e6c2f0),
    SPH_C32(0xc36aa231) },
  { SPH_C32(0x42a30000), SPH_C32(0x6a820000), SPH_C32(0x8b440000),
    SPH_C32(0x22a400a7), SPH_C32(0x33d0b126), SPH_C32(0xea36bca5),
    SPH_C32(0x01ff15da), SPH_C32(0x3ebe8d47), SPH_C32(0x5ad10000),
    SPH_C32(0x9bba0000), SPH_C32(0xebcd0000), SPH_C32(0xa519015d),
    SPH_C32(0x7249073e), SPH_C32(0x61701718), SPH_C32(0xad804af8),
    SPH_C32(0x19ed2231) },
  { SPH_C32(0xe8d70000), SPH_C32(0x130d0000), SPH_C32(0xc9980000),
    SPH_C32(0xd0b000a9), SPH_C32(0x924f23ad), SPH_C32(0x22631e1e),
    SPH_C32(0xb20a33d0), SPH_C32(0x518cecc2), SPH_C32(0xcbc40000),
    SPH_C32(0x4f8c0000), SPH_C32(0x4f0d0000), SPH_C32(0xc9070159),
    SPH_C32(0x9989ae78), SPH_C32(0x50f1d20b), SPH_C32(0x33eb7249),
    SPH_C32(0x84212818) },
  { SPH_C32(0xebea0000), SPH_C32(0x1bbe0000), SPH_C32(0x3aa20000),
    SPH_C32(0xea7200ae), SPH_C32(0xc366a9fd), SPH_C32(0x490d7801),
    SPH_C32(0xbcaffc33), SPH_C32(0xb756933c), SPH_C32(0x631e0000),
    SPH_C32(0xd9320000), SPH_C32(0x13100000), SPH_C32(0xcedd015b),
    SPH_C32(0xe4ef3bfb), SPH_C32(0x4f69a281), SPH_C32(0x888dfa41),
    SPH_C32(0x5ea6a818) },
  { SPH_C32(0x400d0000), SPH_C32(0x85b30000), SPH_C32(0x95850000),
    SPH_C32(0xd76a00ab), SPH_C32(0xef29b62e), SPH_C32(0x3dfb6e94),
    SPH_C32(0x096cbbd8), SPH_C32(0x8b0b6cc2), SPH_C32(0x60230000),
    SPH_C32(0xd1810000), SPH_C32(0xe02a0000), SPH_C32(0xf41f015c),
    SPH_C32(0xb5c6b1ab), SPH_C32(0x2407c49e), SPH_C32(0x862835a2),
    SPH_C32(0xb87cd7e6) },
  { SPH_C32(0x43300000), SPH_C32(0x8d000000), SPH_C32(0x66bf0000),
    SPH_C32(0xeda800ac), SPH_C32(0xbe003c7e), SPH_C32(0x5695088b),
    SPH_C32(0x07c9743b), SPH_C32(0x6dd1133c), SPH_C32(0xc8f90000),
    SPH_C32(0x473f0000), SPH_C32(0xbc370000), SPH_C32(0xf3c5015e),
    SPH_C32(0xc8a02428), SPH_C32(0x3b9fb414), SPH_C32(0x3d4ebdaa),
    SPH_C32(0x62fb57e6) },
  { SPH_C32(0x24c40000), SPH_C32(0x7e090000), SPH_C32(0x30370000),
    SPH_C32(0x2d9300b2), SPH_C32(0x80080b5c), SPH_C32(0xd73e9d72),
    SPH_C32(0x70ec30dc), SPH_C32(0xf751dc07), SPH_C32(0xca130000),
    SPH_C32(0xd7460000), SPH_C32(0x788a0000), SPH_C32(0x2c280153),
    SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2), SPH_C32(0x36d78dc8),
    SPH_C32(0x6944d1fd) },
  { SPH_C32(0x27f90000), SPH_C32(0x76ba0000), SPH_C32(0xc30d0000),
    SPH_C32(0x175100b5), SPH_C32(0xd121810c), SPH_C32(0xbc50fb6d),
    SPH_C32(0x7e49ff3f), SPH_C32(0x118ba3f9), SPH_C32(0x62c90000),
    SPH_C32(0x41f80000), SPH_C32(0x24970000), SPH_C32(0x2bf20151),
    SPH_C32(0x52927f6f), SPH_C32(0x5a7c8a28), SPH_C32(0x8db105c0),
    SPH_C32(0xb3c351fd) },
  { SPH_C32(0x8c1e0000), SPH_C32(0xe8b70000), SPH_C32(0x6c2a0000),
    SPH_C32(0x2a4900b0), SPH_C32(0xfd6e9edf), SPH_C32(0xc8a6edf8),
    SPH_C32(0xcb8ab8d4), SPH_C32(0x2dd65c07), SPH_C32(0x61f40000),
    SPH_C32(0x494b0000), SPH_C32(0xd7ad0000), SPH_C32(0x11300156),
    SPH_C32(0x03bbf53f), SPH_C32(0x3112ec37), SPH_C32(0x8314ca23),
    SPH_C32(0x55192e03) },
  { SPH_C32(0x8f230000), SPH_C32(0xe0040000), SPH_C32(0x9f100000),
    SPH_C32(0x108b00b7), SPH_C32(0xac47148f), SPH_C32(0xa3c88be7),
    SPH_C32(0xc52f7737), SPH_C32(0xcb0c23f9), SPH_C32(0xc92e0000),
    SPH_C32(0xdff50000), SPH_C32(0x8bb00000), SPH_C32(0x16ea0154),
    SPH_C32(0x7edd60bc), SPH_C32(0x2e8a9cbd), SPH_C32(0x3872422b),
    SPH_C32(0x8f9eae03) },
  { SPH_C32(0x25570000), SPH_C32(0x998b0000), SPH_C32(0xddcc0000),
    SPH_C32(0xe29f00b9), SPH_C32(0x0dd88604), SPH_C32(0x6b9d295c),
    SPH_C32(0x76da513d), SPH_C32(0xa43e427c), SPH_C32(0x583b0000),
    SPH_C32(0x0bc30000), SPH_C32(0x2f700000), SPH_C32(0x7af40150),
    SPH_C32(0x951dc9fa), SPH_C32(0x1f0b59ae), SPH_C32(0xa6197a9a),
    SPH_C32(0x1252a42a) },
  { SPH_C32(0x266a0000), SPH_C32(0x91380000), SPH_C32(0x2ef60000),
    SPH_C32(0xd85d00be), SPH_C32(0x5cf10c54), SPH_C32(0x00f34f43),
    SPH_C32(0x787f9ede), SPH_C32(0x42e43d82), SPH_C32(0xf0e10000),
    SPH_C32(0x9d7d0000), SPH_C32(0x736d0000), SPH_C32(0x7d2e0152),
    SPH_C32(0xe87b5c79), SPH_C32(0x00932924), SPH_C32(0x1d7ff292),
    SPH_C32(0xc8d5242a) },
  { SPH_C32(0x8d8d0000), SPH_C32(0x0f350000), SPH_C32(0x81d10000),
    SPH_C32(0xe54500bb), SPH_C32(0x70be1387), SPH_C32(0x740559d6),
    SPH_C32(0xcdbcd935), SPH_C32(0x7eb9c27c), SPH_C32(0xf3dc0000),
    SPH_C32(0x95ce0000), SPH_C32(0x80570000), SPH_C32(0x47ec0155),
    SPH_C32(0xb952d629), SPH_C32(0x6bfd4f3b), SPH_C32(0x13da3d71),
    SPH_C32(0x2e0f5bd4) },
  { SPH_C32(0x8eb00000), SPH_C32(0x07860000), SPH_C32(0x72eb0000),
    SPH_C32(0xdf8700bc), SPH_C32(0x219799d7), SPH_C32(0x1f6b3fc9),
    SPH_C32(0xc31916d6), SPH_C32(0x9863bd82), SPH_C32(0x5b060000),
    SPH_C32(0x03700000), SPH_C32(0xdc4a0000), SPH_C32(0x40360157),
    SPH_C32(0xc43443aa), SPH_C32(0x74653fb1), SPH_C32(0xa8bcb579),
    SPH_C32(0xf488dbd4) },
  { SPH_C32(0xb6ec0000), SPH_C32(0xa28c0000), SPH_C32(0x67cd0000),
    SPH_C32(0x7b4f00b1), SPH_C32(0x3ae1284a), SPH_C32(0x8dd13e7e),
    SPH_C32(0xe022c78e), SPH_C32(0x8c47a9d0), SPH_C32(0x59a80000),
    SPH_C32(0xec410000), SPH_C32(0xc28b0000), SPH_C32(0xb5f8015b),
    SPH_C32(0x18cd44a2), SPH_C32(0xa3a8ed80), SPH_C32(0xa02f1b7b),
    SPH_C32(0x413d3a51) },
  { SPH_C32(0xb5d10000), SPH_C32(0xaa3f0000), SPH_C32(0x94f70000),
    SPH_C32(0x418d00b6), SPH_C32(0x6bc8a21a), SPH_C32(0xe6bf5861),
    SPH_C32(0xee87086d), SPH_C32(0x6a9dd62e), SPH_C32(0xf1720000),
    SPH_C32(0x7aff0000), SPH_C32(0x9e960000), SPH_C32(0xb2220159),
    SPH_C32(0x65abd121), SPH_C32(0xbc309d0a), SPH_C32(0x1b499373),
    SPH_C32(0x9bbaba51) },
  { SPH_C32(0x1e360000), SPH_C32(0x34320000), SPH_C32(0x3bd00000),
    SPH_C32(0x7c9500b3), SPH_C32(0x4787bdc9), SPH_C32(0x92494ef4),
    SPH_C32(0x5b444f86), SPH_C32(0x56c029d0), SPH_C32(0xf24f0000),
    SPH_C32(0x724c0000), SPH_C32(0x6dac0000), SPH_C32(0x88e0015e),
    SPH_C32(0x34825b71), SPH_C32(0xd75efb15), SPH_C32(0x15ec5c90),
    SPH_C32(0x7d60c5af) },
  { SPH_C32(0x1d0b0000), SPH_C32(0x3c810000), SPH_C32(0xc8ea0000),
    SPH_C32(0x465700b4), SPH_C32(0x16ae3799), SPH_C32(0xf92728eb),
    SPH_C32(0x55e18065), SPH_C32(0xb01a562e), SPH_C32(0x5a950000),
    SPH_C32(0xe4f20000), SPH_C32(0x31b10000), SPH_C32(0x8f3a015c),
    SPH_C32(0x49e4cef2), SPH_C32(0xc8c68b9f), SPH_C32(0xae8ad498),
    SPH_C32(0xa7e745af) },
  { SPH_C32(0xb77f0000), SPH_C32(0x450e0000), SPH_C32(0x8a360000),
    SPH_C32(0xb44300ba), SPH_C32(0xb731a512), SPH_C32(0x31728a50),
    SPH_C32(0xe614a66f), SPH_C32(0xdf2837ab), SPH_C32(0xcb800000),
    SPH_C32(0x30c40000), SPH_C32(0x95710000), SPH_C32(0xe3240158),
    SPH_C32(0xa22467b4), SPH_C32(0xf9474e8c), SPH_C32(0x30e1ec29),
    SPH_C32(0x3a2b4f86) },
  { SPH_C32(0xb4420000), SPH_C32(0x4dbd0000), SPH_C32(0x790c0000),
    SPH_C32(0x8e8100bd), SPH_C32(0xe6182f42), SPH_C32(0x5a1cec4f),
    SPH_C32(0xe8b1698c), SPH_C32(0x39f24855), SPH_C32(0x635a0000),
    SPH_C32(0xa67a0000), SPH_C32(0xc96c0000), SPH_C32(0xe4fe015a),
    SPH_C32(0xdf42f237), SPH_C32(0xe6df3e06), SPH_C32(0x8b876421),
    SPH_C32(0xe0accf86) },
  { SPH_C32(0x1fa50000), SPH_C32(0xd3b00000), SPH_C32(0xd62b0000),
    SPH_C32(0xb39900b8), SPH_C32(0xca573091), SPH_C32(0x2eeafada),
    SPH_C32(0x5d722e67), SPH_C32(0x05afb7ab), SPH_C32(0x60670000),
    SPH_C32(0xaec90000), SPH_C32(0x3a560000), SPH_C32(0xde3c015d),
    SPH_C32(0x8e6b7867), SPH_C32(0x8db15819), SPH_C32(0x8522abc2),
    SPH_C32(0x0676b078) },
  { SPH_C32(0x1c980000), SPH_C32(0xdb030000), SPH_C32(0x25110000),
    SPH_C32(0x895b00bf), SPH_C32(0x9b7ebac1), SPH_C32(0x45849cc5),
    SPH_C32(0x53d7e184), SPH_C32(0xe375c855), SPH_C32(0xc8bd0000),
    SPH_C32(0x38770000), SPH_C32(0x664b0000), SPH_C32(0xd9e6015f),
    SPH_C32(0xf30dede4), SPH_C32(0x92292893), SPH_C32(0x3e4423ca),
    SPH_C32(0xdcf13078) },
  { SPH_C32(0x95bb0000), SPH_C32(0x81450000), SPH_C32(0x3b240000),
    SPH_C32(0x48db0140), SPH_C32(0x0a8a6c53), SPH_C32(0x56f56eec),
    SPH_C32(0x62c91877), SPH_C32(0xe7e00a94), SPH_C32(0xee930000),
    SPH_C32(0xd6070000), SPH_C32(0x92c10000), SPH_C32(0x2b9801e0),
    SPH_C32(0x9451287c), SPH_C32(0x3b6cfb57), SPH_C32(0x45312374),
    SPH_C32(0x201f6a64) },
  { SPH_C32(0x96860000), SPH_C32(0x89f60000), SPH_C32(0xc81e0000),
    SPH_C32(0x72190147), SPH_C32(0x5ba3e603), SPH_C32(0x3d9b08f3),
    SPH_C32(0x6c6cd794), SPH_C32(0x013a756a), SPH_C32(0x46490000),
    SPH_C32(0x40b90000), SPH_C32(0xcedc0000), SPH_C32(0x2c4201e2),
    SPH_C32(0xe937bdff), SPH_C32(0x24f48bdd), SPH_C32(0xfe57ab7c),
    SPH_C32(0xfa98ea64) },
  { SPH_C32(0x3d610000), SPH_C32(0x17fb0000), SPH_C32(0x67390000),
    SPH_C32(0x4f010142), SPH_C32(0x77ecf9d0), SPH_C32(0x496d1e66),
    SPH_C32(0xd9af907f), SPH_C32(0x3d678a94), SPH_C32(0x45740000),
    SPH_C32(0x480a0000), SPH_C32(0x3de60000), SPH_C32(0x168001e5),
    SPH_C32(0xb81e37af), SPH_C32(0x4f9aedc2), SPH_C32(0xf0f2649f),
    SPH_C32(0x1c42959a) },
  { SPH_C32(0x3e5c0000), SPH_C32(0x1f480000), SPH_C32(0x94030000),
    SPH_C32(0x75c30145), SPH_C32(0x26c57380), SPH_C32(0x22037879),
    SPH_C32(0xd70a5f9c), SPH_C32(0xdbbdf56a), SPH_C32(0xedae0000),
    SPH_C32(0xdeb40000), SPH_C32(0x61fb0000), SPH_C32(0x115a01e7),
    SPH_C32(0xc578a22c), SPH_C32(0x50029d48), SPH_C32(0x4b94ec97),
    SPH_C32(0xc6c5159a) },
  { SPH_C32(0x94280000), SPH_C32(0x66c70000), SPH_C32(0xd6df0000),
    SPH_C32(0x87d7014b), SPH_C32(0x875ae10b), SPH_C32(0xea56dac2),
    SPH_C32(0x64ff7996), SPH_C32(0xb48f94ef), SPH_C32(0x7cbb0000),
    SPH_C32(0x0a820000), SPH_C32(0xc53b0000), SPH_C32(0x7d4401e3),
    SPH_C32(0x2eb80b6a), SPH_C32(0x6183585b), SPH_C32(0xd5ffd426),
    SPH_C32(0x5b091fb3) },
  { SPH_C32(0x97150000), SPH_C32(0x6e740000), SPH_C32(0x25e50000),
    SPH_C32(0xbd15014c), SPH_C32(0xd6736b5b), SPH_C32(0x8138bcdd),
    SPH_C32(0x6a5ab675), SPH_C32(0x5255eb11), SPH_C32(0xd4610000),
    SPH_C32(0x9c3c0000), SPH_C32(0x99260000), SPH_C32(0x7a9e01e1),
    SPH_C32(0x53de9ee9), SPH_C32(0x7e1b28d1), SPH_C32(0x6e995c2e),
    SPH_C32(0x818e9fb3) },
  { SPH_C32(0x3cf20000), SPH_C32(0xf0790000), SPH_C32(0x8ac20000),
    SPH_C32(0x800d0149), SPH_C32(0xfa3c7488), SPH_C32(0xf5ceaa48),
    SPH_C32(0xdf99f19e), SPH_C32(0x6e0814ef), SPH_C32(0xd75c0000),
    SPH_C32(0x948f0000), SPH_C32(0x6a1c0000), SPH_C32(0x405c01e6),
    SPH_C32(0x02f714b9), SPH_C32(0x15754ece), SPH_C32(0x603c93cd),
    SPH_C32(0x6754e04d) },
  { SPH_C32(0x3fcf0000), SPH_C32(0xf8ca0000), SPH_C32(0x79f80000),
    SPH_C32(0xbacf014e), SPH_C32(0xab15fed8), SPH_C32(0x9ea0cc57),
    SPH_C32(0xd13c3e7d), SPH_C32(0x88d26b11), SPH_C32(0x7f860000),
    SPH_C32(0x02310000), SPH_C32(0x36010000), SPH_C32(0x478601e4),
    SPH_C32(0x7f91813a), SPH_C32(0x0aed3e44), SPH_C32(0xdb5a1bc5),
    SPH_C32(0xbdd3604d) },
  { SPH_C32(0x07930000), SPH_C32(0x5dc00000), SPH_C32(0x6cde0000),
    SPH_C32(0x1e070143), SPH_C32(0xb0634f45), SPH_C32(0x0c1acde0),
    SPH_C32(0xf207ef25), SPH_C32(0x9cf67f43), SPH_C32(0x7d280000),
    SPH_C32(0xed000000), SPH_C32(0x28c00000), SPH_C32(0xb24801e8),
    SPH_C32(0xa3688632), SPH_C32(0xdd20ec75), SPH_C32(0xd3c9b5c7),
    SPH_C32(0x086681c8) },
  { SPH_C32(0x04ae0000), SPH_C32(0x55730000), SPH_C32(0x9fe40000),
    SPH_C32(0x24c50144), SPH_C32(0xe14ac515), SPH_C32(0x6774abff),
    SPH_C32(0xfca220c6), SPH_C32(0x7a2c00bd), SPH_C32(0xd5f20000),
    SPH_C32(0x7bbe0000), SPH_C32(0x74dd0000), SPH_C32(0xb59201ea),
    SPH_C32(0xde0e13b1), SPH_C32(0xc2b89cff), SPH_C32(0x68af3dcf),
    SPH_C32(0xd2e101c8) },
  { SPH_C32(0xaf490000), SPH_C32(0xcb7e0000), SPH_C32(0x30c30000),
    SPH_C32(0x19dd0141), SPH_C32(0xcd05dac6), SPH_C32(0x1382bd6a),
    SPH_C32(0x4961672d), SPH_C32(0x4671ff43), SPH_C32(0xd6cf0000),
    SPH_C32(0x730d0000), SPH_C32(0x87e70000), SPH_C32(0x8f5001ed),
    SPH_C32(0x8f2799e1), SPH_C32(0xa9d6fae0), SPH_C32(0x660af22c),
    SPH_C32(0x343b7e36) },
  { SPH_C32(0xac740000), SPH_C32(0xc3cd0000), SPH_C32(0xc3f90000),
    SPH_C32(0x231f0146), SPH_C32(0x9c2c5096), SPH_C32(0x78ecdb75),
    SPH_C32(0x47c4a8ce), SPH_C32(0xa0ab80bd), SPH_C32(0x7e150000),
    SPH_C32(0xe5b30000), SPH_C32(0xdbfa0000), SPH_C32(0x888a01ef),
    SPH_C32(0xf2410c62), SPH_C32(0xb64e8a6a), SPH_C32(0xdd6c7a24),
    SPH_C32(0xeebcfe36) },
  { SPH_C32(0x06000000), SPH_C32(0xba420000), SPH_C32(0x81250000),
    SPH_C32(0xd10b0148), SPH_C32(0x3db3c21d), SPH_C32(0xb0b979ce),
    SPH_C32(0xf4318ec4), SPH_C32(0xcf99e138), SPH_C32(0xef000000),
    SPH_C32(0x31850000), SPH_C32(0x7f3a0000), SPH_C32(0xe49401eb),
    SPH_C32(0x1981a524), SPH_C32(0x87cf4f79), SPH_C32(0x43074295),
    SPH_C32(0x7370f41f) },
  { SPH_C32(0x053d0000), SPH_C32(0xb2f10000), SPH_C32(0x721f0000),
    SPH_C32(0xebc9014f), SPH_C32(0x6c9a484d), SPH_C32(0xdbd71fd1),
    SPH_C32(0xfa944127), SPH_C32(0x29439ec6), SPH_C32(0x47da0000),
    SPH_C32(0xa73b0000), SPH_C32(0x23270000), SPH_C32(0xe34e01e9),
    SPH_C32(0x64e730a7), SPH_C32(0x98573ff3), SPH_C32(0xf861ca9d),
    SPH_C32(0xa9f7741f) },
  { SPH_C32(0xaeda0000), SPH_C32(0x2cfc0000), SPH_C32(0xdd380000),
    SPH_C32(0xd6d1014a), SPH_C32(0x40d5579e), SPH_C32(0xaf210944),
    SPH_C32(0x4f5706cc), SPH_C32(0x151e6138), SPH_C32(0x44e70000),
    SPH_C32(0xaf880000), SPH_C32(0xd01d0000), SPH_C32(0xd98c01ee),
    SPH_C32(0x35cebaf7), SPH_C32(0xf33959ec), SPH_C32(0xf6c4057e),
    SPH_C32(0x4f2d0be1) },
  { SPH_C32(0xade70000), SPH_C32(0x244f0000), SPH_C32(0x2e020000),
    SPH_C32(0xec13014d), SPH_C32(0x11fcddce), SPH_C32(0xc44f6f5b),
    SPH_C32(0x41f2c92f), SPH_C32(0xf3c41ec6), SPH_C32(0xec3d0000),
    SPH_C32(0x39360000), SPH_C32(0x8c000000), SPH_C32(0xde5601ec),
    SPH_C32(0x48a82f74), SPH_C32(0xeca12966), SPH_C32(0x4da28d76),
    SPH_C32(0x95aa8be1) },
  { SPH_C32(0xca130000), SPH_C32(0xd7460000), SPH_C32(0x788a0000),
    SPH_C32(0x2c280153), SPH_C32(0x2ff4eaec), SPH_C32(0x45e4faa2),
    SPH_C32(0x36d78dc8), SPH_C32(0x6944d1fd), SPH_C32(0xeed70000),
    SPH_C32(0xa94f0000), SPH_C32(0x48bd0000), SPH_C32(0x01bb01e1),
    SPH_C32(0xaffce1b0), SPH_C32(0x92da67d0), SPH_C32(0x463bbd14),
    SPH_C32(0x9e150dfa) },
  { SPH_C32(0xc92e0000), SPH_C32(0xdff50000), SPH_C32(0x8bb00000),
    SPH_C32(0x16ea0154), SPH_C32(0x7edd60bc), SPH_C32(0x2e8a9cbd),
    SPH_C32(0x3872422b), SPH_C32(0x8f9eae03), SPH_C32(0x460d0000),
    SPH_C32(0x3ff10000), SPH_C32(0x14a00000), SPH_C32(0x066101e3),
    SPH_C32(0xd29a7433), SPH_C32(0x8d42175a), SPH_C32(0xfd5d351c),
    SPH_C32(0x44928dfa) },
  { SPH_C32(0x62c90000), SPH_C32(0x41f80000), SPH_C32(0x24970000),
    SPH_C32(0x2bf20151), SPH_C32(0x52927f6f), SPH_C32(0x5a7c8a28),
    SPH_C32(0x8db105c0), SPH_C32(0xb3c351fd), SPH_C32(0x45300000),
    SPH_C32(0x37420000), SPH_C32(0xe79a0000), SPH_C32(0x3ca301e4),
    SPH_C32(0x83b3fe63), SPH_C32(0xe62c7145), SPH_C32(0xf3f8faff),
    SPH_C32(0xa248f204) },
  { SPH_C32(0x61f40000), SPH_C32(0x494b0000), SPH_C32(0xd7ad0000),
    SPH_C32(0x11300156), SPH_C32(0x03bbf53f), SPH_C32(0x3112ec37),
    SPH_C32(0x8314ca23), SPH_C32(0x55192e03), SPH_C32(0xedea0000),
    SPH_C32(0xa1fc0000), SPH_C32(0xbb870000), SPH_C32(0x3b7901e6),
    SPH_C32(0xfed56be0), SPH_C32(0xf9b401cf), SPH_C32(0x489e72f7),
    SPH_C32(0x78cf7204) },
  { SPH_C32(0xcb800000), SPH_C32(0x30c40000), SPH_C32(0x95710000),
    SPH_C32(0xe3240158), SPH_C32(0xa22467b4), SPH_C32(0xf9474e8c),
    SPH_C32(0x30e1ec29), SPH_C32(0x3a2b4f86), SPH_C32(0x7cff0000),
    SPH_C32(0x75ca0000), SPH_C32(0x1f470000), SPH_C32(0x576701e2),
    SPH_C32(0x1515c2a6), SPH_C32(0xc835c4dc), SPH_C32(0xd6f54a46),
    SPH_C32(0xe503782d) },
  { SPH_C32(0xc8bd0000), SPH_C32(0x38770000), SPH_C32(0x664b0000),
    SPH_C32(0xd9e6015f), SPH_C32(0xf30dede4), SPH_C32(0x92292893),
    SPH_C32(0x3e4423ca), SPH_C32(0xdcf13078), SPH_C32(0xd4250000),
    SPH_C32(0xe3740000), SPH_C32(0x435a0000), SPH_C32(0x50bd01e0),
    SPH_C32(0x68735725), SPH_C32(0xd7adb456), SPH_C32(0x6d93c24e),
    SPH_C32(0x3f84f82d) },
  { SPH_C32(0x635a0000), SPH_C32(0xa67a0000), SPH_C32(0xc96c0000),
    SPH_C32(0xe4fe015a), SPH_C32(0xdf42f237), SPH_C32(0xe6df3e06),
    SPH_C32(0x8b876421), SPH_C32(0xe0accf86), SPH_C32(0xd7180000),
    SPH_C32(0xebc70000), SPH_C32(0xb0600000), SPH_C32(0x6a7f01e7),
    SPH_C32(0x395add75), SPH_C32(0xbcc3d249), SPH_C32(0x63360dad),
    SPH_C32(0xd95e87d3) },
  { SPH_C32(0x60670000), SPH_C32(0xaec90000), SPH_C32(0x3a560000),
    SPH_C32(0xde3c015d), SPH_C32(0x8e6b7867), SPH_C32(0x8db15819),
    SPH_C32(0x8522abc2), SPH_C32(0x0676b078), SPH_C32(0x7fc20000),
    SPH_C32(0x7d790000), SPH_C32(0xec7d0000), SPH_C32(0x6da501e5),
    SPH_C32(0x443c48f6), SPH_C32(0xa35ba2c3), SPH_C32(0xd85085a5),
    SPH_C32(0x03d907d3) },
  { SPH_C32(0x583b0000), SPH_C32(0x0bc30000), SPH_C32(0x2f700000),
    SPH_C32(0x7af40150), SPH_C32(0x951dc9fa), SPH_C32(0x1f0b59ae),
    SPH_C32(0xa6197a9a), SPH_C32(0x1252a42a), SPH_C32(0x7d6c0000),
    SPH_C32(0x92480000), SPH_C32(0xf2bc0000), SPH_C32(0x986b01e9),
    SPH_C32(0x98c54ffe), SPH_C32(0x749670f2), SPH_C32(0xd0c32ba7),
    SPH_C32(0xb66ce656) },
  { SPH_C32(0x5b060000), SPH_C32(0x03700000), SPH_C32(0xdc4a0000),
    SPH_C32(0x40360157), SPH_C32(0xc43443aa), SPH_C32(0x74653fb1),
    SPH_C32(0xa8bcb579), SPH_C32(0xf488dbd4), SPH_C32(0xd5b60000),
    SPH_C32(0x04f60000), SPH_C32(0xaea10000), SPH_C32(0x9fb101eb),
    SPH_C32(0xe5a3da7d), SPH_C32(0x6b0e0078), SPH_C32(0x6ba5a3af),
    SPH_C32(0x6ceb6656) },
  { SPH_C32(0xf0e10000), SPH_C32(0x9d7d0000), SPH_C32(0x736d0000),
    SPH_C32(0x7d2e0152), SPH_C32(0xe87b5c79), SPH_C32(0x00932924),
    SPH_C32(0x1d7ff292), SPH_C32(0xc8d5242a), SPH_C32(0xd68b0000),
    SPH_C32(0x0c450000), SPH_C32(0x5d9b0000), SPH_C32(0xa57301ec),
    SPH_C32(0xb48a502d), SPH_C32(0x00606667), SPH_C32(0x65006c4c),
    SPH_C32(0x8a3119a8) },
  { SPH_C32(0xf3dc0000), SPH_C32(0x95ce0000), SPH_C32(0x80570000),
    SPH_C32(0x47ec0155), SPH_C32(0xb952d629), SPH_C32(0x6bfd4f3b),
    SPH_C32(0x13da3d71), SPH_C32(0x2e0f5bd4), SPH_C32(0x7e510000),
    SPH_C32(0x9afb0000), SPH_C32(0x01860000), SPH_C32(0xa2a901ee),
    SPH_C32(0xc9ecc5ae), SPH_C32(0x1ff816ed), SPH_C32(0xde66e444),
    SPH_C32(0x50b699a8) },
  { SPH_C32(0x59a80000), SPH_C32(0xec410000), SPH_C32(0xc28b0000),
    SPH_C32(0xb5f8015b), SPH_C32(0x18cd44a2), SPH_C32(0xa3a8ed80),
    SPH_C32(0xa02f1b7b), SPH_C32(0x413d3a51), SPH_C32(0xef440000),
    SPH_C32(0x4ecd0000), SPH_C32(0xa5460000), SPH_C32(0xceb701ea),
    SPH_C32(0x222c6ce8), SPH_C32(0x2e79d3fe), SPH_C32(0x400ddcf5),
    SPH_C32(0xcd7a9381) },
  { SPH_C32(0x5a950000), SPH_C32(0xe4f20000), SPH_C32(0x31b10000),
    SPH_C32(0x8f3a015c), SPH_C32(0x49e4cef2), SPH_C32(0xc8c68b9f),
    SPH_C32(0xae8ad498), SPH_C32(0xa7e745af), SPH_C32(0x479e0000),
    SPH_C32(0xd8730000), SPH_C32(0xf95b0000), SPH_C32(0xc96d01e8),
    SPH_C32(0x5f4af96b), SPH_C32(0x31e1a374), SPH_C32(0xfb6b54fd),
    SPH_C32(0x17fd1381) },
  { SPH_C32(0xf1720000), SPH_C32(0x7aff0000), SPH_C32(0x9e960000),
    SPH_C32(0xb2220159), SPH_C32(0x65abd121), SPH_C32(0xbc309d0a),
    SPH_C32(0x1b499373), SPH_C32(0x9bbaba51), SPH_C32(0x44a30000),
    SPH_C32(0xd0c00000), SPH_C32(0x0a610000), SPH_C32(0xf3af01ef),
    SPH_C32(0x0e63733b), SPH_C32(0x5a8fc56b), SPH_C32(0xf5ce9b1e),
    SPH_C32(0xf1276c7f) },
  { SPH_C32(0xf24f0000), SPH_C32(0x724c0000), SPH_C32(0x6dac0000),
    SPH_C32(0x88e0015e), SPH_C32(0x34825b71), SPH_C32(0xd75efb15),
    SPH_C32(0x15ec5c90), SPH_C32(0x7d60c5af), SPH_C32(0xec790000),
    SPH_C32(0x467e0000), SPH_C32(0x567c0000), SPH_C32(0xf47501ed),
    SPH_C32(0x7305e6b8), SPH_C32(0x4517b5e1), SPH_C32(0x4ea81316),
    SPH_C32(0x2ba0ec7f) },
  { SPH_C32(0x95ff0000), SPH_C32(0xfe0d0000), SPH_C32(0xe1580000),
    SPH_C32(0x62f80141), SPH_C32(0x3127a59f), SPH_C32(0xff43f26b),
    SPH_C32(0x61c38617), SPH_C32(0x59ea6d0a), SPH_C32(0xb17f0000),
    SPH_C32(0xff4c0000), SPH_C32(0x0b130000), SPH_C32(0x654801f2),
    SPH_C32(0x8a82670f), SPH_C32(0x81cbf39e), SPH_C32(0x122528ab),
    SPH_C32(0x10b1d693) },
  { SPH_C32(0x96c20000), SPH_C32(0xf6be0000), SPH_C32(0x12620000),
    SPH_C32(0x583a0146), SPH_C32(0x600e2fcf), SPH_C32(0x942d9474),
    SPH_C32(0x6f6649f4), SPH_C32(0xbf3012f4), SPH_C32(0x19a50000),
    SPH_C32(0x69f20000), SPH_C32(0x570e0000), SPH_C32(0x629201f0),
    SPH_C32(0xf7e4f28c), SPH_C32(0x9e538314), SPH_C32(0xa943a0a3),
    SPH_C32(0xca365693) },
  { SPH_C32(0x3d250000), SPH_C32(0x68b30000), SPH_C32(0xbd450000),
    SPH_C32(0x65220143), SPH_C32(0x4c41301c), SPH_C32(0xe0db82e1),
    SPH_C32(0xdaa50e1f), SPH_C32(0x836ded0a), SPH_C32(0x1a980000),
    SPH_C32(0x61410000), SPH_C32(0xa4340000), SPH_C32(0x585001f7),
    SPH_C32(0xa6cd78dc), SPH_C32(0xf53de50b), SPH_C32(0xa7e66f40),
    SPH_C32(0x2cec296d) },
  { SPH_C32(0x3e180000), SPH_C32(0x60000000), SPH_C32(0x4e7f0000),
    SPH_C32(0x5fe00144), SPH_C32(0x1d68ba4c), SPH_C32(0x8bb5e4fe),
    SPH_C32(0xd400c1fc), SPH_C32(0x65b792f4), SPH_C32(0xb2420000),
    SPH_C32(0xf7ff0000), SPH_C32(0xf8290000), SPH_C32(0x5f8a01f5),
    SPH_C32(0xdbabed5f), SPH_C32(0xeaa59581), SPH_C32(0x1c80e748),
    SPH_C32(0xf66ba96d) },
  { SPH_C32(0x946c0000), SPH_C32(0x198f0000), SPH_C32(0x0ca30000),
    SPH_C32(0xadf4014a), SPH_C32(0xbcf728c7), SPH_C32(0x43e04645),
    SPH_C32(0x67f5e7f6), SPH_C32(0x0a85f371), SPH_C32(0x23570000),
    SPH_C32(0x23c90000), SPH_C32(0x5ce90000), SPH_C32(0x339401f1),
    SPH_C32(0x306b4419), SPH_C32(0xdb245092), SPH_C32(0x82ebdff9),
    SPH_C32(0x6ba7a344) },
  { SPH_C32(0x97510000), SPH_C32(0x113c0000), SPH_C32(0xff990000),
    SPH_C32(0x9736014d), SPH_C32(0xeddea297), SPH_C32(0x288e205a),
    SPH_C32(0x69502815), SPH_C32(0xec5f8c8f), SPH_C32(0x8b8d0000),
    SPH_C32(0xb5770000), SPH_C32(0x00f40000), SPH_C32(0x344e01f3),
    SPH_C32(0x4d0dd19a), SPH_C32(0xc4bc2018), SPH_C32(0x398d57f1),
    SPH_C32(0xb1202344) },
  { SPH_C32(0x3cb60000), SPH_C32(0x8f310000), SPH_C32(0x50be0000),
    SPH_C32(0xaa2e0148), SPH_C32(0xc191bd44), SPH_C32(0x5c7836cf),
    SPH_C32(0xdc936ffe), SPH_C32(0xd0027371), SPH_C32(0x88b00000),
    SPH_C32(0xbdc40000), SPH_C32(0xf3ce0000), SPH_C32(0x0e8c01f4),
    SPH_C32(0x1c245bca), SPH_C32(0xafd24607), SPH_C32(0x37289812),
    SPH_C32(0x57fa5cba) },
  { SPH_C32(0x3f8b0000), SPH_C32(0x87820000), SPH_C32(0xa3840000),
    SPH_C32(0x90ec014f), SPH_C32(0x90b83714), SPH_C32(0x371650d0),
    SPH_C32(0xd236a01d), SPH_C32(0x36d80c8f), SPH_C32(0x206a0000),
    SPH_C32(0x2b7a0000), SPH_C32(0xafd30000), SPH_C32(0x095601f6),
    SPH_C32(0x6142ce49), SPH_C32(0xb04a368d), SPH_C32(0x8c4e101a),
    SPH_C32(0x8d7ddcba) },
  { SPH_C32(0x07d70000), SPH_C32(0x22880000), SPH_C32(0xb6a20000),
    SPH_C32(0x34240142), SPH_C32(0x8bce8689), SPH_C32(0xa5ac5167),
    SPH_C32(0xf10d7145), SPH_C32(0x22fc18dd), SPH_C32(0x22c40000),
    SPH_C32(0xc44b0000), SPH_C32(0xb1120000), SPH_C32(0xfc9801fa),
    SPH_C32(0xbdbbc941), SPH_C32(0x6787e4bc), SPH_C32(0x84ddbe18),
    SPH_C32(0x38c83d3f) },
  { SPH_C32(0x04ea0000), SPH_C32(0x2a3b0000), SPH_C32(0x45980000),
    SPH_C32(0x0ee60145), SPH_C32(0xdae70cd9), SPH_C32(0xcec23778),
    SPH_C32(0xffa8bea6), SPH_C32(0xc4266723), SPH_C32(0x8a1e0000),
    SPH_C32(0x52f50000), SPH_C32(0xed0f0000), SPH_C32(0xfb4201f8),
    SPH_C32(0xc0dd5cc2), SPH_C32(0x781f9436), SPH_C32(0x3fbb3610),
    SPH_C32(0xe24fbd3f) },
  { SPH_C32(0xaf0d0000), SPH_C32(0xb4360000), SPH_C32(0xeabf0000),
    SPH_C32(0x33fe0140), SPH_C32(0xf6a8130a), SPH_C32(0xba3421ed),
    SPH_C32(0x4a6bf94d), SPH_C32(0xf87b98dd), SPH_C32(0x89230000),
    SPH_C32(0x5a460000), SPH_C32(0x1e350000), SPH_C32(0xc18001ff),
    SPH_C32(0x91f4d692), SPH_C32(0x1371f229), SPH_C32(0x311ef9f3),
    SPH_C32(0x0495c2c1) },
  { SPH_C32(0xac300000), SPH_C32(0xbc850000), SPH_C32(0x19850000),
    SPH_C32(0x093c0147), SPH_C32(0xa781995a), SPH_C32(0xd15a47f2),
    SPH_C32(0x44ce36ae), SPH_C32(0x1ea1e723), SPH_C32(0x21f90000),
    SPH_C32(0xccf80000), SPH_C32(0x42280000), SPH_C32(0xc65a01fd),
    SPH_C32(0xec924311), SPH_C32(0x0ce982a3), SPH_C32(0x8a7871fb),
    SPH_C32(0xde1242c1) },
  { SPH_C32(0x06440000), SPH_C32(0xc50a0000), SPH_C32(0x5b590000),
    SPH_C32(0xfb280149), SPH_C32(0x061e0bd1), SPH_C32(0x190fe549),
    SPH_C32(0xf73b10a4), SPH_C32(0x719386a6), SPH_C32(0xb0ec0000),
    SPH_C32(0x18ce0000), SPH_C32(0xe6e80000), SPH_C32(0xaa4401f9),
    SPH_C32(0x0752ea57), SPH_C32(0x3d6847b0), SPH_C32(0x1413494a),
    SPH_C32(0x43de48e8) },
  { SPH_C32(0x05790000), SPH_C32(0xcdb90000), SPH_C32(0xa8630000),
    SPH_C32(0xc1ea014e), SPH_C32(0x57378181), SPH_C32(0x72618356),
    SPH_C32(0xf99edf47), SPH_C32(0x9749f958), SPH_C32(0x18360000),
    SPH_C32(0x8e700000), SPH_C32(0xbaf50000), SPH_C32(0xad9e01fb),
    SPH_C32(0x7a347fd4), SPH_C32(0x22f0373a), SPH_C32(0xaf75c142),
    SPH_C32(0x9959c8e8) },
  { SPH_C32(0xae9e0000), SPH_C32(0x53b40000), SPH_C32(0x07440000),
    SPH_C32(0xfcf2014b), SPH_C32(0x7b789e52), SPH_C32(0x069795c3),
    SPH_C32(0x4c5d98ac), SPH_C32(0xab1406a6), SPH_C32(0x1b0b0000),
    SPH_C32(0x86c30000), SPH_C32(0x49cf0000), SPH_C32(0x975c01fc),
    SPH_C32(0x2b1df584), SPH_C32(0x499e5125), SPH_C32(0xa1d00ea1),
    SPH_C32(0x7f83b716) },
  { SPH_C32(0xada30000), SPH_C32(0x5b070000), SPH_C32(0xf47e0000),
    SPH_C32(0xc630014c), SPH_C32(0x2a511402), SPH_C32(0x6df9f3dc),
    SPH_C32(0x42f8574f), SPH_C32(0x4dce7958), SPH_C32(0xb3d10000),
    SPH_C32(0x107d0000), SPH_C32(0x15d20000), SPH_C32(0x908601fe),
    SPH_C32(0x567b6007), SPH_C32(0x560621af), SPH_C32(0x1ab686a9),
    SPH_C32(0xa5043716) },
  { SPH_C32(0xca570000), SPH_C32(0xa80e0000), SPH_C32(0xa2f60000),
    SPH_C32(0x060b0152), SPH_C32(0x14592320), SPH_C32(0xec526625),
    SPH_C32(0x35dd13a8), SPH_C32(0xd74eb663), SPH_C32(0xb13b0000),
    SPH_C32(0x80040000), SPH_C32(0xd16f0000), SPH_C32(0x4f6b01f3),
    SPH_C32(0xb12faec3), SPH_C32(0x287d6f19), SPH_C32(0x112fb6cb),
    SPH_C32(0xaebbb10d) },
  { SPH_C32(0xc96a0000), SPH_C32(0xa0bd0000), SPH_C32(0x51cc0000),
    SPH_C32(0x3cc90155), SPH_C32(0x4570a970), SPH_C32(0x873c003a),
    SPH_C32(0x3b78dc4b), SPH_C32(0x3194c99d), SPH_C32(0x19e10000),
    SPH_C32(0x16ba0000), SPH_C32(0x8d720000), SPH_C32(0x48b101f1),
    SPH_C32(0xcc493b40), SPH_C32(0x37e51f93), SPH_C32(0xaa493ec3),
    SPH_C32(0x743c310d) },
  { SPH_C32(0x628d0000), SPH_C32(0x3eb00000), SPH_C32(0xfeeb0000),
    SPH_C32(0x01d10150), SPH_C32(0x693fb6a3), SPH_C32(0xf3ca16af),
    SPH_C32(0x8ebb9ba0), SPH_C32(0x0dc93663), SPH_C32(0x1adc0000),
    SPH_C32(0x1e090000), SPH_C32(0x7e480000), SPH_C32(0x727301f6),
    SPH_C32(0x9d60b110), SPH_C32(0x5c8b798c), SPH_C32(0xa4ecf120),
    SPH_C32(0x92e64ef3) },
  { SPH_C32(0x61b00000), SPH_C32(0x36030000), SPH_C32(0x0dd10000),
    SPH_C32(0x3b130157), SPH_C32(0x38163cf3), SPH_C32(0x98a470b0),
    SPH_C32(0x801e5443), SPH_C32(0xeb13499d), SPH_C32(0xb2060000),
    SPH_C32(0x88b70000), SPH_C32(0x22550000), SPH_C32(0x75a901f4),
    SPH_C32(0xe0062493), SPH_C32(0x43130906), SPH_C32(0x1f8a7928),
    SPH_C32(0x4861cef3) },
  { SPH_C32(0xcbc40000), SPH_C32(0x4f8c0000), SPH_C32(0x4f0d0000),
    SPH_C32(0xc9070159), SPH_C32(0x9989ae78), SPH_C32(0x50f1d20b),
    SPH_C32(0x33eb7249), SPH_C32(0x84212818), SPH_C32(0x23130000),
    SPH_C32(0x5c810000), SPH_C32(0x86950000), SPH_C32(0x19b701f0),
    SPH_C32(0x0bc68dd5), SPH_C32(0x7292cc15), SPH_C32(0x81e14199),
    SPH_C32(0xd5adc4da) },
  { SPH_C32(0xc8f90000), SPH_C32(0x473f0000), SPH_C32(0xbc370000),
    SPH_C32(0xf3c5015e), SPH_C32(0xc8a02428), SPH_C32(0x3b9fb414),
    SPH_C32(0x3d4ebdaa), SPH_C32(0x62fb57e6), SPH_C32(0x8bc90000),
    SPH_C32(0xca3f0000), SPH_C32(0xda880000), SPH_C32(0x1e6d01f2),
    SPH_C32(0x76a01856), SPH_C32(0x6d0abc9f), SPH_C32(0x3a87c991),
    SPH_C32(0x0f2a44da) },
  { SPH_C32(0x631e0000), SPH_C32(0xd9320000), SPH_C32(0x13100000),
    SPH_C32(0xcedd015b), SPH_C32(0xe4ef3bfb), SPH_C32(0x4f69a281),
    SPH_C32(0x888dfa41), SPH_C32(0x5ea6a818), SPH_C32(0x88f40000),
    SPH_C32(0xc28c0000), SPH_C32(0x29b20000), SPH_C32(0x24af01f5),
    SPH_C32(0x27899206), SPH_C32(0x0664da80), SPH_C32(0x34220672),
    SPH_C32(0xe9f03b24) },
  { SPH_C32(0x60230000), SPH_C32(0xd1810000), SPH_C32(0xe02a0000),
    SPH_C32(0xf41f015c), SPH_C32(0xb5c6b1ab), SPH_C32(0x2407c49e),
    SPH_C32(0x862835a2), SPH_C32(0xb87cd7e6), SPH_C32(0x202e0000),
    SPH_C32(0x54320000), SPH_C32(0x75af0000), SPH_C32(0x237501f7),
    SPH_C32(0x5aef0785), SPH_C32(0x19fcaa0a), SPH_C32(0x8f448e7a),
    SPH_C32(0x3377bb24) },
  { SPH_C32(0x587f0000), SPH_C32(0x748b0000), SPH_C32(0xf50c0000),
    SPH_C32(0x50d70151), SPH_C32(0xaeb00036), SPH_C32(0xb6bdc529),
    SPH_C32(0xa513e4fa), SPH_C32(0xac58c3b4), SPH_C32(0x22800000),
    SPH_C32(0xbb030000), SPH_C32(0x6b6e0000), SPH_C32(0xd6bb01fb),
    SPH_C32(0x8616008d), SPH_C32(0xce31783b), SPH_C32(0x87d72078),
    SPH_C32(0x86c25aa1) },
  { SPH_C32(0x5b420000), SPH_C32(0x7c380000), SPH_C32(0x06360000),
    SPH_C32(0x6a150156), SPH_C32(0xff998a66), SPH_C32(0xddd3a336),
    SPH_C32(0xabb62b19), SPH_C32(0x4a82bc4a), SPH_C32(0x8a5a0000),
    SPH_C32(0x2dbd0000), SPH_C32(0x37730000), SPH_C32(0xd16101f9),
    SPH_C32(0xfb70950e), SPH_C32(0xd1a908b1), SPH_C32(0x3cb1a870),
    SPH_C32(0x5c45daa1) },
  { SPH_C32(0xf0a50000), SPH_C32(0xe2350000), SPH_C32(0xa9110000),
    SPH_C32(0x570d0153), SPH_C32(0xd3d695b5), SPH_C32(0xa925b5a3),
    SPH_C32(0x1e756cf2), SPH_C32(0x76df43b4), SPH_C32(0x89670000),
    SPH_C32(0x250e0000), SPH_C32(0xc4490000), SPH_C32(0xeba301fe),
    SPH_C32(0xaa591f5e), SPH_C32(0xbac76eae), SPH_C32(0x32146793),
    SPH_C32(0xba9fa55f) },
  { SPH_C32(0xf3980000), SPH_C32(0xea860000), SPH_C32(0x5a2b0000),
    SPH_C32(0x6dcf0154), SPH_C32(0x82ff1fe5), SPH_C32(0xc24bd3bc),
    SPH_C32(0x10d0a311), SPH_C32(0x90053c4a), SPH_C32(0x21bd0000),
    SPH_C32(0xb3b00000), SPH_C32(0x98540000), SPH_C32(0xec7901fc),
    SPH_C32(0xd73f8add), SPH_C32(0xa55f1e24), SPH_C32(0x8972ef9b),
    SPH_C32(0x6018255f) },
  { SPH_C32(0x59ec0000), SPH_C32(0x93090000), SPH_C32(0x18f70000),
    SPH_C32(0x9fdb015a), SPH_C32(0x23608d6e), SPH_C32(0x0a1e7107),
    SPH_C32(0xa325851b), SPH_C32(0xff375dcf), SPH_C32(0xb0a80000),
    SPH_C32(0x67860000), SPH_C32(0x3c940000), SPH_C32(0x806701f8),
    SPH_C32(0x3cff239b), SPH_C32(0x94dedb37), SPH_C32(0x1719d72a),
    SPH_C32(0xfdd42f76) },
  { SPH_C32(0x5ad10000), SPH_C32(0x9bba0000), SPH_C32(0xebcd0000),
    SPH_C32(0xa519015d), SPH_C32(0x7249073e), SPH_C32(0x61701718),
    SPH_C32(0xad804af8), SPH_C32(0x19ed2231), SPH_C32(0x18720000),
    SPH_C32(0xf1380000), SPH_C32(0x60890000), SPH_C32(0x87bd01fa),
    SPH_C32(0x4199b618), SPH_C32(0x8b46abbd), SPH_C32(0xac7f5f22),
    SPH_C32(0x2753af76) },
  { SPH_C32(0xf1360000), SPH_C32(0x05b70000), SPH_C32(0x44ea0000),
    SPH_C32(0x98010158), SPH_C32(0x5e0618ed), SPH_C32(0x1586018d),
    SPH_C32(0x18430d13), SPH_C32(0x25b0ddcf), SPH_C32(0x1b4f0000),
    SPH_C32(0xf98b0000), SPH_C32(0x93b30000), SPH_C32(0xbd7f01fd),
    SPH_C32(0x10b03c48), SPH_C32(0xe028cda2), SPH_C32(0xa2da90c1),
    SPH_C32(0xc189d088) },
  { SPH_C32(0xf20b0000), SPH_C32(0x0d040000), SPH_C32(0xb7d00000),
    SPH_C32(0xa2c3015f), SPH_C32(0x0f2f92bd), SPH_C32(0x7ee86792),
    SPH_C32(0x16e6c2f0), SPH_C32(0xc36aa231), SPH_C32(0xb3950000),
    SPH_C32(0x6f350000), SPH_C32(0xcfae0000), SPH_C32(0xbaa501ff),
    SPH_C32(0x6dd6a9cb), SPH_C32(0xffb0bd28), SPH_C32(0x19bc18c9),
    SPH_C32(0x1b0e5088) }
};

#define INPUT_BIG   do { \
    unsigned acc = buf(0); \
    __constant const sph_u32 *rp; \
    rp = &T512_0[acc][0]; \
    m0 = rp[0]; \
    m1 = rp[1]; \
    m2 = rp[2]; \
    m3 = rp[3]; \
    m4 = rp[4]; \
    m5 = rp[5]; \
    m6 = rp[6]; \
    m7 = rp[7]; \
    m8 = rp[8]; \
    m9 = rp[9]; \
    mA = rp[10]; \
    mB = rp[11]; \
    mC = rp[12]; \
    mD = rp[13]; \
    mE = rp[14]; \
    mF = rp[15]; \
    acc = buf(1); \
    rp = &T512_8[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(2); \
    rp = &T512_16[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(3); \
    rp = &T512_24[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(4); \
    rp = &T512_32[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(5); \
    rp = &T512_40[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(6); \
    rp = &T512_48[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
    acc = buf(7); \
    rp = &T512_56[acc][0]; \
    m0 ^= rp[0]; \
    m1 ^= rp[1]; \
    m2 ^= rp[2]; \
    m3 ^= rp[3]; \
    m4 ^= rp[4]; \
    m5 ^= rp[5]; \
    m6 ^= rp[6]; \
    m7 ^= rp[7]; \
    m8 ^= rp[8]; \
    m9 ^= rp[9]; \
    mA ^= rp[10]; \
    mB ^= rp[11]; \
    mC ^= rp[12]; \
    mD ^= rp[13]; \
    mE ^= rp[14]; \
    mF ^= rp[15]; \
  } while (0)

#endif
